/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2010, Ajax.org B.V.
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

"undefined"!==typeof process&&require("amd-loader");
define("require exports module ./document ./anchor ./range ./test/assertions".split(" "),function(f,i,h){var d=f("./document").Document,e=f("./anchor").Anchor,g=f("./range").Range,c=f("./test/assertions");h.exports={"test create anchor":function(){var a=new d("juhu"),b=new e(a,0,0);c.position(b.getPosition(),0,0);c.equal(b.getDocument(),a)},"test insert text in same row before cursor should move anchor column":function(){var a=new d("juhu\nkinners"),b=new e(a,1,4);a.insert({row:1,column:1},"123");
c.position(b.getPosition(),1,7)},"test insert text at anchor should not move anchor when insertRight is true":function(){var a=new d("juhu\nkinners"),b=new e(a,1,4);b.$insertRight=!0;a.insert({row:1,column:4},"123");c.position(b.getPosition(),1,4)},"test insert lines before cursor should move anchor row":function(){var a=new d("juhu\nkinners"),b=new e(a,1,4);a.insertFullLines(1,["123","456"]);c.position(b.getPosition(),3,4)},"test insert lines at anchor position should move anchor down":function(){var a=
new d("juhu\nkinners"),b=new e(a,1,0);a.insertLines(1,["line"]);c.position(b.getPosition(),2,0)},"test insert lines at anchor position should not move anchor down when insertRight is true and column is 0":function(){var a=new d("juhu\nkinners"),b=new e(a,1,0);b.$insertRight=!0;a.insertLines(1,["line"]);c.position(b.getPosition(),1,0)},"test insert lines at anchor row should move anchor down when column > 0":function(){var a=new d("juhu\nkinners"),b=new e(a,1,2);b.$insertRight=!0;a.insertLines(1,["line"]);
c.position(b.getPosition(),2,2)},"test insert new line before cursor should move anchor column":function(){var a=new d("juhu\nkinners"),b=new e(a,1,4);a.insertMergedLines({row:0,column:0},["",""]);c.position(b.getPosition(),2,4)},"test insert new line in anchor line before anchor should move anchor column and row":function(){var a=new d("juhu\nkinners"),b=new e(a,1,4);a.insertMergedLines({row:1,column:2},["",""]);c.position(b.getPosition(),2,2)},"test delete text in anchor line before anchor should move anchor column":function(){var a=
new d("juhu\nkinners"),b=new e(a,1,4);a.remove(new g(1,1,1,3));c.position(b.getPosition(),1,2)},"test remove range which contains the anchor should move the anchor to the start of the range":function(){var a=new d("juhu\nkinners"),b=new e(a,0,3);a.remove(new g(0,1,1,3));c.position(b.getPosition(),0,1)},"test delete character before the anchor should have no effect":function(){var a=new d("juhu\nkinners"),b=new e(a,1,4);a.remove(new g(1,4,1,5));c.position(b.getPosition(),1,4)},"test delete lines in anchor line before anchor should move anchor row":function(){var a=
new d("juhu\n1\n2\nkinners"),b=new e(a,3,4);a.removeFullLines(1,2);c.position(b.getPosition(),1,4)},"test remove new line before the cursor":function(){var a=new d("juhu\nkinners"),b=new e(a,1,4);a.removeNewLine(0);c.position(b.getPosition(),0,8)},"test delete range which contains the anchor should move anchor to the end of the range":function(){var a=new d("juhu\nkinners"),b=new e(a,1,4);a.remove(new g(0,2,1,2));c.position(b.getPosition(),0,4)},"test delete line which contains the anchor should move anchor to the end of the range":function(){var a=
new d("juhu\nkinners\n123"),b=new e(a,1,5);a.removeFullLines(1,1);c.position(b.getPosition(),1,0)},"test remove after the anchor should have no effect":function(){var a=new d("juhu\nkinners\n123"),b=new e(a,1,2);a.remove(new g(1,4,2,2));c.position(b.getPosition(),1,2)},"test anchor changes triggered by document changes should emit change event":function(a){var b=new d("juhu\nkinners\n123"),f=new e(b,1,5);f.on("change",function(){c.position(f.getPosition(),0,0);a()});b.remove(new g(0,0,2,1))},"test only fire change event if position changes":function(){var a=
new d("juhu\nkinners\n123");(new e(a,1,5)).on("change",function(){c.fail()});a.remove(new g(2,0,2,1))},"test insert/remove lines at the end of the document":function(){var a=new d("juhu\nkinners\n123"),b=new e(a,2,4);a.removeFullLines(0,3);c.position(b.getPosition(),0,0);a.insertFullLines(0,["a","b","c"]);c.position(b.getPosition(),3,0);c.equal(a.getValue(),"a\nb\nc\n")}}});"undefined"!==typeof module&&module===require.main&&require("asyncjs").test.testcase(module.exports).exec();