/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2012, Ajax.org B.V.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

define("require exports module ./keyboard/hash_handler ./autocomplete/popup ./autocomplete/util ./lib/event ./lib/lang ./lib/dom ./snippets".split(" "),function(h,q){var s=h("./keyboard/hash_handler").HashHandler,t=h("./autocomplete/popup").AcePopup,u=h("./autocomplete/util");h("./lib/event");var r=h("./lib/lang"),v=h("./lib/dom"),w=h("./snippets").snippetManager,k=function(){this.autoInsert=!1;this.autoSelect=!0;this.exactMatch=!1;this.gatherCompletionsId=0;this.keyboardHandler=new s;this.keyboardHandler.bindKeys(this.commands);
this.blurListener=this.blurListener.bind(this);this.changeListener=this.changeListener.bind(this);this.mousedownListener=this.mousedownListener.bind(this);this.mousewheelListener=this.mousewheelListener.bind(this);this.changeTimer=r.delayedCall(function(){this.updateCompletions(!0)}.bind(this));this.tooltipTimer=r.delayedCall(this.updateDocTooltip.bind(this),50)};(function(){this.$init=function(){this.popup=new t(document.body||document.documentElement);this.popup.on("click",function(a){this.insertMatch();
a.stop()}.bind(this));this.popup.focus=this.editor.focus.bind(this.editor);this.popup.on("show",this.tooltipTimer.bind(null,null));this.popup.on("select",this.tooltipTimer.bind(null,null));this.popup.on("changeHoverMarker",this.tooltipTimer.bind(null,null));return this.popup};this.getPopup=function(){return this.popup||this.$init()};this.openPopup=function(a,b,c){this.popup||this.$init();this.popup.setData(this.completions.filtered);a.keyBinding.addKeyboardHandler(this.keyboardHandler);var d=a.renderer;
this.popup.setRow(this.autoSelect?0:-1);if(c)c&&!b&&this.detach();else{this.popup.setTheme(a.getTheme());this.popup.setFontSize(a.getFontSize());b=d.layerConfig.lineHeight;c=d.$cursorLayer.getPixelPosition(this.base,!0);c.left-=this.popup.getTextLeftOffset();var f=a.container.getBoundingClientRect();c.top+=f.top-d.layerConfig.offset;c.left+=f.left-a.renderer.scrollLeft;c.left+=d.gutterWidth;this.popup.show(c,b)}};this.detach=function(){this.editor.keyBinding.removeKeyboardHandler(this.keyboardHandler);
this.editor.off("changeSelection",this.changeListener);this.editor.off("blur",this.blurListener);this.editor.off("mousedown",this.mousedownListener);this.editor.off("mousewheel",this.mousewheelListener);this.changeTimer.cancel();this.hideDocTooltip();this.gatherCompletionsId+=1;this.popup&&this.popup.isOpen&&this.popup.hide();this.base&&this.base.detach();this.activated=!1;this.completions=this.base=null};this.changeListener=function(){var a=this.editor.selection.lead;(a.row!=this.base.row||a.column<
this.base.column)&&this.detach();this.activated?this.changeTimer.schedule():this.detach()};this.blurListener=function(a){var b=document.activeElement,c=this.editor.textInput.getElement(),d=a.relatedTarget&&a.relatedTarget==this.tooltipNode,f=this.popup&&this.popup.container;b!=c&&(b.parentNode!=f&&!d&&b!=this.tooltipNode&&a.relatedTarget!=c)&&this.detach()};this.mousedownListener=function(){this.detach()};this.mousewheelListener=function(){this.detach()};this.goTo=function(a){var b=this.popup.getRow(),
c=this.popup.session.getLength()-1;switch(a){case "up":b=0>=b?c:b-1;break;case "down":b=b>=c?-1:b+1;break;case "start":b=0;break;case "end":b=c}this.popup.setRow(b)};this.insertMatch=function(a){a||(a=this.popup.getData(this.popup.getRow()));if(!a)return!1;if(a.completer&&a.completer.insertMatch)a.completer.insertMatch(this.editor,a);else{if(this.completions.filterText)for(var b=this.editor.selection.getAllRanges(),c=0,d;d=b[c];c++)d.start.column-=this.completions.filterText.length,this.editor.session.remove(d);
a.snippet?w.insertSnippet(this.editor,a.snippet):this.editor.execCommand("insertstring",a.value||a)}this.detach()};this.commands={Up:function(a){a.completer.goTo("up")},Down:function(a){a.completer.goTo("down")},"Ctrl-Up|Ctrl-Home":function(a){a.completer.goTo("start")},"Ctrl-Down|Ctrl-End":function(a){a.completer.goTo("end")},Esc:function(a){a.completer.detach()},Return:function(a){return a.completer.insertMatch()},"Shift-Return":function(a){a.completer.insertMatch(null,{deleteSuffix:!0})},Tab:function(a){var b=
a.completer.insertMatch();if(!b&&!a.tabstopManager)a.completer.goTo("down");else return b},PageUp:function(a){a.completer.popup.gotoPageUp()},PageDown:function(a){a.completer.popup.gotoPageDown()}};this.gatherCompletions=function(a,b){var c=a.getSession(),d=a.getCursorPosition();c.getLine(d.row);var f=u.getCompletionPrefix(a);this.base=c.doc.createAnchor(d.row,d.column-f.length);this.base.$insertRight=!0;var i=[],g=a.completers.length;a.completers.forEach(function(e){e.getCompletions(a,c,d,f,function(d,
e){!d&&e&&(i=i.concat(e));var l=a.getCursorPosition();c.getLine(l.row);b(null,{prefix:f,matches:i,finished:0===--g})})});return!0};this.showPopup=function(a){this.editor&&this.detach();this.activated=!0;this.editor=a;a.completer!=this&&(a.completer&&a.completer.detach(),a.completer=this);a.on("changeSelection",this.changeListener);a.on("blur",this.blurListener);a.on("mousedown",this.mousedownListener);a.on("mousewheel",this.mousewheelListener);this.updateCompletions()};this.updateCompletions=function(a){if(a&&
this.base&&this.completions){var b=this.editor.getCursorPosition(),b=this.editor.session.getTextRange({start:this.base,end:b});if(b!=this.completions.filterText){this.completions.setFilter(b);if(!this.completions.filtered.length||1==this.completions.filtered.length&&this.completions.filtered[0].value==b&&!this.completions.filtered[0].snippet)return this.detach();this.openPopup(this.editor,b,a)}}else{var c=this.gatherCompletionsId;this.gatherCompletions(this.editor,function(b,f){var i=function(){if(f.finished)return this.detach()}.bind(this),
g=f.prefix,e=f&&f.matches;if(!e||!e.length)return i();if(!(0!==g.indexOf(f.prefix)||c!=this.gatherCompletionsId)){this.completions=new p(e);this.exactMatch&&(this.completions.exactMatch=!0);this.completions.setFilter(g);e=this.completions.filtered;if(!e.length||1==e.length&&e[0].value==g&&!e[0].snippet)return i();if(this.autoInsert&&1==e.length&&f.finished)return this.insertMatch(e[0]);this.openPopup(this.editor,g,a)}}.bind(this))}};this.cancelContextMenu=function(){this.editor.$mouseHandler.cancelContextMenu()};
this.updateDocTooltip=function(){var a=this.popup,b=a.data,c=b&&(b[a.getHoveredRow()]||b[a.getRow()]),d=null;if(!c||!this.editor||!this.popup.isOpen)return this.hideDocTooltip();this.editor.completers.some(function(a){a.getDocTooltip&&(d=a.getDocTooltip(c));return d});d||(d=c);"string"==typeof d&&(d={docText:d});if(!d||!d.docHTML&&!d.docText)return this.hideDocTooltip();this.showDocTooltip(d)};this.showDocTooltip=function(a){this.tooltipNode||(this.tooltipNode=v.createElement("div"),this.tooltipNode.className=
"ace_tooltip ace_doc-tooltip",this.tooltipNode.style.margin=0,this.tooltipNode.style.pointerEvents="auto",this.tooltipNode.tabIndex=-1,this.tooltipNode.onblur=this.blurListener.bind(this));var b=this.tooltipNode;a.docHTML?b.innerHTML=a.docHTML:a.docText&&(b.textContent=a.docText);b.parentNode||document.body.appendChild(b);var a=this.popup,c=a.container.getBoundingClientRect();b.style.top=a.container.style.top;b.style.bottom=a.container.style.bottom;320>window.innerWidth-c.right?(b.style.right=window.innerWidth-
c.left+"px",b.style.left=""):(b.style.left=c.right+1+"px",b.style.right="");b.style.display="block"};this.hideDocTooltip=function(){this.tooltipTimer.cancel();if(this.tooltipNode){var a=this.tooltipNode;!this.editor.isFocused()&&document.activeElement==a&&this.editor.focus();this.tooltipNode=null;a.parentNode&&a.parentNode.removeChild(a)}}}).call(k.prototype);k.startCommand={name:"startAutocomplete",exec:function(a){a.completer||(a.completer=new k);a.completer.autoInsert=!1;a.completer.autoSelect=
!0;a.completer.showPopup(a);a.completer.cancelContextMenu()},bindKey:"Ctrl-Space|Ctrl-Shift-Space|Alt-Space"};var p=function(a,b){this.filtered=this.all=a;this.filterText=b||"";this.exactMatch=!1};(function(){this.setFilter=function(a){var b=a.length>this.filterText&&0===a.lastIndexOf(this.filterText,0)?this.filtered:this.all;this.filterText=a;var b=this.filterCompletions(b,this.filterText),b=b.sort(function(a,b){return b.exactMatch-a.exactMatch||b.score-a.score}),c=null;this.filtered=b=b.filter(function(a){a=
a.snippet||a.caption||a.value;if(a===c)return!1;c=a;return!0})};this.filterCompletions=function(a,b){var c=[],d=b.toUpperCase(),f=b.toLowerCase(),i=0,g;a:for(;g=a[i];i++){var e=g.value||g.caption||g.snippet;if(e){var h=-1,k=0,l=0,j,m;if(this.exactMatch){if(b!==e.substr(0,b.length))continue a}else for(var n=0;n<b.length;n++){j=e.indexOf(f[n],h+1);m=e.indexOf(d[n],h+1);j=0<=j?0>m||j<m?j:m:m;if(0>j)continue a;m=j-h-1;0<m&&(-1===h&&(l+=10),l+=m);k|=1<<j;h=j}g.matchMask=k;g.exactMatch=l?0:1;g.score=(g.score||
0)-l;c.push(g)}}return c}}).call(p.prototype);q.Autocomplete=k;q.FilteredList=p});