/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2012, Ajax.org B.V.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

define("require exports module ../virtual_renderer ../editor ../range ../lib/event ../lib/lang ../lib/dom".split(" "),function(h,n){var p=h("../virtual_renderer").VirtualRenderer,q=h("../editor").Editor,m=h("../range").Range,r=h("../lib/event"),s=h("../lib/lang"),l=h("../lib/dom"),t=function(c){c=new p(c);c.$maxLines=4;c=new q(c);c.setHighlightActiveLine(!1);c.setShowPrintMargin(!1);c.renderer.setShowGutter(!1);c.renderer.setHighlightGutterLine(!1);c.$mouseHandler.$focusWaitTimout=0;c.$highlightTagPending=
!0;return c};l.importCssString(".ace_editor.ace_autocomplete .ace_marker-layer .ace_active-line {    background-color: #CAD6FA;    z-index: 1;}.ace_editor.ace_autocomplete .ace_line-hover {    border: 1px solid #abbffe;    margin-top: -1px;    background: rgba(233,233,253,0.4);}.ace_editor.ace_autocomplete .ace_line-hover {    position: absolute;    z-index: 2;}.ace_editor.ace_autocomplete .ace_scroller {   background: none;   border: none;   box-shadow: none;}.ace_rightAlignedText {    color: gray;    display: inline-block;    position: absolute;    right: 4px;    text-align: right;    z-index: -1;}.ace_editor.ace_autocomplete .ace_completion-highlight{    color: #000;    text-shadow: 0 0 0.01em;}.ace_editor.ace_autocomplete {    width: 280px;    z-index: 200000;    background: #fbfbfb;    color: #444;    border: 1px lightgray solid;    position: fixed;    box-shadow: 2px 3px 5px rgba(0,0,0,.2);    line-height: 1.4;}");
n.AcePopup=function(c){var d=l.createElement("div"),a=new t(d);c&&c.appendChild(d);d.style.display="none";a.renderer.content.style.cursor="default";a.renderer.setStyle("ace_autocomplete");a.setOption("displayIndentGuides",!1);a.setOption("dragDelay",150);c=function(){};a.focus=c;a.$isFocused=!0;a.renderer.$cursorLayer.restartTimer=c;a.renderer.$cursorLayer.element.style.opacity=0;a.renderer.$maxLines=8;a.renderer.$keepTextAreaAtCursor=!1;a.setHighlightActiveLine(!1);a.session.highlight("");a.session.$searchHighlight.clazz=
"ace_highlight-marker";a.on("mousedown",function(b){var e=b.getDocumentPosition();a.selection.moveToPosition(e);i.start.row=i.end.row=e.row;b.stop()});var j,f=new m(-1,0,-1,Infinity),i=new m(-1,0,-1,Infinity);i.id=a.session.addMarker(i,"ace_active-line","fullLine");a.setSelectOnHover=function(b){b?f.id&&(a.session.removeMarker(f.id),f.id=null):f.id=a.session.addMarker(f,"ace_line-hover","fullLine")};a.setSelectOnHover(!1);a.on("mousemove",function(b){j?j.x==b.x&&j.y==b.y||(j=b,j.scrollTop=a.renderer.scrollTop,
b=j.getDocumentPosition().row,f.start.row!=b&&(f.id||a.setRow(b),h(b))):j=b});a.renderer.on("beforeRender",function(){if(j&&-1!=f.start.row){j.$pos=null;var b=j.getDocumentPosition().row;f.id||a.setRow(b);h(b,!0)}});a.renderer.on("afterRender",function(){var b=a.getRow(),e=a.renderer.$textLayer,b=e.element.childNodes[b-e.config.firstRow];b!=e.selectedNode&&(e.selectedNode&&l.removeCssClass(e.selectedNode,"ace_selected"),(e.selectedNode=b)&&l.addCssClass(b,"ace_selected"))});var d=function(){h(-1)},
h=function(b,e){b!==f.start.row&&(f.start.row=f.end.row=b,e||a.session._emit("changeBackMarker"),a._emit("changeHoverMarker"))};a.getHoveredRow=function(){return f.start.row};r.addListener(a.container,"mouseout",d);a.on("hide",d);a.on("changeSelection",d);a.session.doc.getLength=function(){return a.data.length};a.session.doc.getLine=function(b){b=a.data[b];return"string"==typeof b?b:b&&b.value||""};d=a.session.bgTokenizer;d.$tokenizeRow=function(b){var b=a.data[b],e=[];if(!b)return e;"string"==typeof b&&
(b={value:b});b.caption||(b.caption=b.value||b.name);for(var c=-1,g,f,d=0;d<b.caption.length;d++)f=b.caption[d],g=b.matchMask&1<<d?1:0,c!==g?(e.push({type:b.className||""+(g?"completion-highlight":""),value:f}),c=g):e[e.length-1].value+=f;b.meta&&(c=a.renderer.$size.scrollerWidth/a.renderer.layerConfig.characterWidth,g=b.meta,g.length+b.caption.length>c-2&&(g=g.substr(0,c-b.caption.length-3)+"\u2026"),e.push({type:"rightAlignedText",value:g}));return e};d.$updateOnChange=c;d.start=c;a.session.$computeWidth=
function(){return this.screenWidth=0};a.$blockScrolling=Infinity;a.isOpen=!1;a.isTopdown=!1;a.data=[];a.setData=function(b){a.setValue(s.stringRepeat("\n",b.length),-1);a.data=b||[];a.setRow(0)};a.getData=function(b){return a.data[b]};a.getRow=function(){return i.start.row};a.setRow=function(b){b=Math.max(0,Math.min(this.data.length,b));i.start.row!=b&&(a.selection.clearSelection(),i.start.row=i.end.row=b||0,a.session._emit("changeBackMarker"),a.moveCursorTo(b||0,0),a.isOpen&&a._signal("select"))};
a.on("changeSelection",function(){a.isOpen&&a.setRow(a.selection.lead.row);a.renderer.scrollCursorIntoView()});a.hide=function(){this.container.style.display="none";this._signal("hide");a.isOpen=!1};a.show=function(b,c,f){var g=this.container,d=window.innerHeight,h=window.innerWidth,i=this.renderer,l=1.4*i.$maxLines*c,k=b.top+this.$borderSize;k>d/2&&!f&&k+c+l>d?(i.$maxPixelHeight=k-2*this.$borderSize,g.style.top="",g.style.bottom=d-k+"px",a.isTopdown=!1):(k+=c,i.$maxPixelHeight=d-k-0.2*c,g.style.top=
k+"px",g.style.bottom="",a.isTopdown=!0);g.style.display="";this.renderer.$textLayer.checkForSizeChanges();b=b.left;b+g.offsetWidth>h&&(b=h-g.offsetWidth);g.style.left=b+"px";this._signal("show");j=null;a.isOpen=!0};a.getTextLeftOffset=function(){return this.$borderSize+this.renderer.$padding+this.$imageSize};a.$imageSize=0;a.$borderSize=1;return a}});