/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2010, Ajax.org B.V.
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

"undefined"!==typeof process&&require("amd-loader");
define("require exports module ./command_manager ../lib/keys ../test/assertions".split(" "),function(d,h,g){var f=d("./command_manager").CommandManager,c=d("../lib/keys"),b=d("../test/assertions");g.exports={setUp:function(){this.command={name:"gotoline",bindKey:{mac:"Command-L",win:"Ctrl-L"},called:!1,exec:function(){this.called=!0}};this.cm=new f("mac",[this.command])},"test: register command":function(){this.cm.exec("gotoline");b.ok(this.command.called)},"test: mac hotkeys":function(){var a=this.cm.findKeyCommand(c.KEY_MODS.command,
"l");b.equal(a,this.command);a=this.cm.findKeyCommand(c.KEY_MODS.ctrl,"l");b.equal(a,void 0)},"test: win hotkeys":function(){var a=new f("win",[this.command]),e=a.findKeyCommand(c.KEY_MODS.command,"l");b.equal(e,void 0);e=a.findKeyCommand(c.KEY_MODS.ctrl,"l");b.equal(e,this.command)},"test: remove command by object":function(){this.cm.removeCommand(this.command);this.cm.exec("gotoline");b.ok(!this.command.called);var a=this.cm.findKeyCommand(c.KEY_MODS.command,"l");b.equal(a,null)},"test: remove command by name":function(){this.cm.removeCommand("gotoline");
this.cm.exec("gotoline");b.ok(!this.command.called);var a=this.cm.findKeyCommand(c.KEY_MODS.command,"l");b.equal(a,null)},"test: adding a new command with the same name as an existing one should remove the old one first":function(){var a={name:"gotoline",bindKey:{mac:"Command-L",win:"Ctrl-L"},called:!1,exec:function(){this.called=!0}};this.cm.addCommand(a);this.cm.exec("gotoline");b.ok(a.called);b.ok(!this.command.called);b.equal(this.cm.findKeyCommand(c.KEY_MODS.command,"l"),a)},"test: adding commands and recording a macro":function(){var a=
"";this.cm.addCommands({togglerecording:function(a){a.cm.toggleRecording(a)},replay:function(a){a.cm.replay()},cm1:function(b,c){a+="1"+(c||"")},cm2:function(){a+="2"}});var c=!1;this._emit=function(){c=!0};this.cm.exec("togglerecording",this);b.ok(this.cm.recording);b.ok(c);this.cm.exec("cm1",this,"-");this.cm.exec("cm2");this.cm.exec("replay",this);b.ok(!this.cm.recording);b.equal(a,"1-2");a="";this.cm.exec("replay",this);b.equal(a,"1-2")},"test: bindkeys":function(){this.cm.bindKeys({"Ctrl-L|Command-C":"cm1",
"Ctrl-R":"cm2"});var a=this.cm.findKeyCommand(c.KEY_MODS.command,"c");b.equal(a,"cm1");a=this.cm.findKeyCommand(c.KEY_MODS.ctrl,"r");b.equal(a,"cm2");this.cm.bindKeys({"Ctrl-R":null});a=this.cm.findKeyCommand(c.KEY_MODS.ctrl,"r");b.equal(a,null)},"test: binding keys without modifiers":function(){this.cm.bindKeys({R:"cm1","Shift-r":"cm2",Return:"cm4",Enter:"cm3"});var a=this.cm.findKeyCommand(-1,"r");b.equal(a,"cm1");a=this.cm.findKeyCommand(-1,"R");b.equal(a,"cm2");a=this.cm.findKeyCommand(0,"return");
b.equal(a+"","cm4,cm3")}}});"undefined"!==typeof module&&module===require.main&&require("asyncjs").test.testcase(module.exports).exec();