/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2010, Ajax.org B.V.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

define("require exports module ../config ../lib/oop ../keyboard/hash_handler ./occur_commands".split(" "),function(e,f){function g(a){this.$iSearch=a}var j=e("../config"),h=e("../lib/oop"),i=e("../keyboard/hash_handler").HashHandler,k=e("./occur_commands").occurStartCommand;f.iSearchStartCommands=[{name:"iSearch",bindKey:{win:"Ctrl-F",mac:"Command-F"},exec:function(a,b){j.loadModule(["core","ace/incremental_search"],function(c){c=c.iSearch=c.iSearch||new c.IncrementalSearch;c.activate(a,b.backwards);
b.jumpToFirstMatch&&c.next(b)})},readOnly:!0},{name:"iSearchBackwards",exec:function(a){a.execCommand("iSearch",{backwards:!0})},readOnly:!0},{name:"iSearchAndGo",bindKey:{win:"Ctrl-K",mac:"Command-G"},exec:function(a){a.execCommand("iSearch",{jumpToFirstMatch:!0,useCurrentOrPrevSearch:!0})},readOnly:!0},{name:"iSearchBackwardsAndGo",bindKey:{win:"Ctrl-Shift-K",mac:"Command-Shift-G"},exec:function(a){a.execCommand("iSearch",{jumpToFirstMatch:!0,backwards:!0,useCurrentOrPrevSearch:!0})},readOnly:!0}];
f.iSearchCommands=[{name:"restartSearch",bindKey:{win:"Ctrl-F",mac:"Command-F"},exec:function(a){a.cancelSearch(!0)}},{name:"searchForward",bindKey:{win:"Ctrl-S|Ctrl-K",mac:"Ctrl-S|Command-G"},exec:function(a,b){b.useCurrentOrPrevSearch=!0;a.next(b)}},{name:"searchBackward",bindKey:{win:"Ctrl-R|Ctrl-Shift-K",mac:"Ctrl-R|Command-Shift-G"},exec:function(a,b){b.useCurrentOrPrevSearch=!0;b.backwards=!0;a.next(b)}},{name:"extendSearchTerm",exec:function(a,b){a.addString(b)}},{name:"extendSearchTermSpace",
bindKey:"space",exec:function(a){a.addString(" ")}},{name:"shrinkSearchTerm",bindKey:"backspace",exec:function(a){a.removeChar()}},{name:"confirmSearch",bindKey:"return",exec:function(a){a.deactivate()}},{name:"cancelSearch",bindKey:"esc|Ctrl-G",exec:function(a){a.deactivate(!0)}},{name:"occurisearch",bindKey:"Ctrl-O",exec:function(a){var b=h.mixin({},a.$options);a.deactivate();k.exec(a.$editor,b)}},{name:"yankNextWord",bindKey:"Ctrl-w",exec:function(a){var b=a.$editor,c=b.selection.getRangeOfMovements(function(a){a.moveCursorWordRight()}),
b=b.session.getTextRange(c);a.addString(b)}},{name:"yankNextChar",bindKey:"Ctrl-Alt-y",exec:function(a){var b=a.$editor,c=b.selection.getRangeOfMovements(function(a){a.moveCursorRight()}),b=b.session.getTextRange(c);a.addString(b)}},{name:"recenterTopBottom",bindKey:"Ctrl-l",exec:function(a){a.$editor.execCommand("recenterTopBottom")}},{name:"selectAllMatches",bindKey:"Ctrl-space",exec:function(a){var b=a.$editor,c=b.session.$isearchHighlight,c=c&&c.cache?c.cache.reduce(function(a,b){return a.concat(b?
b:[])},[]):[];a.deactivate(!1);c.forEach(b.selection.addRange.bind(b.selection))}},{name:"searchAsRegExp",bindKey:"Alt-r",exec:function(a){a.convertNeedleToRegExp()}}].map(function(a){a.readOnly=!0;a.isIncrementalSearchCommand=!0;a.scrollIntoView="animate-cursor";return a});h.inherits(g,i);(function(){this.attach=function(a){var c=this.$iSearch;i.call(this,f.iSearchCommands,a.commands.platform);this.$commandExecHandler=a.commands.addEventListener("exec",function(d){if(!d.command.isIncrementalSearchCommand)return c.deactivate();
d.stopPropagation();d.preventDefault();var e=a.session.getScrollTop(),d=d.command.exec(c,d.args||{});a.renderer.scrollCursorIntoView(null,0.5);a.renderer.animateScrolling(e);return d})};this.detach=function(a){this.$commandExecHandler&&(a.commands.removeEventListener("exec",this.$commandExecHandler),delete this.$commandExecHandler)};var a=this.handleKeyboard;this.handleKeyboard=function(b,c,d,e){if((1===c||8===c)&&"v"===d||1===c&&"y"===d)return null;b=a.call(this,b,c,d,e);return b.command?b:-1==c&&
(c=this.commands.extendSearchTerm)?{command:c,args:d}:!1}}).call(g.prototype);f.IncrementalSearchKeyboardHandler=g});