/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2010, Ajax.org B.V.
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

define("require exports module ./lib/oop ./apply_delta ./lib/event_emitter ./range ./anchor".split(" "),function(f,l){var m=f("./lib/oop"),n=f("./apply_delta").applyDelta,p=f("./lib/event_emitter").EventEmitter,i=f("./range").Range,q=f("./anchor").Anchor,k=function(a){this.$lines=[""];0===a.length?this.$lines=[""]:Array.isArray(a)?this.insertMergedLines({row:0,column:0},a):this.insert({row:0,column:0},a)};(function(){m.implement(this,p);this.setValue=function(a){var b=this.getLength()-1;this.remove(new i(0,
0,b,this.getLine(b).length));this.insert({row:0,column:0},a)};this.getValue=function(){return this.getAllLines().join(this.getNewLineCharacter())};this.createAnchor=function(a,b){return new q(this,a,b)};this.$split=0==="aaa".split(/a/).length?function(a){return a.replace(/\r\n|\r/g,"\n").split("\n")}:function(a){return a.split(/\r\n|\r|\n/)};this.$detectNewLine=function(a){this.$autoNewLine=(a=a.match(/^.*?(\r\n|\r|\n)/m))?a[1]:"\n";this._signal("changeNewLineMode")};this.getNewLineCharacter=function(){switch(this.$newLineMode){case "windows":return"\r\n";
case "unix":return"\n";default:return this.$autoNewLine||"\n"}};this.$autoNewLine="";this.$newLineMode="auto";this.setNewLineMode=function(a){this.$newLineMode!==a&&(this.$newLineMode=a,this._signal("changeNewLineMode"))};this.getNewLineMode=function(){return this.$newLineMode};this.isNewLine=function(a){return"\r\n"==a||"\r"==a||"\n"==a};this.getLine=function(a){return this.$lines[a]||""};this.getLines=function(a,b){return this.$lines.slice(a,b+1)};this.getAllLines=function(){return this.getLines(0,
this.getLength())};this.getLength=function(){return this.$lines.length};this.getTextRange=function(a){return this.getLinesForRange(a).join(this.getNewLineCharacter())};this.getLinesForRange=function(a){var b;if(a.start.row===a.end.row)b=[this.getLine(a.start.row).substring(a.start.column,a.end.column)];else{b=this.getLines(a.start.row,a.end.row);b[0]=(b[0]||"").substring(a.start.column);var c=b.length-1;a.end.row-a.start.row==c&&(b[c]=b[c].substring(0,a.end.column))}return b};this.insertLines=function(a,
b){console.warn("Use of document.insertLines is deprecated. Use the insertFullLines method instead.");return this.insertFullLines(a,b)};this.removeLines=function(a,b){console.warn("Use of document.removeLines is deprecated. Use the removeFullLines method instead.");return this.removeFullLines(a,b)};this.insertNewLine=function(a){console.warn("Use of document.insertNewLine is deprecated. Use insertMergedLines(position, ['', '']) instead.");return this.insertMergedLines(a,["",""])};this.insert=function(a,
b){1>=this.getLength()&&this.$detectNewLine(b);return this.insertMergedLines(a,this.$split(b))};this.insertInLine=function(a,b){var c=this.clippedPos(a.row,a.column),e=this.pos(a.row,a.column+b.length);this.applyDelta({start:c,end:e,action:"insert",lines:[b]},!0);return this.clonePos(e)};this.clippedPos=function(a,b){var c=this.getLength();void 0===a?a=c:0>a?a=0:a>=c&&(a=c-1,b=void 0);c=this.getLine(a);void 0==b&&(b=c.length);b=Math.min(Math.max(b,0),c.length);return{row:a,column:b}};this.clonePos=
function(a){return{row:a.row,column:a.column}};this.pos=function(a,b){return{row:a,column:b}};this.$clipPosition=function(a){var b=this.getLength();a.row>=b?(a.row=Math.max(0,b-1),a.column=this.getLine(b-1).length):(a.row=Math.max(0,a.row),a.column=Math.min(Math.max(a.column,0),this.getLine(a.row).length));return a};this.insertFullLines=function(a,b){var a=Math.min(Math.max(a,0),this.getLength()),c=0;a<this.getLength()?(b=b.concat([""]),c=0):(b=[""].concat(b),a--,c=this.$lines[a].length);this.insertMergedLines({row:a,
column:c},b)};this.insertMergedLines=function(a,b){var c=this.clippedPos(a.row,a.column),e={row:c.row+b.length-1,column:(1==b.length?c.column:0)+b[b.length-1].length};this.applyDelta({start:c,end:e,action:"insert",lines:b});return this.clonePos(e)};this.remove=function(a){var b=this.clippedPos(a.start.row,a.start.column),a=this.clippedPos(a.end.row,a.end.column);this.applyDelta({start:b,end:a,action:"remove",lines:this.getLinesForRange({start:b,end:a})});return this.clonePos(b)};this.removeInLine=
function(a,b,c){b=this.clippedPos(a,b);a=this.clippedPos(a,c);this.applyDelta({start:b,end:a,action:"remove",lines:this.getLinesForRange({start:b,end:a})},!0);return this.clonePos(b)};this.removeFullLines=function(a,b){var a=Math.min(Math.max(0,a),this.getLength()-1),b=Math.min(Math.max(0,b),this.getLength()-1),c=b==this.getLength()-1&&0<a,e=b<this.getLength()-1,d=c?a-1:a,c=c?this.getLine(d).length:0,g=e?b+1:b,e=e?0:this.getLine(g).length,d=new i(d,c,g,e),e=this.$lines.slice(a,b+1);this.applyDelta({start:d.start,
end:d.end,action:"remove",lines:this.getLinesForRange(d)});return e};this.removeNewLine=function(a){a<this.getLength()-1&&0<=a&&this.applyDelta({start:this.pos(a,this.getLine(a).length),end:this.pos(a+1,0),action:"remove",lines:["",""]})};this.replace=function(a,b){a instanceof i||(a=i.fromPoints(a.start,a.end));if(0===b.length&&a.isEmpty())return a.start;if(b==this.getTextRange(a))return a.end;this.remove(a);return b?this.insert(a.start,b):a.start};this.applyDeltas=function(a){for(var b=0;b<a.length;b++)this.applyDelta(a[b])};
this.revertDeltas=function(a){for(var b=a.length-1;0<=b;b--)this.revertDelta(a[b])};this.applyDelta=function(a,b){var c="insert"==a.action;if(!(c?1>=a.lines.length&&!a.lines[0]:!i.comparePoints(a.start,a.end)))c&&2E4<a.lines.length&&this.$splitAndapplyLargeDelta(a,2E4),n(this.$lines,a,b),this._signal("change",a)};this.$splitAndapplyLargeDelta=function(a,b){var c=a.lines,e=c.length,d=a.start.row,g=a.start.column,j=0,h=0;do{var j=h,h=h+(b-1),f=c.slice(j,h);if(h>e){a.lines=f;a.start.row=d+j;a.start.column=
g;break}f.push("");this.applyDelta({start:this.pos(d+j,g),end:this.pos(d+h,g=0),action:a.action,lines:f},!0)}while(1)};this.revertDelta=function(a){this.applyDelta({start:this.clonePos(a.start),end:this.clonePos(a.end),action:"insert"==a.action?"remove":"insert",lines:a.lines.slice()})};this.indexToPosition=function(a,b){for(var c=this.$lines||this.getAllLines(),e=this.getNewLineCharacter().length,d=b||0,g=c.length;d<g;d++)if(a-=c[d].length+e,0>a)return{row:d,column:a+c[d].length+e};return{row:g-
1,column:c[g-1].length}};this.positionToIndex=function(a,b){for(var c=this.$lines||this.getAllLines(),e=this.getNewLineCharacter().length,d=0,g=Math.min(a.row,c.length),f=b||0;f<g;++f)d+=c[f].length+e;return d+a.column}}).call(k.prototype);l.Document=k});