/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2010, Ajax.org B.V.
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

"undefined"!==typeof process&&(require("amd-loader"),require("./test/mockdom"));
define("require exports module ./document ./range ./test/assertions".split(" "),function(g,i,h){var e=g("./document").Document,f=g("./range").Range,b=g("./test/assertions");h.exports={"test: insert text in line":function(){var a=new e(["12","34"]),c=[];a.on("change",function(a){c.push(a)});a.insert({row:0,column:1},"juhu");b.equal(a.getValue(),"1juhu2\n34");var d=c.concat();a.revertDeltas(d);b.equal(a.getValue(),"12\n34");a.applyDeltas(d);b.equal(a.getValue(),"1juhu2\n34")},"test: insert new line":function(){var a=
new e(["12","34"]),c=[];a.on("change",function(a){c.push(a)});a.insertMergedLines({row:0,column:1},["",""]);b.equal(a.getValue(),"1\n2\n34");var d=c.concat();a.revertDeltas(d);b.equal(a.getValue(),"12\n34");a.applyDeltas(d);b.equal(a.getValue(),"1\n2\n34")},"test: insert lines at the beginning":function(){var a=new e(["12","34"]),c=[];a.on("change",function(a){c.push(a)});a.insertFullLines(0,["aa","bb"]);b.equal(a.getValue(),"aa\nbb\n12\n34");var d=c.concat();a.revertDeltas(d);b.equal(a.getValue(),
"12\n34");a.applyDeltas(d);b.equal(a.getValue(),"aa\nbb\n12\n34")},"test: insert lines at the end":function(){var a=new e(["12","34"]),c=[];a.on("change",function(a){c.push(a)});a.insertFullLines(2,["aa","bb"]);b.equal(a.getValue(),"12\n34\naa\nbb")},"test: insert lines in the middle":function(){var a=new e(["12","34"]),c=[];a.on("change",function(a){c.push(a)});a.insertFullLines(1,["aa","bb"]);b.equal(a.getValue(),"12\naa\nbb\n34");var d=c.concat();a.revertDeltas(d);b.equal(a.getValue(),"12\n34");
a.applyDeltas(d);b.equal(a.getValue(),"12\naa\nbb\n34")},"test: insert multi line string at the start":function(){var a=new e(["12","34"]),c=[];a.on("change",function(a){c.push(a)});a.insert({row:0,column:0},"aa\nbb\ncc");b.equal(a.getValue(),"aa\nbb\ncc12\n34");var d=c.concat();a.revertDeltas(d);b.equal(a.getValue(),"12\n34");a.applyDeltas(d);b.equal(a.getValue(),"aa\nbb\ncc12\n34")},"test: insert multi line string at the end":function(){var a=new e(["12","34"]),c=[];a.on("change",function(a){c.push(a)});
a.insert({row:1,column:2},"aa\nbb\ncc");b.equal(a.getValue(),"12\n34aa\nbb\ncc");var d=c.concat();a.revertDeltas(d);b.equal(a.getValue(),"12\n34");a.applyDeltas(d);b.equal(a.getValue(),"12\n34aa\nbb\ncc")},"test: insert multi line string in the middle":function(){var a=new e(["12","34"]),c=[];a.on("change",function(a){c.push(a)});a.insert({row:0,column:1},"aa\nbb\ncc");b.equal(a.getValue(),"1aa\nbb\ncc2\n34");var d=c.concat();a.revertDeltas(d);b.equal(a.getValue(),"12\n34");a.applyDeltas(d);b.equal(a.getValue(),
"1aa\nbb\ncc2\n34")},"test: delete in line":function(){var a=new e(["1234","5678"]),c=[];a.on("change",function(a){c.push(a)});a.remove(new f(0,1,0,3));b.equal(a.getValue(),"14\n5678");var d=c.concat();a.revertDeltas(d);b.equal(a.getValue(),"1234\n5678");a.applyDeltas(d);b.equal(a.getValue(),"14\n5678")},"test: delete new line":function(){var a=new e(["1234","5678"]),c=[];a.on("change",function(a){c.push(a)});a.remove(new f(0,4,1,0));b.equal(a.getValue(),"12345678");var d=c.concat();a.revertDeltas(d);
b.equal(a.getValue(),"1234\n5678");a.applyDeltas(d);b.equal(a.getValue(),"12345678")},"test: delete multi line range line":function(){var a=new e(["1234","5678","abcd"]),c=[];a.on("change",function(a){c.push(a)});a.remove(new f(0,2,2,2));b.equal(a.getValue(),"12cd");var d=c.concat();a.revertDeltas(d);b.equal(a.getValue(),"1234\n5678\nabcd");a.applyDeltas(d);b.equal(a.getValue(),"12cd")},"test: delete full lines":function(){var a=new e(["1234","5678","abcd"]),c=[];a.on("change",function(a){c.push(a)});
a.remove(new f(1,0,3,0));b.equal(a.getValue(),"1234\n")},"test: remove lines should return the removed lines":function(){var a=(new e(["1234","5678","abcd"])).removeFullLines(1,2);b.equal(a.join("\n"),"5678\nabcd")},"test: should handle unix style new lines":function(){var a=new e(["1","2","3"]);b.equal(a.getValue(),"1\n2\n3")},"test: should handle windows style new lines":function(){var a=new e("1\r\n2\r\n3");a.setNewLineMode("unix");b.equal(a.getValue(),"1\n2\n3")},"test: set new line mode to 'windows' should use '\\r\\n' as new lines":function(){var a=
new e("1\n2\n3");a.setNewLineMode("windows");b.equal(a.getValue(),"1\r\n2\r\n3")},"test: set new line mode to 'unix' should use '\\n' as new lines":function(){var a=new e("1\r\n2\r\n3");a.setNewLineMode("unix");b.equal(a.getValue(),"1\n2\n3")},"test: set new line mode to 'auto' should detect the incoming nl type":function(){var a=new e("1\n2\n3");a.setNewLineMode("auto");b.equal(a.getValue(),"1\n2\n3");a=new e("1\r\n2\r\n3");a.setNewLineMode("auto");b.equal(a.getValue(),"1\r\n2\r\n3");a.replace(new f(0,
0,2,1),"4\n5\n6");b.equal("4\n5\n6",a.getValue())},"test: set value":function(){var a=new e("1");b.equal("1",a.getValue());a.setValue(a.getValue());b.equal("1",a.getValue());a=new e("1\n2");b.equal("1\n2",a.getValue());a.setValue(a.getValue());b.equal("1\n2",a.getValue())},"test: empty document has to contain one line":function(){var a=new e("");b.equal(a.$lines.length,1)},"test: ignore empty delta":function(){var a=new e("");a.on("change",function(){throw"should ignore empty delta";});a.insert({row:0,
column:0},"");a.insert({row:1,column:1},"");a.remove({start:{row:1,column:1},end:{row:1,column:1}})},"test: inserting huge delta":function(){for(var a=new e(""),c="",d=0;614400>d;d++)c+=d+"\n";a.setValue(c);b.equal(a.getValue(),c);for(d=184322;184318<=d;d--)c=a.getLines(0,d).join("\n"),a.setValue("\nab"),b.equal(a.getValue(),"\nab"),a.insert({row:1,column:1},c),b.equal(a.getValue(),"\na"+c+"b")}}});"undefined"!==typeof module&&module===require.main&&require("asyncjs").test.testcase(module.exports).exec();