/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2010, Ajax.org B.V.
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

define(["require","exports","module","../range"],function(j,k){function h(a,b){this.foldData=a;Array.isArray(b)?this.folds=b:b=this.folds=[b];var c=b[b.length-1];this.range=new l(b[0].start.row,b[0].start.column,c.end.row,c.end.column);this.start=this.range.start;this.end=this.range.end;this.folds.forEach(function(a){a.setFoldLine(this)},this)}var l=j("../range").Range;(function(){this.shiftRow=function(a){this.start.row+=a;this.end.row+=a;this.folds.forEach(function(b){b.start.row+=a;b.end.row+=
a})};this.addFold=function(a){if(a.sameRow){if(a.start.row<this.startRow||a.endRow>this.endRow)throw Error("Can't add a fold to this FoldLine as it has no connection");this.folds.push(a);this.folds.sort(function(a,c){return-a.range.compareEnd(c.start.row,c.start.column)});0<this.range.compareEnd(a.start.row,a.start.column)?(this.end.row=a.end.row,this.end.column=a.end.column):0>this.range.compareStart(a.end.row,a.end.column)&&(this.start.row=a.start.row,this.start.column=a.start.column)}else if(a.start.row==
this.end.row)this.folds.push(a),this.end.row=a.end.row,this.end.column=a.end.column;else if(a.end.row==this.start.row)this.folds.unshift(a),this.start.row=a.start.row,this.start.column=a.start.column;else throw Error("Trying to add fold to FoldRow that doesn't have a matching row");a.foldLine=this};this.containsRow=function(a){return a>=this.start.row&&a<=this.end.row};this.walk=function(a,b,c){var d=0,e=this.folds,f,h,g;g=!0;null==b&&(b=this.end.row,c=this.end.column);for(var i=0;i<e.length;i++){f=
e[i];h=f.range.compareStart(b,c);if(-1==h){a(null,b,c,d,g);return}g=a(null,f.start.row,f.start.column,d,g);if((g=!g&&a(f.placeholder,f.start.row,f.start.column,d))||0===h)return;g=!f.sameRow;d=f.end.column}a(null,b,c,d,g)};this.getNextFoldTo=function(a,b){for(var c,d,e=0;e<this.folds.length;e++){c=this.folds[e];d=c.range.compareEnd(a,b);if(-1==d)return{fold:c,kind:"after"};if(0===d)return{fold:c,kind:"inside"}}return null};this.addRemoveChars=function(a,b,c){var d=this.getNextFoldTo(a,b),e;if(d)if(e=
d.fold,"inside"==d.kind&&e.start.column!=b&&e.start.row!=a)window.console&&window.console.log(a,b,e);else if(e.start.row==a){a=this.folds;b=a.indexOf(e);0===b&&(this.start.column+=c);for(b;b<a.length;b++){e=a[b];e.start.column+=c;if(!e.sameRow)return;e.end.column+=c}this.end.column+=c}};this.split=function(a,b){var c=this.getNextFoldTo(a,b);if(!c||"inside"==c.kind)return null;var d=this.folds,e=this.foldData,c=d.indexOf(c.fold),f=d[c-1];this.end.row=f.end.row;this.end.column=f.end.column;d=d.splice(c,
d.length-c);d=new h(e,d);e.splice(e.indexOf(this)+1,0,d);return d};this.merge=function(a){for(var b=a.folds,c=0;c<b.length;c++)this.addFold(b[c]);b=this.foldData;b.splice(b.indexOf(a),1)};this.toString=function(){var a=[this.range.toString()+": ["];this.folds.forEach(function(b){a.push("  "+b.toString())});a.push("]");return a.join("\n")};this.idxToPosition=function(a){for(var b=0,c=0;c<this.folds.length;c++){var d=this.folds[c],a=a-(d.start.column-b);if(0>a)return{row:d.start.row,column:d.start.column+
a};a-=d.placeholder.length;if(0>a)return d.start;b=d.end.column}return{row:this.end.row,column:this.end.column+a}}}).call(h.prototype);k.FoldLine=h});