/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2010, Ajax.org B.V.
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

define("require exports module ../range ./fold_line ./fold ../token_iterator".split(" "),function(m,s){var n=m("../range").Range,p=m("./fold_line").FoldLine,q=m("./fold").Fold,r=m("../token_iterator").TokenIterator;s.Folding=function(){this.getFoldAt=function(a,b,c){var d=this.getFoldLine(a);if(!d)return null;for(var d=d.folds,e=0;e<d.length;e++){var f=d[e];if(f.range.contains(a,b)&&!(1==c&&f.range.isEnd(a,b))&&!(-1==c&&f.range.isStart(a,b)))return f}};this.getFoldsInRange=function(a){var b=a.start,
c=a.end,d=this.$foldData,e=[];b.column+=1;c.column-=1;for(var f=0;f<d.length;f++){var g=d[f].range.compareRange(a);if(2!=g){if(-2==g)break;for(var h=d[f].folds,j=0;j<h.length;j++){var k=h[j],g=k.range.compareRange(a);if(-2==g)break;else if(2==g)continue;else if(42==g)break;e.push(k)}}}b.column-=1;c.column+=1;return e};this.getFoldsInRangeList=function(a){if(Array.isArray(a)){var b=[];a.forEach(function(a){b=b.concat(this.getFoldsInRange(a))},this)}else b=this.getFoldsInRange(a);return b};this.getAllFolds=
function(){for(var a=[],b=this.$foldData,c=0;c<b.length;c++)for(var d=0;d<b[c].folds.length;d++)a.push(b[c].folds[d]);return a};this.getFoldStringAt=function(a,b,c,d){d=d||this.getFoldLine(a);if(!d)return null;for(var e={end:{column:0}},f,g,h=0;h<d.folds.length;h++){g=d.folds[h];var j=g.range.compareEnd(a,b);if(-1==j){f=this.getLine(g.start.row).substring(e.end.column,g.start.column);break}else if(0===j)return null;e=g}f||(f=this.getLine(g.start.row).substring(e.end.column));return-1==c?f.substring(0,
b-e.end.column):1==c?f.substring(b-e.end.column):f};this.getFoldLine=function(a,b){var c=this.$foldData,d=0;b&&(d=c.indexOf(b));-1==d&&(d=0);for(d;d<c.length;d++){var e=c[d];if(e.start.row<=a&&e.end.row>=a)return e;if(e.end.row>a)break}return null};this.getNextFoldLine=function(a,b){var c=this.$foldData,d=0;b&&(d=c.indexOf(b));-1==d&&(d=0);for(d;d<c.length;d++){var e=c[d];if(e.end.row>=a)return e}return null};this.getFoldedRowCount=function(a,b){for(var c=this.$foldData,d=b-a+1,e=0;e<c.length;e++){var f=
c[e],g=f.end.row,f=f.start.row;if(g>=b){f<b&&(d=f>=a?d-(b-f):0);break}else g>=a&&(d=f>=a?d-(g-f):d-(g-a+1))}return d};this.$addFoldLine=function(a){this.$foldData.push(a);this.$foldData.sort(function(a,c){return a.start.row-c.start.row});return a};this.addFold=function(a,b){var c=this.$foldData,d=!1,e;a instanceof q?e=a:(e=new q(b,a),e.collapseChildren=b.collapseChildren);this.$clipRangeToDocument(e.range);var f=e.start.row,g=e.start.column,h=e.end.row,j=e.end.column;if(!(f<h||f==h&&g<=j-2))throw Error("The range has to be at least 2 characters width");
var k=this.getFoldAt(f,g,1),l=this.getFoldAt(h,j,-1);if(k&&l==k)return k.addSubFold(e);k&&!k.range.isStart(f,g)&&this.removeFold(k);l&&!l.range.isEnd(h,j)&&this.removeFold(l);g=this.getFoldsInRange(e.range);0<g.length&&(this.removeFolds(g),g.forEach(function(a){e.addSubFold(a)}));for(g=0;g<c.length;g++){var i=c[g];if(h==i.start.row){i.addFold(e);d=!0;break}else if(f==i.end.row){i.addFold(e);d=!0;if(!e.sameRow&&(c=c[g+1])&&c.start.row==h){i.merge(c);break}break}else if(h<=i.start.row)break}d||(i=this.$addFoldLine(new p(this.$foldData,
e)));this.$useWrapMode?this.$updateWrapData(i.start.row,i.start.row):this.$updateRowLengthCache(i.start.row,i.start.row);this.$modified=!0;this._signal("changeFold",{data:e,action:"add"});return e};this.addFolds=function(a){a.forEach(function(a){this.addFold(a)},this)};this.removeFold=function(a){var b=a.foldLine,c=b.start.row,d=b.end.row,e=this.$foldData,f=b.folds;1==f.length?e.splice(e.indexOf(b),1):b.range.isEnd(a.end.row,a.end.column)?(f.pop(),b.end.row=f[f.length-1].end.row,b.end.column=f[f.length-
1].end.column):b.range.isStart(a.start.row,a.start.column)?(f.shift(),b.start.row=f[0].start.row,b.start.column=f[0].start.column):a.sameRow?f.splice(f.indexOf(a),1):(b=b.split(a.start.row,a.start.column),f=b.folds,f.shift(),b.start.row=f[0].start.row,b.start.column=f[0].start.column);this.$updating||(this.$useWrapMode?this.$updateWrapData(c,d):this.$updateRowLengthCache(c,d));this.$modified=!0;this._signal("changeFold",{data:a,action:"remove"})};this.removeFolds=function(a){for(var b=[],c=0;c<a.length;c++)b.push(a[c]);
b.forEach(function(a){this.removeFold(a)},this);this.$modified=!0};this.expandFold=function(a){this.removeFold(a);a.subFolds.forEach(function(b){a.restoreRange(b);this.addFold(b)},this);0<a.collapseChildren&&this.foldAll(a.start.row+1,a.end.row,a.collapseChildren-1);a.subFolds=[]};this.expandFolds=function(a){a.forEach(function(a){this.expandFold(a)},this)};this.unfold=function(a,b){var c,d;null==a?(c=new n(0,0,this.getLength(),0),b=!0):c="number"==typeof a?new n(a,0,a,this.getLine(a).length):"row"in
a?n.fromPoints(a,a):a;d=this.getFoldsInRangeList(c);if(b)this.removeFolds(d);else for(var e=d;e.length;)this.expandFolds(e),e=this.getFoldsInRangeList(c);if(d.length)return d};this.isRowFolded=function(a,b){return!!this.getFoldLine(a,b)};this.getRowFoldEnd=function(a,b){var c=this.getFoldLine(a,b);return c?c.end.row:a};this.getRowFoldStart=function(a,b){var c=this.getFoldLine(a,b);return c?c.start.row:a};this.getFoldDisplayLine=function(a,b,c,d,e){null==d&&(d=a.start.row);null==e&&(e=0);null==b&&
(b=a.end.row);null==c&&(c=this.getLine(b).length);var f=this.doc,g="";a.walk(function(a,b,c,l){if(!(b<d)){if(b==d){if(c<e)return;l=Math.max(e,l)}g=null!=a?g+a:g+f.getLine(b).substring(l,c)}},b,c);return g};this.getDisplayLine=function(a,b,c,d){var e=this.getFoldLine(a);if(e)return this.getFoldDisplayLine(e,a,b,c,d);a=this.doc.getLine(a);return a.substring(d||0,b||a.length)};this.$cloneFoldData=function(){var a=[];return a=this.$foldData.map(function(b){b=b.folds.map(function(a){return a.clone()});
return new p(a,b)})};this.toggleFold=function(a){var b=this.selection.getRange(),c;if(b.isEmpty()){var d=b.start;if(c=this.getFoldAt(d.row,d.column)){this.expandFold(c);return}(a=this.findMatchingBracket(d))?1==b.comparePoint(a)?b.end=a:(b.start=a,b.start.column++,b.end.column--):(a=this.findMatchingBracket({row:d.row,column:d.column+1}))?(1==b.comparePoint(a)?b.end=a:b.start=a,b.start.column++):b=this.getCommentFoldRange(d.row,d.column)||b}else{d=this.getFoldsInRange(b);if(a&&d.length){this.expandFolds(d);
return}1==d.length&&(c=d[0])}c||(c=this.getFoldAt(b.start.row,b.start.column));if(c&&c.range.toString()==b.toString())this.expandFold(c);else{c="...";if(!b.isMultiLine()){c=this.getTextRange(b);if(4>c.length)return;c=c.trim().substring(0,2)+".."}this.addFold(c,b)}};this.getCommentFoldRange=function(a,b,c){var d=new r(this,a,b),e=d.getCurrentToken();if(e&&/^comment|string/.test(e.type)){var f=new n,g=RegExp(e.type.replace(/\..*/,"\\."));if(1!=c){do e=d.stepBackward();while(e&&g.test(e.type));d.stepForward()}f.start.row=
d.getCurrentTokenRow();f.start.column=d.getCurrentTokenColumn()+2;d=new r(this,a,b);if(-1!=c){do e=d.stepForward();while(e&&g.test(e.type));e=d.stepBackward()}else e=d.getCurrentToken();f.end.row=d.getCurrentTokenRow();f.end.column=d.getCurrentTokenColumn()+e.value.length-2;return f}};this.foldAll=function(a,b,c){void 0==c&&(c=1E5);var d=this.foldWidgets;if(d)for(var b=b||this.getLength(),e=a=a||0;e<b;e++)if(null==d[e]&&(d[e]=this.getFoldWidget(e)),"start"==d[e]){var f=this.getFoldWidgetRange(e);
if(f&&f.isMultiLine()&&f.end.row<=b&&f.start.row>=a){e=f.end.row;try{var g=this.addFold("...",f);g&&(g.collapseChildren=c)}catch(h){}}}};this.$foldStyles={manual:1,markbegin:1,markbeginend:1};this.$foldStyle="markbegin";this.setFoldStyle=function(a){if(!this.$foldStyles[a])throw Error("invalid fold style: "+a+"["+Object.keys(this.$foldStyles).join(", ")+"]");this.$foldStyle!=a&&(this.$foldStyle=a,"manual"==a&&this.unfold(),a=this.$foldMode,this.$setFolding(null),this.$setFolding(a))};this.$setFolding=
function(a){this.$foldMode!=a&&(this.$foldMode=a,this.off("change",this.$updateFoldWidgets),this.off("tokenizerUpdate",this.$tokenizerUpdateFoldWidgets),this._signal("changeAnnotation"),!a||"manual"==this.$foldStyle?this.foldWidgets=null:(this.foldWidgets=[],this.getFoldWidget=a.getFoldWidget.bind(a,this,this.$foldStyle),this.getFoldWidgetRange=a.getFoldWidgetRange.bind(a,this,this.$foldStyle),this.$updateFoldWidgets=this.updateFoldWidgets.bind(this),this.$tokenizerUpdateFoldWidgets=this.tokenizerUpdateFoldWidgets.bind(this),
this.on("change",this.$updateFoldWidgets),this.on("tokenizerUpdate",this.$tokenizerUpdateFoldWidgets)))};this.getParentFoldRangeData=function(a,b){var c=this.foldWidgets;if(!c||b&&c[a])return{};for(var d=a-1,e;0<=d;){var f=c[d];null==f&&(f=c[d]=this.getFoldWidget(d));if("start"==f){var g=this.getFoldWidgetRange(d);e||(e=g);if(g&&g.end.row>=a)break}d--}return{range:-1!==d&&g,firstRange:e}};this.onFoldWidgetClick=function(a,b){b=b.domEvent;if(!this.$toggleFoldWidget(a,{children:b.shiftKey,all:b.ctrlKey||
b.metaKey,siblings:b.altKey})){var c=b.target||b.srcElement;c&&/ace_fold-widget/.test(c.className)&&(c.className+=" ace_invalid")}};this.$toggleFoldWidget=function(a,b){if(this.getFoldWidget){var c=this.getFoldWidget(a),d=this.getLine(a),c="end"===c?-1:1;if(c=this.getFoldAt(a,-1===c?0:d.length,c))return b.children||b.all?this.removeFold(c):this.expandFold(c),c;if((d=this.getFoldWidgetRange(a,!0))&&!d.isMultiLine())if((c=this.getFoldAt(d.start.row,d.start.column,1))&&d.isEqual(c.range))return this.removeFold(c),
c;if(b.siblings){c=this.getParentFoldRangeData(a);if(c.range)var e=c.range.start.row+1,f=c.range.end.row;this.foldAll(e,f,b.all?1E4:0)}else b.children?(f=d?d.end.row:this.getLength(),this.foldAll(a+1,f,b.all?1E4:0)):d&&(b.all&&(d.collapseChildren=1E4),this.addFold("...",d));return d}};this.toggleFoldWidget=function(){var a=this.selection.getCursor().row,a=this.getRowFoldStart(a),b=this.$toggleFoldWidget(a,{});if(!b&&(b=this.getParentFoldRangeData(a,!0),b=b.range||b.firstRange))a=b.start.row,(a=this.getFoldAt(a,
this.getLine(a).length,1))?this.removeFold(a):this.addFold("...",b)};this.updateFoldWidgets=function(a){var b=a.start.row,c=a.end.row-b;0===c?this.foldWidgets[b]=null:"remove"==a.action?this.foldWidgets.splice(b,c+1,null):(a=Array(c+1),a.unshift(b,1),this.foldWidgets.splice.apply(this.foldWidgets,a))};this.tokenizerUpdateFoldWidgets=function(a){a=a.data;a.first!=a.last&&this.foldWidgets.length>a.first&&this.foldWidgets.splice(a.first,this.foldWidgets.length)}}});