/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2010, Ajax.org B.V.
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

"undefined"!==typeof process&&(require("amd-loader"),require("./test/mockdom"));
define("require exports module ./edit_session ./editor ./test/mockrenderer ./test/assertions".split(" "),function(d,h,g){var f=d("./edit_session").EditSession,c=d("./editor").Editor,e=d("./test/mockrenderer").MockRenderer,b=d("./test/assertions");g.exports={createEditSession:function(a,b){var c=Array(b+1).join("a"),c=Array(a).join(c+"\n")+c;return new f(c)},"test: navigate to end of file should scroll the last line into view":function(){var a=this.createEditSession(200,10),a=new c(new e,a);a.navigateFileEnd();
var d=a.getCursorPosition();b.ok(a.getFirstVisibleRow()<=d.row);b.ok(a.getLastVisibleRow()>=d.row)},"test: navigate to start of file should scroll the first row into view":function(){var a=this.createEditSession(200,10),a=new c(new e,a);a.moveCursorTo(a.getLastVisibleRow()+20);a.navigateFileStart();b.equal(a.getFirstVisibleRow(),0)},"test: goto hidden line should scroll the line into the middle of the viewport":function(){var a=new c(new e,this.createEditSession(200,5));a.navigateTo(0,0);a.gotoLine(101);
b.position(a.getCursorPosition(),100,0);b.equal(a.getFirstVisibleRow(),89);a.navigateTo(100,0);a.gotoLine(11);b.position(a.getCursorPosition(),10,0);b.equal(a.getFirstVisibleRow(),0);a.navigateTo(100,0);a.gotoLine(6);b.position(a.getCursorPosition(),5,0);b.equal(0,a.getFirstVisibleRow(),0);a.navigateTo(100,0);a.gotoLine(1);b.position(a.getCursorPosition(),0,0);b.equal(a.getFirstVisibleRow(),0);a.navigateTo(0,0);a.gotoLine(191);b.position(a.getCursorPosition(),190,0);b.equal(a.getFirstVisibleRow(),
179);a.navigateTo(0,0);a.gotoLine(196);b.position(a.getCursorPosition(),195,0);b.equal(a.getFirstVisibleRow(),180)},"test: goto visible line should only move the cursor and not scroll":function(){var a=new c(new e,this.createEditSession(200,5));a.navigateTo(0,0);a.gotoLine(12);b.position(a.getCursorPosition(),11,0);b.equal(a.getFirstVisibleRow(),0);a.navigateTo(30,0);a.gotoLine(33);b.position(a.getCursorPosition(),32,0);b.equal(a.getFirstVisibleRow(),30)},"test: navigate from the end of a long line down to a short line and back should maintain the curser column":function(){var a=
new c(new e,new f(["123456","1"]));a.navigateTo(0,6);b.position(a.getCursorPosition(),0,6);a.navigateDown();b.position(a.getCursorPosition(),1,1);a.navigateUp();b.position(a.getCursorPosition(),0,6)},"test: reset desired column on navigate left or right":function(){var a=new c(new e,new f(["123456","12"]));a.navigateTo(0,6);b.position(a.getCursorPosition(),0,6);a.navigateDown();b.position(a.getCursorPosition(),1,2);a.navigateLeft();b.position(a.getCursorPosition(),1,1);a.navigateUp();b.position(a.getCursorPosition(),
0,1)},"test: typing text should update the desired column":function(){var a=new c(new e,new f(["1234","1234567890"]));a.navigateTo(0,3);a.insert("juhu");a.navigateDown();b.position(a.getCursorPosition(),1,7)}}});"undefined"!==typeof module&&module===require.main&&require("asyncjs").test.testcase(module.exports).exec();