/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2010, Ajax.org B.V.
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

"undefined"!==typeof process&&(require("amd-loader"),require("./test/mockdom"));
define("require exports module ./edit_session ./editor ./mode/javascript ./undomanager ./test/mockrenderer ./test/assertions ./ext/whitespace".split(" "),function(g,n,k){var d=g("./edit_session").EditSession,e=g("./editor").Editor,i=g("./mode/javascript").Mode,l=g("./undomanager").UndoManager,f=g("./test/mockrenderer").MockRenderer,c=g("./test/assertions"),m=g("./ext/whitespace");k.exports={"test: delete line from the middle":function(){var b=new d("a\nb\nc\nd"),a=new e(new f,b);a.moveCursorTo(1,
1);a.removeLines();c.equal(b.toString(),"a\nc\nd");c.position(a.getCursorPosition(),1,0);a.removeLines();c.equal(b.toString(),"a\nd");c.position(a.getCursorPosition(),1,0);a.removeLines();c.equal(b.toString(),"a");c.position(a.getCursorPosition(),0,1);a.removeLines();c.equal(b.toString(),"");c.position(a.getCursorPosition(),0,0)},"test: delete multiple selected lines":function(){var b=new d("a\nb\nc\nd"),a=new e(new f,b);a.moveCursorTo(1,1);a.getSelection().selectDown();a.removeLines();c.equal(b.toString(),
"a\nd");c.position(a.getCursorPosition(),1,0)},"test: delete first line":function(){var b=new d("a\nb\nc"),a=new e(new f,b);a.removeLines();c.equal(b.toString(),"b\nc");c.position(a.getCursorPosition(),0,0)},"test: delete last should also delete the new line of the previous line":function(){var b=new d("a\nb\nc\n"),a=new e(new f,b);a.moveCursorTo(3,0);a.removeLines();c.equal(b.toString(),"a\nb\nc");c.position(a.getCursorPosition(),2,1);a.removeLines();c.equal(b.toString(),"a\nb");c.position(a.getCursorPosition(),
1,1)},"test: indent block":function(){var b=new d("a12345\nb12345\nc12345"),a=new e(new f,b);a.moveCursorTo(1,3);a.getSelection().selectDown();a.indent();c.equal("a12345\n    b12345\n    c12345",b.toString());c.position(a.getCursorPosition(),2,7);var h=a.getSelectionRange();c.position(h.start,1,7);c.position(h.end,2,7);b.setValue("   x");b.setOption("useSoftTabs",!1);a.selection.moveTo(0,3);a.indent();c.equal("\tx",b.toString())},"test: indent selected lines":function(){var b=new d("a12345\nb12345\nc12345"),
a=new e(new f,b);a.moveCursorTo(1,0);a.getSelection().selectDown();a.indent();c.equal("a12345\n    b12345\nc12345",b.toString())},"test: no auto indent if cursor is before the {":function(){var b=new d("{",new i),a=new e(new f,b);a.moveCursorTo(0,0);a.onTextInput("\n");c.equal("\n{",b.toString())},"test: outdent block":function(){var b=new d("        a12345\n    b12345\n        c12345"),a=new e(new f,b);a.moveCursorTo(0,5);a.getSelection().selectDown();a.getSelection().selectDown();a.blockOutdent();
c.equal(b.toString(),"    a12345\nb12345\n    c12345");c.position(a.getCursorPosition(),2,1);var h=a.getSelectionRange();c.position(h.start,0,1);c.position(h.end,2,1);a.blockOutdent();c.equal(b.toString(),"a12345\nb12345\nc12345");h=a.getSelectionRange();c.position(h.start,0,0);c.position(h.end,2,0)},"test: outent without a selection should update cursor":function(){var b=new d("        12"),a=new e(new f,b);a.moveCursorTo(0,3);a.blockOutdent("  ");c.equal(b.toString(),"    12");c.position(a.getCursorPosition(),
0,0)},"test: comment lines should perserve selection":function(){var b=new d("  abc\ncde",new i),a=new e(new f,b);m.detectIndentation(b);a.moveCursorTo(0,2);a.getSelection().selectDown();a.toggleCommentLines();c.equal("//   abc\n// cde",b.toString());b=a.getSelectionRange();c.position(b.start,0,5);c.position(b.end,1,5)},"test: uncomment lines should perserve selection":function(){var b=new d("//   abc\n//cde",new i),a=new e(new f,b);b.setTabSize(2);a.moveCursorTo(0,1);a.getSelection().selectDown();
a.getSelection().selectRight();a.getSelection().selectRight();a.toggleCommentLines();c.equal("  abc\ncde",b.toString());c.range(a.getSelectionRange(),0,0,1,1)},"test: toggle comment lines twice should return the original text":function(){var b=new d(["  abc","cde","fg"],new i),a=new e(new f,b);a.moveCursorTo(0,0);a.getSelection().selectDown();a.getSelection().selectDown();a.toggleCommentLines();a.toggleCommentLines();c.equal("  abc\ncde\nfg",b.toString())},"test: comment lines - if the selection end is at the line start it should stay there":function(){var b=
new d("abc\ncde",new i),b=new e(new f,b);b.moveCursorTo(0,0);b.getSelection().selectDown();b.toggleCommentLines();c.range(b.getSelectionRange(),0,3,1,0);b=new d("abc\ncde",new i);b=new e(new f,b);b.moveCursorTo(1,0);b.getSelection().selectUp();b.toggleCommentLines();c.range(b.getSelectionRange(),0,3,1,0)},"test: move lines down should keep selection on moved lines":function(){var b=new d("11\n22\n33\n44"),a=new e(new f,b);a.moveCursorTo(0,1);a.getSelection().selectDown();a.moveLinesDown();c.equal("33\n11\n22\n44",
b.toString());c.position(a.getCursorPosition(),2,1);c.position(a.getSelection().getSelectionAnchor(),1,1);c.position(a.getSelection().getSelectionLead(),2,1);a.moveLinesDown();c.equal("33\n44\n11\n22",b.toString());c.position(a.getCursorPosition(),3,1);c.position(a.getSelection().getSelectionAnchor(),2,1);c.position(a.getSelection().getSelectionLead(),3,1);a.moveLinesDown();c.equal("33\n44\n11\n22",b.toString());c.position(a.getCursorPosition(),3,1);c.position(a.getSelection().getSelectionAnchor(),
2,1);c.position(a.getSelection().getSelectionLead(),3,1)},"test: move lines up should keep selection on moved lines":function(){var b=new d("11\n22\n33\n44"),a=new e(new f,b);a.moveCursorTo(2,1);a.getSelection().selectDown();a.moveLinesUp();c.equal(b.toString(),"11\n33\n44\n22");c.position(a.getCursorPosition(),2,1);c.position(a.getSelection().getSelectionAnchor(),1,1);c.position(a.getSelection().getSelectionLead(),2,1);a.moveLinesUp();c.equal(b.toString(),"33\n44\n11\n22");c.position(a.getCursorPosition(),
1,1);c.position(a.getSelection().getSelectionAnchor(),0,1);c.position(a.getSelection().getSelectionLead(),1,1)},"test: move line without active selection should not move cursor relative to the moved line":function(){var b=new d("11\n22\n33\n44"),a=new e(new f,b);a.moveCursorTo(1,1);a.clearSelection();a.moveLinesDown();c.equal("11\n33\n22\n44",b.toString());c.position(a.getCursorPosition(),2,1);a.clearSelection();a.moveLinesUp();c.equal("11\n22\n33\n44",b.toString());c.position(a.getCursorPosition(),
1,1)},"test: copy lines down should keep selection":function(){var b=new d("11\n22\n33\n44"),a=new e(new f,b);a.moveCursorTo(1,1);a.getSelection().selectDown();a.copyLinesDown();c.equal("11\n22\n33\n22\n33\n44",b.toString());c.position(a.getCursorPosition(),4,1);c.position(a.getSelection().getSelectionAnchor(),3,1);c.position(a.getSelection().getSelectionLead(),4,1)},"test: copy lines up should keep selection":function(){var b=new d("11\n22\n33\n44"),a=new e(new f,b);a.moveCursorTo(1,1);a.getSelection().selectDown();
a.copyLinesUp();c.equal("11\n22\n33\n22\n33\n44",b.toString());c.position(a.getCursorPosition(),2,1);c.position(a.getSelection().getSelectionAnchor(),1,1);c.position(a.getSelection().getSelectionLead(),2,1)},"test: input a tab with soft tab should convert it to spaces":function(){var b=new d(""),a=new e(new f,b);b.setTabSize(2);b.setUseSoftTabs(!0);a.onTextInput("\t");c.equal(b.toString(),"  ");b.setTabSize(5);a.onTextInput("\t");c.equal(b.toString(),"       ")},"test: input tab without soft tabs should keep the tab character":function(){var b=
new d(""),a=new e(new f,b);b.setUseSoftTabs(!1);a.onTextInput("\t");c.equal(b.toString(),"\t")},"test: undo/redo for delete line":function(){var b=new d(["111","222","333"]),a=new l;b.setUndoManager(a);var h=b.toString(),g=new e(new f,b);g.removeLines();var i=b.toString();c.equal(i,"222\n333");b.$syncInformUndoManager();g.removeLines();var j=b.toString();c.equal(j,"333");b.$syncInformUndoManager();g.removeLines();c.equal(b.toString(),"");b.$syncInformUndoManager();a.undo();b.$syncInformUndoManager();
c.equal(b.toString(),j);a.undo();b.$syncInformUndoManager();c.equal(b.toString(),i);a.undo();b.$syncInformUndoManager();c.equal(b.toString(),h);a.undo();b.$syncInformUndoManager();c.equal(b.toString(),h)},"test: remove left should remove character left of the cursor":function(){var b=new d(["123","456"]),a=new e(new f,b);a.moveCursorTo(1,1);a.remove("left");c.equal(b.toString(),"123\n56")},"test: remove left should remove line break if cursor is at line start":function(){var b=new d(["123","456"]),
a=new e(new f,b);a.moveCursorTo(1,0);a.remove("left");c.equal(b.toString(),"123456")},"test: remove left should remove tabsize spaces if cursor is on a tab stop and preceeded by spaces":function(){var b=new d(["123","        456"]);b.setUseSoftTabs(!0);b.setTabSize(4);var a=new e(new f,b);a.moveCursorTo(1,8);a.remove("left");c.equal(b.toString(),"123\n    456")},"test: transpose at line start should be a noop":function(){var b=new d(["123","4567","89"]),a=new e(new f,b);a.moveCursorTo(1,0);a.transposeLetters();
c.equal(b.getValue(),"123\n4567\n89")},"test: transpose in line should swap the charaters before and after the cursor":function(){var b=new d(["123","4567","89"]),a=new e(new f,b);a.moveCursorTo(1,2);a.transposeLetters();c.equal(b.getValue(),"123\n4657\n89")},"test: transpose at line end should swap the last two characters":function(){var b=new d(["123","4567","89"]),a=new e(new f,b);a.moveCursorTo(1,4);a.transposeLetters();c.equal(b.getValue(),"123\n4576\n89")},"test: transpose with non empty selection should be a noop":function(){var b=
new d(["123","4567","89"]),a=new e(new f,b);a.moveCursorTo(1,1);a.getSelection().selectRight();a.transposeLetters();c.equal(b.getValue(),"123\n4567\n89")},"test: transpose should move the cursor behind the last swapped character":function(){var b=new d(["123","4567","89"]),b=new e(new f,b);b.moveCursorTo(1,2);b.transposeLetters();c.position(b.getCursorPosition(),1,3)},"test: remove to line end":function(){var b=new d(["123","4567","89"]),a=new e(new f,b);a.moveCursorTo(1,2);a.removeToLineEnd();c.equal(b.getValue(),
"123\n45\n89")},"test: remove to line end at line end should remove the new line":function(){var b=new d(["123","4567","89"]),a=new e(new f,b);a.moveCursorTo(1,4);a.removeToLineEnd();c.position(a.getCursorPosition(),1,4);c.equal(b.getValue(),"123\n456789")},"test: transform selection to uppercase":function(){var b=new d(["ajax","dot","org"]),a=new e(new f,b);a.moveCursorTo(1,0);a.getSelection().selectLineEnd();a.toUpperCase();c.equal(b.getValue(),"ajax\nDOT\norg")},"test: transform word to uppercase":function(){var b=
new d(["ajax","dot","org"]),a=new e(new f,b);a.moveCursorTo(1,0);a.toUpperCase();c.equal(b.getValue(),"ajax\nDOT\norg");c.position(a.getCursorPosition(),1,0)},"test: transform selection to lowercase":function(){var b=new d(["AJAX","DOT","ORG"]),a=new e(new f,b);a.moveCursorTo(1,0);a.getSelection().selectLineEnd();a.toLowerCase();c.equal(b.getValue(),"AJAX\ndot\nORG")},"test: transform word to lowercase":function(){var b=new d(["AJAX","DOT","ORG"]),a=new e(new f,b);a.moveCursorTo(1,0);a.toLowerCase();
c.equal(b.getValue(),"AJAX\ndot\nORG");c.position(a.getCursorPosition(),1,0)}}});"undefined"!==typeof module&&module===require.main&&require("asyncjs").test.testcase(module.exports).exec();