/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2012, Ajax.org B.V.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

define(["require","exports","module","../editor","../config"],function(l,m){var j=function(a){this.$editor=a;var d=this,b=[],c=!1;this.onAfterExec=function(){c=!1;d.processRows(b);b=[]};this.onExec=function(){c=!0};this.onChange=function(a){c&&(-1==b.indexOf(a.start.row)&&b.push(a.start.row),a.end.row!=a.start.row&&b.push(a.end.row))}};(function(){this.processRows=function(a){this.$inChange=!0;for(var d=[],b=0,c=a.length;b<c;b++){var e=a[b];if(!(-1<d.indexOf(e)))for(var f=this.$findCellWidthsForBlock(e),
e=this.$setBlockCellWidthsToMax(f.cellWidths),f=f.firstRow,i=0,g=e.length;i<g;i++){var h=e[i];d.push(f);this.$adjustRow(f,h);f++}}this.$inChange=!1};this.$findCellWidthsForBlock=function(a){for(var d=[],b,c=a;0<=c;){b=this.$cellWidthsForRow(c);if(0==b.length)break;d.unshift(b);c--}for(var e=c+1,c=a,a=this.$editor.session.getLength();c<a-1;){c++;b=this.$cellWidthsForRow(c);if(0==b.length)break;d.push(b)}return{cellWidths:d,firstRow:e}};this.$cellWidthsForRow=function(a){for(var d=this.$selectionColumnsForRow(a),
b=[-1].concat(this.$tabsForRow(a)),c=b.map(function(){return 0}).slice(1),a=this.$editor.session.getLine(a),e=0,f=b.length-1;e<f;e++){var i=b[e]+1,g=b[e+1],h=this.$rightmostSelectionInCell(d,g),g=a.substring(i,g);c[e]=Math.max(g.replace(/\s+$/g,"").length,h-i)}return c};this.$selectionColumnsForRow=function(a){var d=[],b=this.$editor.getCursorPosition();this.$editor.session.getSelection().isEmpty()&&a==b.row&&d.push(b.column);return d};this.$setBlockCellWidthsToMax=function(a){for(var d=!0,b,c,e=
this.$izip_longest(a),f=0,i=e.length;f<i;f++){var g=e[f];if(g.push){g.push(NaN);for(var h=0,n=g.length;h<n;h++){var k=g[h];d&&(b=h,c=0,d=!1);if(isNaN(k)){for(var d=h,j=b;j<d;j++)a[j][f]=c;d=!0}c=Math.max(c,k)}}else console.error(g)}return a};this.$rightmostSelectionInCell=function(a,d){var b=0;if(a.length){for(var b=[],c=0,e=a.length;c<e;c++)a[c]<=d?b.push(c):b.push(0);b=Math.max.apply(Math,b)}return b};this.$tabsForRow=function(a){for(var d=[],a=this.$editor.session.getLine(a),b=/\t/g,c;null!=(c=
b.exec(a));)d.push(c.index);return d};this.$adjustRow=function(a,d){var b=this.$tabsForRow(a);if(0!=b.length)for(var c=0,e=-1,b=this.$izip(d,b),f=0,i=b.length;f<i;f++){var g=b[f][1],e=e+(1+b[f][0]),g=g+c,h=e-g;if(0!=h){var j=this.$editor.session.getLine(a).substr(0,g),k=j.replace(/\s*$/g,""),j=j.length-k.length;0<h&&(this.$editor.session.getDocument().insertInLine({row:a,column:g+1},Array(h+1).join(" ")+"\t"),this.$editor.session.getDocument().removeInLine(a,g,g+1),c+=h);0>h&&j>=-h&&(this.$editor.session.getDocument().removeInLine(a,
g+h,g),c+=h)}}};this.$izip_longest=function(a){if(!a[0])return[];for(var d=a[0].length,b=a.length,c=1;c<b;c++){var e=a[c].length;e>d&&(d=e)}for(var e=[],f=0;f<d;f++){for(var i=[],c=0;c<b;c++)""===a[c][f]?i.push(NaN):i.push(a[c][f]);e.push(i)}return e};this.$izip=function(a,d){for(var b=a.length>=d.length?d.length:a.length,c=[],e=0;e<b;e++)c.push([a[e],d[e]]);return c}}).call(j.prototype);m.ElasticTabstopsLite=j;var p=l("../editor").Editor;l("../config").defineOptions(p.prototype,"editor",{useElasticTabstops:{set:function(a){a?
(this.elasticTabstops||(this.elasticTabstops=new j(this)),this.commands.on("afterExec",this.elasticTabstops.onAfterExec),this.commands.on("exec",this.elasticTabstops.onExec),this.on("change",this.elasticTabstops.onChange)):this.elasticTabstops&&(this.commands.removeListener("afterExec",this.elasticTabstops.onAfterExec),this.commands.removeListener("exec",this.elasticTabstops.onExec),this.removeListener("change",this.elasticTabstops.onChange))}}})});