/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2010, Ajax.org B.V.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

define("require exports module ace/keyboard/hash_handler ace/editor ace/snippets ace/range ace/config ace/config".split(" "),function(f,e){function i(){}var s=f("ace/keyboard/hash_handler").HashHandler,t=f("ace/editor").Editor,u=f("ace/snippets").snippetManager,v=f("ace/range").Range,d,g;i.prototype={setupContext:function(a){this.ace=a;this.indentation=a.session.getTabString();d||(d=window.emmet);d.require("resources").setVariable("indentation",this.indentation);this.$syntax=null;this.$syntax=this.getSyntax()},
getSelectionRange:function(){var a=this.ace.getSelectionRange(),b=this.ace.session.doc;return{start:b.positionToIndex(a.start),end:b.positionToIndex(a.end)}},createSelection:function(a,b){var c=this.ace.session.doc;this.ace.selection.setRange({start:c.indexToPosition(a),end:c.indexToPosition(b)})},getCurrentLineRange:function(){var a=this.ace,b=a.getCursorPosition().row,c=a.session.getLine(b).length,a=a.session.doc.positionToIndex({row:b,column:0});return{start:a,end:a+c}},getCaretPos:function(){var a=
this.ace.getCursorPosition();return this.ace.session.doc.positionToIndex(a)},setCaretPos:function(a){a=this.ace.session.doc.indexToPosition(a);this.ace.selection.moveToPosition(a)},getCurrentLine:function(){var a=this.ace.getCursorPosition().row;return this.ace.session.getLine(a)},replaceContent:function(a,b,c){null==c&&(c=null==b?this.getContent().length:b);null==b&&(b=0);var l=this.ace,e=l.session.doc,b=v.fromPoints(e.indexToPosition(b),e.indexToPosition(c));l.session.remove(b);b.end=b.start;a=
this.$updateTabstops(a);u.insertSnippet(l,a)},getContent:function(){return this.ace.getValue()},getSyntax:function(){if(this.$syntax)return this.$syntax;var a=this.ace.session.$modeId.split("/").pop();if("html"==a||"php"==a){var b=this.ace.getCursorPosition(),b=this.ace.session.getState(b.row);"string"!=typeof b&&(b=b[0]);b&&(b=b.split("-"),1<b.length?a=b[0]:"php"==a&&(a="html"))}return a},getProfileName:function(){switch(this.getSyntax()){case "css":return"css";case "xml":case "xsl":return"xml";
case "html":var a=d.require("resources").getVariable("profile");a||(a=-1!=this.ace.session.getLines(0,2).join("").search(/<!DOCTYPE[^>]+XHTML/i)?"xhtml":"html");return a;default:return a=this.ace.session.$mode,a.emmetConfig&&a.emmetConfig.profile||"xhtml"}},prompt:function(a){return prompt(a)},getSelection:function(){return this.ace.session.getTextRange()},getFilePath:function(){return""},$updateTabstops:function(a){var b=0,c=null,e=d.require("range"),n=d.require("tabStops"),f=d.require("resources").getVocabulary("user"),
h={tabstop:function(a){var d=parseInt(a.group,10),f=0===d,d=f?++b:d+1E3,j=a.placeholder;j&&(j=n.processText(j,h));d="${"+d+(j?":"+j:"")+"}";f&&(c=e.create(a.start,d));return d},escape:function(a){return"$"==a?"\\$":"\\"==a?"\\\\":a}},a=n.processText(a,h);f.variables.insert_final_tabstop&&!/\$\{0\}$/.test(a)?a+="${0}":c&&(a=d.require("utils").replaceSubstring(a,"${0}",c));return a}};var p={expand_abbreviation:{mac:"ctrl+alt+e",win:"alt+e"},match_pair_outward:{mac:"ctrl+d",win:"ctrl+,"},match_pair_inward:{mac:"ctrl+j",
win:"ctrl+shift+0"},matching_pair:{mac:"ctrl+alt+j",win:"alt+j"},next_edit_point:"alt+right",prev_edit_point:"alt+left",toggle_comment:{mac:"command+/",win:"ctrl+/"},split_join_tag:{mac:"shift+command+'",win:"shift+ctrl+`"},remove_tag:{mac:"command+'",win:"shift+ctrl+;"},evaluate_math_expression:{mac:"shift+command+y",win:"shift+ctrl+y"},increment_number_by_1:"ctrl+up",decrement_number_by_1:"ctrl+down",increment_number_by_01:"alt+up",decrement_number_by_01:"alt+down",increment_number_by_10:{mac:"alt+command+up",
win:"shift+alt+up"},decrement_number_by_10:{mac:"alt+command+down",win:"shift+alt+down"},select_next_item:{mac:"shift+command+.",win:"shift+ctrl+."},select_previous_item:{mac:"shift+command+,",win:"shift+ctrl+,"},reflect_css_value:{mac:"shift+command+r",win:"shift+ctrl+r"},encode_decode_data_url:{mac:"shift+ctrl+d",win:"ctrl+'"},expand_abbreviation_with_tab:"Tab",wrap_with_abbreviation:{mac:"shift+ctrl+a",win:"shift+ctrl+a"}},h=new i;e.commands=new s;e.runEmmetCommand=function b(c){try{h.setupContext(c);
var e=d.require("actions");if("expand_abbreviation_with_tab"==this.action){if(!c.selection.isEmpty())return!1;var f=c.selection.lead,g=c.session.getTokenAt(f.row,f.column);if(g&&/\btag\b/.test(g.type))return!1}if("wrap_with_abbreviation"==this.action)return setTimeout(function(){e.run("wrap_with_abbreviation",h)},0);var i=e.run(this.action,h)}catch(k){if(!d)return q(b.bind(this,c)),!0;c._signal("changeStatus","string"==typeof k?k:k.message);console.log(k);i=!1}return i};for(var m in p)e.commands.addCommand({name:"emmet:"+
m,action:m,bindKey:p[m],exec:e.runEmmetCommand,multiSelectAction:"forEach"});e.updateCommands=function(b,c){c?b.keyBinding.addKeyboardHandler(e.commands):b.keyBinding.removeKeyboardHandler(e.commands)};e.isSupportedMode=function(b){return!b?!1:b.emmetConfig?!0:/css|less|scss|sass|stylus|html|php|twig|ejs|handlebars/.test(b.$id||b)};e.isAvailable=function(b,c){if(/(evaluate_math_expression|expand_abbreviation)$/.test(c))return!0;var d=b.session.$mode,f=e.isSupportedMode(d);if(f&&d.$modes)try{h.setupContext(b),
/js|php/.test(h.getSyntax())&&(f=!1)}catch(g){}return f};var r=function(b,c){if(c){var d=e.isSupportedMode(c.session.$mode);!1===b.enableEmmet&&(d=!1);d&&q();e.updateCommands(c,d)}},q=function(b){"string"==typeof g&&f("ace/config").loadModule(g,function(){g=null;b&&b()})};e.AceEmmetEditor=i;f("ace/config").defineOptions(t.prototype,"editor",{enableEmmet:{set:function(b){this[b?"on":"removeListener"]("changeMode",r);r({enableEmmet:!!b},this)},value:!0}});e.setCore=function(b){"string"==typeof b?g=
b:d=b}});