/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2010, Ajax.org B.V.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

define("require exports module ../lib/dom ../lib/lang ../lib/event ../requirejs/text!./searchbox.css ../keyboard/hash_handler ../lib/keys".split(" "),function(f,h){var c=f("../lib/dom"),j=f("../lib/lang"),d=f("../lib/event"),k=f("../requirejs/text!./searchbox.css"),i=f("../keyboard/hash_handler").HashHandler,l=f("../lib/keys");c.importCssString(k,"ace_searchbox");var m='<div class="ace_search right">    <button type="button" action="hide" class="ace_searchbtn_close"></button>    <div class="ace_search_form">        <input class="ace_search_field" placeholder="Search for" spellcheck="false"></input>        <button type="button" action="findNext" class="ace_searchbtn next"></button>        <button type="button" action="findPrev" class="ace_searchbtn prev"></button>        <button type="button" action="findAll" class="ace_searchbtn" title="Alt-Enter">All</button>    </div>    <div class="ace_replace_form">        <input class="ace_search_field" placeholder="Replace with" spellcheck="false"></input>        <button type="button" action="replaceAndFindNext" class="ace_replacebtn">Replace</button>        <button type="button" action="replaceAll" class="ace_replacebtn">All</button>    </div>    <div class="ace_search_options">        <span action="toggleRegexpMode" class="ace_button" title="RegExp Search">.*</span>        <span action="toggleCaseSensitive" class="ace_button" title="CaseSensitive Search">Aa</span>        <span action="toggleWholeWords" class="ace_button" title="Whole Word Search">\\b</span>    </div></div>'.replace(/>\s+/g,
">"),g=function(a){var b=c.createElement("div");b.innerHTML=m;this.element=b.firstChild;this.$init();this.setEditor(a)};(function(){this.setEditor=function(a){a.searchBox=this;a.container.appendChild(this.element);this.editor=a};this.$initElements=function(a){this.searchBox=a.querySelector(".ace_search_form");this.replaceBox=a.querySelector(".ace_replace_form");this.searchOptions=a.querySelector(".ace_search_options");this.regExpOption=a.querySelector("[action=toggleRegexpMode]");this.caseSensitiveOption=
a.querySelector("[action=toggleCaseSensitive]");this.wholeWordOption=a.querySelector("[action=toggleWholeWords]");this.searchInput=this.searchBox.querySelector(".ace_search_field");this.replaceInput=this.replaceBox.querySelector(".ace_search_field")};this.$init=function(){var a=this.element;this.$initElements(a);var b=this;d.addListener(a,"mousedown",function(a){setTimeout(function(){b.activeInput.focus()},0);d.stopPropagation(a)});d.addListener(a,"click",function(a){var e=(a.target||a.srcElement).getAttribute("action");
if(e&&b[e])b[e]();else b.$searchBarKb.commands[e]&&b.$searchBarKb.commands[e].exec(b);d.stopPropagation(a)});d.addCommandKeyListener(a,function(a,e,c){c=l.keyCodeToString(c);if((e=b.$searchBarKb.findKeyCommand(e,c))&&e.exec)e.exec(b),d.stopEvent(a)});this.$onChange=j.delayedCall(function(){b.find(!1,!1)});d.addListener(this.searchInput,"input",function(){b.$onChange.schedule(20)});d.addListener(this.searchInput,"focus",function(){b.activeInput=b.searchInput;b.searchInput.value&&b.highlight()});d.addListener(this.replaceInput,
"focus",function(){b.activeInput=b.replaceInput;b.searchInput.value&&b.highlight()})};this.$closeSearchBarKb=new i([{bindKey:"Esc",name:"closeSearchBar",exec:function(a){a.searchBox.hide()}}]);this.$searchBarKb=new i;this.$searchBarKb.bindKeys({"Ctrl-f|Command-f":function(a){var b=a.isReplace=!a.isReplace;a.replaceBox.style.display=b?"":"none";a.searchInput.focus()},"Ctrl-H|Command-Option-F":function(a){a.replaceBox.style.display="";a.replaceInput.focus()},"Ctrl-G|Command-G":function(a){a.findNext()},
"Ctrl-Shift-G|Command-Shift-G":function(a){a.findPrev()},esc:function(a){setTimeout(function(){a.hide()})},Return:function(a){a.activeInput==a.replaceInput&&a.replace();a.findNext()},"Shift-Return":function(a){a.activeInput==a.replaceInput&&a.replace();a.findPrev()},"Alt-Return":function(a){a.activeInput==a.replaceInput&&a.replaceAll();a.findAll()},Tab:function(a){(a.activeInput==a.replaceInput?a.searchInput:a.replaceInput).focus()}});this.$searchBarKb.addCommands([{name:"toggleRegexpMode",bindKey:{win:"Alt-R|Alt-/",
mac:"Ctrl-Alt-R|Ctrl-Alt-/"},exec:function(a){a.regExpOption.checked=!a.regExpOption.checked;a.$syncOptions()}},{name:"toggleCaseSensitive",bindKey:{win:"Alt-C|Alt-I",mac:"Ctrl-Alt-R|Ctrl-Alt-I"},exec:function(a){a.caseSensitiveOption.checked=!a.caseSensitiveOption.checked;a.$syncOptions()}},{name:"toggleWholeWords",bindKey:{win:"Alt-B|Alt-W",mac:"Ctrl-Alt-B|Ctrl-Alt-W"},exec:function(a){a.wholeWordOption.checked=!a.wholeWordOption.checked;a.$syncOptions()}}]);this.$syncOptions=function(){c.setCssClass(this.regExpOption,
"checked",this.regExpOption.checked);c.setCssClass(this.wholeWordOption,"checked",this.wholeWordOption.checked);c.setCssClass(this.caseSensitiveOption,"checked",this.caseSensitiveOption.checked);this.find(!1,!1)};this.highlight=function(a){this.editor.session.highlight(a||this.editor.$search.$options.re);this.editor.renderer.updateBackMarkers()};this.find=function(a,b,d){a=this.editor.find(this.searchInput.value,{skipCurrent:a,backwards:b,wrap:!0,regExp:this.regExpOption.checked,caseSensitive:this.caseSensitiveOption.checked,
wholeWord:this.wholeWordOption.checked,preventScroll:d});c.setCssClass(this.searchBox,"ace_nomatch",!a&&this.searchInput.value);this.highlight()};this.findNext=function(){this.find(!0,!1)};this.findPrev=function(){this.find(!0,!0)};this.findAll=function(){var a=!this.editor.findAll(this.searchInput.value,{regExp:this.regExpOption.checked,caseSensitive:this.caseSensitiveOption.checked,wholeWord:this.wholeWordOption.checked})&&this.searchInput.value;c.setCssClass(this.searchBox,"ace_nomatch",a);this.editor._emit("findSearchBox",
{match:!a});this.highlight();this.hide()};this.replace=function(){this.editor.getReadOnly()||this.editor.replace(this.replaceInput.value)};this.replaceAndFindNext=function(){this.editor.getReadOnly()||(this.editor.replace(this.replaceInput.value),this.findNext())};this.replaceAll=function(){this.editor.getReadOnly()||this.editor.replaceAll(this.replaceInput.value)};this.hide=function(){this.element.style.display="none";this.editor.keyBinding.removeKeyboardHandler(this.$closeSearchBarKb);this.editor.focus()};
this.show=function(a,b){this.element.style.display="";this.replaceBox.style.display=b?"":"none";this.isReplace=b;a&&(this.searchInput.value=a);this.find(!1,!1,!0);this.searchInput.focus();this.searchInput.select();this.editor.keyBinding.addKeyboardHandler(this.$closeSearchBarKb)};this.isFocused=function(){var a=document.activeElement;return a==this.searchInput||a==this.replaceInput}}).call(g.prototype);h.SearchBox=g;h.Search=function(a,b){(a.searchBox||new g(a)).show(a.session.getTextRange(),b)}});