/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2010, Ajax.org B.V.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

define("require exports module ../lib/event ../lib/useragent ../lib/net ../ace ../theme/textmate".split(" "),function(k,p,y){function s(c,l){for(var h in l)c.style[h]=l[h]}var q=k("../lib/event"),z=k("../lib/useragent");k("../lib/net");var w=k("../ace");k("../theme/textmate");y.exports=p=w;var t=function(c,l,h){var a=c.style[h];a||(a=window.getComputedStyle?window.getComputedStyle(c,"").getPropertyValue(h):c.currentStyle[h]);if(!a||"auto"==a||"intrinsic"==a)a=l.style[h];return a};p.transformTextarea=
function(c,l){var h;if("textarea"!=c.type)throw Error("Textarea required!");var a=c.parentNode,g=document.createElement("div"),e=function(){var d="position:relative;";["margin-top","margin-left","margin-right","margin-bottom"].forEach(function(b){d+=b+":"+t(c,g,b)+";"});var b=t(c,g,"width")||c.clientWidth+"px",a=t(c,g,"height")||c.clientHeight+"px",d=d+("height:"+a+";width:"+b+";"),d=d+"display:inline-block;";g.setAttribute("style",d)};q.addListener(window,"resize",e);e();for(a.insertBefore(g,c.nextSibling);a!==
document;){if("FORM"===a.tagName.toUpperCase()){var k=a.onsubmit;a.onsubmit=function(d){c.value=h.getValue();k&&k.call(this,d)};break}a=a.parentNode}c.style.display="none";g.style.background="white";a=document.createElement("div");s(a,{top:"0px",left:"0px",right:"0px",bottom:"0px",border:"1px solid gray",position:"absolute"});g.appendChild(a);var r=document.createElement("div");s(r,{position:"absolute",right:"0px",bottom:"0px",background:"red",cursor:"nw-resize",borderStyle:"solid",borderWidth:"9px 8px 10px 9px",
width:"2px",borderColor:"lightblue gray gray lightblue",zIndex:101});var i=document.createElement("div"),e={top:"0px",left:"20%",right:"0px",bottom:"0px",position:"absolute",padding:"5px",zIndex:100,color:"white",display:"none",overflow:"auto",fontSize:"14px",boxShadow:"-5px 2px 3px gray"};e.backgroundColor=z.isOldIE?"#333":"rgba(0, 0, 0, 0.6)";s(i,e);g.appendChild(i);var l=l||p.defaultOptions,b=w.edit(a);h=b.getSession();h.setValue(c.value||c.innerHTML);b.focus();g.appendChild(r);a=l;b.getSession();
b.setDisplaySettings=function(d){null==d&&(d="none"==i.style.display);d?(i.style.display="block",i.hideButton.focus(),b.on("focus",function A(){b.removeListener("focus",A);i.style.display="none"})):b.focus()};b.$setOption=b.setOption;b.$getOption=b.getOption;b.setOption=function(d,a){switch(d){case "mode":b.$setOption("mode","ace/mode/"+a);break;case "theme":b.$setOption("theme","ace/theme/"+a);break;case "keybindings":switch(a){case "vim":b.setKeyboardHandler("ace/keyboard/vim");break;case "emacs":b.setKeyboardHandler("ace/keyboard/emacs");
break;default:b.setKeyboardHandler(null)}break;case "softWrap":case "fontSize":b.$setOption(d,a);break;default:b.$setOption(d,"true"===a||!0==a)}};b.getOption=function(a){switch(a){case "mode":return b.$getOption("mode").substr(9);case "theme":return b.$getOption("theme").substr(10);case "keybindings":switch(a=b.getKeyboardHandler(),a&&a.$id){case "ace/keyboard/vim":return"vim";case "ace/keyboard/emacs":return"emacs";default:return"ace"}default:return b.$getOption(a)}};b.setOptions(a);var a={mode:"Mode:",
wrap:"Soft Wrap:",theme:"Theme:",fontSize:"Font Size:",showGutter:"Display Gutter:",keybindings:"Keyboard",showPrintMargin:"Show Print Margin:",useSoftTabs:"Use Soft Tabs:",showInvisibles:"Show Invisibles"},e={mode:{text:"Plain",javascript:"JavaScript",xml:"XML",html:"HTML",css:"CSS",scss:"SCSS",python:"Python",php:"PHP",java:"Java",ruby:"Ruby",c_cpp:"C/C++",coffee:"CoffeeScript",json:"json",perl:"Perl",clojure:"Clojure",ocaml:"OCaml",csharp:"C#",haxe:"haXe",svg:"SVG",textile:"Textile",groovy:"Groovy",
liquid:"Liquid",Scala:"Scala"},theme:{clouds:"Clouds",clouds_midnight:"Clouds Midnight",cobalt:"Cobalt",crimson_editor:"Crimson Editor",dawn:"Dawn",eclipse:"Eclipse",idle_fingers:"Idle Fingers",kr_theme:"Kr Theme",merbivore:"Merbivore",merbivore_soft:"Merbivore Soft",mono_industrial:"Mono Industrial",monokai:"Monokai",pastel_on_dark:"Pastel On Dark",solarized_dark:"Solarized Dark",solarized_light:"Solarized Light",textmate:"Textmate",twilight:"Twilight",vibrant_ink:"Vibrant Ink"},showGutter:null,
fontSize:{"10px":"10px","11px":"11px","12px":"12px","14px":"14px","16px":"16px"},wrap:{off:"Off",40:"40",80:"80",free:"Free"},keybindings:{ace:"ace",vim:"vim",emacs:"emacs"},showPrintMargin:null,useSoftTabs:null,showInvisibles:null},j=[];j.push("<table><tr><th>Setting</th><th>Value</th></tr>");for(var f in p.defaultOptions){j.push("<tr><td>",a[f],"</td>");j.push("<td>");var n=j,m=f,u=e[f],x=b.getOption(f);if(u){n.push("<select title='"+m+"'>");m=void 0;for(m in u)n.push("<option value='"+m+"' "),
x==m&&n.push(" selected "),n.push(">",u[m],"</option>");n.push("</select>")}else n.push("<input type='checkbox' title='",m,"' ","true"==x+""?"checked='true'":"","'></input>");j.push("</td></tr>")}j.push("</table>");i.innerHTML=j.join("");e=function(a){a=a.currentTarget;b.setOption(a.title,a.value)};f=function(a){a=a.currentTarget;b.setOption(a.title,a.checked)};j=i.getElementsByTagName("select");for(a=0;a<j.length;a++)j[a].onchange=e;e=i.getElementsByTagName("input");for(a=0;a<e.length;a++)e[a].onclick=
f;f=document.createElement("input");f.type="button";f.value="Hide";q.addListener(f,"click",function(){b.setDisplaySettings(!1)});i.appendChild(f);i.hideButton=f;var v="";q.addListener(r,"mousemove",function(a){var b=this.getBoundingClientRect();a.clientX-b.left+(a.clientY-b.top)<(b.width+b.height)/2?(this.style.cursor="pointer",v="toggle"):(v="resize",this.style.cursor="nw-resize")});q.addListener(r,"mousedown",function(a){if("toggle"==v)b.setDisplaySettings();else{g.style.zIndex=1E5;var c=g.getBoundingClientRect(),
e=c.width+c.left-a.clientX,f=c.height+c.top-a.clientY;q.capture(r,function(a){g.style.width=a.clientX-c.left+e+"px";g.style.height=a.clientY-c.top+f+"px";b.resize()},function(){})}});return b};p.defaultOptions={mode:"javascript",theme:"textmate",wrap:"off",fontSize:"12px",showGutter:"false",keybindings:"ace",showPrintMargin:"false",useSoftTabs:"true",showInvisibles:"false"}});