/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2010, Ajax.org B.V.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

define("require exports module ./lib/oop ./range ./search ./search_highlight ./commands/incremental_search_commands ./lib/dom ./commands/command_manager ./editor ./config".split(" "),function(c,k){function f(){this.$options={wrap:!1,skipCurrent:!1};this.$keyboardHandler=new l(this)}function g(a){var a=String(a),b=a.indexOf("/"),d=a.lastIndexOf("/");return{expression:a.slice(b+1,d),flags:a.slice(d+1)}}function h(a,b){try{return RegExp(a,b)}catch(d){return a}}var e=c("./lib/oop"),i=c("./range").Range,
m=c("./search").Search,n=c("./search_highlight").SearchHighlight,j=c("./commands/incremental_search_commands"),l=j.IncrementalSearchKeyboardHandler;e.inherits(f,m);(function(){this.activate=function(a,b){this.$editor=a;this.$startPos=this.$currentPos=a.getCursorPosition();this.$options.needle="";this.$options.backwards=b;a.keyBinding.addKeyboardHandler(this.$keyboardHandler);this.$originalEditorOnPaste=a.onPaste;a.onPaste=this.onPaste.bind(this);this.$mousedownHandler=a.addEventListener("mousedown",
this.onMouseDown.bind(this));this.selectionFix(a);this.statusMessage(!0)};this.deactivate=function(a){this.cancelSearch(a);a=this.$editor;a.keyBinding.removeKeyboardHandler(this.$keyboardHandler);this.$mousedownHandler&&(a.removeEventListener("mousedown",this.$mousedownHandler),delete this.$mousedownHandler);a.onPaste=this.$originalEditorOnPaste;this.message("")};this.selectionFix=function(a){a.selection.isEmpty()&&!a.session.$emacsMark&&a.clearSelection()};this.highlight=function(a){var b=this.$editor.session;
(b.$isearchHighlight=b.$isearchHighlight||b.addDynamicMarker(new n(null,"ace_isearch-result","text"))).setRegexp(a);b._emit("changeBackMarker")};this.cancelSearch=function(a){var b=this.$editor;this.$prevNeedle=this.$options.needle;this.$options.needle="";a?(b.moveCursorToPosition(this.$startPos),this.$currentPos=this.$startPos):b.pushEmacsMark&&b.pushEmacsMark(this.$startPos,!1);this.highlight(null);return i.fromPoints(this.$currentPos,this.$currentPos)};this.highlightAndFindWithNeedle=function(a,
b){if(!this.$editor)return null;var d=this.$options;b&&(d.needle=b.call(this,d.needle||"")||"");if(0===d.needle.length)return this.statusMessage(!0),this.cancelSearch(!0);d.start=this.$currentPos;var c=this.find(this.$editor.session),e=this.$editor.emacsMark?!!this.$editor.emacsMark():!this.$editor.selection.isEmpty();c&&(d.backwards&&(c=i.fromPoints(c.end,c.start)),this.$editor.selection.setRange(i.fromPoints(e?this.$startPos:c.end,c.end)),a&&(this.$currentPos=c.end),this.highlight(d.re));this.statusMessage(c);
return c};this.addString=function(a){return this.highlightAndFindWithNeedle(!1,function(b){if(!(b instanceof RegExp))return b+a;b=g(b);b.expression+=a;return h(b.expression,b.flags)})};this.removeChar=function(){return this.highlightAndFindWithNeedle(!1,function(a){if(!(a instanceof RegExp))return a.substring(0,a.length-1);a=g(a);a.expression=a.expression.substring(0,a.expression.length-1);return h(a.expression,a.flags)})};this.next=function(a){a=a||{};this.$options.backwards=!!a.backwards;this.$currentPos=
this.$editor.getCursorPosition();return this.highlightAndFindWithNeedle(!0,function(b){return a.useCurrentOrPrevSearch&&0===b.length?this.$prevNeedle||"":b})};this.onMouseDown=function(){this.deactivate();return!0};this.onPaste=function(a){this.addString(a)};this.convertNeedleToRegExp=function(){return this.highlightAndFindWithNeedle(!1,function(a){return a instanceof RegExp?a:h(a,"ig")})};this.convertNeedleToString=function(){return this.highlightAndFindWithNeedle(!1,function(a){return a instanceof
RegExp?g(a).expression:a})};this.statusMessage=function(a){var b=this.$options,c;c=""+(b.backwards?"reverse-":"");c+="isearch: "+b.needle;this.message(c+(a?"":" (not found)"))};this.message=function(a){this.$editor.showCommandLine?(this.$editor.showCommandLine(a),this.$editor.focus()):console.log(a)}}).call(f.prototype);k.IncrementalSearch=f;e=c("./lib/dom");e.importCssString&&e.importCssString(".ace_marker-layer .ace_isearch-result {  position: absolute;  z-index: 6;  -moz-box-sizing: border-box;  -webkit-box-sizing: border-box;  box-sizing: border-box;}div.ace_isearch-result {  border-radius: 4px;  background-color: rgba(255, 200, 0, 0.5);  box-shadow: 0 0 4px rgb(255, 200, 0);}.ace_dark div.ace_isearch-result {  background-color: rgb(100, 110, 160);  box-shadow: 0 0 4px rgb(80, 90, 140);}",
"incremental-search-highlighting");e=c("./commands/command_manager");(function(){this.setupIncrementalSearch=function(a,b){this.usesIncrementalSearch!=b&&(this.usesIncrementalSearch=b,this[b?"addCommands":"removeCommands"](j.iSearchStartCommands))}}).call(e.CommandManager.prototype);e=c("./editor").Editor;c("./config").defineOptions(e.prototype,"editor",{useIncrementalSearch:{set:function(a){this.keyBinding.$handlers.forEach(function(b){b.setupIncrementalSearch&&b.setupIncrementalSearch(this,a)});
this._emit("incrementalSearchSettingChanged",{isEnabled:a})}}})});