/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2010, Ajax.org B.V.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

"undefined"!==typeof process&&require("amd-loader");
define("require exports module ./keyboard/emacs ./edit_session ./editor ./test/mockrenderer ./range ./multi_select ./test/assertions ./incremental_search ./multi_select ./keyboard/emacs".split(" "),function(f,n,h){function d(a,d){d=d||b.selection.getAllRanges();e.equal(d+"",a+"")}function g(){var a=b.session,d=[];a.$isearchHighlight.update([],{drawSingleLineMarker:function(a,b){d=d.concat(b)}},a,{firstRow:0,lastRow:a.getRowLength()});return d}f("./keyboard/emacs");var i=f("./edit_session").EditSession,
j=f("./editor").Editor,k=f("./test/mockrenderer").MockRenderer;f("./range");var l=f("./multi_select").MultiSelect,e=f("./test/assertions"),m=f("./incremental_search").IncrementalSearch;f("./multi_select");var b,a;h.exports={name:"ACE incremental_search.js",setUp:function(){var c=new i(["abc123","xyz124"]);b=new j(new k,c);new l(b);a=new m},"test: keyboard handler setup":function(){a.activate(b);e.equal(b.getKeyboardHandler(),a.$keyboardHandler);a.deactivate();e.notEqual(b.getKeyboardHandler(),a.$keyboardHandler)},
"test: isearch highlight setup":function(){var c=b.session;a.activate(b);a.highlight("foo");var d=c.$isearchHighlight.id;e.ok(c.$isearchHighlight,"session has no isearch highlighter");e.equal(c.getMarkers()[d.id],d.id,"isearch highlight not in markers");a.deactivate();a.activate(b);a.highlight("bar");e.equal(c.$isearchHighlight.id,d,"multiple isearch highlights")},"test: find simple text incrementally":function(){a.activate(b);var c=a.addString("1"),e=g(b.session);d("Range: [0/3] -> [0/4]",[c],"range");
d("Range: [0/3] -> [0/4],Range: [1/3] -> [1/4]",e,"highlight");c=a.addString("2");e=g(b.session);d("Range: [0/3] -> [0/5]",[c],"range");d("Range: [0/3] -> [0/5],Range: [1/3] -> [1/5]",e,"highlight");c=a.addString("3");e=g(b.session);d("Range: [0/3] -> [0/6]",[c],"range");d("Range: [0/3] -> [0/6]",e,"highlight");c=a.removeChar();e=g(b.session);d("Range: [0/3] -> [0/5]",[c],"range");d("Range: [0/3] -> [0/5],Range: [1/3] -> [1/5]",e,"highlight")},"test: forward / backward":function(){a.activate(b);a.addString("1");
a.addString("2");var c=a.next();d("Range: [1/3] -> [1/5]",[c],"range");c=a.next();d("",[c],"range");c=a.next({backwards:!0});d("Range: [1/5] -> [1/3]",[c],"range")},"test: cancelSearch":function(){a.activate(b);a.addString("1");a.addString("2");var c=a.cancelSearch(!0);d("Range: [0/0] -> [0/0]",[c],"range");a.addString("1");c=a.addString("2");d("Range: [0/3] -> [0/5]",[c],"range")},"test: failing search keeps pos":function(){a.activate(b);a.addString("1");a.addString("2");var c=a.addString("x");d("",
[c],"range");e.position(b.getCursorPosition(),0,5)},"test: backwards search":function(){b.moveCursorTo(1,0);a.activate(b,!0);a.addString("1");var c=a.addString("2");d("Range: [0/5] -> [0/3]",[c],"range");e.position(b.getCursorPosition(),0,3)},"test: forwards then backwards, same result, reoriented range":function(){a.activate(b);a.addString("1");var c=a.addString("2");d("Range: [0/3] -> [0/5]",[c],"range");e.position(b.getCursorPosition(),0,5);c=a.next({backwards:!0});d("Range: [0/5] -> [0/3]",[c],
"range");e.position(b.getCursorPosition(),0,3)},"test: reuse prev search via option":function(){a.activate(b);a.addString("1");a.addString("2");e.position(b.getCursorPosition(),0,5);a.deactivate();a.activate(b);a.next({backwards:!1,useCurrentOrPrevSearch:!0});e.position(b.getCursorPosition(),1,5)},"test: don't extend selection range if selection is empty":function(){a.activate(b);a.addString("1");a.addString("2");d("Range: [0/5] -> [0/5]",[b.getSelectionRange()],"sel range")},"test: extend selection range if selection exists":function(){a.activate(b);
b.selection.selectTo(0,1);a.addString("1");a.addString("2");d("Range: [0/0] -> [0/5]",[b.getSelectionRange()],"sel range")},"test: extend selection in emacs mark mode":function(){var c=f("./keyboard/emacs");b.keyBinding.addKeyboardHandler(c.handler);c.handler.commands.setMark.exec(b);a.activate(b);a.addString("1");a.addString("2");d("Range: [0/0] -> [0/5]",[b.getSelectionRange()],"sel range")}}});"undefined"!==typeof module&&module===require.main&&require("asyncjs").test.testcase(module.exports).exec();