/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2010, Ajax.org B.V.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

define("require exports module ../lib/dom ../incremental_search ../commands/incremental_search_commands ./hash_handler ../lib/keys".split(" "),function(h,d){var r=h("../lib/dom");h("../incremental_search");var s=h("../commands/incremental_search_commands"),t=function(a,c){var b=this.scroller.getBoundingClientRect();return this.session.screenToDocumentPosition(Math.floor((c+this.scrollTop-b.top)/this.lineHeight),Math.floor((a+this.scrollLeft-b.left-this.$padding)/this.characterWidth))},u=h("./hash_handler").HashHandler;
d.handler=new u;d.handler.isEmacs=!0;d.handler.$id="ace/keyboard/emacs";var n=!1,i,j;d.handler.attach=function(a){n||(n=!0,r.importCssString("            .emacs-mode .ace_cursor{                border: 1px rgba(50,250,50,0.8) solid!important;                -moz-box-sizing: border-box!important;                -webkit-box-sizing: border-box!important;                box-sizing: border-box!important;                background-color: rgba(0,250,0,0.9);                opacity: 0.5;            }            .emacs-mode .ace_hidden-cursors .ace_cursor{                opacity: 1;                background-color: transparent;            }            .emacs-mode .ace_overwrite-cursors .ace_cursor {                opacity: 1;                background-color: transparent;                border-width: 0 0 2px 2px !important;            }            .emacs-mode .ace_text-layer {                z-index: 4            }            .emacs-mode .ace_cursor-layer {                z-index: 2            }",
"emacsMode"));i=a.session.$selectLongWords;a.session.$selectLongWords=!0;j=a.session.$useEmacsStyleLineStart;a.session.$useEmacsStyleLineStart=!0;a.session.$emacsMark=null;a.session.$emacsMarkRing=a.session.$emacsMarkRing||[];a.emacsMark=function(){return this.session.$emacsMark};a.setEmacsMark=function(a){this.session.$emacsMark=a};a.pushEmacsMark=function(a,b){var f=this.session.$emacsMark;f&&this.session.$emacsMarkRing.push(f);!a||b?this.setEmacsMark(a):this.session.$emacsMarkRing.push(a)};a.popEmacsMark=
function(){var a=this.emacsMark();return a?(this.setEmacsMark(null),a):this.session.$emacsMarkRing.pop()};a.getLastEmacsMark=function(){return this.session.$emacsMark||this.session.$emacsMarkRing.slice(-1)[0]};a.emacsMarkForSelection=function(a){var b=this.selection,f=this.multiSelect?this.multiSelect.getAllRanges().length:1,d=this.session.$emacsMarkRing,f=d.length-(f-(b.index||0)),b=d[f]||b.anchor;a&&d.splice(f,1,"row"in a&&"column"in a?a:void 0);return b};a.on("click",p);a.on("changeSession",q);
a.renderer.screenToTextCoordinates=t;a.setStyle("emacs-mode");a.commands.addCommands(l);d.handler.platform=a.commands.platform;a.$emacsModeHandler=this;a.addEventListener("copy",this.onCopy);a.addEventListener("paste",this.onPaste)};d.handler.detach=function(a){delete a.renderer.screenToTextCoordinates;a.session.$selectLongWords=i;a.session.$useEmacsStyleLineStart=j;a.removeEventListener("click",p);a.removeEventListener("changeSession",q);a.unsetStyle("emacs-mode");a.commands.removeCommands(l);a.removeEventListener("copy",
this.onCopy);a.removeEventListener("paste",this.onPaste);a.$emacsModeHandler=null};var q=function(a){a.oldSession&&(a.oldSession.$selectLongWords=i,a.oldSession.$useEmacsStyleLineStart=j);i=a.session.$selectLongWords;a.session.$selectLongWords=!0;j=a.session.$useEmacsStyleLineStart;a.session.$useEmacsStyleLineStart=!0;a.session.hasOwnProperty("$emacsMark")||(a.session.$emacsMark=null);a.session.hasOwnProperty("$emacsMarkRing")||(a.session.$emacsMarkRing=[])},p=function(a){a.editor.session.$emacsMark=
null},v=h("../lib/keys").KEY_MODS,m={C:"ctrl",S:"shift",M:"alt",CMD:"command"};"C-S-M-CMD S-M-CMD C-M-CMD C-S-CMD C-S-M M-CMD S-CMD S-M C-CMD C-M C-S CMD M S C".split(" ").forEach(function(a){var c=0;a.split("-").forEach(function(a){c|=v[m[a]]});m[c]=a.toLowerCase()+"-"});d.handler.onCopy=function(a,c){c.$handlesEmacsOnCopy||(c.$handlesEmacsOnCopy=!0,d.handler.commands.killRingSave.exec(c),c.$handlesEmacsOnCopy=!1)};d.handler.onPaste=function(a,c){c.pushEmacsMark(c.getCursorPosition())};d.handler.bindKey=
function(a,c){"object"==typeof a&&(a=a[this.platform]);if(a){var b=this.commandKeyBinding;a.split("|").forEach(function(a){a=a.toLowerCase();b[a]=c;a.split(" ").slice(0,-1).reduce(function(a,b,c){return a.concat([(a[c-1]?a[c-1]+" ":"")+b])},[]).forEach(function(a){b[a]||(b[a]="null")})},this)}};d.handler.getStatusText=function(a,c){var b="";c.count&&(b+=c.count);c.keyChain&&(b+=" "+c.keyChain);return b};d.handler.handleKeyboard=function(a,c,b,f){if(-1!==f){f=a.editor;f._signal("changeStatus");if(-1==
c&&(f.pushEmacsMark(),a.count))return b=Array(a.count+1).join(b),a.count=null,{command:"insertstring",args:b};c=m[c];if("c-"==c||a.count){var d=parseInt(b[b.length-1]);if("number"===typeof d&&!isNaN(d))return a.count=Math.max(a.count,0)||0,a.count=10*a.count+d,{command:"null"}}c&&(b=c+b);a.keyChain&&(b=a.keyChain+=" "+b);var e=this.commandKeyBinding[b];a.keyChain="null"==e?b:"";if(e){if("null"===e)return{command:"null"};if("universalArgument"===e)return a.count=-4,{command:"null"};var g;"string"!==
typeof e&&(g=e.args,e.command&&(e=e.command),"goorselect"===e&&(e=f.emacsMark()?g[1]:g[0],g=null));if("string"===typeof e&&(("insertstring"===e||"splitline"===e||"togglecomment"===e)&&f.pushEmacsMark(),e=this.commands[e]||f.commands.commands[e],!e))return;!e.readOnly&&!e.isYank&&(a.lastCommand=null);!e.readOnly&&f.emacsMark()&&f.setEmacsMark(null);if(a.count){d=a.count;a.count=0;if(!e||!e.handlesCount)return{args:g,command:{exec:function(a,b){for(var c=0;c<d;c++)e.exec(a,b)},multiSelectAction:e.multiSelectAction}};
g||(g={});"object"===typeof g&&(g.count=d)}return{command:e,args:g}}}};d.emacsKeys={"Up|C-p":{command:"goorselect",args:["golineup","selectup"]},"Down|C-n":{command:"goorselect",args:["golinedown","selectdown"]},"Left|C-b":{command:"goorselect",args:["gotoleft","selectleft"]},"Right|C-f":{command:"goorselect",args:["gotoright","selectright"]},"C-Left|M-b":{command:"goorselect",args:["gotowordleft","selectwordleft"]},"C-Right|M-f":{command:"goorselect",args:["gotowordright","selectwordright"]},"Home|C-a":{command:"goorselect",
args:["gotolinestart","selecttolinestart"]},"End|C-e":{command:"goorselect",args:["gotolineend","selecttolineend"]},"C-Home|S-M-,":{command:"goorselect",args:["gotostart","selecttostart"]},"C-End|S-M-.":{command:"goorselect",args:["gotoend","selecttoend"]},"S-Up|S-C-p":"selectup","S-Down|S-C-n":"selectdown","S-Left|S-C-b":"selectleft","S-Right|S-C-f":"selectright","S-C-Left|S-M-b":"selectwordleft","S-C-Right|S-M-f":"selectwordright","S-Home|S-C-a":"selecttolinestart","S-End|S-C-e":"selecttolineend",
"S-C-Home":"selecttostart","S-C-End":"selecttoend","C-l":"recenterTopBottom","M-s":"centerselection","M-g":"gotoline","C-x C-p":"selectall","C-Down":{command:"goorselect",args:["gotopagedown","selectpagedown"]},"C-Up":{command:"goorselect",args:["gotopageup","selectpageup"]},"PageDown|C-v":{command:"goorselect",args:["gotopagedown","selectpagedown"]},"PageUp|M-v":{command:"goorselect",args:["gotopageup","selectpageup"]},"S-C-Down":"selectpagedown","S-C-Up":"selectpageup","C-s":"iSearch","C-r":"iSearchBackwards",
"M-C-s":"findnext","M-C-r":"findprevious","S-M-5":"replace",Backspace:"backspace","Delete|C-d":"del","Return|C-m":{command:"insertstring",args:"\n"},"C-o":"splitline","M-d|C-Delete":{command:"killWord",args:"right"},"C-Backspace|M-Backspace|M-Delete":{command:"killWord",args:"left"},"C-k":"killLine","C-y|S-Delete":"yank","M-y":"yankRotate","C-g":"keyboardQuit","C-w|C-S-W":"killRegion","M-w":"killRingSave","C-Space":"setMark","C-x C-x":"exchangePointAndMark","C-t":"transposeletters","M-u":"touppercase",
"M-l":"tolowercase","M-/":"autocomplete","C-u":"universalArgument","M-;":"togglecomment","C-/|C-x u|S-C--|C-z":"undo","S-C-/|S-C-x u|C--|S-C-z":"redo","C-x r":"selectRectangularRegion","M-x":{command:"focusCommandLine",args:"M-x "}};d.handler.bindKeys(d.emacsKeys);d.handler.addCommands({recenterTopBottom:function(a){var c=a.renderer,b=c.$cursorLayer.getPixelPosition(),d=c.$size.scrollerHeight-c.lineHeight,c=c.scrollTop,c=2>Math.abs(b.top-c)?b.top-d:2>Math.abs(b.top-c-0.5*d)?b.top:b.top-0.5*d;a.session.setScrollTop(c)},
selectRectangularRegion:function(a){a.multiSelect.toggleBlockSelection()},setMark:{exec:function(a,c){function b(){var b=a.popEmacsMark();b&&a.moveCursorToPosition(b)}if(c&&c.count)a.inMultiSelectMode?a.forEachSelection(b):b(),b();else{var d=a.emacsMark(),k=a.selection.getAllRanges(),e=k.map(function(a){return{row:a.start.row,column:a.start.column}}),k=k.every(function(a){return a.isEmpty()});d||!k?(a.inMultiSelectMode?a.forEachSelection({exec:a.clearSelection.bind(a)}):a.clearSelection(),d&&a.pushEmacsMark(null)):
d||(e.forEach(function(b){a.pushEmacsMark(b)}),a.setEmacsMark(e[e.length-1]))}},readOnly:!0,handlesCount:!0},exchangePointAndMark:{exec:function(a,c){var b=a.selection;if(!c.count&&!b.isEmpty())b.setSelectionRange(b.getRange(),!b.isBackwards());else if(c.count){var d={row:b.lead.row,column:b.lead.column};b.clearSelection();b.moveCursorToPosition(a.emacsMarkForSelection(d))}else b.selectToPosition(a.emacsMarkForSelection())},readOnly:!0,handlesCount:!0,multiSelectAction:"forEach"},killWord:{exec:function(a,
c){a.clearSelection();"left"==c?a.selection.selectWordLeft():a.selection.selectWordRight();var b=a.getSelectionRange(),f=a.session.getTextRange(b);d.killRing.add(f);a.session.remove(b);a.clearSelection()},multiSelectAction:"forEach"},killLine:function(a){a.pushEmacsMark(null);a.clearSelection();var c=a.getSelectionRange(),b=a.session.getLine(c.start.row);c.end.column=b.length;var b=b.substr(c.start.column),f=a.session.getFoldLine(c.start.row);f&&c.end.row!=f.end.row&&(c.end.row=f.end.row,b="x");/^\s*$/.test(b)&&
(c.end.row++,b=a.session.getLine(c.end.row),c.end.column=/^\s*$/.test(b)?b.length:0);b=a.session.getTextRange(c);a.prevOp.command==this?d.killRing.append(b):d.killRing.add(b);a.session.remove(c);a.clearSelection()},yank:function(a){a.onPaste(d.killRing.get()||"");a.keyBinding.$data.lastCommand="yank"},yankRotate:function(a){"yank"==a.keyBinding.$data.lastCommand&&(a.undo(),a.session.$emacsMarkRing.pop(),a.onPaste(d.killRing.rotate()),a.keyBinding.$data.lastCommand="yank")},killRegion:{exec:function(a){d.killRing.add(a.getCopyText());
a.commands.byName.cut.exec(a);a.setEmacsMark(null)},readOnly:!0,multiSelectAction:"forEach"},killRingSave:{exec:function(a){a.$handlesEmacsOnCopy=!0;var c=a.session.$emacsMarkRing.slice(),b=[];d.killRing.add(a.getCopyText());setTimeout(function(){function d(){var c=a.selection,e=c.getRange(),e=c.isBackwards()?e.end:e.start;b.push({row:e.row,column:e.column});c.clearSelection()}a.$handlesEmacsOnCopy=!1;a.inMultiSelectMode?a.forEachSelection({exec:d}):d();a.session.$emacsMarkRing=c.concat(b.reverse())},
0)},readOnly:!0},keyboardQuit:function(a){a.selection.clearSelection();a.setEmacsMark(null);a.keyBinding.$data.count=null},focusCommandLine:function(a,c){a.showCommandLine&&a.showCommandLine(c)}});d.handler.addCommands(s.iSearchStartCommands);var l=d.handler.commands;l.yank.isYank=!0;l.yankRotate.isYank=!0;d.killRing={$data:[],add:function(a){a&&this.$data.push(a);30<this.$data.length&&this.$data.shift()},append:function(a){var c=this.$data.length-1,b=this.$data[c]||"";a&&(b+=a);b&&(this.$data[c]=
b)},get:function(a){return this.$data.slice(this.$data.length-(a||1),this.$data.length).reverse().join("\n")},pop:function(){1<this.$data.length&&this.$data.pop();return this.get()},rotate:function(){this.$data.unshift(this.$data.pop());return this.get()}}});