/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2010, Ajax.org B.V.
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

define(["require","exports","module","../lib/keys","../lib/useragent"],function(k,l){function i(g,a){this.platform=a||(n.isMac?"mac":"win");this.commands={};this.commandKeyBinding={};this.addCommands(g);this.$singleCommand=!0}function m(g,a){i.call(this,g,a);this.$singleCommand=!1}var h=k("../lib/keys"),n=k("../lib/useragent"),j=h.KEY_MODS;m.prototype=i.prototype;(function(){function g(a){return"object"==typeof a&&a.bindKey&&a.bindKey.position||0}this.addCommand=function(a){this.commands[a.name]&&
this.removeCommand(a);this.commands[a.name]=a;a.bindKey&&this._buildKeyHash(a)};this.removeCommand=function(a,b){var c=a&&("string"===typeof a?a:a.name),a=this.commands[c];b||delete this.commands[c];var c=this.commandKeyBinding,e;for(e in c){var d=c[e];if(d==a)delete c[e];else if(Array.isArray(d)){var f=d.indexOf(a);-1!=f&&(d.splice(f,1),1==d.length&&(c[e]=d[0]))}}};this.bindKey=function(a,b,c){"object"==typeof a&&a&&(void 0==c&&(c=a.position),a=a[this.platform]);if(a){if("function"==typeof b)return this.addCommand({exec:b,
bindKey:a,name:b.name||a});a.split("|").forEach(function(a){var d="";if(-1!=a.indexOf(" ")){var f=a.split(/\s+/),a=f.pop();f.forEach(function(a){a=this.parseKeys(a);d+=(d?" ":"")+(j[a.hashId]+a.key);this._addCommandToBinding(d,"chainKeys")},this);d+=" "}a=this.parseKeys(a);this._addCommandToBinding(d+(j[a.hashId]+a.key),b,c)},this)}};this._addCommandToBinding=function(a,b,c){var e=this.commandKeyBinding,d;if(b)if(!e[a]||this.$singleCommand)e[a]=b;else{Array.isArray(e[a])?-1!=(d=e[a].indexOf(b))&&
e[a].splice(d,1):e[a]=[e[a]];"number"!=typeof c&&(c=c||b.isDefault?-100:g(b));a=e[a];for(d=0;d<a.length&&!(g(a[d])>c);d++);a.splice(d,0,b)}else delete e[a]};this.addCommands=function(a){a&&Object.keys(a).forEach(function(b){var c=a[b];if(c){if("string"===typeof c)return this.bindKey(c,b);"function"===typeof c&&(c={exec:c});"object"===typeof c&&(c.name||(c.name=b),this.addCommand(c))}},this)};this.removeCommands=function(a){Object.keys(a).forEach(function(b){this.removeCommand(a[b])},this)};this.bindKeys=
function(a){Object.keys(a).forEach(function(b){this.bindKey(b,a[b])},this)};this._buildKeyHash=function(a){this.bindKey(a.bindKey,a)};this.parseKeys=function(a){var b=a.toLowerCase().split(/[\-\+]([\-\+])?/).filter(function(a){return a}),c=b.pop(),e=h[c];if(h.FUNCTION_KEYS[e])c=h.FUNCTION_KEYS[e].toLowerCase();else if(b.length){if(1==b.length&&"shift"==b[0])return{key:c.toUpperCase(),hashId:-1}}else return{key:c,hashId:-1};for(var e=0,d=b.length;d--;){var f=h.KEY_MODS[b[d]];if(null==f)return"undefined"!=
typeof console&&console.error("invalid modifier "+b[d]+" in "+a),!1;e|=f}return{key:c,hashId:e}};this.findKeyCommand=function(a,b){return this.commandKeyBinding[j[a]+b]};this.handleKeyboard=function(a,b,c,e){if(!(0>e)){var d=j[b]+c,f=this.commandKeyBinding[d];a.$keyChain&&(a.$keyChain+=" "+d,f=this.commandKeyBinding[a.$keyChain]||f);if(f&&("chainKeys"==f||"chainKeys"==f[f.length-1]))return a.$keyChain=a.$keyChain||d,{command:"null"};if(a.$keyChain)if((!b||4==b)&&1==c.length)a.$keyChain=a.$keyChain.slice(0,
-d.length-1);else if(-1==b||0<e)a.$keyChain="";return{command:f}}};this.getStatusText=function(a,b){return b.$keyChain||""}}).call(i.prototype);l.HashHandler=i;l.MultiHashHandler=m});