/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2010, Ajax.org B.V.
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

define(["require","exports","module","../lib/dom"],function(i,j){var d=i("../lib/dom"),e,h=function(a){this.element=d.createElement("div");this.element.className="ace_layer ace_cursor-layer";a.appendChild(this.element);void 0===e&&(e=!("opacity"in this.element.style));this.isVisible=!1;this.isBlinking=!0;this.blinkInterval=1E3;this.smoothBlinking=!1;this.cursors=[];this.cursor=this.addCursor();d.addCssClass(this.element,"ace_hidden-cursors");this.$updateCursors=(e?this.$updateVisibility:this.$updateOpacity).bind(this)};
(function(){this.$updateVisibility=function(a){for(var b=this.cursors,c=b.length;c--;)b[c].style.visibility=a?"":"hidden"};this.$updateOpacity=function(a){for(var b=this.cursors,c=b.length;c--;)b[c].style.opacity=a?"":"0"};this.$padding=0;this.setPadding=function(a){this.$padding=a};this.setSession=function(a){this.session=a};this.setBlinking=function(a){a!=this.isBlinking&&(this.isBlinking=a,this.restartTimer())};this.setBlinkInterval=function(a){a!=this.blinkInterval&&(this.blinkInterval=a,this.restartTimer())};
this.setSmoothBlinking=function(a){a!=this.smoothBlinking&&!e&&(this.smoothBlinking=a,d.setCssClass(this.element,"ace_smooth-blinking",a),this.$updateCursors(!0),this.$updateCursors=this.$updateOpacity.bind(this),this.restartTimer())};this.addCursor=function(){var a=d.createElement("div");a.className="ace_cursor";this.element.appendChild(a);this.cursors.push(a);return a};this.removeCursor=function(){if(1<this.cursors.length){var a=this.cursors.pop();a.parentNode.removeChild(a);return a}};this.hideCursor=
function(){this.isVisible=!1;d.addCssClass(this.element,"ace_hidden-cursors");this.restartTimer()};this.showCursor=function(){this.isVisible=!0;d.removeCssClass(this.element,"ace_hidden-cursors");this.restartTimer()};this.restartTimer=function(){var a=this.$updateCursors;clearInterval(this.intervalId);clearTimeout(this.timeoutId);this.smoothBlinking&&d.removeCssClass(this.element,"ace_smooth-blinking");a(!0);if(this.isBlinking&&this.blinkInterval&&this.isVisible){this.smoothBlinking&&setTimeout(function(){d.addCssClass(this.element,
"ace_smooth-blinking")}.bind(this));var b=function(){this.timeoutId=setTimeout(function(){a(!1)},0.6*this.blinkInterval)}.bind(this);this.intervalId=setInterval(function(){a(!0);b()},this.blinkInterval);b()}};this.getPixelPosition=function(a,b){if(!this.config||!this.session)return{left:0,top:0};a||(a=this.session.selection.getCursor());var c=this.session.documentToScreenPosition(a);return{left:this.$padding+c.column*this.config.characterWidth,top:(c.row-(b?this.config.firstRowScreen:0))*this.config.lineHeight}};
this.update=function(a){this.config=a;var b=this.session.$selectionMarkers,c=0,d=0;if(void 0===b||0===b.length)b=[{cursor:null}];for(var c=0,e=b.length;c<e;c++){var f=this.getPixelPosition(b[c].cursor,!0);if(!((f.top>a.height+a.offset||0>f.top)&&1<c)){var g=(this.cursors[d++]||this.addCursor()).style;this.drawCursor?this.drawCursor(g,f,a,b[c],this.session):(g.left=f.left+"px",g.top=f.top+"px",g.width=a.characterWidth+"px",g.height=a.lineHeight+"px")}}for(;this.cursors.length>d;)this.removeCursor();
a=this.session.getOverwrite();this.$setOverwrite(a);this.$pixelPos=f;this.restartTimer()};this.drawCursor=null;this.$setOverwrite=function(a){a!=this.overwrite&&((this.overwrite=a)?d.addCssClass(this.element,"ace_overwrite-cursors"):d.removeCssClass(this.element,"ace_overwrite-cursors"))};this.destroy=function(){clearInterval(this.intervalId);clearTimeout(this.timeoutId)}}).call(h.prototype);j.Cursor=h});