/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2010, Ajax.org B.V.
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

define("require exports module ../lib/dom ../lib/oop ../lib/lang ../lib/event_emitter".split(" "),function(h,s){var i=h("../lib/dom"),t=h("../lib/oop"),u=h("../lib/lang"),v=h("../lib/event_emitter").EventEmitter,j=function(a){this.element=i.createElement("div");this.element.className="ace_layer ace_gutter-layer";a.appendChild(this.element);this.setShowFoldWidgets(this.$showFoldWidgets);this.gutterWidth=0;this.$annotations=[];this.$updateAnnotations=this.$updateAnnotations.bind(this);this.$cells=[]};
(function(){t.implement(this,v);this.setSession=function(a){this.session&&this.session.removeEventListener("change",this.$updateAnnotations);if(this.session=a)a.on("change",this.$updateAnnotations)};this.addGutterDecoration=function(a,c){window.console&&console.warn&&console.warn("deprecated use session.addGutterDecoration");this.session.addGutterDecoration(a,c)};this.removeGutterDecoration=function(a,c){window.console&&console.warn&&console.warn("deprecated use session.removeGutterDecoration");this.session.removeGutterDecoration(a,
c)};this.setAnnotations=function(a){this.$annotations=[];for(var c=0;c<a.length;c++){var b=a[c],g=b.row,f=this.$annotations[g];f||(f=this.$annotations[g]={text:[]});g=(g=b.text)?u.escapeHTML(g):b.html||"";-1===f.text.indexOf(g)&&f.text.push(g);b=b.type;"error"==b?f.className=" ace_error":"warning"==b&&" ace_error"!=f.className?f.className=" ace_warning":"info"==b&&!f.className&&(f.className=" ace_info")}};this.$updateAnnotations=function(a){if(this.$annotations.length){var c=a.start.row,b=a.end.row-
c;0!==b&&("remove"==a.action?this.$annotations.splice(c,b+1,null):(a=Array(b+1),a.unshift(c,1),this.$annotations.splice.apply(this.$annotations,a)))}};this.update=function(a){for(var c=this.session,b=a.firstRow,g=Math.min(a.lastRow+a.gutterOffset,c.getLength()-1),f=c.getNextFoldLine(b),h=f?f.start.row:Infinity,m=this.$showFoldWidgets&&c.foldWidgets,j=c.$breakpoints,p=c.$decorations,q=c.$firstLineNumber,e=0,l=c.gutterRenderer||this.$renderer,d=null,n=-1;;){b>h&&(b=f.end.row+1,h=(f=c.getNextFoldLine(b,
f))?f.start.row:Infinity);if(b>g){for(;this.$cells.length>n+1;)d=this.$cells.pop(),this.element.removeChild(d.element);break}d=this.$cells[++n];d||(d={element:null,textNode:null,foldWidget:null},d.element=i.createElement("div"),d.textNode=document.createTextNode(""),d.element.appendChild(d.textNode),this.element.appendChild(d.element),this.$cells[n]=d);e="ace_gutter-cell ";j[b]&&(e+=j[b]);p[b]&&(e+=p[b]);this.$annotations[b]&&(e+=this.$annotations[b].className);d.element.className!=e&&(d.element.className=
e);e=c.getRowLength(b)*a.lineHeight+"px";e!=d.element.style.height&&(d.element.style.height=e);if(m){var k=m[b];null==k&&(k=m[b]=c.getFoldWidget(b))}k?(d.foldWidget||(d.foldWidget=i.createElement("span"),d.element.appendChild(d.foldWidget)),e="ace_fold-widget ace_"+k,e="start"==k&&b==h&&b<f.end.row?e+" ace_closed":e+" ace_open",d.foldWidget.className!=e&&(d.foldWidget.className=e),e=a.lineHeight+"px",d.foldWidget.style.height!=e&&(d.foldWidget.style.height=e)):d.foldWidget&&(d.element.removeChild(d.foldWidget),
d.foldWidget=null);var r=e=l?l.getText(c,b):b+q;r!=d.textNode.data&&(d.textNode.data=r);b++}this.element.style.height=a.minHeight+"px";if(this.$fixedWidth||c.$useWrapMode)e=c.getLength()+q;a=l?l.getWidth(c,e,a):e.toString().length*a.characterWidth;c=this.$padding||this.$computePadding();a+=c.left+c.right;a!==this.gutterWidth&&!isNaN(a)&&(this.gutterWidth=a,this.element.style.width=Math.ceil(this.gutterWidth)+"px",this._emit("changeGutterWidth",a))};this.$fixedWidth=!1;this.$showLineNumbers=!0;this.$renderer=
"";this.setShowLineNumbers=function(a){this.$renderer=!a&&{getWidth:function(){return""},getText:function(){return""}}};this.getShowLineNumbers=function(){return this.$showLineNumbers};this.$showFoldWidgets=!0;this.setShowFoldWidgets=function(a){a?i.addCssClass(this.element,"ace_folding-enabled"):i.removeCssClass(this.element,"ace_folding-enabled");this.$showFoldWidgets=a;this.$padding=null};this.getShowFoldWidgets=function(){return this.$showFoldWidgets};this.$computePadding=function(){if(!this.element.firstChild)return{left:0,
right:0};var a=i.computedStyle(this.element.firstChild);this.$padding={};this.$padding.left=parseInt(a.paddingLeft)+1||0;this.$padding.right=parseInt(a.paddingRight)||0;return this.$padding};this.getRegion=function(a){var c=this.$padding||this.$computePadding(),b=this.element.getBoundingClientRect();if(a.x<c.left+b.left)return"markers";if(this.$showFoldWidgets&&a.x>b.right-c.right)return"foldWidgets"}}).call(j.prototype);s.Gutter=j});