/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2010, Ajax.org B.V.
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

define("require exports module ../lib/oop ../lib/dom ../lib/lang ../lib/useragent ../lib/event_emitter".split(" "),function(m,q){var r=m("../lib/oop"),n=m("../lib/dom"),l=m("../lib/lang");m("../lib/useragent");var s=m("../lib/event_emitter").EventEmitter,p=function(a){this.element=n.createElement("div");this.element.className="ace_layer ace_text-layer";a.appendChild(this.element);this.$updateEolChar=this.$updateEolChar.bind(this)};(function(){r.implement(this,s);this.EOF_CHAR="\u00b6";this.EOL_CHAR_LF=
"\u00ac";this.EOL_CHAR_CRLF="\u00a4";this.EOL_CHAR=this.EOL_CHAR_LF;this.TAB_CHAR="\u2014";this.SPACE_CHAR="\u00b7";this.$padding=0;this.$updateEolChar=function(){var a="\n"==this.session.doc.getNewLineCharacter()?this.EOL_CHAR_LF:this.EOL_CHAR_CRLF;if(this.EOL_CHAR!=a)return this.EOL_CHAR=a,!0};this.setPadding=function(a){this.$padding=a;this.element.style.padding="0 "+a+"px"};this.getLineHeight=function(){return this.$fontMetrics.$characterSize.height||0};this.getCharacterWidth=function(){return this.$fontMetrics.$characterSize.width||
0};this.$setFontMetrics=function(a){this.$fontMetrics=a;this.$fontMetrics.on("changeCharacterSize",function(a){this._signal("changeCharacterSize",a)}.bind(this));this.$pollSizeChanges()};this.checkForSizeChanges=function(){this.$fontMetrics.checkForSizeChanges()};this.$pollSizeChanges=function(){return this.$pollSizeChangesTimer=this.$fontMetrics.$pollSizeChanges()};this.setSession=function(a){(this.session=a)&&this.$computeTabString()};this.showInvisibles=!1;this.setShowInvisibles=function(a){if(this.showInvisibles==
a)return!1;this.showInvisibles=a;this.$computeTabString();return!0};this.displayIndentGuides=!0;this.setDisplayIndentGuides=function(a){if(this.displayIndentGuides==a)return!1;this.displayIndentGuides=a;this.$computeTabString();return!0};this.$tabStrings=[];this.onChangeTabSize=this.$computeTabString=function(){var a=this.session.getTabSize();this.tabSize=a;for(var b=this.$tabStrings=[0],e=1;e<a+1;e++)this.showInvisibles?b.push("<span class='ace_invisible ace_invisible_tab'>"+l.stringRepeat(this.TAB_CHAR,
e)+"</span>"):b.push(l.stringRepeat(" ",e));if(this.displayIndentGuides){this.$indentGuideRe=/\s\S| \t|\t |\s$/;a="ace_indent-guide";e=b="";if(this.showInvisibles)var a=a+" ace_invisible",b=" ace_invisible_space",e=" ace_invisible_tab",c=l.stringRepeat(this.SPACE_CHAR,this.tabSize),d=l.stringRepeat(this.TAB_CHAR,this.tabSize);else d=c=l.stringRepeat(" ",this.tabSize);this.$tabStrings[" "]="<span class='"+a+b+"'>"+c+"</span>";this.$tabStrings["\t"]="<span class='"+a+e+"'>"+d+"</span>"}};this.updateLines=
function(a,b,e){(this.config.lastRow!=a.lastRow||this.config.firstRow!=a.firstRow)&&this.scrollLines(a);this.config=a;for(var c=Math.max(b,a.firstRow),e=Math.min(e,a.lastRow),b=this.element.childNodes,d=0,f=a.firstRow;f<c;f++){var g=this.session.getFoldLine(f);if(g)if(g.containsRow(c)){c=g.start.row;break}else f=g.end.row;d++}f=c;for(c=(g=this.session.getNextFoldLine(f))?g.start.row:Infinity;;){f>c&&(f=g.end.row+1,c=(g=this.session.getNextFoldLine(f,g))?g.start.row:Infinity);if(f>e)break;var i=b[d++];
if(i){var k=[];this.$renderLine(k,f,!this.$useLineGroups(),f==c?g:!1);i.style.height=a.lineHeight*this.session.getRowLength(f)+"px";i.innerHTML=k.join("")}f++}};this.scrollLines=function(a){var b=this.config;this.config=a;if(!b||b.lastRow<a.firstRow||a.lastRow<b.firstRow)return this.update(a);var e=this.element;if(b.firstRow<a.firstRow)for(var c=this.session.getFoldedRowCount(b.firstRow,a.firstRow-1);0<c;c--)e.removeChild(e.firstChild);if(b.lastRow>a.lastRow)for(c=this.session.getFoldedRowCount(a.lastRow+
1,b.lastRow);0<c;c--)e.removeChild(e.lastChild);a.firstRow<b.firstRow&&(c=this.$renderLinesFragment(a,a.firstRow,b.firstRow-1),e.firstChild?e.insertBefore(c,e.firstChild):e.appendChild(c));a.lastRow>b.lastRow&&(c=this.$renderLinesFragment(a,b.lastRow+1,a.lastRow),e.appendChild(c))};this.$renderLinesFragment=function(a,b,e){for(var c=this.element.ownerDocument.createDocumentFragment(),d=this.session.getNextFoldLine(b),f=d?d.start.row:Infinity;;){b>f&&(b=d.end.row+1,f=(d=this.session.getNextFoldLine(b,
d))?d.start.row:Infinity);if(b>e)break;var g=n.createElement("div"),i=[];this.$renderLine(i,b,!1,b==f?d:!1);g.innerHTML=i.join("");if(this.$useLineGroups())g.className="ace_line_group",c.appendChild(g),g.style.height=a.lineHeight*this.session.getRowLength(b)+"px";else for(;g.firstChild;)c.appendChild(g.firstChild);b++}return c};this.update=function(a){this.config=a;for(var b=[],e=a.lastRow,c=a.firstRow,d=this.session.getNextFoldLine(c),f=d?d.start.row:Infinity;;){c>f&&(c=d.end.row+1,f=(d=this.session.getNextFoldLine(c,
d))?d.start.row:Infinity);if(c>e)break;this.$useLineGroups()&&b.push("<div class='ace_line_group' style='height:",a.lineHeight*this.session.getRowLength(c),"px'>");this.$renderLine(b,c,!1,c==f?d:!1);this.$useLineGroups()&&b.push("</div>");c++}this.element.innerHTML=b.join("")};this.$textToken={text:!0,rparen:!0,lparen:!0};this.$renderToken=function(a,b,e,c){var d=this,f=c.replace(/\t|&|<|>|( +)|([\x00-\x1f\x80-\xa0\xad\u1680\u180E\u2000-\u200f\u2028\u2029\u202F\u205F\u3000\uFEFF\uFFF9-\uFFFC])|[\u1100-\u115F\u11A3-\u11A7\u11FA-\u11FF\u2329-\u232A\u2E80-\u2E99\u2E9B-\u2EF3\u2F00-\u2FD5\u2FF0-\u2FFB\u3000-\u303E\u3041-\u3096\u3099-\u30FF\u3105-\u312D\u3131-\u318E\u3190-\u31BA\u31C0-\u31E3\u31F0-\u321E\u3220-\u3247\u3250-\u32FE\u3300-\u4DBF\u4E00-\uA48C\uA490-\uA4C6\uA960-\uA97C\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFAFF\uFE10-\uFE19\uFE30-\uFE52\uFE54-\uFE66\uFE68-\uFE6B\uFF01-\uFF60\uFFE0-\uFFE6]/g,
function(a,c,f,e){if(c)return d.showInvisibles?"<span class='ace_invisible ace_invisible_space'>"+l.stringRepeat(d.SPACE_CHAR,a.length)+"</span>":a;if("&"==a)return"&#38;";if("<"==a)return"&#60;";if(">"==a)return"&#62;";if("\t"==a)return a=d.session.getScreenTabSize(b+e),b+=a-1,d.$tabStrings[a];if("\u3000"==a)return a=d.showInvisibles?"ace_cjk ace_invisible ace_invisible_space":"ace_cjk",c=d.showInvisibles?d.SPACE_CHAR:"",b+=1,"<span class='"+a+"' style='width:"+2*d.config.characterWidth+"px'>"+c+
"</span>";if(f)return"<span class='ace_invisible ace_invisible_space ace_invalid'>"+d.SPACE_CHAR+"</span>";b+=1;return"<span class='ace_cjk' style='width:"+2*d.config.characterWidth+"px'>"+a+"</span>"});if(this.$textToken[e.type])a.push(f);else{var g="ace_"+e.type.replace(/\./g," ace_"),i="";"fold"==e.type&&(i=" style='width:"+e.value.length*this.config.characterWidth+"px;' ");a.push("<span class='",g,"'",i,">",f,"</span>")}return b+c.length};this.renderIndentGuide=function(a,b,e){var c=b.search(this.$indentGuideRe);
return 0>=c||c>=e?b:" "==b[0]?(c-=c%this.tabSize,a.push(l.stringRepeat(this.$tabStrings[" "],c/this.tabSize)),b.substr(c)):"\t"==b[0]?(a.push(l.stringRepeat(this.$tabStrings["\t"],c)),b.substr(c)):b};this.$renderWrappedLine=function(a,b,e,c){for(var d=0,f=0,g=e[0],i=0,k=0;k<b.length;k++){var j=b[k],h=j.value;if(0==k&&this.displayIndentGuides){d=h.length;h=this.renderIndentGuide(a,h,g);if(!h)continue;d-=h.length}if(d+h.length<g)i=this.$renderToken(a,i,j,h),d+=h.length;else{for(;d+h.length>=g;)this.$renderToken(a,
i,j,h.substring(0,g-d)),h=h.substring(g-d),d=g,c||a.push("</div>","<div class='ace_line' style='height:",this.config.lineHeight,"px'>"),a.push(l.stringRepeat("\u00a0",e.indent)),f++,i=0,g=e[f]||Number.MAX_VALUE;0!=h.length&&(d+=h.length,i=this.$renderToken(a,i,j,h))}}};this.$renderSimpleLine=function(a,b){var e=0,c=b[0],d=c.value;this.displayIndentGuides&&(d=this.renderIndentGuide(a,d));d&&(e=this.$renderToken(a,e,c,d));for(var f=1;f<b.length;f++)c=b[f],d=c.value,e=this.$renderToken(a,e,c,d)};this.$renderLine=
function(a,b,e,c){!c&&!1!=c&&(c=this.session.getFoldLine(b));var d=c?this.$getFoldLineTokens(b,c):this.session.getTokens(b);e||a.push("<div class='ace_line' style='height:",this.config.lineHeight*(this.$useLineGroups()?1:this.session.getRowLength(b)),"px'>");if(d.length){var f=this.session.getRowSplitData(b);f&&f.length?this.$renderWrappedLine(a,d,f,e):this.$renderSimpleLine(a,d)}this.showInvisibles&&(c&&(b=c.end.row),a.push("<span class='ace_invisible ace_invisible_eol'>",b==this.session.getLength()-
1?this.EOF_CHAR:this.EOL_CHAR,"</span>"));e||a.push("</div>")};this.$getFoldLineTokens=function(a,b){var e=this.session,c=[],d=e.getTokens(a);b.walk(function(a,b,i,k,j){if(null!=a)c.push({type:"fold",value:a});else if(j&&(d=e.getTokens(b)),d.length)a:{a=d;for(j=b=0;j+a[b].value.length<k;)if(j+=a[b].value.length,b++,b==a.length)break a;if(j!=k){var h=a[b].value.substring(k-j);h.length>i-k&&(h=h.substring(0,i-k));c.push({type:a[b].type,value:h});j=k+h.length;b+=1}for(;j<i&&b<a.length;)h=a[b].value,
h.length+j>i?c.push({type:a[b].type,value:h.substring(0,i-j)}):c.push(a[b]),j+=h.length,b+=1}},b.end.row,this.session.getLine(b.end.row).length);return c};this.$useLineGroups=function(){return this.session.getUseWrapMode()};this.destroy=function(){clearInterval(this.$pollSizeChangesTimer);this.$measureNode&&this.$measureNode.parentNode.removeChild(this.$measureNode);delete this.$measureNode}}).call(p.prototype);q.Text=p});