/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2010, Ajax.org B.V.
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

"undefined"!==typeof process&&(require("amd-loader"),require("../test/mockdom"));
define("require exports module ../test/assertions ../edit_session ./text ../mode/javascript".split(" "),function(b,k,g){var e=b("../test/assertions"),h=b("../edit_session").EditSession,i=b("./text").Text,j=b("../mode/javascript").Mode;g.exports={setUp:function(a){this.session=new h("");this.session.setMode(new j);this.textLayer=new i(document.createElement("div"));this.textLayer.setSession(this.session);this.textLayer.config={characterWidth:10,lineHeight:20};a()},"test: render line with hard tabs should render the same as lines with soft tabs":function(){this.session.setValue("a\ta\ta\t\na   a   a   \n");
this.textLayer.$computeTabString();var a=[];this.textLayer.$renderLine(a,0);var c=[];this.textLayer.$renderLine(c,1);e.equal(a.join(""),c.join(""))},"test rendering width of ideographic space (U+3000)":function(){this.session.setValue("\u3000");var a=[];this.textLayer.$renderLine(a,0,!0);e.equal(a.join(""),"<span class='ace_cjk' style='width:20px'></span>");this.textLayer.setShowInvisibles(!0);a=[];this.textLayer.$renderLine(a,0,!0);e.equal(a.join(""),"<span class='ace_cjk ace_invisible ace_invisible_space' style='width:20px'>"+
this.textLayer.SPACE_CHAR+"</span><span class='ace_invisible ace_invisible_eol'>\u00b6</span>")},"test rendering of indent guides":function(){function a(a){for(var b=a.length;b--;){var d=[];c.$renderLine(d,b,!0);e.equal(d.join(""),a[b])}}var c=this.textLayer,b="<span class='ace_invisible ace_invisible_eol'>"+c.EOL_CHAR+"</span>",d=function(a){return Array(a+1).join(" ")},f=function(a){return Array(a+1).join(c.TAB_CHAR)};this.session.setValue("      \n\t\tf\n   ");a(["<span class='ace_indent-guide'>"+
d(4)+"</span>"+d(2),"<span class='ace_indent-guide'>"+d(4)+"</span>"+d(4)+"<span class='ace_identifier'>f</span>",d(3)]);this.textLayer.setShowInvisibles(!0);a(["<span class='ace_indent-guide ace_invisible ace_invisible_space'>"+Array(5).join(c.SPACE_CHAR)+"</span><span class='ace_invisible ace_invisible_space'>"+Array(3).join(c.SPACE_CHAR)+"</span>"+b,"<span class='ace_indent-guide ace_invisible ace_invisible_tab'>"+f(4)+"</span><span class='ace_invisible ace_invisible_tab'>"+f(4)+"</span><span class='ace_identifier'>f</span>"+
b]);this.textLayer.setDisplayIndentGuides(!1);a(["<span class='ace_invisible ace_invisible_space'>"+Array(7).join(c.SPACE_CHAR)+"</span>"+b,"<span class='ace_invisible ace_invisible_tab'>"+f(4)+"</span><span class='ace_invisible ace_invisible_tab'>"+f(4)+"</span><span class='ace_identifier'>f</span>"+b])}}});"undefined"!==typeof module&&module===require.main&&require("asyncjs").test.testcase(module.exports).exec();