/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2010, Ajax.org B.V.
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

define("require exports module ../../lib/oop ../behaviour ../../token_iterator ../../lib/lang".split(" "),function(k,p){var q=k("../../lib/oop"),r=k("../behaviour").Behaviour,m=k("../../token_iterator").TokenIterator,s=k("../../lib/lang"),n=["text","paren.rparen","punctuation.operator"],t=["text","paren.rparen","punctuation.operator","comment"],f,j={},h=function(a){var d=-1;a.multiSelect&&(d=a.selection.index,j.rangeCount!=a.multiSelect.rangeCount&&(j={rangeCount:a.multiSelect.rangeCount}));if(j[d])return f=
j[d];f=j[d]={autoInsertedBrackets:0,autoInsertedRow:-1,autoInsertedLineEnd:"",maybeInsertedBrackets:0,maybeInsertedRow:-1,maybeInsertedLineStart:"",maybeInsertedLineEnd:""}},l=function(a,d,b,e){var c=a.end.row-a.start.row;return{text:b+d+e,selection:[0,a.start.column+1,c,a.end.column+(c?0:1)]}},g=function(){this.add("braces","insertion",function(a,d,b,e,c){a=b.getCursorPosition();d=e.doc.getLine(a.row);if("{"==c){h(b);var c=b.getSelectionRange(),i=e.doc.getTextRange(c);if(""!==i&&"{"!==i&&b.getWrapBehavioursEnabled())return l(c,
i,"{","}");if(g.isSaneInsertion(b,e)){if(/[\]\}\)]/.test(d[a.column])||b.inMultiSelectMode)return g.recordAutoInsert(b,e,"}"),{text:"{}",selection:[1,1]};g.recordMaybeInsert(b,e,"{");return{text:"{",selection:[1,1]}}}else if("}"==c){if(h(b),i=d.substring(a.column,a.column+1),"}"==i&&null!==e.$findOpeningBracket("}",{column:a.column+1,row:a.row})&&g.isAutoInsertedClosing(a,d,c))return g.popAutoInsertedClosing(),{text:"",selection:[1,1]}}else{if("\n"==c||"\r\n"==c){h(b);b="";g.isMaybeInsertedClosing(a,
d)&&(b=s.stringRepeat("}",f.maybeInsertedBrackets),g.clearMaybeInsertedClosing());i=d.substring(a.column,a.column+1);if("}"===i){a=e.findMatchingBracket({row:a.row,column:a.column+1},"}");if(!a)return null;a=this.$getIndent(e.getLine(a.row))}else if(b)a=this.$getIndent(d);else{g.clearMaybeInsertedClosing();return}e=a+e.getTabString();return{text:"\n"+e+"\n"+a+b,selection:[1,e.length,1,e.length]}}g.clearMaybeInsertedClosing()}});this.add("braces","deletion",function(a,d,b,e,c){a=e.doc.getTextRange(c);
if(!c.isMultiLine()&&"{"==a){h(b);if("}"==e.doc.getLine(c.start.row).substring(c.end.column,c.end.column+1))return c.end.column++,c;f.maybeInsertedBrackets--}});this.add("parens","insertion",function(a,d,b,e,c){if("("==c){h(b);c=b.getSelectionRange();a=e.doc.getTextRange(c);if(""!==a&&b.getWrapBehavioursEnabled())return l(c,a,"(",")");if(g.isSaneInsertion(b,e))return g.recordAutoInsert(b,e,")"),{text:"()",selection:[1,1]}}else if(")"==c&&(h(b),b=b.getCursorPosition(),a=e.doc.getLine(b.row),")"==a.substring(b.column,
b.column+1)&&null!==e.$findOpeningBracket(")",{column:b.column+1,row:b.row})&&g.isAutoInsertedClosing(b,a,c)))return g.popAutoInsertedClosing(),{text:"",selection:[1,1]}});this.add("parens","deletion",function(a,d,b,e,c){a=e.doc.getTextRange(c);if(!c.isMultiLine()&&"("==a&&(h(b),")"==e.doc.getLine(c.start.row).substring(c.start.column+1,c.start.column+2)))return c.end.column++,c});this.add("brackets","insertion",function(a,d,b,e,c){if("["==c){h(b);c=b.getSelectionRange();a=e.doc.getTextRange(c);if(""!==
a&&b.getWrapBehavioursEnabled())return l(c,a,"[","]");if(g.isSaneInsertion(b,e))return g.recordAutoInsert(b,e,"]"),{text:"[]",selection:[1,1]}}else if("]"==c&&(h(b),b=b.getCursorPosition(),a=e.doc.getLine(b.row),"]"==a.substring(b.column,b.column+1)&&null!==e.$findOpeningBracket("]",{column:b.column+1,row:b.row})&&g.isAutoInsertedClosing(b,a,c)))return g.popAutoInsertedClosing(),{text:"",selection:[1,1]}});this.add("brackets","deletion",function(a,d,b,e,c){a=e.doc.getTextRange(c);if(!c.isMultiLine()&&
"["==a&&(h(b),"]"==e.doc.getLine(c.start.row).substring(c.start.column+1,c.start.column+2)))return c.end.column++,c});this.add("string_dquotes","insertion",function(a,d,b,e,c){if(('"'==c||"'"==c)&&!(this.lineCommentStart&&-1!=this.lineCommentStart.indexOf(c))){h(b);a=b.getSelectionRange();d=e.doc.getTextRange(a);if(""!==d&&"'"!==d&&'"'!=d&&b.getWrapBehavioursEnabled())return l(a,d,c,c);if(!d){var d=b.getCursorPosition(),a=e.doc.getLine(d.row),b=a.substring(d.column-1,d.column),a=a.substring(d.column,
d.column+1),f=e.getTokenAt(d.row,d.column),d=e.getTokenAt(d.row,d.column+1);if("\\"==b&&f&&/escape/.test(f.type))return null;var f=f&&/string|escape/.test(f.type),g=!d||/string|escape/.test(d.type);if(a==c)(e=f!==g)&&/string\.end/.test(d.type)&&(e=!1);else{if(f&&!g||f&&g)return null;d=e.$mode.tokenRe;d.lastIndex=0;e=d.test(b);d.lastIndex=0;b=d.test(b);if(e||b||a&&!/[\s;,.})\]\\]/.test(a))return null;e=!0}return{text:e?c+c:"",selection:[1,1]}}}});this.add("string_dquotes","deletion",function(a,d,b,
e,c){a=e.doc.getTextRange(c);if(!c.isMultiLine()&&('"'==a||"'"==a))if(h(b),e.doc.getLine(c.start.row).substring(c.start.column+1,c.start.column+2)==a)return c.end.column++,c})};g.isSaneInsertion=function(a,d){var b=a.getCursorPosition(),e=new m(d,b.row,b.column);if(!this.$matchTokenType(e.getCurrentToken()||"text",n)){var c=new m(d,b.row,b.column+1);if(!this.$matchTokenType(c.getCurrentToken()||"text",n))return!1}e.stepForward();return e.getCurrentTokenRow()!==b.row||this.$matchTokenType(e.getCurrentToken()||
"text",t)};g.$matchTokenType=function(a,d){return-1<d.indexOf(a.type||a)};g.recordAutoInsert=function(a,d,b){a=a.getCursorPosition();d=d.doc.getLine(a.row);this.isAutoInsertedClosing(a,d,f.autoInsertedLineEnd[0])||(f.autoInsertedBrackets=0);f.autoInsertedRow=a.row;f.autoInsertedLineEnd=b+d.substr(a.column);f.autoInsertedBrackets++};g.recordMaybeInsert=function(a,d,b){a=a.getCursorPosition();d=d.doc.getLine(a.row);this.isMaybeInsertedClosing(a,d)||(f.maybeInsertedBrackets=0);f.maybeInsertedRow=a.row;
f.maybeInsertedLineStart=d.substr(0,a.column)+b;f.maybeInsertedLineEnd=d.substr(a.column);f.maybeInsertedBrackets++};g.isAutoInsertedClosing=function(a,d,b){return 0<f.autoInsertedBrackets&&a.row===f.autoInsertedRow&&b===f.autoInsertedLineEnd[0]&&d.substr(a.column)===f.autoInsertedLineEnd};g.isMaybeInsertedClosing=function(a,d){return 0<f.maybeInsertedBrackets&&a.row===f.maybeInsertedRow&&d.substr(a.column)===f.maybeInsertedLineEnd&&d.substr(0,a.column)==f.maybeInsertedLineStart};g.popAutoInsertedClosing=
function(){f.autoInsertedLineEnd=f.autoInsertedLineEnd.substr(1);f.autoInsertedBrackets--};g.clearMaybeInsertedClosing=function(){f&&(f.maybeInsertedBrackets=0,f.maybeInsertedRow=-1)};q.inherits(g,r);p.CstyleBehaviour=g});