/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2010, Ajax.org B.V.
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

"undefined"!==typeof process&&require("amd-loader");
define("require exports module ../edit_session ../tokenizer ./javascript ../test/assertions".split(" "),function(d,h,f){var c=d("../edit_session").EditSession,g=d("../tokenizer").Tokenizer,e=d("./javascript").Mode,b=d("../test/assertions");f.exports={setUp:function(){this.mode=new e},"test: getTokenizer() (smoke test)":function(){var a=this.mode.getTokenizer();b.ok(a instanceof g);a=a.getLineTokens("'juhu'","start").tokens;b.equal("string",a[0].type)},"test: toggle comment lines should prepend '//' to each line":function(){var a=
new c(["  abc","cde","fg"]);a.setTabSize(1);this.mode.toggleCommentLines("start",a,0,1);b.equal("//   abc\n// cde\nfg",a.toString())},"test: toggle comment on commented lines should remove leading '//' chars":function(){var a=new c(["//  abc","//cde","fg"]);a.setTabSize(1);this.mode.toggleCommentLines("start",a,0,1);b.equal(" abc\ncde\nfg",a.toString())},"test: toggle comment on all empty lines":function(){var a=new c(["  "," ","  "]);a.setTabSize(1);this.mode.toggleCommentLines("start",a,0,1);b.equal(" //  \n // \n  ",
a.toString())},"test: toggle comment with empty lines":function(){var a=new c(["        abc","","    cde","    fg"]),d=a.toString();this.mode.toggleCommentLines("start",a,0,3);b.equal("    //     abc\n\n    // cde\n    // fg",a.toString());this.mode.toggleCommentLines("start",a,0,3);b.equal(d,a.toString())},"test: toggle comment lines twice should return the original text":function(){var a=new c(["  abc","cde","fg"]);this.mode.toggleCommentLines("start",a,0,2);this.mode.toggleCommentLines("start",
a,0,2);b.equal("  abc\ncde\nfg",a.toString())},"test: toggle comment on multiple lines with one commented line prepend '//' to each line":function(){var a=new c(["  //  abc","  //cde","    fg"]);a.setTabSize(1);this.mode.toggleCommentLines("start",a,0,2);b.equal("  // //  abc\n  // //cde\n  //   fg",a.toString())},"test: toggle comment on a comment line with leading white space":function(){var a=new c(["//cde","  //fg"]);this.mode.toggleCommentLines("start",a,0,1);b.equal("cde\n  fg",a.toString())},
"test: toggle comment lines should take tabsize into account":function(){var a=new c(["  //  abc","  // cde","//    fg"]);a.setTabSize(2);this.mode.toggleCommentLines("start",a,0,2);b.equal("    abc\n  cde\n    fg",a.toString());a.setTabSize(4);this.mode.toggleCommentLines("start",a,0,2);b.equal("//     abc\n//   cde\n//     fg",a.toString());this.mode.toggleCommentLines("start",a,0,2);b.equal("    abc\n  cde\n    fg",a.toString());a.insert({row:0,column:0}," ");this.mode.toggleCommentLines("start",
a,0,2);b.equal("//      abc\n//   cde\n//     fg",a.toString())},"!test: togglecomment on line with one space":function(){var a=new c([" abc","  // cde","//    fg"]),d=a+"";a.setTabSize(4);this.mode.toggleCommentLines("start",a,0,0);this.mode.toggleCommentLines("start",a,0,0);b.equal(d,a.toString())},"test: auto indent after opening brace":function(){b.equal("  ",this.mode.getNextLineIndent("start","if () {","  "))},"test: auto indent after case":function(){b.equal("  ",this.mode.getNextLineIndent("start",
"case 'juhu':","  "))},"test: no auto indent in object literal":function(){b.equal("",this.mode.getNextLineIndent("start","{ 'juhu':","  "))},"test: no auto indent after opening brace in multi line comment":function(){b.equal("",this.mode.getNextLineIndent("start","/*if () {","  "));b.equal("  ",this.mode.getNextLineIndent("comment","  abcd","  "))},"test: no auto indent after opening brace in single line comment":function(){b.equal("",this.mode.getNextLineIndent("start","//if () {","  "));b.equal("  ",
this.mode.getNextLineIndent("start","  //if () {","  "))},"test: no auto indent should add to existing indent":function(){b.equal("      ",this.mode.getNextLineIndent("start","    if () {","  "));b.equal("    ",this.mode.getNextLineIndent("start","    cde","  "));b.equal("    ",this.mode.getNextLineIndent("start","function foo(items) {","    "))},"test: special indent in doc comments":function(){b.equal(" * ",this.mode.getNextLineIndent("doc-start","/**"," "));b.equal("   * ",this.mode.getNextLineIndent("doc-start",
"  /**"," "));b.equal(" * ",this.mode.getNextLineIndent("doc-start"," *"," "));b.equal("    * ",this.mode.getNextLineIndent("doc-start","    *"," "));b.equal("  ",this.mode.getNextLineIndent("doc-start","  abc"," "))},"test: no indent after doc comments":function(){b.equal("",this.mode.getNextLineIndent("doc-start","   */","  "))},"test: trigger outdent if line is space and new text starts with closing brace":function(){b.ok(this.mode.checkOutdent("start","   "," }"));b.ok(!this.mode.checkOutdent("start",
" a  "," }"));b.ok(!this.mode.checkOutdent("start","","}"));b.ok(!this.mode.checkOutdent("start","   ","a }"));b.ok(!this.mode.checkOutdent("start","   }","}"))},"test: auto outdent should indent the line with the same indent as the line with the matching opening brace":function(){var a=new c(["  function foo() {","    bla","    }"],new e);this.mode.autoOutdent("start",a,2);b.equal("  }",a.getLine(2))},"test: no auto outdent if no matching brace is found":function(){var a=new c(["  function foo()",
"    bla","    }"]);this.mode.autoOutdent("start",a,2);b.equal("    }",a.getLine(2))}}});"undefined"!==typeof module&&module===require.main&&require("asyncjs").test.testcase(module.exports).exec();