/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2010, Ajax.org B.V.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

define("require exports module ../tokenizer ./text_highlight_rules ./behaviour/cstyle ../unicode ../lib/lang ../token_iterator ../range".split(" "),function(l,t){var w=l("../tokenizer").Tokenizer,x=l("./text_highlight_rules").TextHighlightRules,y=l("./behaviour/cstyle").CstyleBehaviour,f=l("../unicode"),s=l("../lib/lang"),p=l("../token_iterator").TokenIterator,q=l("../range").Range,r=function(){this.HighlightRules=x};(function(){this.$behaviour=new y;this.tokenRe=RegExp("^["+f.packages.L+f.packages.Mn+
f.packages.Mc+f.packages.Nd+f.packages.Pc+"\\$_]+","g");this.nonTokenRe=RegExp("^(?:[^"+f.packages.L+f.packages.Mn+f.packages.Mc+f.packages.Nd+f.packages.Pc+"\\$_]|\\s])+","g");this.getTokenizer=function(){this.$tokenizer||(this.$highlightRules=this.$highlightRules||new this.HighlightRules(this.$highlightRuleConfig),this.$tokenizer=new w(this.$highlightRules.getRules()));return this.$tokenizer};this.blockComment=this.lineCommentStart="";this.toggleCommentLines=function(b,a,e,g){function c(c){for(var a=
e;a<=g;a++)c(d.getLine(a),a)}var d=a.doc,k=!0,i=!0,h=Infinity,m=a.getTabSize(),b=!1;if(this.lineCommentStart){Array.isArray(this.lineCommentStart)?(j=this.lineCommentStart.map(s.escapeRegExp).join("|"),n=this.lineCommentStart[0]):(j=s.escapeRegExp(this.lineCommentStart),n=this.lineCommentStart);var j=RegExp("^(\\s*)(?:"+j+") ?"),b=a.getUseSoftTabs(),f=function(a,c){var b=a.match(j);if(b){var e=b[1].length,g=b[0].length;!q(a,e,g)&&" "==b[0][g-1]&&g--;d.removeInLine(c,e,g)}},l=n+" ",p=function(a,c){if(!k||
/\S/.test(a))q(a,h,h)?d.insertInLine({row:c,column:h},l):d.insertInLine({row:c,column:h},n)},u=function(a){return j.test(a)},q=function(a,d,c){for(var b=0;d--&&" "==a.charAt(d);)b++;if(0!=b%m)return!1;for(b=0;" "==a.charAt(c++);)b++;return 2<m?b%m!=m-1:0==b%m}}else{if(!this.blockComment)return!1;var n=this.blockComment.start,r=this.blockComment.end,j=RegExp("^(\\s*)(?:"+s.escapeRegExp(n)+")"),t=RegExp("(?:"+s.escapeRegExp(r)+")\\s*$"),p=function(a,b){if(!u(a,b)&&(!k||/\S/.test(a)))d.insertInLine({row:b,
column:a.length},r),d.insertInLine({row:b,column:h},n)},f=function(a,b){var c;(c=a.match(t))&&d.removeInLine(b,a.length-c[0].length,a.length);(c=a.match(j))&&d.removeInLine(b,c[1].length,c[0].length)},u=function(b,c){if(j.test(b))return!0;for(var d=a.getTokens(c),e=0;e<d.length;e++)if("comment"===d[e].type)return!0}}var v=Infinity;c(function(a,b){var c=a.search(/\S/);-1!==c?(c<h&&(h=c),i&&!u(a,b)&&(i=!1)):v>a.length&&(v=a.length)});Infinity==h&&(h=v,i=k=!1);b&&0!=h%m&&(h=Math.floor(h/m)*m);c(i?f:
p)};this.toggleBlockComment=function(b,a,e,g){if(b=this.blockComment){!b.start&&b[0]&&(b=b[0]);var c=new p(a,g.row,g.column),d=c.getCurrentToken(),k=a.selection.toOrientedRange(),i,h;if(d&&/comment/.test(d.type)){for(var f,j;d&&/comment/.test(d.type);){d=d.value.indexOf(b.start);if(-1!=d){e=c.getCurrentTokenRow();c=c.getCurrentTokenColumn()+d;f=new q(e,c,e,c+b.start.length);break}d=c.stepBackward()}c=new p(a,g.row,g.column);for(d=c.getCurrentToken();d&&/comment/.test(d.type);){d=d.value.indexOf(b.end);
if(-1!=d){e=c.getCurrentTokenRow();c=c.getCurrentTokenColumn()+d;j=new q(e,c,e,c+b.end.length);break}d=c.stepForward()}j&&a.remove(j);f&&(a.remove(f),i=f.start.row,h=-b.start.length)}else h=b.start.length,i=e.start.row,a.insert(e.end,b.end),a.insert(e.start,b.start);k.start.row==i&&(k.start.column+=h);k.end.row==i&&(k.end.column+=h);a.selection.fromOrientedRange(k)}};this.getNextLineIndent=function(b,a){return this.$getIndent(a)};this.checkOutdent=function(){return!1};this.autoOutdent=function(){};
this.$getIndent=function(b){return b.match(/^\s*/)[0]};this.createWorker=function(){return null};this.createModeDelegates=function(b){this.$embeds=[];this.$modes={};for(var a in b)b[a]&&(this.$embeds.push(a),this.$modes[a]=new b[a]);var e="toggleBlockComment toggleCommentLines getNextLineIndent checkOutdent autoOutdent transformAction getCompletions".split(" ");for(a=0;a<e.length;a++)(function(b){var c=e[a],d=b[c];b[e[a]]=function(){return this.$delegator(c,arguments,d)}})(this)};this.$delegator=
function(b,a,e){var g=a[0];"string"!=typeof g&&(g=g[0]);for(var c=0;c<this.$embeds.length;c++)if(this.$modes[this.$embeds[c]]){var d=g.split(this.$embeds[c]);if(!d[0]&&d[1])return a[0]=d[1],e=this.$modes[this.$embeds[c]],e[b].apply(e,a)}b=e.apply(this,a);return e?b:void 0};this.transformAction=function(b,a,e,g,c){if(this.$behaviour){var d=this.$behaviour.getBehaviours(),f;for(f in d)if(d[f][a]){var i=d[f][a].apply(this,arguments);if(i)return i}}};this.getKeywords=function(b){if(!this.completionKeywords){var a=
this.$tokenizer.rules,e=[],g;for(g in a)for(var c=a[g],d=0,f=c.length;d<f;d++)if("string"===typeof c[d].token)/keyword|support|storage/.test(c[d].token)&&e.push(c[d].regex);else if("object"===typeof c[d].token)for(var i=0,h=c[d].token.length;i<h;i++)/keyword|support|storage/.test(c[d].token[i])&&(g=c[d].regex.match(/\(.+?\)/g)[i],e.push(g.substr(1,g.length-2)));this.completionKeywords=e}return!b?this.$keywordList:e.concat(this.$keywordList||[])};this.$createKeywordList=function(){this.$highlightRules||
this.getTokenizer();return this.$keywordList=this.$highlightRules.$keywordList||[]};this.getCompletions=function(){return(this.$keywordList||this.$createKeywordList()).map(function(b){return{name:b,value:b,score:0,meta:"keyword"}})};this.$id="ace/mode/text"}).call(r.prototype);t.Mode=r});