/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2010, Ajax.org B.V.
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

define("require exports module ../lib/dom ../lib/event ../lib/useragent".split(" "),function(f,i){function g(a){a.$clickSelection=null;var b=a.editor;b.setDefaultHandler("mousedown",this.onMouseDown.bind(a));b.setDefaultHandler("dblclick",this.onDoubleClick.bind(a));b.setDefaultHandler("tripleclick",this.onTripleClick.bind(a));b.setDefaultHandler("quadclick",this.onQuadClick.bind(a));b.setDefaultHandler("mousewheel",this.onMouseWheel.bind(a));b.setDefaultHandler("touchmove",this.onTouchMove.bind(a));
"select startSelect selectEnd selectAllEnd selectByWordsEnd selectByLinesEnd dragWait dragWaitEnd focusWait".split(" ").forEach(function(b){a[b]=this[b]},this);a.selectByLines=this.extendSelectionBy.bind(a,"getLineRange");a.selectByWords=this.extendSelectionBy.bind(a,"getWordRange")}function h(a,b){return 0>(a.start.row==a.end.row?2*b.column-a.start.column-a.end.column:a.start.row==a.end.row-1&&!a.start.column&&!a.end.column?b.column-4:2*b.row-a.start.row-a.end.row)?{cursor:a.start,anchor:a.end}:
{cursor:a.end,anchor:a.start}}f("../lib/dom");f("../lib/event");f("../lib/useragent");(function(){this.onMouseDown=function(a){var b=a.inSelection(),c=a.getDocumentPosition();this.mousedownEvent=a;var d=this.editor,e=a.getButton();if(0!==e){if(b=d.getSelectionRange().isEmpty(),d.$blockScrolling++,(b||1==e)&&d.selection.moveToPosition(c),d.$blockScrolling--,2==e)d.textInput.onContextMenu(a.domEvent)}else{this.mousedownEvent.time=Date.now();if(b&&!d.isFocused()&&(d.focus(),this.$focusTimout&&!this.$clickSelection&&
!d.inMultiSelectMode)){this.setState("focusWait");this.captureMouse(a);return}this.captureMouse(a);this.startSelect(c,1<a.domEvent._clicks);return a.preventDefault()}};this.startSelect=function(a,b){var a=a||this.editor.renderer.screenToTextCoordinates(this.x,this.y),c=this.editor;c.$blockScrolling++;this.mousedownEvent.getShiftKey()?c.selection.selectToPosition(a):b||c.selection.moveToPosition(a);b||this.select();c.renderer.scroller.setCapture&&c.renderer.scroller.setCapture();c.setStyle("ace_selecting");
this.setState("select");c.$blockScrolling--};this.select=function(){var a,b=this.editor,c=b.renderer.screenToTextCoordinates(this.x,this.y);b.$blockScrolling++;this.$clickSelection&&(a=this.$clickSelection.comparePoint(c),-1==a?a=this.$clickSelection.end:1==a?a=this.$clickSelection.start:(a=h(this.$clickSelection,c),c=a.cursor,a=a.anchor),b.selection.setSelectionAnchor(a.row,a.column));b.selection.selectToPosition(c);b.$blockScrolling--;b.renderer.scrollCursorIntoView()};this.extendSelectionBy=function(a){var b,
c=this.editor,d=c.renderer.screenToTextCoordinates(this.x,this.y),a=c.selection[a](d.row,d.column);c.$blockScrolling++;if(this.$clickSelection){b=this.$clickSelection.comparePoint(a.start);var e=this.$clickSelection.comparePoint(a.end);if(-1==b&&0>=e){if(b=this.$clickSelection.end,a.end.row!=d.row||a.end.column!=d.column)d=a.start}else if(1==e&&0<=b){if(b=this.$clickSelection.start,a.start.row!=d.row||a.start.column!=d.column)d=a.end}else-1==b&&1==e?(d=a.end,b=a.start):(a=h(this.$clickSelection,d),
d=a.cursor,b=a.anchor);c.selection.setSelectionAnchor(b.row,b.column)}c.selection.selectToPosition(d);c.$blockScrolling--;c.renderer.scrollCursorIntoView()};this.selectEnd=this.selectAllEnd=this.selectByWordsEnd=this.selectByLinesEnd=function(){this.$clickSelection=null;this.editor.unsetStyle("ace_selecting");this.editor.renderer.scroller.releaseCapture&&this.editor.renderer.scroller.releaseCapture()};this.focusWait=function(){var a=Math.sqrt(Math.pow(this.x-this.mousedownEvent.x,2)+Math.pow(this.y-
this.mousedownEvent.y,2)),b=Date.now();(0<a||b-this.mousedownEvent.time>this.$focusTimout)&&this.startSelect(this.mousedownEvent.getDocumentPosition())};this.onDoubleClick=function(a){var a=a.getDocumentPosition(),b=this.editor,c=b.session.getBracketRange(a);c?(c.isEmpty()&&(c.start.column--,c.end.column++),this.setState("select")):(c=b.selection.getWordRange(a.row,a.column),this.setState("selectByWords"));this.$clickSelection=c;this.select()};this.onTripleClick=function(a){var a=a.getDocumentPosition(),
b=this.editor;this.setState("selectByLines");var c=b.getSelectionRange();c.isMultiLine()&&c.contains(a.row,a.column)?(this.$clickSelection=b.selection.getLineRange(c.start.row),this.$clickSelection.end=b.selection.getLineRange(c.end.row).end):this.$clickSelection=b.selection.getLineRange(a.row);this.select()};this.onQuadClick=function(){var a=this.editor;a.selectAll();this.$clickSelection=a.getSelectionRange();this.setState("selectAll")};this.onMouseWheel=function(a){if(!a.getAccelKey()){a.getShiftKey()&&
(a.wheelY&&!a.wheelX)&&(a.wheelX=a.wheelY,a.wheelY=0);var b=a.domEvent.timeStamp,c=b-(this.$lastScrollTime||0),d=this.editor;if(d.renderer.isScrollableBy(a.wheelX*a.speed,a.wheelY*a.speed)||200>c)return this.$lastScrollTime=b,d.renderer.scrollBy(a.wheelX*a.speed,a.wheelY*a.speed),a.stop()}};this.onTouchMove=function(a){var b=a.domEvent.timeStamp,c=b-(this.$lastScrollTime||0),d=this.editor;if(d.renderer.isScrollableBy(a.wheelX*a.speed,a.wheelY*a.speed)||200>c)return this.$lastScrollTime=b,d.renderer.scrollBy(a.wheelX*
a.speed,a.wheelY*a.speed),a.stop()}}).call(g.prototype);i.DefaultHandlers=g});