/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2010, Ajax.org B.V.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

define("require exports module ./range_list ./range ./selection ./mouse/multi_select_handler ./lib/event ./lib/lang ./commands/multi_select_commands ./search ./edit_session ./editor ./config".split(" "),function(l,p){function u(a){if(!a.$multiselectOnSessionChange){a.$onAddRange=a.$onAddRange.bind(a);a.$onRemoveRange=a.$onRemoveRange.bind(a);a.$onMultiSelect=a.$onMultiSelect.bind(a);a.$onSingleSelect=a.$onSingleSelect.bind(a);a.$multiselectOnSessionChange=p.onSessionChange.bind(a);a.$checkMultiselectChange=
a.$checkMultiselectChange.bind(a);a.$multiselectOnSessionChange(a);a.on("changeSession",a.$multiselectOnSessionChange);a.on("mousedown",s);a.commands.addCommands(n.defaultCommands);var c=function(){d&&(a.renderer.setMouseCursor(""),d=!1)},b=a.textInput.getElement(),d=!1;t.addListener(b,"keydown",function(b){b=18==b.keyCode&&!(b.ctrlKey||b.shiftKey||b.metaKey);a.$blockSelectEnabled&&b?d||(a.renderer.setMouseCursor("crosshair"),d=!0):d&&c()});t.addListener(b,"keyup",c);t.addListener(b,"blur",c)}}var x=
l("./range_list").RangeList,m=l("./range").Range,v=l("./selection").Selection,s=l("./mouse/multi_select_handler").onMouseDown,t=l("./lib/event"),w=l("./lib/lang"),n=l("./commands/multi_select_commands");p.commands=n.defaultCommands.concat(n.multiSelectCommands);var q=new (l("./search").Search),r=l("./edit_session").EditSession;(function(){this.getSelectionMarkers=function(){return this.$selectionMarkers}}).call(r.prototype);(function(){this.rangeList=this.ranges=null;this.addRange=function(a,c){if(a){if(!this.inMultiSelectMode&&
0===this.rangeCount){var b=this.toOrientedRange();this.rangeList.add(b);this.rangeList.add(a);if(2!=this.rangeList.ranges.length)return this.rangeList.removeAll(),c||this.fromOrientedRange(a);this.rangeList.removeAll();this.rangeList.add(b);this.$onAddRange(b)}a.cursor||(a.cursor=a.end);b=this.rangeList.add(a);this.$onAddRange(a);b.length&&this.$onRemoveRange(b);1<this.rangeCount&&!this.inMultiSelectMode&&(this._signal("multiSelect"),this.inMultiSelectMode=!0,this.session.$undoSelect=!1,this.rangeList.attach(this.session));
return c||this.fromOrientedRange(a)}};this.toSingleRange=function(a){var a=a||this.ranges[0],c=this.rangeList.removeAll();c.length&&this.$onRemoveRange(c);a&&this.fromOrientedRange(a)};this.substractPoint=function(a){if(a=this.rangeList.substractPoint(a))return this.$onRemoveRange(a),a[0]};this.mergeOverlappingRanges=function(){var a=this.rangeList.merge();a.length?this.$onRemoveRange(a):this.ranges[0]&&this.fromOrientedRange(this.ranges[0])};this.$onAddRange=function(a){this.rangeCount=this.rangeList.ranges.length;
this.ranges.unshift(a);this._signal("addRange",{range:a})};this.$onRemoveRange=function(a){this.rangeCount=this.rangeList.ranges.length;if(1==this.rangeCount&&this.inMultiSelectMode){var c=this.rangeList.ranges.pop();a.push(c);this.rangeCount=0}for(var b=a.length;b--;){var d=this.ranges.indexOf(a[b]);this.ranges.splice(d,1)}this._signal("removeRange",{ranges:a});0===this.rangeCount&&this.inMultiSelectMode&&(this.inMultiSelectMode=!1,this._signal("singleSelect"),this.session.$undoSelect=!0,this.rangeList.detach(this.session));
(c=c||this.ranges[0])&&!c.isEqual(this.getRange())&&this.fromOrientedRange(c)};this.$initRangeList=function(){this.rangeList||(this.rangeList=new x,this.ranges=[],this.rangeCount=0)};this.getAllRanges=function(){return this.rangeCount?this.rangeList.ranges.concat():[this.getRange()]};this.splitIntoLines=function(){if(1<this.rangeCount){var a=this.rangeList.ranges,c=a[a.length-1],a=m.fromPoints(a[0].start,c.end);this.toSingleRange();this.setSelectionRange(a,c.cursor==c.start)}else{var a=this.getRange(),
b=this.isBackwards(),d=a.start.row,c=a.end.row;if(d==c)b?(c=a.end,a=a.start):(c=a.start,a=a.end),this.addRange(m.fromPoints(a,a)),this.addRange(m.fromPoints(c,c));else{var b=[],e=this.getLineRange(d,!0);e.start.column=a.start.column;b.push(e);for(d+=1;d<c;d++)b.push(this.getLineRange(d,!0));e=this.getLineRange(c,!0);e.end.column=a.end.column;b.push(e);b.forEach(this.addRange,this)}}};this.toggleBlockSelection=function(){if(1<this.rangeCount){var a=this.rangeList.ranges,c=a[a.length-1],a=m.fromPoints(a[0].start,
c.end);this.toSingleRange();this.setSelectionRange(a,c.cursor==c.start)}else c=this.session.documentToScreenPosition(this.selectionLead),a=this.session.documentToScreenPosition(this.selectionAnchor),this.rectangularRangeBlock(c,a).forEach(this.addRange,this)};this.rectangularRangeBlock=function(a,c,b){var d=[],e=a.column<c.column;if(e)var f=a.column,h=c.column;else f=c.column,h=a.column;var k=a.row<c.row;if(k)var g=a.row,a=c.row;else g=c.row,a=a.row;0>f&&(f=0);0>g&&(g=0);for(g==a&&(b=!0);g<=a;g++){c=
m.fromPoints(this.session.screenToDocumentPosition(g,f),this.session.screenToDocumentPosition(g,h));if(c.isEmpty()){if(i&&c.end.row==i.row&&c.end.column==i.column)break;var i=c.end}c.cursor=e?c.start:c.end;d.push(c)}k&&d.reverse();if(!b){for(b=d.length-1;d[b].isEmpty()&&0<b;)b--;if(0<b)for(var j=0;d[j].isEmpty();)j++;for(;b>=j;b--)d[b].isEmpty()&&d.splice(b,1)}return d}}).call(v.prototype);r=l("./editor").Editor;(function(){this.updateSelectionMarkers=function(){this.renderer.updateCursor();this.renderer.updateBackMarkers()};
this.addSelectionMarker=function(a){a.cursor||(a.cursor=a.end);var c=this.getSelectionStyle();a.marker=this.session.addMarker(a,"ace_selection",c);this.session.$selectionMarkers.push(a);this.session.selectionMarkerCount=this.session.$selectionMarkers.length;return a};this.removeSelectionMarker=function(a){a.marker&&(this.session.removeMarker(a.marker),a=this.session.$selectionMarkers.indexOf(a),-1!=a&&this.session.$selectionMarkers.splice(a,1),this.session.selectionMarkerCount=this.session.$selectionMarkers.length)};
this.removeSelectionMarkers=function(a){for(var c=this.session.$selectionMarkers,b=a.length;b--;){var d=a[b];d.marker&&(this.session.removeMarker(d.marker),d=c.indexOf(d),-1!=d&&c.splice(d,1))}this.session.selectionMarkerCount=c.length};this.$onAddRange=function(a){this.addSelectionMarker(a.range);this.renderer.updateCursor();this.renderer.updateBackMarkers()};this.$onRemoveRange=function(a){this.removeSelectionMarkers(a.ranges);this.renderer.updateCursor();this.renderer.updateBackMarkers()};this.$onMultiSelect=
function(){this.inMultiSelectMode||(this.inMultiSelectMode=!0,this.setStyle("ace_multiselect"),this.keyBinding.addKeyboardHandler(n.keyboardHandler),this.commands.setDefaultHandler("exec",this.$onMultiSelectExec),this.renderer.updateCursor(),this.renderer.updateBackMarkers())};this.$onSingleSelect=function(){this.session.multiSelect.inVirtualMode||(this.inMultiSelectMode=!1,this.unsetStyle("ace_multiselect"),this.keyBinding.removeKeyboardHandler(n.keyboardHandler),this.commands.removeDefaultHandler("exec",
this.$onMultiSelectExec),this.renderer.updateCursor(),this.renderer.updateBackMarkers(),this._emit("changeSelection"))};this.$onMultiSelectExec=function(a){var c=a.command,b=a.editor;if(b.multiSelect)return c.multiSelectAction?"forEach"==c.multiSelectAction?a=b.forEachSelection(c,a.args):"forEachLine"==c.multiSelectAction?a=b.forEachSelection(c,a.args,!0):"single"==c.multiSelectAction?(b.exitMultiSelectMode(),a=c.exec(b,a.args||{})):a=c.multiSelectAction(b,a.args||{}):(a=c.exec(b,a.args||{}),b.multiSelect.addRange(b.multiSelect.toOrientedRange()),
b.multiSelect.mergeOverlappingRanges()),a};this.forEachSelection=function(a,c,b){if(!this.inVirtualSelectionMode){var d=!0==b||b&&b.$byLines,e=this.session,f=this.selection,h=f.rangeList,b=(b&&b.keepOrder?f:h).ranges,k;if(!b.length)return a.exec?a.exec(this,c||{}):a(this,c||{});h=f._eventRegistry;f._eventRegistry={};var g=new v(e);this.inVirtualSelectionMode=!0;for(var i=b.length;i--;){if(d)for(;0<i&&b[i].start.row==b[i-1].end.row;)i--;g.fromOrientedRange(b[i]);g.index=i;this.selection=e.selection=
g;var j=a.exec?a.exec(this,c||{}):a(this,c||{});!k&&void 0!==j&&(k=j);g.toOrientedRange(b[i])}g.detach();this.selection=e.selection=f;this.inVirtualSelectionMode=!1;f._eventRegistry=h;f.mergeOverlappingRanges();a=this.renderer.$scrollAnimation;this.onCursorChange();this.onSelectionChange();a&&a.from==a.to&&this.renderer.animateScrolling(a.from);return k}};this.exitMultiSelectMode=function(){this.inMultiSelectMode&&!this.inVirtualSelectionMode&&this.multiSelect.toSingleRange()};this.getSelectedText=
function(){var a="";if(this.inMultiSelectMode&&!this.inVirtualSelectionMode){for(var a=this.multiSelect.rangeList.ranges,c=[],b=0;b<a.length;b++)c.push(this.session.getTextRange(a[b]));b=this.session.getDocument().getNewLineCharacter();a=c.join(b);a.length==(c.length-1)*b.length&&(a="")}else this.selection.isEmpty()||(a=this.session.getTextRange(this.getSelectionRange()));return a};this.$checkMultiselectChange=function(a,c){if(this.inMultiSelectMode&&!this.inVirtualSelectionMode){var b=this.multiSelect.ranges[0];
this.multiSelect.isEmpty()&&c==this.multiSelect.anchor||(b=c==this.multiSelect.anchor?b.cursor==b.start?b.end:b.start:b.cursor,(b.row!=c.row||this.session.$clipPositionToDocument(b.row,b.column).column!=c.column)&&this.multiSelect.toSingleRange(this.multiSelect.toOrientedRange()))}};this.findAll=function(a,c,b){c=c||{};c.needle=a||c.needle;if(void 0==c.needle){var d=this.selection.isEmpty()?this.selection.getWordRange():this.selection.getRange();c.needle=this.session.getTextRange(d)}this.$search.set(c);
a=this.$search.findAll(this.session);if(!a.length)return 0;this.$blockScrolling+=1;c=this.multiSelect;b||c.toSingleRange(a[0]);for(b=a.length;b--;)c.addRange(a[b],!0);d&&c.rangeList.rangeAtPoint(d.start)&&c.addRange(d,!0);this.$blockScrolling-=1;return a.length};this.selectMoreLines=function(a,c){var b=this.selection.toOrientedRange(),d=b.cursor==b.end,e=this.session.documentToScreenPosition(b.cursor);this.selection.$desiredColumn&&(e.column=this.selection.$desiredColumn);var f=this.session.screenToDocumentPosition(e.row+
a,e.column);if(b.isEmpty())h=f;else var h=this.session.documentToScreenPosition(d?b.end:b.start),h=this.session.screenToDocumentPosition(h.row+a,h.column);d?(d=m.fromPoints(f,h),d.cursor=d.start):(d=m.fromPoints(h,f),d.cursor=d.end);d.desiredColumn=e.column;if(this.selection.inMultiSelectMode){if(c)var k=b.cursor}else this.selection.addRange(b);this.selection.addRange(d);k&&this.selection.substractPoint(k)};this.transposeSelections=function(a){for(var c=this.session,b=c.multiSelect,d=b.ranges,e=d.length;e--;){var f=
d[e];if(f.isEmpty()){var h=c.getWordRange(f.start.row,f.start.column);f.start.row=h.start.row;f.start.column=h.start.column;f.end.row=h.end.row;f.end.column=h.end.column}}b.mergeOverlappingRanges();b=[];for(e=d.length;e--;)f=d[e],b.unshift(c.getTextRange(f));0>a?b.unshift(b.pop()):b.push(b.shift());for(e=d.length;e--;)f=d[e],h=f.clone(),c.replace(f,b[e]),f.start.row=h.start.row,f.start.column=h.start.column};this.selectMore=function(a,c,b){var d=this.session,e=d.multiSelect.toOrientedRange();if(e.isEmpty()&&
(e=d.getWordRange(e.start.row,e.start.column),e.cursor=-1==a?e.start:e.end,this.multiSelect.addRange(e),b))return;b=d.getTextRange(e);q.$options.wrap=!0;q.$options.needle=b;q.$options.backwards=-1==a;if(d=q.find(d))d.cursor=-1==a?d.start:d.end,this.$blockScrolling+=1,this.session.unfold(d),this.multiSelect.addRange(d),this.$blockScrolling-=1,this.renderer.scrollCursorIntoView(null,0.5);c&&this.multiSelect.substractPoint(e.cursor)};this.alignCursors=function(){var a=this.session,c=a.multiSelect,b=
c.ranges,d=-1,e=b.filter(function(a){if(a.cursor.row==d)return!0;d=a.cursor.row});if(!b.length||e.length==b.length-1){var b=this.selection.getRange(),e=b.start.row,f=b.end.row,h=e==f;if(h){var k=this.session.getLength(),g;do g=this.session.getLine(f);while(/[=:]/.test(g)&&++f<k);do g=this.session.getLine(e);while(/[=:]/.test(g)&&0<--e);0>e&&(e=0);f>=k&&(f=k-1)}f=this.session.removeFullLines(e,f);f=this.$reAlignText(f,h);this.session.insert({row:e,column:0},f.join("\n")+"\n");h||(b.start.column=0,
b.end.column=f[f.length-1].length);this.selection.setRange(b)}else{e.forEach(function(a){c.substractPoint(a.cursor)});var i=0,j=Infinity,y=b.map(function(b){var b=b.cursor,c=a.getLine(b.row).substr(b.column).search(/\S/g);-1==c&&(c=0);b.column>i&&(i=b.column);c<j&&(j=c);return c});b.forEach(function(b,c){var d=b.cursor,e=i-d.column,f=y[c]-j;e>f?a.insert(d,w.stringRepeat(" ",e-f)):a.remove(new m(d.row,d.column,d.row,d.column-e+f));b.start.column=b.end.column=i;b.start.row=b.end.row=d.row;b.cursor=
b.end});c.fromOrientedRange(b[0]);this.renderer.updateCursor();this.renderer.updateBackMarkers()}};this.$reAlignText=function(a,c){function b(a){return w.stringRepeat(" ",a)}function d(a){return!a[2]?a[0]:b(g)+a[2]+b(i-a[2].length+j)+a[4].replace(/^([=:])\s+/,"$1 ")}function e(a){return!a[2]?a[0]:b(g+i-a[2].length)+a[2]+b(j," ")+a[4].replace(/^([=:])\s+/,"$1 ")}function f(a){return!a[2]?a[0]:b(g)+a[2]+b(j)+a[4].replace(/^([=:])\s+/,"$1 ")}var h=!0,k=!0,g,i,j;return a.map(function(a){var b=a.match(/(\s*)(.*?)(\s*)([=:].*)/);
if(!b)return[a];if(null==g)return g=b[1].length,i=b[2].length,j=b[3].length,b;g+i+j!=b[1].length+b[2].length+b[3].length&&(k=!1);g!=b[1].length&&(h=!1);g>b[1].length&&(g=b[1].length);i<b[2].length&&(i=b[2].length);j>b[3].length&&(j=b[3].length);return b}).map(c?d:h?k?e:d:f)}}).call(r.prototype);p.onSessionChange=function(a){var c=a.session;c&&!c.multiSelect&&(c.$selectionMarkers=[],c.selection.$initRangeList(),c.multiSelect=c.selection);this.multiSelect=c&&c.multiSelect;if(a=a.oldSession)a.multiSelect.off("addRange",
this.$onAddRange),a.multiSelect.off("removeRange",this.$onRemoveRange),a.multiSelect.off("multiSelect",this.$onMultiSelect),a.multiSelect.off("singleSelect",this.$onSingleSelect),a.multiSelect.lead.off("change",this.$checkMultiselectChange),a.multiSelect.anchor.off("change",this.$checkMultiselectChange);c&&(c.multiSelect.on("addRange",this.$onAddRange),c.multiSelect.on("removeRange",this.$onRemoveRange),c.multiSelect.on("multiSelect",this.$onMultiSelect),c.multiSelect.on("singleSelect",this.$onSingleSelect),
c.multiSelect.lead.on("change",this.$checkMultiselectChange),c.multiSelect.anchor.on("change",this.$checkMultiselectChange));c&&this.inMultiSelectMode!=c.selection.inMultiSelectMode&&(c.selection.inMultiSelectMode?this.$onMultiSelect():this.$onSingleSelect())};p.MultiSelect=u;l("./config").defineOptions(r.prototype,"editor",{enableMultiselect:{set:function(a){u(this);a?(this.on("changeSession",this.$multiselectOnSessionChange),this.on("mousedown",s)):(this.off("changeSession",this.$multiselectOnSessionChange),
this.off("mousedown",s))},value:!0},enableBlockSelect:{set:function(a){this.$blockSelectEnabled=a},value:!0}})});