/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2010, Ajax.org B.V.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

"undefined"!==typeof process&&(require("amd-loader"),require("./test/mockdom"));
define("require exports module ./multi_select ./test/assertions ./range ./editor ./edit_session ./test/mockrenderer ./undomanager".split(" "),function(e,r,n){function p(a){a=a.multiSelect.toJSON();a.length||(a=[a]);a=a.map(function(a){var b,c;a.isBackwards?(b=a.end,c=a.start):(c=a.end,b=a.start);return f.comparePoints(b,c)?[b.row,b.column,c.row,c.column]:[b.row,b.column]});return 1<a.length?a:a[0]}function h(a,g){c.equal(p(a)+"",g+"")}function m(a,c){"number"==typeof c[0]&&(c=[c]);a.selection.fromJSON(c.map(function(a){var b=
{row:a[0],column:a[1]},a=2==a.length?b:{row:a[2],column:a[3]},c=0<f.comparePoints(b,a);return c?{start:a,end:b,isBackwards:c}:{start:b,end:a,isBackwards:c}}))}e("./multi_select");var c=e("./test/assertions"),f=e("./range").Range,i=e("./editor").Editor,j=e("./edit_session").EditSession,k=e("./test/mockrenderer").MockRenderer,q=e("./undomanager").UndoManager,a,d=function(b,c,d){do a.commands.exec(b,a,d);while(1<c--)},l=function(b){c.equal(a.selection.getAllRanges()+"",b+"")};n.exports={name:"ACE multi_select.js",
"test: multiselect editing":function(){var b=new j(["w1.w2","    wtt.w","    wtt.w"]);a=new i(new k,b);a.navigateFileEnd();d("selectMoreBefore",3);c.ok(a.inMultiSelectMode);c.equal(a.selection.getAllRanges().length,4);b=a.session.getDocument().getNewLineCharacter();b=["w","w","w","w"].join(b);c.equal(a.getCopyText(),b);d("insertstring",1,"a");d("backspace",2);c.equal(a.session.getValue(),"w1.w2\ntt\ntt");c.equal(a.selection.getAllRanges().length,4);d("selectall");c.ok(!a.inMultiSelectMode)},"test: multiselect navigation":function(){var b=
new j(["w1.w2","    wtt.w","    wtt.we"]);a=new i(new k,b);a.selectMoreLines(1);l("Range: [0/0] -> [0/0],Range: [1/0] -> [1/0]");c.ok(a.inMultiSelectMode);d("golinedown");d("gotolineend");l("Range: [1/9] -> [1/9],Range: [2/10] -> [2/10]");d("selectwordleft");l("Range: [1/8] -> [1/9],Range: [2/8] -> [2/10]");d("golinedown",2);c.ok(!a.inMultiSelectMode)},"test: multiselect session change":function(){var b=new j(["w1.w2","    wtt.w","    wtt.w"]);a=new i(new k,b);a.selectMoreLines(1);l("Range: [0/0] -> [0/0],Range: [1/0] -> [1/0]");
c.ok(a.inMultiSelectMode);var g=new j(["w1"]);a.setSession(g);c.ok(!a.inMultiSelectMode);a.setSession(b);c.ok(a.inMultiSelectMode)},"test: multiselect addRange":function(){var b=new j(["w1.w2","    wtt.w","    wtt.w"]);a=new i(new k,b);var b=a.selection,g=new f(0,2,0,4);a.selection.fromOrientedRange(g);g=new f(0,3,0,4);b.addRange(g);c.ok(!a.inMultiSelectMode);c.ok(g.isEqual(a.selection.getRange()));var d=new f(0,1,0,1);b.addRange(d);c.ok(a.inMultiSelectMode);l([d,g]);g=new f(0,0,4,0);b.addRange(g);
c.ok(!a.inMultiSelectMode)},"test: onPaste in command with multiselect":function(){var b=new j(["l1","l2"]);a=new i(new k,b);a.commands.addCommand({name:"insertfoo",exec:function(a){a.onPaste("foo")},multiSelectAction:"forEach"});var b=a.selection,d=new f(0,2,0,2),e=new f(1,2,1,2);b.fromOrientedRange(d);b.addRange(e);a.execCommand("insertfoo");c.equal("l1foo\nl2foo",a.getValue())},"test multiselect move lines":function(){a=new i(new k);a.setValue("l1\nl2\nl3\nl4",-1);m(a,[[0,2],[1,2],[2,2],[3,2]]);
d("copylinesdown");c.equal(a.getValue(),"l1\nl1\nl2\nl2\nl3\nl3\nl4\nl4");h(a,[[1,2],[3,2],[5,2],[7,2]]);d("copylinesup");c.equal(a.getValue(),"l1\nl1\nl1\nl2\nl2\nl2\nl3\nl3\nl3\nl4\nl4\nl4");h(a,[[1,2],[4,2],[7,2],[10,2]]);d("removeline");c.equal(a.getValue(),"l1\nl1\nl2\nl2\nl3\nl3\nl4\nl4");h(a,[[1,0],[3,0],[5,0],[7,0]]);m(a,[[1,2],[1,1,1,0],[3,0,3,1],[5,0,5,1],[7,0,7,1]]);d("copylinesdown");d("copylinesup");c.equal(a.getValue(),"l1\nl1\nl1\nl1\nl2\nl2\nl2\nl2\nl3\nl3\nl3\nl3\nl4\nl4\nl4\nl4");
h(a,[[2,2],[2,1,2,0],[6,0,6,1],[10,0,10,1],[14,0,14,1]]);d("movelinesdown",12);c.equal(a.getValue(),"l1\nl1\nl1\nl2\nl2\nl2\nl3\nl3\nl3\nl4\nl4\nl4\nl1\nl2\nl3\nl4");h(a,[[12,2],[12,1,12,0],[13,0,13,1],[14,0,14,1],[15,0,15,1]]);d("movelinesup",12);c.equal(a.getValue(),"l1\nl2\nl3\nl4\nl1\nl1\nl1\nl2\nl2\nl2\nl3\nl3\nl3\nl4\nl4\nl4");h(a,[[0,2],[0,1,0,0],[1,0,1,1],[2,0,2,1],[3,0,3,1]])},"test multiselect fromJSON/toJSON":function(){var b=new j(["l1","l2"]);a=new i(new k,b);var b=a.selection,d=b.toJSON(),
e=new f(0,2,0,2),h=new f(1,2,1,2);b.fromOrientedRange(e);b.addRange(h);e=b.toJSON();b.fromJSON(d);c.ok(!b.isEqual(e));c.ok(b.isEqual(d));b.fromJSON(e);c.ok(!b.isEqual(d));c.ok(b.isEqual(e))},"test multiselect align":function(){var b=new j(["l1","l2","l3"]);b.setUndoManager(new q);a=new i(new k,b);var d=a.selection;d.addRange(new f(1,0,1,0));d.addRange(new f(2,2,2,2));a.execCommand("alignCursors");c.equal("  l1\n  l2\nl3",a.getValue());b.markUndoGroup();a.execCommand("undo");c.equal("l1\nl2\nl3",a.getValue())}}});
"undefined"!==typeof module&&module===require.main&&require("asyncjs").test.testcase(module.exports).exec();