/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2010, Ajax.org B.V.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

"undefined"!==typeof process&&require("amd-loader");
define("require exports module ./edit_session ./editor ./test/mockrenderer ./range ./test/assertions ./occur ./commands/occur_commands".split(" "),function(c,k,f){var g=c("./edit_session").EditSession,h=c("./editor").Editor,i=c("./test/mockrenderer").MockRenderer;c("./range");var b=c("./test/assertions"),j=c("./occur").Occur,e=c("./commands/occur_commands").occurStartCommand,a,d;f.exports={name:"ACE occur.js",setUp:function(){var b=new g("");a=new h(new i,b);d=new j},"test: find lines matching":function(){a.session.insert({row:0,
column:0},"abc\ndef\nxyz\nbcxbc");var c=d.matchingLines(a.session,{needle:"bc"});b.deepEqual(c,[{row:0,content:"abc"},{row:3,content:"bcxbc"}])},"test: display occurrences":function(){a.session.insert({row:0,column:0},"abc\ndef\nxyz\nbcx\n");d.displayOccurContent(a,{needle:"bc"});b.equal(a.getValue(),"abc\nbcx");d.displayOriginalContent(a);b.equal(a.getValue(),"abc\ndef\nxyz\nbcx\n")},"test: original position from occur doc":function(){a.session.insert({row:0,column:0},"abc\ndef\nxyz\nbcx\n");d.displayOccurContent(a,
{needle:"bc"});b.equal(a.getValue(),"abc\nbcx");var c=d.occurToOriginalPosition(a.session,{row:1,column:2});b.position(c,3,2)},"test: occur command":function(){a.session.insert({row:0,column:0},"hel\nlo\n\nwo\nrld\n");a.commands.addCommand(e);a.execCommand("occur",{needle:"o"});b.equal(a.getValue(),"lo\nwo");b.ok(a.getKeyboardHandler().isOccurHandler,"no occur handler installed");b.ok(a.commands.byName.occurexit,"no exitoccur command installed");a.execCommand("occurexit");b.equal(a.getValue(),"hel\nlo\n\nwo\nrld\n");
b.ok(!a.getKeyboardHandler().isOccurHandler,"occur handler installed after detach");b.ok(!a.commands.byName.occurexit,"exitoccur installed after exiting occur")},"test: occur navigation":function(){a.session.insert({row:0,column:0},"hel\nlo\n\nwo\nrld\n");a.commands.addCommand(e);a.moveCursorToPosition({row:1,column:1});a.execCommand("occur",{needle:"o"});b.equal(a.getValue(),"lo\nwo");b.position(a.getCursorPosition(),0,1,"original -> occur pos");a.moveCursorToPosition({row:1,column:1});a.execCommand("occuraccept");
b.position(a.getCursorPosition(),3,1,"occur -> original pos")},"test: recursive occur":function(){a.session.insert({row:0,column:0},"x\nabc1\nx\nabc2\n");a.commands.addCommand(e);a.execCommand("occur",{needle:"abc"});b.equal(a.getValue(),"abc1\nabc2","orig -> occur1");a.execCommand("occur",{needle:"2"});b.equal(a.getValue(),"abc2","occur1 -> occur2");a.execCommand("occurexit");b.equal(a.getValue(),"abc1\nabc2","occur2 -> occur1");a.execCommand("occurexit");b.equal(a.getValue(),"x\nabc1\nx\nabc2\n",
"occur1 -> orig")}}});"undefined"!==typeof module&&module===require.main&&require("asyncjs").test.testcase(module.exports).exec();