/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2010, Ajax.org B.V.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

define(["require","exports","module"],function(g,f){var c=function(a,b,c,d){this.start={row:a,column:b};this.end={row:c,column:d}};(function(){this.isEqual=function(a){return this.start.row===a.start.row&&this.end.row===a.end.row&&this.start.column===a.start.column&&this.end.column===a.end.column};this.toString=function(){return"Range: ["+this.start.row+"/"+this.start.column+"] -> ["+this.end.row+"/"+this.end.column+"]"};this.contains=function(a,b){return 0==this.compare(a,b)};this.compareRange=function(a){var b;
b=a.end;a=a.start;b=this.compare(b.row,b.column);if(1==b)return b=this.compare(a.row,a.column),1==b?2:0==b?1:0;if(-1==b)return-2;b=this.compare(a.row,a.column);return-1==b?-1:1==b?42:0};this.comparePoint=function(a){return this.compare(a.row,a.column)};this.containsRange=function(a){return 0==this.comparePoint(a.start)&&0==this.comparePoint(a.end)};this.intersects=function(a){a=this.compareRange(a);return-1==a||0==a||1==a};this.isEnd=function(a,b){return this.end.row==a&&this.end.column==b};this.isStart=
function(a,b){return this.start.row==a&&this.start.column==b};this.setStart=function(a,b){"object"==typeof a?(this.start.column=a.column,this.start.row=a.row):(this.start.row=a,this.start.column=b)};this.setEnd=function(a,b){"object"==typeof a?(this.end.column=a.column,this.end.row=a.row):(this.end.row=a,this.end.column=b)};this.inside=function(a,b){return 0==this.compare(a,b)&&!this.isEnd(a,b)&&!this.isStart(a,b)?!0:!1};this.insideStart=function(a,b){return 0==this.compare(a,b)&&!this.isEnd(a,b)?
!0:!1};this.insideEnd=function(a,b){return 0==this.compare(a,b)&&!this.isStart(a,b)?!0:!1};this.compare=function(a,b){return!this.isMultiLine()&&a===this.start.row?b<this.start.column?-1:b>this.end.column?1:0:a<this.start.row?-1:a>this.end.row?1:this.start.row===a?b>=this.start.column?0:-1:this.end.row===a?b<=this.end.column?0:1:0};this.compareStart=function(a,b){return this.start.row==a&&this.start.column==b?-1:this.compare(a,b)};this.compareEnd=function(a,b){return this.end.row==a&&this.end.column==
b?1:this.compare(a,b)};this.compareInside=function(a,b){return this.end.row==a&&this.end.column==b?1:this.start.row==a&&this.start.column==b?-1:this.compare(a,b)};this.clipRows=function(a,b){if(this.end.row>b)var e={row:b+1,column:0};else this.end.row<a&&(e={row:a,column:0});if(this.start.row>b)var d={row:b+1,column:0};else this.start.row<a&&(d={row:a,column:0});return c.fromPoints(d||this.start,e||this.end)};this.extend=function(a,b){var e=this.compare(a,b);if(0==e)return this;if(-1==e)var d={row:a,
column:b};else var f={row:a,column:b};return c.fromPoints(d||this.start,f||this.end)};this.isEmpty=function(){return this.start.row===this.end.row&&this.start.column===this.end.column};this.isMultiLine=function(){return this.start.row!==this.end.row};this.clone=function(){return c.fromPoints(this.start,this.end)};this.collapseRows=function(){return 0==this.end.column?new c(this.start.row,0,Math.max(this.start.row,this.end.row-1),0):new c(this.start.row,0,this.end.row,0)};this.toScreenRange=function(a){var b=
a.documentToScreenPosition(this.start),a=a.documentToScreenPosition(this.end);return new c(b.row,b.column,a.row,a.column)};this.moveBy=function(a,b){this.start.row+=a;this.start.column+=b;this.end.row+=a;this.end.column+=b}}).call(c.prototype);c.fromPoints=function(a,b){return new c(a.row,a.column,b.row,b.column)};c.comparePoints=function(a,b){return a.row-b.row||a.column-b.column};c.comparePoints=function(a,b){return a.row-b.row||a.column-b.column};f.Range=c});