/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2010, Ajax.org B.V.
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

"undefined"!==typeof process&&require("amd-loader");
define("require exports module ./range ./edit_session ./test/assertions".split(" "),function(e,h,f){var c=e("./range").Range,g=e("./edit_session").EditSession,b=e("./test/assertions");f.exports={name:"ACE range.js","test: create range":function(){var a=new c(1,2,3,4);b.equal(a.start.row,1);b.equal(a.start.column,2);b.equal(a.end.row,3);b.equal(a.end.column,4)},"test: create from points":function(){var a=c.fromPoints({row:1,column:2},{row:3,column:4});b.equal(a.start.row,1);b.equal(a.start.column,
2);b.equal(a.end.row,3);b.equal(a.end.column,4)},"test: clip to rows":function(){b.range((new c(0,20,100,30)).clipRows(10,30),10,0,31,0);b.range((new c(0,20,30,10)).clipRows(10,30),10,0,30,10);var a=new c(0,20,3,10),a=a.clipRows(10,30);b.ok(a.isEmpty());b.range(a,10,0,10,0)},"test: isEmpty":function(){var a=new c(1,2,1,2);b.ok(a.isEmpty());a=new c(1,2,1,6);b.notOk(a.isEmpty())},"test: is multi line":function(){var a=new c(1,2,1,6);b.notOk(a.isMultiLine());a=new c(1,2,2,6);b.ok(a.isMultiLine())},"test: clone":function(){var a=
new c(1,2,3,4),d=a.clone();b.position(d.start,1,2);b.position(d.end,3,4);d.start.column=20;b.position(a.start,1,2);d.end.column=20;b.position(a.end,3,4)},"test: contains for multi line ranges":function(){var a=new c(1,10,5,20);b.ok(a.contains(1,10));b.ok(a.contains(2,0));b.ok(a.contains(3,100));b.ok(a.contains(5,19));b.ok(a.contains(5,20));b.notOk(a.contains(1,9));b.notOk(a.contains(0,0));b.notOk(a.contains(5,21))},"test: contains for single line ranges":function(){var a=new c(1,10,1,20);b.ok(a.contains(1,
10));b.ok(a.contains(1,15));b.ok(a.contains(1,20));b.notOk(a.contains(0,9));b.notOk(a.contains(2,9));b.notOk(a.contains(1,9));b.notOk(a.contains(1,21))},"test: extend range":function(){var a=new c(2,10,2,30),a=a.extend(2,5);b.range(a,2,5,2,30);a=a.extend(2,35);b.range(a,2,5,2,35);a=a.extend(2,15);b.range(a,2,5,2,35);a=a.extend(1,4);b.range(a,1,4,2,35);a=a.extend(6,10);b.range(a,1,4,6,10)},"test: collapse rows":function(){var a=new c(0,2,1,2);b.range(a.collapseRows(),0,0,1,0);a=new c(2,2,3,1);b.range(a.collapseRows(),
2,0,3,0);a=new c(2,2,3,0);b.range(a.collapseRows(),2,0,2,0);a=new c(2,0,2,0);b.range(a.collapseRows(),2,0,2,0)},"test: to screen range":function(){var a=new g(["juhu","12\t\t34","\u3041\u3041a","\t\t34"]),d=new c(0,0,0,3);b.range(d.toScreenRange(a),0,0,0,3);d=new c(1,1,1,3);b.range(d.toScreenRange(a),1,1,1,4);d=new c(2,1,2,2);b.range(d.toScreenRange(a),2,2,2,4);d=new c(3,0,3,4);b.range(d.toScreenRange(a),3,0,3,10)}}});"undefined"!==typeof module&&module===require.main&&require("asyncjs").test.testcase(module.exports).exec();