/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2010, Ajax.org B.V.
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

define("require exports module ./lib/lang ./lib/oop ./range".split(" "),function(m,q){var k=m("./lib/lang"),r=m("./lib/oop"),l=m("./range").Range,n=function(){this.$options={}};(function(){this.set=function(a){r.mixin(this.$options,a);return this};this.getOptions=function(){return k.copyObject(this.$options)};this.setOptions=function(a){this.$options=a};this.find=function(a){var b=this.$options,a=this.$matchIterator(a,b);if(!a)return!1;var d=null;a.forEach(function(a,c,e){if(a.start)d=a;else if(e=
a.offset+(e||0),d=new l(c,e,c,e+a.length),!a.length&&b.start&&b.start.start&&!1!=b.skipCurrent&&d.isEqual(b.start))return d=null,!1;return!0});return d};this.findAll=function(a){var b=this.$options;if(!b.needle)return[];this.$assembleRegExp(b);var d=b.range,f=d?a.getLines(d.start.row,d.end.row):a.doc.getAllLines(),a=[],c=b.re;if(b.$isMultiLine){var e=c.length,h=f.length-e,g,i=c.offset||0;a:for(;i<=h;i++){for(b=0;b<e;b++)if(-1==f[i+b].search(c[b]))continue a;var j=f[i],b=f[i+e-1],j=j.length-j.match(c[0])[0].length,
b=b.match(c[e-1])[0].length;if(!g||!(g.end.row===i&&g.end.column>j))a.push(g=new l(i,j,i+e-1,b)),2<e&&(i=i+e-2)}}else for(g=0;g<f.length;g++){e=k.getMatchOffsets(f[g],c);for(b=0;b<e.length;b++)h=e[b],a.push(new l(g,h.offset,g,h.offset+h.length))}if(d){c=f=d.start.column;g=0;for(b=a.length-1;g<b&&a[g].start.column<f&&a[g].start.row==d.start.row;)g++;for(;g<b&&a[b].end.column>c&&a[b].end.row==d.end.row;)b--;a=a.slice(g,b+1);g=0;for(b=a.length;g<b;g++)a[g].start.row+=d.start.row,a[g].end.row+=d.start.row}return a};
this.replace=function(a,b){var d=this.$options,f=this.$assembleRegExp(d);if(d.$isMultiLine)return b;if(f){var c=f.exec(a);if(!c||c[0].length!=a.length)return null;b=a.replace(f,b);if(d.preserveCase){b=b.split("");for(d=Math.min(a.length,a.length);d--;)f=a[d],b[d]=f&&f.toLowerCase()!=f?b[d].toUpperCase():b[d].toLowerCase();b=b.join("")}return b}};this.$matchIterator=function(a,b){var d=this.$assembleRegExp(b);if(!d)return!1;var f;if(b.$isMultiLine)var c=d.length,e=function(b,e,j){var p=b.search(d[0]);
if(-1!=p){for(var h=1;h<c;h++)if(b=a.getLine(e+h),-1==b.search(d[h]))return;b=b.match(d[c-1])[0].length;e=new l(e,p,e+c-1,b);1==d.offset?(e.start.row--,e.start.column=Number.MAX_VALUE):j&&(e.start.column+=j);if(f(e))return!0}};else e=b.backwards?function(a,b,e){for(var a=k.getMatchOffsets(a,d),c=a.length-1;0<=c;c--)if(f(a[c],b,e))return!0}:function(a,b,e){for(var a=k.getMatchOffsets(a,d),c=0;c<a.length;c++)if(f(a[c],b,e))return!0};var h=this.$lineIterator(a,b);return{forEach:function(a){f=a;h.forEach(e)}}};
this.$assembleRegExp=function(a,b){if(a.needle instanceof RegExp)return a.re=a.needle;var d=a.needle;if(!a.needle)return a.re=!1;a.regExp||(d=k.escapeRegExp(d));a.wholeWord&&(d="\\b"+d+"\\b");var f=a.caseSensitive?"gm":"gmi";a.$isMultiLine=!b&&/[\n\r]/.test(d);if(a.$isMultiLine)return a.re=this.$assembleMultilineRegExp(d,f);try{var c=RegExp(d,f)}catch(e){c=!1}return a.re=c};this.$assembleMultilineRegExp=function(a,b){for(var d=a.replace(/\r\n|\r|\n/g,"$\n^").split("\n"),f=[],c=0;c<d.length;c++)try{f.push(RegExp(d[c],
b))}catch(e){return!1}""==d[0]?(f.shift(),f.offset=1):f.offset=0;return f};this.$lineIterator=function(a,b){var d=!0==b.backwards,f=!1!=b.skipCurrent,c=b.range,e=b.start;e||(e=c?c[d?"end":"start"]:a.selection.getRange());e.start&&(e=e[f!=d?"end":"start"]);var h=c?c.start.row:0,g=c?c.end.row:a.getLength()-1;return{forEach:d?function(d){var c=e.row,f=a.getLine(c).substring(0,e.column);if(!d(f,c)){for(c--;c>=h;c--)if(d(a.getLine(c),c))return;if(!1!=b.wrap){c=g;for(h=e.row;c>=h&&!d(a.getLine(c),c);c--);
}}}:function(d){var c=e.row,f=a.getLine(c).substr(e.column);if(!d(f,c,e.column)){for(c+=1;c<=g;c++)if(d(a.getLine(c),c))return;if(!1!=b.wrap){c=h;for(g=e.row;c<=g&&!d(a.getLine(c),c);c++);}}}}}}).call(n.prototype);q.Search=n});