/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2010, Ajax.org B.V.
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

"undefined"!==typeof process&&require("amd-loader");
define("require exports module ./edit_session ./test/mockrenderer ./editor ./search ./test/assertions".split(" "),function(g,l,i){var e=g("./edit_session").EditSession,j=g("./test/mockrenderer").MockRenderer,k=g("./editor").Editor,d=g("./search").Search,b=g("./test/assertions");i.exports={"test: configure the search object":function(){(new d).set({needle:"juhu"})},"test: find simple text in document":function(){var a=new e(["juhu kinners 123","456"]),a=(new d).set({needle:"kinners"}).find(a);b.position(a.start,
0,5);b.position(a.end,0,12)},"test: find simple text in next line":function(){var a=new e(["abc","juhu kinners 123","456"]),a=(new d).set({needle:"kinners"}).find(a);b.position(a.start,1,5);b.position(a.end,1,12)},"test: find text starting at cursor position":function(){var a=new e(["juhu kinners","juhu kinners 123"]);a.getSelection().moveCursorTo(0,6);a=(new d).set({needle:"kinners"}).find(a);b.position(a.start,1,5);b.position(a.end,1,12)},"test: wrap search is on by default":function(){var a=new e(["abc",
"juhu kinners 123","456"]);a.getSelection().moveCursorTo(2,1);var c=(new d).set({needle:"kinners"});b.notEqual(c.find(a),null)},"test: wrap search should wrap at file end":function(){var a=new e(["abc","juhu kinners 123","456"]);a.getSelection().moveCursorTo(2,1);a=(new d).set({needle:"kinners",wrap:!0}).find(a);b.position(a.start,1,5);b.position(a.end,1,12)},"test: wrap search should find needle even if it starts inside it":function(){var a=new e(["abc","juhu kinners 123","456"]);a.getSelection().moveCursorTo(6,
1);a=(new d).set({needle:"kinners",wrap:!0}).find(a);b.position(a.start,1,5);b.position(a.end,1,12)},"test: wrap search with no match should return 'null'":function(){var a=new e(["abc","juhu kinners 123","456"]);a.getSelection().moveCursorTo(2,1);var c=(new d).set({needle:"xyz",wrap:!0});b.equal(c.find(a),null)},"test: case sensitive is by default off":function(){var a=new e(["abc","juhu kinners 123","456"]),c=(new d).set({needle:"JUHU"});b.range(c.find(a),1,0,1,4)},"test: case sensitive search":function(){var a=
new e(["abc","juhu kinners 123","456"]),a=(new d).set({needle:"KINNERS",caseSensitive:!0}).find(a);b.equal(a,null)},"test: whole word search should not match inside of words":function(){var a=new e(["juhukinners","juhu kinners 123","456"]),a=(new d).set({needle:"kinners",wholeWord:!0}).find(a);b.position(a.start,1,5);b.position(a.end,1,12)},"test: find backwards":function(){var a=new e(["juhu juhu juhu juhu"]);a.getSelection().moveCursorTo(0,10);a=(new d).set({needle:"juhu",backwards:!0}).find(a);
b.position(a.start,0,5);b.position(a.end,0,9)},"test: find in selection":function(){var a=new e(["juhu","juhu","juhu","juhu"]);a.getSelection().setSelectionAnchor(1,0);a.getSelection().selectTo(3,5);var c=(new d).set({needle:"juhu",wrap:!0,range:a.getSelection().getRange()}),c=c.find(a);b.position(c.start,1,0);b.position(c.end,1,4);c=(new d).set({needle:"juhu",wrap:!0,range:a.getSelection().getRange()});a.getSelection().setSelectionAnchor(0,2);a.getSelection().selectTo(3,2);c=c.find(a);b.position(c.start,
1,0);b.position(c.end,1,4)},"test: find backwards in selection":function(){var a=new e(["juhu","juhu","juhu","juhu"]);a.getSelection().setSelectionAnchor(0,2);a.getSelection().selectTo(3,2);var c=(new d).set({needle:"juhu",wrap:!0,backwards:!0,range:a.getSelection().getRange()}),c=c.find(a);b.position(c.start,2,0);b.position(c.end,2,4);c=(new d).set({needle:"juhu",wrap:!0,range:a.getSelection().getRange()});a.getSelection().setSelectionAnchor(0,2);a.getSelection().selectTo(1,2);c=c.find(a);b.position(c.start,
1,0);b.position(c.end,1,4)},"test: edge case - match directly before the cursor":function(){var a=new e(["123","123","juhu"]),c=(new d).set({needle:"juhu",wrap:!0});a.getSelection().moveCursorTo(2,5);a=c.find(a);b.position(a.start,2,0);b.position(a.end,2,4)},"test: edge case - match backwards directly after the cursor":function(){var a=new e(["123","123","juhu"]),c=(new d).set({needle:"juhu",wrap:!0,backwards:!0});a.getSelection().moveCursorTo(2,0);a=c.find(a);b.position(a.start,2,0);b.position(a.end,
2,4)},"test: find using a regular expression":function(){var a=new e(["abc123 123 cd","abc"]),a=(new d).set({needle:"\\d+",regExp:!0}).find(a);b.position(a.start,0,3);b.position(a.end,0,6)},"test: find using a regular expression and whole word":function(){var a=new e(["abc123 123 cd","abc"]),a=(new d).set({needle:"\\d+\\b",regExp:!0,wholeWord:!0}).find(a);b.position(a.start,0,7);b.position(a.end,0,10)},"test: use regular expressions with capture groups":function(){var a=new e(["  ab: 12px","  <h1 abc"]),
a=(new d).set({needle:"(\\d+)",regExp:!0}).find(a);b.position(a.start,0,6);b.position(a.end,0,8)},"test: find all matches in selection":function(){var a=new e(["juhu","juhu","juhu","juhu"]);a.getSelection().setSelectionAnchor(0,2);a.getSelection().selectTo(3,2);a=(new d).set({needle:"uh",wrap:!0,range:a.getSelection().getRange()}).findAll(a);b.equal(a.length,2);b.position(a[0].start,1,1);b.position(a[0].end,1,3);b.position(a[1].start,2,1);b.position(a[1].end,2,3)},"test: find all multiline matches":function(){var a=
new e(["juhu","juhu","juhu","juhu"]),a=(new d).set({needle:"hu\nju",wrap:!0}).findAll(a);b.equal(a.length,3);b.position(a[0].start,0,2);b.position(a[0].end,1,2);b.position(a[1].start,1,2);b.position(a[1].end,2,2)},"test: replace() should return the replacement if the input matches the needle":function(){var a=(new d).set({needle:"juhu"});b.equal(a.replace("juhu","kinners"),"kinners");b.equal(a.replace("","kinners"),null);b.equal(a.replace(" juhu","kinners"),null);b.equal(a.replace("Juhu","kinners"),
"kinners");a.set({caseSensitive:!0});b.equal(a.replace("Juhu","kinners"),null)},"test: replace with a RegExp search":function(){var a=(new d).set({needle:"\\d+",regExp:!0});b.equal(a.replace("123","kinners"),"kinners");b.equal(a.replace("01234","kinners"),"kinners");b.equal(a.replace("","kinners"),null);b.equal(a.replace("a12","kinners"),null);b.equal(a.replace("12a","kinners"),null)},"test: replace with RegExp match and capture groups":function(){var a=(new d).set({needle:"ab(\\d\\d)",regExp:!0});
b.equal(a.replace("ab12","cd$1"),"cd12");b.equal(a.replace("ab12","-$&-"),"-ab12-");b.equal(a.replace("ab12","$$"),"$")},"test: find all using regular expresion containing $":function(){var a=new e(["a","     b","c ","d"]),c=(new d).set({needle:"[ ]+$",regExp:!0,wrap:!0});a.getSelection().moveCursorTo(1,2);a=c.findAll(a);b.equal(a.length,1);b.position(a[0].start,2,1);b.position(a[0].end,2,2)},"test: find all matches in a line":function(){var a=new e("foo bar foo baz foobar foo"),c=(new d).set({needle:"foo",
wrap:!0,wholeWord:!0});a.getSelection().moveCursorTo(0,4);a=c.findAll(a);b.equal(a.length,3);b.position(a[0].start,0,0);b.position(a[0].end,0,3);b.position(a[1].start,0,8);b.position(a[1].end,0,11);b.position(a[2].start,0,23);b.position(a[2].end,0,26)},"test: find all matches in a line backwards":function(){var a=new e("foo bar foo baz foobar foo"),c=(new d).set({needle:"foo",wrap:!0,wholeWord:!0,backwards:!0});a.getSelection().moveCursorTo(0,13);a=c.findAll(a);b.equal(a.length,3);b.position(a[2].start,
0,23);b.position(a[2].end,0,26);b.position(a[1].start,0,8);b.position(a[1].end,0,11);b.position(a[0].start,0,0);b.position(a[0].end,0,3)},"test: find next empty range":function(){var a=new e("foo foobar foo"),c=new k(new j,a),d={needle:"o*",wrap:!0,regExp:!0,backwards:!1},g=[4,5.2,7,8,9,10,11,12.2,14,0,1.2,3];a.selection.moveCursorTo(0,3);for(a=0;12>a;a++){c.find(d);var f=c.selection.getRange(),h=f.start.column,f=f.end.column-h;b.equal(h+0.1*f,g[a])}d.backwards=!0;for(a=0;16>a;a++)c.find(d),f=c.selection.getRange(),
h=f.start.column,f=f.end.column-h,console.log(h+0.1*f)}}});"undefined"!==typeof module&&module===require.main&&require("asyncjs").test.testcase(module.exports).exec();