/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2010, Ajax.org B.V.
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

"undefined"!==typeof process&&require("amd-loader");
define(["require","exports","module","./edit_session","./test/assertions"],function(f,h,g){var d=f("./edit_session").EditSession,c=f("./test/assertions");g.exports={createSession:function(a,b){var c=Array(b+1).join("a"),c=Array(a).join(c+"\n")+c;return new d(c)},"test: move cursor to end of file should place the cursor on last row and column":function(){var a=this.createSession(200,10).getSelection();a.moveCursorFileEnd();c.position(a.getCursor(),199,10)},"test: moveCursor to start of file should place the cursor on the first row and column":function(){var a=
this.createSession(200,10).getSelection();a.moveCursorFileStart();c.position(a.getCursor(),0,0)},"test: move selection lead to end of file":function(){var a=this.createSession(200,10).getSelection();a.moveCursorTo(100,5);a.selectFileEnd();a=a.getRange();c.position(a.start,100,5);c.position(a.end,199,10)},"test: move selection lead to start of file":function(){var a=this.createSession(200,10).getSelection();a.moveCursorTo(100,5);a.selectFileStart();a=a.getRange();c.position(a.start,0,0);c.position(a.end,
100,5)},"test: move cursor word right":function(){var a=new d("ab\n Juhu Kinners (abc, 12)\n cde"),b=a.getSelection();a.$selectLongWords=!0;b.moveCursorDown();c.position(b.getCursor(),1,0);b.moveCursorWordRight();c.position(b.getCursor(),1,5);b.moveCursorWordRight();c.position(b.getCursor(),1,13);b.moveCursorWordRight();c.position(b.getCursor(),1,18);b.moveCursorWordRight();c.position(b.getCursor(),1,22);b.moveCursorWordRight();c.position(b.getCursor(),2,4);b.moveCursorWordRight();c.position(b.getCursor(),
2,4)},"test: select word right if cursor in word":function(){var a=(new d("Juhu Kinners")).getSelection();a.moveCursorTo(0,2);a.moveCursorWordRight();c.position(a.getCursor(),0,4)},"test: moveCursor word left":function(){var a=new d("ab\n Juhu Kinners (abc, 12)\n cde"),b=a.getSelection();a.$selectLongWords=!0;b.moveCursorDown();b.moveCursorLineEnd();c.position(b.getCursor(),1,23);b.moveCursorWordLeft();c.position(b.getCursor(),1,20);b.moveCursorWordLeft();c.position(b.getCursor(),1,15);b.moveCursorWordLeft();
c.position(b.getCursor(),1,6);b.moveCursorWordLeft();c.position(b.getCursor(),1,1);b.moveCursorWordLeft();c.position(b.getCursor(),0,0);b.moveCursorWordLeft();c.position(b.getCursor(),0,0)},"test: moveCursor word left with umlauts":function(){var a=new d(" Fu\u00df F\u00fc\u00dfe");a.$selectLongWords=!0;a=a.getSelection();a.moveCursorTo(0,9);a.moveCursorWordLeft();c.position(a.getCursor(),0,5);a.moveCursorWordLeft();c.position(a.getCursor(),0,1)},"test: select word left if cursor in word":function(){var a=
new d("Juhu Kinners"),b=a.getSelection();a.$selectLongWords=!0;b.moveCursorTo(0,8);b.moveCursorWordLeft();c.position(b.getCursor(),0,5)},"test: select word right and select":function(){var a=(new d("Juhu Kinners")).getSelection();a.moveCursorTo(0,0);a.selectWordRight();a=a.getRange();c.position(a.start,0,0);c.position(a.end,0,4)},"test: select word left and select":function(){var a=(new d("Juhu Kinners")).getSelection();a.moveCursorTo(0,3);a.selectWordLeft();a=a.getRange();c.position(a.start,0,0);
c.position(a.end,0,3)},"test: select word with cursor in word should select the word":function(){var a=(new d("Juhu Kinners 123")).getSelection();a.moveCursorTo(0,8);a.selectWord();a=a.getRange();c.position(a.start,0,5);c.position(a.end,0,12)},"test: select word with cursor in word including right whitespace should select the word":function(){var a=(new d("Juhu Kinners      123")).getSelection();a.moveCursorTo(0,8);a.selectAWord();a=a.getRange();c.position(a.start,0,5);c.position(a.end,0,18)},"test: select word with cursor betwen white space and word should select the word":function(){var a=
new d("Juhu Kinners"),b=a.getSelection();a.$selectLongWords=!0;b.moveCursorTo(0,4);b.selectWord();a=b.getRange();c.position(a.start,0,0);c.position(a.end,0,4);b.moveCursorTo(0,5);b.selectWord();a=b.getRange();c.position(a.start,0,5);c.position(a.end,0,12)},"test: select word with cursor in white space should select white space":function(){var a=new d("Juhu  Kinners"),b=a.getSelection();a.$selectLongWords=!0;b.moveCursorTo(0,5);b.selectWord();a=b.getRange();c.position(a.start,0,4);c.position(a.end,
0,6)},"test: moving cursor should fire a 'changeCursor' event":function(){var a=new d("Juhu  Kinners"),b=a.getSelection();a.$selectLongWords=!0;b.moveCursorTo(0,5);var e=!1;b.addEventListener("changeCursor",function(){e=!0});b.moveCursorTo(0,6);c.ok(e)},"test: calling setCursor with the same position should not fire an event":function(){var a=new d("Juhu  Kinners"),b=a.getSelection();a.$selectLongWords=!0;b.moveCursorTo(0,5);var e=!1;b.addEventListener("changeCursor",function(){e=!0});b.moveCursorTo(0,
5);c.notOk(e)},"test: moveWordright should move past || and [":function(){var a=new d("||foo["),b=a.getSelection();a.$selectLongWords=!0;b.moveCursorWordRight();c.position(b.getCursor(),0,5);b.moveCursorWordRight();c.position(b.getCursor(),0,6)},"test: moveWordLeft should move past || and [":function(){var a=new d("||foo["),b=a.getSelection();a.$selectLongWords=!0;b.moveCursorTo(0,6);b.moveCursorWordLeft();c.position(b.getCursor(),0,2);b.moveCursorWordLeft();c.position(b.getCursor(),0,0)},"test: move cursor to line start should move cursor to end of the indentation first":function(){var a=
(new d("12\n    Juhu\n12")).getSelection();a.moveCursorTo(1,6);a.moveCursorLineStart();c.position(a.getCursor(),1,4)},"test: move cursor to line start when the cursor is at the end of the indentation should move cursor to column 0":function(){var a=(new d("12\n    Juhu\n12")).getSelection();a.moveCursorTo(1,4);a.moveCursorLineStart();c.position(a.getCursor(),1,0)},"test: move cursor to line start when the cursor is at column 0 should move cursor to the end of the indentation":function(){var a=(new d("12\n    Juhu\n12")).getSelection();
a.moveCursorTo(1,0);a.moveCursorLineStart();c.position(a.getCursor(),1,4)},"test: move cursor to line start when the cursor is before the initial indentation should move cursor to the end of the indentation":function(){var a=(new d("12\n    Juhu\n12")).getSelection();a.moveCursorTo(1,2);a.moveCursorLineStart();c.position(a.getCursor(),1,4)},"test go line up when in the middle of the first line should go to document start":function(){var a=(new d("juhu kinners")).getSelection();a.moveCursorTo(0,4);
a.moveCursorUp();c.position(a.getCursor(),0,0)},"test: (wrap) go line up when in the middle of the first line should go to document start":function(){var a=new d("juhu kinners");a.setWrapLimitRange(5,5);a.adjustWrapLimit(80);a=a.getSelection();a.moveCursorTo(0,4);a.moveCursorUp();c.position(a.getCursor(),0,0)},"test go line down when in the middle of the last line should go to document end":function(){var a=(new d("juhu kinners")).getSelection();a.moveCursorTo(0,4);a.moveCursorDown();c.position(a.getCursor(),
0,12)},"test (wrap) go line down when in the middle of the last line should go to document end":function(){var a=new d("juhu kinners");a.setWrapLimitRange(8,8);a.adjustWrapLimit(80);a=a.getSelection();a.moveCursorTo(0,10);a.moveCursorDown();c.position(a.getCursor(),0,12)},"test go line up twice and then once down when in the second should go back to the previous column":function(){var a=(new d("juhu\nkinners")).getSelection();a.moveCursorTo(1,4);a.moveCursorUp();a.moveCursorUp();a.moveCursorDown();
c.position(a.getCursor(),1,4)},"test (keyboard navigation) when curLine is not EOL and targetLine is all whitespace new column should be current column":function(){var a=(new d("function (a) {\n    \n}")).getSelection();a.moveCursorTo(2,0);a.moveCursorUp();c.position(a.getCursor(),1,0)},"test (keyboard navigation) when curLine is EOL and targetLine is shorter than current column, new column should be targetLine's EOL":function(){var a=(new d("function (a) {\n    \n}")).getSelection();a.moveCursorTo(0,
14);a.moveCursorDown();c.position(a.getCursor(),1,4)},"test fromJSON/toJSON":function(){var a=(new d("function (a) {\n    \n}")).getSelection();a.moveCursorTo(0,14);a.moveCursorDown();c.position(a.getCursor(),1,4);var b=a.toJSON(),b=JSON.parse(JSON.stringify(b));a.moveCursorDown();c.position(a.getCursor(),2,1);c.ok(!a.isEqual(b));a.fromJSON(b);c.position(a.getCursor(),1,4);c.ok(a.isEqual(b))}}});"undefined"!==typeof module&&module===require.main&&require("asyncjs").test.testcase(module.exports).exec();