/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2010, Ajax.org B.V.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

define("require exports module ./lib/oop ./lib/event_emitter ./lib/lang ./range ./anchor ./keyboard/hash_handler ./tokenizer ./lib/dom ./editor".split(" "),function(j,p){var y=j("./lib/oop"),z=j("./lib/event_emitter").EventEmitter,v=j("./lib/lang"),q=j("./range").Range;j("./anchor");var A=j("./keyboard/hash_handler").HashHandler,B=j("./tokenizer").Tokenizer,r=q.comparePoints,n=function(){this.snippetMap={};this.snippetNameMap={}};(function(){y.implement(this,z);this.getTokenizer=function(){function a(a,
b,d){a=a.substr(1);return/^\d+$/.test(a)&&!d.inFormatString?[{tabstopId:parseInt(a,10)}]:[{text:a}]}function b(a){return"(?:[^\\\\"+a+"]|\\\\.)"}n.$tokenizer=new B({start:[{regex:/:/,onMatch:function(a,b,d){return d.length&&d[0].expectIf?(d[0].expectIf=!1,d[0].elseBranch=d[0],[d[0]]):":"}},{regex:/\\./,onMatch:function(a,b,d){b=a[1];"}"==b&&d.length?a=b:-1!="`$\\".indexOf(b)?a=b:d.inFormatString&&("n"==b?a="\n":"t"==b?a="\n":-1!="ulULE".indexOf(b)&&(a={changeCase:b,local:"a"<b}));return[a]}},{regex:/}/,
onMatch:function(a,b,d){return[d.length?d.shift():a]}},{regex:/\$(?:\d+|\w+)/,onMatch:a},{regex:/\$\{[\dA-Z_a-z]+/,onMatch:function(b,e,d){b=a(b.substr(1),e,d);d.unshift(b[0]);return b},next:"snippetVar"},{regex:/\n/,token:"newline",merge:!1}],snippetVar:[{regex:"\\|"+b("\\|")+"*\\|",onMatch:function(a,b,d){d[0].choices=a.slice(1,-1).split(",")},next:"start"},{regex:"/("+b("/")+"+)/(?:("+b("/")+"*)/)(\\w*):?",onMatch:function(a,b,d){b=d[0];b.fmtString=a;a=this.splitRegex.exec(a);b.guard=a[1];b.fmt=
a[2];b.flag=a[3];return""},next:"start"},{regex:"`"+b("`")+"*`",onMatch:function(a,b,d){d[0].code=a.splice(1,-1);return""},next:"start"},{regex:"\\?",onMatch:function(a,b,d){d[0]&&(d[0].expectIf=!0)},next:"start"},{regex:"([^:}\\\\]|\\\\.)*:?",token:"",next:"start"}],formatString:[{regex:"/("+b("/")+"+)/",token:"regex"},{regex:"",onMatch:function(a,b,d){d.inFormatString=!0},next:"start"}]});n.prototype.getTokenizer=function(){return n.$tokenizer};return n.$tokenizer};this.tokenizeTmSnippet=function(a,
b){return this.getTokenizer().getLineTokens(a,b).tokens.map(function(a){return a.value||a})};this.$getDefaultValue=function(a,b){if(/^[A-Z]\d+$/.test(b)){var c=b.substr(1);return(this.variables[b[0]+"__"]||{})[c]}if(/^\d+$/.test(b))return(this.variables.__||{})[b];b=b.replace(/^TM_/,"");if(a)switch(c=a.session,b){case "CURRENT_WORD":var e=c.getWordRange();case "SELECTION":case "SELECTED_TEXT":return c.getTextRange(e);case "CURRENT_LINE":return c.getLine(a.getCursorPosition().row);case "PREV_LINE":return c.getLine(a.getCursorPosition().row-
1);case "LINE_INDEX":return a.getCursorPosition().column;case "LINE_NUMBER":return a.getCursorPosition().row+1;case "SOFT_TABS":return c.getUseSoftTabs()?"YES":"NO";case "TAB_SIZE":return c.getTabSize();case "FILENAME":case "FILEPATH":return"";case "FULLNAME":return"Ace"}};this.variables={};this.getVariableValue=function(a,b){return this.variables.hasOwnProperty(b)?this.variables[b](a,b)||"":this.$getDefaultValue(a,b)||""};this.tmStrFormat=function(a,b,c){var e=b.guard,e=RegExp(e,(b.flag||"").replace(/[^gi]/,
"")),d=this.tokenizeTmSnippet(b.fmt,"formatString"),f=this,a=a.replace(e,function(){f.variables.__=arguments;for(var a=f.resolveVariables(d,c),b="E",g=0;g<a.length;g++){var e=a[g];if("object"==typeof e)if(a[g]="",e.changeCase&&e.local){var k=a[g+1];k&&"string"==typeof k&&(a[g]="u"==e.changeCase?k[0].toUpperCase():k[0].toLowerCase(),a[g+1]=k.substr(1))}else e.changeCase&&(b=e.changeCase);else"U"==b?a[g]=e.toUpperCase():"L"==b&&(a[g]=e.toLowerCase())}return a.join("")});this.variables.__=null;return a};
this.resolveVariables=function(a,b){function c(b){b=a.indexOf(b,d+1);-1!=b&&(d=b)}for(var e=[],d=0;d<a.length;d++){var f=a[d];if("string"==typeof f)e.push(f);else if("object"==typeof f)if(f.skip)c(f);else if(!(f.processed<d))if(f.text){var h=this.getVariableValue(b,f.text);h&&f.fmtString&&(h=this.tmStrFormat(h,f));f.processed=d;null==f.expectIf?h&&(e.push(h),c(f)):h?f.skip=f.elseBranch:c(f)}else null!=f.tabstopId?e.push(f):null!=f.changeCase&&e.push(f)}return e};this.insertSnippetForSelection=function(a,
b){var c=a.getCursorPosition(),e=a.session.getLine(c.row),d=a.session.getTabString(),f=e.match(/^\s*/)[0];c.column<f.length&&(f=f.slice(0,c.column));var b=b.replace(/\r/g,""),h=this.tokenizeTmSnippet(b),h=this.resolveVariables(h,a),h=h.map(function(a){return"\n"==a?a+f:"string"==typeof a?a.replace(/\t/g,d):a}),i=[];h.forEach(function(a,b){if("object"==typeof a){var c=a.tabstopId,d=i[c];d||(d=i[c]=[],d.index=c,d.value="");if(-1===d.indexOf(a)&&(d.push(a),c=h.indexOf(a,b+1),-1!==c))if(c=h.slice(b+1,
c),c.some(function(a){return"object"===typeof a})&&!d.value)d.value=c;else if(c.length&&(!d.value||"string"!==typeof d.value))d.value=c.join("")}});i.forEach(function(a){a.length=0});c={};for(e=0;e<h.length;e++){var g=h[e];if("object"==typeof g){var s=g.tabstopId,k=h.indexOf(g,e+1);if(c[s])c[s]===g&&(c[s]=null);else{var l=i[s],m;if("string"==typeof l.value)m=[l.value];else{m=l.value;for(var j=[],p=0;p<m.length;p++){var n=m[p];if("object"==typeof n){if(c[n.tabstopId])continue;var r=m.lastIndexOf(n,
p-1),n=j[r]||{tabstopId:n.tabstopId}}j[p]=n}m=j}m.unshift(e+1,Math.max(0,k-e));m.push(g);c[s]=g;h.splice.apply(h,m);-1===l.indexOf(g)&&l.push(g)}}}var u=0,t=0,q="";h.forEach(function(a){if("string"===typeof a){var b=a.split("\n");1<b.length?(t=b[b.length-1].length,u+=b.length-1):t+=a.length;q+=a}else a.start?a.end={row:u,column:t}:a.start={row:u,column:t}});c=a.getSelectionRange();e=a.session.replace(c,q);(new w(a)).addTabstops(i,c.start,e,a.inVirtualSelectionMode&&a.selection.index)};this.insertSnippet=
function(a,b){var c=this;if(a.inVirtualSelectionMode)return c.insertSnippetForSelection(a,b);a.forEachSelection(function(){c.insertSnippetForSelection(a,b)},null,{keepOrder:!0});a.tabstopManager&&a.tabstopManager.tabNext()};this.$getScope=function(a){var b=a.session.$mode.$id||"",b=b.split("/").pop();if("html"===b||"php"===b){"php"===b&&!a.session.$mode.inlinePhp&&(b="html");var c=a.getCursorPosition(),a=a.session.getState(c.row);"object"===typeof a&&(a=a[0]);a.substring&&("js-"==a.substring(0,3)?
b="javascript":"css-"==a.substring(0,4)?b="css":"php-"==a.substring(0,4)&&(b="php"))}return b};this.getActiveScopes=function(a){var a=this.$getScope(a),b=[a],c=this.snippetMap;c[a]&&c[a].includeScopes&&b.push.apply(b,c[a].includeScopes);b.push("_");return b};this.expandWithTab=function(a,b){var c=this,e=a.forEachSelection(function(){return c.expandSnippetForSelection(a,b)},null,{keepOrder:!0});e&&a.tabstopManager&&a.tabstopManager.tabNext();return e};this.expandSnippetForSelection=function(a,b){var c=
a.getCursorPosition(),e=a.session.getLine(c.row),d=e.substring(0,c.column),f=e.substr(c.column),h=this.snippetMap,i;this.getActiveScopes(a).some(function(a){(a=h[a])&&(i=this.findMatchingSnippet(a,d,f));return!!i},this);if(!i)return!1;if(b&&b.dryRun)return!0;a.session.doc.removeInLine(c.row,c.column-i.replaceBefore.length,c.column+i.replaceAfter.length);this.variables.M__=i.matchBefore;this.variables.T__=i.matchAfter;this.insertSnippetForSelection(a,i.content);this.variables.M__=this.variables.T__=
null;return!0};this.findMatchingSnippet=function(a,b,c){for(var e=a.length;e--;){var d=a[e];if(!d.startRe||d.startRe.test(b))if(!d.endRe||d.endRe.test(c))if(d.startRe||d.endRe)return d.matchBefore=d.startRe?d.startRe.exec(b):[""],d.matchAfter=d.endRe?d.endRe.exec(c):[""],d.replaceBefore=d.triggerRe?d.triggerRe.exec(b)[0]:"",d.replaceAfter=d.endTriggerRe?d.endTriggerRe.exec(c)[0]:"",d}};this.snippetMap={};this.snippetNameMap={};this.register=function(a,b){function c(a){a&&!/^\^?\(.*\)\$?$|^\\b$/.test(a)&&
(a="(?:"+a+")");return a||""}function e(a,b,d){a=c(a);b=c(b);d?(a=b+a)&&"$"!=a[a.length-1]&&(a+="$"):(a+=b)&&"^"!=a[0]&&(a="^"+a);return RegExp(a)}function d(a){a.scope||(a.scope=b||"_");b=a.scope;f[b]||(f[b]=[],h[b]={});var d=h[b];if(a.name){var c=d[a.name];c&&i.unregister(c);d[a.name]=a}f[b].push(a);a.tabTrigger&&!a.trigger&&(!a.guard&&/^\w/.test(a.tabTrigger)&&(a.guard="\\b"),a.trigger=v.escapeRegExp(a.tabTrigger));if(a.trigger||a.guard||a.endTrigger||a.endGuard)a.startRe=e(a.trigger,a.guard,!0),
a.triggerRe=RegExp(a.trigger,"",!0),a.endRe=e(a.endTrigger,a.endGuard,!0),a.endTriggerRe=RegExp(a.endTrigger,"",!0)}var f=this.snippetMap,h=this.snippetNameMap,i=this;a||(a=[]);a&&a.content?d(a):Array.isArray(a)&&a.forEach(d);this._signal("registerSnippets",{scope:b})};this.unregister=function(a,b){function c(a){var c=d[a.scope||b];c&&c[a.name]&&(delete c[a.name],a=(c=e[a.scope||b])&&c.indexOf(a),0<=a&&c.splice(a,1))}var e=this.snippetMap,d=this.snippetNameMap;a.content?c(a):Array.isArray(a)&&a.forEach(c)};
this.parseSnippetFile=function(a){for(var a=a.replace(/\r/g,""),b=[],c={},e=/^#.*|^({[\s\S]*})\s*$|^(\S+) (.*)$|^((?:\n*\t.*)+)/gm,d;d=e.exec(a);){if(d[1])try{c=JSON.parse(d[1]),b.push(c)}catch(f){}if(d[4])c.content=d[4].replace(/^\t/gm,""),b.push(c),c={};else{var h=d[2];d=d[3];"regex"==h?(h=/\/((?:[^\/\\]|\\.)*)|$/g,c.guard=h.exec(d)[1],c.trigger=h.exec(d)[1],c.endTrigger=h.exec(d)[1],c.endGuard=h.exec(d)[1]):"snippet"==h?(c.tabTrigger=d.match(/^\S*/)[0],c.name||(c.name=d)):c[h]=d}}return b};this.getSnippetByName=
function(a,b){var c=this.snippetNameMap,e;this.getActiveScopes(b).some(function(b){(b=c[b])&&(e=b[a]);return!!e},this);return e}}).call(n.prototype);var w=function(a){if(a.tabstopManager)return a.tabstopManager;a.tabstopManager=this;this.$onChange=this.onChange.bind(this);this.$onChangeSelection=v.delayedCall(this.onChangeSelection.bind(this)).schedule;this.$onChangeSession=this.onChangeSession.bind(this);this.$onAfterExec=this.onAfterExec.bind(this);this.attach(a)};(function(){this.attach=function(a){this.index=
0;this.ranges=[];this.tabstops=[];this.selectedTabstop=this.$openTabstops=null;this.editor=a;this.editor.on("change",this.$onChange);this.editor.on("changeSelection",this.$onChangeSelection);this.editor.on("changeSession",this.$onChangeSession);this.editor.commands.on("afterExec",this.$onAfterExec);this.editor.keyBinding.addKeyboardHandler(this.keyboardHandler)};this.detach=function(){this.tabstops.forEach(this.removeTabstopMarkers,this);this.selectedTabstop=this.tabstops=this.ranges=null;this.editor.removeListener("change",
this.$onChange);this.editor.removeListener("changeSelection",this.$onChangeSelection);this.editor.removeListener("changeSession",this.$onChangeSession);this.editor.commands.removeListener("afterExec",this.$onAfterExec);this.editor.keyBinding.removeKeyboardHandler(this.keyboardHandler);this.editor=this.editor.tabstopManager=null};this.onChange=function(a){var b="r"==a.action[0],c=a.start,e=a.end,a=c.row,d=e.row-a,f=e.column-c.column;b&&(d=-d,f=-f);if(!this.$inChange&&b){var h=this.selectedTabstop;
if(h&&!h.some(function(a){return 0>=r(a.start,c)&&0<=r(a.end,e)}))return this.detach()}for(var h=this.ranges,i=0;i<h.length;i++){var g=h[i];g.end.row<c.row||(b&&0>r(c,g.start)&&0<r(e,g.end)?(this.removeRange(g),i--):(g.start.row==a&&g.start.column>c.column&&(g.start.column+=f),g.end.row==a&&g.end.column>=c.column&&(g.end.column+=f),g.start.row>=a&&(g.start.row+=d),g.end.row>=a&&(g.end.row+=d),0<r(g.start,g.end)&&this.removeRange(g)))}h.length||this.detach()};this.updateLinkedFields=function(){var a=
this.selectedTabstop;if(a&&a.hasLinkedRanges){this.$inChange=!0;for(var b=this.editor.session,c=b.getTextRange(a.firstNonLinked),e=a.length;e--;){var d=a[e];if(d.linked){var f=p.snippetManager.tmStrFormat(c,d.original);b.replace(d,f)}}this.$inChange=!1}};this.onAfterExec=function(a){a.command&&!a.command.readOnly&&this.updateLinkedFields()};this.onChangeSelection=function(){if(this.editor){for(var a=this.editor.selection.lead,b=this.editor.selection.anchor,c=this.editor.selection.isEmpty(),e=this.ranges.length;e--;)if(!this.ranges[e].linked){var d=
this.ranges[e].contains(a.row,a.column),f=c||this.ranges[e].contains(b.row,b.column);if(d&&f)return}this.detach()}};this.onChangeSession=function(){this.detach()};this.tabNext=function(a){var b=this.tabstops.length,a=this.index+(a||1),a=Math.min(Math.max(a,1),b);a==b&&(a=0);this.selectTabstop(a);0===a&&this.detach()};this.selectTabstop=function(a){this.$openTabstops=null;var b=this.tabstops[this.index];b&&this.addTabstopMarkers(b);this.index=a;if((b=this.tabstops[this.index])&&b.length){this.selectedTabstop=
b;if(this.editor.inVirtualSelectionMode)this.editor.selection.setRange(b.firstNonLinked);else{a=this.editor.multiSelect;a.toSingleRange(b.firstNonLinked.clone());for(var c=b.length;c--;)(!b.hasLinkedRanges||!b[c].linked)&&a.addRange(b[c].clone(),!0);a.ranges[0]&&a.addRange(a.ranges[0].clone())}this.editor.keyBinding.addKeyboardHandler(this.keyboardHandler)}};this.addTabstops=function(a,b,c){this.$openTabstops||(this.$openTabstops=[]);a[0]||(c=q.fromPoints(c,c),x(c.start,b),x(c.end,b),a[0]=[c],a[0].index=
0);var e=[this.index+1,0],d=this.ranges;a.forEach(function(a,c){for(var i=this.$openTabstops[c]||a,g=a.length;g--;){var j=a[g],k=q.fromPoints(j.start,j.end||j.start),l=k.start,m=b;0==l.row&&(l.column+=m.column);l.row+=m.row;l=k.end;m=b;0==l.row&&(l.column+=m.column);l.row+=m.row;k.original=j;k.tabstop=i;d.push(k);i!=a?i.unshift(k):i[g]=k;j.fmtString?(k.linked=!0,i.hasLinkedRanges=!0):i.firstNonLinked||(i.firstNonLinked=k)}i.firstNonLinked||(i.hasLinkedRanges=!1);i===a&&(e.push(i),this.$openTabstops[c]=
i);this.addTabstopMarkers(i)},this);2<e.length&&(this.tabstops.length&&e.push(e.splice(2,1)[0]),this.tabstops.splice.apply(this.tabstops,e))};this.addTabstopMarkers=function(a){var b=this.editor.session;a.forEach(function(a){a.markerId||(a.markerId=b.addMarker(a,"ace_snippet-marker","text"))})};this.removeTabstopMarkers=function(a){var b=this.editor.session;a.forEach(function(a){b.removeMarker(a.markerId);a.markerId=null})};this.removeRange=function(a){var b=a.tabstop.indexOf(a);a.tabstop.splice(b,
1);b=this.ranges.indexOf(a);this.ranges.splice(b,1);this.editor.session.removeMarker(a.markerId);a.tabstop.length||(b=this.tabstops.indexOf(a.tabstop),-1!=b&&this.tabstops.splice(b,1),this.tabstops.length||this.detach())};this.keyboardHandler=new A;this.keyboardHandler.bindKeys({Tab:function(a){(!p.snippetManager||!p.snippetManager.expandWithTab(a))&&a.tabstopManager.tabNext(1)},"Shift-Tab":function(a){a.tabstopManager.tabNext(-1)},Esc:function(a){a.tabstopManager.detach()},Return:function(){return!1}})}).call(w.prototype);
var x=function(a,b){a.row==b.row&&(a.column-=b.column);a.row-=b.row};j("./lib/dom").importCssString(".ace_snippet-marker {    -moz-box-sizing: border-box;    box-sizing: border-box;    background: rgba(194, 193, 208, 0.09);    border: 1px dotted rgba(211, 208, 235, 0.62);    position: absolute;}");p.snippetManager=new n;var C=j("./editor").Editor;(function(){this.insertSnippet=function(a,b){return p.snippetManager.insertSnippet(this,a,b)};this.expandSnippet=function(a){return p.snippetManager.expandWithTab(this,
a)}}).call(C.prototype)});