/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2010, Ajax.org B.V.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

"undefined"!==typeof process&&(require("amd-loader"),require("./test/mockdom"));
define("require exports module ./edit_session ./editor ./test/mockrenderer ./multi_select ./snippets ./test/assertions".split(" "),function(c,h,e){c("./edit_session");var f=c("./editor").Editor,g=c("./test/mockrenderer").MockRenderer;c("./multi_select");var d=c("./snippets").snippetManager,a=c("./test/assertions");e.exports={setUp:function(a){this.editor=new f(new g);a()},"test: textmate style format strings":function(){"aOHElo"==d.tmStrFormat("hello",{guard:"(..)(.)(.)",flag:"g",fmt:"a\\UO\\l$1\\E$2"})},
"test: parse snipmate file":function(){var b=d.parseSnippetFile("name a\nregex /(?:(=)|(:))?\\s*)/\\(?f/\\)/\n\t{$0}\n\t\n\n#function\nsnippet f function\n\tfunction");a.equal(JSON.stringify([{name:"a",guard:"(?:(=)|(:))?\\s*)",trigger:"\\(?f",endTrigger:"\\)",endGuard:"",content:"{$0}\n"},{tabTrigger:"f",name:"f function",content:"function"}],null,4),JSON.stringify(b,null,4))},"test: parse snippet":function(){var b=d.tokenizeTmSnippet("-\\$$2a${1:x${$2:y$3\\}\\n\\}$TM_SELECTION}");a.equal(b.length,
15);a.equal(b[4],b[14]);a.equal(b[2].tabstopId,2);b=d.tokenizeTmSnippet("\\}${var/as\\/d/\\ul\\//g:s}");a.equal(b.length,4);a.equal(b[1],b[3]);a.equal(b[2],"s");a.equal(b[1].text,"var");a.equal(b[1].fmt,"\\ul\\/");a.equal(b[1].guard,"as\\/d");a.equal(b[1].flag,"g")},"test: expand snippet with nested tabstops":function(){this.editor.setValue("");d.insertSnippet(this.editor,"-${1}-${1:t\n1}--${2:2 ${3} 2}-${3:3 $1 3}-${4:4 $2 4}");a.equal(this.editor.getValue(),"-t\n1-t\n1--2 3 t\n1 3 2-3 t\n1 3-4 2 3 t\n1 3 2 4");
a.equal(this.editor.getSelectedText(),"t\n1\nt\n1\nt\n1\nt\n1\nt\n1");this.editor.tabstopManager.tabNext();a.equal(this.editor.getSelectedText(),"2 3 t\n1 3 2\n2 3 t\n1 3 2");this.editor.tabstopManager.tabNext();a.equal(this.editor.getSelectedText(),"3 t\n1 3\n3 t\n1 3\n3 t\n1 3");this.editor.tabstopManager.tabNext();a.equal(this.editor.getSelectedText(),"4 2 3 t\n1 3 2 4");this.editor.tabstopManager.tabNext();a.equal(this.editor.getSelectedText(),"");this.editor.setValue("");d.insertSnippet(this.editor,
"-${1:a$2}-${2:b$1}");a.equal(this.editor.getValue(),"-ab-ba");a.equal(this.editor.getSelectedText(),"ab\na");this.editor.tabstopManager.tabNext();a.equal(this.editor.getSelectedText(),"b\nba");this.editor.tabstopManager.tabNext();a.equal(this.editor.getSelectedText(),"")}}});"undefined"!==typeof module&&module===require.main&&require("asyncjs").test.testcase(module.exports).exec();