/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2010, Ajax.org B.V.
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

define("require exports module ./lib/oop ./lib/lang ./lib/event_emitter ./editor ./virtual_renderer ./edit_session".split(" "),function(e,h){function f(a,b){this.$u=a;this.$doc=b}var i=e("./lib/oop"),j=e("./lib/lang"),k=e("./lib/event_emitter").EventEmitter,l=e("./editor").Editor,m=e("./virtual_renderer").VirtualRenderer,n=e("./edit_session").EditSession,g=function(a,b,c){this.BELOW=1;this.BESIDE=0;this.$container=a;this.$theme=b;this.$splits=0;this.$editorCSS="";this.$editors=[];this.$orientation=
this.BESIDE;this.setSplits(c||1);this.$cEditor=this.$editors[0];this.on("focus",function(a){this.$cEditor=a}.bind(this))};(function(){i.implement(this,k);this.$createEditor=function(){var a=document.createElement("div");a.className=this.$editorCSS;a.style.cssText="position: absolute; top:0px; bottom:0px";this.$container.appendChild(a);var b=new l(new m(a,this.$theme));b.on("focus",function(){this._emit("focus",b)}.bind(this));this.$editors.push(b);b.setFontSize(this.$fontSize);return b};this.setSplits=
function(a){var b;if(1>a)throw"The number of splits have to be > 0!";if(a!=this.$splits){if(a>this.$splits){for(;this.$splits<this.$editors.length&&this.$splits<a;)b=this.$editors[this.$splits],this.$container.appendChild(b.container),b.setFontSize(this.$fontSize),this.$splits++;for(;this.$splits<a;)this.$createEditor(),this.$splits++}else for(;this.$splits>a;)b=this.$editors[this.$splits-1],this.$container.removeChild(b.container),this.$splits--;this.resize()}};this.getSplits=function(){return this.$splits};
this.getEditor=function(a){return this.$editors[a]};this.getCurrentEditor=function(){return this.$cEditor};this.focus=function(){this.$cEditor.focus()};this.blur=function(){this.$cEditor.blur()};this.setTheme=function(a){this.$editors.forEach(function(b){b.setTheme(a)})};this.setKeyboardHandler=function(a){this.$editors.forEach(function(b){b.setKeyboardHandler(a)})};this.forEach=function(a,b){this.$editors.forEach(a,b)};this.$fontSize="";this.setFontSize=function(a){this.$fontSize=a;this.forEach(function(b){b.setFontSize(a)})};
this.$cloneSession=function(a){var b=new n(a.getDocument(),a.getMode()),c=a.getUndoManager();c&&(c=new f(c,b),b.setUndoManager(c));b.$informUndoManager=j.delayedCall(function(){b.$deltas=[]});b.setTabSize(a.getTabSize());b.setUseSoftTabs(a.getUseSoftTabs());b.setOverwrite(a.getOverwrite());b.setBreakpoints(a.getBreakpoints());b.setUseWrapMode(a.getUseWrapMode());b.setUseWorker(a.getUseWorker());b.setWrapLimitRange(a.$wrapLimitRange.min,a.$wrapLimitRange.max);b.$foldData=a.$cloneFoldData();return b};
this.setSession=function(a,b){var c;c=null==b?this.$cEditor:this.$editors[b];this.$editors.some(function(b){return b.session===a})&&(a=this.$cloneSession(a));c.setSession(a);return a};this.getOrientation=function(){return this.$orientation};this.setOrientation=function(a){this.$orientation!=a&&(this.$orientation=a,this.resize())};this.resize=function(){var a=this.$container.clientWidth,b=this.$container.clientHeight,c;if(this.$orientation==this.BESIDE)for(var a=a/this.$splits,d=0;d<this.$splits;d++)c=
this.$editors[d],c.container.style.width=a+"px",c.container.style.top="0px",c.container.style.left=d*a+"px",c.container.style.height=b+"px",c.resize();else{b/=this.$splits;for(d=0;d<this.$splits;d++)c=this.$editors[d],c.container.style.width=a+"px",c.container.style.top=d*b+"px",c.container.style.left="0px",c.container.style.height=b+"px",c.resize()}}}).call(g.prototype);(function(){this.execute=function(a){this.$u.execute(a)};this.undo=function(){var a=this.$u.undo(!0);a&&this.$doc.selection.setSelectionRange(a)};
this.redo=function(){var a=this.$u.redo(!0);a&&this.$doc.selection.setSelectionRange(a)};this.reset=function(){this.$u.reset()};this.hasUndo=function(){return this.$u.hasUndo()};this.hasRedo=function(){return this.$u.hasRedo()}}).call(f.prototype);h.Split=g});