/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2010, Ajax.org B.V.
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

"undefined"!==typeof process&&require("amd-loader");
define("require exports module ./edit_session ./mode/javascript ./token_iterator ./test/assertions".split(" "),function(h,k,j){var g=h("./edit_session").EditSession,i=h("./mode/javascript").Mode,f=h("./token_iterator").TokenIterator,a=h("./test/assertions");j.exports={"test: token iterator initialization in JavaScript document":function(){var c=new g('function foo(items) {\n    for (var i=0; i<items.length; i++) {\n        alert(items[i] + "juhu");\n    } // Real Tab.\n}',new i),b=new f(c,0,0);a.equal(b.getCurrentToken().value,
"function");a.equal(b.getCurrentTokenRow(),0);a.equal(b.getCurrentTokenColumn(),0);b.stepForward();a.equal(b.getCurrentToken().value," ");a.equal(b.getCurrentTokenRow(),0);a.equal(b.getCurrentTokenColumn(),8);b=new f(c,0,4);a.equal(b.getCurrentToken().value,"function");a.equal(b.getCurrentTokenRow(),0);a.equal(b.getCurrentTokenColumn(),0);b.stepForward();a.equal(b.getCurrentToken().value," ");a.equal(b.getCurrentTokenRow(),0);a.equal(b.getCurrentTokenColumn(),8);b=new f(c,2,18);a.equal(b.getCurrentToken().value,
"items");a.equal(b.getCurrentTokenRow(),2);a.equal(b.getCurrentTokenColumn(),14);b.stepForward();a.equal(b.getCurrentToken().value,"[");a.equal(b.getCurrentTokenRow(),2);a.equal(b.getCurrentTokenColumn(),19);b=new f(c,4,0);a.equal(b.getCurrentToken().value,"}");a.equal(b.getCurrentTokenRow(),4);a.equal(b.getCurrentTokenColumn(),0);b.stepBackward();a.equal(b.getCurrentToken().value,"// Real Tab.");a.equal(b.getCurrentTokenRow(),3);a.equal(b.getCurrentTokenColumn(),6);b=new f(c,5,0);a.equal(b.getCurrentToken(),
null)},"test: token iterator initialization in text document":function(){var c=["Lorem ipsum dolor sit amet, consectetur adipisicing elit,","sed do eiusmod tempor incididunt ut labore et dolore magna","aliqua. Ut enim ad minim veniam, quis nostrud exercitation","ullamco laboris nisi ut aliquip ex ea commodo consequat."],b=new g(c.join("\n")),d=new f(b,0,0);a.equal(d.getCurrentToken().value,c[0]);a.equal(d.getCurrentTokenRow(),0);a.equal(d.getCurrentTokenColumn(),0);d=new f(b,0,4);a.equal(d.getCurrentToken().value,
c[0]);a.equal(d.getCurrentTokenRow(),0);a.equal(d.getCurrentTokenColumn(),0);d=new f(b,2,18);a.equal(d.getCurrentToken().value,c[2]);a.equal(d.getCurrentTokenRow(),2);a.equal(d.getCurrentTokenColumn(),0);d=new f(b,3,c[3].length-1);a.equal(d.getCurrentToken().value,c[3]);a.equal(d.getCurrentTokenRow(),3);a.equal(d.getCurrentTokenColumn(),0);d=new f(b,4,0);a.equal(d.getCurrentToken(),null)},"test: token iterator step forward in JavaScript document":function(){for(var c=new g('function foo(items) {\n    for (var i=0; i<items.length; i++) {\n        alert(items[i] + "juhu");\n    } // Real Tab.\n}',
new i),b=[],d=c.getLength(),e=0;e<d;e++)b=b.concat(c.getTokens(e));c=new f(c,0,0);for(e=1;e<b.length;e++)a.equal(c.stepForward(),b[e]);a.equal(c.stepForward(),null);a.equal(c.getCurrentToken(),null)},"test: token iterator step backward in JavaScript document":function(){for(var c=new g('function foo(items) {\n     for (var i=0; i<items.length; i++) {\n         alert(items[i] + "juhu");\n     } // Real Tab.\n}',new i),b=[],d=c.getLength(),e=0;e<d;e++)b=b.concat(c.getTokens(e));c=new f(c,4,0);for(e=
b.length-2;0<=e;e--)a.equal(c.stepBackward(),b[e]);a.equal(c.stepBackward(),null);a.equal(c.getCurrentToken(),null)},"test: token iterator reports correct row and column":function(){var c=new g('function foo(items) {\n    for (var i=0; i<items.length; i++) {\n        alert(items[i] + "juhu");\n    } // Real Tab.\n}',new i),c=new f(c,0,0);c.stepForward();c.stepForward();a.equal(c.getCurrentToken().value,"foo");a.equal(c.getCurrentTokenRow(),0);a.equal(c.getCurrentTokenColumn(),9);c.stepForward();c.stepForward();
c.stepForward();c.stepForward();c.stepForward();c.stepForward();c.stepForward();a.equal(c.getCurrentToken().value,"for");a.equal(c.getCurrentTokenRow(),1);a.equal(c.getCurrentTokenColumn(),4)}}});"undefined"!==typeof module&&module===require.main&&require("asyncjs").test.testcase(module.exports).exec();