/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2010, Ajax.org B.V.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

define(["require","exports","module","./config"],function(u,v){var w=u("./config"),s=2E3,t=function(a){this.states=a;this.regExps={};this.matchMappings={};for(var f in this.states){for(var a=this.states[f],d=[],c=0,e=this.matchMappings[f]={defaultToken:"text"},p="g",n=[],j=0;j<a.length;j++){var b=a[j];b.defaultToken&&(e.defaultToken=b.defaultToken);b.caseInsensitive&&(p="gi");if(null!=b.regex){b.regex instanceof RegExp&&(b.regex=b.regex.toString().slice(1,-1));var h=b.regex,i=RegExp("(?:("+h+")|(.))").exec("a").length-
2;Array.isArray(b.token)?1==b.token.length||1==i?b.token=b.token[0]:i-1!=b.token.length?(this.reportError("number of classes and regexp groups doesn't match",{rule:b,groupCount:i-1}),b.token=b.token[0]):(b.tokenArray=b.token,b.token=null,b.onMatch=this.$arrayTokens):"function"==typeof b.token&&!b.onMatch&&(b.onMatch=1<i?this.$applyToken:b.token);1<i&&(/\\\d/.test(b.regex)?h=b.regex.replace(/\\([0-9]+)/g,function(a,b){return"\\"+(parseInt(b,10)+c+1)}):(i=1,h=this.removeCapturingGroups(b.regex)),!b.splitRegex&&
"string"!=typeof b.token&&n.push(b));e[c]=j;c+=i;d.push(h);b.onMatch||(b.onMatch=null)}}d.length||(e[0]=0,d.push("$"));n.forEach(function(a){a.splitRegex=this.createSplitterRegexp(a.regex,p)},this);this.regExps[f]=RegExp("("+d.join(")|(")+")|($)",p)}};(function(){this.$setMaxTokenCount=function(a){s=a|0};this.$applyToken=function(a){var f=this.splitRegex.exec(a).slice(1),d=this.token.apply(this,f);if("string"===typeof d)return[{type:d,value:a}];for(var a=[],c=0,e=d.length;c<e;c++)f[c]&&(a[a.length]=
{type:d[c],value:f[c]});return a};this.$arrayTokens=function(a){if(!a)return[];a=this.splitRegex.exec(a);if(!a)return"text";for(var f=[],d=this.tokenArray,c=0,e=d.length;c<e;c++)a[c+1]&&(f[f.length]={type:d[c],value:a[c+1]});return f};this.removeCapturingGroups=function(a){return a.replace(/\[(?:\\.|[^\]])*?\]|\\.|\(\?[:=!]|(\()/g,function(a,d){return d?"(?:":a})};this.createSplitterRegexp=function(a,f){if(-1!=a.indexOf("(?=")){var d=0,c=!1,e={};a.replace(/(\\.)|(\((?:\?[=!])?)|(\))|([\[\]])/g,function(a,
f,j,b,h,i){c?c="]"!=h:h?c=!0:b?(d==e.stack&&(e.end=i+1,e.stack=-1),d--):j&&(d++,1!=j.length&&(e.stack=d,e.start=i));return a});null!=e.end&&/^\)*$/.test(a.substr(e.end))&&(a=a.substring(0,e.start)+a.substr(e.end))}"^"!=a.charAt(0)&&(a="^"+a);"$"!=a.charAt(a.length-1)&&(a+="$");return RegExp(a,(f||"").replace("g",""))};this.getLineTokens=function(a,f){if(f&&"string"!=typeof f){var d=f.slice(0),f=d[0];"#tmp"===f&&(d.shift(),f=d.shift())}else d=[];var c=f||"start",e=this.states[c];e||(c="start",e=this.states[c]);
var p=this.matchMappings[c],n=this.regExps[c];n.lastIndex=0;for(var j,b=[],h=0,i=0,g={type:null,value:""};j=n.exec(a);){var m=p.defaultToken,l=null,q=j[0],r=n.lastIndex;if(r-q.length>h){var k=a.substring(h,r-q.length);g.type==m?g.value+=k:(g.type&&b.push(g),g={type:m,value:k})}for(k=0;k<j.length-2;k++)if(void 0!==j[k+1]){l=e[p[k]];m=l.onMatch?l.onMatch(q,c,d):l.token;l.next&&(c="string"==typeof l.next?l.next:l.next(c,d),e=this.states[c],e||(this.reportError("state doesn't exist",c),c="start",e=this.states[c]),
p=this.matchMappings[c],h=r,n=this.regExps[c],n.lastIndex=r);break}if(q)if("string"===typeof m)(!l||!1!==l.merge)&&g.type===m?g.value+=q:(g.type&&b.push(g),g={type:m,value:q});else if(m){g.type&&b.push(g);g={type:null,value:""};for(k=0;k<m.length;k++)b.push(m[k])}if(h==a.length)break;h=r;if(i++>s){for(i>2*a.length&&this.reportError("infinite loop with in ace tokenizer",{startState:f,line:a});h<a.length;)g.type&&b.push(g),g={value:a.substring(h,h+=2E3),type:"overflow"};c="start";d=[];break}}g.type&&
b.push(g);1<d.length&&d[0]!==c&&d.unshift("#tmp",c);return{tokens:b,state:d.length?d:c}};this.reportError=w.reportError}).call(t.prototype);v.Tokenizer=t});