/**
 * Copyright (c) 2011-2014 Felix Gnass
 * Licensed under the MIT license
 * http://spin.js.org/
 *
 * Example:
    var opts = {
      lines: 12             // The number of lines to draw
    , length: 7             // The length of each line
    , width: 5              // The line thickness
    , radius: 10            // The radius of the inner circle
    , scale: 1.0            // Scales overall size of the spinner
    , corners: 1            // Roundness (0..1)
    , color: '#000'         // #rgb or #rrggbb
    , opacity: 1/4          // Opacity of the lines
    , rotate: 0             // Rotation offset
    , direction: 1          // 1: clockwise, -1: counterclockwise
    , speed: 1              // Rounds per second
    , trail: 100            // Afterglow percentage
    , fps: 20               // Frames per second when using setTimeout()
    , zIndex: 2e9           // Use a high z-index by default
    , className: 'spinner'  // CSS class to assign to the element
    , top: '50%'            // center vertically
    , left: '50%'           // center horizontally
    , shadow: false         // Whether to render a shadow
    , hwaccel: false        // Whether to use hardware acceleration (might be buggy)
    , position: 'absolute'  // Element positioning
    }
    var target = document.getElementById('foo')
    var spinner = new Spinner(opts).spin(target)
 */

(function(h,g){"object"==typeof module&&module.exports?module.exports=g():"function"==typeof define&&define.amd?define(g):h.Spinner=g()})(this,function(){function h(b,a){var c=document.createElement(b||"div"),d;for(d in a)c[d]=a[d];return c}function g(b){for(var a=1,c=arguments.length;a<c;a++)b.appendChild(arguments[a]);return b}function v(b,a){var c=b.style,d,k,a=a.charAt(0).toUpperCase()+a.slice(1);if(void 0!==c[a])return a;for(k=0;k<w.length;k++)if(d=w[k]+a,void 0!==c[d])return d}function l(b,
a){for(var c in a)b.style[v(b,c)||c]=a[c];return b}function x(b){for(var a=1;a<arguments.length;a++){var c=arguments[a],d;for(d in c)void 0===b[d]&&(b[d]=c[d])}return b}function i(b){this.opts=x(b||{},i.defaults,z)}var w=["webkit","Moz","ms","O"],y={},q,t,z={lines:12,length:7,width:5,radius:10,scale:1,corners:1,color:"#000",opacity:0.25,rotate:0,direction:1,speed:1,trail:100,fps:20,zIndex:2E9,className:"spinner",top:"50%",left:"50%",shadow:!1,hwaccel:!1,position:"absolute"};i.defaults={};x(i.prototype,
{spin:function(b){this.stop();var a=this,c=a.opts,d=a.el=h(null,{className:c.className});l(d,{position:c.position,width:0,zIndex:c.zIndex,left:c.left,top:c.top});b&&b.insertBefore(d,b.firstChild||null);d.setAttribute("role","progressbar");a.lines(d,a.opts);if(!q){var k=0,g=(c.lines-1)*(1-c.direction)/2,f,e=c.fps,r=e/c.speed,j=(1-c.opacity)/(r*c.trail/100),s=r/c.lines;(function n(){k++;for(var b=0;b<c.lines;b++)f=Math.max(1-(k+(c.lines-b)*s)%r*j,c.opacity),a.opacity(d,b*c.direction+g,f,c);a.timeout=
a.el&&setTimeout(n,~~(1E3/e))})()}return a},stop:function(){var b=this.el;b&&(clearTimeout(this.timeout),b.parentNode&&b.parentNode.removeChild(b),this.el=void 0);return this},lines:function(b,a){function c(b,c){return l(h(),{position:"absolute",width:a.scale*(a.length+a.width)+"px",height:a.scale*a.width+"px",background:b,boxShadow:c,transformOrigin:"left",transform:"rotate("+~~(360/a.lines*d+a.rotate)+"deg) translate("+a.scale*a.radius+"px,0)",borderRadius:(a.corners*a.scale*a.width>>1)+"px"})}
for(var d=0,k=(a.lines-1)*(1-a.direction)/2,e;d<a.lines;d++){e=h();var f=1+~(a.scale*a.width/2)+"px",i=a.hwaccel?"translate3d(0,0,0)":"",r=a.opacity,j;if(j=q){j=a.opacity;var s=a.trail,p=k+d*a.direction,n=a.lines,m=["opacity",s,~~(100*j),p,n].join("-"),p=0.01+100*(p/n),n=Math.max(1-(1-j)/s*(100-p),j),u=q.substring(0,q.indexOf("Animation")).toLowerCase(),u=u&&"-"+u+"-"||"";y[m]||(t.insertRule("@"+u+"keyframes "+m+"{0%{opacity:"+n+"}"+p+"%{opacity:"+j+"}"+(p+0.01)+"%{opacity:1}"+(p+s)%100+"%{opacity:"+
j+"}100%{opacity:"+n+"}}",t.cssRules.length),y[m]=1);j=m+" "+1/a.speed+"s linear infinite"}e=l(e,{position:"absolute",top:f,transform:i,opacity:r,animation:j});a.shadow&&g(e,l(c("#000","0 0 4px #000"),{top:"2px"}));g(b,g(e,c("string"==typeof a.color?a.color:a.color[d%a.color.length],"0 0 1px rgba(0,0,0,.1)")))}return b},opacity:function(b,a,c){a<b.childNodes.length&&(b.childNodes[a].style.opacity=c)}});if("undefined"!==typeof document){var e=h("style",{type:"text/css"});g(document.getElementsByTagName("head")[0],
e);t=e.sheet||e.styleSheet;e=l(h("group"),{behavior:"url(#default#VML)"});if(!v(e,"transform")&&e.adj){var m=function(b,a){return h("<"+b+' xmlns="urn:schemas-microsoft.com:vml" class="spin-vml">',a)};t.addRule(".spin-vml","behavior:url(#default#VML)");i.prototype.lines=function(b,a){function c(){return l(m("group",{coordsize:h+" "+h,coordorigin:-e+" "+-e}),{width:h,height:h})}function d(b,d,f){g(i,g(l(c(),{rotation:360/a.lines*b+"deg",left:~~d}),g(l(m("roundrect",{arcsize:a.corners}),{width:e,height:a.scale*
a.width,left:a.scale*a.radius,top:-a.scale*a.width>>1,filter:f}),m("fill",{color:"string"==typeof a.color?a.color:a.color[b%a.color.length],opacity:a.opacity}),m("stroke",{opacity:0}))))}var e=a.scale*(a.length+a.width),h=2*a.scale*e,f=2*-(a.width+a.length)*a.scale+"px",i=l(c(),{position:"absolute",top:f,left:f});if(a.shadow)for(f=1;f<=a.lines;f++)d(f,-2,"progid:DXImageTransform.Microsoft.Blur(pixelradius=2,makeshadow=1,shadowopacity=.3)");for(f=1;f<=a.lines;f++)d(f);return g(b,i)};i.prototype.opacity=
function(b,a,c,d){b=b.firstChild;d=d.shadow&&d.lines||0;if(b&&a+d<b.childNodes.length&&(b=(b=(b=b.childNodes[a+d])&&b.firstChild)&&b.firstChild))b.opacity=c}}else q=v(e,"animation")}return i});