/**
	 * Create a new AnimationOptions object of the given type
	 * see http://greweb.me/2012/02/bezier-curve-based-easing-functions-from-concept-to-implementation/
	 * 
	 * MIT License
	 *
	 * KeySpline - use bezier curve for transition easing function
	 * Copyright (c) 2012 Gaetan Renaudeau <renaudeau.gaetan@gmail.com>
	 *
	 * Permission is hereby granted, free of charge, to any person obtaining a
	 * copy of this software and associated documentation files (the "Software"),
	 * to deal in the Software without restriction, including without limitation
	 * the rights to use, copy, modify, merge, publish, distribute, sublicense,
	 * and/or sell copies of the Software, and to permit persons to whom the
	 * Software is furnished to do so, subject to the following conditions:
	 *
	 * The above copyright notice and this permission notice shall be included in
	 * all copies or substantial portions of the Software.
	 *
	 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
	 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
	 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
	 * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
	 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
	 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
	 * DEALINGS IN THE SOFTWARE.
	 * 
	 * Notice: changed by Esko to become prototyped
	 */

define(["underscore"],function(){var b=function(a){this._types={ease:[0.25,0.1,0.25,1],linear:[0,0,1,1],"ease-in":[0.42,0,1,1],"ease-out":[0,0,0.58,1],"ease-in-out":[0.42,0,0.58,1]};this._options=this._types[a];this._options||(this._options=this._types.linear);this._mX1=this._options[0];this._mY1=this._options[1];this._mX2=this._options[2];this._mY2=this._options[3]};b.prototype.get=function(a){return this._mX1==this._mY1&&this._mX2==this._mY2?a:this._calcBezier(this._getTForX(a),this._mY1,this._mY2)};
b.prototype._a=function(a,c){return 1-3*c+3*a};b.prototype._b=function(a,c){return 3*c-6*a};b.prototype._c=function(a){return 3*a};b.prototype._calcBezier=function(a,c,b){return((this._a(c,b)*a+this._b(c,b))*a+this._c(c))*a};b.prototype._getSlope=function(a,c,b){return 3*this._a(c,b)*a*a+2*this._b(c,b)*a+this._c(c)};b.prototype._getTForX=function(a){for(var c=a,b=0;4>b;++b){var d=this._getSlope(c,this._mX1,this._mX2);if(0==d)break;var e=this._calcBezier(c,this._mX1,this._mX2)-a,c=c-e/d}return c};
return b});