/**
 * Copyright 2015 Craig Campbell
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * Mousetrap is a simple keyboard shortcut library for Javascript with
 * no external dependencies
 *
 * @version 1.5.3
 * @url craig.is/killing/mice
 * 
 * NOTICE: changed by Esko (TAKE INTO ACCOUNT WHEN INTEGRATING NEW VERSION!):
 * 	- fixed support for "-"-key
 *  - allow binding of multiple callbacks to 1 key combination
 *  - completely remove callback when unbinding
 *  - converted to UMD module
 */

(function(q,p){"function"===typeof define&&define.amd?define([],p):"object"===typeof module&&module.exports?module.exports=p():q.MouseTrap=p()})(this,function(){function q(a,b,i){a.addEventListener?a.addEventListener(b,i,!1):a.attachEvent("on"+b,i)}function p(a){if("keypress"==a.type){var b=String.fromCharCode(a.which);a.shiftKey||(b=b.toLowerCase());return b}return l[a.which]?l[a.which]:r[a.which]?r[a.which]:String.fromCharCode(a.which).toLowerCase()}function y(a){var b=[];a.shiftKey&&b.push("shift");
a.altKey&&b.push("alt");a.ctrlKey&&b.push("ctrl");a.metaKey&&b.push("meta");return b}function s(a){return"shift"==a||"ctrl"==a||"alt"==a||"meta"==a}function t(a,b){var i,f,c,h=[];i=a;"+"===i?i=["+"]:(i=i.replace(/\+{2}/g,"+plus"),i=i.split("+"));for(c=0;c<i.length;++c)f=i[c],v[f]&&(f=v[f]),b&&("keypress"!=b&&w[f])&&(f=w[f],h.push("shift")),s(f)&&h.push(f);i=f;c=b;if(!c){if(!m){m={};for(var k in l)95<k&&112>k||l.hasOwnProperty(k)&&(m[l[k]]=k)}c=m[i]?"keydown":"keypress"}"keypress"==c&&h.length&&(c=
"keydown");return{key:f,modifiers:h,action:c}}function x(a,b){return null===a||a===document?!1:a===b?!0:x(a.parentNode,b)}function c(a){function b(a){var a=a||{},b=!1,j;for(j in k)a[j]?b=!0:k[j]=0;b||(u=!1)}function i(a,b,j,d){if(!h.stopCallback(b,b.target||b.srcElement,j,d)&&!1===a(b,j))b.preventDefault?b.preventDefault():b.returnValue=!1,b.stopPropagation?b.stopPropagation():b.cancelBubble=!0}function f(a){"number"!==typeof a.which&&(a.which=a.keyCode);var b=p(a);b&&("keyup"==a.type&&m===b?m=!1:
h.handleKey(b,y(a),a))}function g(a,c,j,d,n){h._directMap[a+":"+j]=c;var a=a.replace(/\s+/g," "),e=a.split(" ");if(1<e.length)for(var f=a,a=function(a){return function(){u=a;++k[f];clearTimeout(l);l=setTimeout(b,1E3)}},d=function(a){i(c,a,f);"keyup"!==j&&(m=p(a));setTimeout(b,10)},n=k[f]=0;n<e.length;++n){var z=n+1===e.length?d:a(j||t(e[n+1]).action);g(e[n],z,j,f,n)}else e=t(a,j),h._callbacks[e.key]=h._callbacks[e.key]||[],h._callbacks[e.key][d?"unshift":"push"]({callback:c,modifiers:e.modifiers,
action:e.action,seq:d,level:n,combo:a})}var h=this,a=a||document;if(!(h instanceof c))return new c(a);h.target=a;h._callbacks={};h._directMap={};var k={},l,m=!1,r=!1,u=!1;h._handleKey=function(a,c,j){var d;var f,e=[],g=j.type;if(h._callbacks[a]){"keyup"==g&&s(a)&&(c=[a]);for(f=0;f<h._callbacks[a].length;++f)if(d=h._callbacks[a][f],!(d.seq&&k[d.seq]!=d.level)&&g==d.action&&("keypress"==g&&!j.metaKey&&!j.ctrlKey||c.sort().join(",")===d.modifiers.sort().join(",")))void 0==d.combo&&h._callbacks[a].splice(f,
1),e.push(d);d=e}else d=[];c={};g=0;f=!1;for(e=0;e<d.length;++e)d[e].seq&&(g=Math.max(g,d[e].level));for(e=0;e<d.length;++e)d[e].seq?d[e].level==g&&(f=!0,c[d[e].seq]=1,i(d[e].callback,j,d[e].combo,d[e].seq)):f||i(d[e].callback,j,d[e].combo);d="keypress"==j.type&&r;j.type==u&&(!s(a)&&!d)&&b(c);r=f&&"keydown"==j.type};h._bindMultiple=function(a,b,c){for(var d=0;d<a.length;++d)g(a[d],b,c)};h._unbindMultiple=function(a,b,c){for(var d=0;d<a.length;++d){for(var f=b,e=c,i=t(a[d],e),g=h._callbacks[i.key],
k=0;k<g.length;)g[k].callback==f&&g[k].action==e?g.splice(k,1):k++;h._callbacks[i.key]=g}};q(a,"keypress",f);q(a,"keydown",f);q(a,"keyup",f)}for(var l={8:"backspace",9:"tab",13:"enter",16:"shift",17:"ctrl",18:"alt",20:"capslock",27:"esc",32:"space",33:"pageup",34:"pagedown",35:"end",36:"home",37:"left",38:"up",39:"right",40:"down",45:"ins",46:"del",91:"meta",93:"meta",224:"meta"},r={106:"*",107:"+",109:"-",110:".",111:"/",173:"-",186:";",187:"=",188:",",189:"-",190:".",191:"/",192:"`",219:"[",220:"\\",
221:"]",222:"'"},w={"~":"`","!":"1","@":"2","#":"3",$:"4","%":"5","^":"6","&":"7","*":"8","(":"9",")":"0",_:"-","+":"=",":":";",'"':"'","<":",",">":".","?":"/","|":"\\"},v={option:"alt",command:"meta","return":"enter",escape:"esc",plus:"+",mod:/Mac|iPod|iPhone|iPad/.test(navigator.platform)?"meta":"ctrl"},m,g=1;20>g;++g)l[111+g]="f"+g;for(g=0;9>=g;++g)l[g+96]=g;c.prototype.bind=function(a,b,c){a=a instanceof Array?a:[a];this._bindMultiple.call(this,a,b,c);return this};c.prototype.unbind=function(a,
b,c){a=a instanceof Array?a:[a];this._unbindMultiple.call(this,a,b,c);return this};c.prototype.trigger=function(a,b){if(this._directMap[a+":"+b])this._directMap[a+":"+b]({},a);return this};c.prototype.reset=function(){this._callbacks={};this._directMap={};return this};c.prototype.stopCallback=function(a,b){return-1<(" "+b.className+" ").indexOf(" mousetrap ")||x(b,this.target)?!1:"INPUT"==b.tagName||"SELECT"==b.tagName||"TEXTAREA"==b.tagName||b.isContentEditable};c.prototype.handleKey=function(){return this._handleKey.apply(this,
arguments)};c.init=function(){var a=c(document),b;for(b in a)"_"!==b.charAt(0)&&(c[b]=function(b){return function(){return a[b].apply(a,arguments)}}(b))};c.init();return c});