/**
 * Creates WebCenter-specific pluging to insert smartnames into the rich text
 */
tinymce.PluginManager.add('smartname', function(editor) {
	var smartNameSelector = null;

	// Add a button that opens a window
	editor.addButton('smartname', {
		text: ' [ ] ',
		icon: false,
		onclick: function() {
			// NOTE: require modules only loaded here, because creation of buttons needs to happen synchronously for tinyMCE
			require(["component/smartnames/selector/smartnameselector"], function(SmartNameSelector){
				if(!smartNameSelector){
					// important that dictionaryService was given to editor at setup, as it cannot create it by itself
					smartNameSelector = new SmartNameSelector(editor.dictionaryService, _.bind(editor.dictionaryService.displaySmartNameSelectorSmartName, editor.dictionaryService));
					
					smartNameSelector.onSmartNameSelected(function (smartnameName) {
						editor.insertContent('[' + smartnameName + ']');
					});
				}
				smartNameSelector.openSmartNameSelector();
			});
		}
	});
});