/**
* WebViewer3D provides an HTML5-based 3D viewing component
*
* @module WebViewer3D
* @author DOGO, PHST
* @copyright	2014 Esko Stonecube Ltd. All rights reserved.
* @version  0.7.1
*/

define(["WV3Dmod/ViewerController","WV3Dmod/Constants","WV3Dmod/LogMessage","WV3D/BuildVersion"],function(k,a,e,i){a=function(b,a,c,f,g){console.log("ESKO HTML Viewer - Client V"+i.SuiteNumber+"/"+i.P4VChangelistNumber);e.SetCallbackFunction(f);e.Log("Creating WebViewer3DAPI Object");this._controller=new k(b,a,c,g)};a.prototype.Dispose=function(){e.Log("API Dispose");this._controller.Dispose()};a.prototype.SetLogMessageCallback=function(b){e.SetCallbackFunction(b)};a.prototype.SetURLPreprocessCallback=
function(b){this._controller.SetURLPreprocessCallback(b)};a.prototype.SetEndCameraInteractionCallback=function(b){this._controller.SetEndCameraInteractionCallback(b)};a.prototype.Resize=function(){this._controller.get("_view").Resize()};a.prototype.Initialize=function(){console.warn("Initialize: Deprecated API function !!!!!!!!!!!!!!!! (No need to call that function anymore: this function will be removed from next builds)")};a.prototype.LoadScene=function(b,a,c,f,g,h){e.Log("API Load Scene from URL");
this._controller.LoadSceneFromURL(b,a,c,f,g,h)};a.prototype.LoadSceneFromLocalFile=function(b,a,c,f,g,h){e.Log("API Load Scene from local file");var j=new FileReader,i=this;j.onload=function(){i.LoadSceneFromObject(JSON.parse(j.result),a,c,f,g,h)};j.readAsText(b)};a.prototype.LoadSceneFromObject=function(b,a,c,f,g,h){e.Log("API Load Scene from object");this._controller.LoadSceneFromJSONObject(b,a,c,f,g,h)};a.prototype.ResetMainSceneVisibility=function(){e.Log("API Reset visiblity of main scene");
this._controller.ResetMainSceneVisibility()};a.prototype.ToggleNodeVisibility=function(b,a,c){this._controller.ToggleNodeVisibility(b,a,c)};a.prototype.SetNodeVisibility=function(b,a,c,f){this._controller.SetNodeVisibility(b,a,c,f)};a.prototype.SetCameraAngles=function(b,a,c){this._controller.SetCameraAngles(b,a,c)};a.prototype.GetCameraAngles=function(){return this._controller.GetCameraAngles()};a.prototype.ResetCamera=function(){this._controller.ResetCamera()};a.prototype.ToggleInteractiveCameraControl=
function(b){this._controller.SetInteractiveCameraControl(b)};a.prototype.SetInteractiveCameraControlMask=function(b){this._controller.SetInteractiveCameraControlMask(b)};a.prototype.SetCameraScale=function(b,a){this._controller.SetCameraScale(b,a)};a.prototype.GetCameraScale=function(){return this._controller.GetCameraScale()};a.prototype.SetCameraPanOffset=function(b,a,c){this._controller.SetCameraPanOffset(b,a,c)};a.prototype.GetCameraPanOffset=function(){return this._controller.GetCameraPanOffset()};
a.prototype.AnimateToView=function(b,a,c,f,e,h){return this._controller.AnimateToView(b,a,c,f,e,h)};a.prototype.SetAnimations=function(){e.Log("SetAnimations API deprecated !!! Use SetCameraSpinAnimation instead.")};a.prototype.SetCameraSpinAnimation=function(b){e.Log("API enable/disable animations: "+b);this._controller.SetCameraSpinAnimation(b)};a.prototype.SetEnvironmentRotation=function(b,a){this._controller.SetEnvironmentRotation(b,a)};a.prototype.GetEnvironmentRotation=function(){return this._controller.get("_view").GetEnvironmentRotation()};
a.prototype.SetOptimisedViewRendering=function(b,a,c){this._controller.SetOptimisedViewRendering(b,a,c)};a.prototype.SetPerspectiveCamera=function(b,a){this._controller.SetPerspectiveCamera(b,a)};a.prototype.SetOrthographicCamera=function(a){this._controller.SetOrthographicCamera(a)};a.prototype.SetCameraFocus=function(a,d){this._controller.SetCameraFocus(a,d)};a.prototype.SetHighlights=function(a,d){this._controller.SetHighlights(a,d)};a.prototype.SetHighlightsConfiguration=function(a,d,c){this._controller.SetHighlightsConfiguration(a,
d,c)};a.prototype.SetHighlightsColor=function(a,d,c,f){this._controller.SetHighlightsColor(parseFloat(a),parseFloat(d),parseFloat(c),f)};a.prototype.SetBackgroundColor=function(a,d,c,f,e){this._controller.SetBackgroundColor(parseFloat(a),parseFloat(d),parseFloat(c),parseFloat(f),e)};a.prototype.SetLabelsVisibility=function(a,d){this._controller.SetLabelsVisibility(a,d)};a.prototype.UpdateLabelProperties=function(a,d){return this._controller.UpdateLabelProperties(a,d)};a.prototype.UpdateAllLabelsProperties=
function(a){return this._controller.UpdateAllLabelsProperties(a)};a.prototype.SetReflections=function(a,d,c,f,g,h){e.Log("API SetReflections: "+a);this._controller.SetReflections(a,d,c,f,g,h)};a.prototype.SetInteractionOptimization=function(a){e.Log("API enable/disable interaction optimization: "+a);this._controller.SetInteractionOptimization(a)};a.prototype.SetQualityLevel=function(a,d){e.Log("API SetQualityLevel: "+a);this._controller.SetQualityLevel(a,d)};a.prototype.SetLightingContrast=function(a,
d){e.Log("API SetLightingContrast: "+a);this._controller.SetLightingContrast(a,d)};a.prototype.SetDefaultResourceRelativePath=function(a){this._controller.SetDefaultResourceRelativePath(a)};a.prototype.GetSystemSupportLevel=function(){return this._controller.GetSystemSupportLevel()};a.prototype.GetSystemReport=function(){return this._controller.GetSystemReport()};a.prototype.GetSnapshot=function(a,d,c){return this._controller.GetSnapshot(a,d,c)};return a});