/**
 * @authors DOGO, zz85 / https://github.com/zz85 | https://www.lab4games.net/zz85/blog
 *
 * Edge Detection Shader using Sobel filter
 * Based on http://rastergrid.com/blog/2011/01/frei-chen-edge-detector
 *
 * @module WebViewer3D
 * @copyright   2016 Esko Stonecube Ltd. All rights reserved.
 */

define(["WV3Dlib/three","WV3Dmod/shaders/ShaderUtils","WV3Dmod/shaders/VertexShaderQuad"],function(a,b,c){return{uniforms:{depth_texture:{type:"t",value:null},canvas_size:{type:"v2",value:new a.Vector2(512,512)},color:{type:"v3",value:new a.Vector3(0,0,0)},offsetRepeat:{type:"v4",value:new a.Vector4(0,0,1,1)},backTexture:{type:"i",value:0},flipNormals:{type:"i",value:0}},vertexShader:c.vertexShader,fragmentShader:["uniform sampler2D depth_texture;\nuniform vec3 color;\nuniform vec2 canvas_size;\nvec2 texel;\nvec2 vUv;\nmat3 G[2];\nconst mat3 g0 = mat3( 1.0, 2.0, 1.0, 0.0, 0.0, 0.0, -1.0, -2.0, -1.0 );\nconst mat3 g1 = mat3( 1.0, 0.0, -1.0, 2.0, 0.0, -2.0, 1.0, 0.0, -1.0 );",
b.get("EncodeDepthChunck"),b.get("DecodeDepthChunck"),"void main(void)\n{\nmat3 I;\nfloat cnv[2];\nfloat depth;\nvec3 sample;\nvec3 value;\nvUv = gl_FragCoord.xy;\ntexel = vec2(1.0 / canvas_size.x, 1.0 / canvas_size.y);\nG[0] = g0;\nG[1] = g1;\ndepth = DecodeFloatRGBA(texture2D(depth_texture, texel * (vUv + vec2(-1.0,-1.0)) ));\nsample = vec3(depth);\nI[0][0] = length(sample);\ndepth = DecodeFloatRGBA(texture2D(depth_texture, texel * (vUv + vec2( 0.0,-1.0)) ));\nsample = vec3(depth);\nI[1][0] = length(sample);\ndepth = DecodeFloatRGBA(texture2D(depth_texture, texel * (vUv + vec2( 1.0,-1.0)) ));\nsample = vec3(depth);\nI[2][0] = length(sample);\ndepth = DecodeFloatRGBA(texture2D(depth_texture, texel * (vUv + vec2(-1.0, 0.0)) ));\nsample = vec3(depth);\nI[0][1] = length(sample);\ndepth = DecodeFloatRGBA(texture2D(depth_texture, texel * (vUv + vec2( 0.0, 0.0)) ));\nsample = vec3(depth);\nvalue = sample;\nI[1][1] = length(sample);\ndepth = DecodeFloatRGBA(texture2D(depth_texture, texel * (vUv + vec2( 1.0, 0.0)) ));\nsample = vec3(depth);\nI[2][1] = length(sample);\ndepth = DecodeFloatRGBA(texture2D(depth_texture, texel * (vUv + vec2(-1.0, 1.0)) ));\nsample = vec3(depth);\nI[0][2] = length(sample);\ndepth = DecodeFloatRGBA(texture2D(depth_texture, texel * (vUv + vec2( 0.0, 1.0)) ));\nsample = vec3(depth);\nI[1][2] = length(sample);\ndepth = DecodeFloatRGBA(texture2D(depth_texture, texel * (vUv + vec2( 1.0, 1.0)) ));\nsample = vec3(depth);\nI[2][2] = length(sample);\nfor (int i=0; i<2; i++) {\nfloat dp3 = dot(G[i][0], I[0]) + dot(G[i][1], I[1]) + dot(G[i][2], I[2]);\ncnv[i] = dp3 * dp3; \n}\nfloat val = 0.5 * sqrt(cnv[0]*cnv[0]+cnv[1]*cnv[1]);\nif (val > 0.02) gl_FragColor = vec4(color, 1.);\nelse discard;\n} "].join("\n")}});