import ParameterConfigurationPanel from "../ParameterConfigurationPanel";
import $ from "jquery";
import _ from "underscore";
/**
 * Configuration panel for a composite parameter.
 * This panel simply shows the parameterconfiguration panels for the subparameters
 * @augments ParameterConfigurationPanel
 * @param {CompositeParameter} parameter
 */
var CompositeParameterConfigurationPanel = function(parameter) {
	ParameterConfigurationPanel.call(this, parameter);
};

CompositeParameterConfigurationPanel.prototype = Object.create(ParameterConfigurationPanel.prototype);
CompositeParameterConfigurationPanel.prototype.constructor = CompositeParameterConfigurationPanel;

/**
 * By default a parameter is shown as a form-group with a label and an input field
 * @private
 */
CompositeParameterConfigurationPanel.prototype._init = function() {
	// we don't display a label currently :)
	var paramConfig = this._getParameterConfiguration(this._parameter.getParameterList());
	this._element.append(paramConfig);
};

export default CompositeParameterConfigurationPanel;
