import ParameterConfigurationPanel from "../ParameterConfigurationPanel";
import $ from "jquery";
import _ from "underscore";
import summernote from "lib/summernote/summernote";
/**
 * Configuration panel for a HTML parameter
 * @augments ParameterConfigurationPanel
 * @param {HTMLParameter}
 */
var HTMLParameterConfigurationPanel = function(parameter) {
	ParameterConfigurationPanel.call(this, parameter);
};

HTMLParameterConfigurationPanel.prototype = Object.create(ParameterConfigurationPanel.prototype);
HTMLParameterConfigurationPanel.prototype.constructor = HTMLParameterConfigurationPanel;

/**
 * By default a parameter is shown as a form-group with a label and an input field
 * @private
 */
HTMLParameterConfigurationPanel.prototype._init = function() {
	// we don't display a label currently :)
	this._editor = $("<div>").html(this._parameter.getValue());
	this._element.append(this._editor);
	this._editor.summernote({ maximumImageFileSize: "102400", dialogsInBody: true });
	this._editor.on(
		"summernote.blur",
		function() {
			this._parameter.undoableSetValue(this._editor.summernote("code"));
		}.bind(this)
	);
	this._observeParam(
		function() {
			this._editor.summernote("code", this._parameter.getValue());
		}.bind(this)
	);
};

/**
 * @override
 * @private
 * @returns {object} [[Description]]
 */
HTMLParameterConfigurationPanel.prototype._getCustomConfiguration = function() {
	return {
		value: this._editor.summernote("code")
	};
};

export default HTMLParameterConfigurationPanel;
