import ParameterConfigurationPanel from "../ParameterConfigurationPanel";
import $ from "jquery";
import _ from "underscore";
/**
 * Configuration panel for a Linked Parameter
 * @augments ParameterConfigurationPanel
 * @param {[[Type]]} parameter [[Description]]
 */
var LinkedParameterConfigurationPanel = function(parameter) {
	ParameterConfigurationPanel.call(this, parameter);
};

LinkedParameterConfigurationPanel.prototype = Object.create(ParameterConfigurationPanel.prototype);
LinkedParameterConfigurationPanel.prototype.constructor = LinkedParameterConfigurationPanel;

/**
 * By default a parameter is shown as a form-group with a label and an input field
 * @private
 */
LinkedParameterConfigurationPanel.prototype._init = function() {
	// FUTURE make the parameter configurable (if canRelink show combobox to link to another parameter, if configurable, get the parameter configuration panel )
};

/**
 * @Override
 * @private
 * @returns {object} [[Description]]
 */
LinkedParameterConfigurationPanel.prototype._getCustomConfiguration = function() {
	return {
		linkedName: this._parameter.getLinkedName(),
		linkedType: this._parameter.getLinkedType()
	};
};

export default LinkedParameterConfigurationPanel;
