import Parameter from "./Parameter";
import Promisify from "@esko/promisify";
/**
 * Boolean Parameter
 * @augments Parameter
 * @param {String} name             - name of the parameter
 * @param {String} userFriendlyName - user friendly representation of the parameter
 */
var BooleanParameter = function(name, context, userFriendlyName) {
	Parameter.call(this, name, context, "dashboard/core/parameters/BooleanParameter", userFriendlyName);
};

BooleanParameter.prototype = Object.create(Parameter.prototype);
BooleanParameter.prototype.constructor = BooleanParameter;

/**
 * Get the configuration element for the parameter
 * @returns {Promise.<ConfigurationPanel>}
 */
BooleanParameter.prototype.getConfigurationPanel = function() {
	return import("../../builder/configuration/parameters/BooleanParameterConfigurationPanel").then(
		({ default: ParameterConfigurationPanel }) => new ParameterConfigurationPanel(this)
	);
};

export default BooleanParameter;
