import NumberParameter from "./NumberParameter";
import Promisify from "@esko/promisify";
/**
 * Css Size Parameter
 * @augments Parameter
 * @param {String} name             - name of the parameter
 * @param {String} userFriendlyName - user friendly representation of the parameter
 */
var CssSizeParameter = function(name, context, userFriendlyName, unitTypes) {
	NumberParameter.call(this, name, context, userFriendlyName, "", { type: "int", max: 999, min: 0 }, unitTypes || ["px", "%", "em"]);
};

CssSizeParameter.prototype = Object.create(NumberParameter.prototype);
CssSizeParameter.prototype.constructor = CssSizeParameter;

/**
 * Override
 */
CssSizeParameter.prototype.getType = function() {
	return "dashboard/core/parameters/CssSizeParameter";
};

export default CssSizeParameter;
