import Parameter from "./Parameter";
import Promisify from "@esko/promisify";
/**
 * HTML Parameter
 * @augments Parameter
 * @param {String} name             - name of the parameter
 * @param {String} userFriendlyName - user friendly representation of the parameter
 */
var HTMLParameter = function(name, context, userFriendlyName) {
	Parameter.call(this, name, context, "dashboard/core/parameters/HTMLParameter", userFriendlyName);
};

HTMLParameter.prototype = Object.create(Parameter.prototype);
HTMLParameter.prototype.constructor = HTMLParameter;

/**
 * Get the configuration element for the parameter
 * @returns {Promise.<ConfigurationPanel>}
 */
HTMLParameter.prototype.getConfigurationPanel = function() {
	return import("../../builder/configuration/parameters/HTMLParameterConfigurationPanel").then(
		({ default: ParameterConfigurationPanel }) => new ParameterConfigurationPanel(this)
	);
};

export default HTMLParameter;
