import LanguageBundle from "./LanguageBundle";
/**
 * A LanguageProvider provides a mechanism to load language/translation bundles
 * @class
 * @constructor
 */
var LanguageProvider = function LanguageProvider() {};

/**
 * Get a translation bundle for a certain id
 * @param {String} bundleName
 * @returns {Promise.<LanguageBundle>}
 */
LanguageProvider.prototype.getLanguageBundle = function(bundleName) {
	// This function needs to be override by some real logic, now the languagebundle will always just display the default value
	return Promise.resolve().then(function() {
		return new LanguageBundle();
	});
};

export default LanguageProvider;
