import BlockWrapper from "../BlockWrapper";
import $ from "jquery";
/**
 * BlockWrapper for elements in a FlexLayout
 * @augments BlockWrapper
 * @param {String} id
 * @param {Context} context
 */
var FlexLayoutBlockWrapper = function(id, context) {
	BlockWrapper.call(this, id, context);
};

FlexLayoutBlockWrapper.prototype = Object.create(BlockWrapper.prototype);
FlexLayoutBlockWrapper.prototype.constructor = FlexLayoutBlockWrapper;

/**
 * Enable/disable Dragging
 * @override
 */
FlexLayoutBlockWrapper.prototype.toggleDragging = function() {
	this._dragDropHandler.toggleDragging(
		this.allowConfigure(),
		this._context,
		this._context.getBlockDefinition(this._blockID),
		this.getParent(),
		this._element,
		this._headerHandle, //the element where dragging is possible from
		function(event, ui) {
			//start
			var flexLayout = this.getParent();
			var flexItem = flexLayout.getFlexItemForID(this._block.getID());
			flexLayout.replaceColumnWithBlock(flexItem.getID(), null);
			ui.helper.data("FlexLayoutFlexItem", flexItem);
		}.bind(this),
		function(event, ui) {
			//stop
			var flexItem = ui.helper.data("FlexLayoutFlexItem");
			var flexLayout = flexItem.getLayout();
			// always add the element back to flexitems (even for a valid drop, in this way the config will be correct for undoable action)
			flexLayout.replaceColumnWithBlock(flexItem.getID(), this._block.getID());
		}.bind(this)
	);
};

export default FlexLayoutBlockWrapper;
