var interval = function(interval, fn, itrs, options) {
	if (typeof interval !== "number") {
		throw "first argument should be a number specifying the interval in ms";
	}
	if (typeof fn !== "function") {
		throw "second argument should be a function";
	}
	if (typeof itrs !== "number" || itrs <= 0) {
		throw "third argument should be a positive number inidcating how many times the function should be called";
	}

	var i = itrs;
	var currentTimeout;
	options = options || {};
	var doLeadingCall = options.leading !== false;

	// Do a single iteration
	var doIteration = function() {
		currentTimeout = setTimeout(function() {
			if (i > 0) {
				fn();
				i--;
				doIteration();
			} else {
				currentTimeout = null;
			}
		}, interval);
	};

	// start the iterations
	var startIterations = function() {
		if (doLeadingCall) {
			fn();
			i--;
		}
		doIteration();
	};

	startIterations();

	return function(newItrs) {
		if (newItrs == undefined) {
			i = itrs;
		} else {
			i = newItrs;
		}
		if (!currentTimeout && i > 0) {
			startIterations();
		}
	};
};

export default interval;
