import React from "react";

const sizeToFontSize = {
	small: "12px",
	normal: "16px",
	large: "32px",
	xl: "64px",
	xxl: "128px",
	mobile: "24px"
};

function getDisplayName(WrappedComponent) {
	return WrappedComponent.displayName || WrappedComponent.name || "Component";
}

export default SvgIcon => {
	class Icon extends React.PureComponent {
		render() {
			const { size, color, style, ...props } = this.props;
			return (
				<SvgIcon
					style={{
						fontSize: sizeToFontSize[size],
						fill: "currentColor",
						color: color,
						...style
					}}
					{...props}
				/>
			);
		}
	}

	Icon.displayName = `Icon(${getDisplayName(SvgIcon)})`;
	Icon.defaultProps = {
		size: "normal"
	};

	return Icon;
};
