var Command = function(doCallback, undoCallback, description) {
	this._do = doCallback;
	this._undo = undoCallback;
	this._description = description;
};

/**
 * Execute the command
 */
Command.prototype.executeDo = function() {
	return this._do();
};

/**
 * Revert the actions done by the command
 */
Command.prototype.executeUndo = function() {
	return this._undo();
};

/**
 * Get the description of the command
 * returns {String}
 */
Command.prototype.getDescription = function() {
	return this._description;
};

export default Command;
