import Map from "@esko/map";
/**
 * @class StringSet is an implementation of the set datastructure for storing strings. It can contain unique strings
 * @constructor
 * @augments Utils.Map
 */
var StringSet = function() {
	Map.call(this);
};

StringSet.prototype = Object.create(Map.prototype);
StringSet.prototype.constructor = StringSet;

/**
 * @override
 * @param {String} key - add a key
 */
StringSet.prototype.add = function(key) {
	Map.prototype.add.call(this, key, true);
};

/**
 * @override
 * @param {String} key - the name of the entry
 * @returns {String} the key if the key exists (or undefined)
 */
StringSet.prototype.get = function(key) {
	if (this.has(key)) {
		return key;
	} else {
		return undefined;
	}
};

/**
 * returns the list of entry names
 * @override
 * @returns {Array.<String>}
 */
StringSet.prototype.values = function() {
	return this.entries();
};

export default StringSet;
