var exec = require('child_process').exec;
var less = require("gulp-less");
var CleanCSS = require("gulp-clean-css");

module.exports = function (gulp, taskName) {
	// Files need to be checked out, otherwise errors appears when trying to overwrite the css/less files
	function p4edit(style) {
		var checkoutCss = new Promise(function (resolve) {
			exec(`p4 edit layout/${style}/css/${style}.css`, function (err, stdout, stderr) {
				if(stderr) {
					console.error(stderr);
				}
				resolve();
			});
		});

		var checkoutLess = new Promise(function (resolve) {
			exec(`p4 edit layout/${style}/less/${style}.less`, function (err, stdout, stderr) {
				if(stderr) {
					console.error(stderr);
				}
				resolve();
			});
		});
		return Promise.all([checkoutCss, checkoutLess]);
	};

	// Build the actual less file
	function buildLess(style) {
		return p4edit(style).then(function () {
			return new Promise(function (resolve) {
				gulp.src(`layout/${style}/less/${style}.less`)
					.pipe(less()
						.on("error", console.error.bind(console)))
					.pipe(new CleanCSS({inline: false}))
					.pipe(gulp.dest(`layout/${style}/css`))
					.on('finish', function () {
						resolve();
					});
			});
		});
	};

	// Register the build task
	gulp.task(taskName, function () {
		return Promise.all([buildLess("print"), buildLess("flex"), buildLess("desktop"), buildLess("mobile")]);
	});
};
