import Annotation from "@esko/web-viewer/annotation/Annotation";
import AnnotationConstants from "@esko/web-viewer/annotation/AnnotationConstants";
/**
 * An annotation for a 3D document, expects window model annotation
 * @param {ViewerFacade} f
 * @param {String} originType
 */
var Annotation3D = function() {
	Annotation.apply(this, arguments);
};

Annotation3D.prototype = Object.create(Annotation.prototype);
Annotation3D.prototype.constructor = Annotation3D;

Annotation3D.prototype.getPermissionFor = function(action) {
	if (action === AnnotationConstants.ActionPermissions.ZOOM_TO_ANNOTATION) {
		return false;
	}
	return Annotation.prototype.getPermissionFor.call(this, action);
};

Annotation3D.prototype._migrate = function(x1, y1, x2, y2) {
	// Migration step, 2D annotations on 3D models from version "undefined" to "1"
	if (isNaN(this._view3DVersion)) {
		return [x1 - 50, y1 - 50, x2 - 50, y2 - 50];
	}
	return [x1, y1, x2, y2];
};

Annotation3D.prototype._modifyAnnotatationCoords = function(x1, y2, x2, y1) {
	return this._migrate(x1, y2, x2, y1);
};

Annotation3D.prototype._modifyAnnotationPopupCoords = function(x1, y1, x2, y2) {
	return this._migrate(x1, y1, x2, y2);
};

export default Annotation3D;
