/**
 * @memberof AnnotationModule
 */
/**
 * @memberof AnnotationModule
 */
import commentRawGif from "@esko/web-viewer/layout/img/comment-raw.gif";

import commentSelectedRawGif from "@esko/web-viewer/layout/img/commentselected-raw.gif";

export default {
	AccessRight: {
		READ_ONLY: 0,
		READ_WRITE: 1
	},
	ActionPermissions: {
		DUPLICATE_WITHOUT_TEXT: "duplicateWithoutText",
		DUPLICATE: "duplicateAnnotation",
		CAN_BE_REPLIED_TO: "canBeRepliedTo",
		ZOOM_TO_ANNOTATION: "zoomToAnnotation"
	},
	AnnotationType: {
		ANNOT_RECT: 0,
		ANNOT_ELLIPSE: 4,
		ANNOT_HIGHLIGHT: 6,
		ANNOT_LINE: 1,
		ANNOT_ARROW: 5,
		ANNOT_PIN: 11,
		ANNOT_FREEFORM: 3
	},

	AnnotationPin: {
		normal: commentRawGif,
		highlighted: commentSelectedRawGif,
		imagehotspotx: 0,
		imagehotspoty: 0,
		imagetouchspotx: 0,
		imagetouchspoty: 0,
		imagetouchspotw: 26,
		imagetouchspoth: 24,
		imagewidth: 26,
		imageheight: 24
	},

	AnnotationElementName: {
		0: "square",
		4: "circle",
		6: "highlight",
		1: "line",
		5: "line",
		11: "text",
		3: "ink"
	},

	AnnotationReplyName: {
		0: "Rectangle",
		4: "Oval",
		6: "Highlight",
		1: "Line",
		5: "Arrow",
		11: "Note",
		3: "Freehand"
	},

	AnnotationReviewState: {
		STATUS_ACCEPTED: "Accepted",
		STATUS_REJECTED: "Rejected",
		STATUS_CANCELLED: "Cancelled",
		STATUS_COMPLETED: "Completed",
		STATUS_NONE: "None"
	},

	AnnotationReviewStateIcons: {
		STATUS_ACCEPTED: "icon-WCR_Approve",
		STATUS_REJECTED: "icon-WCR_Reject",
		STATUS_CANCELLED: "icon-WCR_Canceled",
		STATUS_COMPLETED: "icon-WCR_Approve WCR_Completed",
		STATUS_NONE: "None"
	},

	AnnotationReviewStateLocs: {
		STATUS_ACCEPTED: "AnnStatusAccepted",
		STATUS_REJECTED: "AnnStatusRejected",
		STATUS_CANCELLED: "AnnStatusCancelled",
		STATUS_COMPLETED: "AnnStatusCompleted",
		STATUS_NONE: "AnnStatusNone"
	},

	AnnotationSortType: {
		SORT_BY_MODIFICATION_DATE: 0,
		SORT_BY_CREATION_DATE: 1
	},

	StepThroughMode: {
		WITH_REPLIES: 0,
		BY_THREAD: 1,
		WITH_ZOOM: 2,
		WITH_LINKED: 3
	},

	AnnotationViewType: {
		VIEWTYPE_ALL: 0,
		VIEWTYPE_ONLYFILE: 1,
		VIEWTYPE_ONLYDIFF: 2,
		VIEWTYPE_NONE: 3
	},
	/**
	 * Translation keys for annotation type
	 */
	AnnotationComments: {
		0: "AnnCommRect",
		4: "AnnCommOval",
		6: "AnnCommHighlight",
		1: "AnnCommLine",
		5: "AnnCommArrow",
		11: "AnnCommNote",
		3: "AnnCommFreehand"
	},
	/**
	 * all annotation icons
	 */
	AnnotationIcons: {
		0: "annotRect",
		4: "annotOval",
		6: "annotHighlight",
		1: "annotLine",
		5: "annotArrow",
		11: "annotNote",
		3: "annotFreehand"
	},
	/**
	 * Annotation Type to css Icon class
	 */
	AnnotationToolIcons: {
		0: {
			icon: "icon-WCR_Annotation-Rect icon-danger"
		},
		4: {
			icon: "icon-WCR_Annotation-Oval icon-danger"
		},
		6: {
			icon: "icon icon-WCR_Annotation-Highlight-cont",
			sub: ["icon icon-WCR_Annotation-Highlight-sub icon-yellow"]
		},
		1: {
			icon: "icon-WCR_Annotation-Line icon-danger"
		},
		5: {
			icon: "icon-WCR_Annotation-Arrow icon-danger"
		},
		11: {
			icon: "addNote"
		},
		3: {
			icon: "icon-WCR_Annotation-Freehand icon-danger"
		}
	},
	/**
	 * Which mode of annotating the document is used (relationship approval/annotations)
	 */
	annotateMode: {
		NO_RESTRICTIONS: 0,
		IF_APPROVED_SHOW_WARNING: 1,
		IF_APPROVED_DISABLE: 2,
		ALWAYS_DISABLE: 3,
		IF_APPROVED_OR_REJECTED_SHOW_WARNING: 4,
		IF_APPROVED_OR_REJECTED_DISABLE: 5
	},

	/**
	 * Which people are allow to add annotations
	 */
	allowedAnnotators: {
		ALL: 0, // All Users can annotate
		ALL_APPROVERS: 1, // All people in approval setup can annotate
		ALL_APPROVERS_AND_MASTER: 2, // All people in approval setup + approval master can annotate
		PENDING_APPROVERS: 3, // Only approvers in the currently active cycle can annotate
		PENDING_APPROVERS_AND_MASTER: 4 // Only approvers in the currently active cycle + approval master can annotate
	},

	/**
	 * Operators that can be used in the custor filter popup.
	 */
	FilterOperators: {
		ALL: 0,
		ANY: 1
	},

	/**
	 * Different types for the annotation filter
	 */
	FilterTypes: {
		AUTHOR: 0,
		REVIEWSTATE: 1,
		REVIEWAUTHORANDSTATE: 2,
		TYPE: 3
	},

	/**
	 * Location keys for the filter types
	 */
	FilterTypeNameLocs: {
		AUTHOR: "AnnotFilterAuthor",
		REVIEWSTATE: "AnnotFilterReviewState",
		REVIEWAUTHORANDSTATE: "AnnotFilterReviewAuthorAndState"
	},

	/**
	 * The condition for the specific filter
	 */
	FilterCondition: {
		IS: 0,
		ISNOT: 1
	},

	/**
	 * Define the types of buttons available in the annotation origin selector
	 * values are of type: {
	 *  id: <String> should be the same as the key
	 *  icon: <String> icon class to display
	 *  [subIcon]: <String> optional sub icon class
	 *  langKey: <String> key used to translate the tooltip
	 *  group: <String> group to which this type belongs to
	 *  hideBtnOnEmpty: <Boolean> if the button should be shown if no annotations of this type exist
	 *  hideBtnOnGroupEmpty: <Boolean> if the button should be hidden if there are no annotations in that group
	 * (as defined by group property). hideBtnOnEmpty has higher priority then this property
	 * }
	 *
	 */
	AnnotationOriginTypes: {
		user: {
			id: "user",
			icon: "icon-WCR_AutoReview-cont icon-red",
			subIcon: "icon-WCR_User12 icon-default",
			langKey: "userAnnotations",
			group: "user"
		},
		barcode: {
			id: "barcode",
			icon: "icon-WCR_AutoReview-cont icon-red",
			subIcon: "icon-WCR_AutoReview-Barcode-sub icon-default",
			langKey: "barcodeGVAnnotations",
			group: "GV",
			hideBtnOnGroupEmpty: true
		},
		braille: {
			id: "braille",
			icon: "icon-WCR_AutoReview-cont icon-red",
			subIcon: "icon-WCR_AutoReview-Braille-sub icon-default",
			langKey: "brailleGVAnnotations",
			group: "GV",
			hideBtnOnGroupEmpty: true
		},
		spelling: {
			id: "spelling",
			icon: "icon-WCR_AutoReview-cont icon-red",
			subIcon: "icon-WCR_AutoReview-Spell-sub icon-default",
			langKey: "spellingGVAnnotations",
			group: "GV",
			hideBtnOnGroupEmpty: true
		},
		artwork: {
			id: "artwork",
			icon: "icon-WCR_AutoReview-cont icon-red",
			subIcon: "icon-WCR_AutoReview-Artwork-sub icon-default",
			langKey: "artworkGVAnnotations",
			group: "GV",
			hideBtnOnGroupEmpty: true
		},
		text: {
			id: "text",
			icon: "icon-WCR_AutoReview-cont icon-red",
			subIcon: "icon-WCR_AutoReview-Text-sub icon-default",
			langKey: "textGVAnnotations",
			group: "GV",
			hideBtnOnGroupEmpty: true
		},
		editor: {
			id: "editor",
			icon: "icon-WCR_AutoReview-cont icon-red",
			subIcon: "icon-WCR_AutoReview-Esko-sub icon-default",
			langKey: "editorAnnotations",
			hideBtnOnEmpty: true,
			group: "ext"
		},
		acrobat: {
			id: "acrobat",
			icon: "icon-WCR_AutoReview-cont icon-red",
			subIcon: "icon-WCR_AutoReview-Acrobat-sub icon-default",
			langKey: "acrobatAnnotations",
			hideBtnOnEmpty: true,
			group: "ext"
		},
		ext: {
			id: "ext",
			icon: "icon-WCR_AutoReview-cont icon-red",
			subIcon: "icon-WCR_AutoReview-External-sub icon-default",
			langKey: "extAnnotations",
			hideBtnOnEmpty: true,
			group: "ext"
		}
	}
};
