import Annotation from "@esko/web-viewer/annotation/Annotation";
import Annotation3D from "@esko/web-viewer/annotation/Annotation3D";
/**
 * Creates annotations for the current active page
 *
 * @class
 * @param {Core.ViewerFacade} f
 */
var AnnotationFactory = function(f) {
	this.f = f;
};

/**
 * Creates a default annotation for the current active page
 *
 * @returns {Annotation}
 */
AnnotationFactory.prototype.create = function() {
	if (this.f.getActivePage().is3D && this.f.getActivePage().is3D()) {
		return new Annotation3D(this.f);
	}
	return new Annotation(this.f);
};

export default AnnotationFactory;
