var Lock = function(onAllReleased, onLock) {
	/**
	 *  amount of locks
	 */
	var locks = 0;
	var reasons = [];
	this.getLock = function() {
		var locked = false;
		var myReason = {};
		return {
			release: function() {
				if (locked) {
					locked = false;
					locks--;

					if (locks === 0) {
						onAllReleased && onAllReleased();
					}
				}
				reasons = reasons.filter(function(reason) {
					return reason !== myReason;
				});
				return this;
			},
			lock: function(reason) {
				myReason.reason = reason;
				if (!locked) {
					reasons.push(myReason);
					locked = true;
					locks++;
					if (locks === 1) {
						onLock && onLock(reason);
					}
				}
				return this;
			}
		};
	};

	Object.defineProperty(this, "locked", {
		get: function() {
			return locks !== 0;
		}
	});
	Object.defineProperty(this, "reasons", {
		get: function() {
			return reasons.map(function(reason) {
				return reason.reason;
			});
		}
	});
};

export default Lock;
