import _ from "underscore";
import CompareConstants from "@esko/web-viewer/compare/CompareConstants";

export default {
	mixin: function(object) {
		object.hasCad = function() {
			return true;
		};

		object.has3D = function() {
			return this.get("has3DPerspective");
		};

		object.hasGraphics = function() {
			return false;
		};
		object.getAvailableCompareModes = function(refPage) {
			var modes = [];
			if (!refPage || this.getDocument().getDocumentType() === refPage.getDocument().getDocumentType()) {
				modes.push.apply(modes, [
					CompareConstants.mode.SIDEBYSIDE,
					CompareConstants.mode.SHOW_CURRENT,
					CompareConstants.mode.SHOW_DIFFERENCE,
					CompareConstants.mode.BLINKING,
					CompareConstants.mode.READERSPREAD,
					CompareConstants.mode.ALIGNMENT,
					CompareConstants.mode.DIFFERENCE,
					CompareConstants.mode.SHOWBOTHONTOP
				]);
			}

			if (this.has3D()) {
				modes.push(CompareConstants.mode.SIDEBYSIDE3D);
				modes.push(CompareConstants.mode.BLINKING3D);
				modes.push(CompareConstants.mode.CURRENT3D);
				modes.push(CompareConstants.mode.REFERENCE3D);
			}

			return modes;
		};
	}
};
