import LineworkWrapper from "@esko/web-viewer/utils/LineworkWrapper";
import DrawUtils from "@esko/web-viewer/utils/DrawUtils";
import ShapeUtils from "@esko/shapeutils";
/**
 * @exports CadOneupName
 * @memberof CadModule
 * @class CadOneupName is a LineworkWrapper object that is used to display name of a oneup
 * @augments Utils.LineworkWrapper
 * @constructor
 * @param {String} name - Name of the oneup
 * @param {ShapeUtils.Rect} rect - rect for where the one up needs to be in the world
 */
var CadOneupName = function(name, rect) {
	LineworkWrapper.call(this);

	this.type = DrawUtils.LWTYPE_TEXT;
	this.staticsize = false;

	this.textoptions["rotation"] = 0;
	this.textoptions["font-family"] = "Arial";
	this.textoptions["font-size"] = "21";
	this.textoptions["text"] = name;
	this.textoptions["textAlignment"] = "center";

	this.color = "blue";

	this.rect = new ShapeUtils.Rect(rect.center(), null);
};

// inherit
CadOneupName.prototype = Object.create(LineworkWrapper.prototype);
// correct the constructor pointer
CadOneupName.prototype.constructor = CadOneupName;

export default CadOneupName;
