/**
 * @namespace Data
 */
/**
 * @namespace Data
 */
var AbstractCompareDataAdapter = function(f) {
	/**
	 * @protected
	 */
	this.f = f;
};

/**
 * Save the CAD overlay settings
 * @param {AbstractDocumentPage} graphicsPage - the graphics page in which the CAD reference should be stored
 * @param {AbstractDocumentPage} cadOverlay   - the CAD document that should be set as reference
 * @param {Number}               rotation     - rotation of the CAD overlay (0,90,180,270 degrees)
 * @param {Boolean}              isFlipped    - is the CAD overlay flipped
 * @param {ShapeUtils.Point}     offset       - the offset for the CAD overlay
 * @param {Function}             [callback]   - callback function to be called when CAD overlay is saved (first parameter of the callback is a boolean indicating success)
 */
AbstractCompareDataAdapter.prototype.saveCadOverlay = function(graphicsPage, CADPage, rotation, isFlipped, offset, callback) {
	// to be implemented by a specific dataAdapter
	throw "Not implemented: AbstractCompareDataAdapter.saveCadOverlay";
};

AbstractCompareDataAdapter.prototype.convertCompareParameters = function(compareModel, params) {
	throw "Not implemented: AbstractCompareDataAdapter.convertCompareParameters";
};

export default AbstractCompareDataAdapter;
