import _ from "underscore";
import CompareMode from "@esko/web-viewer/compare/CompareMode";
import CompareConst from "@esko/web-viewer/compare/CompareConstants";
import LayoutConstants from "@esko/web-viewer/layout/LayoutConstants";
import ViewportConstants from "@esko/web-viewer/viewport/ViewportConstants";
import ListenerUtil from "@esko/web-viewer/utils/ListenerUtil";
/**
 * @memberof CompareModule
 * @exports Compare3DCurrent
 * @class This mode shows the 3D view of the active document.
 * @constructor
 * @param {Core.ViewerFacade} f
 * @param {CompareModule.CompareModel} compareModel - model for compare
 */
var Compare3DCurrent = function(f, compareModel) {
	CompareMode.call(this, f, CompareConst.mode.CURRENT3D, compareModel, true, "DiffShow3DSideBySide");
	ListenerUtil.mixin(this, f);
};

Compare3DCurrent.prototype = Object.create(CompareMode.prototype);
Compare3DCurrent.prototype.constructor = Compare3DCurrent;

/**
 * Start/stop show compare mode
 * @param {Boolean} toggle
 * @override
 */
Compare3DCurrent.prototype.toggle = function(toggle, diffMode) {
	CompareMode.prototype.toggle.call(this, toggle, diffMode);
	this._compareModel.setDiffMode(toggle ? CompareConst.diffMode.SHOWCURRENT3D : CompareConst.diffMode.UNDEFINED);
};

Compare3DCurrent.prototype.getLayoutMode = function() {
	return LayoutConstants.LayoutMode.COMPARE_3D;
};

export default Compare3DCurrent;
