import _ from "underscore";
import CompareMode from "@esko/web-viewer/compare/CompareMode";
import CompareConst from "@esko/web-viewer/compare/CompareConstants";
import LayoutConstants from "@esko/web-viewer/layout/LayoutConstants";
import ViewportConstants from "@esko/web-viewer/viewport/ViewportConstants";
import ListenerUtil from "@esko/web-viewer/utils/ListenerUtil";
/**
 * @memberof CompareModule
 * @exports Compare3DReference
 * @class This mode shows the 3D view of the difference document
 * @constructor
 * @param {Core.ViewerFacade} f
 * @param {CompareModule.CompareModel} compareModel - model for compare
 */
var Compare3DReference = function(f, compareModel) {
	CompareMode.call(this, f, CompareConst.mode.REFERENCE3D, compareModel, true, "DiffShow3DSideBySide");
	ListenerUtil.mixin(this, f);
};

Compare3DReference.prototype = Object.create(CompareMode.prototype);
Compare3DReference.prototype.constructor = Compare3DReference;

/**
 * Start/stop show compare mode
 * @param {Boolean} toggle
 * @override
 */
Compare3DReference.prototype.toggle = function(toggle, diffMode) {
	CompareMode.prototype.toggle.call(this, toggle, diffMode);
	this._compareModel.setDiffMode(toggle ? CompareConst.diffMode.SHOWDIFFERENCE3D : CompareConst.diffMode.UNDEFINED);
	if (toggle) {
		this.f.whenModuleAvailable("view3D", function(view3D) {
			view3D.set3DDifferenceEnabled(toggle);
		});
	}
};

Compare3DReference.prototype.getLayoutMode = function() {
	return LayoutConstants.LayoutMode.COMPARE_3D;
};

export default Compare3DReference;
