import _ from "underscore";
import CompareMode from "@esko/web-viewer/compare/CompareMode";
import CompareConst from "@esko/web-viewer/compare/CompareConstants";
/**
 * @memberof CompareModule
 * @exports CompareShowBothOnTopMode
 * @class Deadsimple compare mode that shows the two documents on top of eachother
 * @constructor
 * @param {Core.ViewerFacade} f
 * @param {Compare.CompareModel} compareModel - model for compare
 */
var CompareShowBothOnTopMode = function(f, compareModel) {
	CompareMode.call(this, f, CompareConst.mode.SHOWBOTHONTOP, compareModel, true, "DiffShowBothOnTopAnnotationsHidden");
};

CompareShowBothOnTopMode.prototype = Object.create(CompareMode.prototype);
CompareShowBothOnTopMode.prototype.constructor = CompareShowBothOnTopMode;

/**
 * Start/stop compare mode
 */
CompareShowBothOnTopMode.prototype.toggle = function(toggle) {
	CompareMode.prototype.toggle.call(this, toggle);
	this._compareModel.setDiffMode(toggle ? CompareConst.diffMode.SHOWBOTHONTOP : CompareConst.diffMode.UNDEFINED);
};

export default CompareShowBothOnTopMode;
