import _ from "underscore";
import CompareMode from "@esko/web-viewer/compare/CompareMode";
import CompareConst from "@esko/web-viewer/compare/CompareConstants";
/**
 * @memberof CompareModule
 * @exports CompareShowCurrentMode
 * @class Deadsimple compare mode just showing the current document
 * @constructor
 * @param {Core.ViewerFacade} f
 * @param {Compare.CompareModel} compareModel - model for compare
 */
var CompareShowCurrentMode = function(f, compareModel) {
	CompareMode.call(this, f, CompareConst.mode.SHOW_CURRENT, compareModel, false, "", "current");
};

CompareShowCurrentMode.prototype = Object.create(CompareMode.prototype);
CompareShowCurrentMode.prototype.constructor = CompareShowCurrentMode;

/**
 * Start/stop show compare mode
 */
CompareShowCurrentMode.prototype.toggle = function(toggle) {
	CompareMode.prototype.toggle.call(this, toggle);
	this._compareModel.setDiffMode(toggle ? CompareConst.diffMode.CURRENTVERSION : CompareConst.diffMode.UNDEFINED);
	var viewport = this.f.getModule("viewport");
	if (viewport) {
		var currentFilePanel = viewport.getPanelModel("default");
		currentFilePanel.toggleLayer("Graphics", !toggle || this.f.getActivePage().hasGraphics());
	}
};

export default CompareShowCurrentMode;
