import AbstractModule from "@esko/web-viewer/core/AbstractModule";
import HTTPUtils from "@esko/httputils";

/**
 * This represents an abstract connection module.
 * This module will be fetched by multiple other modules in order to load information from other web services.
 *
 * @param {ViewerFacade} f
 */
var AbstractConnectionModule = function(f) {
	AbstractModule.call(this, f, true, "connection");
};

AbstractConnectionModule.prototype = Object.create(AbstractModule.prototype);
AbstractConnectionModule.prototype.constructor = AbstractConnectionModule;

/**
 * Example of an abstract "fetch function"
 *
 * @param {any} data
 * @param {any} callback
 */
AbstractConnectionModule.prototype.fetch = function(data, callback) {
	throw "Not implemented: fetch";
};

AbstractConnectionModule.prototype.generateUrl = function(context) {
	return HTTPUtils.constructURL(context.servlet, context.params);
};

export default AbstractConnectionModule;
