export default {
	TOOLS: {
		PAN: "pan",
		ZOOM: "zoom",
		TOUCH: "touch",
		NOTOUCH: "notouch",
		ANNOTATION: "annotationtool",
		DYNCONTENT: "dyncontenttool",
		ANNOTATION_TOUCH_DRAW: "annotationTouchDrawTool",
		ANNOTATION_TOUCH: "annotationTouchTool",
		ANNOTATION_DRAW: "annotationdrawtool",
		ANNOTATION_NOTE_DRAW: "annotationnotetool",
		ANNOTATION_INDICATOR: "annotationindicatortool",
		COMPARE_ANCHOR_ALIGNMENT: "compareAnchorTool",
		MEASURE_BARCODE: "measureBarcodeTool",
		MEASURE_BRAILLE: "measureBrailleTool",
		MEASURE_EYEDROPPER: "measureEyeDropperTool",
		MEASURE_RULER: "measureRulerTool",
		MEASURE_CALIPER: "measureCaliperTool",
		MEASURE_SCREEN_RULING: "measureScreenRulingTool",
		INTERRUPT: "interruptTool",
		NAVIGATIONPAN: "navigationPanTool",
		MOUSE_LOCATOR: "mouseLocatorTool",
		TEXTSELECTION: "textSelectionTool",
		VIDEOTOOL: "videoTool"
	},
	SizeUnits: {
		// linked to similar EyeDropperUnits
		MM: 0,
		CM: 1,
		INCH: 2,
		PIXELS: 3,
		POINTS: 4
	},
	EyeDropperUnits: {
		// linked to similar SizeUnits
		SQMM: 0,
		SQCM: 1,
		SQINCH: 2,
		PIXELS: 3,
		PERCENT: 5
	},
	ResolutionUnits: {
		PPI: 0,
		PPMM: 1,
		PPCM: 2
	},
	/**
	 * Mapping array for the unit localized names, see SizeUnits
	 */
	UnitsLocNames: ["Unitmm", "Unitcm", "UnitInchShort", "UnitPixelsShort", "UnitPoint"],
	/**
	 * Mapping array for the unit fixes, see SizeUnits
	 */
	UnitsFixes: [2, 3, 3, 0, 1],

	/**
	 * Mapping array for the resolution unit localized names, see ResolutionUnits
	 */
	ResUnitsLocNames: ["UnitResInch", "UnitResmm", "UnitRescm"],

	/**
	 * Mapping array for the resolution unit fixes, see ResolutionUnits
	 */
	ResUnitsFixes: [3, 2, 3],

	/**
	 * Mapping array for the screen ruling units (localized names), see ResolutionUnits
	 */
	ScreenUnitsLocNames: ["UnitScreenInch", "UnitScreenmm", "UnitScreencm"],
	/**
	 * Mapping array for the screen ruling unit fixes, see ResolutionUnits
	 */
	ScreenUnitsFixes: [2, 1, 2],

	/**
	 * Mapping array for eye dropper unit localized names, see EyeDropperUnits
	 */
	EyeDropperUnitsLocNames: ["Unitmm2", "Unitcm2", "UnitInch2", "UnitPixels", "", "UnitPercent"],
	EyeDropperUnitsShortLocNames: ["Unitmm2", "Unitcm2", "UnitInch2Short", "UnitPixelsShort", "", "UnitPercent"],
	/**
	 * Mapping array for eye dropper unit fixes, see EyeDropperUnits
	 */
	EyeDropperUnitsFixes: [2, 3, 3, 0, 0, 2]
};
