import BundleResolver from "@esko/i18n/BundleResolver";
/**
 * Default implementation of the BundleResolver
 *
 */
var DefaultBundleResolver = function() {
	BundleResolver.call(this);
};

DefaultBundleResolver.prototype = Object.create(BundleResolver.prototype);
DefaultBundleResolver.prototype.constructor = DefaultBundleResolver;

/**
 * Will resolve a bundle to a path based on the given bundleName and requested locale
 *
 * @param {String} bundleName
 * @param {String} locale
 * @param {Function} callback Will be called with the loaded bundle
 */
DefaultBundleResolver.prototype.fetch = function(bundleName, locale, timestamp, callback) {
	import("@esko/web-viewer/i18n/bundles/" + bundleName + "/" + locale).then(({ default: bundle }) => {
		callback(bundle);
	});
};

export default DefaultBundleResolver;
