import $ from "jquery";

/**
 * a wrapper for toolbar components so that the layout can hide toolbar components independently from the widget itself.
 * @param {ToolbarComponent} toolbarcomponent
 */
var ToolbarComponentWrapper = function(toolbarcomponent) {
	/**
	 *  Create a wrapper object with the toolbar component as prototype
	 */
	var toolbarComponentWrapper = Object.create(toolbarcomponent);

	/**
	 * div in which the toolbar component is rendered
	 */
	toolbarComponentWrapper.element = $("<div>", { class: "toolbar-component-wrapper" });
	toolbarComponentWrapper.element.append(toolbarcomponent.element);

	/** in addition to the methods of the toolbar component the wrapper has its own setVisible method */
	toolbarComponentWrapper.setVisible = function(visible) {
		visible ? this.element.removeClass("displayNone") : this.element.addClass("displayNone");
	};

	return toolbarComponentWrapper;
};

export default ToolbarComponentWrapper;
