import RichTextEditorTextarea from "@esko/web-viewer/layout/component/RichTextEditorTextarea";
import RichTextEditorTinyMCE from "@esko/web-viewer/layout/component/RichTextEditorTinyMCE";

export default {
	/**
	 * Create a new editor instance, depending on the used  device a TinyMCE or Textarea editor is created
	 * @param {ViewerFacade} f
	 * @returns {RichTextEditor}
	 */
	createEditor: function(f) {
		if (f.getFeatureDetector().isIOS()) {
			// on iOS tinyMCE has some serious (native) issues, load a textarea editor instead
			return new RichTextEditorTextarea(f);
		} else {
			return new RichTextEditorTinyMCE(f);
		}
	}
};
