import ViewerToolbarButton from "@esko/web-viewer/layout/component/ViewerToolbarButton";
import $ from "jquery";
/**
 * A Button is an interface element which provides an action and can have a text and icon description
 *
 * @exports SubtoolbarButton
 * @constructor
 * @augments Layout.Button
 * @param {String} Name - The name of the button
 * @param {String} icon - The class which is used for displaying the icon
 * @param {Boolean} [forMobile] - If true the button is useful on a mobile device
 * @param {Function} [action] - The function which is called when the button is pressed. This parameter is optional as you can also use listenToTool.
 */
var SubtoolbarButton = function(f, name, icon, forMobile, action) {
	ViewerToolbarButton.call(this, f, name, icon, forMobile, action);

	// Overwrite the styling of the element
	this.element.removeClass("btn").addClass("subtoolbar-btn");
};

SubtoolbarButton.prototype = Object.create(ViewerToolbarButton.prototype);
SubtoolbarButton.prototype.constructor = SubtoolbarButton;

export default SubtoolbarButton;
