var FlexSection = function(context) {
	this._context = context;
};

/**
 * Append an item
 * @param {WidgetWrapper,ToolbarComponent} item - item to add (should have ".element" property)
 */
FlexSection.prototype.appendItem = function(item) {
	this._context.append(item.element);
};

/**
 * Prepend an item before another item
 * @param {WidgetWrapper,ToolbarComponent} itemToPrepend- item to add (should have ".element" property)
 * @param {WidgetWrapper,ToolbarComponent} existingitem - sibbling that hsould be after itemToPrepend  (should have ".element" property)
 */
FlexSection.prototype.prependItemBeforeItem = function(itemToPrepend, existingItem) {
	existingItem.element.before(itemToPrepend.element);
};

/**
 * Returns the context that is used to append all elements
 *
 * @returns {JQueryObj} context
 */
FlexSection.prototype.getContext = function() {
	return this._context;
};

export default FlexSection;
