import DesktopLayout from "@esko/web-viewer/layout/desktop/DesktopLayout";
/**
 * @class
 * Minimal layout that inherits from the desktop layout. It hides all panels so the document is the only visible item on the screen.
 *
 * @exports MinimalLayout
 * @constructor
 * @param {Core.ViewerFacade} f
 * @param {LayoutModel} layoutModel
 * @param {JQueryObj} context - context where the layout will add its components to
 * @param {Object} layoutState
 * @param {LoadingIndicator} loadingIndicator - the loading indicator, which was created before all requests started
 * @param {JQueryObj} initialLoader - the JQuery reference to the element indicating the initial loader (needed to safely remove it without emptying the context)
 */
var MinimalLayout = function(f, layoutModel, context, layoutState, loadingIndicator, initialLoader) {
	DesktopLayout.call(this, f, layoutModel, context, layoutState, loadingIndicator, initialLoader);

	this._layout.top.setDisabled(true);
	this._layout.north.setDisabled(true);
	this._layout.east.setDisabled(true);
	this._layout.west.setDisabled(true);
};

MinimalLayout.prototype = Object.create(DesktopLayout.prototype);
MinimalLayout.prototype.constructor = MinimalLayout;

export default MinimalLayout;
