import SvgLayerModel from "./SvgLayerModel";
/**
 * @class layer model of the difference page
 * @augments SvgLayerModel
 *
 * @param {Core.ViewerFacade} f - Viewer facade
 * @param {String} ID - the ID of the layer model
 * @param {AbstractDocumentPage} page
 */
var SvgDiffLayerModel = function(f, ID, page) {
	SvgLayerModel.call(this, f, ID, page);
	this._registerListener("doc.page.difference", this._updateDiffPage, this);
};

SvgDiffLayerModel.prototype = Object.create(SvgLayerModel.prototype);
SvgDiffLayerModel.prototype.constructor = SvgDiffLayerModel;

/**
 * Updates the page of layer model
 * @param {AbstractDocumentPage} oldPage
 * @param {AbstractDocumentPage} diffPage
 */
SvgLayerModel.prototype._updateDiffPage = function(oldPage, diffPage) {
	this.setPage(diffPage);
};

export default SvgDiffLayerModel;
