import _ from "underscore";
import ShapeUtils from "@esko/shapeutils";
import ConversionConstants from "@esko/web-viewer/utils/ConversionConstants";
var GEOUtils = {
	/**
	 * Convert a ps points number to mm
	 * @param {Number} n - number in ps points to convert to mm
	 * @returns {Number} n converted to mm number
	 */
	convertPSPointsToMM: function(n) {
		// PostScript point was defined as 72 points to the inch (1 point = 1⁄72 inches = 25.4⁄72 mm = 0.3527 mm)
		return n * ConversionConstants.POINTS_TO_MM_RATIO;
	},
	/**
	 * Convert a mm number to ps points
	 * @param {Number} n - number in mm to convert to ps points
	 * @returns {Number} n converted to ps points number
	 */
	convertMMToPSPoints: function(n) {
		// PostScript point was defined as 72 points to the inch (1 point = 1⁄72 inches = 25.4⁄72 mm = 0.3527 mm)
		return n * ConversionConstants.MM_TO_POINT_RATIO;
	}
};

export default GEOUtils;
