import LineworkWrapper from "@esko/web-viewer/utils/LineworkWrapper";
import DrawUtils from "@esko/web-viewer/utils/DrawUtils";
import ShapeUtils from "@esko/shapeutils";
var IMG_SRC = require("@esko/web-viewer/layout/img/crosshair.png");
var IMG_OFFSET = new ShapeUtils.Size(7, 7);

/**
 * @exports SnapIndicator
 * @memberof MeasureModule
 * @class SnapIndicator is a LineworkWrapper object that is used to display a hint to snap to
 * @augments Utils.LineworkWrapper
 * @constructor
 * @param {String} name - Name of the oneup
 * @param {ShapeUtils.Point} [center] - center for where the indication should be
 */

var SnapIndicator = function(center) {
	LineworkWrapper.call(this);

	this.type = DrawUtils.LWTYPE_IMAGE;
	this.linewidth = 0;
	this.imageRef = IMG_SRC;
	this.staticsize = true;
	this.imageOffset = IMG_OFFSET;

	if (center) {
		this.setCenter(center);
	}
};

// inherit
SnapIndicator.prototype = Object.create(LineworkWrapper.prototype);
// correct the constructor pointer
SnapIndicator.prototype.constructor = SnapIndicator;

/**
 * Set the center point of the snap indicator
 * @param {ShapeUtils.Point} center - center of the indicator
 */
SnapIndicator.prototype.setCenter = function(center) {
	this.setRect(new ShapeUtils.Rect(new ShapeUtils.Point(center.x, center.y)));
};

export default SnapIndicator;
