var Timestamp = function Timestamp(time) {
	this.time = time;
};

/**
 * Parses the seconds and converts it to minutes, seconds and milliseconds
 *
 * @returns {Object}
 */
Timestamp.prototype.format = function() {
	var seconds = parseInt(this.time, 10);
	var minutes = Math.floor(seconds / 60);
	seconds = seconds - minutes * 60;
	var ms = Math.floor((this.time * 1000).toFixed(0)) % 1000;

	if (minutes < 10) {
		minutes = "0" + minutes;
	}
	if (seconds < 10) {
		seconds = "0" + seconds;
	}
	if (ms < 10) {
		ms = "00" + ms;
	} else if (ms < 100) {
		ms = "0" + ms;
	}
	return {
		min: minutes,
		sec: seconds,
		ms: ms
	};
};

/**
 * Format the time to a human readable time string
 *
 * @returns
 */
Timestamp.prototype.toString = function() {
	var data = this.format();
	return data.min + ":" + data.sec + ",<small>" + data.ms + "</small>";
};

export default Timestamp;
