import ConversionConstants from "@esko/web-viewer/utils/ConversionConstants";
import ShapeUtils from "@esko/shapeutils";
import CompareConstants from "@esko/web-viewer/compare/CompareConstants";
import LayoutConstants from "@esko/web-viewer/layout/LayoutConstants";
import $ from "jquery";

export default {
	mixin: function(object) {
		object.is3D = function() {
			return true;
		};

		object.getAvailableCompareModes = function(refPage) {
			return [
				CompareConstants.mode.SIDEBYSIDE3D,
				CompareConstants.mode.CURRENT3D,
				CompareConstants.mode.REFERENCE3D,
				CompareConstants.mode.BLINKING3D
			];
		};

		object.areCompareOptionsAllowed = function() {
			return false;
		};

		object.getLayoutMode = function() {
			return LayoutConstants.LayoutMode.THREEDONLY;
		};

		object.getPageSize = function() {
			return new ShapeUtils.Size(1000, 100);
		};
	}
};
