import AbstractView3DWidget from "./AbstractView3DWidget";
import LayoutConstants from "@esko/web-viewer/layout/LayoutConstants";
/**
 * @exports
 * @memberof Compare
 * @augments AbstractView3DWidget
 * @class The View3DWidget shows the 3D Viewer inside a widget of the HTML5 Viewer.
 * @constructor
 *
 * @param {Core.ViewerFacade} f
 */
var CompareView3DWidget = function CompareView3DWidget(f) {
	AbstractView3DWidget.call(this, f, LayoutConstants.Widget.VIEW3D_COMPARE);
};

CompareView3DWidget.prototype = Object.create(AbstractView3DWidget.prototype);
CompareView3DWidget.prototype.constructor = CompareView3DWidget;
CompareView3DWidget.widgetName = LayoutConstants.Widget.VIEW3D_COMPARE;

CompareView3DWidget.prototype._getPage = function() {
	return this.f.getDocumentController().getDifferencePage();
};

CompareView3DWidget.prototype._on3DPerspectiveGenerated = function() {
	var diffPage = this.f.getDocumentController().getDifferencePage();
	if (diffPage != null) {
		diffPage.set("has3DPerspective", true);
	}
};

export default CompareView3DWidget;
