import AbstractView3DWidget from "./AbstractView3DWidget";
import LayoutConstants from "@esko/web-viewer/layout/LayoutConstants";
/**
 * @exports
 * @memberof Compare
 * @augments AbstractView3DWidget
 * @class The View3DWidget shows the 3D Viewer inside a widget of the HTML5 Viewer.
 * @constructor
 *
 * @param {Core.ViewerFacade} f
 */
var View3DWidget = function View3DWidget(f) {
	AbstractView3DWidget.call(this, f, LayoutConstants.Widget.VIEW3D);
};

View3DWidget.prototype = Object.create(AbstractView3DWidget.prototype);
View3DWidget.prototype.constructor = View3DWidget;
View3DWidget.widgetName = LayoutConstants.Widget.VIEW3D;

View3DWidget.prototype._getPage = function() {
	return this.f.getActivePage();
};

View3DWidget.prototype._on3DPerspectiveGenerated = function() {
	this.f.getActivePage().set("has3DPerspective", true);
};

export default View3DWidget;
