/**
 * @namespace Viewport
 */
/**
 * @namespace Viewport
 */
var AbstractViewportDataAdapter = function(f) {
	/**
	 * @protected
	 */
	this.f = f;
};

/**
 * Generate the url parameters for a certain fragment
 * @param {Utils.Fragment} fragment - the fragment for which the URL is generated
 * @returns {String}
 */
AbstractViewportDataAdapter.prototype.generateFragmentURL = function(context, overwriteOptions) {
	throw "Not Implemented: AbstractViewportDataAdapter.generateFragmentURL";
};

/**
 * Get the viewer url
 * @returns {String} e.g. "http(s)://localhost:8081/wcr-static/web-viewer"
 */
AbstractViewportDataAdapter.prototype.loadImageFragment = function(f, name, viewportModule) {
	throw "Not Implemented: AbstractViewportDataAdapter.loadImageFragment";
};

/**
 * Apply overwrite options on the context
 * @param context
 * @param fragmentUrlOverwriteOptions
 */
AbstractViewportDataAdapter.prototype.applyViewportLayerOverwriteOptions = function(context, fragmentUrlOverwriteOptions) {
	throw "Not Implemented: AbstractViewportDataAdapter.applyViewportLayerOverwriteOptions";
};

/*********************************************************************************
 * 		BVON TODO: part of tiling experiment; decide whether or not to keep 	 *
 *********************************************************************************/

/**
 * Return custom fragment loader
 * @return {function}
 */
AbstractViewportDataAdapter.prototype.getCustomFragmentLoader = function(f) {
	return null;
};

/**
 * Indicate whether or not to load data while panning
 * @returns {Boolean}
 */
AbstractViewportDataAdapter.prototype.getTilesWhenPanning = function() {
	return false;
};

AbstractViewportDataAdapter.prototype.getAlternativeName = function(name) {
	return null;
};

export default AbstractViewportDataAdapter;
