import AbstractTool from "@esko/web-viewer/viewport/tools/AbstractTool";
import CoreConstants from "@esko/web-viewer/core/CoreConstants";
/**
 * @exports InterruptTool
 * @memberof ViewportModule
 * @class
 * This tool does nothing but is used to block all other tools in the tool manager.
 * It can be temporary activated and again deactivated by the toolManager.interruptTools event.
 * @constructor
 * @param {Core.ViewerFacade} f - Viewer facade
 */
var InterruptTool = function(f) {
	AbstractTool.call(this, f, CoreConstants.TOOLS.INTERRUPT);
};

InterruptTool.prototype = Object.create(AbstractTool.prototype);
InterruptTool.prototype.constructor = InterruptTool;

/**
 * @override
 * Returns false because this tool can only be controlled (activation/deactivation) by the toolManager.interruptTools event.
 * @returns {Boolean} false
 */
InterruptTool.prototype.canBeInterrupted = function() {
	return false;
};

export default InterruptTool;
