import XDropPanel from "@esko/xdrop/panel/XDropPanel";
import StaticElementXDropDisplay from "@esko/xdrop/display/StaticElementXDropDisplay";
import ToggleController from "@esko/xdrop/controllers/ToggleController";
import XDrop from "@esko/xdrop/XDrop";
import _ from "underscore";
/**
 * Xtendible Dropdown - Button variant
 *
 * @param {jQueryElement} element - the element to attach the XDrop to...
 * @param {XDropDataProvider} dataProvider
 * @param {Object}            renderFactories - map of result type to factory
 * @param {Object}             options         extra options - see XDrop
 * @param {Object}             paneloptions         extra options for the XDroppanel
 */
var ButtonXDrop = function(element, dataProvider, renderFactories, options, panelOptions) {
	this._providedelement = element;
	XDrop.call(this, dataProvider, renderFactories, options, panelOptions);
};

ButtonXDrop.prototype = Object.create(XDrop.prototype);
ButtonXDrop.prototype.constructor = ButtonXDrop;

/**
 * init behavior
 */
ButtonXDrop.prototype._init = function(dataProvider, renderFactories, options, panelOptions) {
	this._panel = new XDropPanel(dataProvider, renderFactories, panelOptions);
	this._display = new StaticElementXDropDisplay(this._providedelement, renderFactories, this._panel, options);
	this._toggleController = new ToggleController(this._display, this._panel, options);
};

/**
 * Update the placeholder of the XDrop and refresh the value to display the new placeholder if needed
 * @param {String} placeholder
 */
ButtonXDrop.prototype.setPlaceHolder = function(placeholder) {
	// NOT SUPPORTED
};

export default ButtonXDrop;
