/*
 * DataProviders are classes that provide data by adding ResultEntry instances to its _resultSet (this._resultSet) 
 * All DataProviders should be a subclass of xdrop/dataproviders/XDropDataProvider
 */
/*
 * DataProviders are classes that provide data by adding ResultEntry instances to its _resultSet (this._resultSet) 
 * All DataProviders should be a subclass of xdrop/dataproviders/XDropDataProvider
 */
import XDropDataProvider from "@esko/xdrop/dataproviders/XDropDataProvider";

import ResultEntry from "@esko/xdrop/dataproviders/ResultEntry";
var ITEMS = 10;

var ExampleDataProvider = function(prefix) {
	XDropDataProvider.call(this);

	this._prefix = prefix ? prefix + " " : "";

	// The example data provider inits it data at  startup
	this._init();
};

ExampleDataProvider.prototype = Object.create(XDropDataProvider.prototype);
ExampleDataProvider.prototype.constructor = ExampleDataProvider;

ExampleDataProvider.prototype._init = function() {
	// Add items to your result set
	this._resultSet.append(this._generateEntry("First Label"));
	for (var i = 1; i < ITEMS; i++) {
		this._resultSet.append(this._generateEntry("LABEL " + i));
	}

	this._labelonepos = 0;

	// Commit changes to notify that the resultSet was changed.
	this._resultSet.commitChanges();
};

/**
 *  @override
 * This function must be overriden to filter the results
 */
ExampleDataProvider.prototype.setQuery = function(text) {
	// Here we remove all the entries in the result set
	this._resultSet.clear();
	if (text.length < 10) {
		for (var i = 0; i < ITEMS; i++) {
			var res =
				Math.random()
					.toString(36)
					.substr(2, 3 + Math.floor(Math.random() * 10)) +
				text +
				Math.random()
					.toString(36)
					.substr(2, 3 + Math.floor(Math.random() * 10));
			// Append the filtered entries to the result set
			this._resultSet.append(this._generateEntry(res));
		}
	}

	// Commit changes when done. This can also be done f.i. after an AJAX request.
	this._resultSet.commitChanges();
};

ExampleDataProvider.prototype._generateEntry = function(label) {
	// The XDrop expects ResultEntry instances. These have a type ("label" in this case) and data (can be anything).
	// The type of the result entry is used to map to the Renderer that will render this ResultEntry in the XDrop
	return new ResultEntry("label", this._prefix + label);
};
export default ExampleDataProvider;
