import Renderer from "@esko/xdrop/renderers/Renderer";
import $ from "jquery";
/**
 * <p>Renders a non-selectable label entry (like for example "No Results")</p>
 *
 * @class DisabledLabelRenderer
 *
 * @class
 * @augments Renderer
 * @param {JQueryObj}   div
 * @param {ResultEntry} resultEntry
 * @param {Object}      api        -  render API
 */
var DisabledLabelRenderer = function(div, resultEntry, api) {
	Renderer.call(this, div, resultEntry, api);

	this._element.text(this._resultEntry.getData());
	this._element.addClass("disabledentry notselectable");
};

DisabledLabelRenderer.prototype = Object.create(Renderer.prototype);
DisabledLabelRenderer.prototype.constructor = DisabledLabelRenderer;

export default {
	make: function(div, resultEntry, api) {
		return new DisabledLabelRenderer(div, resultEntry, api);
	}
};
