import Renderer from "@esko/xdrop/renderers/Renderer";
import $ from "jquery";
/**
 * <p>Renders a non-selectable error entry</p>
 *
 * @class ErrorRenderer
 *
 * @class
 * @augments Renderer
 * @param {JQueryObj}   div
 * @param {ResultEntry} resultEntry
 * @param {Object}      api        -  render API
 */
var ErrorRenderer = function(div, resultEntry, api) {
	Renderer.call(this, div, resultEntry, api);

	this._element.text(this._resultEntry.getData());
	this._element.addClass("notselectable danger");
};

ErrorRenderer.prototype = Object.create(Renderer.prototype);
ErrorRenderer.prototype.constructor = ErrorRenderer;

export default {
	make: function(div, resultEntry, api) {
		return new ErrorRenderer(div, resultEntry, api);
	}
};
