import Renderer from "./Renderer";
import $ from "jquery";
/**
 * @class UnremovableTokenLabelRenderer
 *
 * @class
 * @augments Renderer
 * @param {JQueryObj}   div
 * @param {ResultEntry} resultEntry
 * @param {Object}      api        -  render API
 */
var UnremovableTokenLabelRenderer = function(div, resultEntry, api) {
	Renderer.call(this, div, resultEntry, api);

	this._element.text(this._resultEntry.getData());
};

UnremovableTokenLabelRenderer.prototype = Object.create(Renderer.prototype);
UnremovableTokenLabelRenderer.prototype.constructor = UnremovableTokenLabelRenderer;

/**
 * @override
 */
UnremovableTokenLabelRenderer.prototype.getToken = function() {
	Renderer.prototype.getToken.call(this);

	this._token.prepend(this._resultEntry.getData());
	$(".token-close", this._token).remove();

	return this._token;
};

export default {
	make: function(div, resultEntry, api) {
		return new UnremovableTokenLabelRenderer(div, resultEntry, api);
	}
};
