/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2010, Ajax.org B.V.
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

"undefined"!==typeof process&&(require("amd-loader"),require("./test/mockdom"));
define("require exports module ./lib/lang ./edit_session ./editor ./undomanager ./test/mockrenderer ./range ./test/assertions ./mode/javascript".split(" "),function(l,t,q){function k(){var a=new f('function foo(items) {\n    for (var i=0; i<items.length; i++) {\n        alert(items[i] + "juhu");\n    }    // Real Tab.\n}');a.setUndoManager(new r);a.addFold("args...",new g(0,13,0,18));a.addFold("foo...",new g(1,10,2,10));a.addFold("bar...",new g(2,20,2,25));return a}function j(a,e){b.equal(a+"",e+
"");b.ok(a.length==e.length);for(var c=0;c<a.length;c++)b.equal(a[c],e[c])}var s=l("./lib/lang"),f=l("./edit_session").EditSession,n=l("./editor").Editor,r=l("./undomanager").UndoManager,p=l("./test/mockrenderer").MockRenderer,g=l("./range").Range,b=l("./test/assertions"),m=l("./mode/javascript").Mode;q.exports={"test: find matching opening bracket in Text mode":function(){var a=new f(["(()(","())))"]);b.position(a.findMatchingBracket({row:0,column:3}),0,1);b.position(a.findMatchingBracket({row:1,
column:2}),1,0);b.position(a.findMatchingBracket({row:1,column:3}),0,3);b.position(a.findMatchingBracket({row:1,column:4}),0,0);b.equal(a.findMatchingBracket({row:1,column:5}),null)},"test: find matching closing bracket in Text mode":function(){var a=new f(["(()(","())))"]);b.position(a.findMatchingBracket({row:1,column:1}),1,1);b.position(a.findMatchingBracket({row:1,column:1}),1,1);b.position(a.findMatchingBracket({row:0,column:4}),1,2);b.position(a.findMatchingBracket({row:0,column:2}),0,2);b.position(a.findMatchingBracket({row:0,
column:1}),1,3);b.equal(a.findMatchingBracket({row:0,column:0}),null)},"test: find matching opening bracket in JavaScript mode":function(){var a=new f('function foo() {\n    var str = "{ foo()";\n    if (debug) {\n        // write str (a string) to the console\n        console.log(str);\n    }\n    str += " bar() }";\n}',new m);b.position(a.findMatchingBracket({row:0,column:14}),0,12);b.position(a.findMatchingBracket({row:7,column:1}),0,15);b.position(a.findMatchingBracket({row:6,column:20}),1,15);
b.position(a.findMatchingBracket({row:1,column:22}),1,20);b.position(a.findMatchingBracket({row:3,column:31}),3,21);b.position(a.findMatchingBracket({row:4,column:24}),4,19);b.equal(a.findMatchingBracket({row:0,column:1}),null)},"test: find matching closing bracket in JavaScript mode":function(){var a=new f('function foo() {\n    var str = "{ foo()";\n    if (debug) {\n        // write str (a string) to the console\n        console.log(str);\n    }\n    str += " bar() }";\n}',new m);b.position(a.findMatchingBracket({row:0,
column:13}),0,13);b.position(a.findMatchingBracket({row:0,column:16}),7,0);b.position(a.findMatchingBracket({row:1,column:16}),6,19);b.position(a.findMatchingBracket({row:1,column:21}),1,21);b.position(a.findMatchingBracket({row:3,column:22}),3,30);b.position(a.findMatchingBracket({row:4,column:20}),4,23)},"test: handle unbalanced brackets in JavaScript mode":function(){var a=new f('function foo() {\n    var str = "{ foo()";\n    if (debug) {\n        // write str a string) to the console\n        console.log(str);\n    \n    str += " bar() ";\n}',
new m);b.equal(a.findMatchingBracket({row:0,column:16}),null);b.equal(a.findMatchingBracket({row:3,column:30}),null);b.equal(a.findMatchingBracket({row:1,column:16}),null)},"test: match different bracket types":function(){var a=new f(["({[",")]}"]);b.position(a.findMatchingBracket({row:0,column:1}),1,0);b.position(a.findMatchingBracket({row:0,column:2}),1,2);b.position(a.findMatchingBracket({row:0,column:3}),1,1);b.position(a.findMatchingBracket({row:1,column:1}),0,0);b.position(a.findMatchingBracket({row:1,
column:2}),0,2);b.position(a.findMatchingBracket({row:1,column:3}),0,1)},"test: move lines down":function(){var a=new f(["a1","a2","a3","a4"]);a.moveLinesDown(0,1);b.equal(a.getValue(),"a3\na1\na2\na4");a.moveLinesDown(1,2);b.equal(a.getValue(),"a3\na4\na1\na2");a.moveLinesDown(2,3);b.equal(a.getValue(),"a3\na4\na1\na2");a.moveLinesDown(2,2);b.equal(a.getValue(),"a3\na4\na2\na1")},"test: move lines up":function(){var a=new f(["a1","a2","a3","a4"]);a.moveLinesUp(2,3);b.equal(a.getValue(),"a1\na3\na4\na2");
a.moveLinesUp(1,2);b.equal(a.getValue(),"a3\na4\na1\na2");a.moveLinesUp(0,1);b.equal(a.getValue(),"a3\na4\na1\na2");a.moveLinesUp(2,2);b.equal(a.getValue(),"a3\na1\na4\na2")},"test: duplicate lines":function(){var a=new f(["1","2","3","4"]);a.duplicateLines(1,2);b.equal(a.getValue(),"1\n2\n3\n2\n3\n4")},"test: duplicate last line":function(){var a=new f(["1","2","3"]);a.duplicateLines(2,2);b.equal(a.getValue(),"1\n2\n3\n3")},"test: duplicate first line":function(){var a=new f(["1","2","3"]);a.duplicateLines(0,
0);b.equal(a.getValue(),"1\n1\n2\n3")},"test: getScreenLastRowColumn":function(){var a=new f(["juhu","12\t\t34","\u3041\u3041a"]);b.equal(a.getScreenLastRowColumn(0),4);b.equal(a.getScreenLastRowColumn(1),10);b.equal(a.getScreenLastRowColumn(2),5)},"test: convert document to screen coordinates":function(){var a=new f("01234\t567890\t1234");a.setTabSize(4);b.equal(a.documentToScreenColumn(0,0),0);b.equal(a.documentToScreenColumn(0,4),4);b.equal(a.documentToScreenColumn(0,5),5);b.equal(a.documentToScreenColumn(0,
6),8);b.equal(a.documentToScreenColumn(0,12),14);b.equal(a.documentToScreenColumn(0,13),16);a.setTabSize(2);b.equal(a.documentToScreenColumn(0,0),0);b.equal(a.documentToScreenColumn(0,4),4);b.equal(a.documentToScreenColumn(0,5),5);b.equal(a.documentToScreenColumn(0,6),6);b.equal(a.documentToScreenColumn(0,7),7);b.equal(a.documentToScreenColumn(0,12),12);b.equal(a.documentToScreenColumn(0,13),14)},"test: convert document to screen coordinates with leading tabs":function(){var a=new f("\t\t123");a.setTabSize(4);
b.equal(a.documentToScreenColumn(0,0),0);b.equal(a.documentToScreenColumn(0,1),4);b.equal(a.documentToScreenColumn(0,2),8);b.equal(a.documentToScreenColumn(0,3),9)},"test: documentToScreen without soft wrap":function(){var a=new f(["juhu","12\t\t34","\u3041\u3041a"]);b.position(a.documentToScreenPosition(0,3),0,3);b.position(a.documentToScreenPosition(1,3),1,4);b.position(a.documentToScreenPosition(1,4),1,8);b.position(a.documentToScreenPosition(2,2),2,4)},"test: documentToScreen with soft wrap":function(){var a=
new f(["foo bar foo bar"]);a.setUseWrapMode(!0);a.setWrapLimitRange(12,12);a.adjustWrapLimit(80);a.setOption("wrapMethod","text");b.position(a.documentToScreenPosition(0,11),0,11);b.position(a.documentToScreenPosition(0,12),1,0)},"test: documentToScreen with soft wrap and multibyte characters":function(){var a=new f(["\u3041\u3041a"]);a.setUseWrapMode(!0);a.setWrapLimitRange(2,2);a.adjustWrapLimit(80);b.position(a.documentToScreenPosition(0,1),1,0);b.position(a.documentToScreenPosition(0,2),2,0);
b.position(a.documentToScreenPosition(0,4),2,1)},"test: documentToScreen should clip position to the document boundaries":function(){var a=new f("foo bar\njuhu kinners");b.position(a.documentToScreenPosition(-1,4),0,0);b.position(a.documentToScreenPosition(3,0),1,12)},"test: convert screen to document coordinates":function(){var a=new f("01234\t567890\t1234");a.setTabSize(4);b.equal(a.screenToDocumentColumn(0,0),0);b.equal(a.screenToDocumentColumn(0,4),4);b.equal(a.screenToDocumentColumn(0,5),5);
b.equal(a.screenToDocumentColumn(0,6),5);b.equal(a.screenToDocumentColumn(0,7),5);b.equal(a.screenToDocumentColumn(0,8),6);b.equal(a.screenToDocumentColumn(0,9),7);b.equal(a.screenToDocumentColumn(0,15),12);b.equal(a.screenToDocumentColumn(0,19),16);a.setTabSize(2);b.equal(a.screenToDocumentColumn(0,0),0);b.equal(a.screenToDocumentColumn(0,4),4);b.equal(a.screenToDocumentColumn(0,5),5);b.equal(a.screenToDocumentColumn(0,6),6);b.equal(a.screenToDocumentColumn(0,12),12);b.equal(a.screenToDocumentColumn(0,
13),12);b.equal(a.screenToDocumentColumn(0,14),13)},"test: screenToDocument with soft wrap":function(){var a=new f(["foo bar foo bar"]);a.setUseWrapMode(!0);a.setWrapLimitRange(12,12);a.adjustWrapLimit(80);b.position(a.screenToDocumentPosition(1,0),0,12);b.position(a.screenToDocumentPosition(0,11),0,11);b.position(a.screenToDocumentPosition(0,12),0,11);b.position(a.screenToDocumentPosition(0,20),0,11)},"test: screenToDocument with soft wrap and multi byte characters":function(){var a=new f(["\u3041 a"]);
a.setUseWrapMode(!0);a.adjustWrapLimit(80);b.position(a.screenToDocumentPosition(0,1),0,0);b.position(a.screenToDocumentPosition(0,2),0,1);b.position(a.screenToDocumentPosition(0,3),0,2);b.position(a.screenToDocumentPosition(0,4),0,3);b.position(a.screenToDocumentPosition(0,5),0,3)},"test: screenToDocument should clip position to the document boundaries":function(){var a=new f("foo bar\njuhu kinners");b.position(a.screenToDocumentPosition(-1,4),0,0);b.position(a.screenToDocumentPosition(0,-1),0,0);
b.position(a.screenToDocumentPosition(0,30),0,7);b.position(a.screenToDocumentPosition(2,4),1,12);b.position(a.screenToDocumentPosition(1,30),1,12);b.position(a.screenToDocumentPosition(20,50),1,12);b.position(a.screenToDocumentPosition(20,5),1,12);a.addFold("...",new g(0,1,1,3));b.position(a.screenToDocumentPosition(1,2),1,12);a.setUseWrapMode(!0);a.setWrapLimitRange(5,5);b.position(a.screenToDocumentPosition(4,1),1,12)},"test: wrapLine split function":function(){function a(a,c,d,i){var d=d||12,
i=i||4,a=s.stringTrimRight(a),h=f.prototype.$getDisplayTokens(a),d=f.prototype.$computeWrapSplits(h,d,i);console.log("String:",a,"Result:",d,"Expected:",c);b.ok(d.length==c.length);for(a=0;a<d.length;a++)b.ok(d[a]==c[a])}f.prototype.$wrapAsCode=!0;f.prototype.$indentedSoftWrap=!1;a("foo bar foo bar",[12]);a("foo bar f   bar",[12]);a("foo bar f     r",[12]);a("foo bar foo bar foo bara foo",[12,25]);a("foo foo foo \t \t",[]);a("foooooooooooooo",[12]);a("fooooooooooooooooooooooooooo",[12,24]);a("foo bar fooooooooooobooooooo",
[8,20]);a("foo \t\tbar",[6]);a("foo \t \tbar",[7]);a("foo \t \t   \t \t bar",[7]);a("\u3041\u3041",[1],2);a(" \u3041\u3041",[1,2],2);a(" \u3041\t\u3041",[1,3],2);a(" \u3041\u3041\t\u3041",[2,4],4);a("\u3041\u3041 \u3041\u3041\t\u3041",[3,6],6);a(" ab.c;ef++",[2,4,6,8],2);a(" ab.c;ef++",[3,5,8],3);a(" a.b",[1,2,3],1);a("#>>",[1,2],1);f.prototype.$wrapAsCode=!1;a("ab cde, Juhu kinners",[3,8,13,19],6);f.prototype.$indentedSoftWrap=!0;a("foo bar foo bar foo bara foo",[12,25]);a("fooooooooooooooooooooooooooo",
[12,24]);a("\t\tfoo bar fooooooooooobooooooo",[6,10,16,22,28]);a("\t\t\tfoo bar fooooooooooobooooooo",[3,7,11,17,23,29]);a("\tfoo \t \t   \t \t bar",[6,12])},"test get longest line":function(){var a=new f(["12"]);a.setTabSize(4);b.equal(a.getScreenWidth(),2);a.doc.insertMergedLines({row:0,column:Infinity},["",""]);a.doc.insertFullLines(1,["123"]);b.equal(a.getScreenWidth(),3);a.doc.insertMergedLines({row:0,column:Infinity},["",""]);a.doc.insertFullLines(1,["\t\t"]);b.equal(a.getScreenWidth(),8);a.setTabSize(2);
b.equal(a.getScreenWidth(),4)},"test getDisplayString":function(){var a=new f(["12"]);a.setTabSize(4);b.equal(a.$getDisplayTokens("\t").length,4);b.equal(a.$getDisplayTokens("abc").length,3);b.equal(a.$getDisplayTokens("abc\t").length,4)},"test issue 83":function(){var a=new f("");new n(new p,a);var b=a.getDocument();a.setUseWrapMode(!0);b.insertFullLines(0,["a","b"]);b.insertFullLines(2,["c","d"]);b.removeFullLines(1,2)},"test wrapMode init has to create wrapData array":function(){var a=new f("foo bar\nfoo bar");
new n(new p,a);a.getDocument();a.setUseWrapMode(!0);a.setWrapLimitRange(3,3);a.adjustWrapLimit(80);b.equal(a.$wrapData.length,2);b.equal(a.$wrapData[0].length,1);b.equal(a.$wrapData[1].length,1)},"test first line blank with wrap":function(){var a=new f("\nfoo");a.setUseWrapMode(!0);b.equal(a.doc.getValue(),"\nfoo")},"test first line blank with wrap 2":function(){var a=new f("");a.setUseWrapMode(!0);a.setValue("\nfoo");b.equal(a.doc.getValue(),"\nfoo")},"test fold getFoldDisplayLine":function(){function a(a,
d){var i=e.getLine(a.end.row),i=e.getFoldDisplayLine(a,a.end.row,i.length);b.equal(i,d)}var e=k();a(e.$foldData[0],"function foo(args...) {");a(e.$foldData[1],'    for (vfoo...ert(items[bar..."juhu");')},"test foldLine idxToPosition":function(){function a(a,d,i,h){b.position(e.$foldData[a].idxToPosition(d),i,h)}var e=k();a(0,12,0,12);a(0,13,0,13);a(0,14,0,13);a(0,19,0,13);a(0,20,0,18);a(1,10,1,10);a(1,11,1,10);a(1,15,1,10);a(1,16,2,10);a(1,26,2,20);a(1,27,2,20);a(1,32,2,25)},"test fold documentToScreen":function(){function a(a,
d,i,h){b.position(e.documentToScreenPosition(a,d),i,h)}var e=k();a(0,0,0,0);a(0,13,0,13);a(0,14,0,13);a(0,17,0,13);a(0,18,0,20);a(1,0,1,0);a(1,10,1,10);a(1,11,1,10);a(1,99,1,10);a(2,0,1,10);a(2,9,1,10);a(2,10,1,16);a(2,11,1,17);a(2,19,1,25);a(2,20,1,26);a(2,21,1,26);a(2,24,1,26);a(2,25,1,32);a(2,26,1,33);a(2,99,1,40);a(3,0,2,0)},"test fold screenToDocument":function(){function a(a,d,i,h){b.position(e.screenToDocumentPosition(i,h),a,d)}var e=k();a(0,0,0,0);a(0,13,0,13);a(0,13,0,14);a(0,18,0,20);a(0,
19,0,21);a(1,0,1,0);a(1,10,1,10);a(1,10,1,11);a(1,10,1,15);a(2,10,1,16);a(2,11,1,17);a(2,19,1,25);a(2,20,1,26);a(2,20,1,27);a(2,20,1,31);a(2,25,1,32);a(2,26,1,33);a(2,33,1,99);a(3,0,2,0)},"test getFoldsInRange()":function(){function a(a,c,h,f,j){a=new g(a,c,h,f);a=e.getFoldsInRange(a);b.ok(a.length==j.length);for(c=0;c<a.length;c++)b.equal(a[c].range+"",j[c].range+"")}var e=k(),c=e.$foldData,c=c[0].folds.concat(c[1].folds);a(0,0,0,13,[]);a(0,0,0,14,[c[0]]);a(0,0,0,18,[c[0]]);a(0,0,1,10,[c[0]]);a(0,
0,1,11,[c[0],c[1]]);a(0,18,1,11,[c[1]]);a(2,0,2,13,[c[1]]);a(2,10,2,20,[]);a(2,10,2,11,[]);a(2,19,2,20,[])},"test fold one-line text insert":function(){function a(a,b,c){e.insert({row:a,column:b},c);e.$syncInformUndoManager()}var e=k(),c=e.getUndoManager(),d=e.$foldData,i,h;i=e.$foldData[0];h=i.folds[0];a(0,0,"0");b.range(i.range,0,14,0,19);b.range(h.range,0,14,0,19);a(0,14,"1");b.range(i.range,0,15,0,20);b.range(h.range,0,15,0,20);a(0,20,"2");b.range(i.range,0,15,0,20);b.range(h.range,0,15,0,20);
i=e.$foldData[1];h=i.folds;a(1,0,"3");b.range(i.range,1,11,2,25);b.range(h[0].range,1,11,2,10);b.range(h[1].range,2,20,2,25);a(1,11,"4");b.range(i.range,1,12,2,25);b.range(h[0].range,1,12,2,10);b.range(h[1].range,2,20,2,25);a(2,10,"5");b.range(i.range,1,12,2,26);b.range(h[0].range,1,12,2,10);b.range(h[1].range,2,21,2,26);a(2,21,"6");b.range(i.range,1,12,2,27);b.range(h[0].range,1,12,2,10);b.range(h[1].range,2,22,2,27);a(2,27,"7");b.range(i.range,1,12,2,27);b.range(h[0].range,1,12,2,10);b.range(h[1].range,
2,22,2,27);c.undo();b.range(i.range,1,12,2,27);b.range(h[0].range,1,12,2,10);b.range(h[1].range,2,22,2,27);c.undo();b.range(i.range,1,12,2,26);b.range(h[0].range,1,12,2,10);b.range(h[1].range,2,21,2,26);c.undo();b.range(i.range,1,12,2,25);b.range(h[0].range,1,12,2,10);b.range(h[1].range,2,20,2,25);c.undo();b.range(i.range,1,11,2,25);b.range(h[0].range,1,11,2,10);b.range(h[1].range,2,20,2,25);c.undo();b.equal(d.length,2);b.range(d[0].range,0,15,0,20);b.range(d[1].range,1,10,2,25);i=e.$foldData[0];
h=i.folds[0];c.undo();b.range(i.range,0,15,0,20);b.range(h.range,0,15,0,20);c.undo();b.range(i.range,0,14,0,19);b.range(h.range,0,14,0,19);c.undo();b.range(i.range,0,13,0,18);b.range(h.range,0,13,0,18)},"test fold multi-line insert/remove":function(){function a(a,b,c){e.insert({row:a,column:b},c);e.$syncInformUndoManager()}var e=k(),c=e.getUndoManager(),d=e.$foldData,d=e.$foldData;a(0,0,"\nfo0");b.equal(d.length,2);b.range(d[0].range,1,16,1,21);b.range(d[1].range,2,10,3,25);a(2,0,"\nba1");b.equal(d.length,
2);b.range(d[0].range,1,16,1,21);b.range(d[1].range,3,13,4,25);a(3,10,"\nfo2");b.equal(d.length,2);b.range(d[0].range,1,16,1,21);b.range(d[1].range,4,6,5,25);a(5,10,"\nba3");b.equal(d.length,3);b.range(d[0].range,1,16,1,21);b.range(d[1].range,4,6,5,10);b.range(d[2].range,6,13,6,18);a(6,18,"\nfo4");b.equal(d.length,3);b.range(d[0].range,1,16,1,21);b.range(d[1].range,4,6,5,10);b.range(d[2].range,6,13,6,18);c.undo();b.equal(d.length,3);b.range(d[0].range,1,16,1,21);b.range(d[1].range,4,6,5,10);b.range(d[2].range,
6,13,6,18);c.undo();b.equal(d.length,2);b.range(d[0].range,1,16,1,21);b.range(d[1].range,4,6,5,25);c.undo();b.equal(d.length,2);b.range(d[0].range,1,16,1,21);b.range(d[1].range,3,13,4,25);c.undo();b.equal(d.length,2);b.range(d[0].range,1,16,1,21);b.range(d[1].range,2,10,3,25);c.undo();b.equal(d.length,2);b.range(d[0].range,0,13,0,18);b.range(d[1].range,1,10,2,25)},"test fold wrap data compution":function(){function a(a,b,c){a&&j(d[0],a);b&&j(d[1],b);c&&j(d[2],c)}function b(d,e,f,g,j){c.removeFold(c.getFoldAt(d,
e));a(f,g,j)}var c=new f("foo bar foo bar\nfoo bar foo bar\nfoo bar foo bar");c.setUseWrapMode(!0);c.$wrapLimit=7;c.$updateWrapData(0,2);var d=c.$wrapData;a([8],[8],[8]);c.addFold("woot",new g(0,4,0,15));a([4],[8],[8]);b(0,4,[8],[8],[8]);c.addFold("woot",new g(0,6,0,9));a([6,13],[8],[8]);b(0,6,[8],[8],[8]);c.addFold("woot",new g(0,3,0,15));a([],[8],[8]);b(0,4,[8],[8],[8]);c.addFold("woot",new g(0,8,0,15));a([8],[8],[8]);b(0,8,[8],[8],[8]);c.addFold("woot0123456789",new g(0,8,0,15));a([8],[8],[8]);
b(0,8,[8],[8],[8]);c.addFold("woot0123456789",new g(0,6,0,8));a([6,20],[8],[8]);b(0,8,[8],[8],[8]);c.addFold("woot0123456789",new g(0,6,0,8));c.addFold("woot0123456789",new g(0,8,0,10));a([6,20,34],[8],[8]);c.removeFold(c.getFoldAt(0,7));b(0,8,[8],[8],[8]);c.addFold("woot0123456789",new g(0,7,0,9));c.addFold("woot0123456789",new g(0,13,0,15));a([7,21,25],[8],[8]);c.removeFold(c.getFoldAt(0,7));b(0,14,[8],[8],[8]);c.addFold("woot",new g(0,8,1,15));a([8],[8],[8]);b(0,8,[8],[8],[8]);c.addFold("woot",
new g(0,9,1,11));a([8,14],[8],[8]);b(0,9,[8],[8],[8]);c.addFold("woot",new g(0,9,1,15));a([8],[8],[8]);b(0,9,[8],[8],[8]);return c},"test delete fold with wrap enabled":function(){var a=new f("");a.setValue("This is some placeholder text that will be folded inline.\nThis is some placeholder text that will be folded inline.\nMore text.\n<p>The cursor in this paragraph text will be offset by 1 row.<p>\n<p>Everything after this will be offset as well due to the folds in the row before too.</p>");a.addFold("...",
new g(0,8,0,42));a.addFold("...",new g(1,8,1,42));a.addFold("...",new g(3,7,3,51));a.setOption("wrap",40);a.remove(new g(0,0,2,5));a.adjustWrapLimit(80);b.equal(a.$wrapData+"",",,40,76")},"test add fold":function(){function a(a,b,f){var g=!1;try{c=e.addFold(a,b)}catch(j){g=!0}if(g!=f)throw Error("Expected to get an exception");}var e=k(),c;a("foo",new g(0,13,0,17),!1);a("foo",new g(0,14,0,18),!0);a("foo",new g(0,13,0,18),!1);b.equal(e.$foldData[0].folds.length,1);a("f",new g(0,13,0,18),!1);a("foo",
new g(0,18,0,21),!1);b.equal(e.$foldData[0].folds.length,2);e.removeFold(c);a("foo",new g(0,18,0,22),!1);a("foo",new g(0,18,0,19),!0);a("foo",new g(0,22,1,10),!1)},"test add subfolds":function(){var a=k(),e,c,d=a.$foldData;c=d[0].folds[0];e=a.addFold("fold0",new g(0,10,0,21));b.equal(d[0].folds.length,1);b.equal(e.subFolds.length,1);b.equal(e.subFolds[0],c);a.expandFold(e);b.equal(d[0].folds.length,1);b.equal(d[0].folds[0],c);b.equal(e.subFolds.length,0);e=a.addFold("fold0",new g(0,13,2,10));b.equal(d.length,
1);b.equal(e.subFolds.length,2);b.equal(e.subFolds[0],c);a.expandFold(e);b.equal(d.length,2);b.equal(d[0].folds.length,1);b.equal(d[0].folds[0],c);b.equal(e.subFolds.length,0);a.unfold(null,!0);e=a.addFold("fold0",new g(0,0,0,21));a.addFold("fold0",new g(0,1,0,5));a.addFold("fold0",new g(0,6,0,8));b.equal(e.subFolds.length,2)},"test row cache":function(){var a=k();a.screenToDocumentPosition(2,3);j(a.$docRowCache,[1,3]);j(a.$screenRowCache,[1,2]);a.screenToDocumentPosition(5,3);j(a.$docRowCache,[1,
3,4]);j(a.$screenRowCache,[1,2,3]);a.screenToDocumentPosition(0,3);j(a.$docRowCache,[1,3,4]);j(a.$screenRowCache,[1,2,3]);var e=a.screenToDocumentPosition(0,0);b.equal(e.row,0);j(a.$docRowCache,[1,3,4]);j(a.$screenRowCache,[1,2,3]);a.screenToDocumentPosition(1,0);j(a.$docRowCache,[1,3,4]);j(a.$screenRowCache,[1,2,3]);a.$resetRowCache();j(a.$docRowCache,[]);j(a.$screenRowCache,[]);a.screenToDocumentPosition(1,3);j(a.$docRowCache,[1]);j(a.$screenRowCache,[1]);a.screenToDocumentPosition(5,3);j(a.$docRowCache,
[1,3,4]);j(a.$screenRowCache,[1,2,3]);a=new f(Array(30).join("\n"));a.documentToScreenPosition(2,0);a.documentToScreenPosition(2,0);j(a.$docRowCache,[1,2]);j(a.$screenRowCache,[1,2])},"test annotations":function(){var a=new f([]),b={row:0,type:"info",text:"This is a test."};a.clearAnnotations();j(a.getAnnotations(),[]);a.setAnnotations([b]);j(a.getAnnotations(),[b])},"test: mode loading":function(a){if(l.undef){var e=new f([]);e.setMode("ace/mode/javascript");b.equal(e.$modeid,"ace/mode/javascript");
e.on("changeMode",function(){b.equal(e.$modeid,"ace/mode/javascript")});e.setMode("ace/mode/sh",function(a){b.ok(!a)});setTimeout(function(){e.setMode("ace/mode/javascript",function(){e.setMode("ace/mode/javascript");b.equal(e.$modeid,"ace/mode/javascript");a()})},0)}else console.log("Skipping test: This test only runs in the browser"),a()}}});"undefined"!==typeof module&&module===require.main&&require("asyncjs").test.testcase(module.exports).exec();