/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2010, Ajax.org B.V.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

define("require exports module ./lib/fixoldbrowsers ./lib/oop ./lib/dom ./lib/lang ./lib/useragent ./keyboard/textinput ./mouse/mouse_handler ./mouse/fold_handler ./keyboard/keybinding ./edit_session ./search ./range ./lib/event_emitter ./commands/command_manager ./commands/default_commands ./config ./token_iterator".split(" "),function(h,w){h("./lib/fixoldbrowsers");var t=h("./lib/oop"),u=h("./lib/dom"),r=h("./lib/lang"),x=h("./lib/useragent"),y=h("./keyboard/textinput").TextInput,z=h("./mouse/mouse_handler").MouseHandler,
A=h("./mouse/fold_handler").FoldHandler,B=h("./keyboard/keybinding").KeyBinding,C=h("./edit_session").EditSession,D=h("./search").Search,m=h("./range").Range,E=h("./lib/event_emitter").EventEmitter,F=h("./commands/command_manager").CommandManager,G=h("./commands/default_commands").commands,n=h("./config"),v=h("./token_iterator").TokenIterator,s=function(a,b){this.container=a.getContainerElement();this.renderer=a;this.commands=new F(x.isMac?"mac":"win",G);this.textInput=new y(a.getTextAreaContainer(),
this);this.renderer.textarea=this.textInput.getElement();this.keyBinding=new B(this);this.$mouseHandler=new z(this);new A(this);this.$blockScrolling=0;this.$search=(new D).set({wrap:!0});this.$historyTracker=this.$historyTracker.bind(this);this.commands.on("exec",this.$historyTracker);this.$initOperationListeners();this._$emitInputEvent=r.delayedCall(function(){this._signal("input",{});this.session&&this.session.bgTokenizer&&this.session.bgTokenizer.scheduleStart()}.bind(this));this.on("change",function(a,
b){b._$emitInputEvent.schedule(31)});this.setSession(b||new C(""));n.resetOptions(this);n._signal("editor",this)};(function(){t.implement(this,E);this.$initOperationListeners=function(){this.selections=[];this.commands.on("exec",this.startOperation.bind(this),!0);this.commands.on("afterExec",this.endOperation.bind(this),!0);this.$opResetTimer=r.delayedCall(this.endOperation.bind(this));this.on("change",function(){this.curOp||this.startOperation();this.curOp.docChanged=!0}.bind(this),!0);this.on("changeSelection",
function(){this.curOp||this.startOperation();this.curOp.selectionChanged=!0}.bind(this),!0)};this.curOp=null;this.prevOp={};this.startOperation=function(a){if(this.curOp){if(!a||this.curOp.command)return;this.prevOp=this.curOp}a||(this.previousCommand=null,a={});this.$opResetTimer.schedule();this.curOp={command:a.command||{},args:a.args,scrollTop:this.renderer.scrollTop};this.curOp.command.name&&void 0!==this.curOp.command.scrollIntoView&&this.$blockScrolling++};this.endOperation=function(a){if(this.curOp){if(a&&
!1===a.returnValue)return this.curOp=null;this._signal("beforeEndOperation");a=this.curOp.command;a.name&&0<this.$blockScrolling&&this.$blockScrolling--;if(a=a&&a.scrollIntoView){switch(a){case "center-animate":a="animate";case "center":this.renderer.scrollCursorIntoView(null,0.5);break;case "animate":case "cursor":this.renderer.scrollCursorIntoView();break;case "selectionPart":var b=this.selection.getRange(),c=this.renderer.layerConfig;(b.start.row>=c.lastRow||b.end.row<=c.firstRow)&&this.renderer.scrollSelectionIntoView(this.selection.anchor,
this.selection.lead)}"animate"==a&&this.renderer.animateScrolling(this.curOp.scrollTop)}this.prevOp=this.curOp;this.curOp=null}};this.$mergeableCommands=["backspace","del","insertstring"];this.$historyTracker=function(a){if(this.$mergeUndoDeltas){var b=this.prevOp,c=this.$mergeableCommands,d=b.command&&a.command.name==b.command.name;if("insertstring"==a.command.name){var e=a.args;void 0===this.mergeNextCommand&&(this.mergeNextCommand=!0);d=d&&this.mergeNextCommand&&(!/\s/.test(e)||/\s/.test(b.args));
this.mergeNextCommand=!0}else d=d&&-1!==c.indexOf(a.command.name);"always"!=this.$mergeUndoDeltas&&2E3<Date.now()-this.sequenceStartTime&&(d=!1);d?this.session.mergeUndoDeltas=!0:-1!==c.indexOf(a.command.name)&&(this.sequenceStartTime=Date.now())}};this.setKeyboardHandler=function(a,b){if(a&&"string"===typeof a){this.$keybindingId=a;var c=this;n.loadModule(["keybinding",a],function(d){c.$keybindingId==a&&c.keyBinding.setKeyboardHandler(d&&d.handler);b&&b()})}else this.$keybindingId=null,this.keyBinding.setKeyboardHandler(a),
b&&b()};this.getKeyboardHandler=function(){return this.keyBinding.getKeyboardHandler()};this.setSession=function(a){if(this.session!=a){this.curOp&&this.endOperation();this.curOp={};var b=this.session;if(b){this.session.off("change",this.$onDocumentChange);this.session.off("changeMode",this.$onChangeMode);this.session.off("tokenizerUpdate",this.$onTokenizerUpdate);this.session.off("changeTabSize",this.$onChangeTabSize);this.session.off("changeWrapLimit",this.$onChangeWrapLimit);this.session.off("changeWrapMode",
this.$onChangeWrapMode);this.session.off("changeFold",this.$onChangeFold);this.session.off("changeFrontMarker",this.$onChangeFrontMarker);this.session.off("changeBackMarker",this.$onChangeBackMarker);this.session.off("changeBreakpoint",this.$onChangeBreakpoint);this.session.off("changeAnnotation",this.$onChangeAnnotation);this.session.off("changeOverwrite",this.$onCursorChange);this.session.off("changeScrollTop",this.$onScrollTopChange);this.session.off("changeScrollLeft",this.$onScrollLeftChange);
var c=this.session.getSelection();c.off("changeCursor",this.$onCursorChange);c.off("changeSelection",this.$onSelectionChange)}(this.session=a)?(this.$onDocumentChange=this.onDocumentChange.bind(this),a.on("change",this.$onDocumentChange),this.renderer.setSession(a),this.$onChangeMode=this.onChangeMode.bind(this),a.on("changeMode",this.$onChangeMode),this.$onTokenizerUpdate=this.onTokenizerUpdate.bind(this),a.on("tokenizerUpdate",this.$onTokenizerUpdate),this.$onChangeTabSize=this.renderer.onChangeTabSize.bind(this.renderer),
a.on("changeTabSize",this.$onChangeTabSize),this.$onChangeWrapLimit=this.onChangeWrapLimit.bind(this),a.on("changeWrapLimit",this.$onChangeWrapLimit),this.$onChangeWrapMode=this.onChangeWrapMode.bind(this),a.on("changeWrapMode",this.$onChangeWrapMode),this.$onChangeFold=this.onChangeFold.bind(this),a.on("changeFold",this.$onChangeFold),this.$onChangeFrontMarker=this.onChangeFrontMarker.bind(this),this.session.on("changeFrontMarker",this.$onChangeFrontMarker),this.$onChangeBackMarker=this.onChangeBackMarker.bind(this),
this.session.on("changeBackMarker",this.$onChangeBackMarker),this.$onChangeBreakpoint=this.onChangeBreakpoint.bind(this),this.session.on("changeBreakpoint",this.$onChangeBreakpoint),this.$onChangeAnnotation=this.onChangeAnnotation.bind(this),this.session.on("changeAnnotation",this.$onChangeAnnotation),this.$onCursorChange=this.onCursorChange.bind(this),this.session.on("changeOverwrite",this.$onCursorChange),this.$onScrollTopChange=this.onScrollTopChange.bind(this),this.session.on("changeScrollTop",
this.$onScrollTopChange),this.$onScrollLeftChange=this.onScrollLeftChange.bind(this),this.session.on("changeScrollLeft",this.$onScrollLeftChange),this.selection=a.getSelection(),this.selection.on("changeCursor",this.$onCursorChange),this.$onSelectionChange=this.onSelectionChange.bind(this),this.selection.on("changeSelection",this.$onSelectionChange),this.onChangeMode(),this.$blockScrolling+=1,this.onCursorChange(),this.$blockScrolling-=1,this.onScrollTopChange(),this.onScrollLeftChange(),this.onSelectionChange(),
this.onChangeFrontMarker(),this.onChangeBackMarker(),this.onChangeBreakpoint(),this.onChangeAnnotation(),this.session.getUseWrapMode()&&this.renderer.adjustWrapLimit(),this.renderer.updateFull()):(this.selection=null,this.renderer.setSession(a));this._signal("changeSession",{session:a,oldSession:b});this.curOp=null;b&&b._signal("changeEditor",{oldEditor:this});a&&a._signal("changeEditor",{editor:this})}};this.getSession=function(){return this.session};this.setValue=function(a,b){this.session.doc.setValue(a);
b?1==b?this.navigateFileEnd():-1==b&&this.navigateFileStart():this.selectAll();return a};this.getValue=function(){return this.session.getValue()};this.getSelection=function(){return this.selection};this.resize=function(a){this.renderer.onResize(a)};this.setTheme=function(a,b){this.renderer.setTheme(a,b)};this.getTheme=function(){return this.renderer.getTheme()};this.setStyle=function(a){this.renderer.setStyle(a)};this.unsetStyle=function(a){this.renderer.unsetStyle(a)};this.getFontSize=function(){return this.getOption("fontSize")||
u.computedStyle(this.container,"fontSize")};this.setFontSize=function(a){this.setOption("fontSize",a)};this.$highlightBrackets=function(){this.session.$bracketHighlight&&(this.session.removeMarker(this.session.$bracketHighlight),this.session.$bracketHighlight=null);if(!this.$highlightPending){var a=this;this.$highlightPending=!0;setTimeout(function(){a.$highlightPending=!1;var b=a.session;if(b&&b.bgTokenizer){var c=b.findMatchingBracket(a.getCursorPosition());if(c)var d=new m(c.row,c.column,c.row,
c.column+1);else b.$mode.getMatching&&(d=b.$mode.getMatching(a.session));d&&(b.$bracketHighlight=b.addMarker(d,"ace_bracket","text"))}},50)}};this.$highlightTags=function(){if(!this.$highlightTagPending){var a=this;this.$highlightTagPending=!0;setTimeout(function(){a.$highlightTagPending=!1;var b=a.session;if(b&&b.bgTokenizer){var c=a.getCursorPosition(),d=new v(a.session,c.row,c.column),c=d.getCurrentToken();if(!c||!/\b(?:tag-open|tag-name)/.test(c.type))b.removeMarker(b.$tagHighlight),b.$tagHighlight=
null;else{if(-1!=c.type.indexOf("tag-open")&&(c=d.stepForward(),!c))return;var e=c.value,f=0,g=d.stepBackward();if("<"==g.value){do g=c,(c=d.stepForward())&&(c.value===e&&-1!==c.type.indexOf("tag-name"))&&("<"===g.value?f++:"</"===g.value&&f--);while(c&&0<=f)}else{do c=g,g=d.stepBackward(),c&&(c.value===e&&-1!==c.type.indexOf("tag-name"))&&("<"===g.value?f++:"</"===g.value&&f--);while(g&&0>=f);d.stepForward()}c?(e=d.getCurrentTokenRow(),d=d.getCurrentTokenColumn(),c=new m(e,d,e,d+c.value.length),
b.$tagHighlight&&0!==c.compareRange(b.$backMarkers[b.$tagHighlight].range)&&(b.removeMarker(b.$tagHighlight),b.$tagHighlight=null),c&&!b.$tagHighlight&&(b.$tagHighlight=b.addMarker(c,"ace_bracket","text"))):(b.removeMarker(b.$tagHighlight),b.$tagHighlight=null)}}},50)}};this.focus=function(){var a=this;setTimeout(function(){a.textInput.focus()});this.textInput.focus()};this.isFocused=function(){return this.textInput.isFocused()};this.blur=function(){this.textInput.blur()};this.onFocus=function(a){this.$isFocused||
(this.$isFocused=!0,this.renderer.showCursor(),this.renderer.visualizeFocus(),this._emit("focus",a))};this.onBlur=function(a){this.$isFocused&&(this.$isFocused=!1,this.renderer.hideCursor(),this.renderer.visualizeBlur(),this._emit("blur",a))};this.$cursorChange=function(){this.renderer.updateCursor()};this.onDocumentChange=function(a){this.renderer.updateLines(a.start.row,a.start.row==a.end.row?a.end.row:Infinity,this.session.$useWrapMode);this._signal("change",a);this.$cursorChange();this.$updateHighlightActiveLine()};
this.onTokenizerUpdate=function(a){a=a.data;this.renderer.updateLines(a.first,a.last)};this.onScrollTopChange=function(){this.renderer.scrollToY(this.session.getScrollTop())};this.onScrollLeftChange=function(){this.renderer.scrollToX(this.session.getScrollLeft())};this.onCursorChange=function(){this.$cursorChange();this.$blockScrolling||(n.warn("Automatically scrolling cursor into view after selection change","this will be disabled in the next version","set editor.$blockScrolling = Infinity to disable this message"),
this.renderer.scrollCursorIntoView());this.$highlightBrackets();this.$highlightTags();this.$updateHighlightActiveLine();this._signal("changeSelection")};this.$updateHighlightActiveLine=function(){var a=this.getSession(),b;if(this.$highlightActiveLine){if("line"!=this.$selectionStyle||!this.selection.isMultiLine())b=this.getCursorPosition();this.renderer.$maxLines&&(1===this.session.getLength()&&!(1<this.renderer.$minLines))&&(b=!1)}a.$highlightLineMarker&&!b?(a.removeMarker(a.$highlightLineMarker.id),
a.$highlightLineMarker=null):!a.$highlightLineMarker&&b?(b=new m(b.row,b.column,b.row,Infinity),b.id=a.addMarker(b,"ace_active-line","screenLine"),a.$highlightLineMarker=b):b&&(a.$highlightLineMarker.start.row=b.row,a.$highlightLineMarker.end.row=b.row,a.$highlightLineMarker.start.column=b.column,a._signal("changeBackMarker"))};this.onSelectionChange=function(){var a=this.session;a.$selectionMarker&&a.removeMarker(a.$selectionMarker);a.$selectionMarker=null;if(this.selection.isEmpty())this.$updateHighlightActiveLine();
else{var b=this.selection.getRange(),c=this.getSelectionStyle();a.$selectionMarker=a.addMarker(b,"ace_selection",c)}a=this.$highlightSelectedWord&&this.$getSelectionHighLightRegexp();this.session.highlight(a);this._signal("changeSelection")};this.$getSelectionHighLightRegexp=function(){var a=this.session,b=this.getSelectionRange();if(!b.isEmpty()&&!b.isMultiLine()){var c=b.start.column-1,d=b.end.column+1,a=a.getLine(b.start.row),e=a.length,f=a.substring(Math.max(c,0),Math.min(d,e));if(!(0<=c&&/^[\w\d]/.test(f)||
d<=e&&/[\w\d]$/.test(f)))if(f=a.substring(b.start.column,b.end.column),/^[\w\d]+$/.test(f))return this.$search.$assembleRegExp({wholeWord:!0,caseSensitive:!0,needle:f})}};this.onChangeFrontMarker=function(){this.renderer.updateFrontMarkers()};this.onChangeBackMarker=function(){this.renderer.updateBackMarkers()};this.onChangeBreakpoint=function(){this.renderer.updateBreakpoints()};this.onChangeAnnotation=function(){this.renderer.setAnnotations(this.session.getAnnotations())};this.onChangeMode=function(a){this.renderer.updateText();
this._emit("changeMode",a)};this.onChangeWrapLimit=function(){this.renderer.updateFull()};this.onChangeWrapMode=function(){this.renderer.onResize(!0)};this.onChangeFold=function(){this.$updateHighlightActiveLine();this.renderer.updateFull()};this.getSelectedText=function(){return this.session.getTextRange(this.getSelectionRange())};this.getCopyText=function(){var a=this.getSelectedText();this._signal("copy",a);return a};this.onCopy=function(){this.commands.exec("copy",this)};this.onCut=function(){this.commands.exec("cut",
this)};this.onPaste=function(a,b){this.commands.exec("paste",this,{text:a,event:b})};this.$handlePaste=function(a){"string"==typeof a&&(a={text:a});this._signal("paste",a);var b=a.text;if(!this.inMultiSelectMode||this.inVirtualSelectionMode)this.insert(b);else{var a=b.split(/\r\n|\r|\n/),c=this.selection.rangeList.ranges;if(a.length>c.length||2>a.length||!a[1])return this.commands.exec("insertstring",this,b);for(b=c.length;b--;){var d=c[b];d.isEmpty()||this.session.remove(d);this.session.insert(d.start,
a[b])}}};this.execCommand=function(a,b){return this.commands.exec(a,this,b)};this.insert=function(a,b){var c=this.session,d=c.getMode(),e=this.getCursorPosition();if(this.getBehavioursEnabled()&&!b){var f=d.transformAction(c.getState(e.row),"insertion",this,c,a);f&&(a!==f.text&&(this.$mergeNextCommand=this.session.mergeUndoDeltas=!1),a=f.text)}"\t"==a&&(a=this.session.getTabString());if(this.selection.isEmpty())this.session.getOverwrite()&&(g=new m.fromPoints(e,e),g.end.column+=a.length,this.session.remove(g));
else{var g=this.getSelectionRange(),e=this.session.remove(g);this.clearSelection()}if("\n"==a||"\r\n"==a){var p=c.getLine(e.row);e.column>p.search(/\S|$/)&&(g=p.substr(e.column).search(/\S|$/),c.doc.removeInLine(e.row,e.column,e.column+g))}this.clearSelection();var i=e.column,g=c.getState(e.row),p=c.getLine(e.row),k=d.checkOutdent(g,p,a);c.insert(e,a);f&&f.selection&&(2==f.selection.length?this.selection.setSelectionRange(new m(e.row,i+f.selection[0],e.row,i+f.selection[1])):this.selection.setSelectionRange(new m(e.row+
f.selection[0],f.selection[1],e.row+f.selection[2],f.selection[3])));c.getDocument().isNewLine(a)&&(f=d.getNextLineIndent(g,p.slice(0,e.column),c.getTabString()),c.insert({row:e.row+1,column:0},f));k&&d.autoOutdent(g,c,e.row)};this.onTextInput=function(a){this.keyBinding.onTextInput(a)};this.onCommandKey=function(a,b,c){this.keyBinding.onCommandKey(a,b,c)};this.setOverwrite=function(a){this.session.setOverwrite(a)};this.getOverwrite=function(){return this.session.getOverwrite()};this.toggleOverwrite=
function(){this.session.toggleOverwrite()};this.setScrollSpeed=function(a){this.setOption("scrollSpeed",a)};this.getScrollSpeed=function(){return this.getOption("scrollSpeed")};this.setDragDelay=function(a){this.setOption("dragDelay",a)};this.getDragDelay=function(){return this.getOption("dragDelay")};this.setSelectionStyle=function(a){this.setOption("selectionStyle",a)};this.getSelectionStyle=function(){return this.getOption("selectionStyle")};this.setHighlightActiveLine=function(a){this.setOption("highlightActiveLine",
a)};this.getHighlightActiveLine=function(){return this.getOption("highlightActiveLine")};this.setHighlightGutterLine=function(a){this.setOption("highlightGutterLine",a)};this.getHighlightGutterLine=function(){return this.getOption("highlightGutterLine")};this.setHighlightSelectedWord=function(a){this.setOption("highlightSelectedWord",a)};this.getHighlightSelectedWord=function(){return this.$highlightSelectedWord};this.setAnimatedScroll=function(a){this.renderer.setAnimatedScroll(a)};this.getAnimatedScroll=
function(){return this.renderer.getAnimatedScroll()};this.setShowInvisibles=function(a){this.renderer.setShowInvisibles(a)};this.getShowInvisibles=function(){return this.renderer.getShowInvisibles()};this.setDisplayIndentGuides=function(a){this.renderer.setDisplayIndentGuides(a)};this.getDisplayIndentGuides=function(){return this.renderer.getDisplayIndentGuides()};this.setShowPrintMargin=function(a){this.renderer.setShowPrintMargin(a)};this.getShowPrintMargin=function(){return this.renderer.getShowPrintMargin()};
this.setPrintMarginColumn=function(a){this.renderer.setPrintMarginColumn(a)};this.getPrintMarginColumn=function(){return this.renderer.getPrintMarginColumn()};this.setReadOnly=function(a){this.setOption("readOnly",a)};this.getReadOnly=function(){return this.getOption("readOnly")};this.setBehavioursEnabled=function(a){this.setOption("behavioursEnabled",a)};this.getBehavioursEnabled=function(){return this.getOption("behavioursEnabled")};this.setWrapBehavioursEnabled=function(a){this.setOption("wrapBehavioursEnabled",
a)};this.getWrapBehavioursEnabled=function(){return this.getOption("wrapBehavioursEnabled")};this.setShowFoldWidgets=function(a){this.setOption("showFoldWidgets",a)};this.getShowFoldWidgets=function(){return this.getOption("showFoldWidgets")};this.setFadeFoldWidgets=function(a){this.setOption("fadeFoldWidgets",a)};this.getFadeFoldWidgets=function(){return this.getOption("fadeFoldWidgets")};this.remove=function(a){this.selection.isEmpty()&&("left"==a?this.selection.selectLeft():this.selection.selectRight());
a=this.getSelectionRange();if(this.getBehavioursEnabled()){var b=this.session,c=b.getState(a.start.row),c=b.getMode().transformAction(c,"deletion",this,b,a);if(0===a.end.column){var d=b.getTextRange(a);"\n"==d[d.length-1]&&(b=b.getLine(a.end.row),/^\s+$/.test(b)&&(a.end.column=b.length))}c&&(a=c)}this.session.remove(a);this.clearSelection()};this.removeWordRight=function(){this.selection.isEmpty()&&this.selection.selectWordRight();this.session.remove(this.getSelectionRange());this.clearSelection()};
this.removeWordLeft=function(){this.selection.isEmpty()&&this.selection.selectWordLeft();this.session.remove(this.getSelectionRange());this.clearSelection()};this.removeToLineStart=function(){this.selection.isEmpty()&&this.selection.selectLineStart();this.session.remove(this.getSelectionRange());this.clearSelection()};this.removeToLineEnd=function(){this.selection.isEmpty()&&this.selection.selectLineEnd();var a=this.getSelectionRange();a.start.column==a.end.column&&a.start.row==a.end.row&&(a.end.column=
0,a.end.row++);this.session.remove(a);this.clearSelection()};this.splitLine=function(){this.selection.isEmpty()||(this.session.remove(this.getSelectionRange()),this.clearSelection());var a=this.getCursorPosition();this.insert("\n");this.moveCursorToPosition(a)};this.transposeLetters=function(){if(this.selection.isEmpty()){var a=this.getCursorPosition(),b=a.column;if(0!==b){var c=this.session.getLine(a.row);b<c.length?(c=c.charAt(b)+c.charAt(b-1),a=new m(a.row,b-1,a.row,b+1)):(c=c.charAt(b-1)+c.charAt(b-
2),a=new m(a.row,b-2,a.row,b));this.session.replace(a,c)}}};this.toLowerCase=function(){var a=this.getSelectionRange();this.selection.isEmpty()&&this.selection.selectWord();var b=this.getSelectionRange(),c=this.session.getTextRange(b);this.session.replace(b,c.toLowerCase());this.selection.setSelectionRange(a)};this.toUpperCase=function(){var a=this.getSelectionRange();this.selection.isEmpty()&&this.selection.selectWord();var b=this.getSelectionRange(),c=this.session.getTextRange(b);this.session.replace(b,
c.toUpperCase());this.selection.setSelectionRange(a)};this.indent=function(){var a=this.session,b=this.getSelectionRange();if(b.start.row<b.end.row)b=this.$getSelectedRows(),a.indentRows(b.first,b.last,"\t");else{if(b.start.column<b.end.column){var c=a.getTextRange(b);if(!/^\s+$/.test(c)){b=this.$getSelectedRows();a.indentRows(b.first,b.last,"\t");return}}var c=a.getLine(b.start.row),d=b.start,e=a.getTabSize(),a=a.documentToScreenColumn(d.row,d.column);if(this.session.getUseSoftTabs())b=r.stringRepeat(" ",
e-a%e);else{for(a%=e;" "==c[b.start.column-1]&&a;)b.start.column--,a--;this.selection.setSelectionRange(b);b="\t"}return this.insert(b)}};this.blockIndent=function(){var a=this.$getSelectedRows();this.session.indentRows(a.first,a.last,"\t")};this.blockOutdent=function(){var a=this.session.getSelection();this.session.outdentRows(a.getRange())};this.sortLines=function(){for(var a=this.$getSelectedRows(),b=this.session,c=[],d=a.first;d<=a.last;d++)c.push(b.getLine(d));c.sort(function(a,b){return a.toLowerCase()<
b.toLowerCase()?-1:a.toLowerCase()>b.toLowerCase()?1:0});for(var e=new m(0,0,0,0),d=a.first;d<=a.last;d++){var f=b.getLine(d);e.start.row=d;e.end.row=d;e.end.column=f.length;b.replace(e,c[d-a.first])}};this.toggleCommentLines=function(){var a=this.session.getState(this.getCursorPosition().row),b=this.$getSelectedRows();this.session.getMode().toggleCommentLines(a,this.session,b.first,b.last)};this.toggleBlockComment=function(){var a=this.getCursorPosition(),b=this.session.getState(a.row),c=this.getSelectionRange();
this.session.getMode().toggleBlockComment(b,this.session,c,a)};this.getNumberAt=function(a,b){var c=/[\-]?[0-9]+(?:\.[0-9]+)?/g;c.lastIndex=0;for(var d=this.session.getLine(a);c.lastIndex<b;){var e=c.exec(d);if(e.index<=b&&e.index+e[0].length>=b)return{value:e[0],start:e.index,end:e.index+e[0].length}}return null};this.modifyNumber=function(a){var b=this.selection.getCursor().row,c=this.selection.getCursor().column,d=new m(b,c-1,b,c),d=this.session.getTextRange(d);if(!isNaN(parseFloat(d))&&isFinite(d)&&
(d=this.getNumberAt(b,c))){var e=0<=d.value.indexOf(".")?d.start+d.value.indexOf(".")+1:d.end,f=d.start+d.value.length-e,g=parseFloat(d.value),g=g*Math.pow(10,f),a=e!==d.end&&c<e?a*Math.pow(10,d.end-c-1):a*Math.pow(10,d.end-c),g=(g+a)/Math.pow(10,f),a=g.toFixed(f),e=new m(b,d.start,b,d.end);this.session.replace(e,a);this.moveCursorTo(b,Math.max(d.start+1,c+a.length-d.value.length))}};this.removeLines=function(){var a=this.$getSelectedRows();this.session.removeFullLines(a.first,a.last);this.clearSelection()};
this.duplicateSelection=function(){var a=this.selection,b=this.session,c=a.getRange(),d=a.isBackwards();if(c.isEmpty())a=c.start.row,b.duplicateLines(a,a);else{var e=d?c.start:c.end,b=b.insert(e,b.getTextRange(c),!1);c.start=e;c.end=b;a.setSelectionRange(c,d)}};this.moveLinesDown=function(){this.$moveLines(1,!1)};this.moveLinesUp=function(){this.$moveLines(-1,!1)};this.moveText=function(a,b,c){return this.session.moveText(a,b,c)};this.copyLinesUp=function(){this.$moveLines(-1,!0)};this.copyLinesDown=
function(){this.$moveLines(1,!0)};this.$moveLines=function(a,b){var c,d,e=this.selection;if(!e.inMultiSelectMode||this.inVirtualSelectionMode){var f=e.toOrientedRange();c=this.$getSelectedRows(f);d=this.session.$moveLines(c.first,c.last,b?0:a);b&&-1==a&&(d=0);f.moveBy(d,0);e.fromOrientedRange(f)}else{f=e.rangeList.ranges;e.rangeList.detach(this.session);this.inVirtualSelectionMode=!0;var g=0;d=0;for(var p=f.length,i=0;i<p;i++){var k=i;f[i].moveBy(g,0);c=this.$getSelectedRows(f[i]);g=c.first;for(c=
c.last;++i<p;){d&&f[i].moveBy(d,0);var h=this.$getSelectedRows(f[i]);if(b&&h.first!=c)break;else if(!b&&h.first>c+1)break;c=h.last}i--;g=this.session.$moveLines(g,c,b?0:a);for(b&&-1==a&&(k=i+1);k<=i;)f[k].moveBy(g,0),k++;b||(g=0);d+=g}e.fromOrientedRange(e.ranges[0]);e.rangeList.attach(this.session);this.inVirtualSelectionMode=!1}};this.$getSelectedRows=function(a){a=(a||this.getSelectionRange()).collapseRows();return{first:this.session.getRowFoldStart(a.start.row),last:this.session.getRowFoldEnd(a.end.row)}};
this.onCompositionStart=function(){this.renderer.showComposition(this.getCursorPosition())};this.onCompositionUpdate=function(a){this.renderer.setCompositionText(a)};this.onCompositionEnd=function(){this.renderer.hideComposition()};this.getFirstVisibleRow=function(){return this.renderer.getFirstVisibleRow()};this.getLastVisibleRow=function(){return this.renderer.getLastVisibleRow()};this.isRowVisible=function(a){return a>=this.getFirstVisibleRow()&&a<=this.getLastVisibleRow()};this.isRowFullyVisible=
function(a){return a>=this.renderer.getFirstFullyVisibleRow()&&a<=this.renderer.getLastFullyVisibleRow()};this.$getVisibleRowCount=function(){return this.renderer.getScrollBottomRow()-this.renderer.getScrollTopRow()+1};this.$moveByPage=function(a,b){var c=this.renderer,d=this.renderer.layerConfig,e=a*Math.floor(d.height/d.lineHeight);this.$blockScrolling++;!0===b?this.selection.$moveSelection(function(){this.moveCursorBy(e,0)}):!1===b&&(this.selection.moveCursorBy(e,0),this.selection.clearSelection());
this.$blockScrolling--;var f=c.scrollTop;c.scrollBy(0,e*d.lineHeight);null!=b&&c.scrollCursorIntoView(null,0.5);c.animateScrolling(f)};this.selectPageDown=function(){this.$moveByPage(1,!0)};this.selectPageUp=function(){this.$moveByPage(-1,!0)};this.gotoPageDown=function(){this.$moveByPage(1,!1)};this.gotoPageUp=function(){this.$moveByPage(-1,!1)};this.scrollPageDown=function(){this.$moveByPage(1)};this.scrollPageUp=function(){this.$moveByPage(-1)};this.scrollToRow=function(a){this.renderer.scrollToRow(a)};
this.scrollToLine=function(a,b,c,d){this.renderer.scrollToLine(a,b,c,d)};this.centerSelection=function(){var a=this.getSelectionRange();this.renderer.alignCursor({row:Math.floor(a.start.row+(a.end.row-a.start.row)/2),column:Math.floor(a.start.column+(a.end.column-a.start.column)/2)},0.5)};this.getCursorPosition=function(){return this.selection.getCursor()};this.getCursorPositionScreen=function(){return this.session.documentToScreenPosition(this.getCursorPosition())};this.getSelectionRange=function(){return this.selection.getRange()};
this.selectAll=function(){this.$blockScrolling+=1;this.selection.selectAll();this.$blockScrolling-=1};this.clearSelection=function(){this.selection.clearSelection()};this.moveCursorTo=function(a,b){this.selection.moveCursorTo(a,b)};this.moveCursorToPosition=function(a){this.selection.moveCursorToPosition(a)};this.jumpToMatching=function(a,b){var c=this.getCursorPosition(),d=new v(this.session,c.row,c.column),e=d.getCurrentToken(),f=e||d.stepForward();if(f){var g,h=!1,i={},k=c.column-f.start,q,n={")":"(",
"(":"(","]":"[","[":"[","{":"{","}":"{"};do{if(f.value.match(/[{}()\[\]]/g))for(;k<f.value.length&&!h;k++){if(n[f.value[k]])switch(q=n[f.value[k]]+"."+f.type.replace("rparen","lparen"),isNaN(i[q])&&(i[q]=0),f.value[k]){case "(":case "[":case "{":i[q]++;break;case ")":case "]":case "}":i[q]--,-1===i[q]&&(g="bracket",h=!0)}}else f&&-1!==f.type.indexOf("tag-name")&&(isNaN(i[f.value])&&(i[f.value]=0),"<"===e.value?i[f.value]++:"</"===e.value&&i[f.value]--,-1===i[f.value]&&(g="tag",h=!0));h||(e=f,f=d.stepForward(),
k=0)}while(f&&!h);if(g){var j,l;if("bracket"===g){if(j=this.session.getBracketRange(c),!j&&(j=new m(d.getCurrentTokenRow(),d.getCurrentTokenColumn()+k-1,d.getCurrentTokenRow(),d.getCurrentTokenColumn()+k-1),l=j.start,b||l.row===c.row&&2>Math.abs(l.column-c.column)))j=this.session.getBracketRange(l)}else if("tag"===g){if(f&&-1!==f.type.indexOf("tag-name"))g=f.value;else return;j=new m(d.getCurrentTokenRow(),d.getCurrentTokenColumn()-2,d.getCurrentTokenRow(),d.getCurrentTokenColumn()-2);if(0===j.compare(c.row,
c.column)){h=!1;do if(f=e,e=d.stepBackward())-1!==e.type.indexOf("tag-close")&&j.setEnd(d.getCurrentTokenRow(),d.getCurrentTokenColumn()+1),f.value===g&&-1!==f.type.indexOf("tag-name")&&("<"===e.value?i[g]++:"</"===e.value&&i[g]--,0===i[g]&&(h=!0));while(e&&!h)}f&&f.type.indexOf("tag-name")&&(l=j.start,l.row==c.row&&2>Math.abs(l.column-c.column)&&(l=j.end))}(l=j&&j.cursor||l)&&(a?j&&b?this.selection.setRange(j):j&&j.isEqual(this.getSelectionRange())?this.clearSelection():this.selection.selectTo(l.row,
l.column):this.selection.moveTo(l.row,l.column))}}};this.gotoLine=function(a,b,c){this.selection.clearSelection();this.session.unfold({row:a-1,column:b||0});this.$blockScrolling+=1;this.exitMultiSelectMode&&this.exitMultiSelectMode();this.moveCursorTo(a-1,b||0);this.$blockScrolling-=1;this.isRowFullyVisible(a-1)||this.scrollToLine(a-1,!0,c)};this.navigateTo=function(a,b){this.selection.moveTo(a,b)};this.navigateUp=function(a){if(this.selection.isMultiLine()&&!this.selection.isBackwards())return a=
this.selection.anchor.getPosition(),this.moveCursorToPosition(a);this.selection.clearSelection();this.selection.moveCursorBy(-a||-1,0)};this.navigateDown=function(a){if(this.selection.isMultiLine()&&this.selection.isBackwards())return a=this.selection.anchor.getPosition(),this.moveCursorToPosition(a);this.selection.clearSelection();this.selection.moveCursorBy(a||1,0)};this.navigateLeft=function(a){if(this.selection.isEmpty())for(a=a||1;a--;)this.selection.moveCursorLeft();else a=this.getSelectionRange().start,
this.moveCursorToPosition(a);this.clearSelection()};this.navigateRight=function(a){if(this.selection.isEmpty())for(a=a||1;a--;)this.selection.moveCursorRight();else a=this.getSelectionRange().end,this.moveCursorToPosition(a);this.clearSelection()};this.navigateLineStart=function(){this.selection.moveCursorLineStart();this.clearSelection()};this.navigateLineEnd=function(){this.selection.moveCursorLineEnd();this.clearSelection()};this.navigateFileEnd=function(){this.selection.moveCursorFileEnd();this.clearSelection()};
this.navigateFileStart=function(){this.selection.moveCursorFileStart();this.clearSelection()};this.navigateWordRight=function(){this.selection.moveCursorWordRight();this.clearSelection()};this.navigateWordLeft=function(){this.selection.moveCursorWordLeft();this.clearSelection()};this.replace=function(a,b){b&&this.$search.set(b);var c=this.$search.find(this.session),d=0;if(!c)return d;this.$tryReplace(c,a)&&(d=1);null!==c&&(this.selection.setSelectionRange(c),this.renderer.scrollSelectionIntoView(c.start,
c.end));return d};this.replaceAll=function(a,b){b&&this.$search.set(b);var c=this.$search.findAll(this.session),d=0;if(!c.length)return d;this.$blockScrolling+=1;var e=this.getSelectionRange();this.selection.moveTo(0,0);for(var f=c.length-1;0<=f;--f)this.$tryReplace(c[f],a)&&d++;this.selection.setSelectionRange(e);this.$blockScrolling-=1;return d};this.$tryReplace=function(a,b){var c=this.session.getTextRange(a),b=this.$search.replace(c,b);return null!==b?(a.end=this.session.replace(a,b),a):null};
this.getLastSearchOptions=function(){return this.$search.getOptions()};this.find=function(a,b,c){b||(b={});"string"==typeof a||a instanceof RegExp?b.needle=a:"object"==typeof a&&t.mixin(b,a);var d=this.selection.getRange();null==b.needle&&(a=this.session.getTextRange(d)||this.$search.$options.needle,a||(d=this.session.getWordRange(d.start.row,d.start.column),a=this.session.getTextRange(d)),this.$search.set({needle:a}));this.$search.set(b);b.start||this.$search.set({start:d});a=this.$search.find(this.session);
if(b.preventScroll)return a;if(a)return this.revealRange(a,c),a;b.backwards?d.start=d.end:d.end=d.start;this.selection.setRange(d)};this.findNext=function(a,b){this.find({skipCurrent:!0,backwards:!1},a,b)};this.findPrevious=function(a,b){this.find(a,{skipCurrent:!0,backwards:!0},b)};this.revealRange=function(a,b){this.$blockScrolling+=1;this.session.unfold(a);this.selection.setSelectionRange(a);this.$blockScrolling-=1;var c=this.renderer.scrollTop;this.renderer.scrollSelectionIntoView(a.start,a.end,
0.5);!1!==b&&this.renderer.animateScrolling(c)};this.undo=function(){this.$blockScrolling++;this.session.getUndoManager().undo();this.$blockScrolling--;this.renderer.scrollCursorIntoView(null,0.5)};this.redo=function(){this.$blockScrolling++;this.session.getUndoManager().redo();this.$blockScrolling--;this.renderer.scrollCursorIntoView(null,0.5)};this.destroy=function(){this.renderer.destroy();this._signal("destroy",this);this.session&&this.session.destroy()};this.setAutoScrollEditorIntoView=function(a){if(a){var b,
c=this,d=!1;this.$scrollAnchor||(this.$scrollAnchor=document.createElement("div"));var e=this.$scrollAnchor;e.style.cssText="position:absolute";this.container.insertBefore(e,this.container.firstChild);var f=this.on("changeSelection",function(){d=!0}),g=this.renderer.on("beforeRender",function(){d&&(b=c.renderer.container.getBoundingClientRect())}),h=this.renderer.on("afterRender",function(){if(d&&b&&(c.isFocused()||c.searchBox&&c.searchBox.isFocused())){var a=c.renderer,f=a.$cursorLayer.$pixelPos,
a=a.layerConfig,g=f.top-a.offset;d=0<=f.top&&0>g+b.top?!0:f.top<a.height&&f.top+b.top+a.lineHeight>window.innerHeight?!1:null;null!=d&&(e.style.top=g+"px",e.style.left=f.left+"px",e.style.height=a.lineHeight+"px",e.scrollIntoView(d));d=b=null}});this.setAutoScrollEditorIntoView=function(a){a||(delete this.setAutoScrollEditorIntoView,this.off("changeSelection",f),this.renderer.off("afterRender",h),this.renderer.off("beforeRender",g))}}};this.$resetCursorStyle=function(){var a=this.$cursorStyle||"ace",
b=this.renderer.$cursorLayer;b&&(b.setSmoothBlinking(/smooth/.test(a)),b.isBlinking=!this.$readOnly&&"wide"!=a,u.setCssClass(b.element,"ace_slim-cursors",/slim/.test(a)))}}).call(s.prototype);n.defineOptions(s.prototype,"editor",{selectionStyle:{set:function(a){this.onSelectionChange();this._signal("changeSelectionStyle",{data:a})},initialValue:"line"},highlightActiveLine:{set:function(){this.$updateHighlightActiveLine()},initialValue:!0},highlightSelectedWord:{set:function(){this.$onSelectionChange()},
initialValue:!0},readOnly:{set:function(){this.$resetCursorStyle()},initialValue:!1},cursorStyle:{set:function(){this.$resetCursorStyle()},values:["ace","slim","smooth","wide"],initialValue:"ace"},mergeUndoDeltas:{values:[!1,!0,"always"],initialValue:!0},behavioursEnabled:{initialValue:!0},wrapBehavioursEnabled:{initialValue:!0},autoScrollEditorIntoView:{set:function(a){this.setAutoScrollEditorIntoView(a)}},keyboardHandler:{set:function(a){this.setKeyboardHandler(a)},get:function(){return this.keybindingId},
handlesSet:!0},hScrollBarAlwaysVisible:"renderer",vScrollBarAlwaysVisible:"renderer",highlightGutterLine:"renderer",animatedScroll:"renderer",showInvisibles:"renderer",showPrintMargin:"renderer",printMarginColumn:"renderer",printMargin:"renderer",fadeFoldWidgets:"renderer",showFoldWidgets:"renderer",showLineNumbers:"renderer",showGutter:"renderer",displayIndentGuides:"renderer",fontSize:"renderer",fontFamily:"renderer",maxLines:"renderer",minLines:"renderer",scrollPastEnd:"renderer",fixedWidthGutter:"renderer",
theme:"renderer",scrollSpeed:"$mouseHandler",dragDelay:"$mouseHandler",dragEnabled:"$mouseHandler",focusTimout:"$mouseHandler",tooltipFollowsMouse:"$mouseHandler",firstLineNumber:"session",overwrite:"session",newLineMode:"session",useWorker:"session",useSoftTabs:"session",tabSize:"session",wrap:"session",indentedSoftWrap:"session",foldStyle:"session",mode:"session"});w.Editor=s});