/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2010, Ajax.org B.V.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

define("require exports module ./lib/oop ./lib/dom ./config ./lib/useragent ./layer/gutter ./layer/marker ./layer/text ./layer/cursor ./scrollbar ./scrollbar ./renderloop ./layer/font_metrics ./lib/event_emitter ./requirejs/text!./css/editor.css".split(" "),function(g,n){var p=g("./lib/oop"),h=g("./lib/dom"),l=g("./config"),q=g("./lib/useragent"),r=g("./layer/gutter").Gutter,m=g("./layer/marker").Marker,s=g("./layer/text").Text,t=g("./layer/cursor").Cursor,u=g("./scrollbar").HScrollBar,v=g("./scrollbar").VScrollBar,
w=g("./renderloop").RenderLoop,x=g("./layer/font_metrics").FontMetrics,y=g("./lib/event_emitter").EventEmitter,j=g("./requirejs/text!./css/editor.css");h.importCssString(j,"ace_editor.css");j=function(a,c){var b=this;this.container=a||h.createElement("div");this.$keepTextAreaAtCursor=!q.isOldIE;h.addCssClass(this.container,"ace_editor");this.setTheme(c);this.$gutter=h.createElement("div");this.$gutter.className="ace_gutter";this.container.appendChild(this.$gutter);this.scroller=h.createElement("div");
this.scroller.className="ace_scroller";this.container.appendChild(this.scroller);this.content=h.createElement("div");this.content.className="ace_content";this.scroller.appendChild(this.content);this.$gutterLayer=new r(this.$gutter);this.$gutterLayer.on("changeGutterWidth",this.onGutterResize.bind(this));this.$markerBack=new m(this.content);this.canvas=(this.$textLayer=new s(this.content)).element;this.$markerFront=new m(this.content);this.$cursorLayer=new t(this.content);this.$vScroll=this.$horizScroll=
!1;this.scrollBar=this.scrollBarV=new v(this.container,this);this.scrollBarH=new u(this.container,this);this.scrollBarV.addEventListener("scroll",function(a){b.$scrollAnimation||b.session.setScrollTop(a.data-b.scrollMargin.top)});this.scrollBarH.addEventListener("scroll",function(a){b.$scrollAnimation||b.session.setScrollLeft(a.data-b.scrollMargin.left)});this.scrollLeft=this.scrollTop=0;this.cursorPos={row:0,column:0};this.$fontMetrics=new x(this.container);this.$textLayer.$setFontMetrics(this.$fontMetrics);
this.$textLayer.addEventListener("changeCharacterSize",function(a){b.updateCharacterSize();b.onResize(!0,b.gutterWidth,b.$size.width,b.$size.height);b._signal("changeCharacterSize",a)});this.$size={width:0,height:0,scrollerHeight:0,scrollerWidth:0,$dirty:!0};this.layerConfig={width:1,padding:0,firstRow:0,firstRowScreen:0,lastRow:0,lineHeight:0,characterWidth:0,minHeight:1,maxHeight:1,offset:0,height:1,gutterOffset:1};this.scrollMargin={left:0,right:0,top:0,bottom:0,v:0,h:0};this.$loop=new w(this.$renderChanges.bind(this),
this.container.ownerDocument.defaultView);this.$loop.schedule(this.CHANGE_FULL);this.updateCharacterSize();this.setPadding(4);l.resetOptions(this);l._emit("renderer",this)};(function(){this.CHANGE_CURSOR=1;this.CHANGE_MARKER=2;this.CHANGE_GUTTER=4;this.CHANGE_SCROLL=8;this.CHANGE_LINES=16;this.CHANGE_TEXT=32;this.CHANGE_SIZE=64;this.CHANGE_MARKER_BACK=128;this.CHANGE_MARKER_FRONT=256;this.CHANGE_FULL=512;this.CHANGE_H_SCROLL=1024;p.implement(this,y);this.updateCharacterSize=function(){this.$textLayer.allowBoldFonts!=
this.$allowBoldFonts&&(this.$allowBoldFonts=this.$textLayer.allowBoldFonts,this.setStyle("ace_nobold",!this.$allowBoldFonts));this.layerConfig.characterWidth=this.characterWidth=this.$textLayer.getCharacterWidth();this.layerConfig.lineHeight=this.lineHeight=this.$textLayer.getLineHeight();this.$updatePrintMargin()};this.setSession=function(a){this.session&&this.session.doc.off("changeNewLineMode",this.onChangeNewLineMode);(this.session=a)&&(this.scrollMargin.top&&0>=a.getScrollTop())&&a.setScrollTop(-this.scrollMargin.top);
this.$cursorLayer.setSession(a);this.$markerBack.setSession(a);this.$markerFront.setSession(a);this.$gutterLayer.setSession(a);this.$textLayer.setSession(a);a&&(this.$loop.schedule(this.CHANGE_FULL),this.session.$setFontMetrics(this.$fontMetrics),this.scrollBarV.scrollLeft=this.scrollBarV.scrollTop=null,this.onChangeNewLineMode=this.onChangeNewLineMode.bind(this),this.onChangeNewLineMode(),this.session.doc.on("changeNewLineMode",this.onChangeNewLineMode))};this.updateLines=function(a,c,b){void 0===
c&&(c=Infinity);this.$changedLines?(this.$changedLines.firstRow>a&&(this.$changedLines.firstRow=a),this.$changedLines.lastRow<c&&(this.$changedLines.lastRow=c)):this.$changedLines={firstRow:a,lastRow:c};if(this.$changedLines.lastRow<this.layerConfig.firstRow)if(b)this.$changedLines.lastRow=this.layerConfig.lastRow;else return;this.$changedLines.firstRow>this.layerConfig.lastRow||this.$loop.schedule(this.CHANGE_LINES)};this.onChangeNewLineMode=function(){this.$loop.schedule(this.CHANGE_TEXT);this.$textLayer.$updateEolChar()};
this.onChangeTabSize=function(){this.$loop.schedule(this.CHANGE_TEXT|this.CHANGE_MARKER);this.$textLayer.onChangeTabSize()};this.updateText=function(){this.$loop.schedule(this.CHANGE_TEXT)};this.updateFull=function(a){a?this.$renderChanges(this.CHANGE_FULL,!0):this.$loop.schedule(this.CHANGE_FULL)};this.updateFontSize=function(){this.$textLayer.checkForSizeChanges()};this.$changes=0;this.$updateSizeAsync=function(){if(this.$loop.pending)this.$size.$dirty=!0;else this.onResize()};this.onResize=function(a,
c,b,d){if(!(2<this.resizing)){0<this.resizing?this.resizing++:this.resizing=a?1:0;var e=this.container;d||(d=e.clientHeight||e.scrollHeight);b||(b=e.clientWidth||e.scrollWidth);c=this.$updateCachedSize(a,c,b,d);if(!this.$size.scrollerHeight||!b&&!d)return this.resizing=0;a&&(this.$gutterLayer.$padding=null);a?this.$renderChanges(c|this.$changes,!0):this.$loop.schedule(c|this.$changes);this.resizing&&(this.resizing=0);this.scrollBarV.scrollLeft=this.scrollBarV.scrollTop=null}};this.$updateCachedSize=
function(a,c,b,d){var d=d-(this.$extraHeight||0),e=0,f=this.$size,h={width:f.width,height:f.height,scrollerHeight:f.scrollerHeight,scrollerWidth:f.scrollerWidth};if(d&&(a||f.height!=d))f.height=d,e|=this.CHANGE_SIZE,f.scrollerHeight=f.height,this.$horizScroll&&(f.scrollerHeight-=this.scrollBarH.getHeight()),this.scrollBarV.element.style.bottom=this.scrollBarH.getHeight()+"px",e|=this.CHANGE_SCROLL;if(b&&(a||f.width!=b))if(e|=this.CHANGE_SIZE,f.width=b,null==c&&(c=this.$showGutter?this.$gutter.offsetWidth:
0),this.gutterWidth=c,this.scrollBarH.element.style.left=this.scroller.style.left=c+"px",f.scrollerWidth=Math.max(0,b-c-this.scrollBarV.getWidth()),this.scrollBarH.element.style.right=this.scroller.style.right=this.scrollBarV.getWidth()+"px",this.scroller.style.bottom=this.scrollBarH.getHeight()+"px",this.session&&this.session.getUseWrapMode()&&this.adjustWrapLimit()||a)e|=this.CHANGE_FULL;f.$dirty=!b||!d;e&&this._signal("resize",h);return e};this.onGutterResize=function(){var a=this.$showGutter?
this.$gutter.offsetWidth:0;a!=this.gutterWidth&&(this.$changes|=this.$updateCachedSize(!0,a,this.$size.width,this.$size.height));this.session.getUseWrapMode()&&this.adjustWrapLimit()?this.$loop.schedule(this.CHANGE_FULL):this.$size.$dirty?this.$loop.schedule(this.CHANGE_FULL):(this.$computeLayerConfig(),this.$loop.schedule(this.CHANGE_MARKER))};this.adjustWrapLimit=function(){return this.session.adjustWrapLimit(Math.floor((this.$size.scrollerWidth-2*this.$padding)/this.characterWidth),this.$showPrintMargin&&
this.$printMarginColumn)};this.setAnimatedScroll=function(a){this.setOption("animatedScroll",a)};this.getAnimatedScroll=function(){return this.$animatedScroll};this.setShowInvisibles=function(a){this.setOption("showInvisibles",a)};this.getShowInvisibles=function(){return this.getOption("showInvisibles")};this.getDisplayIndentGuides=function(){return this.getOption("displayIndentGuides")};this.setDisplayIndentGuides=function(a){this.setOption("displayIndentGuides",a)};this.setShowPrintMargin=function(a){this.setOption("showPrintMargin",
a)};this.getShowPrintMargin=function(){return this.getOption("showPrintMargin")};this.setPrintMarginColumn=function(a){this.setOption("printMarginColumn",a)};this.getPrintMarginColumn=function(){return this.getOption("printMarginColumn")};this.getShowGutter=function(){return this.getOption("showGutter")};this.setShowGutter=function(a){return this.setOption("showGutter",a)};this.getFadeFoldWidgets=function(){return this.getOption("fadeFoldWidgets")};this.setFadeFoldWidgets=function(a){this.setOption("fadeFoldWidgets",
a)};this.setHighlightGutterLine=function(a){this.setOption("highlightGutterLine",a)};this.getHighlightGutterLine=function(){return this.getOption("highlightGutterLine")};this.$updateGutterLineHighlight=function(){var a=this.$cursorLayer.$pixelPos,c=this.layerConfig.lineHeight;if(this.session.getUseWrapMode()){var b=this.session.selection.getCursor();b.column=0;a=this.$cursorLayer.getPixelPosition(b,!0);c*=this.session.getRowLength(b.row)}this.$gutterLineHighlight.style.top=a.top-this.layerConfig.offset+
"px";this.$gutterLineHighlight.style.height=c+"px"};this.$updatePrintMargin=function(){if(this.$showPrintMargin||this.$printMarginEl){if(!this.$printMarginEl){var a=h.createElement("div");a.className="ace_layer ace_print-margin-layer";this.$printMarginEl=h.createElement("div");this.$printMarginEl.className="ace_print-margin";a.appendChild(this.$printMarginEl);this.content.insertBefore(a,this.content.firstChild)}a=this.$printMarginEl.style;a.left=this.characterWidth*this.$printMarginColumn+this.$padding+
"px";a.visibility=this.$showPrintMargin?"visible":"hidden";this.session&&-1==this.session.$wrap&&this.adjustWrapLimit()}};this.getContainerElement=function(){return this.container};this.getMouseEventTarget=function(){return this.scroller};this.getTextAreaContainer=function(){return this.container};this.$moveTextAreaToCursor=function(){if(this.$keepTextAreaAtCursor){var a=this.layerConfig,c=this.$cursorLayer.$pixelPos.top,b=this.$cursorLayer.$pixelPos.left,c=c-a.offset,d=this.textarea.style,e=this.lineHeight;
if(0>c||c>a.height-e)d.top=d.left="0";else{a=this.characterWidth;if(this.$composition)var f=this.textarea.value.replace(/^\x01+/,""),a=a*(this.session.$getStringScreenWidth(f)[0]+2),e=e+2;b-=this.scrollLeft;b>this.$size.scrollerWidth-a&&(b=this.$size.scrollerWidth-a);b+=this.gutterWidth;d.height=e+"px";d.width=a+"px";d.left=Math.min(b,this.$size.scrollerWidth-a)+"px";d.top=Math.min(c,this.$size.height-e)+"px"}}};this.getFirstVisibleRow=function(){return this.layerConfig.firstRow};this.getFirstFullyVisibleRow=
function(){return this.layerConfig.firstRow+(0===this.layerConfig.offset?0:1)};this.getLastFullyVisibleRow=function(){var a=this.layerConfig,c=a.lastRow;return this.session.documentToScreenRow(c,0)*a.lineHeight-this.session.getScrollTop()>a.height-a.lineHeight?c-1:c};this.getLastVisibleRow=function(){return this.layerConfig.lastRow};this.$padding=null;this.setPadding=function(a){this.$padding=a;this.$textLayer.setPadding(a);this.$cursorLayer.setPadding(a);this.$markerFront.setPadding(a);this.$markerBack.setPadding(a);
this.$loop.schedule(this.CHANGE_FULL);this.$updatePrintMargin()};this.setScrollMargin=function(a,c,b,d){var e=this.scrollMargin;e.top=a|0;e.bottom=c|0;e.right=d|0;e.left=b|0;e.v=e.top+e.bottom;e.h=e.left+e.right;e.top&&(0>=this.scrollTop&&this.session)&&this.session.setScrollTop(-e.top);this.updateFull()};this.getHScrollBarAlwaysVisible=function(){return this.$hScrollBarAlwaysVisible};this.setHScrollBarAlwaysVisible=function(a){this.setOption("hScrollBarAlwaysVisible",a)};this.getVScrollBarAlwaysVisible=
function(){return this.$vScrollBarAlwaysVisible};this.setVScrollBarAlwaysVisible=function(a){this.setOption("vScrollBarAlwaysVisible",a)};this.$updateScrollBarV=function(){var a=this.layerConfig.maxHeight,c=this.$size.scrollerHeight;!this.$maxLines&&this.$scrollPastEnd&&(a-=(c-this.lineHeight)*this.$scrollPastEnd,this.scrollTop>a-c&&(a=this.scrollTop+c,this.scrollBarV.scrollTop=null));this.scrollBarV.setScrollHeight(a+this.scrollMargin.v);this.scrollBarV.setScrollTop(this.scrollTop+this.scrollMargin.top)};
this.$updateScrollBarH=function(){this.scrollBarH.setScrollWidth(this.layerConfig.width+2*this.$padding+this.scrollMargin.h);this.scrollBarH.setScrollLeft(this.scrollLeft+this.scrollMargin.left)};this.$frozen=!1;this.freeze=function(){this.$frozen=!0};this.unfreeze=function(){this.$frozen=!1};this.$renderChanges=function(a,c){this.$changes&&(a|=this.$changes,this.$changes=0);if(!this.session||(!this.container.offsetWidth||this.$frozen)||!a&&!c)this.$changes|=a;else{if(this.$size.$dirty)return this.$changes|=
a,this.onResize(!0);this.lineHeight||this.$textLayer.checkForSizeChanges();this._signal("beforeRender");var b=this.layerConfig;if(a&this.CHANGE_FULL||a&this.CHANGE_SIZE||a&this.CHANGE_TEXT||a&this.CHANGE_LINES||a&this.CHANGE_SCROLL||a&this.CHANGE_H_SCROLL)a|=this.$computeLayerConfig(),b.firstRow!=this.layerConfig.firstRow&&b.firstRowScreen==this.layerConfig.firstRowScreen&&(b=this.scrollTop+(b.firstRow-this.layerConfig.firstRow)*this.lineHeight,0<b&&(this.scrollTop=b,a|=this.CHANGE_SCROLL,a|=this.$computeLayerConfig())),
b=this.layerConfig,this.$updateScrollBarV(),a&this.CHANGE_H_SCROLL&&this.$updateScrollBarH(),this.$gutterLayer.element.style.marginTop=-b.offset+"px",this.content.style.marginTop=-b.offset+"px",this.content.style.width=b.width+2*this.$padding+"px",this.content.style.height=b.minHeight+"px";a&this.CHANGE_H_SCROLL&&(this.content.style.marginLeft=-this.scrollLeft+"px",this.scroller.className=0>=this.scrollLeft?"ace_scroller":"ace_scroller ace_scroll-left");a&this.CHANGE_FULL?(this.$textLayer.update(b),
this.$showGutter&&this.$gutterLayer.update(b),this.$markerBack.update(b),this.$markerFront.update(b),this.$cursorLayer.update(b),this.$moveTextAreaToCursor(),this.$highlightGutterLine&&this.$updateGutterLineHighlight()):a&this.CHANGE_SCROLL?(a&this.CHANGE_TEXT||a&this.CHANGE_LINES?this.$textLayer.update(b):this.$textLayer.scrollLines(b),this.$showGutter&&this.$gutterLayer.update(b),this.$markerBack.update(b),this.$markerFront.update(b),this.$cursorLayer.update(b),this.$highlightGutterLine&&this.$updateGutterLineHighlight(),
this.$moveTextAreaToCursor()):(a&this.CHANGE_TEXT?(this.$textLayer.update(b),this.$showGutter&&this.$gutterLayer.update(b)):a&this.CHANGE_LINES?(this.$updateLines()||a&this.CHANGE_GUTTER&&this.$showGutter)&&this.$gutterLayer.update(b):(a&this.CHANGE_TEXT||a&this.CHANGE_GUTTER)&&this.$showGutter&&this.$gutterLayer.update(b),a&this.CHANGE_CURSOR&&(this.$cursorLayer.update(b),this.$moveTextAreaToCursor(),this.$highlightGutterLine&&this.$updateGutterLineHighlight()),a&(this.CHANGE_MARKER|this.CHANGE_MARKER_FRONT)&&
this.$markerFront.update(b),a&(this.CHANGE_MARKER|this.CHANGE_MARKER_BACK)&&this.$markerBack.update(b));this._signal("afterRender")}};this.$autosize=function(){var a=this.session.getScreenLength()*this.lineHeight,c=this.$maxLines*this.lineHeight,b=Math.min(c,Math.max((this.$minLines||1)*this.lineHeight,a))+this.scrollMargin.v+(this.$extraHeight||0);this.$horizScroll&&(b+=this.scrollBarH.getHeight());this.$maxPixelHeight&&b>this.$maxPixelHeight&&(b=this.$maxPixelHeight);a=a>c;if(b!=this.desiredHeight||
this.$size.height!=this.desiredHeight||a!=this.$vScroll)a!=this.$vScroll&&(this.$vScroll=a,this.scrollBarV.setVisible(a)),a=this.container.clientWidth,this.container.style.height=b+"px",this.$updateCachedSize(!0,this.$gutterWidth,a,b),this.desiredHeight=b,this._signal("autosize")};this.$computeLayerConfig=function(){var a=this.session,c=this.$size,b=c.height<=2*this.lineHeight,d=this.session.getScreenLength()*this.lineHeight,e=this.$getLongestLine(),f=!b&&(this.$hScrollBarAlwaysVisible||0>c.scrollerWidth-
e-2*this.$padding),h=this.$horizScroll!==f;h&&(this.$horizScroll=f,this.scrollBarH.setVisible(f));var g=this.$vScroll;this.$maxLines&&1<this.lineHeight&&this.$autosize();var f=this.scrollTop%this.lineHeight,j=c.scrollerHeight+this.lineHeight,k=!this.$maxLines&&this.$scrollPastEnd?(c.scrollerHeight-this.lineHeight)*this.$scrollPastEnd:0,d=d+k,i=this.scrollMargin;this.session.setScrollTop(Math.max(-i.top,Math.min(this.scrollTop,d-c.scrollerHeight+i.bottom)));this.session.setScrollLeft(Math.max(-i.left,
Math.min(this.scrollLeft,e+2*this.$padding-c.scrollerWidth+i.right)));k=!b&&(this.$vScrollBarAlwaysVisible||0>c.scrollerHeight-d+k||this.scrollTop>i.top);if(b=g!==k)this.$vScroll=k,this.scrollBarV.setVisible(k);var j=Math.ceil(j/this.lineHeight)-1,g=Math.max(0,Math.round((this.scrollTop-f)/this.lineHeight)),k=g+j,l,i=this.lineHeight,g=a.screenToDocumentRow(g,0);if(f=a.getFoldLine(g))g=f.start.row;l=a.documentToScreenRow(g,0);f=a.getRowLength(g)*i;k=Math.min(a.screenToDocumentRow(k,0),a.getLength()-
1);j=c.scrollerHeight+a.getRowLength(k)*i+f;f=this.scrollTop-l*i;a=0;this.layerConfig.width!=e&&(a=this.CHANGE_H_SCROLL);if(h||b)a=this.$updateCachedSize(!0,this.gutterWidth,c.width,c.height),this._signal("scrollbarVisibilityChanged"),b&&(e=this.$getLongestLine());this.layerConfig={width:e,padding:this.$padding,firstRow:g,firstRowScreen:l,lastRow:k,lineHeight:i,characterWidth:this.characterWidth,minHeight:j,maxHeight:d,offset:f,gutterOffset:i?Math.max(0,Math.ceil((f+c.height-c.scrollerHeight)/i)):
0,height:this.$size.scrollerHeight};return a};this.$updateLines=function(){var a=this.$changedLines.firstRow,c=this.$changedLines.lastRow;this.$changedLines=null;var b=this.layerConfig;if(!(a>b.lastRow+1)&&!(c<b.firstRow))if(Infinity===c)this.$showGutter&&this.$gutterLayer.update(b),this.$textLayer.update(b);else return this.$textLayer.updateLines(b,a,c),!0};this.$getLongestLine=function(){var a=this.session.getScreenWidth();this.showInvisibles&&!this.session.$useWrapMode&&(a+=1);return Math.max(this.$size.scrollerWidth-
2*this.$padding,Math.round(a*this.characterWidth))};this.updateFrontMarkers=function(){this.$markerFront.setMarkers(this.session.getMarkers(!0));this.$loop.schedule(this.CHANGE_MARKER_FRONT)};this.updateBackMarkers=function(){this.$markerBack.setMarkers(this.session.getMarkers());this.$loop.schedule(this.CHANGE_MARKER_BACK)};this.addGutterDecoration=function(a,c){this.$gutterLayer.addGutterDecoration(a,c)};this.removeGutterDecoration=function(a,c){this.$gutterLayer.removeGutterDecoration(a,c)};this.updateBreakpoints=
function(){this.$loop.schedule(this.CHANGE_GUTTER)};this.setAnnotations=function(a){this.$gutterLayer.setAnnotations(a);this.$loop.schedule(this.CHANGE_GUTTER)};this.updateCursor=function(){this.$loop.schedule(this.CHANGE_CURSOR)};this.hideCursor=function(){this.$cursorLayer.hideCursor()};this.showCursor=function(){this.$cursorLayer.showCursor()};this.scrollSelectionIntoView=function(a,c,b){this.scrollCursorIntoView(a,b);this.scrollCursorIntoView(c,b)};this.scrollCursorIntoView=function(a,c,b){if(0!==
this.$size.scrollerHeight){var d=this.$cursorLayer.getPixelPosition(a),a=d.left,d=d.top,e=b&&b.top||0,b=b&&b.bottom||0,f=this.$scrollAnimation?this.session.getScrollTop():this.scrollTop;f+e>d?(c&&f+e>d+this.lineHeight&&(d-=c*this.$size.scrollerHeight),0===d&&(d=-this.scrollMargin.top),this.session.setScrollTop(d)):f+this.$size.scrollerHeight-b<d+this.lineHeight&&(c&&f+this.$size.scrollerHeight-b<d-this.lineHeight&&(d+=c*this.$size.scrollerHeight),this.session.setScrollTop(d+this.lineHeight-this.$size.scrollerHeight));
c=this.scrollLeft;c>a?(a<this.$padding+2*this.layerConfig.characterWidth&&(a=-this.scrollMargin.left),this.session.setScrollLeft(a)):c+this.$size.scrollerWidth<a+this.characterWidth?this.session.setScrollLeft(Math.round(a+this.characterWidth-this.$size.scrollerWidth)):c<=this.$padding&&a-c<this.characterWidth&&this.session.setScrollLeft(0)}};this.getScrollTop=function(){return this.session.getScrollTop()};this.getScrollLeft=function(){return this.session.getScrollLeft()};this.getScrollTopRow=function(){return this.scrollTop/
this.lineHeight};this.getScrollBottomRow=function(){return Math.max(0,Math.floor((this.scrollTop+this.$size.scrollerHeight)/this.lineHeight)-1)};this.scrollToRow=function(a){this.session.setScrollTop(a*this.lineHeight)};this.alignCursor=function(a,c){"number"==typeof a&&(a={row:a,column:0});var b=this.$cursorLayer.getPixelPosition(a).top-(this.$size.scrollerHeight-this.lineHeight)*(c||0);this.session.setScrollTop(b);return b};this.STEPS=8;this.$calcSteps=function(a,c){for(var b=0,d=this.STEPS,e=[],
b=0;b<d;++b)e.push((c-a)*(Math.pow(b/this.STEPS-1,3)+1)+a);return e};this.scrollToLine=function(a,c,b,d){a=this.$cursorLayer.getPixelPosition({row:a,column:0}).top;c&&(a-=this.$size.scrollerHeight/2);c=this.scrollTop;this.session.setScrollTop(a);!1!==b&&this.animateScrolling(c,d)};this.animateScrolling=function(a,c){var b=this.scrollTop;if(this.$animatedScroll){var d=this;if(a!=b){if(this.$scrollAnimation){var e=this.$scrollAnimation.steps;if(e.length&&(a=e[0],a==b))return}var f=d.$calcSteps(a,b);
this.$scrollAnimation={from:a,to:b,steps:f};clearInterval(this.$timer);d.session.setScrollTop(f.shift());d.session.$scrollTop=b;this.$timer=setInterval(function(){f.length?(d.session.setScrollTop(f.shift()),d.session.$scrollTop=b):null!=b?(d.session.$scrollTop=-1,d.session.setScrollTop(b),b=null):(d.$timer=clearInterval(d.$timer),d.$scrollAnimation=null,c&&c())},10)}}};this.scrollToY=function(a){this.scrollTop!==a&&(this.$loop.schedule(this.CHANGE_SCROLL),this.scrollTop=a)};this.scrollToX=function(a){this.scrollLeft!==
a&&(this.scrollLeft=a);this.$loop.schedule(this.CHANGE_H_SCROLL)};this.scrollTo=function(a,c){this.session.setScrollTop(c);this.session.setScrollLeft(c)};this.scrollBy=function(a,c){c&&this.session.setScrollTop(this.session.getScrollTop()+c);a&&this.session.setScrollLeft(this.session.getScrollLeft()+a)};this.isScrollableBy=function(a,c){if(0>c&&this.session.getScrollTop()>=1-this.scrollMargin.top||0<c&&this.session.getScrollTop()+this.$size.scrollerHeight-this.layerConfig.maxHeight<-1+this.scrollMargin.bottom||
0>a&&this.session.getScrollLeft()>=1-this.scrollMargin.left||0<a&&this.session.getScrollLeft()+this.$size.scrollerWidth-this.layerConfig.width<-1+this.scrollMargin.right)return!0};this.pixelToScreenCoordinates=function(a,c){var b=this.scroller.getBoundingClientRect(),d=(a+this.scrollLeft-b.left-this.$padding)/this.characterWidth,b=Math.floor((c+this.scrollTop-b.top)/this.lineHeight),e=Math.round(d);return{row:b,column:e,side:0<d-e?1:-1}};this.screenToTextCoordinates=function(a,c){var b=this.scroller.getBoundingClientRect(),
d=Math.round((a+this.scrollLeft-b.left-this.$padding)/this.characterWidth);return this.session.screenToDocumentPosition((c+this.scrollTop-b.top)/this.lineHeight,Math.max(d,0))};this.textToScreenCoordinates=function(a,c){var b=this.scroller.getBoundingClientRect(),d=this.session.documentToScreenPosition(a,c),e=this.$padding+Math.round(d.column*this.characterWidth);return{pageX:b.left+e-this.scrollLeft,pageY:b.top+d.row*this.lineHeight-this.scrollTop}};this.visualizeFocus=function(){h.addCssClass(this.container,
"ace_focus")};this.visualizeBlur=function(){h.removeCssClass(this.container,"ace_focus")};this.showComposition=function(){this.$composition||(this.$composition={keepTextAreaAtCursor:this.$keepTextAreaAtCursor,cssText:this.textarea.style.cssText});this.$keepTextAreaAtCursor=!0;h.addCssClass(this.textarea,"ace_composition");this.textarea.style.cssText="";this.$moveTextAreaToCursor()};this.setCompositionText=function(){this.$moveTextAreaToCursor()};this.hideComposition=function(){this.$composition&&
(h.removeCssClass(this.textarea,"ace_composition"),this.$keepTextAreaAtCursor=this.$composition.keepTextAreaAtCursor,this.textarea.style.cssText=this.$composition.cssText,this.$composition=null)};this.setTheme=function(a,c){function b(b){if(d.$themeId!=a)return c&&c();if(!b||!b.cssClass)throw Error("couldn't load module "+a+" or it didn't call define");h.importCssString(b.cssText,b.cssClass,d.container.ownerDocument);d.theme&&h.removeCssClass(d.container,d.theme.cssClass);var f="padding"in b?b.padding:
"padding"in(d.theme||{})?4:d.$padding;d.$padding&&f!=d.$padding&&d.setPadding(f);d.$theme=b.cssClass;d.theme=b;h.addCssClass(d.container,b.cssClass);h.setCssClass(d.container,"ace_dark",b.isDark);d.$size&&(d.$size.width=0,d.$updateSizeAsync());d._dispatchEvent("themeLoaded",{theme:b});c&&c()}var d=this;this.$themeId=a;d._dispatchEvent("themeChange",{theme:a});!a||"string"==typeof a?l.loadModule(["theme",a||this.$options.theme.initialValue],b):b(a)};this.getTheme=function(){return this.$themeId};this.setStyle=
function(a,c){h.setCssClass(this.container,a,!1!==c)};this.unsetStyle=function(a){h.removeCssClass(this.container,a)};this.setCursorStyle=function(a){this.scroller.style.cursor!=a&&(this.scroller.style.cursor=a)};this.setMouseCursor=function(a){this.scroller.style.cursor=a};this.destroy=function(){this.$textLayer.destroy();this.$cursorLayer.destroy()}}).call(j.prototype);l.defineOptions(j.prototype,"renderer",{animatedScroll:{initialValue:!1},showInvisibles:{set:function(a){this.$textLayer.setShowInvisibles(a)&&
this.$loop.schedule(this.CHANGE_TEXT)},initialValue:!1},showPrintMargin:{set:function(){this.$updatePrintMargin()},initialValue:!0},printMarginColumn:{set:function(){this.$updatePrintMargin()},initialValue:80},printMargin:{set:function(a){"number"==typeof a&&(this.$printMarginColumn=a);this.$showPrintMargin=!!a;this.$updatePrintMargin()},get:function(){return this.$showPrintMargin&&this.$printMarginColumn}},showGutter:{set:function(a){this.$gutter.style.display=a?"block":"none";this.$loop.schedule(this.CHANGE_FULL);
this.onGutterResize()},initialValue:!0},fadeFoldWidgets:{set:function(a){h.setCssClass(this.$gutter,"ace_fade-fold-widgets",a)},initialValue:!1},showFoldWidgets:{set:function(a){this.$gutterLayer.setShowFoldWidgets(a)},initialValue:!0},showLineNumbers:{set:function(a){this.$gutterLayer.setShowLineNumbers(a);this.$loop.schedule(this.CHANGE_GUTTER)},initialValue:!0},displayIndentGuides:{set:function(a){this.$textLayer.setDisplayIndentGuides(a)&&this.$loop.schedule(this.CHANGE_TEXT)},initialValue:!0},
highlightGutterLine:{set:function(a){this.$gutterLineHighlight?(this.$gutterLineHighlight.style.display=a?"":"none",this.$cursorLayer.$pixelPos&&this.$updateGutterLineHighlight()):(this.$gutterLineHighlight=h.createElement("div"),this.$gutterLineHighlight.className="ace_gutter-active-line",this.$gutter.appendChild(this.$gutterLineHighlight))},initialValue:!1,value:!0},hScrollBarAlwaysVisible:{set:function(){(!this.$hScrollBarAlwaysVisible||!this.$horizScroll)&&this.$loop.schedule(this.CHANGE_SCROLL)},
initialValue:!1},vScrollBarAlwaysVisible:{set:function(){(!this.$vScrollBarAlwaysVisible||!this.$vScroll)&&this.$loop.schedule(this.CHANGE_SCROLL)},initialValue:!1},fontSize:{set:function(a){"number"==typeof a&&(a+="px");this.container.style.fontSize=a;this.updateFontSize()},initialValue:12},fontFamily:{set:function(a){this.container.style.fontFamily=a;this.updateFontSize()}},maxLines:{set:function(){this.updateFull()}},minLines:{set:function(){this.updateFull()}},maxPixelHeight:{set:function(){this.updateFull()},
initialValue:0},scrollPastEnd:{set:function(a){a=+a||0;this.$scrollPastEnd!=a&&(this.$scrollPastEnd=a,this.$loop.schedule(this.CHANGE_SCROLL))},initialValue:0,handlesSet:!0},fixedWidthGutter:{set:function(a){this.$gutterLayer.$fixedWidth=!!a;this.$loop.schedule(this.CHANGE_GUTTER)}},theme:{set:function(a){this.setTheme(a)},get:function(){return this.$themeId||this.theme},initialValue:"./theme/textmate",handlesSet:!0}});n.VirtualRenderer=j});