define("component/message/MessageType",["underscore"],function(b){return{SUCCESS:{value:0,name:"SUCCESS"},INFO:{value:1,name:"INFO"},WARN:{value:2,name:"WARN"},ERROR:{value:3,name:"ERROR"},getTypeFromString:function(c){return b.findWhere(this,{name:c.toUpperCase()})}}});
define("component/message/Message",["underscore","component/message/MessageType"],function(b,c){var a=function(f,e,d,a,j,i){this._type=b.isString(f)?c.getTypeFromString(f):f;this._message=e;this._action=d;this._autoHide=a;this._tag=j;this._allowClose=void 0===i?!0:i};a.prototype.getType=function(){return this._type};a.prototype.getMessage=function(){return this._message};a.prototype.getAction=function(){return this._action};a.prototype.getAutoHide=function(){return this._autoHide};a.prototype.getTag=
function(){return this._tag};a.prototype.allowClose=function(){return this._allowClose};return a});
define("component/message/MessageModel",["utils/Observable","underscore"],function(b,c){var a=function(){b.mixin(this,"message");this._messageQueue=[]};a.prototype.addToMessageQueue=function(b){this._messageQueue.push(b);this._emit("added",b)};a.prototype.getNextMessage=function(){return this._messageQueue.shift()};a.prototype.markObsolete=function(b){this._messageQueue=c.filter(this._messageQueue,function(a){return!a.getTag()||a.getTag()!==b});this._emit("obsolete",b)};a.prototype.getMessageCount=
function(){return this._messageQueue.length};return a});define("utils/webcss-text!component/message/messagewidget-style.css",[],function(){return"/*!\r\n * Bootstrap v2.3.2\r\n *\r\n * Copyright 2013 Twitter, Inc\r\n * Licensed under the Apache License v2.0\r\n * http://www.apache.org/licenses/LICENSE-2.0\r\n *\r\n * Designed and built with all the love in the world @twitter by @mdo and @fat.\r\n * changed by esko: split off alert, close\r\n */\r\n.messageWidget .alert {\r\n\tpadding: 8px 35px 8px 14px;\r\n\tmargin-bottom: 20px;\r\n\tbackground-color: #fcf8e3;\r\n\tborder: 1px solid #fbeed5;\r\n}\r\n.messageWidget .alert,\r\n.messageWidget .alert h4 {\r\n\tcolor: #c09853;\r\n}\r\n.messageWidget .alert h4 {\r\n\tmargin: 0;\r\n}\r\n.messageWidget .alert-success {\r\n\tbackground-color: #dff0d8;\r\n\tborder-color: #d6e9c6;\r\n\tcolor: #468847;\r\n}\r\n.messageWidget .alert-success h4 {\r\n\tcolor: #468847;\r\n}\r\n.messageWidget .alert-danger,\r\n.messageWidget .alert-error {\r\n\tbackground-color: #f2dede;\r\n\tborder-color: #eed3d7;\r\n\tcolor: #b94a48;\r\n}\r\n.messageWidget .alert-danger h4,\r\n.messageWidget .alert-error h4 {\r\n\tcolor: #b94a48;\r\n}\r\n.messageWidget .alert-info {\r\n\tbackground-color: #d9edf7;\r\n\tborder-color: #bce8f1;\r\n\tcolor: #3a87ad;\r\n}\r\n.messageWidget .alert-info h4 {\r\n\tcolor: #3a87ad;\r\n}\r\n.messageWidget .alert-block {\r\n\tpadding-top: 14px;\r\n\tpadding-bottom: 14px;\r\n}\r\n.messageWidget .alert-block > p,\r\n.messageWidget .alert-block > ul {\r\n\tmargin-bottom: 0;\r\n}\r\n.messageWidget .alert-block p + p {\r\n\tmargin-top: 5px;\r\n}\r\n.messageWidget .close {\r\n\tfloat: right;\r\n\tfont-weight: bold;\r\n\tcolor: #000000;\r\n\topacity: 0.2;\r\n\tfilter: alpha(opacity=20);\r\n}\r\n.messageWidget .close:hover,\r\n.messageWidget .close:focus {\r\n\tcolor: #000000;\r\n\ttext-decoration: none;\r\n\tcursor: pointer;\r\n\topacity: 0.4;\r\n\tfilter: alpha(opacity=40);\r\n}\r\n.messageWidget button.close {\r\n\tpadding: 0;\r\n\tcursor: pointer;\r\n\tbackground: transparent;\r\n\tborder: 0;\r\n\t-webkit-appearance: none;\r\n}\r\n.messageWidget .message-text {\r\n\twhite-space: pre-wrap;\r\n}"});
define("component/message/MessageWidget",["utils/webcss!./messagewidget-style.css","component/message/MessageType","component/message/Message","jquery","underscore"],function(b,c,a,f,e){b=function(d,b,a){this._AUTOHIDE_DELAY=3E3;this._showing=!1;this._currentMessage=void 0;this._currentMessageObject=null;this._messageModel=d;this._context=b;this._context.addClass("messageWidget");this.i18n=a;this._messageModel.on("added",e.bind(this._showNextMessage,this));this._messageModel.on("obsolete",e.bind(this._markObsolete,
this));this._showNextMessage()};b.prototype._getCSSClass=function(d){switch(d){case c.ERROR:return"alert-danger";case c.WARN:return"";case c.INFO:return"alert-info";case c.SUCCESS:return"alert-success"}};b.prototype._showMessage=function(d){this._showing=!0;this._currentMessageObject=d;var b=f("<button />").attr("type","button").addClass("close").append(f("<i>",{"class":"icon icon-small icon-WCR_Close12"})),a=f("<strong />").append(this.i18n.t(d.getType().name)),a=f("<span />",{"class":"message-text"}).append(a).append(" "),
c=d.getAction();if(c){var g=f("<a/>").addClass("alert-link").text(d.getMessage());if("string"===typeof c)g.attr("href",c);else g.attr("href","#").on("click",e.bind(function(a){a.stopPropagation();this._destroyCurrentMessage(e.bind(function(){d.getAction()();this._showNextMessage()},this))},this));a.append(g)}else a.append(d.getMessage());this._currentMessage=f("<div />").addClass("alert").addClass(this._getCSSClass(d.getType()));d.allowClose()&&this._currentMessage.append(b);this._currentMessage.append(a).hide();
this._currentMessage.on("contextmenu mouseenter mouseleave mousedown click mousemove mouseup dblclick",function(a){a.stopPropagation()});a.on("dblclick",function(a){if(document.selection){var b=document.body.createTextRange();b.moveToElementText(this);b.select()}else window.getSelection&&(b=document.createRange(),b.selectNodeContents(this),window.getSelection().removeAllRanges(),window.getSelection().addRange(b));a.stopPropagation();a.preventDefault()});var h;d.getAutoHide()&&(h=window.setTimeout(e.bind(function(){this._destroyCurrentMessage(e.bind(function(){this._showNextMessage()},
this))},this),this._AUTOHIDE_DELAY));b.on("click",e.bind(function(a){a.stopPropagation();h&&window.clearTimeout(h);this._destroyCurrentMessage(e.bind(function(){this._showNextMessage()},this))},this));this._context.empty().append(this._currentMessage);this._currentMessage.fadeIn("fast")};b.prototype._destroyCurrentMessage=function(a){this._currentMessage.fadeOut("fast",e.bind(function(){this._currentMessage.remove();this._showing=!1;a()},this))};b.prototype._showNextMessage=function(){if(!this._showing){var a=
this._messageModel.getNextMessage();a&&this._showMessage(a)}};b.prototype._isShowingMessageWithTag=function(a){return this._showing&&this._currentMessage&&this._currentMessageObject&&this._currentMessageObject.getTag()===a};b.prototype._markObsolete=function(a){this._isShowingMessageWithTag(a)&&this._destroyCurrentMessage(e.bind(function(){this._showNextMessage()},this))};b.prototype.getContext=function(){return this._context};b.prototype.getMessageCount=function(){var a=this._messageModel.getMessageCount();
this._showing&&a++;return a};return b});define("component/message/MessageComponent",["component/message/Message","component/message/MessageType","component/message/MessageModel","component/message/MessageWidget","utils/webi18n!MessageWidget"],function(b,c,a,f,e){return{Message:b,MessageType:c,MessageModel:a,MessageWidget:function(a,b){return new f(a,b,e)}}});