/**
	 * Whether this system has a task management license.
	 * @returns {Boolean}
	 */

define("component/searchresults/model/SearchItemsBase",["jquery","underscore"],function(c,d){var b=function(a,b){this._type=a;this._addEmptyAllowed=b;this._list=[];this._initListenerFunctions();this._changedids=[];this._watcherMap={}};b.prototype.each=function(a){c.each(this._list,function(b,f){a(f)})};b.prototype.add=function(a){if(this.findByFieldId(a.getFieldId()))throw Error("That item already exists... Delete it first.");if(!(a instanceof this._type))throw Error("An item of the incorrect type passed.");
if(-1!==d.indexOf(this._list,a))throw Error("Cannot add the same item twice.");this._list.push(a);this._registerCallbacksOnChild(a);this._fireChangeDefer([a.getFieldId()])};b.prototype.findByFieldId=function(a){var b=null;c.each(this._list,function(f,c){c.getFieldId()===a&&(b=c)});return b};b.prototype.ensureExist=function(a){if(this._addEmptyAllowed){var b=d.map(this._list,function(a){return a.getFieldId()});d.each(d.difference(a,b),function(a){this.add(this.createItem(a))},this)}};b.prototype.reorderItemsByIds=
function(a){this._addEmptyAllowed&&this.ensureExist(a);var b=d.invert(a);this._list.sort(function(a,c){var a=a.getFieldId(),c=c.getFieldId(),i=d.has(b,a),h=d.has(b,c);return i&&h?+b[a]<+b[c]?-1:1:i?1:h?-1:0})};b.prototype.tryToRemoveItem=function(a){var b=-1;c.each(this._list,function(f,c){a===c&&(b=f)});0<=b&&(this._unregisterCallbacksOnChild(this._list[b]),this._list[b].canBeRemovedFromModel()?(this._list.splice(b,1),this._fireChangeDefer([a.getFieldId()])):this._registerCallbacksOnChild(this._list[b]))};
b.prototype.onChange=function(a){this._changeCallbacks.push(a)};b.prototype.commitChanges=function(){if(!this._commitInProgress){this._commitInProgress=!0;try{this.each(d.bind(function(a){a.commitChanges()},this))}finally{this._commitInProgress=!1}this._changed&&this._fireChange()}};b.prototype.createItem=function(a){return new this._type(a)};b.prototype.watch=function(a,b){d.has(this._watcherMap,a)||(this._watcherMap[a]=[]);this._watcherMap[a].push(b);this._executeWatcherCallback(a,this.findByFieldId(a),
b)};b.prototype.unwatch=function(a,b){this._watcherMap[a]=d.without(this._watcherMap[a],b)};b.prototype._initListenerFunctions=function(){this.internalChangeCallbacks={};this._changeCallbacks=[]};b.prototype._registerCallbacksOnChild=function(a){var b=null;d.has(this.internalChangeCallbacks,a.getFieldId())?b=this.internalChangeCallbacks[a.getFieldId()]:(b=d.bind(function(a,b){this._fireChangeDefer([a]);b&&this.commitChanges()},this,a.getFieldId()),this.internalChangeCallbacks[a.getFieldId()]=b);a.onChange(b)};
b.prototype._unregisterCallbacksOnChild=function(a){a.removeOnChange(this.internalChangeCallbacks[a.getFieldId()])};b.prototype._fireChangeDefer=function(a){this._changed=!0;this._changedids=this._changedids.concat(a);var b=this._fireindex||0;d.defer(d.bind(function(){b==(this._fireindex||0)&&this._fireChange()},this))};b.prototype._fireChange=function(){this._changed=!1;var a=this._changedids;this._changedids=[];void 0===this._fireindex&&(this._fireindex=0);this._fireindex++;c.each(this._changeCallbacks,
function(a,b){b()});d.each(a,function(a){if(d.has(this._watcherMap,a)){var b=this._watcherMap[a];if(0<b.length){var c=this.findByFieldId(a);d.each(b,function(b){this._executeWatcherCallback(a,c,b)},this)}}},this)};b.prototype._executeWatcherCallback=function(){throw Error("Watching is not implemented for this type of list");};b.prototype.forceEmitUpdateAll=function(){this.each(d.bind(function(a){a.forceEmitUpdateAll()},this));this._fireChange()};return b});
define("component/searchresults/model/SearchItemBase",["jquery","underscore"],function(c,d){var b=function(a){if(!(a&&"string"===typeof a))throw Error("Illegal fieldId value is passed in constructor of SearchItemBase");this._fieldId=a;this._callbacks=[];this._usagetacker=0};b.prototype.take=function(){this._usagetacker++};b.prototype.release=function(){this._usagetacker--;0>this._usagetacker&&window.console.log("[ERR] SearchItemBase.release -> Illegal State: Too much release calls!")};b.prototype.canBeRemovedFromModel=
function(){return 0===this._usagetacker};b.prototype.getFieldId=function(){return this._fieldId};b.prototype.onChange=function(a){this._callbacks.push(a)};b.prototype.commitChanges=function(){this._changed&&this._fireChange(!0)};b.prototype.removeOnChange=function(a){this._callbacks=d.without(this._callbacks,a)};b.prototype._fireChangeDefer=function(){this._changed=!0;var a=this._fireindex||0;d.defer(d.bind(function(){a==(this._fireindex||0)&&this._fireChange(!1)},this))};b.prototype._fireChange=
function(a){this._changed=!1;void 0===this._fireindex&&(this._fireindex=0);this._fireindex++;c.each(this._callbacks,function(b,f){f(a)})};b.prototype.forceEmitUpdateAll=function(){this._fireChange(!1)};return b});
define("component/searchresults/dataobjects/ValueData",["jquery","underscore"],function(){var c=function(){this._attr={};this._lists={}};c.prototype.clear=function(){this._attr={};this._lists={}};c.prototype.getValueKeys=function(){var c=[],b;for(b in this._attr)this._attr.hasOwnProperty(b)&&(void 0!==this._attr[b]&&null!==this._attr[b]&&"string"===typeof this._attr[b])&&c.push(b);return c};c.prototype.getValue=function(c,b){if(void 0===this._attr[c]||null===this._attr[c])return void 0===b?null:b;
if("string"===typeof this._attr[c])return this._attr[c];throw Error("Illegal state... Should never happen.");};c.prototype.setValue=function(c,b){if(!(void 0===b||null===b||"string"===typeof b))throw Error('Only allowed to set string values using "ValueData.setValue".');this._attr[c]=b};c.prototype.getSubListKeys=function(){var c=[],b;for(b in this._lists)this._lists.hasOwnProperty(b)&&(void 0!==this._lists[b]&&null!==this._lists[b]&&this._lists[b]instanceof Array)&&c.push(b);return c};c.prototype.getSubList=
function(c){if(void 0===this._lists[c]||null===this._lists[c])return null;if(this._lists[c]instanceof Array)return this._lists[c];throw Error("Illegal state... Should never happen.");};c.prototype.addNewItemToList=function(d){if(void 0===this._lists[d]||null===this._lists[d])this._lists[d]=[];var b=new c;this._lists[d].push(b);return b};c.prototype.setSubList=function(c,b){if(!(void 0===b||null===b||b instanceof Array))throw Error('Only allowed to set list values using "ValueData.setSubList".');this._lists[c]=
b};return c});
define("component/searchresults/dataobjects/ValueDataUtils",["underscore","./ValueData"],function(c,d){var b={toJSON:function(a){var e,f;if(!(a&&a instanceof d))throw Error("Illegal argument in ValueDataUtils.toJSON");var c=null,i=null,h=a.getValueKeys();for(e=0;e<h.length;e++)f=h[e],null===c&&(c={}),c[f]=a.getValue(f);h=a.getSubListKeys();for(e=0;e<h.length;e++){f=h[e];for(var k=a.getSubList(f),l=[],j=0;j<k.length;j++)l.push(b.toJSON(k[j]));null===i&&(i={});i[f]=l}a={};null!==c&&(a.attr=c);null!==
i&&(a.list=i);return a},fromJSON:function(a,e){var f;if(!(a&&a instanceof d))throw Error("Illegal argument in ValueDataUtils.fromJSON");var c=e.attr;if(c)for(f in c)c.hasOwnProperty(f)&&a.setValue(f,c[f]);if(c=e.list)for(f in c)if(c.hasOwnProperty(f)){for(var i=c[f],h=[],k=0;k<i.length;k++){var l=i[k],j=new d;b.fromJSON(j,l);h.push(j)}a.setSubList(f,h)}},clone:function(a){if(!(a&&a instanceof d))throw Error("Illegal argument in ValueDataUtils.clone");var e=new d;b.fromJSON(e,b.toJSON(a));return e},
equals:function(a,e){var c,g,i;if(!(a&&a instanceof d))throw Error("Illegal argument in ValueDataUtils.equals");if(!(e&&e instanceof d))throw Error("Illegal argument in ValueDataUtils.equals");var h=!0,k=a.getValueKeys(),l=e.getValueKeys(),h=h&&k.length===l.length;k.sort();l.sort();for(c=0;c<k.length;c++)g=k[c],i=l[c],h=(h=h&&g===i)&&a.getValue(g)===e.getValue(g);k=a.getSubListKeys();l=e.getSubListKeys();h=h&&k.length===l.length;k.sort();l.sort();for(c=0;c<k.length;c++){g=k[c];i=l[c];h=h&&g===i;i=
a.getSubList(g);g=e.getSubList(g);for(var h=h&&i.length==g.length,j=0;j<i.length;j++)h=h&&b.equals(i[j],g[j])}return h},setStringList:function(a,b,f){a.setSubList(b,c.map(f,function(a){var b=new d;b.setValue("v",a);return b}))},getStringList:function(a,b){var f=a.getSubList(b);return f?c.map(f,function(a){return a.getValue("v")}):[]}};return b});
define("component/searchresults/model/SearchCriterionInfo",["underscore","jquery","./SearchItemBase","../dataobjects/ValueData","../dataobjects/ValueDataUtils"],function(c,d,b,a,e){var f=function(c){b.call(this,c);this._value=new a;this._lastsetvalue=new a;this._callbacksSmartName=[];this._containsSmartName=!1};f.prototype=Object.create(b.prototype);f.prototype.constructor=f;f.prototype.getValue=function(){return this._value};f.prototype.setValue=function(b,c){if(!b||!(b instanceof a&&(!0===c||!1===
c)))throw Error("Illegal value is being set SearchCriterionInfo.setValue");this._value=b;this._containsSmartName!==c&&(this._containsSmartName=c,this._fireSmartNameChange());e.equals(this._lastsetvalue,this._value)||(this._lastsetvalue=e.clone(this._value),this._fireChangeDefer())};f.prototype.getContainsSmartName=function(){return this._containsSmartName};f.prototype.onSmartNameChange=function(a){this._callbacksSmartName.push(a)};f.prototype.removeOnSmartNameChange=function(a){this._callbacksSmartName=
c.without(this._callbacks,a)};f.prototype._fireSmartNameChange=function(){d.each(this._callbacksSmartName,function(a,b){b()})};f.prototype.copyFrom=function(a){this.setValue(e.clone(a.getValue()),a.getContainsSmartName())};return f});
define("component/searchresults/model/SearchCriteriaList",["underscore","./SearchItemsBase","./SearchCriterionInfo","../dataobjects/ValueDataUtils"],function(c,d,b,a){var e=function(){d.call(this,b,!1)};e.prototype=Object.create(d.prototype);e.prototype.constructor=e;e.prototype.onSmartNameChange=function(a){this._changeSmartNameCallbacks.push(a)};e.prototype._initListenerFunctions=function(){d.prototype._initListenerFunctions.call(this);this.internalSmartNameChangeCallback=c.bind(function(){this._fireSmartNameChange()},
this);this._changeSmartNameCallbacks=[]};e.prototype._registerCallbacksOnChild=function(a){d.prototype._registerCallbacksOnChild.call(this,a);a.onSmartNameChange(this.internalSmartNameChangeCallback)};e.prototype._unregisterCallbacksOnChild=function(a){d.prototype._unregisterCallbacksOnChild.call(this,a);a.removeOnSmartNameChange(this.internalSmartNameChangeCallback)};e.prototype._fireSmartNameChange=function(){$.each(this._changeSmartNameCallbacks,function(a,b){b()})};e.prototype._executeWatcherCallback=
function(b,c,e){c?e(a.clone(c.getValue())):e(null)};return e});
define("component/searchresults/model/SearchDisplayColumn",["jquery","underscore","./SearchItemBase"],function(c,d,b){c=function(a){b.call(this,a);this._editable=this._enabled=!1;this._sequence="-1"};c.prototype=Object.create(b.prototype);c.prototype.constructor=c;c.prototype.getEnabled=function(){return this._enabled};c.prototype.setEnabled=function(a){this._enabled!=a&&(this._enabled=a,this._fireChangeDefer())};c.prototype.isEditable=function(){return this._editable};c.prototype.setEditable=function(a){a=
!!a;this._editable!=a&&(this._editable=a,this._fireChangeDefer())};c.prototype.getSequence=function(){return this._sequence};c.prototype.setSequence=function(a){isNaN(a)&&(a="-1");d.isString(a)||(a=""+a);this._sequence!=a&&(this._sequence=a,this._fireChangeDefer())};c.prototype.copyFrom=function(a){this.setEnabled(a.getEnabled());this.setEditable(a.isEditable());this.setSequence(a.getSequence())};c.prototype.safeCopyFrom=function(a,b){a.supportsViewList&&(this.setEnabled(b.getEnabled()),this.setSequence(b.getSequence()));
a.supportsBatchActions&&this.setEditable(b.isEditable())};return c});define("component/searchresults/model/SearchDisplayColumns",["./SearchItemsBase","./SearchDisplayColumn"],function(c,d){var b=function(){c.call(this,d,!0)};b.prototype=Object.create(c.prototype);return b.prototype.constructor=b});
define("component/searchresults/model/SearchDesignPanelItem",["jquery","underscore","./SearchItemBase"],function(c,d,b){c=function(a){b.call(this,a);this._label=this._column=this._row="";this._visibility=this._originalVisibility="Hidden"};c.prototype=Object.create(b.prototype);c.prototype.constructor=c;c.prototype.getRow=function(){return this._row};c.prototype.setRow=function(a){this._row!=a&&(this._row=a,this._fireChangeDefer())};c.prototype.getColumn=function(){return this._column};c.prototype.setColumn=
function(a){this._column!=a&&(this._column=a,this._fireChangeDefer())};c.prototype.getLabel=function(){return this._label};c.prototype.setLabel=function(a){this._label!=a&&(this._label=a,this._fireChangeDefer())};c.prototype.getOriginalVisibility=function(){return this._originalVisibility};c.prototype.setOriginalVisibility=function(a){this._originalVisibility!=a&&(this._originalVisibility=a,this._fireChangeDefer())};c.prototype.getVisibility=function(){return this._visibility};c.prototype.setVisibility=
function(a){this._visibility!=a&&(this._visibility=a,this._fireChangeDefer())};c.prototype.copyFrom=function(a){this.setRow(a.getRow());this.setColumn(a.getColumn());this.setLabel(a.getLabel());this.setOriginalVisibility(a.getOriginalVisibility());this.setVisibility(a.getVisibility())};c.prototype.safeCopyFrom=function(a,b){a.supportsDesignPanel&&this.copyFrom(b)};return c});
define("component/searchresults/model/SearchDesignPanelItems",["./SearchItemsBase","./SearchDesignPanelItem"],function(c,d){var b=function(){c.call(this,d,!0)};b.prototype=Object.create(c.prototype);b.prototype.constructor=b;b.prototype.getCustomizedLabel=function(a){var b=this.findByFieldId(a.fieldId);return b&&b.getLabel()?a.getCustomizedTranslatedLabel():a.getDefaultLabel()};return b});
define("component/searchresults/model/SearchSortingCriterion",["jquery","underscore","./SearchItemBase"],function(c,d,b){c=function(a){b.call(this,a);this._enabled=!1;this._order="asc";this._number="-1"};c.prototype=Object.create(b.prototype);c.prototype.constructor=c;c.prototype.getEnabled=function(){return this._enabled};c.prototype.setEnabled=function(a){this._enabled!=a&&(this._enabled=a,this._fireChangeDefer())};c.prototype.getOrder=function(){return this._order};c.prototype.setOrder=function(a){this._order!=
a&&(this._order=a,this._fireChangeDefer())};c.prototype.getNumber=function(){return this._number};c.prototype.setNumber=function(a){this._number!=a&&(this._number=a,this._fireChangeDefer())};c.prototype.copyFrom=function(a){this.setEnabled(a.getEnabled());this.setOrder(a.getOrder());this.setNumber(a.getNumber())};c.prototype.safeCopyFrom=function(a,b){a.supportsSorting&&this.copyFrom(b)};return c});
define("component/searchresults/model/SearchSortingCriteriaList",["./SearchItemsBase","./SearchSortingCriterion"],function(c,d){var b=function(){c.call(this,d,!0)};b.prototype=Object.create(c.prototype);return b.prototype.constructor=b});
define("component/searchresults/model/SearchFieldFeaturesInfo",["utils/Observable"],function(c){var d=function(){this._useSpecialChars=this._useSmartNames=!1;c.mixin(this,"model")};d.prototype.getUseSmartNames=function(){return this._useSmartNames};d.prototype.setUseSmartNames=function(b){this._useSmartNames=b};d.prototype.getUseAdvancedChars=function(){return this._useSpecialChars};d.prototype.setUseAdvancedChars=function(b){this._useSpecialChars=b;this._emit("advancedcharschange")};d.prototype.onUseAdvancedCharsChange=
function(b){this.on("advancedcharschange",b)};d.prototype.forceEmitUpdateAll=function(){this.setUseAdvancedChars(this.getUseAdvancedChars())};return d});
define("component/searchresults/model/SearchLayoutOptions",["underscore","../dataobjects/ValueData"],function(c,d){var b=function(a,b,c){this.id=a;this.type=b;this.defaultValue=c},a=function(){this._availablesettingsmap=this._availablesettings=null;this._data={};this.internalChangeCallback=c.bind(function(a){this._fireChangeDefer();a&&this.commitChanges()},this);this._changeCallbacks=[]};a.Setting=b;a.prototype.setAvailableSettings=function(a){if(!a||!c.isArray(a))throw Error("Invalid parameter passed to setAvailableSettings in SearchLayoutOptions");
if(null===this._availablesettings)this._availablesettings=c.map(a,function(a){if(a&&a instanceof b&&a.id&&a.type&&("STRING"===a.type&&c.isString(a.defaultValue)||"BOOLEAN"===a.type&&c.isBoolean(a.defaultValue)||"COMPLEXVALUE"===a.type&&null===a.defaultValue||"ITEMSEQUENCE"===a.type&&null===a.defaultValue))return a;throw Error("Invalid parameter passed to setAvailableSettings in SearchLayoutOptions");}),this._availablesettingsmap=c.indexBy(this._availablesettings,"id");else throw Error("List of available settings already set.");
};a.prototype.getAvailableSettings=function(){return c.map(this._availablesettings,c.identity)};a.prototype.getOptionType=function(a){return!c.has(this._availablesettingsmap,a)?null:this._availablesettingsmap[a].type};a.prototype.getOption=function(a){if(!c.has(this._availablesettingsmap,a))throw Error("Unknown option accessed.");var b=this._availablesettingsmap[a],a=this._data[a],g=b.defaultValue;if("STRING"===b.type)return c.isString(a)?a:g;if("BOOLEAN"===b.type)return c.isBoolean(a)?a:g;if("COMPLEXVALUE"===
b.type)return a&&a instanceof d?a:null;if("ITEMSEQUENCE"===b.type)return c.isArray(a)?c.map(a,function(a){return c.isString(a)?a:""}):[];throw Error("Illegal state");};a.prototype.setOption=function(a,b){if(!c.has(this._availablesettingsmap,a))throw Error("Unknown option accessed.");var g=this._availablesettingsmap[a],i=c.partial(c.reduce,c,function(a,b){return a&&c.isString(b)},!0);if("STRING"===g.type&&c.isString(b)||"BOOLEAN"===g.type&&c.isBoolean(b)||"COMPLEXVALUE"===g.type&&b&&b instanceof d||
"ITEMSEQUENCE"===g.type&&c.isArray(b)&&i(b)){if(i=this._data[a],"STRING"===g.type&&i!==b||"BOOLEAN"===g.type&&i!==b||"COMPLEXVALUE"===g.type||"ITEMSEQUENCE"===g.type)this._data[a]=b,this._fireChangeDefer()}else this._data.hasOwnProperty(a)&&(delete this._data[a],this._fireChangeDefer())};a.prototype.onChange=function(a){this._changeCallbacks.push(a)};a.prototype.commitChanges=function(){this._changed&&this._fireChange()};a.prototype._fireChangeDefer=function(){this._changed=!0;var a=this._fireindex||
0;c.defer(c.bind(function(){a==(this._fireindex||0)&&this._fireChange()},this))};a.prototype._fireChange=function(){this._changed=!1;void 0===this._fireindex&&(this._fireindex=0);this._fireindex++;$.each(this._changeCallbacks,function(a,b){b()})};a.prototype.forceEmitUpdateAll=function(){this._fireChange()};return a});
define("component/searchresults/model/SearchDashboardConfiguration",[],function(){var c=function(){this._dashboardConfiguration=null};c.prototype.hasDashboard=function(){return null!==this._dashboardConfiguration};c.prototype.getDashboard=function(){return this._dashboardConfiguration};c.prototype.setDashboard=function(c){this._dashboardConfiguration=c};return c});
define("component/searchresults/model/SearchInstancedFieldConfiguration",["../../searchresults/dataobjects/ValueData","../../searchresults/dataobjects/ValueDataUtils","underscore"],function(c,d,b){var a=function(){this._instances={}};a.prototype.getDataClone=function(){var a={};b.each(this._instances,function(b,c){a[c]=d.clone(b)});return a};a.prototype.clone=function(){var b=this.getDataClone(),c=new a;c.setData(b);return c};a.prototype.setData=function(a){this._instances=null==a?{}:a};a.prototype.addInstance=
function(a,b){var c=this._generateNewInstanceId(a);this._instances[c]=b;return c};a.prototype.getInstance=function(a){return this._instances[a]};a.prototype.setInstance=function(a,b){this._instances[a]=b};a.prototype.removeInstance=function(a){delete this._instances[a]};a.prototype._generateNewInstanceId=function(a){var c=[];b.each(this._instances,function(b,d){if(this._getFieldIdFromInstanceId(d)===a){var k=d.substr(a.length+1);c.push(parseInt(k,10))}},this);for(var d=1;b.contains(c,d);)d++;return a+
"~"+d};a.prototype._getFieldIdFromInstanceId=function(a){return a.substr(0,a.indexOf("~"))};a.prototype.hasInstancedOfType=function(a){var c=!1;b.each(this._instances,function(b,d){this._getFieldIdFromInstanceId(d)===a&&(c=!0)},this);return c};return a});
define("component/searchresults/model/SearchSetupInformation","./SearchCriteriaList ./SearchDisplayColumns ./SearchDesignPanelItems ./SearchSortingCriteriaList ./SearchFieldFeaturesInfo ./SearchLayoutOptions ./SearchDashboardConfiguration ./SearchInstancedFieldConfiguration".split(" "),function(c,d,b,a,e,f,g,i){var h=function(){this._features=new e;this._criteria=new c;this._displayColumns=new d;this._designPanelItems=new b;this._sortingCriteria=new a;this._layoutoptions=new f;this._searchDashboardConfiguration=
new g;this._searchInstancedFieldConfiguration=new i};h.prototype.getDisplayColumns=function(){return this._displayColumns};h.prototype.getCriteriaList=function(){return this._criteria};h.prototype.getDesignPanelItems=function(){return this._designPanelItems};h.prototype.getSortingCriteriaList=function(){return this._sortingCriteria};h.prototype.getFeatures=function(){return this._features};h.prototype.getLayoutOptions=function(){return this._layoutoptions};h.prototype.getDashboardConfiguration=function(){return this._searchDashboardConfiguration};
h.prototype.getInstancedFieldConfiguration=function(){return this._searchInstancedFieldConfiguration};h.prototype.hasAssetBrowser=function(){var a=this.getLayoutOptions().getOption("cascading_attribute_trees");return null!==a&&null!=a.getSubList("treeElem")&&0<a.getSubList("treeElem").length};h.prototype.hasFacetComponents=function(){return this.getInstancedFieldConfiguration().hasInstancedOfType("db_facet")};h.prototype.hasDesignPanel=function(){var a=!1;this.getDesignPanelItems().each(function(b){b=
b.getOriginalVisibility();if("Available"===b||"Visible"===b)a=!0});return a};h.prototype.hasAvailableDropdown=function(){var a=!1;this.getDesignPanelItems().each(function(b){"Available"===b.getOriginalVisibility()&&(a=!0)});return a};h.prototype.hasRerunableComponents=function(){return this.hasAssetBrowser()||this.hasFacetComponents()||this.hasDesignPanel()};h.prototype.hasSearchButton=function(){return this.getLayoutOptions().getOption("chkbox_ShowSearchButton")&&this.hasRerunableComponents()};h.prototype.forceEmitUpdateAll=
function(){this._features.forceEmitUpdateAll();this._criteria.forceEmitUpdateAll();this._displayColumns.forceEmitUpdateAll();this._designPanelItems.forceEmitUpdateAll();this._sortingCriteria.forceEmitUpdateAll();this._layoutoptions.forceEmitUpdateAll()};return h});
define("component/searchresults/model/SearchField",["../dataobjects/ValueData","../dataobjects/ValueDataUtils","underscore"],function(c,d,b){var a=function(a){this.fieldId=a;this.instancingType="NONE";this.instancingSource="";this.configuratorType=this.editComponentType=this.parameterFieldType=this.cellDisplayType=null;this.customizedtranslatedlabel=this.label="";this.unitLucene=this.unitImperial=this.unitMetric=null;this.dataType="string";this.displayConfig=new c;this.dropdownMode=null;this.dropdownSupportsQuery=
!1;this.listValueID=this.staticListValues=null;this.supportsConfiguration=this.supportsSorting=this.supportsDesignPanel=this.supportsBatchActions=this.supportsViewList=!1;this.groupLabel=null};a.prototype.getDefaultLabel=function(){return this.label};a.prototype.getCustomizedTranslatedLabel=function(){return this.customizedtranslatedlabel};a.prototype.createInstance=function(c){var f=new a;b.extend(f,this);f.displayConfig=d.clone(this.displayConfig);f.fieldId=c;f.instancingSource=this.fieldId;return f};
return a});
define("component/searchresults/dataobjects/ExternalSearchSettings",[],function(){var c=function(c,b){this.preferences=c;this._context=b};c.prototype.getSearchContext=function(){return this._context};c.prototype.getIsAdmin=function(){return"1"===this.preferences.admin};c.prototype.getUserUnitsPreference=function(){return this.preferences.units?this.preferences.units:"metric"};c.prototype.getIsSimpleGUI=function(){return"0"!==this.preferences.simpleGUI};c.prototype.getMenuFileURL=function(){return this.preferences.menu_file_url?this.preferences.menu_file_url:
"myallprojects"};c.prototype.getDateAttrRenderType=function(){return"1"===this.preferences.date_render_type?"date_time":"date"};c.prototype.getIsForceApprovalAllowed=function(){return"0"!==this.preferences.pharma_can_force_approve};c.prototype.getIsForceRejectionAllowed=function(){return"0"!==this.preferences.pharma_can_force_reject};c.prototype.getRoleAssignInviteGroupDefault=function(){return"0"!==this.preferences.invite_group_default};c.prototype.getHasTaskManagementLicense=function(){return"1"===
this.preferences.has_task_management_license};c.prototype.getBOMEnabled=function(){return"1"===this.preferences.bom_enabled};return c});
define("component/searchresults/context/SearchContext",[],function(){var c=function(c){this._isSearchResults=c;this._returnpagebaseurl=null;this._returnpageparams={};this._allowsRedirectActions=!1;this._supportsThumbnailSettingOverride=this._supportsReturnPagePagination=!0};c.prototype.getIsSearchResults=function(){return this._isSearchResults};c.prototype.setReturnPage=function(c,b){this._returnpagebaseurl=c;this._returnpageparams=b};c.prototype.getReturnPageBaseUrl=function(){return this._returnpagebaseurl};
c.prototype.getReturnPageMainParameters=function(){return this._returnpageparams};c.prototype.setAllowRedirectActions=function(c){this._allowsRedirectActions=c};c.prototype.getAllowRedirectActions=function(){return this._allowsRedirectActions};c.prototype.setSupportsReturnPagePagination=function(c){this._supportsReturnPagePagination=c};c.prototype.getSupportsReturnPagePagination=function(){return this._supportsReturnPagePagination};c.prototype.setSupportsThumbnailSettingOverride=function(c){this._supportsThumbnailSettingOverride=
c};c.prototype.getSupportsThumbnailSettingOverride=function(){return this._supportsThumbnailSettingOverride};return c});
define("component/searchresults/model/SearchModelFrontEndData","./SearchField ../dataobjects/ValueData ../dataobjects/ValueDataUtils ../dataobjects/ExternalSearchSettings ../context/SearchContext utils/webi18n!SearchInputs underscore".split(" "),function(c,d,b,a,e,f,g){f=function(a,b){if(!(b&&b instanceof e))throw Error("Illegal arguments passed to SearchModelFrontEndData");this.informationtype=this.searchtype=null;this._context=b;this._defaultDrilldownLabel=null;this.fieldmap={};this.facetmap={};
this.facetvarmap={};this.conversionmap={};this.preferences={};this.listValuesMap={};this._fieldsloadedcallbacks={};this._fieldsloading={};this._fieldspending={};this._fieldspendingarr=[];this._facetsloadedcallbacks={};this._facetsloading={};this._facetspending={};this._facetspendingarr=[];this._additionalFieldListeners={};this._importJSON(a)};f.prototype.isTaskSearch=function(){return"wctask_search"===this.searchtype};f.prototype.isSameResultsType=function(a){var b="wctask_search"===a,c="wctask_search"===
this.searchtype,a="project_search"===a,e="project_search"===this.searchtype;return b&&c||a&&e||!(b||a)&&!(c||e)};f.prototype.getDefaultDrilldownLabel=function(){return this._defaultDrilldownLabel};f.prototype.getSearchContext=function(){return this._context};f.prototype._importFieldJSON=function(a){var e,f;for(f in a)if(a.hasOwnProperty(f)){var l=f,j=a[f],m=new c(l);m.cellDisplayType=j.cell;m.parameterFieldType=j.param;m.editComponentType=j.edit;m.configuratorType=j.fconf;m.label=j.lbl;m.customizedtranslatedlabel=
j.ctlbl;m.supportsViewList=j.sv;m.supportsBatchActions=j.sb;m.supportsDesignPanel=j.sd;m.supportsSorting=j.ss;m.supportsConfiguration=j.sc;m.instancingType=j.itype;j.unit&&(m.unitMetric=j.unit.met,m.unitImperial=j.unit.imp,m.unitLucene=j.unit.luc);m.dataType=j.type;m.groupLabel=j.grp;b.fromJSON(m.displayConfig,j.cnf);if(j.staticListValues){m.staticListValues=[];for(e=0;e<j.staticListValues.length;e++){var n=new d;b.fromJSON(n,j.staticListValues[e]);m.staticListValues.push(n)}}j.valueListID&&(m.listValueID=
j.valueListID);j.dropdownmode&&(m.dropdownMode=j.dropdownmode,m.dropdownSupportsQuery="1"===j.dropdownsupportsquery);this.fieldmap[l]=m;var p=[];if(g.has(j,"facetids")){var q=j.facetmultiv,p=j.facetids;for(e=0;e<p.length;e++)n=p[e],this.facetmap[n]={label:m.label,isMultiValued:q,fieldId:l};j=j.facetvarids;for(e=0;e<j.length;e++)this.facetvarmap[j[e]]={searchfield:l};p=g.union(p,j)}this._fieldsloadedcallbacks.hasOwnProperty(l)&&(g.each(this._fieldsloadedcallbacks[l],function(a){a()}),delete this._fieldsloadedcallbacks[l]);
for(e=0;e<p.length;e++)n=p[e],this._facetsloadedcallbacks.hasOwnProperty(n)&&(g.each(this._facetsloadedcallbacks[n],function(a){a()}),delete this._facetsloadedcallbacks[n])}};f.prototype._importJSON=function(a){if(a){this.searchtype=a.searchtype;this.dashboardContextID=a.dashboardContextID;this._defaultDrilldownLabel=a.defaultDrilldownLabel;this.informationtype=a.informationtype;this._importFieldJSON(a.fields);for(var b=a.unitconv,c=0;c<b.length;c++){var e=b[c],f=e.from,d=e.to,e=e.factor;this.conversionmap.hasOwnProperty(f)||
(this.conversionmap[f]={});this.conversionmap[f].hasOwnProperty(d)||(this.conversionmap[f][d]={});this.conversionmap[f][d]=e}this.preferences=a.prefs||{};this.listValuesMap=this._readListValues(a.listvaluesmap||{})}};f.prototype.getFieldInformation=function(a){if(!this.fieldmap[a]){var b=this._splitInstancedFieldId(a);(b=this.fieldmap[b.fieldid])&&"MULTI_FIELD_SINGLE_SELECTION"===b.instancingType&&(this.fieldmap[a]=b.createInstance(a))}return this.fieldmap[a]};f.prototype.getFacetInfo=function(a){return g.has(this.facetmap,
a)?this.facetmap[a]:{label:"??",isMultiValued:!1}};f.prototype.getFacetValueInfo=function(a,b){return((this._facetValueInfo||{})[a]||{})[b]};f.prototype._splitInstancedFieldId=function(a){a=a.split("~");return{fieldid:a[0],instanceid:a[1]}};f.prototype.requireFieldInformationAvailable=function(a,b){a=this._splitInstancedFieldId(a).fieldid;g.has(this.fieldmap,a)?b():(!this._fieldsloading.hasOwnProperty(a)&&!this._fieldspending.hasOwnProperty(a)&&(this._fieldsloadedcallbacks[a]=[],this._fieldspending[a]=
"1",this._fieldspendingarr.push(a)),this._fieldsloadedcallbacks[a].push(b),g.defer(g.bind(this._doLoadExtraFieldInformation,this)))};f.prototype.requireFieldInformationAvailableAll=function(a,b){var c=g.after(a.length,b);g.each(a,function(a){this.requireFieldInformationAvailable(a,c)},this)};f.prototype.requireFacetInformationAvailable=function(a,b){g.has(this.facetmap,a)||g.has(this.facetvarmap,a)?b():(!this._facetsloading.hasOwnProperty(a)&&!this._facetspending.hasOwnProperty(a)&&(this._facetsloadedcallbacks[a]=
[],this._facetspending[a]="1",this._facetspendingarr.push(a)),this._facetsloadedcallbacks[a].push(b),g.defer(g.bind(this._doLoadExtraFieldInformation,this)))};f.prototype._doLoadExtraFieldInformation=function(){if(0<this._fieldspendingarr.length||0<this._facetspendingarr.length){g.each(this._fieldspendingarr,g.bind(function(a){this._fieldsloading[a]="1"},this));g.each(this._facetspendingarr,g.bind(function(a){this._facetsloading[a]="1"},this));var a=this._fieldspendingarr,b=this._facetspendingarr;
this._fieldspendingarr=[];this._facetspendingarr=[];this._fieldspending={};this._facetspending={};$.ajax("searchdataservice.wcr",{context:this,cache:!1,dataType:"json",method:"POST",data:$.param({action:"getfielddata",searchtype:this.searchtype,fieldids:a,facetids:b,ajax:"1"},!0),success:function(a){if(a.hasOwnProperty("error")){var a=a.error,b="";a.hasOwnProperty("msg")&&(b=a.msg+"\n");a.hasOwnProperty("addonMsg")&&(b+=a.addonMsg);window.alert(b)}else if(a.hasOwnProperty("result")){var a=a.result,
c=this._readListValues(a.listvaluesmap||{});g.each(g.keys(c),g.bind(function(a){this.listValuesMap[a]=c[a]},this));this._importFieldJSON(a.fields)}},error:function(){window.console.log("Could not load the extra field information...")}})}};f.prototype.resolveFacetIdEditField=function(a,b){this.requireFacetInformationAvailable(a,g.bind(function(){var c=this.facetvarmap[a];if(c){var c=c.searchfield,e=this.getFieldInformation(c),e=e.createInstance(c);e.displayConfig.setValue("editfieldforfacet",a);b(e)}else b(null)},
this))};f.prototype.getUnitConversionFactor=function(a,b){var c=(this.conversionmap[a]||{})[b],e=(this.conversionmap[b]||{})[a];return null!=c&&void 0!==c?c:null!=e&&void 0!==e?1/e:1};f.prototype.getSearchSettings=function(){return new a(this.preferences,this._context)};f.prototype._readListValues=function(a){var c={},e;for(e in a)if(a.hasOwnProperty(e)){var f=[],g=a[e];if(g instanceof Array)for(var m=0;m<g.length;m++)if(g[m]){var n=new d;b.fromJSON(n,g[m]);f.push(n)}c[e]=f}return c};f.prototype.getList=
function(a){return this.listValuesMap[a]};f.prototype.observeAdditionalFieldData=function(a,b){this._additionalFieldListeners[a]||(this._additionalFieldListeners[a]=[]);this._additionalFieldListeners[a].push(b)};f.prototype.stopObserveAdditionalFieldData=function(a,b){this._additionalFieldListeners[a]&&(this._additionalFieldListeners[a]=g.without(this._additionalFieldListeners[a],b))};f.prototype.setAdditionalFieldData=function(a){a=g.mapObject(a,function(a){var c=new d;b.fromJSON(c,a);return c});
this._facetValueInfo={};var c=a.db_facet;c&&g.each(c.getSubListKeys(),function(a){this._facetValueInfo[a]={};var b=c.getSubList(a);g.each(b,function(b){this._facetValueInfo[a][b.getValue("id")]=b},this)},this);this._updateAdditionalFieldData(a)};f.prototype.getAdditionalFieldData=function(a){this._additionalFieldData||(this._additionalFieldData={});this._additionalFieldData[a]||(this._additionalFieldData[a]=new d,this._additionalFieldData[a].setSubList("facet",[]));return this._additionalFieldData[a]};
f.prototype._updateAdditionalFieldData=function(a){this._additionalFieldData=a;g.each(this._additionalFieldListeners,function(a,b){var c=this.getAdditionalFieldData(b);g.each(a,function(a){a(c)})},this)};return f});
define("component/searchresults/dataobjects/SearchSettings",["./ExternalSearchSettings"],function(){var c=function(c,b,a,e){this._isSmartNamesEnabled=c;this._externalSettings=b;this._watchCriterionFunc=a;this._unwatchCriterionFunc=e};c.prototype.isSmartNamesEnabled=function(){return this._isSmartNamesEnabled};c.prototype.getExternalSettings=function(){return this._externalSettings};c.prototype.watchCriterion=function(c,b){this._watchCriterionFunc(c,b)};c.prototype.unwatchCriterion=function(c,b){this._unwatchCriterionFunc(c,
b)};return c});define("component/searchresults/dataobjects/DataProvider",["./ValueData"],function(c){var d=function(b,a){this._localToGlobalIdMap=b;this._sharedData=a};d.prototype.getFieldSpecificData=function(b){return(b=this._localToGlobalIdMap[b])?this.getGlobalData(b):null};d.prototype.getGlobalData=function(b){b=this._sharedData[b];if(null===b||void 0===b)return null;if(b instanceof c)return b;window.console.log("DataProvider.getGlobalData: This should never happen...");return null};return d});
define("component/searchresults/dataobjects/ValidationFeedback",[],function(){var c=function(){this._errormsgs=[]};c.prototype.addError=function(c){this._errormsgs.push(c)};c.prototype.getErrors=function(){return this._errormsgs};c.prototype.clear=function(){this._errormsgs=[]};return c});
define("component/searchresults/internal/components/parameterfield/ParameterField","jquery underscore ../../../model/SearchSetupInformation ../../../model/SearchCriterionInfo ../../../model/SearchModelFrontEndData ../../../dataobjects/ValueData ../../../dataobjects/SearchSettings ../../../dataobjects/DataProvider ../../../dataobjects/ValidationFeedback".split(" "),function(c,d,b,a,e,f,g,i,h){b=function(a,b,e,f,g){if(!a||!("string"===typeof a&&b&&1===b.nodeType&&g))throw Error("Illegal arguments passed to SearchResultsDesignPanelFieldController");
this.container=c(b);c(b).wrapInner(c("<div>"));this.componentDiv=c("> div",c(b));this.feedbackDiv=c("<div>");c(b).append(this.feedbackDiv);this._core=e;this._searchfield=this._core.searchData.getFieldInformation(a);var p=new i(null,null);this._feedback=new h;this._valid=this._loading=!0;this._ignoreFieldChange=this._ignoreCriterionChanges=!1;this._doneLoadingCallbacks=[];this._requiresRerunCallbacks=[];this._startsUsingSpecialCharsCallbacks=[];this._core.fieldConfig.collectFieldProperties(this._searchfield).then(d.bind(function(b){g.resolve(b.typeOfParameterField,
a).then(d.bind(function(c){this._valid&&(this._fieldProperties=b,this._implementationfactory=c,this._implementation=this._implementationfactory.make(this.componentDiv.get(0),a,f,p,this._fieldProperties),!this._implementationfactory.isWrongImplementation()&&!this._implementation.isWrongImplementation()&&this._initializeField(a));this._triggerDoneLoading()},this))},this))};b.prototype.getFieldId=function(){return this._searchfield.fieldId};b.prototype._initializeField=function(b){this._implementation.onChange(d.bind(this._onValueUpdate,
this));var c=!1,e=b;"MULTI_FIELD_SINGLE_SELECTION"===this._searchfield.instancingType&&(e=this._searchfield.instancingSource);this._criterion=this._core.setupInfo.getCriteriaList().findByFieldId(e);this._criterion||(this._criterion=new a(e),this._core.setupInfo.getCriteriaList().add(this._criterion),c=!0);this._criterion.take();this._onChangeFunction=d.bind(function(){if(!this._ignoreCriterionChanges){this._ignoreFieldChange=!0;var a=this._implementation.setValueData(this._criterion.getValue());this._ignoreFieldChange=
!1;a||this._onValueUpdate()}},this);this._criterion.onChange(this._onChangeFunction);e=!0;c||(this._ignoreFieldChange=!0,e=this._implementation.setValueData(this._criterion.getValue()),this._ignoreFieldChange=!1);(this._currentHasSpecialCharacters=this._checkSpecialCharacters())&&this._triggerStartsUsingSpecialCharacters(!0);e||this._onValueUpdate(!1);c&&this._onValueUpdate(!0);0<this._fieldProperties.facetIds.length&&(this._core.searchData.observeAdditionalFieldData(b,this._implementation.doFacetUpdate.bind(this._implementation)),
this._implementation.doFacetUpdate(this._core.searchData.getAdditionalFieldData(b)))};b.prototype._extractValue=function(){var a=new f;"MULTI_FIELD_SINGLE_SELECTION"===this._searchfield.instancingType&&(a=this._criterion.getValue());this._feedback.clear();this._implementation.getValueData(a,this._feedback);this._updateFeedback();return a};b.prototype._updateFeedback=function(){this.feedbackDiv.empty();c.each(this._feedback.getErrors(),function(a,b){this.feedbackDiv.append(c("<div>",{text:b}))})};
b.prototype.validate=function(){return this._loading?!0:this._implementation.validate()};b.prototype.clearField=function(){this._loading||this._implementation.clear()};b.prototype.resize=function(){this._loading||this._implementation.resize()};b.prototype.focus=function(){this._loading||this._implementation.focus()};b.prototype._onValueUpdate=function(a){!this._ignoreCriterionChanges&&!this._ignoreFieldChange&&(this._ignoreCriterionChanges=!0,this._criterion.setValue(this._extractValue(),this._implementation.valueContainsSmartName()),
this._criterion.commitChanges(),this._ignoreCriterionChanges=!1,this._currentHasSpecialCharacters||(this._currentHasSpecialCharacters=this._checkSpecialCharacters())&&this._triggerStartsUsingSpecialCharacters(!1),this._triggerRequiresRerun(a))};b.prototype.onDoneLoading=function(a){this._loading?this._doneLoadingCallbacks.push(a):a()};b.prototype._triggerDoneLoading=function(){if(this._loading){this._loading=!1;for(var a=0;a<this._doneLoadingCallbacks.length;a++)this._doneLoadingCallbacks[a]();this._doneLoadingCallbacks=
[]}};b.prototype.isLoaded=function(){return!this._loading};b.prototype.onRequiresRerun=function(a){this._requiresRerunCallbacks.push(a)};b.prototype._triggerRequiresRerun=function(a){for(var b=0;b<this._requiresRerunCallbacks.length;b++)this._requiresRerunCallbacks[b](a)};b.prototype._specialCharacters="&|()~\\".split("");b.prototype._checkSpecialCharacters=function(){return this._implementation.valueContainsSpecialSearchCharacters(this._specialCharacters)};b.prototype.onStartsUsingSpecialCharacters=
function(a){this._startsUsingSpecialCharsCallbacks.push(a)};b.prototype._triggerStartsUsingSpecialCharacters=function(a){for(var b=0;b<this._startsUsingSpecialCharsCallbacks.length;b++)this._startsUsingSpecialCharsCallbacks[b](a);this._startsUsingSpecialCharsCallbacks=[]};b.prototype.destroy=function(){this._valid=!1;this.isLoaded()&&(this._implementation.destroy(),this._criterion.removeOnChange(this._onChangeFunction),this._criterion.release(),this._criterion=null);this._doneLoadingCallbacks=[];
this._requiresRerunCallbacks=[];this._startsUsingSpecialCharsCallbacks=[];this.container.empty()};return b});
define("component/searchresults/internal/functionality/SpecialCharactersHintController",["underscore","utils/webi18n!SearchInputs"],function(c,d){var b=function(a,b){this.div=a;this._alreadyAsked=!1;this._setupInfo=b};b.prototype.needToCheck=function(){return!this._setupInfo.getFeatures().getUseAdvancedChars()&&!this._alreadyAsked};b.prototype.trigger=function(){if(this.needToCheck()){var a=$(".searchwarningcontainer",this.div),b=$("<div>",{"class":"alert alert-warning alert-dismissible",style:"margin-bottom:0px"}),
f=$('<button type="button" class="close" data-dismiss="alert">&times;</button>'),g=$("<div>",{style:"padding-bottom:10px",text:d.t("ADV_CHAR_WARNING").replace(/\n/g,"_newline_")}),i=$("<button>",{type:"button","class":"btn btn-warning",text:d.t("ADV_CHAR_WARNING_OK")}),h=$("<button>",{type:"button","class":"btn btn-default",text:d.t("ADV_CHAR_WARNING_CLOSE"),"data-dismiss":"alert"});g.html(g.html().replace(/_newline_/g,"<br/>"));b.append(f).append(g).append(i).append(" ").append(h);a.append(b);i.click(c.bind(function(){this._setupInfo.getFeatures().setUseAdvancedChars(!0);
b.remove()},this));this._setupInfo.getFeatures().onUseAdvancedCharsChange(c.bind(function(){b.remove()},this));this.setDontAskAgain()}};b.prototype.setDontAskAgain=function(){this._alreadyAsked=!0};return b});
define("component/searchresults/implementations/InterfaceWrapperBase",["underscore"],function(c){var d=!1,b=!1,a=function(a,b,d){a&&"string"===typeof a||(a="<unknown>");this._fieldId=a;this._what=b;this._implementation=d;this._iswrongimplementation=!1;d&&d._isWrapped&&(this._warnAboutWrongImplementation("Implementation of "+b+' with id "'+a+'" wrapped twice. - Extending the error handling wrapper is not allowed when making a new implementation.'),this._implementation=null);c.isObject(d)||this._warnAboutWrongImplementation("Implementation of "+
b+' with id "'+a+'" is not an object.')};a.prototype.isWrongImplementation=function(){return this._iswrongimplementation};a.prototype._isWrapped=!0;a.prototype._doSafeCall=function(a){for(var b=arguments.length,d=Array(b-1),i=1;i<b;++i)d[i-1]=arguments[i];this._safeCallMethod(a,a,function(){this._implementation[a].apply(this._implementation,d)},c.noop)};a.prototype._doSafeBoolReturnCall=function(a,b){for(var d=arguments.length,i=Array(d-2),h=2;h<d;++h)i[h-2]=arguments[h];d=this._safeCallMethod(a,
a,function(){return this._implementation[a].apply(this._implementation,i)},c.constant(b),b);if(!0===d||!1===d)return d;this._warnAboutError(a,"Method should return true or false...");return b};a.prototype._doSafeStringReturnCall=function(a){for(var b=arguments.length,d=Array(b-1),i=1;i<b;++i)d[i-1]=arguments[i];b=this._safeCallMethod(a,a,function(){return this._implementation[a].apply(this._implementation,d)},c.constant(null),null);if(null===b||c.isString(b))return b;this._warnAboutError(a,"Method should return null or a string...");
return null};a.prototype._doSafeAnyReturnCall=function(a){for(var b=arguments.length,d=Array(b-1),i=1;i<b;++i)d[i-1]=arguments[i];return this._safeCallMethod(a,a,function(){return this._implementation[a].apply(this._implementation,d)},c.constant(null),null)};a.prototype._requireMethod=function(a){this._checkForMethod(a)||(this._warnAboutMissingMethod(a),this._iswrongimplementation=!0)};a.prototype._checkForMethod=function(a){return this._implementation&&void 0!==this._implementation[a]&&"function"===
typeof this._implementation[a]};a.prototype._warnAboutMissingMethod=function(a){this._implementation&&(window.console.log('[WARNING]: Missing method "'+a+'" for the '+this._what+' for field "'+this._fieldId+'".'),d||(d=!0,window.alert("Warning: At least one "+this._what+" is missing functionality... Some parts of Search might not work as expected... See Developer Console for more info.")))};a.prototype._warnAboutError=function(a,c){this._implementation&&(window.console.log('[ERROR]: Error occured in method "'+
a+'" for the '+this._what+' for field "'+this._fieldId+'", logged below.'),window.console.log(c),b||(b=!0,window.alert("Error: An error occured in at least one "+this._what+"... Some parts of Search might not work as expected... See Developer Console for more info.")))};a.prototype._warnAboutWrongImplementation=function(a){window.console.log("[ERROR]: "+a);b||(window.alert("Error: An error occured in at least one "+this._what+"... Some parts of Search might not work as expected... See Developer Console for more info."),
d=b=!0);this._iswrongimplementation=!0};a.prototype._safeCallMethod=function(a,b,c,d,h){if(this._checkForMethod(a))try{return c.call(this)}catch(k){return this._warnAboutError(b,k),h}else return d.call(this)};return a});
define("component/searchresults/dataobjects/FieldProperties",["underscore"],function(c){var d=function(){this.displayUnit=this.label=this.defaultLabel=this.fieldid=null;this.unitConversionFactor=1;this.dataType="string";this.dropdownValueKey=this.displayConfig=null;this.dropdownSupportsQuery=!1;this.listValues=this.staticListValues=null;this.facetIds=[];this.isFacetMultiValued=this.getFacetValueData=this.getFacetName=null;this.facetFields={};this.typeOfEditComponent=this.typeOfRenderer=this.typeOfParameterField=
null};d.prototype.isNumeric=function(){return"float"===this.dataType||"int"===this.dataType};d.prototype.getDataType=function(){return this.dataType};d.prototype.getDecimals=function(){return"float"===this.dataType?3:0};d.prototype.getListValues=function(){return c.filter(this.staticListValues.concat(this.listValues),function(b){return"1"!==b.getValue("deleted")&&"0"!==b.getValue("enabled")})};return d});
define("component/searchresults/implementations/parameterfields/ParameterFieldInterface",["underscore","../InterfaceWrapperBase","../../dataobjects/ValueData","../../dataobjects/ValidationFeedback"],function(c,d,b,a){var e=function(a,b){d.call(this,a,"ParameterField Component",b);this._requireMethod("getValueData");this._requireMethod("setValueData");this._requireMethod("clear");this._requireMethod("valueContainsSmartName");this._requireMethod("valueContainsSpecialSearchCharacters");this._requireMethod("onChange");
this._requireMethod("destroy")};e.prototype=Object.create(d.prototype);e.prototype.constructor=e;e.prototype.getValueData=function(c,d){if(!c||!(c instanceof b&&d&&d instanceof a))throw Error("Wrong information passed to ParameterFieldInterface.getValueData...");this._doSafeCall("getValueData",c,d)};e.prototype.setValueData=function(a){if(!(a&&a instanceof b))throw Error("Wrong information passed to ParameterFieldInterface.setValueData...");return this._doSafeBoolReturnCall("setValueData",!0,a)};
e.prototype.clear=function(){this._doSafeCall("clear")};e.prototype.resize=function(){this._doSafeCall("resize")};e.prototype.focus=function(){this._requireMethod("focus");this._doSafeCall("focus")};e.prototype.valueContainsSmartName=function(){return this._doSafeBoolReturnCall("valueContainsSmartName",!0)};e.prototype.valueContainsSpecialSearchCharacters=function(a){if(!c.isArray(a))throw Error("Wrong information passed to ParameterFieldInterface.valueContainsSpecialSearchCharacters...");return this._doSafeBoolReturnCall("valueContainsSpecialSearchCharacters",
!1,a)};e.prototype.onChange=function(a){if(!c.isFunction(a))throw Error("Wrong information passed to ParameterFieldInterface.onChange...");this._doSafeCall("onChange",a)};e.prototype.validate=function(){return this._doSafeBoolReturnCall("validate",!0)};e.prototype.doFacetUpdate=function(a){if(!(a&&a instanceof b))throw Error("Wrong information passed to ParameterFieldInterface.doFacetUpdate...");this._doSafeCall("doFacetUpdate",a)};e.prototype.destroy=function(){this._doSafeCall("destroy")};return e});
define("component/searchresults/implementations/parameterfields/ParameterFieldFactoryInterface","jquery underscore ../InterfaceWrapperBase ../../dataobjects/DataProvider ../../dataobjects/SearchSettings ../../dataobjects/FieldProperties ./ParameterFieldInterface".split(" "),function(c,d,b,a,e,f,g){c=function(a,c){b.call(this,a,"ParameterField Component Factory",c);this._requireMethod("make")};c.prototype=Object.create(b.prototype);c.prototype.constructor=c;c.prototype.make=function(b,c,d,l,j){if(!b||
!(1===b.nodeType&&c&&"string"===typeof c&&d&&d instanceof e&&l&&l instanceof a&&j&&j instanceof f))throw Error("Wrong information passed to ParameterFieldFactoryInterface.make...");b=this._doSafeAnyReturnCall("make",b,c,d,l,j);return new g(c,b)};return c});
define("component/searchresults/internal/components/SearchImplementationGroupedLoadingResolver",["underscore","require","lib/PromisePolyfill"],function(c,d){var b=function(a,b){this._interface=a;this._bundledimplpath=b;this._overrulebyfieldid={};this._loadingpromise=null};b.prototype._loadAll=function(){this._loadingpromise||(this._loadingpromise=new Promise(c.bind(function(a,b){d([this._bundledimplpath],function(b){a(b)},c.bind(function(a){"scripterror"===a.requireType?this._showError('Missing Group File "'+
this._bundledimplpath+'.js".',a):this._showError('"'+this._bundledimplpath+'" or any of the linked files contains an error.',a);b("Unable to load components. See developer console.")},this))},this)));return this._loadingpromise};b.prototype.resolve=function(a,b){if(this._overrulebyfieldid.hasOwnProperty(b)){var a="custom:"+b,d=new this._interface(a,this._overrulebyfieldid[b]);return Promise.resolve(d)}return this._loadAll().then(c.bind(function(b){return b.hasOwnProperty(a)?new this._interface(a,
b[a]):Promise.reject("Null implementationid...")},this))};b.prototype.overruleFieldImplementation=function(a,b){this._overrulebyfieldid[a]=b};b.prototype._showError=function(a,b){b?(window.console.log("[ERROR] "+a+" -- See error below."),window.console.log(b)):window.console.log("[ERROR] "+a)};return b});
define("component/searchresults/internal/components/parameterfield/SearchParameterFieldControl","jquery underscore ./ParameterField ../../../model/SearchSetupInformation ../../../model/SearchModelFrontEndData ../../../dataobjects/ValueData ../../../dataobjects/SearchSettings ../../../dataobjects/DataProvider ../../functionality/SpecialCharactersHintController ../../../implementations/parameterfields/ParameterFieldFactoryInterface ../SearchImplementationGroupedLoadingResolver".split(" "),function(c,
d,b,a,e,f,g,i,h,k,l){a=function(a){this._core=a;this._implementationResolver=new l(k,"component/searchresults/implementations/parameterfields/all");this._componentsStillLoading=0;this._loadingcallbacks=[];this._rerunCallbacks=[];this._charHint=null;this._list=[]};a.prototype.initializeSpecialCharactersHintController=function(a){this._charHint||(this._charHint=new h(a,this._core.setupInfo))};a.prototype.makeParameterField=function(a,c){this._componentsStillLoading++;var e=this._core.setupInfo.getFeatures().getUseSmartNames()&&
this._core.searchData.getSearchSettings().getIsAdmin()&&!this._core.searchData.getSearchContext().getIsSearchResults(),f=this._core.searchData.getSearchSettings(),l=this._core.setupInfo.getCriteriaList(),h=d.bind(l.watch,l),l=d.bind(l.unwatch,l),e=new g(e,f,h,l),i=new b(a,c,this._core,e,this._implementationResolver);c.ParameterFieldComponent=i;this._list.push(c);i.onDoneLoading(d.bind(function(){this._componentsStillLoading--;this._checkAllLoaded()},this));i.onRequiresRerun(d.bind(function(a){this._triggerNeedsRerun(a)},
this));if(this._charHint)i.onStartsUsingSpecialCharacters(d.bind(function(a){a?this._charHint.setDontAskAgain():this._charHint.trigger()},this));return new Promise(function(a){i.onDoneLoading(function(){a()})})};a.prototype.destroyParameterField=function(a){var b=a.ParameterFieldComponent;b.isLoaded()||(this._componentsStillLoading--,this._checkAllLoaded());this._list.splice(d.indexOf(this._list,a),1);b.destroy()};a.prototype.focusParameterField=function(a){var b=a.ParameterFieldComponent;if(b)b.onDoneLoading(d.bind(function(){b.focus()},
this))};a.prototype.replaceImplementations=function(a,b){var c=[];d.each(this._list,function(b){b.ParameterFieldComponent.getFieldId()===a&&c.push(b)},this);d.each(c,function(c){this.destroyParameterField(c);this._implementationResolver.overruleFieldImplementation(a,b);this.makeParameterField(a,c)},this)};a.prototype.clearForm=function(){d.each(this._list,d.bind(function(a){a.ParameterFieldComponent.clearField()},this))};a.prototype.validateAll=function(){var a=!0;d.each(this._list,d.bind(function(b){b.ParameterFieldComponent.validate()||
(a=!1)},this));return a};a.prototype.resizeAll=function(){d.each(this._list,d.bind(function(a){a.ParameterFieldComponent.resize()},this))};a.prototype.isLoaded=function(){return 0===this._componentsStillLoading};a.prototype.whenLoadedOnce=function(a){this.isLoaded()?a():this._loadingcallbacks.push(a)};a.prototype.onNeedsRerun=function(a){this._rerunCallbacks.push(a)};a.prototype._triggerNeedsRerun=function(a){for(var b=0;b<this._rerunCallbacks.length;b++)this._rerunCallbacks[b](a)};a.prototype._checkAllLoaded=
function(){this.isLoaded()&&(c.each(this._loadingcallbacks,function(a,b){b()}),this._loadingcallbacks=[])};return a});
define("component/searchresults/internal/FieldLayoutAPI",["underscore","../model/SearchSetupInformation","../model/SearchModelFrontEndData","./components/parameterfield/SearchParameterFieldControl"],function(c){var d=function(b){this._core=b};d.prototype._withSearchField=function(b,a){this._core.searchData.requireFieldInformationAvailable(b,c.bind(function(){var c=this._core.searchData.getFieldInformation(b);a.call(this,c)},this))};d.prototype.getListOfAllCriterionIds=function(){return c.union(this.getListOfCriterionIds(),
this.getListOfColumnDisplayCriterionIds(),this.getListOfDesignPanelCriterionIds(),this.getListOfSortingCriterionIds())};d.prototype.getListOfCriterionIds=function(){var b=[];this._core.setupInfo.getCriteriaList().each(function(a){b.push(a.getFieldId())});return b};d.prototype.getListOfColumnDisplayCriterionIds=function(){var b=[];this._core.setupInfo.getDisplayColumns().each(function(a){b.push(a.getFieldId())});return b};d.prototype.setColumnDisplayView=function(b,a){var c=this._core.setupInfo.getDisplayColumns().findByFieldId(b);
c||(c=this._core.setupInfo.getDisplayColumns().createItem(b),this._core.setupInfo.getDisplayColumns().add(c));c.setEnabled(a)};d.prototype.getListOfDesignPanelCriterionIds=function(){var b=[];this._core.setupInfo.getDesignPanelItems().each(function(a){b.push(a.getFieldId())});return b};d.prototype.getListOfSortingCriterionIds=function(){var b=[];this._core.setupInfo.getSortingCriteriaList().each(function(a){b.push(a.getFieldId())});return b};d.prototype.makeParameterField=function(b,a,c){this._withSearchField(b,
function(){var d=this._core.searchData.getFieldInformation(b);!d||!d.parameterFieldType?c&&c():this._core.paramFields.makeParameterField(b,a).then(function(){c&&c()})})};d.prototype.destroyParameterField=function(b){this._core.paramFields.destroyParameterField(b)};d.prototype.focusParameterField=function(b){this._core.paramFields.focusParameterField(b)};d.prototype.registerFieldColumnDisplaySettingsController=function(b,a){if(!b||!("string"===typeof b&&a&&"object"===typeof a&&"function"===typeof a.configure&&
"function"===typeof a.destroy))throw Error("Illegal object passed to registerFieldColumnDisplaySettingsController in FieldLayoutAPI");this._withSearchField(b,function(c){var d=this._core.setupInfo.getDisplayColumns().findByFieldId(b);d||(d=this._core.setupInfo.getDisplayColumns().createItem(b),this._core.setupInfo.getDisplayColumns().add(d));a.configure(c,d)})};d.prototype.unregisterFieldColumnDisplaySettingsController=function(b){b.destroy()};d.prototype.registerFieldDesignPanelSettingsController=
function(b,a){if(!b||!("string"===typeof b&&a&&"object"===typeof a&&"function"===typeof a.configure&&"function"===typeof a.destroy))throw Error("Illegal object passed to registerFieldDesignPanelSettingsController in FieldLayoutAPI");this._withSearchField(b,function(c){var d=this._core.setupInfo.getDesignPanelItems().findByFieldId(b);d||(d=this._core.setupInfo.getDesignPanelItems().createItem(b),this._core.setupInfo.getDesignPanelItems().add(d));a.configure(c,d)})};d.prototype.unregisterFieldDesignPanelSettingsController=
function(b){b.destroy()};d.prototype.registerFieldSortingSettingsController=function(b,a){if(!b||!("string"===typeof b&&a&&"object"===typeof a&&"function"===typeof a.configure&&"function"===typeof a.destroy))throw Error("Illegal object passed to registerFieldSortingSettingsController in FieldLayoutAPI");this._withSearchField(b,function(c){var d=this._core.setupInfo.getSortingCriteriaList().findByFieldId(b);d||(d=this._core.setupInfo.getSortingCriteriaList().createItem(b),this._core.setupInfo.getSortingCriteriaList().add(d));
a.configure(c,d)})};d.prototype.unregisterFieldSortingSettingsController=function(b){b.destroy()};d.prototype.registerFieldConfigButtonController=function(b,a){if(!b||!("string"===typeof b&&a&&"object"===typeof a&&"function"===typeof a.configure&&"function"===typeof a.destroy))throw Error("Illegal object passed to registerFieldConfigButtonController in FieldLayoutAPI");this._withSearchField(b,function(b){var d=c.bind(this._core.fieldConfig.toggleConfiguration,this._core.fieldConfig,b);a.configure(b,
d)})};d.prototype.unregisterFieldConfigButtonController=function(b){b.destroy()};d.prototype.tryCopyAllInformationForField=function(b,a){this.tryCopyCriterion(b,a);this.tryCopyDisplayColumnCriterion(b,a);this.tryCopyDesignPanelCriterion(b,a);this.tryCopySortingCriterion(b,a)};d.prototype.tryCopyCriterion=function(b,a){var c=this._core.setupInfo.getCriteriaList().findByFieldId(b),d=this._core.setupInfo.getCriteriaList().findByFieldId(a);c&&!d&&(d=this._core.setupInfo.getCriteriaList().createItem(a),
d.copyFrom(c),this._core.setupInfo.getCriteriaList().add(d))};d.prototype.tryCopyDisplayColumnCriterion=function(b,a){var c=this._core.setupInfo.getDisplayColumns().findByFieldId(b),d=this._core.setupInfo.getDisplayColumns().findByFieldId(a);c&&!d&&(d=this._core.setupInfo.getDisplayColumns().createItem(a),this._withSearchField(a,function(a){d.safeCopyFrom(a,c)}),this._core.setupInfo.getDisplayColumns().add(d))};d.prototype.tryCopyDesignPanelCriterion=function(b,a){var c=this._core.setupInfo.getDesignPanelItems().findByFieldId(b),
d=this._core.setupInfo.getDesignPanelItems().findByFieldId(a);c&&!d&&(d=this._core.setupInfo.getDesignPanelItems().createItem(a),this._withSearchField(a,function(a){d.safeCopyFrom(a,c)}),this._core.setupInfo.getDesignPanelItems().add(d))};d.prototype.tryCopySortingCriterion=function(b,a){var c=this._core.setupInfo.getSortingCriteriaList().findByFieldId(b),d=this._core.setupInfo.getSortingCriteriaList().findByFieldId(a);c&&!d&&(d=this._core.setupInfo.getSortingCriteriaList().createItem(a),this._withSearchField(a,
function(a){d.safeCopyFrom(a,c)}),this._core.setupInfo.getSortingCriteriaList().add(d))};d.prototype.tryMoveAllInformationForField=function(b,a){this.tryMoveCriterion(b,a);this.tryMoveDisplayColumnCriterion(b,a);this.tryMoveDesignPanelCriterion(b,a);this.tryMoveSortingCriterion(b,a)};d.prototype.tryMoveCriterion=function(b,a){var c=this._core.setupInfo.getCriteriaList().findByFieldId(b),d=this._core.setupInfo.getCriteriaList().findByFieldId(a);c&&!d&&(d=this._core.setupInfo.getCriteriaList().createItem(a),
d.copyFrom(c),this._core.setupInfo.getCriteriaList().tryToRemoveItem(c),this._core.setupInfo.getCriteriaList().add(d))};d.prototype.tryMoveDisplayColumnCriterion=function(b,a){var c=this._core.setupInfo.getDisplayColumns().findByFieldId(b),d=this._core.setupInfo.getDisplayColumns().findByFieldId(a);c&&!d&&(d=this._core.setupInfo.getDisplayColumns().createItem(a),this._withSearchField(a,function(a){d.safeCopyFrom(a,c)}),this._core.setupInfo.getDisplayColumns().tryToRemoveItem(c),this._core.setupInfo.getDisplayColumns().add(d))};
d.prototype.tryMoveDesignPanelCriterion=function(b,a){var c=this._core.setupInfo.getDesignPanelItems().findByFieldId(b),d=this._core.setupInfo.getDesignPanelItems().findByFieldId(a);c&&!d&&(d=this._core.setupInfo.getDesignPanelItems().createItem(a),this._withSearchField(a,function(a){d.safeCopyFrom(a,c)}),this._core.setupInfo.getDesignPanelItems().tryToRemoveItem(c),this._core.setupInfo.getDesignPanelItems().add(d))};d.prototype.tryMoveSortingCriterion=function(b,a){var c=this._core.setupInfo.getSortingCriteriaList().findByFieldId(b),
d=this._core.setupInfo.getSortingCriteriaList().findByFieldId(a);c&&!d&&(d=this._core.setupInfo.getSortingCriteriaList().createItem(a),this._withSearchField(a,function(a){d.safeCopyFrom(a,c)}),this._core.setupInfo.getSortingCriteriaList().tryToRemoveItem(c),this._core.setupInfo.getSortingCriteriaList().add(d))};d.prototype.tryDeleteAllInformationForField=function(b){this.tryDeleteCriterion(b);this.tryDeleteDisplayColumnCriterion(b);this.tryDeleteDesignPanelCriterion(b);this.tryDeleteSortingCriterion(b)};
d.prototype.tryDeleteCriterion=function(b){(b=this._core.setupInfo.getCriteriaList().findByFieldId(b))&&this._core.setupInfo.getCriteriaList().tryToRemoveItem(b)};d.prototype.tryDeleteDisplayColumnCriterion=function(b){(b=this._core.setupInfo.getDisplayColumns().findByFieldId(b))&&this._core.setupInfo.getDisplayColumns().tryToRemoveItem(b)};d.prototype.tryDeleteDesignPanelCriterion=function(b){(b=this._core.setupInfo.getDesignPanelItems().findByFieldId(b))&&this._core.setupInfo.getDesignPanelItems().tryToRemoveItem(b)};
d.prototype.tryDeleteSortingCriterion=function(b){(b=this._core.setupInfo.getSortingCriteriaList().findByFieldId(b))&&this._core.setupInfo.getSortingCriteriaList().tryToRemoveItem(b)};d.prototype.getSetupLabel=function(b,a){this._withSearchField(b,function(b){a(b.getDefaultLabel())})};d.prototype.getExternalSearchSettings=function(){return this._core.searchData.getSearchSettings()};d.prototype.getLayoutOptions=function(){return this._core.setupInfo.getLayoutOptions()};d.prototype.updateObjectModelOrder=
function(b){this._core.setupInfo.getDisplayColumns().reorderItemsByIds(b);this._core.setupInfo.getCriteriaList().reorderItemsByIds(b);this._core.setupInfo.getDesignPanelItems().reorderItemsByIds(b);this._core.setupInfo.getSortingCriteriaList().reorderItemsByIds(b)};d.prototype.isSameResultsType=function(b){return this._core.searchData.isSameResultsType(b)};d.prototype.getDefaultDrilldownLabel=function(){return this._core.searchData.getDefaultDrilldownLabel()};d.prototype.watch=function(b,a){this._core.setupInfo.getCriteriaList().watch(b,
a)};d.prototype.unwatch=function(b,a){this._core.setupInfo.getCriteriaList().unwatch(b,a)};return d});
define("component/searchresults/implementations/fieldconfigurators/FieldConfigurationPanelInterface",["underscore","../InterfaceWrapperBase","../../dataobjects/ValueData"],function(c,d,b){var a=function(a,b){d.call(this,a,"FieldOptionsPanel Component",b);this._requireMethod("getData");this._requireMethod("setData");this._requireMethod("onChange");this._requireMethod("destroy")};a.prototype=Object.create(d.prototype);a.prototype.constructor=a;a.prototype.getData=function(a){if(!(a&&a instanceof b))throw Error("Wrong information passed to FieldConfigurationPanelInterface.getData...");
this._doSafeCall("getData",a)};a.prototype.setData=function(a){if(!(a&&a instanceof b))throw Error("Wrong information passed to FieldConfigurationPanelInterface.setData...");this._doSafeCall("setData",a)};a.prototype.onChange=function(a){if(!c.isFunction(a))throw Error("Wrong information passed to FieldConfigurationPanelInterface.onChange...");this._doSafeCall("onChange",a)};a.prototype.destroy=function(){this._doSafeCall("destroy")};a.prototype.getUserDocumentationURL=function(){return this._doSafeStringReturnCall("getUserDocumentationURL")};
return a});
define("component/searchresults/implementations/fieldconfigurators/FieldConfiguratorInterface","jquery underscore ../InterfaceWrapperBase ../../dataobjects/ExternalSearchSettings ../../dataobjects/FieldProperties ../../dataobjects/ValueData ../../model/SearchLayoutOptions ../../model/SearchModelFrontEndData ./FieldConfigurationPanelInterface".split(" "),function(c,d,b,a,e,f,g,i,h){c=function(a,c){b.call(this,a,"FieldOptionsPanel Component Factory",c);this._requireMethod("configureFieldProperties")};c.prototype=
Object.create(b.prototype);c.prototype.constructor=c;c.prototype.makeConfigurationPanel=function(b,c,d){if(!b||!(1===b.nodeType&&d&&d instanceof a&&c&&c instanceof e))throw Error("Wrong information passed to FieldConfiguratorInterface.makeConfigurationPanel...");b=this._doSafeAnyReturnCall("makeConfigurationPanel",b,c,d);return new h(c.fieldid,b)};c.prototype.configureFieldProperties=function(b,c,d,m,h,p){if(!b||!(b instanceof e&&c&&c instanceof f&&d&&d instanceof g&&m&&m instanceof a&&h&&h instanceof
i&&p))throw Error("Wrong information passed to FieldConfiguratorInterface.configureFieldProperties...");return this._doSafeAnyReturnCall("configureFieldProperties",b,c,d,m,h,p)};return c});
define("component/searchresults/internal/components/fieldconfigurator/SearchFieldConfiguratorControl","underscore component/helpIcon/HelpIcon ../../../model/SearchField ../../../dataobjects/FieldProperties ../../../dataobjects/ValueData ../../../dataobjects/ValueDataUtils ../../../implementations/fieldconfigurators/FieldConfiguratorInterface ../SearchImplementationGroupedLoadingResolver utils/webi18n!SearchInputs".split(" "),function(c,d,b,a,e,f,g,i,h){var k=function(a){this._core=a;this._implementationResolver=
new i(g,"component/searchresults/implementations/fieldconfigurators/all");this._initPopoverHandling()};k.prototype._initPopoverHandling=function(){this._lastpanel=this._lastpopover=this._lastpopoverbtn=null;this._closeOpenPopovers=function(){this._lastpopover&&(this._lastpopoverbtn.popover("hide"),this._lastpopover=this._lastpopoverbtn=null,setTimeout(c.partial(function(a){a.destroy()},this._lastpanel),1E3),this._lastpanel=null)};$("body").click(c.bind(function(a){this._lastpopover&&(a.target===this._lastpopover||
$(a.target).closest(".popover").length||!$(a.target).is(".advconfigbtn")&&!$(a.target).closest(".advconfigbtn").length&&this._closeOpenPopovers())},this))};k.prototype.collectFieldProperties=function(d){if(!(d&&d instanceof b))throw Error("Illegal arguments passed to SearchFieldConfiguratorControl.makeFieldProperties");var e=d?d.configuratorType:"";return(e?this._implementationResolver.resolve(e,d.fieldId):Promise.resolve(null)).then(c.bind(function(b){var e="metric"===this._core.searchData.getSearchSettings().getUserUnitsPreference()?
d.unitMetric:d.unitImperial,h=new a;h.fieldid=d.fieldId;h.defaultLabel=d.label;h.label=this._core.setupInfo.getDesignPanelItems().getCustomizedLabel(d);h.displayUnit=e;h.unitConversionFactor=this._core.searchData.getUnitConversionFactor(d.unitLucene,e);h.dataType=d.dataType;h.typeOfParameterField=d.parameterFieldType;h.typeOfRenderer=d.cellDisplayType;h.typeOfEditComponent=d.editComponentType;h.displayConfig=f.clone(d.displayConfig);h.staticListValues=d.staticListValues||[];h.listValues=[];d.listValueID&&
(h.listValues=this._core.searchData.getList(d.listValueID)||[]);h.dropdownValueKey=d.dropdownMode;h.dropdownSupportsQuery=d.dropdownSupportsQuery;e=[];if(b){var g=this._core.setupInfo.getInstancedFieldConfiguration().getInstance(d.fieldId);g||(g=d.displayConfig);e.push(b.configureFieldProperties(h,g,this._core.setupInfo.getLayoutOptions(),this._core.searchData.getSearchSettings(),this._core.searchData,c.bind(this.collectFieldProperties,this)))}return Promise.all(e).then(function(){return h})},this))};
k.prototype.toggleConfiguration=function(a,g){if(!(a&&a instanceof b))throw Error("Illegal arguments passed to SearchFieldConfiguratorControl.makeFieldProperties");if(this._lastpopoverbtn===g)this._closeOpenPopovers();else{var m=a?a.configuratorType:"",m=m?this._implementationResolver.resolve(m,a.fieldId):Promise.resolve(null),i=this.collectFieldProperties(a);return Promise.all([m,i]).then(c.bind(function(b){var m=b[0],i=b[1];if(m){this._closeOpenPopovers();var b=$("<div>"),k=m.makeConfigurationPanel(b[0],
i,this._core.searchData.getSearchSettings());g.popover({title:h.t("SEARCH_CONFIGURE_TITLE"),content:"<div class='contentplaceholder'>"+$("<div>").append(b).html()+"</div>",trigger:"manual",html:!0});g.popover("show");m=g.next(".popover");k.getUserDocumentationURL()&&(i=m.find(".popover-title"),i.append(d.getInlineHelpTopicJQuery(k.getUserDocumentationURL())),i.find("a").addClass("popover-title-help"));i=m.find(".popover-content .contentplaceholder");i.before(b);i.remove();b=$(".arrow",m);b.css({top:b.position().top});
var n=this._core.setupInfo.getInstancedFieldConfiguration(),b=n.getInstance(a.fieldId);b||(b=a.displayConfig);k.setData(f.clone(b));k.onChange(c.bind(function(){var b=new e;k.getData(b);n.setInstance(a.fieldId,b)},this));this._lastpopoverbtn=g;this._lastpopover=m;this._lastpanel=k}else window.console.log("[ERROR] Tried to open configuration panel for field without configurator!")},this))}};return k});
define("component/searchresults/internal/expandmodes/ExpandModeModal",["jquery","component/modal/Modal","underscore"],function(c,d,b){var a=function(a){if(a&&!b.isString(a))throw Error("Illegal arguments passed to ExpandModeModal constructor");this._defaultTitle=a||""};a.prototype.show=function(a,f){if(!(a&&"function"===typeof a))throw Error("Illegal arguments passed to ExpandModeModal.show");f&&"object"===typeof f||(f={});var g={},i=b.bind(function(){this.close()},g),h=c("<div>");a(h,i);i={};f.popupcssclass&&
(i.customClass=f.popupcssclass);i.widthClass=f.modaldialogclass;i.onClose=f.onclose;h=new d(h,i);g.close=b.bind(h.close,h);h.setTitle((f.title?f.title:this._defaultTitle)+(f.subtitle?" - "+f.subtitle:""));h.open()};a.prototype.setDefaultTitle=function(a){this._defaultTitle=a};return a});
define("component/searchresults/implementations/editcomponents/EditComponentInterface",["jquery","underscore","../InterfaceWrapperBase"],function(c,d,b){c=function(a,c){b.call(this,a,"Edit Component",c);this._requireMethod("getValue");this._requireMethod("setValue");this._requireMethod("getJQElement");this._requireMethod("getAttribute");this._requireMethod("onChange")};c.prototype=Object.create(b.prototype);c.prototype.constructor=c;c.prototype.getValue=function(){return this._doSafeStringReturnCall("getValue")};
c.prototype.setValue=function(a){if(!(null===a||d.isString(a)))throw Error("Wrong information passed to EditComponentInterface.setValue...");return this._doSafeBoolReturnCall("setValue",!0,a)};c.prototype.getJQElement=function(){return this._doSafeAnyReturnCall("getJQElement")};c.prototype.getAttribute=function(a){if(!d.isString(a))throw Error("Wrong information passed to EditComponentInterface.setValue...");return this._doSafeStringReturnCall("getAttribute",a)};c.prototype.focus=function(){this._requireMethod("focus");
this._doSafeCall("focus")};c.prototype.onChange=function(a){if(!d.isFunction(a))throw Error("Wrong information passed to EditComponentInterface.onChange...");this._doSafeCall("onChange",a)};return c});
define("component/searchresults/implementations/editcomponents/EditComponentFactoryInterface","jquery underscore ../InterfaceWrapperBase ../../dataobjects/ExternalSearchSettings ../../dataobjects/FieldProperties ./EditComponentInterface".split(" "),function(c,d,b,a,e,f){c=function(a,c){b.call(this,a,"Edit Component Factory",c);this._requireMethod("make")};c.prototype=Object.create(b.prototype);c.prototype.constructor=c;c.prototype.make=function(b,c){if(!b||!(b instanceof a&&c&&c instanceof e))throw Error("Wrong information passed to EditComponentFactoryInterface.make...");
var d=this._doSafeAnyReturnCall("make",b,c);return new f("<unknown>",d)};return c});
define("component/searchresults/internal/components/editcomponent/SearchEditComponentFactory","jquery underscore ../../../model/SearchSetupInformation ../../../model/SearchModelFrontEndData ../../../dataobjects/SearchSettings ../../expandmodes/ExpandModeModal ../../../implementations/editcomponents/EditComponentFactoryInterface ../SearchImplementationGroupedLoadingResolver".split(" "),function(c,d,b,a,e,f,g,i){c=function(a,b){this._core=a;this._resolveToFieldMethod=b;this._implementationResolver=
new i(g,"component/searchresults/implementations/editcomponents/all");this._resolvedFieldMap={}};c.prototype.load=function(a,b){this._resolveToFieldMethod(a,d.bind(function(c){this._core.fieldConfig.collectFieldProperties(c).then(d.bind(function(c){c.typeOfEditComponent?this._implementationResolver.resolve(c.typeOfEditComponent,a).then(d.bind(function(d){this._resolvedFieldMap[a]={supported:!0,fieldProperties:c,implementationfactory:d};b()},this)):(this._resolvedFieldMap[a]={supported:!1,fieldProperties:c},
b())},this))},this))};c.prototype.make=function(a){var b=this._resolvedFieldMap[a];if(void 0===b)throw Error("Call and wait for load to complete first!");var a=b.implementationfactory,b=b.fieldProperties,c=this._core.searchData.getSearchSettings();return a.isWrongImplementation()?null:a.make(c,b)};c.prototype.isSupported=function(a){a=this._resolvedFieldMap[a];if(void 0===a)throw Error("Call and wait for load to complete first!");return a.supported};return c});
define("component/searchresults/internal/attributecategory/SearchCategoryInfo","underscore jquery require utils/idUtils utils/Observable wcr/ObjectArrayCloneUtil".split(" "),function(c,d,b,a,e,f){var g=function(b,h,g){if(!b||!(b instanceof d&&h&&c.isString(h)&&c.isBoolean(g)))throw Error("Illegal arguments passed to SearchCategoryInfo");this._categoryid=h;this._isTaskType=g;this._id=a.newClientSideId("search_attr_cat");this._prefix="searchattrcat_"+this._id+"_";b.attr("id",this.getAttributeCategoryDomElementId());
this._log="";this._doneLoading=this._isLoading=!1;this._listidcounter=0;this._listsLoadingAll={};this._listsLoadingDone=[];this._category=null;e.mixin(this,"searchcategoryinfo")};g.prototype.getId=function(){return this._id};g.prototype.getAttributeCategoryDomElementId=function(){return this._prefix+"ACatPanel"};g.prototype.getAttributeCategory=function(){if(this._doneLoading)return this._category;throw Error("Tried to access Attribute Category before done loading.");};g.prototype.log=function(a){this._log+=
"\n"+a};g.prototype.load=function(a){if(this._doneLoading)a();else this.once("loadingbasedone",a);if(!this._isLoading&&!this._doneLoading){this._isLoading=!0;a={};a[this._isTaskType?"tasktypeid":"categoryid"]=this._categoryid;var a="GetAttributeCategoryXML.jsp?"+d.param(a,!0),e=f.getCloneOfObject(window.gCurrentUser);e.canEditAttributes=!1;var g={};g.currentUser=e;g.ACatObj=this.getAttributeCategoryDomElementId();g.isTemplate=!1;g.ACatPanel=null;g.readURL=a;g.type="";g.disableSynchronizingAttributes=
!0;g.prefix=this._prefix;b(["attributecategory/AttributeCategory"],c.bind(function(a){var b=new a(g),d=new Date;setTimeout(c.bind(function p(){var a=!0;b.loadingDone||(a=!1);if(a){var e=b.lists;if(e){for(var g=0;g<e.length;g++){var h=e[g];if(h&&"OnTheFly"!=h.loadingType&&(!h.combinations||0===h.combinations.length))a=!1}if(!a){setTimeout(c.bind(p,this),100);return}}this.log("loading Ready after "+(new Date-d)+"ms"+new Date);this._doneLoading=!0;this._isLoading=!1;this._category=b;this._emit("loadingbasedone")}else setTimeout(c.bind(p,
this),100)},this),100)},this))}};g.prototype.loadList=function(a,b){this.load(c.bind(function(){var e=this._category.lists[a.listIdx];if("OnTheFly"!=e.loadingType)b();else{var g=e.columns.length;a.depth&&a.depth<g&&(g=a.depth);var f=e.name+"~~"+g;if(c.has(this._listsLoadingDone,f))b();else if(c.has(this._listsLoadingAll,f))this.once("loadinglistdone."+this._listsLoadingAll[f],c.bind(function(){b()},this));else{var m=this._listidcounter;this._listidcounter++;this._listsLoadingAll[f]=m;for(var n=window.webcenterConfig.jspBaseUrl+
"GetRowsFromList.jsp?",p={listType:"WCR_DB_List",outputType:"JSON",indexed:"1",list:e.name,maxrows:"10000",maxcolrows:"1000",output:[]},q=0;q<g;q++)p.output.push(e.columns[q].columnName);var n=n+d.param(p,!0),r=c.bind(function(){this._listsLoadingDone[f]=!0;this._emit("loadinglistdone."+m);b();r=null},this);d.ajax({url:n,type:"GET",dataType:"text"}).done(c.bind(function(a){try{var b=d.parseJSON(a);if(!b.success||"0"==b.success)window.alert("Cannot get values "+b.error.code+" : "+b.error.message);
else{for(a=0;a<g;a++)e.columns[a].values=b.columns[a].values;e.assettreecombinations=b.combinations}r()}catch(c){window.alert("Error processing return of ajax call to GetRowsFromList.jsp in SearchCategoryInfo.loadList: "+c),r()}},this)).fail(c.bind(function(a){window.alert("Ajax call unsuccessful. Status: "+a.status+"\n"+a.responseText)},this))}}},this))};g.prototype.loadWithLists=function(a,b){var d=a.length;c.each(a,function(a){this.loadList(a,c.bind(function(){d--;0===d&&b()},this))},this)};return g});
define("component/searchresults/internal/attributecategory/SearchResultsAttributeCategoryControl",["underscore","require","./SearchCategoryInfo"],function(c,d,b){var a=function(a){this._core=a;this._resizeCallback=this._rerunSearchResultsAutomaticCall=null;this._categoryInfos={};this._assetBrowser=null;this._cascadingDropdownsLoaded=!1;this._cascadingDropdownsLoadedCallbacks=[]};a.prototype.onNeedsRerun=function(a){this._rerunSearchResultsAutomaticCall=a};a.prototype.onResize=function(a){this._resizeCallback=
a};a.prototype.configure=function(a){this._div=a};a.prototype.activate=function(){var a=this.hasdesignpanelitems("db_attr_"),b=this.hasdesignpanelitems("db_attr_ext_"),c=this._core.setupInfo.getLayoutOptions().getOption("cascading_attribute_trees"),c=0<((c?c.getSubList("treeElem"):[])||[]).length;if(a||c){var d=this._core.setupInfo.getLayoutOptions().getOption("category_id"),h=this._core.searchData.isTaskSearch();this._initCategory(d,h,!1,a,c,"db_attr_")}b&&(a=this._core.setupInfo.getLayoutOptions().getOption("extended_category_id"),
this._initCategory(a,!1,!0,!0,!1,"db_attr_ext_"));return Promise.resolve()};a.prototype.clearForm=function(){this._assetBrowser&&this._assetBrowser.clear()};a.prototype._initCategory=function(a,f,g,i,h,k){if(a){i=$("<td>").css({padding:"0px"});$(".attributecategorycells",this._div).append($("<tr>").append(i));var l=new b(i,a,f);this._categoryInfos[g?"extended":"normal"]=l;h&&d(["./AssetBrowser"],c.bind(function(a){var b=new a(l,this._core.setupInfo,this._rerunSearchResultsAutomaticCall);b.whenReady(c.bind(function(){if(b.isCorrectlyConfigured()){var a;
a=$("#headerAssetViewDropdownContainer");a=0<a.length?a:$(".assetViewDropdownContainer",this._div);b.makeVisibilityDropdown(a.get(0));a=$(".searchassetbrowserImageArea",this._div);b.makeImagePane(a.get(0));a=$(".assetViewTreeContainer",this._div);b.makeTreePane(a.get(0));this._assetBrowser=b;this._resizeCallback&&this._resizeCallback()}},this))},this));this._initCascadingDropdowns(l,k)}};a.prototype.getImagepanel=function(){return $(".searchassetbrowserImageArea",this._div)};a.prototype.getSidePanel=
function(){return $(".assetViewTreeContainer",this._div)};a.prototype.hasdesignpanelitems=function(a){var b=!1;this._core.setupInfo.getDesignPanelItems().each(function(c){b=b||0===c.getFieldId().lastIndexOf(a,0)});return b};a.prototype._initCascadingDropdowns=function(a,b){a.load(function(){d(["component/searchresults/implementations/parameterfields/ParameterField_cascading_dropdown","component/searchresults/implementations/parameterfields/ParameterField_cascading_dropdown_xml"],c.bind(function(d,
i){var h=a.getAttributeCategory();h.lists&&(c.each(h.cells,function(a,e){c.each(a,function(a,c){if(a){var n=a.attObj;if(n&&n.listObj&&n.columnObj){var k=b+n.id,n="database"===n.listObj.type?new d(this,h,n,e,c):new i(h,a,e,c);this._core.paramFields.replaceImplementations(k,n)}}}.bind(this))}.bind(this)),this._fireCascadingDropdownsLoaded())},this))}.bind(this))};a.prototype.onCascadingDropdownsLoaded=function(a){this._cascadingDropdownsLoaded?a():this._cascadingDropdownsLoadedCallbacks.push(a)};a.prototype._fireCascadingDropdownsLoaded=
function(){this._cascadingDropdownsLoaded=!0;c.each(this._cascadingDropdownsLoadedCallbacks,function(a){a()})};return a});
define("component/searchresults/internal/SearchCoreData","underscore ../model/SearchSetupInformation ../model/SearchModelFrontEndData ./FieldLayoutAPI ./components/fieldconfigurator/SearchFieldConfiguratorControl ./components/parameterfield/SearchParameterFieldControl ./components/editcomponent/SearchEditComponentFactory ./attributecategory/SearchResultsAttributeCategoryControl".split(" "),function(c,d,b,a,e,f,g,i){var h=function(a,c){if(!c||!(c instanceof d&&a&&a instanceof b))throw Error("Illegal arguments passed to SearchCoreData");
Object.defineProperty(this,"setupInfo",{value:c});Object.defineProperty(this,"searchData",{value:a});this._initParameterFieldControl();this._initLayoutAPI();this._initFieldConfiguratorControl();this._initAttributeCategoryControl()};h.prototype._initLayoutAPI=function(){this.hasOwnProperty("layoutApi")||Object.defineProperty(this,"layoutApi",{value:new a(this)})};h.prototype._initParameterFieldControl=function(){this.hasOwnProperty("paramFields")||Object.defineProperty(this,"paramFields",{value:new f(this)})};
h.prototype._initFieldConfiguratorControl=function(){this.hasOwnProperty("fieldConfig")||Object.defineProperty(this,"fieldConfig",{value:new e(this)})};h.prototype._initAttributeCategoryControl=function(){this.hasOwnProperty("categoryControl")||Object.defineProperty(this,"categoryControl",{value:new i(this)})};h.prototype.initFacetValueEditFactory=function(){this.hasOwnProperty("facetValueEditFactory")||Object.defineProperty(this,"facetValueEditFactory",{value:new g(this,c.bind(this.searchData.resolveFacetIdEditField,
this.searchData))})};return h});
define("component/searchresults/model/io/SearchModelTransferedJsonReader","../SearchSetupInformation ../SearchCriterionInfo ../SearchDesignPanelItem ../SearchDisplayColumn ../SearchSortingCriterion ../SearchLayoutOptions ../../dataobjects/ValueData ../../dataobjects/ValueDataUtils underscore".split(" "),function(c,d,b,a,e,f,g,i,h){var k=function(a){if(!(a&&a instanceof c))throw Error("Wrong parameter... No SearchSetupInformation object passed to SearchModelTransferedJsonReader.");this.model=a};k.prototype.read=
function(a){this._parseFeatures(a);this._parseCriteria(a);this._parseDesignPanelItems(a);this._parseDisplayColumns(a);this._parseSortingCriteria(a);this._parseLayoutOptions(a);this._parseDashboardConfiguration(a);this._parseInstancedFieldConfiguration(a)};k.prototype._parseFeatures=function(a){var a=a.features||{},b=this.model.getFeatures();b.setUseSmartNames(!0===a.smartnames);b.setUseAdvancedChars(!0===a.advchars)};k.prototype._parseLayoutOptions=function(a){var b=[],c=[];h.each(a.options||[],function(a){var d=
a.id,e=a.type,h=null,l=null;"BOOLEAN"===e||"STRING"===e?(h=a.defaultValue,null!==a.value&&void 0!==a.value&&(l=a.value)):"COMPLEXVALUE"===e?a.value&&(l=new g,i.fromJSON(l,a.value)):"ITEMSEQUENCE"===e&&a.value&&(l=a.value);b.push(new f.Setting(d,e,h));null!==l&&c.push({id:d,value:l})});this.model.getLayoutOptions().setAvailableSettings(b);h.each(c,function(a){this.model.getLayoutOptions().setOption(a.id,a.value)},this)};k.prototype._parseCriteria=function(a){for(var a=a.criteria||[],b=0;b<a.length;b++){var c=
a[b],e=c.id,h=c.SN,f=c.valueData||{},c=new g;i.fromJSON(c,f);e=new d(e);e.setValue(c,h);this.model.getCriteriaList().add(e)}this.model.getCriteriaList().commitChanges()};k.prototype._parseDesignPanelItems=function(a){for(var a=a.designPanelItems||[],c=0;c<a.length;c++){var d=a[c],e=d.row,g=d.column,h=d.label,f=d.originalVisibility,i=d.visibility,d=new b(d.id);d.setRow(e);d.setColumn(g);d.setLabel(h);d.setOriginalVisibility(f);d.setVisibility(i);this.model.getDesignPanelItems().add(d)}this.model.getDesignPanelItems().commitChanges()};
k.prototype._parseDisplayColumns=function(b){for(var b=b.displayColumns||[],c=0;c<b.length;c++){var d=b[c],e=d.editable,g=d.enabled,h=d.sequence,d=new a(d.id);d.setEnabled(g);d.setEditable(e);d.setSequence(""+h);this.model.getDisplayColumns().add(d)}this.model.getDisplayColumns().commitChanges()};k.prototype._parseSortingCriteria=function(a){for(var a=a.sortingCriteria||[],b=0;b<a.length;b++){var c=a[b],d=c.order,g=c.number,c=new e(c.id);c.setEnabled(!0);c.setOrder(d);c.setNumber(g);this.model.getSortingCriteriaList().add(c)}this.model.getSortingCriteriaList().commitChanges()};
k.prototype._parseDashboardConfiguration=function(a){a.dashboard_configuration?this.model.getDashboardConfiguration().setDashboard(a.dashboard_configuration):this.model.getDashboardConfiguration().setDashboard(null)};k.prototype._parseInstancedFieldConfiguration=function(a){var a=a.instanced_field_configuration,b={};if(a)for(var c in a)if(a.hasOwnProperty(c)){var d=new g;i.fromJSON(d,a[c]);b[c]=d}this.model.getInstancedFieldConfiguration().setData(b)};k.read=function(a,b){(new k(a)).read(b)};return k});
define("component/searchresults/model/io/SearchModelTransferedJsonWriter",["../SearchSetupInformation","../SearchCriterionInfo","../../dataobjects/ValueData","../../dataobjects/ValueDataUtils","underscore"],function(c,d,b,a,e){var f=function(a){if(!(a&&a instanceof c))throw Error("Wrong parameter... No SearchSetupInformation object passed to SearchModelTransferedJsonWriter.");this.model=a};f.prototype.write=function(a){this._writeSearchFeatures(a);this._writeLayoutOptions(a);this._writeCriteria(a);
this._writeDesignPanelItems(a);this._writeDisplayColumns(a);this._writeSortingCriteria(a);this._writeDashboardConfiguration(a);this._writeInstancedFieldConfiguration(a)};f.prototype._writeSearchFeatures=function(a){a.features={smartnames:this.model.getFeatures().getUseSmartNames(),advchars:this.model.getFeatures().getUseAdvancedChars()}};f.prototype._writeLayoutOptions=function(b){var c=[],d=this.model.getLayoutOptions().getAvailableSettings();e.each(d,function(b){var d=b.id,e=b.type,h={id:d,type:e},
d=this.model.getLayoutOptions().getOption(d);"BOOLEAN"===e||"STRING"===e?(h.defaultValue=b.defaultValue,d!==b.defaultValue&&(h.value=d)):"COMPLEXVALUE"===e?null!=d&&(h.value=a.toJSON(d)):"ITEMSEQUENCE"===e&&null!=d&&(h.value=d);c.push(h)},this);b.options=c};f.prototype._writeCriteria=function(b){var c=[];this.model.getCriteriaList().each(function(b){var d=b.getValue(),d=a.toJSON(d),b={id:b.getFieldId(),valueData:d,SN:b.getContainsSmartName()};c.push(b)});b.criteria=c};f.prototype._writeDesignPanelItems=
function(a){var b=[];this.model.getDesignPanelItems().each(function(a){a={id:a.getFieldId(),row:a.getRow(),column:a.getColumn(),label:a.getLabel(),originalVisibility:a.getOriginalVisibility(),visibility:a.getVisibility()};b.push(a)});a.designPanelItems=b};f.prototype._writeDisplayColumns=function(a){var b=[];this.model.getDisplayColumns().each(function(a){if(a.getEnabled()||a.isEditable())a={id:a.getFieldId(),editable:a.isEditable(),sequence:isNaN(a.getSequence())?-1:parseInt(a.getSequence(),10),
enabled:a.getEnabled()},b.push(a)});a.displayColumns=b};f.prototype._writeSortingCriteria=function(a){var b=[];this.model.getSortingCriteriaList().each(function(a){a.getEnabled()&&(a={id:a.getFieldId(),order:a.getOrder(),number:a.getNumber()},b.push(a))});a.sortingCriteria=b};f.prototype._writeDashboardConfiguration=function(a){this.model.getDashboardConfiguration().hasDashboard()&&(a.dashboard_configuration=this.model.getDashboardConfiguration().getDashboard())};f.prototype._writeInstancedFieldConfiguration=
function(b){if(this.model.getInstancedFieldConfiguration()){var c=this.model.getInstancedFieldConfiguration().getDataClone(),d={};null!==c&&e.each(c,function(b,c){d[c]=a.toJSON(b)});b.instanced_field_configuration=d}};f.write=function(a,b){(new f(a)).write(b)};return f});
define("component/searchresults/dashboard/configuration/DefaultSearchResultsConfiguration",["utils/webi18n!SearchDashboard"],function(){return{type:"dashboard/Dashboard",id:"dashboard_Dashboard_0",config:{layout:{type:"dashboard/layout/ListLayout",id:"dashboard_layout_ListLayout_0",config:{items:[{id:"component_searchresults_dashboard_blocks_SearchResultsTableBlock_1"}],blocks:[]}},blocks:[{type:"component/searchresults/dashboard/blocks/SearchResultsTableBlock",id:"component_searchresults_dashboard_blocks_SearchResultsTableBlock_1",
config:{parameters:[{name:"blockTitle",type:"dashboard/core/parameters/StringParameter",config:{value:"i18n!{T:SharedLabels:SEARCH_RESULTS:Search Results}"}}]}}]}}});
define("component/searchresults/dashboard/SearchContextParameter",["dashboard/core/parameters/Parameter","component/searchresults/model/SearchInstancedFieldConfiguration","lib/PromisePolyfill"],function(c){var d=function(b,a){c.call(this,b,a,"component/searchresults/dashboard/SearchContextParameter","Search");var d=function(){return null};this._getAttributeCategoryControl=this._getCart=this._getSearchDesignPanel=this._getResultsTable=d;this._instancedFieldConfiguration=this._editFactory=null;this._isLoadingData=
!1};d.prototype=Object.create(c.prototype);d.prototype.constructor=d;d.prototype.getValue=function(){return this};d.prototype.setEditFactory=function(b){this._editFactory!==b&&(this._editFactory=b,this._emitChanged())};d.prototype.hasEditFactory=function(){return this._editFactory&&!0};d.prototype.isEditingSupportedForFacetId=function(b){var a=this;return Promise.resolve().then(function(){return a._editFactory?a._loadFacetFieldEditInformation(b).then(function(){return a._editFactory.isSupported(b)}):
!1})};d.prototype.getEditComponentForFacetId=function(b){var a=this;return this.isEditingSupportedForFacetId(b).then(function(c){if(c)return a._editFactory.make(b);throw Error("Editing not supported for given facet id "+b);})};d.prototype._loadFacetFieldEditInformation=function(b){var a=this;return new Promise(function(c){return a._editFactory.load(b,c)})};d.prototype.setFieldLayoutAPI=function(b){this._fieldLayoutAPI!==b&&(this._fieldLayoutAPI=b,this._emitChanged())};d.prototype.getFieldLayoutAPI=
function(){return this._fieldLayoutAPI};d.prototype.getSearchSetup=function(){return this._searchSetup};d.prototype.getCart=function(){return this._getCart()};d.prototype.setCartGenerator=function(b){this._getCart=b};d.prototype.getAttributeCategoryControl=function(){return this._getAttributeCategoryControl()};d.prototype.setAttributeCategoryControlGenerator=function(b){this._getAttributeCategoryControl=b};d.prototype.setSearchSetup=function(b){this._searchSetup!==b&&(this._searchSetup=b,this._emitChanged())};
d.prototype.getSearchData=function(){return this._searchData};d.prototype.setSearchData=function(b){this._searchData!==b&&(this._searchData=b,this._emitChanged())};d.prototype.setSearchDesignPanelGenerator=function(b){this._getSearchDesignPanel!==b&&(this._getSearchDesignPanel=b,this._emitChanged())};d.prototype.getSearchDesignPanel=function(){return this._getSearchDesignPanel()};d.prototype.getSearchResultsTable=function(){return this._getResultsTable()};d.prototype.setSearchResultsTableGenerator=
function(b){this._getResultsTable!==b&&(this._getResultsTable=b,this._emitChanged())};d.prototype.getInstanceConfig=function(b){return this.getInstancedFieldConfiguration()?this.getInstancedFieldConfiguration().getInstance(b):null};d.prototype.getInstancedFieldConfiguration=function(){!this._instancedFieldConfiguration&&this._searchSetup&&(this._instancedFieldConfiguration=this._searchSetup.getInstancedFieldConfiguration().clone());return this._instancedFieldConfiguration};d.prototype.setInstanceConfig=
function(b,a){this.getInstancedFieldConfiguration()&&this.getInstancedFieldConfiguration().setInstance(b,a)};d.prototype.removeInstanceConfig=function(b){this.getInstancedFieldConfiguration()&&this.getInstancedFieldConfiguration().removeInstance(b)};d.prototype.addInstanceConfig=function(b,a){return this.getInstancedFieldConfiguration()?this.getInstancedFieldConfiguration().addInstance(b,a):null};d.prototype.setLoadingData=function(b){this._isLoadingData!=b&&(this._isLoadingData=b,this._emit("loadingData",
b))};d.prototype.isLoadingData=function(){return this._isLoadingData};return d});
define("component/dashboard/DashboardUserPreferencesCache",["webcenterapi/AbstractAPI","utils/Promisify","underscore"],function(c,d,b){var a=function(d,f,g,i){c.apply(this,arguments);this._type=g;this._id=i;this._params={};g===a.type.SEARCH?this._params.savedSearchID=i:g===a.type.DASHBOARD?this._params.dashboardID=i:console.error("DashboardUserPreferencesCache: Type is not supported: "+g);this._userPreferences;this._saveDebounced=b.debounce(this._save,250)};a.prototype=Object.create(c.prototype);
a.prototype.constructor=a;a.type={SEARCH:"SEARCH",DASHBOARD:"DASHBOARD"};a.prototype.getPreferences=function(a){return this._getUserPreferences().then(function(b){return b[a]})};a.prototype.savePreferences=function(a,b){return this._getUserPreferences().then(function(c){c[a]=b;return this._saveDebounced(c)}.bind(this))};a.prototype._getUserPreferences=function(){this._userPreferences||this._load();return this._userPreferences};a.prototype._load=function(){return this._userPreferences=d.deferred(this.callSDK("dashboard.wcr",
b.extend({action:"LOADUSERSETTINGS"},this._params),{dataType:"json"})).then(function(a){var b={};if(a)try{b=JSON.parse(a.userSettingsJSON)}catch(c){b={},console.error("invalid JSON format for Dashboard User Settings")}return b})};a.prototype._save=function(a){return d.deferred(this.callSDK("dashboard.wcr",b.extend({action:"SAVEUSERSETTINGS"},this._params),{dataType:"json",method:"POST",data:{userSettingsJSON:JSON.stringify(a)}}))};return a});
define("component/searchresults/dashboard/configuration/BlockDefinitionsJSON",{HTMLBlock:{displayName:"Rich Text Block",type:"dashboard/blocks/HTMLBlock",category:"General",displayNameTag:"HTMLBLOCK",descriptionTag:"HTMLBLOCK_DESCRIPTION",languageBundle:"DashboardHTMLBlock",config:{parameters:[{name:"blockShowInEditMode",type:"dashboard/core/parameters/BooleanParameter",config:{value:!0}},{name:"blockTitle",type:"dashboard/core/parameters/StringParameter",config:{value:"i18n!{T:SharedLabels:HTML_BLOCK:Rich Text Block}"}}]}},
ListLayout:{displayName:"List Layout",type:"dashboard/layout/ListLayout",category:"Layout",displayNameTag:"LIST_LAYOUT",descriptionTag:"LIST_LAYOUT_DESCRIPTION",languageBundle:"DashboardListLayout",config:{parameters:[{name:"blockTitle",type:"dashboard/core/parameters/StringParameter",config:{value:"i18n!{T:SharedLabels:DSH_LIST_LAYOUT:List Layout}"}}]}},ColumnLayout:{displayName:"Column Layout",type:"dashboard/layout/flex/FlexLayout",category:"Layout",displayNameTag:"COLUMN_LAYOUT",descriptionTag:"COLUMN_LAYOUT_DESCRIPTION",
languageBundle:"DashboardFlexLayout",config:{parameters:[{name:"FlexColumnParameter",type:"dashboard/layout/flex/FlexColumnParameter",config:{value:{flexDirection:"horizontal",columns:[{grow:1,shrink:1},{grow:1,shrink:1}]}}},{name:"blockTitle",type:"dashboard/core/parameters/StringParameter",config:{value:"i18n!{T:SharedLabels:DSH_COLUMN_LAYOUT:Column Layout}"}}]}},AssetBrowserColumnLayout:{displayName:"Column Layout",type:"dashboard/layout/flex/FlexLayout",category:"Layout",displayNameTag:"COLUMN_LAYOUT",
descriptionTag:"COLUMN_LAYOUT_DESCRIPTION",languageBundle:"DashboardFlexLayout",config:{parameters:[{name:"CssSizeParameter",type:"dashboard/core/parameters/CssSizeParameter",config:{value:"10px"}},{name:"FlexColumnParameter",type:"dashboard/layout/flex/FlexColumnParameter",config:{value:{flexDirection:"horizontal",columns:[{grow:0,shrink:0,fitContent:!0},{grow:1,shrink:1,minWidth:"300px"}]}}},{name:"blockTitle",type:"dashboard/core/parameters/StringParameter",config:{value:"i18n!{T:SharedLabels:DSH_COLUMN_LAYOUT:Column Layout}"}}]}},
LeftSidePanelLayout:{displayName:"Left Side Panel Layout",type:"dashboard/layout/flex/FlexLayout",category:"Layout",displayNameTag:"LEFT_PANEL_LAYOUT",descriptionTag:"LEFT_PANEL_LAYOUT_DESCRIPTION",languageBundle:"DashboardFlexLayout",config:{parameters:[{name:"FlexColumnParameter",type:"dashboard/layout/flex/FlexColumnParameter",config:{value:{flexDirection:"horizontal",columns:[{grow:0,shrink:0,width:"200px",blockid:"dashboard_layout_ListLayout_0"},{grow:1,shrink:1}]}}},{name:"blockTitle",type:"dashboard/core/parameters/StringParameter",
config:{value:"i18n!{T:SharedLabels:DSH_LEFT_PANEL_LAYOUT:Left Side Panel Layout}"}}],blocks:[{displayName:"List Layout",id:"dashboard_layout_ListLayout_0",type:"dashboard/layout/ListLayout",category:"Layout",displayNameTag:"LIST_LAYOUT",descriptionTag:"LIST_LAYOUT_DESCRIPTION",languageBundle:"DashboardListLayout",config:{}}]}},SearchResults:{displayName:"Search Results",type:"component/searchresults/dashboard/blocks/SearchResultsTableBlock",category:"Search",displayNameTag:"RESULTS_PANEL_BLOCK",
descriptionTag:"RESULTS_PANEL_BLOCK_DESCRIPTION",languageBundle:"SearchDashboard",onePerContext:!0,config:{parameters:[{name:"blockTitle",type:"dashboard/core/parameters/StringParameter",config:{value:"i18n!{T:SharedLabels:SEARCH_RESULTS:Search Results}"}}]}},SearchDesignPanel:{displayName:"Search Design Panel",type:"component/searchresults/dashboard/blocks/SearchParameterPanelBlock",category:"Search",displayNameTag:"DESIGN_PANEL_BLOCK",descriptionTag:"DESIGN_PANEL_BLOCK_DESCRIPTION",languageBundle:"SearchDashboard",
onePerContext:!0,config:{parameters:[{name:"blockTitle",type:"dashboard/core/parameters/StringParameter",config:{value:"i18n!{T:SharedLabels:SEARCH_DESIGN_PANEL:Search Design Panel}"}}]}},AssetBrowserSidePanel:{displayName:"Asset Browser Side Panel",type:"component/searchresults/dashboard/blocks/SearchAssetBrowserSidePanel",category:"Search",displayNameTag:"ASSETBROWSER_SIDEPANEL_BLOCK",descriptionTag:"ASSETBROWSER_SIDEPANEL_BLOCK_DESCRIPTION",languageBundle:"SearchDashboard",onePerContext:!0,config:{parameters:[{name:"blockTitle",
type:"dashboard/core/parameters/StringParameter",config:{value:"i18n!{T:SharedLabels:ASSETBROWSER_SIDEPANEL:Asset Browser Side Panel}"}}]}},AssetBrowserImagePanel:{displayName:"Asset Browser Image Panel",type:"component/searchresults/dashboard/blocks/SearchAssetBrowserImagePanel",category:"Search",displayNameTag:"ASSETBROWSER_IMAGE_BLOCK",descriptionTag:"ASSETBROWSER_IMAGE_BLOCK_DESCRIPTION",languageBundle:"SearchDashboard",onePerContext:!0,config:{parameters:[{name:"blockTitle",type:"dashboard/core/parameters/StringParameter",
config:{value:"i18n!{T:SharedLabels:ASSETBROWSER_IMAGE_PANEL:Asset Browser Image Panel}"}}]}},Cart:{displayName:"Cart",type:"component/searchresults/dashboard/blocks/SearchCartBlock",category:"Search",displayNameTag:"CART_BLOCK",descriptionTag:"CART_BLOCK_DESCRIPTION",languageBundle:"SearchDashboard",onePerContext:!0,config:{parameters:[{name:"blockTitle",type:"dashboard/core/parameters/StringParameter",config:{value:"i18n!{T:SharedLabels:CART_BLOCK:Cart}"}}]}},FacetList:{displayName:"Facet List",
type:"component/searchresults/dashboard/blocks/FacetListBlock",category:"Search",displayNameTag:"FACET_LIST",descriptionTag:"FACET_LIST_DESCRIPTION",languageBundle:"SearchDashboard",config:{parameters:[{name:"blockShowInEditMode",type:"dashboard/core/parameters/BooleanParameter",config:{value:!0}}]}},FacetGraph:{displayName:"Facet Graph",type:"component/searchresults/dashboard/blocks/FacetGraphBlock",category:"Search",displayNameTag:"FACET_GRAPH",descriptionTag:"FACET_GRAPH_DESCRIPTION",languageBundle:"SearchDashboard",
config:{parameters:[{name:"blockShowInEditMode",type:"dashboard/core/parameters/BooleanParameter",config:{value:!0}}]}},FacetCounterBar:{displayName:"Facet Counter Bar",type:"component/searchresults/dashboard/blocks/FacetCounterBarBlock",category:"Search",displayNameTag:"FACET_COUNTER_BAR",descriptionTag:"FACET_COUNTER_BAR_DESCRIPTION",languageBundle:"SearchDashboard",config:{parameters:[{name:"blockShowInEditMode",type:"dashboard/core/parameters/BooleanParameter",config:{value:!0}}]}},SavedSearchCounter:{displayName:"Counter",
displayNameTag:"COUNTER_BLOCK",descriptionTag:"COUNTER_DESCRIPTION",languageBundle:"SavedSearchCounterBlock",type:"component/searchresults/dashboard/blocks/SavedSearchCounterBlock",category:"General",config:{parameters:[{name:"color",type:"dashboard/core/parameters/StringParameter",config:{value:"#4cae4c"}},{name:"runSearchOnClick",type:"dashboard/core/parameters/BooleanParameter",config:{value:!0}},{name:"blockShowInEditMode",type:"dashboard/core/parameters/BooleanParameter",config:{value:!0}},{name:"blockTitle",
type:"dashboard/core/parameters/StringParameter",config:{value:"i18n!{T:SharedLabels:SEARCH_COUNTER:Counter}"}}]}},SavedSearchImageSpinner:{displayName:"Image Spinner",displayNameTag:"IMAGE_SPINNER",descriptionTag:"IMAGE_SPINNER_DESCRIPTION",languageBundle:"SavedSearchImageSpinnerBlock",type:"component/searchresults/dashboard/blocks/SavedSearchImageSpinnerBlock",category:"General",config:{parameters:[{name:"blockShowInEditMode",type:"dashboard/core/parameters/BooleanParameter",config:{value:!0}},
{name:"blockTitle",type:"dashboard/core/parameters/StringParameter",config:{value:"i18n!{T:SharedLabels:IMAGE_SPINNER:Image Spinner}"}}]}},DiscussionBlock:{displayName:"Discussions",displayNameTag:"DISCUSSION_BLOCK",descriptionTag:"DISCUSSION_BLOCK_DESCRIPTION",languageBundle:"DiscussionBlock",type:"component/dashboard/blocks/DiscussionBlock",category:"General",config:{parameters:[{name:"blockShowInEditMode",type:"dashboard/core/parameters/BooleanParameter",config:{value:!0}},{name:"showProjectDiscussions",
config:{value:!0},type:"dashboard/core/parameters/BooleanParameter"},{name:"showDocumentDiscussions",config:{value:!0},type:"dashboard/core/parameters/BooleanParameter"},{name:"showTaskDiscussions",config:{value:!0},type:"dashboard/core/parameters/BooleanParameter"},{name:"height",config:{value:"75%"},type:"dashboard/core/parameters/CssSizeParameter"},{name:"blockTitle",type:"dashboard/core/parameters/StringParameter",config:{value:"i18n!{T:SharedLabels:DISCUSSIONS:Discussions}"}}]}},MyTodoListBlock:{displayName:"My Todo List",
displayNameTag:"MY_TODO_LIST_BLOCK",descriptionTag:window.gCurrentUser.hasTaskMngmtLicense?"MY_TODO_LIST_BLOCK_DESCRIPTION":"MY_TODO_LIST_BLOCK_DESCRIPTION_NO_TASK_LIC",languageBundle:"MyTodoListBlock",type:"component/dashboard/blocks/MyTodoListBlock",category:"My Work",config:{parameters:[{name:"blockShowInEditMode",type:"dashboard/core/parameters/BooleanParameter",config:{value:!0}},{name:"showTasks",config:{value:!0},type:"dashboard/core/parameters/BooleanParameter"},{name:"showApprovals",config:{value:!0},
type:"dashboard/core/parameters/BooleanParameter"},{name:"timeBasedCategories",config:{value:!0},type:"dashboard/core/parameters/BooleanParameter"},{name:"blockTitle",type:"dashboard/core/parameters/StringParameter",config:{value:"i18n!{T:SharedLabels:MY_TODO_LIST:My Todo List}"}}]}}});
define("component/searchresults/dashboard/SearchResultsDashboard","dashboard/core/Context dashboard/core/parameters/Parameter ./SearchContextParameter component/dashboard/i18n/WebCenterLanguageProvider component/dashboard/DashboardUserPreferencesCache dashboard/core/BlockDefinition ./configuration/BlockDefinitionsJSON utils/LocalStorageUtil component/errorhandler/ErrorHandler utils/webi18n!Dashboard underscore jquery lib/PromisePolyfill".split(" "),function(c,d,b,a,e,f,g,i,h,k,l,j){i=function(f,i,
k,q,r){var s=this;this._element=j("<div>");var u=f.data.dashboardContextID?"S_"+f.data.dashboardContextID:"",t={};r&&(t.builder={calculateDimensions:r});this._context=new c(u,t);this._context.setLanguageProvider(new a);this._userPreferenceCache=new e(window.webcenterConfig,new h,e.type.SEARCH,f.data.dashboardContextID);this._context.setPreferenceProvider({load:function(a){return Promise.resolve().then(function(){if(s._context.getID())return s._userPreferenceCache.getPreferences(a)})},save:function(a,
b){return Promise.resolve().then(function(){s._context.getID()&&b&&s._userPreferenceCache.savePreferences(a,b)})}});this._context.toggleEditMode(k);setTimeout(l.bind(function(){this._context.getLanguageBundle("Dashboard").then(function(a){this._dashboard||this._element.text(a.t("LOADING_BLOCK"))}.bind(this))},this),500);this._element[0].__CONTEXT=this._context;this._searchContextParameter=new b("searchContext",this._context);this._searchContextParameter.setSearchData(f.data);this._searchContextParameter.setSearchSetup(f.setup);
f.getResultsTable&&this._searchContextParameter.setSearchResultsTableGenerator(f.getResultsTable);f.getDesignPanel&&this._searchContextParameter.setSearchDesignPanelGenerator(f.getDesignPanel);f.getCart&&this._searchContextParameter.setCartGenerator(f.getCart);f.fieldLayoutAPI&&this._searchContextParameter.setFieldLayoutAPI(f.fieldLayoutAPI);f.getAttributeCategoryControl&&this._searchContextParameter.setAttributeCategoryControlGenerator(f.getAttributeCategoryControl);f.editfactory&&this._searchContextParameter.setEditFactory(f.editfactory);
this._context.setParameter(this._searchContextParameter.getName(),this._searchContextParameter);q&&(f=new d("WCR_SMARTNAME_CONTEXT",null,"dashboard/core/parameters/Parameter"),f.setValue(q),this._context.setParameter(f.getName(),f));this._dashboardPromise=this._context.registerAndLoadBlock(i).then(function(a){this._dashboard=this._element[0].__DASHBOARD=a;this._element.html("");this._addMissingSearchBlocks();if(k){var b=this.initUndoRedo().addClass("add-spacing-right");this._element.append(j("<div>",
{"class":"clearfix add-spacing-bottom dshUndoRedo"}).append(b))}a.getElement().addClass("dshSearchDashboard");this._element.append(a.getElement());return a}.bind(this));this.setBlockDefinitions(g)};i.prototype.setInDOM=function(a){this._dashboardPromise.then(function(b){b.setInDOM(a)})};i.prototype.getElement=function(){return this._element};i.prototype._addMissingSearchBlocks=function(){var a=this._searchContextParameter.getSearchSetup(),b=a.hasDesignPanel(),c=a.hasAssetBrowser(),d=a.getLayoutOptions().getOption("chkbox_ShowCart"),
e=b||c||a.hasSearchButton();if(e||d){var f=this;this._dashboard.whenFullyLoaded().then(function(){var b=[];e&&b.push("SearchDesignPanel");if(c){var h="LeftAndImagePanel";f._context.isEditModeActive()&&(h=a.getLayoutOptions().getOption("SelectImageAreaStyle"));("LeftAndImagePanel"===h||"LeftPanelOnly"===h)&&b.push("AssetBrowserSidePanel");("LeftAndImagePanel"===h||"ImagePanelOnly"===h)&&b.push("AssetBrowserImagePanel")}d&&b.push("Cart");var i={};Promise.all(l.map(b,function(a){var b=g[a];return f._context.getAttachedBlocksByType(b.type).then(function(c){0===
c.length&&(i[a]=f._context.registerBlock(b))})})).then(function(){var a=[];l.each(["SearchDesignPanel","AssetBrowserImagePanel","Cart"],function(b){i[b]&&a.push(i[b])});return f._dashboard.prependBlocks(a).then(function(){if(i.AssetBrowserSidePanel){var a=f._context.loadBlock(f._context.registerBlock(g.ListLayout)),b=f._context.loadBlock(f._context.registerBlock(g.AssetBrowserColumnLayout));return Promise.all([a,b,f._dashboard.getLayout()]).then(function(a){var b=a[0],c=a[1],a=a[2],d=a.getItemList(),
e=[];c.replaceColumnWithBlock(0,i.AssetBrowserSidePanel);c.replaceColumnWithBlock(1,b.getID());e.push(a.prependBlock(c.getID()));e.push(b.setItemList(d));return Promise.all(e)})}})})})}};i.prototype.hasBlocksOfType=function(a){var b=this;return Promise.all(l.map(a,function(a){return b._context.getAttachedBlocksByType(g[a].type).then(function(a){return 0<a.length})})).then(function(b){return l.object(a,b)})};i.prototype.setBlockDefinitions=function(a){var b=this._context,c=this;b.getBlockDefinitionDataSource().then(function(d){var e=
[];"DOCUMENTS"!==c._searchContextParameter.getSearchData().informationtype&&(e=["AssetBrowserImagePanel","AssetBrowserSidePanel","Cart"]);e.push("AssetBrowserColumnLayout");var g=l.filter(a,function(a,b){return!l.contains(e,b)});Promise.all(l.map(g,function(a){return b.getLanguageBundle(a.languageBundle).then(function(b){a.displayNameTag&&(a.displayName=b.tFallback(a.displayNameTag,a.displayName));var c=new f("",a.type,a);c.setDescription(b.tFallback(a.descriptionTag,a.description));return c})})).then(function(a){d.setBlockDefinitions(a)})})};
i.prototype.initUndoRedo=function(){var a=this._context.getUndoRedoController(),b=j("<div>",{"class":"btn-group pull-right"}),c=!1,d=j("<a>",{"class":"btn btn-default",title:k.t("UNDO")}).append(j("<i>",{"class":"icon icon-WCR_Actions-Undo12"})).click(function(){c=!0;f();Promise.resolve(a.undo()).then(function(){c=!1;f()})}),e=j("<a>",{"class":"btn btn-default",title:k.t("REDO")}).append(j("<i>",{"class":"icon icon-WCR_Actions-Redo12"})).click(function(){c=!0;f();Promise.resolve(a.redo()).then(function(){c=
!1;f()})}),f=l.debounce(function(){d.toggleClass("disabled",c||0>=a.undoCount());d.attr("title",k.t("UNDO")+" "+(a.peekUndo()?a.peekUndo().getDescription():""));e.toggleClass("disabled",c||0>=a.redoCount());e.attr("title",k.t("REDO")+" "+(a.peekRedo()?a.peekRedo().getDescription():""))},10);a.on("changed",f);f();b.append(d).append(e);return b};i.prototype._getDashboardVersion=function(){return Promise.resolve(j.get("dashboardversion.jsp")).then(function(a){return JSON.parse(a).number}).catch(function(){return this._context.getLanguageBundle("Dashboard").then(function(a){return Promise.reject(a.t("NOT_LOGGED_IN"))})}.bind(this))};
i.prototype.getConfiguration=function(){return this.whenFullyLoaded().then(function(a){return Promise.all([Promise.resolve(a.getConfiguration(!0)),this._getDashboardVersion()])}.bind(this)).then(function(a){var b=a[0];b.version=a[1];return b})};i.prototype.whenFullyLoaded=function(){return this._dashboardPromise.then(function(a){return a.whenFullyLoaded()})};i.prototype.getInstancedFieldConfigurationClone=function(){return this._searchContextParameter.getInstancedFieldConfiguration().getDataClone()};
i.prototype.getInstanceIds=function(){return this._context.getAttachedBlocks().then(function(a){var b=[];l.each(a,function(a){l.each(a.getParameterListByType("searchresults/dashboard/parameters/SearchIFCParameter"),function(a){a.getInstanceId&&(a=a.getInstanceId())&&b.push(a)})});return b})};i.prototype.setLoadingData=function(a){this._searchContextParameter.setLoadingData(a)};i.prototype.isModified=function(){return this._context.isModified()};return i});
define("component/searchresults/internal/functionality/SearchBrowserHistoryManager",["underscore"],function(c){var d=function(b){this._enabled=!!window.history;this._searchid="search"+b};d.prototype._getBaseSearchBrowserHistoryState=function(){return this._enabled&&window.history.state?(window.history.state.search||(window.history.state.search=[]),window.history.state):{search:{}}};d.prototype.getRestoreData=function(){var b=this._getBaseSearchBrowserHistoryState();if(c.has(b.search,this._searchid))return b.search[this._searchid]};
d.prototype.storeState=function(b){var a=this._getBaseSearchBrowserHistoryState();a.search[this._searchid]=b;history.replaceState(a,"")};return d});define("component/searchresults/internal/common",function(){});