/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2010, Ajax.org B.V.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

define("component/smartnames/encoding/smartnamestringpart",["require","exports","module"],function(g,h){var b=function(){};(function(){this.isSmartNamePart=function(){return null!==this._smartName};this.isTextPart=function(){return null!==this._text};this.getAsSmartName=function(){return this._smartName};this.getAsText=function(){return this._text}}).call(b.prototype);h.makeSmartNamePart=function(f){if(null==f)throw'A "SmartName" part of a SmartName string can not be null.';var a=new b;a._smartName=
f;a._text=null;return a};h.makePlainTextPart=function(f){if(null==f)throw'A "Text" part of a SmartName string can not be null.';var a=new b;a._smartName=null;a._text=f;return a}});
define("component/smartnames/encoding/smartnameargumentencoding",["utils/wcrerror","utils/extendedstring"],function(g){var h={},b=function(b,a){this._delimeterChar=b;this._escapeChar=a};(function(){this.encodeSmartName=function(b,a){for(var c=b,d=0;d<a.length;d++)var j=a[d].replaceAll(this._escapeChar,this._escapeChar+this._escapeChar).replaceAll(this._delimeterChar,this._escapeChar+this._delimeterChar),c=c+this._delimeterChar,c=c+j;return c.toString()};this.decodeSmartNameArguments=function(b){for(var a=
[],c=!1,d="",j=0;j<b.length;j++){var e=b.charAt(j);if(e===this._escapeChar)c&&(d+=this._escapeChar),c=!c;else if(e===this._delimeterChar)c?(d+=this._delimeterChar,c=!1):(a.push(d),d="");else{if(c)throw new g("SMARTNAME_ARGUMENT_PARSING_ILLEGAL_ESCAPE_CHARACTER","Parsing of arguments of SmartName failed. Found a single escape character in the string.");d+=e}}a.push(d);if(c)throw new g("SMARTNAME_ARGUMENT_PARSING_ILLEGAL_ESCAPE_CHARACTER","Parsing of arguments of SmartName failed. Found a single escape character in the string.");
return a}}).call(b.prototype);h.DEFAULT=new b(":","\\");h.constructor=b;return h});
define("component/smartnames/encoding/smartname",["../encoding/smartnameargumentencoding"],function(g){var h=function(){if(1===arguments.length){var b=g.DEFAULT.decodeSmartNameArguments(arguments[0]);this._name=b[0];this._arguments=1<b.length?b.slice(1,b.length):[]}else if(1<arguments.length)this._name=arguments[0],2==arguments.length&&arguments[1].constructor==Array?this._arguments=arguments[1]:(this._arguments=Array.prototype.slice.call(arguments),this._arguments=this._arguments.slice(1,this._arguments.length));
else if(1>arguments.length)throw Error("A SmartName requires at least one 'name' parameter.");};(function(){this.getName=function(){return this._name};this.getArguments=function(){return this._arguments};this.getFullName=function(){return g.DEFAULT.encodeSmartName(this._name,this._arguments)};this.equals=function(b){if(b instanceof h){var f=b.getName()===this.getName(),b=this._compareArguments(b);return f&&b}return!1};this._compareArguments=function(b){if(this._arguments.length===b.getArguments().length){for(var f=
0;f<this._arguments.length;f++)if(this._arguments[f]!==b.getArguments()[f])return!1;return!0}return!1}}).call(h.prototype);return h});
define("component/smartnames/encoding/smartnameencoding",["./smartnamestringpart","./smartname","utils/wcrerror","underscore","utils/extendedstring"],function(g,h,b,f){function a(a){if(!1===a)throw Error("Something is wrong in the implementation of the SmartNameEncoding. Assert failed.");}var c={},d=function(j,e,i,b,d){this._startOfSmartName=j;this._endOfSmartName=e;this._escapeChar=i;if(this._fuzzyEncoding=b)this._smartnameLookupFunction=d;this._charactersToEscape=[];b=i+j+e;for(d=0;d<b.length;d++){var c=
b.charAt(d);f.contains(this._charactersToEscape,c)||this._charactersToEscape.push(c)}this._charactersToEscape=[i,j.charAt(0),e.charAt(0)];a(-1===j.indexOf(i));a(-1===e.indexOf(i))};(function(){this.escapeString=function(a){return this._fuzzyEncoding?a:this._escapeStringInternal(a)};this._escapeStringInternal=function(a){for(var e=0;e<this._charactersToEscape.length;e++)a=a.replaceAll(""+this._charactersToEscape[e],""+this._escapeChar+this._charactersToEscape[e]);return a};this.unescapeString=function(a){return this._fuzzyEncoding?
a:this._unescapeStringInternal(a)};this._unescapeStringInternal=function(a){for(var e=this._charactersToEscape.length-1;0<=e;e--)a=a.replaceAll(""+this._escapeChar+this._charactersToEscape[e],""+this._charactersToEscape[e]);return a};this.encodeSmartNameString=function(a){for(var e="",i="",b=0;b<a.length;b++){var d=a[b];d.isTextPart()?i+=d.getAsText():(e+=this.escapeString(i),i="",e+=this._startOfSmartName,e+=this._escapeStringInternal(d.getAsSmartName().getFullName()),e+=this._endOfSmartName)}return e+=
this.escapeString(i)};this.encodeSmartNameStringSingleSmartName=function(a){return this._startOfSmartName+this._escapeStringInternal(a.getFullName())+this._endOfSmartName};this.encodeSmartNameSingleSmartName=function(a){return this._escapeStringInternal(a.getFullName())};this._revertDecodedOpenSmartName=function(a,e){var i="";0<e.length&&e[e.length-1].isTextPart()&&(i+=e.pop().getAsText());return i+a};this.decodeSmartNameString=function(a){for(var e=[],i=-1,d="",c=0;c<a.length;c++){var l=a.charAt(c);
if(l===this._escapeChar)if(this._fuzzyEncoding&&-1===i)d+=l;else if(c+1<a.length){var k=a.charAt(c+1);if(f.contains(this._charactersToEscape,k))d+=k,c++;else if(this._fuzzyEncoding)d=this._revertDecodedOpenSmartName(a.substring(i,c),e),d+=l,i=-1;else throw new b("SMARTNAME_PARSING_ILLEGAL_ESCAPE_CHARACTER","Parsing of string with SmartNames failed. Found a single escape character in the string.");}else if(this._fuzzyEncoding)d=this._revertDecodedOpenSmartName(a.substring(i,c),e),d+=l,i=-1;else throw new b("SMARTNAME_PARSING_ILLEGAL_ESCAPE_CHARACTER",
"Parsing of string with SmartNames failed. Found a single escape character in the string.");else if(c+this._startOfSmartName.length<=a.length&&this._startOfSmartName===a.substring(c,c+this._startOfSmartName.length)){this._fuzzyEncoding&&0<=i&&(d=this._revertDecodedOpenSmartName(a.substring(i,c),e),i=-1);if(0<=i)throw new b("SMARTNAME_PARSING_SMARTNAME_ALREADY_OPEN","Parsing of string with SmartNames failed. SmartName started within a SmartName.");0<d.length&&e.push(g.makePlainTextPart(d));d="";i=
c;c+=this._startOfSmartName.length-1}else if(c+this._endOfSmartName.length<=a.length&&this._endOfSmartName===a.substring(c,c+this._endOfSmartName.length)){if(-1===i)if(this._fuzzyEncoding){d+=l;continue}else throw new b("SMARTNAME_PARSING_SMARTNAME_NOT_OPEN","Parsing of string with SmartNames failed. SmartName was closed before the SmartName was opened.");else{k=null;try{k=new h(d)}catch(m){if(this._fuzzyEncoding){d=this._revertDecodedOpenSmartName(a.substring(i,c),e);d+=l;i=-1;continue}else throw m;
}if(this._fuzzyEncoding&&!this._smartnameLookupFunction(k)){d=this._revertDecodedOpenSmartName(a.substring(i,c),e);d+=l;i=-1;continue}e.push(g.makeSmartNamePart(k));d="";i=-1}c+=this._endOfSmartName.length-1}else d+=l}this._fuzzyEncoding&&0<=i&&(d=this._revertDecodedOpenSmartName(a.substring(i),e),i=-1);if(0<=i)throw new b("SMARTNAME_PARSING_SMARTNAME_NEVER_CLOSED","Parsing of string with SmartNames failed. SmartName was never closed.");0<d.length&&e.push(g.makePlainTextPart(d));return e};this.containsSmartName=
function(a){if(a)for(var a=this.decodeSmartNameString(a),e=0;e<a.length;e++)if(a[e].isSmartNamePart())return!0;return!1};this.modifySmartNameEncodedString=function(a,e,i){if(void 0===e||null===e)e=function(e){return e};if(void 0===i||null===i)i=function(e){return e};for(var a=this.decodeSmartNameString(a),d=0;d<a.length;d++){var b=a[d];b.isSmartNamePart()?(b=b.getAsSmartName(),b=i(b),a[d]=g.makeSmartNamePart(b)):(b=b.getAsText(),b=e(b),a[d]=g.makePlainTextPart(b))}return this.encodeSmartNameString(a)}}).call(d.prototype);
c.SAVEDSEARCH=new d("{","}","!",!1);c.AUTONAMING=new d("[","]","\u00a7",!1);c.WORKFLOWEDITOR=new d("<","/>","\u00a7",!0,function(a){a.getName();return!0});c.UNIVERSALCOPYPASTEENCODING=new d("[","]","\\",!1);c.constructor=d;return c});define("utils/webcss-text!component/smartnames/input/smartnameeditpanel-style.css",[],function(){return".w .SmartNameEditPopover {\r\n\tz-index: 351; \r\n\tborder: 1px solid #ccc;\r\n\tbackground-color: rgba(250,250,250,1);\r\n}\r\n.w .SmartNameParamConfig {\r\n\twidth: 485px;\r\n\tmargin: 8px;\r\n}\r\n.w .SmartNameParamConfig .form-compact .form-group label {\r\n\ttext-align: right;\r\n}\r\n.w .SmartNameParamConfig .ToolbarWrapper {\r\n\twidth: 100%;\r\n\tmargin-top: -8px;\r\n}\r\n.w .SmartNameParamConfig .ToolbarWrapper > .AddRemoveButtonWrapper {\r\n\tfloat: left;\r\n\ttext-align: left;\r\n}\r\n.w .SmartNameParamConfig .ToolbarWrapper > .AddRemoveButtonWrapper > button {\r\n\tmargin-right: 3px;\r\n}\r\n.w .SmartNameParamConfig .ToolbarWrapper > .SaveCancelButtonWrapper {\r\n\tfloat: right;\r\n\ttext-align: right;\r\n}\r\n.w .SmartNameParamConfig .ToolbarWrapper > .SaveCancelButtonWrapper > button {\r\n\tmargin-left: 3px;\r\n}"});
define("component/smartnames/input/smartnameeditpanel-view",["require","jquery","utils/webi18n!SmartNameSelector","utils/webcss!./smartnameeditpanel-style.css"],function(g,h,b){var f=function(a,c,d){this._parameterSmartFields=[];this._labels=d&&d.labels?d.labels:[];this._hasStrictParams=d&&!0==d.hasStrictParams?!0:!1;d.smartnameInputOptions.dictionaryService&&(this._dictionaryService=d.smartnameInputOptions.dictionaryService);d.smartnameInputOptions.encoding&&(this._encoding=d.smartnameInputOptions.encoding);
d.smartnameInputOptions.displayFunction&&(this._displayFunction=d.smartnameInputOptions.displayFunction);d.smartnameInputOptions.selectorDisplayFunction&&(this._selectorDisplayFunction=d.smartnameInputOptions.selectorDisplayFunction);this._onSave=[];this._onCancel=[];this._wrapper=h("<div>",{"class":"SmartNameParamConfig"});this._paramForm=h("<div>",{"class":"parameter-panel form-horizontal form-compact notOnlyOffsetLabels"});if(0<c.length||0<this._labels.length){for(a=0;a<c.length;a++)this.addParameter(c[a],
this._labels[a]);if(0<this._labels.length-c.length)for(a=c.length;a<this._labels.length;a++)this.addParameter("",this._labels[a])}else this.addParameter("");c=h("<div>",{"class":"AddRemoveButtonWrapper"});a=h("<i>",{"class":"icon icon-WCR_Plus"});this._addParameterButton=h("<button>",{"class":"btn btn-default btn-xs"}).append(a);this._addParameterButton.on("click",function(){this.addParameter("")}.bind(this));a=h("<i>",{"class":"icon icon-WCR_Minus"});this._removeParameterButton=h("<button>",{"class":"btn btn-default btn-xs"}).append(a);
this._removeParameterButton.on("click",function(){this.removeLastParameter()}.bind(this));a=h("<div>",{"class":"SaveCancelButtonWrapper"});this._saveButton=h("<button>",{"class":"btn btn-primary btn-xs"}).text(b.t("SMARTNAME_EDIT_SAVE"));this._saveButton.on("click",function(){this.doSave()}.bind(this));this._cancelButton=h("<button>",{"class":"btn btn-default btn-xs"}).append(b.t("SMARTNAME_EDIT_CANCEL"));this._cancelButton.on("click",function(){this.doCancel()}.bind(this));var f=h("<div>",{"class":"ToolbarWrapper clearfix"});
c.append(this._addParameterButton);c.append(this._removeParameterButton);a.append(this._cancelButton);a.append(this._saveButton);this._hasStrictParams||f.append(c);f.append(a);this._wrapper.append(this._paramForm);this._wrapper.append(f);d.smartnameInputOptions.readOnly?this.disable():this.enable()};f.prototype.addParameter=function(a){var c=this._parameterSmartFields.length,d=h("<div>",{"class":"form-group"}),f="Param "+(c+1);c<this._labels.length&&(this._labels[c]&&0<this._labels[c].length)&&(f=
b.t(this._labels[c]));c=h("<label>",{"class":"col-sm-12 col-lg-4"}).text(f);d.append(c);c=new (g("component/smartnames/smartfield/smartfield"))(h("<input>",{type:"text"}),!1,this._dictionaryService,this._displayFunction,this._selectorDisplayFunction,this._encoding);c.setWidth("100%");f=h("<div>",{"class":"col-sm-12 col-lg-8"}).append(c.getJQElement());d.append(f);c.setIsInline(!0);c.setValue(a);this._parameterSmartFields.push(c);this._paramForm.append(d)};f.prototype.removeLastParameter=function(){0!==
this._parameterSmartFields.length&&(this._parameterSmartFields.splice(-1,1),this._paramForm.children().last().remove())};f.prototype.getArguments=function(){for(var a=[],b=0;b<this._parameterSmartFields.length;b++){var d=this._parameterSmartFields[b].getValue();void 0!==d&&a.push(d)}return a};f.prototype.onSave=function(a){this._onSave.push(a)};f.prototype.onCancel=function(a){this._onCancel.push(a)};f.prototype.doSave=function(){for(var a=0;a<this._onSave.length;a++)this._onSave[a]()};f.prototype.doCancel=
function(){for(var a=0;a<this._onCancel.length;a++)this._onCancel[a]()};f.prototype.getJQElement=function(){return this._wrapper};f.prototype.disable=function(){this._saveButton.hide();for(var a=0;a<this._parameterSmartFields.length;a++)this._parameterSmartFields[a].disable()};f.prototype.enable=function(){this._saveButton.show();for(var a=0;a<this._parameterSmartFields.length;a++)this._parameterSmartFields[a].enable()};f.prototype.destroy=function(){for(var a=0;a<this._parameterSmartFields.length;a++)this._parameterSmartFields[a].destroy()};
f.prototype.resize=function(){for(var a=0;a<this._parameterSmartFields.length;a++)this._parameterSmartFields[a].resize()};return f});
define("component/smartnames/input/smartnameeditpanel",["jquery","./smartnameeditpanel-view","component/smartnames/encoding/smartname"],function(g,h,b){g=function(b,a){this._name=b.getName();this._arguments=b.getArguments();this._view=new h(this._name,this._arguments,a)};g.prototype.getName=function(){return this._name};g.prototype.getArguments=function(){return this._view.getArguments()};g.prototype.getSmartName=function(){return new b(this.getName(),this.getArguments())};g.prototype.onSave=function(b){this._view.onSave(b)};
g.prototype.onCancel=function(b){this._view.onCancel(b)};g.prototype.getJQElement=function(){return this._view.getJQElement()};g.prototype.disable=function(){this._view.disable()};g.prototype.enable=function(){this._view.enable()};g.prototype.resize=function(){this._view.resize()};g.prototype.destroy=function(){this._view.destroy()};return g});
define("services/languageService",["jquery","utils/AttributeEventBus","utils/LanguageUtils"],function(g){var h=function(){this._cachedLanguages={};this._langsAreBeingRetrieved={};this._onLangsRetrieved={};this._allLangsAreBeingRetrieved=!1;this._onAllLangsRetrieved=[]};h.prototype.getProjectLanguages=function(b,f,a){this._cachedLanguages[b]?this._returnCachedLanguagesFor(b,f,!0,a):(this._onLangsRetrieved[b]||(this._onLangsRetrieved[b]=[]),this._onLangsRetrieved[b].push(_.bind(function(){this._returnCachedLanguagesFor(b,
f,!0,a)},this)),this._getLanguages(b))};h.prototype.getAllLanguages=function(b,f,a){this._cachedLanguages.all?this._returnCachedLanguagesFor(b,f,!1,a):(this._onLangsRetrieved[b]||(this._onLangsRetrieved[b]=[]),this._onLangsRetrieved[b].push(_.bind(function(){this._returnCachedLanguagesFor(b,f,!1,a)},this)),this._getLanguages(b))};h.prototype.getBothAllLanguages=function(b){if(this._cachedLanguages.all){var f;f=g.extend(!0,f,this._cachedLanguages.all);b(f.master,f.translations)}else this._onAllLangsRetrieved.push(_.bind(function(){var a;
a=g.extend(!0,a,this._cachedLanguages.all);b(a.master,a.translations)},this)),this._getAllLanguages()};h.prototype._returnCachedLanguagesFor=function(b,f,a,c){if(a){var d;d=g.extend(!0,d,this._cachedLanguages[b]);f?c(d.master):c(d.translations)}else{var j;j=g.extend(!0,j,this._cachedLanguages.all);f?c(j.master):c(j.translations)}};h.prototype.getLanguages=function(b,f,a){if(this._cachedLanguages.all&&this._cachedLanguages[b]){var c;c=g.extend(!0,c,this._cachedLanguages.all);var d;d=g.extend(!0,d,
this._cachedLanguages[b]);f(d.master,d.translations,c.master,c.translations)}else this._onLangsRetrieved[b]||(this._onLangsRetrieved[b]=[]),this._onLangsRetrieved[b].push(_.bind(function(){var a;a=g.extend(!0,a,this._cachedLanguages.all);var e;e=g.extend(!0,e,this._cachedLanguages[b]);f(e.master,e.translations,a.master,a.translations)},this)),this._getLanguages(b,a)};h.prototype._getLanguages=function(b,f){if(void 0===this._langsAreBeingRetrieved[b]||!1===this._langsAreBeingRetrieved[b]){this._langsAreBeingRetrieved[b]=
!0;var a=window.webcenterConfig.jspBaseUrl+"GetProjectLanguageAttr.jsp?json=1";b&&(a+="&projectid="+b);f&&(a+="&languages="+f);g.getJSON(a,_.bind(function(a){this._cachedLanguages.all={};this._cachedLanguages.all.master=this._parseLangs(a.languages.complete_source_language.language);this._cachedLanguages.all.translations=this._parseLangs(a.languages.complete_translation_language.language);this._cachedLanguages[b]={};this._cachedLanguages[b].master=a.languages.selected_source_language?this._parseLangs(a.languages.selected_source_language.language):
[];this._cachedLanguages[b].translations=a.languages.selected_translation_language?this._parseLangs(a.languages.selected_translation_language.language):[];if(a=this._onLangsRetrieved[b])for(var d=0;d<a.length;d++)a[d]();this._langsAreBeingRetrieved[b]=!1},this)).fail(function(){})}};h.prototype._getAllLanguages=function(){!1===this._allLangsAreBeingRetrieved&&(this._allLangsAreBeingRetrieved=!0,g.getJSON(window.webcenterConfig.jspBaseUrl+"GetProjectLanguageAttr.jsp?json=1",_.bind(function(b){this._cachedLanguages.all=
{};this._cachedLanguages.all.master=this._parseLangs(b.languages.complete_source_language.language);this._cachedLanguages.all.translations=this._parseLangs(b.languages.complete_translation_language.language);for(b=0;b<this._onAllLangsRetrieved.length;b++)this._onAllLangsRetrieved[b]();this._allLangsAreBeingRetrieved=!1},this)).fail(function(){}))};h.prototype._parseLangs=function(b){var f=[];if(b instanceof Array)for(var a=0;a<b.length;a++){var c={};c.langCode=b[a].language_code;c.langDesc=b[a].descriptor;
c.langFlag=b[a].flag_file_name;c.langIndex=b[a].language_index;f.push(c)}else b instanceof Object&&(c={},c.langCode=b.language_code,c.langDesc=b.descriptor,c.langFlag=b.flag_file_name,c.langIndex=b.language_index,f.push(c));return f};return new h});
define("packaging-content-management/text-content-services/tableElementTypeService",["jquery"],function(g){var h=function(){this._cachedTableElementTypes=void 0;this._tableElementTypesAreBeingRetrieved=!1;this._onTableElementTypesRetrieved=[]};h.prototype.getReadableElementType=function(b,f){b&&(this._cachedTableElementTypes?this._cachedTableElementTypes[b]?f(this._cachedTableElementTypes[b]):f(b):this.getTableElementTypes(function(a){(a=a[b])?f(a):f(b)}))};h.prototype.getTableElementTypes=function(b){this._cachedTableElementTypes?
b(this._cachedTableElementTypes):(this._onTableElementTypesRetrieved.push(b),this._tableElementTypesAreBeingRetrieved||(this._tableElementTypesAreBeingRetrieved=!0,g.ajax({url:window.webcenterConfig.jspBaseUrl+"GetRowsFromList.jsp?listType=WCR_DB_List&indexed=1",type:"GET",dataType:"text",data:{outputType:"JSON",list:"TABLE_ELEMENT_TYPES",maxrows:200,maxcolrows:200},success:function(f){this._cachedTableElementTypes={};try{var a;try{a=jsonParse(f)}catch(c){a=eval("("+f+")")}if(!a.success||"0"==a.success)b("Cannot get values "+
a.error.code+" : "+a.error.message);else{for(var d=[],j=-1,e=[],i=-1,p=[],q=-1,f=0;f<a.columns.length;f++)"STRUCT_ELEMENT_TYPES"==a.columns[f].name?(d=a.columns[f].values,j=f):"STRUCT_HUMAN_READABLE_FORM"==a.columns[f].name?(e=a.columns[f].values,i=f):"STRUCT_ELEMENT_CATEGORY"==a.columns[f].name&&(p=a.columns[f].values,q=f);g.each(a.combinations,function(a,b){var c={},f=b.split("~");this._cachedTableElementTypes[d[f[j]].trim()]=c;0<=i&&(c.tableElementHumanReadable=e[f[i]].trim());0<=q&&(c.tableElementCat=
p[f[q]].trim())}.bind(this))}}catch(l){alert(l)}for(f=0;f<this._onTableElementTypesRetrieved.length;f++)this._onTableElementTypesRetrieved[f](this._cachedTableElementTypes)}.bind(this)})))};h.prototype.getTableElementTypesPromise=function(){return new Promise(function(b){return this.getTableElementTypes(b)}.bind(this))};return new h});
define("component/smartnames/input/content-smartnameeditpanel-view","require ./smartnameeditpanel-view services/languageService utils/LanguageUtils packaging-content-management/text-content-services/tableElementTypeService jquery utils/webi18n!SmartNameSelector utils/webcss!./smartnameeditpanel-style.css".split(" "),function(g,h,b,f,a,c,d){var j=function(e,a,b){h.call(this,e,a,b)};j.prototype=Object.create(h.prototype);j.prototype.constructor=j;j.prototype.addParameter=function(e,i){var j=this._parameterSmartFields.length,
q=c("<div>",{"class":"form-group"}),l="Param "+(j+1);j<this._labels.length&&(this._labels[j]&&0<this._labels[j].length)&&(l=d.t(this._labels[j]));j=c("<label>",{"class":"col-sm-12 col-lg-4"}).text(l);q.append(j);var k=c("<input>",{type:"text"});if("CONTENT_LANGUAGE"==i||"TABLE_ELEMENT_TYPE"==i||"CONTENT_TEXT_FORMAT"==i)k=c("<select/>");var m=new (g("component/smartnames/smartfield/smartfield"))(k,!1,this._dictionaryService,this._displayFunction,this._selectorDisplayFunction,this._encoding);m.setWidth("99%");
j=c("<div>",{"class":"col-sm-12 col-lg-8"}).append(m.getJQElement());q.append(j);m.setIsInline(!0);"CONTENT_LANGUAGE"==i?b.getBothAllLanguages(_.bind(function(a,b){var i=f.mergeBothLanguagesTogether(a,b);_.each(i.values(),function(e){k.append(c("<option/>").val(e.langCode).text(e.langDesc))},this);m.setValue(e)},this)):"TABLE_ELEMENT_TYPE"==i?a.getTableElementTypes(_.bind(function(a){_.each(a,function(e,a){k.append(c("<option/>").val(a).text(e.tableElementHumanReadable))},this);m.setValue(e)},this)):
"TABLE_ELEMENT_INSTANCE"==i?(""===e.trim()&&(e="1"),m.setValue(e)):"CONTENT_TEXT_FORMAT"==i&&(k.append(c("<option/>").val("richtext").text(d.t("CONTENT_TEXTTYPE_RICH"))),k.append(c("<option/>").val("simpletext").text(d.t("CONTENT_TEXTTYPE_SIMPLE"))),m.setValue(e));this._parameterSmartFields.push(m);this._paramForm.append(q)};return j});
define("component/smartnames/input/content-smartnameeditpanel",["jquery","./smartnameeditpanel","./content-smartnameeditpanel-view","component/smartnames/encoding/smartname"],function(g,h,b){g=function(f,a){this._name=f.getName();this._arguments=f.getArguments();this._view=new b(this._name,this._arguments,a)};g.prototype=Object.create(h.prototype);return g.prototype.constructor=g});
define("lib/ace-modifications/mod-ace-autocomplete",["ace/autocomplete","ace/autocomplete/util"],function(g,h){h.retrievePrecedingIdentifier=function(b,f,a,c){if(c)return a=b.lastIndexOf("[",f),-1===a?"":b.substring(a,f);a=/[a-zA-Z_0-9$.[]/;c=[];for(f-=1;0<=f;f--)if(a.test(b[f]))c.push(b[f]);else break;return c.reverse().join("")};h.getCompletionPrefix=function(b){var f=b.getCursorPosition(),a=b.session.getLine(f.row);return this.retrievePrecedingIdentifier(a,f.column,void 0,b.session.isSmartNamesEnabled())};
(function(){this.insertMatch=function(b){b||(b=this.popup.getData(this.popup.getRow()));if(!b&&(b=this.popup.getData(0),!b))return!1;if(b.completer&&b.completer.insertMatch)b.completer.insertMatch(this.editor,b);else{if(this.completions.filterText)for(var f=this.editor.selection.getAllRanges(),a=0,c;c=f[a];a++)c.start.column-=this.completions.filterText.length,this.editor.session.remove(c);b.snippet?snippetManager.insertSnippet(this.editor,b.snippet):b.smartname?this.editor.insertSmartName(b.smartname):
this.editor.execCommand("insertstring",b.value||b)}this.detach()};delete this.commands.Space}).call(g.Autocomplete.prototype)});define("lib/ace-modifications/smartnamesupport/smartnameinfo",[],function(){var g=function(g){this._name=g};(function(){this.getFullName=function(){return this._name}}).call(g.prototype);return g});
define("lib/ace-modifications/smartnamesupport/mod-ace-anchor",["ace/anchor"],function(g){(function(){var g=this.onChange;this.onChange=function(b){b&&(b.action&&("insert"===b.action||"remove"===b.action))&&g.call(this,b)}}).call(g.Anchor.prototype)});
define("lib/ace-modifications/smartnamesupport/smartnameanchor",["ace/anchor","ace/lib/oop","./mod-ace-anchor"],function(g,h){var b=g.Anchor,f=function(a,c,d,f){this._info=f;this._isvalidanchor=!0;b.call(this,a,c,d)};h.inherits(f,g.Anchor);(function(){this.getSmartNameInfo=function(){return this._info};this.setSmartNameInfo=function(a){this._info=a};this.applyDeltas=function(a){if("remove"===a.action&&a.start.column<=this.column&&a.end.column>this.column)return this._isvalidanchor=!1;b.prototype.onChange.call(this,
a);return!0};this.isValid=function(){return this._isvalidanchor};this.onChange=function(){}}).call(f.prototype);return f});
define("lib/ace-modifications/smartnamesupport/smartnameanchorcontrol",["./smartnameanchor","./smartnameinfo","ace/range"],function(g,h,b){function f(e){void 0===e.smartnameanchors&&(e.smartnameanchors=[]);return e.smartnameanchors}var a=b.Range,c={},d=new h("?");d.unresolved=!0;var j=function(e,a,b){for(var e=f(e),d=0;d<e.length;d++){var c=e[d],j=c.getPosition();if(j.row===a&&j.column===b)return c}return null};c.getSmartNameInfoAt=function(e,a,b){e=j(e,a,b);return null!==e?e.getSmartNameInfo():d};
c.setSmartNameInfoAt=function(e,b,d,c){var j=new g(e,b,d,c);f(e).push(j);j=new a(b,d,b,d+1);e._signal("change",{action:"addSmartName",start:j.start,end:j.end,smartname:{row:b,column:d,info:c}})};c.applyDelta=function(e,b){for(var d=f(e),c=[],j=0;j<d.length;j++){var k=d[j];k.applyDeltas(b)||(c.push(k),d.splice(j,1),j--)}for(j=0;j<c.length;j++){var k=c[j],d=k.row,m=k.column,k=k._info,s=new a(d,m,d,m+1);e._signal("change",{start:s.start,end:s.end,action:"removeSmartName",smartname:{row:d,column:m,info:k}})}};
c.renameSmartName=function(e,b,d,c){var f=j(e.doc,b,d);if(null!=f){var k=f.getSmartNameInfo(),m=new h(c);if(c===k.getFullName())return!1;f.setSmartNameInfo(m);c=new a(b,d,b,d+1);e.doc._signal("change",{start:c.start,end:c.end,action:"renameSmartName",smartname:{row:b,column:d,oldinfo:k,newinfo:m}});return!0}return!1};c.setActiveSmartName=function(e,b,d){c.clearActiveSmartName(e);var f=j(e,b,d);null!=f&&(b=new a(b,d,b,d+1),e.activeAnchor=f,e._signal("change",{start:b.start,end:b.end,action:"changeActiveSmartName",
ignore:!0}))};c.clearActiveSmartName=function(e){if(e.activeAnchor&&e.activeAnchor.isValid()){var b=e.activeAnchor.getPosition(),b=new a(b.row,b.column,b.row,b.column+1);e.activeAnchor=null;e._signal("change",{start:b.start,end:b.end,action:"changeActiveSmartName",ignore:!0})}};c.getActiveSmartNamePosition=function(e){return e.activeAnchor&&e.activeAnchor.isValid()?e.activeAnchor.getPosition():null};c.provideSmartNameAPI=function(e,b,d){var f=e.getSession(),g=j(f.doc,b,d);return null===g?null:{isValid:function(){return g.isValid()},
setActive:function(e){g.isValid()&&(e?(e=g.getPosition(),c.setActiveSmartName(f.doc,e.row,e.column)):c.clearActiveSmartName(f.doc))},isActive:function(){return g.isValid()&&g===f.doc.activeAnchor},getSmartName:function(){return g.getSmartNameInfo().getFullName()},setSmartName:function(e){if(g.isValid()){var a=g.getPosition();c.renameSmartName(f,a.row,a.column,e)}},getSmartNameBoundingClientRect:function(b){if(g.isValid()){var d=g.getPosition(),c=(new a(d.row,d.column,d.row,d.column+1)).toScreenRange(f),
i=e.renderer;i.$textLayer.checkForSizeChanges();var d=i.scroller.getBoundingClientRect(),j=c.start.column*i.characterWidth+i.$padding+d.left-i.scrollLeft,h=c.end.column*i.characterWidth+i.$padding+d.left-i.scrollLeft,p=c.start.row*i.lineHeight+d.top-i.scrollTop,c=(c.end.row+1)*i.lineHeight+d.top-i.scrollTop;b&&(j<d.left&&(j=d.left),j>d.right&&(j=d.right),h<d.left&&(h=d.left),h>d.right&&(h=d.right),p<d.top&&(p=d.top),p>d.bottom&&(p=d.bottom),c<d.top&&(c=d.top),c>d.bottom&&(c=d.bottom));return{left:j,
top:p,width:h-j,height:c-p}}return null}}};c.undoRedo=function(e,d,b){var f=d.action;("addSmartName"===f||"removeSmartName"===f)&&b!==("addSmartName"===f)&&c.setSmartNameInfoAt(e,d.smartname.row,d.smartname.column,d.smartname.info);if("renameSmartName"===f){var f=b?d.smartname.oldinfo:d.smartname.newinfo,g=j(e,d.smartname.row,d.smartname.column);null!=g&&(g.setSmartNameInfo(f),f=new a(d.smartname.row,d.smartname.column,d.smartname.row,d.smartname.column+1),e._signal("change",{start:f.start,end:f.end,
action:"renameSmartName",smartname:{row:d.smartname.row,column:d.smartname.column,oldinfo:b?d.smartname.newinfo:d.smartname.oldinfo,newinfo:b?d.smartname.oldinfo:d.smartname.newinfo}}))}};return c});
define("lib/ace-modifications/smartnamesupport/smartnameextensionutils",["component/smartnames/encoding/smartname","component/smartnames/encoding/smartnamestringpart","component/smartnames/encoding/smartnameencoding","./smartnameinfo","./smartnameanchorcontrol"],function(g,h,b,f,a){var c={SMARTNAMECHAR:"\u0010",getSmartNameDisplayString:function(a,b){if(void 0!==a.displayFunction){var e=new g(b.getFullName());return a.displayFunction(e)}return"["+b.getFullName()+"]"},parseText:function(a,j,e){if(a.isSmartNamesEnabled()){for(var i=
{text:"",smartnames:[]},j=j.replaceAll("\n","").replaceAll("\r",""),a=(!0===e?b.UNIVERSALCOPYPASTEENCODING:a.getSmartNameEncoding()).decodeSmartNameString(j),j=0;j<a.length;j++)e=a[j],e.isTextPart()?i.text+=e.getAsText():(i.smartnames.push({index:i.text.length,info:new f(e.getAsSmartName().getFullName())}),i.text+=c.SMARTNAMECHAR);return i}return{text:j,smartnames:[]}},tryParseText:function(a,b,e){if(a.isSmartNamesEnabled())try{return c.parseText(a,b,e)}catch(f){return{text:b.replaceAll("\n","").replaceAll("\r",
"").replaceAll(""+c.SMARTNAMECHAR,"?"),smartnames:[]}}else return{text:b,smartnames:[]}},recompileText:function(d,f,e,i,p){if(d.isSmartNamesEnabled()){for(var q=[],l=0;l<i.length;l++)if(i.charAt(l)===c.SMARTNAMECHAR){var k=a.getSmartNameInfoAt(f,0,e+l);q.push(h.makeSmartNamePart(new g(k.getFullName())))}else q.push(h.makePlainTextPart(""+i.charAt(l)));return(!0===p?b.UNIVERSALCOPYPASTEENCODING:d.getSmartNameEncoding()).encodeSmartNameString(q)}return i},addSmartNameAnchors:function(d,b,e){for(var c=
0;c<e.length;c++)a.setSmartNameInfoAt(d,0,e[c].index+b.start.column,e[c].info)},startSmartNameChangeGroup:function(a){void 0==a.smartnamechangeready&&(a.smartnamechangeready=0);a.smartnamechangeready++},stopSmartNameChangeGroup:function(a,b){a.smartnamechangeready--;a._signal("change",{action:"changeAfterSmartNames",start:b.start,end:b.end})},isInSmartNameChangeReady:function(a){return void 0==a.smartnamechangeready?!0:0===a.smartnamechangeready},getSmartNameEditAPI:function(b,f,e){return b.getSession().isSmartNamesEnabled()&&
b.getSession().getLine(f).charAt(e)===c.SMARTNAMECHAR?a.provideSmartNameAPI(b,f,e):null}};return c});
define("lib/ace-modifications/smartnamesupport/smartnametooltip","require exports module ace/lib/oop ace/lib/event ace/tooltip ./smartnameextensionutils ./smartnameanchorcontrol".split(" "),function(g,h){function b(e){e.smartnameTooltip||(c.call(this,e.container),e.smartnameTooltip=this,this.editor=e,this.update=this.update.bind(this),this.onMouseMove=this.onMouseMove.bind(this),this.onMouseOut=this.onMouseOut.bind(this),a.addListener(e.renderer.scroller,"mousemove",this.onMouseMove),a.addListener(e.renderer.content,
"mouseout",this.onMouseOut),a.addListener(e,"change",function(a){var e=a.data;"undefined"===typeof e&&(e=a);"changeActiveSmartName"===e.action&&this.lastHoverSmartName&&this.update()}.bind(this)))}var f=g("ace/lib/oop"),a=g("ace/lib/event"),c=g("ace/tooltip").Tooltip,d=g("./smartnameextensionutils"),j=g("./smartnameanchorcontrol");f.inherits(b,c);(function(){this.update=function(){this.$timer=null;var a=this.editor.renderer;if(1E3<this.lastT-(a.timeStamp||0))a.rect=null,a.timeStamp=this.lastT,this.maxHeight=
window.innerHeight,this.maxWidth=window.innerWidth;var b=a.rect||(a.rect=a.scroller.getBoundingClientRect()),c=Math.floor((this.y+a.scrollTop-b.top)/a.lineHeight),a=Math.round((this.x+a.scrollLeft-b.left-a.$padding)/a.characterWidth),f=this.editor.session,g=f.screenToDocumentPosition(c,a),a=c=!1;f.getLine(g.row).charAt(g.column)===d.SMARTNAMECHAR?(b=j.getSmartNameInfoAt(f.getDocument(),g.row,g.column),f=j.getActiveSmartNamePosition(f.getDocument()),f=null!==f&&f.row===g.row&&f.column===g.column,b===
this.lastHoverSmartName&&f===this.lastSmartNameActive?(c=!1,a=this.isOpen):(g=$(this.getElement()),g.empty(),this.lastHoverSmartName=b,this.lastSmartNameActive=f,this.editor.smartnameTooltipFunction&&(c=a=this.editor.smartnameTooltipFunction(b.getFullName(),f,g)))):(this.lastHoverSmartName=null,c=a=!1);a?(c&&(this.width=this.getWidth(),this.height=this.getHeight()),this.show(null,this.x,this.y)):this.hide()};this.onMouseMove=function(a){this.x=a.clientX;this.y=a.clientY;this.isOpen&&(this.lastT=a.timeStamp,
this.setPosition(this.x,this.y));this.$timer||(this.$timer=setTimeout(this.update,100))};this.onMouseOut=function(a){if(!a||!a.currentTarget.contains(a.relatedTarget))this.hide(),this.$timer=clearTimeout(this.$timer),this.lastHoverSmartName=null};this.setPosition=function(a,b){a+10+this.width>this.maxWidth&&(a=window.innerWidth-this.width-10);if(b>0.75*window.innerHeight||b+20+this.height>this.maxHeight)b=b-this.height-30;c.prototype.setPosition.call(this,a+10,b+20)};this.destroy=function(){this.onMouseOut();
a.removeListener(this.editor.renderer.scroller,"mousemove",this.onMouseMove);a.removeListener(this.editor.renderer.content,"mouseout",this.onMouseOut);delete this.editor.smartnameTooltip}}).call(b.prototype);h.SmartNameTooltip=b});
define("lib/ace-modifications/smartnamesupport/mod-ace-editor","ace/editor ace/range ./smartnameinfo ./smartnameextensionutils ./smartnametooltip utils/extendedstring".split(" "),function(g,h,b,f,a){var c=h.Range,d=a.SmartNameTooltip;(function(){this.insertSmartName=function(a){f.startSmartNameChangeGroup(this.getSession().getDocument());this.insert(f.SMARTNAMECHAR);var d=this.getCursorPosition().column-1,j=new c(0,d,0,d+1);f.addSmartNameAnchors(this.getSession().getDocument(),j,[{index:0,info:new b(a)}]);
f.stopSmartNameChangeGroup(this.getSession().getDocument(),j);this._triggerSmartNameEditing({row:0,column:d})};this.getSmartNameEncodedValue=function(){return f.recompileText(this.getSession(),this.getSession().getDocument(),0,this.getValue())};this.isChangeReady=function(){return f.isInSmartNameChangeReady(this.getSession().getDocument())};this.setSmartNameEncodedValue=function(a){a=f.parseText(this.getSession(),a);f.startSmartNameChangeGroup(this.getSession().getDocument());this.setValue(a.text);
var b=new c(0,0,0,a.text.length);f.addSmartNameAnchors(this.getSession().getDocument(),b,a.smartnames);f.stopSmartNameChangeGroup(this.getSession().getDocument(),b);this.navigateFileEnd()};this.configureSmartNameTooltip=function(a){this.smartnameTooltipFunction=a;new d(this)};this.initSmartNameEditListener=function(a){this.onEditSmartNameCallback=a;this.on("click",function(a){a=a.getDocumentPosition();this._triggerSmartNameEditing(a)}.bind(this))};this._triggerSmartNameEditing=function(a){if(this.onEditSmartNameCallback&&
(a=f.getSmartNameEditAPI(this,a.row,a.column),null!=a))this.onEditSmartNameCallback(a)};this.insertBase=this.insert;this.insert=function(a,b){this.getSession().isSmartNamesEnabled()&&(a=a.replaceAll("\r","").replaceAll("\n",""));this.insertBase(a,b)};var a=this.onPaste;this.onPaste=function(b){b=f.tryParseText(this.session,b,!0);f.startSmartNameChangeGroup(this.session.getDocument());a.call(this,b.text);var d=this.getCursorPosition().column-b.text.length,d=new c(0,d,0,d+b.text.length);f.addSmartNameAnchors(this.session.getDocument(),
d,b.smartnames);f.stopSmartNameChangeGroup(this.session.getDocument(),d)};this.getCopyText=function(){var a=this.getSelectionRange().start.column,b=this.getSelectedText(),b=f.recompileText(this.getSession(),this.getSession().getDocument(),a,b,!0);this._signal("copy",b);return b}}).call(g.Editor.prototype)});
define("lib/ace-modifications/smartnamesupport/mod-ace-edit_session",["ace/edit_session","ace/range","./smartnameanchorcontrol","./smartnameextensionutils"],function(g,h,b,f){(function(){var a=h.Range,c=f.SMARTNAMECHAR;this.isSmartNamesEnabled=function(){return void 0===this._smartNamesEnabled?!1:this._smartNamesEnabled};this.enableSmartNames=function(a){void 0!==a&&(this._smartNamesEnabled=!0,this.getDocument().enableSmartNames(),this._smartNameEncoding=a)};this.getSmartNameEncoding=function(){return this._smartNameEncoding};
this.$getStringScreenWidth=function(a,j,e){function i(a){if(9==a)e+=g.getScreenTabSize(e);else{var b;if(b=4352<=a)b=4352>a?!1:4352<=a&&4447>=a||4515<=a&&4519>=a||4602<=a&&4607>=a||9001<=a&&9002>=a||11904<=a&&11929>=a||11931<=a&&12019>=a||12032<=a&&12245>=a||12272<=a&&12283>=a||12288<=a&&12350>=a||12353<=a&&12438>=a||12441<=a&&12543>=a||12549<=a&&12589>=a||12593<=a&&12686>=a||12688<=a&&12730>=a||12736<=a&&12771>=a||12784<=a&&12830>=a||12832<=a&&12871>=a||12880<=a&&13054>=a||13056<=a&&19903>=a||19968<=
a&&42124>=a||42128<=a&&42182>=a||43360<=a&&43388>=a||44032<=a&&55203>=a||55216<=a&&55238>=a||55243<=a&&55291>=a||63744<=a&&64255>=a||65040<=a&&65049>=a||65072<=a&&65106>=a||65108<=a&&65126>=a||65128<=a&&65131>=a||65281<=a&&65376>=a||65504<=a&&65510>=a;e=b?e+2:e+1}}if(0==j)return[0,0];null==j&&(j=Infinity);var e=e||0,g=this,h,l;for(l=0;l<a.length;l++){h=a.charCodeAt(l);if(h==c.charCodeAt(0)&&this.isSmartNamesEnabled()){h=b.getSmartNameInfoAt(this.getDocument(),0,l);h=f.getSmartNameDisplayString(this.getDocument(),
h);for(var k=0;k<h.length;k++){var m=h.charCodeAt(k);i(m)}}else i(h);if(e>j)break}return[e,l]};this.getWordRangeBase=this.getWordRange;this.getWordRange=function(b,f){return this.getLine(b).charAt(f)==c&&this.isSmartNamesEnabled()?new a(b,f,b,f+1):this.getWordRangeBase(b,f)};this.moveText=function(b,c,e){var i=this.getTextRange(b),i=f.recompileText(this,this.getDocument(),b.start.column,i,!0),g=this.getFoldsInRange(b),c=a.fromPoints(c,c);if(!e){this.remove(b);var h=b.start.row-b.end.row,l=h?-b.end.column:
b.start.column-b.end.column;l&&(c.start.row==b.end.row&&c.start.column>b.end.column&&(c.start.column+=l),c.end.row==b.end.row&&c.end.column>b.end.column&&(c.end.column+=l));h&&c.start.row>=b.end.row&&(c.start.row+=h,c.end.row+=h)}e=f.parseText(this,i,!0);f.startSmartNameChangeGroup(this.getDocument());i=e.text;c.end=this.insert(c.start,i);i=new a(0,c.start.column,0,c.start.column+e.text.length);f.addSmartNameAnchors(this.getDocument(),i,e.smartnames);f.stopSmartNameChangeGroup(this.getDocument(),
i);if(g.length){var k=b.start,b=c.start,h=b.row-k.row,l=b.column-k.column;this.addFolds(g.map(function(a){a=a.clone();a.start.row==k.row&&(a.start.column+=l);a.end.row==k.row&&(a.end.column+=l);a.start.row+=h;a.end.row+=h;return a}))}return c}}).call(g.EditSession.prototype)});
define("lib/ace-modifications/smartnamesupport/mod-ace-document",["ace/document","ace/range","ace/apply_delta","./smartnameanchorcontrol","./smartnameextensionutils"],function(g,h,b,f,a){var c=h.Range,d=f.undoRedo,j=f.applyDelta;(function(){this.isSmartNamesEnabled=function(){return void 0===this._smartNamesEnabled?!1:this._smartNamesEnabled};this.enableSmartNames=function(){this._smartNamesEnabled=!0};this.applyDelta=function(e,f){var g="insert"==e.action,h="remove"==e.action;if(!(g?1>=e.lines.length&&
!e.lines[0]:!c.comparePoints(e.start,e.end)))g&&2E4<e.lines.length&&this.$splitAndapplyLargeDelta(e,2E4),!g&&!h?d(this,e,"undefined"!==typeof e.undo&&e.undo):(this.isSmartNamesEnabled()?(a.startSmartNameChangeGroup(this),b.applyDelta(this.$lines,e,f),j(this,{action:e.action,start:e.start,end:e.end}),a.stopSmartNameChangeGroup(this,{start:e.start,end:e.end})):b.applyDelta(this.$lines,e,f),this._signal("change",e))};this.revertDelta=function(a){var b=a.action;"insert"===a.action?b="remove":"remove"===
a.action&&(b="insert");var c={start:this.clonePos(a.start),end:this.clonePos(a.end),action:b,undo:!0};"undefined"!==typeof a.smartname&&(c.smartname=a.smartname);if("insert"===b||"remove"==b)c.lines=a.lines.slice();this.applyDelta(c)}}).call(g.Document.prototype)});
define("lib/ace-modifications/smartnamesupport/mod-ace-layer-text",["ace/layer/text","ace/lib/lang","./smartnameanchorcontrol","./smartnameextensionutils"],function(g,h,b,f){(function(){this.$renderToken=function(a,c,d,g){var e=this,i=/\x10|\t|&|<|( +)|([\x00-\x1f\x80-\xa0\xad\u1680\u180E\u2000-\u200f\u2028\u2029\u202F\u205F\u3000\uFEFF])|[\u1100-\u115F\u11A3-\u11A7\u11FA-\u11FF\u2329-\u232A\u2E80-\u2E99\u2E9B-\u2EF3\u2F00-\u2FD5\u2FF0-\u2FFB\u3000-\u303E\u3041-\u3096\u3099-\u30FF\u3105-\u312D\u3131-\u318E\u3190-\u31BA\u31C0-\u31E3\u31F0-\u321E\u3220-\u3247\u3250-\u32FE\u3300-\u4DBF\u4E00-\uA48C\uA490-\uA4C6\uA960-\uA97C\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFAFF\uFE10-\uFE19\uFE30-\uFE52\uFE54-\uFE66\uFE68-\uFE6B\uFF01-\uFF60\uFFE0-\uFFE6]/g,
p=function(a,b,d,f){if(b)return e.showInvisibles?"<span class='ace_invisible ace_invisible_space'>"+h.stringRepeat(e.SPACE_CHAR,a.length)+"</span>":h.stringRepeat("\u00a0",a.length);if("&"==a)return"&#38;";if("<"==a)return"&#60;";if("\t"==a)return a=e.session.getScreenTabSize(c+f),c+=a-1,e.$tabStrings[a];if("\u3000"==a)return a=e.showInvisibles?"ace_cjk ace_invisible ace_invisible_space":"ace_cjk",b=e.showInvisibles?e.SPACE_CHAR:"",c+=1,"<span class='"+a+"' style='width:"+2*e.config.characterWidth+
"px'>"+b+"</span>";if(d)return"<span class='ace_invisible ace_invisible_space ace_invalid'>"+e.SPACE_CHAR+"</span>";c+=1;return"<span class='ace_cjk' style='width:"+2*e.config.characterWidth+"px'>"+a+"</span>"},q=g.replace(i,function(a,d,g,h,j){return a==f.SMARTNAMECHAR&&e.session.isSmartNamesEnabled()?(d=e.session.screenToDocumentPosition(0,c+h),a=b.getSmartNameInfoAt(e.session.getDocument(),d.row,d.column),g=b.getActiveSmartNamePosition(e.session.getDocument()),d=null!=g&&d.row===g.row&&d.column===
g.column,a=f.getSmartNameDisplayString(e.session.getDocument(),a),c+=a.length-1,a=a.replace(i,p),"<span class='ace_smartname"+(d?" ace_smartname_active":"")+"'>"+a+"</span>"):p(a,d,g,h,j)});if(this.$textToken[d.type])a.push(q);else{var l="ace_"+d.type.replace(/\./g," ace_"),k="";"fold"==d.type&&(k=" style='width:"+d.value.length*this.config.characterWidth+"px;' ");a.push("<span class='",l,"'",k,">",q,"</span>")}return c+g.length}}).call(g.Text.prototype)});
define("lib/ace-modifications/smartnamesupport/mod-ace-mouse-dragdrop_handler",["ace/config","ace/lib/event","ace/range","./smartnameanchorcontrol","./smartnameextensionutils"],function(g,h,b,f,a){var c=b.Range;g.on("editor",function(b){var f=b.container,e;h.addListener(f,"dragstart",function(c){if(!this.cancelDrag&&f.draggable){var g=b.session.selection.getRange().start.column,c=c.dataTransfer;c.clearData();var h=b.session.getTextRange(),h=a.recompileText(b.session,b.session.getDocument(),g,h,!0);
c.setData("Text",h);e=!0}}.bind(this));h.addListener(f,"dragend",function(){e=!1}.bind(this));h.addListener(f,"drop",function(){if(!e){var f=b.getSelectedText(),g=a.tryParseText(b.session,f,!0);g.text!==f&&(a.startSmartNameChangeGroup(b.session.getDocument()),f=b.getSelectionRange(),f.isEmpty()||b.session.remove(f),b.session.insert(f.start,g.text),f=new c(0,f.start.column,0,f.start.column+g.text.length),a.addSmartNameAnchors(b.session.getDocument(),f,g.smartnames),a.stopSmartNameChangeGroup(b.session.getDocument(),
f))}}.bind(this))})});
define("lib/ace-modifications/smartnamesupport/mod-ace-undomanager",["ace/undomanager"],function(g){(function(){function g(a){return{action:a.action,start:a.start,end:a.end,lines:1==a.lines.length?null:a.lines,text:1==a.lines.length?a.lines[0]:null,smartname:a.smartname}}function b(a){return{action:a.action,start:a.start,end:a.end,lines:a.lines||[a.text],smartname:a.smartname}}function f(a,b){for(var d=Array(a.length),f=0;f<a.length;f++){for(var e=a[f],g={group:e.group,deltas:Array(e.length)},h=0;h<
e.deltas.length;h++)g.deltas[h]=b(e.deltas[h]);d[f]=g}return d}this.$serializeDeltas=function(a){return f(a,g)};this.$deserializeDeltas=function(a){return f(a,b)}}).call(g.UndoManager.prototype)});define("lib/ace-modifications/javascriptsupport/mod-ace-languagetools",["ace/ext/language_tools"],function(g){g.addCompleter=function(h){g.setCompleters([g.snippetCompleter,g.textCompleter,g.keyWordCompleter,h])}});
define("lib/ace-modifications/mod-ace-all","./mod-ace-autocomplete ./smartnamesupport/mod-ace-editor ./smartnamesupport/mod-ace-edit_session ./smartnamesupport/mod-ace-document ./smartnamesupport/mod-ace-layer-text ./smartnamesupport/mod-ace-mouse-dragdrop_handler ./smartnamesupport/mod-ace-undomanager ./smartnamesupport/mod-ace-anchor ./javascriptsupport/mod-ace-languagetools".split(" "),function(){});
define("component/smartnames/input/smartnameinput","component/smartnames/encoding/smartnameencoding component/smartnames/encoding/smartnamestringpart component/smartnames/encoding/smartname ./smartnameeditpanel ./content-smartnameeditpanel component/popover/Popover utils/webi18n!SmartNameSelector underscore jquery ace/ace ace/ext/language_tools lib/ace-modifications/mod-ace-all".split(" "),function(g,h,b,f,a,c,d,j,e,i){function p(a){var b="[",b="ProjAttr"==a.getName()?b+(a.getArguments()[0]+" ("+
d.t("PROJECT_LABEL")+")"):"DocAttr"==a.getName()?b+(a.getArguments()[0]+" ("+d.t("DOCUMENT_LABEL")+")"):b+d.t(a.getName());return b+"]"}var q="showSettingsMenu goToNextError goToPreviousError centerselection gotoline fold unfold toggleFoldWidget toggleParentFoldWidget foldall foldOther unfoldall findnext findprevious selectOrFindNext selectOrFindPrevious find togglerecording replaymacro jumptomatching selecttomatching expandToMatching removeline duplicateSelection sortlines togglecomment toggleBlockComment modifyNumberUp modifyNumberDown replace copylinesup movelinesup copylinesdown movelinesdown cut_or_delete removetolinestart removetolineend outdent indent blockoutdent blockindent splitline transposeletters touppercase tolowercase expandtoline".split(" "),
l=function(k,m){k=void 0===k?document.createElement("div"):e(k).get(0);void 0===m&&(m={});void 0===m.readOnly&&(m.readOnly=!1);void 0===m.encoding&&(m.encoding=g.SAVEDSEARCH);this._encoding=m.encoding;var l=m.editPanelBuilder;this._mark=(this._markaware=!1===m.markaware?!1:!0)&&(!0===m.mark?!0:!1);this._markid=void 0!==m.markid?m.markid:"@";this._marksn=this._encoding.encodeSmartNameString([h.makeSmartNamePart(new b(this._markid))]);var n=i.edit(k);n.setBehavioursEnabled(!1);this._editor=n;this._div=
e(k);this._formcontrol=this._div.wrap(e("<div/>")).parent();k.SmartNameInput=this;n.$blockScrolling=Infinity;var t=n.getValue();n.getSession().enableSmartNames(this._encoding);this.setValue(t);this._displayFunction=m.displayFunction||p;n.getSession().getDocument().displayFunction=this._displayFunction;n.setOptions({highlightActiveLine:!1,highlightSelectedWord:!1});this.readOnly=m.readOnly;this.disabled=!1;this.readOnly?(n.setReadOnly(!0),n.setTheme("component/smartnames/input/themes/smartnames-display")):
(this._formcontrol.addClass("form-control"),n.setTheme("component/smartnames/input/themes/smartnames-input"));n.getSession().gutterRenderer={getWidth:function(){return 0},getText:function(){return""}};n.renderer.setOptions({showLineNumbers:!1,maxLines:1,printMargin:0,printMarginColumn:0,showPrintMargin:!1,displayIndentGuides:!1,showGutter:!1});n.renderer.setPadding(10);this._formcontrol.css({"padding-left":"0px","padding-right":"0px"});n.commands.removeCommands(q);n.commands.addCommand({name:"myCommand",
bindKey:{win:"Ctrl-F",mac:"Command-F"},exec:function(){},readOnly:!0});this._isAdminUser=window.gCurrentUser.isAdmin;var r=j.bind(function(a){a?(this._smartNameEditPopoverDiv&&this._smartNameEditPopoverDiv.show(),this._smartNameEditPopover&&this._smartNameEditPopover.show(),e.each(this._onSmartNamePopoverShowListeners,function(a,b){b()}),a=function(){this._smartNameEditPopover.element.trigger("contentResized")}.bind(this),j.defer(a),a()):(this._destroySmartNameEditPanel(),e.each(this._onSmartNamePopoverHideListeners,
function(a,b){b()}))},this);this._recalculateSmartNameEditPopover=j.bind(function(a){a&&this._smartNameEditPopover&&(a=a.getSmartNameBoundingClientRect(!0),this._smartNameEditPopoverDiv||(this._smartNameEditPopoverDiv=e("<div />"),e("body").append(this._smartNameEditPopoverDiv)),this._smartNameEditPopoverDiv.css({position:"absolute",width:a.width,height:a.height,top:a.top+window.pageYOffset,left:a.left+window.pageXOffset}),this._smartNameEditPopover.setContext(this._smartNameEditPopoverDiv),this._smartNameEditPopover.element.trigger("contentResized"),
this._smartNameEditPopover.isActive()&&this._smartNameEditPopover.show())},this);this._lastAPI=null;this._isAdminUser&&n.initSmartNameEditListener(function(d){this._lastAPI&&this._smartNameEditPanel&&this._lastAPI.setSmartName(this._smartNameEditPanel.getSmartName().getFullName());var g=new b(d.getSmartName()),h={};if("List"==g.getName())h.labels=["SMARTNAME_LIST_NAME","SMARTNAME_LIST_RESULT_COLUMN","SMARTNAME_LIST_LOOKUP_COLUMN","SMARTNAME_LIST_LOOKUP_VALUE"],h.hasStrictParams=!0,h.smartnameInputOptions=
m,this._smartNameEditPanel=new f(g,h);else if("tcelemstatus"==g.getName())h.labels=["CONTENT_LANGUAGE"],h.hasStrictParams=!0,h.smartnameInputOptions=m,this._smartNameEditPanel=new a(g,h);else if("tctextvalue"==g.getName())h.labels=["CONTENT_LANGUAGE","CONTENT_TEXT_FORMAT"],h.hasStrictParams=!0,h.smartnameInputOptions=m,this._smartNameEditPanel=new a(g,h);else if("tctablevalue"==g.getName())h.labels=["CONTENT_LANGUAGE","TABLE_ELEMENT_TYPE","TABLE_ELEMENT_INSTANCE","CONTENT_TEXT_FORMAT"],h.hasStrictParams=
!0,h.smartnameInputOptions=m,this._smartNameEditPanel=new a(g,h);else if(l)if(g=l(g))this._smartNameEditPanel=g;else{r(!1);return}else{r(!1);return}this.isDisabled()?this._smartNameEditPanel.disable():this._smartNameEditPanel.enable();this._smartNameEditPopover||(this._smartNameRestrict=e("<div>",{css:{visibility:"hidden",top:0,left:0,right:0,bottom:0,position:"fixed"}}).appendTo("body"),this._smartNameEditPopover=new c(this.getJQElement(),e("body"),this._smartNameRestrict,"bottom","#FAFAFA","SmartNameEditPopover",
void 0,void 0,void 0,"#CCC"),this._smartNameEditPopover.getElement().css("z-index",Math.max(351,this.getJQElement().zIndex()+1)));this._smartNameEditPopover.setContent(this._smartNameEditPanel.getJQElement());this._smartNameEditPanel.onSave(function(){var a=this._smartNameEditPanel.getSmartName();d.setSmartName(a.getFullName());r(!1);d.setActive(!1);this.focus()}.bind(this));this._smartNameEditPanel.onCancel(function(){r(!1);d.setActive(!1);this.focus()}.bind(this));d.setActive(!0);this._recalculateSmartNameEditPopover(d);
r(!0);this._lastAPI=d}.bind(this));this._editor.configureSmartNameTooltip(function(a,c,e){return"List"==(new b(a)).getName()&&!c?(e.text(d.t("SMARTNAME_LIST_TOOLTIP")),!0):!1});this.onValueChange(j.bind(function(){this._lastAPI&&!this._lastAPI.isValid()&&(r(!1),this._lastAPI.setActive(!1),this._lastAPI=null)},this));void 0!==m.insertCommandCallback&&n.commands.addCommand({name:"openSmartNameSelector",bindKey:{win:"Ctrl-I",mac:"Command-I"},exec:function(){m.insertCommandCallback()},readOnly:!0})};
(function(){this._addMark=function(a){this._mark&&(!this._encoding.containsSmartName(a)&&0<a.length)&&(a=this._marksn+a);return a};this._removeMark=function(a){if(this._markaware&&a.length>=this._marksn.length){for(var a=this._encoding.decodeSmartNameString(a),b=0;b<a.length;b++){var c=a[b];c.isSmartNamePart()&&c.getAsSmartName().getName()===this._markid&&(a.splice(b,1),b--)}a=this._encoding.encodeSmartNameString(a)}return a};this.getValue=function(){return this._addMark(this._editor.getSmartNameEncodedValue())};
this.setValue=function(a){try{this._encoding.decodeSmartNameString(a)}catch(b){window.console.error("Error: Illegal value used in setValue on SmartField. Falling back to text..."),a=this._encoding.escapeString(a)}this._editor.setSmartNameEncodedValue(this._removeMark(a))};this.clear=function(){this._editor.setValue("")};this.onFocus=function(a){this._editor.on("focus",function(){try{a()}catch(b){console.error("An error was thrown in a focus listener: "+b)}})};this.onBlur=function(a){this._editor.on("blur",
function(){try{a()}catch(b){console.error("An error was thrown in a blur listener: "+b)}})};this.onValueChange=function(a){var b=this;this._editor.on("change",function(){try{b._editor.isChangeReady()&&a(b.getValue())}catch(c){console.error("An error was thrown in a change listener: "+c)}})};this._onSmartNamePopoverShowListeners=[];this.onSmartNamePopoverShow=function(a){this._onSmartNamePopoverShowListeners.push(a)};this._onSmartNamePopoverHideListeners=[];this.onSmartNamePopoverHide=function(a){this._onSmartNamePopoverHideListeners.push(a)};
this.setSmartNames=function(a){var b=a.map(j.bind(function(a){var b=this._displayFunction(a);return{caption:b,value:b,score:1,meta:"",smartname:a.getFullName()}},this));this._editor.setOptions({enableLiveAutocompletion:[{getCompletions:function(a,c,d,e,f){f(null,b)}}]});this._editor.resize(!0)};this.insertText=function(a){this._editor.insert(a);this._editor.renderer.scrollCursorIntoView()};this.insertSmartName=function(a){this._editor.insertSmartName(a);this._editor.renderer.scrollCursorIntoView()};
this.show=function(){this._formcontrol.show()};this.hide=function(){this._formcontrol.hide()};this.focus=function(){this._editor.focus()};this.blur=function(){this._editor.blur()};this.resize=function(){this._editor.resize();this._recalculateSmartNameEditPopover(this._lastAPI);this._smartNameEditPanel&&this._smartNameEditPanel.resize()};this.isDisabled=function(){return this.disabled};this.disable=function(){this.disabled||(this.disabled=!0,this._editor.setReadOnly(!0),this._div.addClass("ace_smartinput_disabled"),
this._smartNameEditPanel&&this._smartNameEditPanel.disable())};this.enable=function(){this.disabled&&(this.disabled=!1,this._editor.setReadOnly(!1),this._div.removeClass("ace_smartinput_disabled"),this._smartNameEditPanel&&this._smartNameEditPanel.enable())};this._destroySmartNameEditPanel=function(){this._smartNameEditPopover&&(this._smartNameEditPopoverDiv.remove(),this._smartNameEditPopoverDiv=null,this._smartNameEditPopover.destroy(),this._smartNameRestrict.detach(),this._smartNameEditPopover=
this._smartNameRestrict=null);this._smartNameEditPanel&&(this._smartNameEditPanel.destroy(),this._smartNameEditPanel=null)};this.destroy=function(){var a=this.getValue();this._destroySmartNameEditPanel();this.stopEditing();this._editor.destroy();this.getJQElement().text(a).removeClass("ace_editor").removeClass("ace-smartnamefield-display").removeClass("ace-smartnamefield-input");try{delete this._div.get(0).SmartNameInput}catch(b){}};this.stopEditing=function(){this._editor.completer&&this._editor.completer.getPopup()&&
this._editor.completer.getPopup().hide()};this.getJQElement=function(){return this._formcontrol}}).call(l.prototype);l.wcrinit=function(a){new l(a)};l.wcrdestroy=function(a){a.SmartNameInput.destroy()};return l});