/**
		 * The core for user creation popups. 
		 * Responsible for success/cancel handlers and for license check.
		 * You can add a footer and content.
		 */

/**
		 * Check if license is present to create a regular user
		 */

// check if license is available to create a regular user

// enable the create user button if license is available

/**
		 * returns if there is a license
		 */

define("component/usercreation/UserCreationAndInviteMemberErrorUtil",["jquery","underscore","utils/webi18n!UserCreationStrings"],function(a,e,f){e=function(){this._errorMessageDiv=a("<div>",{"class":"error-message"});this._ssoErrorMessageDiv=a("<div>",{"class":"sso-error-message"});this._warningMessageDiv=a("<div>",{"class":"warning-message"});this.errorSection=a("<div>",{"class":"form-section"});this.errorSection.append(this._errorMessageDiv,this._ssoErrorMessageDiv,this._warningMessageDiv)};e.prototype.showErrorMessage=
function(a,d){if(a){var b=!d?f.t(a):a,b=this._getAlertMessage(b,"alert-danger",!0);this._errorMessageDiv.append(b)}};e.prototype.showWarningMessage=function(a,d){if(a){var b=this._getAlertMessage(f.t(a),d||"alert-danger",!1);this._warningMessageDiv.append(b)}};e.prototype._getAlertMessage=function(e,d,b){e=a("<div>",{"class":"alert "+d}).append(a("<p>").text(e));b&&(e.addClass("alert-dismissible"),e.prepend(a("<button>",{"class":"close","data-dismiss":"alert","aria-label":"Close"}).append(a("<i>").addClass("icon icon-small icon-WCR_Close12"))));
return e};e.prototype.addSSOErrorSection=function(e){this._ssoErrorMessageDiv.append(a("<div>",{id:"sso-config-user-error-"+e,name:"sso-config-user-error-"+e}))};e.prototype.clearSSOErrorSections=function(){this._ssoErrorMessageDiv.children().empty()};e.prototype.clearErrorMessage=function(){this._errorMessageDiv.empty()};return e});
define("component/usercreation/UserCreationCorePopup",["jquery","underscore","component/modal/Modal","./UserCreationAndInviteMemberErrorUtil","utils/webi18n!UserCreationStrings"],function(a,e,f,g,d){var b=function(){this._hasLicenseToCreateUser=!1;this._onCreateCallbacks=[];this._onCancelCallbacks=[];this._errorUtil=new g;this._createClickHandler=e.bind(function(a){e.each(this._onCreateCallbacks,e.bind(function(b){b(a)},this));this._popup.close()},this);this._cancelClickHandler=e.bind(function(){e.each(this._onCancelCallbacks,
e.bind(function(a){a()},this));this._popup.close()},this)};b.prototype.constructPopup=function(){this._popupContent=a("<div>");this._popupContent.append(this._errorUtil.errorSection,this._content.getContent(this._errorUtil));var b={customClass:"create_newuser_modalpopup"};b.onClose=e.bind(function(){this._popup.destroy()},this);this._popup=new f(this._popupContent,b);this._popup.setTitle(d.t("CREATE_AND_INVITE_NEW_USER"));this._popup.setFooter(this._footer.getContent(this._errorUtil))};b.prototype.setContent=
function(a){this._content=a};b.prototype.setFooter=function(a){a.setUserCreationAPI(Object.create(this,{cancel:{value:this._cancelClickHandler},success:{value:this._createClickHandler}}));this._footer=a};b.prototype.show=function(a){this.reset();this._checkLicense();this._content.beforeOpen(a);this._popup.open()};b.prototype._checkLicense=function(){var b=a.ajax({url:"CreateNewUserLicenseCheck.jsp",method:"POST",dataType:"xml"});a.when(b).then(function(b){(b=a(b).children().get(0))&&"can_create_user"===
b.tagName?"true"===a(b).text()?(this._hasLicenseToCreateUser=!0,this._footer.enable()):this._errorUtil.showWarningMessage("LIC_VIOLATION_REGULAR_USERCREATION","alert-danger",this._warningMessageDiv):"error"===a(b).prop("tagName").toLowerCase()&&(b=a("> message",b).text(),this._errorUtil.showErrorMessage(b,!0,this._errorMessageDiv))}.bind(this),function(){this._errorUtil.showErrorMessage("UNKNOWNEXCEPTION_TAG",!1,this._errorDiv)}.bind(this))};b.prototype.onSubmit=function(a){this._onCreateCallbacks.push(a)};
b.prototype.onCancel=function(a){this._onCancelCallbacks.push(a)};b.prototype.getUserDetails=function(){return this._content.getUserDetails()};b.prototype.hasLicense=function(){return this._hasLicenseToCreateUser};b.prototype.reset=function(){this._errorUtil.clearSSOErrorSections();this._errorUtil.clearErrorMessage();this._content.reset()};b.prototype.validateFields=function(){return this._content.validateFields(this._errorUtil)};b.builder=function(){var a=new b;return{setFooter:function(b){a.setFooter(b);
return this},setContent:function(b){a.setContent(b);return this},construct:function(){a.constructPopup();return a}}};return b});
define("component/usercreation/content/CreateUserPopupContent","jquery underscore utils/webi18n!UserCreationStrings component/sdrop/SDrop wcr/sdrop_common wcr/sso".split(" "),function(a,e,f,g){var d=function(){};d.prototype.getContent=function(b){var c=a("<div>",{name:"create_newuser_popup","class":"wcr-form form-labels-on-top add-padding"});this._emailInput=a("<input>",{type:"text","class":"form-control",id:"userprofile-email"});this._emailInput.keyup(this._clearErrorMessage.bind(this,b));this._emailInput.change(function(a){a=
this._parseEmailAddress(a.target.value);!this._userNameInput.val()&&a.username&&this._userNameInput.val(a.username);!this._lastNameInput.val()&&a.lastname&&this._lastNameInput.val(a.lastname);!this._firstNameInput.val()&&a.firstname&&this._firstNameInput.val(a.firstname)}.bind(this));var d=a("<div>",{"class":"form-group"}).append(a("<label>",{"class":"form-required","for":"userprofile-email"}).text(f.t("EMAIL_ADDRESS")),a("<div>",{"class":"form-entry"}).append(this._emailInput));this._userNameInput=
a("<input>",{type:"text","class":"form-control",id:"username"});this._userNameInput.keyup(this._clearErrorMessage.bind(this,b).bind(this));var e=a("<div>",{"class":"form-group"}).append(a("<label>",{"class":"form-required","for":"username"}).text(f.t("USER_NAME")),a("<div>",{"class":"form-entry"}).append(this._userNameInput));this._lastNameInput=a("<input>",{type:"text","class":"form-control",id:"userprofile-lastname"});this._lastNameInput.keyup(this._clearErrorMessage.bind(this,b));var j=a("<div>",
{"class":"form-group"}).append(a("<label>",{"class":"form-required","for":"userprofile-lastname"}).text(f.t("LAST_NAME")),a("<div>",{"class":"form-entry"}).append(this._lastNameInput));this._firstNameInput=a("<input>",{type:"text","class":"form-control",id:"userprofile-firstname"});var k=a("<div>",{"class":"form-group"}).append(a("<label>",{"for":"userprofile-firstname"}).text(f.t("FIRST_NAME")),a("<div>",{"class":"form-entry"}).append(this._firstNameInput));this._companySelect=a("<select>",{"class":"form-control"});
var m=a("<div>",{"class":"form-group"}).append(a("<label>").text(f.t("COMPANY")),a("<div>",{"class":"form-entry"}).append(this._companySelect));this._locationSelect=a("<select>",{"class":"form-control"});var g=a("<div>",{"class":"form-group"}).append(a("<label>").text(f.t("LOCATION")),a("<div>",{"class":"form-entry"}).append(this._locationSelect));this._loadCompanyAndLocFields();this._userDetailsSection=a("<div>",{"class":"form-section"});this._userDetailsSection.append(d,e,k,j,m,g);this._ssoAuthSections=
a("<div>",{"class":"sso_auth_sections"});this._createSSOAuthSections(b);c.append(this._userDetailsSection,this._ssoAuthSections);return c};d.prototype.beforeOpen=function(a){a&&(0<a.indexOf("@")?this._emailInput.val(a).trigger("change"):this._userNameInput.val(a).trigger("change"))};d.prototype._loadCompanyAndLocFields=function(){this._companySelect.empty();this._companyDataProvider=new CompanyWithLocationsDataProvider;var a={initialValue:"",enableEmptySelection:!0,emptySelectionValue:"",onChangedByUser:e.bind(this._loadLocationSelect,
this),manageStyleAndWidth:!1};this._companySDrop=new g(this._companySelect,"",this._companyDataProvider,a);this._loadLocationSelect()};d.prototype._createSSOAuthSections=function(b){this._ssoAuthSections.empty();var c=a.ajax({url:"GetSSOAuthUserConfigs.jsp",method:"POST",dataType:"text"});a.when(c).then(function(c){c=a(c.trim()).get(0);if("sso"===a(c).prop("tagName").toLowerCase()&&0<a("> userconfigs",c).children().length){var d=a("> uuid",c).text(),j=a("> timestamp",c).text(),f=a("<div>",{id:"sso-userconfig-hidden"}).hide();
f.append(a("<input>",{type:"hidden",name:"sso-uuid",value:d}),a("<input>",{type:"hidden",name:"sso-timestamp",value:j}),a("<input>",{type:"hidden",name:"isActiveUser",value:"on"}),a("<input>",{type:"hidden",name:"deactivatedAtTimeStamp",value:""}));this._ssoAuthSections.append(f);sso.timestamp=j;sso.uuid=d;sso.setUserInfo({eMail:"",firstName:"",lastName:"",userName:""});e.each(a("> userconfigs",c).children(),function(c){var d=a("<div>").html(a("> xhtml",c).text()),e=a("> id",c).text(),j=a("> name",
c).text(),f="1"===a("> show",c).text();0<a("> allow",c).length&&a("> allow",c).text();var i="1"===a("> defaultallow",c).text(),c="1"===a("> hashtml",c).text();d.attr({id:e,name:j});f||a(d).hide();"Basic password authentication"===j&&(a("input[type='password']",d).keyup(function(c){a(c.target).hasClass("validationHighlight")&&(c=a(c.target).attr("id").substring(4,20),a("#"+c+" input[type='password']").removeClass("validationHighlight"),b.clearSSOErrorSections())}.bind(this)),a("input[type='checkbox']",
d).prop("checked",!0));b.addSSOErrorSection(e);var h=a("<div>",{"class":"sso form-section"});h.append(a("<input>",{type:"hidden",name:"sso-allow-"+e,id:"sso-allow-"+e,value:f}));f&&h.append(a("<div>",{"class":"section-title"}).append(a("<h4>",{text:j}).prepend(a("<i>",{"class":"icon icon-normal icon-WCR_Cont-Circle12 icon-success"}))));h.append(a("<input>",{type:"hidden",name:"sso-defaultallow-"+e,id:"sso-defaultallow-"+e,value:i}),a("<input>",{type:"hidden",name:"sso-hashtml-"+e,id:"sso-hashtml-"+
e,value:c}),d);this._ssoAuthSections.append(h)}.bind(this))}else"error"===a(c).prop("tagName").toLowerCase()&&(c=a("> message",c).text(),b.showErrorMessage(c,!0))}.bind(this),function(a,c,d){b.showErrorMessage(d,!1)}.bind(this))};d.prototype._loadLocationSelect=function(){var b=this._companySelect.val();this._locationSelect.empty().prop("disabled",!0);if(b&&(b=this._getCompanyInfo(b)))b=b.locations,0<b.length&&(this._locationSelect.prop("disabled",!1),e.each(b,function(b){b=a("<option>",{value:b.id,
text:b.name});this._locationSelect.append(b)},this))};d.prototype._getCompanyInfo=function(a){return this._companyDataProvider.getById(a)};d.prototype.validateFields=function(b){var c=!0,d="REQUIRED_FIELDS_TAG",e=this._emailInput.val().trim();e?e&&!this._validateEmail(e)?(c=!1,this._emailInput.addClass("validationHighlight"),d="EMAIL_BAD_EMAIL"):this._userNameInput.val().trim()?this._lastNameInput.val().trim()?ssoprivate.validateConfigurations()||(c=!1,a("input[type='password']",this._ssoAuthSections).addClass("validationHighlight"),
d=""):(c=!1,this._lastNameInput.addClass("validationHighlight"),d="BADLASTNAME"):(c=!1,this._userNameInput.addClass("validationHighlight"),d="INVALIDUSERNAMEMSG"):(c=!1,this._emailInput.addClass("validationHighlight"),d="BADEMAIL");c||b.showErrorMessage(d,!1);return c};d.prototype._validateEmail=function(a){if(-1!=a.indexOf("<")){var c=a.indexOf("<")+1;if(-1!=a.indexOf(">"))var d=a.indexOf(">"),a=a.substring(c,d).trim();else return!1}return RegExp("^[a-z0-9!#$%&'*+/=?^_`{|}~-]+(?:\\.[a-z0-9!#$%&'*+/=?^_`{|}~-]+)*@(?:[a-z0-9](?:[a-z0-9-]*[a-z0-9])?\\.)+[a-z0-9](?:[a-z0-9-]*[a-z0-9])?$").test(a.toLowerCase())?
!0:!1};d.prototype._parseEmailAddress=function(a){var c={};if(-1!=a.indexOf("<")&&-1!=a.indexOf(">"))var d=a.indexOf("<")+1,f=a.indexOf(">"),a=a.substring(d,f).trim();0<a.indexOf("@")&&(a=a.substr(0,a.indexOf("@")),d=a.split("."),1===d.length?c.lastname=a:(c.firstname=d[0],c.lastname=e.rest(d).join(" ")),c.username=a);return c};d.prototype.getUserDetails=function(){var b={};b.newuseremail=this._emailInput.val();b.newusername=this._userNameInput.val();b.newuserlastname=this._lastNameInput.val();this._firstNameInput.val().trim()&&
(b.newuserfirstname=this._firstNameInput.val().trim());var c=this._companySelect.val();if(c&&(c=this._getCompanyInfo(c))){b.newusercompanycode=c.name;var d=this._locationSelect.val();d&&(c=e.findWhere(c.locations,{id:d}),b.newusercompanylocation=c.name)}c=e.reduce(a("<form>").append(this._ssoAuthSections.clone()).serializeArray(),function(a,b){a[b.name]=b.value;return a},{});return e.extend(b,c)};d.prototype._clearErrorMessage=function(b,c){a(c.target).hasClass("validationHighlight")&&(a(c.target).removeClass("validationHighlight"),
b.clearErrorMessage())};d.prototype.reset=function(){this._emailInput.val("").removeClass("validationHighlight");this._userNameInput.val("").removeClass("validationHighlight");this._lastNameInput.val("").removeClass("validationHighlight");this._firstNameInput.val("");this._companySelect.val("");this._companySelect.trigger("change");this._loadLocationSelect();a("input[type='password']",this._ssoAuthSections).val("");a("input[type='checkbox']",this._ssoAuthSections).prop("checked",!0);sso.setUserInfo({eMail:"",
firstName:"",lastName:"",userName:""});this._emailInput.focus()};return d});
define("component/usercreation/RoleFieldComponent",["jquery","underscore","./UserCreationAndInviteMemberErrorUtil","utils/webi18n!UserCreationStrings"],function(a,e,f,g){f=function(d,b,c){this._projectId=d;this._folderId=b;this._options=c;this._errorUtil=c.errorUtil;this._rolesAvailable=!1;this._wrapper=a("<div>",{"class":"form-group"});this._constructView()};f.prototype._constructView=function(){this._roleSelect=a("<select>",{"class":"form-control"});this._roleSelect.change(function(d){a(d.target).removeClass("validationHighlight");
this._errorUtil.clearErrorMessage()}.bind(this));this._wrapper.append(a("<label>",{"class":"form-required"}).text(g.t("ASSIGN_TO_ROLE")),a("<div>",{"class":"form-entry"}).append(this._roleSelect,a("<p>",{"class":"help-block"}).text(g.t("INVITE_ROLE_TIP"))));this._projectId&&this._loadRoleField()};f.prototype.validate=function(){return this._rolesAvailable?""!=this.getValue():!0};f.prototype.highLightField=function(){this._roleSelect.addClass("validationHighlight")};f.prototype.reset=function(){this._rolesAvailable&&
this._roleSelect.val(a("option:first",this._roleSelect).val())};f.prototype.getValue=function(){return this._roleSelect.val()||""};f.prototype.getJQElement=function(){return this._wrapper};f.prototype._loadRoleField=function(){this._roleSelect.empty();var d=a.ajax({url:"GetRolesInProject.jsp",method:"POST",dataType:"xml",data:{projectid:this._projectId,folderid:this._folderId}});a.when(d).then(function(b){(b=a(b).children().get(0))&&"role_list"===b.tagName?(this._roleList=[],e.each(a(b).children(),
function(b){var d=a(b).attr("id"),b=a(b).text();this._roleList.push({roleid:d,rolename:b})}.bind(this)),0<this._roleList.length?(this._rolesAvailable=!0,this._wrapper.parent().show(),b=a("<option>",{value:""}).text("--- "+g.t("SELECT_ROLE")+" ---"),this._roleSelect.append(b),a.each(this._roleList,function(b,d){var e=a("<option>",{value:d.roleid}).text(d.rolename);this._roleSelect.append(e)}.bind(this))):(this._rolesAvailable=!1,this._errorUtil.showWarningMessage("NO_ROLE_CURRENT_PROJECT_INFO","alert-warning"))):
"error"===a(b).prop("tagName").toLowerCase()&&(b=a("> message",b).text(),this._errorUtil.showErrorMessage(b,!0))}.bind(this),function(){this._errorUtil.showErrorMessage("UNKNOWNEXCEPTION_TAG",!1)}.bind(this))};return f});
define("component/usercreation/content/CreateAndInviteUserPopupContent",["jquery","./CreateUserPopupContent","../RoleFieldComponent"],function(a,e,f){var g=function(a,b){e.call(this);this._folderId=b;this._projectId=a};g.prototype=Object.create(e.prototype);g.prototype.getContent=function(d){var b=e.prototype.getContent.call(this,d);this._roleSection=a("<div>",{"class":"form-section"}).hide();if(this._projectId){var c={};c.errorUtil=d;this._roleField=new f(this._projectId,this._folderId,c);d=this._roleField.getJQElement();
this._roleSection.append(d)}b.append(this._roleSection);return b};g.prototype.validateFields=function(a){var b=e.prototype.validateFields.call(this,a);if(b&&!this._roleField.validate()){b=!1;this._roleField.highLightField();var c="INVALIDROLE"}c&&a.showErrorMessage(c,!1);return b};g.prototype.getUserDetails=function(){var a=e.prototype.getUserDetails.call(this);this._roleField.validate()&&(a.roleid=this._roleField.getValue());a.projectid=this._projectId;return a};g.prototype.reset=function(){this._roleField.reset()};
return g});
define("component/usercreation/CreateUserAndInviteInProject",["jquery","underscore","webcenterapi/data/WebCenterUser"],function(a,e,f){var g=function(){};g.prototype.createOrModifyAndInvite=function(d,b,c,g,h,j){var k={action:d,getnewuserinfo:"1"};e.extend(k,c);d=a.ajax({url:"CreateUser.jsp",method:"POST",dataType:"xml",data:k});a.when(d).then(function(c){if((c=a(c).children().get(0))&&c.tagName){if("new_user_info"===c.tagName){var d=a("> userID",c).text(),e=a("> userName",c).text(),l=a("> firstName",
c).text(),n=a("> lastName",c).text(),p=a("> email",c).text(),q=a("> isActive",c).text(),e=new f(d,e,l,n,p,"true"===q),l={};l.usermemberid=d;""!==k.roleid&&(l.roleid=k.roleid);l.projectid=k.projectid;j?g(e):this.inviteMemberToProject(l,e,b,g,h)}"error"===c.tagName&&h(c)}}.bind(this),function(){h("UNKNOWNEXCEPTION_TAG",!0)}.bind(this))};g.prototype.inviteMemberToProject=function(d,b,c,e,f){d.roleid||(d.folderid=c||"0");d=a.ajax({url:"InviteMemberToProject.jsp",method:"POST",dataType:"xml",data:d});
a.when(d).then(function(c){if((c=a(c).children().get(0))&&c.tagName)"result"===c.tagName&&e(b),"error"===c.tagName&&f(c)}.bind(this),function(){f("UNKNOWNEXCEPTION_TAG",!0)}.bind(this))};return new g});
define("component/usercreation/footers/CreateUserPopupFooter",["jquery","underscore","component/overlaymessage/OverlayMessage","utils/webi18n!UserCreationStrings","../CreateUserAndInviteInProject"],function(a,e,f,g,d){var b=function(a,b){this._folderId=b;this._projectId=a};b.prototype.setUserCreationAPI=function(a){this._api=a};b.prototype.getContent=function(b){var i=a("<div>").addClass("btn-group").attr({role:"group",name:"FooterButtons"});this._createButton=a("<input>").attr({type:"button",value:g.t(this._projectId?
"CREATE_AND_INVITE":"CREATE")}).addClass("btn btn-primary");this._createButton.prop("disabled",!0);this._createButton.click(e.bind(function(){if(this._api.hasLicense()&&this._api.validateFields()){var e=this._api.getUserDetails(),j=new f(this._api._popup.getJQElement());j.showLoading();var g=function(a){this._api.success(a);j.hide()}.bind(this),i=function(d,e){if(e)b.showErrorMessage(d,!1);else if("error"===a(d).prop("tagName").toLowerCase()){var f=a("> message",d).text();b.showErrorMessage(f,!0)}j.hide()}.bind(this);
e.applydefaultprefs="1";d.createOrModifyAndInvite("create",this._folderId,e,g,i,!this._projectId)}},this));this._cancelButton=a("<input>").attr({type:"button",value:g.t("CANCEL")}).addClass("btn btn-default add-spacing-right");this._cancelButton.click(e.bind(function(){this._api.cancel()},this));this._clearButton=a("<input>").attr({type:"button",value:g.t("CLEAR")}).addClass("btn btn-default add-spacing-right");this._clearButton.click(this._api.reset.bind(this._api));i.append(this._clearButton,this._cancelButton,
this._createButton);return i};b.prototype.enable=function(){this._createButton.prop("disabled",!1)};return b});define("component/usercreation/CreateNewUserPopup",["./UserCreationCorePopup","./content/CreateAndInviteUserPopupContent","./content/CreateUserPopupContent","./footers/CreateUserPopupFooter"],function(a,e,f,g){return function(d,b){var c,i=new g(d,b);c=d?new e(d,b):new f;return a.builder().setFooter(i).setContent(c).construct()}});
define("component/usercreation/InviteMemberPopup","jquery underscore component/modal/Modal component/overlaymessage/OverlayMessage ./CreateUserAndInviteInProject ./RoleFieldComponent ./UserCreationAndInviteMemberErrorUtil utils/webi18n!UserCreationStrings".split(" "),function(a,e,f,g,d,b,c,i){var h=function(a,b,d,f){this._userInfo=a;this._projectId=b;this._folderId=d;this._userAlreadyInProject=f;this._errorUtil=new c;this._onCreateCallbacks=[];this._onCancelCallbacks=[];this._inviteClickHandler=e.bind(function(a){e.each(this._onCreateCallbacks,
e.bind(function(b){b(a)},this))},this);this._cancelClickHandler=e.bind(function(){e.each(this._onCancelCallbacks,e.bind(function(a){a()},this))},this)};h.prototype._constructPopup=function(){this._popupContent=a("<div>");this._popupContent.append(this._getPopupContent());this._popup=new f(this._popupContent,{customClass:"invite_member_modalpopup"});this._popup.setTitle(this._userAlreadyInProject?i.tFallback("ACTIVATE_USER","Activate User"):i.t("INVITE_PROJECT_MEMBER"));this._popup.setFooter(this._getFooterContent());
this._popup.onClose(this._cancelClickHandler)};h.prototype._getPopupContent=function(){var c=a("<div>",{name:"invite_member_popup","class":"wcr-form form-labels-on-top add-padding"});c.append(this._errorUtil.errorSection);if(!this._userAlreadyInProject){this._roleSection=a("<div>",{"class":"form-section"}).hide();if(this._projectId){var d={};d.errorUtil=this._errorUtil;this._roleField=new b(this._projectId,this._folderId,d);d=this._roleField.getJQElement();this._roleSection.append(d)}c.append(this._roleSection)}this._userInfo.isActiveUser()||
this._errorUtil.showWarningMessage("DEACTIVATED_USER_INFO","alert-warning");return c};h.prototype._getFooterContent=function(){var b=a("<div>").addClass("btn-group").attr({role:"group",name:"FooterButtons"}),c=i.t("INVITE");this._userAlreadyInProject?c=i.t("ACTIVATE"):this._userInfo.isActiveUser()||(c=i.t("ACTIVATE_AND_INVITE"));this._inviteButton=a("<input>").attr({type:"button",value:c}).addClass("btn btn-primary");this._inviteButton.click(e.bind(function(){if(this._validateFields()){var b=new g(this._popup.getJQElement());
b.showLoading();var c=function(a){this._inviteClickHandler(a);this._popup.close();b.hide()}.bind(this),e=function(c,d){if(d)this._errorUtil.showErrorMessage(c,!1);else if("error"===a(c).prop("tagName").toLowerCase()){var e=a("> message",c).text();this._errorUtil.showErrorMessage(e,!0)}b.hide()}.bind(this),f={};f.usermemberid=this._userInfo.getId();this._roleField&&""!=this._roleField.getValue()&&(f.roleid=this._roleField.getValue());f.projectid=this._projectId;this._userInfo.isActiveUser()?d.inviteMemberToProject(f,
this._userInfo,this._folderId,c,e):(f.activateuser="1",f.userid=this._userInfo.getId(),d.createOrModifyAndInvite("modify",this._folderId,f,c,e,this._userAlreadyInProject))}},this));this._cancelButton=a("<input>").attr({type:"button",value:i.t("CANCEL")}).addClass("btn btn-default add-spacing-right");this._cancelButton.click(e.bind(function(){this._cancelClickHandler();this._popup.close()},this));b.append(this._cancelButton,this._inviteButton);return b};h.prototype._validateFields=function(){var a=
!0,b="REQUIRED_FIELDS_TAG";this._roleField&&!this._roleField.validate()&&(a=!1,this._roleField.highLightField(),b="INVALIDROLE");a||this._errorUtil.showErrorMessage(b,!1);return a};h.prototype.show=function(){this._popup||this._constructPopup();this._resetPopup();this._popup.open()};h.prototype._resetPopup=function(){this._errorUtil.clearErrorMessage();this._roleField&&this._roleField.reset()};h.prototype.onSubmit=function(a){this._onCreateCallbacks.push(a)};h.prototype.onCancel=function(a){this._onCancelCallbacks.push(a)};
return h});
define("component/xdrop/dataproviders/CreateUserDataProvider",["xdrop/dataproviders/XDropDataProvider","xdrop/dataproviders/ResultEntry","webcenterapi/data/WebCenterUser","utils/webi18n!UserCreationStrings","require"],function(a,e,f,g,d){f=function(b,c){a.call(this);this._projectId=b;this._folderId=c;this._init()};f.prototype=Object.create(a.prototype);f.prototype.constructor=f;f.prototype._init=function(){this._resultSet.append(this._generateEntry());setTimeout(function(){d(["component/usercreation/CreateNewUserPopup"],function(){})},
1500)};f.prototype.setQuery=function(a){this._query=a};f.prototype._generateEntry=function(){var a=this,c=new e("button",{getLabel:function(){return g.t("CREATE_AND_INVITE_NEW_USER")},doAction:function(c,f){f.closeXDrop();d(["component/usercreation/CreateNewUserPopup"],function(c){c=new c(a._projectId,a._folderId);c.onSubmit(function(a){var b=new e("user",a);a.INCONTEXTCREATED=!0;f.selectResultEntry(b)});c.show(a._query)})},getIcon:function(){return"icon icon-WCR_Actions-User-Add12"}});c.setDefaultSelectionIndex(80);
return c};return f});