define("dashboard/core/BlockDefinition",["underscore"],function(){var e=function(e,b,a){this.promise=null;this._id=e;this.type=b;this.config=a;this._description=null};e.prototype.getID=function(){return this._id};e.prototype.getType=function(){return this.type};e.prototype.getDisplayName=function(){return this.config.displayName||this.getID()||""};e.prototype.getDescription=function(){return this._description};e.prototype.setDescription=function(e){this._description=e};e.prototype.getCategory=function(){return this.config.category||
""};e.prototype.allowMultipleInContext=function(){return!this.config.onePerContext};e.prototype.clone=function(f){return new e(f,this.type,JSON.parse(JSON.stringify(this.config)))};return e});
define("dashboard/core/BlockDefinitionDataSource",["utils/Observable","utils/Observer","utils/FilterUtils","underscore","lib/PromisePolyfill"],function(e,f,b,a){var g=function(a,b){e.mixin(this,"BlockDefinitionDataSource");f.mixin(this);b||(b=[]);this._observingContext=!1;this._context=a;this._blockDefinitions=b;this._observeContextIfNeeded()};g.prototype.getCategories=function(){var d=this._blockDefinitions;return Promise.resolve().then(function(){return a.unique(a.sortBy(a.map(d,function(a){return a.getCategory()}),
!0))})};g.prototype.getBlocks=function(){return Promise.resolve(this._blockDefinitions.slice(0))};g.prototype.getBlocksForCategory=function(d){var b=this._blockDefinitions;return Promise.resolve().then(function(){return d?a.filter(b,function(a){return a.getCategory()===d},this):b}.bind(this))};g.prototype.filterBlocks=function(d,j){var c=this;return this.getBlocksForCategory(d).then(function(c){var d=b.generateRegex(j,!0);return a.filter(c,function(a){return d.test(a.getDisplayName())||d.test(a.getDescription())})}).then(function(d){return a.some(d,
function(a){return!a.allowMultipleInContext()})?c._context.whenFullyLoaded().then(function(){return Promise.all(a.map(d,function(d){return d.allowMultipleInContext()?d:c._context.getAttachedBlocksByType(d.getType()).then(function(c){return 0===c.length?d:Promise.resolve().then(function(){if(d.config.uniqueParameter){var b=a.find(d.config.config.parameters,function(a){return a.name===d.config.uniqueParameter});return a.find(c,function(a){return a.getParameterByName(d.config.uniqueParameter).getValue()===
b.config.value})?null:d}return null}).catch(function(a){console.error(a);return null})})}))}):d}).then(function(c){return a.compact(c)})};g.prototype.setBlockDefinitions=function(a){this._blockDefinitions=a;this._observeContextIfNeeded();this._emit("changed.blockDefinitions")};g.prototype.addBlockDefinition=function(a){this._blockDefinitions.push(a);this._observeContextIfNeeded();this._emit("changed.blockDefinitions")};g.prototype.removeBlockDefinition=function(d){this._blockDefinitions=a.without(this._blockDefinitions,
d);this._emit("changed.blockDefinitions")};g.prototype._observeContextIfNeeded=function(){!this._observingContext&&a.find(this._blockDefinitions,function(a){return!a.allowMultipleInContext()})&&(this._observe(this._context,"changed",function(){this._emit("changed.blockDefinitions")}),this._observingContext=!0)};return g});
define("dashboard/core/Factory",["utils/Promisify"],function(e){var f=function(){};f.prototype.initBlock=function(b,a,g){return e.require(g).then(function(d){return new d(b,a)}).catch(function(a){a.message="Could not load definition for Block ("+b+", type: "+g+") \r\nRequireJS error: "+a.message;throw a;})};return f});
define("dashboard/core/parameters/ParameterSet",["utils/Observable","utils/Observer","utils/OrderedObject","underscore"],function(e,f,b,a){var g=function(){e.mixin(this,"ParameterSet");f.mixin(this);this._parameters=new b};g.prototype.getParameterList=function(){return this._parameters.getOrderedObjectList()};g.prototype.getParameterListByType=function(d){return a.filter(this.getParameterList(),function(a){return a.getType()===d})};g.prototype.getParameter=function(a){return this._parameters.getItemByKey(a)};
g.prototype.setParameter=function(d,b){if(this._parameters.getItemByKey(d)!==b){this._parameters.getItemByKey(d)&&this._stopObserveObject(this._parameters.getItemByKey(d));var c=this.getValue(d);this._parameters.addOrReplaceItem(d,b);this._emitParameterChanged(d,c,this.getValue(d));b&&this._observe(b,"changed",a.partial(this._emitParameterChanged,d))}};g.prototype._emitParameterChanged=function(a,b,c){this._emit(["changed",a].join("."),b,c)};g.prototype.getValue=function(a){if(a=this._parameters.getItemByKey(a))return a.getValue()};
g.prototype.setValue=function(a,b){this._parameters.getItemByKey(a).setValue(b)};g.prototype.moveParameterToEndOfList=function(a){this._parameters.moveItemByKeyToEnd(a)};g.prototype.moveParametertoFrontOfList=function(a){this._parameters.moveItemByKeyToIndex(a,0)};return g});
define("dashboard/core/IDMap",[],function(){var e=function(e){this._masterMap=e;this._mapping={}};e.prototype.mapID=function(e){return this._mapping[e]?this._mapping[e]:this._masterMap?this._masterMap.mapID(e):e};e.prototype.addMapping=function(e,b){this._mapping[e]=b};e.prototype.createInstance=function(){return new e(this)};return e});
define("dashboard/blocks/ErrorBlock",["../core/Block","underscore"],function(e,f){var b=function(a,b,d,j,c){e.call(this,a,b);this._message=d;this._blockDefinition=j;this._errorDetails=c||null};b.prototype=Object.create(e.prototype);b.prototype.constructor=b;b.prototype.getType=function(){return"dashboard/blocks/ErrorBlock"};b.prototype.getConfiguration=function(){return this._blockDefinition.config};b.prototype._initializeDefaultParameters=function(){};b.prototype._doInit=function(){this._error=this._generateUserfriendlyException(this._message,
this._blockDefinition,this._errorDetails);this._render()};b.prototype._doRender=function(){this._element.html(this._error)};b.prototype.isPersistent=function(){return!f.isEmpty(this._blockDefinition.config)};b.prototype.canConfigure=function(){return!1};b.prototype._generateUserfriendlyException=function(a,b,d){var j=document.createElement("div");j.className="alert alert-danger";this._context.getLanguageBundle("Dashboard").then(function(c){var e=document.createElement("p");e.textContent=c.t("ERROR_UNEXPECTED_BLOCK");
j.appendChild(e);if(a&&(a.message||a.stack)||b||d){var k=document.createElement("a");k.textContent=c.t("ERROR_UNEXPECTED_DETAILS");var f=!1,h=null;k.addEventListener("click",function(){if(f)j.removeChild(h),k.textContent=c.t("ERROR_UNEXPECTED_DETAILS"),f=!1;else{h=document.createElement("pre");var m=[];a.message&&m.push(a.message);a.stack&&m.push(a.stack);if(b)try{m.push("Block Definition: \r\n"+JSON.stringify(b,null,"  "))}catch(e){m.push("Could not generate block definition \r\n"+e)}d&&m.push(d);
h.textContent=m.join("\r\n\r\n---------------------------------------------\r\n\r\n");k.textContent=c.t("ERROR_UNEXPECTED_HIDE_DETAILS");j.appendChild(h);f=!0}});j.appendChild(k)}});return j};return b});
define("dashboard/core/Context","./BlockDefinition ./BlockDefinitionDataSource ./Factory ./parameters/ParameterSet ./IDMap utils/SynchronizedUndoRedoController utils/Command utils/Observable utils/Promisify underscore dashboard/blocks/ErrorBlock lib/PromisePolyfill".split(" "),function(e,f,b,a,g,d,j,c,i,k,l){var h=function(m,b){m||(m="");this._id=m;this._options=k.extend({},b);c.mixin(this,"Context_"+m);this._blocks={};this._idGenerator={};this._defaultIDMap=new g;this._parameters=new a;this._undoRedoController=
new d(500);this._dragDropHandler=null;this._isEditModeActive=!1;this._dashboardRootBlock=null;this._preferenceProvider={load:function(){return Promise.resolve().then(function(){})},save:function(){return Promise.resolve().then(function(){})}}};h.prototype.getBlocks=function(){return this._blocks};h.prototype.getFactory=function(){this._factory||(this._factory=Promise.resolve().then(function(){return new b}));return this._factory};h.prototype.toggleEditMode=function(a){this._isEditModeActive!=a&&(this._isEditModeActive=
a,this._emit("editModeActive",a))};h.prototype.isEditModeActive=function(){return this._isEditModeActive};h.prototype.setFactory=function(a){this._factory=Promise.resolve(a)};h.prototype.getLanguageProvider=function(){this._languageProvider||(this._languageProvider=i.require("dashboard/i18n/LanguageProvider").then(function(a){return new a}));return this._languageProvider};h.prototype.getDragDropHandler=function(){this._dragDropHandler||(this._dragDropHandler=i.require("dashboard/builder/dragdrop/DragDropHandler").then(function(a){return new a}));
return this._dragDropHandler};h.prototype.getUndoRedoController=function(){return this._undoRedoController};h.prototype.undoableAction=function(a,c,b){var d=this,h=null,b=new j(function(){return Promise.resolve().then(function(){if(null===h)return Promise.all(k.map(a,function(a){return Promise.resolve(a.getConfiguration()).then(function(c){return{item:a,config:JSON.stringify(c)}})})).then(function(a){h=a})}).then(function(){return c()}).then(function(){d._emit("changed")})},function(){return Promise.all(k.map(h,
function(a){var c=JSON.parse(a.config);return a.item.configure(c.config,d._defaultIDMap.createInstance())})).then(function(){d._emit("changed")})},b);return d.getUndoRedoController().execute(b)};h.prototype.isModified=function(){return 0<this.getUndoRedoController().undoCount()};h.prototype.configureBlock=function(a,c,b){var d=this;return this.getLanguageBundle("Dashboard").then(function(h){return this.undoableAction([a],function(){return a.configure(c,d._defaultIDMap.createInstance())},b||h.t("CONFIGURE_BLOCK_UNDOREDOMESSAGE",
a.getID()))}.bind(this))};h.prototype.getParameterSet=function(){return this._parameters};h.prototype.getParametersByType=function(a){return this._parameters.getParameterListByType(a)};h.prototype.setParameter=function(a,c){this._parameters.setParameter(a,c)};h.prototype.getParameter=function(a){return this._parameters.getParameter(a)};h.prototype.setLanguageProvider=function(a){this._languageProvider=Promise.resolve(a)};h.prototype.getLanguageBundle=function(a){return this.getLanguageProvider().then(function(c){return c.getLanguageBundle(a)})};
h.prototype.loadBlock=function(a){var c=this;return Promise.resolve().then(function(){if(!this._blocks[a])throw Error(Error("No definition for Block with id "+a));this._blocks[a].promise||(this._blocks[a].promise=this._initBlock(a));return this._blocks[a].promise}.bind(this)).catch(function(b){c._blocks[a]||(c._blocks[a]=new e(a,"dashboard/blocks/ErrorBlock",{}));var d=c._blocks[a],b=Promise.resolve(new l(a,c,b,d.clone(a))).then(function(a){return a.configure({},c._defaultIDMap.createInstance())});
return d.promise=b})};h.prototype._initBlock=function(a){var c=this,b=this._blocks[a];return this.getFactory(b.type).then(function(d){return d.initBlock(a,c,b.type,b.config)}).then(function(a){var d=c._defaultIDMap;b.IDMap&&(d=b.IDMap,b.IDMap=null);return a.configure(b.config.config,d.createInstance(),b.getDisplayName())}).then(function(a){b.block=a;c._emit("initBlock",a);return a})};h.prototype.getBlocksByType=function(a){return k.where(this._blocks,{type:a})};h.prototype.getAttachedBlocksByType=
function(a){return this._getAttachedBlocks(this.getBlocksByType(a))};h.prototype.getAttachedBlocks=function(){return this._getAttachedBlocks(this.getBlocks())};h.prototype._getAttachedBlocks=function(a){var c=this._dashboardRootBlock;return Promise.all(k.map(a,function(a){return a.promise?a.promise:null})).then(function(a){return k.filter(a,function(a){return null!==a&&a.isAttached()&&a.getRoot()===c})})};h.prototype._makeTypeIDFriendly=function(a){return a.split("/").join("_")};h.prototype._generateUniqueID=
function(a,c){var b=this._makeTypeIDFriendly(a);if(1E4<c)throw Error("Could not generate unique ID after 10000 attempts");if(!this._idGenerator[b]){var d=0;k.each(this.getBlocksByType(a),function(a){a=a.getID();a.substr(0,a.lastIndexOf("_"))===b&&(a=parseInt(a.substr(a.lastIndexOf("_")+1),10),isNaN(a)||(d=Math.max(a+1,d)))});this._idGenerator[b]=d}var h=b+"_"+this._idGenerator[b]++;return this._blocks[h]?(c||(c=0),this._generateUniqueID(a,c++)):h};h.prototype._updateUniqueIDs=function(a){var c=a.substr(0,
a.lastIndexOf("_")),a=parseInt(a.substr(a.lastIndexOf("_")+1),10);0<c.length&&!isNaN(a)&&(this._idGenerator[c]||(this._idGenerator[c]=0),this._idGenerator[c]=Math.max(a+1,this._idGenerator[c]))};h.prototype.registerAndMapBlocks=function(a,c){c||(c=this._defaultIDMap);k.each(k.pluck(a,"id"),this._updateUniqueIDs,this);var b=k.map(a,function(a){var b=a.id,d=b;this._blocks[b]&&(d=this._generateUniqueID(a.type),c.addMapping(b,d));a=JSON.parse(JSON.stringify(a));a.id=d;return a},this);k.each(b,function(a){this._registerBlockWithID(a,
c,a.id)},this)};h.prototype.registerBlock=function(a,c){var b=this._generateUniqueID(a.type);this._registerBlockWithID(a,c,b);return b};h.prototype._registerBlockWithID=function(a,c,b){if(!a.type)throw Error("Cannot register block without a type!",b,a);if(this._blocks[b])throw Error("Trying to add BlockDefinition with already existing ID");c||(c=this._defaultIDMap);a=new e(b,a.type,a);a.idMap=c;this._blocks[b]=a;this._emit("changed")};h.prototype.registerBlockFromDefinition=function(a){var c=this._generateUniqueID(a.type),
a=a.clone(c);this._blocks[c]=a;this._emit("changed");return c};h.prototype.registerAndLoadBlock=function(a,c){var b=this,d=!1;!b._dashboardRootBlock&&!b._rootBlockIsLoading&&(this._rootBlockIsLoading=d=!0);return Promise.resolve().then(function(){return b.loadBlock(b.registerBlock(a,c))}).then(function(a){d&&(b._dashboardRootBlock=a,a.__makeRootBlock(),delete b._rootBlockIsLoading);return a})};h.prototype.destroyBlock=function(a){a.destroy();delete this._blocks[a.getID()];this._emit("changed")};h.prototype.detachBlock=
function(a,c){return this.getLanguageBundle("Dashboard").then(function(b){return this.undoableAction(a,function(){c.setParent(null)},b.t("DELETE_BLOCK_UNDOREDOMESSAGE",c.getID()))}.bind(this))};h.prototype.removeBlockDefinition=function(a){(a=this._blocks[a.getID()])&&(a.promise?a.promise.then(function(a){this.destroyBlock(a)}.bind(this)):delete this._blocks[a.getID()]);this._emit("changed")};h.prototype.getBlockDefinitionDataSource=function(){this._blockDefinitionDataSource||(this._blockDefinitionDataSource=
Promise.resolve(new f(this)));return this._blockDefinitionDataSource};h.prototype.setBlockDefinitionDataSource=function(a){this._blockDefinitionDataSource=Promise.resolve(a)};h.prototype.getBlockDefinition=function(a){return this._blocks[a]};h.prototype.whenFullyLoaded=function(){var a=this;return Promise.all(k.map(this._blocks,function(a){return a.promise?a.promise.then(function(a){return a.whenFullyLoaded(!0)}).catch(function(){return!0}):!0})).then(function(){return a})};h.prototype.setLegacyMyWorkUserPreferences=
function(a){this._legacyMyWorkUserPrefs=a};h.prototype.getLegacyMyWorkSectionUserPreferences=function(a){if(this._legacyMyWorkUserPrefs){var c=k.find(this._legacyMyWorkUserPrefs,function(c){return c._HomePageID===a});if(c)return c}return null};h.prototype.getID=function(){return this._id};h.prototype.setPreferenceProvider=function(a){this._preferenceProvider=a};h.prototype.savePreferences=function(a,c){this._preferenceProvider.save(a,c)};h.prototype.loadPreferences=function(a){return this._preferenceProvider.load(a)};
h.prototype.getOption=function(a){return this._options[a]};return h});
define("dashboard/core/parameters/Parameter",["utils/Observable","utils/Promisify"],function(e,f){var b=function(a,b,d,j,c,i){e.mixin(this,"Parameter_"+a);this._name=a;this._context=b;d||(d="dashboard/core/parameters/Parameter");this._configurationPanelComponentLocation="dashboard/builder/configuration/ParameterConfigurationPanel";this._type=d;this._userFriendlyName=j;this._helpText=c;this._toolTipText=i;this._restrictedSet=null;this._isPersistentWhenDefaultValue=this._isPeristent=this._isVisible=
this._configurableByUser=!0;this._defaultValue=null};b.prototype.getName=function(){return this._name};b.prototype.getType=function(){return this._type};b.prototype.getUserFriendlyName=function(){return this._userFriendlyName};b.prototype.getHelpText=function(){return this._helpText};b.prototype.setHelpText=function(a){this._helpText=a};b.prototype.getToolTipText=function(){return this._toolTipText};b.prototype.setTooltipText=function(a){this._toolTipText=a};b.prototype.setValue=function(a){var b=
this._value;this._value=a;this._valueEquals(b,a)||this._emitChanged(b,a)};b.prototype._valueEquals=function(a,b){return a===b};b.prototype.undoableSetValue=function(a){return this._context.getLanguageBundle("Dashboard").then(function(b){return this._context.undoableAction([this],function(){this.setValue(a)}.bind(this),b.t("CONFIGURE_PARAMETER_UNDOREDOMESSAGE",this.getUserFriendlyName()))}.bind(this))};b.prototype.setRestrictedSet=function(a){this._restrictedSet=a};b.prototype.getRestrictedSet=function(){return this._restrictedSet};
b.prototype._emitChanged=function(a,b){this._emit("changed",a,b)};b.prototype.getValue=function(){return this._value};b.prototype.configure=function(a){this.setValue(a.value)};b.prototype.getConfiguration=function(a){return Promise.resolve(this._getParameterSpecificConfig(a)).then(function(a){return{name:this.getName(),type:this.getType(),config:a}}.bind(this))};b.prototype._getParameterSpecificConfig=function(){return Promise.resolve({value:this.getValue()})};b.prototype._getConfigurationPanelComponentLocation=
function(){return this._configurationPanelComponentLocation};b.prototype.setConfigurationPanelComponentLocation=function(a){this._configurationPanelComponentLocation=a};b.prototype.setConfigurableByUser=function(a){this._configurableByUser!==a&&(this._configurableByUser=a,this._emitChanged(this.getValue(),this.getValue()))};b.prototype.isVisible=function(){return this.isConfigurableByUser()&&this._isVisible};b.prototype.setVisible=function(a){this._isVisible!==a&&(this._isVisible=a,this._emitChanged(this.getValue(),
this.getValue()))};b.prototype.isConfigurableByUser=function(){return this._configurableByUser};b.prototype.getConfigurationPanel=function(){return f.require(this._getConfigurationPanelComponentLocation()).then(function(a){return new a(this)}.bind(this))};b.prototype.isPersistent=function(){return this._isPeristent&&(this._isPersistentWhenDefaultValue||this._defaultValue!==this.getValue())};b.prototype.dontPersistIfDefaultValue=function(a){this._defaultValue=a;this._isPersistentWhenDefaultValue=!1};
b.prototype.setPersistent=function(a){this._isPeristent=a};return b});
define("component/customizedlabels/CustomizedLabelTranslator",["underscore","component/smartnames/encoding/smartnameencoding","utils/webi18n!SharedLabels","utils/webi18n!CustomizedLabels"],function(e,f,b,a){var g=f.SAVEDSEARCH;return{translate:function(d){if(d&&0===d.indexOf("i18n!")){var d=g.decodeSmartNameString(d.substr(5)),j="";e.each(d,function(c){var d=c.getAsSmartName();if(d){var c=j,g=d.getArguments()[0],d=d.getArguments()[1],e="?";"SharedLabels"===g?e=b.t(d):"CustomizedLabels"===g&&(e=a.t(d));
j=c+e}else j+=c.getAsText()||""});return j}return d}}});
define("dashboard/core/parameters/StringParameter",["dashboard/core/parameters/Parameter","component/customizedlabels/CustomizedLabelTranslator","lib/PromisePolyfill"],function(e,f){var b=function(a,b,d){e.call(this,a,b,"dashboard/core/parameters/StringParameter",d);this._defaultConfigurationPanelLocation=this._configurationPanelComponentLocation;this._configurationPanelComponentLocation="component/dashboard/builder/configuration/parameters/WCRCustomizedLabelStringParameterConfigurationPanel"};b.prototype=
Object.create(e.prototype);b.prototype.constructor=b;b.prototype.setValue=function(a){var b=this.getValue();this._value=a;a=this.getValue();this._valueEquals(b,a)||this._emitChanged(b,a)};b.prototype.getValue=function(){return f.translate(this._value)};b.prototype.getEncodedValue=function(){return this._value};b.prototype._getConfigurationPanelComponentLocation=function(){return this.getRestrictedSet()&&"component/dashboard/builder/configuration/parameters/WCRCustomizedLabelStringParameterConfigurationPanel"===
this._configurationPanelComponentLocation?this._defaultConfigurationPanelLocation:this._configurationPanelComponentLocation};b.prototype._getParameterSpecificConfig=function(){return Promise.resolve({value:this._value})};return b});
define("dashboard/core/parameters/BooleanParameter",["./Parameter","utils/Promisify"],function(e,f){var b=function(a,b,d){e.call(this,a,b,"dashboard/core/parameters/BooleanParameter",d)};b.prototype=Object.create(e.prototype);b.prototype.constructor=b;b.prototype.getConfigurationPanel=function(){return f.require("dashboard/builder/configuration/parameters/BooleanParameterConfigurationPanel").then(function(a){return new a(this)}.bind(this))};return b});
define("dashboard/core/Block","./Context ./parameters/ParameterSet ./parameters/StringParameter ./parameters/BooleanParameter utils/Observable utils/Observer utils/Promisify utils/OrderedObject underscore jquery lib/PromisePolyfill".split(" "),function(e,f,b,a,g,d,j,c,i,k){c=function(a,c){c||(c=new e);g.mixin(this,"Block_"+a);d.mixin(this);this._id=a;this._isCollapsed=this._isCollapsible=this._inDOM=!1;this._context=c;this._parameters=new f;var b=this;this._observeUnbound(this._parameters,"changed.*",
function(a,c){var d=i.last(this.event.split("."));b._emit(["parameter.changed",d].join("."),a,c)});this._element=k("<div>",{"data-block-id":a});this._element[0].__BLOCK=this;this._isInEditMode=this._isModified=this._isInitialized=!1;this._parent=null;this._futureChildren={};this._children=[];this._didRequestAnimationFrame=null;this._showTransparentFrame=this._isRoot=this._isAttached=!1};c.prototype._initTitleAndFrameParameters=function(c){return this._context.getLanguageBundle("Block").then(function(d){var j=
new a("blockShowFrame",this._context,d.t("SHOW_FRAME"));j.setValue(!1);j.dontPersistIfDefaultValue(!1);this._addParameter(j);j=new b("blockTitle",this._context,d.t("BLOCK_TITLE"));j.setValue(c||this.getID());j.setVisible(!1);this._addParameter(j);d=new b("blockFrameColor",this._context,d.t("FRAME_COLOR"));d.setConfigurationPanelComponentLocation("dashboard/builder/configuration/parameters/ColorPickerConfigurationPanel");d.setValue("#dedede");d.dontPersistIfDefaultValue("#dedede");d.setVisible(!1);
this._addParameter(d);d=new a("blockShowInEditMode",this._context,"");d.setValue(!1);d.setVisible(!1);d.setPersistent(!1);this._addParameter(d);this._observeParam("blockShowFrame",this._blockShowFrameChanged)}.bind(this))};c.prototype.getType=function(){throw Error("This method should be overriden!");};c.prototype.getID=function(){return this._id};c.prototype.getTitle=function(){var a=this._parameters.getParameter("blockTitle");return null!=a?a.getValue():this.getID()};c.prototype.getTitleElement=
function(){var a=this.getTitle();return k("<h4>",{title:a,text:a})};c.prototype.getHeaderButtons=function(){};c.prototype.shouldShowFrame=function(){return this._parameters.getParameter("blockShowFrame").getValue()};c.prototype.getFrameColor=function(){return this._parameters.getParameter("blockFrameColor").getValue()};c.prototype.showAlwaysTransparentFrame=function(){return this._showTransparentFrame};c.prototype.setTitle=function(a){var c=this._parameters.getParameter("blockTitle");null!=c&&c.setValue(a)};
c.prototype.configure=function(a,c,b){var d=this;return Promise.resolve().then(function(){d._context.registerAndMapBlocks(a.blocks,c)}).then(function(){if(!d._isInitialized)return d._initTitleAndFrameParameters(b).then(function(){return d._initializeDefaultParameters()}).then(function(){return d._updateParameterOrder()})}).then(function(){return d._configureParameters(a,c)}).then(function(){return d._doConfigure(a,c)}).then(function(){return d._loadPreferences()}).then(function(){if(!d._isInitialized)return Promise.resolve(d._doInit()).then(function(){d._isInitialized=
!0;d._emit("initialized")})}).then(function(){d._emit("configured");return d})};c.prototype._configureParameters=function(a,c){return Promise.all(i.map(a.parameters,function(a){return this._parameters.getParameter(a.name)?this._parameters.getParameter(a.name).configure(a.config,c):this._addParameterWithConfig(a,c)},this))};c.prototype._addParameter=function(a){this._parameters.setParameter(a.getName(),a)};c.prototype.findChildren=function(a,c,b){var d=[],j=function(e){a(e)?(d.push(e),c&&i.each(e.getChildren(),
j)):b&&(!i.isFunction(b)||b(e))&&i.each(e.getChildren(),j)};i.each(this.getChildren(),j);return d};c.prototype._addParameterWithConfig=function(a){console.warn("_addParameterWithConfig not implemented",a)};c.prototype._initializeDefaultParameters=function(){};c.prototype._updateParameterOrder=function(){this._parameters.moveParameterToEndOfList("blockShowFrame");this._parameters.moveParameterToEndOfList("blockTitle");this._parameters.moveParameterToEndOfList("blockFrameColor")};c.prototype._blockShowFrameChanged=
function(a,c){this._parameters.getParameter("blockFrameColor").setVisible(c);this._parameters.getParameter("blockTitle").setVisible(c)};c.prototype.getParameterList=function(){return this._parameters.getParameterList()};c.prototype.getParameterListByType=function(a){return this._parameters.getParameterListByType(a)};c.prototype.getParameterByName=function(a){return this._parameters.getParameter(a)};c.prototype._observeParam=function(a,c){this._observe(this._parameters,["changed",a].join("."),c)};
c.prototype._observeParams=function(a,c){i.each(a,function(a){this._observeParam(a,c)},this)};c.prototype._doConfigure=function(){};c.prototype._doInit=function(){};c.prototype.getConfiguration=function(a){var c=this;return Promise.resolve().then(function(){return Promise.all([c._getBlockConfiguration(a),c._getParameterConfiguration(a),c._getChildrenConfiguration(a)])}).then(function(a){a.unshift({});(a[1].parameters||a[1].blocks)&&console&&console.warn&&console.warn("'parameters' and 'blocks' are reserved keywords for the config object and will be ovewritten");
return{type:c.getType(),id:c.getID(),config:i.extend.apply(i,a)}})};c.prototype._getConfigurationForBlocks=function(a,c){return Promise.all(i.map(a,function(a){return a.getConfiguration(c)}))};c.prototype._getParameterConfiguration=function(a){var c=this.getParameterList();return 0<c.length?Promise.all(i.map(c,function(c){return c.isPersistent()||!a?c.getConfiguration(a):null})).then(function(a){return{parameters:i.compact(a)}}):Promise.resolve({})};c.prototype._getChildrenConfiguration=function(a){if(a){var c=
this;return Promise.resolve(c._findChildrenForPersistence()).then(function(b){return c._getConfigurationForBlocks(b,a)}).then(function(a){return{blocks:a}})}return Promise.resolve({})};c.prototype._findChildrenForPersistence=function(){return Promise.resolve([])};c.prototype._getBlockConfiguration=function(){return{}};c.prototype.destroy=function(){i.each(this.getChildren(),function(a){a.destroy()});this.getParent()&&this.getParent().detachChild(this);this.setInDOM(!1);this._emit("destroyed");this._stopObserveAll();
this._element.detach()};c.prototype.isPersistent=function(){return!0};c.prototype.canConfigure=function(){return!0};c.prototype.getContext=function(){return this._context};c.prototype.getElement=function(){return this._element};c.prototype.addChild=function(a){this._registerChild(a);this._element.append(a.getElement());a.setInDOM(this.isInDOM())};c.prototype._registerFutureChild=function(a){for(var c,b=this;null!=b;){if(b.getID()===a)throw Error("Cannot register a child which is a parent of the current block");
b=b.getParent()}if(this._futureChildren[a])c=this._futureChildren[a];else{var d=function(){};c=new Promise(function(a){d=a});this._futureChildren[a]=c;var j=this;c.markAsResolved=function(){delete j._futureChildren[a];d()}}return function(){c.markAsResolved()}};c.prototype._markFutureChildResolved=function(a){this._futureChildren[a]&&this._futureChildren[a].markAsResolved()};c.prototype._registerChild=function(a){i.contains(this._children,a)||(delete this._futureChildren[a.getID()],a.setParent(this),
this._children.push(a),this._emit("child.attach",a))};c.prototype.detachChild=function(a){i.contains(this._children,a)&&(this._markFutureChildResolved(a.getID()),this._children=i.without(this._children,a),this._emit("child.detach",a))};c.prototype.setParent=function(a){if(this._parent!=a){if(null==a){if(this._isAttached&&!this._isRoot)this.onDetached()}else if(!this._isAttached)this.onAttached();this._parent&&this._parent.detachChild(this);this._parent=a;this.setInDOM(!1);this._emit("parent",a)}};
c.prototype.__makeRootBlock=function(){this._isRoot=!0;if(!this._isAttached)this.onAttached()};c.prototype.getParent=function(){return this._parent};c.prototype.getRoot=function(){for(var a=this;a.getParent();)a=a.getParent();return a};c.prototype.isAttached=function(){return this._isAttached||this._isRoot};c.prototype.isInDOM=function(){return this._inDOM};c.prototype.getChildren=function(){return this._children};c.prototype._requestUserEdit=function(){this._emit("request.useredit")};c.prototype.getConfigurationPanel=
function(){var a=this;return j.require("dashboard/builder/configuration/BlockConfigurationPanel").then(function(c){return new c(a)})};c.prototype._render=function(){if(!this._didRequestAnimationFrame)if(this._isInitialized){var a=this;this._didRequestAnimationFrame=window.requestAnimationFrame(function(){a._doRender();a._didRequestAnimationFrame=null;a._emit("render")})}else this.once("initialized",this._render.bind(this))};c.prototype._doRender=function(){};c.prototype.whenFullyLoaded=function(a){var c=
Promise.all(i.values(this._futureChildren)),b=this;a||(c=c.then(function(){return Promise.all(i.map(b.getChildren(),function(a){return a.whenFullyLoaded()}))}));return c.then(function(){if(!b._isInitialized)return j.once(b,"initialized")}).then(function(){return b})};c.prototype.onAttached=function(){this._isAttached=!0;i.each(this._children,function(a){a.onAttached()})};c.prototype.onDetached=function(){this._isAttached=!1;i.each(this._children,function(a){a.onDetached()})};c.prototype.setInDOM=
function(a){this._inDOM!=a&&(this._inDOM=a,i.each(this._children,function(c){c.setInDOM(a&&this._childInDOM(c))},this),this._emit("inDOM",a))};c.prototype._childInDOM=function(){return!0};var l=null;c.prototype._keepElementsInDOM=function(a){var c=this,b=[],d=function(){c._inDOM?(i.each(b,function(a){a.el.insertBefore(a.guard);a.guard.detach()}),b=[]):(l||(l=k("<div>",{"class":"hidden dshElementInDOMKeeper"}).appendTo("body")),i.each(a,function(a){var a=k(a),c=k("<div>",{"class":"dshDOMKeeperGuard"});
c.insertBefore(a);l.append(a);b.push({el:a,guard:c})}))};d();var j=this._observe(this,"inDOM",d);return{stop:function(){l&&(l.find(a).detach(),c._stopObserveSubscription(j))}}};c.prototype.onConfigurationPanelClosed=function(){};c.prototype.isCollapsible=function(){return this._isCollapsible};c.prototype.isCollapsed=function(){return this._isCollapsed};c.prototype.collapse=function(a,c){this.getParameterByName("blockShowFrame").getValue()&&(this._isCollapsed=a,this._element.toggleClass("hidden",a),
c&&this._savePreferences())};c.prototype._loadPreferences=function(){this._context.loadPreferences(this._id).then(function(a){this._onLoadPreferences(a)}.bind(this))};c.prototype._onLoadPreferences=function(){};c.prototype._savePreferences=function(){this._isInitialized&&this._onSavePreferences().then(function(a){this._context.savePreferences(this._id,a)}.bind(this))};c.prototype._onSavePreferences=function(){return Promise.resolve()};return c});
define("utils/webcss-text!dashboard/layout/BlockWrapper.css",[],function(){return".dshBlockWrapper {\r\n\tdisplay: -ms-flex;\r\n\tdisplay: -webkit-flex;\r\n\tdisplay: flex;\r\n\t-ms-flex-direction: column;\r\n\t-webkit-flex-direction: column;\r\n\tflex-direction: column;\r\n}\r\n.dshBlockWrapper>div {\r\n\t-ms-flex-grow: 1;\r\n\t-webkit-flex-grow: 1;\r\n\tflex-grow: 1;\r\n}\r\n.dshBlockWrapper.showFrame {\r\n\tborder: 1px solid transparent;\r\n}\r\n.dshBlockWrapper>.header {\r\n\tdisplay: -ms-flexbox;\r\n\tdisplay: -webkit-flex;\r\n\tdisplay: flex;\r\n\t-ms-align-items: stretch;\r\n\t-webkit-align-items: stretch;\r\n\talign-items: stretch;\r\n\t-ms-flex-grow: 0;\r\n\t-webkit-flex-grow: 0;\r\n\tflex-grow: 0;\r\n\tbackground: #dedede;\r\n\tmin-height: 32px;\r\n}\r\n.dshBlockWrapper>.header .headerHandle {\r\n\t-ms-flex: 1 1 auto;\r\n\t-webkit-flex: 1 1 auto;\r\n\tflex: 1 1 auto;\r\n\tdisplay: -ms-flex;\r\n\tdisplay: -webkit-flex;\r\n\tdisplay: flex;\r\n\t-ms-align-items: center;\r\n\t-webkit-align-items: center;\r\n\talign-items: center;\r\n\t-ms-justify-content: flex-start;\r\n\t-webkit-justify-content: flex-start;\r\n\tjustify-content: flex-start;\r\n\toverflow: hidden;\r\n\tpadding: 3px 3px 3px 6px;\r\n}\r\n.dshBlockWrapper.allowDrag>.header .headerHandle {\r\n\tcursor: move;\r\n}\r\n.dshBlockWrapper.showFrame>.dshBlockPadding {\r\n\tpadding: 6px;\r\n}\r\n.dshBlockWrapper>.header h4 {\r\n\tfont-weight: 500;\r\n\tfont-size: 13px;\r\n\t-ms-flex: 1 1 auto;\r\n\t-webkit-flex: 1 1 auto;\r\n\tflex: 1 1 auto;\r\n\ttext-overflow: ellipsis;\r\n\toverflow: hidden;\r\n\twhite-space: nowrap;\r\n\tmargin: 0;\r\n\tpadding: 0;\r\n}\r\n.dshBlockWrapper>.header .buttons {\r\n\t-ms-flex: 0 0 auto;\r\n\t-webkit-flex: 0 0 auto;\r\n\tflex: 0 0 auto;\r\n\tpadding: 3px 6px 3px 3px;\r\n\tdisplay: -ms-flex;\r\n\tdisplay: -webkit-flex;\r\n\tdisplay: flex;\r\n}\r\n.dshBlockWrapper>.header .buttons .btn {\r\n\tpadding-left: 5px;\r\n\tpadding-right: 5px;\r\n}\r\n.dshBlockWrapper>.header .buttons .btn.save {\r\n\tcolor: #334444;\r\n}\r\n.labelAsButton {\r\n\tcursor: pointer;\r\n}"});
define("dashboard/layout/BlockWrapper","../core/Block utils/ColorUtils component/modal/Modal jquery underscore utils/webcss!./BlockWrapper.css".split(" "),function(e,f,b,a,g){var d=function(a,c){e.call(this,a,c);this._block=null;this._isConfiguring=!1;this._dragDropHandler=null;this._element.addClass("dshBlockWrapper");this._hasCustomHeaderButtons=!1;this._previousState={divDisplayed:null,showFrame:!1,showHeaderButtons:!1,showLoadingIndicator:!1,initial:!0}};d.prototype=Object.create(e.prototype);
d.prototype.constructor=d;d.prototype.getType=function(){return"dashboard/layout/BlockWrapper"};d.prototype.isPersistent=function(){return!1};d.prototype.getBlock=function(){return this._block};d.prototype.detachChild=function(a){e.prototype.detachChild.call(this,a);this._block===a&&(this._block=null,this._stopObserveObject(a),this._context.destroyBlock(this))};d.prototype._initHeader=function(){if(!this._header){this._header=a("<div>",{"class":"header"});this._headerHandle=a("<div>",{"class":"headerHandle"});
if(this._block){if(this._headerTitle=this._headerHandle.append(this._block.getTitleElement()),this._block.isCollapsible()){var b=this,c=this._block.isCollapsed(),d=a("<i>",{"class":c?"icon icon-WCR_Right":"icon icon-WCR_Down"});this._collapseBtn=a("<a>",{"class":"btn btn-no-border dshToggleBtn",title:c?this._i18n.t("EXPAND"):this._i18n.t("COLLAPSE")}).append(d).click(function(c){c.preventDefault();a(this).toggleClass("collapsed");c=a(this).hasClass("collapsed");a(this).attr("title",c?b._i18n.t("EXPAND"):
b._i18n.t("COLLAPSE"));d.toggleClass("icon-WCR_Right",c);d.toggleClass("icon-WCR_Down",!c);b._block.collapse(c,!0)});this._collapseBtn.toggleClass("collapsed",c);this._headerHandle.prepend(this._collapseBtn)}}else this._headerTitle=this._headerHandle.append(a("<h4>"));this._headerButtons=a("<div>",{"class":"buttons"});if(this._block&&(c=this._block.getHeaderButtons())&&0<c.length)this._hasCustomHeaderButtons=!0,this._headerButtons.append(c);this._deleteBtn=a("<a>",{"class":"btn btn-no-border",title:this._i18n.t("DELETE_BLOCK")}).append(a("<i>",
{"class":"icon icon-WCR_Actions-Delete12"})).click(function(a){a.preventDefault();this.deleteBlock()}.bind(this));this._configureBtn=a("<a>",{"class":"btn btn-no-border",title:this._i18n.t("EDIT_BLOCK_CONFIGURATION")}).append(a("<i>",{"class":"icon icon icon-WCR_Actions-Edit12"})).click(function(){this._enableBlockConfiguration()}.bind(this));this._saveButton=a("<a>",{"class":"btn btn-no-border save hidden",title:this._i18n.t("PREVIEW_BLOCK_CONFIGURATION")}).append(a("<i>",{"class":"icon icon-WCR_Actions-Eye12"}));
this._cancelButton=a("<a>",{"class":"btn btn-no-border hidden",title:this._i18n.t("CANCEL_BLOCK_CONFIGURATION")}).append(a("<i>",{"class":"icon icon-WCR_Revert12"}));this._saveButton.click(function(){this.setConfiguring(!1);this._block.onConfigurationPanelClosed()}.bind(this));this._headerButtons.append(this._deleteBtn).append(this._configureBtn).append(this._saveButton);this._header.append(this._headerHandle)}};d.prototype._enableBlockConfiguration=function(){this.setConfiguring(!0);this.isConfiguring()&&
!this._configurationPanel?this._blockPromise.then(function(a){return a.getConfigurationPanel()}).then(function(a){this._configurationPanel=a;this._render()}.bind(this)):this.isConfiguring()&&this._configurationPanel&&this._render()};d.prototype.deleteBlock=function(){return this._blockPromise.then(function(a){this._context.detachBlock([this.getParent()],a)}.bind(this))};d.prototype.getWrappedBlockID=function(){return this._blockID};d.prototype._doConfigure=function(a){var c=this;c._blockID=a.blockID;
return c._context.getLanguageBundle("Dashboard").then(function(a){c._i18n=a;var b=c._registerFutureChild(c._blockID);c._blockPromise=c._context.loadBlock(c._blockID).then(function(a){c._block=a;c._observe(a,"parameter.changed.blockTitle",c._render);c._observe(a,"parameter.changed.blockShowFrame",c._render);c._observe(a,"parameter.changed.blockFrameColor",c._render);c._observe(a,"parameter.changed.blockShowInEditMode",c._render);c._observe(a,"configured",c._blockConfigured);c._registerChild(a)}).then(function(){c.once("render",
b);c._render();return c._block});c._registerLoadingStart();c._render()})};d.prototype._registerLoadingStart=function(){this._loadingStart=Date.now()};d.prototype._doInit=function(){this._observe(this._context,"editModeActive",this._render)};d.prototype.canConfigure=function(){return this.allowConfigure()&&this._block&&this._block.canConfigure()};e.prototype.allowConfigure=function(){return this._context.isEditModeActive()};d.prototype.isConfiguring=function(){return this._isConfiguring};d.prototype.setConfiguring=
function(a){this._isConfiguring!=a&&(this._isConfiguring=a,this._registerLoadingStart(),this._render());!a&&this._configurationPanel&&(this._configurationPanel.destroy(),this._configurationPanel=null)};d.prototype._shouldShowFrame=function(){return this.allowConfigure()||this._block&&(this._block.shouldShowFrame()||this._block.showAlwaysTransparentFrame())};d.prototype._doRender=function(){var b=this._block?this._block.getParameterByName("blockShowInEditMode"):void 0;if(b&&this.canConfigure()&&b.getValue()&&
250<=this._element[0].offsetWidth)b.setValue(!1),this._enableBlockConfiguration();else{var c=this._shouldShowFrame(),b={divDisplayed:null,showFrame:c||!1,showHeader:c||this._block&&this._block.showAlwaysTransparentFrame(),showHeaderButtons:!1,showLoadingIndicator:!1,headerElement:this._headerTitle,blockInDOM:!1};if(c){this._initHeader();if(this._block){b.headerElement=this._block.getTitleElement();var d="",c="";this._block.shouldShowFrame()?(d=this._block.getFrameColor(),c=f.calculateContrastColor(d)):
!this._context.isEditModeActive()&&this._block.showAlwaysTransparentFrame()&&(d="transparent");this._header.css({"background-color":d,color:c});this.allowConfigure()&&(this._block&&!this._block.shouldShowFrame())&&(d="transparent");this._element.css("border-color",d);this._headerButtons&&("#000000"==c&&(c=""),this._headerButtons.find("i").css("color",c))}b.showHeaderButtons=this.allowConfigure()||this._hasCustomHeaderButtons;this._saveButton.toggleClass("hidden",!this.isConfiguring());this._configureBtn.toggleClass("hidden",
!this.canConfigure()||this.isConfiguring());this._deleteBtn.toggleClass("hidden",!this.allowConfigure());this._collapseBtn&&this._collapseBtn.toggleClass("hidden",this.allowConfigure())}this._block&&!this.isConfiguring()||this._configurationPanel?this.isConfiguring()?this._configurationModal||250>this._element[0].offsetWidth?(this._block&&(b.divDisplayed=this._block.getElement(),b.blockInDOM=!0),this._openConfigurationPanelInModal()):b.divDisplayed=this._configurationPanel.getElement():(b.divDisplayed=
this._block.getElement(),b.blockInDOM=!0):250<Date.now()-this._loadingStart?b.showLoadingIndicator=!0:setTimeout(this._render.bind(this),250);if(!g.isEqual(this._previousState,b)){this._headerTitle&&this._headerTitle.children().detach();b.headerElement&&(this._headerTitle=this._headerHandle.append(b.headerElement));this._collapseBtn&&this._headerHandle.prepend(this._collapseBtn);if(this._previousState.divDisplayed!=b.divDisplayed||b.showLoadingIndicator||this._previousState.showHeader!=b.showHeader||
this._previousState.initial)this._element.children().detach(),this._element.empty(),this._element.append(this._header),b.showLoadingIndicator?this._element.append(a("<span>",{text:this._i18n.t("LOADING_BLOCK")})):this._element.append(b.divDisplayed);this._element.toggleClass("showFrame",b.showFrame);this._element.toggleClass("allowDrag",this.allowConfigure());this._header&&this._header.toggleClass("hidden",!b.showHeader);b.showHeaderButtons?this._header.append(this._headerButtons):this._headerButtons&&
this._headerButtons.detach();this._element.toggleClass("blockloading",b.showLoadingIndicator||null===b.divDisplayed);this._block&&this._block.setInDOM(b.blockInDOM&&this.isInDOM());this._previousState=b}this._dragDropHandler?this.toggleDragging():this.allowConfigure()&&this._context.getDragDropHandler().then(function(a){this._dragDropHandler=a;this.toggleDragging()}.bind(this));!this.isConfiguring()&&this._configurationPanel&&(this._configurationPanel.destroy(),this._configurationPanel=null)}};d.prototype._openConfigurationPanelInModal=
function(){this._configurationModal||(this._configurationModal=new b(this._configurationPanel.getElement(),{widthClass:"modal-lg",onClose:function(){this.setConfiguring(!1);this._configurationModal.destroy();this._configurationModal=null}.bind(this),closeOnBackdropClick:!1}),this._configurationModal.setTitle(this._block.getTitle()),this._configurationModal.open(),this._configurationModal.setFooter(a("<div>").append(a("<a>",{"class":"btn btn-primary",text:this._i18n.t("SAVE_BLOCK_CONFIGURATION")}).click(function(){this._configurationModal.close()}.bind(this)))))};
d.prototype.toggleDragging=function(){this._dragDropHandler.toggleDragging(this.allowConfigure(),this._context,this._context.getBlockDefinition(this._blockID),this.getParent(),this._element,this._headerHandle)};d.prototype._blockConfigured=function(){this.isConfiguring()&&this._block.getConfigurationPanel().then(function(a){this._configurationPanel=a;this._render()}.bind(this))};d.prototype.setParent=function(a){e.prototype.setParent.call(this,a);null===a&&this._block&&this._block.setParent(null)};
d.prototype._childInDOM=function(a){return a==this._block&&this._previousState.blockInDOM};return d});
define("dashboard/core/Layout",["./Block","../layout/BlockWrapper","underscore"],function(e,f){var b=function(a,b){e.call(this,a,b);this._element.addClass("dshLayout")};b.prototype=Object.create(e.prototype);b.prototype.constructor=b;b.prototype.getType=function(){return"dashboard/core/Layout"};b.prototype._initTitleAndFrameParameters=function(){return e.prototype._initTitleAndFrameParameters.apply(this,arguments).then(function(){var a=this._parameters.getParameter("blockFrameColor");a.setValue("#ececec");
a.dontPersistIfDefaultValue("#ececec")}.bind(this))};b.prototype._getBlockConfiguration=function(){return this._getLayoutSpecificConfiguration()};b.prototype._findChildrenForPersistence=function(){return this.findChildren(function(a){return a instanceof b},!1,function(a){return a instanceof f})};b.prototype.shouldShowFrame=function(){return e.prototype.shouldShowFrame.call(this)||this._context.isEditModeActive()};b.prototype._getLayoutSpecificConfiguration=function(){return{}};b.prototype._loadBlockWrapper=
function(a){return this._context.registerAndLoadBlock({type:"dashboard/layout/BlockWrapper",config:{blockID:a}})};b.prototype.prependBlock=function(a){return this.prependBlocks([a])};b.prototype.prependBlocks=function(a){a=a.concat(this.getItemList());return this.setItemList(a)};b.prototype.appendBlock=function(a){return this.appendBlocks([a])};b.prototype.appendBlocks=function(a){a=this.getItemList().concat(a);return this.setItemList(a)};b.prototype.getItemList=function(){return Promise.reject("Not implemented")};
b.prototype.setItemList=function(){return Promise.reject("Not implemented")};return b});define("utils/webcss-text!dashboard/Dashboard.css",[],function(){return".dashboardBlockPlaceholder {\r\n\tmargin: 0;\r\n\ttext-align: center;\r\n\tfont-size: 16px;\r\n\tcolor: #cacaca;\r\n\tline-height: 32px;\r\n\tpadding: 24px;\r\n\tbackground-color: #f5f5f5;\r\n}\r\n.dshBlockWrapper>.header .dshToggleBtn {\r\n\tpadding-left: 0;\r\n\tpadding-right: 5px;\r\n\tcolor: inherit;\r\n}\r\n.dshFlexLayout,\r\n.dshBuilderConstrainedHeight {\r\n\tdisplay: -ms-flex;\r\n\tdisplay: -webkit-flex;\r\n\tdisplay: flex;\r\n}\r\n.dshFlexItem,\r\n.dshFlexItem>div,\r\n.dshFlexItem>div>div,\r\n.dshBlockGallery {\r\n\tdisplay: -ms-flex;\r\n\tdisplay: -webkit-flex;\r\n\tdisplay: flex;\r\n\t-ms-flex-direction: column;\r\n\t-webkit-flex-direction: column;\r\n\tflex-direction: column;\r\n}\r\n.dshFlexItem>div,\r\n.dshFlexItem>div>div,\r\n.dshBuilderConstrainedHeight>.dshLayout {\r\n\t-ms-flex: 1 0 auto;\r\n\t-webkit-flex: 1 0 auto;\r\n\tflex: 1 0 auto;\r\n}\r\n.dshBuilderConstrainedHeight>.dshLayout {\r\n\t-ms-flex: 1 1 auto;\r\n\t-webkit-flex: 1 1 auto;\r\n\tflex: 1 1 auto;\r\n\t-ms-flex-wrap: nowrap !important;\r\n\t-webkit-flex-wrap: nowrap !important;\r\n\tflex-wrap: nowrap !important;\r\n\tmin-height: 330px;\r\n}\r\n.dshBuilderConstrainedHeight .dshBuilderLayout,\r\n.dshBuilderConstrainedHeight .dshBuilderGallery {\r\n\toverflow-y: auto;\r\n}\r\n.dshBuilderConstrainedHeight .dshBuilderGallery>div {\r\n\tpadding-bottom: 0 !important;\r\n\tpadding-left: 5px !important;\r\n\toverflow-x: hidden;\r\n}"});
define("dashboard/Dashboard",["./core/Block","./core/Layout","underscore","utils/webcss!./Dashboard.css"],function(e,f){var b=function(a,b){e.call(this,a,b);this._builderError=this._builder=this._builderPromise=this._layoutError=this._layout=this._layoutPromise=this._layoutID=null;this._observe(this._context,"editModeActive",this._render)};b.prototype=Object.create(e.prototype);b.prototype.constructor=b;b.prototype.getType=function(){return"dashboard/Dashboard"};b.prototype._doConfigure=function(a,
b){var d=this;return this._context.getLanguageBundle("Dashboard").then(function(e){d._i18n=e;return d._setLayout(a.layout,b)})};b.prototype._doInit=function(){this._context.isEditModeActive()&&this._loadBuilder()};b.prototype._getBlockConfiguration=function(a){return this._layoutPromise.then(function(b){return b.getConfiguration(a)}).then(function(a){return{layout:a}})};b.prototype._findChildrenForPersistence=function(){return this._layoutPromise.then(function(a){return a.findChildren(function(a){return a.isPersistent()&&
!(a instanceof f)},!0,!0)})};b.prototype._setLayout=function(a,b){this._layout&&(this.detachChild(this._layout),this._layout=null);var d=this._layoutID=this._context.registerBlock(a,b);this._layoutPromise=this._context.loadBlock(this._layoutID);this._layoutError=null;var e=this._registerFutureChild(d);this._render();var c=this;return this._layoutPromise.then(function(a){c._layoutID===d&&(c._layout=a,c._render())}).catch(function(b){c._layoutID===d&&(console&&console.log("Error initializing layout for Dashboard",
arguments),c._layoutError=c._generateUserfriendlyException(b,a),c._render())}).then(function(){c.once("render",e)})};b.prototype._loadBuilder=function(){var a=this,b={type:"dashboard/builder/DashboardBuilder",config:{dashboard:a,layout:null}},d=this._registerFutureChild("BUILDER");this._layoutPromise.then(function(){b.config.layout=a._layout;a._builderPromise=a._context.registerAndLoadBlock(b).then(function(b){a.once("render",d);return b}).then(function(b){a._builder=b;a._render()}).catch(function(d){a._builderError=
a._generateUserfriendlyException(d,b);a._render()})})};b.prototype.getLayout=function(){return this._layoutPromise};b.prototype.prependBlock=function(a){return this._layoutPromise.then(function(b){return b.prependBlock(a)})};b.prototype.prependBlocks=function(a){return this._layoutPromise.then(function(b){return b.prependBlocks(a)})};b.prototype._doRender=function(){this._element.contents().detach();this._context.isEditModeActive()?(this._layout&&this._layout.setInDOM(!1),this._builder?(this._registerChild(this._builder),
this._element.append(this._builder.getElement()),this._builder.activate(!0),this._builder.setInDOM(this.isInDOM())):this._builderError?this._element.append(this._builderError):(this._builderPromise||this._loadBuilder(),this._element.text(this._i18n.t("LOADING_BLOCK")))):(this._builder&&(this._builder.activate(!1),this._builder.setInDOM(!1)),this._layout?(this._registerChild(this._layout),this._element.append(this._layout.getElement()),this._layout.setInDOM(this.isInDOM())):this._layoutError?this._element.append(this._layoutError):
this._element.text(this._i18n.t("LOADING_BLOCK")))};b.prototype._generateUserfriendlyException=function(a,b,d){var e=document.createElement("div");e.className="alert alert-danger";this._context.getLanguageBundle("Dashboard").then(function(c){var i=document.createElement("p");i.textContent=c.t("ERROR_UNEXPECTED_BLOCK");e.appendChild(i);if(a&&(a.message||a.stack)||b||d){var f=document.createElement("a");f.textContent=c.t("ERROR_UNEXPECTED_DETAILS");var l=!1,h=null;f.addEventListener("click",function(){if(l)e.removeChild(h),
f.textContent=c.t("ERROR_UNEXPECTED_DETAILS"),l=!1;else{h=document.createElement("pre");var i=[];a.message&&i.push(a.message);a.stack&&i.push(a.stack);if(b)try{i.push("Block Definition: \r\n"+JSON.stringify(b,null,"  "))}catch(n){i.push("Could not generate block definition \r\n"+n)}d&&i.push(d);h.textContent=i.join("\r\n\r\n---------------------------------------------\r\n\r\n");f.textContent=c.t("ERROR_UNEXPECTED_HIDE_DETAILS");e.appendChild(h);l=!0}});e.appendChild(f)}});return e};b.prototype._childInDOM=
function(a){return a==(this._context.isEditModeActive()?this._builder:this._layout)};return b});
define("dashboard/core/parameters/LinkedParameter",["./Parameter","utils/Observer","utils/Promisify"],function(e,f,b){var a=function(a,b,j,c,i,k,l){e.call(this,a,b,"dashboard/core/parameters/LinkedParameter",j);f.mixin(this);this._linkedSet=c;this._allowPushValue=l;this._linkedType=i;this._linkedName=null;this.setLinkedName(k)};a.prototype=Object.create(e.prototype);a.prototype.constructor=a;a.prototype.setLinkedName=function(a){if(this._linkedName!==a){var b=this.getValue();this._stopObserveAll();
this._linkedName=a;this._observe(this._linkedSet,["changed",a].join("."),this._emitChanged);this._emitChanged(b,this.getValue())}};a.prototype.getLinkedName=function(){return this._linkedName};a.prototype.getLinkedType=function(){return this._linkedType};a.prototype.setLinkedType=function(a){this._linkedType=a};a.prototype.configure=function(a){this.setLinkedName(a.linkedName);this.setLinkedType(a.linkedType)};a.prototype._getLinkedParameter=function(){return this._linkedSet.getParameter(this._linkedName)};
a.prototype.getValue=function(){var a=this._getLinkedParameter();if(a)return a.getValue()};a.prototype.setValue=function(a){this._allowPushValue&&this._getLinkedParameter()&&this._getLinkedParameter().setValue(a)};a.prototype.isConfigurableByUser=function(){return this._configurableByUser&&this._allowPushValue};a.prototype._getParameterSpecificConfig=function(){return{linkedName:this.getLinkedName(),linkedType:this.getLinkedType()}};a.prototype.getConfigurationPanel=function(){return b.require("dashboard/builder/configuration/parameters/LinkedParameterConfigurationPanel").then(function(a){return new a(this)}.bind(this))};
return a});
define("dashboard/core/parameters/NumberParameter",["./Parameter","utils/Promisify"],function(e,f){var b=function(a,b,d,j,c,i,f,l){e.call(this,a,b,this.getType(),d,f,l);this._defaultNumber=j;this._constraints=c;this._units=i||[]};b.prototype=Object.create(e.prototype);b.prototype.constructor=b;b.prototype.getType=function(){"dashboard/core/parameters/NumberParameter"};b.prototype.getDefaultNumber=function(){return this._defaultNumber};b.prototype.getConstraints=function(){return this._constraints};b.prototype.getUnits=
function(){return this._units};b.prototype.getConfigurationPanel=function(){return f.require("dashboard/builder/configuration/parameters/NumberParameterConfigurationPanel").then(function(a){return new a(this)}.bind(this))};return b});
define("dashboard/core/parameters/CssSizeParameter",["./NumberParameter","utils/Promisify"],function(e){var f=function(b,a,f,d){e.call(this,b,a,f,"",{type:"int",max:999,min:0},d||["px","%","em"])};f.prototype=Object.create(e.prototype);f.prototype.constructor=f;f.prototype.getType=function(){return"dashboard/core/parameters/CssSizeParameter"};return f});define("utils/webcss-text!dashboard/layout/ListLayout.css",[],function(){return".ListLayout>.ghost {\r\n\tborder: 1px dotted #ccc;\r\n\tpadding: 10px;\r\n\tmargin: 5px;\r\n}\r\n.dshBuilder .dshBuilderLayout>div>.ListLayout {\r\n\tpadding-top: 5px;\r\n\tpadding-bottom: 40px;\r\n}\r\n.ListLayout.isDroppable {\r\n\tmin-height: 30px;\r\n}"});
define("dashboard/layout/ListLayout","../core/Layout utils/Promisify ../core/parameters/CssSizeParameter underscore utils/webcss!./ListLayout.css lib/PromisePolyfill".split(" "),function(e,f,b,a){var g=function(a,b){e.call(this,a,b);this._element.addClass("ListLayout");this._list=[]};g.prototype=Object.create(e.prototype);g.prototype.constructor=g;g.prototype.getType=function(){return"dashboard/layout/ListLayout"};g.prototype.canConfigure=function(){return!0};g.prototype._doConfigure=function(b,e){if(b.items){var c=
a.map(b.items,function(b){var b=e.mapID(b.id),c=a.findWhere(this._list,{id:b});return c?c:{id:b}},this);return this._updateList(c)}this._render()};g.prototype._doInit=function(){this._observe(this._context,"editModeActive",this._initializeDropzone);this._initializeDropzone();this._observe(this._context,"CssSizeParameter",this._render)};g.prototype._doRender=function(){for(var a=this._parameters.getParameter("CssSizeParameter").getValue(),b=0;b<this._list.length-1;b++)this._list[b].blockWrapper._element.css("margin-bottom",
a)};g.prototype._waitForList=function(b){return Promise.all(a.map(b,function(a){a.blockWrapperPromise||(a={id:a.id,blockWrapperPromise:this._loadBlockWrapper(a.id)},this._registerFutureChild(a.id));return a.blockWrapperPromise.then(function(b){a.blockWrapper=b;return a})}.bind(this)))};g.prototype._markListProcessed=function(b){a.each(b,function(a){this._markFutureChildResolved(a.id)},this)};g.prototype._updateList=function(b){var e=this,b=a.map(b,function(b){var c=a.findWhere(this._list,{id:b.id});
return c?c:{id:b.id}},this),c=e._list.slice(0);return Promise.all([this._waitForList(c),this._waitForList(b)]).then(function(b){for(var c=b[0],d=b[1],f=0,g=0;g<d.length;g++)if(c[f]===d[g])f++;else{var b=d[g],n=a.indexOf(c,b);0<=n&&c.splice(n,1);e._registerChild(b.blockWrapper);d[g-1]?d[g-1].blockWrapper.getElement().after(b.blockWrapper.getElement()):e._element.prepend(b.blockWrapper.getElement());b.blockWrapper.setInDOM(e.isInDOM())}for(;f<c.length;)b=c[f++],b.blockWrapper.setInDOM(!1),b.blockWrapper.getElement().detach(),
b.blockWrapper.setParent(null);e._list=d;e._render();e._markListProcessed(c);e._markListProcessed(d)})};g.prototype._getLayoutSpecificConfiguration=function(){return{items:a.map(this._list,function(a){return{id:a.id}})}};g.prototype.detachChild=function(b){e.prototype.detachChild.call(this,b);b.getWrappedBlockID&&(this._list=a.filter(this._list,function(a){return a.id!==b.getWrappedBlockID()}))};g.prototype._getItemForID=function(b){return a.findWhere(this._list,{id:b})};g.prototype._initializeDefaultParameters=
function(){return this._context.getLanguageBundle("ListLayout").then(function(a){a=new b("CssSizeParameter",this._context,a.t("SPACING"));a.setValue("10px");this._addParameter(a);this._observeParam("CssSizeParameter",function(){this._render()}.bind(this))}.bind(this))};g.prototype._initializeDropzone=function(){this._context.isEditModeActive()&&f.require("dashboard/layout/ListLayoutDragDrop").then(function(){this._ddInitializeDropzone()}.bind(this));this._element.toggleClass("isDroppable",this._context.isEditModeActive())};
g.prototype.getItemList=function(){return a.pluck(this._list,"id")};g.prototype.setItemList=function(b){b=a.map(b,function(a){return{id:a}});return this._updateList(b)};return g});
define("dashboard/layout/flex/FlexItem",["jquery","underscore"],function(e,f){var b=function(a,b,d,f){this._layout=a;this._columnID=b;this._block=this._blockPromise=this._blockID=null;this._element=e("<div>",{"class":"dshFlexItem"});this._wrapper=e("<div>");this._element.append(this._wrapper);this._isPlaceholder=this._contentElement=null;this.configure(d,f);this._layout._initializePlaceholder(this)};b.prototype.setID=function(a){this._columnID!=a&&(this._columnID=a,this.applyColumnStyles())};b.prototype.getID=
function(){return this._columnID};b.prototype.configure=function(a,b){this._config=f.pick(a,"fitContent","grow","shrink","width","height","maxWidth","minWidth","lockedColumn","minWidthIsContent","className");this._totalColumns=b;a.blockid?this.setItem(a.blockid):this.setItem(null);this._element.removeClass();this._element.addClass("dshFlexItem");this._config.className&&this._element.addClass(this._config.className);this.applyColumnStyles()};b.prototype.setItem=function(a){if(this._blockID!==a){if(this._block){var b=
this._block;this._block=null;b.setInDOM(!1);this._layout.detachChild(b)}if(a){this._layout._context.getDragDropHandler().then(function(a){this._isPlaceholder&&(a.removeDropzone(this.getElement()),this._isPlaceholder=null)}.bind(this));this._blockID=a;var d=this._layout._registerFutureChild(this._blockID);this._blockPromise=this._config.lockedColumn?this._layout.getContext().loadBlock(this._blockID):this._layout.loadBlockWrapper(this._blockID);this._blockPromise.then(function(b){this._blockID===a&&
(this._replaceElement(b.getElement()),this._layout._registerChild(b),b.setInDOM(this._layout.isInDOM()),this._block=b);d()}.bind(this))}else this._block=this._blockPromise=this._blockID=null,this._layout._initializePlaceholder(this)}};b.prototype.getBlockPromise=function(){return this._blockPromise};b.prototype.makePlaceholder=function(a){this._replaceElement(a);this._isPlaceholder=!0};b.prototype._replaceElement=function(a){this._wrapper.children().detach();this._wrapper.append(a);this._contentElement=
a;this.applyColumnStyles()};b.prototype.getConfiguration=function(){var a=f.pick(this._config,"fitContent","grow","shrink","width","height","maxWidth","minWidth","lockedColumn","minWidthIsContent","className");this._blockID&&(a.blockid=this._blockID);return a};b.prototype.getElement=function(){return this._element};b.prototype.getBlockID=function(){return this._blockID};b.prototype.hasWidthDefined=function(){return(this._config.width||this._config.minWidth||this._config.maxWidth||this._config.fitContent||
this._config.minWidthIsContent)&&!0};b.prototype.applyColumnStyles=function(){this._element.attr("data-column",this._columnID);var a=!0,b=!1,d=this._config.width||this._config.minWidth||this._config.maxWidth;this._config.fitContent&&(d="auto");d||(d=Math.floor(100/this._totalColumns)+"%");d={"-webkit-flex":this._config.grow+" "+this._config.shrink+" "+d,"-ms-flex":this._config.grow+" "+this._config.shrink+" "+d,flex:this._config.grow+" "+this._config.shrink+" "+d};!this._blockID&&this._layout._context.isEditModeActive()&&
(this._contentElement||(this._contentElement=e("<div>",{css:{width:"100px"}}),this._wrapper.append(this._contentElement)),this._contentElement.css({border:"1px dotted #ccc",padding:"10px",margin:"5px"}));this._config.width?d.width=this._config.width:0<this._config.grow&&0<this._config.shrink&&!this._config.fitContent?(d.width="100%",a=!1):this._config.fitContent&&(d.width="auto",b=!0,a=!1);this._config.height&&(d.height=this._config.height);this._config.maxWidth&&(d["max-width"]=this._config.maxWidth);
d["min-width"]=this._config.minWidth?this._config.minWidth:this._config.minWidthIsContent?"":0;this._element.css(d);d=this._layout._spacingParameter.getValue();this._wrapper.css({"padding-left":d,"padding-bottom":d});this._element.toggleClass("columnwidthdecided",a);this._element.toggleClass("columnwidthfittocontent",b)};b.prototype.getBlock=function(){return this._block};b.prototype.getLayout=function(){return this._layout};return b});
define("dashboard/layout/flex/FlexLayoutBlockWrapper",["../BlockWrapper","jquery"],function(e){var f=function(b,a){e.call(this,b,a)};f.prototype=Object.create(e.prototype);f.prototype.constructor=f;f.prototype.toggleDragging=function(){this._dragDropHandler.toggleDragging(this.allowConfigure(),this._context,this._context.getBlockDefinition(this._blockID),this.getParent(),this._element,this._headerHandle,function(b,a){var e=this.getParent(),d=e.getFlexItemForID(this._block.getID());e.replaceColumnWithBlock(d.getID(),
null);a.helper.data("FlexLayoutFlexItem",d)}.bind(this),function(b,a){var e=a.helper.data("FlexLayoutFlexItem");e.getLayout().replaceColumnWithBlock(e.getID(),this._block.getID())}.bind(this))};return f});
define("dashboard/layout/flex/FlexColumnParameter","dashboard/core/parameters/Parameter ./FlexItem dashboard/core/IDMap utils/Promisify underscore lib/PromisePolyfill".split(" "),function(e,f,b,a,g){b=function(a,b,c,f){e.call(this,a,b,"dashboard/layout/flex/ColumnParameter",f);this._columns=[];this._layout=c;this._toBeDeleted=[]};b.prototype=Object.create(e.prototype);b.prototype.constructor=b;b.prototype.getConfigurationPanel=function(){return Promise.all([a.require("dashboard/layout/flex/FlexLayoutConfigurationPanel"),
this._context.getLanguageBundle("DashboardFlexLayout")]).then(function(a){return new a[0](this,a[1])}.bind(this))};b.prototype.configure=function(a,b){g.each(a.value.columns,function(a){a.blockid=b.mapID(a.blockid)});this.setValue(a.value)};b.prototype.getItemList=function(){return this._columns.slice(0)};b.prototype.setItem=function(a,b){this.getItemList()[a].setItem(b);this.setValue(this._getSpecification())};b.prototype._getSpecification=function(){return{columns:g.map(this.getItemList(),function(a){return a.getConfiguration()})}};
b.prototype.getBlockTitle=function(a){return this._context.loadBlock(a).then(function(a){return a.getTitle()})};b.prototype.update=function(){this.setValue(this._getSpecification())};b.prototype.getToBeDeletedItems=function(){return this._toBeDeleted.splice(0,this._toBeDeleted.length)};b.prototype.shouldWrap=function(){return g.some(this._columns,function(a){return a.hasWidthDefined()})};b.prototype.setValue=function(a){this._layout._element.css("overflow-x","auto");var b=this._columns.slice(0),c=
0;this._columns=[];for(var i=a.columns.length,g=0;g<a.columns.length;g++){var l=b[c],h=a.columns[g];if(l&&l.getBlockID()===h.blockid)this._columns[g]=l,this._columns[g].configure(h,i),c++;else{for(var m=c,l=null;m<b.length&&!l;)b[m].getBlockID()===h.blockid?(l=b[m],b.splice(m,1)):m++;l?l.configure(h,i):l=new f(this._layout,g,h,i);this._columns[g]=l}this._columns[g].setID(g)}for(;c<b.length;)i=b[c++],this._toBeDeleted.push(i);e.prototype.setValue.apply(this,arguments)};return b});
define("dashboard/layout/flex/FlexLayout","./FlexItem utils/Promisify ../../core/Layout underscore ./FlexLayoutBlockWrapper dashboard/core/parameters/CssSizeParameter dashboard/layout/flex/FlexColumnParameter".split(" "),function(e,f,b,a,g,d,j){e=function(a,d){b.call(this,a,d);this._element.addClass("dshFlexLayout");this._observe(this,"child.detach",this._onChildDetached)};e.prototype=Object.create(b.prototype);e.prototype.constructor=e;e.prototype.getType=function(){return"dashboard/layout/flex/FlexLayout"};
e.prototype._doConfigure=function(){this._element.css("overflow-x",this._context.isEditModeActive()?"auto":"");for(var a=this._columnParameter.getItemList(),b=0;b<a.length;b++)this._element.append(a[b].getElement());a=this._columnParameter.getToBeDeletedItems();for(b=0;b<a.length;b++){var d=a[b];d.getElement().detach();d.getBlockPromise()&&d.getBlockPromise().then(function(a){a.setInDOM(!1);a.setParent(null)})}};e.prototype._loadBlockWrapper=function(a){return this._context.registerAndLoadBlock({type:"dashboard/layout/flex/FlexLayoutBlockWrapper",
config:{blockID:a}})};e.prototype._doInit=function(){var b=this;b._observe(b._context,"editModeActive",b._initializeDropzone);b._initializeDropzone();b._observeParam("FlexColumnParameter",function(){b._columnParameter.getConfiguration().then(function(a){b._doConfigure(a.config);b._render()})});b._observeParam("CssSizeParameter",function(){a.each(b._columnParameter.getItemList(),function(a){a.applyColumnStyles();b._render()})});b._render()};e.prototype._doRender=function(){var a="";this._spacingParameter.getValue()&&
(a="-"+this._spacingParameter.getValue());a={"margin-bottom":a,"margin-left":a};this._columnParameter.shouldWrap()&&(a["-webkit-flex-wrap"]="wrap",a["-ms-flex-wrap"]="wrap",a["flex-wrap"]="wrap");this._element.css(a)};e.prototype.replaceColumnWithBlock=function(a,b){this._columnParameter.setItem(a,b)};e.prototype._onChildDetached=function(b){a.each(this._columnParameter.getItemList(),function(a){a.getBlock()===b&&a.setItem(null)});this._columnParameter.update()};e.prototype.loadBlockWrapper=function(a){return this._loadBlockWrapper(a)};
e.prototype._initializeDropzone=function(){this._context.isEditModeActive()&&f.require("dashboard/layout/flex/FlexLayoutDragDrop").then(function(){a.each(this._columnParameter.getItemList(),function(a){this._initializePlaceholder(a)}.bind(this))}.bind(this))};e.prototype.getFlexItemForID=function(b){return a.find(this._columnParameter.getItemList(),function(a){return a.getBlockID()===b})};e.prototype._initializePlaceholder=function(){};e.prototype._initializeDefaultParameters=function(){return this._context.getLanguageBundle("FlexLayout").then(function(a){this._spacingParameter=
new d("CssSizeParameter",this._context,a.t("SPACING"));this._spacingParameter.setValue("10px");this._addParameter(this._spacingParameter);this._columnParameter=new j("FlexColumnParameter",this._context,this,"");this._addParameter(this._columnParameter)}.bind(this))};return e});
define("dashboard/i18n/LanguageBundle",[],function(){var e=function(){};e.prototype.getValueForKey=function(){};e.prototype.t=function(e){var b=this.getValueForKey(e);"undefined"===typeof b&&(b=e);return this.substitute(b,Array.prototype.slice.call(arguments,1))};e.prototype.tFallback=function(e,b){var a=this.getValueForKey(e);"undefined"===typeof a&&(a=b);return this.substitute(a,Array.prototype.slice.call(arguments,2))};e.prototype.substitute=function(e,b){for(var a=0;a<b.length;a++)e=e.replace("{"+
a+"}",b[a]);return e};return e});define("dashboard/i18n/LanguageProvider",["./LanguageBundle","lib/PromisePolyfill"],function(e){var f=function(){};f.prototype.getLanguageBundle=function(){return Promise.resolve().then(function(){return new e})};return f});
define("component/dashboard/i18n/WebCenterLanguageBundle",["dashboard/i18n/LanguageBundle","utils/Promisify"],function(e){var f=function(b){e.call(this);this._bundle=b};f.prototype=Object.create(e.prototype);f.prototype.constructor=f;f.prototype.getValueForKey=function(b){return this._bundle.asMap()[b]};return f});
define("component/dashboard/i18n/WebCenterLanguageProvider",["dashboard/i18n/LanguageProvider","./WebCenterLanguageBundle","utils/Promisify"],function(e,f,b){var a=function(){e.call(this)};a.prototype=Object.create(e.prototype);a.prototype.constructor=a;a.prototype.getLanguageBundle=function(a){return b.require("utils/webi18n!"+a).then(function(a){return new f(a)})};return a});