/**
  A javascript Bezier curve library by Pomax.

  Based on http://pomax.github.io/bezierinfo

  This code is MIT licensed.
**/

/**
 * Copyright 2015 Craig Campbell
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * Mousetrap is a simple keyboard shortcut library for Javascript with
 * no external dependencies
 *
 * @version 1.5.3
 * @url craig.is/killing/mice
 * 
 * NOTICE: changed by Esko (TAKE INTO ACCOUNT WHEN INTEGRATING NEW VERSION!):
 * 	- fixed support for "-"-key
 *  - allow binding of multiple callbacks to 1 key combination
 *  - completely remove callback when unbinding
 *  - converted to UMD module
 */

define("utils/ShapeUtils",["underscore"],function(){var j=function(e,a){this.x=e?e:0;this.y=a?a:0};j.prototype.toString=function(){return this.x+"x"+this.y};j.prototype.copy=function(){return new j(this.x,this.y)};j.prototype.equals=function(e){return this.x==e.x&&this.y==e.y};j.prototype.sizeTo=function(e){return new f.Size(e.x-this.x,e.y-this.y)};j.prototype.offset=function(e){this.x+=e.width;this.y+=e.height};j.prototype.offsetXY=function(e,a){this.x+=e;this.y+=a};j.prototype.near=function(e,a){return Math.abs(this.x-
e.x)<=a&&Math.abs(this.y-e.y)<=a};j.prototype.getDistance=function(e){return Math.sqrt(Math.pow(this.x-e.x,2)+Math.pow(this.y-e.y,2))};j.prototype.round=function(){this.x=Math.round(this.x);this.y=Math.round(this.y);return this};j.prototype.containPointInRect=function(e){this.x>e.normRight()?this.x=e.normRight():this.x<e.normLeft()&&(this.x=e.normLeft());this.y>e.normBottom()?this.y=e.normBottom():this.y<e.normTop()&&(this.y=e.normTop())};var h=function(e,a){this.width=e?e:0;this.height=a?a:0};h.prototype.toString=
function(){return this.width+" x "+this.height};h.prototype.copy=function(){return new h(this.width,this.height)};h.prototype.equals=function(e){return this.width==e.width&&this.height==e.height};h.prototype.add=function(e){this.width+=e.width;this.height+=e.height};var b=function(e,a){this.origin=e?e:new j;this.size=a?a:new h};b.prototype.normalize=function(){0>this.size.width&&(this.origin.x+=this.size.width,this.size.width=Math.abs(this.size.width));0>this.size.height&&(this.origin.y+=this.size.height,
this.size.height=Math.abs(this.size.height))};b.prototype.containsPoint=function(e){var a=!1;this.origin.x<=e.x&&e.x<=Number(this.origin.x)+Number(this.size.width)&&this.origin.y<=e.y&&e.y<=Number(this.origin.y)+Number(this.size.height)&&(a=!0);return a};b.prototype.toString=function(){return"Origin: "+this.origin.toString()+" size: "+this.size.toString()};b.prototype.rectEquals=function(e,a){if(void 0===e||null===e)return!1;void 0===a&&(a=1E-6);return Math.abs(e.origin.x-this.origin.x)<=a&&Math.abs(e.origin.y-
this.origin.y)<=a&&Math.abs(e.size.width-this.size.width)<=a&&Math.abs(e.size.height-this.size.height)<=a};b.prototype.rectIntersect=function(e,a){var b=!(e.normLeft()>this.normRight()||e.normRight()<this.normLeft()||e.normTop()>this.normBottom()||e.normBottom()<this.normTop());return a&&b?(b=this.calculateOverlap(e),b.normalize(),b.size.width*b.size.height/(e.size.width*e.size.height)>a):b};b.prototype.right=function(){return this.origin.x+this.size.width};b.prototype.left=function(){return this.origin.x};
b.prototype.top=function(){return this.origin.y};b.prototype.bottom=function(){return this.origin.y+this.size.height};b.prototype.width=function(){return this.size.width};b.prototype.height=function(){return this.size.height};b.prototype.topleft=function(){return new j(this.left(),this.top())};b.prototype.topright=function(){return new j(this.right(),this.top())};b.prototype.bottomleft=function(){return new j(this.left(),this.bottom())};b.prototype.bottomright=function(){return new j(this.right(),
this.bottom())};b.prototype.topcenter=function(){return new j(this.center().x,this.top())};b.prototype.bottomcenter=function(){return new j(this.center().x,this.bottom())};b.prototype.centerleft=function(){return new j(this.left(),this.center().y)};b.prototype.centerright=function(){return new j(this.right(),this.center().y)};b.prototype.normRight=function(){return 0<=this.size.width?this.origin.x+this.size.width:this.origin.x};b.prototype.normLeft=function(){return 0<=this.size.width?this.origin.x:
this.origin.x+this.size.width};b.prototype.normTop=function(){return 0<=this.size.height?this.origin.y:this.origin.y+this.size.height};b.prototype.normBottom=function(){return 0<=this.size.height?this.origin.y+this.size.height:this.origin.y};b.prototype.normHeight=function(){return Math.abs(this.size.height)};b.prototype.normWidth=function(){return Math.abs(this.size.height)};b.prototype.center=function(){return new j(this.origin.x+this.size.width/2,this.origin.y+this.size.height/2)};b.prototype.setCenter=
function(e){this.origin.x=e.x-this.size.width/2;this.origin.y=e.y-this.size.height/2};b.prototype.containsRect=function(e,a){a||(a=0);var b=this.origin.x-a,f=this.origin.y-a,j=this.size.width+a,h=this.size.height+a,w=e.origin.x,s=e.origin.y,m=e.size.width,x=e.size.height;if(0>(j|h|m|x)||w<b||s<f)return!1;j+=b;m+=w;if(m<=w){if(j>=b||m>j)return!1}else if(j>=b&&m>j)return!1;h+=f;x+=s;if(x<=s){if(h>=f||x>h)return!1}else if(h>=f&&x>h)return!1;return!0};b.prototype.copy=function(){return new b(this.origin.copy(),
this.size.copy())};b.prototype.update=function(a,b){1==arguments.length?(this.size.width=a.x-this.origin.x,this.size.height=a.y-this.origin.y):(this.origin.x=a.x,this.origin.y=a.y,this.size.width=b.x-a.x,this.size.height=b.y-b.y)};b.prototype.calculateOverlap=function(a){var f=new j(Math.max(this.normLeft(),a.normLeft()),Math.max(this.normTop(),a.normTop())),a=new j(Math.min(this.normRight(),a.normRight()),Math.min(this.normBottom(),a.normBottom())),f=new b(f);f.update(a);return f};b.prototype.calculateArea=
function(a){var f=new j(Math.min(this.normLeft(),a.normLeft()),Math.min(this.normTop(),a.normTop())),a=new j(Math.max(this.normRight(),a.normRight()),Math.max(this.normBottom(),a.normBottom())),f=new b(f);f.update(a);return f};b.prototype.getNormalizedRectArray=function(){return[this.normLeft(),this.normTop(),this.normRight(),this.normBottom()]};var a=function(a,b,f){this.x=a?a:0;this.y=b?b:0;this.angleWhenZero=0==this.x&&0==this.y?f?f:0:this.getAngleInRadians()};a.prototype.toString=function(){return this.x+
","+this.y};a.prototype.copy=function(){return new a(this.x,this.y,this.angleWhenZero)};a.prototype.equals=function(a){return this.x==a.x&&this.y==a.y&&this.getAngleInRadians()==a.getAngleInRadians()};a.prototype.getLength=function(){return Math.sqrt(Math.pow(this.x,2)+Math.pow(this.y,2))};a.prototype.setLength=function(a){var b=this.getLength(),f=this.getAngleInRadians();0===b?(this.x=Math.cos(f)*a,this.y=Math.sin(f)*a):(a/=b,this.x*=a,this.y*=a);this.angleWhenZero=f};a.prototype.getAngleInDegrees=
function(){return 180*this.getAngleInRadians()/Math.PI};a.prototype.getAngleInRadians=function(){return 0===this.x&&0===this.y?this.angleWhenZero:Math.atan2(this.y,this.x)};a.prototype.setAngleInDegrees=function(a){this.setAngleInRadians(a*Math.PI/180)};a.prototype.setAngleInRadians=function(a){var b=this.getLength();this.angleWhenZero=a;this.x=b*Math.cos(a);this.y=b*Math.sin(a)};var f={Point:j,Size:h,Rect:b,Vector:a,rectMake:function(a,f,l,r){return new b(new j(a,f),new h(l,r))},rectFromNormalizedRectArray:function(a){return new b(new j(a[0],
a[1]),new h(a[2]-a[0],a[3]-a[1]))},calculateBoundingBoxRectArrays:function(a,b){return[Math.min(a[0],b[0]),Math.min(a[1],b[1]),Math.max(a[2],b[2]),Math.max(a[3],b[3])]},normalizedRectEquals:function(a,b){return a[0]===b[0]&&a[1]===b[1]&&a[2]===b[2]&&a[3]===b[3]},rectIntersection:function(a,b){var f,j,h,u;f=Math.max(a.left(),b.left());h=Math.max(a.top(),b.top());j=Math.min(a.right(),b.right());u=Math.min(a.bottom(),b.bottom());return this.rectMake(f,h,j-f,u-h)},rectIsNull:function(a){return 0==a.origin.x&&
0==a.origin.y&&0==a.size.width&&0==a.size.height}};return f});
define("utils/DashUtils",["underscore","utils/ShapeUtils"],function(j){function h(b,a,f,e,p,l,h){l||(l=[10,5]);void 0!==h&&null!==h&&(l=j.map(l,function(a){return Math.abs(a/h)}));var y=!0;void 0!==b.setLineDash?b.setLineDash(l):void 0!==b.mozDash?b.mozDash=l:y=!1;b.save();b.beginPath();var e=e-a,u=p-f,p=Math.sqrt(e*e+u*u),e=Math.atan2(u,e);b.translate(a,f);b.moveTo(0,0);b.rotate(e);if(y)b.lineTo(p,0);else{f=l.length;y=0;e=!0;for(a=0;p>a;)a+=l[y++%f],a>p&&(a=p),e?b.lineTo(a,0):b.moveTo(a,0),e=!e}b.stroke();
b.restore()}return{drawDash:function(b,a,f,e,p,l){var j=l.length,h=e-a,u=p-f,w=h>u,s=w?u/h:h/u;9999<s?s=9999:-9999>s&&(s=-9999);for(var m=Math.sqrt(h*h+u*u),x=0,v=!0;0.1<=m;){var c=l[x++%j];0===c&&(c=0.001);c>m&&(c=m);var i=Math.sqrt(c*c/(1+s*s));w?(a+=0>h&&0>u?-1*i:i,f+=0>h&&0>u?-1*s*i:s*i):(a+=0>h&&0>u?-1*s*i:s*i,f+=0>h&&0>u?-1*i:i);b[v?"lineTo":"moveTo"](a,f);m-=c;v=!v}b.moveTo(e,p)},drawDashedLine:h,drawDashedRect:function(b,a,f,e){var p=a.left()+0.5*b.lineWidth,l=a.right()-0.5*b.lineWidth,j=
a.top()+0.5*b.lineWidth,a=a.bottom()-0.5*b.lineWidth;h(b,p,j,l,j,f,e);h(b,p,a,l,a,f,e);h(b,p,j+0.5*b.lineWidth,p,a-0.5*b.lineWidth,f,e);h(b,l,j+0.5*b.lineWidth,l,a-0.5*b.lineWidth,f,e)}}});
(function(){var j=Math.abs,h=Math.min,b=Math.max,a=Math.cos,f=Math.sin,e=Math.acos,p=Math.atan2,l=Math.sqrt,r=function(c){return 0>c?-Math.pow(-c,1/3):Math.pow(c,1/3)},y=Math.PI,u=2*y,w=y/2,s={x:0,y:0,z:0},m={Tvalues:[-0.06405689286260563,0.06405689286260563,-0.1911188674736163,0.1911188674736163,-0.3150426796961634,0.3150426796961634,-0.4337935076260451,0.4337935076260451,-0.5454214713888396,0.5454214713888396,-0.6480936519369755,0.6480936519369755,-0.7401241915785544,0.7401241915785544,-0.820001985973903,
0.820001985973903,-0.8864155270044011,0.8864155270044011,-0.9382745520027328,0.9382745520027328,-0.9747285559713095,0.9747285559713095,-0.9951872199970213,0.9951872199970213],Cvalues:[0.12793819534675216,0.12793819534675216,0.1258374563468283,0.1258374563468283,0.12167047292780339,0.12167047292780339,0.1155056680537256,0.1155056680537256,0.10744427011596563,0.10744427011596563,0.09761865210411388,0.09761865210411388,0.08619016153195327,0.08619016153195327,0.0733464814110803,0.0733464814110803,0.05929858491543678,
0.05929858491543678,0.04427743881741981,0.04427743881741981,0.028531388628933663,0.028531388628933663,0.0123412297999872,0.0123412297999872],arcfn:function(c,i){var d=i(c),d=d.x*d.x+d.y*d.y;"undefined"!==typeof d.z&&(d+=d.z*d.z);return l(d)},length:function(c){var i=0,d=this.Tvalues.length,a,n;for(a=0;a<d;a++)n=0.5*this.Tvalues[a]+0.5,i+=this.Cvalues[a]*this.arcfn(n,c);return 0.5*i},map:function(c,i,d,a,n){return a+(n-a)*((c-i)/(d-i))},lerp:function(c,i,d){var a={x:i.x+c*(d.x-i.x),y:i.y+c*(d.y-i.y)};
i.z&&d.z&&(a.z=i.z+c*(d.z-i.z));return a},pointToString:function(c){var i=c.x+"/"+c.y;"undefined"!==typeof c.z&&(i+="/"+c.z);return i},pointsToString:function(c){return"["+c.map(this.pointToString).join(", ")+"]"},copy:function(c){return JSON.parse(JSON.stringify(c))},angle:function(c,i,d){var a=i.x-c.x,i=i.y-c.y,n=d.x-c.x,c=d.y-c.y,d=a*c-i*n,g=l(a*a+i*i),b=l(n*n+c*c);return p(d,a/g*(n/b)+i/g*(c/b))},dist:function(c,i){var d=c.x-i.x,a=c.y-i.y;return l(d*d+a*a)},lli8:function(c,i,d,a,n,g,b,e){var f=
(c-d)*(g-e)-(i-a)*(n-b);return 0==f?!1:{x:((c*a-i*d)*(n-b)-(c-d)*(n*e-g*b))/f,y:((c*a-i*d)*(g-e)-(i-a)*(n*e-g*b))/f}},lli4:function(c,i,d,a){return this.lli8(c.x,c.y,i.x,i.y,d.x,d.y,a.x,a.y)},lli:function(c,i){return this.lli4(c,c.c,i,i.c)},makeline:function(c,i){var d=c.x,a=c.y,n=i.x,g=i.y,b=(n-d)/3,e=(g-a)/3;return new v(d,a,d+b,a+e,d+2*b,a+2*e,n,g)},findbbox:function(c){var i=99999999,d=i,a=-i,n=a;c.forEach(function(c){c=c.bbox();i>c.x.min&&(i=c.x.min);d>c.y.min&&(d=c.y.min);a<c.x.max&&(a=c.x.max);
n<c.y.max&&(n=c.y.max)});return{x:{min:i,mid:(i+a)/2,max:a,size:a-i},y:{min:d,mid:(d+n)/2,max:n,size:n-d}}},shapeintersections:function(c,i,d,a){if(!this.bboxoverlap(i,a))return[];var n=[],g=[d.startcap,d.forward,d.back,d.endcap];[c.startcap,c.forward,c.back,c.endcap].forEach(function(i){i.virtual||g.forEach(function(a){if(!a.virtual){var k=i.intersects(a);0<k.length&&(k.c1=i,k.c2=a,k.s1=c,k.s2=d,n.push(k))}})});return n},makeshape:function(c,i){var d=c.points.length,a=this.makeline(i.points[i.points.length-
1],c.points[0]),d=this.makeline(c.points[d-1],i.points[0]),n={startcap:a,forward:c,back:i,endcap:d,bbox:this.findbbox([a,c,i,d])},g=this;n.intersections=function(c){return g.shapeintersections(n,n.bbox,c,c.bbox)};return n},getminmax:function(c,a,d){if(!d)return{min:0,max:0};var k=1.8446744073709552E19,n=-k,g;-1===d.indexOf(0)&&(d=[0].concat(d));-1===d.indexOf(1)&&d.push(1);for(var b=0,e=d.length;b<e;b++)g=d[b],g=c.get(g),g[a]<k&&(k=g[a]),g[a]>n&&(n=g[a]);return{min:k,mid:(k+n)/2,max:n,size:n-k}},
align:function(c,i){var d=i.p1.x,k=i.p1.y,n=-p(i.p2.y-k,i.p2.x-d);return c.map(function(c){return{x:(c.x-d)*a(n)-(c.y-k)*f(n),y:(c.x-d)*f(n)+(c.y-k)*a(n)}})},roots:function(c,i){var i=i||{p1:{x:0,y:0},p2:{x:1,y:0}},d=c.length-1,k=this.align(c,i),n=function(c){return 0<=c&&1>=c};if(2===d){var d=k[0].y,g=k[1].y,k=k[2].y,b=d-2*g+k;return 0!==b?(k=-l(g*g-d*k),d=-d+g,[-(k+d)/b,-(-k+d)/b].filter(n)):g!==k&&0===b?[(2*g-k)/2*(g-k)].filter(n):[]}var f=k[0].y,g=k[1].y,d=k[2].y,b=-f+3*g-3*d+k[3].y,d=(3*f-6*
g+3*d)/b,g=(-3*f+3*g)/b,k=(3*g-d*d)/3,m=k/3,b=(2*d*d*d-9*d*g+27*(f/b))/27,g=b/2,f=g*g+m*m*m;if(0>f)return k=-k/3,k=l(k*k*k),b=-b/(2*k),g=e(-1>b?-1:1<b?1:b),f=2*r(k),k=f*a(g/3)-d/3,b=f*a((g+u)/3)-d/3,d=f*a((g+2*u)/3)-d/3,[k,b,d].filter(n);if(0===f)return k=0>g?r(-g):-r(g),[2*k-d/3,-k-d/3].filter(n);b=l(f);k=r(-g+b);b=r(g+b);return[k-b-d/3].filter(n)},droots:function(c){if(3===c.length){var a=c[0],d=c[1],k=c[2],c=a-2*d+k;return 0!==c?(k=-l(d*d-a*k),a=-a+d,[-(k+a)/c,-(-k+a)/c]):d!==k&&0===c?[(2*d-k)/
(2*(d-k))]:[]}if(2===c.length)return a=c[0],d=c[1],a!==d?[a/(a-d)]:[]},bboxoverlap:function(c,a){var d=["x","y"],k=d.length,b,g,f,e;for(b=0;b<k;b++)if(g=d[b],f=c[g].mid,e=a[g].mid,g=(c[g].size+a[g].size)/2,j(f-e)>=g)return!1;return!0},expandbox:function(c,a){a.x.min<c.x.min&&(c.x.min=a.x.min);a.y.min<c.y.min&&(c.y.min=a.y.min);a.z&&a.z.min<c.z.min&&(c.z.min=a.z.min);a.x.max>c.x.max&&(c.x.max=a.x.max);a.y.max>c.y.max&&(c.y.max=a.y.max);a.z&&a.z.max>c.z.max&&(c.z.max=a.z.max);c.x.mid=(c.x.min+c.x.max)/
2;c.y.mid=(c.y.min+c.y.max)/2;c.z&&(c.z.mid=(c.z.min+c.z.max)/2);c.x.size=c.x.max-c.x.min;c.y.size=c.y.max-c.y.min;c.z&&(c.z.size=c.z.max-c.z.min)},pairiteration:function(c,a){var d=c.bbox(),k=a.bbox();if(0.5>d.x.size+d.y.size&&0.5>k.x.size+k.y.size)return[(1E5*(c._t1+c._t2)/2|0)/1E5+"/"+(1E5*(a._t1+a._t2)/2|0)/1E5];var d=c.split(0.5),k=a.split(0.5),d=[{left:d.left,right:k.left},{left:d.left,right:k.right},{left:d.right,right:k.right},{left:d.right,right:k.left}],d=d.filter(function(c){return m.bboxoverlap(c.left.bbox(),
c.right.bbox())}),b=[];if(0===d.length)return b;d.forEach(function(c){b=b.concat(m.pairiteration(c.left,c.right))});return b=b.filter(function(c,a){return b.indexOf(c)===a})},getccenter:function(c,i,d){var k=i.x-c.x,b=i.y-c.y,g=d.x-i.x,e=d.y-i.y,z=k*a(w)-b*f(w),k=k*f(w)+b*a(w),b=g*a(w)-e*f(w),g=g*f(w)+e*a(w),e=(c.x+i.x)/2,q=(c.y+i.y)/2,h=(i.x+d.x)/2,l=(i.y+d.y)/2,z=m.lli8(e,q,e+z,q+k,h,l,h+b,l+g),k=m.dist(z,c),c=p(c.y-z.y,c.x-z.x),i=p(i.y-z.y,i.x-z.x),d=p(d.y-z.y,d.x-z.x);if(c<d){if(c>i||i>d)c+=u;
c>d&&(i=d,d=c,c=i)}else d<i&&i<c?(i=d,d=c,c=i):d+=u;z.s=c;z.e=d;z.r=k;return z}},x=function(c){this.curves=[];this._3d=!1;c&&(this.curves=c,this._3d=this.curves[0]._3d)};x.prototype={valueOf:function(){return this.toString()},toString:function(){return m.pointsToString(this.points)},addCurve:function(c){this.curves.push(c);this._3d=this._3d||c._3d},length:function(){return this.curves.map(function(c){return c.length()}).reduce(function(c,a){return c+a})},curve:function(c){return this.curves[c]},bbox:function(){for(var c=
this.curves,a=c[0].bbox(),d=1;d<c.length;d++)m.expandbox(a,c[d].bbox());return a},offset:function(c){var a=[];this.curves.forEach(function(d){a=a.concat(d.offset(c))});return new x(a)}};var v=function(c){var a=c&&c.forEach?c:arguments;if("object"===typeof a[0])for(var a=[],d=0;d<c.length;d++)["x","y","z"].forEach(function(k){"undefined"!==typeof c[d][k]&&a.push(c[d][k])});var k=a.length;if(6!==k&&8!==k&&9!==k&&12!==k)throw console.log(c),Error("This Bezier curve library only supports quadratic and cubic curves (in 2d and 3d)");
var b=9===k||12===k;this._3d=b;for(var g=[],f=0,e=b?3:2;f<k;f+=e){var q={x:a[f],y:a[f+1]};b&&(q.z=a[f+2]);g.push(q)}this.order=g.length-1;this.points=g;k=["x","y"];b&&k.push("z");this.dims=k;this.dimlen=k.length;a:{b=m.align(g,{p1:g[0],p2:g[this.order]});for(g=0;g<b.length;g++)if(1E-4<j(b[g].y)){this._linear=!1;break a}this._linear=!0}this._t1=0;this._t2=1;this.update()};v.fromSVG=function(c){var a=-1<c.indexOf("m"),c=c.match(/(-?\d+(\.\d+)*)\s*[, ]\s*(-?\d+(\.\d+)*)/g).map(function(c){c=c.split(" ").map(function(c){return parseFloat(c)});
return{x:c[0],y:c[1]}});if(!a)return new v(c);var d=[c[0]];c.reduce(function(c,a){a.x+=c.x;a.y+=c.y;d.push({x:a.x,y:a.y});return a});return new v(d)};v.utils=m;v.prototype={valueOf:function(){return this.toString()},toString:function(){return m.pointsToString(this.points)},toSVG:function(){if(this._3d)return!1;for(var c=this.points,a=["M",c[0].x,c[0].y,2===this.order?"Q":"C"],d=1,k=c.length;d<k;d++)a.push(c[d].x),a.push(c[d].y);return a.join(" ")},update:function(){this.dpoints=[];for(var c=this.points,
a=c.length,d=a-1;1<a;a--,d--){for(var k=[],b=0,g;b<d;b++)g={x:d*(c[b+1].x-c[b].x),y:d*(c[b+1].y-c[b].y)},this._3d&&(g.z=d*(c[b+1].z-c[b].z)),k.push(g);this.dpoints.push(k);c=k}this.computedirection()},computedirection:function(){var c=this.points;this.clockwise=0<m.angle(c[0],c[this.order],c[1])},length:function(){return m.length(this.derivative.bind(this))},getLUT:function(c){for(var c=c||100,a=[],d=0;d<=c;d++)a.push(this.compute(d/c));return a},get:function(c){return this.compute(c)},point:function(c){return this.points[c]},
compute:function(c){if(0===c)return this.points[0];if(1===c)return this.points[this.order];var a=1-c,d=a*a,b=c*c,f,g,e,m=0,q=this.points;2===this.order&&(q=[q[0],q[1],q[2],s],f=d,g=2*a*c,e=b);3===this.order&&(f=d*a,g=3*d*c,e=3*a*b,m=c*b);c={x:f*q[0].x+g*q[1].x+e*q[2].x+m*q[3].x,y:f*q[0].y+g*q[1].y+e*q[2].y+m*q[3].y};this._3d&&(c.z=f*q[0].z+g*q[1].z+e*q[2].z+m*q[3].z);return c},raise:function(){var c=this.points,a=[c[0]],d,b=c.length,f,g;for(d=1;d<b;d++)f=c[d],g=c[d-1],a[d]={x:(b-d)/b*f.x+d/b*g.x,
y:(b-d)/b*f.y+d/b*g.y};a[b]=c[b-1];return new v(a)},derivative:function(c){var a=1-c,d,b,f=0,g=this.dpoints[0];2===this.order&&(g=[g[0],g[1],s],d=a,b=c);3===this.order&&(d=a*a,b=2*a*c,f=c*c);c={x:d*g[0].x+b*g[1].x+f*g[2].x,y:d*g[0].y+b*g[1].y+f*g[2].y};this._3d&&(c.z=d*g[0].z+b*g[1].z+f*g[2].z);return c},normal:function(c){return this._3d?this.__normal3(c):this.__normal2(c)},__normal2:function(c){var c=this.derivative(c),a=l(c.x*c.x+c.y*c.y);return{x:-c.y/a,y:c.x/a}},__normal3:function(){var c=this.derivative(t),
a=this.derivative(t+0.01),d=l(c.x*c.x+c.y*c.y+c.z*c.z),b=l(a.x*a.x+a.y*a.y+a.z*a.z);c.x/=d;c.y/=d;c.z/=d;a.x/=b;a.y/=b;a.z/=b;var d=a.y*c.z-a.z*c.y,b=a.z*c.x-a.x*c.z,a=a.x*c.y-a.y*c.x,f=l(d*d+b*b+a*a),d=d/f,b=b/f,a=a/f,a=[d*d,d*b-a,d*a+b,d*b+a,b*b,b*a-d,d*a-b,b*a+d,a*a];return{x:a[0]*c.x+a[1]*c.y+a[2]*c.z,y:a[3]*c.x+a[4]*c.y+a[5]*c.z,z:a[6]*c.x+a[7]*c.y+a[8]*c.z}},split:function(a,b){if(0===a&&b)return this.split(b).left;if(1===b)return this.split(a).right;var d=this.points,f=[],e,g=[],h=0,l=0,q=
0;g[h++]=d[0];g[h++]=d[1];g[h++]=d[2];for(3===this.order&&(g[h++]=d[3]);1<d.length;){f=[];l=0;for(q=d.length-1;l<q;l++)e=m.lerp(a,d[l],d[l+1]),g[h++]=e,f.push(e);d=f}d={left:2===this.order?new v([g[0],g[3],g[5]]):new v([g[0],g[4],g[7],g[9]]),right:2===this.order?new v([g[5],g[4],g[2]]):new v([g[9],g[8],g[6],g[3]]),span:g};d.left._t1=m.map(0,0,1,this._t1,this._t2);d.left._t2=m.map(a,0,1,this._t1,this._t2);d.right._t1=m.map(a,0,1,this._t1,this._t2);d.right._t2=m.map(1,0,1,this._t1,this._t2);if(!b)return d;
b=m.map(b,a,1,0,1);return d.right.split(b).left},inflections:function(){var a={},b=[],d,f;this.dims.forEach(function(e){f=function(a){return a[e]};d=this.dpoints[0].map(f);a[e]=m.droots(d);3===this.order&&(d=this.dpoints[1].map(f),a[e]=a[e].concat(m.droots(d)));a[e]=a[e].filter(function(a){return 0<=a&&1>=a});b=b.concat(a[e].sort())}.bind(this));b.sort();a.values=b;return a},bbox:function(){var a=this.inflections(),b={};this.dims.forEach(function(d){b[d]=m.getminmax(this,d,a[d])}.bind(this));return b},
overlaps:function(a){var b=this.bbox(),a=a.bbox();return m.bboxoverlap(b,a)},offset:function(a,b){if("undefined"!==typeof b){var d=this.get(a),f=this.normal(a),e={c:d,n:f,x:d.x+f.x*b,y:d.y+f.y*b};this._3d&&(e.z=d.z+f.z*b);return e}if(this._linear){var g=this.normal(0),d=this.points.map(function(d){var b={x:d.x+a*g.x,y:d.y+a*g.y};d.z&&f.z&&(b.z=d.z+a*g.z);return b});return[new v(d)]}return this.reduce().map(function(d){return d.scale(a)})},simple:function(){if(3===this.order){var a=m.angle(this.points[0],
this.points[3],this.points[1]),b=m.angle(this.points[0],this.points[3],this.points[2]);if(0<a&&0>b||0>a&&0<b)return!1}var a=this.normal(0),b=this.normal(1),d=a.x*b.x+a.y*b.y;this._3d&&(d+=a.z*b.z);return j(e(d))<y/3},reduce:function(){var a,b=0,d=0,f,e=[],g=[],h=this.inflections().values;-1===h.indexOf(0)&&(h=[0].concat(h));-1===h.indexOf(1)&&h.push(1);b=h[0];for(a=1;a<h.length;a++)d=h[a],f=this.split(b,d),f._t1=b,f._t2=d,e.push(f),b=d;e.forEach(function(a){for(d=b=0;1>=d;)for(d=b+0.01;1.01>=d;d+=
0.01)if(f=a.split(b,d),!f.simple()){d-=0.01;if(0.01>j(b-d))return[];f=a.split(b,d);f._t1=m.map(b,0,1,a._t1,a._t2);f._t2=m.map(d,0,1,a._t1,a._t2);g.push(f);b=d;break}1>b&&(f=a.split(b,1),f._t1=m.map(b,0,1,a._t1,a._t2),f._t2=a._t2,g.push(f))});return g},scale:function(a){var b=this.order,d=!1;"function"===typeof a&&(d=a);if(d&&2===b)return this.raise().scale(d);var f=this.clockwise,e=d?d(0):a,g=d?d(1):a,h=[this.offset(0,10),this.offset(1,10)],j=m.lli4(h[0],h[0].c,h[1],h[1].c);if(!j)throw"cannot scale this curve. Try reducing it first.";
var q=this.points,p=[];[0,1].forEach(function(a){var c=p[a*b]=m.copy(q[a*b]);c.x+=(a?g:e)*h[a].n.x;c.y+=(a?g:e)*h[a].n.y}.bind(this));if(!d)return[0,1].forEach(function(a){if(!(2===this.order&&a)){var c=p[a*b],d=this.derivative(a);p[a+1]=m.lli4(c,{x:c.x+d.x,y:c.y+d.y},j,q[a+1])}}.bind(this)),new v(p);[0,1].forEach(function(e){if(!(2===this.order&&e)){var g=q[e+1],m=g.x-j.x,h=g.y-j.y,n=d?d((e+1)/b):a;d&&!f&&(n=-n);var x=l(m*m+h*h);p[e+1]={x:g.x+n*(m/x),y:g.y+n*(h/x)}}}.bind(this));return new v(p)},
outline:function(a,b,d,f){function e(a,c,d,b,f){return function(e){var g=c-a;return m.map(e,0,1,a+b/d*g,a+(b+f)/d*g)}}var b="undefined"===typeof b?a:b,g=this.reduce(),h=g.length,l=[],q=[],j,p=0,v=this.length(),r="undefined"!==typeof d&&"undefined"!==typeof f;g.forEach(function(g){s=g.length();r?(l.push(g.scale(e(a,d,v,p,s))),q.push(g.scale(e(-b,-f,v,p,s)))):(l.push(g.scale(a)),q.push(g.scale(-b)));p+=s});var q=q.map(function(a){j=a.points;a.points=j[3]?[j[3],j[2],j[1],j[0]]:[j[2],j[1],j[0]];return a}).reverse(),
g=l[h-1].points[l[h-1].points.length-1],A=q[0].points[0],h=m.makeline(q[h-1].points[q[h-1].points.length-1],l[0].points[0]),g=m.makeline(g,A),h=[h].concat(l).concat([g]).concat(q),s=h.length;return new x(h)},outlineshapes:function(a,b){for(var d=this.outline(a,b||a).curves,f=[],e=1,g=d.length;e<g/2;e++){var h=m.makeshape(d[e],d[g-e]);h.startcap.virtual=1<e;h.endcap.virtual=e<g/2-1;f.push(h)}return f},intersects:function(a){if(!a)return this.selfintersects();if(a.p1&&a.p2)return this.lineIntersects(a);
a instanceof v&&(a=a.reduce());return this.curveintersects(this.reduce(),a)},lineIntersects:function(a){var f=h(a.p1.x,a.p2.x),d=h(a.p1.y,a.p2.y),e=b(a.p1.x,a.p2.x),l=b(a.p1.y,a.p2.y),g=this;return m.roots(this.points,a).filter(function(a){a=g.get(a);return f<=a.x&&a.x<=e&&d<=a.y&&a.y<=l})},selfintersects:function(){var a=this.reduce(),b,d=a.length-2,f=[],e,g;for(b=0;b<d;b++)e=a.slice(b,b+1),g=a.slice(b+2),e=this.curveintersects(e,g),f=f.concat(e);return f},curveintersects:function(a,b){var d=[];
a.forEach(function(a){b.forEach(function(c){a.overlaps(c)&&d.push({left:a,right:c})})});var f=[];d.forEach(function(a){a=m.pairiteration(a.left,a.right);0<a.length&&(f=f.concat(a))});return f},arcs:function(a){return this._iterate(a||0.5,[])},_error:function(a,b,d,f){var e=(f-d)/4,d=this.get(d+e),f=this.get(f-e),b=m.dist(a,b),d=m.dist(a,d),a=m.dist(a,f);return j(d-b)+j(a-b)},_iterate:function(a,b){var d=0,f=1,e;do{e=0;var f=1,g=this.get(d),h,l,q,j=l=!1,p=f,x=1,v=0;do if(j=l,q=h,p=(d+f)/2,v++,h=this.get(p),
l=this.get(f),h=m.getccenter(g,h,l),l=this._error(h,g,d,f)<=a,(j=j&&!l)||(x=f),l){if(1<=f){x=1;q=h;break}f+=(f-d)/2}else f=p;while(!j&&100>e++);if(100<=e){console.error("arc abstraction somehow failed...");break}q=q?q:h;b.push(q);d=x}while(1>f);return b}};"undefined"!==typeof module&&module.exports?module.exports=v:"undefined"!==typeof define?define("lib/bezier",[],function(){return v}):"undefined"!==typeof window&&(window.Bezier=v)})();
(function(j,h){"function"===typeof define&&define.amd?define("Mousetrap",[],h):"object"===typeof module&&module.exports?module.exports=h():j.MouseTrap=h()})(this,function(){function j(a,b,f){a.addEventListener?a.addEventListener(b,f,!1):a.attachEvent("on"+b,f)}function h(a){if("keypress"==a.type){var b=String.fromCharCode(a.which);a.shiftKey||(b=b.toLowerCase());return b}return l[a.which]?l[a.which]:r[a.which]?r[a.which]:String.fromCharCode(a.which).toLowerCase()}function b(a){var b=[];a.shiftKey&&
b.push("shift");a.altKey&&b.push("alt");a.ctrlKey&&b.push("ctrl");a.metaKey&&b.push("meta");return b}function a(a){return"shift"==a||"ctrl"==a||"alt"==a||"meta"==a}function f(b,f){var e,c,i,d=[];e=b;"+"===e?e=["+"]:(e=e.replace(/\+{2}/g,"+plus"),e=e.split("+"));for(i=0;i<e.length;++i)c=e[i],u[c]&&(c=u[c]),f&&("keypress"!=f&&y[c])&&(c=y[c],d.push("shift")),a(c)&&d.push(c);e=c;i=f;if(!i){if(!w){w={};for(var h in l)95<h&&112>h||l.hasOwnProperty(h)&&(w[l[h]]=h)}i=w[e]?"keydown":"keypress"}"keypress"==
i&&d.length&&(i="keydown");return{key:c,modifiers:d,action:i}}function e(a,b){return null===a||a===document?!1:a===b?!0:e(a.parentNode,b)}function p(e){function l(a){var a=a||{},b=!1,c;for(c in k)a[c]?b=!0:k[c]=0;b||(u=!1)}function r(a,b,c,f){if(!d.stopCallback(b,b.target||b.srcElement,c,f)&&!1===a(b,c))b.preventDefault?b.preventDefault():b.returnValue=!1,b.stopPropagation?b.stopPropagation():b.cancelBubble=!0}function c(a){"number"!==typeof a.which&&(a.which=a.keyCode);var c=h(a);c&&("keyup"==a.type&&
g===c?g=!1:d.handleKey(c,b(a),a))}function i(a,b,c,e,m){d._directMap[a+":"+c]=b;var a=a.replace(/\s+/g," "),j=a.split(" ");if(1<j.length)for(var p=a,a=function(a){return function(){u=a;++k[p];clearTimeout(n);n=setTimeout(l,1E3)}},e=function(a){r(b,a,p);"keyup"!==c&&(g=h(a));setTimeout(l,10)},m=k[p]=0;m<j.length;++m){var s=m+1===j.length?e:a(c||f(j[m+1]).action);i(j[m],s,c,p,m)}else j=f(a,c),d._callbacks[j.key]=d._callbacks[j.key]||[],d._callbacks[j.key][e?"unshift":"push"]({callback:b,modifiers:j.modifiers,
action:j.action,seq:e,level:m,combo:a})}var d=this,e=e||document;if(!(d instanceof p))return new p(e);d.target=e;d._callbacks={};d._directMap={};var k={},n,g=!1,s=!1,u=!1;d._handleKey=function(b,c,f){var e;var g,h=[],i=f.type;if(d._callbacks[b]){"keyup"==i&&a(b)&&(c=[b]);for(g=0;g<d._callbacks[b].length;++g)if(e=d._callbacks[b][g],!(e.seq&&k[e.seq]!=e.level)&&i==e.action&&("keypress"==i&&!f.metaKey&&!f.ctrlKey||c.sort().join(",")===e.modifiers.sort().join(",")))void 0==e.combo&&d._callbacks[b].splice(g,
1),h.push(e);e=h}else e=[];c={};i=0;g=!1;for(h=0;h<e.length;++h)e[h].seq&&(i=Math.max(i,e[h].level));for(h=0;h<e.length;++h)e[h].seq?e[h].level==i&&(g=!0,c[e[h].seq]=1,r(e[h].callback,f,e[h].combo,e[h].seq)):g||r(e[h].callback,f,e[h].combo);e="keypress"==f.type&&s;f.type==u&&(!a(b)&&!e)&&l(c);s=g&&"keydown"==f.type};d._bindMultiple=function(a,b,c){for(var d=0;d<a.length;++d)i(a[d],b,c)};d._unbindMultiple=function(a,b,c){for(var e=0;e<a.length;++e){for(var g=b,h=c,i=f(a[e],h),k=d._callbacks[i.key],
m=0;m<k.length;)k[m].callback==g&&k[m].action==h?k.splice(m,1):m++;d._callbacks[i.key]=k}};j(e,"keypress",c);j(e,"keydown",c);j(e,"keyup",c)}for(var l={8:"backspace",9:"tab",13:"enter",16:"shift",17:"ctrl",18:"alt",20:"capslock",27:"esc",32:"space",33:"pageup",34:"pagedown",35:"end",36:"home",37:"left",38:"up",39:"right",40:"down",45:"ins",46:"del",91:"meta",93:"meta",224:"meta"},r={106:"*",107:"+",109:"-",110:".",111:"/",173:"-",186:";",187:"=",188:",",189:"-",190:".",191:"/",192:"`",219:"[",220:"\\",
221:"]",222:"'"},y={"~":"`","!":"1","@":"2","#":"3",$:"4","%":"5","^":"6","&":"7","*":"8","(":"9",")":"0",_:"-","+":"=",":":";",'"':"'","<":",",">":".","?":"/","|":"\\"},u={option:"alt",command:"meta","return":"enter",escape:"esc",plus:"+",mod:/Mac|iPod|iPhone|iPad/.test(navigator.platform)?"meta":"ctrl"},w,s=1;20>s;++s)l[111+s]="f"+s;for(s=0;9>=s;++s)l[s+96]=s;p.prototype.bind=function(a,b,e){a=a instanceof Array?a:[a];this._bindMultiple.call(this,a,b,e);return this};p.prototype.unbind=function(a,
b,e){a=a instanceof Array?a:[a];this._unbindMultiple.call(this,a,b,e);return this};p.prototype.trigger=function(a,b){if(this._directMap[a+":"+b])this._directMap[a+":"+b]({},a);return this};p.prototype.reset=function(){this._callbacks={};this._directMap={};return this};p.prototype.stopCallback=function(a,b){return-1<(" "+b.className+" ").indexOf(" mousetrap ")||e(b,this.target)?!1:"INPUT"==b.tagName||"SELECT"==b.tagName||"TEXTAREA"==b.tagName||b.isContentEditable};p.prototype.handleKey=function(){return this._handleKey.apply(this,
arguments)};p.init=function(){var a=p(document),b;for(b in a)"_"!==b.charAt(0)&&(p[b]=function(b){return function(){return a[b].apply(a,arguments)}}(b))};p.init();return p});
define("utils/Transformation",["underscore","utils/ShapeUtils"],function(j,h){var b=function(a,b,e,h,j,r){this.a=void 0!==a?a:1;this.b=void 0!==b?b:0;this.c=void 0!==e?e:0;this.d=void 0!==h?h:1;this.e=void 0!==j?j:0;this.f=void 0!==r?r:0};b.prototype.setTransform=function(a,b,e,h,j,r){this.a=a?a:1;this.b=b?b:0;this.c=e?e:0;this.d=h?h:1;this.e=j?j:0;this.f=r?r:0};b.prototype.copy=function(){return new b(this.a,this.b,this.c,this.d,this.e,this.f)};b.prototype.equals=function(a){return this.a==a.a&&
this.b==a.b&&this.c==a.c&&this.d==a.d&&this.e==a.e&&this.f==a.f};b.prototype.createInverse=function(){var a=this.copy(),b=1/(this.a*this.d-this.b*this.c),e=-this.b*b,h=-this.c*b,j=this.a*b,r=b*(this.c*this.f-this.d*this.e),y=b*(this.b*this.e-this.a*this.f);a.a=this.d*b;a.b=e;a.c=h;a.d=j;a.e=r;a.f=y;return a};b.prototype.setScale=function(a,b){this.a=a;this.d=b};b.prototype.scale=function(a,b){this.a*=a;this.b*=a;this.c*=b;this.d*=b};b.prototype.preScale=function(a,b){this.a*=a;this.b*=a;this.e*=a;
this.c*=b;this.d*=b;this.f*=b};b.prototype.setTranslate=function(a,b){this.e=a;this.f=b};b.prototype.translate=function(a,b){this.e+=a*this.a+b*this.c;this.f+=a*this.b+b*this.d};b.prototype.preTranslate=function(a,b){this.e+=a;this.f+=b};b.prototype.rotationTransformation=function(a,f,e){var f=void 0===f?0:f,e=void 0===e?0:e,h=Math.cos(a),a=Math.sin(a);return new b(h,a,-a,h,f-f*h+e*a,e-f*a-e*h)};b.prototype.translateTransformation=function(a,f){return new b(1,0,0,1,a,f)};b.prototype.rotate=function(a,
b,e){a=this.rotationTransformation(a,b,e);this.concatenate(a)};b.prototype.preRotate=function(a,b,e){return this.preConcatenate(this.rotationTransformation(a,b,e))};b.prototype.flipTransformation=function(a,f){return new b(-1,0,0,1,a,f)};b.prototype.flip=function(a,b){this.concatenate(this.flipTransformation(a,b))};b.prototype.preFlip=function(a,b){this.preConcatenate(this.flipTransformation(a,b))};b.prototype.toString=function(){return"Transformation[["+this.a+", "+this.c+", "+this.e+"], ["+this.b+
", "+this.d+", "+this.f+"]]"};b.prototype.concatenate=function(a){var b=this.b*a.a+this.d*a.b,e=this.a*a.c+this.c*a.d,h=this.b*a.c+this.d*a.d,j=this.a*a.e+this.c*a.f+this.e,r=this.b*a.e+this.d*a.f+this.f;this.a=this.a*a.a+this.c*a.b;this.b=b;this.c=e;this.d=h;this.e=j;this.f=r};b.prototype.preConcatenate=function(a){var b=a.a*this.c+a.c*this.d,e=a.a*this.e+a.c*this.f+a.e,h=a.b*this.a+a.d*this.b,j=a.b*this.c+a.d*this.d,r=a.b*this.e+a.d*this.f+a.f;this.a=a.a*this.a+a.c*this.b;this.c=b;this.e=e;this.b=
h;this.d=j;this.f=r;return this};b.prototype.transformedPoint=function(a){var b=a.x,a=a.y;return new h.Point(b*this.a+a*this.c+this.e,b*this.b+a*this.d+this.f)};b.prototype.preTransformedPoint=function(a){return new h.Point(this.a*a.x+this.b*a.y+this.e,this.c*a.x+this.d*a.y+this.f)};b.prototype.transformedSize=function(a){var b=this.transformedPoint(new h.Point),a=this.transformedPoint(new h.Point(a.width,a.height));return new h.Size(a.x-b.x,a.y-b.y)};b.prototype.transformedRect=function(a){var a=
a.copy(),b=this.transformedPoint(a.origin),e=b.x,j=b.y,l=b.x,b=b.y,r=this.transformedPoint(new h.Point(a.right(),a.top())),e=Math.min(e,r.x),j=Math.min(j,r.y),l=Math.max(l,r.x),b=Math.max(b,r.y),r=this.transformedPoint(new h.Point(a.left(),a.bottom())),e=Math.min(e,r.x),j=Math.min(j,r.y),l=Math.max(l,r.x),b=Math.max(b,r.y),r=this.transformedPoint(new h.Point(a.right(),a.bottom())),e=Math.min(e,r.x),j=Math.min(j,r.y),l=Math.max(l,r.x),b=Math.max(b,r.y),e=new h.Point(e,j),l=new h.Point(l,b);a.origin=
e;a.size=new h.Size(l.x-e.x,l.y-e.y);return a};b.prototype.getScaleX=function(){return Math.sqrt(this.a*this.a+this.b*this.b)};b.prototype.getScaleY=function(){return Math.sqrt(this.c*this.c+this.d*this.d)};b.prototype.getRotation=function(){return Math.atan2(this.c,this.d)};return b});define("web-viewer-WF-commons",function(){});