define("web-viewer/compare/CompareModel",["web-viewer/core/AbstractModel","web-viewer/compare/CompareConstants","utils/ShapeUtils","underscore"],function(c,e,d,g){var b=function(a,b,f){c.call(this,a,b);this._currentMode=null;this._diffMode=f?f:e.diffMode.UNDEFINED;this._availableModes={};this._offset=new d.Point(0,0);this._cadOverlayOffset=new d.Point(0,0);this._cornerAlign=e.cornerAutoAlign.TOPLEFT;this._referenceNegated=this._cadOverlayFlipped=this._referenceFlipped=!1;this._cadOverlayRotation=
this._referenceRotation=e.referenceRotation.NOTROTATED;this._trimBoxAlign=!1;this._newModeName=null;this._fireParametersChanged=this._silenceParametersChanged=!1};b.prototype=Object.create(c.prototype);b.prototype.constructor=b;b.prototype.activateModeByName=function(a,b){if(this._availableModes[a]){var f=this._currentMode,c=this._availableModes[a];c!==f&&(this.toggleCurrentMode(!1),this._newModeName=a,this._currentMode=c,c.toggle(!0,b),this._fireChange(!1,["mode"],f,c))}};b.prototype.deactivateCurrentMode=
function(){this.toggleCurrentMode(!1);if(this._currentMode){var a=this._currentMode;this._newModeName="";this._currentMode=null;this._fireChange(!1,["mode"],a,null)}};b.prototype.toggleCurrentMode=function(a){this._currentMode&&this._currentMode.isEnabled()!==a&&this._currentMode.toggle(a)};b.prototype.getModeNameByDiffMode=function(a){a=g.invert(e.diffMode)[a];return e.mode[e.diffModeToMode[a]]};b.prototype.getModeByName=function(a){return this._availableModes[a]};b.prototype.setOffset=function(a){var b=
this._offset;this._offset=a.copy();this._fireChange(!1,["offset"],b,a)};b.prototype.getOffset=function(){return this._offset.copy()};b.prototype.resetOffset=function(){this.setOffset(new d.Point(0,0))};b.prototype.setCadOverlayOffset=function(a){var b=this._cadOverlayOffset;this._cadOverlayOffset=a.copy();this._fireChange(!1,["cadOverlayOffset"],b,a)};b.prototype.getCadOverlayOffset=function(){return this._cadOverlayOffset.copy()};b.prototype.resetCadOverlayOffset=function(){this.setCadOverlayOffset(new d.Point(0,
0))};b.prototype.setCornerAlign=function(a){this._cornerAlign=a};b.prototype.getCornerAlign=function(){return this._cornerAlign};b.prototype.resetCornerAlign=function(){this._cornerAlign=e.cornerAutoAlign.TOPLEFT};b.prototype.getReferenceRotation=function(){return this._referenceRotation};b.prototype.setReferenceRotation=function(a){this._referenceRotation=a};b.prototype.flipReference=function(){this._referenceFlipped=!this._referenceFlipped};b.prototype.flipCadOverlay=function(a){void 0===a&&(a=
!this._cadOverlayFlipped);this._cadOverlayFlipped=a};b.prototype.isReferenceFlipped=function(){return this._referenceFlipped};b.prototype.isCadOverlayFlipped=function(){return this._cadOverlayFlipped};b.prototype.negateReference=function(){this._referenceNegated=!this._referenceNegated;this.parametersChanged()};b.prototype.isReferenceNegated=function(){return this._referenceNegated};b.prototype.resetReferenceOrientation=function(){this._referenceNegated=this._referenceFlipped=!1;this._referenceRotation=
e.referenceRotation.NOTROTATED};b.prototype.resetCadOverlayOrientation=function(){this._cadOverlayRotation=e.referenceRotation.NOTROTATED;this._cadOverlayFlipped=!1};b.prototype.toggleTrimBoxAlign=function(){this._trimBoxAlign=!this._trimBoxAlign};b.prototype.isTrimBoxAlign=function(){return this._trimBoxAlign};b.prototype.resetTrimBoxAlign=function(){this._trimBoxAlign=!1};b.prototype.setDiffMode=function(a){var b=this._diffMode;this._diffMode=a;null===this._currentMode&&(b=e.diffMode.UNDEFINED);
b!=a&&this.parametersChanged();this._fireChange(!1,["diffMode"],b,this._diffMode)};b.prototype.getDiffMode=function(){return this._diffMode};b.prototype.getActiveMode=function(){return this._currentMode};b.prototype.registerMode=function(a){if(this._availableModes[a.getName()])throw Error("Trying to register mode which already exists!",a.getName(),a);var b=g.keys(this._availableModes);this._availableModes[a.getName()]=a;this._fireChange(!1,["availableModes"],b,g.keys(this._availableModes))};b.prototype.parametersChanged=
function(){this._silenceParametersChanged?this._fireParametersChanged=!0:this.f.emit("viewport.viewserverParametersChanged")};b.prototype.isRealCompareMode=function(a){return a>=e.diffMode.SHOWBOTHCHANGES&&a<=e.diffMode.SHOWBOTHSIDEBYSIDECHANGESONLY&&a!==e.diffMode.READERSPREAD};b.prototype.isReaderSpreadActive=function(){return this._newModeName===e.mode.READERSPREAD};b.prototype.toggleSilenceParametersChanged=function(a){a?this._silenceParametersChanged=!0:(this._silenceParametersChanged=!1,this._fireParametersChanged&&
(this.parametersChanged(),this._fireParametersChanged=!1))};b.prototype.setCadOverlayRotation=function(a){this._cadOverlayRotation=a};b.prototype.getCadOverlayRotation=function(){return this._cadOverlayRotation};return b});
define("web-viewer/compare/CompareMode",["web-viewer/core/AbstractModel","web-viewer/layout/LayoutConstants","underscore"],function(c,e){var d=function(d,b,a,i,f,k){var e=a.getPrivateChannelNameAsArray();e.push("mode");e.push(b);c.call(this,d,e);this.f=d;this.name=b;this._enabled=!1;this._compareModel=a;this._enableTogglingAnnotations=i;this._annotationTooltipKey=f;this._whichToEnable=k;this._annotationModuleAvailable=!1;this.f.whenModuleAvailable("annotation",function(){this._annotationModuleAvailable=
!0;this._enabled&&this._fireTemporarilyDisableAnnotations()},this)};d.prototype=Object.create(c.prototype);d.prototype.constructor=d;d.prototype.getName=function(){return this.name};d.prototype.toggle=function(c){c!==this._enabled&&(this._enabled=c,this._annotationModuleAvailable&&this._fireTemporarilyDisableAnnotations())};d.prototype.isEnabled=function(){return this._enabled};d.prototype.interceptFragmentURL=function(){};d.prototype._fireTemporarilyDisableAnnotations=function(){this.f.loadBundle("viewer",
function(){this.f.emit("module.annotation.temporarilyDisable",this._enabled,this._enableTogglingAnnotations,this.f.t(this._annotationTooltipKey),this._whichToEnable)},this)};d.prototype.getLayoutMode=function(){var c=this.f.getDocumentController().getActivePage();return c&&c.is3D()?e.LayoutMode.COMPARE_3D:this.f.isMobile()?e.LayoutMode.MOBILE_COMPARE:e.LayoutMode.VIEW2D};return d});
define("web-viewer/compare/CompareShowCurrentMode",["underscore","web-viewer/compare/CompareMode","web-viewer/compare/CompareConstants"],function(c,e,d){c=function(c,b){e.call(this,c,d.mode.SHOW_CURRENT,b,!1,"","current")};c.prototype=Object.create(e.prototype);c.prototype.constructor=c;c.prototype.toggle=function(c){e.prototype.toggle.call(this,c);this._compareModel.setDiffMode(c?d.diffMode.CURRENTVERSION:d.diffMode.UNDEFINED);var b=this.f.getModule("viewport");b&&b.getPanelModel("default").toggleLayer("Graphics",
!c||this.f.getActivePage().hasGraphics())};return c});
define("web-viewer/compare/CompareShowDifferenceMode",["underscore","web-viewer/compare/CompareMode","web-viewer/compare/CompareConstants"],function(c,e,d){c=function(c,b){e.call(this,c,d.mode.SHOW_DIFFERENCE,b,!1,"AnnDisabledDiffMode","difference")};c.prototype=Object.create(e.prototype);c.prototype.constructor=c;c.prototype.toggle=function(c){e.prototype.toggle.call(this,c);this._compareModel.setDiffMode(c?d.diffMode.DIFFVERSION:d.diffMode.UNDEFINED);var b=this.f.getModule("viewport"),a=this.f.getDocumentController().getDifferencePage();
b&&b.getPanelModel("default").toggleLayer("Graphics",!c||!a||a.hasGraphics())};return c});
define("web-viewer/compare/CompareBlinkingMode",["underscore","web-viewer/compare/CompareMode","web-viewer/layout/LayoutConstants","web-viewer/compare/CompareConstants"],function(c,e,d,g){var b=function(a,b){e.call(this,a,g.mode.BLINKING,b,!1,"DiffBlinkingAnnotationsHidden");this._blinkInterval=g.blinkingSpeed;this._differenceVisible=!1;this._toggleDifference=c.bind(function(){this._differenceVisible=!this._differenceVisible;var a=this.f.getModule("viewport"),b=this.f.getActivePage(),c=this.f.getDocumentController().getDifferencePage();
a&&a.getPanelModel("default").toggleLayer("Graphics",this._differenceVisible&&c&&c.hasGraphics()||!this._differenceVisible&&b.hasGraphics());this._updateCompareModel();this.isEnabled()&&(this._timer=setTimeout(this._toggleDifference,this._blinkInterval))},this)};b.prototype=Object.create(e.prototype);b.prototype.constructor=b;b.prototype.toggle=function(a){e.prototype.toggle.call(this,a);a?this._toggleDifference():(this._timer&&clearTimeout(this._timer),this._differenceVisible=!1,(a=this.f.getModule("viewport"))&&
a.getPanelModel("default").toggleLayer("Graphics",!0),this._updateCompareModel())};b.prototype._updateCompareModel=function(){var a=this.isDifferenceVisible()?g.diffMode.DIFFVERSION:g.diffMode.CURRENTVERSION;this._compareModel.setDiffMode(a)};b.prototype.isDifferenceVisible=function(){return this._differenceVisible};b.prototype.isCurrentVisible=function(){return!this._differenceVisible};b.prototype.getLayoutMode=function(){var a=this.f.getDocumentController().getActivePage();return a&&a.is3D()?d.LayoutMode.COMPARE_3D:
e.prototype.getLayoutMode.call(this)};return b});
define("web-viewer/compare/CompareShowBothOnTopMode",["underscore","web-viewer/compare/CompareMode","web-viewer/compare/CompareConstants"],function(c,e,d){c=function(c,b){e.call(this,c,d.mode.SHOWBOTHONTOP,b,!0,"DiffShowBothOnTopAnnotationsHidden")};c.prototype=Object.create(e.prototype);c.prototype.constructor=c;c.prototype.toggle=function(c){e.prototype.toggle.call(this,c);this._compareModel.setDiffMode(c?d.diffMode.SHOWBOTHONTOP:d.diffMode.UNDEFINED)};return c});
define("web-viewer/compare/Compare3DSideBySideMode","underscore web-viewer/compare/CompareMode web-viewer/compare/CompareConstants web-viewer/layout/LayoutConstants web-viewer/viewport/ViewportConstants web-viewer/utils/ListenerUtil".split(" "),function(c,e,d,g,b,a){c=function(b,c){e.call(this,b,d.mode.SIDEBYSIDE3D,c,!0,"DiffShow3DSideBySide");a.mixin(this,b)};c.prototype=Object.create(e.prototype);c.prototype.constructor=c;c.prototype.toggle=function(a,b){e.prototype.toggle.call(this,a,b);this._compareModel.setDiffMode(a?
d.diffMode.SHOW3DSIDEBYSIDE:d.diffMode.UNDEFINED);a&&this.f.whenModuleAvailable("view3D",function(b){b.set3DDifferenceEnabled(a)})};c.prototype.getLayoutMode=function(){return g.LayoutMode.COMPARE_3D};return c});
define("web-viewer/compare/Compare3DBlinking","underscore web-viewer/compare/CompareMode web-viewer/compare/CompareConstants web-viewer/layout/LayoutConstants web-viewer/viewport/ViewportConstants web-viewer/utils/ListenerUtil".split(" "),function(c,e,d,g,b,a){b=function(b,f){e.call(this,b,d.mode.BLINKING3D,f,!0,"DiffShow3DSideBySide");a.mixin(this,b);this._blinkInterval=d.blinkingSpeed;this._differenceVisible=!1;this._toggleDifference=c.bind(function(){this._differenceVisible=!this._differenceVisible;
this._updateCompareModel();this.isEnabled()&&(this._timer=setTimeout(this._toggleDifference,this._blinkInterval))},this)};b.prototype=Object.create(e.prototype);b.prototype.constructor=b;b.prototype.toggle=function(a){e.prototype.toggle.call(this,a);a?this.f.whenModuleAvailable("view3D",function(b){b.set3DDifferenceEnabled(a);this._toggleDifference()}.bind(this)):(this._timer&&clearTimeout(this._timer),this._differenceVisible=!1,this._updateCompareModel())};b.prototype._updateCompareModel=function(){var a=
this.isDifferenceVisible()?d.diffMode.SHOWDIFFERENCE3D:d.diffMode.SHOWCURRENT3D;this._compareModel.setDiffMode(a)};b.prototype.isDifferenceVisible=function(){return this._differenceVisible};b.prototype.isCurrentVisible=function(){return!this._differenceVisible};b.prototype.getLayoutMode=function(){return g.LayoutMode.COMPARE_3D};return b});
define("web-viewer/compare/Compare3DCurrent","underscore web-viewer/compare/CompareMode web-viewer/compare/CompareConstants web-viewer/layout/LayoutConstants web-viewer/viewport/ViewportConstants web-viewer/utils/ListenerUtil".split(" "),function(c,e,d,g,b,a){c=function(b,c){e.call(this,b,d.mode.CURRENT3D,c,!0,"DiffShow3DSideBySide");a.mixin(this,b)};c.prototype=Object.create(e.prototype);c.prototype.constructor=c;c.prototype.toggle=function(a,b){e.prototype.toggle.call(this,a,b);this._compareModel.setDiffMode(a?
d.diffMode.SHOWCURRENT3D:d.diffMode.UNDEFINED)};c.prototype.getLayoutMode=function(){return g.LayoutMode.COMPARE_3D};return c});
define("web-viewer/compare/Compare3DReference","underscore web-viewer/compare/CompareMode web-viewer/compare/CompareConstants web-viewer/layout/LayoutConstants web-viewer/viewport/ViewportConstants web-viewer/utils/ListenerUtil".split(" "),function(c,e,d,g,b,a){c=function(b,c){e.call(this,b,d.mode.REFERENCE3D,c,!0,"DiffShow3DSideBySide");a.mixin(this,b)};c.prototype=Object.create(e.prototype);c.prototype.constructor=c;c.prototype.toggle=function(a,b){e.prototype.toggle.call(this,a,b);this._compareModel.setDiffMode(a?
d.diffMode.SHOWDIFFERENCE3D:d.diffMode.UNDEFINED);a&&this.f.whenModuleAvailable("view3D",function(b){b.set3DDifferenceEnabled(a)})};c.prototype.getLayoutMode=function(){return g.LayoutMode.COMPARE_3D};return c});
define("web-viewer/core/ViewerMode",["underscore"],function(){var c=function(c,d){this.f=c;this._name=d;this._active=!1};c.prototype.toggle=function(c){!this._active&&c?(this._active=!0,this._doStart()):this._active&&!c&&(this._active=!1,this._doStop())};c.prototype._doStart=function(){};c.prototype._doStop=function(){};c.prototype.isActive=function(){return this._active};c.prototype.requestStop=function(){this._active&&this.f.stopMode(this)};c.prototype._allowAllTools=function(){this.f.emit("toolManager.request.allowAllTools")};
c.prototype._allowAllToolsExcept=function(c){this.f.emit("toolManager.request.allowAllToolsExcept",c)};c.prototype._disallowAllToolsExcept=function(c){this.f.emit("toolManager.request.disallowAllToolsExcept",c)};return c});
define("web-viewer/compare/alignment/CompareAlignmentAnchorModel",["web-viewer/core/AbstractModel","utils/ShapeUtils","underscore"],function(c,e){var d=function(d,b){c.call(this,d,b);this._referenceAnchor=this._currentAnchor=null;this._isCurrentActive=!1};d.prototype=Object.create(c.prototype);d.prototype.constructor=d;d.prototype.setCurrentAnchor=function(c){var b=this._currentAnchor;this._currentAnchor=null!==c?c.copy():null;this._fireChange(!1,["current"],b,null!==this._currentAnchor?this._currentAnchor.copy():
null)};d.prototype.moveCurrentAnchor=function(c,b){var a=this._currentAnchor;null===this._currentAnchor&&(this._currentAnchor=new e.Point);this._currentAnchor=new e.Point(this._currentAnchor.x+c,this._currentAnchor.y+b);this._fireChange(!1,["current"],a,this._currentAnchor.copy())};d.prototype.setReferenceAnchor=function(c){var b=this._referenceAnchor;this._referenceAnchor=null!==c?c.copy():null;this._fireChange(!1,["reference"],b,null!==this._referenceAnchor?this._referenceAnchor.copy():null)};d.prototype.moveReferencAnchor=
function(c,b){var a=this._referenceAnchor;null===this._referenceAnchor&&(this._referenceAnchor=new e.Point);this._referenceAnchor=new e.Point(this._referenceAnchor.x+c,this._referenceAnchor.y+b);this._fireChange(!1,["reference"],a,this._referenceAnchor.copy())};d.prototype.getOffset=function(){if(null!==this._currentAnchor&&null!==this._referenceAnchor)return new e.Size(this._currentAnchor.x-this._referenceAnchor.x,this._currentAnchor.y-this._referenceAnchor.y)};d.prototype.getCurrentAnchor=function(){return null!==
this._currentAnchor?this._currentAnchor.copy():null};d.prototype.getReferenceAnchor=function(){return null!==this._referenceAnchor?this._referenceAnchor.copy():null};d.prototype.getActiveAnchor=function(){return this._isCurrentActive?this.getCurrentAnchor():this.getReferenceAnchor()};d.prototype.setCurrentActive=function(c){var b=this._isCurrentActive;this._isCurrentActive=c;this._fireChange(!1,["isCurrentActive"],b,c)};d.prototype.isCurrentActive=function(){return this._isCurrentActive};d.prototype.setActiveAnchorPosition=
function(c){this.isCurrentActive()?this.setCurrentAnchor(c):this.setReferenceAnchor(c)};d.prototype.moveActiveAnchor=function(c,b){this.isCurrentActive()?this.moveCurrentAnchor(c,b):this.moveReferencAnchor(c,b)};d.prototype.reset=function(){this.setCurrentAnchor(null);this.setReferenceAnchor(null)};return d});
define("web-viewer/compare/alignment/CompareAlignmentAnchorLayerModel","underscore web-viewer/viewport/model/ViewportLayerModel web-viewer/compare/CompareConstants web-viewer/utils/LineworkWrapper web-viewer/utils/DrawUtils utils/ShapeUtils web-viewer/utils/SnapIndicator".split(" "),function(c,e,d,g,b,a,i){var f=function(a,b){e.call(this,a,b);this._anchor=null;this._isActive=!1;this._snapIndicator=null;this.f.getDocumentController().whenActivePageParametersChange(c.bind(this._updateTransformation,
this))};f.prototype=Object.create(e.prototype);f.prototype.constructor=f;f.prototype.setAnchor=function(a){this._anchor=a;this.modelChanged()};f.prototype.moveAnchor=function(a,b){this._anchor.x+=a;this._anchor.y+=b;this.modelChanged()};f.prototype.setActive=function(a){this._isActive=a};f.prototype._updateTransformation=function(){this.resetTransformation();var a=this.f.getActivePage().getDocumentPageOrigin();this.transform.translate(a.x,a.y)};f.prototype.indicateSnapPoint=function(a){this._snapPoint!==
a&&(this._snapPoint=a,this.modelChanged())};f.prototype.getLinework=function(){var c=[];if(this._anchor){var f=new g;f.type=b.LWTYPE_IMAGE;f.linewidth=1;f.imageRef=d.anchorAlignment[this._isActive?"ACTIVE":"DEFAULT"];f.staticsize=!0;f.setRect(new a.Rect(new a.Point(this._anchor.x,this._anchor.y)));f.imageOffset=new a.Size(d.anchorAlignment.OFFSET.width,d.anchorAlignment.OFFSET.height);c.push(f)}this._snapPoint&&(this._snapIndicator?this._snapIndicator.setCenter(this._snapPoint):this._snapIndicator=
new i(this._snapPoint),c.push(this._snapIndicator));return c};return f});
define("web-viewer/compare/alignment/CompareAnchorTool",["underscore","web-viewer/viewport/tools/AbstractTool","utils/ShapeUtils","web-viewer/core/CoreConstants"],function(c,e,d,g){var b=function(a,b,f,d){e.call(this,a,g.TOOLS.COMPARE_ANCHOR_ALIGNMENT);this._alignmentAnchorModel=b;this._currentLayerModel=f;this._referenceLayerModel=d;this._forCadOverlay=!1;null!==window.mozInnerScreenX&&0<=navigator.platform.indexOf("Mac")?(this._macFF=!0,this.f.getContext().addClass("MacFF")):this._macFF=!1;this.registerState("default",
{mousedown:c.bind(function(a){var b=this.getPanelAt(a).getModel().getName();"default"===b?(this._alignmentAnchorModel.setCurrentActive(!0),this.changeState("validPanel")):"compare_difference"===b&&(this._alignmentAnchorModel.setCurrentActive(!1),this.changeState("validPanel"));a.preventDefault()},this),mouseup:function(){},mousemove:c.bind(function(a){this._getAndIndicateSnapPoint(a)},this),contextmenu:c.bind(function(a){a.preventDefault();a.stopPropagation()},this)});this.registerState("validPanel",
c.defaults({mouseup:c.bind(function(a){var b=this._getAndIndicateSnapPoint(a);b||(a=this.getScenePoint(a),b=this.convertScenePointToWorldWithCorrectTransform(a));this._alignmentAnchorModel.setActiveAnchorPosition(b);this.changeState("default")},this),mousemove:c.bind(function(a){var b=this._getAndIndicateSnapPoint(a);b||(a=this.getScenePoint(a),b=this.convertScenePointToWorldWithCorrectTransform(a));this._liveSetAnchor(b)},this)},this.getState("default")));this.registerActiveEvents(["mousedown","mousemove",
"mouseup","contextmenu"]);c.each(["up","down","left","right"],function(a){this.activeKeyEvents.push([a,c.bind(this._handleArrowKey,this,a),"keyup"])},this);this._keyMove=null;this._handleEndOfKeyInput=c.debounce(c.bind(function(){this._keyMove&&(this._alignmentAnchorModel.moveActiveAnchor(this._keyMove.width,this._keyMove.height),this._keyMove=null);this.f.emit("viewport.stopInteractive")},this),500)};b.prototype=Object.create(e.prototype);b.prototype.constructor=b;b.prototype.doActivation=function(a){e.prototype.doActivation.call(this,
a);this.changeState("default")};b.prototype._getActiveAnchorLayerModel=function(){return this._alignmentAnchorModel.isCurrentActive()?this._currentLayerModel:this._referenceLayerModel};b.prototype._liveSetAnchor=function(a){this._getActiveAnchorLayerModel().setAnchor(a)};b.prototype.getDefaultCursor=function(){return"cursor-anchor"};b.prototype.convertScenePointToWorldWithCorrectTransform=function(a){var b=this._widget.getWorld().getTransformation(),c=this.f.getActivePage().getDocumentPageOrigin();
b.translate(c.x,c.y);return b.createInverse().transformedPoint(a)};b.prototype._getAndIndicateSnapPoint=function(a){var b=this.getPanelAt(a);if(b&&(b=b.getModel().getName(),"default"===b||"compare_difference"===b)){var c=this._widget.requestView(a),a=this.getScenePoint(a);if(c){var d;"default"===b?(d=["Cad"],this._forCadOverlay||d.push("CadOverlay")):"compare_difference"===b&&(d=this._forCadOverlay?["CadOverlay"]:["referenceCad"]);(d=c.getClosestLineworkPointFromPoint(a,16,d))?(d=this.convertScenePointToWorldWithCorrectTransform(d),
this._currentLayerModel.indicateSnapPoint("default"===b?d:null),this._referenceLayerModel.indicateSnapPoint("compare_difference"===b?d:null),this.setCursor("cursor-none")):(d=this.convertScenePointToWorldWithCorrectTransform(a),this._currentLayerModel.indicateSnapPoint(null),this._referenceLayerModel.indicateSnapPoint(null),this.setCursor("cursor-anchor"));return d}}return null};b.prototype._handleArrowKey=function(a){this._keyMove||(this.f.emit("viewport.startInteractive"),this._keyMove=new d.Size(0,
0));var b=1/this._widget.getWorld().getZoom(),a=c.indexOf(["up","right","down","left"],a),f=this._widget.getWorld().getRotation()%360,e=this._widget.getWorld().isFlip();if(this._widget.getWorld().isFlipViewFromBack()){if(90===f||270===f)f=(f+180)%360;e=!e}a=(a+4-f/90%4)%4;e&&(1==a?a=3:3==a&&(a=1));e=f=0;switch(a){case 0:e-=b;break;case 1:f+=b;break;case 2:e+=b;break;case 3:f-=b}this._getActiveAnchorLayerModel().moveAnchor(f,e);this._keyMove.width+=f;this._keyMove.height+=e;this._handleEndOfKeyInput()};
b.prototype.setForCadOverlay=function(a){this._forCadOverlay=a};b.prototype.getIconOffset=function(){return this._macFF?new d.Size(0,0):new d.Size(5,5)};return b});define("tpl!web-viewer/compare/alignment/CompareAlignmentWizardWidget",function(){return function(c){var e;return c=""+("<h3>"+(null==(e=c.i18n("AnchorAlignWizardTitle"))?"":_.escape(e))+"</h3>\r\n<p>"+(null==(e=c.getExplanationText())?"":_.escape(e))+"<br />\r\n"+(null==(e=c.i18n("AnchorAlignWizardArrowKeys"))?"":_.escape(e))+"</p>")}});
define("web-viewer/compare/alignment/CompareAlignmentWizardWidget","web-viewer/layout/AbstractWidget Template tpl!web-viewer/compare/alignment/CompareAlignmentWizardWidget web-viewer/layout/component/ViewerToolbarButton component/toolbar/ButtonGroup component/popover/Popover jquery underscore web-viewer/compare/CompareConstants web-viewer/layout/LayoutConstants web-viewer/core/CoreConstants web-viewer/utils/ListenerUtil".split(" "),function(c,e,d,g,b,a,i,f,k,h,j,l){k=function(k,j,n){c.call(this,k,
h.Widget.ALIGNWIZARD);l.mixin(this,k);this._wizard=j;this._anchorTool=n;this.templateContext=i("<td/>");this.t=new e(k.i18n,d);this.t.d.getExplanationText=function(){return j.isForCadOverlay()?this.i18n("AnchorAlignWizardExplanationCadGraphics"):this.i18n("AnchorAlignWizardExplanation")};this.render=f.throttle(f.bind(this._render,this),40);this._buttonBar=i("<td/>").addClass("buttons");this._anchorToolButton=new g(this.f,"anchorTool","icon-WCR_Align-Point",!0);var t=new a(this._anchorToolButton.element,
this.f.getContext(),this.f.getContext(),"bottom","#333","tooltip",5);this._tooltip=t;var u=this._anchorToolButton.setActive;this._anchorToolButton.setActive=f.bind(function(a,b){u.call(this,b);!b&&a.isVisible()&&a.isEnabled()?t.show():t.hide()},this._anchorToolButton,this);this._anchorToolButton.listenToTool(this._anchorTool,!0);this._anchorToolButton.setTooltip("viewer","AnchorAlignWizardAnchorTool");this._autoAlignButton=new g(this.f,"autoAlign","icon-WCR_Align-Auto",!0,f.bind(function(){this._wizard.autoAlign()},
this));this._autoAlignButton.setTooltip("viewer","AlignAuto");this._autoAlignButton.element.addClass("autoAlign");this._alignGroup=new b("alignButtons",[this._anchorToolButton,this._autoAlignButton]);this._buttonBar.append(this._alignGroup.element);this._cancelButton=new g(this.f,"cancelAlignment","icon-WCR_Revert",!0,f.bind(function(){this._tooltip.hide();this._wizard.cancel()},this));this._alignButton=new g(this.f,"saveAlignment","icon-WCR_Save",!0,f.bind(function(){this._tooltip.hide();this._wizard.alignAndExit()},
this));this._alignButton.element.addClass("btn-success");this._cancelSaveGroup=new b("editActionsGroup",[this._cancelButton,this._alignButton]);this._buttonBar.append(this._cancelSaveGroup.element);this.f.loadBundle("viewer",function(){this._tooltip.setContent(i("<div/>").text(this.f.t("AnchorAlignWizardReactivateTool")));this._alignButton.setContent(i("<span/>").text(this.f.t("AnchorAlignWizardAlign")));this._cancelButton.setContent(i("<span/>").text(this.f.t("CancelButton")));this.render()},this)};
k.prototype=Object.create(c.prototype);k.prototype.constructor=k;k.widgetName=h.Widget.ALIGNWIZARD;k.prototype.setContext=function(a){c.prototype.setContext.call(this,a);this.context.addClass("enableTextSelection");this.context.append(i("<table>").append(i("<tr>").append(this.templateContext).append(this._buttonBar)));this.t.setContext(this.templateContext);this.context.addClass("CompareAlignmentWizardWidget");this.render()};k.prototype._render=function(){this._wizard.isAutoAlignEnabled()?this._alignGroup.addButton(this._autoAlignButton):
this._alignGroup.detachButton(this._autoAlignButton);this.t.render()};k.prototype.getWidgetType=function(){return"wizard"};k.prototype.setEnabled=function(a){c.prototype.setEnabled.apply(this,arguments);a||this._tooltip.hide()};k.prototype.setVisible=function(a){c.prototype.setVisible.call(this,a);a||this._tooltip.hide();this.render()};k.prototype.setCollapsed=function(a){c.prototype.setCollapsed.call(this,a);a&&this._tooltip.hide()};return k});
define("web-viewer/compare/alignment/CompareAlignmentWizard","web-viewer/core/ViewerMode web-viewer/core/CoreConstants web-viewer/compare/alignment/CompareAlignmentAnchorModel web-viewer/compare/alignment/CompareAlignmentAnchorLayerModel web-viewer/compare/alignment/CompareAnchorTool web-viewer/compare/alignment/CompareAlignmentWizardWidget web-viewer/utils/ListenerUtil utils/ShapeUtils web-viewer/layout/LayoutConstants web-viewer/graphics/GraphicsConstants web-viewer/cad/CadConstants Mousetrap underscore".split(" "),
function(c,e,d,g,b,a,i,f,k,h,j,l,q){var r=function(a,b,e,k){c.call(this,a,"compareAlignmentWizardMode");i.mixin(this,a);this._compareModule=b;this._compareModel=e;this._alignmentAnchorModel=new d(this.f,["module","compare","alignment","anchor"]);this._currentAnchorLayerModel=new g(this.f,"compare_alignment_currentAnchor");this._referenceAnchorLayerModel=new g(this.f,"compare_alignment_referenceAnchor");this._compareAlignmentMode=new k(this.f,this._compareModel,this._currentAnchorLayerModel,this._referenceAnchorLayerModel);
this._compareModel.registerMode(this._compareAlignmentMode);this._anchorTool=this._middleToActiveAnchor=this._compareAlignmentWizardWidget=null;this._forCadOverlay=!1;this._offsetBeforeStart=null;this._before={};this._activeAnchorToWorldOffset=new f.Size;this._compareDiffMode=null;this._onPressA=q.bind(function(){this.f.emit("toolManager.activateTool",this._anchorTool)},this)};r.prototype=Object.create(c.prototype);r.prototype.constructor=r;r.prototype._doStart=function(){this._before={};this._offsetBeforeStart=
this._forCadOverlay?this._compareModel.getCadOverlayOffset():this._compareModel.getOffset();var b=this.f.getModule("graphics");b&&(this._before.channelViewMode=b.getChannelViewMode(),b.setChannelViewMode(h.ChannelViewMode.COMPOSITE_VIEW));if(b=this.f.getModule("cad"))this._before.cadGraphicsMode=b.getCadGraphicsMode(),b.setCadGraphicsMode(j.CadGraphicsMode.BOTH);this._registerListener("changed.*",this._anchorsUpdated,this,this._alignmentAnchorModel);this._registerListener("referenceOffset.beforeChange",
this._storeMiddleToAnchorOffset,this,this._compareModule);this._registerListener("cadOverlayOffset.beforeChange",this._storeMiddleToAnchorOffset,this,this._compareModule);this._registerListener("referenceOffset.changed",this._offsetChanged,this,this._compareModel);this._registerListener("cadOverlayOffset.changed",this._offsetChanged,this,this._compareModel);this._alignmentAnchorModel.reset();this._currentAnchorLayerModel._updateTransformation();this._referenceAnchorLayerModel._updateTransformation();
this._disallowAllToolsExcept([e.TOOLS.PAN,e.TOOLS.ZOOM,e.TOOLS.COMPARE_ANCHOR_ALIGNMENT]);this._compareDiffMode=this._compareModule.getCurrentDiffMode();this._compareAlignmentMode.setForCadOverlay(this._forCadOverlay);this._compareModule.activateModeByName("alignment");this._anchorTool||this._initializeAnchorTool();this._anchorTool.setForCadOverlay(this._forCadOverlay);this.f.emit("toolManager.activateTool",this._anchorTool);this._compareAlignmentWizardWidget||(this._compareAlignmentWizardWidget=
new a(this.f,this,this._anchorTool),this.f.emit("layout.addWidget",a.widgetName,q.bind(function(){return this._compareAlignmentWizardWidget},this)));this._compareAlignmentWizardWidget.setEnabled(!0);l.bind("a",this._onPressA,"keypress");this.f.emit("layout.switchLayoutMode",k.LayoutMode.WIZARD);this._compareAlignmentWizardWidget&&this._compareAlignmentWizardWidget.render()};r.prototype._doStop=function(){this._unregisterAllListeners();this._allowAllTools();this._anchorTool.isActive()&&this._anchorTool.requestDeactivation();
this._compareModule.activateModeByDiffMode(this._compareDiffMode);this._compareDiffMode=null;l.unbind("a",this._onPressA,"keypress");this._compareAlignmentWizardWidget.setEnabled(!1);this.f.emit("layout.switchLayoutMode");var a=this.f.getModule("graphics");a&&a.setChannelViewMode(this._before.channelViewMode);(a=this.f.getModule("cad"))&&void 0!==this._before.cadGraphicsMode&&a.setCadGraphicsMode(this._before.cadGraphicsMode)};r.prototype._offsetChanged=function(){this._currentAnchorLayerModel.indicateSnapPoint(null);
this._referenceAnchorLayerModel.indicateSnapPoint(null);this._currentAnchorLayerModel._updateTransformation();this._referenceAnchorLayerModel._updateTransformation();this._alignmentAnchorModel.setReferenceAnchor(this._alignmentAnchorModel.getCurrentAnchor());this._restoreMiddleToAnchorOffset()};r.prototype._setReferenceOffset=function(){var a=this._alignmentAnchorModel.getOffset(),b;if(a&&!(0===a.width&&0===a.height))if(this._forCadOverlay){var c=this._compareModel.getCadOverlayOffset();b=this.f.getModule("cad");
a=b.getOverlayTransform().createInverse().transformedSize(a);this._compareModule.changeCadOverlayOffset(new f.Point(c.x-a.width,c.y+a.height))}else c=this._compareModel.getOffset(),this.f.getActivePage().hasCad()&&(b=this.f.getModule("cad"),a=b.getReferenceTransform().createInverse().transformedSize(a),a.width=-a.width),this._compareModule.changeReferenceOffset(new f.Point(c.x+a.width,c.y+a.height))};r.prototype._anchorsUpdated=function(){this._referenceAnchorLayerModel.setAnchor(this._alignmentAnchorModel.getReferenceAnchor());
this._currentAnchorLayerModel.setAnchor(this._alignmentAnchorModel.getCurrentAnchor());this._currentAnchorLayerModel.setActive(this._alignmentAnchorModel.isCurrentActive());this._referenceAnchorLayerModel.setActive(!this._alignmentAnchorModel.isCurrentActive());this._setReferenceOffset()};r.prototype._initializeAnchorTool=function(){this._anchorTool=new b(this.f,this._alignmentAnchorModel,this._currentAnchorLayerModel,this._referenceAnchorLayerModel);this.f.emit("toolManager.addTool",this._anchorTool)};
r.prototype.cancel=function(){this._forCadOverlay?this._compareModule.changeCadOverlayOffset(this._offsetBeforeStart):this._compareModule.changeReferenceOffset(this._offsetBeforeStart);this.requestStop()};r.prototype.alignAndExit=function(){this.requestStop()};r.prototype.autoAlign=function(){this._compareModule.autoAlign()};r.prototype._storeMiddleToAnchorOffset=function(){var a=this._alignmentAnchorModel.getActiveAnchor();if(a&&!this._middleToActiveAnchor){var b=this.f.getActivePage().getDocumentPageOrigin();
a.offset(new f.Size(b.x,b.y));var c=this.f.getModule("viewport"),b=c.getMiddle(),c=c.getZoom();this._middleToActiveAnchor=new f.Size((a.x-b.x)*c,(a.y-b.y)*c);this.f.emit("module.graphics.model.needsFragmentCleanup")}};r.prototype._restoreMiddleToAnchorOffset=function(){if(this._middleToActiveAnchor){var a=this._alignmentAnchorModel.getActiveAnchor(),b=this.f.getActivePage().getDocumentPageOrigin();a.offset(new f.Size(b.x,b.y));var b=this.f.getModule("viewport"),c=b.getZoom();b.transform({middle:new f.Point(a.x-
this._middleToActiveAnchor.width/c,a.y-this._middleToActiveAnchor.height/c),animated:!1,tmpDisableConstraints:!0});this._middleToActiveAnchor=null}};r.prototype.isAutoAlignEnabled=function(){return!this.f.getActivePage().hasCad()&&!this._forCadOverlay};r.prototype.isForCadOverlay=function(){return this._forCadOverlay};r.prototype.setForCadOverlay=function(a){this._forCadOverlay=a};return r});
define("web-viewer/layout/component/Slider","component/tooltip/Tooltip web-viewer/layout/component/Spinner web-viewer/utils/ViewerUtils underscore jquery jqueryUI jqueryUITouchPunch".split(" "),function(c,e,d,g,b){d=function(a,d){this.f=a;this._min=void 0===d.min?0:d.min;this._max=void 0===d.max?100:d.max;this._step=void 0===d.step?1:d.step;this._onSliderChanged=d.onSliderChanged;this._showInput=void 0===d.showInput?!0:d.showInput;this._inputUnit=void 0===d.inputUnit?"%":d.inputUnit;this.element=
b("<div />").addClass("sliderWrapper");this._slider=b("<div />").addClass("slider");this.element.append(this._slider);this._slider.slider({slide:g.bind(function(a,b){this._setInputValue(b.value);this._fireSliderChanged(b.value)},this),min:this._min,max:this._max,step:this._step});this._showInput&&(this._spinner=new e(a,{min:this._min,max:this._max,step:this._step,page:10*this._step,onSpinnerChanged:g.bind(function(a){this._setSliderValue(a)},this),inputUnit:this._inputUnit}),this.element.append(this._spinner.element));
void 0!==d.tooltip&&(this._tooltip=new c(this.f.i18n,this.element,this.f.getContext(),this.f.getContext(),this.f.isMobile(),d.tooltip))};d.prototype._fireSliderChanged=function(a){this._onSliderChanged(a)};d.prototype._setSliderValue=function(a){this.getValue()!==a&&(this._slider.slider("value",a),this._fireSliderChanged(a))};d.prototype._setInputValue=function(a){this._showInput&&this._spinner.setValue(a)};d.prototype.setValue=function(a){this.getValue()!==a&&(this._setSliderValue(a),this._setInputValue(a))};
d.prototype.getValue=function(){return this._slider.slider("value")};d.prototype.isDisabled=function(){return this._slider.slider("option","disabled")};d.prototype.setDisabled=function(a){this._slider.slider("option","disabled",a);this._showInput&&this._input.spinner("option","disabled",a)};d.prototype.setTooltip=function(a){void 0===this._tooltip?this._tooltip=new c(this.f.i18n,this.element,this.f.getContext(),this.f.getContext(),this.f.isMobile(),a):this._tooltip.setTooltipContent(a)};d.prototype.setOption=
function(a,b){var c=this["_"+a];void 0!==c&&c!==b&&(this["_"+a]=b,this._slider.slider("option",a,b),this._showInput&&this._spinner.setOption(a,b))};d.prototype.getOption=function(a){return this["_"+a]};return d});
define("web-viewer/compare/CompareDifferenceSubToolbarComponent","component/toolbar/ToolbarComponent web-viewer/layout/component/SubtoolbarButton web-viewer/layout/component/DropdownSubtoolbarButton component/toolbar/ButtonGroup web-viewer/layout/component/Slider web-viewer/layout/component/ColorPicker web-viewer/layout/component/DoubleColorBlock web-viewer/compare/CompareConstants web-viewer/utils/ListenerUtil underscore".split(" "),function(c,e,d,g,b,a,i,f,k,h){var j=function(a,b,d){k.mixin(this,
a);c.call(this,"DifferenceCompareOptions",a);this.f=a;this.compareDiffMode=b;this.parent=d;this._initColorSpace();this._initThresholdSlider();this._initHighlightColor();this._initDiffmode();this.f.getDocumentController().whenActivePageChanged(h.bind(function(a,b){this._whenActivePageChanged(a,b)},this))};j.prototype=Object.create(c.prototype);j.prototype.constructor=j;j.prototype._whenActivePageChanged=function(a,b){b.hasCad()?(this.colorspaceGroup.hide(),this.differenceShowModeGroup.hide(),this.slider.element.addClass("displayNone")):
(this.colorspaceGroup.show(),this.differenceShowModeGroup.show(),this.slider.element.removeClass("displayNone"))};j.prototype._initColorSpace=function(){this.colorSpaceButtons=[];this.f.isMobile();this.colorSpaceButtons[0]=new e(this.f,"colorspaceChannels","icon-WCR_Compare-Channels",!0,h.bind(this.compareDiffMode.setColorSpace,this.compareDiffMode,f.colorSpace.CHANNELS));this.colorSpaceButtons[1]=new e(this.f,"colorspaceHSV","icon-WCR_Compare-HSV",!0,h.bind(this.compareDiffMode.setColorSpace,this.compareDiffMode,
f.colorSpace.HSV));this.colorSpaceButtons[2]=new e(this.f,"colorspaceAutomatic","icon-WCR_Compare-Automatic",!0,h.bind(this.compareDiffMode.setColorSpace,this.compareDiffMode,f.colorSpace.AUTOMATIC));this.f.i18n.loadBundle("viewer",function(){var a=this.f.i18n.t("DiffColorSpace")+" ";this.colorSpaceButtons[0].setTooltip(a+this.f.i18n.t("DiffColorSpaceChannels"));this.colorSpaceButtons[1].setTooltip(a+this.f.i18n.t("DiffColorSpaceHsv"));this.colorSpaceButtons[2].setTooltip(a+this.f.i18n.t("DiffColorSpaceAutomatic"))},
this);this.colorspaceGroup=new g("colorspace",this.colorSpaceButtons);this.colorspaceGroup.element.addClass("toggleBtnGroup");this.addButtonGroup(this.colorspaceGroup);this.compareDiffMode.on("changed.colorspace",h.bind(this.updateColorSpaceButtons,this));this.updateColorSpaceButtons(0,this.compareDiffMode.getColorSpace())};j.prototype.updateColorSpaceButtons=function(a,b){h.each(this.colorSpaceButtons,function(a,c){b===f.colorSpace.DEFAULT&&(b=f.colorSpace.CHANNELS);a.setActive(c+1===b)},this)};
j.prototype._initThresholdSlider=function(){this.slider=new b(this.f,{onSliderChanged:h.bind(h.debounce(function(){this.compareDiffMode.setThreshold(this.slider.getValue())},250),this)});this.slider.setValue(this.compareDiffMode.getThreshold());this._registerListener("changed.threshold",function(a,b){this.slider.setValue(b)},this,this.compareDiffMode);this.f.i18n.loadBundle("viewer",function(){this.slider.setTooltip(this.f.i18n.t("ChangeDifferenceThresholdTT"))},this);this.element.append(this.slider.element)};
j.prototype._initHighlightColor=function(){if(!this.f.isMobile()){this.diffColorChangeGroup=new g("diffColorChangeGroup");this.addButtonGroup(this.diffColorChangeGroup);var b=new i(this.compareDiffMode.getAddedHighlightColor(),this.compareDiffMode.getSubtractedHighlightColor()),c=new d(this.f,"ChangeDiffColor",b.element,!0);c.setTooltip("viewer","ChangeDifferenceHighlightColorsTT");this.diffColorChangeGroup.addButton(c);var f=new a(this.f,h.bind(this.compareDiffMode.setAddedHighlightColor,this.compareDiffMode));
f.setColor(this.compareDiffMode.getAddedHighlightColor());var k=new a(this.f,h.bind(this.compareDiffMode.setSubtractedHighlightColor,this.compareDiffMode));k.setColor(this.compareDiffMode.getSubtractedHighlightColor());var j=new i(this.compareDiffMode.getAddedHighlightColor(),this.compareDiffMode.getSubtractedHighlightColor()),u=new a(this.f,h.bind(function(a){this.compareDiffMode.setAddedHighlightColor(a);this.compareDiffMode.setSubtractedHighlightColor(a)},this),j.element);u.setColor(this.compareDiffMode.getAddedHighlightColor());
this.compareDiffMode.on("changed.addedHighlightColor",function(a,c){f.setColor(c);b.setLeftColor(c);j.setLeftColor(c)});this.compareDiffMode.on("changed.subtractedHighlightColor",function(a,c){k.setColor(c);b.setRightColor(c);j.setRightColor(c)});this.f.i18n.loadBundle("viewer",function(){c.addAction({name:"changeAddedHighlightColor",icon:f.element,content:this.f.i18n.t("DiffAddColor"),enabled:!0,action:function(){f.show()}});c.addAction({name:"changeSubtractedHighlightColor",icon:k.element,content:this.f.i18n.t("DiffSubColor"),
enabled:!0,action:function(){k.show()}});c.addAction({name:"changeBothHighlightColor",icon:u.element,content:this.f.i18n.t("DiffBothColors"),enabled:!0,action:function(){u.show()}})},this);var x=new e(this.f,"ResetDiffColor","icon-WCR_WF-Undo",!0,h.bind(this.compareDiffMode.resetHighlightColors,this.compareDiffMode));x.setTooltip("viewer","DiffResetColor");this.diffColorChangeGroup.addButton(x)}};j.prototype._initDiffmode=function(){this.showModeButtons=[];this.f.isMobile();this.showModeButtons[0]=
new e(this.f,"differenceShow","icon-WCR_Compare-BothDiff",!0,h.bind(this.setDifferenceMode,this,f.showDifferenceMode.SHOW));this.showModeButtons[1]=new e(this.f,"differenceHighlight","icon-WCR_Compare-HighlightDiff",!0,h.bind(this.setDifferenceMode,this,f.showDifferenceMode.HIGHLIGHT));this.showModeButtons[2]=new e(this.f,"differenceOnly","icon-WCR_Compare-ShowDiff",!0,h.bind(this.setDifferenceMode,this,f.showDifferenceMode.ONLY));this.f.i18n.loadBundle("viewer",function(){this.showModeButtons[0].setTooltip(this.f.i18n.t("DiffBothTT"));
this.showModeButtons[1].setTooltip(this.f.i18n.t("DiffBothHighlightTT"));this.showModeButtons[2].setTooltip(this.f.i18n.t("DiffBothShowTT"))},this);this.differenceShowModeGroup=new g("differenceShowMode",this.showModeButtons);this.differenceShowModeGroup.element.addClass("toggleBtnGroup");this.addButtonGroup(this.differenceShowModeGroup);this.compareDiffMode.on("changed.differenceMode",h.bind(this.updateDifferenceModeButtons,this));this.updateDifferenceModeButtons(0,this.compareDiffMode.getDifferenceMode())};
j.prototype.updateDifferenceModeButtons=function(a,b){h.each(this.showModeButtons,function(a,c){a.setActive(c+2===b);a.element.removeClass("displayNone")});this.updateParentIcon(["icon-WCR_Compare-BothDiff","icon-WCR_Compare-HighlightDiff","icon-WCR_Compare-ShowDiff"][b-2])};j.prototype.updateParentIcon=function(a){this.parent&&this.parent.setIcon(a)};j.prototype.setDifferenceMode=function(a){this.compareDiffMode.setDifferenceMode(a)};return j});
define("web-viewer/compare/CompareSideBySideSubToolbarComponent","web-viewer/compare/CompareDifferenceSubToolbarComponent component/toolbar/ButtonGroup web-viewer/layout/component/SubtoolbarButton web-viewer/layout/component/DropdownSubtoolbarButton web-viewer/viewport/ViewportConstants web-viewer/compare/CompareConstants jquery underscore".split(" "),function(c,e,d,g,b,a,i,f){a=function(a,i,j,l){this._sideBySideMode=j;c.call(this,a,i,l);this._tileIcons=["icon-WCR_Tiling-Auto","icon-WCR_Tiling-Vertical",
"icon-WCR_Tiling-Horizontal"];this._tileButton=new g(this.f,"sideBySideMode",this.getTileIcon(),!0);this._tileButton.setTooltip("viewer","diffChangeSideBySideTilingMode");this.f.i18n.loadBundle("viewer",function(){this._tileButton.addAction({name:"automaticTiling",icon:"icon-WCR_Tiling-Auto",content:this.f.i18n.t("DiffSplitTileAuto"),enabled:!0,action:f.bind(function(){this._sideBySideMode.setPanelsLayoutMode(b.PanelsLayoutMode.AUTOMATIC)},this)});this._tileButton.addAction({name:"verticalTiling",
icon:"icon-WCR_Tiling-Vertical",content:this.f.i18n.t("DiffSplitTileVer"),enabled:!0,action:f.bind(function(){this._sideBySideMode.setPanelsLayoutMode(b.PanelsLayoutMode.VERTICAL)},this)});this._tileButton.addAction({name:"horizontalTiling",icon:"icon-WCR_Tiling-Horizontal",content:this.f.i18n.t("DiffSplitTileHor"),enabled:!0,action:f.bind(function(){this._sideBySideMode.setPanelsLayoutMode(b.PanelsLayoutMode.HORIZONTAL)},this)})},this);this.f.isMobile()||(this._tilingModeButtonGroup=new e("tilingmode",
[this._tileButton]),this.prependButtonGroup(this._tilingModeButtonGroup));this.toggleDifferenceSidePanelButton=new d(this.f,"toggleDifferencePanel","icon-WCR_Compare-HideDiff",!1,f.bind(this.toggleDifferencePanel,this));this.toggleDifferenceSidePanelButton.setTooltip("viewer","compareDisableDifferenceView");this.f.i18n.loadBundle("viewer",function(){var a=this.f.i18n.t("DiffBothSplitShowDiff")+": <br />\r\n";this.showModeButtons[0].setTooltip(a+this.f.i18n.t("DiffBothTT"));this.showModeButtons[1].setTooltip(a+
this.f.i18n.t("DiffBothHighlightTT"));this.showModeButtons[2].setTooltip(a+this.f.i18n.t("DiffBothShowTT"))},this);this.differenceShowModeGroup.prependButton(this.toggleDifferenceSidePanelButton);this._sideBySideMode.on("changed.*",f.bind(function(){this.updateControls()},this));this.updateControls()};a.prototype=Object.create(c.prototype);a.prototype.constructor=a;a.prototype.updateParentIcon=function(){};a.prototype.updateControls=function(){this.differenceShowModeGroup.show();if(this._sideBySideMode.isShowingDifference()){this.diffColorChangeGroup&&
this.diffColorChangeGroup.show();var a=this.f.getDocumentController().getActivePage();a&&!a.hasCad()&&(this.colorspaceGroup.show(),this.slider.element.removeClass("displayNone"))}else this.colorspaceGroup.hide(),this.slider.element.addClass("displayNone"),this.diffColorChangeGroup&&this.diffColorChangeGroup.hide();this._tileButton&&this._tileButton.setIcon(this.getTileIcon());this.updateDifferenceModeButtons();this.element.trigger("contentResized")};a.prototype.setDifferenceMode=function(a){this._sideBySideMode.setShowingDifference(!0);
c.prototype.setDifferenceMode.call(this,a)};a.prototype._whenActivePageChanged=function(a,b){c.prototype._whenActivePageChanged.call(this,a,b);this.updateControls()};a.prototype.updateDifferenceModeButtons=function(){if(this.compareDiffMode.isAvailable()){this._sideBySideMode.isShowingDifference()?c.prototype.updateDifferenceModeButtons.call(this,void 0,this.compareDiffMode.getDifferenceMode()):f.each(this.showModeButtons,function(a){a.setActive(!1)});this.differenceShowModeGroup&&this.differenceShowModeGroup.show();
this.toggleDifferenceSidePanelButton&&this.toggleDifferenceSidePanelButton.setActive(!this._sideBySideMode.isShowingDifference());var a=this.f.getDocumentController().getActivePage();a&&a.hasCad()?f.each(this.showModeButtons,function(a,b){0<b?a.element.addClass("displayNone"):a.element.addClass("endRoundedCorner")}):a&&f.each(this.showModeButtons,function(a){a.element.removeClass("displayNone");a.element.removeClass("endRoundedCorner")})}else this.differenceShowModeGroup&&this.differenceShowModeGroup.hide(),
f.each(this.showModeButtons,function(a){a.element.addClass("displayNone")})};a.prototype.getTileIcon=function(){return this._tileIcons[this._sideBySideMode.getPanelsLayoutMode()]};a.prototype.toggleDifferencePanel=function(){this._sideBySideMode.isShowingDifference()&&this._sideBySideMode.setShowingDifference(!1)};return a});
define("web-viewer/compare/CompareToolbarComponent","component/toolbar/ToolbarComponent component/toolbar/ButtonGroup web-viewer/layout/component/DropdownToolbarButton web-viewer/layout/component/ViewerToolbarButton web-viewer/layout/LayoutConstants web-viewer/compare/CompareConstants web-viewer/compare/CompareDifferenceSubToolbarComponent web-viewer/compare/CompareSideBySideSubToolbarComponent underscore".split(" "),function(c,e,d,g,b,a,i,f,k){var h=function(d,f){c.call(this,b.ToolbarComponent.COMPARE,
d);this.f=d;this.compareModule=f;this.compareModel=f.getCompareModel();this.buttons={};this.modesGroup=new e("Compare",[]);this.modesGroup.setTitle(this.f.i18n,"viewer","CompareToolsTitle");this.addButtonGroup(this.modesGroup);this.alignGroup=new e("Align",[]);this.alignGroup.setTitle(this.f.i18n,"viewer","CompareToolsTitle2");this.addButtonGroup(this.alignGroup);this.addLockButton();this.addAlignButton();var g=k.bind(function(a,b){a&&void 0!==this.buttons[a.getName()]&&this.buttons[a.getName()].setActive(!1);
b&&void 0!==this.buttons[b.getName()]&&this.buttons[b.getName()].setActive(!0)},this);this.compareModel.on("changed.mode",g);this.addButtonForMode([a.mode.SHOW_CURRENT,a.mode.CURRENT3D],"icon-WCR_Compare-Current","DiffCurrentTT");this.addButtonForMode([a.mode.SHOW_DIFFERENCE,a.mode.REFERENCE3D],"icon-WCR_Compare-Reference","DiffPrevTT");this.addButtonForMode([a.mode.BLINKING,a.mode.BLINKING3D],"icon-WCR_Compare-Blinking","DiffBothBlinkingTT");this.addButtonForMode(a.mode.SHOWBOTHONTOP,"icon-WCR_Compare",
"DiffShowBothOnTopTT");var i=this.compareModel.getModeByName(a.mode.DIFFERENCE);if(void 0!==i){this.addDifferenceModeButton(i);var h=k.debounce(k.bind(this._updateBadges,this),0);i.on("changed.threshold",h);this.compareModel.on("changed.mode",h);this.f.getDocumentController().whenActivePageChanged(h);var t=this.compareModel.getModeByName(a.mode.SIDEBYSIDE);void 0!==t&&(this.addSideBySideModeButton(i,t),t.on("changed.showDifference",h));this._updateBadges()}this.f.getDocumentController().whenActiveOrDifferencePageChanged(this._updateButtonVisibility.bind(this));
this.f.on("module.compare.changed.mode",this._updateButtonVisibility.bind(this));this.f.on("view3d.widget.loaded",this._updateButtonVisibility.bind(this));this.f.on("changed.lock",k.bind(function(a){this.f.getModule("view3D")&&this._compare3DLockBtn.setActive(!a)},this));g(void 0,this.compareModel.getActiveMode())};h.prototype=Object.create(c.prototype);h.prototype.constructor=h;h.toolbarName=b.ToolbarComponent.COMPARE;h.prototype.addButtonForMode=function(b,c,d){var b=k.flatten([b]),f=new g(this.f,
"compare_"+b[0],c,!0,k.partial(function(c){if(c.compareModel.getActiveMode()&&-1!==b.indexOf(c.compareModel.getActiveMode().getName()))c.compareModule.activateModeByName();else{var d=this.f.getDocumentController().getActivePage(),f=this.f.getDocumentController().getDifferencePage(),e;e=f?k.intersection(d.getAvailableCompareModes(f),f.getAvailableCompareModes(d)):c._getAvailableCompareModes(d);var i=(d=c.compareModel.getActiveMode())&&a.modes3D[d.getName()];(d=k.find(b,function(b){return-1!==e.indexOf(b)&&
(i&&a.modes3D[b]||!i&&a.modes2D[b])}))||(d=k.find(b,function(a){return-1!==e.indexOf(a)}));c.compareModule.activateModeByName(d)}},this));f.setTooltip("viewer",d);this.modesGroup.addButton(f);b.forEach(function(a){this.buttons[a]=f}.bind(this))};h.prototype.addLockButton=function(){this._compare3DLockBtn=new d(this.f,"compare3D_lock","icon-WCR_Viewer-Perspectives-Linked",!0,k.partial(function(a){a.f.emit("changed.lock",this.isActive())},this));this._compare3DLockBtn.addOption({name:"compare3D_lock_low_performance",
content:this.f.i18n.t("View3DLockCameraLive"),selected:1===this.f.getOption("PREFERENCES_VIEW3D_CAMERA_LOCK_LIVE"),onchange:function(){var a=1===this.f.getOption("PREFERENCES_VIEW3D_CAMERA_LOCK_LIVE");this.f.setOption("PREFERENCES_VIEW3D_CAMERA_LOCK_LIVE",a?0:1)}.bind(this)});this._compare3DLockBtn.setTooltip("viewer","LockMovementTT");this._compare3DLockBtn.setActive(!0);this.alignGroup.addButton(this._compare3DLockBtn)};h.prototype.addAlignButton=function(){var a=new g(this.f,"compare3D_sync","icon-WCR_Viewer-Perspectives-Reset",
!0,k.partial(function(a){(a=a.f.getModule("view3D"))&&a.syncCurrentWithDifference()},this));a.setTooltip("viewer","AlignViewsTT");this.alignGroup.addButton(a)};h.prototype._updateButtonVisibility=function(){var b=this.f.getDocumentController().getActivePage(),c=this.f.getDocumentController().getDifferencePage(),d;d=c?k.intersection(b.getAvailableCompareModes(c),c.getAvailableCompareModes(b)):this._getAvailableCompareModes(b);k.chain(this.buttons).filter(function(a,b){return-1===d.indexOf(b)}).uniq().invoke("hide");
k.chain(this.buttons).filter(function(a,b){return-1!==d.indexOf(b)}).uniq().invoke("show");(b=this.compareModule.getActiveMode())&&-1!=k.keys(a.modes3D).indexOf(b.getName())?(b=this.f.getModule("view3D"))&&b.canSyncWidgets()?this.alignGroup.show():this.alignGroup.hide():this.alignGroup.hide()};h.prototype._getAvailableCompareModes=function(a){return k.chain(this.f.getDocumentController().getAllDocuments()).map(function(a){return a.getDocumentVersions()}).flatten().map(function(a){return a.getAllPages()}).flatten().without(a).reduce(function(b,
c){return k.union(b,k.intersection(a.getAvailableCompareModes(c),c.getAvailableCompareModes(a)))},[]).value()};h.prototype.addDifferenceModeButton=function(b){this.addButtonForMode(a.mode.DIFFERENCE,"icon-WCR_Compare-BothDiff","compareDifferenceMode");var c=this.buttons[a.mode.DIFFERENCE];c.addSubtoolbarComponent(new i(this.f,b,c));this._differenceCompareMode=b};h.prototype.addSideBySideModeButton=function(b,c){this.addButtonForMode([a.mode.SIDEBYSIDE,a.mode.SIDEBYSIDE3D],"icon-WCR_Compare2-SideBySide",
"DiffBothSplitTT");var d=this.buttons[a.mode.SIDEBYSIDE],e=new f(this.f,b,c,d),i=function(){var b=this.f.getModule("compare")&&this.f.getModule("compare").getActiveMode();b&&b.getName()===a.mode.SIDEBYSIDE?d.addSubtoolbarComponent(e):d.detachSubtoolbarComponent(e)}.bind(this);this.f.on("module.compare.changed.mode",i);i();this._sideBySideCompareMode=c};h.prototype._updateBadges=function(){var b;this.buttons[a.mode.DIFFERENCE]&&this._differenceCompareMode&&(b=this.buttons[a.mode.DIFFERENCE],this._differenceCompareMode.isEnabled()&&
0<this._differenceCompareMode.getThreshold()&&!this.f.getActivePage().hasCad()?(b.setBadge("!","warning"),b.setTooltip("viewer","compareDifferenceThresholdWarning")):(b.setBadge(),b.setTooltip("viewer","compareDifferenceMode")));this.buttons[a.mode.SIDEBYSIDE]&&(b=this.buttons[a.mode.SIDEBYSIDE],this._sideBySideCompareMode.isEnabled()&&this._sideBySideCompareMode.isShowingDifference()&&0<this._differenceCompareMode.getThreshold()&&!this.f.getActivePage().hasCad()?(b.setBadge("!","warning"),b.setTooltip("viewer",
"compareDifferenceThresholdWarning")):(b.setBadge(),b.setTooltip("viewer","DiffBothSplitTT")))};return h});
define("web-viewer/compare/CompareTouchToolbarComponent","component/toolbar/ToolbarComponent component/toolbar/ButtonGroup web-viewer/layout/component/ViewerToolbarButton web-viewer/layout/LayoutConstants web-viewer/compare/CompareConstants underscore".split(" "),function(c,e,d,g,b,a){var i=function(d,i){c.call(this,g.ToolbarComponent.COMPARE,d);this.f=d;this._compareModule=i;this._compareModel=i.getCompareModel();this._buttons={};this._modesGroup=new e("Compare",[]);this._modesGroup.element.removeClass("btn-group");
this._modesGroup.element.addClass("compareModes");this._modesGroup.setTitle(this.f.i18n,"viewer","CompareToolsTitle");this.addButtonGroup(this._modesGroup);var h=this._compareModel.getModeByName(b.mode.DIFFERENCE);this.addDifferenceModeButton(h);this.addButtonForMode([b.mode.BLINKING,b.mode.BLINKING3D],"icon-WCR_Compare-Blinking","DiffBothBlinkingTT");var j=this._compareModel.getModeByName(b.mode.SIDEBYSIDE);this.addSideBySideModeButton(h,j);this.addButtonForMode(b.mode.SHOWBOTHONTOP,"icon-WCR_Compare-Both",
"DiffShowBothOnTopTT");this.addButtonForMode([b.mode.SHOW_CURRENT,b.mode.CURRENT3D],"icon-WCR_Compare-Current","DiffCurrentTT");this.addButtonForMode([b.mode.SHOW_DIFFERENCE,b.mode.REFERENCE3D],"icon-WCR_Compare-Reference","DiffPrevTT");this._compareModel.on("changed.mode",a.bind(this._updateActiveStatus,this));this._updateActiveStatus(void 0,this._compareModule.getActiveMode());this.f.getDocumentController().whenActiveOrDifferencePageChanged(this._updateButtonVisibility.bind(this))};i.prototype=
Object.create(c.prototype);i.prototype.constructor=i;i.toolbarName=g.ToolbarComponent.COMPARE;i.prototype._updateActiveStatus=function(a,b){a&&void 0!==this._buttons[a.getName()]&&this._buttons[a.getName()].setActive(!1);b&&void 0!==this._buttons[b.getName()]&&this._buttons[b.getName()].setActive(!0)};i.prototype.addButtonForMode=function(c,e,i){var c=a.flatten([c]),g=new d(this.f,"compare_"+c[0],e,!0,a.partial(function(d){if(this.isActive())d._compareModule.activateModeByName();else{var e=this.f.getDocumentController().getActivePage(),
i=this.f.getDocumentController().getDifferencePage(),g;g=i?a.intersection(e.getAvailableCompareModes(i),i.getAvailableCompareModes(e)):d._getAvailableCompareModes(e);var k=(e=d._compareModel.getActiveMode())&&b.modes3D[e.getName()];(e=a.find(c,function(a){return-1!==g.indexOf(a)&&(k&&b.modes3D[a]||!k&&b.modes2D[a])}))||(e=a.find(c,function(a){return-1!==g.indexOf(a)}));d._compareModule.activateModeByName(e)}},this));g.setTooltip("viewer",i);this._modesGroup.addButton(g);c.forEach(function(a){this._buttons[a]=
g}.bind(this))};i.prototype._updateButtonVisibility=function(){var b=this.f.getDocumentController().getActivePage(),c=this.f.getDocumentController().getDifferencePage(),d=b.getAvailableCompareModes(),e=[],e=c?a.intersection(d,c.getAvailableCompareModes()):this._getAvailableCompareModes(b);a.chain(this._buttons).filter(function(a,b){return-1===e.indexOf(b)}).uniq().invoke("hide");a.chain(this._buttons).filter(function(a,b){return-1!==e.indexOf(b)}).uniq().invoke("show")};i.prototype._getAvailableCompareModes=
function(b){var c=b.getAvailableCompareModes();return a.chain(this.f.getDocumentController().getAllDocuments()).map(function(a){return a.getDocumentVersions()}).flatten().map(function(a){return a.getAllPages()}).flatten().without(b).reduce(function(b,d){return a.union(b,a.intersection(c,d.getAvailableCompareModes(d)))},[]).value()};i.prototype.addDifferenceModeButton=function(){this.addButtonForMode(b.mode.DIFFERENCE,"icon-WCR_Compare-BothDiff","compareDifferenceMode")};i.prototype.addSideBySideModeButton=
function(){this.addButtonForMode([b.mode.SIDEBYSIDE,b.mode.SIDEBYSIDE3D],"icon-WCR_Compare-SideBySide","DiffBothSplitTT")};return i});
define("web-viewer/layout/component/UserUnitInputField",["web-viewer/utils/ViewerUtils","web-viewer/core/CoreConstants","underscore","jquery"],function(c,e,d,g){var b=function(a,b,e,k){this.f=a;this.element=g("<span>").addClass("userUnitInputField");this._input=g("<input>").attr("type","number").attr("step","any").appendTo(this.element);this._unitLabel=g("<span>").addClass("unitLabel").appendTo(this.element);this._direction=e;this._mmValue=b=c.parseFloat(b);this.f.getCurrentUser().on("options.changed.PREFERENCES_UNIT_SIZE",
d.bind(this._renderField,this));this._input.on("blur keydown",d.bind(this._inputChanged,this));this._renderField();this._onChange=k};b.prototype.setValue=function(a){var b=this._mmValue;this._mmValue=c.parseFloat(a);this._renderField();b!==this._mmValue&&this._onChange(b,this._mmValue)};b.prototype._renderField=function(){var a=c.convertFromMmValue(this._mmValue,this.f.getUnits(),this.f.getUnitsFix(),this._getResolution());this._input.val(a);this.f.loadBundle("viewer",function(){this._unitLabel.text(this.f.t(this.f.getUnitsLocName()))},
this)};b.prototype._getResolution=function(){var a=this.f.getActivePage();if(a){if("y"===this._direction)return c.parseFloat(a.getParam("resolutiony"));if("x"===this._direction)return c.parseFloat(a.getParam("resolutionx"))}return 1};b.prototype._inputChanged=function(a){if(13==a.which||13==a.keyCode||"keydown"!==a.type){(a=c.parseFloat(this._input.val()))||(a=0);this._input.val(a);var b=this._mmValue;this._mmValue=c.parseFloat(c.convertToMmValue(a,this.f.getUnits(),this.f.getUnitsFix(e.SizeUnits.MM),
this._getResolution()));this._mmValue!=b&&this._onChange(b,this._mmValue);this._input.blur()}};b.prototype.toggleLabel=function(a){this._unitLabel.toggleClass("displayNone",!a)};b.prototype.getValue=function(){return this._mmValue};return b});
define("web-viewer/compare/CompareWidget","web-viewer/layout/AbstractWidget web-viewer/layout/component/ViewerToolbarButton web-viewer/layout/component/DropdownToolbarButton web-viewer/layout/component/MiniButton web-viewer/layout/component/ModalPopup web-viewer/layout/component/UserUnitInputField web-viewer/compare/CompareDifferenceSubToolbarComponent web-viewer/compare/CompareSideBySideSubToolbarComponent web-viewer/layout/LayoutConstants web-viewer/compare/CompareConstants jquery underscore".split(" "),function(c,
e,d,g,b,a,i,f,k,h,j,l){var q=function(a,d,f,i){c.call(this,a,k.Widget.COMPARE);this._compareModel=f;this._compareModule=d;this.f=a;this._documentSelection=i;this._cadOverlayOptionsInitialized=this._compareOptionsInitialized=!1;this._extraControls=j("<div/>").addClass("extraControls displayNone");this._documentSelectionDiv=j("<div/>").addClass("documentSelection");this._compareOptions=j("<div/>").addClass("compareOptions displayNone");this._cadOverlay=j("<div>").addClass("cadOverlay displayNone");
this._docTraversal=this.createDocTraversalElem();this._resetLinkedComparePagesButton=new g(this.f,"resetLinkedComparePages","icon-WCR_Revert",!0,l.bind(function(){this.f.i18n.loadBundle("viewer",function(){var c=new b(this.f,"resetLinkedComparePagesPopup",this.f.getContext());c.setRemoveFromDomAfterUsage(!0);c.setOkAction(l.bind(function(){this.f.getActivePage().resetLinkedComparePage();this._updateResetLinkedComparePagesBtn();c.hide()},this));c.addButton(new e(this.f,"allPages",j("<span/>").append(a.i18n.t("AllPages")),
!0,l.bind(function(){l.each(this.f.getActivePage().getDocumentVersion().getAllPages(),function(a){a.resetLinkedComparePage()});this._updateResetLinkedComparePagesBtn();c.hide()},this)));c.setHeader(j("<span/>").addClass("popupTitle").text(this.f.i18n.t("ResetLinkedComparePagesTT")));c.setContent(j("<div/>").addClass("unsavedItemsContent").text(this.f.t("ResetLinkedComparePages")));c.setOkBtnText(this.f.i18n.t("PageOnly"));c.show()},this)},this),"icon-WCR_Revert fontIconDisabled");this._resetLinkedComparePagesButton.setTooltip("viewer",
"ResetLinkedComparePagesTT");this._diffDocPageElement=j("<div/>");this.f.i18n.loadBundle("viewer",l.bind(function(){this._documentSelectionDiv.append(j("<div />").addClass("currentTitleBox").append(j("<h4/>").addClass("currentTitle").append(this.f.t("DocumentListCurrentLabel"))).append(this._docTraversal));this._documentSelectionDiv.append(this._documentSelection.getActiveDocumentSelector().element);this._diffDocPageElement.append(j("<h4/>").append(this.f.t("DocumentListDiffLabel")+" <br/>")).append(this._documentSelection.getDifferenceDocumentSelector().element);
this._documentSelectionDiv.append(this._diffDocPageElement);this.f.getActivePage().canBeComparedTo()&&this._diffDocPageElement.addClass("displayNone");this.setTitle(this.f.t("DocumentListTitle"))},this));this.f.isMobile()&&this.f.loadBundle("viewer",function(){this._compareModule.on("changed.mode",l.bind(this._compareModeChanged,this));this._compareModeChanged()},this);this.f.on("layout.*.changed.layoutMode",this.updateCompareWidget.bind(this));this.setIcon("icon icon-WCR_Document");this.f.getDocumentController().whenActivePageChanged(this.updateDocTraversalElem.bind(this))};
q.prototype=Object.create(c.prototype);q.prototype.constructor=q;q.widgetName=k.Widget.COMPARE;q.prototype._compareModeChanged=function(){var a=this._compareModule.getActiveMode(),b;if(a){var c=a.getName();b=this.f.t(h.modeNameToLanguageKey[c]);this.f.isMobile()&&(c===h.mode.DIFFERENCE||c===h.mode.SIDEBYSIDE?(a=this._compareModel.getModeByName(h.mode.DIFFERENCE),c===h.mode.DIFFERENCE&&(this._differenceCompareControls||(this._differenceCompareControls=new i(this.f,a),this._extraControls.prepend(this._differenceCompareControls.element)),
this._differenceCompareControls.element.removeClass("displayNone"),this._sideBySideCompareControls&&this._sideBySideCompareControls.element.addClass("displayNone")),c===h.mode.SIDEBYSIDE&&(this._sideBySideCompareControls||(c=this._compareModel.getModeByName(h.mode.SIDEBYSIDE),this._sideBySideCompareControls=new f(this.f,a,c),this._extraControls.prepend(this._sideBySideCompareControls.element)),this._sideBySideCompareControls.element.removeClass("displayNone"),this._differenceCompareControls&&this._differenceCompareControls.element.addClass("displayNone")),
this._extraControls.removeClass("displayNone")):this._extraControls.addClass("displayNone"),this._fireResized())}else this._extraControls.addClass("displayNone");this.f.isMobile()&&(b||(b=this.f.t("DocumentListTitle")),this.setTitle(b))};q.prototype._initCompareOptions=function(){this._compareOptionsInitialized||(this._compareOptionsInitialized=!0,this.f.isMobile()||(this._channelMatchingBtn=new e(this.f,"channelMatching","icon-WCR_Channel-Matching",!1,l.bind(function(){var a=this.f.getModule("graphics");
void 0!==a&&a.showChannelMatchingPopup()},this))),this._autoAlign=new e(this.f,"autoAlign","icon-WCR_Align-Auto",!0,l.bind(function(){this._emit("autoAlign")},this)),this._autoAlign.element.addClass("autoAlign"),this._anchorAlign=new e(this.f,"anchorAlign","icon-WCR_Align-Point",!0,l.bind(function(){this._compareModule.startAlignmentWizard()},this)),this._anchorAlign.setTooltip("viewer","AnchorAlignWizardTitle"),this._cornerAlign=new d(this.f,"cornerAlign","cornerAlign",!0),this._rotateReference=
new e(this.f,"rotateReference","icon-WCR_Orientation-Rotate1",!0,l.bind(function(){this._emit("rotateReference");this._updateRotateBtn()},this)),this._flipReference=new e(this.f,"flipReference","icon-WCR_Orientation-Mirror",!0,l.bind(function(){this._emit("flipReference");this._updateFlipBtn()},this)),this._negateReference=new e(this.f,"negateReference","icon-WCR_Invert",!0,l.bind(function(){this._emit("negateReference");this._updateNegateBtn()},this)),this._trimBoxAlign=new e(this.f,"trimBoxAlign",
"icon-WCR_Align-Trimbox",!0,l.bind(function(){this._emit("trimBoxAlign");this._trimBoxAlign.setActive(this._compareModel.isTrimBoxAlign())},this)),this._trimBoxAlign.element.addClass("toggleBtn"),this._offsetX=new a(this.f,0,"x",l.bind(function(a,b){this._emit("offsetXChanged",b)},this)),this._offsetY=new a(this.f,0,"y",l.bind(function(a,b){this._emit("offsetYChanged",b)},this)),this.f.i18n.loadBundle("viewer",l.bind(function(){this._cornerAlign.addAction({name:"topLeftAlign",content:this.f.t("AlignTopLeft"),
icon:"icon-WCR_Align-TopLeft",action:l.bind(function(){this._emit("doCornerAlign",h.cornerAutoAlign.TOPLEFT);this._cornerAlign.setIcon("icon-WCR_Align-TopLeft")},this),enabled:!0});this._cornerAlign.addAction({name:"topCenterAlign",content:this.f.t("AlignTopCenter"),icon:"icon-WCR_Align-TopCenter",action:l.bind(function(){this._emit("doCornerAlign",h.cornerAutoAlign.TOPCENTER);this._cornerAlign.setIcon("icon-WCR_Align-TopCenter")},this),enabled:!0});this._cornerAlign.addAction({name:"topRightAlign",
content:this.f.t("AlignTopRight"),icon:"icon-WCR_Align-TopRight",action:l.bind(function(){this._emit("doCornerAlign",h.cornerAutoAlign.TOPRIGHT);this._cornerAlign.setIcon("icon-WCR_Align-TopRight")},this),enabled:!0});this._cornerAlign.addAction({name:"centerLeftAlign",content:this.f.t("AlignCenterLeft"),icon:"icon-WCR_Align-MiddleLeft",action:l.bind(function(){this._emit("doCornerAlign",h.cornerAutoAlign.CENTERLEFT);this._cornerAlign.setIcon("icon-WCR_Align-MiddleLeft")},this),enabled:!0});this._cornerAlign.addAction({name:"centeredAlign",
content:this.f.t("AlignCentered"),icon:"icon-WCR_Align-MiddleCenter",action:l.bind(function(){this._emit("doCornerAlign",h.cornerAutoAlign.CENTERED);this._cornerAlign.setIcon("icon-WCR_Align-MiddleCenter")},this),enabled:!0});this._cornerAlign.addAction({name:"centerRightAlign",content:this.f.t("AlignCenterRight"),icon:"icon-WCR_Align-MiddleRight",action:l.bind(function(){this._emit("doCornerAlign",h.cornerAutoAlign.CENTERRIGHT);this._cornerAlign.setIcon("icon-WCR_Align-MiddleRight")},this),enabled:!0});
this._cornerAlign.addAction({name:"bottomLeftAlign",content:this.f.t("AlignBottomLeft"),icon:"icon-WCR_Align-BottomLeft",action:l.bind(function(){this._emit("doCornerAlign",h.cornerAutoAlign.BOTTOMLEFT);this._cornerAlign.setIcon("icon-WCR_Align-BottomLeft")},this),enabled:!0});this._cornerAlign.addAction({name:"bottomCenterAlign",content:this.f.t("AlignBottomCenter"),icon:"icon-WCR_Align-BottomCenter",action:l.bind(function(){this._emit("doCornerAlign",h.cornerAutoAlign.BOTTOMCENTER);this._cornerAlign.setIcon("icon-WCR_Align-BottomCenter")},
this),enabled:!0});this._cornerAlign.addAction({name:"bottomRightAlign",content:this.f.t("AlignBottomRight"),icon:"icon-WCR_Align-BottomRight",action:l.bind(function(){this._emit("doCornerAlign",h.cornerAutoAlign.BOTTOMRIGHT);this._cornerAlign.setIcon("icon-WCR_Align-BottomRight")},this),enabled:!0});this._channelMatchingBtn&&this._channelMatchingBtn.setTooltip(this.f.i18n.t("MapChanTitle"));this._autoAlign.setTooltip(this.f.t("AlignAuto"));this._rotateReference.setTooltip(this.f.t("RotateReferenceTT"));
this._flipReference.setTooltip(this.f.t("MirrorReferenceTT"));this._negateReference.setTooltip(this.f.t("ToolInvertReferenceTT"));this._cornerAlign.setTooltip(this.f.t("AlignCornerReferenceTT"));this._trimBoxAlign.setTooltip(this.f.t("AlignFromTrimBoxTT"));this._addCompareOptionsToDOM()},this)))};q.prototype._initCadOverlayOptions=function(){this._cadOverlayOptionsInitialized||(this._cadOverlayOptionsInitialized=!0,this._cadOverlaySaveToEmpty=new g(this.f,"saveCadOverlayToEmpty","icon-WCR_Save",!0,
l.bind(function(){this._emit("saveCadOverlay")},this),"icon-WCR_Save fontIconDisabled"),this._cadOverlaySaveToEmpty.setTooltip("viewer","saveCadRefTT"),this._cadOverlaySaveToEmpty.hide(),this._cadOverlaySave=new e(this.f,"saveCadOVerlay","icon-WCR_Save",!0,l.bind(function(){this._emit("saveCadOverlay")},this)),this._cadOverlaySave.setTooltip("viewer","SaveCadOverlayTT"),this._open3DView=new e(this.f,"open3DView","icon-WCR_3D-Create",!1,l.bind(function(){this._compareModule.checkAligmentAndShow3D()},
this)),this._open3DView.setTooltip("viewer","Open3DViewTT"),this._cadOverlayOrientation=j("<div>").addClass("alignment"),this._cadOverlayRotate=new e(this.f,"rotateOverlay","icon-WCR_Orientation-Rotate1",!0,l.bind(function(){this._emit("rotateCadOverlay")},this)),this._cadOverlayRotate.setTooltip("viewer","RotateOverlayTT"),this._cadOverlayFlip=new e(this.f,"flipOverlay","icon-WCR_Orientation-Mirror",!0,l.bind(function(){this._emit("flipCadOverlay")},this)),this._cadOverlayFlip.setTooltip("viewer",
"FlipOverlayTT"),this._cadOverlayOffsetX=new a(this.f,0,"x",l.bind(function(a,b){this._emit("cadOverlayOffsetXChanged",b)},this)),this._cadOverlayOffsetY=new a(this.f,0,"y",l.bind(function(a,b){this._emit("cadOverlayOffsetYChanged",b)},this)),this.f.loadBundle("viewer",function(){var a=j("<div>").addClass("documentSelection cadSelection").append(this._documentSelection.getCadOverlayDocumentSelector().element);this.f.isMobile()?this._cadOverlay.append(j("<h3>").text(this.f.t("DocumentListCadOverlayTitle")).append(this._cadOverlaySaveToEmpty.element)):
(a.append(this._cadOverlaySaveToEmpty.element),this._cadOverlay.append(j("<h4>").text(this.f.t("DocumentListCadLabel"))));this._cadOverlay.append(a);this._cadOverlay.append(this._cadOverlayOrientation);this.f.isMobile()||this._cadOverlayOrientation.append(j("<span>").addClass("alignLabel").text(this.f.t("DiffOrientation")));this._cadOverlayOrientation.append(this._cadOverlayRotate.element).append(this._cadOverlayFlip.element);this._cadOverlayOrientation.append("<br />");this.f.isMobile()||(this._cadOverlayOrientation.append(j("<span>").addClass("alignLabel").text(this.f.t("AlignLabel"))),
this._cadOverlayAnchorAlign=new e(this.f,"anchorAlign","icon-WCR_Align-Point",!0,l.bind(function(){this._compareModule.startAlignmentWizard(!0)},this)),this._cadOverlayAnchorAlign.setTooltip("viewer","AnchorAlignWizardTitle"),this._cadOverlayOrientation.append(this._cadOverlayAnchorAlign.element));this.f.isMobile()?(a=j("<div>").addClass("offsetFields"),a.append(j("<p>").addClass("alignLabel").text(this.f.t("AlignOffset"))),a.append(j("<p>").text("X: ").append(this._cadOverlayOffsetX.element)),a.append(j("<p>").text("Y: ").append(this._cadOverlayOffsetY.element))):
(this._cadOverlayOffsetX.toggleLabel(!1),a=j("<div>").append(j("<span>").addClass("alignLabel").text(this.f.t("AlignOffset"))),a.append(j("<div>").addClass("offsetFields").append(this._cadOverlayOffsetX.element).append(this._cadOverlayOffsetY.element)));this._cadOverlayOrientation.append(this._cadOverlaySave.element);this._cadOverlayOrientation.append(this._open3DView.element);this._cadOverlayOrientation.append(a)},this))};q.prototype._addCompareOptionsToDOM=function(){this._compareOptionsInitialized&&
(this.context&&!this._compareOptionsAddedToDOM)&&(this._compareOptionsAddedToDOM=!0,this.f.loadBundle("viewer",function(){this.f.isMobile()?(this._documentSelectionTitle=j("<h3/>").text(this.f.t("DocumentListTitle")),this._extraControls.append(this._documentSelectionTitle)):(this._channelMatching=j("<div/>").addClass("channelMatching"),this._channelMatching.append(j("<h4/>").append(this.f.t("DocumentListChannelMatch")+": ")),this._channelMatching.append(this._channelMatchingBtn.element),this._compareOptions.append(this._channelMatching));
this._alignBtns=j("<div/>").addClass("alignment");var a=j(this.f.isMobile()?"<h3/>":"<h4/>");this._alignBtns.append(a.text(this.f.t("DocumentListAlignment")));this.f.isMobile()||this._alignBtns.append(j("<span>").addClass("alignLabel").text(this.f.t("DiffOrientation")));this._alignBtns.append(this._rotateReference.element);this._alignBtns.append(this._flipReference.element);this._alignBtns.append(this._negateReference.element);this._alignBtns.append("<br>");this.f.isMobile()||this._alignBtns.append(j("<span>").addClass("alignLabel").text(this.f.t("AlignLabel")));
this._alignBtns.append(this._autoAlign.element);this.f.isMobile()||this._alignBtns.append(this._anchorAlign.element);this._alignBtns.append(this._cornerAlign.element);this._alignBtns.append(this._trimBoxAlign.element);this._alignBtns.append("<br>");this.f.isMobile()?(this._offsetFields=j("<div>").addClass("offsetFields"),this._offsetFields.append(j("<p>").addClass("alignLabel").text(this.f.t("AlignOffset"))),this._offsetFields.append(j("<p>").text("X: ").append(this._offsetX.element)),this._offsetFields.append(j("<p>").text("Y: ").append(this._offsetY.element)),
this._alignBtns.append(this._offsetFields)):(this._alignBtns.append(j("<span>").addClass("alignLabel").text(this.f.t("AlignOffset"))),this._offsetFields=j("<div>").addClass("offsetFields"),this._offsetX.toggleLabel(!1),this._offsetFields.append(this._offsetX.element),this._offsetFields.append(this._offsetY.element),this._alignBtns.append(this._offsetFields).append(this._unitLabel));this._compareOptions.append(this._alignBtns);this.headerExtra.append(this._resetLinkedComparePagesButton.element);this._compareModeChanged()},
this))};q.prototype.setContext=function(a,b){c.prototype.setContext.call(this,a,b);this.context.addClass("compareWidget");this.context.append(this._extraControls).append(this._documentSelectionDiv).append(this._compareOptions).append(this._cadOverlay);this._addCompareOptionsToDOM();this.headerExtra.addClass("flexEnd");this._updateResetLinkedComparePagesBtn()};q.prototype.updateCompareWidget=function(){var a=this.f.getDocumentController().getDifferencePage();this.f.getActivePage().canBeComparedTo()?
this._diffDocPageElement.removeClass("displayNone"):this._diffDocPageElement.addClass("displayNone");if(void 0===a||this._compareModel.isReaderSpreadActive()||!this.f.getActivePage().canBeComparedTo()||!this.f.getActivePage().areCompareOptionsAllowed()||!a.areCompareOptionsAllowed()||this._compareModule.getActiveMode()&&h.modes3D[this._compareModule.getActiveMode().name])null!==this._compareOptions&&this._compareOptions.addClass("displayNone");else{this._initCompareOptions();this._compareOptions.removeClass("displayNone");
var b=this._compareModel.getOffset();this._offsetX.setValue(b.x);this._offsetY.setValue(b.y);this._trimBoxAlign.setActive(this._compareModel.isTrimBoxAlign());(b=h.cornerAlignIcons[this._compareModel.getCornerAlign()])?this._cornerAlign.setIcon(b):this._cornerAlign.setIcon("icon-WCR_Align-TopLeft");this._updateRotateBtn();this._updateFlipBtn();this._updateNegateBtn();a.hasCad()?(this._negateReference.hide(),this._trimBoxAlign.hide(),this._cornerAlign.hide(),this._autoAlign.hide(),this._channelMatching&&
this._channelMatching.hide()):(this._negateReference.show(),this._trimBoxAlign.show(),this._cornerAlign.show(),this._autoAlign.show(),this._channelMatching&&this._channelMatching.show())}this._cadOverlay&&this._cadOverlay.toggleClass("displayNone",!this._compareModule.isCadOverlayAllowed());(a=this.f.getDocumentController().getCadOverlay())&&a.hasCad()?(this._initCadOverlayOptions(),this._cadOverlayOrientation.removeClass("displayNone"),a=this._compareModel.getCadOverlayOffset(),this._cadOverlayOffsetX.setValue(a.x),
this._cadOverlayOffsetY.setValue(a.y),this._compareModule.canSaveCadOverlay()?(this._cadOverlaySave.show(),!this.f.getActivePage().getDocumentVersion().isMultiPage()&&this.f.getActivePage().get("canGenerate3D")&&this.f.getActivePage().canEditAttributes()?this._open3DView.show():this._open3DView.hide(),this._compareModule.isCadOverlayModified()?this._cadOverlaySave.setEnabled(!0):this._cadOverlaySave.setEnabled(!1)):(this._cadOverlaySave.hide(),this._open3DView.hide()),this.f.getActivePage().hasLinkedPage()&&
(this.f.getActivePage().get("canGenerate3D")&&this.f.getActivePage().canEditAttributes())&&this._open3DView.show(),this._cadOverlaySaveToEmpty.hide(),this._updateCadOverlayButtons()):(this._cadOverlayOrientation&&this._cadOverlayOrientation.addClass("displayNone"),this._compareModule.isCadOverlayAllowed()&&this._initCadOverlayOptions(),this._compareModule.canSaveCadOverlay()?(this._initCadOverlayOptions(),this._cadOverlaySaveToEmpty&&(this._cadOverlaySaveToEmpty.show(),this._compareModule.isCadOverlayModified()?
this._cadOverlaySaveToEmpty.setEnabled(!0):this._cadOverlaySaveToEmpty.setEnabled(!1))):this._cadOverlaySaveToEmpty&&this._cadOverlaySaveToEmpty.hide());this._updateResetLinkedComparePagesBtn();this._fireResized()};q.prototype._updateRotateBtn=function(){var a=this._compareModel.getReferenceRotation();a===h.referenceRotation.NOTROTATED?this._rotateReference.setIcon("icon-WCR_Orientation-Rotate1"):a===h.referenceRotation.ROTATED90?this._rotateReference.setIcon("icon-WCR_Orientation-Rotate2"):a===h.referenceRotation.ROTATED180?
this._rotateReference.setIcon("icon-WCR_Orientation-Rotate3"):a===h.referenceRotation.ROTATED270&&this._rotateReference.setIcon("icon-WCR_Orientation-Rotate4")};q.prototype._updateFlipBtn=function(){this._compareModel.isReferenceFlipped()?(this._flipReference.setIcon("icon-WCR_Orientation-MirrorReverse"),this._flipReference.setTooltip(this.f.t("MirrorReferenceTT2"))):(this._flipReference.setIcon("icon-WCR_Orientation-Mirror"),this._flipReference.setTooltip(this.f.t("MirrorReferenceTT")))};q.prototype._updateNegateBtn=
function(){this._compareModel.isReferenceNegated()?(this._negateReference.setIcon("icon-WCR_InvertReverse"),this._negateReference.setTooltip(this.f.t("ToolInvertReferenceTT2"))):(this._negateReference.setIcon("icon-WCR_Invert"),this._negateReference.setTooltip(this.f.t("ToolInvertReferenceTT")))};q.prototype._updateResetLinkedComparePagesBtn=function(){this.f.getActivePage().getDocumentVersion().isMultiPage()&&this._resetLinkedComparePagesButton.setEnabled(l.some(this.f.getActivePage().getDocumentVersion().getAllPages(),
function(a){return a.hasLinkedComparePage()}))};q.prototype.toggleDifferenceDocPageSelector=function(a){a?this._diffDocPageElement.hide():this._diffDocPageElement.show()};q.prototype._updateCadOverlayButtons=function(){var a=this._compareModel.getCadOverlayRotation();a===h.referenceRotation.NOTROTATED?this._cadOverlayRotate.setIcon("icon-WCR_Orientation-Rotate1"):a===h.referenceRotation.ROTATED90?this._cadOverlayRotate.setIcon("icon-WCR_Orientation-Rotate2"):a===h.referenceRotation.ROTATED180?this._cadOverlayRotate.setIcon("icon-WCR_Orientation-Rotate3"):
a===h.referenceRotation.ROTATED270&&this._cadOverlayRotate.setIcon("icon-WCR_Orientation-Rotate4");this._compareModel.isCadOverlayFlipped()?(this._cadOverlayFlip.setIcon("icon-WCR_Orientation-MirrorReverse"),this._cadOverlayFlip.setTooltip(this.f.t("MirrorCadOverlayTT2"))):(this._cadOverlayFlip.setIcon("icon-WCR_Orientation-Mirror"),this._cadOverlayFlip.setTooltip(this.f.t("MirrorCadOverlayTT")))};q.prototype.createDocTraversalElem=function(){var a=j("<div>").addClass("doctraversal"),b=this.f.getDocumentController().getAllDocuments();
if(1<b.length){var c=function(a){var c=0,c=this.getCurrentDocIndex(),c=a?(c-1+b.length)%b.length:(c+1)%b.length;this.f.emit("selection.requestdoc",b[c])},d=function(a){this.f.emit("selection.requestdoc",b[a?0:b.length-1])};this._firstBtn=new g(this.f,"SelectFirstDoc","icon icon-WCR_Table-Page-First12",!0,l.bind(d,this,!0));this._firstBtn.setTooltip("viewer","NavigatorFirstTT");a.append(this._firstBtn.element);this._prevtBtn=new g(this.f,"SelectPreviousDoc","icon icon-WCR_Table-Page-Previous12",!0,
l.bind(c,this,!0));this._prevtBtn.setTooltip("viewer","NavigatorPreviousTT");a.append(this._prevtBtn.element);this._docIndexSpan=j("<span />").addClass("documentOverview");a.append(this._docIndexSpan);this._nextBtn=new g(this.f,"SelectNextDoc","icon icon-WCR_Table-Page-Next12",!0,l.bind(c,this,!1));this._nextBtn.setTooltip("viewer","NavigatorNextTT");a.append(this._nextBtn.element);this._lastBtn=new g(this.f,"SelectLastDoc","icon icon-WCR_Table-Page-Last12",!0,l.bind(d,this,!1));this._lastBtn.setTooltip("viewer",
"NavigatorLastTT");a.append(this._lastBtn.element);this.updateDocTraversalElem();this.docTraversalInitialized=!0}return a};q.prototype.updateDocTraversalElem=function(){if(this.docTraversalInitialized){var a=this.getCurrentDocIndex(),b=this.f.getDocumentController().getAllDocuments();this._docIndexSpan.empty().append(this.f.t("PageNumberOfCount",this.getCurrentDocIndex()+1,b.length));this._firstBtn.setEnabled(0!==a);this._prevtBtn.setEnabled(0!==a);this._nextBtn.setEnabled(a!==b.length-1);this._lastBtn.setEnabled(a!==
b.length-1)}};q.prototype.getCurrentDocIndex=function(){var a=this.f.getDocumentController().getAllDocuments(),b=this.f.getActiveDocument();return a.indexOf(b)};return q});
define("tpl!web-viewer/compare/ComparePagelistPopup",function(){return function(c){var e,d;d="";c.showPage&&(d+='\r\n\t<div class="page">\r\n\t\t'+(null==(e=c.i18n("PagelistComparePage"))?"":_.escape(e))+" "+(null==(e=c.page)?"":_.escape(e))+"\r\n\t</div>\r\n");d+='\r\n<div class="range">\r\n\t<div>'+(null==(e=c.i18n("PagelistCompareRange"))?"":_.escape(e))+'</div>\r\n\t<ul>\r\n\t\t<li><input type="radio" name="range" value="0" ';0===c.range&&(d+=" checked ");d+=" /> "+(null==(e=c.i18n("PagelistCompareCurrent"))?
"":_.escape(e))+'</li>\r\n\t\t<li><input type="radio" name="range" value="1" ';1===c.range&&(d+=" checked ");d+=" /> "+(null==(e=c.i18n("PagelistCompareFollowing"))?"":_.escape(e))+'</li>\r\n\t\t<li><input type="radio" name="range" value="2" ';2===c.range&&(d+=" checked ");return d+=" /> "+(null==(e=c.i18n("PagelistCompareAll"))?"":_.escape(e))+"</li>\r\n\t</ul>\r\n</div>"}});
define("web-viewer/compare/ComparePagelistPopup","web-viewer/core/PrivateChannel web-viewer/layout/component/ModalPopup Template tpl!web-viewer/compare/ComparePagelistPopup web-viewer/compare/CompareConstants jquery underscore".split(" "),function(c,e,d,g,b,a){var i=function(f,i){e.call(this,f,i,f.getContext());c.installTo(this,f,["comparePagelist"]);this._defaultPagelistCompareRange=b.pagelistCompareRange.CURRENT;this._pagelistComparePage=this._currentPagelistCompareRange=null;this.t=new d(this.f.i18n,
g);this.t.setContext(this._popupContent);this.t.bind("change","[name=range]",function(a){this._currentPagelistCompareRange=parseInt(a.value,10)},this);this.f.i18n.loadBundle("viewer",function(){this.setHeader(a("<span/>").addClass("popupTitle").html(f.i18n.t("MultipageCompare")));this.setOkBtnText(f.i18n.t("OkButton"))},this);this.element.addClass("comparePagelistPopup")};i.prototype=Object.create(e.prototype);i.prototype.constructor=i;i.prototype.render=function(){this.t.d.showPage=this._pagelistComparePage&&
this._pagelistComparePage.getDocumentVersion().isMultiPage();this.t.d.page=this._pagelistComparePage.getPagenum()||"";this.t.d.range=this._currentPagelistCompareRange;this.t.render()};i.prototype._reset=function(){this._currentPagelistCompareRange=b.pagelistCompareRange.CURRENT};i.prototype.show=function(){this._reset();this.render();e.prototype.show.call(this);this.recalculateSize(300)};i.prototype.setComparePage=function(a){this._pagelistComparePage=a};return i});
define("web-viewer/compare/AbstractCompareDataAdapter",[],function(){var c=function(c){this.f=c};c.prototype.saveCadOverlay=function(){throw"Not implemented: AbstractCompareDataAdapter.saveCadOverlay";};c.prototype.convertCompareParameters=function(){throw"Not implemented: AbstractCompareDataAdapter.convertCompareParameters";};return c});
define("web-viewer/compare/CompareModule","web-viewer/core/AbstractModule web-viewer/compare/CompareModel web-viewer/compare/CompareShowCurrentMode web-viewer/compare/CompareShowDifferenceMode web-viewer/compare/CompareBlinkingMode web-viewer/compare/CompareShowBothOnTopMode web-viewer/compare/Compare3DSideBySideMode web-viewer/compare/Compare3DBlinking web-viewer/compare/Compare3DCurrent web-viewer/compare/Compare3DReference web-viewer/compare/alignment/CompareAlignmentWizard web-viewer/compare/CompareToolbarComponent web-viewer/compare/CompareTouchToolbarComponent web-viewer/compare/CompareWidget web-viewer/compare/CompareConstants web-viewer/compare/ComparePagelistPopup web-viewer/compare/AbstractCompareDataAdapter web-viewer/data/DataConstants web-viewer/layout/component/DocumentSelection web-viewer/layout/component/ModalPopup web-viewer/layout/LayoutConstants web-viewer/utils/ListenerUtil utils/XMLUtils utils/ShapeUtils web-viewer/utils/ViewerUtils Mousetrap underscore".split(" "),function(c,
e,d,g,b,a,i,f,k,h,j,l,q,r,n,t,u,x,B,C,A,D,m,y,w,v,p){m=function(s,z,E){c.call(this,s,z,"compare",E||new u(s));D.mixin(this,s);s=this.f.getOption("PREFERENCES_DIFFMODE_COMPARE");this._compareModel=new e(this.f,this.getPrivateChannelNameAsArray(),s);this._documentSelection=new B(this.f,this,p.bind(function(){this._compareWidget&&this._compareWidget.updateCompareWidget()},this),this.f.isMobile());this._compareModel.registerMode(new d(this.f,this._compareModel));this._compareModel.registerMode(new g(this.f,
this._compareModel));this._compareModel.registerMode(new b(this.f,this._compareModel));this._compareModel.registerMode(new i(this.f,this._compareModel));this._compareModel.registerMode(new f(this.f,this._compareModel));this._compareModel.registerMode(new k(this.f,this._compareModel));this._compareModel.registerMode(new h(this.f,this._compareModel));this._compareModel.registerMode(this.createCompareShowReaderSpreadMode());this._differenceMode=this.createCompareDifferenceMode();this._compareModel.registerMode(this._differenceMode);
this._sideBySideMode=this.createCompareSideBySideMode();this._compareModel.registerMode(this._sideBySideMode);this._compareModel.registerMode(new a(this.f,this._compareModel));this._compareAlignmentWizard=this._comparePagelistPopup=this._compareWidget=this._toolbarComponent=null;this._publishToolbarComponentAndWidgetIfNeeded();this._docListener=this._registerListener("doc.loaded",this._publishToolbarComponentAndWidgetIfNeeded,this);this._registerListener("intercept.fragmentURL",this._interceptFragmentURL,
this);this._registerListener("intercept.parameters",this._interceptFragmentURL,this);this._settingDefault=!1;"1"===this.f.getProperty("compare")&&this._compareModel.isRealCompareMode(s)?((z=this.getDefaultDiffPage(this.f.getActivePage()))&&this.activateModeByName(this.f.getActivePage().getAvailableCompareModes(z)[0],s,z),this._settingDefault=!0):this._compareModel.setDiffMode(n.diffMode.UNDEFINED);this._registerListener("changed.mode",function(a,b){var c=this.getCurrentDiffMode();null===b&&void 0!==
this.f.getDocumentController().getDifferencePage()&&this.changeReferenceOffset(new y.Point(0,0));this._compareModel.isRealCompareMode(c)&&this.f.setOption("PREFERENCES_DIFFMODE_COMPARE",c)},this,this._compareModel);this._registerListener("changed.differenceMode",function(a,b){var c=b;this._compareModel.getActiveMode().getName()===n.mode.SIDEBYSIDE&&(c=c===n.diffMode.SHOWBOTHCHANGESHIGHLIGHT?n.diffMode.SHOWBOTHSIDEBYSIDEHIGHLIGHT:c===n.diffMode.SHOWBOTHCHANGESONLY?n.diffMode.SHOWBOTHSIDEBYSIDECHANGESONLY:
n.diffMode.SHOWBOTHSIDEBYSIDE);this.f.setOption("PREFERENCES_DIFFMODE_COMPARE",c)},this,this._differenceMode);this.f.getDocumentController().whenDifferencePageChanged(function(a,b){!this._settingDefault&&(void 0===a&&b&&!this._compareModel.isReaderSpreadActive())&&this.activateModeByDiffMode(this.f.getOption("PREFERENCES_DIFFMODE_COMPARE"))},this);this.f.getDocumentController().whenActiveOrDifferencePageChanged(this._whenActiveOrDifferencePageChanged,this);this.f.getDocumentController().whenActiveOrDifferencePageChangedAndParametersAvailableOrChange(this._whenActiveOrDifferencePageChangedAndParametersAvailableOrChange,
this);this._registerListener("changeReferencePage",p.bind(function(a){this.f.getActivePage().getDocumentVersion().isMultiPage()?(this._comparePagelistPopup.setComparePage(a),this._comparePagelistPopup.show()):this.activateModeByDiffMode(this.f.getOption("PREFERENCES_DIFFMODE_COMPARE"),a)},this),this,this._documentSelection);this._registerListener("changeActivePage",p.bind(function(a,b){this._compareModel.isReaderSpreadActive()&&!a.getDocumentVersion().isMultiPage()&&this.activateModeByName();var c=
this.f.getDocumentController().changeActivePage(a);b&&b(c)},this),this,this._documentSelection);this._registerListener("changeCadOverlay",p.bind(function(a){this.f.getDocumentController().changeCadOverlay(a)},this),this,this._documentSelection);this._registerListener("intercept.activePageChange",this._interceptActivePageChange,this);this.f.getDocumentController().whenDifferencePageChanged(function(a,b){var c=this.f.getModule("navigation");c&&c.resetExtraRotation();this._compareModel.isRealCompareMode(this._compareModel.getDiffMode())&&
(this._previousDifferencePage=b)},this);this.f.getDocumentController().whenCadOverlayChanged(function(a,b){b&&(this.changeCadOverlayOffset(this._compareModel.getCadOverlayOffset()),this.flipCadOverlay(this._compareModel.isCadOverlayFlipped()),this.setCadOverlayRotation(this._compareModel.getCadOverlayRotation()))},this);this.f.getDocumentController().whenActivePageChanged(function(a,b){var c=this.f.getModule("navigation");c&&c.resetExtraRotation();this._compareModel.resetCadOverlayOffset();this._compareModel.resetCadOverlayOrientation();
if(b&&b.hasLinkedPage()&&(c=b.getLinkedPage())){var d=new y.Point,e=!1,s=0;this.f.getDocumentController().getActivePage().hasLinkedPage()&&this.f.getDocumentController().getActivePage().getLinkedPage()===c&&(d=new y.Point(w.parseFloat(c.get("offsetx")),w.parseFloat(c.get("offsety"))),e=c.get("overlayIsFlipped"),s=c.get("overlayRotation"));this.changeCadOverlayOffset(d);this.flipCadOverlay(e);this.setCadOverlayRotation(s)}this._3DWidget&&this._3DWidget.setEnabled(!1)},this);this._registerListener("newLinkedCad",
function(a,b){if(a!==b){var c=null;a&&(c=a.getUniqueID());this._documentSelection.setNewlyCreatedCadOverlay(this.f.getActivePage(),c)}},this,this.f.getDocumentController());v.bind("ctrl+l",p.bind(function(a){var b=this.f.getDocumentController().getDifferencePage();void 0===b||(this._compareModel.isReaderSpreadActive()||b.hasCad())||(this.autoAlign(),a.preventDefault(),a.stopPropagation())},this),"keydown");v.bind("home",p.bind(function(a){var b=this._documentSelection.getFirstSelectablePageId();b&&
(b=this.f.getDocumentController().getDocumentPage(b))&&this.f.getDocumentController().changeActivePage(b);a.preventDefault();a.stopPropagation()},this));v.bind("end",p.bind(function(a){var b=this._documentSelection.getLastSelectablePageId();b&&(b=this.f.getDocumentController().getDocumentPage(b))&&this.f.getDocumentController().changeActivePage(b);a.preventDefault();a.stopPropagation()},this));v.bind("pagedown",p.bind(function(a){var b=this._documentSelection.getNextSelectablePageId();b&&(b=this.f.getDocumentController().getDocumentPage(b))&&
this.f.getDocumentController().changeActivePage(b);a.preventDefault();a.stopPropagation()},this));v.bind("pageup",p.bind(function(a){var b=this._documentSelection.getPreviousSelectablePageId();b&&(b=this.f.getDocumentController().getDocumentPage(b))&&this.f.getDocumentController().changeActivePage(b);a.preventDefault();a.stopPropagation()},this));v.bind("ctrl+s",p.bind(function(a){if(!(this.getCurrentDiffMode()===n.diffMode.UNDEFINED||this.isReaderSpreadActive())){var b=this.getActiveMode().getName();
n.modes2D[b]?b===n.mode.SHOW_CURRENT?this.activateModeByName(n.mode.SHOW_DIFFERENCE):this.activateModeByName(n.mode.SHOW_CURRENT):n.modes3D[b]&&(b===n.mode.CURRENT3D?this.activateModeByName(n.mode.REFERENCE3D):this.activateModeByName(n.mode.CURRENT3D));a.preventDefault();a.stopPropagation()}},this),"keydown")};m.prototype=Object.create(c.prototype);m.prototype.constructor=m;m.prototype.getCurrentDiffMode=function(){var a=this._compareModel.getActiveMode(),b=null;return b=null!==a&&a.getName()===n.mode.BLINKING?
n.diffMode.BLINKING_CURRENT:this._compareModel.getDiffMode()};m.prototype.activateLastUsedCompareMode=function(){var a=this.f.getOption("PREFERENCES_DIFFMODE_COMPARE");this._compareModel.isRealCompareMode(a)&&(this._previousDifferencePage===this.f.getActivePage()&&delete this._previousDifferencePage,this.activateModeByDiffMode(this.f.getOption("PREFERENCES_DIFFMODE_COMPARE"),this._previousDifferencePage),this._previousState&&(this.setState(this._previousState),delete this._previousState))};m.prototype.activateModeByName=
function(a,b,c){if(void 0===a)this._compareModel.isRealCompareMode(this._compareModel.getDiffMode())?this._previousState=this.getState():delete this._previousState,this._compareModel.deactivateCurrentMode(),this.f.getDocumentController().resetDifferencePage();else{var d=this._compareModel.getActiveMode();!d||d.getName()!==a?(this._compareModel.toggleSilenceParametersChanged(!0),this._compareModel.toggleCurrentMode(!1),a===n.mode.READERSPREAD||a===n.mode.ALIGNMENT?(this._compareModel.activateModeByName(a,
b),(c=this.f.getDocumentController().getDifferencePage())&&!c.isBlankPage()?c.whenParametersAvailable(p.bind(function(){this._compareModel.toggleSilenceParametersChanged(!1);this._compareWidget&&this._compareWidget.updateCompareWidget()},this)):this._compareModel.toggleSilenceParametersChanged(!1)):this.f.getDocumentController().whenDocumentsLoaded(function(){c||(c=this.f.getDocumentController().getDifferencePage());c||(c=this.getDefaultDiffPage(this.f.getActivePage(),a));this._settingDefault=!0;
this.f.getDocumentController().changeDifferencePage(c);this._settingDefault=!1;(c=this.f.getDocumentController().getDifferencePage())?(this._compareModel.activateModeByName(a,b),c.whenParametersAvailable(p.bind(function(){this._compareModel.toggleSilenceParametersChanged(!1);this._compareWidget&&this._compareWidget.updateCompareWidget()},this))):this._compareModel.toggleSilenceParametersChanged(!1)},this)):c&&(this._settingDefault=!0,this.f.getDocumentController().changeDifferencePage(c),this._settingDefault=
!1)}};m.prototype.activateModeByDiffMode=function(a,b){if(a===n.diffMode.UNDEFINED)this.activateModeByName();else{var c=this._compareModel.getModeNameByDiffMode(a),d=this.f.getDocumentController().getActivePage(),e=d.getAvailableCompareModes(b);b&&(d=b.getAvailableCompareModes(d),e=p.intersection(e,d));-1!==e.indexOf(c)?this.activateModeByName(c,a,b):this.activateModeByName(e[0],a,b)}};m.prototype.getDefaultDiffPage=function(a,b){a||(a=this.f.getActivePage());var c=a.getLinkedComparePage();if(c)return c;
if(c=this._getNextDiffDocumentVersion(a,void 0,b)){if(a.getDocumentVersion().isMultiPage()&&c.isMultiPage()||a.getDocumentVersion().isPageList()&&c.isPageList()){var d=c.getPage(a.getPagenum());if(d&&!d.isBlankPage()){if(d===a){if(c=this._getNextDiffDocumentVersion(a,c,b))return(d=c.getPage(a.getPagenum()))?d:c.getLastPage();return}return d}if(c.isPageList()&&(void 0===d||d.isBlankPage())){d=a.getPagenum();for(d++;d<c.getPageCount()&&(!c.hasPage(d)||c.getPage(d).isBlankPage());)d++;return d<c.getPageCount()&&
c.getPage(d)!==a?c.getPage(d):c.getFirstNotBlankPage()}return c.getLastPage()}return c.getFirstPage()}if(a.getDocumentVersion().isMultiPage()){c=a.getDocumentVersion().getFirstPage();if(a===c)for(c=c.getNextPage();c.isBlankPage()&&c.getPagenum()<c.getDocumentVersion().getPageCount();)c=c.getNextPage();return c}};m.prototype._getNextDiffDocumentVersion=function(a,b,c){var d=a.getDocument(),e=p.find(this.f.getDocumentController().getAllDocuments(),function(e){return(!b||b&&e!==b.getDocument())&&e!==
d&&p.all(e.getDocumentVersion().getAllPages(),function(b){return b.canBeComparedTo(a,c)})}),f;void 0!==e?f=e.getDocumentVersion():(e=a.getDocumentVersion(),d.hasMultipleVersions()&&1<e.getVersionId()&&(f=d.getDocumentVersion(e.getVersionId()-1)));e=f;if(a.getDocumentVersion().isPageList()&&void 0!==f&&!f.hasPage(a.getPagenum())){for(;void 0!==f&&0<f.getVersionId()&&!f.hasPage(a.getPagenum());)f=d.getDocumentVersion(f.getVersionId()-1);void 0!==f&&!f.hasPage(a.getPagenum())&&(f=a.getDocumentVersion())}return b&&
f===b?e&&e===b?void 0:e:f};m.prototype._interceptFragmentURL=function(a){this._compareModel.getActiveMode()&&(this.f.getDataAdapterForModule("compare").convertCompareParameters(this._compareModel,a.params),this._compareModel.getActiveMode().interceptFragmentURL(a))};m.prototype.getCompareModel=function(){return this._compareModel};m.prototype.getDiffMode=function(){return this._compareModel.getDiffMode()};m.prototype.getActiveMode=function(){return this._compareModel.getActiveMode()};m.prototype.getReferenceOffset=
function(){return this._compareModel.getOffset()};m.prototype.isCompareAvailable=function(){if(!this._compareWidget&&!this._toolbarComponent){var a=this._shouldShowWidgetOrTools();return a.widget||a.tools}return!0};m.prototype.isCadOverlayAllowed=function(){var a=this.f.getActivePage();if(!a.hasCad()&&!a.is3D()&&!a.hasSvg()&&!a.hasVideo()&&-1!==this.f.getLayoutMode().getMainPanelContent().indexOf(A.Widget.VIEWPORT)){if(a.canSaveCadOverlay()||a.hasLinkedPage())return!0;var b=this.f.getDocumentController().getActiveDocument();
return p.some(this.f.getDocumentController().getDocuments(),function(a){if(a!=b&&(a=a.getDocumentVersion()))if(a=a.getPage())return a.hasCad()||a.hasLinkedPage();return!1})}return!1};m.prototype.canSaveCadOverlay=function(){return this.f.getActivePage().canSaveCadOverlay()};m.prototype.isCadOverlayModified=function(){var a=this.f.getActivePage().getLinkedPage(),b=this.f.getDocumentController().getCadOverlay();return a!=b||a&&a.documentType==x.documentPageType.CAD&&(void 0!==a.getStateParam("compareOffset")&&
w.parseFloat(a.get("offsetx"))!==a.getStateParam("compareOffset").x||void 0!==a.getStateParam("compareOffset")&&w.parseFloat(a.get("offsety"))!==a.getStateParam("compareOffset").y||void 0!==a.getStateParam("rotation")&&w.parseFloat(a.get("overlayRotation"))!==a.getStateParam("rotation")||void 0!==a.getStateParam("flipped")&&a.get("overlayIsFlipped")!==a.getStateParam("flipped"))};m.prototype.saveCadOverlay=function(a){var b=this.f.getActivePage(),c={saveCadOverlay:!0,callback:p.partial(p.bind(this.saveCadOverlay,
this),a)};this.f.emit("intercept.savingCadOverlay",c);c.saveCadOverlay&&this.f.getDataAdapterForModule("compare").saveCadOverlay(b,this.f.getDocumentController().getCadOverlay(),this._compareModel.getCadOverlayRotation(),this._compareModel.isCadOverlayFlipped(),this._compareModel.getCadOverlayOffset(),p.bind(function(c){c&&b.set("isCadAlignmentSaved",!0);this._compareWidget&&this._compareWidget.updateCompareWidget();a&&a(c)},this))};m.prototype._shouldShowWidgetOrTools=function(){var a=!1,b=!1;if(2<
this.f.getDocumentController().getDocumentCount())b=a=!0;else{var c=this.f.getDocumentController().getAllDocuments();p.some(c,function(a){return a.hasMultipleVersions()})?b=a=!0:2==c.length?(a=!0,0<p.chain(c[0].getDocumentVersions()[0].getAllPages()).union(c[1].getDocumentVersions()[0].getAllPages()).reduce(function(a,b){return void 0===a?b.getAvailableCompareModes():p.intersection(a,b.getAvailableCompareModes())},void 0).value().length&&(b=!0)):(1<c[0].getDocumentVersion().getPageCount()&&(b=a=!0),
this.f.getActivePage().hasLinkedPage()&&(a=!0,b=!1));a||p.some(c,function(a){return p.some(a.getDocumentVersion().getAllPages(),function(a){return a.canSaveCadOverlay()})})&&(a=!0)}return{widget:a,tools:b}};m.prototype._publishToolbarComponentAndWidgetIfNeeded=function(){if(null===this._toolbarComponent||null===this._compareWidget){var a=this._shouldShowWidgetOrTools();a.tools&&this._publishToolbarComponent(l.toolbarName,p.bind(function(a){return this._toolbarComponent=a===A.LayoutType.MOBILE?new q(this.f,
this):new l(this.f,this)},this));a.widget&&this._publishWidget(r.widgetName,p.bind(function(){this._compareWidget=new r(this.f,this,this._compareModel,this._documentSelection);this._comparePagelistPopup=new t(this.f,"comparePagelistPopup");this._comparePagelistPopup.setOkAction(p.partial(function(a){switch(this._currentPagelistCompareRange){case n.pagelistCompareRange.CURRENT:a._doCurrentCompareRange(this._pagelistComparePage);break;case n.pagelistCompareRange.CURRENTANDFOLLOWING:a._doCurrentAndFollowingCompareRange(this._pagelistComparePage);
break;case n.pagelistCompareRange.ALL:a._doAllCompareRange(this._pagelistComparePage)}a.activateModeByDiffMode(a.f.getOption("PREFERENCES_DIFFMODE_COMPARE"),this._pagelistComparePage);this.hide()},this));this._comparePagelistPopup.setCancelAction(p.bind(function(){this._documentSelection.setDifferenceSelectorPage(this.f.getDocumentController().getDifferencePage())},this));this._registerListener("autoAlign",this.autoAlign,this,this._compareWidget);this._registerListener("doCornerAlign",this._doCornerAlign,
this,this._compareWidget);this._registerListener("rotateReference",this.rotateReference,this,this._compareWidget);this._registerListener("flipReference",this.flipReference,this,this._compareWidget);this._registerListener("negateReference",p.bind(function(){this._compareModel.negateReference()},this),this,this._compareWidget);this._registerListener("trimBoxAlign",this._doTrimBoxAlign,this,this._compareWidget);this._registerListener("offsetXChanged",p.bind(function(a){var b=this._compareModel.getOffset();
b.x=a;this.changeReferenceOffset(b)},this),this,this._compareWidget);this._registerListener("offsetYChanged",p.bind(function(a){var b=this._compareModel.getOffset();b.y=a;this.changeReferenceOffset(b)},this),this,this._compareWidget);this._registerListener("cadOverlayOffsetXChanged",p.bind(function(a){var b=this._compareModel.getCadOverlayOffset();b.x=a;this.changeCadOverlayOffset(b)},this),this,this._compareWidget);this._registerListener("cadOverlayOffsetYChanged",p.bind(function(a){var b=this._compareModel.getCadOverlayOffset();
b.y=a;this.changeCadOverlayOffset(b)},this),this,this._compareWidget);this._registerListener("rotateCadOverlay",this.rotateCadOverlay,this,this._compareWidget);this._registerListener("flipCadOverlay",this.flipCadOverlay,this,this._compareWidget);this._registerListener("saveCadOverlay",this.saveCadOverlay,this,this._compareWidget);this._docListener&&(this._unregisterListener(this._docListener),this._docListener=null);this._compareWidget.updateCompareWidget();return this._compareWidget},this));(a.widget||
a.tools)&&this._emit("compareAvailable")}};m.prototype._whenActiveOrDifferencePageChanged=function(){this._compareModel.resetOffset();this._compareModel.resetCornerAlign();this._compareModel.resetReferenceOrientation();this._compareModel.resetTrimBoxAlign();0===!this.f.getActivePage().canBeComparedTo(this.f.getDocumentController().getDifferencePage()).length&&this.activateModeByName();this._showOrHideCompareToolbarComponent();this._compareWidget&&this._compareWidget.updateCompareWidget()};m.prototype._showOrHideCompareToolbarComponent=
function(){null!==this._toolbarComponent&&(this.f.getActivePage().isBlankPage()||!this.f.getActivePage().canBeComparedTo()?(this._toolbarComponent.hide(),this._compareWidget&&this._compareWidget.toggleDifferenceDocPageSelector(!0)):(this._toolbarComponent.show(),this._compareWidget&&this._compareWidget.toggleDifferenceDocPageSelector(!1)))};m.prototype._whenActiveOrDifferencePageChangedAndParametersAvailableOrChange=function(){this._compareWidget&&this._compareWidget.updateCompareWidget();this._showOrHideCompareToolbarComponent()};
m.prototype._doCornerAlign=function(a){var b=this.f.getDocumentController();b.willNeedParameterUpdate("CORNER_ALIGN");this._compareModel.resetOffset();this._compareWidget&&this._compareWidget.updateCompareWidget();this._compareModel.setCornerAlign(a);this.changeReferenceOffset(this._compareModel.getOffset());b.readyForParameterUpdate("CORNER_ALIGN")};m.prototype._doTrimBoxAlign=function(){var a=this.f.getDocumentController();a.willNeedParameterUpdate("TRIMBOX_ALIGN");this._compareModel.toggleTrimBoxAlign();
a.readyForParameterUpdate("TRIMBOX_ALIGN")};m.prototype.autoAlign=function(){var a={rectangle:this.f.getModule("viewport").getVisibleRect(),servlet:"",params:{x1:0,x2:0,y1:0,y2:0,isTrimBoxAlign:this._compareModel.isTrimBoxAlign()}};this.f.emit("intercept.fragmentURL",a);this.doAutoAlign(a)};m.prototype._getCornerAlignOffset=function(){var a=this._compareModel.getCornerAlign(),b=new y.Size,c=this.f.getActivePage(),d=this.f.getDocumentController().getDifferencePage().getPageSize(),c=c.getPageSize();
if(!(a===n.cornerAutoAlign.TOPLEFT||a===n.cornerAutoAlign.CENTERLEFT||a===n.cornerAutoAlign.BOTTOMLEFT))if(a===n.cornerAutoAlign.TOPCENTER||a===n.cornerAutoAlign.CENTERED||a===n.cornerAutoAlign.BOTTOMCENTER)b.width=c.width/2-d.width/2;else if(a===n.cornerAutoAlign.TOPRIGHT||a===n.cornerAutoAlign.CENTERRIGHT||a===n.cornerAutoAlign.BOTTOMRIGHT)b.width=c.width-d.width;if(!(a===n.cornerAutoAlign.TOPLEFT||a===n.cornerAutoAlign.TOPCENTER||a===n.cornerAutoAlign.TOPRIGHT))if(a===n.cornerAutoAlign.CENTERLEFT||
a===n.cornerAutoAlign.CENTERED||a===n.cornerAutoAlign.CENTERRIGHT)b.height=c.height/2-d.height/2;else if(a===n.cornerAutoAlign.BOTTOMLEFT||a===n.cornerAutoAlign.BOTTOMCENTER||a===n.cornerAutoAlign.BOTTOMRIGHT)b.height=c.height-d.height;return b};m.prototype.changeReferenceOffset=function(a){this.f.getDocumentController().willNeedParameterUpdate("COMPARE_OFFSET");this._emit("referenceOffset.beforeChange");this._compareModel.setOffset(a);null!==this._compareWidget&&this._compareWidget.updateCompareWidget();
this.f.getDocumentController().getDifferencePage().setStateParam("compareOffset",a);this.f.getDocumentController().readyForParameterUpdate("COMPARE_OFFSET");this.f.getDocumentController().whenParametersAvailable(function(){this._emit("referenceOffset.changed")},this)};m.prototype.changeCadOverlayOffset=function(a){this._compareModel.setCadOverlayOffset(a);null!==this._compareWidget&&this._compareWidget.updateCompareWidget();var b=this.f.getDocumentController().getCadOverlay();b&&(this.f.getDocumentController().willNeedParameterUpdate("CAD_OVERLAY_OFFSET"),
this._emit("cadOverlayOffset.beforeChange"),b.setStateParam("compareOffset",a),this.f.getDocumentController().readyForParameterUpdate("CAD_OVERLAY_OFFSET"),this.f.getDocumentController().whenParametersAvailable(function(){this._emit("cadOverlayOffset.changed")},this))};m.prototype.getState=function(){return{compareModel:{diffMode:this.getCurrentDiffMode(),cornerAlign:this._compareModel.getCornerAlign(),trimBoxAlign:this._compareModel.isTrimBoxAlign(),offset:this._compareModel.getOffset(),cadOverlayOffset:this._compareModel.getCadOverlayOffset(),
cadOVerlayRotation:this._compareModel.getCadOverlayRotation(),referenceFlipped:this._compareModel.isReferenceFlipped(),referenceNegated:this._compareModel.isReferenceNegated(),referenceRotation:this._compareModel.getReferenceRotation()},differenceMode:{threshold:this._differenceMode.getThreshold(),colorSpace:this._differenceMode.getColorSpace(),addedColor:this._differenceMode.getAddedHighlightColor(),subtractedColor:this._differenceMode.getSubtractedHighlightColor()},sideBySideMode:{panelsLayoutMode:this._sideBySideMode.getPanelsLayoutMode(),
showingDifference:this._sideBySideMode.isShowingDifference()}}};m.prototype.setState=function(a){this.f.whenModuleAvailable("compare",function(){if(void 0!==a){var b=a.compareModel;void 0!==b&&(this.activateModeByDiffMode(b.diffMode),void 0!==this.f.getDocumentController().getDifferencePage()&&(this._compareModel.setCornerAlign(b.cornerAlign),b.trimBoxAlign&&this._doTrimBoxAlign(),b.referenceFlipped&&this.flipReference(),b.referenceNegated&&this._compareModel.negateReference(),b.referenceRotation&&
this.setReferenceRotation(b.referenceRotation),this._compareModel.isReaderSpreadActive()||this.changeReferenceOffset(b.offset),b.cadOverlayOffset&&this._compareModel.setCadOverlayOffset(b.cadOverlayOffset),b.cadOverlayRotation&&this._compareModel.setCadOverlayRotation(b.cadOverlayRotation)));b=a.differenceMode;void 0!==b&&(this._differenceMode.setThreshold(b.threshold),this._differenceMode.setColorSpace(b.colorSpace),this._differenceMode.setAddedHighlightColor(b.addedColor),this._differenceMode.setSubtractedHighlightColor(b.subtractedColor));
b=a.sideBySideMode;void 0!==b&&(this._sideBySideMode.setPanelsLayoutMode(b.panelsLayoutMode),this._sideBySideMode.setShowingDifference(b.showingDifference))}this.f.debug.log("STATE","compare state is injected.")},this)};m.prototype.isReaderSpreadActive=function(){return this._compareModel.isReaderSpreadActive()};m.prototype._doCurrentCompareRange=function(a){this.f.getActivePage().setLinkedComparePage(a)};m.prototype._doCurrentAndFollowingCompareRange=function(a){for(var b=this.f.getActivePage(),
c=b.getDocumentVersion(),d=a.getDocumentVersion(),e=b.getPagenum(),f=a.getPagenum();e<=c.getPageCount();)b=c.getPage(e),f<=d.getPageCount()&&(a=d.getPage(f)),void 0!==b&&!b.isBlankPage()&&b.setLinkedComparePage(a),e++,f++};m.prototype._doAllCompareRange=function(a){this._doCurrentAndFollowingCompareRange(a);for(var b=this.f.getActivePage(),c=b.getDocumentVersion(),d=a.getDocumentVersion(),e=b.getPagenum()-1,f=a.getPagenum()-1;1<=e;)b=c.getPage(e),1<=f&&(a=d.getPage(f)),void 0!==b&&!b.isBlankPage()&&
b.setLinkedComparePage(a),e--,f--};m.prototype.startAlignmentWizard=function(a){this._compareAlignmentWizard||(this._compareAlignmentWizard=new j(this.f,this,this._compareModel,this.getCompareAlignmentModeConstructor()));this._compareAlignmentWizard.setForCadOverlay(a);this.f.startMode(this._compareAlignmentWizard)};m.prototype._interceptActivePageChange=function(a){var b=this.f.getModule("navigation");b&&b.resetExtraRotation();if(this.f.getDocumentController().getDifferencePage()&&(!this.isReaderSpreadActive()&&
a.newActivePage.getDocumentVersion().isMultiPage())&&(b=this.getDefaultDiffPage(a.newActivePage)))a.diffPage=b;a.newActivePage.getDocumentVersion().isPageList()&&(this._documentSelection.updateDocumentSelectorsForPageList(a.oldActivePage,a.newActivePage),!this.isReaderSpreadActive()&&a.newActivePage.isBlankPage()&&(a.diffPage=void 0,this.activateModeByName()))};m.prototype.flipReference=function(){var a=this.f.getDocumentController();a.willNeedParameterUpdate("FLIP");this._compareModel.flipReference();
a.getDifferencePage().flipPage();a.readyForParameterUpdate("FLIP")};m.prototype.flipCadOverlay=function(a){this._compareModel.flipCadOverlay(a);var b=this.f.getDocumentController(),c=b.getCadOverlay();c&&(b.willNeedParameterUpdate("FLIP_OVERLAY"),c.flipPage(a),b.readyForParameterUpdate("FLIP_OVERLAY"))};m.prototype.rotateReference=function(){this.setReferenceRotation((this._compareModel.getReferenceRotation()+90)%360)};m.prototype.setReferenceRotation=function(a){var b=this.f.getDocumentController();
b.willNeedParameterUpdate("ROTATION");a%=360;this._compareModel.setReferenceRotation(a);var c=this.f.getDocumentController().getDifferencePage();c.setRotation(a);var d=this.f.getModule("navigation");d&&c.hasCad()&&d.setExtraRotation(a);b.readyForParameterUpdate("ROTATION")};m.prototype.rotateCadOverlay=function(){this.setCadOverlayRotation((this._compareModel.getCadOverlayRotation()+90)%360)};m.prototype.setCadOverlayRotation=function(a){a%=360;this._compareModel.setCadOverlayRotation(a);var b=this.f.getDocumentController(),
c=b.getCadOverlay();c&&(b.willNeedParameterUpdate("ROTATION_OVERLAY"),c.setRotation(a),(c=this.f.getModule("navigation"))&&c.setExtraRotation(a),b.readyForParameterUpdate("ROTATION_OVERLAY"))};m.prototype.checkAligmentAndShow3D=function(){this.isCadOverlayModified()?this.f.loadBundle("viewer",function(){var a=new C(this.f,"saveCADAlignment",this.f.getContext());a.setRemoveFromDomAfterUsage(!0);this.canSaveCadOverlay()?(a.setOkAction(p.bind(function(){this.saveCadOverlay(p.bind(this._load3DView,this));
a.hide()},this)),a.setHeader($("<span/>").addClass("popupTitle").text(this.f.i18n.t("CadOverlayPromptTitle"))),a.setContent($("<div/>").addClass("unsavedItemsContent").text(this.f.i18n.t("CadOverlayPromptContent"))),a.setOkBtnText(this.f.i18n.t("Save"))):(a.setOkAction(p.bind(function(){this._load3DView();a.hide()},this)),a.setHeader($("<span/>").addClass("popupTitle").text(this.f.i18n.t("CadOverlayPromptOpen3D"))),a.setContent($("<div/>").addClass("unsavedItemsContent").text(this.f.i18n.t("CadOverlayPromptOpen3DContent"))),
a.setOkBtnText(this.f.i18n.t("CadOverlayPromptOpen3D")));a.setCancelBtnText(this.f.i18n.t("AppDialogCancel"));a.show()},this):!this.f.getActivePage().get("isCadAlignmentSaved")&&this.canSaveCadOverlay()?this.saveCadOverlay(p.bind(this._load3DView,this)):this._load3DView()};m.prototype._load3DView=function(){this.f.requestModule("view3D",p.bind(function(a){a.show3D()},this),!1)};m.prototype.createCompareDifferenceMode=function(){throw"Not Implemented: createCompareShowDifferenceMode";};m.prototype.createCompareSideBySideMode=
function(){throw"Not Implemented: createCompareSideBySideMode";};m.prototype.createCompareShowReaderSpreadMode=function(){throw"Not Implemented: CompareShowReaderSpreadMode";};m.prototype.getCompareAlignmentModeConstructor=function(){throw"Not Implemented: getCompareAlignmentModeConstructor";};m.prototype.doAutoAlign=function(){throw"Not Implemented: CompareShowReaderSpreadMode";};return m});
define("web-viewer/compare/CompareDifferenceMode",["underscore","web-viewer/compare/CompareMode","web-viewer/compare/CompareConstants","web-viewer/utils/ViewerUtils"],function(c,e,d){var g=function(b,a){e.call(this,b,d.mode.DIFFERENCE,a,!0,"DiffDifferenceAnnotationsHidden");this.threshold=0;this.setThreshold(parseInt(this.f.getCurrentUser().getOption("PREFERENCES_DIFFMODE_THRESHOLD"),10));this.f.getCurrentUser().on("options.changed.PREFERENCES_DIFFMODE_THRESHOLD",c.bind(function(a,b){this.setThreshold(b)},
this));this.colorSpace=this.f.getOption("CONFIG_DIFF_COMPAREMODE");this.differenceMode=a.getDiffMode();if(this.differenceMode<d.diffMode.SHOWBOTHCHANGES||this.differenceMode>d.diffMode.SHOWBOTHCHANGESONLY){var i=d.sideBySideToDiffMode[this.differenceMode];this.differenceMode=void 0===i?d.diffMode.SHOWBOTHCHANGES:i}this.addedHighlightColor=this.f.getCurrentUser().getColor("PREFERENCES_HIGHLIGHTCOLORS_DIFF_ADD");this.f.getCurrentUser().on("options.changed.PREFERENCES_HIGHLIGHTCOLORS_DIFF_ADD",c.bind(function(){this.setAddedHighlightColor(this.f.getCurrentUser().getColor("PREFERENCES_HIGHLIGHTCOLORS_DIFF_ADD"))},
this));this.subtractedHighlightColor=this.f.getCurrentUser().getColor("PREFERENCES_HIGHLIGHTCOLORS_DIFF_SUB");this.f.getCurrentUser().on("options.changed.PREFERENCES_HIGHLIGHTCOLORS_DIFF_SUB",c.bind(function(){this.setSubtractedHighlightColor(this.f.getCurrentUser().getColor("PREFERENCES_HIGHLIGHTCOLORS_DIFF_SUB"))},this));this.on("changed.**",function(){a.parametersChanged()})};g.prototype=Object.create(e.prototype);g.prototype.constructor=g;g.prototype.toggle=function(b,a){e.prototype.toggle.call(this,
b);b?void 0!=a&&(a===d.diffMode.SHOWBOTHCHANGES||a===d.diffMode.SHOWBOTHCHANGESHIGHLIGHT||a===d.diffMode.SHOWBOTHCHANGESONLY||a===d.diffMode.SHOWBOTHONTOP)?this.setDifferenceMode(a):this._compareModel.setDiffMode(this.differenceMode):this._compareModel.setDiffMode(d.diffMode.UNDEFINED)};g.prototype._getDType=function(){return 8*this.colorSpace};g.prototype.interceptFragmentURL=function(){throw"Not Implemented";};g.prototype.getOverwriteOptions=function(){throw"Not Implemented";};g.prototype.setThreshold=
function(b){var a=this.threshold;this.threshold=b;isNaN(this.threshold)&&(this.threshold=0);this.threshold=Math.min(Math.max(this.threshold,0),100);this.f.setOption("PREFERENCES_DIFFMODE_THRESHOLD",this.threshold);this._fireChange(!1,["threshold"],a,b)};g.prototype.getThreshold=function(){return this.threshold};g.prototype.setColorSpace=function(b){var a=this.colorSpace;this.colorSpace=b;this._fireChange(!1,["colorspace"],a,b);this.f.setOption("CONFIG_DIFF_COMPAREMODE",b)};g.prototype.getColorSpace=
function(){return this.colorSpace};g.prototype.setDifferenceMode=function(b){var a=this.differenceMode;this.differenceMode=b;this.isEnabled()&&this._compareModel.setDiffMode(this.differenceMode);this._fireChange(!1,["differenceMode"],a,b)};g.prototype.getDifferenceMode=function(){return this.differenceMode};g.prototype.setAddedHighlightColor=function(b){var a=this.addedHighlightColor;this.f.getCurrentUser().setColor("PREFERENCES_HIGHLIGHTCOLORS_DIFF_ADD",b);this.addedHighlightColor=this.f.getCurrentUser().getColor("PREFERENCES_HIGHLIGHTCOLORS_DIFF_ADD");
this._fireChange(!1,["addedHighlightColor"],a,this.addedHighlightColor)};g.prototype.getAddedHighlightColor=function(){return this.addedHighlightColor};g.prototype.setSubtractedHighlightColor=function(b){var a=this.subtractedHighlightColor;this.f.getCurrentUser().setColor("PREFERENCES_HIGHLIGHTCOLORS_DIFF_SUB",b);this.subtractedHighlightColor=this.f.getCurrentUser().getColor("PREFERENCES_HIGHLIGHTCOLORS_DIFF_SUB");this._fireChange(!1,["subtractedHighlightColor"],a,this.subtractedHighlightColor)};
g.prototype.getSubtractedHighlightColor=function(){return this.subtractedHighlightColor};g.prototype.resetHighlightColors=function(){this.f.getCurrentUser().resetOption("PREFERENCES_HIGHLIGHTCOLORS_DIFF_ADD");this.f.getCurrentUser().resetOption("PREFERENCES_HIGHLIGHTCOLORS_DIFF_SUB")};g.prototype.isAvailable=function(){var b=this.f.getDocumentController().getActivePage(),a=this.f.getDocumentController().getDifferencePage();return c.reduce([b,a],function(a,b){return a&&(!b||-1!==b.getAvailableCompareModes().indexOf(d.mode.DIFFERENCE))},
!0)};return g});
define("web-viewer-wcr/webcenter/modules/compare/CompareDifferenceMode",["underscore","web-viewer/compare/CompareDifferenceMode","web-viewer/compare/CompareConstants","web-viewer/utils/ViewerUtils"],function(c,e,d,g){d=function(b,a){e.call(this,b,a)};d.prototype=Object.create(e.prototype);d.prototype.constructor=d;d.prototype.interceptFragmentURL=function(b){b.params=c.extend(b.params,this.getOverwriteOptions())};d.prototype.getOverwriteOptions=function(){return{dtype:this._getDType(),dlevel:this.threshold,
hc0:g.rgbIntToBgrInt(g.intFromHex(this.addedHighlightColor)),hc1:g.rgbIntToBgrInt(g.intFromHex(this.subtractedHighlightColor))}};return d});
define("web-viewer/compare/CompareSideBySideMode",["underscore","web-viewer/compare/CompareMode","web-viewer/compare/CompareConstants","web-viewer/viewport/ViewportConstants","web-viewer/utils/ListenerUtil"],function(c,e,d,g,b){var a=function(a,f,k){e.call(this,a,d.mode.SIDEBYSIDE,f,!0,"DiffSideBySideAnnotationsHidden");b.mixin(this,a);this.differenceCompareMode=k;this._showDifference=!0;this._isListeningToGraphics=!1;this._panelsLayoutMode=g.PanelsLayoutMode.AUTOMATIC;this.updateSettingsFromUserPreference(this.f.getOption("PREFERENCES_DIFF_SPLITMODE"));
this.differenceModePanel=this.differenceFilePanel=this.currentFilePanel=null;this.viewport=this.f.getModule("viewport");a.getCurrentUser().on("options.changed.PREFERENCES_DIFF_SPLITMODE",c.bind(function(a,b){this.updateSettingsFromUserPreference(b)},this))};a.prototype=Object.create(e.prototype);a.prototype.constructor=a;a.prototype.toggle=function(a,b){!this.isEnabled()&&a?(e.prototype.toggle.call(this,a),void 0===b&&(b=this.differenceCompareMode.getDifferenceMode(),b=parseInt(c.invert(d.sideBySideToDiffMode)[b])),
this._compareModel.setDiffMode(b),this.f.getDocumentController().whenParametersAvailable(function(){if(this.isEnabled()){this.graphicsModule||(this.graphicsModule=this.f.getModule("graphics"));this.viewport.setPanelsLayoutMode(this._panelsLayoutMode);this.currentFilePanel=this.viewport.getPanelModel("default");this.currentFilePanel.toggleLayer("referenceCad",!1);this.currentFilePanel.toggleLayer("currentDiffCad",!1);this.currentFilePanel.toggleLayer("referenceDiffCad",!1);this.currentFilePanel.toggleLayer("SVGDifferenceLayer",
!1);this.currentFilePanel.toggleLayer("Graphics",this.f.getActivePage().hasGraphics());var a=["Cad","currentDiffCad","referenceDiffCad","SVGLayer","Video"];this.f.getDocumentController().getDifferencePage().hasGraphics()||a.push("Graphics");this.differenceFilePanel=this.viewport.addPanel("compare_difference",this._getAllDifferenceFileOverwriteOptions(),a);this.toggleDifferencePanel(this.isShowingDifference());this.updateOverwriteOptions();this.f.whenModuleAvailable("graphics",function(a){this.graphicsModule=
a;this.isEnabled()&&!this._isListeningToGraphics&&(this._registerListener("model.changed.channels",c.debounce(c.bind(this.updateOverwriteOptions,this),40),void 0,this.graphicsModule),this._registerListener("model.changed.channel.**",c.debounce(c.bind(this.updateOverwriteOptions,this),40),void 0,this.graphicsModule),this._isListeningToGraphics=!0,this.updateOverwriteOptions())},this);this._registerListener("changed.**",this.updateOverwriteOptions,this,this.differenceCompareMode);this._registerListener("annotationModel.annotation.temporarilyDisableChanged",
this.updateOverwriteOptions,this);this._registerListener("annotationModel.annotation.disabledReasonChanged",this.updateOverwriteOptions,this);this._registerListener("doc.page.active",this.updatePanelHeaders,this);this._registerListener("doc.page.difference",this.updatePanelHeaders,this);this._registerListener("doc.page.active",this._updateLayers.bind(this,this.currentFilePanel),this);this._registerListener("doc.page.difference",this._updateLayers.bind(this,this.differenceFilePanel),this);this.updatePanelHeaders()}},
this)):this.isEnabled()&&!a&&(e.prototype.toggle.call(this,a),this.viewport.removePanel("compare_difference"),this.viewport.removePanel("compare_differenceMode"),this._compareModel.setDiffMode(d.diffMode.UNDEFINED),this.currentFilePanel&&(this.currentFilePanel.deleteOverwriteOption("dmode"),this.currentFilePanel.deleteOverwriteOption("colorBITWISE"),this.currentFilePanel.toggleLayer("Annotations",!0),this.currentFilePanel.toggleLayer("AnnotationPopups",!0),this.currentFilePanel.toggleLayer("referenceCad",
!0),this.currentFilePanel.toggleLayer("currentDiffCad",!0),this.currentFilePanel.toggleLayer("referenceDiffCad",!0),this.currentFilePanel.toggleLayer("SVGDifferenceLayer",!0),this.currentFilePanel.toggleLayer("Graphics",!0),this.currentFilePanel.setHeaderText(null)),this.differenceModePanel=this.differenceFilePanel=this.currentFilePanel=null,this.viewport.setPanelsLayoutMode(g.PanelsLayoutMode.AUTOMATIC),this._unregisterAllListeners(),this._isListeningToGraphics=!1)};a.prototype._updateLayers=function(a,
b,c){a.toggleLayer("Graphics",c&&c.hasGraphics())};a.prototype.isShowingDifference=function(){return this._showDifference&&this._canFilesShowDifference()};a.prototype._canFilesShowDifference=function(){return this.differenceCompareMode.isAvailable()};a.prototype.setShowingDifference=function(a){var b=this._showDifference;this._showDifference=a&&this._canFilesShowDifference();this.isEnabled()&&b!==a&&this.toggleDifferencePanel(a);this.storeUserPreference();this._fireChange(!1,["showDifference"],b,
a)};a.prototype.toggleDifferencePanel=function(a){a?(this.differenceModePanel=this.viewport.addPanel("compare_differenceMode",this._getAllDifferenceModeOverwriteOptions(),["Annotations","AnnotationPopups","Cad","referenceCad"]),this.f.loadBundle("viewer",function(){this.differenceModePanel.setHeaderText(this.f.t("CaptionCompared"))},this)):(this.viewport.removePanel("compare_differenceMode"),this.differenceModePanel=null);this.updateOverwriteOptions()};a.prototype.updateOverwriteOptions=function(){this.isEnabled()&&
(void 0===this.graphicsModule&&(this.graphicsModule=this.f.getModule("graphics")),void 0===this.annotationModule&&(this.annotationModule=this.f.getModule("annotation")),this.currentFilePanel.setOverwriteOptions(this._getCurrentFileOverwriteOptions()),this.differenceFilePanel.setOverwriteOptions(this._getAllDifferenceFileOverwriteOptions()),null!==this.differenceModePanel&&this.differenceModePanel.setOverwriteOptions(this._getAllDifferenceModeOverwriteOptions()),void 0!==this.annotationModule&&(this.currentFilePanel.toggleLayer("Annotations",
this.annotationModule.isTemporarilyCurrentPageAnnotationsShown()),this.currentFilePanel.toggleLayer("AnnotationPopups",this.annotationModule.isTemporarilyCurrentPageAnnotationsShown()),this.differenceFilePanel.toggleLayer("Annotations",this.annotationModule.isTemporarilyDifferencePageAnnotationsShown()),this.differenceFilePanel.toggleLayer("AnnotationPopups",this.annotationModule.isTemporarilyDifferencePageAnnotationsShown())))};a.prototype._getCurrentFileOverwriteOptions=function(){throw"Not Implemented";
};a.prototype._getAllDifferenceFileOverwriteOptions=function(){var a=this._getDifferenceFileOverwriteOptions();a.isDefaultView=!1;return a};a.prototype._getDifferenceFileOverwriteOptions=function(){throw"Not Implemented";};a.prototype._getAllDifferenceModeOverwriteOptions=function(){var a=this._getDifferenceModeOverwriteOptions();a.isDefaultView=!1;return a};a.prototype._getDifferenceModeOverwriteOptions=function(){throw"Not Implemented";};a.prototype.updateSettingsFromUserPreference=function(a){this.setPanelsLayoutMode(+a&
3);this.setShowingDifference(4===(a&4))};a.prototype.storeUserPreference=function(){var a=this.getPanelsLayoutMode();this.isShowingDifference()&&(a+=4);this.f.setOption("PREFERENCES_DIFF_SPLITMODE",a)};a.prototype.setPanelsLayoutMode=function(a){var b=this._panelsLayoutMode;this._panelsLayoutMode=a;this.isEnabled()&&this.viewport.setPanelsLayoutMode(a);this.storeUserPreference();this._fireChange(!1,["panelLayout"],b,this._panelsLayoutMode)};a.prototype.getPanelsLayoutMode=function(){return this._panelsLayoutMode};
a.prototype.updatePanelHeaders=function(){this.f.loadBundle("viewer",function(){if(this.isEnabled()){var a="",b="",c=this.f.getDocumentController(),d=c.getActivePage().getDocumentVersion(),c=c.getDifferencePage().getDocumentVersion();d.getDocument()!==c.getDocument()&&(a+=d.getDocument().get("docname")+", ",b+=c.getDocument().get("docname")+", ");a+=this.f.t("WCHistVersion")+" "+d.getVersionId();b+=this.f.t("WCHistVersion")+" "+c.getVersionId();a+=" - ("+this.f.t("CaptionCurrent")+")";b+=" - ("+this.f.t("CaptionPrevious")+
")";this.currentFilePanel.setHeaderText(a);this.differenceFilePanel.setHeaderText(b)}},this)};a.prototype.interceptFragmentURL=function(){throw"Not Implemented";};return a});
define("web-viewer-wcr/webcenter/modules/compare/CompareSideBySideMode",["underscore","web-viewer/compare/CompareSideBySideMode","web-viewer/compare/CompareConstants"],function(c,e,d){var g=function(b,a,c){e.call(this,b,a,c)};g.prototype=Object.create(e.prototype);g.prototype.constructor=g;g.prototype._getCurrentFileOverwriteOptions=function(){var b=0;void 0!==this.graphicsModule&&(b=this.graphicsModule.getChannelSelectionForDiffMode(d.diffMode.CURRENTVERSION));return{dmode:d.diffMode.CURRENTVERSION,
colorBITWISE:b}};g.prototype._getDifferenceFileOverwriteOptions=function(){var b=0;void 0!==this.graphicsModule&&(b=this.graphicsModule.getChannelSelectionForDiffMode(d.diffMode.DIFFVERSION));return{dmode:d.diffMode.DIFFVERSION,colorBITWISE:b}};g.prototype._getDifferenceModeOverwriteOptions=function(){var b=0;void 0!==this.graphicsModule&&(b=this.graphicsModule.getChannelSelectionForDiffMode(this.differenceCompareMode.getDifferenceMode()));return c.extend(this.differenceCompareMode.getOverwriteOptions(),
{dmode:this.differenceCompareMode.getDifferenceMode(),colorBITWISE:b})};g.prototype.interceptFragmentURL=function(b){b.params.dmode=d.diffMode.CURRENTVERSION};return g});
define("web-viewer/compare/CompareShowReaderSpreadMode","underscore web-viewer/compare/CompareMode web-viewer/compare/CompareConstants web-viewer/viewport/ViewportConstants web-viewer/pagelist/PagelistConstants web-viewer/utils/ListenerUtil web-viewer/layout/LayoutConstants".split(" "),function(c,e,d,g,b,a,i){c=function(b,c){e.call(this,b,d.mode.READERSPREAD,c,!1,"","current");a.mixin(this,b);this.diffPage=null;this.rs=d.pagelistSide.RIGHTPAGE};c.prototype=Object.create(e.prototype);c.prototype.constructor=
c;c.prototype.toggle=function(a){e.prototype.toggle.call(this,a);this.f.getDocumentController().willNeedParameterUpdate("READER_SPREAD");if(a){a=void 0!==this.f.getDocumentController().getDifferencePage();this.f.getDocumentController().resetDifferencePage();this._compareModel.setDiffMode(d.diffMode.READERSPREAD);var b=this.f.getDocumentController().getActivePage();b.setReaderSpread(!0);var c=this._calculateReferencePageNumber(b);this.diffPage=b.getDocumentVersion().getPage(c);void 0!==this.diffPage&&
(this.diffPage.resetParameters(),b.resetParameters(),this.f.getDocumentController().changeDifferencePage(this.diffPage),this.diffPage.setReaderSpread(!0));this.rs===d.pagelistSide.RIGHTPAGE?(b.set("isRightPage",!0),void 0===this.diffPage?a&&b.resetParameters():this.diffPage.set("isRightPage",!1)):(b.set("isRightPage",!1),this.diffPage&&this.diffPage.set("isRightPage",!0));this._registerListener("intercept.activePageChange",this._whenActivePageChanges,this,this.f)}else b=this.f.getDocumentController().getActivePage(),
b.reset("isRightPage"),this.diffPage&&(this.diffPage.reset("isRightPage"),this.diffPage.setReaderSpread(!1)),b.setReaderSpread(!1),this.diffPage=null,this.f.getDocumentController().resetDifferencePage(),this._compareModel.setDiffMode(d.diffMode.UNDEFINED),this._unregisterAllListeners();this.f.getDocumentController().readyForParameterUpdate("READER_SPREAD")};c.prototype.interceptFragmentURL=function(){throw"Not Implemented";};c.prototype._whenActivePageChanges=function(a){if(this.isEnabled()){void 0!==
a.oldActivePage&&(a.oldActivePage.setReaderSpread(!1),a.oldActivePage.reset("isRightPage"));this.diffPage&&(this.diffPage.reset("isRightPage"),this.diffPage.setReaderSpread(!1));a.newActivePage.setReaderSpread(!0);var b=this._calculateReferencePageNumber(a.newActivePage);this.diffPage=a.newActivePage.getDocumentVersion().getPage(b);void 0===this.diffPage?a.diffPage=void 0:(this.diffPage.resetParameters(),this.diffPage.setReaderSpread(!0),a.diffPage=this.diffPage);this.rs===d.pagelistSide.RIGHTPAGE?
(void 0!==this.diffPage&&(a.newActivePage.resetParameters(),this.diffPage.set("isRightPage",!1)),a.newActivePage.set("isRightPage",!0)):(this.diffPage&&this.diffPage.set("isRightPage",!0),a.newActivePage.set("isRightPage",!1))}};c.prototype._calculateReferencePageNumber=function(a){var c=a.getPagenum(),a=a.getDocument().get("binding");0===c%2?(c+=1,void 0===a||a===b.binding.LEFT?this.rs=d.pagelistSide.LEFTPAGE:a===b.binding.RIGHT&&(this.rs=d.pagelistSide.RIGHTPAGE)):(c-=1,void 0===a||a===b.binding.LEFT?
this.rs=d.pagelistSide.RIGHTPAGE:a===b.binding.RIGHT&&(this.rs=d.pagelistSide.LEFTPAGE));return c};c.prototype.getLayoutMode=function(){return this.f.isMobile()?i.LayoutMode.MOBILE_READERSPREAD:e.prototype.getLayoutMode.call(this)};return c});
define("web-viewer-wcr/webcenter/modules/compare/CompareShowReaderSpreadMode",["underscore","web-viewer/compare/CompareShowReaderSpreadMode","web-viewer/compare/CompareConstants"],function(c,e,d){c=function(c,b){e.call(this,c,b)};c.prototype=Object.create(e.prototype);c.prototype.constructor=c;c.prototype.interceptFragmentURL=function(c){c.params.rs=this.rs;c.params.daligntrim=1;c.params.dmode=d.diffMode.SHOWBOTHONTOP};return c});
define("web-viewer-wcr/webcenter/modules/compare/CompareDataAdapter",["web-viewer/compare/AbstractCompareDataAdapter","utils/XMLUtils"],function(c,e){var d=function(d){c.call(this,d)};d.prototype=Object.create(c.prototype);d.prototype.constructor=d;d.prototype.saveCadOverlay=function(c,b,a,d,f,k){if(c.canSaveCadOverlay()){var h=(4-a/90)%4;d&&(h+=4);var j;b&&(j=b.get("docversionid"));var l=c.getMargins(),h=this.f.getDataAdapter().WebCenter("setcadalignment.jsp",{docversionid:c.get("docversionid"),
cadversionid:j,cadorgx:f.x,cadorgy:f.y,cadorientation:h,hs:c.get("hsize"),vs:c.get("vsize"),ml:l.left,mt:l.top,mr:l.right,mb:l.bottom});this.f.getDataAdapter().fetch(h,{dataType:"xml",success:_.bind(function(h){var h=e.xml2obj(h),j="";if(h){if(h.status&&"0"===h.status.value){this.f.loadBundle("viewer",function(){b&&b.hasCad()?this.f.emit("userMessage","success",this.f.t("SaveCadOverlaySuccess"),!0):this.f.emit("userMessage","success",this.f.t("SaveStructuredDocumentSuccess"),!0)},this);c.getLinkedPage()!==
this.f.getDocumentController().getCadOverlay()&&this.f.getDocumentController().createNewLinkedCadFromOverlay();(h=this.f.getDocumentController().getCadOverlay())?(h.set("offsetx",f.x),h.set("offsety",f.y),h.set("overlayRotation",a),h.set("overlayIsFlipped",d)):this.f.getDataAdapter().updateDocumentData(c,void 0,!0);k&&k(!0);return}"-1"===h.status&&(j=h.status.message)}this.f.emit("userMessage","warn",this.f.t("SaveCadOverlayFailed")+" "+j);k&&k(!1)},this),error:_.bind(function(){this.f.loadBundle("viewer",
function(){this.f.emit("userMessage","warn",this.f.t("SaveCadOverlayFailed"))},this);k&&k(!1)},this)})}else this.f.emit("userMessage","warn",this.f.t("SaveCadOverlayFailed")),k&&k(!1)};d.prototype.convertCompareParameters=function(c,b){var a=c.getOffset();null!==a&&(b.dox=a.x,b.doy=a.y);a=c.getCornerAlign();null!==a&&(b.dalign=a);c.isReferenceNegated()&&(b.dn=1);a=c.getReferenceRotation()/90;c.isReferenceFlipped()&&(a+=4);0!==a&&(b.dor=a);c.isTrimBoxAlign()&&(b.daligntrim=1);b.dmode=c.getDiffMode()};
return d});
define("web-viewer/compare/alignment/CompareAlignmentMode","underscore web-viewer/compare/CompareMode web-viewer/compare/CompareConstants web-viewer/viewport/ViewportConstants web-viewer/utils/ListenerUtil utils/ShapeUtils".split(" "),function(c,e,d,g,b){var a=function(a,c,g,h){e.call(this,a,d.mode.ALIGNMENT,c,!1,"DiffSideBySideAnnotationsHidden");b.mixin(this,a);this._isListeningToGraphics=!1;this._resultPanel=this._differenceFilePanel=this._currentFilePanel=null;this._currentAnchorLayerModel=g;
this._referenceAnchorLayerModel=h;this._forCadOverlay=!1;this.viewport=this.f.getModule("viewport")};a.prototype=Object.create(e.prototype);a.prototype.constructor=a;a.prototype.toggle=function(a){!this.isEnabled()&&a?(e.prototype.toggle.call(this,a),this.viewport.addLayer("compare_alignment_currentAnchor",this._currentAnchorLayerModel),this.viewport.addLayer("compare_alignment_referenceAnchor",this._referenceAnchorLayerModel),this.graphicsModule||(this.graphicsModule=this.f.getModule("graphics")),
this._compareModel.setDiffMode(d.diffMode.SHOWBOTHSIDEBYSIDEHIGHLIGHT),this.viewport.setPanelsLayoutMode(g.PanelsLayoutMode.VERTICAL),this._currentFilePanel=this.viewport.getPanelModel("default"),this._currentFilePanel.toggleLayer("referenceCad",!1),this._currentFilePanel.toggleLayer("currentDiffCad",!1),this._currentFilePanel.toggleLayer("referenceDiffCad",!1),this._currentFilePanel.toggleLayer("Annotations",!1),this._currentFilePanel.toggleLayer("AnnotationPopups",!1),this._currentFilePanel.toggleLayer("compare_alignment_referenceAnchor",
!1),this._currentFilePanel.toggleLayer("CadOverlay",!this._forCadOverlay),a="Cad currentDiffCad referenceDiffCad Annotations AnnotationPopups compare_alignment_currentAnchor".split(" "),this._forCadOverlay||a.push("CadOverlay"),this._differenceFilePanel=this.viewport.addPanel("compare_difference",this._getAllDifferenceFileOverwriteOptions(),a),this._resultPanel=this.viewport.addPanel("compare_align_result",this._getResultOverwriteOptions(),["Annotations","AnnotationPopups","Cad","referenceCad","compare_alignment_referenceAnchor"]),
this.updatePanelHeaders(),this.updateOverwriteOptions(),this.f.whenModuleAvailable("graphics",function(a){this.graphicsModule=a;this.isEnabled()&&!this._isListeningToGraphics&&(this._registerListener("model.changed.channels",c.debounce(c.bind(this.updateOverwriteOptions,this),40),void 0,this.graphicsModule),this._registerListener("model.changed.channel.**",c.debounce(c.bind(this.updateOverwriteOptions,this),40),void 0,this.graphicsModule),this._isListeningToGraphics=!0,this.updateOverwriteOptions())},
this),this._registerListener("doc.page.active",this.updatePanelHeaders,this),this._registerListener("doc.page.difference",this.updatePanelHeaders,this),this.updatePanelHeaders()):this.isEnabled()&&!a&&(e.prototype.toggle.call(this,a),this.viewport.removePanel("compare_difference"),this.viewport.removePanel("compare_align_result"),this._compareModel.setDiffMode(d.diffMode.UNDEFINED),this._currentFilePanel.deleteOverwriteOption("dmode"),this._currentFilePanel.deleteOverwriteOption("colorBITWISE"),this._currentFilePanel.toggleLayer("Annotations",
!0),this._currentFilePanel.toggleLayer("AnnotationPopups",!0),this._currentFilePanel.toggleLayer("referenceCad",!0),this._currentFilePanel.toggleLayer("currentDiffCad",!0),this._currentFilePanel.toggleLayer("referenceDiffCad",!0),this._currentFilePanel.toggleLayer("CadOverlay",!0),this._currentFilePanel.setHeaderText(null),this._resultPanel=this._differenceFilePanel=this._currentFilePanel=null,this.viewport.setPanelsLayoutMode(g.PanelsLayoutMode.AUTOMATIC),this._unregisterAllListeners(),this._isListeningToGraphics=
!1,this.viewport.removeLayer("compare_alignment_currentAnchor"),this.viewport.removeLayer("compare_alignment_referenceAnchor"))};a.prototype.updateOverwriteOptions=function(){this.isEnabled()&&(void 0===this.graphicsModule&&(this.graphicsModule=this.f.getModule("graphics")),void 0===this.annotationModule&&(this.annotationModule=this.f.getModule("annotation")),this._currentFilePanel.setOverwriteOptions(this._getCurrentFileOverwriteOptions()),this._differenceFilePanel.setOverwriteOptions(this._getAllDifferenceFileOverwriteOptions()),
this._resultPanel.setOverwriteOptions(this._getResultOverwriteOptions()))};a.prototype._getCurrentFileOverwriteOptions=function(){throw"Not Implemented: CompareAlignmentMode._getCurrentFileOverwriteOptions";};a.prototype._getAllDifferenceFileOverwriteOptions=function(){var a=this._getDifferenceFileOverwriteOptions();a.isDefaultView=!1;return a};a.prototype._getDifferenceFileOverwriteOptions=function(){throw"Not Implemented: CompareAlignmentMode._getDifferenceFileOverwriteOptions";};a.prototype._getResultOverwriteOptions=
function(){throw"Not Implemented: CompareAlignmentMode._getResultOverwriteOptions";};a.prototype.updatePanelHeaders=function(){this.f.loadBundle("viewer",function(){if(this.isEnabled()&&!this._forCadOverlay){var a="",b="",c=this.f.getDocumentController(),d=c.getActivePage().getDocumentVersion(),c=c.getDifferencePage().getDocumentVersion();d.getDocument()!==c.getDocument()&&(a+=d.getDocument().get("docname")+", ",b+=c.getDocument().get("docname")+", ");a+=this.f.t("WCHistVersion")+" "+d.getVersionId();
a+=" - ("+this.f.t("CaptionCurrent")+")";b+=this.f.t("WCHistVersion")+" "+c.getVersionId();b+=" - ("+this.f.t("CaptionPrevious")+")";this._currentFilePanel.setHeaderText(a);this._differenceFilePanel.setHeaderText(b);this._resultPanel&&this._resultPanel.setHeaderText(this.f.t("AnchorAlignWizardResultPanelHeader"))}},this)};a.prototype.setForCadOverlay=function(a){this._forCadOverlay=a};return a});
define("web-viewer-wcr/webcenter/modules/compare/CompareAlignmentMode",["web-viewer/compare/alignment/CompareAlignmentMode","web-viewer/compare/CompareConstants"],function(c,e){var d=function(d,b,a,e){c.call(this,d,b,a,e)};d.prototype=Object.create(c.prototype);d.prototype.constructor=d;d.prototype._getCurrentFileOverwriteOptions=function(){var c=0;void 0!==this.graphicsModule&&(c=this.graphicsModule.getChannelSelectionForDiffMode(e.diffMode.CURRENTVERSION));return{dmode:e.diffMode.CURRENTVERSION,
colorBITWISE:c}};d.prototype._getDifferenceFileOverwriteOptions=function(){var c={dmode:e.diffMode.DIFFVERSION,colorBITWISE:0};void 0!==this.graphicsModule&&(c.colorBITWISE=this.graphicsModule.getChannelSelectionForDiffMode(e.diffMode.DIFFVERSION));this._forCadOverlay&&(c.colorBITWISE=0);return c};d.prototype._getResultOverwriteOptions=function(){var c={dmode:e.diffMode.SHOWBOTHONTOP};void 0!==this.graphicsModule&&(c.colorBITWISE=this.graphicsModule.getChannelSelectionForDiffMode(e.diffMode.SHOWBOTHCHANGES));
return c};return d});
define("web-viewer-wcr/webcenter/modules/compare/CompareModule","web-viewer/compare/CompareModule web-viewer-wcr/webcenter/modules/compare/CompareDifferenceMode web-viewer-wcr/webcenter/modules/compare/CompareSideBySideMode web-viewer-wcr/webcenter/modules/compare/CompareShowReaderSpreadMode web-viewer-wcr/webcenter/modules/compare/CompareDataAdapter web-viewer-wcr/webcenter/modules/compare/CompareAlignmentMode utils/XMLUtils utils/ShapeUtils web-viewer/utils/ViewerUtils".split(" "),function(c,e,
d,g,b,a,i,f,k){var h=function(a,d){c.call(this,a,d,new b(a))};h.prototype=Object.create(c.prototype);h.prototype.constructor=h;h.prototype.createCompareDifferenceMode=function(){return new e(this.f,this._compareModel)};h.prototype.createCompareSideBySideMode=function(){return new d(this.f,this._compareModel,this._differenceMode)};h.prototype.createCompareShowReaderSpreadMode=function(){return new g(this.f,this._compareModel)};h.prototype.getCompareAlignmentModeConstructor=function(){return a};h.prototype.doAutoAlign=
function(a){var b=this.f.getActivePage();a.params.opmask=3;a.params.daligntrim=a.params.isTrimBoxAlign?1:0;a=b.getInfoURL(a.params);this.f.getDataAdapter().fetch(a,{success:_.bind(function(a){var b=i.xml2obj(a);void 0!==b.status.info&&void 0!==b.status.info.autoalign&&(a=this._compareModel.getOffset(),b=new f.Size(k.parseFloat(b.status.info.autoalign.dx),k.parseFloat(b.status.info.autoalign.dy)),a.offset(b),this.changeReferenceOffset(a))},this),error:_.bind(function(a,b,c){this.f.i18n.loadBundle("viewer",
function(){this.f.emit("error.SEVERE",this.f.i18n.t("AlignChangeError")+" "+b,a,b,c)},this)},this)})};return h});