define("web-viewer/graphics/Channel",["web-viewer/utils/ViewerUtils","web-viewer/graphics/GraphicsConstants","underscore"],function(c,b){var a=function(d,a,b,c,j,g,q,f,n){this.id=d;this.viewserverID=a;this.displayedName=this.name=b;this.displayedRgb=this.rgb=c;this.isOpaque=this.wasOpaque=j;this.file=g;this.dmode=void 0===q?null:q;this.page=f;this.matchedWith=n;void 0===this.matchedWith&&(this.matchedWith=null);this.enabled=!0};a.prototype.copy=function(){var d=new a(this.id,this.viewserverID,this.name,
this.rgb,this.wasOpaque,this.file,this.dmode,this.page,this.matchedWith);d.displayedRgb=this.displayedRgb;d.isOpaque=this.isOpaque;d.displayedName=this.displayedName;return d};a.prototype.toggle=function(a){this.enabled=void 0===a?!this.enabled:a};a.prototype.isEnabled=function(){return this.enabled};a.prototype.getViewserverID=function(){return this.viewserverID};a.prototype.getID=function(){return this.id};a.prototype.getName=function(){return this.isChanged()?this.displayedName+" *":this.displayedName};
a.prototype.getOriginalName=function(){return this.name};a.prototype.getNameWithoutSuffix=function(){return this.displayedName};a.prototype.getRGB=function(){return this.displayedRgb};a.prototype.getHexRGB=function(){return c.hexFromInt(this.displayedRgb)};a.prototype.getFile=function(){return this.file};a.prototype.getDiffMode=function(){return this.dmode};a.prototype.resetToDefault=function(){this.displayedName=this.name;this.displayedRgb=this.rgb;this.isOpaque=this.wasOpaque};a.prototype.isChannelOpaque=
function(){return this.isOpaque};a.prototype.wasChannelOpaque=function(){return this.wasOpaque};a.prototype.isChanged=function(){return this.rgb!=this.displayedRgb||this.isOpaque!=this.wasOpaque||this.displayedName!=this.name};a.prototype.setRgb=function(a){a!==this.displayedRgb&&(this.displayedRgb=a)};a.prototype.setOpaque=function(a){a!==this.isOpaque&&(this.isOpaque=a)};a.prototype.setName=function(a){this.displayedName=a};a.prototype.equals=function(a){return a.getRGB()===this.displayedRgb&&a.isChannelOpaque()===
this.isOpaque&&a.displayedName===this.displayedName?!0:!1};a.prototype.equalsOriginalDef=function(a){return a.rgb===this.rgb&&a.wasChannelOpaque()===this.isOpaque?!0:!1};a.prototype.isMatched=function(){return null!==this.matchedWith};a.prototype.getMatchedChannelServerId=function(){return this.matchedWith};a.prototype.setMatchedChannelServerId=function(a){this.matchedWith=void 0===a?null:a};a.prototype.getPage=function(){return this.page};a.prototype.isInCurrentAndMatchedToPrevious=function(){return this.dmode===
b.ChannelDiffMode.IN_CURRENT_AND_MATCHED_WITH_PREVIOUS||this.isMatched()&&this.dmode===b.ChannelDiffMode.CURRENT};a.prototype.isInPreviousAndMatchedWithCurrent=function(){return this.dmode===b.ChannelDiffMode.IN_PREVIOUS_AND_MATCHED_WITH_CURRENT||this.isMatched()&&this.dmode===b.ChannelDiffMode.PREVIOUS};a.prototype.isSubtracted=function(){return this.dmode===b.ChannelDiffMode.PREVIOUS&&!this.isMatched()};a.prototype.isAdded=function(){return this.dmode===b.ChannelDiffMode.CURRENT&&!this.isMatched()};
return a});
define("web-viewer/graphics/GraphicsDataExtensions",["web-viewer/data/AbstractDocumentPage","web-viewer/graphics/Channel","underscore"],function(c,b,a){return a.once(function(){c.prototype._initGraphicsModule=function(){if(this.hasGraphics()&&this.isParametersAvailable())if(this._channels=[],a.isArray(this._parameters.channel))for(var b=0;b<this._parameters.channel.length;b++)this._parseChannelData(this._parameters.channel[b]);else this._parseChannelData(this._parameters.channel)};c.prototype.getChannels=function(b){(!this._channels||
b)&&this._initGraphicsModule();return a.clone(this._channels)};c.prototype.getChannelForFile=function(a){if(this._channels)for(var b=0;b<this._channels.length;b++)if(this._channels[b].getFile()==a)return this._channels[b];return null};c.prototype.getImageURL=function(){throw"Not implemented: AbstractDocumentPage.getImageURL (GraphicsDataExtensions)";};c.prototype.interceptFragmentURL=function(){throw"Not implemented: AbstractDocumentPage.interceptFragmentURL (GraphicsDataExtensions)";};c.prototype._parseChannelData=
function(){throw"Not implemented: AbstractDocumentPage._parseChannelData (GraphicsDataExtensions)";};c.prototype.hasDeepZoom=function(){return!1}})});
define("tpl!web-viewer/graphics/ChannelsWidget",function(){return function(c){var b,a="",a=a+('<table class="channelList sortableChannelsList">\r\n\t<tr class="all">\r\n\t\t<td><i class="eyeBox '+(null==(b=c.isAllEnabled()?"selected icon icon-WCR_Eye":"")?"":_.escape(b))+'" data-bind="all"></i></td> \r\n\t\t<td><i class="colorBox" style="background: #fff;" data-bind="all"></i></td> \r\n\t\t<td>'+(null==(b=c.i18n("ChanAll"))?"":_.escape(b))+"</td>\t\r\n\t\t<td> "+(null==(b=c.totalCount)?"":_.escape(b))+
"</td>\r\n\t</tr>\r\n");_.each(c.getChannels(),function(d){a+='\r\n\t<tr class="dragAndDropChannel" data-bind="'+(null==(b=d.getID())?"":_.escape(b))+'">\r\n\t\t<td><i class="eyeBox '+(null==(b=d.isEnabled()?"selected icon icon-WCR_Eye":"")?"":_.escape(b))+'" data-bind="'+(null==(b=d.getID())?"":_.escape(b))+'"></i></td>  \r\n\t\t<td><i class="colorBox" data-bind="'+(null==(b=d.getID())?"":_.escape(b))+'" style="background: #'+(null==(b=d.getHexRGB())?"":_.escape(b))+';"></i></td> \r\n\t\t<td  data-bind="'+
(null==(b=d.getID())?"":_.escape(b))+'" class="channelName">'+(null==(b=d.getName())?"":_.escape(b))+" "+(null==(b=c.getChannelSuffix(d))?"":_.escape(b))+'</td>\r\n\t\t<td class="pull-right"> '+(null==(b=c.getChannelsInfo(d))?"":_.escape(b))+"</td>\r\n\t</tr>\r\n"});return a+="\r\n</table>"}});
define("tpl!web-viewer/graphics/ChannelInformationPopup",function(){return function(c){var b,a="",a=a+('<table class="channelInformation">\r\n\t<tr><th colspan="4">'+(null==(b=c.i18n("ChanOrigTitle"))?"":_.escape(b))+'</th></tr>\r\n\t<tr class="colorBlockCell">\r\n\t\t<td></td><td></td><td></td>\r\n\t\t<td width="25%" rowspan="3"><span class="colorBlockText">'+(null==(b=c.i18n("ChannelInformationCurrent"))?"":_.escape(b))+'</span><div style="background-color:#'+(null==(b=c.originalChannelColor)?"":
_.escape(b))+'" class="colorblock"></div></td>\r\n\t</tr>\r\n\t<tr>\r\n\t\t<td width="75%" colspan="3"><input class="channelName" value="'+(null==(b=c.originalName)?"":_.escape(b))+'" disabled></td>\t \t\r\n\t</tr>\t\r\n\t<tr>\r\n\t\t<td width="25%">R: <input class="rgbField" size="3" value="'+(null==(b=c.originalRgb.r)?"":_.escape(b))+'" disabled></td>\r\n\t\t<td width="25%">G: <input class="rgbField" size="3" value="'+(null==(b=c.originalRgb.g)?"":_.escape(b))+'" disabled></td>\r\n\t\t<td width="25%">B: <input class="rgbField" size="3" value="'+
(null==(b=c.originalRgb.b)?"":_.escape(b))+'" disabled></td>\t\r\n\t</tr>\r\n\t<tr>\r\n\t\t<td colspan="4"><input type="checkbox" ');c.wasOpaque&&(a+=" checked ");a+=" disabled> "+(null==(b=c.i18n("Opaque"))?"":_.escape(b))+'</td>\r\n\t</tr>\r\n</table>\r\n<hr/>\r\n<table class="channelInformation">\r\n\t<tr><th colspan="4">'+(null==(b=c.i18n("ChanDispTitle"))?"":_.escape(b))+'</th></tr>\r\n\t<tr class="colorBlockCell">\r\n\t\t<td></td><td></td><td></td>\r\n\t\t<td width="25%" rowspan="3"><span class="colorBlockText">'+
(null==(b=c.i18n("ChannelInformationNew"))?"":_.escape(b))+'</span><div style="background-color:#'+(null==(b=c.channelColor)?"":_.escape(b))+'" class="colorblock colorChangeBlock"></div></td>\r\n\t</tr>\r\n\t<tr>\r\n\t\t<td width="75%" colspan="3">\r\n\t\t<select class="channelSelectName">\r\n\t\t';_.each(c.channels,function(d){a+="\r\n\t\t\t";d.isChanged()&&(a+='\r\n\t\t\t<option value="'+(null==(b=d.getID())?"":_.escape(b))+'" class="changedChannelDef" ',d.getName()===c.channelName&&(a+="selected"),
a+=">"+(null==(b=d.getName())?"":_.escape(b))+"</option>\r\n\t\t\t");a+='\r\n\t\t\t<option value="'+(null==(b=d.getID())?"":_.escape(b))+'" class="originalChannelDef" ';d.getOriginalName()===c.channelName&&(a+="selected");a+=">"+(null==(b=d.getOriginalName())?"":_.escape(b))+"</option>\r\n\t\t"});a+='\r\n\t\t</select></td>\t \t\r\n\t</tr>\t\r\n\t<tr>\r\n\t\t<td width="25%">R: <input class="rgbField" name="r" size="3" value="'+(null==(b=c.rgb.r)?"":_.escape(b))+'" ></td>\r\n\t\t<td width="25%">G: <input class="rgbField" name="g" size="3" value="'+
(null==(b=c.rgb.g)?"":_.escape(b))+'" ></td>\r\n\t\t<td width="25%">B: <input class="rgbField" name="b" size="3" value="'+(null==(b=c.rgb.b)?"":_.escape(b))+'" ></td>\t\r\n\t</tr>\r\n\t<tr>\r\n\t\t<td colspan="4"><input name="opaque" type="checkbox" ';c.isOpaque&&(a+=" checked ");return a+="> "+(null==(b=c.i18n("Opaque"))?"":_.escape(b))+"</td>\r\n\t</tr>\r\n</table>"}});
define("web-viewer/graphics/ChannelPopup","web-viewer/layout/component/Popup Template tpl!web-viewer/graphics/ChannelInformationPopup utils/ShapeUtils component/toolbar/ButtonGroup web-viewer/layout/component/ColorPicker web-viewer/layout/component/ViewerToolbarButton web-viewer/utils/ViewerUtils jquery underscore".split(" "),function(c,b,a,d,e,l,i,j,g){d=function(d,f,n){c.call(this,d,f,d.getContext());this.f=d;this.element.addClass("channelsInfoPopup");this._graphicsModel=n;this.channel=this._colorPicker=
null;this._nextButton=new i(this.f,"nextChannel","icon-WCR_Table-Page-Next12",!1,_.bind(function(){var a=this._graphicsModel.getNextChannel(this.channel.getID());a&&this.setSelectedChannel(a)},this));this._previousButton=new i(this.f,"previousChannel","icon-WCR_Table-Page-Previous12",!1,_.bind(function(){var a=this._graphicsModel.getPreviousChannel(this.channel.getID());a&&this.setSelectedChannel(a)},this));this._stepButtonGroup=new e("stepThroughChannels",[this._previousButton,this._nextButton]);
this._tplContent=g("<div>");this._popupBtns=g("<div>").addClass("channelPopupBtns");d.i18n.loadBundle("viewer",_.bind(function(){this._revertButton=new i(this.f,"undoChannelRgb","icon-WCR_Actions-Undo12",!1,_.bind(function(){this._graphicsModel.resetChannel(this.channel.getID())},this));this._revertButton.element.append(d.i18n.t("AppDialogRevert"));this._revertButton.element.addClass("undoChannelRgbBtn");this.content.append(this._tplContent);this._popupBtns.append(this._revertButton.element);this._popupBtns.append(this._stepButtonGroup.element);
this._outerContent.append(this._popupBtns);this.setHeader(g("<span />").addClass("popupTitle").html(d.i18n.t("ChanEditTitle")))},this));this.t=new b(this.f.i18n,a);this.t.setContext(this._tplContent);this.t.bind("change","[name=r],[name=g],[name=b]",this._rgbValueChanged,this);this.t.bind("click","[name=opaque]",this._opaqueValueChanged,this);this.t.bind("change",".channelSelectName",this._channelDefinitionChanged,this);this.t.bind("click",".colorChangeBlock",function(a,f){this._colorPicker&&this._colorPicker.destroy();
this._colorPicker=new l(this.f,_.bind(function(a){this._changeChannelColor(j.intFromHex(a))},this),g(a));this._colorPicker.setColor(this.channel.getHexRGB());this._colorPicker.show();f.stopPropagation()},this);this.on("closed",_.bind(function(){this.hide()},this));this._debouncedRender=_.debounce(this.render,50);this._graphicsModel.on("changed.channel.*.channelRGB",_.bind(function(){this.visible&&this._debouncedRender()},this))};d.prototype=Object.create(c.prototype);d.prototype.constructor=d;d.prototype._opaqueValueChanged=
function(a){this._graphicsModel.setChannelOpaque(this.channel.getID(),a.checked)};d.prototype._rgbValueChanged=function(a){var f=j.rgbColor(this.channel.getHexRGB());"r"===a.name?f.r=parseInt(a.value,10):"g"===a.name?f.g=parseInt(a.value,10):"b"===a.name&&(f.b=parseInt(a.value,10));this._changeChannelColor(j.intFromHex(j.rgbToHex(f.r,f.g,f.b)))};d.prototype._changeChannelColor=function(a){this._graphicsModel.changeChannelRgb(this.channel.getID(),a)};d.prototype._channelDefinitionChanged=function(a){var f=
a.value,a=g(a).find(":selected").hasClass("originalChannelDef");this._graphicsModel.changeChannelDef(this.channel.getID(),f,a)};d.prototype.setSelectedChannel=function(a){this.channel=a;this.updateStepButtons();this.updateRevertButton();this.render()};d.prototype.show=function(a){c.prototype.show.call(this,a,250);this.render()};d.prototype.updateStepButtons=function(){this._previousButton.setEnabled(this._graphicsModel.hasPreviousChannel(this.channel.getID()));this._nextButton.setEnabled(this._graphicsModel.hasNextChannel(this.channel.getID()))};
d.prototype.updateRevertButton=function(){this.channel.isChanged()?this._revertButton.setEnabled(!0):this._revertButton.setEnabled(!1)};d.prototype.render=function(){this.t.d.channelName=this.channel.getName();this.t.d.originalName=this.channel.name;this.t.d.channelColor=this.channel.getHexRGB();this.t.d.originalChannelColor=j.hexFromInt(this.channel.rgb);this.t.d.channels=this._graphicsModel.getChannels();this.t.d.rgb=j.rgbColor(this.channel.getHexRGB());this.t.d.originalRgb=j.rgbColor(j.hexFromInt(this.channel.rgb));
this.t.d.isOpaque=this.channel.isChannelOpaque();this.t.d.wasOpaque=this.channel.wasChannelOpaque();this.updateStepButtons();this.updateRevertButton();this.t.render()};return d});
define("web-viewer/measure/EyeDropperUnitSelector",["web-viewer/layout/component/DropdownMiniButton","web-viewer/core/CoreConstants","underscore"],function(c,b,a){var d=function(d){this.f=d;this._optionButton=new c(this.f,"eyeDropperUnitSettings","icon-WCR_Settings-submenu");this._optionButton.setTooltip("viewer","UnitSettings");this.f.i18n.loadBundle("viewer",function(){this._optionButton.addOption({name:"eyeDropperUnitPixels",content:this.f.i18n.t(b.EyeDropperUnitsLocNames[b.EyeDropperUnits.PIXELS]),
onchange:a.bind(this._toggleEyeDropperUnit,this,b.EyeDropperUnits.PIXELS),userCannotUncheck:!0});this._optionButton.addOption({name:"eyeDropperUnitSQMM",content:this.f.i18n.t(b.EyeDropperUnitsLocNames[b.EyeDropperUnits.SQMM]),onchange:a.bind(this._toggleEyeDropperUnit,this,b.EyeDropperUnits.SQMM),userCannotUncheck:!0});this._optionButton.addOption({name:"eyeDropperUnitSQCM",content:this.f.i18n.t(b.EyeDropperUnitsLocNames[b.EyeDropperUnits.SQCM]),onchange:a.bind(this._toggleEyeDropperUnit,this,b.EyeDropperUnits.SQCM),
userCannotUncheck:!0});this._optionButton.addOption({name:"eyeDropperUnitSQINCH",content:this.f.i18n.t(b.EyeDropperUnitsLocNames[b.EyeDropperUnits.SQINCH]),onchange:a.bind(this._toggleEyeDropperUnit,this,b.EyeDropperUnits.SQINCH),userCannotUncheck:!0});this._optionButton.addOption({name:"eyeDropperUnitPercent",content:this.f.i18n.t(b.EyeDropperUnitsLocNames[b.EyeDropperUnits.PERCENT]),onchange:a.bind(this._toggleEyeDropperUnit,this,b.EyeDropperUnits.PERCENT),userCannotUncheck:!0});this._updateOptions();
this.f.getCurrentUser().on("options.changed.PREFERENCES_UNIT_EYEDROPPER",a.bind(this._updateOptions,this))},this)};d.prototype.getButtonElement=function(){return this._optionButton.element};d.prototype._toggleEyeDropperUnit=function(a,d){d&&(this.f.setOption("PREFERENCES_UNIT_EYEDROPPER",a,!0),a!==b.EyeDropperUnits.PERCENT&&this.f.setOption("PREFERENCES_UNIT_SIZE",a,!0))};d.prototype._updateOptions=function(){var a=this.f.getOption("PREFERENCES_UNIT_EYEDROPPER");this._optionButton.toggleOption("eyeDropperUnitPixels",
a===b.EyeDropperUnits.PIXELS);this._optionButton.toggleOption("eyeDropperUnitSQMM",a===b.EyeDropperUnits.SQMM);this._optionButton.toggleOption("eyeDropperUnitSQCM",a===b.EyeDropperUnits.SQCM);this._optionButton.toggleOption("eyeDropperUnitSQINCH",a===b.EyeDropperUnits.SQINCH);this._optionButton.toggleOption("eyeDropperUnitPercent",a===b.EyeDropperUnits.PERCENT)};return d});
define("web-viewer/measure/ScreenRulingUnitSelector",["web-viewer/layout/component/DropdownMiniButton","web-viewer/core/CoreConstants","web-viewer/measure/MeasureConstants","underscore"],function(c,b,a,d){var e=function(e){this.f=e;this._optionButton=new c(e,"screenRulingUnitSettings","icon-WCR_Settings-submenu");e.i18n.loadBundle("viewer",function(){function e(a,b,f){f&&this.setUnitAndMode(a,b)}function c(a,b){b&&this.setOrientation(a)}this._optionButton.addOption({name:"unitLpmm",content:this.f.i18n.t("UnitScreenmm"),
onchange:d.bind(e,this,b.ResolutionUnits.PPMM,a.ScreenRulingMode.LINES),userCannotUncheck:!0});this._optionButton.addOption({name:"unitLpcm",content:this.f.i18n.t("UnitScreencm"),onchange:d.bind(e,this,b.ResolutionUnits.PPCM,a.ScreenRulingMode.LINES),userCannotUncheck:!0});this._optionButton.addOption({name:"unitLpi",content:this.f.i18n.t("UnitScreenInch"),onchange:d.bind(e,this,b.ResolutionUnits.PPI,a.ScreenRulingMode.LINES),userCannotUncheck:!0});this._optionButton.addOption({name:"unitDeg",content:this.f.i18n.t("UnitDegree"),
onchange:d.bind(e,this,0,a.ScreenRulingMode.ANGLE),userCannotUncheck:!0});this._optionButton.addOption({name:"unitLpmmDeg",content:this.f.i18n.t("UnitDegreemm"),onchange:d.bind(e,this,b.ResolutionUnits.PPMM,a.ScreenRulingMode.BOTH),userCannotUncheck:!0});this._optionButton.addOption({name:"unitLpcmDeg",content:this.f.i18n.t("UnitDegreecm"),onchange:d.bind(e,this,b.ResolutionUnits.PPCM,a.ScreenRulingMode.BOTH),userCannotUncheck:!0});this._optionButton.addOption({name:"unitLpiDeg",content:this.f.i18n.t("UnitDegreeInch"),
onchange:d.bind(e,this,b.ResolutionUnits.PPI,a.ScreenRulingMode.BOTH),userCannotUncheck:!0});this._optionButton.addDivider();this._optionButton.addOption({name:"scrOrientationCW",content:this.f.i18n.t("ScreenCW"),onchange:d.bind(c,this,a.ScreenRulingOrientation.CW),userCannotUncheck:!0});this._optionButton.addOption({name:"scrOrientationCCW",content:this.f.i18n.t("ScreenCCW"),onchange:d.bind(c,this,a.ScreenRulingOrientation.CCW),userCannotUncheck:!0});this._updateUnitOptions();this._updateOrientationOptions();
this._optionButton.setTooltip("viewer","UnitSettings");this.f.getCurrentUser().on("options.changed.PREFERENCES_UNIT_SCREENRULING",d.bind(this._updateUnitOptions,this));this.f.getCurrentUser().on("options.changed.PREFERENCES_UNIT_SCREEN",d.bind(this._updateUnitOptions,this));this.f.getCurrentUser().on("options.changed.PREFERENCES_SCREEN_ORIENTATION",d.bind(this._updateOrientationOptions,this))},this)};e.prototype.getButtonElement=function(){return this._optionButton.element};e.prototype.setUnitAndMode=
function(a,b){this.f.getOption("PREFERENCES_UNIT_SCREENRULING")!==a&&this.f.setOption("PREFERENCES_UNIT_SCREENRULING",a,!0);this.f.getOption("PREFERENCES_UNIT_SCREEN")!==b&&this.f.setOption("PREFERENCES_UNIT_SCREEN",b,!1)};e.prototype._updateUnitOptions=function(){var d=this.f.getOption("PREFERENCES_UNIT_SCREENRULING"),e=this.f.getOption("PREFERENCES_UNIT_SCREEN");this._optionButton.toggleOption("unitLpmm",d===b.ResolutionUnits.PPMM&&e===a.ScreenRulingMode.LINES);this._optionButton.toggleOption("unitLpcm",
d===b.ResolutionUnits.PPCM&&e===a.ScreenRulingMode.LINES);this._optionButton.toggleOption("unitLpi",d===b.ResolutionUnits.PPI&&e===a.ScreenRulingMode.LINES);this._optionButton.toggleOption("unitDeg",e===a.ScreenRulingMode.ANGLE);this._optionButton.toggleOption("unitLpmmDeg",d===b.ResolutionUnits.PPMM&&e===a.ScreenRulingMode.BOTH);this._optionButton.toggleOption("unitLpcmDeg",d===b.ResolutionUnits.PPCM&&e===a.ScreenRulingMode.BOTH);this._optionButton.toggleOption("unitLpiDeg",d===b.ResolutionUnits.PPI&&
e===a.ScreenRulingMode.BOTH)};e.prototype.setOrientation=function(a){this.f.setOption("PREFERENCES_SCREEN_ORIENTATION",a,!1)};e.prototype._updateOrientationOptions=function(){var b=this.f.getOption("PREFERENCES_SCREEN_ORIENTATION");this._optionButton.toggleOption("scrOrientationCW",b===a.ScreenRulingOrientation.CW);this._optionButton.toggleOption("scrOrientationCCW",b===a.ScreenRulingOrientation.CCW)};return e});
define("web-viewer/graphics/ChannelsWidget","web-viewer/layout/AbstractWidget Template tpl!web-viewer/graphics/ChannelsWidget web-viewer/graphics/GraphicsConstants web-viewer/layout/component/ViewerToolbarButton component/toolbar/ButtonGroup web-viewer/layout/component/DropdownToolbarButton web-viewer/layout/component/ColorPicker web-viewer/layout/LayoutConstants web-viewer/graphics/ChannelPopup utils/ShapeUtils web-viewer/utils/ViewerUtils web-viewer/compare/CompareConstants web-viewer/measure/EyeDropperUnitSelector web-viewer/measure/ScreenRulingUnitSelector web-viewer/utils/ListenerUtil web-viewer/core/CoreConstants jquery underscore jqueryUI jqueryUITouchPunch".split(" "),function(c,
b,a,d,e,l,i,j,g,q,f,n,k,m,v,K,x,t,h){var p=function(f,n){c.call(this,f,g.Widget.CHANNELS);this.f=f;K.mixin(this,f);this._graphicsModel=null;this.setGraphicsModel(n);this.isOrderingEnabled=!0;this._contentDiv=t("<div/>");this._screenRulingUnitSelector=this._eyeDropperUnitSelector=this._colorPicker=null;this.setIcon("icon icon-WCR_Channel-Color");this.t=new b(this.f.i18n,a);this.t.setContext(this._contentDiv);this.t.d.getChannels=h.bind(function(){return this._graphicsModel?this._graphicsModel.getChannels(!0):
[]},this);this.t.d.getChannelsInfo=function(a){return this.channelsInfo?this.channelsInfo[a.getViewserverID()]||"":""};this.t.d.isAllEnabled=h.bind(function(){return this.isAllChannelsEnabled()},this);this.t.d.getChannelSuffix=h.bind(function(a){if(this._graphicsModel.isInDifferenceCompareMode()){if(a.isAdded())return"(+)";if(a.isSubtracted())return"(-)"}else return""},this);this.f.on("channels.informationAdded",h.bind(function(a){this.t.d.channelsInfo=[];a=this._graphicsModel.getParsedChannelsInfo(a);
h.each(a.channels,function(a){a&&(this.t.d.channelsInfo[a.getViewserverID()]=a.value)},this);this.t.d.totalCount=a.total;this.render()},this));this.f.on("channels.informationNotVisible",h.bind(function(){this.t.d.channelsInfo=null;this.t.d.totalCount="";this.render()},this));this.channelPopup=new q(f,"channelInformation",n);this._splitChannels=new i(f,"splitChannels"," icon-WCR_Tiling-Auto",!0,h.bind(function(a){a?this.setChannelViewMode(d.ChannelViewMode.AUTOMATIC_TILING):this.setChannelViewMode(d.ChannelViewMode.COMPOSITE_VIEW)},
this));this._splitChannels.element.addClass("toggleBtn");this._singleChannelMode=new i(f,"singleChannelMode","icon-WCR_Channel-Black",!0,h.bind(function(a){a?this.setSingleChannelMode(d.SingleChannelMode.IN_BLACK):this.setSingleChannelMode(d.SingleChannelMode.IN_CHANNEL_COLOR)},this));this._singleChannelMode.element.addClass("toggleBtn");this._resetChannelsButton=new i(f,"resetChannels","icon-WCR_Revert",!0,h.bind(function(){this._graphicsModel.resetDefaultChannelOrder();this._graphicsModel.resetAllChannelsColorDef()},
this));this._moveChannelsUp=new e(f,"moveChannelUp","icon-WCR_Up",!1,h.bind(function(){var a,f;if(this._graphicsModel.hasEnabledChannelGaps()){var b=null;for(a=0;a<this._graphicsModel.getChannelCount();a++)f=this._graphicsModel.getChannelAtIndex(a),f.isEnabled()&&(null===b||b===a?b=a+1:(this._graphicsModel.moveChannelTo(f.getID(),b),b++))}else if(2<=this._graphicsModel.getChannelCount()&&!this._graphicsModel.getChannelAtIndex(0).isEnabled())for(a=1;a<this._graphicsModel.getChannelCount();)f=this._graphicsModel.getChannelAtIndex(a),
f.isEnabled()?this._graphicsModel.moveChannelTo(f.getID(),a-1):a++},this));this._moveChannelsDown=new e(f,"moveChannelDown","icon-WCR_Down",!1,h.bind(function(){var a,f;if(this._graphicsModel.hasEnabledChannelGaps()){var b=null;for(a=this._graphicsModel.getChannelCount()-1;0<=a;a--)f=this._graphicsModel.getChannelAtIndex(a),f.isEnabled()&&(null===b||b===a?b=a-1:(this._graphicsModel.moveChannelTo(f.getID(),b),b--))}else if(1<this._graphicsModel.getChannelCount()&&!this._graphicsModel.getChannelAtIndex(this._graphicsModel.getChannelCount()-
1).isEnabled())for(a=n.getChannelCount()-2;0<=a;)f=this._graphicsModel.getChannelAtIndex(a),f.isEnabled()?this._graphicsModel.moveChannelTo(f.getID(),a+1):a--},this));this._channelMatching=new e(f,"channelMatching","icon-WCR_Channel-Matching",!1,function(){});this._channelMatching.element.hide();this._moveChannelsButtonGroup=new l("moveChannels",[this._moveChannelsUp,this._moveChannelsDown]);f.i18n.loadBundle("viewer",h.bind(function(){this.setTitle(this.f.t("ChannelsTitle"));this._splitChannels.setTooltip(f.i18n.t("ChanSplitChannelsTT"));
this._singleChannelMode.setTooltip(f.i18n.t("ChanSingleTT"));this._moveChannelsDown.setTooltip(f.i18n.t("ChanDownTT"));this._moveChannelsUp.setTooltip(f.i18n.t("ChanUpTT"));this._resetChannelsButton.setTooltip(f.i18n.t("ChanResetDefsTT"));this._channelMatching.setTooltip(f.i18n.t("MapChanTitle"));this._splitChannels.addOption({name:"composite",content:f.i18n.t("SplitChannelsOff"),onchange:h.bind(function(){this.setChannelViewMode(d.ChannelViewMode.COMPOSITE_VIEW)},this),userCannotUncheck:!0});this._splitChannels.addOption({name:"automatic",
content:f.i18n.t("SplitChannelsTileAuto"),onchange:h.bind(function(){this.setChannelViewMode(d.ChannelViewMode.AUTOMATIC_TILING)},this),userCannotUncheck:!0});this._splitChannels.addOption({name:"horizontal",content:f.i18n.t("SplitChannelsTileHor"),onchange:h.bind(function(){this.setChannelViewMode(d.ChannelViewMode.HORIZONTAL_TILING)},this),userCannotUncheck:!0});this._splitChannels.addOption({name:"vertical",content:f.i18n.t("SplitChannelsTileVer"),onchange:h.bind(function(){this.setChannelViewMode(d.ChannelViewMode.VERTICAL_TILING)},
this),userCannotUncheck:!0});this.setChannelViewMode(this._graphicsModel.getChannelViewMode());this._singleChannelMode.addOption({name:"inChannelColor",content:f.i18n.t("ChanSingleOff"),onchange:h.bind(function(){this.setSingleChannelMode(d.SingleChannelMode.IN_CHANNEL_COLOR)},this),userCannotUncheck:!0});this._singleChannelMode.addOption({name:"inBlack",content:f.i18n.t("ChanSingleOn"),onchange:h.bind(function(){this.setSingleChannelMode(d.SingleChannelMode.IN_BLACK)},this),userCannotUncheck:!0});
this._singleChannelMode.addOption({name:"inBlackWithShowAll",content:f.i18n.t("ChanSingleShowAll"),onchange:h.bind(function(){this.setSingleChannelMode(d.SingleChannelMode.IN_BLACK_WITH_SHOW_ALL_EFFECT)},this),userCannotUncheck:!0});this.setSingleChannelMode(this._graphicsModel.getSingleChannelMode());this._resetChannelsButton.addAction({name:"resetOnlyChannelOrder",content:f.i18n.t("ChanResetOrder"),action:h.bind(function(){this._graphicsModel.resetDefaultChannelOrder()},this)});this._resetChannelsButton.addAction({name:"resetOnlyChannelsColorDef",
content:f.i18n.t("ChanResetColor"),action:h.bind(function(){this._graphicsModel.resetAllChannelsColorDef()},this)});this._resetChannelsButton.addAction({name:"resetBothChannelsColorDefAndOrder",content:f.i18n.t("ChanResetBoth"),action:h.bind(function(){this._graphicsModel.resetDefaultChannelOrder();this._graphicsModel.resetAllChannelsColorDef()},this)})},this));this.keyEvents=[];this.keyEvents.push(["alt+1 alt+2 alt+3 alt+4 alt+5 alt+6 alt+7 alt+8 alt+9".split(" "),h.bind(function(a){a.preventDefault();
var f=0>a.keyCode-96?a.keyCode-48:a.keyCode-96,a=this._graphicsModel.getChannels(!0);f<=a.length&&h.each(a,h.bind(function(a,b){this._graphicsModel.toggleChannel(a.getID(),b==f-1)},this))},this)]);this.keyEvents.push([["alt+a"],h.bind(function(a){a.preventDefault();h.each(this._graphicsModel.getChannels(),h.bind(function(a){this._graphicsModel.toggleChannel(a.getID(),!0)},this))},this)]);this.keyEvents.push([["alt+n"],h.bind(function(a){a.preventDefault();var a=this._graphicsModel.getChannels(!0),
f=h.find(a,function(a){return a.isEnabled()}).getID();if(1<this._graphicsModel.getEnabledChannelCount(!0))h.each(a,h.bind(function(a){this._graphicsModel.toggleChannel(a.getID(),a.getID()==f)},this));else{this._graphicsModel.toggleChannel(f,!1);for(var b=0;b<a.length&&a[b].getID()!==f;)b++;this._graphicsModel.toggleChannel(a[(b+1)%a.length].getID(),!0)}},this)]);this.keyEvents.push(["ctrl+alt+0 ctrl+alt+1 ctrl+alt+2 ctrl+alt+3 ctrl+alt+4 ctrl+alt+5 ctrl+alt+6 ctrl+alt+7 ctrl+alt+8 ctrl+alt+9".split(" "),
h.bind(function(a){a.preventDefault();a.stopPropagation();var f=0>a.keyCode-96?a.keyCode-48:a.keyCode-96,f=f+10,a=this._graphicsModel.getChannels(!0);f-1<a.length&&h.each(a,h.bind(function(a,b){this._graphicsModel.toggleChannel(a.getID(),b==f-1)},this))},this),"keydown"]);this.bindKeys(this.keyEvents);this.f.isMobile()?(this._lastClickedElement=this._clickTimer=null,this.t.bind("touchstart pointerdown",".eyeBox",function(a,f){null==this._clickTimer||this._lastClickedElement!==a?(this._lastClickedElement=
a,this._clickTimer=setTimeout(h.bind(function(){this._clickTimer=null;this.eyeBoxClicked(a,f)},this),350)):(clearTimeout(this._clickTimer),this._clickTimer=null,f.which=3,this.eyeBoxClicked(a,f))},this)):this.t.bind("mouseup",".eyeBox",this.eyeBoxClicked,this);this.t.bind("click",".colorBox,.channelName",this.colorBoxClicked,this);this.t.bind("contextmenu",".colorBox",this.colorBoxRightClicked,this);this.t.bind("contextmenu",".eyeBox",function(a,f){f.preventDefault();return!1},this);this.f.on("module.compare.changed.mode",
h.bind(function(a,f){var b=!0;if(f&&(f.getName()===k.mode.BLINKING||f.getName()===k.mode.DIFFERENCE||f.getName()===k.mode.SHOWBOTHONTOP||f.getName()===k.mode.SIDEBYSIDE))b=!1;this.toggleOrdering(b)},this));this.f.getDocumentController().whenActivePageChangedAndParametersAvailable(this._updateEyeDropperUnitSelectorButton,this);this.f.on("tool.measureEyeDropperTool.activated",h.bind(this._updateEyeDropperUnitSelectorButton,this));this.f.on("tool.measureEyeDropperTool.deactivated",h.bind(this._updateEyeDropperUnitSelectorButton,
this));this.f.on("tool.measureScreenRulingTool.activated",h.bind(this._updateScreenRulingUnitSelectorButton,this));this.f.on("tool.measureScreenRulingTool.deactivated",h.bind(this._updateScreenRulingUnitSelectorButton,this))};p.prototype=Object.create(c.prototype);p.prototype.constructor=p;p.widgetName=g.Widget.CHANNELS;p.prototype.setContext=function(a,f){c.prototype.setContext.call(this,a,f);this.context.addClass("channelsWidget");this._updateEyeDropperUnitSelectorButton();var b=t("<div/>").addClass("buttons");
b.append(this._splitChannels.element);b.append(this._singleChannelMode.element);this.f.isMobile()?this.headerExtra.addClass("flexEnd").append(this._resetChannelsButton.element):(b.append(this._resetChannelsButton.element),b.append(this._moveChannelsButtonGroup.element),b.append(this._channelMatching.element));this.context.append(b);this.context.append(this._contentDiv);this.render()};p.prototype.showChannelMatchingBtn=function(a){this._channelMatching.setAction(a);this._channelMatching.element.show()};
p.prototype.hideChannelMatchingBtn=function(){this._channelMatching.element.hide()};p.prototype.setGraphicsModel=function(a){this._unregisterAllListeners();this._graphicsModel=a;a=h.throttle(h.bind(function(){this.render()},this),40);a();this._registerListener("changed.channel.**",a,this,this._graphicsModel);this._registerListener("changed.channels",a,this,this._graphicsModel);this._registerListener("changed.channelViewMode",h.bind(function(a,f){this._updateChannelViewModeBtn(f)},this),this,this._graphicsModel);
this._registerListener("changed.channelOrder",a,this,this._graphicsModel)};p.prototype.eyeBoxClicked=function(a,f){var b,d=t(a).attr("data-bind");if("all"==d)this.isAllChannelsEnabled()?(b=this._graphicsModel.getChannels(),h.each(b,function(a,f){0<f&&this._graphicsModel.toggleChannel(a.getID(),!1)},this),this._graphicsModel.toggleChannel(b[0].getID(),!0)):h.each(this._graphicsModel.getChannels(),function(a){this._graphicsModel.toggleChannel(a.getID(),!0)},this);else if(3===f.which)h.each(this._graphicsModel.getChannels(),
function(a){this._graphicsModel.toggleChannel(a.getID(),!1)},this),this._graphicsModel.toggleChannel(d,!0);else if(b=!t(a).hasClass("selected"),this._graphicsModel.toggleChannel(d,b),this.isNoChannelEnabled()){b=this._graphicsModel.getChannels();for(var e=0;e<b.length&&b[e].getID()!==d;)e++;this._graphicsModel.toggleChannel(b[(e+1)%b.length].getID(),!0)}};p.prototype.colorBoxClicked=function(a,b){if(!this.f.isMobile())if(3>b.which){var d=t(a).attr("data-bind"),e=null,e="all"===d?h.first(this._graphicsModel.getChannels(!0)):
this._graphicsModel.getChannel(d);this.channelPopup.setSelectedChannel(e);d=250>this.context.offset().left?this.context.width():this.context.offset().left-250;d=new f.Point(d,this.context.offset().top);this.channelPopup.show(d)}else 3===b.which&&this.colorBoxRightClicked(a,b)};p.prototype.colorBoxRightClicked=function(a,f){f.preventDefault();var b=t(a).attr("data-bind");if("all"!==b){var d=this._graphicsModel.getChannel(b);this._colorPicker&&(this._colorPicker.destroy(),this._colorPicker=null);this._colorPicker=
new j(this.f,h.bind(function(a){this._graphicsModel.changeChannelRgb(b,n.intFromHex(a))},this),t("<div/>").insertAfter(t(a)));this._colorPicker.setColor(d.getHexRGB());this._colorPicker.show()}};p.prototype.render=h.debounce(function(){if(this.isContextAvailable()){this.t.render();var a;this.f.isMobile()&&(a=".colorBox");this.context.find(".sortableChannelsList").sortable({items:"tr.dragAndDropChannel",update:h.bind(function(){this._graphicsModel.channelOrderChanged=!0;var a=this.context.find(".sortableChannelsList").sortable("toArray",
{attribute:"data-bind"});this._graphicsModel.setChannelOrder(a);this.channelPopup.visible&&this.channelPopup.hide();this.updateRevertButton()},this),handle:a});this.context.find(".sortableChannelsList").disableSelection();this.updateMoveChannelsButtons();this.updateRevertButton();this._fireResized()}},40);p.prototype.isAllChannelsEnabled=function(){return h.every(this._graphicsModel.getChannels(),function(a){return a.isEnabled()})};p.prototype.isNoChannelEnabled=function(){return h.every(this._graphicsModel.getChannels(),
function(a){return!a.isEnabled()})};p.prototype.setChannelViewMode=function(a){this._updateChannelViewModeBtn(a);this._graphicsModel.setChannelViewMode(a)};p.prototype._updateChannelViewModeBtn=function(a){this._splitChannels.toggleOption("composite",a===d.ChannelViewMode.COMPOSITE_VIEW);this._splitChannels.toggleOption("automatic",a===d.ChannelViewMode.AUTOMATIC_TILING);this._splitChannels.toggleOption("horizontal",a===d.ChannelViewMode.HORIZONTAL_TILING);this._splitChannels.toggleOption("vertical",
a===d.ChannelViewMode.VERTICAL_TILING);this._splitChannels.setActive(a!==d.ChannelViewMode.COMPOSITE_VIEW)};p.prototype.setSingleChannelMode=function(a){this._singleChannelMode.setActive(a!==d.SingleChannelMode.IN_CHANNEL_COLOR);this._singleChannelMode.toggleOption("inChannelColor",a===d.SingleChannelMode.IN_CHANNEL_COLOR);this._singleChannelMode.toggleOption("inBlack",a===d.SingleChannelMode.IN_BLACK);this._singleChannelMode.toggleOption("inBlackWithShowAll",a===d.SingleChannelMode.IN_BLACK_WITH_SHOW_ALL_EFFECT);
this._singleChannelMode.setTooltip("viewer",a!==d.SingleChannelMode.IN_CHANNEL_COLOR?"ChanSingleTT2":"ChanSingleTT");this._graphicsModel.setSingleChannelMode(a)};p.prototype.updateMoveChannelsButtons=function(){if(this.isContextAvailable())if(this.isOrderingEnabled){if(this._graphicsModel.hasEnabledChannelGaps())this._moveChannelsUp.setEnabled(!0),this._moveChannelsDown.setEnabled(!0);else{var a=this._graphicsModel.getChannels();0<a.length?(this._moveChannelsDown.setEnabled(!h.last(a).isEnabled()),
this._moveChannelsUp.setEnabled(!h.first(a).isEnabled())):(this._moveChannelsDown.setEnabled(!1),this._moveChannelsUp.setEnabled(!1))}this.context.find(".sortableChannelsList").sortable("enable")}else this._moveChannelsUp.setEnabled(!1),this._moveChannelsDown.setEnabled(!1),this.context.find(".sortableChannelsList").sortable("disable")};p.prototype.toggleOrdering=function(a){this.isOrderingEnabled!=a&&(this.isOrderingEnabled=a,this.updateMoveChannelsButtons())};p.prototype.updateRevertButton=function(){this._graphicsModel.hasChanges()?
this._resetChannelsButton.setEnabled(!0):this._resetChannelsButton.setEnabled(!1)};p.prototype._updateEyeDropperUnitSelectorButton=function(){this.isContextAvailable()&&this.f.emit("toolManager.activeTool",h.bind(function(a){void 0!==a&&(a.getIID()===x.TOOLS.MEASURE_EYEDROPPER&&a.isActive())&&this.f.getActivePage().isDigitalFilmPage()?null===this._eyeDropperUnitSelector?(this._eyeDropperUnitSelector=new m(this.f),this.headerExtra.append(this._eyeDropperUnitSelector.getButtonElement())):this._eyeDropperUnitSelector.getButtonElement().show():
null!==this._eyeDropperUnitSelector&&this._eyeDropperUnitSelector.getButtonElement().hide()},this))};p.prototype._updateScreenRulingUnitSelectorButton=function(){this.isContextAvailable()&&this.f.emit("toolManager.activeTool",h.bind(function(a){void 0!==a&&(a.getIID()===x.TOOLS.MEASURE_SCREEN_RULING&&a.isActive())&&this.f.getActivePage().isDigitalFilmPage()?null===this._screenRulingUnitSelector?(this._screenRulingUnitSelector=new v(this.f),this.headerExtra.append(this._screenRulingUnitSelector.getButtonElement())):
this._screenRulingUnitSelector.getButtonElement().show():null!==this._screenRulingUnitSelector&&this._screenRulingUnitSelector.getButtonElement().hide()},this))};p.prototype.willFill=function(){return this.f.isMobile()};return p});
define("web-viewer/graphics/GraphicsLayerModel","underscore web-viewer/viewport/model/ViewportLayerModel web-viewer/utils/LineworkWrapper web-viewer/utils/DrawUtils utils/ShapeUtils web-viewer/utils/LineworkPoint web-viewer/utils/ListenerUtil web-viewer/utils/ViewerUtils web-viewer/compare/CompareConstants".split(" "),function(c,b,a,d,e,l,i,j,g){e=function(a,f,d){b.call(this,a,f);i.mixin(this,a);this._graphicsModel=d;this._showMargin=!1;this.f.whenModuleAvailable("viewport",function(a){this._viewport=
a},this);this._hasGrid=!1;this._buffer=null;this.markAllAsDirty=c.throttle(c.bind(this._markAllAsDirty,this),20);this._registerListener("changed.**",this.modelChanged,this,this._graphicsModel);this._registerListener("changed.channel.**",this.markAllAsDirty,void 0,this._graphicsModel);this._registerListener("changed.channelOrder",this.markAllAsDirty,void 0,this._graphicsModel);this._registerListener("changed.singleChannelMode",this.markAllAsDirty,void 0,this._graphicsModel);this._registerListener("viewport.viewserverParametersChanged",
this.markAllAsDirty);this._registerListener("doc.parameters.changed",this.markAllAsDirty);this._registerListener("changed.page",this._cleanupFragments,this,this._graphicsModel);this._registerListener("needsFragmentCleanup",this._cleanupFragments,this,this._graphicsModel)};e.prototype=Object.create(b.prototype);e.prototype.constructor=e;e.prototype.destroy=function(){b.prototype.destroy.call(this);this._unregisterAllListeners()};e.prototype.hasGraphics=function(){return this._graphicsModel.page&&this._graphicsModel.page.hasGraphics()||
this._graphicsModel.difference&&this._graphicsModel.difference.hasGraphics()};e.prototype.hasBuffer=function(a){return"default"===a?null!==this._buffer:!1};e.prototype.getBuffer=function(){return this._buffer};e.prototype.setBuffer=function(a){this._buffer=a};e.prototype.hasLinework=function(a){return this._hasGrid&&"default"===a};e.prototype.shouldAutoFetchFragments=function(){return!0};e.prototype.getLinework=function(a,f,b,d,e,c){var l=[];void 0!==this._graphicsModel.page&&(!c&&void 0!==b)&&(this._getTrimbox(l,
b,e),this._getGridLinework(l,a,f,b,d,e),this._getReaderSpreadLines(l));return l};e.prototype._getGridLinework=function(b,f,e,k,m,i){f=this.f.getActivePage();if(this._viewport&&1E3<=this._viewport.getWorld().getZoomPercentage()&&!f.hasDeepZoom()){if(this._hasGrid=!0,m=this._viewport.getFirstViewOccurrence(m),"default"===i&&m){for(var g=this._viewport.getVisibleRect(),k=j.parseFloat(f.getParam("resolutionx")),f=j.parseFloat(f.getParam("resolutiony")),i=this._viewport.getWorld().getZoom(),e=Math.ceil(g.origin.x*
k)/k+0,x=Math.round((e-g.origin.x)*i),k=1/k,t=k*i,h=g.origin.x+g.size.width,p=[];e<h;)p.push(e),e+=k;p.push(g.origin.x+g.size.width);for(var e=Math.ceil(g.origin.y*f)/f+0,D=Math.round((e-g.origin.y)*i),k=g.origin.y+g.size.height,f=1/f,y=f*i,w=[];e<k;)w.push(e),e+=f;w.push(g.origin.y+g.size.height);this._graphicsLayer=m.getLayer("Graphics").getLayerElement();var s=this._viewport.getWorld().getRotation()%360,A=this._viewport.getWorld().isFlip();if(this._viewport.getWorld().isFlipViewFromBack()){if(90===
s||270===s)s=(s+180)%360;A=!A}var B=Math.ceil(t/2),C=Math.ceil(y/2),u=$(this._graphicsLayer).innerWidth(),z=$(this._graphicsLayer).innerHeight(),I=0;0===g.origin.x&&(I=u-Math.ceil(g.size.width*i));var J=0;0===g.origin.y&&(J=z-Math.ceil(g.size.height*i));if(0!==u&&0!==z){var E=$(this._graphicsLayer)[0].getContext("2d").getImageData(0,0,u,z).data;c.each(p,function(f,e){c.each(w,function(n,k){var m=1,i=1,j=0,j=0==e?g.origin.x:p[e-1],v=0,v=0==k?g.origin.y:w[k-1],h=e,F=k,G=x,H=D;90===s||180===s?(F=w.length-
k-1,H=90===s?(u-D)%Math.round(y):(z-D)%Math.round(y),0===k&&(m=-1)):c.last(w)==n&&(m=-1);(180===s||270===s)&&!A||(90===s||0===s)&&A?(h=p.length-e-1,G=90===s||270===s?(z-x)%Math.round(t):(u-x)%Math.round(t),0===e&&(i=-1)):c.last(p)==f&&(i=-1);var r=0;if(90==s||270==s){if(r=u*Math.round(h*t)+G*u+Math.round(y*F)+H-B*u-C,0===e||0===k||c.last(p)==f||c.last(w)==n)r+=i*(B-2)*u+m*(C-2)}else if(r=u*Math.round(F*y)+H*u+J*u+I+Math.round(t*h)+G-C*u-B,0===e||0===k||c.last(p)==f||c.last(w)==n)r+=m*(C-2)*u+i*(B-
2);r*=4;m=(255-E[r+0]).toString(16);i=(255-E[r+1]).toString(16);r=(255-E[r+2]).toString(16);1===m.length&&(m="0"+m);1===i.length&&(i="0"+i);1===r.length&&(r="0"+r);h=new a;h.type=d.LWTYPE_LINE;h.linewidth=1;h.color="#"+m+i+r;h.pointArray[0]=new l;h.pointArray[0].makeMoveTo(j,n);h.pointArray[1]=new l;h.pointArray[1].makeLineTo(f,n);b.push(h);h=new a;h.type=d.LWTYPE_LINE;h.linewidth=1;h.color="#"+m+i+r;h.pointArray[0]=new l;h.pointArray[0].makeMoveTo(f,v);h.pointArray[1]=new l;h.pointArray[1].makeLineTo(f,
n);b.push(h)},this)},this)}}}else this._hasGrid=!1};e.prototype._getReaderSpreadLines=function(b){if(this._graphicsModel.page.isReaderSpread()){var f=new a;f.type=d.LWTYPE_LINE;f.linewidth=1;f.color="#ababab";var e=new a;e.type=d.LWTYPE_LINE;e.linewidth=1;e.color="#ababab";var c=this._graphicsModel.getPage(),m=c.getPageSize(),i=this._graphicsModel.getReferencePage(),g=0;c&&c.get("isRightPage")?i?i.isBlankPage()?(g=i.getTrimboxSize().width,c.isBlankPage()&&(g+=i.getMargins().left)):g=i.getPageSize().width-
i.getMargins().right:g=c.isBlankPage()?m.width+c.getMargins().left:c.getTrimboxRect().origin.x-c.getMargins().left:c.isBlankPage()&&i?(g=c.getTrimboxSize().width,i.isBlankPage()&&(g+=c.getMargins().left)):g=m.width-c.getMargins().right;f.pointArray[0]=new l;f.pointArray[0].makeMoveTo(g,-(0.1*m.height));f.pointArray[1]=new l;f.pointArray[1].makeLineTo(g,-(0.01*m.height));e.pointArray[0]=new l;e.pointArray[0].makeMoveTo(g,m.height+0.1*m.height);e.pointArray[1]=new l;e.pointArray[1].makeLineTo(g,m.height+
0.01*m.height);b.push(f);b.push(e)}};e.prototype._getTrimbox=function(b,f,e){if(this._graphicsModel.isShowTrimbox()){var c=new a,m=this._graphicsModel.getTrimBox(),i=this._graphicsModel.dmode===g.diffMode.SHOWBOTHSIDEBYSIDE||this._graphicsModel.dmode===g.diffMode.SHOWBOTHSIDEBYSIDEHIGHLIGHT||this._graphicsModel.dmode===g.diffMode.SHOWBOTHSIDEBYSIDECHANGESONLY;if(null!==m&&!m.containsRect(f)&&this._graphicsModel.dmode!==g.diffMode.DIFFVERSION&&(i&&("default"===e||"compare_align_result"===e||"compare_differenceMode"===
e)||!i))c.type=d.LWTYPE_DASHEDBOX,c.dash=[10,3,2,3,2,3],c.linewidth=1,c.color=this.f.getCurrentUser().getColor("PREFERENCES_HIGHLIGHTCOLORS_MARGINS"),c.fillcolor=this.f.getCurrentUser().getColor("PREFERENCES_HIGHLIGHTCOLORS_MARGINS"),c.rect=m,b.push(c);m=this._graphicsModel.getReferenceTrimBox();if(null!==m&&!m.containsRect(f)&&this._graphicsModel.dmode!==g.diffMode.CURRENTVERSION&&(i&&("compare_difference"===e||"compare_align_result"===e||"compare_differenceMode"===e)||!i))c=new a,c.type=d.LWTYPE_DASHEDBOX,
c.dash=[10,3,2,3,2,3],c.linewidth=1,c.color=this.f.getCurrentUser().getColor("PREFERENCES_HIGHLIGHTCOLORS_MARGINS_DIFF"),c.fillcolor=this.f.getCurrentUser().getColor("PREFERENCES_HIGHLIGHTCOLORS_MARGINS_DIFF"),c.rect=m,b.push(c)}};e.prototype.getMaximumResolution=function(){return this._graphicsModel.getMaximumResolution()};e.prototype.getBackgroundOptions=function(){var a={};this._graphicsModel.page&&this._graphicsModel.page.isBlankPage()&&(a.fillStyle="rgba(255,255,255,1)");return a};return e});
define("web-viewer/graphics/GraphicsViewportWidgetController",["web-viewer/graphics/GraphicsConstants","web-viewer/graphics/GraphicsLayerModel","web-viewer/viewport/ViewportConstants","web-viewer/utils/ListenerUtil","underscore"],function(c,b,a,d,e){var l=function(a,b){this.f=a;d.mixin(this,a);this._graphicsModel=null;this.viewport=this.f.getModule("viewport");this._createdViewLayerModels={};this._shownViews=[];this.setGraphicsModel(b);this._registerListener("options.changed.PREFERENCES_HIGHLIGHTCOLORS_MARGINS_DIFF",
function(a,b){a!==b&&this._repaintViewport()},this,this.f.getCurrentUser());this._registerListener("options.changed.PREFERENCES_HIGHLIGHTCOLORS_MARGINS",function(a,b){a!==b&&this._repaintViewport()},this,this.f.getCurrentUser())};l.prototype.setGraphicsModel=function(a){this._unregisterAllListeners();this._graphicsModel=a;this._registerListener("changed.channels",this.updateTiles,this,this._graphicsModel);this._registerListener("changed.channelViewMode",this.updateTiles,this,this._graphicsModel);
this._registerListener("changed.channel.*.enabled",this.updateTiles,this,this._graphicsModel);this._registerListener("changed.channelOrder",this.updateTiles,this,this._graphicsModel);this._registerListener("changed.trimbox",this._repaintViewport,this,this._graphicsModel);this._registerListener("changed.page",function(){this.destructViews();this.updateTiles()},this,this._graphicsModel)};l.prototype.getLayerModelForChannel=function(a){var e=this._createdViewLayerModels[a.getID()];if(!e){this.viewport.createView(a.getID(),
a.getName(),!1);var e=new b(this.f,"Graphics",this._graphicsModel),d=this._graphicsModel.getSpecificChannelSelection(a);e.setOverwriteOption("color",d);this.viewport.addLayer("Graphics",e,a.getID());this._createdViewLayerModels[a.getID()]=e}return e};l.prototype.updateTiles=function(){var b=this.isTiledViewEnabled();b&&this._graphicsModel.getChannelViewMode()!==c.ChannelViewMode.COMPOSITE_VIEW&&1>=this._graphicsModel.getEnabledChannelCount()&&(b=!1);var d=this._shownViews,g=[];b&&e.each(this._graphicsModel.getChannels(),
function(a){if(a.isEnabled()&&(!this._graphicsModel.isInDifferenceCompareMode()||!a.isInPreviousAndMatchedWithCurrent()))d=e.without(d,a.getID()),g.push(a)},this);e.each(d,function(a){this.viewport.toggleView(a,!1)},this);this._shownViews=[];e.each(g,function(a){var b=this.getLayerModelForChannel(a),e=[a];if(this._graphicsModel.isInDifferenceCompareMode()&&a.isInCurrentAndMatchedToPrevious()){var d=this._graphicsModel.getMatchedChannel(a);d&&e.push(d)}b.setOverwriteOption("color",this._graphicsModel.getChannelSelection(e));
this._shownViews.push(a.getID());this.viewport.toggleView(a.getID(),!0)},this);if(b){var l=[];e.each(g,function(a){l.push(a.getID())});this.viewport.setViewsOrder(l)}this.f.emit("viewport.toggleAnimation","tiledMode",!b);this.viewport.setViewsLayoutMode(a.ViewsLayoutMode[c.ChannelViewModeLayoutMode[e.invert(c.ChannelViewMode)[this._graphicsModel.getChannelViewMode()]]])};l.prototype.isTiledViewEnabled=function(){return this._graphicsModel.getChannelViewMode()!==c.ChannelViewMode.COMPOSITE_VIEW};l.prototype._repaintViewport=
function(){this.f.emit("viewport.repaint")};l.prototype.destructViews=function(){e.each(this._createdViewLayerModels,function(a,b){this.viewport.removeView(b);a.destroy()},this);this._createdViewLayerModels={}};return l});
define("web-viewer/graphics/ChannelMatchingModel",["web-viewer/core/PrivateChannel","web-viewer/graphics/GraphicsConstants","jquery","underscore"],function(c,b){var a=function(a,e){c.installTo(this,a,"channelMatchingModel");this._currentChannels={};this._referenceChannels={};this._currentChannelMatching=a.getCurrentUser().getOption("PREFERENCES_COLORMATCHING");this._currentMatchedChannels=[];this._referenceMatchedChannels=[];this._isCurrentChannelActive=[];this._stayMatchedCurrentChannels=[];this._stayMatchedReferenceChannels=
[];this._isChannelMatchingPersisted=this._currentChannelMatching!==b.SMART_NAME_MATCHING;this.setChannels(e)};a.prototype.getCurrentChannel=function(a){return this._currentChannels[a]};a.prototype.getReferenceChannel=function(a){return this._referenceChannels[a]};a.prototype.getCurrentChannels=function(){return _.reject(this._currentChannels,function(a,b){return _.contains(this._currentMatchedChannels,parseInt(b,10))},this)};a.prototype.getReferenceChannels=function(){return _.reject(this._referenceChannels,
function(a,b){return _.contains(this._referenceMatchedChannels,parseInt(b,10))},this)};a.prototype.hasUnmatchedChannels=function(){return 0!==this.getCurrentChannels().length&&0!==this.getReferenceChannels().length};a.prototype.getMatchedCurrentChannels=function(){return _.map(this._currentMatchedChannels,_.bind(function(a){return this._currentChannels[a]},this))};a.prototype.getMatchedReferenceChannels=function(){return _.map(this._referenceMatchedChannels,_.bind(function(a){return this._referenceChannels[a]},
this))};a.prototype.getIsCurrentChannelActive=function(){return this._isCurrentChannelActive};a.prototype.setIsChannelMatchingPersisted=function(a){this._isChannelMatchingPersisted=a};a.prototype.isChannelMatchingPersisted=function(){return this._isChannelMatchingPersisted};a.prototype.setChannelActive=function(a){-1!==_.indexOf(this._currentMatchedChannels,a)?this._isCurrentChannelActive[_.indexOf(this._currentMatchedChannels,a)]=!0:-1!==_.indexOf(this._referenceMatchedChannels,a)&&(this._isCurrentChannelActive[_.indexOf(this._referenceMatchedChannels,
a)]=!1)};a.prototype.getChannelMatching=function(){return this._currentChannelMatching};a.prototype.setChannelMatching=function(a){this._currentChannelMatching=a};a.prototype.resetChannelMatching=function(){this._currentMatchedChannels=[];this._referenceMatchedChannels=[];this._isCurrentChannelActive=[];this._stayMatchedCurrentChannels=[];this._stayMatchedReferenceChannels=[]};a.prototype.setMatchedCurrentChannels=function(a){this._currentMatchedChannels=this._stayMatchedCurrentChannels.slice(0);
this._currentMatchedChannels=_.union(this._currentMatchedChannels,_.map(a,function(a){return parseInt(a,10)}))};a.prototype.setMatchedReferenceChannels=function(a){this._referenceMatchedChannels=this._stayMatchedReferenceChannels.slice(0);this._referenceMatchedChannels=_.union(this._referenceMatchedChannels,_.map(a,function(a){return parseInt(a,10)}))};a.prototype.setChannelMatch=function(a,b,c,i){void 0===c&&(c=!1);if(_.contains(this._currentMatchedChannels,a)){var j=_.indexOf(this._currentMatchedChannels,
a);this._referenceMatchedChannels[j]=b;this._isCurrentChannelActive[j]=c;i&&!_.contains(this._stayMatchedCurrentChannels,a)&&this._stayMatchedCurrentChannels.push(a)}else _.contains(this._referenceMatchedChannels,b)?(j=_.indexOf(this._referenceMatchedChannels,b),this._currentMatchedChannels[j]=a,this._isCurrentChannelActive[j]=c,i&&!_.contains(this._stayMatchedReferenceChannels,b)&&this._stayMatchedReferenceChannels.push(b)):(this._currentMatchedChannels.push(a),this._referenceMatchedChannels.push(b),
this._isCurrentChannelActive.push(c),i&&(_.contains(this._stayMatchedCurrentChannels,a)||this._stayMatchedCurrentChannels.push(a),_.contains(this._stayMatchedReferenceChannels,b)||this._stayMatchedReferenceChannels.push(b)))};a.prototype.orderMatchedChannels=function(){var a=this._stayMatchedCurrentChannels.slice(0),b=this._stayMatchedReferenceChannels.slice(0);_.each(this._currentMatchedChannels,_.bind(function(b){_.contains(a,b)||a.push(b)},this));_.each(this._referenceMatchedChannels,_.bind(function(a){_.contains(b,
a)||b.push(a)},this));this._currentMatchedChannels=a;this._referenceMatchedChannels=b};a.prototype.getStayMatchedCurrentChannels=function(){return this._stayMatchedCurrentChannels};a.prototype.getStayMatchedReferenceChannels=function(){return this._stayMatchedReferenceChannels};a.prototype.setChannels=function(a){this._referenceChannels={};this._currentChannels={};this._currentMatchedChannels=[];this._referenceMatchedChannels=[];this._isCurrentChannelActive=[];this._stayMatchedCurrentChannels=[];
this._stayMatchedReferenceChannels=[];void 0===a&&(a=[]);_.each(a,_.bind(function(a){a=a.copy();a.getDiffMode()===b.ChannelDiffMode.CURRENT||a.getDiffMode()===b.ChannelDiffMode.IN_CURRENT_AND_MATCHED_WITH_PREVIOUS?this._currentChannels[a.getViewserverID()]=a:this._referenceChannels[a.getViewserverID()]=a},this))};return a});
define("tpl!web-viewer/graphics/ChannelMatchingPopup",function(){return function(c){var b,a="",a=a+('<div class="channelMatchingSettings">\r\n\t<h2>'+(null==(b=c.i18n("channelMatchingSettings"))?"":_.escape(b))+'</h2>\r\n\t<div class="channelMatchingSetting"><input type="radio" name="channelMatching" value="0" ');0===c.channelMatching&&(a+=" checked ");a+=" /> "+(null==(b=c.i18n("MapChanAuto0"))?"":_.escape(b))+' </div>\r\n\t<div class="channelMatchingSetting"><input type="radio" name="channelMatching" value="1" ';
1===c.channelMatching&&(a+=" checked ");a+=" /> "+(null==(b=c.i18n("MapChanAuto1"))?"":_.escape(b))+' </div>\r\n\t<div class="channelMatchingSetting"><input type="radio" name="channelMatching" value="2" ';2===c.channelMatching&&(a+=" checked ");a+=" /> "+(null==(b=c.i18n("MapChanAuto2"))?"":_.escape(b))+' </div>\r\n\t\r\n\t<div class="channelMatchingSetDefault"><input type="checkbox" name="saveChannelMatchingAsDefault" ';c.isChannelMatchingPersisted&&(a+="checked");a+=" />"+(null==(b=c.i18n("MapChanAutoDefault"))?
"":_.escape(b))+'</div>\r\n</div>\r\n\r\n<div class="channelMatchingTitles">\r\n\t<div class="channelMatchingTitle">\r\n\t\t'+(null==(b=c.i18n("matchedChannelsTitle"))?"":_.escape(b))+'\r\n\t</div>\r\n</div>\r\n\r\n<div class="channelMatchingTables">\r\n\r\n<ul class="channelMatchingList sortableCurrent">\r\n\t<li class="channelMatchingTitle">'+(null==(b=c.i18n("currentChannelsTitle"))?"":_.escape(b))+"</li>\r\n";_.each(c.currentChannels,function(c){a+='\r\n\t<li class="dragAndDropChannel" data-bind="'+
(null==(b=c.getViewserverID())?"":_.escape(b))+'">\r\n\t\t<span><i class="colorBox" style="background: #'+(null==(b=c.getHexRGB())?"":_.escape(b))+';"></i></span> \r\n\t\t<span class="channelName">'+(null==(b=c.getName())?"":_.escape(b))+" </span>\r\n\t</li>\r\n"});a+='\r\n</ul>\r\n\r\n<ul class="channelMatchingList sortableCurrentMatched">\r\n\t<li class="channelMatchingTitle">'+(null==(b=c.i18n("CaptionCurrent"))?"":_.escape(b))+"</li>\r\n";_.each(c.matchedCurrentChannels,function(d,e){a+='\r\n\t<li class="dragAndDropChannel ';
c.isMatchedChannelClickable[e]&&(a+="clickable ",c.currentMatchedChannelActive[e]&&(a+="matchedChannelActive"));a+=" ";a=_.contains(c.stayMatchedCurrentChannels,d.getViewserverID())?a+"stayMatched":a+"";a+='" data-bind="'+(null==(b=d.getViewserverID())?"":_.escape(b))+'">\r\n\t\t<span><i class="colorBox" style="background: #'+(null==(b=d.getHexRGB())?"":_.escape(b))+';"></i></span> \r\n\t\t<span class="channelName">'+(null==(b=d.getName())?"":_.escape(b))+" </span>\r\n\t</li>\r\n"});a+='\r\n</ul>\r\n\r\n<ul class="channelMatchingList sortableReferenceMatched">\r\n\t<li class="channelMatchingTitle">'+
(null==(b=c.i18n("CaptionPrevious"))?"":_.escape(b))+"</li>\r\n";_.each(c.matchedReferenceChannels,function(d,e){a+='\r\n\t<li class="dragAndDropChannel ';c.isMatchedChannelClickable[e]&&(a+="clickable ",c.currentMatchedChannelActive[e]||(a+="matchedChannelActive"));a+=" ";a=_.contains(c.stayMatchedReferenceChannels,d.getViewserverID())?a+"stayMatched":a+"";a+='" data-bind="'+(null==(b=d.getViewserverID())?"":_.escape(b))+'">\r\n\t\t<span><i class="colorBox" style="background: #'+(null==(b=d.getHexRGB())?
"":_.escape(b))+';"></i></span> \r\n\t\t<span class="channelName">'+(null==(b=d.getName())?"":_.escape(b))+" </span>\r\n\t</li>\r\n"});a+='\r\n</ul>\r\n\r\n<ul class="channelMatchingList sortableReference">\r\n\t<li class="channelMatchingTitle">'+(null==(b=c.i18n("referenceChannelsTitle"))?"":_.escape(b))+"</li>\r\n";_.each(c.referenceChannels,function(c){a+='\r\n\t<li class="dragAndDropChannel" data-bind="'+(null==(b=c.getViewserverID())?"":_.escape(b))+'">\r\n\t\t<span><i class="colorBox" style="background: #'+
(null==(b=c.getHexRGB())?"":_.escape(b))+';"></i></span> \r\n\t\t<span class="channelName">'+(null==(b=c.getName())?"":_.escape(b))+"</span>\r\n\t</li>\r\n"});return a+='\r\n</ul>\r\n</div>\r\n<div class="channelMatchingDescription">'+(null==(b=c.i18n("explenationHightlightChannels"))?"":_.escape(b))+"</div>"}});
define("web-viewer/graphics/ChannelMatchingPopup","web-viewer/core/PrivateChannel web-viewer/utils/ListenerUtil utils/ShapeUtils web-viewer/layout/component/ModalPopup Template tpl!web-viewer/graphics/ChannelMatchingPopup jquery underscore".split(" "),function(c,b,a,d,e,l,i,j){a=function(a,q,f){d.call(this,a,q,a.getContext());c.installTo(this,a,["channelMatchingPopup"]);b.mixin(this,a);a.i18n.loadBundle("viewer",j.bind(function(){this.setHeader(i("<span/>").addClass("popupTitle").html(a.i18n.t("MapChanTitle")));
this.setOkBtnText(a.i18n.t("saveChannelMatching"))},this));this.element.addClass("channelsMatchingPopup");this._channelMatchingModel=f;this.setOkAction(j.bind(function(){this._emit("channelMatchingComplete");this.hide()},this));this.t=new e(this.f.i18n,l);this.t.setContext(this._popupContent);this.t.bind("change","[name=channelMatching]",function(a){this._emit("channelMatching",a.value)},this);this.t.bind("click",".clickable",j.bind(function(a){this._emit("matchedChannelClicked",parseInt(a.getAttribute("data-bind"),
10))},this));this.t.bind("change","[name=saveChannelMatchingAsDefault]",j.bind(function(a){this._emit("persistDefaultChannelMatching",a.checked)},this));this._registerListener("modelChanged",this.render,this,this._channelMatchingModel)};a.prototype=Object.create(d.prototype);a.prototype.constructor=a;a.prototype.render=j.throttle(function(){this.t.d.currentChannels=this._channelMatchingModel.getCurrentChannels();this.t.d.referenceChannels=this._channelMatchingModel.getReferenceChannels();this.t.d.matchedCurrentChannels=
this._channelMatchingModel.getMatchedCurrentChannels();this.t.d.matchedReferenceChannels=this._channelMatchingModel.getMatchedReferenceChannels();this.t.d.channelMatching=this._channelMatchingModel.getChannelMatching();this.t.d.currentMatchedChannelActive=this._channelMatchingModel.getIsCurrentChannelActive();this.t.d.stayMatchedCurrentChannels=this._channelMatchingModel.getStayMatchedCurrentChannels();this.t.d.stayMatchedReferenceChannels=this._channelMatchingModel.getStayMatchedReferenceChannels();
this.t.d.isChannelMatchingPersisted=this._channelMatchingModel.isChannelMatchingPersisted();this.t.d.isMatchedChannelClickable=j.map(this.t.d.matchedCurrentChannels,j.bind(function(a,b){return void 0!==this.t.d.matchedReferenceChannels[b]&&!a.equals(this.t.d.matchedReferenceChannels[b])},this));this.t.render();var a=this._popupContent.find(".sortableCurrentMatched").sortable({items:"li.dragAndDropChannel:not(.stayMatched)",connectWith:".sortableCurrent",receive:function(a,b){b.item.addClass("clickable")},
remove:function(a,b){b.item.removeClass("clickable")},update:j.bind(function(a,b){var c=this._popupContent.find(".sortableCurrentMatched").sortable("toArray",{attribute:"data-bind"}),e=!1;null!==b.sender&&(e=!0);this.recalculateSize();this._emit("currentChannelMatch",b.item.context.getAttribute("data-bind"),c,e)},this)}),b=this._popupContent.find(".sortableReferenceMatched").sortable({items:"li.dragAndDropChannel:not(.stayMatched)",connectWith:".sortableReference",receive:function(a,b){b.item.addClass("clickable")},
remove:function(a,b){b.item.removeClass("clickable")},update:j.bind(function(a,b){var c=this._popupContent.find(".sortableReferenceMatched").sortable("toArray",{attribute:"data-bind"}),e=!1;null!==b.sender&&(e=!0);this.recalculateSize();this._emit("referenceChannelMatch",b.item.context.getAttribute("data-bind"),c,e)},this)});this._popupContent.find(".sortableCurrent").sortable({items:"li.dragAndDropChannel",connectWith:a,stop:j.bind(this.render,this)});this._popupContent.find(".sortableReference").sortable({items:"li.dragAndDropChannel",
connectWith:b,stop:j.bind(this.render,this)})},40);a.prototype.show=function(){this.render();d.prototype.show.call(this)};return a});
define("web-viewer/graphics/ChannelMatchingController","web-viewer/utils/ListenerUtil web-viewer/graphics/ChannelMatchingModel web-viewer/graphics/ChannelMatchingPopup web-viewer/graphics/GraphicsConstants jquery underscore".split(" "),function(c,b,a,d){b=function(a,b,d,j){c.mixin(this,a);this.f=a;this.channelMatchingPopup=b;this.channelMatchingModel=d;this._graphicsModel=j;this._matchChannels(this.channelMatchingModel.getChannelMatching());this._registerListener("currentChannelMatch",this._currentChannelMatchingChanged,
this,this.channelMatchingPopup);this._registerListener("referenceChannelMatch",this._referenceChannelMatchingChanged,this,this.channelMatchingPopup);this._registerListener("channelMatching",this._matchChannels,this,this.channelMatchingPopup);this._registerListener("channelMatchingComplete",_.bind(function(){this._completeChannelMatching(!0)},this),this,this.channelMatchingPopup);this._registerListener("matchedChannelClicked",this._activateMatchedChannel,this,this.channelMatchingPopup);this._registerListener("persistDefaultChannelMatching",
this._persistChannelMatching,this,this.channelMatchingPopup)};b.prototype._currentChannelMatchingChanged=function(a,b,c){this.channelMatchingModel.setMatchedCurrentChannels(b);c||this.channelMatchingModel.getCurrentChannel(parseInt(a,10)).resetToDefault();this.channelMatchingPopup.render()};b.prototype._referenceChannelMatchingChanged=function(a,b,c){this.channelMatchingModel.setMatchedReferenceChannels(b);c||this.channelMatchingModel.getReferenceChannel(parseInt(a,10)).resetToDefault();this.channelMatchingPopup.render()};
b.prototype._persistChannelMatching=function(a){a?this.f.getCurrentUser().setOption("PREFERENCES_COLORMATCHING",this.channelMatchingModel.getChannelMatching()):this.f.resetOption("PREFERENCES_COLORMATCHING");this.channelMatchingModel.setIsChannelMatchingPersisted(a)};b.prototype.setChannels=function(a){this.channelMatchingModel.setChannels(a);this._matchChannels(this.channelMatchingModel.getChannelMatching());this._completeChannelMatching(!1)};b.prototype._matchChannels=function(a){this.channelMatchingModel.resetChannelMatching();
a=parseInt(a,10);this.channelMatchingModel.setChannelMatching(a);var b=this.channelMatchingModel.getCurrentChannels(),c=this.channelMatchingModel.getReferenceChannels();_.each(b,function(b){var g=void 0;a===d.ChannelMatching.SMART_NAME_MATCHING&&(g=_.find(c,function(a){return this._canChannelsBeMatched(b,a,d.ChannelMatching.NAME_MATCHING)},this));void 0===g&&(g=_.find(c,function(f){return this._canChannelsBeMatched(b,f,a)},this));if(void 0!==g){var l=this._canChannelsBeMatched(b,g,a,!0);this.channelMatchingModel.setChannelMatch(b.getViewserverID(),
g.getViewserverID(),!0,l)}},this);this.channelMatchingModel.orderMatchedChannels();this.channelMatchingPopup.render();this._persistChannelMatching(this.channelMatchingModel.isChannelMatchingPersisted())};b.prototype._canChannelsBeMatched=function(a,b,c,j){var g=a.getNameWithoutSuffix(),q=b.getNameWithoutSuffix();j&&(g=a.getOriginalName(),q=b.getOriginalName());if(c===d.ChannelMatching.SMART_NAME_MATCHING){g=g.replace(/process\s*/i,"").replace(/pantone\s*/i,"");q=q.replace(/process\s*/i,"").replace(/pantone\s*/i,
"");if(g.toLowerCase()===q.toLowerCase())return!0;g=g.replace(/cyan/i,"c").replace(/magenta/i,"m").replace(/yellow/i,"y").replace(/black/i,"k");q=q.replace(/cyan/i,"c").replace(/magenta/i,"m").replace(/yellow/i,"y").replace(/black/i,"k");return g.toLowerCase()===q.toLowerCase()?!0:!1}if(c===d.ChannelMatching.NAME_MATCHING)return g.toLowerCase()===q.toLowerCase()?!0:!1;if(c===d.ChannelMatching.IDENTICAL_MATCHING)return g.toLowerCase()===q.toLowerCase()&&j&&a.equalsOriginalDef(b)?!0:g.toLowerCase()===
q.toLowerCase()&&!j&&a.equals(b)?!0:!1};b.prototype._completeChannelMatching=function(a){this._graphicsModel.resetChannelMatching();var b=this.channelMatchingModel.getMatchedCurrentChannels(),c=this.channelMatchingModel.getMatchedReferenceChannels(),d=this.channelMatchingModel.getIsCurrentChannelActive();_.each(b,_.bind(function(a,b){var f=c[b],e=d[b];void 0!==f?(this._graphicsModel.setChannelMatching(a.getID(),f.getID()),e?(a.isChanged()||this._graphicsModel.getChannel(a.getID()).resetToDefault(),
this._graphicsModel.changeChannelDef(f.getID(),a.getID(),!1)):(f.isChanged()||this._graphicsModel.getChannel(f.getID()).resetToDefault(),this._graphicsModel.changeChannelDef(a.getID(),f.getID(),!1))):this._graphicsModel.changeChannelDef(a.getID(),a.getID(),!0)},this));a&&(a=this.channelMatchingModel.getCurrentChannels(),b=this.channelMatchingModel.getReferenceChannels(),_.each(a,_.bind(function(a){this._graphicsModel.resetChannel(a.getID())},this)),_.each(b,_.bind(function(a){this._graphicsModel.resetChannel(a.getID())},
this)))};b.prototype._activateMatchedChannel=function(a){this.channelMatchingModel.setChannelActive(a);this.channelMatchingPopup.render()};return b});
define("web-viewer/graphics/AbstractGraphicsModule","web-viewer/core/AbstractModule web-viewer/graphics/GraphicsDataExtensions web-viewer/graphics/ChannelsWidget web-viewer/graphics/GraphicsLayerModel web-viewer/graphics/GraphicsViewportWidgetController web-viewer/graphics/ChannelMatchingModel web-viewer/graphics/ChannelMatchingPopup web-viewer/graphics/ChannelMatchingController web-viewer/layout/component/ModalPopup web-viewer/graphics/GraphicsConstants underscore jquery".split(" "),function(c,b,
a,d,e,l,i,j,g,q,f,n){var k=function(a,e){c.call(this,a,e,"graphics");b(a);this.channelMatchingController=this.channelMatchingModel=this.channelMatchingPopup=this.channelsWidget=this.graphicsLayerModel=this.graphicsModel=this.graphicsViewportWidgetController=null;this.isChannelMatchingActive=!1;this.nonMatchedChannelsPopup=null;this._waitingForParameterUpdate=this.isGraphicsActive=!1;this.f.on("intercept.fragmentURL",f.bind(this._interceptFragmentURL,this));this.f.on("module.compare.changed.diffMode",
f.bind(function(a,b){this.graphicsModel&&this.graphicsModel.setCompareMode(b)},this));f.defer(f.bind(function(){this.f.getDocumentController().whenParametersAvailable(function(){this._whenParametersAvailable();this.f.getDocumentController().whenActiveOrDifferencePageChanged(this._whenActiveOrDifferencePageChanged,this)},this)},this))};k.prototype=Object.create(c.prototype);k.prototype.constructor=k;k.prototype._whenActiveOrDifferencePageChanged=function(){var a=this.f.getDocumentController();this._waitingForParameterUpdate||
(a.isParameterUpdateOngoing()?(this.f.getDocumentController().once("parameters.afterEndUpdate",f.bind(this._whenParametersAvailable,this)),this._waitingForParameterUpdate=!0):this._whenParametersAvailable())};k.prototype._whenParametersAvailable=function(){this._waitingForParameterUpdate=!1;var b,c=this.f.getActivePage(),n=this.f.getDocumentController().getDifferencePage();c&&(c.hasGraphics()||n&&n.hasGraphics()||c.isBlankPage()?(null==this.graphicsModel?(this.graphicsModel=this._createGraphicsModel(this.f,
[this.getPrivateChannelName(),"model"],c,n),this.graphicsLayerModel=new d(this.f,"Graphics",this.graphicsModel)):((this.graphicsModel.getPage()!=c||!this.isGraphicsActive)&&this.graphicsViewportWidgetController&&this.graphicsViewportWidgetController.destructViews(),this.graphicsModel.setPage(c,n),this.isChannelMatchingActive&&(b=this.graphicsModel.getAllChannels(),this.channelMatchingController.setChannels(b),void 0!==c&&(void 0!==n&&null===this.nonMatchedChannelsPopup)&&this.showChannelMatchingPopupIfNeeded())),
(b=this.f.getModule("compare"))&&this.graphicsModel.setCompareMode(b.getDiffMode()),this.isGraphicsActive||(this.f.getModule("viewport").addLayer("Graphics",this.graphicsLayerModel,"Main"),this.isGraphicsActive=!0),null==this.graphicsViewportWidgetController&&(this.graphicsViewportWidgetController=new e(this.f,this.graphicsModel),this.graphicsViewportWidgetController.updateTiles()),this.channelsWidget?this.channelsWidget.setEnabled(!0):this._publishWidget(a.widgetName,f.bind(function(){return this.channelsWidget=
new a(this.f,this.graphicsModel)},this))):(this.f.getModule("viewport").removeLayer("Graphics","Main"),this.graphicsModel.getPage()!=c&&this.graphicsViewportWidgetController&&this.graphicsViewportWidgetController.destructViews(),this.graphicsModel.setPage(void 0,void 0),this.isGraphicsActive=!1,this.channelsWidget&&this.channelsWidget.setEnabled(!1),this.graphicsModel.setChannelViewMode(q.ChannelViewMode.COMPOSITE_VIEW)),c.isReaderSpread()?this.channelsWidget&&this.channelsWidget.hideChannelMatchingBtn():
void 0!==c&&void 0!==n&&c.hasGraphics()&&n.hasGraphics()?(this.isChannelMatchingActive=!0,b=this.graphicsModel.getAllChannels(),null===this.channelMatchingModel&&(this.channelMatchingModel=new l(this.f,b)),null===this.channelMatchingPopup&&(this.channelMatchingPopup=new i(this.f,"channelMatchingPopup",this.channelMatchingModel)),null===this.channelMatchingController&&(this.channelMatchingController=new j(this.f,this.channelMatchingPopup,this.channelMatchingModel,this.graphicsModel)),this.channelMatchingController.setChannels(b),
this.showChannelMatchingPopupIfNeeded(),this.channelsWidget&&this.channelsWidget.showChannelMatchingBtn(f.bind(this.showChannelMatchingPopup,this))):this.isChannelMatchingActive&&(this.isChannelMatchingActive=!1,this.nonMatchedChannelsPopup&&this.nonMatchedChannelsPopup.remove(),this.nonMatchedChannelsPopup=null,this.channelsWidget&&this.channelsWidget.hideChannelMatchingBtn()))};k.prototype.showChannelMatchingPopupIfNeeded=function(){void 0!==this.channelMatchingModel&&(this.channelMatchingModel.hasUnmatchedChannels()&&
!this.f.isMobile())&&(null===this.nonMatchedChannelsPopup&&(this.nonMatchedChannelsPopup=new g(this.f,"nonMatchingChannelsPopup",this.f.getContext())),this.f.i18n.loadBundle("viewer",f.bind(function(){this.nonMatchedChannelsPopup.setContent(n("<div>").addClass("nonMatchingChannelsDialog").html(this.f.i18n.t("DocumentListWarning")));this.nonMatchedChannelsPopup.setOkBtnText(this.f.i18n.t("startChannelMatching"));this.nonMatchedChannelsPopup.setHeader(n("<span/>").addClass("popupTitle").html(this.f.i18n.t("MapChanTitle")))},
this)),this.nonMatchedChannelsPopup.setOkAction(f.bind(function(){this.channelMatchingPopup.show();this.nonMatchedChannelsPopup.hide()},this)),this.nonMatchedChannelsPopup.show(),this.nonMatchedChannelsPopup.recalculateSize(820))};k.prototype.getGraphicsModel=function(){return this.graphicsModel};k.prototype.getChannelSelectionForDiffMode=function(a){if(null!==this.graphicsModel)return this.graphicsModel.getChannelSelectionForDiffMode(a)};k.prototype.showChannelMatchingPopup=function(){var a=this.graphicsModel.getAllChannels();
this.channelMatchingController.setChannels(a);this.channelMatchingPopup.show()};k.prototype.getState=function(){if(null!==this.graphicsModel){var a={};f.each(this.graphicsModel.getAllChannels(),function(b){var f={enabled:b.isEnabled(),displayedRgb:b.getRGB(),isOpaque:b.isChannelOpaque()};a[b.getID()]=f},this);var b={graphicsModel:{channelViewMode:this.graphicsModel.getChannelViewMode(),channelKeysOrder:this.graphicsModel.getChannelKeysOrder(),singleChannelMode:this.graphicsModel.getSingleChannelMode(),
channels:a}};null!==this.channelMatchingModel&&(b.channelMatchingModel={channelMatching:this.channelMatchingModel.getChannelMatching()});return b}};k.prototype.setState=function(a){this.f.whenModuleAvailable("graphics",function(){null===this.graphicsModel&&(this.graphicsModel=this._createGraphicsModel(this.f.getDocumentController().getActivePage(),this.f.getDocumentController().getDifferencePage()),this.graphicsLayerModel=new d(this.f,"Graphics",this.graphicsModel));if(void 0!==a){var b=a.graphicsModel;
if(void 0!==b){this.graphicsModel.setChannelViewMode(b.channelViewMode);this.graphicsModel.setChannelOrder(b.channelKeysOrder);this.graphicsModel.setSingleChannelMode(b.singleChannelMode);var c=b.channels;f.each(this.graphicsModel.getAllChannels(),function(a){var a=a.getID(),b=c[a];void 0!==b&&(this.graphicsModel.toggleChannel(a,b.enabled),this.graphicsModel.setChannelOpaque(a,b.isOpaque),this.graphicsModel.changeChannelRgb(a,b.displayedRgb))},this)}b=a.channelMatchingModel;null!==b&&void 0!==b&&
(null===this.channelMatchingModel&&(this.channelMatchingModel=new l(this.f,void 0)),this.channelMatchingModel.setChannelMatching(b.channelMatching))}},this)};k.prototype.getChannelSelection=function(){var a={};f.each(this.graphicsModel.getAllChannels(),function(b){a[b.getID()]=b.isEnabled()});return a};k.prototype.setChannelSelection=function(a){f.each(a,function(a,b){this.graphicsModel.toggleChannel(b,a)},this)};k.prototype.setChannelViewMode=function(a){this.graphicsModel.setChannelViewMode(a)};
k.prototype.getChannelViewMode=function(){return this.graphicsModel.getChannelViewMode()};k.prototype.setShowTrimbox=function(a,b){this.graphicsModel&&this.graphicsModel.setShowTrimbox(a,b)};k.prototype._interceptFragmentURL=function(){throw"Not Implemented";};k.prototype._setTrimboxInformation=function(){throw"Not Implemented";};k.prototype._createGraphicsModel=function(){throw"Not Implemented";};return k});
define("web-viewer/graphics/AbstractGraphicsModel","web-viewer/core/PrivateChannel web-viewer/core/AbstractModel utils/ShapeUtils web-viewer/utils/ViewerUtils web-viewer/graphics/GraphicsConstants utils/OrderedObject web-viewer/compare/CompareConstants web-viewer/viewControls/ViewControlsConstants underscore".split(" "),function(c,b,a,d,e,l,i,j,g){function q(a,b){this.page=a;this.difference=b}q.prototype.equals=function(a){return this.page&&this.difference?this.page.equals(a.page)&&this.difference.equals(a.difference):
this.page===a.page&&this.difference===a.difference};c=function(a,c,d,g){b.call(this,a,c);this.f=a;this.difference=this.page=null;this.dmode=0;if(a=this.f.getModule("compare"))this.dmode=a.getDiffMode();this._channels=new l;this._defaultOrder=null;this._trimboxMode=1===this.f.getOption("PREFERENCES_DISPLAY_MARGINS")?this.f.getOption("PREFERENCES_MARGIN_DISPLAY_MODE"):null;this._reverseChannelOrder=!1;this.allowServerDeepZoom=!0;this.channelViewMode=e.ChannelViewMode.COMPOSITE_VIEW;this.singleChannelMode=
this.f.getOption("PREFERENCES_CHANNELS_SINGESEPBLACK");this.setPage(d,g,!0)};c.prototype=Object.create(b.prototype);c.prototype.constructor=c;c.prototype.getTrimBox=function(){var b=this.page.getTrimboxRect();if(this.page.isReaderSpread()&&this.page.isBlankPage()&&this.page.get("isRightPage")&&this.difference){var c=this.difference.getTrimboxRect().size.width+this.difference.getMargins().left-this.page.getMargins().left;b.origin.offset(new a.Size(c,0))}else this.page.isReaderSpread()&&(this.page.isBlankPage()&&
this.page.get("isRightPage"))&&b.origin.offset(new a.Size(this.page.getPageSize().width,0));return b};c.prototype.getReferenceTrimBox=function(){if(this.difference&&!(this.page.isReaderSpread()&&this._trimboxMode===j.trimboxMode.ONCURRENTPAGE)){var b=this.difference.getTrimboxRect();if(this.difference.isBlankPage()&&!this.page.get("isRightPage")&&this.page){var c=this.page.getTrimboxRect().size.width+this.page.getMargins().left-this.difference.getMargins().left;b.origin.offset(new a.Size(c,0))}return b}return null};
c.prototype.setPage=function(a,b,c){var e=new q(this.page,this.difference);this.page=a;this.difference=b;b=new q(this.page,this.difference);void 0!==a&&this.initChannels(e,b,c);this._fireChange(c,["page"],e,b)};c.prototype.getPage=function(){return this.page};c.prototype.getReferencePage=function(){return this.difference};c.prototype.initChannels=function(a,b,c){function e(a){d.push(a.getID());var b=a.copy();b.toggle(!0);if(a=this._channels.getItemByKey(a.getID()))b.toggle(a.isEnabled()),b.setOpaque(a.isChannelOpaque()),
b.setRgb(a.getRGB()),b.setName(a.getNameWithoutSuffix());this._channels.addOrReplaceItem(b.getID(),b)}var a=this.getChannels(),d=[];g.each(this.page.getChannels(!0),e,this);this.difference&&g.each(this.difference.getChannels(!0),e,this);this._channels.omitOthers(d);if(this.difference)for(b=0;b<this._channels.getLength();b++){var l=this._channels.getItemByIndex(b);if(l.isInCurrentAndMatchedToPrevious()){var i=this.getMatchedChannel(l);i&&this._toggleChannel(i,l.isEnabled())}}this._defaultOrder=this._channels.getKeys().slice(0);
this._fireChange(c,["channels"],a,this.getChannels())};c.prototype.getChannel=function(a){return this._channels.getItemByKey(a)};c.prototype.hasChanges=function(){return g.some(this.getChannels(),function(a){return a.isChanged()})||!this.hasDefaultOrder()?!0:!1};c.prototype.hasDefaultOrder=function(){for(var a=this._channels.getKeys().slice(0),b=this._defaultOrder.length;b--;)if(a[b]!==this._defaultOrder[b])return!1;return!0};c.prototype.toggleChannel=function(a,b,c){var a=this.getChannel(a),e=this.getMatchedChannel(a);
this._toggleChannel(a,b,c);null!==e&&this._toggleChannel(e,b,c)};c.prototype._toggleChannel=function(a,b,c){var e=a.isEnabled();a.toggle(b);this._fireChange(c,["channel",a.getID(),"enabled"],e,b,a.getID())};c.prototype.getMatchedChannel=function(a){if(a.isMatched())for(var b=0;b<this._channels.getLength();b++){var c=this._channels.getItemByIndex(b);if(c!==a&&c.getViewserverID()===a.getMatchedChannelServerId())return c}return null};c.prototype.isChannelEnabled=function(a){return this._channels.getItemByKey(a).isEnabled()};
c.prototype.getSpecificChannelSelection=function(a){return this.getChannelSelection([a])};c.prototype.getChannelSelection=function(){throw"Not Implemented: GraphicsModel.getChannelSelection";};c.prototype.getChannelSelectionForDiffMode=function(a){var b=[];g.each(this.getChannels(!1,a),function(a){a.isEnabled()&&b.push(a)});return this.getChannelSelection(b)};c.prototype.getSingleChannelMode=function(){return this.singleChannelMode};c.prototype.setSingleChannelMode=function(a){var b=this.getSingleChannelMode();
b!=a&&(this.singleChannelMode=a,this.f.getCurrentUser().setOption("PREFERENCES_CHANNELS_SINGESEPBLACK",a),this._fireChange(!1,["singleChannelMode"],b,a))};c.prototype.getDisabledChannels=function(){var a=this._channels.getOrderedObjectList();return g.difference(a,this.getChannels())};c.prototype.getAllChannels=function(){return this._channels.getOrderedObjectList()};c.prototype.getChannels=function(a,b){var c=this._channels.getOrderedObjectList();void 0===b&&(b=this.dmode);return g.filter(c,function(c){return b===
i.diffMode.SHOWBOTHCHANGES||b===i.diffMode.SHOWBOTHCHANGESHIGHLIGHT||b===i.diffMode.SHOWBOTHCHANGESONLY||b===i.diffMode.SHOWBOTHSIDEBYSIDE||b===i.diffMode.SHOWBOTHONTOP||b===i.diffMode.READERSPREAD||b===i.diffMode.SHOWBOTHSIDEBYSIDEHIGHLIGHT||b===i.diffMode.SHOWBOTHSIDEBYSIDECHANGESONLY?a?!c.isInPreviousAndMatchedWithCurrent():!0:b===i.diffMode.DIFFVERSION?null===c.getDiffMode()||c.getDiffMode()===e.ChannelDiffMode.PREVIOUS||c.getDiffMode()===e.ChannelDiffMode.IN_PREVIOUS_AND_MATCHED_WITH_CURRENT:
null===c.getDiffMode()||c.getDiffMode()===e.ChannelDiffMode.CURRENT||c.getDiffMode()===e.ChannelDiffMode.IN_CURRENT_AND_MATCHED_WITH_PREVIOUS},this)};c.prototype.setChannelViewMode=function(a){if(this.channelViewMode!=a){var b=this.channelViewMode;this.channelViewMode=a;this._fireChange(!1,["channelViewMode"],b,this.channelViewMode)}};c.prototype.getChannelViewMode=function(){return this.channelViewMode};c.prototype.getSelectedChannels=function(){return g.filter(this.getChannels(),function(a){return a.isEnabled()})};
c.prototype.getFirstSelectedChannel=function(){return g.find(this.getChannels(),function(a){return a.isEnabled()})};c.prototype.hasEnabledChannelGaps=function(){for(var a=!1,b=!1,c=this.getChannels(),e=0;e<c.length;e++){var d=c[e];if(0<e)if(!a&&b&&!d.isEnabled())a=!0;else if(a&&d.isEnabled())return!0;b=d.isEnabled()}return!1};c.prototype.getEnabledChannelCount=function(a){return g.reduce(this.getChannels(a),function(a,b){b.isEnabled()&&a++;return a},0)};c.prototype.getChannelCount=function(){return this._channels.getLength()};
c.prototype.moveChannelTo=function(a,b){var c=this._channels.getKeys().slice(0);this._channels.moveItemByKeyToIndex(a,b);this._fireChange(!1,["channelOrder"],c,this._channels.getKeys())};c.prototype.resetDefaultChannelOrder=function(){var a=this._channels.getKeys().slice(0);this._channels.setOrder(this._defaultOrder);this._fireChange(!1,["channelOrder"],a,this._channels.getKeys())};c.prototype.resetAllChannelsColorDef=function(){g.each(this.getChannels(),g.bind(function(a){this.resetChannel(a.getID())},
this))};c.prototype.hasVisibleOpaqueChannels=function(){return g.some(this.getChannels(),function(a){return a.isEnabled()&&a.isChannelOpaque()})};c.prototype.setChannelOrder=function(a){var b=this._channels.getKeys().slice(0),c=b.slice(0);this.getChannels().length===a.length&&g.each(this.getChannels(),function(e,d){if(g.indexOf(a,0<=e.getID())){var l=g.indexOf(b,e.getID());c[l]=a[d]}else c=null});null!==c&&(this._channels.setOrder(c),this._fireChange(!1,["channelOrder"],b,this._channels.getKeys()))};
c.prototype.setReverseChannelOrder=function(a){this._reverseChannelOrder=a};c.prototype.getChannelKeysOrder=function(){return this._channels.getKeys()};c.prototype.getChannelAtIndex=function(a){return this._channels.getItemByIndex(a)};c.prototype.resetChannel=function(a){var a=this.getChannel(a),b=a.copy();a.resetToDefault();this._fireChange(!1,["channel",a.getID(),"channelRGB"],b,a,a.isEnabled(),a.getID())};c.prototype.getNextChannel=function(a){return this._channels.getNext(a)};c.prototype.hasNextChannel=
function(a){return this._channels.hasNext(a)};c.prototype.getPreviousChannel=function(a){return this._channels.getPrevious(a)};c.prototype.hasPreviousChannel=function(a){return this._channels.hasPrevious(a)};c.prototype.changeChannelDef=function(a,b,c){var e=this.getChannel(a),b=this.getChannel(b),d=e.copy();c?(e.setName(b.name),e.setRgb(b.rgb)):(e.setName(b.getNameWithoutSuffix()),e.setRgb(b.displayedRgb));this._fireChange(!1,["channel",a,"channelRGB"],d,e,e.isEnabled(),e.getID())};c.prototype.setChannelMatching=
function(a,b){var c=this.getChannel(a),e=this.getChannel(b);e.setMatchedChannelServerId(c.getViewserverID());c.setMatchedChannelServerId(e.getViewserverID())};c.prototype.resetChannelMatching=function(){g.each(this.getChannels(),function(a){a.setMatchedChannelServerId()})};c.prototype.changeChannelRgb=function(a,b){var c=this.getChannel(a),e=c.copy();c.setRgb(b);this._fireChange(!1,["channel",a,"channelRGB"],e,c,c.isEnabled,c.getID())};c.prototype.setChannelOpaque=function(a,b){var c=this.getChannel(a),
e=c.isChannelOpaque();c.setOpaque(b);this._fireChange(!1,["channel",a,"channelRGB"],e,b,c.isEnabled(),c.getID())};c.prototype.getParsedChannelsInfo=function(){throw"Not Implemented: GraphicsModel.getParsedChannelsInfo";};c.prototype.interceptFragmentURL=function(){throw"Not Implemented: GraphicsModel.interceptFragmentURL";};c.prototype.getMaximumResolution=function(){return this.allowServerDeepZoom?-1:d.parseFloat(this.page.getParam("resolutionx"))};c.prototype.getCompareMode=function(){return this.dmode};
c.prototype.isInDifferenceCompareMode=function(){return this.dmode===i.diffMode.SHOWBOTHCHANGES||this.dmode===i.diffMode.SHOWBOTHCHANGESHIGHLIGHT||this.dmode===i.diffMode.SHOWBOTHCHANGESONLY||this.dmode===i.diffMode.SHOWBOTHSIDEBYSIDE||this.dmode===i.diffMode.SHOWBOTHONTOP||this.dmode===i.diffMode.READERSPREAD||this.dmode===i.diffMode.SHOWBOTHSIDEBYSIDEHIGHLIGHT||this.dmode===i.diffMode.SHOWBOTHSIDEBYSIDECHANGESONLY};c.prototype.setCompareMode=function(a){var b=this.dmode,c=this.getChannels();this.dmode=
a;this._fireChange(!1,["compareMode"],b,a);this._fireChange(!1,["channels"],c,this.getChannels())};c.prototype.setShowTrimbox=function(a,b){var c=this._trimboxMode;this._trimboxMode=a?b:null;this._fireChange(!1,["trimbox"],c,this._trimboxMode)};c.prototype.isShowTrimbox=function(){return null!==this._trimboxMode};return c});
define("web-viewer-wcr/webcenter/modules/graphics/GraphicsModel",["web-viewer/graphics/AbstractGraphicsModel","web-viewer/utils/ViewerUtils","underscore"],function(c,b,a){var d=function(a,b){c.call(this,a,b)};d.prototype=Object.create(c.prototype);d.prototype.constructor=d;d.prototype.interceptFragmentURL=function(b){b.params.color=this.getChannelSelectionMask();b.params.singlesepblack=this.getSingleChannelMode();b.params.coldef=this.getColorDef();if(this.channelOrderChanged||this._reverseChannelOrder){var c=
this._channels.getOrderedObjectList();this._reverseChannelOrder&&(c=c.reverse());var d=[];a.each(c,function(a,b){d[a.getViewserverID()]=b});b.params.seq=d.toString()}};d.prototype.getChannelSelectionMask=function(){var b=0;a.each(this.getChannels(),function(a){a.isEnabled()&&(b+=Math.pow(2,a.getViewserverID()))});return b};d.prototype.getColorDef=function(){var c="";a.each(this.getChannels(),function(a){if(a.isChanged()){""!==c&&(c+=",");var d=a.isChannelOpaque()?1:0;c+=a.getViewserverID()+" ["+a.displayedName+
"] "+b.rgbIntToBgrInt(a.displayedRgb)+" "+d}});return c};d.prototype.getParsedChannelsInfo=function(c){var d={channels:[]},i=c.unit||"",j=void 0===c.unitFix?2:c.unitFix,g=0,q;a.each(this.getChannels(),function(a){var a=a.copy(),n=c[a.getViewserverID()],k=null;void 0===n||0===n.length?n="---":(k=b.parseFirstFloat(n),isNaN(k)&&(k=null));var m="";if(this.isInDifferenceCompareMode()&&a.isInCurrentAndMatchedToPrevious()){var v=this.getMatchedChannel(a);v&&(v=c[v.getViewserverID()],void 0!==v&&0<v.length&&
(m=b.parseFirstFloat(v),m=!isNaN(m)&&c.makeTotalCount?" ("+m.toFixed(j)+")":" ("+v+")"))}if(null!==k&&c.makeTotalCount){if(!this.isInDifferenceCompareMode()||a.isInCurrentAndMatchedToPrevious()||a.isAdded())g+=k;if(this.isInDifferenceCompareMode()&&(a.isInPreviousAndMatchedWithCurrent()||a.isSubtracted()))void 0===q&&(q=0),q+=k;n=k.toFixed(j);m+=" "+i}a.value=n+m;d.channels[a.getViewserverID()]=a},this);d.total=c.makeTotalCount?void 0!==q?g.toFixed(j)+" ("+q.toFixed(j)+") "+i:g.toFixed(j)+" "+i:"";
return d};d.prototype.getChannelSelection=function(b){var c=0;a.each(b,function(a){c+=Math.pow(2,a.getViewserverID())});return c};return d});
define("web-viewer-wcr/webcenter/modules/graphics/GraphicsDataExtensions",["web-viewer/data/AbstractDocumentPage","web-viewer/graphics/Channel","web-viewer/graphics/GraphicsDataExtensions","underscore"],function(c,b,a){return function(d){var e=d.getDataAdapter();a(d);e.WebCenter?(c.prototype._parseChannelData=function(a){var c=this.getUniqueID()+"_"+this._channels.length,d=a.name;void 0===d&&(d="");d=d.replace(/&amp;/g,"&").replace(/&sl;/g,"/");a=new b(c,parseInt(a.serverID,10),d,a.rgb,a.opaque,a.file,
a.dmode,this,a.matchedWith);this._channels.push(a)},c.prototype.getImageURL=function(a){return e.ViewServer("thumbdata.jsp",a)},c.prototype.interceptFragmentURL=function(a){a.params.file=this._data.file;a.params.vdist=this._data.vdist;a.params.vsize=this._data.vsize;a.params.vscale=this._data.vscale;a.params.hscale=this._data.hscale;a.params.hsize=this._data.hsize;a.params.hdist=this._data.hdist;a.params.margtop=this._data.margtop;a.params.margright=this._data.margright;a.params.margbot=this._data.margbot;
a.params.margleft=this._data.margleft}):d.emit("error.SEVERE","Can't initialize Graphics on a non-webcenter data-adapter")}});
define("web-viewer-wcr/webcenter/modules/graphics/GraphicsModule",["web-viewer/graphics/AbstractGraphicsModule","web-viewer-wcr/webcenter/modules/graphics/GraphicsModel","web-viewer-wcr/webcenter/modules/graphics/GraphicsDataExtensions"],function(c,b,a){var d=function(b,d){a(b);c.call(this,b,d)};d.prototype=Object.create(c.prototype);d.prototype.constructor=d;d.prototype._interceptFragmentURL=function(a){this.graphicsModel&&this.graphicsModel.interceptFragmentURL(a);this.isChannelMatchingActive&&
null!==this.channelMatchingModel&&(a.params.colormatching=this.channelMatchingModel.getChannelMatching());this.f.getProperty("viewquality")&&(a.params.vq=this.f.getProperty("viewquality"));this._setTrimboxInformation(a)};d.prototype._setTrimboxInformation=function(a){var b=this.f.getDocumentController().getDifferencePage(),c=this.f.getDocumentController().getActivePage(),d=c.getMargins(),c=c.getTrimboxSize();a.params.ftbtlx=d.left;a.params.ftbtly=d.top;a.params.ftbbrx=c.width+d.left;a.params.ftbbry=
c.height+d.top;b&&b.hasGraphics()&&(d=b.getMargins(),c=b.getTrimboxSize(),a.params.diff=b.get("file"),a.params.dtbtlx=d.left,a.params.dtbtly=d.top,a.params.dtbbrx=c.width+d.left,a.params.dtbbry=c.height+d.top)};d.prototype._createGraphicsModel=function(a,c){return new b(this.f,[this.getPrivateChannelName(),"model"],a,c)};return d});