/**
	 * Check licenses for barcode and braille
	 * @returns {$.Deferred.<Boolean, Boolean>} Two parameters where the first one if true indicates has barcode license 
	 *                                          and second one if true indicates has braille license
	 */

/**
	 * Get the ServerInfo flags (can be used for checking licenses)
	 * @return {$.Deferred.<Number>} Flags number. 0 if something went wrong.
	 */

define("web-viewer/measure/MeasureModule","underscore web-viewer/core/AbstractModule web-viewer/core/CoreConstants web-viewer/measure/MeasureConstants web-viewer/utils/ListenerUtil jquery".split(" "),function(b,a,c,f,k){f=function(c,e){a.call(this,c,e,"measure");k.mixin(this,c);this._registerListener("module.graphics.model.changed.**",b.debounce(b.partial(this.updateMeasureTools,!1),10),this);this._registerListener("module.compare.referenceOffset.changed",b.partial(this.updateMeasureTools,!0),this)};
f.prototype=Object.create(a.prototype);f.prototype.constructor=f;f.prototype.updateMeasureTools=function(a){b.each(this.tools,function(b){b.isActive()&&b.updateIfNeeded(a)})};f.prototype.getState=function(){var a={sizeUnitState:this.f.getOption("PREFERENCES_UNIT_SIZE")};b.each(this.tools,function(b){a[b.getIID()]=b.getToolState()});return a};f.prototype.setState=function(a){b.each(a,function(a,d){var e=b.find(this.tools,function(a){return a.getIID()===d});e&&e.setState(a)});var e=b.find(this.tools,
function(a){return a.getIID()===c.TOOLS.MEASURE_RULER});void 0!==a.ruler&&e&&(a.ruler.isActive&&this.f.emit("toolManager.activateTool",e),this.f.emit("toolManager.interruptTools",!0))};return f});
define("web-viewer/measure/Ruler","web-viewer/utils/LineworkWrapper web-viewer/utils/LineworkPoint utils/ShapeUtils web-viewer/utils/ViewerUtils web-viewer/utils/DrawUtils web-viewer/measure/MeasureConstants underscore".split(" "),function(b,a,c,f,k,j){var e=function(a){this.f=a;this.rulerType=1;this.endPoint=this.startPoint=null};e.prototype.reset=function(){this.endPoint=this.startPoint=null};e.prototype.snapToClosestAngle=function(a){if(0===this.rulerType){var d=this.getLength(),b=f.closestAngle(this.getAngle(),
8);a?(this.startPoint.x=this.endPoint.x-d*Math.cos(b*Math.PI/180),this.startPoint.y=this.endPoint.y-d*Math.sin(b*Math.PI/180)):(this.endPoint.x=d*Math.cos(b*Math.PI/180)+this.startPoint.x,this.endPoint.y=d*Math.sin(b*Math.PI/180)+this.startPoint.y)}};e.prototype.getLength=function(){if(this.endPoint&&this.startPoint){var a=Math.abs(this.endPoint.x-this.startPoint.x),d=Math.abs(this.endPoint.y-this.startPoint.y);return Math.sqrt(a*a+d*d)}return 0};e.prototype.getAngle=function(){return 180*Math.atan2(this.endPoint.y-
this.startPoint.y,this.endPoint.x-this.startPoint.x)/Math.PI};e.prototype.getLinework=function(){return this.endPoint&&this.startPoint?0===this.rulerType?this.getRulerLinework():this.getSquareLinework():[]};e.prototype.getSquareLinework=function(){var e=[];if(this.startPoint&&this.endPoint){var d=new b;d.fillcolor="rgba(0, 0, 0, 0.30)";d.color="rgba(0, 0, 0, 1.00)";d.linewidth=1;d.type=k.LWTYPE_RECT;var i=new a;i.makeMoveTo(this.startPoint.x,this.startPoint.y);d.pointArray[0]=i;i=new a;i.makeLineTo(this.endPoint.x,
this.endPoint.y);d.pointArray[1]=i;d.rect=new c.Rect(this.startPoint,this.startPoint.sizeTo(this.endPoint));e.push(d);d=new b;d.fillcolor="rgba(0, 0, 0, 0.0)";d.color="rgba(220, 220, 220, 0.9)";d.linewidth=1;d.type=k.LWTYPE_DASHEDBOX;d.dash=[4,3];i=new a;i.makeMoveTo(this.startPoint.x,this.startPoint.y);d.pointArray[0]=i;i=new a;i.makeLineTo(this.endPoint.x,this.endPoint.y);d.pointArray[1]=i;d.rect=new c.Rect(this.startPoint,this.startPoint.sizeTo(this.endPoint));e.push(d)}return e};e.prototype.getRulerLinework=
function(){var a="black";this.f&&(a=this.f.getCurrentUser().getColor("PREFERENCES_RULER_DISPLAY_COLOR"));if(this.startPoint&&this.endPoint)return this._cachedRulerLinework&&this._cachedRulerLinework.startPoint.equals(this.startPoint)&&this._cachedRulerLinework.endPoint.equals(this.endPoint)&&this._cachedRulerLinework.color==a?this._cachedRulerLinework.linework:this.generateRulerLinework(this.startPoint,this.endPoint,a)};e.prototype.generateRulerLinework=function(e,d,c){var h=[],m=new a;m.makeMoveTo(e.x,
e.y);var l=new a;l.makeLineTo(d.x,d.y);var n=new b;n.pointArray.push(m);n.pointArray.push(l);n.color="white";n.type=k.LWTYPE_LINE;h.push(n);n=new b;n.pointArray.push(m);n.pointArray.push(l);n.color=c;n.dash=[10,10];n.type=k.LWTYPE_LINE;h.push(n);m=this.getCursor(e);l=this.getCursor(d);h.push(m);h.push(l);this._cachedRulerLinework={startPoint:e.copy(),endPoint:d.copy(),color:c,linework:h};return h};e.prototype.getCursor=function(a){var d=new b;d.type=k.LWTYPE_IMAGE;d.linewidth=1;d.imageRef=j.RulerPoint.DEFAULT;
d.staticsize=!0;d.setRect(new c.Rect(new c.Point(a.x,a.y)));d.imageOffset=new c.Size(j.RulerPoint.OFFSET.width,j.RulerPoint.OFFSET.height);return d};return e});
define("tpl!web-viewer/measure/RulerPopoverTemplate",function(){return function(b){var a,c;c="<table>\r\n";b.showXY&&(c+="\r\n\t<tr>\r\n\t\t<td><strong>"+(null==(a=b.i18n("InfoX"))?"":_.escape(a))+'</strong></td>\r\n\t\t<td align="right">'+(null==(a=b.x)?"":_.escape(a))+" "+(null==(a=b.i18n(b.unitsloc))?"":_.escape(a))+"</td>\r\n\t</tr>\r\n\t<tr>\r\n\t\t<td><strong>"+(null==(a=b.i18n("InfoY"))?"":_.escape(a))+'</strong></td>\r\n\t\t<td align="right">'+(null==(a=b.y)?"":_.escape(a))+" "+(null==(a=
b.i18n(b.unitsloc))?"":_.escape(a))+"</td>\r\n\t</tr>\r\n");c+="\r\n";b.showDA&&(c+="\r\n\t<tr>\r\n\t\t<td><strong>"+(null==(a=b.i18n("InfoDist"))?"":_.escape(a))+'</strong></td>\r\n\t\t<td align="right">'+(null==(a=b.distance)?"":_.escape(a))+" "+(null==(a=b.i18n(b.unitsloc))?"":_.escape(a))+"</td>\r\n\t</tr>\r\n\t<tr>\r\n\t\t<td><strong>"+(null==(a=b.i18n("InfoAngle"))?"":_.escape(a))+'</strong></td>\r\n\t\t<td align="right">'+(null==(a=b.angle)?"":_.escape(a))+"&#176;</td>\r\n\t</tr>\r\n");c+=
"\r\n";b.showWH&&(c+="\r\n\t<tr>\r\n\t\t<td><strong>"+(null==(a=b.i18n("InfoWidth"))?"":_.escape(a))+'</strong></td>\r\n\t\t<td align="right">'+(null==(a=b.width)?"":_.escape(a))+" "+(null==(a=b.i18n(b.unitsloc))?"":_.escape(a))+"</td>\r\n\t</tr>\r\n\t<tr>\r\n\t\t<td><strong>"+(null==(a=b.i18n("InfoHeight"))?"":_.escape(a))+'</strong></td>\r\n\t\t<td align="right">'+(null==(a=b.height)?"":_.escape(a))+" "+(null==(a=b.i18n(b.unitsloc))?"":_.escape(a))+"</td>\r\n\t</tr>\r\n");c+="\r\n\r\n</table>\r\n";
b.createAnnotation&&(c+='\r\n    <a class="addAnnotation">\r\n        <i class="icon-WCR_Annotation-Arrow12"></i>\r\n        <span>'+(null==(a=b.i18n("AnnFromReadout"))?"":_.escape(a))+"</span>\r\n    </a>\r\n");return c+""}});
define("web-viewer/measure/RulerSnapIndicatorPopoverModel","underscore web-viewer/utils/ViewerUtils web-viewer/viewport/model/ViewportPopoverModel utils/ShapeUtils Template tpl!web-viewer/measure/RulerPopoverTemplate web-viewer/core/CoreConstants".split(" "),function(b,a,c,f,k,j,e){var g=function(a,e,h,m){c.call(this,a,e);var l=$("<div/>");this.fix=3;this.f=a;this.snapIndicator=h;this.t=new k(a.i18n,j);a.i18n.loadBundle("viewer",b.bind(function(){this.t.render()},this));this.t.setContext(l);this.t.render();
this.getFrame=function(){return this.snapIndicator?this.snapIndicator.rect:new f.Rect};this.getContent=function(){return l};this.getRestrictBorder=function(){return 0};this.getClass=function(){return m};this.getContext=b.bind(function(){return this.f.getContext().find(".viewport")},this)};g.prototype=Object.create(c.prototype);g.prototype.constructor=g;g.prototype.setPoint=function(a){this.point=a;this.render()};g.prototype.render=function(){if(this.snapIndicator){var d=this.snapIndicator.rect.center(),
b=null,c=null;this.f.getUnits()===e.SizeUnits.PIXELS&&(c=this.f.getActivePage(),b=c.getParam("resolutionx"),c=c.getParam("resolutiony"));this.t.d.showXY=!0;this.t.d.unitsloc=this.f.getUnitsLocName();d=new f.Point(d.x,d.y);d=this._coordinates.getTransformedPoint(d);this.t.d.x=a.convertFromMmValue(d.x,this.f.getUnits(),this.f.getUnitsFix(),a.parseFloat(b));this.t.d.y=a.convertFromMmValue(d.y,this.f.getUnits(),this.f.getUnitsFix(),a.parseFloat(c));this.t.render()}};return g});
define("web-viewer/measure/MeasureLayerModel","underscore jquery web-viewer/viewport/model/ViewportLayerModel web-viewer/measure/Ruler utils/XMLUtils utils/ShapeUtils web-viewer/measure/MeasureConstants web-viewer/utils/SnapIndicator web-viewer/measure/RulerSnapIndicatorPopoverModel".split(" "),function(b,a,c,f,k,j,e,g,d){a=function(a,b){c.call(this,a,b);this.f=a;this.ruler=new f(a);this._drawType=e.MeasureDrawType.RECTANGLE;this._allowStartPointSnapping=!1;this.snapIndicator=null;this.snapIndicatorModel=
new d(a,"RulerSnapIndicatorPopover",this.snapIndicator)};a.prototype=Object.create(c.prototype);a.prototype.constructor=a;a.prototype.getLinework=function(){var a=b.clone(this.ruler.getLinework());this.snapIndicator&&a.push(this.snapIndicator);return a};a.prototype.setStartPoint=function(a,b){this.snapIndicator=null;this.ruler.startPoint=a;b&&this._allowStartPointSnapping&&this.ruler.snapToClosestAngle(!0);this.repaint();this.modelChanged()};a.prototype.setEndPoint=function(a,b){var d=this.ruler.endPoint?
this.ruler.endPoint.copy():null;this.ruler.endPoint=a;b&&this.ruler.snapToClosestAngle();if(!d||!d.equals(this.ruler.endPoint))this.repaint(),this.ruler.rulerType==e.MeasureType.Ruler&&this.calculate();this.modelChanged()};a.prototype.getStartPoint=function(){return this.ruler.startPoint};a.prototype.getEndPoint=function(){return this.ruler.endPoint};a.prototype.repaint=function(){this.modelChanged()};a.prototype.reset=function(){this.ruler.reset();this.modelChanged()};a.prototype.hidePopover=function(){this.removePopover(this.name)};
a.prototype.calculate=function(){this.ruler.endPoint&&this.ruler.startPoint&&this.ruler.rulerType==e.MeasureType.Ruler&&(this.ruler.getLength(),this.ruler.getAngle(),this.ruler.startPoint.sizeTo(this.ruler.endPoint))};a.prototype.setRulerType=function(a){this.ruler.rulerType=a;this.reset()};a.prototype.setSnapIndicatorPoint=function(a){var b=!1;a?!this._allowStartPointSnapping&&this.ruler.startPoint&&a.equals(this.ruler.startPoint)?this.snapIndicator&&(this.snapIndicator=null,b=!0):this.snapIndicator?
a.equals(this.snapIndicator.rect.center())||(this.snapIndicator.setCenter(a),b=!0):(this.snapIndicator=new g(a),b=!0):this.snapIndicator&&(this.snapIndicator=null,b=!0);b&&(b=a=!1,this.ruler&&this.snapIndicator&&(this.ruler.endPoint&&this.snapIndicator.rect.center().equals(this.ruler.endPoint)&&(a=!0),this.ruler.startPoint&&this.snapIndicator.rect.center().equals(this.ruler.startPoint)&&(b=!0)),(a=null!==this.snapIndicator&&!a&&!b)&&!this.getPopoverModel(this.snapIndicatorModel.getID())?(this.snapIndicatorModel.snapIndicator=
this.snapIndicator,this.addPopoverModel(this.snapIndicatorModel)):!a&&this.getPopoverModel(this.snapIndicatorModel.getID())&&this.removePopoverModel(this.snapIndicatorModel.getID()),this.snapIndicatorModel.render(),this.modelChanged())};a.prototype.clearSnapIndicator=function(){this.setSnapIndicatorPoint(null)};a.prototype.setAllowStartPointSnapping=function(a){this._allowStartPointSnapping=a};a.prototype.setDrawType=function(a){this._drawType=a};a.prototype.modelChanged=function(a){var b=null;!a&&
(this.ruler&&this.ruler.startPoint&&this.ruler.endPoint)&&(a=this.ruler.startPoint.sizeTo(this.ruler.endPoint),b={mode:this._drawType,w:a.width,h:a.height},this._drawType===e.MeasureDrawType.RECTANGLE?(b.x=this.ruler.startPoint.x,b.y=this.ruler.startPoint.y):this._drawType===e.MeasureDrawType.LINE&&(b.d=this.ruler.getLength(),b.a=this.ruler.getAngle()));this.f.emit("selection.changed",b);c.prototype.modelChanged.call(this)};return a});
define("tpl!web-viewer/measure/MeasurePopoverTemplate",function(){return function(b){var a,c="",c=c+"<ul>\r\n\t";_.each(b.channels,function(b){b&&(c+='\r\n\t\t<li>\r\n\t\t\t<span class="colorBlock" style="background-color: #'+(null==(a=b.getHexRGB())?"":_.escape(a))+';"></span>\r\n\t\t\t<span class="channelName">'+(null==(a=b.displayedName)?"":_.escape(a))+"</span>\r\n\t\t\t<span>"+(null==(a=b.value)?"":_.escape(a))+"</span>\r\n\t\t</li>\r\n\t")});c+="\r\n</ul>\r\n";b.makeTotalCount&&(c+='\r\n<ul>\r\n\t<li><div style="text-align:right">'+
(null==(a=b.totalCount)?"":_.escape(a))+"</div></li>\r\n</ul>\r\n");c+="\r\n";b.addAnnotation&&(c+='\r\n<ul>\r\n\t<li class="addAnnotation"><a><i class="icon-WCR_Annotation-Rect12"></i><span>'+(null==(a=b.i18n("AnnFromReadout"))?"":_.escape(a))+"</span></a></li>\r\n</ul>\r\n");return c+=""}});
define("web-viewer/measure/MeasurePopoverModel","web-viewer/utils/ViewerUtils web-viewer/viewport/model/ViewportPopoverModel tpl!web-viewer/measure/MeasurePopoverTemplate Template underscore jquery".split(" "),function(b,a,c,f,k,j){b=function(b,g,d,i,h,m,l){a.call(this,b,d);this._content=j("<div/>").addClass("measureInfo");this._header=j("<div />").addClass("measureInfoHeader");this._headerTitle=j("<div />").addClass("headerTitle").html(i);this._headerExtra=j("<div />").addClass("headerExtra").html(l);
this._header.append(this._headerTitle).append(this._headerExtra);this._content.append(this._header);this._body=j("<div />");this._content.append(this._body);this.t=new f(b.i18n,c);this.t.setContext(this._body);this.makeTotalCount=m;this._channelsInfo=h;this.channels=[];this.t.bind("click",".addAnnotation",k.bind(function(){var a="<p>";k.each(this.channels,function(b,d){a+=(0<d?"<br />":"")+"<b>"+b.name+"</b>: "+b.value},this);a+="</p>";this.f.emit("module.annotation.createAnnotation",this.area.rect,
a);this.f.emit("toolManager.deactivateTool")},this));this.f.i18n.loadBundle("viewer",k.bind(function(){this.t.render()},this));this.t.d.channels=[];this.t.d.makeTotalCount=m;this.area=g;this.update();this.getFrame=function(){return this.area?this.area.rect:null};this.getContent=function(){return this._content};this.getRestrictBorder=function(){return 0};this.isInteractive=function(){return!0}};b.prototype=Object.create(a.prototype);b.prototype.constructor=b;b.prototype.getChannelsInformation=function(){return this._channelsInfo};
b.prototype.update=function(){this.f.requestModule("graphics",k.bind(function(a){var b=a.getGraphicsModel();this.channels=[];this.t.d.channels=[];this.t.d.addAnnotation=!!this.f.getModule("annotation");a=b.getParsedChannelsInfo(this._channelsInfo);k.each(a.channels,function(a){if(!b.isInDifferenceCompareMode()||!a.isInPreviousAndMatchedWithCurrent())this.channels.push(a),this.t.d.channels.push(a)},this);this.t.d.totalCount=this.makeTotalCount?a.total:"";this.t.render()},this))};b.prototype.setChannelsInfo=
function(a){this._channelsInfo=a;this.update()};b.prototype.setArea=function(a){this.area=a};b.prototype.setHeaderExtra=function(a){this._headerExtra.html(a)};b.prototype.setHeader=function(a){this._headerTitle.html(a)};return b});
define("web-viewer/measure/AbstractMeasureTool","underscore web-viewer/viewport/tools/AbstractTool utils/ShapeUtils web-viewer/utils/GEOUtils web-viewer/utils/DrawUtils web-viewer/utils/ViewerUtils web-viewer/measure/MeasureLayerModel web-viewer/measure/MeasureConstants web-viewer/measure/MeasurePopoverModel utils/XMLUtils web-viewer/utils/ConversionConstants utils/Cache".split(" "),function(b,a,c,f,k,j,e,g,d,i,h,m){f=function(d,c){a.call(this,d,c);this.f=d;this.popover=null;this.defaultState="default";
this.drawingState="drawing";this.clickState="click";this.model=new e(d,c);this.touchPoint=null;this.snapDistance=this.minimum=16;this.infoFetchedFor=null;this.isPopoverShown=!1;this._infoCache=new m(4,!0);this._infoCache._loadItem=b.bind(function(a){var d=this.f.getActivePage(),e=JSON.parse(a);d.getInfo(e,b.bind(function(b){b&&(b.status&&"-1"==b.status.value)&&this.f.emit("userMessage","warn",b.status.message);this._infoCache._registerItem(a,b)},this),b.bind(function(b,d,e){this._infoCache._registerItem(a);
this.f.i18n.loadBundle("viewer",function(){this.f.emit("error.SEVERE",this.f.i18n.t("MeasurementInfoError"),b,d,e)},this)},this))},this);this.registerState(this.defaultState,function(a){return{enterState:function(){},mousedown:function(b){a.removePopover();a.model.reset();a.didReset();a.touchPoint=a.keepPointWithinWorldBounds(a.getWorldPoint(b),!0);var d=a.getPointToSnapTo(b,a.snapDistance);d||(d=a.keepPointWithinWorldBounds(a.getWorldPoint(b),!1));a.model.setStartPoint(d);a.model.hidePopover();a.changeState(a.drawingState);
b.originalEvent.preventDefault()},mouseup:function(){a.model.ruler.startPoint&&!a.model.ruler.endPoint?a.changeState(a.clickState):(a.changeState(a.defaultState),a.model.ruler.startPoint&&a.model.ruler.endPoint&&a.calculate())},mousemove:function(b){a.checkForSnapPoint(b)},mouseout:function(){},contextmenu:function(a){a.preventDefault();a.stopPropagation();return!1},mouseleave:function(){}}}(this));this.registerState(this.drawingState,b.defaults(function(a){return{enterState:function(){d.emit("layout.disableTextSelection");
d.emit("viewport.startInteractive")},leaveState:function(){setTimeout(function(){d.emit("layout.enableTextSelection")},500);d.emit("viewport.stopInteractive")},mousemove:function(b){var d=a.keepPointWithinWorldBounds(a.getWorldPoint(b),!0).sizeTo(a.touchPoint);(a.model.ruler.endPoint||Math.abs(d.width)>=a.minimum||Math.abs(d.height)>a.minimum)&&a.registerEndPoint(b);a.checkForSnapPoint(b)}}}(this),this.getState(this.defaultState)));this.registerState(this.clickState,b.defaults(function(a){return{enterState:function(){a.changeState(a.defaultState)}}}(this),
this.getState(this.drawingState)));this.getDefaultCursor=function(){return"rulerCursor"};this._override("initialize",function(a,b){this._super(a,b);this.changeState(this.defaultState);this.registerActiveEvents("mousedown mousemove mouseup mouseout mouseleave contextmenu".split(" "))});this._override("activate",function(a){this._super(a);a||(this.f.getModule("viewport").addLayer(this.getIID(),this.model),this.model.ruler.startPoint&&this.model.ruler.endPoint&&this.popover&&(this.model.addPopoverModel(this.popover),
this.f.emit("channels.informationAdded",this.popover.getChannelsInformation())))});this._override("deactivate",function(a){this._super(a);a||(this.model.modelChanged(!0),this.removePopover(),this.f.getModule("viewport").removeLayer(this.getIID()),d.emit("channels.informationNotVisible"))})};f.prototype=new a;f.prototype.constructor=f;f.prototype.calculate=function(){};f.prototype.endPointSet=function(){};f.prototype.didReset=function(){};f.prototype.registerEndPoint=function(a){var b=this.getPointToSnapTo(a,
this.snapDistance);b||(b=this.keepPointWithinWorldBounds(this.getWorldPoint(a),!1));this.model.setEndPoint(b,a.shiftKey);this.endPointSet()};f.prototype.registerStartPoint=function(a){var b=this.getPointToSnapTo(a,this.snapDistance);b||(b=this.keepPointWithinWorldBounds(this.getWorldPoint(a),!1));this.model.setStartPoint(b,a.shiftKey);this.endPointSet()};f.prototype.getPointToSnapTo=function(){return null};f.prototype.checkForSnapPoint=function(a){a=this.getPointToSnapTo(a,this.snapDistance);this.model.setSnapIndicatorPoint(a)};
f.prototype.showInfo=function(){};f.prototype.getInfo=function(a){var d=this._generateParameters(),e=b.clone(d);null!=d&&(b.each(a,function(a,b){d[b]=a}),a=JSON.stringify(d),this._infoCache.get(a,b.bind(function(a){a&&(this.infoFetchedFor=e,this.showInfo(a,d))},this)))};f.prototype._generateParameters=function(){if(this.model.ruler.startPoint&&this.model.ruler.endPoint){var a=new c.Rect(this.model.ruler.startPoint.copy(),this.model.ruler.startPoint.sizeTo(this.model.ruler.endPoint));a.normalize();
var b=h.FIXED_BARCODE_DPMM,a={rectangle:a,params:{tool:this.getIID(),x1:0,y1:0,x2:0,y2:0}};this.f.emit("intercept.fragmentURL",a);a=a.params;a.res=b;return a}return null};f.prototype.canBeInterrupted=function(){return this.getCurrentStateName()!=this.drawingState};f.prototype.canBeUsedOnActivePage=function(){return!0};f.prototype.updateIfNeeded=function(a){(a||this.infoFetchedFor&&this.infoFetchedFor!=this._generateParameters())&&this.calculate();this.popover&&this.isPopoverShown&&(this.popover.update(),
this.model.modelChanged())};f.prototype.showPopover=function(a,b,d,e){b||(b=this.model.ruler.getSquareLinework()[0]);this.popover?(this.popover.setArea(b),this.popover.setChannelsInfo(a),this.popover.setHeader(d),this.popover.setHeaderExtra(e)):this.popover=this.createPopoverModel(a,b,d,e);this.model.addPopoverModel(this.popover);this.isPopoverShown=!0;this.model.modelChanged()};f.prototype.createPopoverModel=function(a,b,e,c){return new d(this.f,b,"Channels",e?e:this.f.i18n.t("ChannelsTitle"),a,
this._needsTotalCount(),c)};f.prototype.removePopover=function(){this.popover&&this.model.removePopoverModel(this.popover.getID());this.isPopoverShown=!1};f.prototype._needsTotalCount=function(){return!1};f.prototype.getToolState=function(){return{startPoint:this.model.getStartPoint(),endPoint:this.model.getEndPoint(),isActive:this.isActive()}};f.prototype.setToolState=function(a){null!==a.startPoint&&this.model.setStartPoint(a.startPoint);null!==a.endPoint&&(this.model.setEndPoint(a.endPoint),this.endPointSet())};
f.prototype.doActivation=function(){this.model.modelChanged();a.prototype.doActivation.call(this)};return f});
define("web-viewer/measure/RulerPopoverModel","underscore web-viewer/utils/ViewerUtils web-viewer/viewport/model/ViewportPopoverModel utils/ShapeUtils Template tpl!web-viewer/measure/RulerPopoverTemplate web-viewer/core/CoreConstants".split(" "),function(b,a,c,f,k,j,e){var g=function(a,e,h,m,l){c.call(this,a,e);var n=$("<div/>").addClass("rulerMeasurement");this.ruler=h;this.end=m;this.fix=3;this.f=a;h&&(this.point=h.startPoint);this.t=new k(a.i18n,j);a.i18n.loadBundle("viewer",b.bind(function(){this.t.render()},
this));this.f.getCurrentUser().on("options.changed.PREFERENCES_UNIT_SIZE",b.bind(this.render,this));this.t.setContext(n);this.t.bind("mousedown",".addAnnotation",function(a,b){b.preventDefault();b.stopPropagation()},this);this.t.bind("click",".addAnnotation",function(a,b){this._emit("createRulerAnnotation");b.preventDefault();b.stopPropagation()},this);this.t.render();this.getFrame=function(){if(this.ruler){if(this.end&&h.endPoint)return new f.Rect(h.endPoint.copy(),null);if(h.startPoint)return new f.Rect(h.startPoint.copy(),
null)}else if(this.point)return new f.Rect(this.point.copy(),null);return null};this.getContent=function(){return n};this.getPreferredPosition=function(){return this.ruler.startPoint&&this.ruler.endPoint?this.ruler.startPoint.x.toFixed(this.fix)==this.ruler.endPoint.x.toFixed(this.fix)?this.ruler.startPoint.y<=this.ruler.endPoint.y?!this.end?"top":"bottom":!this.end?"bottom":"top":this.ruler.startPoint.x<=this.ruler.endPoint.x?this.end?"right":"left":this.end?"left":"right":"bottom"};this.getRestrictBorder=
function(){return 0};this.getContext=b.bind(function(){return this.f.getContext().find(".viewport")},this);this.getClass=function(){return l};this.isInteractive=function(){return!0}};g.prototype=Object.create(c.prototype);g.prototype.constructor=g;g.prototype.isEmpty=function(){return this.end?!(this.f.getOption("PREFERENCES_RULER_DISPLAY_MODE_DA")||this.f.getOption("PREFERENCES_RULER_DISPLAY_MODE_XY")||this.f.getOption("PREFERENCES_RULER_DISPLAY_MODE_WH")):!(this.f.getOption("PREFERENCES_RULER_DISPLAY_MODE_XY")||
this.point)};g.prototype.render=function(){if(this.ruler){if(!this.ruler.startPoint||!this.ruler.endPoint)return}else if(!this.point)return;b.extend(this.t.d,this.getMeasureData());this.t.render()};g.prototype.getMeasureData=function(){var b={};b.unitsloc=this.f.getUnitsLocName();this.fix=this.f.getUnitsFix();var c=this.f.getUnits(),h,m=null,l=null,n=null;this.ruler?(h=new f.Rect(this.ruler.startPoint.copy(),this.ruler.startPoint.sizeTo(this.ruler.endPoint)),c===e.SizeUnits.PIXELS&&(l=this.f.getActivePage(),
m=a.parseFloat(l.getParam("resolutionx")),l=a.parseFloat(l.getParam("resolutiony")))):h=this.point?new f.Rect(this.point):new f.Rect;if(b.end=this.end){if(!this.ruler.endPoint)return;b.createAnnotation=!!this.f.getModule("annotation");b.showDA=this.f.getOption("PREFERENCES_RULER_DISPLAY_MODE_DA");b.showXY=this.f.getOption("PREFERENCES_RULER_DISPLAY_MODE_XY");b.showWH=this.f.getOption("PREFERENCES_RULER_DISPLAY_MODE_WH");var g=new f.Point(h.right(),h.bottom()),g=this._coordinates.getTransformedPoint(g);
b.x=a.convertFromMmValue(g.x,c,this.fix,m);b.y=a.convertFromMmValue(g.y,c,this.fix,l);c===e.SizeUnits.PIXELS&&(n=this.ruler.getAngle()*Math.PI/180,n=Math.sqrt(Math.cos(n)*Math.cos(n)*m*m+Math.sin(n)*Math.sin(n)*l*l));b.distance=a.convertFromMmValue(this.ruler.getLength(),c,this.fix,n);b.angle=this.f.getOption("PREFERENCES_RULER_ANGLE_MODE")?-this.ruler.getAngle().toFixed(2):this.ruler.getAngle().toFixed(2);b.width=a.convertFromMmValue(h.size.width,c,this.fix,m);b.height=a.convertFromMmValue(h.size.height,
c,this.fix,l)}else{if(this.ruler&&!this.ruler.startPoint)return;b.showXY=this.f.getOption("PREFERENCES_RULER_DISPLAY_MODE_XY")||(this.point?!0:!1);b.showDA=!1;b.showWH=!1;h=new f.Point(h.origin.x,h.origin.y);h=this._coordinates.getTransformedPoint(h);b.x=a.convertFromMmValue(h.x,c,this.fix,m);b.y=a.convertFromMmValue(h.y,c,this.fix,l)}return b};return g});
define("tpl!web-viewer/measure/RulerToAnnotationText",function(){return function(b){var a,c;c="";b.showXY&&(c+="\r\n    <b>"+(null==(a=b.i18n("RulerAnnotationFrom"))?"":_.escape(a))+"</b><br/>\r\n        &nbsp;"+(null==(a=b.i18n("InfoX"))?"":_.escape(a))+" "+(null==(a=b.fromX)?"":_.escape(a))+" "+(null==(a=b.i18n(b.unitsloc))?"":_.escape(a))+"<br/>\r\n        &nbsp;"+(null==(a=b.i18n("InfoY"))?"":_.escape(a))+" "+(null==(a=b.fromY)?"":_.escape(a))+" "+(null==(a=b.i18n(b.unitsloc))?"":_.escape(a))+
"<br/>\r\n    <b>"+(null==(a=b.i18n("RulerAnnotationTo"))?"":_.escape(a))+"</b><br/>\r\n        &nbsp;"+(null==(a=b.i18n("InfoX"))?"":_.escape(a))+" "+(null==(a=b.x)?"":_.escape(a))+" "+(null==(a=b.i18n(b.unitsloc))?"":_.escape(a))+"<br/>\r\n        &nbsp;"+(null==(a=b.i18n("InfoY"))?"":_.escape(a))+" "+(null==(a=b.y)?"":_.escape(a))+" "+(null==(a=b.i18n(b.unitsloc))?"":_.escape(a))+"<br/><br/>\r\n");c+="\r\n";b.showDA&&(c+="\r\n    <b>"+(null==(a=b.i18n("InfoDist"))?"":_.escape(a))+"</b> "+(null==
(a=b.distance)?"":_.escape(a))+" "+(null==(a=b.i18n(b.unitsloc))?"":_.escape(a))+"<br/>\r\n    <b>"+(null==(a=b.i18n("InfoAngle"))?"":_.escape(a))+"</b> "+(null==(a=b.angle)?"":_.escape(a))+"&#176;<br/>\r\n");c+="\r\n";b.showWH&&(c+="\r\n    <b>"+(null==(a=b.i18n("InfoWidth"))?"":_.escape(a))+"</b> "+(null==(a=b.width)?"":_.escape(a))+" "+(null==(a=b.i18n(b.unitsloc))?"":_.escape(a))+"<br/>\r\n    <b>"+(null==(a=b.i18n("InfoHeight"))?"":_.escape(a))+"</b> "+(null==(a=b.height)?"":_.escape(a))+" "+
(null==(a=b.i18n(b.unitsloc))?"":_.escape(a))+"<br/>\r\n");return c+""}});
define("web-viewer/measure/RulerTool","underscore web-viewer/measure/AbstractMeasureTool web-viewer/measure/MeasureConstants web-viewer/utils/ListenerUtil web-viewer/measure/RulerPopoverModel Template tpl!web-viewer/measure/RulerToAnnotationText web-viewer/annotation/AnnotationConstants utils/ShapeUtils web-viewer/core/CoreConstants".split(" "),function(b,a,c,f,k,j,e,g,d,i){var h=function(d){a.call(this,d,i.TOOLS.MEASURE_RULER);f.mixin(this,d);this.hoverState="hover";this.draggingState="dragging";
this.drawnState="drawn";this.t=new j(d.i18n,e);this.model.setRulerType(c.MeasureType.Ruler);this.model.setAllowStartPointSnapping(!0);this.model.setDrawType(c.MeasureDrawType.LINE);this.startPopover=new k(d,"startRulerPopover",this.model.ruler,!1,"transparent");this.endPopover=new k(d,"endRulerPopover",this.model.ruler,!0,"transparent");this._registerListener("createRulerAnnotation",this._createAnnotation,this,this.endPopover);this.getState(this.defaultState).canBeInterrupted=!0;this.registerState(this.drawnState,
b.defaults({mousemove:b.bind(function(a){this._isHovering(a)&&this.changeState(this.hoverState);this.checkForSnapPoint(a)},this),mouseup:b.bind(function(){this.model.ruler.startPoint&&!this.model.ruler.endPoint?this.changeState(this.clickState):(this.changeState(this.drawnState),this.model.ruler.startPoint&&this.model.ruler.endPoint&&this.calculate())},this),mouseleave:b.bind(function(){this.changeState(this.drawnState)},this),canBeInterrupted:!0},this.getState(this.defaultState)));this.registerState(this.hoverState,
b.defaults({mousedown:b.bind(function(a){if(a=this._getDistanceToPoints(a))this._isMovingStartPoint=a.toStartPoint<a.toEndPoint,this.changeState("dragging")},this),mousemove:b.bind(function(a){this._isHovering(a)||this.changeState(this.drawnState);this.checkForSnapPoint(a)},this),canBeInterrupted:!1,canBeInterruptedForNavigation:!0},this.getState(this.drawnState)));this.registerState(this.draggingState,b.defaults({enterState:b.bind(function(){this.setCursor("cursor-none")},this),mousemove:b.bind(function(a){this.setCursor("cursor-none");
this._isMovingStartPoint?this.registerStartPoint(a):this.registerEndPoint(a);this.checkForSnapPoint(a)},this),mouseup:b.bind(function(){this.changeState(this.hoverState)},this),canBeInterrupted:!1,canBeInterruptedForNavigation:!0},this.getState(this.drawnState)));this.registerState(this.drawingState,b.defaults({enterState:function(){d.emit("layout.disableTextSelection");d.emit("viewport.startInteractive")},leaveState:function(){setTimeout(function(){d.emit("layout.enableTextSelection")},500);d.emit("viewport.stopInteractive")},
mousemove:b.bind(function(a){this.model.ruler.endPoint&&this.setCursor("cursor-none");var b=this.keepPointWithinWorldBounds(this.getWorldPoint(a),!0).sizeTo(this.touchPoint);(this.model.ruler.endPoint||Math.abs(b.width)>=this.minimum||Math.abs(b.height)>this.minimum)&&this.registerEndPoint(a);this.checkForSnapPoint(a)},this),canBeInterrupted:!1,canBeInterruptedForNavigation:!0},this.getState(this.drawnState)));this.registerState(this.clickState,b.defaults({enterState:function(){},mousedown:b.bind(function(a){this.registerEndPoint(a);
this.changeState(this.drawnState)},this)},this.getState(this.drawingState)));this._override("activate",function(a){this._super(a);this.endPointSet()});d.getCurrentUser().on("options.changed.PREFERENCES_RULER_ANGLE_MODE",b.bind(function(){this.startPopover.render();this.endPopover.render();this.model.repaint()},this));d.getCurrentUser().on("options.changed.PREFERENCES_RULER_DISPLAY_MODE",b.bind(function(){this.startPopover.isEmpty()?this.model.removePopoverModel(this.startPopover.getID()):(void 0===
this.model.getPopoverModel(this.startPopover.getID())&&this.model.addPopoverModel(this.startPopover),this.startPopover.render());this.endPopover.isEmpty()?this.model.removePopoverModel(this.endPopover.getID()):(void 0===this.model.getPopoverModel(this.endPopover.getID())&&this.model.addPopoverModel(this.endPopover),this.endPopover.render());this.model.repaint()},this));d.getCurrentUser().on("options.changed.PREFERENCES_RULER_DISPLAY_COLOR",b.bind(function(){this.startPopover.render();this.endPopover.render();
this.model.repaint()},this))};h.prototype=Object.create(a.prototype);h.prototype.constructor=h;h.prototype.endPointSet=b.throttle(function(){this.model.ruler.startPoint&&(!this.model.getPopoverModel(this.startPopover.getID())&&!this.startPopover.isEmpty())&&this.model.addPopoverModel(this.startPopover);this.model.ruler.endPoint&&(!this.model.getPopoverModel(this.endPopover.getID())&&!this.endPopover.isEmpty())&&this.model.addPopoverModel(this.endPopover);this.startPopover.render();this.endPopover.render()},
100);h.prototype.didReset=function(){this.model.removePopoverModel(this.startPopover.getID());this.model.removePopoverModel(this.endPopover.getID())};h.prototype.removePopover=function(){this.didReset()};h.prototype.getPointToSnapTo=function(a,b){if(!this.f.getActivePage().hasCad()&&!this.f.getActivePage().hasLinkedPage())return null;var d=this._widget.requestView(a);if(d){var e=this.getScenePoint(a);(d=d.getClosestLineworkPointFromPoint(e,b))&&(d=this.sceneToWorld(d));return d}return null};h.prototype._isHovering=
function(a){if((a=this._getDistanceToPoints(a))&&(a.toStartPoint<c.RulerPoint.CLOSETODISTANCE||a.toEndPoint<c.RulerPoint.CLOSETODISTANCE))return this.setCursor("cursor-moveObject"),!0;this.setCursor(this.getDefaultCursor());return!1};h.prototype._getDistanceToPoints=function(a){var a=this.getScenePoint(a),b=this.model.ruler.startPoint,d=this.model.ruler.endPoint;if(b&&d)return b=this._widget.getWorld().getScenePointFromWorld(b),d=this._widget.getWorld().getScenePointFromWorld(d),b=a.sizeTo(b),b=Math.sqrt(Math.abs(b.width*
b.width+b.height*b.height)),a=a.sizeTo(d),a=Math.sqrt(Math.abs(a.width*a.width+a.height*a.height)),{toStartPoint:b,toEndPoint:a}};h.prototype._createAnnotation=function(){var a=this.startPopover.getMeasureData();this.t.d.fromX=a.x;this.t.d.fromY=a.y;b.extend(this.t.d,this.endPopover.getMeasureData());var a=this.t.getRenderedHtml(),e=new d.Rect(this.model.ruler.startPoint,this.model.ruler.startPoint.sizeTo(this.model.ruler.endPoint));this.f.emit("module.annotation.createAnnotation",e,a,g.AnnotationType.ANNOT_ARROW);
this.f.emit("toolManager.deactivateTool")};h.prototype.canBeInterrupted=function(a){return this.getCurrentState().canBeInterrupted||this.getCurrentState().canBeInterruptedForNavigation&&a&&(a.getIID()===i.TOOLS.PAN||a.getIID()===i.TOOLS.NAVIGATIONPAN||a.getIID()===i.TOOLS.TOUCH||a.getIID()===i.TOOLS.ZOOM)};return h});
define("web-viewer/measure/BarcodeMeasureTool","underscore web-viewer/measure/AbstractMeasureTool web-viewer/measure/MeasureConstants web-viewer/measure/MeasurePopoverModel web-viewer/utils/ViewerUtils web-viewer/core/CoreConstants".split(" "),function(b,a,c,f,k,j){var e=function(b,d){a.call(this,b,j.TOOLS.MEASURE_BARCODE);this.f=b;this.measureModule=d;this.model.setRulerType(c.MeasureType.Barcode)};e.prototype=Object.create(a.prototype);e.prototype.constructor=e;e.prototype.showInfo=function(a){var d=
[];a&&(a.status.info&&(b.isArray(a.status.info.barcodegv)||(a.status.info.barcodegv=[a.status.info.barcodegv]),this.f.i18n.loadBundle("viewer",b.bind(function(){b.each(a.status.info.barcodegv,b.bind(function(a){var e=a.xml.Barcodes.Barcode;b.isArray(e)||(e=[e]);d[a.color]="";b.each(e,b.bind(function(b,e){0<e&&(d[a.color]+=" | ");d[a.color]+=b.attributes.Type+": "+b.Decoded;b.Decoded_reverse_dir&&(d[a.color]+=" (--\>) "+b.Decoded_reverse_dir+" (<--)");void 0!==b.Magnification&&(100!==parseInt(b.Magnification,
10)&&999!==parseInt(b.Magnification,10))&&(d[a.color]+=" "+b.Magnification+"%");var c=k.parseFloat(b.BWR);999>c&&0!==c&&(d[a.color]+=" ["+c+" "+this.f.i18n.t("Unitmm")+"] ")},this))},this))},this))),this.f.emit("channels.informationAdded",d));this.showPopover(d)};e.prototype.removePopover=function(){this.popover&&this.model.removePopoverModel(this.popover.getID())};e.prototype.calculate=function(){this.getInfo({})};e.prototype.canBeUsedOnActivePage=function(){var a=this.f.getActivePage();return a&&
a.hasGraphics()};e.prototype.createPopoverModel=function(a,b){return new f(this.f,b,"Channels",$("<i>").addClass("icon icon-normal icon-WCR_Measure-Barcode"),a,this._needsTotalCount())};return e});
define("web-viewer/measure/BrailleMeasureTool","underscore web-viewer/measure/AbstractMeasureTool web-viewer/measure/MeasureConstants web-viewer/utils/ViewerUtils web-viewer/core/CoreConstants component/tooltip/Tooltip".split(" "),function(b,a,c,f,k,j){f=function(e,g){a.call(this,e,k.TOOLS.MEASURE_BRAILLE);this.model.setRulerType(c.MeasureType.Braille);this.language=c.BrailleLanguage[e.getOption("PREFERENCES_BRAILLE_LANGUAGE")]?c.BrailleLanguage[e.getOption("PREFERENCES_BRAILLE_LANGUAGE")].url:c.BrailleLanguage[c.LanguageDefault].url;
this.f=e;this.measureModule=g;e.getCurrentUser().on("options.changed.PREFERENCES_BRAILLE_LANGUAGE",b.bind(function(a,b){this.language=c.BrailleLanguage[b].url;this.removePopover();this.calculate()},this))};f.prototype=Object.create(a.prototype);f.prototype.constructor=f;f.prototype.showInfo=function(a,c){var d=!0,f=!1,h=[];if(a){if(a.status.info){var m=a.status.info.braille;m instanceof Array||(m=[m]);b.each(m,function(a){var e=a.xml.Regions.Braille;e instanceof Array||(e=[e]);b.each(e,function(c,
l){f=!0;"Pass"!==c.attributes.Status&&(d=!1);var g="";1<e.length&&(g=l+1+",");void 0===h[a.color]&&(h[a.color]="");c.Line instanceof Array?b.each(c.Line,function(b,d){1<=d&&(h[a.color]+=" ");h[a.color]+="["+g+(d+1)+"] "+b}):h[a.color]=1<e.length?h[a.color]+("["+g+"1] "+c.Line+" "):h[a.color]+c.Line},this)},this)}this.f.emit("channels.informationAdded",h)}m=null;f&&(m=d?this._createPassIcon():this._createFailIcon());var l=$("<span>").append($("<i>").addClass("icon icon-normal icon-WCR_Measure-Braille")).append($("<span>").addClass("titleText").text(c.brlang));
this.showPopover(h,null,l,m)};f.prototype.calculate=function(){var a=this.language;if(void 0===a||a===c.BrailleLanguage[c.LanguageAutomatic].url)a=c.BrailleLanguage[c.LanguageLocales[this.f.getCurrentUser().getLocale()]].url,void 0===a&&(a=c.BrailleLanguage[c.LanguageDefault].url);this.getInfo({brlang:a})};f.prototype.canBeUsedOnActivePage=function(){var a=this.f.getActivePage();return a&&a.hasGraphics()};f.prototype._createPassIcon=function(){var a=$("<i>").addClass("icon icon-normal icon icon-WCR_Msg-Success-round"),
b=$("<div>").append(a);new j(this.f.i18n,a,b,this.f.getContext(),!1,"viewer","BraillePass");return b};f.prototype._createFailIcon=function(){var a=$("<i>").addClass("icon icon-normal icon icon-WCR_Msg-Warning"),b=$("<div>").append(a);new j(this.f.i18n,a,b,this.f.getContext(),!1,"viewer","BrailleFail");return b};return f});
define("web-viewer/measure/EyeDropperUnitSelector",["web-viewer/layout/component/DropdownMiniButton","web-viewer/core/CoreConstants","underscore"],function(b,a,c){var f=function(f){this.f=f;this._optionButton=new b(this.f,"eyeDropperUnitSettings","icon-WCR_Settings-submenu");this._optionButton.setTooltip("viewer","UnitSettings");this.f.i18n.loadBundle("viewer",function(){this._optionButton.addOption({name:"eyeDropperUnitPixels",content:this.f.i18n.t(a.EyeDropperUnitsLocNames[a.EyeDropperUnits.PIXELS]),
onchange:c.bind(this._toggleEyeDropperUnit,this,a.EyeDropperUnits.PIXELS),userCannotUncheck:!0});this._optionButton.addOption({name:"eyeDropperUnitSQMM",content:this.f.i18n.t(a.EyeDropperUnitsLocNames[a.EyeDropperUnits.SQMM]),onchange:c.bind(this._toggleEyeDropperUnit,this,a.EyeDropperUnits.SQMM),userCannotUncheck:!0});this._optionButton.addOption({name:"eyeDropperUnitSQCM",content:this.f.i18n.t(a.EyeDropperUnitsLocNames[a.EyeDropperUnits.SQCM]),onchange:c.bind(this._toggleEyeDropperUnit,this,a.EyeDropperUnits.SQCM),
userCannotUncheck:!0});this._optionButton.addOption({name:"eyeDropperUnitSQINCH",content:this.f.i18n.t(a.EyeDropperUnitsLocNames[a.EyeDropperUnits.SQINCH]),onchange:c.bind(this._toggleEyeDropperUnit,this,a.EyeDropperUnits.SQINCH),userCannotUncheck:!0});this._optionButton.addOption({name:"eyeDropperUnitPercent",content:this.f.i18n.t(a.EyeDropperUnitsLocNames[a.EyeDropperUnits.PERCENT]),onchange:c.bind(this._toggleEyeDropperUnit,this,a.EyeDropperUnits.PERCENT),userCannotUncheck:!0});this._updateOptions();
this.f.getCurrentUser().on("options.changed.PREFERENCES_UNIT_EYEDROPPER",c.bind(this._updateOptions,this))},this)};f.prototype.getButtonElement=function(){return this._optionButton.element};f.prototype._toggleEyeDropperUnit=function(b,c){c&&(this.f.setOption("PREFERENCES_UNIT_EYEDROPPER",b,!0),b!==a.EyeDropperUnits.PERCENT&&this.f.setOption("PREFERENCES_UNIT_SIZE",b,!0))};f.prototype._updateOptions=function(){var b=this.f.getOption("PREFERENCES_UNIT_EYEDROPPER");this._optionButton.toggleOption("eyeDropperUnitPixels",
b===a.EyeDropperUnits.PIXELS);this._optionButton.toggleOption("eyeDropperUnitSQMM",b===a.EyeDropperUnits.SQMM);this._optionButton.toggleOption("eyeDropperUnitSQCM",b===a.EyeDropperUnits.SQCM);this._optionButton.toggleOption("eyeDropperUnitSQINCH",b===a.EyeDropperUnits.SQINCH);this._optionButton.toggleOption("eyeDropperUnitPercent",b===a.EyeDropperUnits.PERCENT)};return f});
define("web-viewer/measure/EyeDropperPopoverModel",["web-viewer/measure/MeasurePopoverModel","web-viewer/measure/EyeDropperUnitSelector","underscore","jquery"],function(b,a){var c=function(a,c,j,e,g,d,i){b.call(this,a,c,j,e,g,d,i);this._eyeDropperUnitSelector=null;this.f.getDocumentController().whenActivePageChangedAndParametersAvailable(this._updateEyeDropperUnitSelectorButton,this)};c.prototype=Object.create(b.prototype);c.prototype.constructor=c;c.prototype._updateEyeDropperUnitSelectorButton=
function(){this.f.getActivePage().isDigitalFilmPage()?null===this._eyeDropperUnitSelector?(this._eyeDropperUnitSelector=new a(this.f),this._headerExtra.append(this._eyeDropperUnitSelector.getButtonElement())):this._eyeDropperUnitSelector.getButtonElement().show():null!==this._eyeDropperUnitSelector&&this._eyeDropperUnitSelector.getButtonElement().hide()};return c});
define("web-viewer/measure/EyeDropperMeasureTool","underscore web-viewer/measure/AbstractMeasureTool web-viewer/measure/MeasureConstants web-viewer/measure/EyeDropperPopoverModel utils/ShapeUtils web-viewer/utils/ViewerUtils web-viewer/core/CoreConstants".split(" "),function(b,a,c,f,k,j,e){var g=function(d){a.call(this,d,e.TOOLS.MEASURE_EYEDROPPER);this.model.setRulerType(c.MeasureType.EyeDropper);this.registerState(this.clickState,b.defaults({enterState:b.bind(function(){var a=this.getWorldResolution();
if(null!==a){var b=c.ClickSize.NORMAL;this.f.getActivePage().isDigitalFilmPage()&&(b=c.ClickSize.DIGITAL_FILM);var d=b/a.x,a=b/a.y;this.model.setStartPoint(new k.Point(this.model.ruler.startPoint.x-d/2,this.model.ruler.startPoint.y-a/2));this.model.setEndPoint(new k.Point(this.model.ruler.startPoint.x+d,this.model.ruler.startPoint.y+a));this.calculate();this.changeState(this.defaultState)}},this)},this.getState(this.drawingState)));this._channels=[];this.f.getCurrentUser().on("options.changed.PREFERENCES_UNIT_EYEDROPPER",
b.bind(this._onEyeDropperUnitChanged,this));this.f.getCurrentUser().on("options.changed.PREFERENCES_UNIT_SIZE",b.bind(function(){var a=this.f.getOption("PREFERENCES_UNIT_SIZE");a!==e.SizeUnits.POINTS&&this.f.setOption("PREFERENCES_UNIT_EYEDROPPER",a,!0)},this))};g.prototype=Object.create(a.prototype);g.prototype.constructor=g;g.prototype.showInfo=function(a){this._channels=[];a&&a.status.info.dotpercentage&&(b.isArray(a.status.info.dotpercentage)||(a.status.info.dotpercentage=[a.status.info.dotpercentage]),
b.each(a.status.info.dotpercentage,function(a){this._channels[a.color]=j.parseFloat(a.dotvalue)},this));this._onEyeDropperUnitChanged(!0)};g.prototype._onEyeDropperUnitChanged=function(a){if(this.popover&&this.isPopoverShown||a)if((a=this.model.ruler)&&a.startPoint&&a.endPoint){var c=a.startPoint.sizeTo(a.endPoint),a=e.EyeDropperUnits.PERCENT;this.f.getActivePage().isDigitalFilmPage()&&(a=this.f.getOption("PREFERENCES_UNIT_EYEDROPPER"));var h=c.width,c=c.height,g=0;switch(a){case e.EyeDropperUnits.SQMM:g=
h*c;break;case e.EyeDropperUnits.SQCM:g=j.parseFloat(j.convertFromMmValue(h,e.SizeUnits.CM))*j.parseFloat(j.convertFromMmValue(c,e.SizeUnits.CM));break;case e.EyeDropperUnits.SQINCH:g=j.parseFloat(j.convertFromMmValue(h,e.SizeUnits.INCH))*j.parseFloat(j.convertFromMmValue(c,e.SizeUnits.INCH));break;case e.EyeDropperUnits.PIXELS:var l=this.getWorldResolution();null!==l&&(g=h*l.x*c*l.y);break;case e.EyeDropperUnits.PERCENT:g=100}var f=[];b.each(this._channels,function(a,b){a&&(f[b]=""+a/100*g)},this);
f.makeTotalCount=!0;f.unit=this.f.i18n.t(e.EyeDropperUnitsShortLocNames[a]);f.unitFix=e.EyeDropperUnitsFixes[a];this.f.emit("channels.informationAdded",f);this.showPopover(f)}};g.prototype.calculate=function(){this.getInfo({})};g.prototype.canBeUsedOnActivePage=function(){var a=this.f.getActivePage();return a&&a.hasGraphics()};g.prototype._needsTotalCount=function(){return!0};g.prototype.createPopoverModel=function(a,b){return new f(this.f,b,"Channels",$("<i>").addClass("icon icon-normal icon-WCR_Measure-Colorpicker"),
a,this._needsTotalCount())};return g});define("tpl!web-viewer/measure/CaliperPopoverTemplate",function(){return function(b){var a;return b=""+("<table>\r\n\t<tr>\r\n\t\t<td><strong>"+(null==(a=b.endPointLabel)?"":_.escape(a))+": </strong></td>\r\n\t\t<td>"+(null==(a=b.endPointValue)?"":_.escape(a))+"</td>\r\n\t</tr>\r\n\t<tr>\r\n\t\t<td><strong>"+(null==(a=b.i18n("GapSize"))?"":_.escape(a))+": </strong></td>\r\n\t\t<td>"+(null==(a=b.gap)?"":_.escape(a))+"</td>\r\n\t</tr>\r\n</table>")}});
define("web-viewer/measure/CaliperPopoverModel","web-viewer/viewport/model/ViewportPopoverModel tpl!web-viewer/measure/CaliperPopoverTemplate utils/ShapeUtils web-viewer/utils/ViewerUtils Template web-viewer/core/CoreConstants underscore".split(" "),function(b,a,c,f,k,j,e){var g=function(d,g,h){b.call(this,d,h);this.div=$("<div/>").addClass("measureInfo caliperPopover");this.t=new k(d.i18n,a);this.t.setContext(this.div);this.t.d.isMeasuringHeight=!0;this._endPoint=new c.Point;this._gapinMm=this._endPointValueInMm=
null;d.i18n.loadBundle("viewer",e.bind(function(){this.t.render()},this));this.f.getCurrentUser().on("options.changed.PREFERENCES_UNIT_SIZE",e.bind(this.recalculateGap,this));this.frame=null;this.getFrame=function(){return this.frame?this.frame:new c.Rect(new c.Point(0,0),new c.Size(1,1))};this.getContent=function(){return this.div};this.getPreferredPosition=function(){return this.t.d.isMeasuringHeight?"bottom":"right"};this.getRestrictBorder=function(){return 0};this.isInteractive=function(){return!0};
this.getContext=function(){return this.f.getContext().find(".viewport")};this.render=e.throttle(e.bind(function(){this.t.render()},this),100);this.getClass=function(){return"transparent"}};g.prototype=Object.create(b.prototype);g.prototype.constructor=g;g.prototype.getChannelsInformation=function(){return this._channelsInfo};g.prototype.setGap=function(a){this._gapinMm=a.getVector().getLength();this.t.d.gap=this._convertToCorrectUnits(this._gapinMm);this.render()};g.prototype.recalculateGap=function(){null!==
this._gapinMm&&null!==this._endPointValueInMm&&(this.t.d.endPointValue=this._convertToCorrectUnits(this._endPointValueInMm),this.t.d.gap=this._convertToCorrectUnits(this._gapinMm),this.render())};g.prototype.setEndPoint=function(a){if(this._endPoint=a)this.t.d.endPointValue=this._convertToCorrectUnits(this.t.d.isMeasuringHeight?this._endPoint.y:this._endPoint.x)};g.prototype._convertToCorrectUnits=function(a){var b=null;this.f.getUnits()===j.SizeUnits.PIXELS&&(b=this.f.getActivePage(),b=this.t.d.isMeasuringHeight?
b.getParam("resolutiony"):b.getParam("resolutionx"));a=f.convertFromMmValue(a,this.f.getUnits(),this.f.getUnitsFix(),f.parseFloat(b));b=this.f.i18n.t(this.f.getUnitsLocName());return a+" "+b};g.prototype.setFrame=function(a){this.frame=a};g.prototype.setMeasuringHeight=function(a){this.t.d.isMeasuringHeight=a;this._endPoint&&(this.t.d.isMeasuringHeight?(this.t.d.endPointLabel="Y",a=this._endPoint.copy(),a=this._coordinates.getTransformedPoint(a),this.t.d.endPointValue=this._convertToCorrectUnits(a.y),
this._endPointValueInMm=a.y):(this.t.d.endPointLabel="X",a=this._endPoint.copy(),a=this._coordinates.getTransformedPoint(a),this.t.d.endPointValue=this._convertToCorrectUnits(a.x),this._endPointValueInMm=a.x));this.render()};return g});
define("web-viewer/measure/CaliperLayerModel","underscore web-viewer/viewport/model/ViewportLayerModel web-viewer/measure/CaliperPopoverModel web-viewer/utils/DrawUtils utils/ShapeUtils web-viewer/utils/LineworkWrapper web-viewer/utils/LineworkPoint web-viewer/utils/ListenerUtil web-viewer/measure/MeasureConstants".split(" "),function(b,a,c,f,k,j,e,g,d){var i=function(b,d,c){a.call(this,b,d);g.mixin(this,b);this._caliperModel=c;this._caliperPopover=null;this._popoverFrame=new k.Rect;this._startPoint=
null;this._registerListener("changed.currentGap",this.modelChanged,this,this._caliperModel);this._registerListener("changed.currentGap.vector",this.modelChanged,this,this._caliperModel)};i.prototype=Object.create(a.prototype);i.prototype.constructor=i;i.prototype.setStartPoint=function(a){this._startPoint=a;this.modelChanged()};i.prototype.getStartPoint=function(){return this._startPoint};i.prototype.getLinework=function(a,b,d){if(this._startPoint){var a=new j,b=new j,c=new j,g=new j,i=this._caliperModel.getCurrentGap().getVector(),
p=i.getLength(),u=i.getAngleInDegrees();if(this._caliperModel.isMeasuringHeight(i)){if(0===u||90===u)p=-p;i=new k.Rect(new k.Point(d.left(),d.top()),new k.Size(d.right()-d.left(),Math.min(this._startPoint.y,this._startPoint.y+p)-d.top()));i.normalize();c.rect=i;i=Math.max(this._startPoint.y,this._startPoint.y+p);i=new k.Rect(new k.Point(d.left(),i),new k.Size(d.right()-d.left(),d.bottom()-i));i.normalize();g.rect=i;i=new e;i.makeMoveTo(d.left(),this._startPoint.y);a.pointArray.push(i);i=new e;i.makeLineTo(d.right(),
this._startPoint.y);a.pointArray.push(i);i=new e;i.makeMoveTo(d.left(),this._startPoint.y+p);b.pointArray.push(i);i=new e;i.makeLineTo(d.right(),this._startPoint.y+p);b.pointArray.push(i);this._popoverFrame.origin.x=d.left();this._popoverFrame.origin.y=this._startPoint.y+p;this._popoverFrame.size.width=d.size.width;this._popoverFrame.size.height=1E-8}else this._caliperModel.isMeasuringWidth(i)&&(180===u&&(p=-p),i=new k.Rect(new k.Point(d.left(),d.top()),new k.Size(Math.min(this._startPoint.x,this._startPoint.x+
p)-d.left(),d.bottom()-d.top())),i.normalize(),c.rect=i,i=Math.max(this._startPoint.x,this._startPoint.x+p),i=new k.Rect(new k.Point(i,d.top()),new k.Size(d.right()-i,d.bottom()-d.top())),i.normalize(),g.rect=i,i=new e,i.makeMoveTo(this._startPoint.x,d.top()),a.pointArray.push(i),i=new e,i.makeLineTo(this._startPoint.x,d.bottom()),a.pointArray.push(i),i=new e,i.makeMoveTo(this._startPoint.x+p,d.top()),b.pointArray.push(i),i=new e,i.makeLineTo(this._startPoint.x+p,d.bottom()),b.pointArray.push(i),
this._popoverFrame.origin.x=this._startPoint.x+p,this._popoverFrame.origin.y=d.top(),this._popoverFrame.size.width=1E-8,this._popoverFrame.size.height=d.size.height);a.dash=[4,3];a.color="rgba(210,210,210,0.9)";a.type=f.LWTYPE_LINE;b.dash=[4,3];b.color="rgba(210,210,210,0.9)";b.type=f.LWTYPE_LINE;c.type=f.LWTYPE_RECT;c.fillcolor="rgba(0, 0, 0, 0.40)";c.color="rgba(0, 0, 0, 1.00)";c.linewidth=1;g.type=f.LWTYPE_RECT;g.fillcolor="rgba(0, 0, 0, 0.40)";g.color="rgba(0, 0, 0, 1.00)";g.linewidth=1;return[c,
g,a,b]}};i.prototype.getEndPoint=function(){if(this._startPoint){var a=this._caliperModel.getCurrentGap().getVector(),b=a.getLength(),d=a.getAngleInDegrees();if(this._caliperModel.isMeasuringHeight(a)){if(0===d||90===d)b=-b;return new k.Point(this._startPoint.x,this._startPoint.y+b)}if(this._caliperModel.isMeasuringWidth(a))return 180===d&&(b=-b),new k.Point(this._startPoint.x+b,this._startPoint.y)}else return null};i.prototype.setPoints=function(a,b,d,c){var e=this.getStartPoint(),g=this.getEndPoint(),
i=this._caliperModel.getCurrentGap().getVector();if(d)c=b.y-g.y,b=b.x-g.x,0!==c?a=new k.Point(e.x,e.y+c):0!==b&&(a=new k.Point(e.x+b,e.y));else{var d=g=0,g=b.x-a.x,f=b.y-a.y,b=Math.abs(g),d=Math.abs(f),j=b>d;c&&(j=this._caliperModel.isMeasuringWidth(i));j?(g=0>g?180:0,d=b):g=0>f?90:-90;i.setAngleInDegrees(g);i.setLength(d)}a.equals(e)||(this._startPoint=a);this._caliperModel.setCurrentGapVector(i);this.modelChanged()};i.prototype.showPopover=function(){this._caliperPopover||(this._caliperPopover=
new c(this.f,null,"CaliperPopover",this),this.modelChanged(),this.addPopoverModel(this._caliperPopover))};i.prototype.hidePopover=function(){this._caliperPopover&&(this.removePopoverModel(this._caliperPopover.getID()),this.removePopover(this._caliperPopover.getID()),this._caliperPopover=null)};i.prototype.modelChanged=function(c){var e=null;if(!b.isBoolean(c)||b.isBoolean(c)&&!c)this._caliperPopover&&(this._caliperPopover.setGap(this._caliperModel.getCurrentGap()),this._caliperPopover.setEndPoint(this.getEndPoint()),
this._caliperPopover.setMeasuringHeight(this._caliperModel.isMeasuringHeight(this._caliperModel.getCurrentGap().getVector())),this._caliperPopover.setFrame(this._popoverFrame)),this._startPoint&&(this._caliperModel.getCurrentGap()&&0!==this._caliperModel.getCurrentGap().getVector().getLength())&&(e=this._caliperModel.isMeasuringHeight(this._caliperModel.getCurrentGap().getVector())?{mode:d.MeasureDrawType.HEIGHT,y:this._startPoint.y,h:this._caliperModel.getCurrentGap().getVector().getLength()}:{mode:d.MeasureDrawType.WIDTH,
x:this._startPoint.x,w:this._caliperModel.getCurrentGap().getVector().getLength()});this.f.emit("selection.changed",e);a.prototype.modelChanged.call(this)};return i});
define("web-viewer/measure/CaliperTool","underscore web-viewer/viewport/tools/AbstractTool utils/ShapeUtils web-viewer/measure/CaliperLayerModel web-viewer/measure/MeasureConstants web-viewer/core/CoreConstants".split(" "),function(b,a,c,f,k,j){c=function(c,g){a.call(this,c,j.TOOLS.MEASURE_CALIPER);this.CLOSETODISTANCE=16;this._caliperModel=g;this._caliperLayerModel=new f(c,this.getIID(),g);this.registerState("default",{enterState:b.bind(function(){this._caliperLayerModel.hidePopover();this._caliperLayerModel.setStartPoint(null);
this._caliperModel.resetFreeformVector()},this),mousedown:b.bind(function(a){var b=this.keepPointWithinWorldBounds(this.getWorldPoint(a),!1);this._caliperLayerModel.setStartPoint(b);this._caliperLayerModel.getEndPoint()||this._moveEndLine(a);this.changeState("dragging")},this),mouseup:function(){},mousemove:function(){},mouseout:function(){},mouseleave:function(){},contextmenu:b.bind(function(a){a.preventDefault();a.stopPropagation()},this),canBeInterrupted:!0});this.registerState("dragging",b.defaults({enterState:b.bind(function(){this._caliperLayerModel.showPopover();
this.f.emit("viewport.startInteractive")},this),leaveState:b.bind(function(){this.f.emit("viewport.stopInteractive")},this),mousedown:function(){},mouseup:b.bind(function(){var a=this._caliperModel.getCurrentGap(),b=a.getStyle();(b===k.CaliperStyle.Fixed||b===k.CaliperStyle.Preset||0<a.getVector().getLength())&&this.changeState("drawn")},this),mousemove:b.bind(function(a){var b=this._caliperModel.getCurrentGap().getStyle();b===k.CaliperStyle.Fixed||b===k.CaliperStyle.Preset?this._moveStartLine(a):
this._moveEndLine(a)},this),canBeInterrupted:!1},this.getState("default")));this.registerState("drawn",b.defaults({enterState:function(){},mousemove:b.bind(function(a){this._isHovering(a)&&this.changeState("hover")},this),canBeInterrupted:!0},this.getState("default")));this.registerState("hover",b.defaults({enterState:function(){},mousedown:b.bind(function(a){var a=this.getWorldPoint(a),b=this._caliperLayerModel.getStartPoint(),c=this._caliperLayerModel.getEndPoint();this._isCloseToLine(b,a)?this.changeState("movingStartLine"):
this._isCloseToLine(c,a)&&this.changeState("movingEndLine")},this),mousemove:b.bind(function(a){this._isHovering(a)||this.changeState("drawn")},this),mouseleave:b.bind(function(){this.changeState("drawn")},this),canBeInterrupted:!0},this.getState("default")));this.registerState("movingEndLine",b.defaults({enterState:b.bind(function(){this.f.emit("viewport.startInteractive")},this),leaveState:b.bind(function(){this.f.emit("viewport.stopInteractive")},this),mouseleave:b.bind(function(){this.changeState("drawn")},
this),mouseup:b.bind(function(){this.changeState("drawn")},this),mousemove:b.bind(function(a){this._moveEndLine(a,!0)},this),canBeInterrupted:!1},this.getState("default")));this.registerState("movingStartLine",b.defaults({enterState:b.bind(function(){this.f.emit("viewport.startInteractive")},this),leaveState:b.bind(function(){this.f.emit("viewport.stopInteractive")},this),mouseleave:b.bind(function(){this.changeState("drawn")},this),mouseup:b.bind(function(){this.changeState("drawn")},this),mousemove:b.bind(function(a){this._moveStartLine(a)},
this),canBeInterrupted:!1},this.getState("default")));this.registerActiveEvents(["mousedown","mousemove","mouseup","mouseleave","contextmenu"]);this.activeKeyEvents.push(["esc",b.bind(function(a){this.changeState("default");a.preventDefault();a.stopPropagation()},this),"keyup"]);this._override("initialize",function(a,b){this._super(a,b);this.changeState("default")});this._override("activate",function(a){this._super(a);a||this.f.getModule("viewport").addLayer(this.getIID(),this._caliperLayerModel)});
this._override("deactivate",function(a){this._super(a);a||(this._caliperLayerModel.modelChanged(!0),this.f.getModule("viewport").removeLayer(this.getIID()));(!a||b.contains(["movingStartLine","movingEndLine","dragging"],this.getCurrentStateName()))&&this.changeState("default")})};c.prototype=Object.create(a.prototype);c.prototype.constructor=c;c.prototype._moveEndLine=function(a,b){var c=this._caliperModel.getCurrentGap().getStyle(),f=this.keepPointWithinWorldBounds(this.getWorldPoint(a),!1),h=this._caliperLayerModel.getStartPoint();
c===k.CaliperStyle.Freeform?this._caliperLayerModel.setPoints(h,f,!1,b):(c===k.CaliperStyle.Fixed||c===k.CaliperStyle.Preset)&&this._caliperLayerModel.setPoints(h,f,!0,b)};c.prototype._moveStartLine=function(a){var b=this._caliperModel.getCurrentGap().getStyle(),a=this.keepPointWithinWorldBounds(this.getWorldPoint(a),!1);b===k.CaliperStyle.Freeform?(b=this._caliperLayerModel.getEndPoint(),this._caliperLayerModel.setPoints(a,b,!1,!0)):(b===k.CaliperStyle.Fixed||b===k.CaliperStyle.Preset)&&this._caliperLayerModel.setStartPoint(a)};
c.prototype._isHovering=function(a){var a=this.getWorldPoint(a),b=this._caliperLayerModel.getStartPoint(),c=this._caliperLayerModel.getEndPoint();if(this._isCloseToLine(b,a)||this._isCloseToLine(c,a))return a=this._widget.getWorld().getRotation(),this._caliperModel.isMeasuringHeight(this._caliperModel.getCurrentGap().getVector())?90===a%180?this.setCursor("cursor-resizeE"):this.setCursor("cursor-resizeN"):this._caliperModel.isMeasuringWidth(this._caliperModel.getCurrentGap().getVector())&&(90===a%
180?this.setCursor("cursor-resizeN"):this.setCursor("cursor-resizeE")),!0;this.setCursor(this.getDefaultCursor());return!1};c.prototype._isCloseToLine=function(a,b){var c=this._widget.getWorld().getZoom();return Math.abs(this._getDistanceToLine(a,b))<this.CLOSETODISTANCE/c};c.prototype._getDistanceToLine=function(a,b){var c=this._caliperModel.getCurrentGap().getVector();if(this._caliperModel.isMeasuringHeight(c))return a.y-b.y;if(this._caliperModel.isMeasuringWidth(c))return a.x-b.x};c.prototype.canBeInterrupted=
function(){return this.getCurrentState().canBeInterrupted};c.prototype.getCaliperModel=function(){return this._caliperModel};c.prototype.canBeUsedOnActivePage=function(){return!0};c.prototype.updateIfNeeded=function(){};c.prototype.getDefaultCursor=function(){return"rulerCursor"};c.prototype.doActivation=function(){this._caliperLayerModel.modelChanged(!1);a.prototype.doActivation.call(this)};c.prototype.getToolState=function(){var a=this._caliperModel.getCurrentGap();return{caliperStyle:a.getStyle(),
caliperGapVector:a.getVector(),startPoint:this._caliperLayerModel.getStartPoint(),isActive:this.isActive()}};c.prototype.setToolState=function(a){if(a.isActive){this.f.emit("toolManager.activateTool",this);this.f.emit("toolManager.interruptTools",!0);var c=a.caliperStyle,d=a.caliperGapVector;if(void 0!==c&&void 0!==d&&void 0!==a.startPoint){var f=b.bind(function(a,b){this._caliperModel.setCurrentGapById(a);this._caliperModel.setCurrentGapVector(b)},this);if(c===k.CaliperStyle.Freeform){var h=this._caliperModel.getFreeformGap();
f(h.getId(),d)}else h=this._caliperModel.getFixedGap(),f(h.getId(),d),c===k.CaliperStyle.Preset&&(c=this._caliperModel.getSimilarPreset(this._caliperModel.getCurrentGap()),void 0!==c&&this._caliperModel.setCurrentGapById(c.getId()));this._caliperLayerModel.setStartPoint(a.startPoint);this._caliperLayerModel.showPopover()}}};return c});
define("web-viewer/measure/CaliperGap",["utils/ShapeUtils","underscore"],function(){var b=function(a,b,f){this._id=a;this._style=b;this._vector=f};b.prototype.getId=function(){return this._id};b.prototype.getStyle=function(){return this._style};b.prototype.getVector=function(){return this._vector.copy()};b.prototype.setVector=function(a){this._vector=a};b.prototype.isSimilarTo=function(a){return this._vector.equals(a.getVector())};return b});
define("web-viewer/measure/CaliperModel",["web-viewer/core/AbstractModel","web-viewer/measure/CaliperGap","web-viewer/measure/MeasureConstants","utils/ShapeUtils","underscore"],function(b,a,c,f,k){var j=function(e,g){b.call(this,e,g);this._nextId=0;this._freeformVector=new f.Vector(0,0,-Math.PI/2);this._freeform=new a(this._getNextId(),c.CaliperStyle.Freeform,this._freeformVector);var d=new f.Vector(0,0.8);this._fixed=new a(this._getNextId(),c.CaliperStyle.Fixed,d);this._presetGaps=[];this._readPresets();
this._currentGap=null};j.prototype=Object.create(b.prototype);j.prototype.constructor=j;j.prototype.resetFreeformVector=function(){var a=this.getCurrentGap();a&&a.getStyle()===c.CaliperStyle.Freeform&&this.setCurrentGapVector(this._freeformVector)};j.prototype._getNextId=function(){var a=this._nextId;this._nextId++;return""+a};j.prototype.getFreeformGap=function(){return this._freeform};j.prototype.getFixedGap=function(){return this._fixed};j.prototype.getAllGaps=function(){var a=[this._freeform,
this._fixed],b=k.sortBy(this._presetGaps,function(a){return 1E4*Math.abs(a.getVector().getAngleInDegrees())+a.getVector().getLength()});return k.union(a,b)};j.prototype.getCurrentGap=function(){return this._currentGap};j.prototype.getGapById=function(a){return k.find(this.getAllGaps(),function(b){return b.getId()===a})};j.prototype.setCurrentGapById=function(a){var b=this.getGapById(a);b?(a=this._currentGap,this._currentGap=b,this._fireChange(!1,["currentGap"],a,this._currentGap)):this.f.debug.error("Gap with id "+
a+" not found")};j.prototype.setCurrentGapVector=function(a){var b=this._currentGap.getVector();this._currentGap.setVector(a);this._fireChange(!1,["currentGap","vector"],b,a)};j.prototype.saveCurrentGapAsPreset=function(){var b=new a(this._getNextId(),c.CaliperStyle.Preset,this._currentGap.getVector());this._presetGaps.push(b);this._persistPresets();this._fireChange(!1,["presetGaps","new"],null,b)};j.prototype._readPresets=function(){var b=this.f.getOption("CALIPER_PRESETS");b&&(b=JSON.parse(b),this._presetGaps=
k.map(b,function(b){return new a(this._getNextId(),c.CaliperStyle.Preset,new f.Vector(b.x,b.y))},this))};j.prototype._persistPresets=function(){var a=k.map(this._presetGaps,function(a){return a.getVector()}),a=JSON.stringify(a);this.f.setOption("CALIPER_PRESETS",a)};j.prototype.deleteCurrentGapFromPresets=function(){this._currentGap.getStyle()!==c.CaliperStyle.Preset&&this.f.debug.error("Cannot delete a non-preset style");this._presetGaps=k.without(this._presetGaps,this._currentGap);this._persistPresets();
this._fireChange(!1,["presetGaps","deleted"],this._currentGap,null)};j.prototype.getSimilarPreset=function(a){return k.find(this._presetGaps,function(b){return b.isSimilarTo(a)})};j.prototype.isMeasuringHeight=function(a){a=a.getAngleInDegrees();return 90===a||-90===a};j.prototype.isMeasuringWidth=function(a){a=a.getAngleInDegrees();return 0===a||180===a};return j});
define("web-viewer/measure/ScreenRulingUnitSelector",["web-viewer/layout/component/DropdownMiniButton","web-viewer/core/CoreConstants","web-viewer/measure/MeasureConstants","underscore"],function(b,a,c,f){var k=function(j){this.f=j;this._optionButton=new b(j,"screenRulingUnitSettings","icon-WCR_Settings-submenu");j.i18n.loadBundle("viewer",function(){function b(a,c,e){e&&this.setUnitAndMode(a,c)}function g(a,b){b&&this.setOrientation(a)}this._optionButton.addOption({name:"unitLpmm",content:this.f.i18n.t("UnitScreenmm"),
onchange:f.bind(b,this,a.ResolutionUnits.PPMM,c.ScreenRulingMode.LINES),userCannotUncheck:!0});this._optionButton.addOption({name:"unitLpcm",content:this.f.i18n.t("UnitScreencm"),onchange:f.bind(b,this,a.ResolutionUnits.PPCM,c.ScreenRulingMode.LINES),userCannotUncheck:!0});this._optionButton.addOption({name:"unitLpi",content:this.f.i18n.t("UnitScreenInch"),onchange:f.bind(b,this,a.ResolutionUnits.PPI,c.ScreenRulingMode.LINES),userCannotUncheck:!0});this._optionButton.addOption({name:"unitDeg",content:this.f.i18n.t("UnitDegree"),
onchange:f.bind(b,this,0,c.ScreenRulingMode.ANGLE),userCannotUncheck:!0});this._optionButton.addOption({name:"unitLpmmDeg",content:this.f.i18n.t("UnitDegreemm"),onchange:f.bind(b,this,a.ResolutionUnits.PPMM,c.ScreenRulingMode.BOTH),userCannotUncheck:!0});this._optionButton.addOption({name:"unitLpcmDeg",content:this.f.i18n.t("UnitDegreecm"),onchange:f.bind(b,this,a.ResolutionUnits.PPCM,c.ScreenRulingMode.BOTH),userCannotUncheck:!0});this._optionButton.addOption({name:"unitLpiDeg",content:this.f.i18n.t("UnitDegreeInch"),
onchange:f.bind(b,this,a.ResolutionUnits.PPI,c.ScreenRulingMode.BOTH),userCannotUncheck:!0});this._optionButton.addDivider();this._optionButton.addOption({name:"scrOrientationCW",content:this.f.i18n.t("ScreenCW"),onchange:f.bind(g,this,c.ScreenRulingOrientation.CW),userCannotUncheck:!0});this._optionButton.addOption({name:"scrOrientationCCW",content:this.f.i18n.t("ScreenCCW"),onchange:f.bind(g,this,c.ScreenRulingOrientation.CCW),userCannotUncheck:!0});this._updateUnitOptions();this._updateOrientationOptions();
this._optionButton.setTooltip("viewer","UnitSettings");this.f.getCurrentUser().on("options.changed.PREFERENCES_UNIT_SCREENRULING",f.bind(this._updateUnitOptions,this));this.f.getCurrentUser().on("options.changed.PREFERENCES_UNIT_SCREEN",f.bind(this._updateUnitOptions,this));this.f.getCurrentUser().on("options.changed.PREFERENCES_SCREEN_ORIENTATION",f.bind(this._updateOrientationOptions,this))},this)};k.prototype.getButtonElement=function(){return this._optionButton.element};k.prototype.setUnitAndMode=
function(a,b){this.f.getOption("PREFERENCES_UNIT_SCREENRULING")!==a&&this.f.setOption("PREFERENCES_UNIT_SCREENRULING",a,!0);this.f.getOption("PREFERENCES_UNIT_SCREEN")!==b&&this.f.setOption("PREFERENCES_UNIT_SCREEN",b,!1)};k.prototype._updateUnitOptions=function(){var b=this.f.getOption("PREFERENCES_UNIT_SCREENRULING"),e=this.f.getOption("PREFERENCES_UNIT_SCREEN");this._optionButton.toggleOption("unitLpmm",b===a.ResolutionUnits.PPMM&&e===c.ScreenRulingMode.LINES);this._optionButton.toggleOption("unitLpcm",
b===a.ResolutionUnits.PPCM&&e===c.ScreenRulingMode.LINES);this._optionButton.toggleOption("unitLpi",b===a.ResolutionUnits.PPI&&e===c.ScreenRulingMode.LINES);this._optionButton.toggleOption("unitDeg",e===c.ScreenRulingMode.ANGLE);this._optionButton.toggleOption("unitLpmmDeg",b===a.ResolutionUnits.PPMM&&e===c.ScreenRulingMode.BOTH);this._optionButton.toggleOption("unitLpcmDeg",b===a.ResolutionUnits.PPCM&&e===c.ScreenRulingMode.BOTH);this._optionButton.toggleOption("unitLpiDeg",b===a.ResolutionUnits.PPI&&
e===c.ScreenRulingMode.BOTH)};k.prototype.setOrientation=function(a){this.f.setOption("PREFERENCES_SCREEN_ORIENTATION",a,!1)};k.prototype._updateOrientationOptions=function(){var a=this.f.getOption("PREFERENCES_SCREEN_ORIENTATION");this._optionButton.toggleOption("scrOrientationCW",a===c.ScreenRulingOrientation.CW);this._optionButton.toggleOption("scrOrientationCCW",a===c.ScreenRulingOrientation.CCW)};return k});
define("web-viewer/measure/ScreenRulingPopoverModel",["web-viewer/measure/MeasurePopoverModel","web-viewer/measure/ScreenRulingUnitSelector","underscore","jquery"],function(b,a){var c=function(a,c,j,e,g,d,i){b.call(this,a,c,j,e,g,d,i);this._screenRulingUnitSelector=null;this.f.getDocumentController().whenActivePageChangedAndParametersAvailable(this._updateScreenRulingUnitSelectorButton,this)};c.prototype=Object.create(b.prototype);c.prototype.constructor=c;c.prototype._updateScreenRulingUnitSelectorButton=
function(){this.f.getActivePage().isDigitalFilmPage()?null===this._screenRulingUnitSelector?(this._screenRulingUnitSelector=new a(this.f),this._headerExtra.append(this._screenRulingUnitSelector.getButtonElement())):this._screenRulingUnitSelector.getButtonElement().show():null!==this._screenRulingUnitSelector&&this._screenRulingUnitSelector.getButtonElement().hide()};return c});
define("web-viewer/measure/ScreenRulingMeasureTool","underscore web-viewer/measure/AbstractMeasureTool web-viewer/measure/MeasureConstants web-viewer/measure/ScreenRulingPopoverModel utils/ShapeUtils web-viewer/utils/ViewerUtils web-viewer/core/CoreConstants".split(" "),function(b,a,c,f,k,j,e){var g=function(d){a.call(this,d,e.TOOLS.MEASURE_SCREEN_RULING);this.model.setRulerType(c.MeasureType.ScreenRuling);this._storedResults=null;this.registerState(this.clickState,b.defaults({enterState:b.bind(function(){var a=
this.getWorldResolution();if(null!==a){var b=c.ClickSize.DIGITAL_FILM/a.x,a=c.ClickSize.DIGITAL_FILM/a.y;this.model.setStartPoint(new k.Point(this.model.ruler.startPoint.x-b/2,this.model.ruler.startPoint.y-a/2));this.model.setEndPoint(new k.Point(this.model.ruler.startPoint.x+b,this.model.ruler.startPoint.y+a));this.calculate();this.changeState(this.defaultState)}},this)},this.getState(this.drawingState)));this.f.getCurrentUser().on("options.changed.PREFERENCES_UNIT_SCREENRULING",b.bind(this.showInfo,
this,null));this.f.getCurrentUser().on("options.changed.PREFERENCES_UNIT_SCREEN",b.bind(this.showInfo,this,null));this.f.getCurrentUser().on("options.changed.PREFERENCES_SCREEN_ORIENTATION",b.bind(this.showInfo,this,null))};g.prototype=Object.create(a.prototype);g.prototype.constructor=g;g.prototype.canBeUsedOnActivePage=function(){var a=this.f.getActivePage();return a&&a.hasGraphics()&&a.isDigitalFilmPage()};g.prototype._needsTotalCount=function(){return!1};g.prototype.calculate=function(){this.getInfo({})};
g.prototype.showInfo=function(a){var e=[];a?this._storedResults=a:a=this._storedResults;var f=this.f.getOption("PREFERENCES_UNIT_SCREEN"),g=this.f.getOption("PREFERENCES_SCREEN_ORIENTATION");a&&(a.status.info.screen&&(b.isArray(a.status.info.screen)||(a.status.info.screen=[a.status.info.screen]),b.each(a.status.info.screen,b.bind(function(a){var b="";if("1"===a.found){if(f===c.ScreenRulingMode.LINES||f===c.ScreenRulingMode.BOTH)b+=j.convertResolutionFromPpmmValue(j.parseFloat(a.ruling),this.f.getScreenUnits(),
this.f.getScreenUnitsFix()),b+=" "+this.f.i18n.t(this.f.getScreenUnitsLocName());f===c.ScreenRulingMode.BOTH&&(b+=" / ");if(f===c.ScreenRulingMode.ANGLE||f===c.ScreenRulingMode.BOTH){var d=j.parseFloat(a.angle);g===c.ScreenRulingOrientation.CCW&&(d=90-d);b+=d.toFixed(2)+"\u00b0"}}e[a.color]=b},this))),this.f.emit("channels.informationAdded",e));this.showPopover(e)};g.prototype.createPopoverModel=function(a,b){return new f(this.f,b,"Channels",$("<i>").addClass("icon icon-normal icon-WCR_Measure-Screen"),
a,this._needsTotalCount())};return g});
define("web-viewer/measure/CaliperSubtoolbarComponent","component/toolbar/ToolbarComponent component/toolbar/ButtonGroup web-viewer/layout/component/SubtoolbarButton web-viewer/layout/component/Spinner web-viewer/core/CoreConstants web-viewer/measure/MeasureConstants web-viewer/utils/ViewerUtils web-viewer/utils/ListenerUtil jquery underscore".split(" "),function(b,a,c,f,k,j,e,g,d,i){var h=function(e,h){b.call(this,"CaliperSubtoolbar",e);g.mixin(this,e);this.f=e;this._caliperModel=h;this.f.i18n.loadBundle("viewer",
function(){this._stylesLabel=d("<span />").addClass("styleLabel").text(this.f.i18n.t("GapStyle")+":");this._styles=d("<select />").addClass("styleSelect mousetrap");this._refreshGaps();this._styles.on("change",i.bind(this._styleSelectorChanged,this));this.element.append(d("<div class='caliperStyle'/>").append(this._stylesLabel).append(this._styles));this._gapLabel=d("<span />").addClass("gapLabel").text(this.f.i18n.t("GapSize")+":");this._gapSpinner=new f(this.f,{min:0,max:9999,step:0.01,page:10,
onSpinnerChanged:i.bind(this._spinnerChanged,this),inputUnit:this.f.i18n.t(this.f.getUnitsLocName())});this.element.append(d("<div class='caliperGap'/>").append(this._gapLabel).append(this._gapSpinner.element.addClass("mousetrap")));this._heightWidthButtonGroup=new a("heightWidthButtonGroup");this._heightWidthButtonGroup.element.addClass("heightWidthButtonGroup");this._heightButton=new c(this.f,"checkHeight","icon-WCR_Height",!0,i.bind(this._heightButtonClicked,this));this._heightButton.element.append(this.f.i18n.t("GapHeight"));
this._heightWidthButtonGroup.addButton(this._heightButton);this._widthButton=new c(this.f,"checkWidth","icon-WCR_Width",!0,i.bind(this._widthButtonClicked,this));this._widthButton.element.append(this.f.i18n.t("GapWidth"));this._heightWidthButtonGroup.addButton(this._widthButton);this.addButtonGroup(this._heightWidthButtonGroup);this._saveButtonGroup=new a("saveButtonGroup");this._saveGapButton=new c(this.f,"SaveGap","icon-WCR_Save",!0,i.bind(this._saveClicked,this));this._saveGapButton.setTooltip("viewer",
"SaveGapTT");this._saveButtonGroup.addButton(this._saveGapButton);this._deleteGapButton=new c(this.f,"DeleteGap","icon-WCR_Actions-Delete12",!0,i.bind(this._deleteClicked,this));this._deleteGapButton.setTooltip("viewer","DeleteGapTT");this._saveButtonGroup.addButton(this._deleteGapButton);this.addButtonGroup(this._saveButtonGroup);this._registerListener("changed.currentGap",this._gapChanged,this,this._caliperModel);this._registerListener("changed.currentGap.vector",this._gapVectorChanged,this,this._caliperModel);
this._registerListener("changed.presetGaps.new",this._refreshGaps,this,this._caliperModel);this._registerListener("changed.presetGaps.deleted",this._deletedPresetGap,this,this._caliperModel);this.f.getCurrentUser().on("options.changed.PREFERENCES_UNIT_SIZE",i.bind(this._unitsUpdated,this));this._caliperModel.setCurrentGapById(this._caliperModel.getFreeformGap().getId())},this)};h.prototype=Object.create(b.prototype);h.prototype.constructor=h;h.prototype._styleSelectorChanged=function(a){var b=this._caliperModel.getCurrentGap(),
c=this._caliperModel.getGapById(a.target.value);(c.getStyle()===j.CaliperStyle.Fixed&&b.getStyle()===j.CaliperStyle.Freeform||c.getStyle()===j.CaliperStyle.Freeform&&b.getStyle()===j.CaliperStyle.Fixed)&&c.setVector(b.getVector());this._caliperModel.setCurrentGapById(a.target.value)};h.prototype._spinnerChanged=function(a){var b=null;this.f.getUnits()===k.SizeUnits.PIXELS&&(b=this._getResolution(this._caliperModel.getCurrentGap().getVector()));a=e.convertToMmValue(a,this.f.getUnits(),this.f.getUnitsFix(k.SizeUnits.MM),
e.parseFloat(b));this._caliperModel.getCurrentGap().getStyle()===j.CaliperStyle.Preset&&(b=this._caliperModel.getCurrentGap(),this._caliperModel.setCurrentGapById(this._caliperModel.getFixedGap().getId()),this._caliperModel.setCurrentGapVector(b.getVector()));b=this._caliperModel.getCurrentGap().getVector();b.setLength(a);this._caliperModel.setCurrentGapVector(b)};h.prototype._heightButtonClicked=function(a){if(this._caliperModel.getCurrentGap().getStyle()===j.CaliperStyle.Preset){var b=this._caliperModel.getCurrentGap();
this._caliperModel.setCurrentGapById(this._caliperModel.getFixedGap().getId());this._caliperModel.setCurrentGapVector(b.getVector())}b=this._caliperModel.getCurrentGap().getVector();b.setAngleInDegrees(-90);this._caliperModel.setCurrentGapVector(b);a.stopPropagation()};h.prototype._widthButtonClicked=function(a){if(this._caliperModel.getCurrentGap().getStyle()===j.CaliperStyle.Preset){var b=this._caliperModel.getCurrentGap();this._caliperModel.setCurrentGapById(this._caliperModel.getFixedGap().getId());
this._caliperModel.setCurrentGapVector(b.getVector())}b=this._caliperModel.getCurrentGap().getVector();b.setAngleInDegrees(0);this._caliperModel.setCurrentGapVector(b);a.stopPropagation()};h.prototype._gapChanged=function(a,b){this._styles.find('option[value="'+b.getId()+'"]').prop("selected",!0);this._gapVectorChanged(null,b.getVector());this._updateButtons()};h.prototype._gapVectorChanged=function(a,b){this._caliperModel.isMeasuringHeight(b)?(this._heightButton.setActive(!0),this._widthButton.setActive(!1)):
this._caliperModel.isMeasuringWidth(b)&&(this._widthButton.setActive(!0),this._heightButton.setActive(!1));var c=null;this.f.getUnits()===k.SizeUnits.PIXELS&&(c=this._getResolution(b));var d=b.getLength(),d=e.convertFromMmValue(d,this.f.getUnits(),this.f.getUnitsFix(),e.parseFloat(c));this._gapSpinner.setValue(d)};h.prototype._refreshGaps=function(a,b){this._styles.empty();i.each(this._caliperModel.getAllGaps(),function(a){this._newGap(a)},this);void 0!==b&&this._caliperModel.setCurrentGapById(b.getId())};
h.prototype._unitsUpdated=function(){this._gapSpinner.setInputUnit(this.f.i18n.t(this.f.getUnitsLocName()));this._gapChanged(this._caliperModel.getCurrentGap(),this._caliperModel.getCurrentGap());this._refreshGaps()};h.prototype._newGap=function(a){a=d("<option />").html(this._toString(a)).val(a.getId());this._styles.append(a)};h.prototype._deletedPresetGap=function(a){this._styles.find('option[value="'+a.getId()+'"]').remove();this._caliperModel.setCurrentGapById(this._caliperModel.getFixedGap().getId());
this._caliperModel.setCurrentGapVector(a.getVector())};h.prototype._saveClicked=function(){var a=this._caliperModel.getSimilarPreset(this._caliperModel.getCurrentGap());a?this._caliperModel.setCurrentGapById(a.getId()):this._caliperModel.saveCurrentGapAsPreset()};h.prototype._deleteClicked=function(){this._caliperModel.deleteCurrentGapFromPresets()};h.prototype._updateButtons=function(){switch(this._caliperModel.getCurrentGap().getStyle()){case j.CaliperStyle.Freeform:this._deleteGapButton.element.addClass("hiddenElement");
this._saveGapButton.element.removeClass("hiddenElement");break;case j.CaliperStyle.Fixed:this._deleteGapButton.element.addClass("hiddenElement");this._saveGapButton.element.removeClass("hiddenElement");break;case j.CaliperStyle.Preset:this._saveGapButton.element.addClass("hiddenElement"),this._deleteGapButton.element.removeClass("hiddenElement")}};h.prototype._toString=function(a){switch(a.getStyle()){case j.CaliperStyle.Freeform:return this.f.i18n.t("GapStyleFreeform");case j.CaliperStyle.Fixed:return this.f.i18n.t("GapStyleFixed");
case j.CaliperStyle.Preset:var b=null;this.f.getUnits()===k.SizeUnits.PIXELS&&(b=this._getResolution(a.getVector()));var b=e.convertFromMmValue(a.getVector().getLength(),this.f.getUnits(),this.f.getUnitsFix(),e.parseFloat(b)),c=this.f.i18n.t(this.f.getUnitsLocName()),d="";this._caliperModel.isMeasuringHeight(a.getVector())?d=this.f.i18n.t("GapHeight"):this._caliperModel.isMeasuringWidth(a.getVector())&&(d=this.f.i18n.t("GapWidth"));return b+" "+c+" ("+d+")"}};h.prototype._getResolution=function(a){var b=
this.f.getActivePage(),c=null;this._caliperModel.isMeasuringHeight(a)?c=b.getParam("resolutiony"):this._caliperModel.isMeasuringWidth(a)&&(c=b.getParam("resolutionx"));return c};return h});
define("web-viewer/measure/MeasureToolbarComponent","component/toolbar/ToolbarComponent component/toolbar/ButtonGroup web-viewer/layout/component/ViewerToolbarButton web-viewer/layout/component/SubtoolbarButton component/button/Button web-viewer/layout/component/ColorPicker web-viewer/layout/LayoutConstants web-viewer/measure/MeasureConstants web-viewer/measure/CaliperSubtoolbarComponent utils/OrderedObject underscore jquery".split(" "),function(b,a,c,f,k,j,e,g,d,i,h,m){var l=function(c,d,f,g,i,j,
k){b.call(this,e.ToolbarComponent.MEASURE,c);this.f=c;this.rulerTool=d;this.eyedropperTool=f;this.barcodeTool=g;this.brailleTool=i;this.caliperTool=j;this.screenRulingTool=k;this.screenRulingButton=this.caliperButton=this.brailleButton=this.barcodeButton=this.eyeDropperButton=this.rulerButton=null;this.measureGroup=new a("MeasureGroup");this.measureGroup.setTitle(c.i18n,"viewer","MeasurementToolsTitle");this.addButtonGroup(this.measureGroup);this.f.getDocumentController().whenActivePageChangedAndParametersAvailable(h.bind(function(){this.updateTools()},
this))};l.prototype=Object.create(b.prototype);l.prototype.constructor=l;l.toolbarName=e.ToolbarComponent.MEASURE;l.prototype.initializeRulerButton=function(d){if(!this.rulerButton){this.rulerButton=new c(this.f,"RulerButton","icon icon-WCR_Measure-Ruler",!0);this.rulerButton.listenToTool(d,!0);this.rulerButton.setTooltip("viewer","RulerTT");d=new b("RulerSubtoolbar",this.f);this.rulerButton.addSubtoolbarComponent(d);var e=new a("RulerSubGroup");d.addButtonGroup(e);var g=new f(this.f,"DAButton","icon-WCR_Measure-Ruler-DA-cont",
!0,h.partial(function(a){a.setOption("PREFERENCES_RULER_DISPLAY_MODE_DA",a.getOption("PREFERENCES_RULER_DISPLAY_MODE_DA")?0:1);a.setOption("PREFERENCES_RULER_DISPLAY_MODE",1<=a.getOption("PREFERENCES_RULER_DISPLAY_MODE")?0:1)},this.f));g.setIcon("icon-WCR_Measure-Ruler-DA-cont",["icon-WCR_Measure-Ruler-DA-sub icon-red"]);g.setTooltip("viewer","RulerDATT");e.addButton(g);var i=new f(this.f,"XYButton","icon-WCR_Measure-Ruler-XY-cont",!0,h.partial(function(a){a.setOption("PREFERENCES_RULER_DISPLAY_MODE_XY",
a.getOption("PREFERENCES_RULER_DISPLAY_MODE_XY")?0:1);a.setOption("PREFERENCES_RULER_DISPLAY_MODE",2<=a.getOption("PREFERENCES_RULER_DISPLAY_MODE")?1:2)},this.f));i.setIcon("icon-WCR_Measure-Ruler-XY-cont",["icon-WCR_Measure-Ruler-XY-sub icon-red"]);i.setTooltip("viewer","RulerXYTT");e.addButton(i);var k=new f(this.f,"WHButton","icon-WCR_Measure-Ruler-WH-cont",!0,h.partial(function(a){a.setOption("PREFERENCES_RULER_DISPLAY_MODE_WH",a.getOption("PREFERENCES_RULER_DISPLAY_MODE_WH")?0:1);a.setOption("PREFERENCES_RULER_DISPLAY_MODE",
3<=a.getOption("PREFERENCES_RULER_DISPLAY_MODE")?2:3)},this.f));k.setIcon("icon-WCR_Measure-Ruler-WH-cont",["icon-WCR_Measure-Ruler-WH-sub icon-red"]);k.setTooltip("viewer","RulerWHTT");e.addButton(k);var l=h.partial(function(a){g.setActive(1===a.getOption("PREFERENCES_RULER_DISPLAY_MODE_DA"));i.setActive(1===a.getOption("PREFERENCES_RULER_DISPLAY_MODE_XY"));k.setActive(1===a.getOption("PREFERENCES_RULER_DISPLAY_MODE_WH"))},this.f);this.f.getCurrentUser().on("options.changed.PREFERENCES_RULER_DISPLAY_MODE",
function(){l()});l();var m=new j(this.f,h.partial(function(a,b){a.getCurrentUser().setColor("PREFERENCES_RULER_DISPLAY_COLOR",b)},this.f));this.f.getCurrentUser().on("options.changed.PREFERENCES_RULER_DISPLAY_COLOR",h.partial(function(a){m.setColor(a.getCurrentUser().getColor("PREFERENCES_RULER_DISPLAY_COLOR"))},this.f));m.setColor(this.f.getCurrentUser().getColor("PREFERENCES_RULER_DISPLAY_COLOR"));e=new f(this.f,"ColorSelector",m.element,!0);e.setTooltip("viewer","RulerDisplayColorChange");var r=
new f(this.f,"ColorReset","icon-WCR_Revert",!0,h.partial(function(a){a.resetOption("PREFERENCES_RULER_DISPLAY_COLOR")},this.f));r.setTooltip("viewer","RulerDisplayColorReset");var q=new f(this.f,"angleButton",this.f.getOption("PREFERENCES_RULER_ANGLE_MODE")?"measureCCW":"measureCW",!0,h.partial(function(a){a.setOption("PREFERENCES_RULER_ANGLE_MODE",a.getOption("PREFERENCES_RULER_ANGLE_MODE")?0:1);a.getOption("PREFERENCES_RULER_ANGLE_MODE")?(this.setTooltip("viewer","RulerAngleToCW"),this.setIcon("icon-WCR_Measure-Ruler-CCW-cont",
["icon-WCR_Measure-Ruler-CCW-sub icon-red"])):(this.setTooltip("viewer","RulerAngleToCCW"),this.setIcon("icon-WCR_Measure-Ruler-CW-cont",["icon-WCR_Measure-Ruler-CW-sub icon-red"]))},this.f));this.f.getOption("PREFERENCES_RULER_ANGLE_MODE")?(q.setTooltip("viewer","RulerAngleToCW"),q.setIcon("icon-WCR_Measure-Ruler-CCW-cont",["icon-WCR_Measure-Ruler-CCW-sub icon-red"])):(q.setTooltip("viewer","RulerAngleToCCW"),q.setIcon("icon-WCR_Measure-Ruler-CW-cont",["icon-WCR_Measure-Ruler-CW-sub icon-red"]));
var s=new a("RulerSubGroupOptions");d.addButtonGroup(s);s.addButton(q);s.addButton(e);s.addButton(r)}};l.prototype.initializeEyeDropperButton=function(a){this.eyeDropperButton||(this.eyeDropperButton=new c(this.f,"EyeDropperButton","icon icon-WCR_Measure-Colorpicker",!1),this.eyeDropperButton.listenToTool(a,!0),this.eyeDropperButton.setTooltip("viewer","ToolPercentageTT"))};l.prototype.initializeBarCodeButton=function(a){this.barcodeButton||(this.barcodeButton=new c(this.f,"BarcodeButton","icon icon-WCR_Measure-Barcode",
!1),this.barcodeButton.listenToTool(a,!0),this.barcodeButton.setTooltip("viewer","ToolBarcodeTT"))};l.prototype.initializeBrailleButton=function(a){if(!this.brailleButton){this.brailleButton=new c(this.f,"BrailleButton","icon icon-WCR_Measure-Braille",!1);this.brailleButton.listenToTool(a,!0);this.brailleButton.setTooltip("viewer","ToolBrailleTT");var d=new i;h.each(g.BrailleLanguage,function(a,b){b!==g.LanguageAutomatic&&d.addItem(this.f.i18n.t(g.LanguageTranslationPrefix+a.lang),b)},this);d.setOrder(h.sortBy(d.getKeys()));
d.addItemAtIndex(this.f.i18n.t(g.LanguageTranslationPrefix+g.BrailleLanguage[g.LanguageAutomatic].lang),g.LanguageAutomatic);a=new b("BrailleSubToolbar",this.f);this.brailleButton.addSubtoolbarComponent(a);var e=m("<div/>").addClass("brailleLanguages"),f=m("<span/>").addClass("currentlang").append(d.getKeyByValue(this.f.getOption("PREFERENCES_BRAILLE_LANGUAGE").toString())),j=m("<ul/>").addClass("languagelist").hide(),l=new k(this.f.i18n,this.f.getContext(),this.f.isMobile(),"language",f,!1,function(){j.toggle()});
h.each(d.getKeys(),function(a){var b=new k(this.f.i18n,this.f.getContext(),this.f.isMobile(),"brailleLang"+d.getItemByKey(a),a,!1,h.partial(function(b){var c=parseInt(d.getItemByKey(a),10);isNaN(c)&&(c=0);b.setOption("PREFERENCES_BRAILLE_LANGUAGE",c);j.hide()},this.f));j.append(m("<li/>").append(b.element))},this);l.element.append(m("<b/>").addClass("caret"));e.append(l.element);e.append(j);a.element.append(e);this.f.getCurrentUser().on("options.changed.PREFERENCES_BRAILLE_LANGUAGE",function(a,b){f.html(d.getKeyByValue(b+
""))})}};l.prototype.initializeCaliperButton=function(a){this.caliperButton||(this.caliperButton=new c(this.f,"CaliperButton","icon-WCR_Measure-Caliper2-cont",!1),this.caliperButton.listenToTool(a,!0),this.caliperButton.setIcon("icon-WCR_Measure-Caliper2-cont",["icon-WCR_Measure-Caliper2-sub icon-red"]),this.caliperButton.setTooltip("viewer","CaliperTT"),this.caliperButton.addSubtoolbarComponent(new d(this.f,a.getCaliperModel())))};l.prototype.initializeScreenRulingButton=function(a){this.screenRulingButton||
(this.screenRulingButton=new c(this.f,"ScreenRulingButton","icon icon-WCR_Measure-Screen",!1),this.screenRulingButton.listenToTool(a,!0),this.screenRulingButton.setTooltip("viewer","ToolScreenTT"))};l.prototype.updateTools=function(){this.f.emit("toolManager.activeTool",h.bind(function(a){a&&(a.canBeUsedOnActivePage&&!a.canBeUsedOnActivePage())&&this.f.emit("toolManager.deactivateTool",a)},this));this.measureGroup.clearButtons();this.rulerTool&&this.rulerTool.canBeUsedOnActivePage()&&(this.initializeRulerButton(this.rulerTool),
this.measureGroup.addButton(this.rulerButton));this.eyedropperTool&&this.eyedropperTool.canBeUsedOnActivePage()&&(this.initializeEyeDropperButton(this.eyedropperTool),this.measureGroup.addButton(this.eyeDropperButton));this.screenRulingTool&&this.screenRulingTool.canBeUsedOnActivePage()&&(this.initializeScreenRulingButton(this.screenRulingTool),this.measureGroup.addButton(this.screenRulingButton));this.barcodeTool&&this.barcodeTool.canBeUsedOnActivePage()&&(this.initializeBarCodeButton(this.barcodeTool),
this.measureGroup.addButton(this.barcodeButton));this.brailleTool&&this.brailleTool.canBeUsedOnActivePage()&&(this.initializeBrailleButton(this.brailleTool),this.measureGroup.addButton(this.brailleButton));this.caliperTool&&this.caliperTool.canBeUsedOnActivePage()&&(this.initializeCaliperButton(this.caliperTool),this.measureGroup.addButton(this.caliperButton));this._emit("changed.content")};return l});
define("web-viewer-wcr/webcenter/modules/measure/MeasureModule","web-viewer/measure/MeasureModule web-viewer/measure/MeasureConstants underscore utils/XMLUtils web-viewer/measure/RulerTool web-viewer/measure/BarcodeMeasureTool web-viewer/measure/BrailleMeasureTool web-viewer/measure/EyeDropperMeasureTool web-viewer/measure/CaliperTool web-viewer/measure/CaliperModel web-viewer/measure/ScreenRulingMeasureTool web-viewer/measure/MeasureToolbarComponent".split(" "),function(b,a,c,f,k,j,e,g,d,i,h,m){var l=
function(a,f){b.apply(this,arguments);$.when(this._checkBarCodeAndBrailleLicenses()).done(c.bind(function(b,f){this.tools=[];var l=new k(a);this._publishTool(l);this.tools.push(l);if(b){var t=new j(a,this);this._publishTool(t);this.tools.push(t)}if(f){var v=new e(a,this);this._publishTool(v);this.tools.push(v)}var r=new g(a,"eyedropper");this._publishTool(r);this.tools.push(r);var q=new h(a,"screenruling");this._publishTool(q);this.tools.push(q);var s=new i(a,[this.getPrivateChannelName(),"caliper",
"model"]),w=new d(a,s);this._publishTool(w);this.tools.push(w);this._publishToolbarComponent(m.toolbarName,c.bind(function(){return new m(a,l,r,t,v,w,q)},this))},this))};l.prototype=Object.create(b.prototype);l.prototype.constructor=l;l.prototype._checkBarCodeAndBrailleLicenses=function(){var b=$.Deferred();$.when(this._getServerInfoFlags()).done(function(c){b.resolve((c&a.ServerInfoFlags.barCode)===a.ServerInfoFlags.barCode||(c&a.ServerInfoFlags.barCodeGV)===a.ServerInfoFlags.barCodeGV,(c&a.ServerInfoFlags.braille)===
a.ServerInfoFlags.braille)});return b.promise()};b.prototype._getServerInfoFlags=function(){var a=$.Deferred();void 0!==this._serverFlags?a.resolve(this._serverFlags):this.f.getDataAdapter().fetch(this.f.getDataAdapter().ViewServer("getserverinfo.jsp"),{success:c.bind(function(b){if(b&&(b=f.xml2obj(b))&&(b.status&&"0"==b.status.value)&&b.status.server){this._serverFlags=parseInt(b.status.server.flags,10);a.resolve(this._serverFlags);return}this.f.emit("error.WARNING","Problem while fetching server flags");
a.resolve(0)},this),error:c.bind(function(b,c,d){this.f.emit("error.WARNING","Problem while fetching server flags",c,d);a.resolve(0)},this)});return a.promise()};return l});