/**
  A javascript Bezier curve library by Pomax.

  Based on http://pomax.github.io/bezierinfo

  This code is MIT licensed.
**/

(function(){var n=Math.abs,y=Math.min,z=Math.max,p=Math.cos,r=Math.sin,A=Math.acos,s=Math.atan2,l=Math.sqrt,u=function(a){return 0>a?-Math.pow(-a,1/3):Math.pow(a,1/3)},w=Math.PI,v=2*w,q=w/2,B={x:0,y:0,z:0},j={Tvalues:[-0.06405689286260563,0.06405689286260563,-0.1911188674736163,0.1911188674736163,-0.3150426796961634,0.3150426796961634,-0.4337935076260451,0.4337935076260451,-0.5454214713888396,0.5454214713888396,-0.6480936519369755,0.6480936519369755,-0.7401241915785544,0.7401241915785544,-0.820001985973903,
0.820001985973903,-0.8864155270044011,0.8864155270044011,-0.9382745520027328,0.9382745520027328,-0.9747285559713095,0.9747285559713095,-0.9951872199970213,0.9951872199970213],Cvalues:[0.12793819534675216,0.12793819534675216,0.1258374563468283,0.1258374563468283,0.12167047292780339,0.12167047292780339,0.1155056680537256,0.1155056680537256,0.10744427011596563,0.10744427011596563,0.09761865210411388,0.09761865210411388,0.08619016153195327,0.08619016153195327,0.0733464814110803,0.0733464814110803,0.05929858491543678,
0.05929858491543678,0.04427743881741981,0.04427743881741981,0.028531388628933663,0.028531388628933663,0.0123412297999872,0.0123412297999872],arcfn:function(a,b){var c=b(a),c=c.x*c.x+c.y*c.y;"undefined"!==typeof c.z&&(c+=c.z*c.z);return l(c)},length:function(a){var b=0,c=this.Tvalues.length,d,f;for(d=0;d<c;d++)f=0.5*this.Tvalues[d]+0.5,b+=this.Cvalues[d]*this.arcfn(f,a);return 0.5*b},map:function(a,b,c,d,f){return d+(f-d)*((a-b)/(c-b))},lerp:function(a,b,c){var d={x:b.x+a*(c.x-b.x),y:b.y+a*(c.y-b.y)};
b.z&&c.z&&(d.z=b.z+a*(c.z-b.z));return d},pointToString:function(a){var b=a.x+"/"+a.y;"undefined"!==typeof a.z&&(b+="/"+a.z);return b},pointsToString:function(a){return"["+a.map(this.pointToString).join(", ")+"]"},copy:function(a){return JSON.parse(JSON.stringify(a))},angle:function(a,b,c){var d=b.x-a.x,b=b.y-a.y,f=c.x-a.x,a=c.y-a.y,c=d*a-b*f,e=l(d*d+b*b),g=l(f*f+a*a);return s(c,d/e*(f/g)+b/e*(a/g))},dist:function(a,b){var c=a.x-b.x,d=a.y-b.y;return l(c*c+d*d)},lli8:function(a,b,c,d,f,e,g,h){var i=
(a-c)*(e-h)-(b-d)*(f-g);return 0==i?!1:{x:((a*d-b*c)*(f-g)-(a-c)*(f*h-e*g))/i,y:((a*d-b*c)*(e-h)-(b-d)*(f*h-e*g))/i}},lli4:function(a,b,c,d){return this.lli8(a.x,a.y,b.x,b.y,c.x,c.y,d.x,d.y)},lli:function(a,b){return this.lli4(a,a.c,b,b.c)},makeline:function(a,b){var c=a.x,d=a.y,f=b.x,e=b.y,g=(f-c)/3,h=(e-d)/3;return new k(c,d,c+g,d+h,c+2*g,d+2*h,f,e)},findbbox:function(a){var b=99999999,c=b,d=-b,f=d;a.forEach(function(a){a=a.bbox();b>a.x.min&&(b=a.x.min);c>a.y.min&&(c=a.y.min);d<a.x.max&&(d=a.x.max);
f<a.y.max&&(f=a.y.max)});return{x:{min:b,mid:(b+d)/2,max:d,size:d-b},y:{min:c,mid:(c+f)/2,max:f,size:f-c}}},shapeintersections:function(a,b,c,d){if(!this.bboxoverlap(b,d))return[];var f=[],e=[c.startcap,c.forward,c.back,c.endcap];[a.startcap,a.forward,a.back,a.endcap].forEach(function(b){b.virtual||e.forEach(function(d){if(!d.virtual){var e=b.intersects(d);0<e.length&&(e.c1=b,e.c2=d,e.s1=a,e.s2=c,f.push(e))}})});return f},makeshape:function(a,b){var c=a.points.length,d=this.makeline(b.points[b.points.length-
1],a.points[0]),c=this.makeline(a.points[c-1],b.points[0]),f={startcap:d,forward:a,back:b,endcap:c,bbox:this.findbbox([d,a,b,c])},e=this;f.intersections=function(a){return e.shapeintersections(f,f.bbox,a,a.bbox)};return f},getminmax:function(a,b,c){if(!c)return{min:0,max:0};var d=1.8446744073709552E19,f=-d,e;-1===c.indexOf(0)&&(c=[0].concat(c));-1===c.indexOf(1)&&c.push(1);for(var g=0,h=c.length;g<h;g++)e=c[g],e=a.get(e),e[b]<d&&(d=e[b]),e[b]>f&&(f=e[b]);return{min:d,mid:(d+f)/2,max:f,size:f-d}},
align:function(a,b){var c=b.p1.x,d=b.p1.y,f=-s(b.p2.y-d,b.p2.x-c);return a.map(function(a){return{x:(a.x-c)*p(f)-(a.y-d)*r(f),y:(a.x-c)*r(f)+(a.y-d)*p(f)}})},roots:function(a,b){var b=b||{p1:{x:0,y:0},p2:{x:1,y:0}},c=a.length-1,d=this.align(a,b),f=function(a){return 0<=a&&1>=a};if(2===c){var c=d[0].y,e=d[1].y,d=d[2].y,g=c-2*e+d;return 0!==g?(d=-l(e*e-c*d),c=-c+e,[-(d+c)/g,-(-d+c)/g].filter(f)):e!==d&&0===g?[(2*e-d)/2*(e-d)].filter(f):[]}var h=d[0].y,e=d[1].y,c=d[2].y,g=-h+3*e-3*c+d[3].y,c=(3*h-6*
e+3*c)/g,e=(-3*h+3*e)/g,d=(3*e-c*c)/3,i=d/3,g=(2*c*c*c-9*c*e+27*(h/g))/27,e=g/2,h=e*e+i*i*i;if(0>h)return d=-d/3,d=l(d*d*d),g=-g/(2*d),e=A(-1>g?-1:1<g?1:g),h=2*u(d),d=h*p(e/3)-c/3,g=h*p((e+v)/3)-c/3,c=h*p((e+2*v)/3)-c/3,[d,g,c].filter(f);if(0===h)return d=0>e?u(-e):-u(e),[2*d-c/3,-d-c/3].filter(f);g=l(h);d=u(-e+g);g=u(e+g);return[d-g-c/3].filter(f)},droots:function(a){if(3===a.length){var b=a[0],c=a[1],d=a[2],a=b-2*c+d;return 0!==a?(d=-l(c*c-b*d),b=-b+c,[-(d+b)/a,-(-d+b)/a]):c!==d&&0===a?[(2*c-d)/
(2*(c-d))]:[]}if(2===a.length)return b=a[0],c=a[1],b!==c?[b/(b-c)]:[]},bboxoverlap:function(a,b){var c=["x","y"],d=c.length,f,e,g,h;for(f=0;f<d;f++)if(e=c[f],g=a[e].mid,h=b[e].mid,e=(a[e].size+b[e].size)/2,n(g-h)>=e)return!1;return!0},expandbox:function(a,b){b.x.min<a.x.min&&(a.x.min=b.x.min);b.y.min<a.y.min&&(a.y.min=b.y.min);b.z&&b.z.min<a.z.min&&(a.z.min=b.z.min);b.x.max>a.x.max&&(a.x.max=b.x.max);b.y.max>a.y.max&&(a.y.max=b.y.max);b.z&&b.z.max>a.z.max&&(a.z.max=b.z.max);a.x.mid=(a.x.min+a.x.max)/
2;a.y.mid=(a.y.min+a.y.max)/2;a.z&&(a.z.mid=(a.z.min+a.z.max)/2);a.x.size=a.x.max-a.x.min;a.y.size=a.y.max-a.y.min;a.z&&(a.z.size=a.z.max-a.z.min)},pairiteration:function(a,b){var c=a.bbox(),d=b.bbox();if(0.5>c.x.size+c.y.size&&0.5>d.x.size+d.y.size)return[(1E5*(a._t1+a._t2)/2|0)/1E5+"/"+(1E5*(b._t1+b._t2)/2|0)/1E5];var c=a.split(0.5),d=b.split(0.5),c=[{left:c.left,right:d.left},{left:c.left,right:d.right},{left:c.right,right:d.right},{left:c.right,right:d.left}],c=c.filter(function(a){return j.bboxoverlap(a.left.bbox(),
a.right.bbox())}),f=[];if(0===c.length)return f;c.forEach(function(a){f=f.concat(j.pairiteration(a.left,a.right))});return f=f.filter(function(a,c){return f.indexOf(a)===c})},getccenter:function(a,b,c){var d=b.x-a.x,f=b.y-a.y,e=c.x-b.x,g=c.y-b.y,h=d*p(q)-f*r(q),d=d*r(q)+f*p(q),f=e*p(q)-g*r(q),e=e*r(q)+g*p(q),g=(a.x+b.x)/2,i=(a.y+b.y)/2,m=(b.x+c.x)/2,C=(b.y+c.y)/2,h=j.lli8(g,i,g+h,i+d,m,C,m+f,C+e),d=j.dist(h,a),a=s(a.y-h.y,a.x-h.x),b=s(b.y-h.y,b.x-h.x),c=s(c.y-h.y,c.x-h.x);if(a<c){if(a>b||b>c)a+=v;
a>c&&(b=c,c=a,a=b)}else c<b&&b<a?(b=c,c=a,a=b):c+=v;h.s=a;h.e=c;h.r=d;return h}},x=function(a){this.curves=[];this._3d=!1;a&&(this.curves=a,this._3d=this.curves[0]._3d)};x.prototype={valueOf:function(){return this.toString()},toString:function(){return j.pointsToString(this.points)},addCurve:function(a){this.curves.push(a);this._3d=this._3d||a._3d},length:function(){return this.curves.map(function(a){return a.length()}).reduce(function(a,b){return a+b})},curve:function(a){return this.curves[a]},bbox:function(){for(var a=
this.curves,b=a[0].bbox(),c=1;c<a.length;c++)j.expandbox(b,a[c].bbox());return b},offset:function(a){var b=[];this.curves.forEach(function(c){b=b.concat(c.offset(a))});return new x(b)}};var k=function(a){var b=a&&a.forEach?a:arguments;if("object"===typeof b[0])for(var b=[],c=0;c<a.length;c++)["x","y","z"].forEach(function(d){"undefined"!==typeof a[c][d]&&b.push(a[c][d])});var d=b.length;if(6!==d&&8!==d&&9!==d&&12!==d)throw console.log(a),Error("This Bezier curve library only supports quadratic and cubic curves (in 2d and 3d)");
var f=9===d||12===d;this._3d=f;for(var e=[],g=0,h=f?3:2;g<d;g+=h){var i={x:b[g],y:b[g+1]};f&&(i.z=b[g+2]);e.push(i)}this.order=e.length-1;this.points=e;d=["x","y"];f&&d.push("z");this.dims=d;this.dimlen=d.length;a:{f=j.align(e,{p1:e[0],p2:e[this.order]});for(e=0;e<f.length;e++)if(1E-4<n(f[e].y)){this._linear=!1;break a}this._linear=!0}this._t1=0;this._t2=1;this.update()};k.fromSVG=function(a){var b=-1<a.indexOf("m"),a=a.match(/(-?\d+(\.\d+)*)\s*[, ]\s*(-?\d+(\.\d+)*)/g).map(function(a){a=a.split(" ").map(function(a){return parseFloat(a)});
return{x:a[0],y:a[1]}});if(!b)return new k(a);var c=[a[0]];a.reduce(function(a,b){b.x+=a.x;b.y+=a.y;c.push({x:b.x,y:b.y});return b});return new k(c)};k.utils=j;k.prototype={valueOf:function(){return this.toString()},toString:function(){return j.pointsToString(this.points)},toSVG:function(){if(this._3d)return!1;for(var a=this.points,b=["M",a[0].x,a[0].y,2===this.order?"Q":"C"],c=1,d=a.length;c<d;c++)b.push(a[c].x),b.push(a[c].y);return b.join(" ")},update:function(){this.dpoints=[];for(var a=this.points,
b=a.length,c=b-1;1<b;b--,c--){for(var d=[],f=0,e;f<c;f++)e={x:c*(a[f+1].x-a[f].x),y:c*(a[f+1].y-a[f].y)},this._3d&&(e.z=c*(a[f+1].z-a[f].z)),d.push(e);this.dpoints.push(d);a=d}this.computedirection()},computedirection:function(){var a=this.points;this.clockwise=0<j.angle(a[0],a[this.order],a[1])},length:function(){return j.length(this.derivative.bind(this))},getLUT:function(a){for(var a=a||100,b=[],c=0;c<=a;c++)b.push(this.compute(c/a));return b},get:function(a){return this.compute(a)},point:function(a){return this.points[a]},
compute:function(a){if(0===a)return this.points[0];if(1===a)return this.points[this.order];var b=1-a,c=b*b,d=a*a,f,e,g,h=0,i=this.points;2===this.order&&(i=[i[0],i[1],i[2],B],f=c,e=2*b*a,g=d);3===this.order&&(f=c*b,e=3*c*a,g=3*b*d,h=a*d);a={x:f*i[0].x+e*i[1].x+g*i[2].x+h*i[3].x,y:f*i[0].y+e*i[1].y+g*i[2].y+h*i[3].y};this._3d&&(a.z=f*i[0].z+e*i[1].z+g*i[2].z+h*i[3].z);return a},raise:function(){var a=this.points,b=[a[0]],c,d=a.length,f,e;for(c=1;c<d;c++)f=a[c],e=a[c-1],b[c]={x:(d-c)/d*f.x+c/d*e.x,
y:(d-c)/d*f.y+c/d*e.y};b[d]=a[d-1];return new k(b)},derivative:function(a){var b=1-a,c,d,f=0,e=this.dpoints[0];2===this.order&&(e=[e[0],e[1],B],c=b,d=a);3===this.order&&(c=b*b,d=2*b*a,f=a*a);a={x:c*e[0].x+d*e[1].x+f*e[2].x,y:c*e[0].y+d*e[1].y+f*e[2].y};this._3d&&(a.z=c*e[0].z+d*e[1].z+f*e[2].z);return a},normal:function(a){return this._3d?this.__normal3(a):this.__normal2(a)},__normal2:function(a){var a=this.derivative(a),b=l(a.x*a.x+a.y*a.y);return{x:-a.y/b,y:a.x/b}},__normal3:function(){var a=this.derivative(t),
b=this.derivative(t+0.01),c=l(a.x*a.x+a.y*a.y+a.z*a.z),d=l(b.x*b.x+b.y*b.y+b.z*b.z);a.x/=c;a.y/=c;a.z/=c;b.x/=d;b.y/=d;b.z/=d;var c=b.y*a.z-b.z*a.y,d=b.z*a.x-b.x*a.z,b=b.x*a.y-b.y*a.x,f=l(c*c+d*d+b*b),c=c/f,d=d/f,b=b/f,b=[c*c,c*d-b,c*b+d,c*d+b,d*d,d*b-c,c*b-d,d*b+c,b*b];return{x:b[0]*a.x+b[1]*a.y+b[2]*a.z,y:b[3]*a.x+b[4]*a.y+b[5]*a.z,z:b[6]*a.x+b[7]*a.y+b[8]*a.z}},split:function(a,b){if(0===a&&b)return this.split(b).left;if(1===b)return this.split(a).right;var c=this.points,d=[],f,e=[],g=0,h=0,i=
0;e[g++]=c[0];e[g++]=c[1];e[g++]=c[2];for(3===this.order&&(e[g++]=c[3]);1<c.length;){d=[];h=0;for(i=c.length-1;h<i;h++)f=j.lerp(a,c[h],c[h+1]),e[g++]=f,d.push(f);c=d}c={left:2===this.order?new k([e[0],e[3],e[5]]):new k([e[0],e[4],e[7],e[9]]),right:2===this.order?new k([e[5],e[4],e[2]]):new k([e[9],e[8],e[6],e[3]]),span:e};c.left._t1=j.map(0,0,1,this._t1,this._t2);c.left._t2=j.map(a,0,1,this._t1,this._t2);c.right._t1=j.map(a,0,1,this._t1,this._t2);c.right._t2=j.map(1,0,1,this._t1,this._t2);if(!b)return c;
b=j.map(b,a,1,0,1);return c.right.split(b).left},inflections:function(){var a={},b=[],c,d;this.dims.forEach(function(f){d=function(a){return a[f]};c=this.dpoints[0].map(d);a[f]=j.droots(c);3===this.order&&(c=this.dpoints[1].map(d),a[f]=a[f].concat(j.droots(c)));a[f]=a[f].filter(function(a){return 0<=a&&1>=a});b=b.concat(a[f].sort())}.bind(this));b.sort();a.values=b;return a},bbox:function(){var a=this.inflections(),b={};this.dims.forEach(function(c){b[c]=j.getminmax(this,c,a[c])}.bind(this));return b},
overlaps:function(a){var b=this.bbox(),a=a.bbox();return j.bboxoverlap(b,a)},offset:function(a,b){if("undefined"!==typeof b){var c=this.get(a),d=this.normal(a),f={c:c,n:d,x:c.x+d.x*b,y:c.y+d.y*b};this._3d&&(f.z=c.z+d.z*b);return f}if(this._linear){var e=this.normal(0),c=this.points.map(function(b){var c={x:b.x+a*e.x,y:b.y+a*e.y};b.z&&d.z&&(c.z=b.z+a*e.z);return c});return[new k(c)]}return this.reduce().map(function(b){return b.scale(a)})},simple:function(){if(3===this.order){var a=j.angle(this.points[0],
this.points[3],this.points[1]),b=j.angle(this.points[0],this.points[3],this.points[2]);if(0<a&&0>b||0>a&&0<b)return!1}var a=this.normal(0),b=this.normal(1),c=a.x*b.x+a.y*b.y;this._3d&&(c+=a.z*b.z);return n(A(c))<w/3},reduce:function(){var a,b=0,c=0,d,f=[],e=[],g=this.inflections().values;-1===g.indexOf(0)&&(g=[0].concat(g));-1===g.indexOf(1)&&g.push(1);b=g[0];for(a=1;a<g.length;a++)c=g[a],d=this.split(b,c),d._t1=b,d._t2=c,f.push(d),b=c;f.forEach(function(a){for(c=b=0;1>=c;)for(c=b+0.01;1.01>=c;c+=
0.01)if(d=a.split(b,c),!d.simple()){c-=0.01;if(0.01>n(b-c))return[];d=a.split(b,c);d._t1=j.map(b,0,1,a._t1,a._t2);d._t2=j.map(c,0,1,a._t1,a._t2);e.push(d);b=c;break}1>b&&(d=a.split(b,1),d._t1=j.map(b,0,1,a._t1,a._t2),d._t2=a._t2,e.push(d))});return e},scale:function(a){var b=this.order,c=!1;"function"===typeof a&&(c=a);if(c&&2===b)return this.raise().scale(c);var d=this.clockwise,f=c?c(0):a,e=c?c(1):a,g=[this.offset(0,10),this.offset(1,10)],h=j.lli4(g[0],g[0].c,g[1],g[1].c);if(!h)throw"cannot scale this curve. Try reducing it first.";
var i=this.points,m=[];[0,1].forEach(function(a){var c=m[a*b]=j.copy(i[a*b]);c.x+=(a?e:f)*g[a].n.x;c.y+=(a?e:f)*g[a].n.y}.bind(this));if(!c)return[0,1].forEach(function(a){if(!(2===this.order&&a)){var c=m[a*b],d=this.derivative(a);m[a+1]=j.lli4(c,{x:c.x+d.x,y:c.y+d.y},h,i[a+1])}}.bind(this)),new k(m);[0,1].forEach(function(e){if(!(2===this.order&&e)){var f=i[e+1],g=f.x-h.x,j=f.y-h.y,k=c?c((e+1)/b):a;c&&!d&&(k=-k);var D=l(g*g+j*j);m[e+1]={x:f.x+k*(g/D),y:f.y+k*(j/D)}}}.bind(this));return new k(m)},
outline:function(a,b,c,d){function f(a,c,b,d,e){return function(f){var g=c-a;return j.map(f,0,1,a+d/b*g,a+(d+e)/b*g)}}var b="undefined"===typeof b?a:b,e=this.reduce(),g=e.length,h=[],i=[],m,k=0,l=this.length(),p="undefined"!==typeof c&&"undefined"!==typeof d;e.forEach(function(e){n=e.length();p?(h.push(e.scale(f(a,c,l,k,n))),i.push(e.scale(f(-b,-d,l,k,n)))):(h.push(e.scale(a)),i.push(e.scale(-b)));k+=n});var i=i.map(function(a){m=a.points;a.points=m[3]?[m[3],m[2],m[1],m[0]]:[m[2],m[1],m[0]];return a}).reverse(),
e=h[g-1].points[h[g-1].points.length-1],q=i[0].points[0],g=j.makeline(i[g-1].points[i[g-1].points.length-1],h[0].points[0]),e=j.makeline(e,q),g=[g].concat(h).concat([e]).concat(i),n=g.length;return new x(g)},outlineshapes:function(a,b){for(var c=this.outline(a,b||a).curves,d=[],f=1,e=c.length;f<e/2;f++){var g=j.makeshape(c[f],c[e-f]);g.startcap.virtual=1<f;g.endcap.virtual=f<e/2-1;d.push(g)}return d},intersects:function(a){if(!a)return this.selfintersects();if(a.p1&&a.p2)return this.lineIntersects(a);
a instanceof k&&(a=a.reduce());return this.curveintersects(this.reduce(),a)},lineIntersects:function(a){var b=y(a.p1.x,a.p2.x),c=y(a.p1.y,a.p2.y),d=z(a.p1.x,a.p2.x),f=z(a.p1.y,a.p2.y),e=this;return j.roots(this.points,a).filter(function(a){a=e.get(a);return b<=a.x&&a.x<=d&&c<=a.y&&a.y<=f})},selfintersects:function(){var a=this.reduce(),b,c=a.length-2,d=[],f,e;for(b=0;b<c;b++)f=a.slice(b,b+1),e=a.slice(b+2),f=this.curveintersects(f,e),d=d.concat(f);return d},curveintersects:function(a,b){var c=[];
a.forEach(function(a){b.forEach(function(b){a.overlaps(b)&&c.push({left:a,right:b})})});var d=[];c.forEach(function(a){a=j.pairiteration(a.left,a.right);0<a.length&&(d=d.concat(a))});return d},arcs:function(a){return this._iterate(a||0.5,[])},_error:function(a,b,c,d){var f=(d-c)/4,c=this.get(c+f),d=this.get(d-f),b=j.dist(a,b),c=j.dist(a,c),a=j.dist(a,d);return n(c-b)+n(a-b)},_iterate:function(a,b){var c=0,d=1,f;do{f=0;var d=1,e=this.get(c),g,h,i,k=h=!1,l=d,n=1,p=0;do if(k=h,i=g,l=(c+d)/2,p++,g=this.get(l),
h=this.get(d),g=j.getccenter(e,g,h),h=this._error(g,e,c,d)<=a,(k=k&&!h)||(n=d),h){if(1<=d){n=1;i=g;break}d+=(d-c)/2}else d=l;while(!k&&100>f++);if(100<=f){console.error("arc abstraction somehow failed...");break}i=i?i:g;b.push(i);c=n}while(1>d);return b}};"undefined"!==typeof module&&module.exports?module.exports=k:"undefined"!==typeof define?define([],function(){return k}):"undefined"!==typeof window&&(window.Bezier=k)})();