/**
 * @author DOGO
 * @module WebViewer3D
 * @copyright   2014 Esko Stonecube Ltd. All rights reserved.
 */

define("underscore backbone WV3Dlib/three WV3Dmod/Utils WV3Dmod/Timers WV3Dmod/LogMessage".split(" "),function(L,K,h,J,M,D){return K.Model.extend({initialize:function(k){D.Log("Creating ThreeDObjectHandler Object");this.set("_geometrycounter",0);this.set("_build_mesh_execution_queue",k);this.set("_geomsources",{});this.set("_proxy_geometries",{});this.set("_geom_register_map",{})},ClearBuildMaps:function(){this.set("_geomsources",{});this.set("_proxy_geometries",{});this.set("_geom_register_map",
{})},DotNormals:function(k,d,c,l){var g=3*k[0],n=3*k[1],k=3*k[2],g=new h.Vector3(c[g],c[g+1],c[g+2]),n=new h.Vector3(c[n],c[n+1],c[n+2]),c=new h.Vector3(c[k],c[k+1],c[k+2]),c=g.add(n).add(c).normalize(),g=3*d[0],n=3*d[1],k=3*d[2],d=new h.Vector3(l[g],l[g+1],l[g+2]),n=new h.Vector3(l[n],l[n+1],l[n+2]),l=new h.Vector3(l[k],l[k+1],l[k+2]),n=n.sub(d).normalize(),l=l.sub(d).normalize();return n.cross(l).dot(c)},ColorFromHexa:function(k){k=parseInt(k,16);return{r:(k&16711680)>>16,g:(k&65280)>>8,b:k&255}},
GetColor:function(k,d,c){var l=c.indices;return this.ColorFromHexa(d[c.source][l[k%l.length]])},DotNormalsInterleaved:function(k,d,c,l){var g=3*k[1],n=3*k[1+l],e=3*k[1+2*l],g=new h.Vector3(d[g],d[g+1],d[g+2]),n=new h.Vector3(d[n],d[n+1],d[n+2]),d=new h.Vector3(d[e],d[e+1],d[e+2]),d=g.add(n).add(d).normalize(),g=3*k[0],e=3*k[l],l=3*k[2*l],k=new h.Vector3(c[g],c[g+1],c[g+2]),e=new h.Vector3(c[e],c[e+1],c[e+2]),c=new h.Vector3(c[l],c[l+1],c[l+2]),l=e.sub(k).normalize(),c=c.sub(k).normalize();return l.cross(c).dot(d)},
CreateCuboidFaces:function(k,d){var c=this;return function(){var l=0.5*d.length,g=0.5*d.width,n=0.5*d.height,e=[-1,1,1,1,1,1,-1,-1,1,1,-1,1,1,1,-1,-1,1,-1,1,-1,-1,-1,-1,-1,-1,1,-1,-1,1,1,-1,-1,-1,-1,-1,1,1,1,1,1,1,-1,1,-1,1,1,-1,-1,-1,1,1,1,1,1,-1,1,-1,1,1,-1,1,-1,1,-1,-1,1,1,-1,-1,-1,-1,-1].map(function(b,c){switch(c%3){case 0:return b*l;case 1:return b*g;case 2:return b*n}}),e=new h.BufferAttribute(new Float32Array(e),3);k.addAttribute("position",e);var e=1/3,b=2*e,e=new h.BufferAttribute(new Float32Array([0,
e,0.5,e,0,0,0.5,0,0.5,e,1,e,0.5,0,1,0,0.5,1,1,1,0.5,b,1,b,0,1,0.5,1,0,b,0.5,b,0,e,0.5,e,0,b,0.5,b,0.5,e,1,e,0.5,b,1,b]),2);k.addAttribute("uv",e);if(d.hasOwnProperty("colors")&&null!==d.colors){e=[];for(b=0;24>b;b++){var v;switch(Math.floor(b/4)){case 0:v=2;break;case 1:v=5;break;case 2:v=3;break;case 3:v=0;break;case 4:v=1;break;case 5:v=4}var t=c.ColorFromHexa(d.colors[v%d.colors.length]);e.push(t.r/255);e.push(t.g/255);e.push(t.b/255)}v=new h.BufferAttribute(new Float32Array(e),3);k.addAttribute("color",
v)}v=new Uint16Array([0,2,1,2,3,1,4,6,5,6,7,5,8,10,9,10,11,9,12,14,13,14,15,13,16,17,18,18,17,19,20,21,22,22,21,23]);k.setIndex(new h.BufferAttribute(v,1));v=new h.BufferAttribute(new Float32Array([0,0,1,0,0,1,0,0,1,0,0,1,0,0,-1,0,0,-1,0,0,-1,0,0,-1,-1,0,0,-1,0,0,-1,0,0,-1,0,0,1,0,0,1,0,0,1,0,0,1,0,0,0,1,0,0,1,0,0,1,0,0,1,0,0,-1,0,0,-1,0,0,-1,0,0,-1,0]),3);k.addAttribute("normal",v)}},CreateCuboidHardEdges:function(k,d){return function(){var c=-d.length/2,l=-d.width/2,g=-d.height/2,n=d.length/2,e=
d.width/2,b=d.height/2,v=[c,l,g],t=[n,l,g],m=[c,l,b],l=[n,l,b],r=[c,e,g],g=[n,e,g],c=[c,e,b],n=[n,e,b],v=[].concat(v,m,m,l,l,t,m,c,c,n,n,l,c,r,r,g,g,n,r,v,v,t,t,g),v=new h.BufferAttribute(new Float32Array(v),3);k.addAttribute("position",v)}},CreateMeshFaces:function(k,d,c){var l=this;return function(){var g=c.input.position,n=c.input.interleaved,e=c.input.color,b=c.input.normal,v=c.input.texcoord,t=b&&b.hasOwnProperty("smooth")&&J.get("toBool")(b.smooth);if(n){var m=d[n.sources[0]],b=n.indices,r=
d[n.sources[1]],x=null,p=[],v=[],g=[],q=[],i=[],j,u;switch(n.format){default:D.Log("ThreeDObjectHandler Warning: Unrecognized interleaved format, switching to default PNT");case "PNT":x=d[n.sources[2]];j=9;u=3;break;case "PN":j=6,u=2}switch(c.topology){default:D.Log("ThreeDObjectHandler Warning: Unrecognized topology type. Switching to default triangle soup");case "TRIANGLE_SOUP":n=l.DotNormalsInterleaved(b,r,m,u);0==n&&D.Log("ThreeDObjectHandler Warning: Problem in normal computation for winding");
(0>n&&"CCW"==c.winding||0<n&&"CW"==c.winding)&&D.Log("ThreeDObjectHandler Warning: Surface winding is not coherent with input normals, please check input file.");switch(c.winding){default:case "CCW":n=1;break;case "CW":n=-1}for(var f={},a=0;a<c.count;++a){0>n&&(b[a*j+u]=[b[a*j+2*u],b[a*j+2*u]=b[a*j+u]][0],b[a*j+u+1]=[b[a*j+2*u+1],b[a*j+2*u+1]=b[a*j+u+1]][0],3<=u&&(b[a*j+u+2]=[b[a*j+2*u+2],b[a*j+2*u+2]=b[a*j+u+2]][0]));var s,A,B,C,F,G,H,y,z;s=m[3*b[j*a]];A=m[3*b[j*a]+1];B=m[3*b[j*a]+2];C=m[3*b[j*a+
u]];F=m[3*b[j*a+u]+1];G=m[3*b[j*a+u]+2];H=m[3*b[j*a+2*u]];y=m[3*b[j*a+2*u]+1];z=m[3*b[j*a+2*u]+2];var w=[s,A,B,C,F,G,H,y,z];p.push.apply(p,w);t?(w=function(a,b,c){f.hasOwnProperty(a)?f[a].add(c):f[a]=c},s=new h.Vector3(s,A,B),C=new h.Vector3(C,F,G),H=new h.Vector3(H,y,z),y=C.clone().sub(s),H=H.clone().sub(s),H=y.cross(H),w(b[j*a],f,H),w(b[j*a+u],f,H),w(b[j*a+2*u],f,H)):(w=[r[3*b[j*a+1]],r[3*b[j*a+1]+1],r[3*b[j*a+1]+2],r[3*b[j*a+u+1]],r[3*b[j*a+u+1]+1],r[3*b[j*a+u+1]+2],r[3*b[j*a+2*u+1]],r[3*b[j*a+
2*u+1]+1],r[3*b[j*a+2*u+1]+2]],v.push.apply(v,w));w=x?[x[2*b[j*a+2]],x[2*b[j*a+2]+1],x[2*b[j*a+u+2]],x[2*b[j*a+u+2]+1],x[2*b[j*a+2*u+2]],x[2*b[j*a+2*u+2]+1]]:[0,0,0,0,0,0];g.push.apply(g,w);q.push.apply(q,w);e&&(w=l.GetColor(a,d,e),i.push.apply(i,[w.r/255,w.g/255,w.b/255]),i.push.apply(i,[w.r/255,w.g/255,w.b/255]),i.push.apply(i,[w.r/255,w.g/255,w.b/255]))}if(t){n=0;a=Object.keys(f);for(m=a.length;n<m;++n)f[a[n]].normalize();for(a=0;a<c.count;++a)w=[f[b[j*a]].x,f[b[j*a]].y,f[b[j*a]].z,f[b[j*a+u]].x,
f[b[j*a+u]].y,f[b[j*a+u]].z,f[b[j*a+2*u]].x,f[b[j*a+2*u]].y,f[b[j*a+2*u]].z],v.push.apply(v,w)}}k.addAttribute("position",new h.BufferAttribute(new Float32Array(p),3));k.addAttribute("normal",new h.BufferAttribute(new Float32Array(v),3));e&&k.addAttribute("color",new h.BufferAttribute(new Float32Array(i),3));k.addAttribute("uv",new h.BufferAttribute(new Float32Array(g),2));k.addAttribute("uv2",new h.BufferAttribute(new Float32Array(q),2));k.uvsNeedUpdate=!0}else{n=1;b&&(g&&b.hasOwnProperty("indices")&&
b.indices&&3<=b.indices.length&&d[b.source]&&g.hasOwnProperty("indices")&&g.indices&&3<=g.indices.length&&d[g.source])&&(n=d[g.source],r=d[b.source],n=l.DotNormals(b.indices,g.indices,r,n),0==n&&D.Log("ThreeDObjectHandler Warning: Problem in normal computation for winding"),(0>n&&"CCW"==c.winding||0<n&&"CW"==c.winding)&&D.Log("ThreeDObjectHandler Warning: Surface winding is not coherent with input normals, please check input file."));switch(c.winding){default:case "CCW":n=1;break;case "CW":n=-1}if(g){m=
d[g.source];b=g.indices;p=[];i=[];switch(c.topology){default:D.Log("ThreeDObjectHandler Warning: Unrecognized topology type. Switching to default triangle soup");case "TRIANGLE_SOUP":for(a=0;a<c.count;++a)0>n&&(b[3*a+2]=[b[3*a+1],b[3*a+1]=b[3*a+2]][0]),w=[m[3*parseInt(b[3*a])],m[3*parseInt(b[3*a])+1],m[3*parseInt(b[3*a])+2],m[3*parseInt(b[3*a+1])],m[3*parseInt(b[3*a+1])+1],m[3*parseInt(b[3*a+1])+2],m[3*parseInt(b[3*a+2])],m[3*parseInt(b[3*a+2])+1],m[3*parseInt(b[3*a+2])+2]],void 0===w[0]||void 0===
w[1]||void 0===w[2]||void 0===w[3]||void 0===w[4]||void 0===w[5]||void 0===w[6]||void 0===w[7]||void 0===w[8]?D.Log("ThreeDObjectHandler Warning: index out of vertices array bounds"):p.push.apply(p,w),e&&(w=l.GetColor(a,d,e),i.push.apply(i,[w.r/255,w.g/255,w.b/255]),i.push.apply(i,[w.r/255,w.g/255,w.b/255]),i.push.apply(i,[w.r/255,w.g/255,w.b/255]))}k.addAttribute("position",new h.BufferAttribute(new Float32Array(p),3));e&&k.addAttribute("color",new h.BufferAttribute(new Float32Array(i),3))}if(b=
c.input.normal)if(b.hasOwnProperty("smooth")&&J.get("toBool")(b.smooth)){m=d[g.source];b=g.indices;e=[];f={};r=new h.Vector3;p=new h.Vector3;g=new h.Vector3;q=new h.Vector3;i=new h.Vector3;for(a=0;a<c.count;++a)t=3*b[3*a],x=3*b[3*a+1],j=3*b[3*a+2],r.fromArray(m,t),p.fromArray(m,x),g.fromArray(m,j),q.subVectors(g,p),i.subVectors(r,p),q.cross(i),u=function(a,b){f.hasOwnProperty(a)?f[a].add(b):f[a]=b.clone()},u(t,q),u(x,q),u(j,q);r=0;a=Object.keys(f);for(m=a.length;r<m;++r)f[a[r]].normalize();for(a=
0;a<c.count;++a)t=3*b[3*a],x=3*b[3*a+1],j=3*b[3*a+2],t=[f[t].x,f[t].y,f[t].z,f[x].x,f[x].y,f[x].z,f[j].x,f[j].y,f[j].z],e.push.apply(e,t);k.addAttribute("normal",new h.BufferAttribute(new Float32Array(e),3))}else if(b.hasOwnProperty("indices")&&b.indices&&b.indices.length&&d[b.source]){r=d[b.source];b=b.indices;e=[];for(a=0;a<c.count;++a)0>n&&(b[3*a+2]=[b[3*a+1],b[3*a+1]=b[3*a+2]][0]),t=[r[3*b[3*a]],r[3*b[3*a]+1],r[3*b[3*a]+2],r[3*b[3*a+1]],r[3*b[3*a+1]+1],r[3*b[3*a+1]+2],r[3*b[3*a+2]],r[3*b[3*a+
2]+1],r[3*b[3*a+2]+2]],e.push.apply(e,t);k.addAttribute("normal",new h.BufferAttribute(new Float32Array(e),3))}else if(b.hasOwnProperty("smooth")&&!J.get("toBool")(b.smooth)){m=d[g.source];b=g.indices;e=[];r=new h.Vector3;p=new h.Vector3;g=new h.Vector3;q=new h.Vector3;i=new h.Vector3;for(a=0;a<c.count;++a)t=3*b[3*a],x=3*b[3*a+1],j=3*b[3*a+2],r.fromArray(m,t),p.fromArray(m,x),g.fromArray(m,j),q.subVectors(g,p),i.subVectors(r,p),q.cross(i),q.normalize(),t=[q.x,q.y,q.z,q.x,q.y,q.z,q.x,q.y,q.z],e.push.apply(e,
t);k.addAttribute("normal",new h.BufferAttribute(new Float32Array(e),3))}else D.Log("Problem parsing json: no normal computation can be infered");else k.computeVertexNormals();g=[];q=[];if(v&&v.indices&&v.indices.length&&d[v.source]){x=d[v.source];b=v.indices;for(a=0;a<c.count;a++)0>n&&(b[3*a+2]=[b[3*a+1],b[3*a+1]=b[3*a+2]][0]),w=[x[2*b[3*a]],x[2*b[3*a]+1],x[2*b[3*a+1]],x[2*b[3*a+1]+1],x[2*b[3*a+2]],x[2*b[3*a+2]+1]],g.push.apply(g,w),q.push.apply(q,w);k.uvsNeedUpdate=!0}else for(a=0;a<3*c.count;a++)g.push.apply(g,
[0,0]),q.push.apply(q,[0,0]);k.addAttribute("uv",new h.BufferAttribute(new Float32Array(g),2));k.addAttribute("uv2",new h.BufferAttribute(new Float32Array(q),2))}}},AttributesInit:function(k,d){return function(){d.attributes.position&&(k.attributes.position=d.attributes.position);d.attributes.normal&&(k.attributes.normal=d.attributes.normal);d.attributes.color&&(k.attributes.color=d.attributes.color);d.attributes.uv&&(k.attributes.uv=d.attributes.uv);d.attributes.uv2&&(k.attributes.uv2=d.attributes.uv2);
d.adjacentfacesedgeslines.attributes.position&&(k.adjacentfacesedgeslines.attributes.position=d.adjacentfacesedgeslines.attributes.position)}},CreateMeshHardEdges:function(k,d,c,l,g){return function(){var n=c.input.position,e=c.input.interleaved,b=c.input.normal,v=!(b&&b.hasOwnProperty("smooth")&&J.get("toBool")(b.smooth)),t={};if(v||g)for(var m={},r=0;r<c.count;++r){var x=r,p,q,i;if(n)i=n.indices,p=parseInt(i[3*x]),q=parseInt(i[3*x+1]),i=parseInt(i[3*x+2]);else if(e){var j,u;switch(e.format){default:D.Log("ThreeDObjectHandler Warning: Unrecognized interleaved format, switching to default PNT");
case "PNT":j=9;u=3;break;case "PN":j=6,u=2}i=e.indices;p=parseInt(i[x*j]);q=parseInt(i[x*j+u]);i=parseInt(i[x*j+2*u])}var f={"0":p,1:q,face1:x,face2:null,opedge:null,edgeIDF1:0,edgeIDF2:null},a=f["0"]+"/"+f["1"],s=f["1"]+"/"+f["0"];m.hasOwnProperty(s)?(m[a]=f,m[a].face2=m[s].face1,m[a].opedge=m[s],m[s].face2&&D.Log("ThreeDObjectHandler Warning: Edge shared with more than two faces"),m[s].face2=x,m[s].opedge=f,m[s].edgeIDF2=0):m.hasOwnProperty(a)?D.Log("ThreeDObjectHandler Warning: Edge already existing : not treated"):
(m[a]=f,t[a]=f);f={"0":q,1:i,face1:x,face2:null,opedge:null,edgeIDF1:1,edgeIDF2:null};a=f["0"]+"/"+f["1"];s=f["1"]+"/"+f["0"];m.hasOwnProperty(s)?(m[a]=f,m[a].face2=m[s].face1,m[a].opedge=m[s],m[s].face2&&D.Log("ThreeDObjectHandler Warning: Edge shared with more than two faces"),m[s].face2=x,m[s].opedge=f,m[s].edgeIDF2=1):m.hasOwnProperty(a)?D.Log("Warning: Edge already existing : not treated"):(m[a]=f,t[a]=f);f={"0":i,1:p,face1:x,face2:null,opedge:null,edgeIDF1:2,edgeIDF2:null};a=f["0"]+"/"+f["1"];
s=f["1"]+"/"+f["0"];m.hasOwnProperty(s)?(m[a]=f,m[a].face2=m[s].face1,m[a].opedge=m[s],m[s].face2&&D.Log("ThreeDObjectHandler Warning: Edge shared with more than two faces"),m[s].face2=x,m[s].opedge=f,m[s].edgeIDF2=2):m.hasOwnProperty(a)?D.Log("ThreeDObjectHandler Warning: Edge already existing : not treated"):(m[a]=f,t[a]=f)}m=[];r=0;x=Object.keys(t);for(p=x.length;r<p;++r)if(q=t[x[r]],q.face2){if(v){f=new h.Vector3;if(b||e){var A,B,C,F,G;if(n&&b)a=d[b.source],i=b.indices,s=3*q.face1+q.edgeIDF1,
C=3*q.face1+(q.edgeIDF1+1)%3,F=3*q.face2+q.edgeIDF2,G=3*q.face2+(q.edgeIDF2+1)%3;else{switch(e.format){default:D.Log("ThreeDObjectHandler Warning: Unrecognized interleaved format, switching to default PNT");case "PNT":j=9;u=3;break;case "PN":j=6,u=2}a=d[e.sources[1]];i=e.indices;s=q.face1*j+1+u*q.edgeIDF1;C=q.face1*j+1+u*((q.edgeIDF1+1)%3);F=q.face2*j+1+u*q.edgeIDF2;G=q.face2*j+1+u*((q.edgeIDF2+1)%3)}j=new h.Vector3;u=new h.Vector3;A=new h.Vector3;B=new h.Vector3;j.fromArray(a,3*i[s]);u.fromArray(a,
3*i[C]);A.fromArray(a,3*i[F]);B.fromArray(a,3*i[G]);j.normalize();u.normalize();A.normalize();B.normalize();i=Math.abs(Math.min(j.dot(B),u.dot(A)))>1-l;f.addVectors(j,u);f.add(A).add(B).divideScalar(4)}else{if(n){z=d[n.source];i=n.indices;G=3*q.face1+q.edgeIDF1;var H=3*q.face1+(q.edgeIDF1+1)%3,y=3*q.face1+(q.edgeIDF1+2)%3,a=3*q.face2+q.edgeIDF2,s=3*q.face2+(q.edgeIDF2+1)%3;C=3*q.face2+(q.edgeIDF2+2)%3;F=new h.Vector3;j=new h.Vector3;u=new h.Vector3;A=new h.Vector3;B=new h.Vector3;F.fromArray(z,3*
i[G]);j.fromArray(z,3*i[H]);u.fromArray(z,3*i[y]);A.subVectors(u,j);B.subVectors(F,j);A.cross(B);A.normalize();G=A.clone();F.fromArray(z,3*i[a]);j.fromArray(z,3*i[s]);u.fromArray(z,3*i[C]);A.subVectors(u,j);B.subVectors(F,j);A.cross(B);A.normalize();a=A.clone()}else{D.Log("Missing vertex data");break}i=Math.abs(G.dot(a))>1-l;f.addVectors(G,a);f.divideScalar(4)}i||(i=q["0"],q=q["1"],n?z=d[n.source]:e&&(z=d[e.sources[0]]),a=3*i,f=3*q,i=z[a],q=z[a+1],a=z[a+2],s=z[f],C=z[f+1],f=z[f+2],m.push(i,q,a,s,
C,f))}}else if(g){i=q["0"];q=q["1"];var z;n?z=d[n.source]:e&&(z=d[e.sources[0]]);a=3*i;f=3*q;i=z[a];q=z[a+1];a=z[a+2];s=z[f];C=z[f+1];f=z[f+2];m.push(i,q,a,s,C,f)}z=new h.BufferAttribute(new Float32Array(m),3);k.addAttribute("position",z)}},InstanciateGeometry:function(k,d,c,l,g,n,e,b,v,t,m,r,x){var p,q,i,j;void 0===r&&(r="");var u=!1;switch(k){case "Cuboid":j=l.hasOwnProperty("surfaceID")&&e.hasOwnProperty(l.surfaceID)?e[l.surfaceID].material_name:"default_material";g.hasOwnProperty(r+d)||(g[r+d]=
{});this.get("_geom_register_map").hasOwnProperty(r+d)||(this.get("_geom_register_map")[r+d]={});this.get("_geom_register_map")[r+d].hasOwnProperty(j+"#"+c)||(this.get("_geom_register_map")[r+d][j+"#"+c]={},u=!0);if(!g[r+d].hasOwnProperty(j)&&"opaque_pass"==c){this.set("_geometrycounter",this.get("_geometrycounter")+1);p=new h.InstancedBufferGeometry;p.maxInstancedCount=1;p.adjacentfacesedgeslines=new h.InstancedBufferGeometry;p.adjacentfacesedgeslines.maxInstancedCount=1;var f=new h.Vector3,a=new h.Quaternion,
s=new h.Vector3(1,1,1);m.decompose(f,a,s);var A=(new h.InstancedBufferAttribute(new Float32Array(3*p.maxInstancedCount),3,1)).setDynamic(!0);A.setXYZ(0,f.x,f.y,f.z);var B=(new h.InstancedBufferAttribute(new Float32Array(4*p.maxInstancedCount),4,1)).setDynamic(!0);B.setXYZW(0,a.x,a.y,a.z,a.w);var C=(new h.InstancedBufferAttribute(new Float32Array(3*p.maxInstancedCount),3,1)).setDynamic(!0);C.setXYZ(0,s.x,s.y,s.z);this.get("_proxy_geometries").hasOwnProperty(d)?(p.copy(this.get("_proxy_geometries")[d]),
p.adjacentfacesedgeslines.copy(this.get("_proxy_geometries")[d].adjacentfacesedgeslines)):(this.set("_geometrycounter",this.get("_geometrycounter")+1),this.get("_proxy_geometries")[d]=p,this.CreateCuboidFaces(p,l)(),this.CreateCuboidHardEdges(p.adjacentfacesedgeslines,l)());p.addAttribute("inst_translation",A);p.addAttribute("inst_rotation",B);p.addAttribute("inst_scale",C);p.adjacentfacesedgeslines.addAttribute("inst_translation",A);p.adjacentfacesedgeslines.addAttribute("inst_rotation",B);p.adjacentfacesedgeslines.addAttribute("inst_scale",
C);p.attributes.inst_translation.jarray=[f.x,f.y,f.z];p.attributes.inst_rotation.jarray=[a.x,a.y,a.z,a.w];p.attributes.inst_scale.jarray=[s.x,s.y,s.z];g[r+d][j]=p}else p=g[r+d][j],"opaque_pass"==c&&(f=new h.Vector3,a=new h.Quaternion,s=new h.Vector3(1,1,1),m.decompose(f,a,s),p.attributes.inst_translation.jarray.push(f.x,f.y,f.z),p.attributes.inst_rotation.jarray.push(a.x,a.y,a.z,a.w),p.attributes.inst_scale.jarray.push(s.x,s.y,s.z));break;case "Mesh":q=null;for(var F=0,G=Object.keys(l.triangles),
H=G.length;F<H;++F){var y=G[F],z=l.triangles[y];if(0<z.count){j=e.hasOwnProperty(y)?e[y].material_name:"default_material";g.hasOwnProperty(r+d)?i=g[r+d]:g[r+d]=i=[];if(this.get("_geomsources").hasOwnProperty(d))q=this.get("_geomsources")[d];else{q={};if(l.sources)for(var f=0,a=Object.keys(l.sources),w=a.length;f<w;++f)if(s=a[f],"string"==typeof s){var A=[],B=l.sources[s].stride,C=l.sources[s].count,I=l.sources[s].values;switch(l.sources[s].format){case "ST":case "UV":for(var E=0;E<C;++E)A.push.apply(A,
[parseFloat(I[E*B]),parseFloat(I[E*B+1])]);break;case "XYZ":case "RGB":for(E=0;E<C;++E)A.push.apply(A,[parseFloat(I[E*B]),parseFloat(I[E*B+1]),parseFloat(I[E*B+2])]);break;case "XYZW":for(E=0;E<C;++E)A.push.apply(A,[parseFloat(I[E*B]),parseFloat(I[E*B+1]),parseFloat(I[E*B+2]),parseFloat(I[E*B+3])]);break;default:D.Log("ThreeDObjectHandler Warning: Unhandled format string: default single buffer selected");case "C":A=I}q[s]=A}this.get("_geomsources")[d]=q}i.hasOwnProperty(y)||(i[y]={});this.get("_geom_register_map").hasOwnProperty(r+
d)||(this.get("_geom_register_map")[r+d]={});if(!this.get("_geom_register_map")[r+d].hasOwnProperty(j+"#"+c)||z.hasOwnProperty("coincident-group"))this.get("_geom_register_map")[r+d][j+"#"+c]={},u=!0;if(!i[y].hasOwnProperty(j)||z.hasOwnProperty("coincident-group")){if("opaque_pass"==c){f=!1;if(z.hasOwnProperty("coincident-group")&&i[y]){s=0;a=Object.keys(i[y]);for(w=a.length;s<w;++s)if(A=a[s],"default_cg"!=A&&1==i[y][A].maxInstancedCount){f=!0;p=i[y][A];break}}f||(p=new h.InstancedBufferGeometry,
p.maxInstancedCount=1,p.adjacentfacesedgeslines=new h.InstancedBufferGeometry,p.adjacentfacesedgeslines.maxInstancedCount=1,a=d,w=z.hasOwnProperty("coincident-group")?parseFloat(z["coincident-group"]):0,s=z.hasOwnProperty("coincident-priority")?parseFloat(z["coincident-priority"]):0,A=z.hasOwnProperty("coincident-group-tag")?z["coincident-group-tag"]:"tris-same",p.useSoftwareInstancing=z.hasOwnProperty("coincident-group")?!0:f,p.adjacentfacesedgeslines.useSoftwareInstancing=z.hasOwnProperty("coincident-group")?
!0:f,p.coincidentmeshID=a,p.coincidentgroup=w,p.coincidentpriority=s,p.coincidentgrouptag=A,A=(new h.InstancedBufferAttribute(new Float32Array(3*p.maxInstancedCount),3,1)).setDynamic(!0),B=(new h.InstancedBufferAttribute(new Float32Array(4*p.maxInstancedCount),4,1)).setDynamic(!0),C=(new h.InstancedBufferAttribute(new Float32Array(3*p.maxInstancedCount),3,1)).setDynamic(!0),f=new h.Vector3,a=new h.Quaternion,s=new h.Vector3(1,1,1),z.hasOwnProperty("coincident-group")||m.decompose(f,a,s),A.setXYZ(0,
f.x,f.y,f.z),B.setXYZW(0,a.x,a.y,a.z,a.w),C.setXYZ(0,s.x,s.y,s.z),p.addAttribute("inst_translation",A),p.addAttribute("inst_rotation",B),p.addAttribute("inst_scale",C),p.adjacentfacesedgeslines.addAttribute("inst_translation",A),p.adjacentfacesedgeslines.addAttribute("inst_rotation",B),p.adjacentfacesedgeslines.addAttribute("inst_scale",C),p.attributes.inst_translation.jarray=[f.x,f.y,f.z],p.attributes.inst_rotation.jarray=[a.x,a.y,a.z,a.w],p.attributes.inst_scale.jarray=[s.x,s.y,s.z],this.get("_proxy_geometries").hasOwnProperty(d)||
(this.get("_proxy_geometries")[d]={}),this.get("_proxy_geometries")[d].hasOwnProperty(y)?f=this.get("_proxy_geometries")[d][y]:(this.set("_geometrycounter",this.get("_geometrycounter")+1),this.get("_proxy_geometries")[d][y]=f=new h.BufferGeometry,f.adjacentfacesedgeslines=new h.BufferGeometry,this.get("_build_mesh_execution_queue").run(this.CreateMeshFaces(f,q,z),this,!1,null,null,!0),this.get("_build_mesh_execution_queue").run(this.CreateMeshHardEdges(f.adjacentfacesedgeslines,q,z,b,v),this,!1,null,
null,!0)),this.get("_build_mesh_execution_queue").run(this.AttributesInit(p,f),this,!1,null,null,!0),i[y].hasOwnProperty(j)||(i[y][j]={}),z.hasOwnProperty("coincident-group")?i[y][j][w]=p:i[y][j].default_cg=p)}}else p=i[y][j].default_cg,p instanceof h.InstancedBufferGeometry&&("opaque_pass"==c&&void 0===t)&&(f=new h.Vector3,a=new h.Quaternion,s=new h.Vector3(1,1,1),m.decompose(f,a,s),p.attributes.inst_translation.jarray.push(f.x,f.y,f.z),p.attributes.inst_rotation.jarray.push(a.x,a.y,a.z,a.w),p.attributes.inst_scale.jarray.push(s.x,
s.y,s.z))}}break;default:D.Log("ThreeDObjectHandler Warning: Unrecognized type of geometry - Accepted: Cuboid, Mesh")}d=[];if(u)switch(c){case "highlightnode":switch(k){case "Cuboid":d.push(new h.LineSegments(p.adjacentfacesedgeslines,n.highlight));break;case "Mesh":f=0;a=Object.keys(i);for(w=a.length;f<w;++f)if(y=a[f],p=i[y],j=e.hasOwnProperty(y)?e[y].material_name:"default_material",p[j]){s=0;c=Object.keys(p[j]);for(x=c.length;s<x;++s)d.push(new h.LineSegments(p[j][c[s]].adjacentfacesedgeslines,
n.highlight))}break;default:D.Log("ThreeDObjectHandler Warning: Unrecognized type of geometry - Accepted: Cuboid, Mesh")}break;default:switch(k){case "Cuboid":if(l.hasOwnProperty("surfaceID")&&e.hasOwnProperty(l.surfaceID)){if(y=l.surfaceID,i=e[y].front,j=1>i.opacity||i.transp_texture,x.SetNonEmptyScene(j),i.mat.untextured_mat[c]){i.boundmeshlist||(i.boundmeshlist={});i.boundmeshlist.hasOwnProperty(c)||(i.boundmeshlist[c]={});i.boundmeshlist[c].hasOwnProperty("front_mat")||(i.boundmeshlist[c].front_mat=
{});j=i.mat.untextured_mat[c];k=0;l=Object.keys(j);for(t=l.length;k<t;k++)g=l[k],r=j[l[g]],i.mat.textured_mat.hasOwnProperty(c)||(i.mat.textured_mat[c]={}),i.mat.textured_mat[c].hasOwnProperty(g)||(i.mat.textured_mat[c][g]={}),i.mat.textured_mat[c][g].hasOwnProperty(y)||(i.mat.textured_mat[c][g][y]=r),i.boundmeshlist[c].front_mat.hasOwnProperty(g)||(i.boundmeshlist[c].front_mat[g]={}),i.boundmeshlist[c].front_mat[g].hasOwnProperty(y)||(i.boundmeshlist[c].front_mat[g][y]=[]),r=new h.Mesh(p,r),d.push(r),
i.boundmeshlist[c].front_mat[g][y].push(r)}}else r=new h.Mesh(p,n.default_material),d.push(r),x.SetNonEmptyScene(!1);break;case "Mesh":p=this.OrderRenderList(c,i,t,e,x);f=0;a=Object.keys(p);for(w=a.length;f<w;++f)if(y=p[f].surfaceID,b=p[f].geometry,v=p[f].material,e.hasOwnProperty(y))if(m=v.side==h.BackSide?"back_mat":"front_mat",i=v.side==h.BackSide?e[y].back:e[y].front){if(j=1>i.opacity||i.transp_texture,(!v.transparencylayer||j)&&i.mat.untextured_mat[c]){j=i.mat.untextured_mat[c];k=0;l=Object.keys(j);
for(t=l.length;k<t;k++)g=l[k],r=j[g],v.side==h.BackSide&&e[y].sharedmaterial&&r.side==h.FrontSide||(q=new r.constructor({name:"placeholder_material"}),q.copy(r),q.side=v.side,i.mat.textured_mat.hasOwnProperty(c)||(i.mat.textured_mat[c]={}),i.mat.textured_mat[c].hasOwnProperty(g)||(i.mat.textured_mat[c][g]={}),i.mat.textured_mat[c][g].hasOwnProperty(y)||(i.mat.textured_mat[c][g][y]=q),i.boundmeshlist||(i.boundmeshlist={}),i.boundmeshlist.hasOwnProperty(c)||(i.boundmeshlist[c]={}),i.boundmeshlist[c].hasOwnProperty(m)||
(i.boundmeshlist[c][m]={}),i.boundmeshlist[c][m].hasOwnProperty(g)||(i.boundmeshlist[c][m][g]={}),i.boundmeshlist[c][m][g].hasOwnProperty(y)||(i.boundmeshlist[c][m][g][y]=[]),r=new h.Mesh(b,q),d.push(r),i.boundmeshlist[c][m][g][y].push(r))}}else D.Log("ThreeDObjectHandler Warning: No front material found for this surface");else r=new h.Mesh(b,n.default_material),d.push(r),x.SetNonEmptyScene(!1);break;default:D.Log("ThreeDObjectHandler Warning: Unrecognized type of geometry - Only accepted: Cuboid, Mesh")}}return{register:u,
objects:d}},OrderRenderList:function(k,d,c,l,g){for(var k=[],n=[],e,b=Object.keys(d),h=b.length-1;-1!==h;h--){var t=d[b[h]];e=b[h];e=l.hasOwnProperty(e)?l[e].material_name:"default_material";if(t[e])for(var m=0,r=Object.keys(t[e]),x=r.length;m<x;++m)n.push({surfaceID:b[h],geometry:t[e][r[m]]});t=!1;l.hasOwnProperty(b[h])&&(t=l[b[h]].front,e=l[b[h]].back,e=1>e.opacity||e.transp_texture,t=1>t.opacity||t.transp_texture||e);g.SetNonEmptyScene(t)}n.sort(this.CompareSurfacesInGlueGroup(!0));d=this.splitSingleSurfaces(n);
void 0===c&&(n=this.DuplicateSurfaceForFrontAndBack(d.singles),Array.prototype.push.apply(k,n.ungrouped),Array.prototype.push.apply(k,n.front),Array.prototype.push.apply(k,n.back));l=this.FilterRenderList(d.sorted,c,l,g);l=this.DuplicateSurfaceForFrontAndBack(l);l.front.sort(this.CompareSurfacesInGlueGroup(!0));l.back.sort(this.CompareSurfacesInGlueGroup(!1));void 0===c&&Array.prototype.push.apply(k,l.ungrouped);this.tagInnerSurfaces(l.front,!1);l.back.reverse();this.tagInnerSurfaces(l.back,!0);l.back.reverse();
Array.prototype.push.apply(k,l.back);Array.prototype.push.apply(k,l.front);return k},DuplicateSurfaceForFrontAndBack:function(k){for(var d=[],c=[],l=[],g=Object.keys(k),n=g.length-1;-1!==n;n--){var e=k[g[n]].geometry;if(e.hasOwnProperty(["coincidentgroup"])&&e.hasOwnProperty(["coincidentpriority"])&&e.hasOwnProperty(["coincidentgrouptag"])&&0<=e.coincidentgroup&&0!==e.coincidentpriority){var b=e.coincidentpriority,v={surfaceID:k[g[n]].surfaceID,geometry:e,material:{transparencylayer:!1,coincidentsurface:!0,
fromARD:!1,side:0<b?h.FrontSide:h.BackSide}},t={surfaceID:k[g[n]].surfaceID,geometry:e,material:{transparencylayer:!1,coincidentsurface:!0,fromARD:!1,side:0<b?h.BackSide:h.FrontSide}};switch(e.coincidentgrouptag){case "planar":0<b?d.unshift(v):c.unshift(t);break;default:case "tris-same":case "shape-same":d.unshift(v),c.unshift(t)}}else v={surfaceID:k[g[n]].surfaceID,geometry:e,material:{transparencylayer:!1,coincidentsurface:!1,fromARD:!1,side:h.FrontSide}},t={surfaceID:k[g[n]].surfaceID,geometry:e,
material:{transparencylayer:!1,coincidentsurface:!1,fromARD:!1,side:h.BackSide}},l.push(v),l.unshift(t)}return{front:d,back:c,ungrouped:l}},FilterRenderList:function(k,d,c,l){for(var g=[],n=Object.keys(k),e=n.length-1;-1!==e;e--){var b=k[n[e]].surfaceID;if(c.hasOwnProperty(b)){var h=c[b].front,b=c[b].back,b=1>b.opacity||b.transp_texture,h=1>h.opacity||h.transp_texture||b,b=!1,t=k[n[e]].geometry;if(t.hasOwnProperty(["coincidentgroup"])&&t.hasOwnProperty(["coincidentpriority"])&&t.hasOwnProperty(["coincidentgrouptag"])&&
0<=t.coincidentgroup&&0!==t.coincidentpriority)switch(t.coincidentgrouptag){case "planar":b=!0;break;default:case "tris-same":case "shape-same":b=!1}void 0===d?(b||h)&&t.hasOwnProperty("coincidentgroup")&&0<=t.coincidentgroup&&0!==t.coincidentpriority?l.CreateNewCoincidentGroupPass(t.coincidentgroup,h):g.push(k[e]):(b||h)&&(t.hasOwnProperty("coincidentgroup")&&0<=t.coincidentgroup&&0!==t.coincidentpriority&&d==t.coincidentgroup)&&g.push(k[e])}else D.Log("ThreeDObjectHandler Warning: Surface '"+b+
"' not found in material map :("),g.push(k[e])}return g},CompareSurfacesInGlueGroup:function(k){return function(d,c){return parseFloat(d.geometry.coincidentgroup)!=parseFloat(c.geometry.coincidentgroup)?0>parseFloat(d.geometry.coincidentgroup)&&0>parseFloat(c.geometry.coincidentgroup)?!1:parseFloat(d.geometry.coincidentgroup)-parseFloat(c.geometry.coincidentgroup):k?Math.abs(d.geometry.coincidentpriority)-Math.abs(c.geometry.coincidentpriority):Math.abs(c.geometry.coincidentpriority)-Math.abs(d.geometry.coincidentpriority)}},
splitSingleSurfaces:function(k){var d=[],c=[],l=Object.keys(k);if(0!=l.length)if(1==l.length)d=k;else for(var g=0;g!==l.length;g++){var h=!k[l[g]].geometry.hasOwnProperty("coincidentgroup");if(!h){var e=k[l[g]].geometry.coincidentgroup;if(0==g){var b=k[l[g+1]].geometry.coincidentgroup;e!=b&&(h=!0)}else if(g==l.length-1){var v=k[l[g-1]].geometry.coincidentgroup;e!=v&&(h=!0)}else b=k[l[g+1]].geometry.coincidentgroup,v=k[l[g-1]].geometry.coincidentgroup,e!=v&&e!=b&&(h=!0)}h?d.push(k[l[g]]):c.push(k[l[g]])}return{singles:d,
sorted:c}},tagInnerSurfaces:function(h,d){var c,l,g,n,e,b,v,t;c=l="-1";if(d)for(e=0;e<h.length;){b=h[e];v=b.geometry.coincidentgroup;t=b.geometry.coincidentpriority;switch(b.geometry.coincidentgrouptag){case "planar":m=!0;break;default:case "tris-same":case "shape-same":m=!1}0>t?(v!=l?n=t:t<n&&(b.material.transparencylayer=!m),l=v):b.material.transparencylayer=!m;b.material.fromARD=m;e++}else for(e=h.length-1;0<=e;){b=h[e];v=b.geometry.coincidentgroup;t=b.geometry.coincidentpriority;var m;switch(b.geometry.coincidentgrouptag){case "planar":m=
!0;break;default:case "tris-same":case "shape-same":m=!1}0<t?(v!=c?g=t:t<g&&(b.material.transparencylayer=!m),c=v):b.material.transparencylayer=!m;b.material.fromARD=m;e--}}})});