/**
 * @author DOGO, PHST
 * @module WebViewer3D
 * @copyright   2014 Esko Stonecube Ltd. All rights reserved.
 */

define("backbone underscore WV3Dlib/three WV3Dmod/threeEXT WV3Dmod/Math WV3Dmod/SystemChecker WV3Dmod/HttpRequestHandler WV3Dmod/ThreeDObjectHandler WV3Dmod/TextSpriteMaker WV3Dmod/shaders/UniformColorShader WV3Dmod/shaders/EdgeShader2 WV3Dmod/shaders/ShaderUtils WV3Dmod/shaders/D0Shader WV3Dmod/shaders/D1Shader WV3Dmod/shaders/D2Shader WV3Dmod/shaders/DepthOnlyShader WV3Dmod/shaders/BackdropShader WV3Dmod/shaders/ColorBlendShader WV3Dmod/shaders/TransparencyBlendShader WV3Dmod/shaders/CopyShader WV3Dmod/shaders/DesignerShader WV3Dmod/shaders/FilterShaderPM WV3Dmod/shaders/FilterShaderNPM WV3Dmod/shaders/ReflectanceShaderPM WV3Dmod/shaders/ReflectanceShaderNPM WV3Dmod/shaders/IrradianceShaderPM WV3Dmod/shaders/IrradianceShaderNPM WV3Dmod/shaders/DiffractionShaderPM WV3Dmod/Constants WV3Dmod/Utils WV3Dmod/FPSCounter WV3Dmod/Timers WV3Dmod/ExecutionQueue WV3Dmod/LogMessage".split(" "),
function(ca,$,d,da,z,A,ea,fa,ga,M,N,ia,E,O,P,Q,R,S,T,U,F,V,W,H,I,X,Y,Z,L,y,aa,ba,ha,w){return ca.Model.extend({initialize:function(a,b,c){w.Log("Creating WV3DViewerView Object");this.set("_context",a);this.set("_model",b);this.set("_clientUIAddElementCallback",c);a={alpha:!0,antialias:A.get("_glantialias"),preserveDrawingBuffer:!0};new da;this.set("_3JSrenderer",new d.WebGLRenderer(a));this.get("_3JSrenderer").sortObjects=!1;this.InitializeRenderTargets();this.set("_textSpriteMaker",new ga);this.set("_resourcePath",
"../Resources");this.set("_current_fps",0);this.set("_target_fps_min",25);this.set("_target_fps_max",60);this.set("_nb_max_peels",7);this.set("_nb_min_peels",2);this.set("_reflection_config","JSON");this.set("_enableInteractionOptimization",!1);this.set("_enableAnimations",!1);this.set("_lighting_contrast",0.5);this.set("_optimised_view",!1);this.set("_optimised_view_border",0);this.set("_obj_in_frustum_prev",!0);this.set("_obj_in_frustum",!0);this.set("_polygon_offset_factor",0.5);this.set("_polygon_offset_units",
1);this.set("_build_scene_exec_queue",new ha(!1,!1,$.bind(this.NotifySceneBuildProgress,this)));a=new Image(2,2);a.src="data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAAIAAAACCAIAAAD91JpzAAAACXBIWXMAAAsTAAALEwEAmpwYAAAAB3RJTUUH4AUMDiIqLjEjFgAAAAtJREFUCNdjYEAGAAAOAAEx6d0VAAAAAElFTkSuQmCC";var i=new d.Texture(a),f=new d.CubeTexture([a,a,a,a,a,a]);a.onload=function(){i.needsUpdate=!0;f.needsUpdate=!0;w.Log("Dummy texture loaded")};this.set("_DummyTexture",i);this.set("_DummyTextureCube",f);this.ResetScene();
this.CameraUpdate(!1);this.listenTo(this.get("_model"),"scene_reset",this.ResetScene);this.listenTo(this.get("_model"),"added_scene_resource",this.AddedResource);window.addEventListener("resize",$.bind(this.Resize,this),!1);this.Resize();this.SetBackgroundColor(0.37,0.37,0.37,1,!1);this.AppendRendererToDocument()},NotifySceneBuildProgress:function(a,b,c){"function"===typeof this.get("_model").get("_clientCallback")?(0==this.get("_model").get("_assetmanager").get("_textureCounter")&&(b=100),void 0===
b&&(b=100*(this.get("_model").get("_assetmanager").get("_textureLoadedCounter")/this.get("_model").get("_assetmanager").get("_textureCounter"))),void 0===c&&(c=0),this.get("_model").get("_clientCallback")(c,a,b,this.get("_model").get("_assetmanager").get("_assetloader").get("_httprequestmanager").get("_queriedassetnumber"),this.get("_model").get("_assetmanager").get("_resolvedassetnumber"))):w.Log("ViewerView Warning: Client callback not a function")},SetDefaultResourceRelativePath:function(a){this.set("_resourcePath",
a)},ReleaseRenderTarget:function(a){a&&a.dispose()},ReleaseDummyTextures:function(){this.ReleaseRenderTarget(this.get("_DummyTexture"));this.ReleaseRenderTarget(this.get("_DummyTextureCube"))},ReleaseAllRenderTargets:function(){this.ReleaseRenderTarget(this.get("_OpaqueDepthRT"));this.ReleaseRenderTarget(this.get("_D1RT"));this.ReleaseRenderTarget(this.get("_D2RT"));this.ReleaseRenderTarget(this.get("_ColorStackRT"));this.ReleaseRenderTarget(this.get("_PeelColorRT"));this.ReleaseRenderTarget(this.get("_TransparencyStackRT"));
this.ReleaseRenderTarget(this.get("_OpaqueBackgroundMaskRT"));this.ReleaseRenderTarget(this.get("_MirrorOpaqueDepthRT"));this.ReleaseRenderTarget(this.get("_MirrorColorStackRT"));this.ReleaseRenderTarget(this.get("_MirrorColorStackRT2"));this.ReleaseRenderTarget(this.get("_MirrorPeelColorRT"));this.ReleaseRenderTarget(this.get("_MirrorTransparencyStackRT"));this.ReleaseRenderTarget(this.get("_FadedMirrorTransparencyStackRT"));this.ReleaseRenderTarget(this.get("_MirrorOpaqueBackgroundMaskRT"))},InitializeRenderTargets:function(a,
b){var c=a?a:this.get("_context").clientWidth,i=b?b:this.get("_context").clientHeight,f,g;this.ReleaseAllRenderTargets();A.get("_fullSupportFloatingPointTextures")?(f={minFilter:d.LinearFilter,format:d.RGBAFormat,type:d.FloatType},g={minFilter:d.LinearFilter,format:d.RGBAFormat},this.set("_OpaqueDepthRT",new d.WebGLRenderTarget(c,i,f)),this.set("_D1RT",new d.WebGLRenderTarget(c,i,f)),this.set("_D2RT",new d.WebGLRenderTarget(c,i,f)),this.set("_ColorStackRT",new d.WebGLRenderTarget(c,i,g)),this.set("_PeelColorRT",
new d.WebGLRenderTarget(c,i,g)),this.set("_TransparencyStackRT",new d.WebGLRenderTarget(c,i,g)),this.set("_OpaqueBackgroundMaskRT",new d.WebGLRenderTarget(c,i,g)),this.set("_MirrorOpaqueDepthRT",new d.WebGLRenderTarget(c,i,f)),this.set("_MirrorColorStackRT",new d.WebGLRenderTarget(c,i,g)),this.set("_MirrorColorStackRT2",new d.WebGLRenderTarget(c,i,g)),this.set("_MirrorPeelColorRT",new d.WebGLRenderTarget(c,i,g)),this.set("_MirrorTransparencyStackRT",new d.WebGLRenderTarget(c,i,g)),this.set("_FadedMirrorTransparencyStackRT",
new d.WebGLRenderTarget(c,i,g)),this.set("_MirrorOpaqueBackgroundMaskRT",new d.WebGLRenderTarget(c,i,g))):A.get("_fullSupportHFloatingPointTextures")?(f={minFilter:d.LinearFilter,magFilter:d.NearestFilter,format:d.RGBAFormat,type:d.HalfFloatType},g={minFilter:d.LinearFilter,magFilter:d.NearestFilter,format:d.RGBAFormat},this.set("_OpaqueDepthRT",new d.WebGLRenderTarget(c,i,f)),this.set("_D1RT",new d.WebGLRenderTarget(c,i,f)),this.set("_D2RT",new d.WebGLRenderTarget(c,i,f)),this.set("_ColorStackRT",
new d.WebGLRenderTarget(c,i,g)),this.set("_PeelColorRT",new d.WebGLRenderTarget(c,i,g)),this.set("_TransparencyStackRT",new d.WebGLRenderTarget(c,i,g)),this.set("_OpaqueBackgroundMaskRT",new d.WebGLRenderTarget(c,i,g)),this.set("_MirrorOpaqueDepthRT",new d.WebGLRenderTarget(c,i,f)),this.set("_MirrorColorStackRT",new d.WebGLRenderTarget(c,i,g)),this.set("_MirrorColorStackRT2",new d.WebGLRenderTarget(c,i,g)),this.set("_MirrorPeelColorRT",new d.WebGLRenderTarget(c,i,g)),this.set("_MirrorTransparencyStackRT",
new d.WebGLRenderTarget(c,i,g)),this.set("_FadedMirrorTransparencyStackRT",new d.WebGLRenderTarget(c,i,g)),this.set("_MirrorOpaqueBackgroundMaskRT",new d.WebGLRenderTarget(c,i,g))):(g={minFilter:d.LinearFilter,magFilter:d.NearestFilter,format:d.RGBAFormat},this.set("_ColorStackRT",new d.WebGLRenderTarget(c,i,g)),this.set("_PeelColorRT",new d.WebGLRenderTarget(c,i,g)))},ResetOutlineShaders:function(){if(!this.get("_renderercache").materials.colordepth){var a=d.UniformsUtils.clone(M.uniforms),a=new d.ShaderMaterial({uniforms:a,
vertexShader:M.vertexShader,fragmentShader:M.fragmentShader,name:"ColorDepth",side:d.DoubleSide});this.get("_renderercache").materials.colordepth=a}if(!this.get("_renderercache").materials.edge){var a=this.get("_renderercache").materials.defaultcolor,b=d.UniformsUtils.clone(N.uniforms);b.color.value=new d.Vector3(a[0]/255,a[1]/255,a[2]/255);b.depth_texture.value=this.get("_DummyTexture");a=new d.ShaderMaterial({uniforms:b,vertexShader:N.vertexShader,fragmentShader:N.fragmentShader,name:"Edge",wireframe:!0});
this.get("_renderercache").materials.edge=a}},ResetShaders:function(){if(!this.get("_renderercache").materials.D0ShaderMaterial){var a=d.UniformsUtils.clone(E.uniforms),a=new d.ShaderMaterial({uniforms:a,vertexShader:E.vertexShader,fragmentShader:E.fragmentShader,side:d.DoubleSide,depthWrite:!0,transparent:!1,name:"D0ShaderMaterial"});this.get("_renderercache").materials.D0ShaderMaterial=a}this.get("_renderercache").materials.D1ShaderMaterial||(a=d.UniformsUtils.clone(O.uniforms),a.D0RT.value=this.get("_DummyTexture"),
a=new d.ShaderMaterial({uniforms:a,vertexShader:O.vertexShader,fragmentShader:O.fragmentShader,side:d.DoubleSide,depthWrite:!0,transparent:!1,name:"D1ShaderMaterial"}),this.get("_renderercache").materials.D1ShaderMaterial=a);this.get("_renderercache").materials.D2ShaderMaterial||(a=d.UniformsUtils.clone(P.uniforms),a.DX1RT.value=this.get("_DummyTexture"),a.DX2RT.value=this.get("_DummyTexture"),a=new d.ShaderMaterial({uniforms:a,vertexShader:P.vertexShader,fragmentShader:P.fragmentShader,side:d.DoubleSide,
depthWrite:!0,transparent:!1,name:"D2ShaderMaterial"}),this.get("_renderercache").materials.D2ShaderMaterial=a);this.get("_renderercache").materials.DepthOnlyShaderMaterial||(a=d.UniformsUtils.clone(Q.uniforms),a.DX1RT.value=this.get("_DummyTexture"),a.DX2RT.value=this.get("_DummyTexture"),a=new d.ShaderMaterial({uniforms:a,vertexShader:Q.vertexShader,fragmentShader:Q.fragmentShader,side:d.DoubleSide,depthWrite:!0,colorWrite:!1,transparent:!1,name:"DepthOnlyShaderMaterial"}),this.get("_renderercache").materials.DepthOnlyShaderMaterial=
a);this.get("_renderercache").materials.BackdropShaderMaterial||(a=d.UniformsUtils.clone(R.uniforms),a.backdrop.value=this.get("_DummyTexture"),a.reflection.value=this.get("_DummyTexture"),a=new d.ShaderMaterial({uniforms:a,vertexShader:R.vertexShader,fragmentShader:R.fragmentShader,side:d.FrontSide,depthWrite:!1,transparent:!1,name:"BackdropShaderMaterial"}),this.get("_renderercache").materials.BackdropShaderMaterial=a);this.get("_renderercache").materials.ColorBlendShaderMaterial||(a=d.UniformsUtils.clone(S.uniforms),
a.CX1RT.value=this.get("_DummyTexture"),a.TransparencyStack.value=this.get("_DummyTexture"),a.OpaqueRT.value=this.get("_DummyTexture"),a.ColorStackRT.value=this.get("_DummyTexture"),a=new d.ShaderMaterial({uniforms:a,vertexShader:S.vertexShader,fragmentShader:S.fragmentShader,side:d.FrontSide,depthWrite:!0,transparent:!0,blending:d.AdditiveBlending,name:"ColorBlendShaderMaterial"}),this.get("_renderercache").materials.ColorBlendShaderMaterial=a);this.get("_renderercache").materials.CopyShaderMaterial||
(a=d.UniformsUtils.clone(U.uniforms),a.CXRT.value=this.get("_DummyTexture"),a.OpaqueRT.value=this.get("_DummyTexture"),a=new d.ShaderMaterial({uniforms:a,vertexShader:U.vertexShader,fragmentShader:U.fragmentShader,side:d.FrontSide,depthWrite:!0,transparent:!1,blending:d.AdditiveBlending,name:"CopyShaderMaterial"}),this.get("_renderercache").materials.CopyShaderMaterial=a);this.ResetOutlineShaders()},ApplyFctToMaterialStruct:function(a,b){for(var c=0,i=Object.keys(a.mat.untextured_mat),d=i.length;c<
d;++c)for(var g=a.mat.untextured_mat[i[c]],e=0,h=Object.keys(g),j=h.length;e<j;++e){var l=g[h[e]];b(l);l.needsUpdate=!0}c=0;i=Object.keys(a.mat.textured_mat);for(d=i.length;c<d;++c){g=a.mat.textured_mat[i[c]];e=0;h=Object.keys(g);for(j=h.length;e<j;++e)for(var n=g[h[e]],k=0,r=Object.keys(n),m=r.length;k<m;++k)l=n[r[k]],b(l),l.needsUpdate=!0}},ApplyFctToAllMaterials:function(a){a(this.get("_renderercache").materials.default_material);this.get("_renderercache").materials.default_material.needsUpdate=
!0;for(var b=0,c=Object.keys(this.get("_renderercache").materials.materiallist),d=c.length;b<d;++b){var f=this.get("_renderercache").materials.materiallist[c[b]];this.ApplyFctToMaterialStruct(f.front,a);this.ApplyFctToMaterialStruct(f.back,a)}},ReleaseMaterial:function(a,b){if(a&&(a.dispose(),a.uniforms))for(var c=0,i=Object.keys(a.uniforms),f=i.length;c<f;++c){var g=a.uniforms[i[c]];g.value&&"function"===typeof g.value.dispose&&(void 0===b||b||!(g.value instanceof d.Texture))&&g.value.dispose()}},
ReleaseMaterialsAndTextures:function(a){if(a){var b=a.boundmeshlist;if(b){0==Object.keys(b).length&&w.Log("ViewerView Warning: No meshes to update");for(var c=0,d=Object.keys(b),f=d.length;c<f;++c){var g=d[c];0==Object.keys(b[g]).length&&w.Log("ViewerView Warning: No render passes to update");for(var e=0,h=Object.keys(b[g]),j=h.length;e<j;++e){for(var l=h[e],n=0,k=Object.keys(b[g][l]),r=k.length;n<r;n++){var m=k[n];this.ReleaseMaterial(a.mat.untextured_mat[g][m]);0==Object.keys(b[g][l][m]).length&&
w.Log("ViewerView Warning: No sided materials to update");for(var p=0,s=Object.keys(b[g][l][m]),q=s.length;p<q;++p){var u=s[p];this.ReleaseMaterial(a.mat.textured_mat[g][m][u]);delete a.mat.textured_mat[g][m][u];delete b[g][l][m][u]}delete b[g][l][m]}delete b[g][l];delete b[g]}}delete a.boundmeshlist}else w.Log("ViewerView Warning: No meshes to update");a.diff_texture&&a.diff_texture.dispose();a.spec_texture&&a.spec_texture.dispose();a.int_spec_texture&&a.int_spec_texture.dispose();a.normal_chan0_texture&&
a.normal_chan0_texture.dispose();a.normal_chan1_texture&&a.normal_chan1_texture.dispose();a.diff_grating_texture&&a.diff_grating_texture.dispose();a.diff_grating_filter_texture&&a.diff_grating_filter_texture.dispose()}},ReleaseAllMaterialsAndTextures:function(){if(this.get("_renderercache")){this.ReleaseMaterial(this.get("_renderercache").materials.default_material);this.ReleaseMaterial(this.get("_renderercache").materials.highlight);this.ReleaseMaterial(this.get("_renderercache").materials.edge);
this.ReleaseMaterial(this.get("_renderercache").materials.colordepth);this.ReleaseMaterial(this.get("_renderercache").materials.D0ShaderMaterial);this.ReleaseMaterial(this.get("_renderercache").materials.D1ShaderMaterial);this.ReleaseMaterial(this.get("_renderercache").materials.D2ShaderMaterial);this.ReleaseMaterial(this.get("_renderercache").materials.BackdropShaderMaterial);this.ReleaseMaterial(this.get("_renderercache").materials.ColorBlendShaderMaterial);this.ReleaseMaterial(this.get("_renderercache").materials.CopyShaderMaterial);
for(var a=0,b=Object.keys(this.get("_renderercache").materials.materiallist),c=b.length;a<c;++a){var d=this.get("_renderercache").materials.materiallist[b[a]];this.ReleaseMaterialsAndTextures(d.front);this.ReleaseMaterialsAndTextures(d.back)}this.get("_renderercache").textures.Designer.irradiancemap.data&&this.get("_renderercache").textures.Designer.irradiancemap.data.dispose();this.get("_renderercache").textures.Designer.envmap.glossy.data&&this.get("_renderercache").textures.Designer.envmap.glossy.data.dispose();
this.get("_renderercache").textures.Designer.envmap.matte.data&&this.get("_renderercache").textures.Designer.envmap.matte.data.dispose();this.get("_renderercache").textures.Visualizer.irradiancemap.data&&this.get("_renderercache").textures.Visualizer.irradiancemap.data.dispose();if(this.get("_renderercache").textures.Visualizer.envmap.data)for(a=0;a<this.get("_renderercache").textures.Visualizer.envmap.data.length;a++)this.get("_renderercache").textures.Visualizer.envmap.data[a]&&this.get("_renderercache").textures.Visualizer.envmap.data[a].dispose();
this.get("_renderercache").textures.Visualizer.spectrum.data&&this.get("_renderercache").textures.Visualizer.spectrum.data.dispose()}},ReleaseGeomMatTex:function(a){if(a){var b=this;a.traverse(function(a){a instanceof d.Mesh&&a.geometry&&(a.geometry.dispose(),b.ReleaseMaterial(a.material))})}},ReleaseSGGeometriesAndMaterials:function(){this.ApplyFctToAllScenes(this.ReleaseGeomMatTex.bind(this))},ReleaseThreejsnodesReferences:function(){if(this.get("_renderercache")&&this.get("_renderercache").hasOwnProperty("nodeviewproperties"))for(var a=
this.get("_renderercache").nodeviewproperties,b=0,c=Object.keys(a),d=c.length;b<d;b++){for(var f=a[c[b]].threejsnodes,g=0,e=Object.keys(f),h=e.length;g<h;g++){for(var j=0,l=f[e[g]],n=l.length;j<n;j++)delete f[e[g]][l[j]];delete f[e[g]]}delete a[c[b]].threejsnodes;delete a[c[b]]}},ClearInstanceArrays:function(){this.TraverseAllScenes(function(a){a instanceof d.Mesh&&a.geometry instanceof d.InstancedBufferGeometry&&(a.geometry.attributes.inst_translation.jarray&&(a.geometry.attributes.inst_translation.jarray=
null),a.geometry.attributes.inst_rotation.jarray&&(a.geometry.attributes.inst_rotation.jarray=null),a.geometry.attributes.inst_scale.jarray&&(a.geometry.attributes.inst_scale.jarray=null))})},ApplyFctToAllScenes:function(a){a(this.get("_3JSsceneOp"));a(this.get("_3JSsceneOpDepth"));a(this.get("_3JSsceneOpaqueDiffuse"));if(this.get("_3JSsceneOpCoincidentGroupsPasses"))for(var b=0;b<this.get("_3JSsceneOpCoincidentGroupsPasses").length;++b){var c=this.get("_3JSsceneOpCoincidentGroupsPasses")[b];a(this.get("_3JSsceneOpCoincidentGroups")[c]);
a(this.get("_3JSsceneOpCoincidentGroupsDepth")[c]);a(this.get("_3JSsceneOpCoincidentGroupsDiffuse")[c])}a(this.get("_3JSsceneTransp"));a(this.get("_3JSsceneTranspDepth"));a(this.get("_3JSsceneTranspDiffuse"));if(this.get("_3JSsceneTranspCoincidentGroupsPasses"))for(b=0;b<this.get("_3JSsceneTranspCoincidentGroupsPasses").length;++b)c=this.get("_3JSsceneTranspCoincidentGroupsPasses")[b],a(this.get("_3JSsceneTranspCoincidentGroups")[c]),a(this.get("_3JSsceneTranspCoincidentGroupsDepth")[c]),a(this.get("_3JSsceneTranspCoincidentGroupsDiffuse")[c]);
a(this.get("_3JSsceneHightlights"));a(this.get("_3JSsceneLabels"))},TraverseAllScenes:function(a){this.get("_3JSsceneOp").traverse(a);this.get("_3JSsceneOpDepth").traverse(a);this.get("_3JSsceneOpaqueDiffuse").traverse(a);if(this.get("_3JSsceneOpCoincidentGroupsPasses"))for(var b=0;b<this.get("_3JSsceneOpCoincidentGroupsPasses").length;++b){var c=this.get("_3JSsceneOpCoincidentGroupsPasses")[b];this.get("_3JSsceneOpCoincidentGroups")[c].traverse(a);this.get("_3JSsceneOpCoincidentGroupsDepth")[c].traverse(a);
this.get("_3JSsceneOpCoincidentGroupsDiffuse")[c].traverse(a)}this.get("_3JSsceneTransp").traverse(a);this.get("_3JSsceneTranspDepth").traverse(a);this.get("_3JSsceneTranspDiffuse").traverse(a);if(this.get("_3JSsceneTranspCoincidentGroupsPasses"))for(b=0;b<this.get("_3JSsceneTranspCoincidentGroupsPasses").length;++b)c=this.get("_3JSsceneTranspCoincidentGroupsPasses")[b],this.get("_3JSsceneTranspCoincidentGroups")[c].traverse(a),this.get("_3JSsceneTranspCoincidentGroupsDepth")[c].traverse(a),this.get("_3JSsceneTranspCoincidentGroupsDiffuse")[c].traverse(a);
this.get("_3JSsceneHightlights").traverse(a);this.get("_3JSsceneLabels").traverse(a)},ReleaseScene:function(){this.ReleaseAllMaterialsAndTextures();this.ReleaseSGGeometriesAndMaterials();this.ReleaseThreejsnodesReferences();d.Cache.clear();this.set("_3JSsceneOp",null);this.set("_3JSsceneOpDepth",null);this.set("_3JSsceneOpaqueDiffuse",null);this.set("_3JSsceneTransp",null);this.set("_3JSsceneTranspDepth",null);this.set("_3JSsceneTranspDiffuse",null);this.set("_3JSsceneHightlights",null);this.set("_3JSsceneLabels",
null);this.set("_3JSsceneBBox",null);this.set("_3JSsceneBBoxFocus",null);this.set("_nodecounter",0);this.set("_geometrycounter",0);this.set("_labelCreationCallbackList",[]);this.set("_renderercache",null);this.set("_emptyTransparentScene",!0);this.set("_emptyOpaqueScene",!0);this.set("_3JSsceneOpCoincidentGroupsIds",{});this.set("_3JSsceneOpCoincidentGroupsPasses",[]);this.set("_3JSsceneNbOpCoincidentGroups",0);this.set("_3JSsceneTranspCoincidentGroupsIds",{});this.set("_3JSsceneTranspCoincidentGroupsPasses",
[]);this.set("_3JSsceneNbTranspCoincidentGroups",0)},ResetScene:function(a,b){this.ReleaseScene();this.set("_3JSsceneOp",new d.Scene);this.set("_3JSsceneOpCoincidentGroups",{});this.set("_3JSsceneOpDepth",new d.Scene);this.set("_3JSsceneOpCoincidentGroupsDepth",[]);this.set("_3JSsceneOpaqueDiffuse",new d.Scene);this.set("_3JSsceneOpCoincidentGroupsDiffuse",[]);this.set("_3JSsceneTransp",new d.Scene);this.set("_3JSsceneTranspCoincidentGroups",{});this.set("_3JSsceneTranspDepth",new d.Scene);this.set("_3JSsceneTranspCoincidentGroupsDepth",
[]);this.set("_3JSsceneTranspDiffuse",new d.Scene);this.set("_3JSsceneTranspCoincidentGroupsDiffuse",[]);this.set("_3JSsceneHightlights",new d.Scene);this.set("_3JSsceneLabels",new d.Scene);this.set("_3JSsceneBBox",new d.Box3);this.set("_3JSsceneBBoxFocus",new d.Box3);this.set("_renderercache",{nodeviewproperties:{},coplanarityepsilon:void 0!==a?a:0.2,boundaryhardedges:void 0!==b?b:!0,geometries:[],materials:{enablehighlights:!1,enablehorizonhighlights:!0,enablehardedgehighlights:!0,enableirradiancemap:!0,
enableenvmap:!0,defaultcolor:[30,30,30],default_material:{},materiallist:{},shaders:{}},labels:{visible:!0,list:{}},textures:{Designer:{path:"lighting_environments/designer_quality/",irradiancemap:{files:"irr_map_right.PNG irr_map_left.PNG irr_map_top.PNG irr_map_bottom.PNG irr_map_front.PNG irr_map_back.PNG".split(" "),data:null,loaded:!1},envmap:{glossy:{files:"env_map_glossy_right.PNG env_map_glossy_left.PNG env_map_glossy_top.PNG env_map_glossy_bottom.PNG env_map_glossy_front.PNG env_map_glossy_back.PNG".split(" "),
data:null,loaded:!1},matte:{files:"env_map_mate_right.PNG env_map_mate_left.PNG env_map_mate_top.PNG env_map_mate_bottom.PNG env_map_mate_front.PNG env_map_mate_back.PNG".split(" "),data:null,loaded:!1}},backdrop:{loaded:!1,data:null,original_width:null,original_height:null}},Visualizer:{path:"lighting_environments/visualizer_quality/",irradiancemap:{files:"cubic_irradiance_xpos.jpg cubic_irradiance_xneg.jpg cubic_irradiance_ypos.jpg cubic_irradiance_yneg.jpg cubic_irradiance_zpos.jpg cubic_irradiance_zneg.jpg".split(" "),
data:null,loaded:!1},envmap:{files:"cubic_blur_00_xpos.jpg cubic_blur_00_xneg.jpg cubic_blur_00_ypos.jpg cubic_blur_00_yneg.jpg cubic_blur_00_zpos.jpg cubic_blur_00_zneg.jpg cubic_blur_02_xpos.jpg cubic_blur_02_xneg.jpg cubic_blur_02_ypos.jpg cubic_blur_02_yneg.jpg cubic_blur_02_zpos.jpg cubic_blur_02_zneg.jpg cubic_blur_04_xpos.jpg cubic_blur_04_xneg.jpg cubic_blur_04_ypos.jpg cubic_blur_04_yneg.jpg cubic_blur_04_zpos.jpg cubic_blur_04_zneg.jpg cubic_blur_06_xpos.jpg cubic_blur_06_xneg.jpg cubic_blur_06_ypos.jpg cubic_blur_06_yneg.jpg cubic_blur_06_zpos.jpg cubic_blur_06_zneg.jpg cubic_blur_08_xpos.jpg cubic_blur_08_xneg.jpg cubic_blur_08_ypos.jpg cubic_blur_08_yneg.jpg cubic_blur_08_zpos.jpg cubic_blur_08_zneg.jpg".split(" "),
data:null,loaded:!1},spectrum:{file:"spectrum_00.png",data:null,loaded:!1,queried:!1},backdrop:{loaded:!1,data:null,original_width:null,original_height:null}},FromFile:{}},cameras:{defaultcamera:{cam_type:"PERSPECTIVE",azimuthAngle:0,elevationAngle:0,fieldOfView:30,scale:1,panOffset:{x:0,y:0}}},view_settings:{mode:1,model_xform:new d.Matrix4},camera_preset:{eye_position:null},environment_settings:{rotation:new d.Quaternion},lights:{},reflections:{enabled:!1,opacity:0.25,fade:!1,fade_size:1.2,fade_position:0.95},
hudelements:[],diagrams:[],viewports:[],animationkeyframes:[]});var c=d.UniformsUtils.clone(F.uniforms);c.diffuse.value=new d.Vector3(1,1,1);c.specular.value=new d.Vector3(0,0,0);this.get("_renderercache");var i=this.get("_renderercache").materials.enablehighlights&&__enableHardEdgeHighlights;this.get("_renderercache").materials.default_material=new d.ShaderMaterial({name:"designer",uniforms:c,vertexShader:F.vertexShader,fragmentShader:F.fragmentShader,depthTest:!0,vertexColors:d.FaceColors,side:d.FrontSide,
transparent:!1,defines:{},lights:!0,polygonOffset:!0,polygonOffsetFactor:i?this.get("_polygon_offset_factor"):0,polygonOffsetUnits:i?this.get("_polygon_offset_units"):0});c=this.get("_renderercache").materials.defaultcolor;c=new d.LineBasicMaterial({color:(c[0]<<16)+(c[1]<<8)+c[2],linewidth:1,depthTest:!0});this.get("_renderercache").materials.highlight=c;c=new d.LineBasicMaterial({color:0,linewidth:1,depthTest:!0});this.get("_renderercache").materials.blackhighlight=c;this.AddDirectionalAndAmbientLightsToScene(this.get("_3JSsceneOp"),
"cg_0",!1);this.AddDirectionalAndAmbientLightsToScene(this.get("_3JSsceneTransp"),"cg_0",!0);this.set("_InitialisedSceneSettings",!1);this.set("_QueriedGlobalTextures",!1);this.set("_TextureSizeWarningMessageDisplayed",!1);this.set("_TextureSizeByPass",!1);this.set("_SceneLoaded",!1);this.set("_parsedEntireSceneGraphOnce",!1)},AddDirectionalAndAmbientLightsToScene:function(a,b,c){this.get("_renderercache").lights.dir_light||(this.get("_renderercache").lights.dir_light={});var i=new d.DirectionalLight(11184810,
0.5);this.get("_renderercache").lights.dir_light[(c?"tr_":"")+b]=i;a.add(i);this.get("_renderercache").lights.amb_light||(this.get("_renderercache").lights.amb_light={});i=new d.AmbientLight(8947848);this.get("_renderercache").lights.amb_light[(c?"tr_":"")+b]=i;a.add(i)},InitOpaqueCoincidentGroupScene:function(a){this.get("_3JSsceneOpCoincidentGroups").hasOwnProperty(a)||(this.get("_3JSsceneOpCoincidentGroups")[a]=new d.Scene,this.AddDirectionalAndAmbientLightsToScene(this.get("_3JSsceneOpCoincidentGroups")[a],
a,!1),this.get("_3JSsceneOpCoincidentGroupsDepth")[a]=new d.Scene,this.get("_3JSsceneOpCoincidentGroupsDiffuse")[a]=new d.Scene)},InitTransparentCoincidentGroupScene:function(a){this.get("_3JSsceneTranspCoincidentGroups").hasOwnProperty(a)||(this.get("_3JSsceneTranspCoincidentGroups")[a]=new d.Scene,this.AddDirectionalAndAmbientLightsToScene(this.get("_3JSsceneTranspCoincidentGroups")[a],a,!0),this.get("_3JSsceneTranspCoincidentGroupsDepth")[a]=new d.Scene,this.get("_3JSsceneTranspCoincidentGroupsDiffuse")[a]=
new d.Scene)},CreateLabels:function(){for(var a=0;a<this.get("_labelCreationCallbackList").length;++a)this.get("_labelCreationCallbackList")[a]();this.CreateSprites()},PostSceneLoadActions:function(){this.set("_SceneLoaded",!0);this.get("_3DObjectHandler").ClearBuildMaps();this.ClearInstanceArrays();this.CreateLabels();this.CameraUpdate(!0)},CheckPostSceneLoadActions:function(){var a=this.get("_model").get("_assetmanager").get("_assetloader").get("_httprequestmanager").get("_queriedassetnumber"),
b=this.get("_model").get("_assetmanager").get("_resolvedassetnumber"),c=this.get("_model").get("_assetmanager").get("_textureLoadedCounter"),d=this.get("_model").get("_assetmanager").get("_textureCounter"),f=100*(d/c);a==b&&c==d&&this.PostSceneLoadActions();return f},AddedResource:function(){this.ResetShaders();this.SetUpScene();var a=this;this.get("_build_scene_exec_queue").whenFinished(function(){a.UpdateReflectionUniforms();0==a.get("_model").get("_assetmanager").get("_textureCounter")&&a.get("_model").get("_assetmanager").get("_assetloader").get("_httprequestmanager").get("_queriedassetnumber")==
a.get("_model").get("_assetmanager").get("_resolvedassetnumber")&&this.PostSceneLoadActions();a.Render();a.NotifySceneBuildProgress(100,0,0)})},GetFileList:function(a,b){for(var c=[],d=0,f=Object.keys(b),g=f.length;d<g;++d)c.push(a+b[f[d]]);return c},CheckTextureSizeByPass:function(a){var b=!0;if(a.image.naturalHeight>L.textureSupport.MAX_NATURAL_HEIGHT||a.image.naturalWidth>L.textureSupport.MAX_NATURAL_WIDTH)this.get("_TextureSizeWarningMessageDisplayed")?b=this.get("_TextureSizeByPass"):(b=window.confirm("WARNING ! Some textures have a size greater than "+
L.textureSupport.MAX_NATURAL_WIDTH+"x"+L.textureSupport.MAX_NATURAL_HEIGHT+". This might not be supported by your system and you might experience browser or graphics card crashes."),this.set("_TextureSizeWarningMessageDisplayed",!0),this.set("_TextureSizeByPass",b));return b},StartAsyncTextureLoad:function(a,b,c,i,f,g,e,h,j){if(c.front.hasOwnProperty(i)&&c.front[i]&&b.hasOwnProperty(c.front[i])){var b=b[c.front[i]],l=b.Properties.hasOwnProperty("remapped_alpha_channel")?y.get("toBool")(b.Properties.remapped_alpha_channel):
!1,e=this.get("_model").get("_assetmanager").get("_assetloader").get("_httprequestmanager").IsAbsoluteURL(b.Properties.filepath)?b.Properties.filepath:e+b.Properties.filepath,c=new d.TextureLoader;c.crossOrigin="";c=c.load(e,function(b){a.get("_build_scene_exec_queue").whenFinished(function(){var c=a.CheckTextureSizeByPass(b);a.get("_model").get("_assetmanager").set("_textureLoadedCounter",a.get("_model").get("_assetmanager").get("_textureLoadedCounter")+1);var d=a.CheckPostSceneLoadActions();if(c&&
g){var i,e;i=e=1;g.hasOwnProperty("originalTexWidth")&&(i=(g.originalTexWidth-1)/b.image.naturalWidth);g.hasOwnProperty("originalTexHeight")&&(e=(g.originalTexHeight-1)/b.image.naturalHeight);b.repeat.set(i,e);b.remappedAlphaChannel=l;g[f]=b;a.UpdateTexturedMaterial(g);a.Render()}a.NotifySceneBuildProgress(100,d,c?0:1)})},void 0,function(){w.Log("ViewerView Warning: Problem loading texture")});c.name=e;c.format=h;c.unpackAlignment=j;c.anisotropy=16;a.get("_model").get("_assetmanager").set("_textureCounter",
a.get("_model").get("_assetmanager").get("_textureCounter")+1);a.SelectTextureWrappingMode(c,b.Properties,g);this.get("_renderercache").textures.FromFile.hasOwnProperty(e)||(this.get("_renderercache").textures.FromFile[e]=null);return!0}return!1},StartAsyncGlobalTextureLoad:function(a,b,c){if(a.get("_renderercache").textures[a.get("_RenderingQuality")][b]){var i=function(b){a.get("_model").get("_assetmanager").set("_textureLoadedCounter",a.get("_model").get("_assetmanager").get("_textureLoadedCounter")+
1);var c=a.CheckPostSceneLoadActions();a.Render();b=a.CheckTextureSizeByPass(b);a.NotifySceneBuildProgress(100,c,b?0:1)},f=function(c){a.get("_build_scene_exec_queue").whenFinished(function(){a.get("_renderercache").textures[a.get("_RenderingQuality")][b].loaded=!0;a.UpdateMaterialsGlobalLighting();i(c)})},g=function(b){a.get("_build_scene_exec_queue").whenFinished(function(){a.get("_renderercache").textures[a.get("_RenderingQuality")].envmap.glossy.loaded=!0;a.UpdateMaterialsGlobalLighting();i(b)})},
e=function(b){a.get("_build_scene_exec_queue").whenFinished(function(){a.get("_renderercache").textures[a.get("_RenderingQuality")].envmap.matte.loaded=!0;a.UpdateMaterialsGlobalLighting();i(b)})},h=function(c){a.get("_build_scene_exec_queue").whenFinished(function(){a.get("_renderercache").textures[a.get("_RenderingQuality")][b].loaded=!0;i(c)})},j=function(){w.Log("ViewerView Warning: Problem loading texture")};switch(b){default:w.Log("ViewerView Warning: Unhandled global texture type: default to irradiancemap");
case "irradiancemap":var l=new d.CubeTextureLoader,e=a.GetFileList(c,a.get("_renderercache").textures[a.get("_RenderingQuality")][b].files),f=l.load(e,f,void 0,j);f.format=d.RGBFormat;a.get("_renderercache").textures[a.get("_RenderingQuality")][b].data=f;a.get("_model").get("_assetmanager").set("_textureCounter",a.get("_model").get("_assetmanager").get("_textureCounter")+1);break;case "envmap":l=new d.CubeTextureLoader;switch(a.get("_RenderingQuality")){case "Designer":f=a.GetFileList(c,a.get("_renderercache").textures[a.get("_RenderingQuality")][b].glossy.files);
f=l.load(f,g,void 0,j);f.format=d.RGBFormat;a.get("_renderercache").textures[a.get("_RenderingQuality")][b].glossy.data=f;f=a.GetFileList(c,a.get("_renderercache").textures[a.get("_RenderingQuality")][b].matte.files);e=l.load(f,e,void 0,j);e.format=d.RGBFormat;a.get("_renderercache").textures[a.get("_RenderingQuality")][b].matte.data=e;a.get("_model").get("_assetmanager").set("_textureCounter",a.get("_model").get("_assetmanager").get("_textureCounter")+2);break;case "Visualizer":a.get("_renderercache").textures[a.get("_RenderingQuality")][b].data=
{};a.get("_renderercache").textures[a.get("_RenderingQuality")][b].loaded={};e=function(a,e){var g=a.GetFileList(c,a.get("_renderercache").textures[a.get("_RenderingQuality")][b].files.slice(6*e,6*(e+1))),g=l.load(g,function(c){a.get("_build_scene_exec_queue").whenFinished(function(){a.get("_renderercache").textures[a.get("_RenderingQuality")][b].loaded[e]=!0;a.UpdateMaterialsGlobalLighting();i(c)})},void 0,j);g.format=d.RGBFormat;a.get("_renderercache").textures[a.get("_RenderingQuality")][b].data[e]=
g};for(f=0;5>f;++f)e(a,f);a.get("_model").get("_assetmanager").set("_textureCounter",a.get("_model").get("_assetmanager").get("_textureCounter")+5)}break;case "spectrum":l=new d.TextureLoader;e=c+a.get("_renderercache").textures[a.get("_RenderingQuality")][b].file;f=l.load(e,f,void 0,j);f.format=d.RGBFormat;f.name=e;a.get("_renderercache").textures[a.get("_RenderingQuality")][b].data=f;a.get("_model").get("_assetmanager").set("_textureCounter",a.get("_model").get("_assetmanager").get("_textureCounter")+
1);break;case "backdrop":l=new d.TextureLoader,l.crossOrigin="",f=l.load(c,h,void 0,j),f.format=d.RGBFormat,f.name=c,a.get("_renderercache").textures[a.get("_RenderingQuality")][b].data=f,a.get("_model").get("_assetmanager").set("_textureCounter",a.get("_model").get("_assetmanager").get("_textureCounter")+1)}}},InitializeSceneSettings:function(a){if(!this.get("_InitialisedSceneSettings")){this.set("_RenderingQuality","Designer");this.set("_EnvironmentName","Office");if(a.Properties){if(a.Properties.hasOwnProperty("rendering_quality")&&
(A.get("_fullSupportFloatingPointTextures")||A.get("_fullSupportHFloatingPointTextures")))this.set("_RenderingQuality",a.Properties.rendering_quality),a.Properties.hasOwnProperty("environment_name")&&(this.set("_EnvironmentName",a.Properties.environment_name),this.get("_renderercache").textures.Visualizer.path=this.get("_renderercache").textures.Visualizer.path+a.Properties.environment_name+"/");a.Properties.hasOwnProperty("reflection_settings")&&(this.get("_renderercache").reflections.enabled=a.Properties.reflection_settings.hasOwnProperty("reflective_table_enabled")?
y.get("toBool")(a.Properties.reflection_settings.reflective_table_enabled):!1,this.get("_renderercache").reflections.enabled&&(this.get("_renderercache").reflections.opacity=a.Properties.reflection_settings.hasOwnProperty("reflection_opacity")?parseFloat(a.Properties.reflection_settings.reflection_opacity):0.25,a.Properties.reflection_settings.hasOwnProperty("reflection_fade_size")&&a.Properties.reflection_settings.hasOwnProperty("reflection_fade_position")&&(this.get("_renderercache").reflections.fade=
!0,this.get("_renderercache").reflections.fade_size=parseFloat(a.Properties.reflection_settings.reflection_fade_size),this.get("_renderercache").reflections.fade_position=parseFloat(a.Properties.reflection_settings.reflection_fade_position))))}this.LoadBackdrop(a);this.set("_InitialisedSceneSettings",!0)}},UpdateSceneSettings:function(){if(this.get("_renderercache").camera_preset.eye_position){this.CameraUpdate(!1);var a=this.get("_3JSsceneBBox").center(),b=this.get("_3JScamera").position,c=this.get("_renderercache").camera_preset.eye_position.clone(),
a=a.clone().sub(b),d=a.clone().multiplyScalar(c.clone().sub(b).dot(a)),f=this.get("_3JScamera").up,g=a.clone().normalize().cross(f),g=g.clone().multiplyScalar(c.clone().sub(b).dot(g)),b=f.clone().multiplyScalar(c.clone().sub(b).dot(f));this.SetCameraPanOffset({x:g.length(),y:b.length()},!1);b=a.length();a=a.clone().sub(d).length();this.SetCameraScale(a/b)}},LoadGlobalLightingTextures:function(){if(!this.get("_QueriedGlobalTextures")){var a=this.get("_resourcePath")+"/"+this.get("_renderercache").textures[this.get("_RenderingQuality")].path;
this.get("_renderercache").materials.enableirradiancemap&&this.StartAsyncGlobalTextureLoad(this,"irradiancemap",a);this.get("_renderercache").materials.enableenvmap&&this.StartAsyncGlobalTextureLoad(this,"envmap",a);this.set("_QueriedGlobalTextures",!0)}},LoadBackdrop:function(a){if(a.Properties&&a.Properties.hasOwnProperty("backdrop"))if("COLOR"===a.Properties.backdrop.type)a=a.Properties.backdrop.color,this.SetBackgroundColor(a[0],a[1],a[2],1,!1);else if("IMAGE"===a.Properties.backdrop.type){var a=
a.Assets[a.Properties.backdrop.image_tex].Properties,b;this.get("_model").get("_assetmanager").get("_assetloader").get("_httprequestmanager").IsAbsoluteURL(a.filepath)?b=a.filepath:(b=this.get("_model").get("SceneId"),b=b.substring(0,b.lastIndexOf("/")+1)+a.filepath);this.StartAsyncGlobalTextureLoad(this,"backdrop",b);this.get("_renderercache").textures[this.get("_RenderingQuality")].backdrop.original_height=a.original_height;this.get("_renderercache").textures[this.get("_RenderingQuality")].backdrop.original_width=
a.original_width;this.get("_renderercache").textures[this.get("_RenderingQuality")].backdrop.enabled=!0}else w.Log("ViewerView Warning: Backdrop type not supported (default to grey)."),this.SetBackgroundColor(0.37,0.37,0.37,1,!1);else this.SetBackgroundColor(0.37,0.37,0.37,1,!1)},SetUpScene:function(){ba.start("Scene Hierarchy Creation");this.CreateTHREEJSObjectHierarchy();ba.stop("Scene Hierarchy Creation");var a=this;this.get("_build_scene_exec_queue").whenFinished(function(){var b=new d.Box3;b.setFromObject(a.get("_3JSsceneOp"));
for(var c=0;c<a.get("_3JSsceneOpCoincidentGroupsPasses").length;++c){var i=new d.Box3,f=a.get("_3JSsceneOpCoincidentGroupsPasses")[c];i.setFromObject(a.get("_3JSsceneOpCoincidentGroups")[f]);b.union(i)}c=new d.Box3;c.setFromObject(a.get("_3JSsceneTransp"));b.union(c);for(c=0;c<a.get("_3JSsceneTranspCoincidentGroupsPasses").length;++c)i=new d.Box3,f=a.get("_3JSsceneTranspCoincidentGroupsPasses")[c],i.setFromObject(a.get("_3JSsceneTranspCoincidentGroups")[f]),b.union(i);a.set("_3JSsceneBBox",b);a.set("_3JSsceneBBoxFocus",
b);a.SetupReflections();a.CameraUpdate(!1);a.set("_InitialDistanceToSceneCenter",a.get("_3JSsceneBBox").center().clone().sub(a.get("_3JScamera").position).length())})},CreateSprites:function(){for(var a=0,b=Object.keys(this.get("_renderercache").labels.list),c=b.length;a<c;++a){var i=this.get("_renderercache").labels.list[b[a]],f=this.get("_textSpriteMaker").MakeTextSprite(i.text,i.display_style,new d.Vector3(0,0,0),!1,!1,!1,!1,!1,!1,i.orientation);this.get("_3JSsceneLabels").add(f);i.threejs_sprite=
f}},SetupReflections:function(){var a=new d.Matrix4;a.set(1,0,0,0,0,-1,0,0,0,0,1,0,0,0,0,1);this.set("_reflection_Y_scale",a);this.set("_mirror_offset",0.01);var a=2*this.get("_3JSsceneBBox").min.y-this.get("_mirror_offset"),b=new d.Matrix4;b.makeTranslation(0,a,0);this.set("_reflection_Y_translation",b);b=new d.Matrix4;b.makeTranslation(0,-a,0);this.set("_reflection_Y_opp_translation",b)},AddUIElement:function(a){"function"===typeof this.get("_clientUIAddElementCallback")?this.get("_clientUIAddElementCallback").apply(null,
arguments):w.Log("ViewerView Warning: Client callback not a function")},CreateTHREEJSObjectHierarchy:function(){this.get("_3DObjectHandler")||this.set("_3DObjectHandler",new fa(this.get("_build_scene_exec_queue")));this.get("_3DObjectHandler").set("_geometrycounter",0);this.get("_build_scene_exec_queue").run(function(){},this);this.get("_build_scene_exec_queue").run(function(){var a=this.get("_model").get("_assetmanager").get("_cache"),b=this.get("_model").get("SceneId");this.InitializeSceneSettings(a.rootnodes[b])},
this);this.get("_build_scene_exec_queue").run(function(){this.LoadGlobalLightingTextures()},this);this.get("_build_scene_exec_queue").run(function(){w.Log("Building Surfaces...")},this);this.get("_build_scene_exec_queue").whenFinished(function(){w.Log("Finished Building Surfaces.")},this);this.get("_build_scene_exec_queue").run(function(){var a=this.get("_model").get("_assetmanager").get("_cache"),b=this.get("_model").get("SceneId");this.BuildOpaqueScenes(a.rootnodes[b],b)},this);this.get("_build_scene_exec_queue").run(function(){for(var a=
this.get("_model").get("_assetmanager").get("_cache"),b=this.get("_model").get("SceneId"),a=a.rootnodes[b],c=0;c<this.get("_3JSsceneOpCoincidentGroupsPasses").length;++c){var d=this.get("_3JSsceneOpCoincidentGroupsPasses")[c];this.BuildOpaqueScenes(a,b,d)}},this);this.get("_build_scene_exec_queue").run(function(){if(!this.get("_emptyTransparentScene")){var a=this.get("_model").get("_assetmanager").get("_cache"),b=this.get("_model").get("SceneId"),a=a.rootnodes[b];this.BuildTransparentScenes(a,b);
for(var c=0;c<this.get("_3JSsceneTranspCoincidentGroupsPasses").length;++c){var d=this.get("_3JSsceneTranspCoincidentGroupsPasses")[c];this.BuildTransparentScenes(a,b,d)}}},this);this.get("_build_scene_exec_queue").run(function(){this.UpdateLightingContrast()},this);this.get("_build_scene_exec_queue").run(function(){var a=this.get("_model").get("_assetmanager").get("_cache"),b=this.get("_model").get("SceneId"),a=this.GetTHREEJSObjectHierarchy(a.rootnodes[b],"highlightnode",b,b);a.newlycreated&&this.get("_3JSsceneHightlights").add(a.node);
this.set("_geometrycounter",this.get("_geometrycounter")+this.get("_3DObjectHandler").get("_geometrycounter"));w.Log(this.get("_nodecounter")+" nodes have been created for this scene");w.Log(this.get("_geometrycounter")+" geometries have been created for this scene")},this)},CopyRestOfLabelProperties:function(a,b){b.hasOwnProperty("text")&&b.text&&(a.text=b.text);b.hasOwnProperty("orientation")&&b.orientation&&(a.orientation=b.orientation);b.hasOwnProperty("preferred_loc_h")&&b.preferred_loc_h&&(a.preferred_loc_h=
b.preferred_loc_h);b.hasOwnProperty("preferred_loc_v")&&b.preferred_loc_v&&(a.preferred_loc_v=b.preferred_loc_v);b.hasOwnProperty("pixel_offset")&&b.pixel_offset&&(a.pixel_offset=b.pixel_offset)},SetLabelProperties:function(a,b){if(b.hasOwnProperty("display_style")&&b.display_style){var c=b.display_style;c.hasOwnProperty("fontface")&&c.fontface&&(a.display_style.fontface=c.fontface);c.hasOwnProperty("fontsize")&&c.fontsize&&(a.display_style.fontsize=c.fontsize);c.hasOwnProperty("borderThickness")&&
c.borderThickness&&(a.display_style.borderThickness=c.borderThickness);c.hasOwnProperty("borderColor")&&c.borderColor&&(a.display_style.borderColor=c.borderColor);c.hasOwnProperty("backgroundColor")&&c.backgroundColor&&(a.display_style.backgroundColor=c.backgroundColor);c.hasOwnProperty("color")&&c.color&&(a.display_style.color=c.color)}this.CopyRestOfLabelProperties(a,b);c=a.threejs_sprite.visible;this.get("_3JSsceneLabels").remove(a.threejs_sprite);var i=this.get("_textSpriteMaker").MakeTextSprite(a.text,
a.display_style,new d.Vector3(0,0,0),!1,!1,!1,!1,!1,!1,a.orientation);this.get("_3JSsceneLabels").add(i);a.threejs_sprite=i;a.threejs_sprite.visible=b.hasOwnProperty("visible")?y.get("toBool")(b.visible):c},UpdateLabelProperties:function(a,b){var c=this.URLToKeyString(a);if(!(c in this.get("_renderercache").labels.list))return!1;c=this.get("_renderercache").labels.list[c];if(void 0===c)throw"UpdateLabelProperties: Cannot find requested label";this.SetLabelProperties(c,b);this.CameraUpdate(!0);return!0},
UpdateAllLabelsProperties:function(a){for(var b=0,c=Object.keys(this.get("_renderercache").labels.list),d=c.length;b<d;++b){var f=this.get("_renderercache").labels.list[c[b]];if(void 0===f)throw"UpdateAllLabelsProperties: Cannot find intended label!";this.SetLabelProperties(f,a)}0<b&&this.CameraUpdate(!0);return 0<b},DeduceLabelEdgesFromBoundingBox:function(a,b,c){if("x_axis"==a||"xyz_axes"==a)b.edge_list[0]=[c.min.x,c.min.y,c.min.z,c.max.x,c.min.y,c.min.z],b.edge_list[1]=[c.min.x,c.min.y,c.max.z,
c.max.x,c.min.y,c.max.z],b.edge_list[2]=[c.min.x,c.max.y,c.max.z,c.max.x,c.max.y,c.max.z],b.edge_list[3]=[c.min.x,c.max.y,c.min.z,c.max.x,c.max.y,c.min.z];if("y_axis"==a||"xyz_axes"==a){var d=0;"xyz_axes"==a&&(d=4);b.edge_list[d]=[c.max.x,c.min.y,c.max.z,c.max.x,c.min.y,c.min.z];b.edge_list[d+1]=[c.max.x,c.max.y,c.max.z,c.max.x,c.max.y,c.min.z];b.edge_list[d+2]=[c.min.x,c.max.y,c.max.z,c.min.x,c.max.y,c.min.z];b.edge_list[d+3]=[c.min.x,c.min.y,c.max.z,c.min.x,c.min.y,c.min.z]}if("z_axis"==a||"xyz_axes"==
a)d=0,"xyz_axes"==a&&(d=8),b.edge_list[d]=[c.min.x,c.min.y,c.max.z,c.min.x,c.max.y,c.max.z],b.edge_list[d+1]=[c.max.x,c.min.y,c.max.z,c.max.x,c.max.y,c.max.z],b.edge_list[d+2]=[c.max.x,c.min.y,c.min.z,c.max.x,c.max.y,c.min.z],b.edge_list[d+3]=[c.min.x,c.min.y,c.min.z,c.min.x,c.max.y,c.min.z]},LoadLabel:function(a,b,c,i,f,g,e){if(!("Label"!=c.AssetType||!c.hasOwnProperty("Properties")||null==c.Properties)){var h=c.Properties,c={text:h.text,orientation:h.orientation,preferred_loc_h:h.preferred_loc_h,
preferred_loc_v:h.preferred_loc_v,edge_list:[],point_list:[],ellipse:{center:null,radius1_vec:null,radius2_vec:null},bounds_type:null,threejs_sprite:null,display_style:null,pixel_offset:null};h.hasOwnProperty("display_style")&&h.display_style?c.display_style=a.Properties.label_display_styles[h.display_style]:a.Properties.hasOwnProperty("label_display_styles")&&a.Properties.label_display_styles&&(c.display_style=a.Properties.label_display_styles.default_style);c.pixel_offset=h.hasOwnProperty("pixel_offset")&&
h.pixel_offset?h.pixel_offset:[0,0];if(h.hasOwnProperty("edge_list")&&h.edge_list){c.bounds_type="edge_list";for(var e=0,j=Object.keys(h.edge_list),l=j.length;e<l;++e)c.edge_list[e]=JSON.parse(JSON.stringify(h.edge_list[j[e]])),g.applyToVector3Array(c.edge_list[e])}else if(h.hasOwnProperty("point_list")&&h.point_list){c.bounds_type="point_list";e=0;j=Object.keys(h.point_list);for(l=j.length;e<l;++e)c.point_list[e]=JSON.parse(JSON.stringify(h.point_list[j[e]])),g.applyToVector3Array(c.point_list[e])}else if(h.hasOwnProperty("ellipse")&&
h.ellipse)c.bounds_type="ellipse",c.ellipse.center=JSON.parse(JSON.stringify(h.ellipse.center)),c.ellipse.radius1_vec=JSON.parse(JSON.stringify(h.ellipse.radius1_vec)),c.ellipse.radius2_vec=JSON.parse(JSON.stringify(h.ellipse.radius2_vec)),g.applyToVector3Array(c.ellipse.center),h=new d.Matrix3,h.setFromMatrix4(g),h.applyToVector3Array(c.ellipse.radius1_vec),h.applyToVector3Array(c.ellipse.radius2_vec);else if(h.hasOwnProperty("bounding_box")&&h.bounding_box)c.bounds_type="edge_list",g=new d.Box3,
g.setFromObject(e.node),this.DeduceLabelEdgesFromBoundingBox(h.bounding_box,c,g);else{w.Log("Invalid bounds specification in Label asset: "+i);return}if(f instanceof Object&&0!=Object.keys(f).length&&f.hasOwnProperty(i)){f=f[i];if(!f)return;f.hasOwnProperty("display_style")&&f.display_style&&(c.display_style=a.Properties.label_display_styles[f.display_style]);this.CopyRestOfLabelProperties(c,f)}a=this.URLToKeyString(b);this.get("_renderercache").labels.list[a]=c;this.AddUIElement(a,!0);w.Log("Built Label asset: "+
i)}},BuildOpaqueScenes:function(a,b,c){var d=this.GetTHREEJSObjectHierarchy(a,"opaque_pass",b,b,c),f=this.GetTHREEJSObjectHierarchy(a,"depth_pass",b,b,c),a=this.GetTHREEJSObjectHierarchy(a,"opaque_diffuse_pass",b,b,c);void 0===c?(d.newlycreated&&(d.node.applyMatrix(this.get("_renderercache").view_settings.model_xform),this.get("_3JSsceneOp").add(d.node)),f.newlycreated&&(f.node.applyMatrix(this.get("_renderercache").view_settings.model_xform),this.get("_3JSsceneOpDepth").add(f.node)),a.newlycreated&&
(a.node.applyMatrix(this.get("_renderercache").view_settings.model_xform),this.get("_3JSsceneOpaqueDiffuse").add(a.node))):(this.InitOpaqueCoincidentGroupScene(c),d.newlycreated&&(d.node.applyMatrix(this.get("_renderercache").view_settings.model_xform),this.get("_3JSsceneOpCoincidentGroups")[c].add(d.node)),f.newlycreated&&(f.node.applyMatrix(this.get("_renderercache").view_settings.model_xform),this.get("_3JSsceneOpCoincidentGroupsDepth")[c].add(f.node)),a.newlycreated&&(a.node.applyMatrix(this.get("_renderercache").view_settings.model_xform),
this.get("_3JSsceneOpCoincidentGroupsDiffuse")[c].add(a.node)))},BuildTransparentScenes:function(a,b,c){var d=this.GetTHREEJSObjectHierarchy(a,"transparent_pass",b,b,c),f=this.GetTHREEJSObjectHierarchy(a,"transp_depth_pass",b,b,c),a=this.GetTHREEJSObjectHierarchy(a,"transp_diffuse_pass",b,b,c);void 0===c?(d.newlycreated&&this.get("_3JSsceneTransp").add(d.node),f.newlycreated&&this.get("_3JSsceneTranspDepth").add(f.node),a.newlycreated&&this.get("_3JSsceneTranspDiffuse").add(a.node)):(this.InitTransparentCoincidentGroupScene(c),
d.newlycreated&&this.get("_3JSsceneTranspCoincidentGroups")[c].add(d.node),f.newlycreated&&this.get("_3JSsceneTranspCoincidentGroupsDepth")[c].add(f.node),a.newlycreated&&this.get("_3JSsceneTranspCoincidentGroupsDiffuse")[c].add(a.node))},SetNonEmptyScene:function(a){a?this.set("_emptyTransparentScene",!1):this.set("_emptyOpaqueScene",!1)},CreateNewCoincidentGroupPass:function(a,b){b?this.get("_3JSsceneTranspCoincidentGroupsIds").hasOwnProperty(a)||(this.get("_3JSsceneTranspCoincidentGroupsIds")[a]=
{},this.get("_3JSsceneTranspCoincidentGroupsPasses").push(a)):this.get("_3JSsceneOpCoincidentGroupsIds").hasOwnProperty(a)||(this.get("_3JSsceneOpCoincidentGroupsIds")[a]={},this.get("_3JSsceneOpCoincidentGroupsPasses").push(a))},AsynchronousLightLoad:function(a){var b=this;b.get("_build_scene_exec_queue").whenFinished(function(){b.get("_renderercache").lights.holo_light=a;b.UpdateMaterialsGlobalLighting();b.get("_model").get("_assetmanager").set("_textureLoadedCounter",b.get("_model").get("_assetmanager").get("_textureLoadedCounter")+
1);var c=b.CheckPostSceneLoadActions();b.Render();b.NotifySceneBuildProgress(100,c,0)})},SelectTextureWrappingMode:function(a,b,c){b.hasOwnProperty("original_width")&&(c.originalTexWidth=parseFloat(b.original_width));b.hasOwnProperty("original_height")&&(c.originalTexHeight=parseFloat(b.original_height));switch(b.swrap){default:case "GL_REPEAT":a.wrapS=d.RepeatWrapping;break;case "GL_CLAMP":case "GL_CLAMP_TO_BORDER":case "GL_CLAMP_TO_EDGE":a.wrapS=d.ClampToEdgeWrapping}switch(b.twrap){default:case "GL_REPEAT":a.wrapT=
d.RepeatWrapping;break;case "GL_CLAMP":case "GL_CLAMP_TO_BORDER":case "GL_CLAMP_TO_EDGE":a.wrapT=d.ClampToEdgeWrapping}},LoadMaterial:function(a,b,c,i,f){if("Material"==a.AssetType){if(a.hasOwnProperty("Properties")){var a=a.Properties,g=1,e=1,h=1,j=1,l=1,n=1,k=1,r=1,m=1;a.front.hasOwnProperty("diffuse")&&(g=a.front.diffuse[0],e=a.front.diffuse[1],h=a.front.diffuse[2]);a.front.hasOwnProperty("specular")&&(j=a.front.specular[0],l=a.front.specular[1],n=a.front.specular[2]);a.front.hasOwnProperty("ambient")&&
(k=a.front.ambient[0],r=a.front.ambient[1],m=a.front.ambient[2]);var g=new d.Color(g,e,h),j=new d.Color(j,l,n),m=new d.Color(k,r,m),l=a.front.hasOwnProperty("shininess")?z.clamp(parseFloat(a.front.shininess),0,1):0.5,n=a.hasOwnProperty("double_sided")?y.get("toBool")(a.double_sided):!1,e=a.hasOwnProperty("opacity")?z.clamp(parseFloat(a.opacity),0,1):1,h=a.front.hasOwnProperty("double_grating")?y.get("toBool")(a.front.double_grating):!1,p=a.front.hasOwnProperty("grating_spacing_scale")?parseFloat(a.front.grating_spacing_scale):
null,s=a.front.hasOwnProperty("default_diff_haze")?parseFloat(a.front.default_diff_haze):null,q=a.front.hasOwnProperty("default_diff_spacing")?parseFloat(a.front.default_diff_spacing):null,r=(k=a.front.hasOwnProperty("diff_grating_tex")||a.front.hasOwnProperty("diff_grating_filter_tex"))||a.front.hasOwnProperty("int_specular_tex")||a.front.hasOwnProperty("normal_chan0_tex")||a.front.hasOwnProperty("normal_chan1_tex"),u=!1;a.front.hasOwnProperty("diffuse_tex")&&b[a.front.diffuse_tex].Properties.hasOwnProperty("transparent")&&
(e=(u=y.get("toBool")(b[a.front.diffuse_tex].Properties.transparent))?0.5:e);i={mat:{untextured_mat:null,textured_mat:{}},boundmeshlist:null,reflectance_model:a.reflectance_model,diff_texture:null,spec_texture:null,int_spec_texture:null,normal_chan0_texture:null,normal_chan1_texture:null,diff_grating_texture:null,diff_grating_filter_texture:null,diff_col:g,spec_col:j,amb_col:m,shininess:l,double_sided:n,opacity:e,transp_texture:u,double_grating:h,grating_spacing_scale:p,default_diff_haze:s,default_diff_spacing:q,
holographic:k,printable:r,backTexture:i,flipNormals:f};f=this.CreateMaterial(i);i.mat.untextured_mat=f;c=this.get("_model").get("_assetmanager").get("_assetloader").get("_httprequestmanager").IsAbsoluteURL(c)?c.substring(0,c.lastIndexOf("/")+1):this.get("_resourcePath")+"/";this.StartAsyncTextureLoad(this,b,a,"diffuse_tex","diff_texture",i,c,r?d.RGBAFormat:d.RGBFormat,4);this.StartAsyncTextureLoad(this,b,a,"specular_tex","spec_texture",i,c,d.RGBAFormat,4);"Visualizer"==this.get("_RenderingQuality")&&
(this.StartAsyncTextureLoad(this,b,a,"int_specular_tex","int_spec_texture",i,c,d.RGBAFormat,4),this.StartAsyncTextureLoad(this,b,a,"normal_chan0_tex","normal_chan0_texture",i,c,d.RGBFormat,1),this.StartAsyncTextureLoad(this,b,a,"normal_chan1_tex","normal_chan1_texture",i,c,d.RGBFormat,1),this.StartAsyncTextureLoad(this,b,a,"diff_grating_tex","diff_grating_texture",i,c,d.RGBAFormat,4)&&this.StartAsyncTextureLoad(this,b,a,"diff_grating_filter_tex","diff_grating_filter_texture",i,c,d.RGBAFormat,4));
"Visualizer"==this.get("_RenderingQuality")&&(k&&!this.get("_renderercache").textures[this.get("_RenderingQuality")].spectrum.queried)&&(c=this.get("_resourcePath")+"/"+this.get("_renderercache").textures[this.get("_RenderingQuality")].path,this.get("_renderercache").textures[this.get("_RenderingQuality")].spectrum.queried=!0,new ea(c+"PointLightSources.json",this,this.AsynchronousLightLoad),this.get("_model").get("_assetmanager").set("_textureCounter",this.get("_model").get("_assetmanager").get("_textureCounter")+
1),this.StartAsyncGlobalTextureLoad(this,"spectrum",c));return i}w.Log("ViewerView Warning: Material properties not defined")}else w.Log("ViewerView Warning: Queried asset is not a material")},CreateMaterial:function(a,b){var c=null,i=null,f,g;a.diff_texture?f=a.diff_texture:a.spec_texture&&(f=a.spec_texture);if(void 0!==f){var e=f.offset;f=f.repeat;g=new d.Vector4(e.x,e.y,f.x,f.y)}else g=new d.Vector4(0,0,1,1);e={};f=A.get("_fullSupportFloatingPointTextures")||A.get("_fullSupportHFloatingPointTextures");
f=1<=a.opacity&&!a.transp_texture||!f;switch(this.get("_RenderingQuality")){case "Designer":0.5<=a.shininess?this.get("_renderercache").textures.Designer.envmap.glossy.loaded&&(c=this.get("_renderercache").textures.Designer.envmap.glossy.data,this.get("_renderercache").textures.Designer.irradiancemap.loaded&&(i=this.get("_renderercache").textures.Designer.irradiancemap.data)):this.get("_renderercache").textures.Designer.envmap.matte.loaded&&(c=this.get("_renderercache").textures.Designer.envmap.matte.data,
this.get("_renderercache").textures.Designer.irradiancemap.loaded&&(i=this.get("_renderercache").textures.Designer.irradiancemap.data));var h=d.UniformsUtils.clone(F.uniforms);h.diffuse.value=a.diff_col;h.opacity.value=f?1:a.opacity;h.specular.value=a.spec_col;h.shininess.value=Math.max(0.001,a.shininess);h.map.value=a.diff_texture;h.specularMap.value=a.spec_texture;h.irr_tex.value=i;h.envMap.value=c;h.reflectivity.value=0.5;h.offsetRepeat.value=g;e[1]={name:"designer",uniforms:h,vertexShader:F.vertexShader,
fragmentShader:F.fragmentShader,depthTest:!0,vertexColors:d.FaceColors,side:a.double_sided?d.DoubleSide:d.FrontSide,transparent:!f,blending:d.NormalBlending,defines:{ENVMAP_TYPE_CUBE:"",ENVMAP_MODE_REFLECTION:"",ENVMAP_BLENDING_ADD:""},lights:!0};break;case "Visualizer":for(var j={},l=!0,h=0;5>h;++h)if(this.get("_renderercache").textures.Visualizer.envmap.loaded[h])j[h]=this.get("_renderercache").textures.Visualizer.envmap.data[h];else{l=!1;break}l&&this.get("_renderercache").textures.Visualizer.irradiancemap.loaded&&
(i=this.get("_renderercache").textures.Visualizer.irradiancemap.data,c=j);if(a.printable){if(h=d.UniformsUtils.clone(X.uniforms),h.offsetRepeat.value=g,h.diffuseColor.value=a.diff_col,h.opacity.value=f?1:a.opacity,h.diffuseTexture.value=a.diff_texture?a.diff_texture:this.get("_DummyTexture"),h.normalMap_chan_0.value=a.normal_chan0_texture?a.normal_chan0_texture:this.get("_DummyTexture"),h.normalMap_chan_1.value=a.normal_chan1_texture?a.normal_chan1_texture:this.get("_DummyTexture"),h.DX1RT.value=
this.get("_DummyTexture"),h.DX2RT.value=this.get("_DummyTexture"),h.irradianceCubeMap.value=i?i:this.get("_DummyTextureCube"),h.backTexture.value=a.backTexture?1:0,h.flipNormals.value=a.flipNormals?1:0,j={},a.normal_chan0_texture&&(j.USE_CHAN0_TEXTURE=""),a.normal_chan1_texture&&(j.USE_CHAN1_TEXTURE=""),e[1]={name:"irradiancepm",uniforms:h,vertexShader:X.vertexShader,fragmentShader:X.fragmentShader,depthTest:!0,vertexColors:d.FaceColors,side:a.double_sided?d.DoubleSide:d.FrontSide,defines:j,blending:f?
d.NormalBlending:d.CustomBlending,blendSrc:d.OneFactor,blendDst:d.OneMinusSrcAlphaFactor,transparent:!0,extensions:{derivatives:!0,fragDepth:!1,drawBuffers:!1,shaderTextureLOD:!1}},h=d.UniformsUtils.clone(V.uniforms),h.offsetRepeat.value=g,h.diffuseColor.value=a.diff_col,h.opacity.value=f?1:a.opacity,h.diffuseTexture.value=a.diff_texture?a.diff_texture:this.get("_DummyTexture"),h.DX1RT.value=this.get("_DummyTexture"),h.DX2RT.value=this.get("_DummyTexture"),h.backTexture.value=a.backTexture?1:0,h.flipNormals.value=
a.flipNormals?1:0,e[3]={name:"filterpm",uniforms:h,vertexShader:V.vertexShader,fragmentShader:V.fragmentShader,depthTest:!0,vertexColors:d.FaceColors,side:a.double_sided?d.DoubleSide:d.FrontSide,defines:{},blending:d.CustomBlending,blendSrc:d.DstColorFactor,blendDst:d.ZeroFactor,transparent:!0},11<=A.get("_glmaxtextureimageunits")?(h=d.UniformsUtils.clone(H.EXTuniforms),h.haze1CubeMap.value=c?c[0]:this.get("_DummyTextureCube"),h.haze2CubeMap.value=c?c[1]:this.get("_DummyTextureCube"),h.haze3CubeMap.value=
c?c[2]:this.get("_DummyTextureCube"),h.haze4CubeMap.value=c?c[3]:this.get("_DummyTextureCube"),h.haze5CubeMap.value=c?c[4]:this.get("_DummyTextureCube")):(h=d.UniformsUtils.clone(H.uniforms),h.haze1CubeMap.value=c?c[0]:this.get("_DummyTextureCube"),h.haze2CubeMap.value=c?c[4]:this.get("_DummyTextureCube")),h.offsetRepeat.value=g,h.diffuseColor.value=a.diff_col,h.specularColor.value=a.spec_col,h.shininess.value=a.shininess,h.diffuseTexture.value=a.diff_texture?a.diff_texture:this.get("_DummyTexture"),
h.specularTexture.value=a.spec_texture?a.spec_texture:this.get("_DummyTexture"),h.internalSpecTex.value=a.int_spec_texture?a.int_spec_texture:this.get("_DummyTexture"),h.normalMap_chan_0.value=a.normal_chan0_texture?a.normal_chan0_texture:this.get("_DummyTexture"),h.normalMap_chan_1.value=a.normal_chan1_texture?a.normal_chan1_texture:this.get("_DummyTexture"),h.DX1RT.value=this.get("_DummyTexture"),h.DX2RT.value=this.get("_DummyTexture"),h.backTexture.value=a.backTexture?1:0,h.flipNormals.value=a.flipNormals?
1:0,j={},a.int_spec_texture&&(j.USE_INT_SPEC_TEXTURE=""),a.normal_chan0_texture&&(j.USE_CHAN0_TEXTURE=""),a.normal_chan1_texture&&(j.USE_CHAN1_TEXTURE=""),e[6]={name:"reflectancepm",uniforms:h,vertexShader:H.vertexShader,fragmentShader:11<=A.get("_glmaxtextureimageunits")?H.EXTfragmentShader:H.fragmentShader,depthTest:!0,vertexColors:d.FaceColors,side:a.double_sided?d.DoubleSide:d.FrontSide,defines:j,blending:d.CustomBlending,blendSrc:d.OneFactor,blendDst:d.OneFactor,transparent:!0,extensions:{derivatives:!0,
fragDepth:!1,drawBuffers:!1,shaderTextureLOD:!1}},a.holographic){j=d.UniformsUtils.clone(Z.uniforms);j.offsetRepeat.value=g;j.uvdhTexture.value=a.diff_grating_texture?a.diff_grating_texture:this.get("_DummyTexture");j.diffFilterTexture.value=a.diff_grating_filter_texture?a.diff_grating_filter_texture:this.get("_DummyTexture");j.normalMap_chan_0.value=a.normal_chan0_texture?a.normal_chan0_texture:this.get("_DummyTexture");j.normalMap_chan_1.value=a.normal_chan1_texture?a.normal_chan1_texture:this.get("_DummyTexture");
j.DX1RT.value=this.get("_DummyTexture");j.DX2RT.value=this.get("_DummyTexture");j.grating_spacing_scale.value=a.grating_spacing_scale;j.spectrumTexture.value=this.get("_renderercache").textures[this.get("_RenderingQuality")].spectrum.data;j.defaultDiffSpacing.value=a.default_diff_spacing;j.defaultDiffHaze.value=a.default_diff_haze;j.backTexture.value=a.backTexture?1:0;j.flipNormals.value=a.flipNormals?1:0;l={};a.double_grating&&(l.DOUBLE_GRATING="");a.normal_chan0_texture&&(l.USE_CHAN0_TEXTURE="");
a.normal_chan1_texture&&(l.USE_CHAN1_TEXTURE="");if(this.get("_renderercache").textures[this.get("_RenderingQuality")].spectrum.loaded&&this.get("_renderercache").lights.hasOwnProperty("holo_light")){l.USE_HOLOGRAPHICS="";j.lightPos.value=[];j.lightIntensity.value=[];j.lightRadius.value=[];j.lightHardness.value=[];for(h=0;h<this.get("_renderercache").lights.holo_light.Lights.length&&4>h;++h){var n=this.get("_renderercache").lights.holo_light.Lights[h];j.lightPos.value.push(new d.Vector3(n[0],n[1],
n[2]));j.lightIntensity.value.push(n[3]);j.lightRadius.value.push(n[4]);j.lightHardness.value.push(n[5])}}e[5]={name:"holographicspm",uniforms:j,vertexShader:Z.vertexShader,fragmentShader:Z.fragmentShader,depthTest:!0,vertexColors:d.FaceColors,side:a.double_sided?d.DoubleSide:d.FrontSide,defines:l,blending:d.CustomBlending,blendSrc:d.OneMinusDstColorFactor,blendDst:d.OneFactor,transparent:!0,extensions:{derivatives:!0,fragDepth:!1,drawBuffers:!1,shaderTextureLOD:!1}}}}else h=d.UniformsUtils.clone(Y.uniforms),
h.offsetRepeat.value=g,h.diffuseColor.value=a.diff_col,h.opacity.value=f?1:a.opacity,h.diffuseTexture.value=a.diff_texture?a.diff_texture:this.get("_DummyTexture"),h.DX1RT.value=this.get("_DummyTexture"),h.DX2RT.value=this.get("_DummyTexture"),h.irradianceCubeMap.value=i?i:this.get("_DummyTextureCube"),h.backTexture.value=a.backTexture?1:0,h.flipNormals.value=a.flipNormals?1:0,e[2]={name:"irradiancenpm",uniforms:h,vertexShader:Y.vertexShader,fragmentShader:Y.fragmentShader,depthTest:!0,vertexColors:d.FaceColors,
side:a.double_sided?d.DoubleSide:d.FrontSide,defines:{},blending:f?d.NormalBlending:d.CustomBlending,blendSrc:d.OneFactor,blendDst:d.OneMinusSrcAlphaFactor,transparent:!0},h=d.UniformsUtils.clone(W.uniforms),h.offsetRepeat.value=g,h.diffuseColor.value=a.diff_col,h.opacity.value=f?1:a.opacity,h.diffuseTexture.value=a.diff_texture?a.diff_texture:this.get("_DummyTexture"),h.DX1RT.value=this.get("_DummyTexture"),h.DX2RT.value=this.get("_DummyTexture"),h.backTexture.value=a.backTexture?1:0,h.flipNormals.value=
a.flipNormals?1:0,e[4]={name:"filternpm",uniforms:h,vertexShader:W.vertexShader,fragmentShader:W.fragmentShader,depthTest:!0,vertexColors:d.FaceColors,side:a.double_sided?d.DoubleSide:d.FrontSide,defines:{},blending:d.CustomBlending,blendSrc:d.DstColorFactor,blendDst:d.ZeroFactor,transparent:!0},11<=A.get("_glmaxtextureimageunits")?(h=d.UniformsUtils.clone(I.EXTuniforms),h.haze1CubeMap.value=c?c[0]:this.get("_DummyTextureCube"),h.haze2CubeMap.value=c?c[1]:this.get("_DummyTextureCube"),h.haze3CubeMap.value=
c?c[2]:this.get("_DummyTextureCube"),h.haze4CubeMap.value=c?c[3]:this.get("_DummyTextureCube"),h.haze5CubeMap.value=c?c[4]:this.get("_DummyTextureCube")):(h=d.UniformsUtils.clone(I.uniforms),h.haze1CubeMap.value=c?c[0]:this.get("_DummyTextureCube"),h.haze2CubeMap.value=c?c[4]:this.get("_DummyTextureCube")),h.DX1RT.value=this.get("_DummyTexture"),h.DX2RT.value=this.get("_DummyTexture"),h.offsetRepeat.value=g,h.specularCol.value=a.spec_col,h.shininess.value=a.shininess,h.backTexture.value=a.backTexture?
1:0,h.flipNormals.value=a.flipNormals?1:0,e[7]={name:"reflectancenpm",uniforms:h,vertexShader:I.vertexShader,fragmentShader:11<=A.get("_glmaxtextureimageunits")?I.EXTfragmentShader:I.fragmentShader,depthTest:!0,vertexColors:d.FaceColors,side:a.double_sided?d.DoubleSide:d.FrontSide,defines:{},blending:d.CustomBlending,blendSrc:d.OneFactor,blendDst:d.OneFactor,transparent:!0}}j={};if(!b||"depth_pass"==b||"opaque_diffuse_pass"==b||"transp_depth_pass"==b||"transp_diffuse_pass"==b){l=h=null;if(!b||"depth_pass"==
b||"transp_depth_pass"==b)h=d.UniformsUtils.clone(E.uniforms),h=new d.ShaderMaterial({uniforms:h,vertexShader:E.vertexShader,fragmentShader:E.fragmentShader,side:d.DoubleSide,depthWrite:!0,transparent:!1,name:"D0ShaderMaterial",lights:!1});if(!b||"opaque_diffuse_pass"==b||"transp_diffuse_pass"==b)l=d.UniformsUtils.clone(T.uniforms),l.diffuseColor.value=a.diff_col,l.opacity.value=a.opacity,l.diffuseTexture.value=a.diff_texture?a.diff_texture:this.get("_DummyTexture"),l.offsetRepeat.value=g,l.DX1RT.value=
this.get("_DummyTexture"),l.DX2RT.value=this.get("_DummyTexture"),l.backTexture.value=a.backTexture?1:0,l.flipNormals.value=a.flipNormals?1:0,l=new d.ShaderMaterial({uniforms:l,vertexShader:T.vertexShader,fragmentShader:T.fragmentShader,side:a.double_sided?d.DoubleSide:d.FrontSide,depthWrite:!0,transparent:!0,blending:d.CustomBlending,blendSrc:d.DstColorFactor,blendDst:d.ZeroFactor,name:"TransBlendShader",lights:!1}),a.diff_texture&&(l.defines.USE_MAP=""),a.printable||(l.defines.IS_NPM=""),a.diff_texture&&
a.diff_texture.remappedAlphaChannel&&(l.defines.REMAPPED_DIFFUSE_ALPHA_CHANNEL=""),a.spec_texture&&a.spec_texture.remappedAlphaChannel&&(l.defines.REMAPPED_SPECULAR_ALPHA_CHANNEL=""),a.int_spec_texture&&a.int_spec_texture.remappedAlphaChannel&&(l.defines.REMAPPED_INT_SPECULAR_ALPHA_CHANNEL=""),a.diff_grating_texture&&a.diff_grating_texture.remappedAlphaChannel&&(l.defines.REMAPPED_DIFF_GRATING_ALPHA_CHANNEL="");f?(h&&(j.depth_pass=[h]),l&&(j.opaque_diffuse_pass=[l])):(h&&(j.transp_depth_pass=[h]),
l&&(j.transp_diffuse_pass=[l]))}j.hasOwnProperty("opaque_pass")||(j.opaque_pass=[]);j.hasOwnProperty("transparent_pass")||(j.transparent_pass=[]);h=0;g=Object.keys(e);for(l=g.length;h<l;++h)if(n=g[h],e[n])if(a.double_sided&&(e[n].defines.DOUBLE_SIDED=""),a.diff_texture&&(e[n].defines.USE_MAP=""),a.spec_texture&&(e[n].defines.USE_SPECULARMAP=""),i&&(e[n].defines.USE_IRRMAP=""),c&&(e[n].defines.USE_ENVMAP=""),a.diff_texture&&a.diff_texture.remappedAlphaChannel&&(e[n].defines.REMAPPED_DIFFUSE_ALPHA_CHANNEL=
""),a.spec_texture&&a.spec_texture.remappedAlphaChannel&&(e[n].defines.REMAPPED_SPECULAR_ALPHA_CHANNEL=""),a.int_spec_texture&&a.int_spec_texture.remappedAlphaChannel&&(e[n].defines.REMAPPED_INT_SPECULAR_ALPHA_CHANNEL=""),a.diff_grating_texture&&a.diff_grating_texture.remappedAlphaChannel&&(e[n].defines.REMAPPED_DIFF_GRATING_ALPHA_CHANNEL=""),f&&(!b||"opaque_pass"==b)){n=new d.ShaderMaterial(e[n]);n.polygonOffset=!0;this.get("_renderercache");var k=this.get("_renderercache").materials.enablehighlights&&
__enableHardEdgeHighlights;n.polygonOffsetFactor=k?this.get("_polygon_offset_factor"):0;n.polygonOffsetUnits=k?this.get("_polygon_offset_units"):0;j.opaque_pass.push(n)}else if(!f&&(!b||"transparent_pass"==b))n=new d.ShaderMaterial(e[n]),n.polygonOffset=!1,j.transparent_pass.push(n);return j},UpdateTexturedMaterial:function(a){if(a){var b=a.boundmeshlist;if(b){0==Object.keys(b).length&&w.Log("ViewerView Warning: No meshes to update");for(var c=0,d=Object.keys(b),f=d.length;c<f;++c){var g=d[c];0==
Object.keys(b[g]).length&&w.Log("ViewerView Warning: No render passes to update");for(var e=0,h=Object.keys(b[g]),j=h.length;e<j;++e){var l=h[e];0==Object.keys(b[g][l]).length&&w.Log("ViewerView Warning: No sided materials to update");for(var n=0,k=Object.keys(b[g][l]),r=k.length;n<r;++n){var m=k[n];0==Object.keys(b[g][l][m]).length&&w.Log("ViewerView Warning: No shading pass to update");for(var p=0,s=Object.keys(b[g][l][m]),q=s.length;p<q;++p){var u=s[p],v=this.CreateMaterial(a,g);v[g][m].side=a.mat.textured_mat[g][m][u].side;
this.ReleaseMaterial(a.mat.textured_mat[g][m][u],!1);a.mat.textured_mat[g][m][u]=v[g][m];for(var t=0,B=Object.keys(b[g][l][m][u]),x=B.length;t<x;++t){var J=b[g][l][m][u][B[t]];J.material=v[g][m];J.geometry.buffersNeedUpdate=!0;J.geometry.uvsNeedUpdate=!0}}}}}}else w.Log("ViewerView Warning: No meshes to update")}},UpdateMaterialsGlobalLighting:function(){for(var a=this.get("_renderercache").materials,b=0,c=Object.keys(a.materiallist),d=c.length;b<d;++b){var f=c[b],g=a.materiallist[f].back;this.UpdateTexturedMaterial(a.materiallist[f].front);
this.UpdateTexturedMaterial(g)}},UpdateMaterialTexture:function(a,b,c){if(a){for(var i=a.mat.textured_mat,f=0,g=Object.keys(a),e=g.length;f<e;++f){var h=g[f];a[h]&&(a[h]instanceof d.Texture&&""!=a[h].name&&a[h].name==b)&&(a[h].dispose(),a[h]=c)}if(i){0==Object.keys(i).length&&w.Log("ViewerView Warning: No render passes to update");a=0;f=Object.keys(i);for(h=f.length;a<h;++a){var j=f[a];0==Object.keys(i[j]).length&&w.Log("ViewerView Warning: No shading passes to update");for(var l=0,n=Object.keys(i[j]),
e=n.length;l<e;++l){var k=n[l];0==Object.keys(i[j][k]).length&&w.Log("ViewerView Warning: No surface materials to update");for(var r=0,m=Object.keys(i[j][k]),p=m.length;r<p;++r){var s=i[j][k][m[r]];if(s&&s.uniforms)for(var q=0,g=Object.keys(s.uniforms),u=g.length;q<u;++q){var v=s.uniforms[g[q]];if(v.value&&"function"===typeof v.value.dispose&&v.value instanceof d.Texture){var t=v.value;""!=t.name&&t.name==b&&(c.format=t.format,c.unpackAlignment=t.unpackAlignment,c.anisotropy=t.anisotropy,c.repeat=
t.repeat,c.remappedAlphaChannel=t.remappedAlphaChannel,v.value=c)}}}}}}else w.Log("ViewerView Warning: No textured material to update")}},ReloadAllTextures:function(a,b){for(var c=0,d=this,f=0,g=Object.keys(this.get("_renderercache").textures.FromFile),e=g.length;f<e;++f){var h=g[f];this.ReloadTexture(h,h,function(){++c;c==e&&((void 0===b||b)&&d.Render(),"function"==typeof a&&a())},!0,!1)}},ReloadTexture:function(a,b,c,i,f){var g=this,e=new d.TextureLoader;e.crossOrigin="";e.load(b+"?t="+(new Date).getTime(),
function(b){for(var d=g.get("_renderercache").materials,i=0,e=Object.keys(d.materiallist),k=e.length;i<k;++i){var r=e[i],m=d.materiallist[r].back;g.UpdateMaterialTexture(d.materiallist[r].front,a,b);g.UpdateMaterialTexture(m,a,b)}(void 0===f||f)&&g.Render();"function"==typeof c&&c()},void 0,function(){w.Log("ViewerView Warning: Problem loading texture")}).name=i||void 0==i?a:b},AssetRefParse:function(a,b){var c={},d=a.lastIndexOf("#");if(-1==d)c.new_scene_id=a,c.refnode=b[c.new_scene_id];else{c.new_scene_id=
a.substring(0,d);var f=b[c.new_scene_id];if(f){var d=a.substring(d+1),g;do g=d.indexOf("/"),-1==g?(g=d,d=""):g=d.substring(0,g),f=f[g],d=d.substring(Math.min(d.indexOf("/")+1,d.length));while(0<d.length&&void 0!==f);f||null==f}null===f?w.Log(c.new_scene_id+" is null"):void 0==f&&w.Log(c.new_scene_id+" not yet in cache or not existing");c.refnode=f}return c},URLToKeyString:function(a){a=a.replace("#","/");return a=a.replace(/(ftp|http|https):\/\/?/,"")},RegisterObjectNode:function(a,b,c,i,f){var a=
this.URLToKeyString(a),g=this.get("_renderercache").nodeviewproperties,e=!1;g.hasOwnProperty(a)||(g[a]={threejsnodes:{}});g[a].threejsnodes.hasOwnProperty(b)||(g[a].threejsnodes[b]={});void 0===i?g[a].threejsnodes[b].hasOwnProperty("default_cg")||(this.set("_nodecounter",this.get("_nodecounter")+1),g[a].threejsnodes[b].default_cg=new d.Object3D,e=!0):g[a].threejsnodes[b].hasOwnProperty(i)||(this.set("_nodecounter",this.get("_nodecounter")+1),g[a].threejsnodes[b][i]=new d.Object3D,e=!0);"highlightnode"==
b&&(void 0===f||!0===f)&&this.AddUIElement(a,c);return{node:void 0!==i?g[a].threejsnodes[b][i]:g[a].threejsnodes[b].default_cg,newlycreated:e,register:!0}},GetTHREEJSObjectHierarchyRec:function(a,b,c,i,f,g,e,h,j,l,n){var k=a.AssetReferenceProperties,r={};if(e)for(var m=0,p=Object.keys(e),s=p.length;m<s;++m){var q=p[m];r[q]=e[q]}if(k&&(e=k.materialmap)){m=0;p=Object.keys(e);for(s=p.length;m<s;++m){var q=p[m],u=this.get("_renderercache").materials.materiallist,v=this.get("_model").get("_assetmanager").get("_cache").rootnodes,
t=e[q][0]+(e[q][1]?"/"+e[q][1]:""),v=v[c].Assets,B=null,x=null;if(u.hasOwnProperty(t))v=u[t];else{var J=!1;v.hasOwnProperty(e[q][0])?B=this.LoadMaterial(v[e[q][0]],v,c,!1,!1):w.Log("ViewerView Warning: Front material "+e[q][0]+" not found");var z=!1;e[q][1]&&(v.hasOwnProperty(e[q][1])?(x=v[e[q][1]],x=this.LoadMaterial(x,v,c,!0,!0),z=!0):w.Log("ViewerView Warning: Back material "+e[q][1]+" not found. Trying to assign front material."));!z&&v.hasOwnProperty(e[q][0])&&(x=v[e[q][0]],x=this.LoadMaterial(x,
v,c,!1,!0),J=!0);v={material_name:t,front:B,back:x,sharedmaterial:J};u[t]=v}r[q]=v}}m=new d.Matrix4;if(k)if(p=new d.Vector3(parseFloat(k.x),parseFloat(k.y),parseFloat(k.z)),new d.Vector3(0,0,0),k.hasOwnProperty("orientation_matrix"))m.set(k.orientation_matrix[0],k.orientation_matrix[1],k.orientation_matrix[2],p.x,k.orientation_matrix[3],k.orientation_matrix[4],k.orientation_matrix[5],p.y,k.orientation_matrix[6],k.orientation_matrix[7],k.orientation_matrix[8],p.z,0,0,0,1);else switch(k.orientation){case "2":m.set(0,
-1,0,p.x,1,0,0,p.y,0,0,1,p.z,0,0,0,1);break;case "3":m.set(-1,0,0,p.x,0,-1,0,p.y,0,0,1,p.z,0,0,0,1);break;case "4":m.set(0,1,0,p.x,-1,0,0,p.y,0,0,1,p.z,0,0,0,1);break;case "5":m.set(1,0,0,p.x,0,0,1,p.y,0,-1,0,p.z,0,0,0,1);break;case "6":m.set(0,0,-1,p.x,1,0,0,p.y,0,-1,0,p.z,0,0,0,1);break;case "7":m.set(-1,0,0,p.x,0,0,-1,p.y,0,-1,0,p.z,0,0,0,1);break;case "8":m.set(0,0,1,p.x,-1,0,0,p.y,0,-1,0,p.z,0,0,0,1);break;case "9":m.set(0,0,-1,p.x,0,1,0,p.y,1,0,0,p.z,0,0,0,1);break;case "10":m.set(0,-1,0,p.x,
0,0,-1,p.y,1,0,0,p.z,0,0,0,1);break;case "11":m.set(0,0,1,p.x,0,-1,0,p.y,1,0,0,p.z,0,0,0,1);break;case "12":m.set(0,1,0,p.x,0,0,1,p.y,1,0,0,p.z,0,0,0,1);break;case "13":m.set(-1,0,0,p.x,0,1,0,p.y,0,0,-1,p.z,0,0,0,1);break;case "14":m.set(0,-1,0,p.x,-1,0,0,p.y,0,0,-1,p.z,0,0,0,1);break;case "15":m.set(1,0,0,p.x,0,-1,0,p.y,0,0,-1,p.z,0,0,0,1);break;case "16":m.set(0,1,0,p.x,1,0,0,p.y,0,0,-1,p.z,0,0,0,1);break;case "17":m.set(-1,0,0,p.x,0,0,1,p.y,0,1,0,p.z,0,0,0,1);break;case "18":m.set(0,0,-1,p.x,-1,
0,0,p.y,0,1,0,p.z,0,0,0,1);break;case "19":m.set(1,0,0,p.x,0,0,-1,p.y,0,1,0,p.z,0,0,0,1);break;case "20":m.set(0,0,1,p.x,1,0,0,p.y,0,1,0,p.z,0,0,0,1);break;case "21":m.set(0,0,1,p.x,0,1,0,p.y,-1,0,0,p.z,0,0,0,1);break;case "22":m.set(0,-1,0,p.x,0,0,1,p.y,-1,0,0,p.z,0,0,0,1);break;case "23":m.set(0,0,-1,p.x,0,-1,0,p.y,-1,0,0,p.z,0,0,0,1);break;case "24":m.set(0,1,0,p.x,0,0,-1,p.y,-1,0,0,p.z,0,0,0,1);break;default:m.set(1,0,0,p.x,0,1,0,p.y,0,0,1,p.z,0,0,0,1)}else m.set(1,0,0,0,0,1,0,0,0,0,1,0,0,0,0,
1);j instanceof d.Matrix4&&m.premultiply(j);j={};if(h&&!this.get("_parsedEntireSceneGraphOnce")){p=0;s=Object.keys(h);for(q=s.length;p<q;++p)j[s[p]]=h[s[p]]}if(k&&!this.get("_parsedEntireSceneGraphOnce")&&(h=k.labelsettingsmap)){k=0;p=Object.keys(h);for(s=p.length;k<s;++k)j[p[k]]=h[p[k]]}return this.GetTHREEJSObjectHierarchy(a,b,c,i,f,g,r,j,m,l,n)},IsAssetBoundingBoxLabelAssetType:function(a,b,c){return(a=this.get("_model").get("_assetmanager").get("_assetloader").IsURL(a)?this.AssetRefParse(a,b).refnode:
b[c].Assets[a])?"Label"==a.AssetType&&a.Properties.hasOwnProperty("bounding_box"):!1},GetTHREEJSObjectHierarchy:function(a,b,c,i,f,g,e,h,j,l,n){var k=this.get("_model").get("_assetmanager").get("_cache").rootnodes,r;if(void 0==a)return w.Log("ViewerView Warning: Reference to __asset '"+i+"' not yet loaded in cache. This node should be updated when asynchronuous data is loaded."),{node:null,newlycreated:!1,register:!1};var m=!(a.hasOwnProperty("Children")&&a.Children||a.hasOwnProperty("AssetRef"));
if(a.hasOwnProperty("Children")&&a.Children){var p=!1;a.hasOwnProperty("FlattenSubTree")&&(p=!y.get("toBool")(a.FlattenSubTree));for(var s=[],q=0,u=Object.keys(a.Children),v=u.length;q<v;++q){var t=u[q];if(!this.IsAssetBoundingBoxLabelAssetType(a.Children[t].AssetRef,k,c)){var B=i+"/"+t,t=this.GetTHREEJSObjectHierarchyRec(a.Children[t],b,c,B,f,a.AssetRef,e,h,j,p?B:l,null);t.register&&t.newlycreated&&s.push(t.node)}}if(0<s.length){r=this.RegisterObjectNode(i,b,m,f);q=0;u=Object.keys(s);for(v=u.length;q<
v;++q)r.node.add(s[u[q]]);q=0;u=Object.keys(a.Children);for(v=u.length;q<v;++q)t=u[q],this.IsAssetBoundingBoxLabelAssetType(a.Children[t].AssetRef,k,c)&&(B=i+"/"+t,t=this.GetTHREEJSObjectHierarchyRec(a.Children[t],b,c,B,f,a.AssetRef,e,h,j,p?B:l,r))}else r={node:null,newlycreated:!1,register:!1}}else if(a.hasOwnProperty("AssetRef"))this.get("_model").get("_assetmanager").get("_assetloader").IsURL(a.AssetRef)?(m=this.AssetRefParse(a.AssetRef,k),r=m.refnode,m=m.new_scene_id):(r=k[c].Assets[a.AssetRef],
m=c),r=this.GetTHREEJSObjectHierarchy(r,b,m,i,f,a.AssetRef,e,h,j,l,n);else{p=!1;if(a.hasOwnProperty("Properties")&&a.Properties&&("Cuboid"==a.AssetType||"Mesh"==a.AssetType)){var q=a.AssetType,u=a.Properties,v=this.get("_renderercache").geometries,s=this.get("_renderercache").materials,t=this.get("_renderercache").coplanarityepsilon,B=this.get("_renderercache").boundaryhardedges,x=c+g.substring(g.lastIndexOf("/")),e=this.get("_3DObjectHandler").InstanciateGeometry(q,x,b,u,v,s,e,t,B,f,j,l,this);if(e.register){p=
!0;r=this.RegisterObjectNode(i,b,m,f);q=0;u=Object.keys(e.objects);for(v=u.length;q<v;++q)b=u[q],r.node.add(e.objects[b]),e.objects[b].geometry.hasOwnProperty("useSoftwareInstancing")&&e.objects[b].geometry.useSoftwareInstancing&&e.objects[b].applyMatrix(j)}}else a.hasOwnProperty("Properties")&&(a.Properties&&"Label"==a.AssetType&&!this.get("_parsedEntireSceneGraphOnce"))&&this.get("_labelCreationCallbackList").push(function(){this.LoadLabel(k[c],i,a,g,h,j,n)}.bind(this));p||(r={node:null,newlycreated:!1,
register:!1})}a.hasOwnProperty("AssetType")&&"Scene"==a.AssetType&&(this.get("_model").get("SceneId")==a.AssetId&&this.set("_parsedEntireSceneGraphOnce",!0),r.node&&r.node.traverse(function(a){if(a instanceof d.Mesh&&a.geometry instanceof d.InstancedBufferGeometry&&a.geometry.attributes.inst_translation.jarray&&a.geometry.attributes.inst_rotation.jarray&&a.geometry.attributes.inst_scale.jarray&&1<a.geometry.attributes.inst_translation.jarray.length/3){a.geometry.maxInstancedCount=a.geometry.attributes.inst_translation.jarray.length/
3;a.geometry.adjacentfacesedgeslines.maxInstancedCount=a.geometry.maxInstancedCount;var b=new Float32Array(a.geometry.attributes.inst_translation.jarray),c=new Float32Array(a.geometry.attributes.inst_rotation.jarray),e=new Float32Array(a.geometry.attributes.inst_scale.jarray);a.geometry.attributes.inst_translation.array=b;a.geometry.attributes.inst_rotation.array=c;a.geometry.attributes.inst_scale.array=e;a.geometry.adjacentfacesedgeslines.attributes.inst_translation.array=b;a.geometry.adjacentfacesedgeslines.attributes.inst_rotation.array=
c;a.geometry.adjacentfacesedgeslines.attributes.inst_scale.array=e}}));return r},RotateOutOfBoundsVisibleLabels:function(a,b,c,d,f,g){for(var e=!0,h=0,j=Object.keys(this.get("_renderercache").labels.list),l=j.length;h<l;++h){var n=j[h],n=this.get("_renderercache").labels.list[n],k=this.GetLabelBoundingBox(n,n.orientation),r=void 0;if("vertical"!=n.orientation)if(k.max.x>f||k.min.x<-f)n.threejs_sprite.material.rotation=1.5708,r="vertical";else{if(k.max.y>g||k.min.y<-g)e=!1;n.threejs_sprite.material.rotation=
0}else if(k.max.y>g||k.min.y<-g)n.threejs_sprite.material.rotation=0,r="horizontal";else{if(k.max.x>f||k.min.x<-f)e=!1;n.threejs_sprite.material.rotation=1.5708}if(r&&(this.UpdateLabelPosition(n,a,c/2,d/2,r),k=this.GetLabelBoundingBox(n,r),k.max.x>f||k.min.x<-f||k.max.y>g||k.min.y<-g))e=!1;b.union(k)}return e},GetLabelBoundingBox:function(a,b){var c=a.threejs_sprite,i=new d.Box2,f=c.scale.x,g=c.scale.y,e=0.5*("vertical"==(b?b:a.orientation)?g:f),f=0.5*("vertical"==(b?b:a.orientation)?f:g);i.expandByPoint(new d.Vector2(c.position.x-
e,c.position.y-f));i.expandByPoint(new d.Vector2(c.position.x-e,c.position.y+f));i.expandByPoint(new d.Vector2(c.position.x+e,c.position.y-f));i.expandByPoint(new d.Vector2(c.position.x+e,c.position.y+f));return i},UpdateLabelsPositions:function(a,b,c){a.updateMatrixWorld();for(var b=b?b:this.get("_context").clientWidth,c=c?c:this.get("_context").clientHeight,d=0,f=Object.keys(this.get("_renderercache").labels.list),g=f.length;d<g;++d){var e=f[d],e=this.get("_renderercache").labels.list[e];this.UpdateLabelPosition(e,
a,b/2,c/2)}},UpdateLabelPosition:function(a,b,c,i,f){var g=a.threejs_sprite,e=[],h=[],j;switch(a.bounds_type){case "edge_list":for(var l=0,n=Object.keys(a.edge_list),k=n.length;l<k;++l){var r=a.edge_list[n[l]],m=new d.Vector3(r[0],r[1],r[2]);m.project(b);h.push(new d.Vector2(m.x*c,m.y*i));r=new d.Vector3(r[3],r[4],r[5]);r.project(b);h.push(new d.Vector2(r.x*c,r.y*i));m=m.add(r).multiplyScalar(0.5);e.push(new d.Vector2(m.x*c,m.y*i))}break;case "point_list":l=0;n=Object.keys(a.point_list);for(k=n.length;l<
k;++l)m=a.point_list[n[l]],m=new d.Vector3(m[0],m[1],m[2]),m.project(b),h.push(new d.Vector2(m.x*c,m.y*i)),e.push(new d.Vector2(m.x*c,m.y*i));break;case "ellipse":j=a.ellipse.center;m=a.ellipse.radius1_vec;k=a.ellipse.radius2_vec;j=new d.Vector3(j[0],j[1],j[2]);m=new d.Vector3(m[0],m[1],m[2]);r=new d.Vector3(k[0],k[1],k[2]);k=m.clone().cross(r).normalize();k.x=Math.abs(k.x);k.y=Math.abs(k.y);k.z=Math.abs(k.z);k.angleTo(new d.Vector3(0,1,0));m.add(j);r.add(j);j.project(b);m.project(b);r.project(b);
m.sub(j);r.sub(j);m.length()<r.length()&&(m=[r,r=m][0]);var b=m.length(),k=r.length(),m=m.clone().normalize(),p=r.clone().normalize(),s,q,u,v,t,B,x,y,A,r=j.x;s=j.y;u=Math.atan2(-b*m.y,k*p.y);q=b*Math.cos(u)*m.x+k*Math.sin(u)*p.x;B=b*Math.cos(u)*m.y+k*Math.sin(u)*p.y;v=u+Math.PI;u=b*Math.cos(v)*m.x+k*Math.sin(v)*p.x;x=b*Math.cos(v)*m.y+k*Math.sin(v)*p.y;Math.atan2(-b*m.x,k*p.x);t=v+0.5*Math.PI;v=b*Math.cos(t)*m.x+k*Math.sin(t)*p.x;y=b*Math.cos(t)*m.y+k*Math.sin(t)*p.y;A=t+Math.PI;t=b*Math.cos(A)*m.x+
k*Math.sin(A)*p.x;m=b*Math.cos(A)*m.y+k*Math.sin(A)*p.y;u+=r;x+=s;v+=r;y+=s;t+=r;m+=s;b=new d.Vector2((q+r)*c,(B+s)*i);k=new d.Vector2(u*c,x*i);r=new d.Vector2(v*c,y*i);m=new d.Vector2(t*c,m*i);s=b.distanceToSquared(k);q=b.distanceToSquared(r);u=b.distanceToSquared(m);v=k.distanceToSquared(r);t=k.distanceToSquared(m);B=r.distanceToSquared(m);x=0;s>=x&&(x=s,l=b,n=k);q>=x&&(x=q,l=b,n=r);u>=x&&(x=u,l=b,n=m);v>=x&&(x=v,l=k,n=r);t>=x&&(x=t,l=k,n=m);B>=x&&(l=r,n=m);e.push(l);e.push(n);h.push(new d.Vector2(j.x,
j.y));break;default:w.Log("Warning! Unsupported label_asset type.");return}m=k=void 0;n=l=0;r=e.length;switch(r){case 0:w.Log("Warning: no attachment point found.");break;case 1:l=e[0].x;n=e[0].y;break;default:v=new d.Box2;s=0;for(q=e.length;s<q;++s)u=e[s],v.expandByPoint(new d.Vector2(u.x,u.y));b=[];s=0;for(q=e.length;s<q;++s)u=e[s],(u.x==v.min.x||u.x==v.max.x||u.y==v.min.y||u.y==v.max.y)&&b.push(u);switch(b.length){case 0:console.log("There is probably an issue here. at least for vertices and edges");
break;case 1:l=b[0].x;n=b[0].y;break;default:if("center"==a.preferred_loc_h&&"center"==a.preferred_loc_v)m=z.CreateConvexHullFromPointlist(h),k=z.ConvexHullCenter(h,h.length-1),l=k.x,n=k.y;else if("center"==a.preferred_loc_h||"center"==a.preferred_loc_v){l=b[0].x;n=b[0].y;s=1;for(q=b.length;s<q;++s)u=b[s],"left"==a.preferred_loc_h?u.x<l&&(l=u.x,n=u.y):"right"==a.preferred_loc_h?u.x>l&&(l=u.x,n=u.y):"bottom"==a.preferred_loc_v?u.y<n&&(l=u.x,n=u.y):"top"==a.preferred_loc_v?u.y>n&&(l=u.x,n=u.y):(w.Log("Unrecognised Label user preference !"),
n=l=0)}else{e=new d.Vector2;s=0;for(q=b.length;s<q;++s){u=b[s];for(v=s+1;v<q;++v)t=b[v],t=u.clone().sub(t),e.add(new d.Vector2(Math.abs(t.x),Math.abs(t.y)))}l=b[0].x;n=b[0].y;if(e.x>e.y){s=1;for(q=b.length;s<q;++s)u=b[s],"left"==a.preferred_loc_h?u.x<l&&(l=u.x,n=u.y):"right"==a.preferred_loc_h?u.x>l&&(l=u.x,n=u.y):w.Log("Unrecognised horizontal layout: "+a.preferred_loc_h)}else{s=1;for(q=b.length;s<q;++s)u=b[s],"bottom"==a.preferred_loc_v?u.y<n&&(l=u.x,n=u.y):"top"==a.preferred_loc_v?u.y>n&&(l=u.x,
n=u.y):w.Log("Unrecognised vertical layout: "+a.preferred_loc_v)}}}}q=s=0;b=a.threejs_sprite.scale.x;u=a.threejs_sprite.scale.y;e=0.5*("vertical"==(f?f:a.orientation)?u:b);f=0.5*("vertical"==(f?f:a.orientation)?b:u);b=new d.Vector2(a.pixel_offset[0],a.pixel_offset[1]);if(1==r&&"point_list"==a.bounds_type||"center"==a.preferred_loc_h&&"center"==a.preferred_loc_v){var C=0,D=0;"right"==a.preferred_loc_h?C=1:"left"==a.preferred_loc_h&&(C=-1);"top"==a.preferred_loc_v?D=1:"bottom"==a.preferred_loc_v&&(D=
-1);s+=b.x*Math.sign(C);q+=b.y*Math.sign(D)}else if("ellipse"==a.bounds_type)j=new d.Vector2(j.x*c,j.y*i),s=l-j.x+b.x,q=n-j.y+b.y;else{c=m?m:z.CreateConvexHullFromPointlist(h);j=k?k:z.ConvexHullCenter(h,h.length-1);i=(new d.Vector2(l-j.x,n-j.y)).normalize();j=new d.Vector2;s=0;for(q=h.length-1;s<q;++s){u=h[s];for(v=s+1;v<q;++v)t=h[v],t=u.clone().sub(t),j.add(new d.Vector2(Math.abs(t.x),Math.abs(t.y)))}j.x>j.y?"top"==a.preferred_loc_v?(C=0,D=1):"bottom"==a.preferred_loc_v?(C=0,D=-1):"right"==a.preferred_loc_h?
(C=1,D=0):"left"==a.preferred_loc_h&&(C=-1,D=0):"right"==a.preferred_loc_h?(C=1,D=0):"left"==a.preferred_loc_h?(C=-1,D=0):"top"==a.preferred_loc_v?(C=0,D=1):"bottom"==a.preferred_loc_v&&(C=0,D=-1);s=(e+0.001)*C;q=(f+0.001)*D;a=1E4;for(k=!0;a&&k;)if(a--,j=[new d.Vector2(l+e+s,n+f+q),new d.Vector2(l-e+s,n+f+q),new d.Vector2(l+e+s,n-f+q),new d.Vector2(l-e+s,n-f+q)],z.ConvexHullContainsPoint(h,c,j[0])||z.ConvexHullContainsPoint(h,c,j[1])||z.ConvexHullContainsPoint(h,c,j[2])||z.ConvexHullContainsPoint(h,
c,j[3]))s+=i.x,q+=i.y;else{k=new d.Box2;k.setFromPoints(j);for(j=0;j<h;++j)k.containsPoint(h[j])&&(s+=i.x,q+=i.y);k=!1}0==a&&w.Log("ViewerView Warning: too many iterations when pushing label outside of its convex hull.");s+=b.x*Math.sign(C);q+=b.y*Math.sign(D)}g.position.set(l+s,n+q,0)},CameraUpdate:function(a,b,c){var i=this.get("_3JSsceneBBox").clone();if(!i.isEmpty()){this.SetCamera(this.get("_3JSsceneBBoxFocus"),b,c);var f=this.get("_3JScamera").position.clone(),g=this.get("_3JScamera").up.clone().normalize(),
f=i.center().clone().sub(f);f.normalize();for(var e=f.clone().cross(g),g=f.clone().sub(g.clone().multiplyScalar(0.5)).sub(e.clone().multiplyScalar(0.7)),f=0,e=Object.keys(this.get("_renderercache").lights.dir_light),h=e.length;f<h;++f){var j=this.get("_renderercache").lights.dir_light[e[f]];j&&(j.position.set(-g.x,-g.y,-g.z),j.needsUpdate=!0)}g=this.get("_3JSsceneBBox").min.clone();f=new d.Vector3(0,this.get("_3JSsceneBBox").size().y+this.get("_mirror_offset"),0);g.sub(f);i.expandByPoint(g);this.UpdateCamNearAndFar(i,
b,c);b=!1;null===this.get("_3JScamera").parent&&this.get("_3JScamera").updateMatrixWorld();c=new d.Matrix4;b=new d.Frustum;this.get("_3JScamera").matrixWorldInverse.getInverse(this.get("_3JScamera").matrixWorld);c.multiplyMatrices(this.get("_3JScamera").projectionMatrix,this.get("_3JScamera").matrixWorldInverse);b.setFromMatrix(c);c=new d.Geometry;c.vertices.push(this.get("_3JSsceneBBox").min,this.get("_3JSsceneBBox").max);c=new d.Mesh(c,null);this.set("_obj_in_frustum_prev",this.get("_obj_in_frustum"));
b=b.intersectsObject(c);this.set("_obj_in_frustum",b);(void 0===a||a)&&this.Render()}},SetCameraAngles:function(a,b,c){var d=this.get("_renderercache").cameras.defaultcamera.azimuthAngle,f=this.get("_renderercache").cameras.defaultcamera.elevationAngle;this.get("_renderercache").cameras.defaultcamera.azimuthAngle=a;this.get("_renderercache").cameras.defaultcamera.elevationAngle=b;this.CameraUpdate(c);!this.get("_obj_in_frustum")&&this.get("_obj_in_frustum_prev")&&(this.get("_renderercache").cameras.defaultcamera.azimuthAngle=
d,this.get("_renderercache").cameras.defaultcamera.elevationAngle=f,this.CameraUpdate(c))},GetCameraAngles:function(){return{azimuth:this.get("_renderercache").cameras.defaultcamera.azimuthAngle,elevation:this.get("_renderercache").cameras.defaultcamera.elevationAngle}},SetCameraScale:function(a,b){var c=this.get("_renderercache").cameras.defaultcamera.scale;this.get("_renderercache").cameras.defaultcamera.scale=a;this.CameraUpdate(b);!this.get("_obj_in_frustum")&&this.get("_obj_in_frustum_prev")&&
(this.get("_renderercache").cameras.defaultcamera.scale=c,this.CameraUpdate(b))},GetCameraScale:function(){return this.get("_renderercache").cameras.defaultcamera.scale},SetCameraPanOffset:function(a,b){var c=this.get("_renderercache").cameras.defaultcamera.panOffset;this.get("_renderercache").cameras.defaultcamera.panOffset=a;this.CameraUpdate(b);!this.get("_obj_in_frustum")&&this.get("_obj_in_frustum_prev")&&(this.get("_renderercache").cameras.defaultcamera.panOffset=c,this.CameraUpdate(b))},GetCameraPanOffset:function(){var a=
this.get("_renderercache").cameras.defaultcamera.panOffset;return{x:a.x,y:a.y}},SetPerspectiveCamera:function(a,b){this.get("_renderercache").cameras.defaultcamera.cam_type="PERSPECTIVE";this.get("_renderercache").cameras.defaultcamera.fieldOfView=a;this.CameraUpdate(b)},SetOrthographicCamera:function(a){this.get("_renderercache").cameras.defaultcamera.cam_type="ORTHOGRAPHIC";this.CameraUpdate(a)},UpdateCamNearAndFar:function(a,b,c){var i=this.get("_3JScamera"),f=this.get("_renderercache").cameras.defaultcamera.fieldOfView,
g=a.max,e=a.min,a=new d.Vector3(g.x-e.x,g.y-e.y,g.z-e.z),g=new d.Vector3((e.x+g.x)/2,(e.y+g.y)/2,(e.z+g.z)/2),b=b?b:this.get("_context").clientWidth,c=c?c:this.get("_context").clientHeight,c=b/c;Math.min(f,c*f);f=Math.sqrt(a.x*a.x+a.y*a.y+a.z*a.z);a=this.get("_3JScamera").position.clone();b=this.get("_renderercache").cameras.defaultcamera;a.addScaledVector(this.get("_cameraleftdirvec"),b.panOffset.x);a.addScaledVector(this.get("_3JScamera").up,-b.panOffset.y);g=g.sub(a).length();i.near=Math.max(g-
f/2,0.1);i.far=Math.max(g+f/2,0.2);i.aspect=c;i.updateProjectionMatrix()},GetOptimisedScaleForCurrentView:function(a,b){var c=this.get("_renderercache").cameras.defaultcamera,i=a?a:this.get("_context").clientWidth,f=b?b:this.get("_context").clientHeight,g=this.get("_3JSsceneBBoxFocus").max,e=this.get("_3JSsceneBBoxFocus").min,h=c.fieldOfView,j=i/f,l,n=new d.Vector3(Math.abs(g.x-e.x),Math.abs(g.y-e.y),Math.abs(g.z-e.z));l=Math.sqrt(n.x*n.x+n.y*n.y+n.z*n.z);var k=e.x-(e.x+g.x)/2,n=e.y-(e.y+g.y)/2,r=
e.z-(e.z+g.z)/2,m=g.x-(e.x+g.x)/2,p=g.y-(e.y+g.y)/2,g=g.z-(e.z+g.z)/2,s=z.radians(c.azimuthAngle),q=z.radians(-c.elevationAngle),e=new d.Matrix3;e.set(Math.cos(q)*Math.cos(s),-Math.sin(q),Math.cos(q)*-Math.sin(s),Math.sin(q)*Math.cos(s),Math.cos(q),Math.sin(q)*-Math.sin(s),Math.sin(s),0,Math.cos(s));var s=new d.Vector3(k,n,r),q=new d.Vector3(k,n,g),u=new d.Vector3(k,p,r),v=new d.Vector3(k,p,g),t=new d.Vector3(m,n,r),w=new d.Vector3(m,n,g),x=new d.Vector3(m,p,r),g=new d.Vector3(m,p,g);s.applyMatrix3(e);
q.applyMatrix3(e);u.applyMatrix3(e);v.applyMatrix3(e);t.applyMatrix3(e);w.applyMatrix3(e);x.applyMatrix3(e);g.applyMatrix3(e);k=Math.min(s.x,Math.min(q.x,Math.min(u.x,Math.min(v.x,Math.min(t.x,Math.min(w.x,Math.min(x.x,g.x)))))));n=Math.min(s.y,Math.min(q.y,Math.min(u.y,Math.min(v.y,Math.min(t.y,Math.min(w.y,Math.min(x.y,g.y)))))));r=Math.min(s.z,Math.min(q.z,Math.min(u.z,Math.min(v.z,Math.min(t.z,Math.min(w.z,Math.min(x.z,g.z)))))));m=Math.max(s.x,Math.max(q.x,Math.max(u.x,Math.max(v.x,Math.max(t.x,
Math.max(w.x,Math.max(x.x,g.x)))))));p=Math.max(s.y,Math.max(q.y,Math.max(u.y,Math.max(v.y,Math.max(t.y,Math.max(w.y,Math.max(x.y,g.y)))))));g=Math.max(s.z,Math.max(q.z,Math.max(u.z,Math.max(v.z,Math.max(t.z,Math.max(w.z,Math.max(x.z,g.z)))))));if("PERSPECTIVE"==c.cam_type)return i=j*h,n=new d.Vector3(Math.abs(m-k),Math.abs(p-n),Math.abs(g-r)),f=Math.abs(n.y/(2*Math.tan(z.radians(h)/2))),i=Math.abs(n.z/(2*Math.tan(z.radians(i)/2))),i=Math.max(i,f),i=0.5*Math.abs(m-k)+i,f=Math.min(h,j*h),Math.abs(l/
(2*Math.tan(z.radians(f)/2)))/(i-0.5*l);h=Math.abs(g-r)/i;j=Math.abs(p-n)/f;j=Math.max(h,j);h=j*i;j*=f;l=Math.max(l/i,l/f);return Math.max(l*i/h,l*f/j)},SetOptimisedViewRendering:function(a,b,c){this.set("_optimised_view",b);this.set("_optimised_view_border",a);this.CameraUpdate(c)},ComputeNewCamera:function(a,b,c,i,f,g,e,h,j,l){var n,k;k=Math.max(0.5*g+e/c,0.5*g);e=new d.Vector3(b.x,b.y,b.z);e.x+=k*Math.sin(Math.PI/2-z.radians(a.elevationAngle))*Math.cos(z.radians(a.azimuthAngle));e.z-=k*Math.sin(Math.PI/
2-z.radians(a.elevationAngle))*Math.sin(z.radians(a.azimuthAngle));e.y+=k*Math.cos(Math.PI/2-z.radians(a.elevationAngle));var r=new d.Vector3(b.x,b.y,b.z);r.sub(e);var m,p;p=90<=a.elevationAngle?a.elevationAngle=89.99:a.elevationAngle;m=new d.Vector3(0,0,0);m.x+=k*Math.sin(Math.PI/2-z.radians(p))*Math.cos(z.radians(a.azimuthAngle)-Math.PI/2);m.z-=k*Math.sin(Math.PI/2-z.radians(p))*Math.sin(z.radians(a.azimuthAngle)-Math.PI/2);m.normalize();r=r.cross(m).normalize();p=k-g/2;k+=g/2;g=Math.max(g/j,g/
l);j=g*j/c;c=g*l/c;"PERSPECTIVE"==a.cam_type?n=new d.PerspectiveCamera(a.fieldOfView,h,p,k):"ORTHOGRAPHIC"==a.cam_type&&(n=new d.OrthographicCamera(j/-2,j/2,c/2,c/-2,p,k));n.up=r;n.position.set(e.x,e.y,e.z);n.lookAt(b);this.set("_cameraleftdirvec",m);n.position.set(e.x,e.y,e.z);a.panOffset.x=i;a.panOffset.y=f;n.position.addScaledVector(m,-i);n.position.addScaledVector(r,f);return n},SetCamera:function(a,b,c){var i=this.get("_renderercache").cameras.defaultcamera,f=b?b:this.get("_context").clientWidth,
g=c?c:this.get("_context").clientHeight,e=a.max,h=a.min,j=new d.Vector3((h.x+e.x)/2,(h.y+e.y)/2,(h.z+e.z)/2),l=i.fieldOfView,n=f/g,b=i.scale=this.get("_optimised_view")?this.GetOptimisedScaleForCurrentView(b,c):i.scale,e=new d.Vector3(Math.abs(e.x-h.x),Math.abs(e.y-h.y),Math.abs(e.z-h.z)),e=Math.sqrt(e.x*e.x+e.y*e.y+e.z*e.z),l=Math.min(l,n*l),l=Math.abs(e/(2*Math.tan(z.radians(l)/2))),k;if(this.get("_optimised_view")){k=this.ComputeNewCamera(i,j,b,0,0,e,l,n,f,g);this.UpdateLabelsPositions(k,f,g);
var h=a.min.clone(),c=new d.Vector3(a.min.x,a.min.y,a.max.z),r=new d.Vector3(a.min.x,a.max.y,a.min.z),m=new d.Vector3(a.min.x,a.max.y,a.max.z),p=new d.Vector3(a.max.x,a.min.y,a.min.z),s=new d.Vector3(a.max.x,a.min.y,a.max.z),q=new d.Vector3(a.max.x,a.max.y,a.min.z),a=a.max.clone(),u=f/2-this.get("_optimised_view_border").x,v=g/2-this.get("_optimised_view_border").y,t=new d.Box2;t.expandByPoint(h.clone().project(k));t.expandByPoint(c.clone().project(k));t.expandByPoint(r.clone().project(k));t.expandByPoint(m.clone().project(k));
t.expandByPoint(p.clone().project(k));t.expandByPoint(s.clone().project(k));t.expandByPoint(q.clone().project(k));t.expandByPoint(a.clone().project(k));t.min.x*=f/2;t.min.y*=g/2;t.max.x*=f/2;t.max.y*=g/2;for(var w=t.min.x>=-u&&t.max.x<=u&&t.min.y>=-v&&t.max.y<=v,w=w&&this.RotateOutOfBoundsVisibleLabels(k,t,f,g,u,v),x=new d.Vector2(0,0),y=100;!w&&0.1<b;)k=new d.Vector2,t.size(k),k.x>u||k.y>v||!y?i.scale=b-=0.005:(k=t.center(),i.panOffset.x=x.x+=1.5*Math.sign(k.x),i.panOffset.y=x.y+=1.5*Math.sign(k.y),
y--),k=this.ComputeNewCamera(i,j,b,x.x,x.y,e,l,n,f,g),this.UpdateLabelsPositions(k,f,g),t.makeEmpty(),t.expandByPoint(h.clone().project(k)),t.expandByPoint(c.clone().project(k)),t.expandByPoint(r.clone().project(k)),t.expandByPoint(m.clone().project(k)),t.expandByPoint(p.clone().project(k)),t.expandByPoint(s.clone().project(k)),t.expandByPoint(q.clone().project(k)),t.expandByPoint(a.clone().project(k)),t.min.x*=f/2,t.min.y*=g/2,t.max.x*=f/2,t.max.y*=g/2,w=(w=t.min.x>=-u&&t.max.x<=u&&t.min.y>=-v&&
t.max.y<=v)&&this.RotateOutOfBoundsVisibleLabels(k,t,f,g,u,v)}else k=this.ComputeNewCamera(i,j,b,i.panOffset.x,i.panOffset.y,e,l,n,f,g),this.UpdateLabelsPositions(k,f,g);this.set("_3JScamera",k)},SetCameraFocus:function(a,b){for(var c=this.URLToKeyString(a),i=0,f=Object.keys(this.get("_renderercache").nodeviewproperties[c].threejsnodes),g=f.length;i<g;++i){for(var e=f[i],e=this.get("_renderercache").nodeviewproperties[c].threejsnodes[e],h=new d.Box3,j=0,l=Object.keys(e),n=l.length;j<n;j++){var k=
new d.Box3;k.setFromObject(e[l[j]]);k.empty()||h.union(k)}if(!h.empty()){this.set("_3JSsceneBBoxFocus",h);this.CameraUpdate(b);break}}},SetEnvironmentRotation:function(a,b){this.get("_renderercache").environment_settings.rotation=a.clone();this.ApplyFctToAllMaterials(this.UpdateMaterialEnvironmentRotation(this.get("_renderercache").environment_settings.rotation));(void 0===b||b)&&this.Render()},GetEnvironmentRotation:function(){return this.get("_renderercache").environment_settings.rotation.clone()},
UpdateMaterialEnvironmentRotation:function(a){var b=new d.Vector4(a.x,a.y,a.z,a.w),c=this;return function(i){if(i&&i.hasOwnProperty("uniforms")&&(i.uniforms.hasOwnProperty("envMapRotQuat")&&(i.uniforms.envMapRotQuat.value=b),i.uniforms.hasOwnProperty("lightPos")))for(var f=0;f<c.get("_renderercache").lights.holo_light.Lights.length&&4>f;++f){var g=c.get("_renderercache").lights.holo_light.Lights[f],g=new d.Vector3(g[0],g[1],g[2]);g.applyQuaternion(a);i.uniforms.lightPos.value[f]=g}}},FlipMaterialSide:function(a){return function(b){b&&
(b.flipped!=a&&(b.side!=d.DoubleSide&&(b.side=b.side==d.FrontSide?d.BackSide:d.FrontSide),b.hasOwnProperty("uniforms")&&b.uniforms.hasOwnProperty("isFloorReflection")&&(b.uniforms.isFloorReflection.value=d.FrontSide==a?0:1)),b.flipped=a)}},UpdateReflectionUniforms:function(a,b,c,d){this.get("_renderercache").materials.BackdropShaderMaterial.uniforms.reflection_opacity.value=void 0!==a?a:this.get("_renderercache").reflections.opacity;this.get("_renderercache").materials.BackdropShaderMaterial.uniforms.reflection_fade.value=
void 0!==b?b:this.get("_renderercache").reflections.fade;this.get("_renderercache").materials.BackdropShaderMaterial.uniforms.reflection_fade_position.value=void 0!==c?c:this.get("_renderercache").reflections.fade_position;this.get("_renderercache").materials.BackdropShaderMaterial.uniforms.reflection_fade_size.value=void 0!==d?d:this.get("_renderercache").reflections.fade_size;this.get("_renderercache").materials.ColorBlendShaderMaterial.uniforms.reflection_opacity.value=void 0!==a?a:this.get("_renderercache").reflections.opacity;
this.get("_renderercache").materials.ColorBlendShaderMaterial.uniforms.reflection_fade.value=void 0!==b?b:this.get("_renderercache").reflections.fade;this.get("_renderercache").materials.ColorBlendShaderMaterial.uniforms.reflection_fade_position.value=void 0!==c?c:this.get("_renderercache").reflections.fade_position;this.get("_renderercache").materials.ColorBlendShaderMaterial.uniforms.reflection_fade_size.value=void 0!==d?d:this.get("_renderercache").reflections.fade_size;this.get("_renderercache").materials.CopyShaderMaterial.uniforms.reflection_opacity.value=
void 0!==a?a:this.get("_renderercache").reflections.opacity;this.get("_renderercache").materials.CopyShaderMaterial.uniforms.reflection_fade.value=void 0!==b?b:this.get("_renderercache").reflections.fade;this.get("_renderercache").materials.CopyShaderMaterial.uniforms.reflection_fade_position.value=void 0!==c?c:this.get("_renderercache").reflections.fade_position;this.get("_renderercache").materials.CopyShaderMaterial.uniforms.reflection_fade_size.value=void 0!==d?d:this.get("_renderercache").reflections.fade_size},
IsReflectionsRenderingEnabled:function(){return this.get("_SceneLoaded")&&this.get("_3JSsceneBBox").min.y<this.get("_3JScamera").position.y&&("JSON"==this.get("_reflection_config")&&this.get("_renderercache").reflections.enabled||"ON"==this.get("_reflection_config"))},FlipScene:function(a){a.applyMatrix(this.get("_reflection_Y_scale"));a.applyMatrix(this.get("_reflection_Y_translation"))},UnflipScene:function(a){a.applyMatrix(this.get("_reflection_Y_opp_translation"));a.applyMatrix(this.get("_reflection_Y_scale"))},
FlipAllScenes:function(){this.FlipScene(this.get("_3JSsceneOp"));this.FlipScene(this.get("_3JSsceneOpDepth"));this.FlipScene(this.get("_3JSsceneOpaqueDiffuse"));for(var a=0;a<this.get("_3JSsceneOpCoincidentGroupsPasses").length;++a){var b=this.get("_3JSsceneOpCoincidentGroupsPasses")[a];this.FlipScene(this.get("_3JSsceneOpCoincidentGroups")[b]);this.FlipScene(this.get("_3JSsceneOpCoincidentGroupsDepth")[b]);this.FlipScene(this.get("_3JSsceneOpCoincidentGroupsDiffuse")[b])}this.FlipScene(this.get("_3JSsceneTransp"));
this.FlipScene(this.get("_3JSsceneTranspDepth"));this.FlipScene(this.get("_3JSsceneTranspDiffuse"));for(a=0;a<this.get("_3JSsceneTranspCoincidentGroupsPasses").length;++a)b=this.get("_3JSsceneTranspCoincidentGroupsPasses")[a],this.FlipScene(this.get("_3JSsceneTranspCoincidentGroups")[b]),this.FlipScene(this.get("_3JSsceneTranspCoincidentGroupsDiffuse")[b]),this.FlipScene(this.get("_3JSsceneTranspCoincidentGroupsDepth")[b])},UnFlipAllScenes:function(){this.UnflipScene(this.get("_3JSsceneOp"));this.UnflipScene(this.get("_3JSsceneOpDepth"));
this.UnflipScene(this.get("_3JSsceneOpaqueDiffuse"));for(var a=0;a<this.get("_3JSsceneOpCoincidentGroupsPasses").length;++a){var b=this.get("_3JSsceneOpCoincidentGroupsPasses")[a];this.UnflipScene(this.get("_3JSsceneOpCoincidentGroups")[b]);this.UnflipScene(this.get("_3JSsceneOpCoincidentGroupsDepth")[b]);this.UnflipScene(this.get("_3JSsceneOpCoincidentGroupsDiffuse")[b])}this.UnflipScene(this.get("_3JSsceneTransp"));this.UnflipScene(this.get("_3JSsceneTranspDepth"));this.UnflipScene(this.get("_3JSsceneTranspDiffuse"));
for(a=0;a<this.get("_3JSsceneTranspCoincidentGroupsPasses").length;++a)b=this.get("_3JSsceneTranspCoincidentGroupsPasses")[a],this.UnflipScene(this.get("_3JSsceneTranspCoincidentGroups")[b]),this.UnflipScene(this.get("_3JSsceneTranspCoincidentGroupsDiffuse")[b]),this.UnflipScene(this.get("_3JSsceneTranspCoincidentGroupsDepth")[b])},FlipOpaqueScene:function(){this.FlipScene(this.get("_3JSsceneOp"));for(var a=0;a<this.get("_3JSsceneOpCoincidentGroupsPasses").length;++a){var b=this.get("_3JSsceneOpCoincidentGroupsPasses")[a];
this.FlipScene(this.get("_3JSsceneOpCoincidentGroups")[b])}},UnFlipOpaqueScene:function(){this.UnflipScene(this.get("_3JSsceneOp"));for(var a=0;a<this.get("_3JSsceneOpCoincidentGroupsPasses").length;++a){var b=this.get("_3JSsceneOpCoincidentGroupsPasses")[a];this.UnflipScene(this.get("_3JSsceneOpCoincidentGroups")[b])}},FlipTransparentScene:function(){this.FlipScene(this.get("_3JSsceneTransp"));for(var a=0;a<this.get("_3JSsceneTranspCoincidentGroupsPasses").length;++a){var b=this.get("_3JSsceneTranspCoincidentGroupsPasses")[a];
this.FlipScene(this.get("_3JSsceneTranspCoincidentGroups")[b])}},UnFlipTransparentScene:function(){this.UnflipScene(this.get("_3JSsceneTransp"));for(var a=0;a<this.get("_3JSsceneTranspCoincidentGroupsPasses").length;++a){var b=this.get("_3JSsceneTranspCoincidentGroupsPasses")[a];this.UnflipScene(this.get("_3JSsceneTranspCoincidentGroups")[b])}},FlipLights:function(){for(var a=0,b=Object.keys(this.get("_renderercache").lights.dir_light),c=b.length;a<c;++a){var d=this.get("_renderercache").lights.dir_light[b[a]];
d&&(d.position.set(-d.position.x,d.position.y,-d.position.z),d.needsUpdate=!0)}},UnFlipLights:function(){this.FlipLights()},RenderScene:function(a,b){this.get("_3JSrenderer").render(a,this.get("_3JScamera"),b)},RenderOpaqueScene:function(a){this.RenderScene(this.get("_3JSsceneOp"),a);var b=function(a){return function(b){b instanceof d.Mesh&&b.material&&(b.material.depthWrite=a)}};this.get("_3JSrenderer").autoClear=!1;for(var c=0;c<this.get("_3JSsceneOpCoincidentGroupsPasses").length;++c){var i=this.get("_3JSsceneOpCoincidentGroupsPasses")[c];
this.get("_3JSsceneOpCoincidentGroups")[i].traverse(b(!1));this.RenderScene(this.get("_3JSsceneOpCoincidentGroups")[i],a);this.get("_3JSrenderer").context.colorMask(!1,!1,!1,!1);this.get("_3JSsceneOpCoincidentGroups")[i].traverse(b(!0));this.RenderScene(this.get("_3JSsceneOpCoincidentGroups")[i],a);this.get("_3JSrenderer").context.colorMask(!0,!0,!0,!0)}this.get("_3JSrenderer").autoClear=!0},RenderOpaqueSceneDepth:function(a,b){this.get("_3JSsceneOpDepth").overrideMaterial=b?b:this.get("_renderercache").materials.D0ShaderMaterial;
this.RenderScene(this.get("_3JSsceneOpDepth"),a);this.get("_3JSrenderer").autoClear=!1;for(var c=0;c<this.get("_3JSsceneOpCoincidentGroupsPasses").length;++c){var d=this.get("_3JSsceneOpCoincidentGroupsPasses")[c];this.get("_3JSsceneOpCoincidentGroupsDepth")[d].overrideMaterial=b?b:this.get("_renderercache").materials.D0ShaderMaterial;this.RenderScene(this.get("_3JSsceneOpCoincidentGroupsDepth")[d],a)}this.get("_3JSrenderer").autoClear=!0},RenderOpaqueSceneDiffuse:function(a){this.RenderScene(this.get("_3JSsceneOpaqueDiffuse"),
a);var b=function(a){return function(b){b instanceof d.Mesh&&b.material&&(b.material.depthWrite=a)}};this.get("_3JSrenderer").autoClear=!1;for(var c=0;c<this.get("_3JSsceneOpCoincidentGroupsPasses").length;++c){var i=this.get("_3JSsceneOpCoincidentGroupsPasses")[c];this.get("_3JSsceneOpCoincidentGroupsDiffuse")[i].traverse(b(!1));this.RenderScene(this.get("_3JSsceneOpCoincidentGroupsDiffuse")[i],a);this.get("_3JSrenderer").context.colorMask(!1,!1,!1,!1);this.get("_3JSsceneOpCoincidentGroupsDiffuse")[i].traverse(b(!0));
this.RenderScene(this.get("_3JSsceneOpCoincidentGroupsDiffuse")[i],a);this.get("_3JSrenderer").context.colorMask(!0,!0,!0,!0)}this.get("_3JSrenderer").autoClear=!0},RenderTransparentScene:function(a,b){"function"===typeof b&&this.get("_3JSsceneTransp").traverse(b);this.RenderScene(this.get("_3JSsceneTransp"),a);var c=function(a){return function(b){b instanceof d.Mesh&&b.material&&(b.material.depthWrite=a)}};this.get("_3JSrenderer").autoClear=!1;for(var i=0;i<this.get("_3JSsceneTranspCoincidentGroupsPasses").length;++i){var f=
this.get("_3JSsceneTranspCoincidentGroupsPasses")[i];this.get("_3JSsceneTranspCoincidentGroups")[f].traverse(b);this.get("_3JSsceneTranspCoincidentGroups")[f].traverse(c(!1));this.RenderScene(this.get("_3JSsceneTranspCoincidentGroups")[f],a);this.get("_3JSrenderer").context.colorMask(!1,!1,!1,!1);this.get("_3JSsceneTranspCoincidentGroups")[f].traverse(c(!0));this.RenderScene(this.get("_3JSsceneTranspCoincidentGroups")[f],a);this.get("_3JSrenderer").context.colorMask(!0,!0,!0,!0)}this.get("_3JSrenderer").autoClear=
!0},RenderTransparentSceneDepth:function(a,b){this.get("_3JSsceneTranspDepth").overrideMaterial=b;this.RenderScene(this.get("_3JSsceneTranspDepth"),a);this.get("_3JSsceneTranspDepth").overrideMaterial=null;this.get("_3JSrenderer").autoClear=!1;for(var c=0;c<this.get("_3JSsceneTranspCoincidentGroupsPasses").length;++c){var d=this.get("_3JSsceneTranspCoincidentGroupsPasses")[c];this.get("_3JSsceneTranspCoincidentGroupsDepth")[d].overrideMaterial=b;this.RenderScene(this.get("_3JSsceneTranspCoincidentGroupsDepth")[d],
a);this.get("_3JSsceneTranspCoincidentGroupsDepth")[d].overrideMaterial=null}this.get("_3JSrenderer").autoClear=!0},RenderTransparentSceneDiffuse:function(a,b){this.get("_3JSsceneTranspDiffuse").traverse(b);this.RenderScene(this.get("_3JSsceneTranspDiffuse"),a);var c=function(a){return function(b){b instanceof d.Mesh&&b.material&&(b.material.depthWrite=a)}};this.get("_3JSrenderer").autoClear=!1;for(var i=0;i<this.get("_3JSsceneTranspCoincidentGroupsPasses").length;++i){var f=this.get("_3JSsceneTranspCoincidentGroupsPasses")[i];
this.get("_3JSsceneTranspCoincidentGroupsDiffuse")[f].traverse(b);this.get("_3JSsceneTranspCoincidentGroupsDiffuse")[f].traverse(c(!1));this.RenderScene(this.get("_3JSsceneTranspCoincidentGroupsDiffuse")[f],a);this.get("_3JSrenderer").context.colorMask(!1,!1,!1,!1);this.get("_3JSsceneTranspCoincidentGroupsDiffuse")[f].traverse(c(!0));this.RenderScene(this.get("_3JSsceneTranspCoincidentGroupsDiffuse")[f],a);this.get("_3JSrenderer").context.colorMask(!0,!0,!0,!0)}this.get("_3JSrenderer").autoClear=
!0},SetSizeOfRTSrc:function(a,b){return function(c){c instanceof d.Mesh&&c.material.hasOwnProperty("uniforms")&&c.material.uniforms.hasOwnProperty("canvas_size")&&(c.material.uniforms.canvas_size.value=new d.Vector2(a,b))}},SetAsRTSrc:function(a,b,c,i){var f=Math.max(arguments.length-2,0),g=this;return function(e){e instanceof d.Mesh&&e.material.hasOwnProperty("uniforms")&&(e.material.uniforms.hasOwnProperty("DX1RT")&&(e.material.uniforms.hasOwnProperty("DX2RT")&&e.material.uniforms.hasOwnProperty("NBRTSRC")&&
e.material.uniforms.hasOwnProperty("canvas_size"))&&(e.material.uniforms.canvas_size.value=new d.Vector2(a,b),e.material.uniforms.DX1RT.value=c?c.texture:g.get("_DummyTexture"),e.material.uniforms.DX2RT.value=i?i.texture:g.get("_DummyTexture"),e.material.uniforms.NBRTSRC.value=f),e.material.uniforms.hasOwnProperty("transparent")&&(e.material.uniforms.transparent.value=c?1:0))}},RenderDepthPeel:function(a,b,c,i,f,g,e,h,j,l,n,k,r,m){this.get("_3JSrenderer").setClearColor(r,1);this.RenderOpaqueSceneDepth(h);
this.get("_3JSrenderer").autoClearDepth=!0;this.get("_renderercache").materials.DepthOnlyShaderMaterial.uniforms.DX1RT.value=h.texture;this.get("_renderercache").materials.DepthOnlyShaderMaterial.uniforms.NBRTSRC.value=1;this.RenderTransparentSceneDepth(g,this.get("_renderercache").materials.DepthOnlyShaderMaterial);this.get("_3JSrenderer").autoClearDepth=!1;this.get("_3JSrenderer").setClearColor(r,1);this.RenderTransparentScene(g,this.SetAsRTSrc(i,f,h));this.get("_3JSrenderer").autoClearDepth=!0;
this.RenderTransparentSceneDepth(e,this.get("_renderercache").materials.DepthOnlyShaderMaterial);this.get("_3JSrenderer").autoClearDepth=!1;this.get("_3JSrenderer").setClearColor(m,1);this.RenderTransparentSceneDiffuse(e,this.SetAsRTSrc(i,f,h));this.get("_3JSrenderer").autoClearDepth=!0;if(1<this.get("_current_nb_peels")&&this.get("_SceneLoaded")){this.get("_3JSrenderer").setClearColor(r,1);this.get("_renderercache").materials.D1ShaderMaterial.uniforms.D0RT.value=h.texture;this.RenderTransparentSceneDepth(j,
this.get("_renderercache").materials.D1ShaderMaterial);this.get("_renderercache").materials.D2ShaderMaterial.uniforms.DX1RT.value=h.texture;this.get("_3JSrenderer").setClearColor(r,1);for(var p=0;p<this.get("_current_nb_peels")-1;++p){this.get("_3JSrenderer").autoClearDepth=!0;this.get("_3JSrenderer").autoClearColor=!0;this.get("_renderercache").materials.DepthOnlyShaderMaterial.uniforms.DX2RT.value=p%2?l.texture:j.texture;this.get("_renderercache").materials.DepthOnlyShaderMaterial.uniforms.NBRTSRC.value=
2;this.RenderTransparentSceneDepth(n,this.get("_renderercache").materials.DepthOnlyShaderMaterial);this.get("_3JSrenderer").autoClearDepth=!1;this.RenderTransparentScene(n,this.SetAsRTSrc(i,f,h,p%2?l:j));this.get("_3JSrenderer").autoClearDepth=!0;this.get("_3JSrenderer").autoClearColor=!1;this.get("_renderercache").materials.ColorBlendShaderMaterial.uniforms.CX1RT.value=n.texture;this.get("_renderercache").materials.ColorBlendShaderMaterial.uniforms.TransparencyStack.value=e.texture;this.get("_renderercache").materials.ColorBlendShaderMaterial.uniforms.EnableBGBlend.value=
0;var s=new d.Mesh(c,this.get("_renderercache").materials.ColorBlendShaderMaterial),q=new d.Scene;q.add(s);this.get("_3JSrenderer").render(q,b,g);this.get("_3JSrenderer").autoClearColor=!0;this.get("_3JSrenderer").autoClearDepth=!0;this.get("_3JSrenderer").autoClearColor=!1;this.RenderTransparentSceneDepth(e,this.get("_renderercache").materials.DepthOnlyShaderMaterial);this.get("_3JSrenderer").autoClearDepth=!1;this.get("_3JSrenderer").autoClearColor=!1;this.RenderTransparentSceneDiffuse(e,this.SetAsRTSrc(i,
f,h,p%2?l:j));this.get("_3JSrenderer").autoClearColor=!0;this.get("_3JSrenderer").autoClearDepth=!0;this.get("_renderercache").materials.D2ShaderMaterial.uniforms.DX2RT.value=p%2?l.texture:j.texture;this.RenderTransparentSceneDepth(p%2?j:l,this.get("_renderercache").materials.D2ShaderMaterial)}}this.get("_3JSrenderer").setClearColor(r,1);this.RenderOpaqueScene(n);a&&(this.get("_3JSrenderer").autoClear=!1,this.get("_3JSrenderer").render(this.get("_3JSsceneHightlights"),this.get("_3JScamera"),n),this.get("_3JSrenderer").autoClear=
!0);this.get("_3JSrenderer").setClearColor(m,1);this.RenderOpaqueSceneDiffuse(k);a&&(this.get("_3JSrenderer").autoClear=!1,this.get("_3JSsceneHightlights").overrideMaterial=this.get("_renderercache").materials.blackhighlight,this.get("_3JSrenderer").render(this.get("_3JSsceneHightlights"),this.get("_3JScamera"),k),this.get("_3JSsceneHightlights").overrideMaterial=null,this.get("_3JSrenderer").autoClear=!0)},Render:function(a,b,c){if(!this.get("_emptyOpaqueScene")||!this.get("_emptyTransparentScene")){b=
b?b:this.get("_context").clientWidth;c=c?c:this.get("_context").clientHeight;if(a||this.get("_resetRenderTarget"))this.InitializeRenderTargets(b,c),this.CameraUpdate(!1,b,c),this.set("_3JSHUDcamera",new d.OrthographicCamera(-b/2,b/2,c/2,-c/2,0,10)),this.set("_resetRenderTarget",!1);this.get("_renderercache");var i=this.get("_renderercache").materials.enablehighlights,f=this.get("_renderercache").materials.enablehardedgehighlights,g=this.get("_renderercache").materials.enablehorizonhighlights,e=this.get("_renderercache").labels.visible,
h=this.get("_ColorStackRT"),j=new d.OrthographicCamera(-b/2,b/2,c/2,-c/2,-1E5,1E5);j.position.z=1E4;var l=new d.PlaneGeometry(b,c),n,k,r,m,p;if(this.get("_renderercache").textures[this.get("_RenderingQuality")].backdrop.loaded&&this.get("_renderercache").textures[this.get("_RenderingQuality")].backdrop.enabled){n=this.get("_renderercache").textures[this.get("_RenderingQuality")].backdrop.data;m=this.get("_renderercache").textures[this.get("_RenderingQuality")].backdrop.original_width;p=this.get("_renderercache").textures[this.get("_RenderingQuality")].backdrop.original_height;
var s=n.image.naturalWidth,q=n.image.naturalHeight;m||(m=s);p||(p=q);var u=b/c,v=s/p;r=k=1;u<v?k=u/v:r=v/u;k*=m/s;r*=p/q;m=-0.5*k+0.5*m/s;p=-0.5*r+0.5*p/q}aa.Update();q=aa.GetCountPerMinute();q!=this.get("_current_fps")&&(w.Log("Average framerate: "+q),this.set("_current_fps",q));if(!this.get("_emptyTransparentScene")&&"Visualizer"==this.get("_RenderingQuality")){this.get("_interactiveFrameRate")&&this.get("_enableInteractionOptimization")?(q>this.get("_target_fps_max")?this.set("_current_nb_peels",
this.get("_current_nb_peels")+1):q<this.get("_target_fps_min")&&this.set("_current_nb_peels",this.get("_current_nb_peels")-1),this.set("_current_nb_peels",Math.max(Math.min(this.get("_current_nb_peels"),this.get("_nb_max_peels")),this.get("_nb_min_peels")))):this.set("_current_nb_peels",this.get("_nb_max_peels"));var q=this.get("_OpaqueDepthRT"),t=this.get("_D1RT"),y=this.get("_D2RT"),s=this.get("_PeelColorRT"),u=this.get("_TransparencyStackRT"),v=this.get("_OpaqueBackgroundMaskRT"),x=this.get("_MirrorColorStackRT"),
z=this.get("_MirrorColorStackRT2"),A=this.get("_MirrorOpaqueDepthRT"),C=this.get("_MirrorPeelColorRT"),D=this.get("_MirrorTransparencyStackRT");this.get("_FadedMirrorTransparencyStackRT");var E=this.get("_MirrorOpaqueBackgroundMaskRT");this.get("_3JSsceneOp").traverse(this.SetSizeOfRTSrc(b,c));this.get("_3JSsceneTransp").traverse(this.SetSizeOfRTSrc(b,c));this.get("_3JSsceneTranspDepth").traverse(this.SetSizeOfRTSrc(b,c));this.get("_3JSsceneTranspDiffuse").traverse(this.SetSizeOfRTSrc(b,c));this.get("_3JSsceneOpaqueDiffuse").traverse(this.SetSizeOfRTSrc(b,
c));this.get("_3JSrenderer").autoClear=!0;var F=new d.Color(1,1,1),G=new d.Color(0,0,0),H=this.get("_backgroundColor"),I=this.get("_backgroundAlpha");this.get("_renderercache").materials.CopyShaderMaterial.uniforms.canvas_size.value=new d.Vector2(b,c);this.get("_renderercache").materials.ColorBlendShaderMaterial.uniforms.canvas_size.value=new d.Vector2(b,c);this.get("_renderercache").materials.ColorBlendShaderMaterial.uniforms.EnableBGBlend.value=0;this.get("_renderercache").materials.ColorBlendShaderMaterial.uniforms.EnableBackdrop.value=
0;this.get("_renderercache").materials.ColorBlendShaderMaterial.uniforms.Backdrop.value=this.get("_DummyTexture");this.get("_renderercache").materials.ColorBlendShaderMaterial.uniforms.CX1RT.value=this.get("_DummyTexture");this.get("_renderercache").materials.ColorBlendShaderMaterial.uniforms.TransparencyStack.value=this.get("_DummyTexture");this.get("_renderercache").materials.ColorBlendShaderMaterial.uniforms.OpaqueRT.value=this.get("_DummyTexture");this.get("_renderercache").materials.ColorBlendShaderMaterial.uniforms.ColorStackRT.value=
this.get("_DummyTexture");this.get("_renderercache").materials.DepthOnlyShaderMaterial.uniforms.canvas_size.value=new d.Vector2(b,c);this.get("_renderercache").materials.D1ShaderMaterial.uniforms.canvas_size.value=new d.Vector2(b,c);this.get("_renderercache").materials.D2ShaderMaterial.uniforms.canvas_size.value=new d.Vector2(b,c);this.IsReflectionsRenderingEnabled()&&(this.FlipAllScenes(),this.ApplyFctToAllMaterials(this.FlipMaterialSide(d.BackSide)),this.FlipLights(),this.RenderDepthPeel(!1,j,l,
b,c,x,D,A,t,y,C,E,G,F),this.UnFlipAllScenes(),this.ApplyFctToAllMaterials(this.FlipMaterialSide(d.FrontSide)),this.UnFlipLights());this.RenderDepthPeel(i&&f,j,l,b,c,h,u,q,t,y,s,v,G,F);this.get("_3JSrenderer").getContext().colorMask(!1,!1,!1,!0);this.get("_3JSrenderer").setClearColor(G,0);this.get("_3JSrenderer").clearTarget(h,!0,!1,!1);this.get("_3JSrenderer").getContext().colorMask(!0,!0,!0,!0);this.get("_3JSrenderer").setClearColor(G,1);this.get("_3JSrenderer").autoClearColor=!1;t=new d.Mesh(l,
this.get("_renderercache").materials.ColorBlendShaderMaterial);f=new d.Scene;f.add(t);this.get("_renderercache").materials.ColorBlendShaderMaterial.uniforms.EnableBGBlend.value=1;this.get("_renderercache").materials.ColorBlendShaderMaterial.uniforms.BGColor.value=H;this.get("_renderercache").materials.ColorBlendShaderMaterial.uniforms.BGAlpha.value=I;this.get("_renderercache").materials.ColorBlendShaderMaterial.uniforms.Backdrop.value=n;this.get("_renderercache").materials.ColorBlendShaderMaterial.uniforms.EnableBackdrop.value=
n?1:0;this.get("_renderercache").materials.ColorBlendShaderMaterial.uniforms.EnableBackdropAlpha.value=n?0:1;this.get("_renderercache").materials.ColorBlendShaderMaterial.uniforms.Backdrop_scale.value=new d.Vector2(k,r);this.get("_renderercache").materials.ColorBlendShaderMaterial.uniforms.Backdrop_offset.value=new d.Vector2(m,p);this.IsReflectionsRenderingEnabled()?(this.get("_3JSrenderer").autoClearColor=!0,this.get("_3JSrenderer").setClearColor(G,0),n=new d.Mesh(l,this.get("_renderercache").materials.CopyShaderMaterial),
k=new d.Scene,k.add(n),this.get("_renderercache").materials.ColorBlendShaderMaterial.uniforms.EnableMirror.value=1,this.get("_renderercache").materials.ColorBlendShaderMaterial.uniforms.CX1RT.value=C.texture,this.get("_renderercache").materials.ColorBlendShaderMaterial.uniforms.TransparencyStack.value=D.texture,this.get("_renderercache").materials.ColorBlendShaderMaterial.uniforms.OpaqueRT.value=E.texture,this.get("_renderercache").materials.ColorBlendShaderMaterial.uniforms.ColorStackRT.value=x.texture,
this.get("_3JSrenderer").render(f,j,z),this.get("_renderercache").materials.ColorBlendShaderMaterial.uniforms.EnableMirror.value=0,this.get("_renderercache").materials.ColorBlendShaderMaterial.uniforms.EnableBackdrop.value=1,this.get("_renderercache").materials.ColorBlendShaderMaterial.uniforms.EnableBackdropAlpha.value=1,this.get("_renderercache").materials.ColorBlendShaderMaterial.uniforms.Backdrop_scale.value=new d.Vector2(1,1),this.get("_renderercache").materials.ColorBlendShaderMaterial.uniforms.Backdrop_offset.value=
new d.Vector2(0,0),this.get("_renderercache").materials.ColorBlendShaderMaterial.uniforms.Backdrop.value=z.texture,this.get("_renderercache").materials.ColorBlendShaderMaterial.uniforms.CX1RT.value=s.texture,this.get("_renderercache").materials.ColorBlendShaderMaterial.uniforms.TransparencyStack.value=u.texture,this.get("_renderercache").materials.ColorBlendShaderMaterial.uniforms.OpaqueRT.value=v.texture,this.get("_renderercache").materials.ColorBlendShaderMaterial.uniforms.ColorStackRT.value=h.texture,
this.get("_3JSrenderer").render(f,j,x),this.get("_renderercache").materials.ColorBlendShaderMaterial.uniforms.EnableMirror.value=0):(this.get("_3JSrenderer").autoClearColor=!0,this.get("_3JSrenderer").setClearColor(G,0),this.get("_renderercache").materials.ColorBlendShaderMaterial.uniforms.EnableMirror.value=0,this.get("_renderercache").materials.ColorBlendShaderMaterial.uniforms.CX1RT.value=s.texture,this.get("_renderercache").materials.ColorBlendShaderMaterial.uniforms.TransparencyStack.value=u.texture,
this.get("_renderercache").materials.ColorBlendShaderMaterial.uniforms.OpaqueRT.value=v.texture,this.get("_renderercache").materials.ColorBlendShaderMaterial.uniforms.ColorStackRT.value=h.texture,this.get("_3JSrenderer").render(f,j,x));this.get("_3JSrenderer").autoClearColor=!0;if(i&&g||e)this.get("_3JSrenderer").clear(!1,!0,!1),i&&g&&(this.get("_3JSrenderer").autoClear=!0,this.get("_3JSrenderer").setClearColor(K,0),this.RenderOpaqueSceneDepth(q,this.get("_renderercache").materials.colordepth),this.get("_3JSrenderer").autoClear=
!1,this.RenderTransparentSceneDepth(q,this.get("_renderercache").materials.colordepth),this.get("_3JSrenderer").autoClear=!1,this.get("_renderercache").materials.edge.uniforms.canvas_size.value=new d.Vector2(b,c),this.get("_renderercache").materials.edge.uniforms.depth_texture.value=q.texture,this.RenderOpaqueSceneDepth(x,this.get("_renderercache").materials.edge),this.get("_3JSrenderer").autoClear=!1,this.RenderTransparentSceneDepth(x,this.get("_renderercache").materials.edge),this.get("_3JSrenderer").autoClear=
!1),e&&(this.get("_3JSrenderer").autoClear=!1,this.get("_3JSrenderer").render(this.get("_3JSsceneLabels"),this.get("_3JSHUDcamera"),x)),this.get("_3JSrenderer").autoClear=!0;a||(this.get("_3JSrenderer").setClearColor(G,0),this.get("_renderercache").materials.CopyShaderMaterial.transparent=!0,this.get("_renderercache").materials.CopyShaderMaterial.blending=d.AdditiveBlending,this.get("_renderercache").materials.CopyShaderMaterial.uniforms.canvas_size.value=new d.Vector2(b,c),this.get("_renderercache").materials.CopyShaderMaterial.uniforms.CXRT.value=
x.texture,this.get("_renderercache").materials.CopyShaderMaterial.uniforms.OpaqueRT.value=this.get("_DummyTexture"),this.get("_renderercache").materials.CopyShaderMaterial.uniforms.EnableMask.value=0,this.get("_renderercache").materials.CopyShaderMaterial.uniforms.EnableRefOpacity.value=0,this.get("_renderercache").materials.CopyShaderMaterial.uniforms.EnableInvRefOpacity.value=0,n=new d.Mesh(l,this.get("_renderercache").materials.CopyShaderMaterial),k=new d.Scene,k.add(n),this.get("_3JSrenderer").render(k,
j,null));this.get("_3JSrenderer").autoClear=!1}else{q=null;if(this.IsReflectionsRenderingEnabled()){var q=this.get("_PeelColorRT"),K=new d.Color(0,0,0);this.get("_3JSrenderer").setClearColor(K,1);this.FlipOpaqueScene();this.FlipTransparentScene();this.ApplyFctToAllMaterials(this.FlipMaterialSide(d.BackSide));this.FlipLights();this.RenderOpaqueScene(q,!0);this.get("_3JSrenderer").autoClear=!1;this.RenderTransparentScene(q,!0);this.UnFlipOpaqueScene();this.UnFlipTransparentScene();this.ApplyFctToAllMaterials(this.FlipMaterialSide(d.FrontSide));
this.UnFlipLights()}n?(this.get("_renderercache").materials.BackdropShaderMaterial.uniforms.canvas_size.value=new d.Vector2(b,c),this.get("_renderercache").materials.BackdropShaderMaterial.uniforms.backdrop.value=n,this.get("_renderercache").materials.BackdropShaderMaterial.uniforms.backdrop_enabled.value=1,this.get("_renderercache").materials.BackdropShaderMaterial.uniforms.backdrop_scale.value=new d.Vector2(k,r),this.get("_renderercache").materials.BackdropShaderMaterial.uniforms.backdrop_offset.value=
new d.Vector2(m,p),this.get("_renderercache").materials.BackdropShaderMaterial.uniforms.reflection.value=q,this.get("_renderercache").materials.BackdropShaderMaterial.uniforms.reflection_enabled.value=this.IsReflectionsRenderingEnabled()?1:0,K=new d.Mesh(l,this.get("_renderercache").materials.BackdropShaderMaterial),l=new d.Scene,l.add(K),this.get("_3JSrenderer").render(l,j,a?h:null),this.get("_3JSrenderer").autoClear=!1):this.IsReflectionsRenderingEnabled()?(this.get("_3JSrenderer").setClearColor(this.get("_backgroundColor"),
this.get("_backgroundAlpha")),this.get("_renderercache").materials.BackdropShaderMaterial.uniforms.canvas_size.value=new d.Vector2(b,c),this.get("_renderercache").materials.BackdropShaderMaterial.uniforms.backdrop.value=this.get("_DummyTexture"),this.get("_renderercache").materials.BackdropShaderMaterial.uniforms.backdrop_enabled.value=0,this.get("_renderercache").materials.BackdropShaderMaterial.uniforms.reflection.value=q.texture,this.get("_renderercache").materials.BackdropShaderMaterial.uniforms.reflection_enabled.value=
1,this.get("_renderercache").materials.BackdropShaderMaterial.uniforms.default_bg_color.value=new d.Vector4(this.get("_backgroundColor").r,this.get("_backgroundColor").g,this.get("_backgroundColor").b,this.get("_backgroundAlpha")),K=new d.Mesh(l,this.get("_renderercache").materials.BackdropShaderMaterial),l=new d.Scene,l.add(K),this.get("_3JSrenderer").render(l,j,a?h:null),this.get("_3JSrenderer").autoClear=!1):(this.get("_3JSrenderer").setClearColor(this.get("_backgroundColor"),this.get("_backgroundAlpha")),
this.get("_3JSrenderer").autoClear=!0);this.RenderOpaqueScene(a?h:null);this.get("_3JSrenderer").autoClear=!1;this.RenderTransparentScene(a?h:null);this.get("_3JSrenderer").autoClear=!1;i&&(g&&(this.get("_3JSrenderer").autoClear=!0,q=this.get("_OpaqueDepthRT"),this.get("_3JSrenderer").setClearColor(G,0),this.RenderOpaqueSceneDepth(q,this.get("_renderercache").materials.colordepth),this.get("_3JSrenderer").autoClear=!1,this.RenderTransparentSceneDepth(q,this.get("_renderercache").materials.colordepth),
this.get("_3JSrenderer").autoClear=!1,this.get("_renderercache").materials.edge.uniforms.canvas_size.value=new d.Vector2(b,c),this.get("_renderercache").materials.edge.uniforms.depth_texture.value=q.texture,this.RenderOpaqueSceneDepth(a?h:null,this.get("_renderercache").materials.edge),this.get("_3JSrenderer").autoClear=!1,this.RenderTransparentSceneDepth(a?h:null,this.get("_renderercache").materials.edge),this.get("_3JSrenderer").autoClear=!1),f&&this.get("_3JSrenderer").render(this.get("_3JSsceneHightlights"),
this.get("_3JScamera"),a?h:null));e&&this.get("_3JSrenderer").render(this.get("_3JSsceneLabels"),this.get("_3JSHUDcamera"),a?h:null)}this.get("_3JSrenderer").autoClear=!0;a&&this.set("_resetRenderTarget",!0)}},StartInteractiveFramerate:function(){this.set("_interactiveFrameRate",!0);this.set("_current_nb_peels",this.get("_nb_min_peels"))},EndInteractiveFramerate:function(a){this.set("_interactiveFrameRate",!1);(void 0===a||a)&&this.Render()},Animate:function(){w.Log("View Animate function");var a=
this,b=function(){if(a.get("_enableAnimations")){requestAnimationFrame(b);var c=a.get("_renderercache").cameras.defaultcamera;c.azimuthAngle=(c.azimuthAngle+0.1+180)%360-180;a.CameraUpdate();a.Render()}};b()},Resize:function(a,b,c){var i=this;this.get("_build_scene_exec_queue").whenFinished(function(){var a=b?b:i.get("_context").clientWidth,g=c?c:i.get("_context").clientHeight;i.get("_3JSrenderer").setSize(a,g);i.set("_3JSHUDcamera",new d.OrthographicCamera(-a/2,a/2,g/2,-g/2,0,10));i.InitializeRenderTargets();
i.CameraUpdate(!0,b,c)})},UpdatePolygonOffset:function(a){var b=this;return function(c){c&&c.polygonOffset&&(c.polygonOffsetFactor=a?b.get("_polygon_offset_factor"):0,c.polygonOffsetUnits=a?b.get("_polygon_offset_units"):0)}},SetHighlights:function(a,b){var c=(this.get("_renderercache").materials.enablehighlights=a)&&this.get("_renderercache").materials.enablehardedgehighlights;this.ApplyFctToAllMaterials(this.UpdatePolygonOffset(c));(void 0==b||b)&&this.Render()},SetHighlightsConfiguration:function(a,
b,c){var d=this.get("_renderercache").materials;d.enablehardedgehighlights=b;d.enablehorizonhighlights=a;this.ApplyFctToAllMaterials(this.UpdatePolygonOffset(d.enablehighlights&&b));(void 0==c||c)&&this.Render()},SetHighlightsColor:function(a,b,c,i){this.get("_renderercache").materials.highlight.color.setHex((a<<16)+(b<<8)+c);this.get("_renderercache").materials.edge.uniforms.color.value=new d.Vector3(a/255,b/255,c/255);this.get("_renderercache").materials.enablehighlights&&(void 0==i||i)&&this.Render()},
SetBackgroundColor:function(a,b,c,i,f){this.set("_backgroundColor",new d.Color(a,b,c));this.set("_backgroundAlpha",i);this.get("_renderercache").materials.hasOwnProperty("ColorBlendShaderMaterial")&&(this.get("_renderercache").textures[this.get("_RenderingQuality")].backdrop.enabled=!1);(void 0==f||f)&&this.Render()},SetLabelsVisible:function(a,b){this.get("_renderercache").labels.visible=a;(void 0==b||b)&&this.CameraUpdate(!0)},ResetMainSceneVisibility:function(a){var b=function(a){a instanceof d.Scene||
a instanceof d.Mesh||(a.visible=!0)};this.get("_3JSsceneOp").traverse(b);this.get("_3JSsceneTransp").traverse(b);this.get("_3JSsceneHightlights").traverse(b);(void 0==a||a)&&this.Render()},ToggleNodeVisibility:function(a,b,c,d){this.SetNodeVisibility(a,null,b,c,d)},SetNodeVisibility:function(a,b,c,i,f){var g=this.URLToKeyString(a);if(void 0!==this.get("_renderercache").nodeviewproperties[g]){for(var e=0,h=Object.keys(this.get("_renderercache").nodeviewproperties[g].threejsnodes),j=h.length;e<j;++e)for(var l=
function(a){a instanceof d.Scene||a instanceof d.Mesh||(a.visible=null===b?!a.visible:b)},a=this.get("_renderercache").nodeviewproperties[g].threejsnodes[h[e]],n=0,k=Object.keys(a),r=k.length;n<r;n++){var m=a[k[n]];l(m);if(void 0!=c&&c)for(var p=0,s=Object.keys(m.children),q=s.length;p<q;++p)m.children[s[p]].traverse(l);void 0!=i&&i&&m.parent&&m.parent.traverseParents(l)}(void 0==f||f)&&this.Render()}},GetNodeInfo:function(a,b){switch(b){case "NODEOBJECTVIS":var c=a.threejsnodes[Object.keys(a.threejsnodes)[0]];
return c[Object.keys(c)[0]].visible;default:w.Log("Unknown queried data type")}},Get:function(a,b){var c=this.URLToKeyString(a),d=this.get("_renderercache").nodeviewproperties[c];if(d)return this.GetNodeInfo(d,b);w.Log("ViewerView Warning: No existing node for "+c)},LogMemoryReport:function(){w.Log("Node View Properties Size: "+y.get("SizeOf")(this.get("_renderercache").nodeviewproperties)/1E6+"MB");w.Log("_3JSsceneOp Size: "+y.get("SizeOf")(this.get("_3JSsceneOp"))/1E6+"MB");w.Log("_3JSsceneOpDepth Size: "+
y.get("SizeOf")(this.get("_3JSsceneOpDepth"))/1E6+"MB");w.Log("_3JSsceneOpaqueDiffuse Size: "+y.get("SizeOf")(this.get("_3JSsceneOpaqueDiffuse"))/1E6+"MB");w.Log("_3JSsceneTransp Size: "+y.get("SizeOf")(this.get("_3JSsceneTransp"))/1E6+"MB");w.Log("_3JSsceneTranspDepth Size: "+y.get("SizeOf")(this.get("_3JSsceneTranspDepth"))/1E6+"MB");w.Log("_3JSsceneTranspDiffuse Size: "+y.get("SizeOf")(this.get("_3JSsceneTranspDiffuse"))/1E6+"MB");for(var a=0;a<this.get("_3JSsceneOpCoincidentGroupsPasses").length;++a){var b=
this.get("_3JSsceneOpCoincidentGroupsPasses")[a];w.Log("_3JSsceneOpCoincidentGroups["+b+"] Size: "+y.get("SizeOf")(this.get("_3JSsceneOpCoincidentGroups")[b])/1E6+"MB");w.Log("_3JSsceneOpCoincidentGroupsDepth["+b+"] Size: "+y.get("SizeOf")(this.get("_3JSsceneOpCoincidentGroupsDepth")[b])/1E6+"MB");w.Log("_3JSsceneOpCoincidentGroupsDiffuse["+b+"] Size: "+y.get("SizeOf")(this.get("_3JSsceneOpCoincidentGroupsDiffuse")[b])/1E6+"MB")}for(a=0;a<this.get("_3JSsceneTranspCoincidentGroupsPasses").length;++a)b=
this.get("_3JSsceneTranspCoincidentGroupsPasses")[a],w.Log("_3JSsceneTranspCoincidentGroups["+b+"] Size: "+y.get("SizeOf")(this.get("_3JSsceneTranspCoincidentGroups")[b])/1E6+"MB"),w.Log("_3JSsceneTranspCoincidentGroupsDepth["+b+"] Size: "+y.get("SizeOf")(this.get("_3JSsceneTranspCoincidentGroupsDepth")[b])/1E6+"MB"),w.Log("_3JSsceneTranspCoincidentGroupsDiffuse["+b+"] Size: "+y.get("SizeOf")(this.get("_3JSsceneTranspCoincidentGroupsDiffuse")[b])/1E6+"MB");w.Log("_3JSsceneHightlights Size: "+y.get("SizeOf")(this.get("_3JSsceneHightlights"))/
1E6+"MB");w.Log("_3JSsceneLabels Size: "+y.get("SizeOf")(this.get("_3JSsceneLabels"))/1E6+"MB")},PrintOpaqueSceneVertices:function(){w.Log("List of vertices (opaques scene)");var a=new d.Vector3,b=function(a){a instanceof d.Vector3&&(!isNaN(a.x)&&!isNaN(a.y)&&!isNaN(a.z))&&w.Log("("+a.x+","+a.y+","+a.z+")")},c=function(c){var e=c.geometry;if(void 0!==e)if(e instanceof d.Geometry)for(var e=e.vertices,f=0,i=e.length;f<i;++f)a.copy(e[f]),a.applyMatrix4(c.matrixWorld),b(a);else if(e instanceof d.BufferGeometry&&
void 0!==e.attributes.position){var l=e.attributes.position.array;e instanceof d.InstancedBufferGeometry&&new d.Box3;f=0;for(i=l.length;f<i;f+=3)if(a.fromArray(l,f),a.applyMatrix4(c.matrixWorld),e instanceof d.InstancedBufferGeometry&&void 0!==e.attributes.inst_translation&&void 0!==e.attributes.inst_rotation&&void 0!==e.attributes.inst_scale)for(var n=0,k=e.maxInstancedCount;n<k;++n){var r=d.GetInstanceTransform(e.attributes.inst_translation,e.attributes.inst_rotation,e.attributes.inst_scale,n);
b(d.Vector3.transformVertex(a,r))}else b(a)}};this.get("_3JSsceneOp").updateMatrixWorld(!0);this.get("_3JSsceneOp").traverse(c);for(var i=0;i<this.get("_3JSsceneOpCoincidentGroupsPasses").length;++i){var f=this.get("_3JSsceneOpCoincidentGroupsPasses")[i];this.get("_3JSsceneOpCoincidentGroups")[f].updateMatrixWorld(!0);this.get("_3JSsceneOpCoincidentGroups")[f].traverse(c)}},SetReflections:function(a,b,c,d,f,g){this.set("_reflection_config",a);"ON"==a?this.UpdateReflectionUniforms(b,c,d,f):"JSON"==
a&&this.UpdateReflectionUniforms();(void 0==g||g)&&this.Render()},SetAnimations:function(a){this.set("_enableAnimations",a);this.Animate()},SetInteractionOptimization:function(a){this.set("_enableInteractionOptimization",a)},SetQualityLevel:function(a,b){this.set("_nb_max_peels",a);(void 0==b||b)&&this.Render()},SetLightingContrast:function(a,b){this.set("_lighting_contrast",a);this.UpdateLightingContrast();(void 0==b||b)&&this.Render()},UpdateLightingContrast:function(){for(var a=0,b=Object.keys(this.get("_renderercache").lights.dir_light),
c=b.length;a<c;a++){var d=b[a];this.get("_renderercache").lights.dir_light[d].intensity=this.get("_lighting_contrast")}a=0;b=Object.keys(this.get("_renderercache").lights.amb_light);for(c=b.length;a<c;a++)d=b[a],this.get("_renderercache").lights.amb_light[d].intensity=1+(0.5-this.get("_lighting_contrast"))},AppendRendererToDocument:function(){"function"===typeof this.get("_context").appendChild&&this.get("_context").appendChild(this.get("_3JSrenderer").domElement)},GetSnapshot:function(a,b,c){this.Render(!0,
b,c);var d=this.get("_3JSrenderer").getContext(),f=new Uint8Array(4*b*c);d.readPixels(0,0,b,c,d.RGBA,d.UNSIGNED_BYTE,f);d=document.createElement("canvas");d.width=b;d.height=c;var g=d.getContext("2d"),b=g.createImageData(b,c);b.data.set(f);for(var e,h,j,f=0;f<b.height/2;f++)for(c=0;c<b.width;c++)e=b.width*f+c,h=b.width*(b.height-1-f)+c,e*=4,h*=4,j=b.data[h],b.data[h]=b.data[e],b.data[e]=j,j=b.data[h+1],b.data[h+1]=b.data[e+1],b.data[e+1]=j,j=b.data[h+2],b.data[h+2]=b.data[e+2],b.data[e+2]=j,j=b.data[h+
3],b.data[h+3]=b.data[e+3],b.data[e+3]=j;g.putImageData(b,0,0);"function"===typeof this.get("_context").appendChild&&this.CameraUpdate(!0,this.get("_context").clientWidth,this.get("_context").clientHeight);return d.toDataURL("image/"+a)}})});