/**
 * @author SVN & DOGO (Original by RAVO)
 * @module WebViewer3D
 * @copyright   2015 Esko Stonecube Ltd. All rights reserved.
 */

define(["WV3Dlib/three","WV3Dmod/shaders/VertexShaderPM","WV3Dmod/shaders/ShaderUtils"],function(b,c,a){var d={diffuseColor:{type:"c",value:new b.Color(16777215)},specularColor:{type:"c",value:new b.Color(16777215)},shininess:{type:"f",value:0.5},diffuseTexture:{type:"t",value:null},specularTexture:{type:"t",value:null},internalSpecTex:{type:"t",value:null},normalMap_chan_0:{type:"t",value:null},normalMap_chan_1:{type:"t",value:null},isFloorReflection:{type:"i",value:0},haze1CubeMap:{type:"t",value:null},
haze2CubeMap:{type:"t",value:null},envMapRotQuat:{type:"v4",value:new b.Vector4(0,0,0,1)},canvas_size:{type:"v2",value:new b.Vector2(1,1)},DX1RT:{type:"t",value:null},DX2RT:{type:"t",value:null},NBRTSRC:{type:"i",value:0}};fragmentShader_part2Alt="#endif\nvec3 resolveHaze(float haze, vec3 reflSamples[5])\n{\nvec3 result = reflSamples[0] * (1.0 - clamp(abs(0.0 - haze), 0.0, 1.0));\nresult +=     reflSamples[1] * (1.0 - clamp(abs(1.0 - haze), 0.0, 1.0));";a=["return result;\n}\nmat3 cotangent_frame(vec3 N, vec3 p, vec2 uv)\n{\nvec3 dp1 = dFdx( p );\nvec3 dp2 = dFdy( p );\nvec2 duv1 = dFdx( uv );\nvec2 duv2 = dFdy( uv );\nvec3 dp2perp = cross( dp2, N );\nvec3 dp1perp = cross( N, dp1 );\nvec3 T = normalize(dp2perp * duv1.x + dp1perp * duv2.x);\nvec3 B = normalize(dp2perp * duv1.y + dp1perp * duv2.y);\nfloat invmax = inversesqrt( max( dot(T,T), dot(B,B) ) );\nreturn mat3( T * invmax, B * invmax, N );\n}\nvec3 perturb_normal( vec3 N, vec3 V, vec2 texcoord )\n{\nfloat chan_0 = texture2D(normalMap_chan_0, texcoord).r;\nfloat chan_1 = texture2D(normalMap_chan_1, texcoord).r;\nvec3 map = vec3(chan_0, chan_1, 0.);\nmap = map * 255./127. - 128./127.;\nvec2 tmp;\nif(map.x >= 0.0) tmp.x = -1.0; else tmp.x = 1.0;\nif(map.y >= 0.0) tmp.y = -1.0; else tmp.y = 1.0;\nmap = abs(map) * 9.96722625883599;\nmap = exp2(map);\nmap = (map * 0.001) - 0.001;\nmap = map * vec3(tmp,0.);\nmap.z = sqrt( 1. - dot( map.xy, map.xy ) );\nmat3 TBN = cotangent_frame(N, -V, texcoord);\nreturn normalize(TBN * map);\n}",
a.get("DeclareDepthSamplersChunck"),a.get("EncodeDepthChunck"),a.get("DecodeDepthChunck"),a.get("EnvironmentRotationChunck"),"void main()\n{",a.get("SelectPeelChunck"),"vec4 specularCol = vec4(specularColor, 1.0 - shininess);\nvec4 internalSpecCol = vec4(0.0, 0.0, 0.0, 1.0 - shininess);\n#ifdef USE_SPECULARMAP\nspecularCol = texture2D(specularTexture, texcoordVaryingScaled);\n#ifdef REMAPPED_SPECULAR_ALPHA_CHANNEL\nspecularCol.a = clamp((specularCol.a - 127./255.) * 255. / 127., 0.,1.);\n#endif\n#endif\n#ifdef USE_INT_SPEC_TEXTURE\ninternalSpecCol = texture2D(internalSpecTex, texcoordVaryingScaled);\n#ifdef REMAPPED_INT_SPECULAR_ALPHA_CHANNEL\ninternalSpecCol.a = clamp((internalSpecCol.a - 127./255.) * 255. / 127., 0.,1.);\n#endif\n#endif\nvec3 eyeVector = normalize(vec3(vWorldPosition) - cameraPosition.xyz);\n#ifdef USE_CHAN0_TEXTURE\n#ifdef USE_CHAN1_TEXTURE\nvec3 pN = perturb_normal(normalize(vNormal), eyeVector, texcoordVarying);\n#else\n#define NO_BUMP\n#endif\n#else\n#define NO_BUMP\n#endif\n#ifdef NO_BUMP\nvec3 pN = normalize(vNormal);\n#endif\n#ifdef USE_ENVMAP\nvec3 reflection = reflect(eyeVector, pN);\nif(isFloorReflection)\n{\nreflection.y = -reflection.y;\n}\nreflection = rotate_vec_from_quat(envMapRotQuat, reflection);\nvec3 reflSamples[5], reflResult;\nreflSamples[0] = textureCube(haze1CubeMap, reflection).rgb;\nreflSamples[1] = textureCube(haze2CubeMap, reflection).rgb;"].join("\n");
return{vertexShader:c.vertexShader,uniforms:b.UniformsUtils.merge([c.uniforms,d]),fragmentShader:["varying vec2 texcoordVarying;\nvarying vec2 texcoordVaryingScaled;\nvarying vec3 vNormal;\nvarying vec4 vPosition;\nvarying vec4 vWorldPosition;\nuniform vec3 diffuseColor;\nuniform vec3 specularColor;\nuniform float shininess;\nuniform sampler2D diffuseTexture;\nuniform sampler2D specularTexture;\nuniform sampler2D internalSpecTex;\nuniform sampler2D normalMap_chan_0;\nuniform sampler2D normalMap_chan_1;\nuniform vec4 envMapRotQuat;\n#ifdef USE_ENVMAP\nuniform bool isFloorReflection;\nuniform samplerCube haze1CubeMap;\nuniform samplerCube haze2CubeMap;",
fragmentShader_part2Alt,a,"reflResult = specularCol.rgb * resolveHaze(specularCol.w, reflSamples);\nreflResult += internalSpecCol.rgb * resolveHaze(internalSpecCol.w, reflSamples);\n#else\nvec3 reflResult = specularCol.rgb;\n#endif\ngl_FragColor.rgb = reflResult;\ngl_FragColor.a = 0.0;\n}"].join("\n"),EXTuniforms:b.UniformsUtils.merge([c.uniforms,d,{haze3CubeMap:{type:"t",value:null},haze4CubeMap:{type:"t",value:null},haze5CubeMap:{type:"t",value:null}}]),EXTfragmentShader:["varying vec2 texcoordVarying;\nvarying vec2 texcoordVaryingScaled;\nvarying vec3 vNormal;\nvarying vec4 vPosition;\nvarying vec4 vWorldPosition;\nuniform vec3 diffuseColor;\nuniform vec3 specularColor;\nuniform float shininess;\nuniform sampler2D diffuseTexture;\nuniform sampler2D specularTexture;\nuniform sampler2D internalSpecTex;\nuniform sampler2D normalMap_chan_0;\nuniform sampler2D normalMap_chan_1;\nuniform vec4 envMapRotQuat;\n#ifdef USE_ENVMAP\nuniform bool isFloorReflection;\nuniform samplerCube haze1CubeMap;\nuniform samplerCube haze2CubeMap;\nuniform samplerCube haze3CubeMap;\nuniform samplerCube haze4CubeMap;\nuniform samplerCube haze5CubeMap;\n#endif\nvec3 resolveHaze(float haze, vec3 reflSamples[5])\n{\nfloat haze4 = 4.0 * haze;\nvec3 result = reflSamples[0] * (1.0 - clamp(abs(0.0 - haze4), 0.0, 1.0));\nresult +=     reflSamples[1] * (1.0 - clamp(abs(1.0 - haze4), 0.0, 1.0));\nresult +=     reflSamples[2] * (1.0 - clamp(abs(2.0 - haze4), 0.0, 1.0));\nresult +=     reflSamples[3] * (1.0 - clamp(abs(3.0 - haze4), 0.0, 1.0));\nresult +=     reflSamples[4] * (1.0 - clamp(abs(4.0 - haze4), 0.0, 1.0));",
a,"reflSamples[2] = textureCube(haze3CubeMap, reflection).rgb;\nreflSamples[3] = textureCube(haze4CubeMap, reflection).rgb;\nreflSamples[4] = textureCube(haze5CubeMap, reflection).rgb;\nreflResult = specularCol.rgb * resolveHaze(specularCol.w, reflSamples);\nreflResult += internalSpecCol.rgb * resolveHaze(internalSpecCol.w, reflSamples);\n#else\nvec3 reflResult = specularCol.rgb;\n#endif\ngl_FragColor.rgb = reflResult;\ngl_FragColor.a = 0.0;\n}"].join("\n")}});