/**
 * @author DOGO
 * @module WebViewer3D
 * @copyright   2014 Esko Stonecube Ltd. All rights reserved.
 */

define("underscore backbone WV3Dlib/jquery.mousewheel WV3Dmod/hammerEXT WV3Dlib/three WV3Dmod/ViewerView WV3Dmod/ViewerModel WV3Dmod/SystemChecker WV3Dmod/Constants WV3Dmod/Math WV3Dmod/Timers WV3Dmod/LogMessage".split(" "),function(g,n,t,i,j,p,s,k,d,l,m,h){return n.Model.extend({initialize:function(a,b,c,e){h.Log("Creating WV3DViewerController Object");a||(a={clientWidth:1,clientHeight:1});this.set("_model",new s(b,e));this.set("_view",new p(a,this.get("_model"),c));this.set("_cameratransformstate",
{pscale:1,deltax:0,deltay:0});this.set("_interactivecontrol",!0);this.set("_interactivecontrolmask",d.interaction.ALL);this.set("_enableAnimations",!1);"function"===typeof a.appendChild&&(a.oncontextmenu=function(){return!1},b=function(){return!1},a.onselectstart=b,a.onmousedown=b,this.set("_hammer",new i(a)),this.get("_hammer").get("pan").set({threshold:0,direction:i.DIRECTION_ALL}),this.get("_hammer").get("tap").set({taps:2}),this.get("_hammer").get("pinch").set({enable:!0}),this.get("_hammer").add(new i.Pinch({event:"threepan",
pointers:3})),this.get("_hammer").on("panstart panmove panend",g.bind(this.InteractiveCameraMove,this)),this.get("_hammer").on("pinchstart pinchmove pinchend",g.bind(this.InteractiveCameraScale_touch,this)),this.get("_hammer").on("tap",g.bind(this.InteractiveResetCamera,this)),this.get("_hammer").on("press",g.bind(this.InteractiveResetCamera,this)),this.get("_hammer").on("threepan",g.bind(this.InteractiveEnvironmentRotation_touch,this)),$(a).on("mousewheel",g.bind(this.InteractiveCameraScale_mouse,
this)))},Dispose:function(){this.get("_view").ReleaseDummyTextures();this.get("_view").ReleaseAllRenderTargets();this.get("_view").ReleaseScene()},SetEndCameraInteractionCallback:function(a){"function"===typeof a&&this.set("_clientEndCameraInteractionCallback",a)},SetURLPreprocessCallback:function(a){"function"===typeof a&&this.get("_model").get("_assetmanager").SetURLPreprocessCallback(a)},Resize:function(){this.get("_view").Resize()},SetDefaultResourceRelativePath:function(a){this.get("_view").SetDefaultResourceRelativePath(a)},
LoadSceneFromURL:function(a,b,c,e,f,d){c&&this.get("_model").set("_clientCallback",c);e&&this.get("_view").set("_clientUIAddElementCallback",e);this.get("_model").ResetAssetManager();this.get("_view").ResetScene(b,f);d&&d instanceof Object&&this.get("_model").get("_assetmanager").SetReplacementMaterialsAndTextures(d);this.AddSceneFromURL(a)},AddSceneFromURL:function(a){this.get("_model").LoadSceneURL(a)},LoadSceneFromJSONObject:function(a,b,c,e,f,d){h.Log("Controller LoadResource function");c&&this.get("_model").set("_clientCallback",
c);e&&this.get("_view").set("_clientUIAddElementCallback",e);this.get("_model").ResetAssetManager();this.get("_view").ResetScene(b,f);this.AddSceneFromJSONObject(a,d)},AddSceneFromJSONObject:function(a,b){h.Log("Controller LoadResource function");this.get("_model").get("_assetmanager").IncrementQueryCounter();this.get("_model").LoadSceneJSON(a,b)},ReloadAllTextures:function(a,b){h.Log("Controller ReLoadAllTextures function");this.get("_view").ReloadAllTextures(a,b)},ReloadTexture:function(a,b,c,e,
f){h.Log("Controller ReLoadTexture function");this.get("_view").ReloadTexture(a,b,c,e,f)},ResetMainSceneVisibility:function(){h.Log("Controller Reset visiblity of main scene");this.get("_view").ResetMainSceneVisibility()},ToggleNodeVisibility:function(a,b,c){this.get("_view").ToggleNodeVisibility(a,b,c)},SetNodeVisibility:function(a,b,c,e){if("boolean"!=typeof b)throw"Set visiblity: NaB Exception";this.get("_view").SetNodeVisibility(a,b,c,e)},InteractiveCameraPanOffset:function(a){var b=this.get("_view").GetCameraPanOffset(),
c=b.x,b=b.y,e=this.get("_view").GetCameraScale(),f=0.005*Math.abs(a.deltaX-this.get("_cameratransformstate").deltax)/e*this.get("_view").get("_3JSsceneBBox").getBoundingSphere().radius,e=0.005*Math.abs(a.deltaY-this.get("_cameratransformstate").deltay)/e*this.get("_view").get("_3JSsceneBBox").getBoundingSphere().radius,c=a.deltaX>this.get("_cameratransformstate").deltax?c-f:c+f,b=a.deltaY<this.get("_cameratransformstate").deltay?b-e:b+e;this.get("_cameratransformstate").deltax=a.deltaX;this.get("_cameratransformstate").deltay=
a.deltaY;this.get("_view").SetCameraPanOffset({x:c,y:b})},InteractiveCameraMove:function(a){if(!1!=this.get("_interactivecontrol")){if("panstart"==a.type){this.set("_interaction_type",a.srcEvent.shiftKey?"PANNING":a.srcEvent.ctrlKey||2===a.button?"ENVROT":"ROTATION");if(!(d.interaction.ROTATE&this.get("_interactivecontrolmask"))&&"ROTATION"===this.get("_interaction_type")||!(d.interaction.PAN&this.get("_interactivecontrolmask"))&&"PANNING"===this.get("_interaction_type")||!(d.interaction.ENVROT&this.get("_interactivecontrolmask"))&&
"ENVROT"===this.get("_interaction_type"))return;this.get("_cameratransformstate").deltax=a.deltaX;this.get("_cameratransformstate").deltay=a.deltaY;this.get("_view").StartInteractiveFramerate()}if(d.interaction.ROTATE&this.get("_interactivecontrolmask")||"ROTATION"!==this.get("_interaction_type"))if(d.interaction.PAN&this.get("_interactivecontrolmask")||"PANNING"!==this.get("_interaction_type"))if(d.interaction.ENVROT&this.get("_interactivecontrolmask")||"ENVROT"!==this.get("_interaction_type")){"panend"==
a.type&&this.get("_view").EndInteractiveFramerate();switch(this.get("_interaction_type")){case "PANNING":this.InteractiveCameraPanOffset(a);break;case "ROTATION":var b=this.get("_view").GetCameraAngles(),c=this.get("_view").GetCameraScale(),e=Math.abs(a.deltaX-this.get("_cameratransformstate").deltax)/(1*c),c=Math.abs(a.deltaY-this.get("_cameratransformstate").deltay)/(1*c);b.azimuth=a.deltaX>this.get("_cameratransformstate").deltax?b.azimuth-=e:b.azimuth+=e;if(-360>b.azimuth||360<b.azimuth)b.azimuth=
0;b.elevation=a.deltaY<this.get("_cameratransformstate").deltay?Math.min(Math.max(b.elevation-=c,-90),90):Math.min(Math.max(b.elevation+=c,-90),89.99);this.get("_view").SetCameraAngles(b.azimuth,b.elevation);this.get("_cameratransformstate").deltax=a.deltaX;this.get("_cameratransformstate").deltay=a.deltaY;break;case "ENVROT":this.InteractiveEnvironmentRotation(a);break;default:h.Log("Unrecognised interaction type")}"panend"==a.type&&this.get("_clientEndCameraInteractionCallback")&&this.get("_clientEndCameraInteractionCallback")();
a.preventDefault()}}},InteractiveCameraScale_touch:function(a){if(!1!=this.get("_interactivecontrol")&&(d.interaction.SCALE&this.get("_interactivecontrolmask")||"SCALING"!==this.get("_interaction_type")))if(d.interaction.PAN&this.get("_interactivecontrolmask")||"PANNING"!==this.get("_interaction_type"))"pinchstart"==a.type&&(this.get("_cameratransformstate").deltax=a.deltaX,this.get("_cameratransformstate").deltay=a.deltaY,this.get("_cameratransformstate").pscale=this.get("_view").GetCameraScale()||
1,this.get("_view").StartInteractiveFramerate()),"pinchend"==a.type&&this.get("_view").EndInteractiveFramerate(),d.interaction.SCALE&this.get("_interactivecontrolmask")&&this.SetCameraScale(Math.min(Math.max(this.get("_cameratransformstate").pscale*a.scale,0.1),20)),d.interaction.PAN&this.get("_interactivecontrolmask")&&this.InteractiveCameraPanOffset(a),"pinchend"==a.type&&this.get("_clientEndCameraInteractionCallback")&&this.get("_clientEndCameraInteractionCallback")(),a.preventDefault()},InteractiveCameraScale_mouse:function(a){if(!1!=
this.get("_interactivecontrol")&&d.interaction.SCALE&this.get("_interactivecontrolmask")){this.get("_mousewheel_timeout")&&window.clearTimeout(this.get("_mousewheel_timeout"));var b=this,c=this.get("_view");c.StartInteractiveFramerate();this.set("_mousewheel_timeout",window.setTimeout(function(){b.get("_view").EndInteractiveFramerate(!0);b.get("_clientEndCameraInteractionCallback")&&b.get("_clientEndCameraInteractionCallback")()},500));c=c.GetCameraScale();c=Math.min(Math.max(c+c*a.deltaY*a.deltaFactor/
1E3,0.1),20);this.SetCameraScale(c);a.preventDefault()}},InteractiveEnvironmentRotation_touch:function(a){!1!=this.get("_interactivecontrol")&&d.interaction.ENVROT&this.get("_interactivecontrolmask")&&("panstart"==a.type&&(this.get("_cameratransformstate").deltax=a.deltaX,this.get("_cameratransformstate").deltay=a.deltaY,this.get("_view").StartInteractiveFramerate()),"panend"==a.type&&this.get("_view").EndInteractiveFramerate(),this.InteractiveEnvironmentRotation(a),"panend"==a.type&&this.get("_clientEndCameraInteractionCallback")&&
this.get("_clientEndCameraInteractionCallback")(),a.preventDefault())},InteractiveEnvironmentRotation:function(a){var b=this.get("_view").GetEnvironmentRotation(),c=a.deltaX-this.get("_cameratransformstate").deltax,e=a.deltaY-this.get("_cameratransformstate").deltay,f=new j.Quaternion;f.setFromEuler(new j.Euler(e/100,c/100,0,"XYZ"));c=new j.Quaternion;c.setFromRotationMatrix(this.get("_view").get("_3JScamera").matrixWorld);b.multiply(c);b.multiply(f);b.multiply(c.conjugate());this.get("_view").SetEnvironmentRotation(b);
this.get("_cameratransformstate").deltax=a.deltaX;this.get("_cameratransformstate").deltay=a.deltaY},SetEnvironmentRotation:function(a,b){if(!(a instanceof j.Quaternion))throw"SetEnvironmentRotation: Not A Quaternion Exception";this.get("_view").SetEnvironmentRotation(a,b)},ResetEnvironmentRotation:function(){var a=new j.Quaternion;this.get("_view").SetEnvironmentRotation(a)},InteractiveResetCamera:function(a){if(!1!=this.get("_interactivecontrol")){var b=d.interaction.SCALE&this.get("_interactivecontrolmask"),
c=d.interaction.ROTATE&this.get("_interactivecontrolmask"),e=d.interaction.PAN&this.get("_interactivecontrolmask"),f=d.interaction.ENVROT&this.get("_interactivecontrolmask");b&&this.SetCameraScale(1,!e&&!c&&!f);e&&this.SetCameraPanOffset(0,0,!c&&!f);c&&this.SetCameraAngles(0,0,!f);f&&this.ResetEnvironmentRotation();d.interaction.NONE&this.get("_interactivecontrolmask")||this.get("_clientEndCameraInteractionCallback")&&this.get("_clientEndCameraInteractionCallback")();a.preventDefault()}},SetInteractiveCameraControl:function(a){this.set("_interactivecontrol",
a)},SetInteractiveCameraControlMask:function(a){this.set("_interactivecontrolmask",a)},ResetCamera:function(){this.SetCameraAngles(0,0);this.SetCameraScale(1);this.SetCameraPanOffset(0,0)},SetCameraAngles:function(a,b,c){if("number"!=typeof a||"number"!=typeof b)throw"SetCameraAngles: NaN Exception";this.get("_view").SetCameraAngles(a,b,c)},GetCameraAngles:function(){return this.get("_view").GetCameraAngles()},SetCameraScale:function(a,b){if("number"!=typeof a)throw"SetCameraScale: NaN Exception";
if(0>=a)throw"SetCameraScale: Out of range Exception";this.get("_view").SetCameraScale(a,b)},GetCameraScale:function(){return this.get("_view").GetCameraScale()},SetCameraPanOffset:function(a,b,c){if("number"!=typeof a||"number"!=typeof b)throw"SetCameraPanOffset: NaN Exception";this.get("_view").SetCameraPanOffset({x:a,y:b},c)},GetCameraPanOffset:function(){return this.get("_view").GetCameraPanOffset()},AnimateToView:function(a,b,c,e,f,d){if("number"!=typeof a||"number"!=typeof b||"number"!=typeof c||
"number"!=typeof e||"number"!=typeof f||"number"!=typeof d&&void 0!==d)throw"AnimateToView: NaN Exception";h.Log("Controller AnimateToView function");if(m.isRunning("AnimateToView"))return!1;m.reset("AnimateToView");var g=1E3*(d?d:1),j=this.GetCameraScale(),i=this.GetCameraAngles(),d=b-i.azimuth,k=b+(180<d?-360:-180>d?360:0),q=this.GetCameraPanOffset(),r=function(){var b=m.now("AnimateToView");if(b<g){var d=1/l.SmartEaseInEaseOutInterpolation(1/j,1/a,b,g),h=l.SmartEaseInEaseOutInterpolation(i.azimuth,
k,b,g),n=l.SmartEaseInEaseOutInterpolation(i.elevation,c,b,g),p=l.SmartEaseInEaseOutInterpolation(q.x,e,b,g),b=l.SmartEaseInEaseOutInterpolation(q.y,f,b,g);this.SetCameraScale(d,!1);this.SetCameraAngles(h,n,!1);this.SetCameraPanOffset(p,b);requestAnimationFrame(r.bind(this))}else m.stop("AnimateToView"),this.SetCameraScale(a,!1),this.SetCameraAngles(k,c,!1),this.SetCameraPanOffset(e,f)};r.bind(this)();return!0},SetCameraSpinAnimation:function(a){if("boolean"!=typeof a)throw"SetCameraSpinAnimation: NaB Exception";
this.set("_enableAnimations",a);h.Log("Controller SetCameraSpinAnimation function");var b=this,c=function(){if(b.get("_enableAnimations")){requestAnimationFrame(c);var a=b.get("_view").GetCameraAngles(),d=(a.azimuth+0.1+180)%360-180;b.get("_view").SetCameraAngles(d,a.elevation)}};c()},SetOptimisedViewRendering:function(a,b,c){if("number"!=typeof a.x||"number"!=typeof a.y)throw"SetOptimisedViewRendering: NaN Exception";if("boolean"!=typeof b)throw"SetOptimisedViewRendering: NaB Exception";this.get("_view").SetOptimisedViewRendering(a,
b,c)},SetPerspectiveCamera:function(a,b){if("number"!=typeof a)throw"SetPerspectiveCamera: NaN Exception";if(0>=a)throw"SetPerspectiveCamera: Out of range (__fieldOfView) Exception";this.get("_view").SetPerspectiveCamera(a,b)},SetOrthographicCamera:function(a){this.get("_view").SetOrthographicCamera(a)},SetCameraFocus:function(a,b){this.get("_view").SetCameraFocus(a,b)},SetHighlights:function(a,b){if("boolean"!=typeof a)throw"SetHighLights: NaB Exception";this.get("_view").SetHighlights(a,b)},SetHighlightsConfiguration:function(a,
b,c){if("boolean"!=typeof a||"boolean"!=typeof b)throw"SetHighLights: NaB Exception";this.get("_view").SetHighlightsConfiguration(a,b,c)},SetHighlightsColor:function(a,b,c){if("number"!=typeof a||"number"!=typeof b||"number"!=typeof c)throw"SetHighlightColor: NaN Exception";this.get("_view").SetHighlightsColor(a,b,c)},SetBackgroundColor:function(a,b,c,e,d){if("number"!=typeof a||"number"!=typeof b||"number"!=typeof c||"number"!=typeof e)throw"SetBackgroundColor: NaN Exception";if(0>a||255<a||0>b||
255<b||0>c||255<c||0>e||255<e)throw"SetBackgroundColor: Out of range Exception";this.get("_view").SetBackgroundColor(a/255,b/255,c/255,e/255,d)},SetLabelsVisibility:function(a,b){"undefined"!==typeof a&&this.get("_view").SetLabelsVisible(a,b)},UpdateLabelProperties:function(a,b){if("undefined"===typeof a||!a)throw"UpdateLabelProperties: invalid __nodeURL argument";if("undefined"===typeof b||!b)throw"UpdateLabelProperties: invalid __properties argument";return this.get("_view").UpdateLabelProperties(a,
b)},UpdateAllLabelsProperties:function(a){if("undefined"==typeof a||!a)throw"UpdateAllLabelsProperties: invalid __properties argument";return this.get("_view").UpdateAllLabelsProperties(a)},Get:function(a,b){return this.get("_view").Get(a,b)},LogMemoryReport:function(){return this.get("_view").LogMemoryReport()},PrintOpaqueSceneVertices:function(){return this.get("_view").PrintOpaqueSceneVertices()},SetReflections:function(a,b,c,e,d,g){if("ON"!=a&&"OFF"!=a&&"JSON"!=a)throw"SetReflections: Invalid parameter";
if("ON"==a){if("number"!==typeof b)throw"SetReflections: NaN Exception";if(0>b||1<b)throw"SetReflections: Out of range Exception";if("boolean"!==typeof c)throw"SetReflections: Invalid parameter";if(c){if("number"!==typeof e||"number"!==typeof d)throw"SetReflections: NaN Exception";if(0>e||1<e||1>d||2<d)throw"SetReflections: Out of range Exception";}}this.get("_view").SetReflections(a,b,c,e,d,g)},SetInteractionOptimization:function(a){this.get("_view").SetInteractionOptimization(a)},SetQualityLevel:function(a,
b){if("number"!==typeof a)throw"SetQualityLevel: NaN Exception";if(1>a||10<a)throw"SetQualityLevel: Out of range Exception";this.get("_view").SetQualityLevel(a,b)},SetLightingContrast:function(a,b){if("number"!==typeof a)throw"SetLightingContrast: NaN Exception";if(0>a||1<a)throw"SetLightingContrast: Out of range Exception";this.get("_view").SetLightingContrast(a,b)},GetSystemSupportLevel:function(){h.Log("ViewController: Get system support level");return k.GetSystemSupportLevel()},GetSystemReport:function(){h.Log("ViewController: Get readable system report");
return k.GetSystemReport()},GetSnapshot:function(a,b,c){return this.get("_view").GetSnapshot(a,b,c)}})});