/**
 * @author DOGO, PHST
 * @module WebViewer3D
 * @copyright   2014 Esko Stonecube Ltd. All rights reserved.
 */

define("backbone underscore WV3Dlib/three WV3Dmod/threeEXT WV3Dmod/Math WV3Dmod/SystemChecker WV3Dmod/HttpRequestHandler WV3Dmod/ThreeDObjectHandler WV3Dmod/TextSpriteMaker WV3Dmod/shaders/UniformColorShader WV3Dmod/shaders/EdgeShader2 WV3Dmod/shaders/ShaderUtils WV3Dmod/shaders/D0Shader WV3Dmod/shaders/D1Shader WV3Dmod/shaders/D2Shader WV3Dmod/shaders/DepthOnlyShader WV3Dmod/shaders/BackdropShader WV3Dmod/shaders/ColorBlendShader WV3Dmod/shaders/TransparencyBlendShader WV3Dmod/shaders/CopyShader WV3Dmod/shaders/DesignerShader WV3Dmod/shaders/FilterShaderPM WV3Dmod/shaders/FilterShaderNPM WV3Dmod/shaders/ReflectanceShaderPM WV3Dmod/shaders/ReflectanceShaderNPM WV3Dmod/shaders/IrradianceShaderPM WV3Dmod/shaders/IrradianceShaderNPM WV3Dmod/shaders/DiffractionShaderPM WV3Dmod/Constants WV3Dmod/Utils WV3Dmod/FPSCounter WV3Dmod/Timers WV3Dmod/ExecutionQueue WV3Dmod/LogMessage".split(" "),
function(ca,$,d,da,z,A,ea,fa,ga,M,N,ia,E,O,P,Q,R,S,T,U,F,V,W,H,I,X,Y,Z,L,y,aa,ba,ha,w){return ca.Model.extend({initialize:function(a,b,c){w.Log("Creating WV3DViewerView Object");this.set("_context",a);this.set("_model",b);this.set("_clientUIAddElementCallback",c);a={alpha:!0,antialias:A.get("_glantialias"),preserveDrawingBuffer:!0};new da;this.set("_3JSrenderer",new d.WebGLRenderer(a));this.get("_3JSrenderer").sortObjects=!1;this.InitializeRenderTargets();this.set("_textSpriteMaker",new ga);this.set("_resourcePath",
"../Resources");this.set("_current_fps",0);this.set("_target_fps_min",25);this.set("_target_fps_max",60);this.set("_nb_max_peels",7);this.set("_nb_min_peels",2);this.set("_reflection_config","JSON");this.set("_enableInteractionOptimization",!1);this.set("_lighting_contrast",0.5);this.set("_optimised_view",!1);this.set("_optimised_view_border",0);this.set("_obj_in_frustum_prev",!0);this.set("_obj_in_frustum",!0);this.set("_polygon_offset_factor",0.5);this.set("_polygon_offset_units",1);this.set("_build_scene_exec_queue",
new ha(!1,!1,$.bind(this.NotifySceneBuildProgress,this)));a=new Image(2,2);a.src="data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAAIAAAACCAIAAAD91JpzAAAACXBIWXMAAAsTAAALEwEAmpwYAAAAB3RJTUUH4AUMDiIqLjEjFgAAAAtJREFUCNdjYEAGAAAOAAEx6d0VAAAAAElFTkSuQmCC";var i=new d.Texture(a),g=new d.CubeTexture([a,a,a,a,a,a]);a.onload=function(){i.needsUpdate=!0;g.needsUpdate=!0;w.Log("Dummy texture loaded")};this.set("_DummyTexture",i);this.set("_DummyTextureCube",g);this.ResetScene();this.CameraUpdate(!1);this.listenTo(this.get("_model"),
"scene_reset",this.ResetScene);this.listenTo(this.get("_model"),"added_scene_resource",this.AddedResource);window.addEventListener("resize",$.bind(this.Resize,this),!1);this.Resize();this.SetBackgroundColor(0.37,0.37,0.37,1,!1);this.AppendRendererToDocument()},NotifySceneBuildProgress:function(a,b,c){"function"===typeof this.get("_model").get("_clientCallback")?(0==this.get("_model").get("_assetmanager").get("_textureCounter")&&(b=100),void 0===b&&(b=100*(this.get("_model").get("_assetmanager").get("_textureLoadedCounter")/
this.get("_model").get("_assetmanager").get("_textureCounter"))),void 0===c&&(c=0),this.get("_model").get("_clientCallback")(c,a,b,this.get("_model").get("_assetmanager").get("_queriedassetnumber"),this.get("_model").get("_assetmanager").get("_resolvedassetnumber"))):w.Log("ViewerView Warning: Client callback not a function")},NotifyResourceQueryErrorCallback:function(a,b){return function(){this.get("_build_scene_exec_queue").whenFinished(function(){w.Log("ViewerView Warning: Problem loading "+b);
var c=this.CheckPostSceneLoadActions();this.NotifySceneBuildProgress(100,c,a)},this)}.bind(this)},SetDefaultResourceRelativePath:function(a){this.set("_resourcePath",a)},ReleaseRenderTarget:function(a){a&&a.dispose()},ReleaseDummyTextures:function(){this.ReleaseRenderTarget(this.get("_DummyTexture"));this.ReleaseRenderTarget(this.get("_DummyTextureCube"))},ReleaseAllRenderTargets:function(){this.ReleaseRenderTarget(this.get("_OpaqueDepthRT"));this.ReleaseRenderTarget(this.get("_D1RT"));this.ReleaseRenderTarget(this.get("_D2RT"));
this.ReleaseRenderTarget(this.get("_ColorStackRT"));this.ReleaseRenderTarget(this.get("_PeelColorRT"));this.ReleaseRenderTarget(this.get("_TransparencyStackRT"));this.ReleaseRenderTarget(this.get("_OpaqueBackgroundMaskRT"));this.ReleaseRenderTarget(this.get("_MirrorOpaqueDepthRT"));this.ReleaseRenderTarget(this.get("_MirrorColorStackRT"));this.ReleaseRenderTarget(this.get("_MirrorColorStackRT2"));this.ReleaseRenderTarget(this.get("_MirrorPeelColorRT"));this.ReleaseRenderTarget(this.get("_MirrorTransparencyStackRT"));
this.ReleaseRenderTarget(this.get("_FadedMirrorTransparencyStackRT"));this.ReleaseRenderTarget(this.get("_MirrorOpaqueBackgroundMaskRT"))},InitializeRenderTargets:function(a,b){var c=a?a:this.get("_context").clientWidth,i=b?b:this.get("_context").clientHeight,g,h;this.ReleaseAllRenderTargets();A.get("_fullSupportFloatingPointTextures")?(g={minFilter:d.LinearFilter,format:d.RGBAFormat,type:d.FloatType},h={minFilter:d.LinearFilter,format:d.RGBAFormat},this.set("_OpaqueDepthRT",new d.WebGLRenderTarget(c,
i,g)),this.set("_D1RT",new d.WebGLRenderTarget(c,i,g)),this.set("_D2RT",new d.WebGLRenderTarget(c,i,g)),this.set("_ColorStackRT",new d.WebGLRenderTarget(c,i,h)),this.set("_PeelColorRT",new d.WebGLRenderTarget(c,i,h)),this.set("_TransparencyStackRT",new d.WebGLRenderTarget(c,i,h)),this.set("_OpaqueBackgroundMaskRT",new d.WebGLRenderTarget(c,i,h)),this.set("_MirrorOpaqueDepthRT",new d.WebGLRenderTarget(c,i,g)),this.set("_MirrorColorStackRT",new d.WebGLRenderTarget(c,i,h)),this.set("_MirrorColorStackRT2",
new d.WebGLRenderTarget(c,i,h)),this.set("_MirrorPeelColorRT",new d.WebGLRenderTarget(c,i,h)),this.set("_MirrorTransparencyStackRT",new d.WebGLRenderTarget(c,i,h)),this.set("_FadedMirrorTransparencyStackRT",new d.WebGLRenderTarget(c,i,h)),this.set("_MirrorOpaqueBackgroundMaskRT",new d.WebGLRenderTarget(c,i,h))):A.get("_fullSupportHFloatingPointTextures")?(g={minFilter:d.LinearFilter,magFilter:d.NearestFilter,format:d.RGBAFormat,type:d.HalfFloatType},h={minFilter:d.LinearFilter,magFilter:d.NearestFilter,
format:d.RGBAFormat},this.set("_OpaqueDepthRT",new d.WebGLRenderTarget(c,i,g)),this.set("_D1RT",new d.WebGLRenderTarget(c,i,g)),this.set("_D2RT",new d.WebGLRenderTarget(c,i,g)),this.set("_ColorStackRT",new d.WebGLRenderTarget(c,i,h)),this.set("_PeelColorRT",new d.WebGLRenderTarget(c,i,h)),this.set("_TransparencyStackRT",new d.WebGLRenderTarget(c,i,h)),this.set("_OpaqueBackgroundMaskRT",new d.WebGLRenderTarget(c,i,h)),this.set("_MirrorOpaqueDepthRT",new d.WebGLRenderTarget(c,i,g)),this.set("_MirrorColorStackRT",
new d.WebGLRenderTarget(c,i,h)),this.set("_MirrorColorStackRT2",new d.WebGLRenderTarget(c,i,h)),this.set("_MirrorPeelColorRT",new d.WebGLRenderTarget(c,i,h)),this.set("_MirrorTransparencyStackRT",new d.WebGLRenderTarget(c,i,h)),this.set("_FadedMirrorTransparencyStackRT",new d.WebGLRenderTarget(c,i,h)),this.set("_MirrorOpaqueBackgroundMaskRT",new d.WebGLRenderTarget(c,i,h))):(h={minFilter:d.LinearFilter,magFilter:d.NearestFilter,format:d.RGBAFormat},this.set("_ColorStackRT",new d.WebGLRenderTarget(c,
i,h)),this.set("_PeelColorRT",new d.WebGLRenderTarget(c,i,h)))},ResetOutlineShaders:function(){if(!this.get("_renderercache").materials.colordepth){var a=d.UniformsUtils.clone(M.uniforms),a=new d.ShaderMaterial({uniforms:a,vertexShader:M.vertexShader,fragmentShader:M.fragmentShader,name:"ColorDepth",side:d.DoubleSide});this.get("_renderercache").materials.colordepth=a}if(!this.get("_renderercache").materials.edge){var a=this.get("_renderercache").materials.defaultcolor,b=d.UniformsUtils.clone(N.uniforms);
b.color.value=new d.Vector3(a[0]/255,a[1]/255,a[2]/255);b.depth_texture.value=this.get("_DummyTexture");a=new d.ShaderMaterial({uniforms:b,vertexShader:N.vertexShader,fragmentShader:N.fragmentShader,name:"Edge",wireframe:!0});this.get("_renderercache").materials.edge=a}},ResetShaders:function(){if(!this.get("_renderercache").materials.D0ShaderMaterial){var a=d.UniformsUtils.clone(E.uniforms),a=new d.ShaderMaterial({uniforms:a,vertexShader:E.vertexShader,fragmentShader:E.fragmentShader,side:d.DoubleSide,
depthWrite:!0,transparent:!1,name:"D0ShaderMaterial"});this.get("_renderercache").materials.D0ShaderMaterial=a}this.get("_renderercache").materials.D1ShaderMaterial||(a=d.UniformsUtils.clone(O.uniforms),a.D0RT.value=this.get("_DummyTexture"),a=new d.ShaderMaterial({uniforms:a,vertexShader:O.vertexShader,fragmentShader:O.fragmentShader,side:d.DoubleSide,depthWrite:!0,transparent:!1,name:"D1ShaderMaterial"}),this.get("_renderercache").materials.D1ShaderMaterial=a);this.get("_renderercache").materials.D2ShaderMaterial||
(a=d.UniformsUtils.clone(P.uniforms),a.DX1RT.value=this.get("_DummyTexture"),a.DX2RT.value=this.get("_DummyTexture"),a=new d.ShaderMaterial({uniforms:a,vertexShader:P.vertexShader,fragmentShader:P.fragmentShader,side:d.DoubleSide,depthWrite:!0,transparent:!1,name:"D2ShaderMaterial"}),this.get("_renderercache").materials.D2ShaderMaterial=a);this.get("_renderercache").materials.DepthOnlyShaderMaterial||(a=d.UniformsUtils.clone(Q.uniforms),a.DX1RT.value=this.get("_DummyTexture"),a.DX2RT.value=this.get("_DummyTexture"),
a=new d.ShaderMaterial({uniforms:a,vertexShader:Q.vertexShader,fragmentShader:Q.fragmentShader,side:d.DoubleSide,depthWrite:!0,colorWrite:!1,transparent:!1,name:"DepthOnlyShaderMaterial"}),this.get("_renderercache").materials.DepthOnlyShaderMaterial=a);this.get("_renderercache").materials.BackdropShaderMaterial||(a=d.UniformsUtils.clone(R.uniforms),a.backdrop.value=this.get("_DummyTexture"),a.reflection.value=this.get("_DummyTexture"),a=new d.ShaderMaterial({uniforms:a,vertexShader:R.vertexShader,
fragmentShader:R.fragmentShader,side:d.FrontSide,depthWrite:!1,transparent:!1,name:"BackdropShaderMaterial"}),this.get("_renderercache").materials.BackdropShaderMaterial=a);this.get("_renderercache").materials.ColorBlendShaderMaterial||(a=d.UniformsUtils.clone(S.uniforms),a.CX1RT.value=this.get("_DummyTexture"),a.TransparencyStack.value=this.get("_DummyTexture"),a.OpaqueRT.value=this.get("_DummyTexture"),a.ColorStackRT.value=this.get("_DummyTexture"),a=new d.ShaderMaterial({uniforms:a,vertexShader:S.vertexShader,
fragmentShader:S.fragmentShader,side:d.FrontSide,depthWrite:!0,transparent:!0,blending:d.AdditiveBlending,name:"ColorBlendShaderMaterial"}),this.get("_renderercache").materials.ColorBlendShaderMaterial=a);this.get("_renderercache").materials.CopyShaderMaterial||(a=d.UniformsUtils.clone(U.uniforms),a.CXRT.value=this.get("_DummyTexture"),a.OpaqueRT.value=this.get("_DummyTexture"),a=new d.ShaderMaterial({uniforms:a,vertexShader:U.vertexShader,fragmentShader:U.fragmentShader,side:d.FrontSide,depthWrite:!0,
transparent:!1,blending:d.AdditiveBlending,name:"CopyShaderMaterial"}),this.get("_renderercache").materials.CopyShaderMaterial=a);this.ResetOutlineShaders()},ApplyFctToMaterialStruct:function(a,b){for(var c=0,d=Object.keys(a.mat.untextured_mat),g=d.length;c<g;++c)for(var h=a.mat.untextured_mat[d[c]],f=0,e=Object.keys(h),j=e.length;f<j;++f){var l=h[e[f]];b(l);l.needsUpdate=!0}c=0;d=Object.keys(a.mat.textured_mat);for(g=d.length;c<g;++c){h=a.mat.textured_mat[d[c]];f=0;e=Object.keys(h);for(j=e.length;f<
j;++f)for(var m=h[e[f]],k=0,r=Object.keys(m),n=r.length;k<n;++k)l=m[r[k]],b(l),l.needsUpdate=!0}},ApplyFctToAllMaterials:function(a){a(this.get("_renderercache").materials.default_material);this.get("_renderercache").materials.default_material.needsUpdate=!0;for(var b=0,c=Object.keys(this.get("_renderercache").materials.materiallist),d=c.length;b<d;++b){var g=this.get("_renderercache").materials.materiallist[c[b]];this.ApplyFctToMaterialStruct(g.front,a);this.ApplyFctToMaterialStruct(g.back,a)}},
ReleaseMaterial:function(a,b){if(a&&(a.dispose(),a.uniforms))for(var c=0,i=Object.keys(a.uniforms),g=i.length;c<g;++c){var h=a.uniforms[i[c]];h.value&&"function"===typeof h.value.dispose&&(void 0===b||b||!(h.value instanceof d.Texture))&&h.value.dispose()}},ReleaseMaterialsAndTextures:function(a){if(a){var b=a.boundmeshlist;if(b){0==Object.keys(b).length&&w.Log("ViewerView Warning: No meshes to update");for(var c=0,d=Object.keys(b),g=d.length;c<g;++c){var h=d[c];0==Object.keys(b[h]).length&&w.Log("ViewerView Warning: No render passes to update");
for(var f=0,e=Object.keys(b[h]),j=e.length;f<j;++f){for(var l=e[f],m=0,k=Object.keys(b[h][l]),r=k.length;m<r;m++){var n=k[m];this.ReleaseMaterial(a.mat.untextured_mat[h][n]);0==Object.keys(b[h][l][n]).length&&w.Log("ViewerView Warning: No sided materials to update");for(var p=0,s=Object.keys(b[h][l][n]),q=s.length;p<q;++p){var u=s[p];this.ReleaseMaterial(a.mat.textured_mat[h][n][u]);delete a.mat.textured_mat[h][n][u];delete b[h][l][n][u]}delete b[h][l][n]}delete b[h][l];delete b[h]}}delete a.boundmeshlist}else w.Log("ViewerView Warning: No meshes to update");
a.diff_texture&&a.diff_texture.dispose();a.spec_texture&&a.spec_texture.dispose();a.int_spec_texture&&a.int_spec_texture.dispose();a.normal_chan0_texture&&a.normal_chan0_texture.dispose();a.normal_chan1_texture&&a.normal_chan1_texture.dispose();a.diff_grating_texture&&a.diff_grating_texture.dispose();a.diff_grating_filter_texture&&a.diff_grating_filter_texture.dispose()}},ReleaseAllMaterialsAndTextures:function(){if(this.get("_renderercache")){this.ReleaseMaterial(this.get("_renderercache").materials.default_material);
this.ReleaseMaterial(this.get("_renderercache").materials.highlight);this.ReleaseMaterial(this.get("_renderercache").materials.edge);this.ReleaseMaterial(this.get("_renderercache").materials.colordepth);this.ReleaseMaterial(this.get("_renderercache").materials.D0ShaderMaterial);this.ReleaseMaterial(this.get("_renderercache").materials.D1ShaderMaterial);this.ReleaseMaterial(this.get("_renderercache").materials.D2ShaderMaterial);this.ReleaseMaterial(this.get("_renderercache").materials.BackdropShaderMaterial);
this.ReleaseMaterial(this.get("_renderercache").materials.ColorBlendShaderMaterial);this.ReleaseMaterial(this.get("_renderercache").materials.CopyShaderMaterial);for(var a=0,b=Object.keys(this.get("_renderercache").materials.materiallist),c=b.length;a<c;++a){var d=this.get("_renderercache").materials.materiallist[b[a]];this.ReleaseMaterialsAndTextures(d.front);this.ReleaseMaterialsAndTextures(d.back)}this.get("_renderercache").textures.Designer.irradiancemap.data&&this.get("_renderercache").textures.Designer.irradiancemap.data.dispose();
this.get("_renderercache").textures.Designer.envmap.glossy.data&&this.get("_renderercache").textures.Designer.envmap.glossy.data.dispose();this.get("_renderercache").textures.Designer.envmap.matte.data&&this.get("_renderercache").textures.Designer.envmap.matte.data.dispose();this.get("_renderercache").textures.Visualizer.irradiancemap.data&&this.get("_renderercache").textures.Visualizer.irradiancemap.data.dispose();if(this.get("_renderercache").textures.Visualizer.envmap.data)for(a=0;a<this.get("_renderercache").textures.Visualizer.envmap.data.length;a++)this.get("_renderercache").textures.Visualizer.envmap.data[a]&&
this.get("_renderercache").textures.Visualizer.envmap.data[a].dispose();this.get("_renderercache").textures.Visualizer.spectrum.data&&this.get("_renderercache").textures.Visualizer.spectrum.data.dispose()}},ReleaseGeomMatTex:function(a){if(a){var b=function(a){a instanceof d.Mesh&&a.geometry&&(a.geometry.dispose(),this.ReleaseMaterial(a.material))}.bind(this);a.traverse(b)}},ReleaseSGGeometriesAndMaterials:function(){this.ApplyFctToAllScenes(this.ReleaseGeomMatTex.bind(this))},ReleaseThreejsnodesReferences:function(){if(this.get("_renderercache")&&
this.get("_renderercache").hasOwnProperty("nodeviewproperties"))for(var a=this.get("_renderercache").nodeviewproperties,b=0,c=Object.keys(a),d=c.length;b<d;b++){for(var g=a[c[b]].threejsnodes,h=0,f=Object.keys(g),e=f.length;h<e;h++){for(var j=0,l=g[f[h]],m=l.length;j<m;j++)delete g[f[h]][l[j]];delete g[f[h]]}delete a[c[b]].threejsnodes;delete a[c[b]]}},ClearInstanceArrays:function(){this.TraverseAllScenes(function(a){a instanceof d.Mesh&&a.geometry instanceof d.InstancedBufferGeometry&&(a.geometry.attributes.inst_translation.jarray&&
(a.geometry.attributes.inst_translation.jarray=null),a.geometry.attributes.inst_rotation.jarray&&(a.geometry.attributes.inst_rotation.jarray=null),a.geometry.attributes.inst_scale.jarray&&(a.geometry.attributes.inst_scale.jarray=null))})},ApplyFctToAllScenes:function(a){a(this.get("_3JSsceneOp"));a(this.get("_3JSsceneOpDepth"));a(this.get("_3JSsceneOpaqueDiffuse"));if(this.get("_3JSsceneOpCoincidentGroupsPasses"))for(var b=0;b<this.get("_3JSsceneOpCoincidentGroupsPasses").length;++b){var c=this.get("_3JSsceneOpCoincidentGroupsPasses")[b];
a(this.get("_3JSsceneOpCoincidentGroups")[c]);a(this.get("_3JSsceneOpCoincidentGroupsDepth")[c]);a(this.get("_3JSsceneOpCoincidentGroupsDiffuse")[c])}a(this.get("_3JSsceneTransp"));a(this.get("_3JSsceneTranspDepth"));a(this.get("_3JSsceneTranspDiffuse"));if(this.get("_3JSsceneTranspCoincidentGroupsPasses"))for(b=0;b<this.get("_3JSsceneTranspCoincidentGroupsPasses").length;++b)c=this.get("_3JSsceneTranspCoincidentGroupsPasses")[b],a(this.get("_3JSsceneTranspCoincidentGroups")[c]),a(this.get("_3JSsceneTranspCoincidentGroupsDepth")[c]),
a(this.get("_3JSsceneTranspCoincidentGroupsDiffuse")[c]);a(this.get("_3JSsceneHightlights"));a(this.get("_3JSsceneLabels"))},TraverseAllScenes:function(a){this.get("_3JSsceneOp").traverse(a);this.get("_3JSsceneOpDepth").traverse(a);this.get("_3JSsceneOpaqueDiffuse").traverse(a);if(this.get("_3JSsceneOpCoincidentGroupsPasses"))for(var b=0;b<this.get("_3JSsceneOpCoincidentGroupsPasses").length;++b){var c=this.get("_3JSsceneOpCoincidentGroupsPasses")[b];this.get("_3JSsceneOpCoincidentGroups")[c].traverse(a);
this.get("_3JSsceneOpCoincidentGroupsDepth")[c].traverse(a);this.get("_3JSsceneOpCoincidentGroupsDiffuse")[c].traverse(a)}this.get("_3JSsceneTransp").traverse(a);this.get("_3JSsceneTranspDepth").traverse(a);this.get("_3JSsceneTranspDiffuse").traverse(a);if(this.get("_3JSsceneTranspCoincidentGroupsPasses"))for(b=0;b<this.get("_3JSsceneTranspCoincidentGroupsPasses").length;++b)c=this.get("_3JSsceneTranspCoincidentGroupsPasses")[b],this.get("_3JSsceneTranspCoincidentGroups")[c].traverse(a),this.get("_3JSsceneTranspCoincidentGroupsDepth")[c].traverse(a),
this.get("_3JSsceneTranspCoincidentGroupsDiffuse")[c].traverse(a);this.get("_3JSsceneHightlights").traverse(a);this.get("_3JSsceneLabels").traverse(a)},ReleaseScene:function(){this.ReleaseAllMaterialsAndTextures();this.ReleaseSGGeometriesAndMaterials();this.ReleaseThreejsnodesReferences();d.Cache.clear();this.set("_3JSsceneOp",null);this.set("_3JSsceneOpDepth",null);this.set("_3JSsceneOpaqueDiffuse",null);this.set("_3JSsceneTransp",null);this.set("_3JSsceneTranspDepth",null);this.set("_3JSsceneTranspDiffuse",
null);this.set("_3JSsceneHightlights",null);this.set("_3JSsceneLabels",null);this.set("_3JSsceneBBox",null);this.set("_3JSsceneBBoxFocus",null);this.set("_nodecounter",0);this.set("_geometrycounter",0);this.set("_labelCreationCallbackList",[]);this.set("_renderercache",null);this.set("_emptyTransparentScene",!0);this.set("_emptyOpaqueScene",!0);this.set("_3JSsceneOpCoincidentGroupsIds",{});this.set("_3JSsceneOpCoincidentGroupsPasses",[]);this.set("_3JSsceneNbOpCoincidentGroups",0);this.set("_3JSsceneTranspCoincidentGroupsIds",
{});this.set("_3JSsceneTranspCoincidentGroupsPasses",[]);this.set("_3JSsceneNbTranspCoincidentGroups",0)},ResetScene:function(a,b){this.ReleaseScene();this.set("_3JSsceneOp",new d.Scene);this.set("_3JSsceneOpCoincidentGroups",{});this.set("_3JSsceneOpDepth",new d.Scene);this.set("_3JSsceneOpCoincidentGroupsDepth",[]);this.set("_3JSsceneOpaqueDiffuse",new d.Scene);this.set("_3JSsceneOpCoincidentGroupsDiffuse",[]);this.set("_3JSsceneTransp",new d.Scene);this.set("_3JSsceneTranspCoincidentGroups",{});
this.set("_3JSsceneTranspDepth",new d.Scene);this.set("_3JSsceneTranspCoincidentGroupsDepth",[]);this.set("_3JSsceneTranspDiffuse",new d.Scene);this.set("_3JSsceneTranspCoincidentGroupsDiffuse",[]);this.set("_3JSsceneHightlights",new d.Scene);this.set("_3JSsceneLabels",new d.Scene);this.set("_3JSsceneBBox",new d.Box3);this.set("_3JSsceneBBoxFocus",new d.Box3);this.set("_renderercache",{nodeviewproperties:{},coplanarityepsilon:void 0!==a?a:0.2,boundaryhardedges:void 0!==b?b:!0,geometries:[],materials:{enablehighlights:!1,
enablehorizonhighlights:!0,enablehardedgehighlights:!0,enableirradiancemap:!0,enableenvmap:!0,defaultcolor:[30,30,30],default_material:{},materiallist:{},shaders:{}},labels:{visible:!0,list:{}},textures:{Designer:{path:"lighting_environments/designer_quality/",irradiancemap:{files:"irr_map_right.PNG irr_map_left.PNG irr_map_top.PNG irr_map_bottom.PNG irr_map_front.PNG irr_map_back.PNG".split(" "),data:null,loaded:!1},envmap:{glossy:{files:"env_map_glossy_right.PNG env_map_glossy_left.PNG env_map_glossy_top.PNG env_map_glossy_bottom.PNG env_map_glossy_front.PNG env_map_glossy_back.PNG".split(" "),
data:null,loaded:!1},matte:{files:"env_map_mate_right.PNG env_map_mate_left.PNG env_map_mate_top.PNG env_map_mate_bottom.PNG env_map_mate_front.PNG env_map_mate_back.PNG".split(" "),data:null,loaded:!1}},backdrop:{loaded:!1,data:null,original_width:null,original_height:null}},Visualizer:{path:"lighting_environments/visualizer_quality/",irradiancemap:{files:"cubic_irradiance_xpos.jpg cubic_irradiance_xneg.jpg cubic_irradiance_ypos.jpg cubic_irradiance_yneg.jpg cubic_irradiance_zpos.jpg cubic_irradiance_zneg.jpg".split(" "),
data:null,loaded:!1},envmap:{files:"cubic_blur_00_xpos.jpg cubic_blur_00_xneg.jpg cubic_blur_00_ypos.jpg cubic_blur_00_yneg.jpg cubic_blur_00_zpos.jpg cubic_blur_00_zneg.jpg cubic_blur_02_xpos.jpg cubic_blur_02_xneg.jpg cubic_blur_02_ypos.jpg cubic_blur_02_yneg.jpg cubic_blur_02_zpos.jpg cubic_blur_02_zneg.jpg cubic_blur_04_xpos.jpg cubic_blur_04_xneg.jpg cubic_blur_04_ypos.jpg cubic_blur_04_yneg.jpg cubic_blur_04_zpos.jpg cubic_blur_04_zneg.jpg cubic_blur_06_xpos.jpg cubic_blur_06_xneg.jpg cubic_blur_06_ypos.jpg cubic_blur_06_yneg.jpg cubic_blur_06_zpos.jpg cubic_blur_06_zneg.jpg cubic_blur_08_xpos.jpg cubic_blur_08_xneg.jpg cubic_blur_08_ypos.jpg cubic_blur_08_yneg.jpg cubic_blur_08_zpos.jpg cubic_blur_08_zneg.jpg".split(" "),
data:null,loaded:!1},spectrum:{file:"spectrum_00.png",data:null,loaded:!1,queried:!1},backdrop:{loaded:!1,data:null,original_width:null,original_height:null}},FromFile:{}},cameras:{defaultcamera:{cam_type:"PERSPECTIVE",azimuthAngle:0,elevationAngle:0,fieldOfView:30,scale:1,panOffset:{x:0,y:0}}},view_settings:{mode:1,model_xform:new d.Matrix4},camera_preset:{eye_position:null},environment_settings:{rotation:new d.Quaternion},lights:{},reflections:{enabled:!1,opacity:0.25,fade:!1,fade_size:1.2,fade_position:0.95},
hudelements:[],diagrams:[],viewports:[],animationkeyframes:[]});var c=d.UniformsUtils.clone(F.uniforms);c.diffuse.value=new d.Vector3(1,1,1);c.specular.value=new d.Vector3(0,0,0);this.get("_renderercache");var i=this.get("_renderercache").materials.enablehighlights&&__enableHardEdgeHighlights;this.get("_renderercache").materials.default_material=new d.ShaderMaterial({name:"designer",uniforms:c,vertexShader:F.vertexShader,fragmentShader:F.fragmentShader,depthTest:!0,vertexColors:d.FaceColors,side:d.FrontSide,
transparent:!1,defines:{},lights:!0,polygonOffset:!0,polygonOffsetFactor:i?this.get("_polygon_offset_factor"):0,polygonOffsetUnits:i?this.get("_polygon_offset_units"):0});c=this.get("_renderercache").materials.defaultcolor;c=new d.LineBasicMaterial({color:(c[0]<<16)+(c[1]<<8)+c[2],linewidth:1,depthTest:!0});this.get("_renderercache").materials.highlight=c;c=new d.LineBasicMaterial({color:0,linewidth:1,depthTest:!0});this.get("_renderercache").materials.blackhighlight=c;this.AddDirectionalAndAmbientLightsToScene(this.get("_3JSsceneOp"),
"cg_0",!1);this.AddDirectionalAndAmbientLightsToScene(this.get("_3JSsceneTransp"),"cg_0",!0);this.set("_InitialisedSceneSettings",!1);this.set("_QueriedGlobalTextures",!1);this.set("_TextureSizeWarningMessageDisplayed",!1);this.set("_TextureSizeByPass",!1);this.set("_SceneLoaded",!1);this.set("_parsedEntireSceneGraphOnce",!1)},AddDirectionalAndAmbientLightsToScene:function(a,b,c){this.get("_renderercache").lights.dir_light||(this.get("_renderercache").lights.dir_light={});var i=new d.DirectionalLight(11184810,
0.5);this.get("_renderercache").lights.dir_light[(c?"tr_":"")+b]=i;a.add(i);this.get("_renderercache").lights.amb_light||(this.get("_renderercache").lights.amb_light={});i=new d.AmbientLight(8947848);this.get("_renderercache").lights.amb_light[(c?"tr_":"")+b]=i;a.add(i)},InitOpaqueCoincidentGroupScene:function(a){this.get("_3JSsceneOpCoincidentGroups").hasOwnProperty(a)||(this.get("_3JSsceneOpCoincidentGroups")[a]=new d.Scene,this.AddDirectionalAndAmbientLightsToScene(this.get("_3JSsceneOpCoincidentGroups")[a],
a,!1),this.get("_3JSsceneOpCoincidentGroupsDepth")[a]=new d.Scene,this.get("_3JSsceneOpCoincidentGroupsDiffuse")[a]=new d.Scene)},InitTransparentCoincidentGroupScene:function(a){this.get("_3JSsceneTranspCoincidentGroups").hasOwnProperty(a)||(this.get("_3JSsceneTranspCoincidentGroups")[a]=new d.Scene,this.AddDirectionalAndAmbientLightsToScene(this.get("_3JSsceneTranspCoincidentGroups")[a],a,!0),this.get("_3JSsceneTranspCoincidentGroupsDepth")[a]=new d.Scene,this.get("_3JSsceneTranspCoincidentGroupsDiffuse")[a]=
new d.Scene)},CreateLabels:function(){for(var a=0;a<this.get("_labelCreationCallbackList").length;++a)this.get("_labelCreationCallbackList")[a]();this.CreateSprites()},PostSceneLoadActions:function(){this.set("_SceneLoaded",!0);this.get("_3DObjectHandler").ClearBuildMaps();this.ClearInstanceArrays();this.CreateLabels();this.CameraUpdate(!0)},CheckPostSceneLoadActions:function(){var a=this.get("_model").get("_assetmanager").get("_queriedassetnumber"),b=this.get("_model").get("_assetmanager").get("_resolvedassetnumber"),
c=this.get("_model").get("_assetmanager").get("_textureCounter"),d=this.get("_model").get("_assetmanager").get("_textureLoadedCounter"),g=100*(d/c);a==b&&c==d&&this.PostSceneLoadActions();return g},AddedResource:function(){this.ResetShaders();this.SetUpScene();this.get("_build_scene_exec_queue").whenFinished(function(){this.UpdateReflectionUniforms();0==this.get("_model").get("_assetmanager").get("_textureCounter")&&this.get("_model").get("_assetmanager").get("_queriedassetnumber")==this.get("_model").get("_assetmanager").get("_resolvedassetnumber")&&
this.PostSceneLoadActions();this.Render();this.NotifySceneBuildProgress(100,0,0)},this)},GetFileList:function(a,b){for(var c=[],d=0,g=Object.keys(b),h=g.length;d<h;++d)c.push(a+b[g[d]]);return c},CheckTextureSizeByPass:function(a){var b=!0;if(a.image.naturalHeight>L.textureSupport.MAX_NATURAL_HEIGHT||a.image.naturalWidth>L.textureSupport.MAX_NATURAL_WIDTH)this.get("_TextureSizeWarningMessageDisplayed")?b=this.get("_TextureSizeByPass"):(b=window.confirm("WARNING ! Some textures have a size greater than "+
L.textureSupport.MAX_NATURAL_WIDTH+"x"+L.textureSupport.MAX_NATURAL_HEIGHT+". This might not be supported by your system and you might experience browser or graphics card crashes."),this.set("_TextureSizeWarningMessageDisplayed",!0),this.set("_TextureSizeByPass",b));return b},StartAsyncTextureLoad:function(a,b,c,i,g,h,f,e){if(b.front.hasOwnProperty(c)&&b.front[c]&&a.hasOwnProperty(b.front[c])){var j=a[b.front[c]],l=j.Properties.hasOwnProperty("remapped_alpha_channel")?y.get("toBool")(j.Properties.remapped_alpha_channel):
!1,m=function(a){this.get("_build_scene_exec_queue").whenFinished(function(){var b=this.CheckTextureSizeByPass(a);this.get("_model").get("_assetmanager").IncrementTextureLoadCounter();var c=this.CheckPostSceneLoadActions();if(b&&g){var d,h;d=h=1;g.hasOwnProperty("originalTexWidth")&&(d=(g.originalTexWidth-1)/a.image.naturalWidth);g.hasOwnProperty("originalTexHeight")&&(h=(g.originalTexHeight-1)/a.image.naturalHeight);a.repeat.set(d,h);a.remappedAlphaChannel=l;g[i]=a;this.UpdateTexturedMaterial(g);
this.Render()}this.NotifySceneBuildProgress(100,c,b?0:1)},this)}.bind(this),k=this.NotifyResourceQueryErrorCallback(2,"Texture"),r;r=this.get("_model").get("_assetmanager").get("_assetloader").get("_httprequestmanager").IsAbsoluteURL(j.Properties.filepath)?j.Properties.filepath:h+j.Properties.filepath;a=function(a){var b=new d.TextureLoader;b.crossOrigin="";a=b.load(a,function(a){m(a)},void 0,k);a.name=r;a.format=f;a.unpackAlignment=e;a.anisotropy=16;this.SelectTextureWrappingMode(a,j.Properties,
g)}.bind(this);this.get("_model").get("_assetmanager").IncrementTextureQueryCounter(1);this.get("_model").get("_assetmanager").GetURLPreprocessCallback()(r,a);this.get("_renderercache").textures.FromFile.hasOwnProperty(r)||(this.get("_renderercache").textures.FromFile[r]=null);return!0}return!1},StartAsyncGlobalTextureLoad:function(a,b){if(this.get("_renderercache").textures[this.get("_RenderingQuality")][a]){var c=function(a){this.get("_model").get("_assetmanager").IncrementTextureLoadCounter();
var b=this.CheckPostSceneLoadActions();this.Render();a=this.CheckTextureSizeByPass(a);this.NotifySceneBuildProgress(100,b,a?0:1)}.bind(this),i=function(b){this.get("_build_scene_exec_queue").whenFinished(function(){this.get("_renderercache").textures[this.get("_RenderingQuality")][a].loaded=!0;this.UpdateMaterialsGlobalLighting();c(b)},this)}.bind(this),g=function(a){this.get("_build_scene_exec_queue").whenFinished(function(){this.get("_renderercache").textures[this.get("_RenderingQuality")].envmap.glossy.loaded=
!0;this.UpdateMaterialsGlobalLighting();c(a)},this)}.bind(this),h=function(a){this.get("_build_scene_exec_queue").whenFinished(function(){this.get("_renderercache").textures[this.get("_RenderingQuality")].envmap.matte.loaded=!0;this.UpdateMaterialsGlobalLighting();c(a)},this)}.bind(this),f=function(b){this.get("_build_scene_exec_queue").whenFinished(function(){this.get("_renderercache").textures[this.get("_RenderingQuality")][a].loaded=!0;c(b)},this)}.bind(this),e=this.NotifyResourceQueryErrorCallback(2,
"Texture"),j=function(a,b,c,i){for(var h=[],g=function(f){h.push(f);if(h.length==a.length)switch(f=(new d.CubeTextureLoader).load(h,i,void 0,e),f.format=d.RGBFormat,b){case "irradiancemap":this.get("_renderercache").textures[this.get("_RenderingQuality")][b].data=f;break;case "envmap":switch(this.get("_RenderingQuality")){case "Designer":this.get("_renderercache").textures[this.get("_RenderingQuality")][b][c].data=f;break;case "Visualizer":this.get("_renderercache").textures[this.get("_RenderingQuality")][b].data[c]=
f}}}.bind(this),f=0,j=Object.keys(a),l=a.length;f<l;++f)this.get("_model").get("_assetmanager").GetURLPreprocessCallback()(a[j[f]],g)}.bind(this);switch(a){default:w.Log("ViewerView Warning: Unhandled global texture type: default to irradiancemap");case "irradiancemap":h=this.GetFileList(b,this.get("_renderercache").textures[this.get("_RenderingQuality")][a].files);j(h,a,null,i);this.get("_model").get("_assetmanager").IncrementTextureQueryCounter(1);break;case "envmap":switch(this.get("_RenderingQuality")){case "Designer":var l=
this.GetFileList(b,this.get("_renderercache").textures[this.get("_RenderingQuality")][a].glossy.files);j(l,a,"glossy",g);g=this.GetFileList(b,this.get("_renderercache").textures[this.get("_RenderingQuality")][a].matte.files);j(g,a,"matte",h);this.get("_model").get("_assetmanager").IncrementTextureQueryCounter(2);break;case "Visualizer":this.get("_renderercache").textures[this.get("_RenderingQuality")][a].data={};this.get("_renderercache").textures[this.get("_RenderingQuality")][a].loaded={};h=function(d){var i=
function(b){this.get("_build_scene_exec_queue").whenFinished(function(){this.get("_renderercache").textures[this.get("_RenderingQuality")][a].loaded[d]=!0;this.UpdateMaterialsGlobalLighting();c(b)},this)}.bind(this),h=this.GetFileList(b,this.get("_renderercache").textures[this.get("_RenderingQuality")][a].files.slice(6*d,6*(d+1)));j(h,a,d,i)}.bind(this);for(g=0;5>g;++g)h(g);this.get("_model").get("_assetmanager").IncrementTextureQueryCounter(5)}break;case "spectrum":var m=b+this.get("_renderercache").textures[this.get("_RenderingQuality")][a].file,
h=function(b){b=(new d.TextureLoader).load(b,i,void 0,e);b.format=d.RGBFormat;b.name=m;this.get("_renderercache").textures[this.get("_RenderingQuality")][a].data=b}.bind(this);this.get("_model").get("_assetmanager").IncrementTextureQueryCounter(1);this.get("_model").get("_assetmanager").GetURLPreprocessCallback()(m,h);break;case "backdrop":h=function(c){var i=new d.TextureLoader;i.crossOrigin="";c=i.load(c,f,void 0,e);c.format=d.RGBFormat;c.name=b;this.get("_renderercache").textures[this.get("_RenderingQuality")][a].data=
c}.bind(this),this.get("_model").get("_assetmanager").IncrementTextureQueryCounter(1),this.get("_model").get("_assetmanager").GetURLPreprocessCallback()(b,h)}}},InitializeSceneSettings:function(a){if(!this.get("_InitialisedSceneSettings")){this.set("_RenderingQuality","Designer");this.set("_EnvironmentName","Office");if(a.Properties){if(a.Properties.hasOwnProperty("rendering_quality")&&(A.get("_fullSupportFloatingPointTextures")||A.get("_fullSupportHFloatingPointTextures")))this.set("_RenderingQuality",
a.Properties.rendering_quality),a.Properties.hasOwnProperty("environment_name")&&(this.set("_EnvironmentName",a.Properties.environment_name),this.get("_renderercache").textures.Visualizer.path=this.get("_renderercache").textures.Visualizer.path+a.Properties.environment_name+"/");a.Properties.hasOwnProperty("reflection_settings")&&(this.get("_renderercache").reflections.enabled=a.Properties.reflection_settings.hasOwnProperty("reflective_table_enabled")?y.get("toBool")(a.Properties.reflection_settings.reflective_table_enabled):
!1,this.get("_renderercache").reflections.enabled&&(this.get("_renderercache").reflections.opacity=a.Properties.reflection_settings.hasOwnProperty("reflection_opacity")?parseFloat(a.Properties.reflection_settings.reflection_opacity):0.25,a.Properties.reflection_settings.hasOwnProperty("reflection_fade_size")&&a.Properties.reflection_settings.hasOwnProperty("reflection_fade_position")&&(this.get("_renderercache").reflections.fade=!0,this.get("_renderercache").reflections.fade_size=parseFloat(a.Properties.reflection_settings.reflection_fade_size),
this.get("_renderercache").reflections.fade_position=parseFloat(a.Properties.reflection_settings.reflection_fade_position))))}this.LoadBackdrop(a);this.set("_InitialisedSceneSettings",!0)}},UpdateSceneSettings:function(){if(this.get("_renderercache").camera_preset.eye_position){this.CameraUpdate(!1);var a=this.get("_3JSsceneBBox").center(),b=this.get("_3JScamera").position,c=this.get("_renderercache").camera_preset.eye_position.clone(),a=a.clone().sub(b),d=a.clone().multiplyScalar(c.clone().sub(b).dot(a)),
g=this.get("_3JScamera").up,h=a.clone().normalize().cross(g),h=h.clone().multiplyScalar(c.clone().sub(b).dot(h)),b=g.clone().multiplyScalar(c.clone().sub(b).dot(g));this.SetCameraPanOffset({x:h.length(),y:b.length()},!1);b=a.length();a=a.clone().sub(d).length();this.SetCameraScale(a/b)}},LoadGlobalLightingTextures:function(){if(!this.get("_QueriedGlobalTextures")){var a=this.get("_resourcePath")+"/"+this.get("_renderercache").textures[this.get("_RenderingQuality")].path;this.get("_renderercache").materials.enableirradiancemap&&
this.StartAsyncGlobalTextureLoad("irradiancemap",a);this.get("_renderercache").materials.enableenvmap&&this.StartAsyncGlobalTextureLoad("envmap",a);this.set("_QueriedGlobalTextures",!0)}},LoadBackdrop:function(a){if(a.Properties&&a.Properties.hasOwnProperty("backdrop"))if("COLOR"===a.Properties.backdrop.type)a=a.Properties.backdrop.color,this.SetBackgroundColor(a[0],a[1],a[2],1,!1);else if("IMAGE"===a.Properties.backdrop.type){var a=a.Assets[a.Properties.backdrop.image_tex].Properties,b;this.get("_model").get("_assetmanager").get("_assetloader").get("_httprequestmanager").IsAbsoluteURL(a.filepath)?
b=a.filepath:(b=this.get("_model").get("SceneId"),b=b.substring(0,b.lastIndexOf("/")+1)+a.filepath);this.StartAsyncGlobalTextureLoad("backdrop",b);this.get("_renderercache").textures[this.get("_RenderingQuality")].backdrop.original_height=a.original_height;this.get("_renderercache").textures[this.get("_RenderingQuality")].backdrop.original_width=a.original_width;this.get("_renderercache").textures[this.get("_RenderingQuality")].backdrop.enabled=!0}else w.Log("ViewerView Warning: Backdrop type not supported (default to grey)."),
this.SetBackgroundColor(0.37,0.37,0.37,1,!1);else this.SetBackgroundColor(0.37,0.37,0.37,1,!1)},SetUpScene:function(){ba.start("Scene Hierarchy Creation");this.CreateTHREEJSObjectHierarchy();ba.stop("Scene Hierarchy Creation");this.get("_build_scene_exec_queue").whenFinished(function(){var a=new d.Box3;a.setFromObject(this.get("_3JSsceneOp"));for(var b=0;b<this.get("_3JSsceneOpCoincidentGroupsPasses").length;++b){var c=new d.Box3,i=this.get("_3JSsceneOpCoincidentGroupsPasses")[b];c.setFromObject(this.get("_3JSsceneOpCoincidentGroups")[i]);
a.union(c)}b=new d.Box3;b.setFromObject(this.get("_3JSsceneTransp"));a.union(b);for(b=0;b<this.get("_3JSsceneTranspCoincidentGroupsPasses").length;++b)c=new d.Box3,i=this.get("_3JSsceneTranspCoincidentGroupsPasses")[b],c.setFromObject(this.get("_3JSsceneTranspCoincidentGroups")[i]),a.union(c);this.set("_3JSsceneBBox",a);this.set("_3JSsceneBBoxFocus",a);this.SetupReflections();this.CameraUpdate(!1);this.set("_InitialDistanceToSceneCenter",this.get("_3JSsceneBBox").center().clone().sub(this.get("_3JScamera").position).length())},
this)},CreateSprites:function(){for(var a=0,b=Object.keys(this.get("_renderercache").labels.list),c=b.length;a<c;++a){var i=this.get("_renderercache").labels.list[b[a]],g=this.get("_textSpriteMaker").MakeTextSprite(i.text,i.display_style,new d.Vector3(0,0,0),!1,!1,!1,!1,!1,!1,i.orientation);this.get("_3JSsceneLabels").add(g);i.threejs_sprite=g}},SetupReflections:function(){var a=new d.Matrix4;a.set(1,0,0,0,0,-1,0,0,0,0,1,0,0,0,0,1);this.set("_reflection_Y_scale",a);this.set("_mirror_offset",0.01);
var a=2*this.get("_3JSsceneBBox").min.y-this.get("_mirror_offset"),b=new d.Matrix4;b.makeTranslation(0,a,0);this.set("_reflection_Y_translation",b);b=new d.Matrix4;b.makeTranslation(0,-a,0);this.set("_reflection_Y_opp_translation",b)},AddUIElement:function(a){"function"===typeof this.get("_clientUIAddElementCallback")?this.get("_clientUIAddElementCallback").apply(null,arguments):w.Log("ViewerView Warning: Client callback not a function")},CreateTHREEJSObjectHierarchy:function(){this.get("_3DObjectHandler")||
this.set("_3DObjectHandler",new fa(this.get("_build_scene_exec_queue")));this.get("_3DObjectHandler").set("_geometrycounter",0);this.get("_build_scene_exec_queue").run(function(){},this);this.get("_build_scene_exec_queue").run(function(){var a=this.get("_model").get("_assetmanager").get("_cache"),b=this.get("_model").get("SceneId");this.InitializeSceneSettings(a.rootnodes[b])},this);this.get("_build_scene_exec_queue").run(function(){this.LoadGlobalLightingTextures()},this);this.get("_build_scene_exec_queue").run(function(){w.Log("Building Surfaces...")},
this);this.get("_build_scene_exec_queue").whenFinished(function(){w.Log("Finished Building Surfaces.")},this);this.get("_build_scene_exec_queue").run(function(){var a=this.get("_model").get("_assetmanager").get("_cache"),b=this.get("_model").get("SceneId");this.BuildOpaqueScenes(a.rootnodes[b],b)},this);this.get("_build_scene_exec_queue").run(function(){for(var a=this.get("_model").get("_assetmanager").get("_cache"),b=this.get("_model").get("SceneId"),a=a.rootnodes[b],c=0;c<this.get("_3JSsceneOpCoincidentGroupsPasses").length;++c){var d=
this.get("_3JSsceneOpCoincidentGroupsPasses")[c];this.BuildOpaqueScenes(a,b,d)}},this);this.get("_build_scene_exec_queue").run(function(){if(!this.get("_emptyTransparentScene")){var a=this.get("_model").get("_assetmanager").get("_cache"),b=this.get("_model").get("SceneId"),a=a.rootnodes[b];this.BuildTransparentScenes(a,b);for(var c=0;c<this.get("_3JSsceneTranspCoincidentGroupsPasses").length;++c){var d=this.get("_3JSsceneTranspCoincidentGroupsPasses")[c];this.BuildTransparentScenes(a,b,d)}}},this);
this.get("_build_scene_exec_queue").run(function(){this.UpdateLightingContrast()},this);this.get("_build_scene_exec_queue").run(function(){var a=this.get("_model").get("_assetmanager").get("_cache"),b=this.get("_model").get("SceneId"),a=this.GetTHREEJSObjectHierarchy(a.rootnodes[b],"highlightnode",b,b);a.newlycreated&&this.get("_3JSsceneHightlights").add(a.node);this.set("_geometrycounter",this.get("_geometrycounter")+this.get("_3DObjectHandler").get("_geometrycounter"));w.Log(this.get("_nodecounter")+
" nodes have been created for this scene");w.Log(this.get("_geometrycounter")+" geometries have been created for this scene")},this)},CopyRestOfLabelProperties:function(a,b){b.hasOwnProperty("text")&&b.text&&(a.text=b.text);b.hasOwnProperty("orientation")&&b.orientation&&(a.orientation=b.orientation);b.hasOwnProperty("preferred_loc_h")&&b.preferred_loc_h&&(a.preferred_loc_h=b.preferred_loc_h);b.hasOwnProperty("preferred_loc_v")&&b.preferred_loc_v&&(a.preferred_loc_v=b.preferred_loc_v);b.hasOwnProperty("pixel_offset")&&
b.pixel_offset&&(a.pixel_offset=b.pixel_offset)},SetLabelProperties:function(a,b){if(b.hasOwnProperty("display_style")&&b.display_style){var c=b.display_style;c.hasOwnProperty("fontface")&&c.fontface&&(a.display_style.fontface=c.fontface);c.hasOwnProperty("fontsize")&&c.fontsize&&(a.display_style.fontsize=c.fontsize);c.hasOwnProperty("borderThickness")&&c.borderThickness&&(a.display_style.borderThickness=c.borderThickness);c.hasOwnProperty("borderColor")&&c.borderColor&&(a.display_style.borderColor=
c.borderColor);c.hasOwnProperty("backgroundColor")&&c.backgroundColor&&(a.display_style.backgroundColor=c.backgroundColor);c.hasOwnProperty("color")&&c.color&&(a.display_style.color=c.color)}this.CopyRestOfLabelProperties(a,b);c=a.threejs_sprite.visible;this.get("_3JSsceneLabels").remove(a.threejs_sprite);var i=this.get("_textSpriteMaker").MakeTextSprite(a.text,a.display_style,new d.Vector3(0,0,0),!1,!1,!1,!1,!1,!1,a.orientation);this.get("_3JSsceneLabels").add(i);a.threejs_sprite=i;a.threejs_sprite.visible=
b.hasOwnProperty("visible")?y.get("toBool")(b.visible):c},UpdateLabelProperties:function(a,b){var c=this.URLToKeyString(a);if(!(c in this.get("_renderercache").labels.list))return!1;c=this.get("_renderercache").labels.list[c];if(void 0===c)throw"UpdateLabelProperties: Cannot find requested label";this.SetLabelProperties(c,b);this.CameraUpdate(!0);return!0},UpdateAllLabelsProperties:function(a){for(var b=0,c=Object.keys(this.get("_renderercache").labels.list),d=c.length;b<d;++b){var g=this.get("_renderercache").labels.list[c[b]];
if(void 0===g)throw"UpdateAllLabelsProperties: Cannot find intended label!";this.SetLabelProperties(g,a)}0<b&&this.CameraUpdate(!0);return 0<b},DeduceLabelEdgesFromBoundingBox:function(a,b,c){if("x_axis"==a||"xyz_axes"==a)b.edge_list[0]=[c.min.x,c.min.y,c.min.z,c.max.x,c.min.y,c.min.z],b.edge_list[1]=[c.min.x,c.min.y,c.max.z,c.max.x,c.min.y,c.max.z],b.edge_list[2]=[c.min.x,c.max.y,c.max.z,c.max.x,c.max.y,c.max.z],b.edge_list[3]=[c.min.x,c.max.y,c.min.z,c.max.x,c.max.y,c.min.z];if("y_axis"==a||"xyz_axes"==
a){var d=0;"xyz_axes"==a&&(d=4);b.edge_list[d]=[c.max.x,c.min.y,c.max.z,c.max.x,c.min.y,c.min.z];b.edge_list[d+1]=[c.max.x,c.max.y,c.max.z,c.max.x,c.max.y,c.min.z];b.edge_list[d+2]=[c.min.x,c.max.y,c.max.z,c.min.x,c.max.y,c.min.z];b.edge_list[d+3]=[c.min.x,c.min.y,c.max.z,c.min.x,c.min.y,c.min.z]}if("z_axis"==a||"xyz_axes"==a)d=0,"xyz_axes"==a&&(d=8),b.edge_list[d]=[c.min.x,c.min.y,c.max.z,c.min.x,c.max.y,c.max.z],b.edge_list[d+1]=[c.max.x,c.min.y,c.max.z,c.max.x,c.max.y,c.max.z],b.edge_list[d+2]=
[c.max.x,c.min.y,c.min.z,c.max.x,c.max.y,c.min.z],b.edge_list[d+3]=[c.min.x,c.min.y,c.min.z,c.min.x,c.max.y,c.min.z]},LoadLabel:function(a,b,c,i,g,h,f){if(!("Label"!=c.AssetType||!c.hasOwnProperty("Properties")||null==c.Properties)){var e=c.Properties,c={text:e.text,orientation:e.orientation,preferred_loc_h:e.preferred_loc_h,preferred_loc_v:e.preferred_loc_v,edge_list:[],point_list:[],ellipse:{center:null,radius1_vec:null,radius2_vec:null},bounds_type:null,threejs_sprite:null,display_style:null,pixel_offset:null};
e.hasOwnProperty("display_style")&&e.display_style?c.display_style=a.Properties.label_display_styles[e.display_style]:a.Properties.hasOwnProperty("label_display_styles")&&a.Properties.label_display_styles&&(c.display_style=a.Properties.label_display_styles.default_style);c.pixel_offset=e.hasOwnProperty("pixel_offset")&&e.pixel_offset?e.pixel_offset:[0,0];if(e.hasOwnProperty("edge_list")&&e.edge_list){c.bounds_type="edge_list";for(var f=0,j=Object.keys(e.edge_list),l=j.length;f<l;++f)c.edge_list[f]=
JSON.parse(JSON.stringify(e.edge_list[j[f]])),h.applyToVector3Array(c.edge_list[f])}else if(e.hasOwnProperty("point_list")&&e.point_list){c.bounds_type="point_list";f=0;j=Object.keys(e.point_list);for(l=j.length;f<l;++f)c.point_list[f]=JSON.parse(JSON.stringify(e.point_list[j[f]])),h.applyToVector3Array(c.point_list[f])}else if(e.hasOwnProperty("ellipse")&&e.ellipse)c.bounds_type="ellipse",c.ellipse.center=JSON.parse(JSON.stringify(e.ellipse.center)),c.ellipse.radius1_vec=JSON.parse(JSON.stringify(e.ellipse.radius1_vec)),
c.ellipse.radius2_vec=JSON.parse(JSON.stringify(e.ellipse.radius2_vec)),h.applyToVector3Array(c.ellipse.center),e=new d.Matrix3,e.setFromMatrix4(h),e.applyToVector3Array(c.ellipse.radius1_vec),e.applyToVector3Array(c.ellipse.radius2_vec);else if(e.hasOwnProperty("bounding_box")&&e.bounding_box)c.bounds_type="edge_list",h=new d.Box3,h.setFromObject(f.node),this.DeduceLabelEdgesFromBoundingBox(e.bounding_box,c,h);else{w.Log("Invalid bounds specification in Label asset: "+i);return}if(g instanceof Object&&
0!=Object.keys(g).length&&g.hasOwnProperty(i)){g=g[i];if(!g)return;g.hasOwnProperty("display_style")&&g.display_style&&(c.display_style=a.Properties.label_display_styles[g.display_style]);this.CopyRestOfLabelProperties(c,g)}a=this.URLToKeyString(b);this.get("_renderercache").labels.list[a]=c;this.AddUIElement(a,!0);w.Log("Built Label asset: "+i)}},BuildOpaqueScenes:function(a,b,c){var d=this.GetTHREEJSObjectHierarchy(a,"opaque_pass",b,b,c),g=this.GetTHREEJSObjectHierarchy(a,"depth_pass",b,b,c),a=
this.GetTHREEJSObjectHierarchy(a,"opaque_diffuse_pass",b,b,c);void 0===c?(d.newlycreated&&(d.node.applyMatrix(this.get("_renderercache").view_settings.model_xform),this.get("_3JSsceneOp").add(d.node)),g.newlycreated&&(g.node.applyMatrix(this.get("_renderercache").view_settings.model_xform),this.get("_3JSsceneOpDepth").add(g.node)),a.newlycreated&&(a.node.applyMatrix(this.get("_renderercache").view_settings.model_xform),this.get("_3JSsceneOpaqueDiffuse").add(a.node))):(this.InitOpaqueCoincidentGroupScene(c),
d.newlycreated&&(d.node.applyMatrix(this.get("_renderercache").view_settings.model_xform),this.get("_3JSsceneOpCoincidentGroups")[c].add(d.node)),g.newlycreated&&(g.node.applyMatrix(this.get("_renderercache").view_settings.model_xform),this.get("_3JSsceneOpCoincidentGroupsDepth")[c].add(g.node)),a.newlycreated&&(a.node.applyMatrix(this.get("_renderercache").view_settings.model_xform),this.get("_3JSsceneOpCoincidentGroupsDiffuse")[c].add(a.node)))},BuildTransparentScenes:function(a,b,c){var d=this.GetTHREEJSObjectHierarchy(a,
"transparent_pass",b,b,c),g=this.GetTHREEJSObjectHierarchy(a,"transp_depth_pass",b,b,c),a=this.GetTHREEJSObjectHierarchy(a,"transp_diffuse_pass",b,b,c);void 0===c?(d.newlycreated&&this.get("_3JSsceneTransp").add(d.node),g.newlycreated&&this.get("_3JSsceneTranspDepth").add(g.node),a.newlycreated&&this.get("_3JSsceneTranspDiffuse").add(a.node)):(this.InitTransparentCoincidentGroupScene(c),d.newlycreated&&this.get("_3JSsceneTranspCoincidentGroups")[c].add(d.node),g.newlycreated&&this.get("_3JSsceneTranspCoincidentGroupsDepth")[c].add(g.node),
a.newlycreated&&this.get("_3JSsceneTranspCoincidentGroupsDiffuse")[c].add(a.node))},SetNonEmptyScene:function(a){a?this.set("_emptyTransparentScene",!1):this.set("_emptyOpaqueScene",!1)},CreateNewCoincidentGroupPass:function(a,b){b?this.get("_3JSsceneTranspCoincidentGroupsIds").hasOwnProperty(a)||(this.get("_3JSsceneTranspCoincidentGroupsIds")[a]={},this.get("_3JSsceneTranspCoincidentGroupsPasses").push(a)):this.get("_3JSsceneOpCoincidentGroupsIds").hasOwnProperty(a)||(this.get("_3JSsceneOpCoincidentGroupsIds")[a]=
{},this.get("_3JSsceneOpCoincidentGroupsPasses").push(a))},AsynchronousLightLoad:function(a){this.get("_build_scene_exec_queue").whenFinished(function(){this.get("_renderercache").lights.holo_light=a;this.UpdateMaterialsGlobalLighting();this.get("_model").get("_assetmanager").IncrementTextureLoadCounter();var b=this.CheckPostSceneLoadActions();this.Render();this.NotifySceneBuildProgress(100,b,0)},this)},SelectTextureWrappingMode:function(a,b,c){b.hasOwnProperty("original_width")&&(c.originalTexWidth=
parseFloat(b.original_width));b.hasOwnProperty("original_height")&&(c.originalTexHeight=parseFloat(b.original_height));switch(b.swrap){default:case "GL_REPEAT":a.wrapS=d.RepeatWrapping;break;case "GL_CLAMP":case "GL_CLAMP_TO_BORDER":case "GL_CLAMP_TO_EDGE":a.wrapS=d.ClampToEdgeWrapping}switch(b.twrap){default:case "GL_REPEAT":a.wrapT=d.RepeatWrapping;break;case "GL_CLAMP":case "GL_CLAMP_TO_BORDER":case "GL_CLAMP_TO_EDGE":a.wrapT=d.ClampToEdgeWrapping}},LoadMaterial:function(a,b,c,i,g){if("Material"==
a.AssetType){if(a.hasOwnProperty("Properties")){var a=a.Properties,h=1,f=1,e=1,j=1,l=1,m=1,k=1,r=1,n=1;a.front.hasOwnProperty("diffuse")&&(h=a.front.diffuse[0],f=a.front.diffuse[1],e=a.front.diffuse[2]);a.front.hasOwnProperty("specular")&&(j=a.front.specular[0],l=a.front.specular[1],m=a.front.specular[2]);a.front.hasOwnProperty("ambient")&&(k=a.front.ambient[0],r=a.front.ambient[1],n=a.front.ambient[2]);var h=new d.Color(h,f,e),j=new d.Color(j,l,m),n=new d.Color(k,r,n),l=a.front.hasOwnProperty("shininess")?
z.clamp(parseFloat(a.front.shininess),0,1):0.5,m=a.hasOwnProperty("double_sided")?y.get("toBool")(a.double_sided):!1,f=a.hasOwnProperty("opacity")?z.clamp(parseFloat(a.opacity),0,1):1,e=a.front.hasOwnProperty("double_grating")?y.get("toBool")(a.front.double_grating):!1,p=a.front.hasOwnProperty("grating_spacing_scale")?parseFloat(a.front.grating_spacing_scale):null,s=a.front.hasOwnProperty("default_diff_haze")?parseFloat(a.front.default_diff_haze):null,q=a.front.hasOwnProperty("default_diff_spacing")?
parseFloat(a.front.default_diff_spacing):null,r=(k=a.front.hasOwnProperty("diff_grating_tex")||a.front.hasOwnProperty("diff_grating_filter_tex"))||a.front.hasOwnProperty("int_specular_tex")||a.front.hasOwnProperty("normal_chan0_tex")||a.front.hasOwnProperty("normal_chan1_tex"),u=!1;a.front.hasOwnProperty("diffuse_tex")&&b[a.front.diffuse_tex].Properties.hasOwnProperty("transparent")&&(f=(u=y.get("toBool")(b[a.front.diffuse_tex].Properties.transparent))?0.5:f);i={mat:{untextured_mat:null,textured_mat:{}},
boundmeshlist:null,reflectance_model:a.reflectance_model,diff_texture:null,spec_texture:null,int_spec_texture:null,normal_chan0_texture:null,normal_chan1_texture:null,diff_grating_texture:null,diff_grating_filter_texture:null,diff_col:h,spec_col:j,amb_col:n,shininess:l,double_sided:m,opacity:f,transp_texture:u,double_grating:e,grating_spacing_scale:p,default_diff_haze:s,default_diff_spacing:q,holographic:k,printable:r,backTexture:i,flipNormals:g};g=this.CreateMaterial(i);i.mat.untextured_mat=g;c=
this.get("_model").get("_assetmanager").get("_assetloader").get("_httprequestmanager").IsAbsoluteURL(c)?c.substring(0,c.lastIndexOf("/")+1):this.get("_resourcePath")+"/";this.StartAsyncTextureLoad(b,a,"diffuse_tex","diff_texture",i,c,r?d.RGBAFormat:d.RGBFormat,4);this.StartAsyncTextureLoad(b,a,"specular_tex","spec_texture",i,c,d.RGBAFormat,4);"Visualizer"==this.get("_RenderingQuality")&&(this.StartAsyncTextureLoad(b,a,"int_specular_tex","int_spec_texture",i,c,d.RGBAFormat,4),this.StartAsyncTextureLoad(b,
a,"normal_chan0_tex","normal_chan0_texture",i,c,d.RGBFormat,1),this.StartAsyncTextureLoad(b,a,"normal_chan1_tex","normal_chan1_texture",i,c,d.RGBFormat,1),this.StartAsyncTextureLoad(b,a,"diff_grating_tex","diff_grating_texture",i,c,d.RGBAFormat,4)&&this.StartAsyncTextureLoad(b,a,"diff_grating_filter_tex","diff_grating_filter_texture",i,c,d.RGBAFormat,4));"Visualizer"==this.get("_RenderingQuality")&&(k&&!this.get("_renderercache").textures[this.get("_RenderingQuality")].spectrum.queried)&&(c=this.get("_resourcePath")+
"/"+this.get("_renderercache").textures[this.get("_RenderingQuality")].path,this.get("_renderercache").textures[this.get("_RenderingQuality")].spectrum.queried=!0,new ea(c+"PointLightSources.json",this.AsynchronousLightLoad.bind(this),this.NotifyResourceQueryErrorCallback(3,"Point Light Sources"),this.get("_model").get("_assetmanager").GetURLPreprocessCallback()),this.get("_model").get("_assetmanager").IncrementTextureQueryCounter(1),this.StartAsyncGlobalTextureLoad("spectrum",c));return i}w.Log("ViewerView Warning: Material properties not defined")}else w.Log("ViewerView Warning: Queried asset is not a material")},
CreateMaterial:function(a,b){var c=null,i=null,g,h;a.diff_texture?g=a.diff_texture:a.spec_texture&&(g=a.spec_texture);if(void 0!==g){var f=g.offset;g=g.repeat;h=new d.Vector4(f.x,f.y,g.x,g.y)}else h=new d.Vector4(0,0,1,1);f={};g=A.get("_fullSupportFloatingPointTextures")||A.get("_fullSupportHFloatingPointTextures");g=1<=a.opacity&&!a.transp_texture||!g;switch(this.get("_RenderingQuality")){case "Designer":0.5<=a.shininess?this.get("_renderercache").textures.Designer.envmap.glossy.loaded&&(c=this.get("_renderercache").textures.Designer.envmap.glossy.data,
this.get("_renderercache").textures.Designer.irradiancemap.loaded&&(i=this.get("_renderercache").textures.Designer.irradiancemap.data)):this.get("_renderercache").textures.Designer.envmap.matte.loaded&&(c=this.get("_renderercache").textures.Designer.envmap.matte.data,this.get("_renderercache").textures.Designer.irradiancemap.loaded&&(i=this.get("_renderercache").textures.Designer.irradiancemap.data));var e=d.UniformsUtils.clone(F.uniforms);e.diffuse.value=a.diff_col;e.opacity.value=g?1:a.opacity;
e.specular.value=a.spec_col;e.shininess.value=Math.max(0.001,a.shininess);e.map.value=a.diff_texture;e.specularMap.value=a.spec_texture;e.irr_tex.value=i;e.envMap.value=c;e.reflectivity.value=0.5;e.offsetRepeat.value=h;f[1]={name:"designer",uniforms:e,vertexShader:F.vertexShader,fragmentShader:F.fragmentShader,depthTest:!0,vertexColors:d.FaceColors,side:a.double_sided?d.DoubleSide:d.FrontSide,transparent:!g,blending:d.NormalBlending,defines:{ENVMAP_TYPE_CUBE:"",ENVMAP_MODE_REFLECTION:"",ENVMAP_BLENDING_ADD:""},
lights:!0};break;case "Visualizer":for(var j={},l=!0,e=0;5>e;++e)if(this.get("_renderercache").textures.Visualizer.envmap.loaded[e])j[e]=this.get("_renderercache").textures.Visualizer.envmap.data[e];else{l=!1;break}l&&this.get("_renderercache").textures.Visualizer.irradiancemap.loaded&&(i=this.get("_renderercache").textures.Visualizer.irradiancemap.data,c=j);if(a.printable){if(e=d.UniformsUtils.clone(X.uniforms),e.offsetRepeat.value=h,e.diffuseColor.value=a.diff_col,e.opacity.value=g?1:a.opacity,
e.diffuseTexture.value=a.diff_texture?a.diff_texture:this.get("_DummyTexture"),e.normalMap_chan_0.value=a.normal_chan0_texture?a.normal_chan0_texture:this.get("_DummyTexture"),e.normalMap_chan_1.value=a.normal_chan1_texture?a.normal_chan1_texture:this.get("_DummyTexture"),e.DX1RT.value=this.get("_DummyTexture"),e.DX2RT.value=this.get("_DummyTexture"),e.irradianceCubeMap.value=i?i:this.get("_DummyTextureCube"),e.backTexture.value=a.backTexture?1:0,e.flipNormals.value=a.flipNormals?1:0,j={},a.normal_chan0_texture&&
(j.USE_CHAN0_TEXTURE=""),a.normal_chan1_texture&&(j.USE_CHAN1_TEXTURE=""),f[1]={name:"irradiancepm",uniforms:e,vertexShader:X.vertexShader,fragmentShader:X.fragmentShader,depthTest:!0,vertexColors:d.FaceColors,side:a.double_sided?d.DoubleSide:d.FrontSide,defines:j,blending:g?d.NormalBlending:d.CustomBlending,blendSrc:d.OneFactor,blendDst:d.OneMinusSrcAlphaFactor,transparent:!0,extensions:{derivatives:!0,fragDepth:!1,drawBuffers:!1,shaderTextureLOD:!1}},e=d.UniformsUtils.clone(V.uniforms),e.offsetRepeat.value=
h,e.diffuseColor.value=a.diff_col,e.opacity.value=g?1:a.opacity,e.diffuseTexture.value=a.diff_texture?a.diff_texture:this.get("_DummyTexture"),e.DX1RT.value=this.get("_DummyTexture"),e.DX2RT.value=this.get("_DummyTexture"),e.backTexture.value=a.backTexture?1:0,e.flipNormals.value=a.flipNormals?1:0,f[3]={name:"filterpm",uniforms:e,vertexShader:V.vertexShader,fragmentShader:V.fragmentShader,depthTest:!0,vertexColors:d.FaceColors,side:a.double_sided?d.DoubleSide:d.FrontSide,defines:{},blending:d.CustomBlending,
blendSrc:d.DstColorFactor,blendDst:d.ZeroFactor,transparent:!0},11<=A.get("_glmaxtextureimageunits")?(e=d.UniformsUtils.clone(H.EXTuniforms),e.haze1CubeMap.value=c?c[0]:this.get("_DummyTextureCube"),e.haze2CubeMap.value=c?c[1]:this.get("_DummyTextureCube"),e.haze3CubeMap.value=c?c[2]:this.get("_DummyTextureCube"),e.haze4CubeMap.value=c?c[3]:this.get("_DummyTextureCube"),e.haze5CubeMap.value=c?c[4]:this.get("_DummyTextureCube")):(e=d.UniformsUtils.clone(H.uniforms),e.haze1CubeMap.value=c?c[0]:this.get("_DummyTextureCube"),
e.haze2CubeMap.value=c?c[4]:this.get("_DummyTextureCube")),e.offsetRepeat.value=h,e.diffuseColor.value=a.diff_col,e.specularColor.value=a.spec_col,e.shininess.value=a.shininess,e.diffuseTexture.value=a.diff_texture?a.diff_texture:this.get("_DummyTexture"),e.specularTexture.value=a.spec_texture?a.spec_texture:this.get("_DummyTexture"),e.internalSpecTex.value=a.int_spec_texture?a.int_spec_texture:this.get("_DummyTexture"),e.normalMap_chan_0.value=a.normal_chan0_texture?a.normal_chan0_texture:this.get("_DummyTexture"),
e.normalMap_chan_1.value=a.normal_chan1_texture?a.normal_chan1_texture:this.get("_DummyTexture"),e.DX1RT.value=this.get("_DummyTexture"),e.DX2RT.value=this.get("_DummyTexture"),e.backTexture.value=a.backTexture?1:0,e.flipNormals.value=a.flipNormals?1:0,j={},a.int_spec_texture&&(j.USE_INT_SPEC_TEXTURE=""),a.normal_chan0_texture&&(j.USE_CHAN0_TEXTURE=""),a.normal_chan1_texture&&(j.USE_CHAN1_TEXTURE=""),f[6]={name:"reflectancepm",uniforms:e,vertexShader:H.vertexShader,fragmentShader:11<=A.get("_glmaxtextureimageunits")?
H.EXTfragmentShader:H.fragmentShader,depthTest:!0,vertexColors:d.FaceColors,side:a.double_sided?d.DoubleSide:d.FrontSide,defines:j,blending:d.CustomBlending,blendSrc:d.OneFactor,blendDst:d.OneFactor,transparent:!0,extensions:{derivatives:!0,fragDepth:!1,drawBuffers:!1,shaderTextureLOD:!1}},a.holographic){j=d.UniformsUtils.clone(Z.uniforms);j.offsetRepeat.value=h;j.uvdhTexture.value=a.diff_grating_texture?a.diff_grating_texture:this.get("_DummyTexture");j.diffFilterTexture.value=a.diff_grating_filter_texture?
a.diff_grating_filter_texture:this.get("_DummyTexture");j.normalMap_chan_0.value=a.normal_chan0_texture?a.normal_chan0_texture:this.get("_DummyTexture");j.normalMap_chan_1.value=a.normal_chan1_texture?a.normal_chan1_texture:this.get("_DummyTexture");j.DX1RT.value=this.get("_DummyTexture");j.DX2RT.value=this.get("_DummyTexture");j.grating_spacing_scale.value=a.grating_spacing_scale;j.spectrumTexture.value=this.get("_renderercache").textures[this.get("_RenderingQuality")].spectrum.data;j.defaultDiffSpacing.value=
a.default_diff_spacing;j.defaultDiffHaze.value=a.default_diff_haze;j.backTexture.value=a.backTexture?1:0;j.flipNormals.value=a.flipNormals?1:0;l={};a.double_grating&&(l.DOUBLE_GRATING="");a.normal_chan0_texture&&(l.USE_CHAN0_TEXTURE="");a.normal_chan1_texture&&(l.USE_CHAN1_TEXTURE="");if(this.get("_renderercache").textures[this.get("_RenderingQuality")].spectrum.loaded&&this.get("_renderercache").lights.hasOwnProperty("holo_light")){l.USE_HOLOGRAPHICS="";j.lightPos.value=[];j.lightIntensity.value=
[];j.lightRadius.value=[];j.lightHardness.value=[];for(e=0;e<this.get("_renderercache").lights.holo_light.Lights.length&&4>e;++e){var m=this.get("_renderercache").lights.holo_light.Lights[e];j.lightPos.value.push(new d.Vector3(m[0],m[1],m[2]));j.lightIntensity.value.push(m[3]);j.lightRadius.value.push(m[4]);j.lightHardness.value.push(m[5])}}f[5]={name:"holographicspm",uniforms:j,vertexShader:Z.vertexShader,fragmentShader:Z.fragmentShader,depthTest:!0,vertexColors:d.FaceColors,side:a.double_sided?
d.DoubleSide:d.FrontSide,defines:l,blending:d.CustomBlending,blendSrc:d.OneMinusDstColorFactor,blendDst:d.OneFactor,transparent:!0,extensions:{derivatives:!0,fragDepth:!1,drawBuffers:!1,shaderTextureLOD:!1}}}}else e=d.UniformsUtils.clone(Y.uniforms),e.offsetRepeat.value=h,e.diffuseColor.value=a.diff_col,e.opacity.value=g?1:a.opacity,e.diffuseTexture.value=a.diff_texture?a.diff_texture:this.get("_DummyTexture"),e.DX1RT.value=this.get("_DummyTexture"),e.DX2RT.value=this.get("_DummyTexture"),e.irradianceCubeMap.value=
i?i:this.get("_DummyTextureCube"),e.backTexture.value=a.backTexture?1:0,e.flipNormals.value=a.flipNormals?1:0,f[2]={name:"irradiancenpm",uniforms:e,vertexShader:Y.vertexShader,fragmentShader:Y.fragmentShader,depthTest:!0,vertexColors:d.FaceColors,side:a.double_sided?d.DoubleSide:d.FrontSide,defines:{},blending:g?d.NormalBlending:d.CustomBlending,blendSrc:d.OneFactor,blendDst:d.OneMinusSrcAlphaFactor,transparent:!0},e=d.UniformsUtils.clone(W.uniforms),e.offsetRepeat.value=h,e.diffuseColor.value=a.diff_col,
e.opacity.value=g?1:a.opacity,e.diffuseTexture.value=a.diff_texture?a.diff_texture:this.get("_DummyTexture"),e.DX1RT.value=this.get("_DummyTexture"),e.DX2RT.value=this.get("_DummyTexture"),e.backTexture.value=a.backTexture?1:0,e.flipNormals.value=a.flipNormals?1:0,f[4]={name:"filternpm",uniforms:e,vertexShader:W.vertexShader,fragmentShader:W.fragmentShader,depthTest:!0,vertexColors:d.FaceColors,side:a.double_sided?d.DoubleSide:d.FrontSide,defines:{},blending:d.CustomBlending,blendSrc:d.DstColorFactor,
blendDst:d.ZeroFactor,transparent:!0},11<=A.get("_glmaxtextureimageunits")?(e=d.UniformsUtils.clone(I.EXTuniforms),e.haze1CubeMap.value=c?c[0]:this.get("_DummyTextureCube"),e.haze2CubeMap.value=c?c[1]:this.get("_DummyTextureCube"),e.haze3CubeMap.value=c?c[2]:this.get("_DummyTextureCube"),e.haze4CubeMap.value=c?c[3]:this.get("_DummyTextureCube"),e.haze5CubeMap.value=c?c[4]:this.get("_DummyTextureCube")):(e=d.UniformsUtils.clone(I.uniforms),e.haze1CubeMap.value=c?c[0]:this.get("_DummyTextureCube"),
e.haze2CubeMap.value=c?c[4]:this.get("_DummyTextureCube")),e.DX1RT.value=this.get("_DummyTexture"),e.DX2RT.value=this.get("_DummyTexture"),e.offsetRepeat.value=h,e.specularCol.value=a.spec_col,e.shininess.value=a.shininess,e.backTexture.value=a.backTexture?1:0,e.flipNormals.value=a.flipNormals?1:0,f[7]={name:"reflectancenpm",uniforms:e,vertexShader:I.vertexShader,fragmentShader:11<=A.get("_glmaxtextureimageunits")?I.EXTfragmentShader:I.fragmentShader,depthTest:!0,vertexColors:d.FaceColors,side:a.double_sided?
d.DoubleSide:d.FrontSide,defines:{},blending:d.CustomBlending,blendSrc:d.OneFactor,blendDst:d.OneFactor,transparent:!0}}j={};if(!b||"depth_pass"==b||"opaque_diffuse_pass"==b||"transp_depth_pass"==b||"transp_diffuse_pass"==b){l=e=null;if(!b||"depth_pass"==b||"transp_depth_pass"==b)e=d.UniformsUtils.clone(E.uniforms),e=new d.ShaderMaterial({uniforms:e,vertexShader:E.vertexShader,fragmentShader:E.fragmentShader,side:d.DoubleSide,depthWrite:!0,transparent:!1,name:"D0ShaderMaterial",lights:!1});if(!b||
"opaque_diffuse_pass"==b||"transp_diffuse_pass"==b)l=d.UniformsUtils.clone(T.uniforms),l.diffuseColor.value=a.diff_col,l.opacity.value=a.opacity,l.diffuseTexture.value=a.diff_texture?a.diff_texture:this.get("_DummyTexture"),l.offsetRepeat.value=h,l.DX1RT.value=this.get("_DummyTexture"),l.DX2RT.value=this.get("_DummyTexture"),l.backTexture.value=a.backTexture?1:0,l.flipNormals.value=a.flipNormals?1:0,l=new d.ShaderMaterial({uniforms:l,vertexShader:T.vertexShader,fragmentShader:T.fragmentShader,side:a.double_sided?
d.DoubleSide:d.FrontSide,depthWrite:!0,transparent:!0,blending:d.CustomBlending,blendSrc:d.DstColorFactor,blendDst:d.ZeroFactor,name:"TransBlendShader",lights:!1}),a.diff_texture&&(l.defines.USE_MAP=""),a.printable||(l.defines.IS_NPM=""),a.diff_texture&&a.diff_texture.remappedAlphaChannel&&(l.defines.REMAPPED_DIFFUSE_ALPHA_CHANNEL=""),a.spec_texture&&a.spec_texture.remappedAlphaChannel&&(l.defines.REMAPPED_SPECULAR_ALPHA_CHANNEL=""),a.int_spec_texture&&a.int_spec_texture.remappedAlphaChannel&&(l.defines.REMAPPED_INT_SPECULAR_ALPHA_CHANNEL=
""),a.diff_grating_texture&&a.diff_grating_texture.remappedAlphaChannel&&(l.defines.REMAPPED_DIFF_GRATING_ALPHA_CHANNEL="");g?(e&&(j.depth_pass=[e]),l&&(j.opaque_diffuse_pass=[l])):(e&&(j.transp_depth_pass=[e]),l&&(j.transp_diffuse_pass=[l]))}j.hasOwnProperty("opaque_pass")||(j.opaque_pass=[]);j.hasOwnProperty("transparent_pass")||(j.transparent_pass=[]);e=0;h=Object.keys(f);for(l=h.length;e<l;++e)if(m=h[e],f[m])if(a.double_sided&&(f[m].defines.DOUBLE_SIDED=""),a.diff_texture&&(f[m].defines.USE_MAP=
""),a.spec_texture&&(f[m].defines.USE_SPECULARMAP=""),i&&(f[m].defines.USE_IRRMAP=""),c&&(f[m].defines.USE_ENVMAP=""),a.diff_texture&&a.diff_texture.remappedAlphaChannel&&(f[m].defines.REMAPPED_DIFFUSE_ALPHA_CHANNEL=""),a.spec_texture&&a.spec_texture.remappedAlphaChannel&&(f[m].defines.REMAPPED_SPECULAR_ALPHA_CHANNEL=""),a.int_spec_texture&&a.int_spec_texture.remappedAlphaChannel&&(f[m].defines.REMAPPED_INT_SPECULAR_ALPHA_CHANNEL=""),a.diff_grating_texture&&a.diff_grating_texture.remappedAlphaChannel&&
(f[m].defines.REMAPPED_DIFF_GRATING_ALPHA_CHANNEL=""),g&&(!b||"opaque_pass"==b)){m=new d.ShaderMaterial(f[m]);m.polygonOffset=!0;this.get("_renderercache");var k=this.get("_renderercache").materials.enablehighlights&&__enableHardEdgeHighlights;m.polygonOffsetFactor=k?this.get("_polygon_offset_factor"):0;m.polygonOffsetUnits=k?this.get("_polygon_offset_units"):0;j.opaque_pass.push(m)}else if(!g&&(!b||"transparent_pass"==b))m=new d.ShaderMaterial(f[m]),m.polygonOffset=!1,j.transparent_pass.push(m);
return j},UpdateTexturedMaterial:function(a){if(a){var b=a.boundmeshlist;if(b){0==Object.keys(b).length&&w.Log("ViewerView Warning: No meshes to update");for(var c=0,d=Object.keys(b),g=d.length;c<g;++c){var h=d[c];0==Object.keys(b[h]).length&&w.Log("ViewerView Warning: No render passes to update");for(var f=0,e=Object.keys(b[h]),j=e.length;f<j;++f){var l=e[f];0==Object.keys(b[h][l]).length&&w.Log("ViewerView Warning: No sided materials to update");for(var m=0,k=Object.keys(b[h][l]),r=k.length;m<r;++m){var n=
k[m];0==Object.keys(b[h][l][n]).length&&w.Log("ViewerView Warning: No shading pass to update");for(var p=0,s=Object.keys(b[h][l][n]),q=s.length;p<q;++p){var u=s[p],v=this.CreateMaterial(a,h);v[h][n].side=a.mat.textured_mat[h][n][u].side;this.ReleaseMaterial(a.mat.textured_mat[h][n][u],!1);a.mat.textured_mat[h][n][u]=v[h][n];for(var t=0,B=Object.keys(b[h][l][n][u]),x=B.length;t<x;++t){var J=b[h][l][n][u][B[t]];J.material=v[h][n];J.geometry.buffersNeedUpdate=!0;J.geometry.uvsNeedUpdate=!0}}}}}}else w.Log("ViewerView Warning: No meshes to update")}},
UpdateMaterialsGlobalLighting:function(){for(var a=this.get("_renderercache").materials,b=0,c=Object.keys(a.materiallist),d=c.length;b<d;++b){var g=c[b],h=a.materiallist[g].back;this.UpdateTexturedMaterial(a.materiallist[g].front);this.UpdateTexturedMaterial(h)}},UpdateMaterialTexture:function(a,b,c){if(a){for(var i=a.mat.textured_mat,g=0,h=Object.keys(a),f=h.length;g<f;++g){var e=h[g];a[e]&&(a[e]instanceof d.Texture&&""!=a[e].name&&a[e].name==b)&&(a[e].dispose(),a[e]=c)}if(i){0==Object.keys(i).length&&
w.Log("ViewerView Warning: No render passes to update");a=0;g=Object.keys(i);for(e=g.length;a<e;++a){var j=g[a];0==Object.keys(i[j]).length&&w.Log("ViewerView Warning: No shading passes to update");for(var l=0,m=Object.keys(i[j]),f=m.length;l<f;++l){var k=m[l];0==Object.keys(i[j][k]).length&&w.Log("ViewerView Warning: No surface materials to update");for(var r=0,n=Object.keys(i[j][k]),p=n.length;r<p;++r){var s=i[j][k][n[r]];if(s&&s.uniforms)for(var q=0,h=Object.keys(s.uniforms),u=h.length;q<u;++q){var v=
s.uniforms[h[q]];if(v.value&&"function"===typeof v.value.dispose&&v.value instanceof d.Texture){var t=v.value;""!=t.name&&t.name==b&&(c.format=t.format,c.unpackAlignment=t.unpackAlignment,c.anisotropy=t.anisotropy,c.repeat=t.repeat,c.remappedAlphaChannel=t.remappedAlphaChannel,v.value=c)}}}}}}else w.Log("ViewerView Warning: No textured material to update")}},ReloadAllTextures:function(a,b){for(var c=0,d=0,g=Object.keys(this.get("_renderercache").textures.FromFile),h=g.length;d<h;++d){var f=g[d],e=
function(){++c;c==h&&((void 0===b||b)&&this.Render(),"function"==typeof a&&a())}.bind(this);this.ReloadTexture(f,f,e,!0,!1)}},ReloadTexture:function(a,b,c,i,g){var h=function(a,b){for(var d=this.get("_renderercache").materials,i=0,h=Object.keys(d.materiallist),f=h.length;i<f;++i){var e=h[i],s=d.materiallist[e].back;this.UpdateMaterialTexture(d.materiallist[e].front,a,b);this.UpdateMaterialTexture(s,a,b)}(void 0===g||g)&&this.Render();"function"==typeof c&&c()}.bind(this),f=function(){w.Log("ViewerView Warning: Problem loading texture");
this.Render();this.NotifySceneBuildProgress(100,0,2)}.bind(this),e=function(c){var e=new d.TextureLoader;e.crossOrigin="";e.load(c,function(b){h(a,b)},void 0,f).name=i||void 0==i?a:b}.bind(this);this.get("_model").get("_assetmanager").GetURLPreprocessCallback()(b+"?t="+(new Date).getTime(),e)},AssetRefParse:function(a,b){var c={},d=a.lastIndexOf("#");if(-1==d)c.new_scene_id=a,c.refnode=b[c.new_scene_id];else{c.new_scene_id=a.substring(0,d);var g=b[c.new_scene_id];if(g){var d=a.substring(d+1),h;do h=
d.indexOf("/"),-1==h?(h=d,d=""):h=d.substring(0,h),g=g[h],d=d.substring(Math.min(d.indexOf("/")+1,d.length));while(0<d.length&&void 0!==g);g||null==g}null===g?w.Log(c.new_scene_id+" is null"):void 0==g&&w.Log(c.new_scene_id+" not yet in cache or not existing");c.refnode=g}return c},URLToKeyString:function(a){a=a.replace("#","/");return a=a.replace(/(ftp|http|https):\/\/?/,"")},RegisterObjectNode:function(a,b,c,i,g){var a=this.URLToKeyString(a),h=this.get("_renderercache").nodeviewproperties,f=!1;
h.hasOwnProperty(a)||(h[a]={threejsnodes:{}});h[a].threejsnodes.hasOwnProperty(b)||(h[a].threejsnodes[b]={});void 0===i?h[a].threejsnodes[b].hasOwnProperty("default_cg")||(this.set("_nodecounter",this.get("_nodecounter")+1),h[a].threejsnodes[b].default_cg=new d.Object3D,f=!0):h[a].threejsnodes[b].hasOwnProperty(i)||(this.set("_nodecounter",this.get("_nodecounter")+1),h[a].threejsnodes[b][i]=new d.Object3D,f=!0);"highlightnode"==b&&(void 0===g||!0===g)&&this.AddUIElement(a,c);return{node:void 0!==
i?h[a].threejsnodes[b][i]:h[a].threejsnodes[b].default_cg,newlycreated:f,register:!0}},GetTHREEJSObjectHierarchyRec:function(a,b,c,i,g,h,f,e,j,l,m){var k=a.AssetReferenceProperties,r={};if(f)for(var n=0,p=Object.keys(f),s=p.length;n<s;++n){var q=p[n];r[q]=f[q]}if(k&&(f=k.materialmap)){n=0;p=Object.keys(f);for(s=p.length;n<s;++n){var q=p[n],u=this.get("_renderercache").materials.materiallist,v=this.get("_model").get("_assetmanager").get("_cache").rootnodes,t=f[q][0]+(f[q][1]?"/"+f[q][1]:""),v=v[c].Assets,
B=null,x=null;if(u.hasOwnProperty(t))v=u[t];else{var J=!1;v.hasOwnProperty(f[q][0])?B=this.LoadMaterial(v[f[q][0]],v,c,!1,!1):w.Log("ViewerView Warning: Front material "+f[q][0]+" not found");var z=!1;f[q][1]&&(v.hasOwnProperty(f[q][1])?(x=v[f[q][1]],x=this.LoadMaterial(x,v,c,!0,!0),z=!0):w.Log("ViewerView Warning: Back material "+f[q][1]+" not found. Trying to assign front material."));!z&&v.hasOwnProperty(f[q][0])&&(x=v[f[q][0]],x=this.LoadMaterial(x,v,c,!1,!0),J=!0);v={material_name:t,front:B,
back:x,sharedmaterial:J};u[t]=v}r[q]=v}}n=new d.Matrix4;if(k)if(p=new d.Vector3(parseFloat(k.x),parseFloat(k.y),parseFloat(k.z)),new d.Vector3(0,0,0),k.hasOwnProperty("orientation_matrix"))n.set(k.orientation_matrix[0],k.orientation_matrix[1],k.orientation_matrix[2],p.x,k.orientation_matrix[3],k.orientation_matrix[4],k.orientation_matrix[5],p.y,k.orientation_matrix[6],k.orientation_matrix[7],k.orientation_matrix[8],p.z,0,0,0,1);else switch(k.orientation){case "2":n.set(0,-1,0,p.x,1,0,0,p.y,0,0,1,
p.z,0,0,0,1);break;case "3":n.set(-1,0,0,p.x,0,-1,0,p.y,0,0,1,p.z,0,0,0,1);break;case "4":n.set(0,1,0,p.x,-1,0,0,p.y,0,0,1,p.z,0,0,0,1);break;case "5":n.set(1,0,0,p.x,0,0,1,p.y,0,-1,0,p.z,0,0,0,1);break;case "6":n.set(0,0,-1,p.x,1,0,0,p.y,0,-1,0,p.z,0,0,0,1);break;case "7":n.set(-1,0,0,p.x,0,0,-1,p.y,0,-1,0,p.z,0,0,0,1);break;case "8":n.set(0,0,1,p.x,-1,0,0,p.y,0,-1,0,p.z,0,0,0,1);break;case "9":n.set(0,0,-1,p.x,0,1,0,p.y,1,0,0,p.z,0,0,0,1);break;case "10":n.set(0,-1,0,p.x,0,0,-1,p.y,1,0,0,p.z,0,
0,0,1);break;case "11":n.set(0,0,1,p.x,0,-1,0,p.y,1,0,0,p.z,0,0,0,1);break;case "12":n.set(0,1,0,p.x,0,0,1,p.y,1,0,0,p.z,0,0,0,1);break;case "13":n.set(-1,0,0,p.x,0,1,0,p.y,0,0,-1,p.z,0,0,0,1);break;case "14":n.set(0,-1,0,p.x,-1,0,0,p.y,0,0,-1,p.z,0,0,0,1);break;case "15":n.set(1,0,0,p.x,0,-1,0,p.y,0,0,-1,p.z,0,0,0,1);break;case "16":n.set(0,1,0,p.x,1,0,0,p.y,0,0,-1,p.z,0,0,0,1);break;case "17":n.set(-1,0,0,p.x,0,0,1,p.y,0,1,0,p.z,0,0,0,1);break;case "18":n.set(0,0,-1,p.x,-1,0,0,p.y,0,1,0,p.z,0,0,
0,1);break;case "19":n.set(1,0,0,p.x,0,0,-1,p.y,0,1,0,p.z,0,0,0,1);break;case "20":n.set(0,0,1,p.x,1,0,0,p.y,0,1,0,p.z,0,0,0,1);break;case "21":n.set(0,0,1,p.x,0,1,0,p.y,-1,0,0,p.z,0,0,0,1);break;case "22":n.set(0,-1,0,p.x,0,0,1,p.y,-1,0,0,p.z,0,0,0,1);break;case "23":n.set(0,0,-1,p.x,0,-1,0,p.y,-1,0,0,p.z,0,0,0,1);break;case "24":n.set(0,1,0,p.x,0,0,-1,p.y,-1,0,0,p.z,0,0,0,1);break;default:n.set(1,0,0,p.x,0,1,0,p.y,0,0,1,p.z,0,0,0,1)}else n.set(1,0,0,0,0,1,0,0,0,0,1,0,0,0,0,1);j instanceof d.Matrix4&&
n.premultiply(j);j={};if(e&&!this.get("_parsedEntireSceneGraphOnce")){p=0;s=Object.keys(e);for(q=s.length;p<q;++p)j[s[p]]=e[s[p]]}if(k&&!this.get("_parsedEntireSceneGraphOnce")&&(e=k.labelsettingsmap)){k=0;p=Object.keys(e);for(s=p.length;k<s;++k)j[p[k]]=e[p[k]]}return this.GetTHREEJSObjectHierarchy(a,b,c,i,g,h,r,j,n,l,m)},IsAssetLabelAssetType:function(a,b,c){return(a=this.get("_model").get("_assetmanager").get("_assetloader").IsURL(a)?this.AssetRefParse(a,b).refnode:b[c].Assets[a])?"Label"==a.AssetType:
!1},GetTHREEJSObjectHierarchy:function(a,b,c,i,g,h,f,e,j,l,m){var k=this.get("_model").get("_assetmanager").get("_cache").rootnodes,r;if(void 0==a)return w.Log("ViewerView Warning: Reference to __asset '"+i+"' not yet loaded in cache. This node should be updated when asynchronuous data is loaded."),{node:null,newlycreated:!1,register:!1};var n=!(a.hasOwnProperty("Children")&&a.Children||a.hasOwnProperty("AssetRef"));if(a.hasOwnProperty("Children")&&a.Children){var p=!1;a.hasOwnProperty("FlattenSubTree")&&
(p=!y.get("toBool")(a.FlattenSubTree));var s=[];r=!1;for(var q=0,u=Object.keys(a.Children),v=u.length;q<v;++q){var t=u[q];if(this.IsAssetLabelAssetType(a.Children[t].AssetRef,k,c))r=!0;else{var B=i+"/"+t,t=this.GetTHREEJSObjectHierarchyRec(a.Children[t],b,c,B,g,a.AssetRef,f,e,j,p?B:l,null);t.register&&t.newlycreated&&s.push(t.node)}}if(0<s.length||r){r=this.RegisterObjectNode(i,b,n,g);q=0;u=Object.keys(s);for(v=u.length;q<v;++q)r.node.add(s[u[q]]);q=0;u=Object.keys(a.Children);for(v=u.length;q<v;++q)t=
u[q],this.IsAssetLabelAssetType(a.Children[t].AssetRef,k,c)&&(B=i+"/"+t,t=this.GetTHREEJSObjectHierarchyRec(a.Children[t],b,c,B,g,a.AssetRef,f,e,j,p?B:l,r))}else r={node:null,newlycreated:!1,register:!1}}else if(a.hasOwnProperty("AssetRef"))this.get("_model").get("_assetmanager").get("_assetloader").IsURL(a.AssetRef)?(n=this.AssetRefParse(a.AssetRef,k),r=n.refnode,n=n.new_scene_id):(r=k[c].Assets[a.AssetRef],n=c),r=this.GetTHREEJSObjectHierarchy(r,b,n,i,g,a.AssetRef,f,e,j,l,m);else{p=!1;if(a.hasOwnProperty("Properties")&&
a.Properties&&("Cuboid"==a.AssetType||"Mesh"==a.AssetType)){var q=a.AssetType,u=a.Properties,v=this.get("_renderercache").geometries,s=this.get("_renderercache").materials,t=this.get("_renderercache").coplanarityepsilon,B=this.get("_renderercache").boundaryhardedges,x=c+h.substring(h.lastIndexOf("/")),f=this.get("_3DObjectHandler").InstanciateGeometry(q,x,b,u,v,s,f,t,B,g,j,l,this);if(f.register){p=!0;r=this.RegisterObjectNode(i,b,n,g);q=0;u=Object.keys(f.objects);for(v=u.length;q<v;++q)b=u[q],r.node.add(f.objects[b]),
f.objects[b].geometry.hasOwnProperty("useSoftwareInstancing")&&f.objects[b].geometry.useSoftwareInstancing&&f.objects[b].applyMatrix(j)}}else a.hasOwnProperty("Properties")&&(a.Properties&&"Label"==a.AssetType&&!this.get("_parsedEntireSceneGraphOnce"))&&this.get("_labelCreationCallbackList").push(function(){w.Log("Label: Current Scene Id: "+c);w.Log("Label: root node: "+k[c]);this.LoadLabel(k[c],i,a,h,e,j,m)}.bind(this));p||(r={node:null,newlycreated:!1,register:!1})}a.hasOwnProperty("AssetType")&&
"Scene"==a.AssetType&&(this.get("_model").get("SceneId")==a.AssetId&&this.set("_parsedEntireSceneGraphOnce",!0),r.node&&r.node.traverse(function(a){if(a instanceof d.Mesh&&a.geometry instanceof d.InstancedBufferGeometry&&a.geometry.attributes.inst_translation.jarray&&a.geometry.attributes.inst_rotation.jarray&&a.geometry.attributes.inst_scale.jarray&&1<a.geometry.attributes.inst_translation.jarray.length/3){a.geometry.maxInstancedCount=a.geometry.attributes.inst_translation.jarray.length/3;a.geometry.adjacentfacesedgeslines.maxInstancedCount=
a.geometry.maxInstancedCount;var b=new Float32Array(a.geometry.attributes.inst_translation.jarray),c=new Float32Array(a.geometry.attributes.inst_rotation.jarray),h=new Float32Array(a.geometry.attributes.inst_scale.jarray);a.geometry.attributes.inst_translation.array=b;a.geometry.attributes.inst_rotation.array=c;a.geometry.attributes.inst_scale.array=h;a.geometry.adjacentfacesedgeslines.attributes.inst_translation.array=b;a.geometry.adjacentfacesedgeslines.attributes.inst_rotation.array=c;a.geometry.adjacentfacesedgeslines.attributes.inst_scale.array=
h}}));return r},RotateOutOfBoundsVisibleLabels:function(a,b,c,d,g,h){for(var f=!0,e=0,j=Object.keys(this.get("_renderercache").labels.list),l=j.length;e<l;++e){var m=j[e],m=this.get("_renderercache").labels.list[m],k=this.GetLabelBoundingBox(m,m.orientation),r=void 0;if("vertical"!=m.orientation)if(k.max.x>g||k.min.x<-g)m.threejs_sprite.material.rotation=1.5708,r="vertical";else{if(k.max.y>h||k.min.y<-h)f=!1;m.threejs_sprite.material.rotation=0}else if(k.max.y>h||k.min.y<-h)m.threejs_sprite.material.rotation=
0,r="horizontal";else{if(k.max.x>g||k.min.x<-g)f=!1;m.threejs_sprite.material.rotation=1.5708}if(r&&(this.UpdateLabelPosition(m,a,c/2,d/2,r),k=this.GetLabelBoundingBox(m,r),k.max.x>g||k.min.x<-g||k.max.y>h||k.min.y<-h))f=!1;b.union(k)}return f},GetLabelBoundingBox:function(a,b){var c=a.threejs_sprite,i=new d.Box2,g=c.scale.x,h=c.scale.y,f=0.5*("vertical"==(b?b:a.orientation)?h:g),g=0.5*("vertical"==(b?b:a.orientation)?g:h);i.expandByPoint(new d.Vector2(c.position.x-f,c.position.y-g));i.expandByPoint(new d.Vector2(c.position.x-
f,c.position.y+g));i.expandByPoint(new d.Vector2(c.position.x+f,c.position.y-g));i.expandByPoint(new d.Vector2(c.position.x+f,c.position.y+g));return i},UpdateLabelsPositions:function(a,b,c){a.updateMatrixWorld();for(var b=b?b:this.get("_context").clientWidth,c=c?c:this.get("_context").clientHeight,d=0,g=Object.keys(this.get("_renderercache").labels.list),h=g.length;d<h;++d){var f=g[d],f=this.get("_renderercache").labels.list[f];this.UpdateLabelPosition(f,a,b/2,c/2)}},UpdateLabelPosition:function(a,
b,c,i,g){var h=a.threejs_sprite,f=[],e=[],j;switch(a.bounds_type){case "edge_list":for(var l=0,m=Object.keys(a.edge_list),k=m.length;l<k;++l){var r=a.edge_list[m[l]],n=new d.Vector3(r[0],r[1],r[2]);n.project(b);e.push(new d.Vector2(n.x*c,n.y*i));r=new d.Vector3(r[3],r[4],r[5]);r.project(b);e.push(new d.Vector2(r.x*c,r.y*i));n=n.add(r).multiplyScalar(0.5);f.push(new d.Vector2(n.x*c,n.y*i))}break;case "point_list":l=0;m=Object.keys(a.point_list);for(k=m.length;l<k;++l)n=a.point_list[m[l]],n=new d.Vector3(n[0],
n[1],n[2]),n.project(b),e.push(new d.Vector2(n.x*c,n.y*i)),f.push(new d.Vector2(n.x*c,n.y*i));break;case "ellipse":j=a.ellipse.center;n=a.ellipse.radius1_vec;k=a.ellipse.radius2_vec;j=new d.Vector3(j[0],j[1],j[2]);n=new d.Vector3(n[0],n[1],n[2]);r=new d.Vector3(k[0],k[1],k[2]);k=n.clone().cross(r).normalize();k.x=Math.abs(k.x);k.y=Math.abs(k.y);k.z=Math.abs(k.z);k.angleTo(new d.Vector3(0,1,0));n.add(j);r.add(j);j.project(b);n.project(b);r.project(b);n.sub(j);r.sub(j);n.length()<r.length()&&(n=[r,
r=n][0]);var b=n.length(),k=r.length(),n=n.clone().normalize(),p=r.clone().normalize(),s,q,u,v,t,B,x,y,A,r=j.x;s=j.y;u=Math.atan2(-b*n.y,k*p.y);q=b*Math.cos(u)*n.x+k*Math.sin(u)*p.x;B=b*Math.cos(u)*n.y+k*Math.sin(u)*p.y;v=u+Math.PI;u=b*Math.cos(v)*n.x+k*Math.sin(v)*p.x;x=b*Math.cos(v)*n.y+k*Math.sin(v)*p.y;Math.atan2(-b*n.x,k*p.x);t=v+0.5*Math.PI;v=b*Math.cos(t)*n.x+k*Math.sin(t)*p.x;y=b*Math.cos(t)*n.y+k*Math.sin(t)*p.y;A=t+Math.PI;t=b*Math.cos(A)*n.x+k*Math.sin(A)*p.x;n=b*Math.cos(A)*n.y+k*Math.sin(A)*
p.y;u+=r;x+=s;v+=r;y+=s;t+=r;n+=s;b=new d.Vector2((q+r)*c,(B+s)*i);k=new d.Vector2(u*c,x*i);r=new d.Vector2(v*c,y*i);n=new d.Vector2(t*c,n*i);s=b.distanceToSquared(k);q=b.distanceToSquared(r);u=b.distanceToSquared(n);v=k.distanceToSquared(r);t=k.distanceToSquared(n);B=r.distanceToSquared(n);x=0;s>=x&&(x=s,l=b,m=k);q>=x&&(x=q,l=b,m=r);u>=x&&(x=u,l=b,m=n);v>=x&&(x=v,l=k,m=r);t>=x&&(x=t,l=k,m=n);B>=x&&(l=r,m=n);f.push(l);f.push(m);e.push(new d.Vector2(j.x,j.y));break;default:w.Log("Warning! Unsupported label_asset type.");
return}n=k=void 0;m=l=0;r=f.length;switch(r){case 0:w.Log("Warning: no attachment point found.");break;case 1:l=f[0].x;m=f[0].y;break;default:v=new d.Box2;s=0;for(q=f.length;s<q;++s)u=f[s],v.expandByPoint(new d.Vector2(u.x,u.y));b=[];s=0;for(q=f.length;s<q;++s)u=f[s],(u.x==v.min.x||u.x==v.max.x||u.y==v.min.y||u.y==v.max.y)&&b.push(u);switch(b.length){case 0:console.log("There is probably an issue here. at least for vertices and edges");break;case 1:l=b[0].x;m=b[0].y;break;default:if("center"==a.preferred_loc_h&&
"center"==a.preferred_loc_v)n=z.CreateConvexHullFromPointlist(e),k=z.ConvexHullCenter(e,e.length-1),l=k.x,m=k.y;else if("center"==a.preferred_loc_h||"center"==a.preferred_loc_v){l=b[0].x;m=b[0].y;s=1;for(q=b.length;s<q;++s)u=b[s],"left"==a.preferred_loc_h?u.x<l&&(l=u.x,m=u.y):"right"==a.preferred_loc_h?u.x>l&&(l=u.x,m=u.y):"bottom"==a.preferred_loc_v?u.y<m&&(l=u.x,m=u.y):"top"==a.preferred_loc_v?u.y>m&&(l=u.x,m=u.y):(w.Log("Unrecognised Label user preference !"),m=l=0)}else{f=new d.Vector2;s=0;for(q=
b.length;s<q;++s){u=b[s];for(v=s+1;v<q;++v)t=b[v],t=u.clone().sub(t),f.add(new d.Vector2(Math.abs(t.x),Math.abs(t.y)))}l=b[0].x;m=b[0].y;if(f.x>f.y){s=1;for(q=b.length;s<q;++s)u=b[s],"left"==a.preferred_loc_h?u.x<l&&(l=u.x,m=u.y):"right"==a.preferred_loc_h?u.x>l&&(l=u.x,m=u.y):w.Log("Unrecognised horizontal layout: "+a.preferred_loc_h)}else{s=1;for(q=b.length;s<q;++s)u=b[s],"bottom"==a.preferred_loc_v?u.y<m&&(l=u.x,m=u.y):"top"==a.preferred_loc_v?u.y>m&&(l=u.x,m=u.y):w.Log("Unrecognised vertical layout: "+
a.preferred_loc_v)}}}}q=s=0;b=a.threejs_sprite.scale.x;u=a.threejs_sprite.scale.y;f=0.5*("vertical"==(g?g:a.orientation)?u:b);g=0.5*("vertical"==(g?g:a.orientation)?b:u);b=new d.Vector2(a.pixel_offset[0],a.pixel_offset[1]);if(1==r&&"point_list"==a.bounds_type||"center"==a.preferred_loc_h&&"center"==a.preferred_loc_v){var C=0,D=0;"right"==a.preferred_loc_h?C=1:"left"==a.preferred_loc_h&&(C=-1);"top"==a.preferred_loc_v?D=1:"bottom"==a.preferred_loc_v&&(D=-1);s+=b.x*Math.sign(C);q+=b.y*Math.sign(D)}else if("ellipse"==
a.bounds_type)j=new d.Vector2(j.x*c,j.y*i),s=l-j.x+b.x,q=m-j.y+b.y;else{c=n?n:z.CreateConvexHullFromPointlist(e);j=k?k:z.ConvexHullCenter(e,e.length-1);i=(new d.Vector2(l-j.x,m-j.y)).normalize();j=new d.Vector2;s=0;for(q=e.length-1;s<q;++s){u=e[s];for(v=s+1;v<q;++v)t=e[v],t=u.clone().sub(t),j.add(new d.Vector2(Math.abs(t.x),Math.abs(t.y)))}j.x>j.y?"top"==a.preferred_loc_v?(C=0,D=1):"bottom"==a.preferred_loc_v?(C=0,D=-1):"right"==a.preferred_loc_h?(C=1,D=0):"left"==a.preferred_loc_h&&(C=-1,D=0):"right"==
a.preferred_loc_h?(C=1,D=0):"left"==a.preferred_loc_h?(C=-1,D=0):"top"==a.preferred_loc_v?(C=0,D=1):"bottom"==a.preferred_loc_v&&(C=0,D=-1);s=(f+0.001)*C;q=(g+0.001)*D;a=1E4;for(k=!0;a&&k;)if(a--,j=[new d.Vector2(l+f+s,m+g+q),new d.Vector2(l-f+s,m+g+q),new d.Vector2(l+f+s,m-g+q),new d.Vector2(l-f+s,m-g+q)],z.ConvexHullContainsPoint(e,c,j[0])||z.ConvexHullContainsPoint(e,c,j[1])||z.ConvexHullContainsPoint(e,c,j[2])||z.ConvexHullContainsPoint(e,c,j[3]))s+=i.x,q+=i.y;else{k=new d.Box2;k.setFromPoints(j);
for(j=0;j<e;++j)k.containsPoint(e[j])&&(s+=i.x,q+=i.y);k=!1}0==a&&w.Log("ViewerView Warning: too many iterations when pushing label outside of its convex hull.");s+=b.x*Math.sign(C);q+=b.y*Math.sign(D)}h.position.set(l+s,m+q,0)},CameraUpdate:function(a,b,c){var i=this.get("_3JSsceneBBox").clone();if(!i.isEmpty()){this.SetCamera(this.get("_3JSsceneBBoxFocus"),b,c);var g=this.get("_3JScamera").position.clone(),h=this.get("_3JScamera").up.clone().normalize(),g=i.center().clone().sub(g);g.normalize();
for(var f=g.clone().cross(h),h=g.clone().sub(h.clone().multiplyScalar(0.5)).sub(f.clone().multiplyScalar(0.7)),g=0,f=Object.keys(this.get("_renderercache").lights.dir_light),e=f.length;g<e;++g){var j=this.get("_renderercache").lights.dir_light[f[g]];j&&(j.position.set(-h.x,-h.y,-h.z),j.needsUpdate=!0)}h=this.get("_3JSsceneBBox").min.clone();g=new d.Vector3(0,this.get("_3JSsceneBBox").size().y+this.get("_mirror_offset"),0);h.sub(g);i.expandByPoint(h);this.UpdateCamNearAndFar(i,b,c);b=!1;null===this.get("_3JScamera").parent&&
this.get("_3JScamera").updateMatrixWorld();c=new d.Matrix4;b=new d.Frustum;this.get("_3JScamera").matrixWorldInverse.getInverse(this.get("_3JScamera").matrixWorld);c.multiplyMatrices(this.get("_3JScamera").projectionMatrix,this.get("_3JScamera").matrixWorldInverse);b.setFromMatrix(c);c=new d.Geometry;c.vertices.push(this.get("_3JSsceneBBox").min,this.get("_3JSsceneBBox").max);c=new d.Mesh(c,null);this.set("_obj_in_frustum_prev",this.get("_obj_in_frustum"));b=b.intersectsObject(c);this.set("_obj_in_frustum",
b);(void 0===a||a)&&this.Render()}},SetCameraAngles:function(a,b,c){var d=this.get("_renderercache").cameras.defaultcamera.azimuthAngle,g=this.get("_renderercache").cameras.defaultcamera.elevationAngle;this.get("_renderercache").cameras.defaultcamera.azimuthAngle=a;this.get("_renderercache").cameras.defaultcamera.elevationAngle=b;this.CameraUpdate(c);!this.get("_obj_in_frustum")&&this.get("_obj_in_frustum_prev")&&(this.get("_renderercache").cameras.defaultcamera.azimuthAngle=d,this.get("_renderercache").cameras.defaultcamera.elevationAngle=
g,this.CameraUpdate(c))},GetCameraAngles:function(){return{azimuth:this.get("_renderercache").cameras.defaultcamera.azimuthAngle,elevation:this.get("_renderercache").cameras.defaultcamera.elevationAngle}},SetCameraScale:function(a,b){var c=this.get("_renderercache").cameras.defaultcamera.scale;this.get("_renderercache").cameras.defaultcamera.scale=a;this.CameraUpdate(b);!this.get("_obj_in_frustum")&&this.get("_obj_in_frustum_prev")&&(this.get("_renderercache").cameras.defaultcamera.scale=c,this.CameraUpdate(b))},
GetCameraScale:function(){return this.get("_renderercache").cameras.defaultcamera.scale},SetCameraPanOffset:function(a,b){var c=this.get("_renderercache").cameras.defaultcamera.panOffset;this.get("_renderercache").cameras.defaultcamera.panOffset=a;this.CameraUpdate(b);!this.get("_obj_in_frustum")&&this.get("_obj_in_frustum_prev")&&(this.get("_renderercache").cameras.defaultcamera.panOffset=c,this.CameraUpdate(b))},GetCameraPanOffset:function(){var a=this.get("_renderercache").cameras.defaultcamera.panOffset;
return{x:a.x,y:a.y}},SetPerspectiveCamera:function(a,b){this.get("_renderercache").cameras.defaultcamera.cam_type="PERSPECTIVE";this.get("_renderercache").cameras.defaultcamera.fieldOfView=a;this.CameraUpdate(b)},SetOrthographicCamera:function(a){this.get("_renderercache").cameras.defaultcamera.cam_type="ORTHOGRAPHIC";this.CameraUpdate(a)},UpdateCamNearAndFar:function(a,b,c){var i=this.get("_3JScamera"),g=this.get("_renderercache").cameras.defaultcamera.fieldOfView,h=a.max,f=a.min,a=new d.Vector3(h.x-
f.x,h.y-f.y,h.z-f.z),h=new d.Vector3((f.x+h.x)/2,(f.y+h.y)/2,(f.z+h.z)/2),b=b?b:this.get("_context").clientWidth,c=c?c:this.get("_context").clientHeight,c=b/c;Math.min(g,c*g);g=Math.sqrt(a.x*a.x+a.y*a.y+a.z*a.z);a=this.get("_3JScamera").position.clone();b=this.get("_renderercache").cameras.defaultcamera;a.addScaledVector(this.get("_cameraleftdirvec"),b.panOffset.x);a.addScaledVector(this.get("_3JScamera").up,-b.panOffset.y);h=h.sub(a).length();i.near=Math.max(h-g/2,0.1);i.far=Math.max(h+g/2,0.2);
i.aspect=c;i.updateProjectionMatrix()},GetOptimisedScaleForCurrentView:function(a,b){var c=this.get("_renderercache").cameras.defaultcamera,i=a?a:this.get("_context").clientWidth,g=b?b:this.get("_context").clientHeight,h=this.get("_3JSsceneBBoxFocus").max,f=this.get("_3JSsceneBBoxFocus").min,e=c.fieldOfView,j=i/g,l,m=new d.Vector3(Math.abs(h.x-f.x),Math.abs(h.y-f.y),Math.abs(h.z-f.z));l=Math.sqrt(m.x*m.x+m.y*m.y+m.z*m.z);var k=f.x-(f.x+h.x)/2,m=f.y-(f.y+h.y)/2,r=f.z-(f.z+h.z)/2,n=h.x-(f.x+h.x)/2,
p=h.y-(f.y+h.y)/2,h=h.z-(f.z+h.z)/2,s=z.radians(c.azimuthAngle),q=z.radians(-c.elevationAngle),f=new d.Matrix3;f.set(Math.cos(q)*Math.cos(s),-Math.sin(q),Math.cos(q)*-Math.sin(s),Math.sin(q)*Math.cos(s),Math.cos(q),Math.sin(q)*-Math.sin(s),Math.sin(s),0,Math.cos(s));var s=new d.Vector3(k,m,r),q=new d.Vector3(k,m,h),u=new d.Vector3(k,p,r),v=new d.Vector3(k,p,h),t=new d.Vector3(n,m,r),w=new d.Vector3(n,m,h),x=new d.Vector3(n,p,r),h=new d.Vector3(n,p,h);s.applyMatrix3(f);q.applyMatrix3(f);u.applyMatrix3(f);
v.applyMatrix3(f);t.applyMatrix3(f);w.applyMatrix3(f);x.applyMatrix3(f);h.applyMatrix3(f);k=Math.min(s.x,Math.min(q.x,Math.min(u.x,Math.min(v.x,Math.min(t.x,Math.min(w.x,Math.min(x.x,h.x)))))));m=Math.min(s.y,Math.min(q.y,Math.min(u.y,Math.min(v.y,Math.min(t.y,Math.min(w.y,Math.min(x.y,h.y)))))));r=Math.min(s.z,Math.min(q.z,Math.min(u.z,Math.min(v.z,Math.min(t.z,Math.min(w.z,Math.min(x.z,h.z)))))));n=Math.max(s.x,Math.max(q.x,Math.max(u.x,Math.max(v.x,Math.max(t.x,Math.max(w.x,Math.max(x.x,h.x)))))));
p=Math.max(s.y,Math.max(q.y,Math.max(u.y,Math.max(v.y,Math.max(t.y,Math.max(w.y,Math.max(x.y,h.y)))))));h=Math.max(s.z,Math.max(q.z,Math.max(u.z,Math.max(v.z,Math.max(t.z,Math.max(w.z,Math.max(x.z,h.z)))))));if("PERSPECTIVE"==c.cam_type)return i=j*e,m=new d.Vector3(Math.abs(n-k),Math.abs(p-m),Math.abs(h-r)),g=Math.abs(m.y/(2*Math.tan(z.radians(e)/2))),i=Math.abs(m.z/(2*Math.tan(z.radians(i)/2))),i=Math.max(i,g),i=0.5*Math.abs(n-k)+i,g=Math.min(e,j*e),Math.abs(l/(2*Math.tan(z.radians(g)/2)))/(i-0.5*
l);e=Math.abs(h-r)/i;j=Math.abs(p-m)/g;j=Math.max(e,j);e=j*i;j*=g;l=Math.max(l/i,l/g);return Math.max(l*i/e,l*g/j)},SetOptimisedViewRendering:function(a,b,c){this.set("_optimised_view",b);this.set("_optimised_view_border",a);this.CameraUpdate(c)},ComputeNewCamera:function(a,b,c,i,g,h,f,e,j,l){var m,k;k=Math.max(0.5*h+f/c,0.5*h);f=new d.Vector3(b.x,b.y,b.z);f.x+=k*Math.sin(Math.PI/2-z.radians(a.elevationAngle))*Math.cos(z.radians(a.azimuthAngle));f.z-=k*Math.sin(Math.PI/2-z.radians(a.elevationAngle))*
Math.sin(z.radians(a.azimuthAngle));f.y+=k*Math.cos(Math.PI/2-z.radians(a.elevationAngle));var r=new d.Vector3(b.x,b.y,b.z);r.sub(f);var n,p;p=90<=a.elevationAngle?a.elevationAngle=89.99:a.elevationAngle;n=new d.Vector3(0,0,0);n.x+=k*Math.sin(Math.PI/2-z.radians(p))*Math.cos(z.radians(a.azimuthAngle)-Math.PI/2);n.z-=k*Math.sin(Math.PI/2-z.radians(p))*Math.sin(z.radians(a.azimuthAngle)-Math.PI/2);n.normalize();r=r.cross(n).normalize();p=k-h/2;k+=h/2;h=Math.max(h/j,h/l);j=h*j/c;c=h*l/c;"PERSPECTIVE"==
a.cam_type?m=new d.PerspectiveCamera(a.fieldOfView,e,p,k):"ORTHOGRAPHIC"==a.cam_type&&(m=new d.OrthographicCamera(j/-2,j/2,c/2,c/-2,p,k));m.up=r;m.position.set(f.x,f.y,f.z);m.lookAt(b);this.set("_cameraleftdirvec",n);m.position.set(f.x,f.y,f.z);a.panOffset.x=i;a.panOffset.y=g;m.position.addScaledVector(n,-i);m.position.addScaledVector(r,g);return m},SetCamera:function(a,b,c){var i=this.get("_renderercache").cameras.defaultcamera,g=b?b:this.get("_context").clientWidth,h=c?c:this.get("_context").clientHeight,
f=a.max,e=a.min,j=new d.Vector3((e.x+f.x)/2,(e.y+f.y)/2,(e.z+f.z)/2),l=i.fieldOfView,m=g/h,b=i.scale=this.get("_optimised_view")?this.GetOptimisedScaleForCurrentView(b,c):i.scale,f=new d.Vector3(Math.abs(f.x-e.x),Math.abs(f.y-e.y),Math.abs(f.z-e.z)),f=Math.sqrt(f.x*f.x+f.y*f.y+f.z*f.z),l=Math.min(l,m*l),l=Math.abs(f/(2*Math.tan(z.radians(l)/2))),k;if(this.get("_optimised_view")){k=this.ComputeNewCamera(i,j,b,0,0,f,l,m,g,h);this.UpdateLabelsPositions(k,g,h);var e=a.min.clone(),c=new d.Vector3(a.min.x,
a.min.y,a.max.z),r=new d.Vector3(a.min.x,a.max.y,a.min.z),n=new d.Vector3(a.min.x,a.max.y,a.max.z),p=new d.Vector3(a.max.x,a.min.y,a.min.z),s=new d.Vector3(a.max.x,a.min.y,a.max.z),q=new d.Vector3(a.max.x,a.max.y,a.min.z),a=a.max.clone(),u=g/2-this.get("_optimised_view_border").x,v=h/2-this.get("_optimised_view_border").y,t=new d.Box2;t.expandByPoint(e.clone().project(k));t.expandByPoint(c.clone().project(k));t.expandByPoint(r.clone().project(k));t.expandByPoint(n.clone().project(k));t.expandByPoint(p.clone().project(k));
t.expandByPoint(s.clone().project(k));t.expandByPoint(q.clone().project(k));t.expandByPoint(a.clone().project(k));t.min.x*=g/2;t.min.y*=h/2;t.max.x*=g/2;t.max.y*=h/2;for(var w=t.min.x>=-u&&t.max.x<=u&&t.min.y>=-v&&t.max.y<=v,w=w&&this.RotateOutOfBoundsVisibleLabels(k,t,g,h,u,v),x=new d.Vector2(0,0),y=100;!w&&0.1<b;)k=new d.Vector2,t.size(k),k.x>u||k.y>v||!y?i.scale=b-=0.005:(k=t.center(),i.panOffset.x=x.x+=1.5*Math.sign(k.x),i.panOffset.y=x.y+=1.5*Math.sign(k.y),y--),k=this.ComputeNewCamera(i,j,b,
x.x,x.y,f,l,m,g,h),this.UpdateLabelsPositions(k,g,h),t.makeEmpty(),t.expandByPoint(e.clone().project(k)),t.expandByPoint(c.clone().project(k)),t.expandByPoint(r.clone().project(k)),t.expandByPoint(n.clone().project(k)),t.expandByPoint(p.clone().project(k)),t.expandByPoint(s.clone().project(k)),t.expandByPoint(q.clone().project(k)),t.expandByPoint(a.clone().project(k)),t.min.x*=g/2,t.min.y*=h/2,t.max.x*=g/2,t.max.y*=h/2,w=(w=t.min.x>=-u&&t.max.x<=u&&t.min.y>=-v&&t.max.y<=v)&&this.RotateOutOfBoundsVisibleLabels(k,
t,g,h,u,v)}else k=this.ComputeNewCamera(i,j,b,i.panOffset.x,i.panOffset.y,f,l,m,g,h),this.UpdateLabelsPositions(k,g,h);this.set("_3JScamera",k)},SetCameraFocus:function(a,b){for(var c=this.URLToKeyString(a),i=0,g=Object.keys(this.get("_renderercache").nodeviewproperties[c].threejsnodes),h=g.length;i<h;++i){for(var f=g[i],f=this.get("_renderercache").nodeviewproperties[c].threejsnodes[f],e=new d.Box3,j=0,l=Object.keys(f),m=l.length;j<m;j++){var k=new d.Box3;k.setFromObject(f[l[j]]);k.empty()||e.union(k)}if(!e.empty()){this.set("_3JSsceneBBoxFocus",
e);this.CameraUpdate(b);break}}},SetEnvironmentRotation:function(a,b){this.get("_renderercache").environment_settings.rotation=a.clone();this.ApplyFctToAllMaterials(this.UpdateMaterialEnvironmentRotation(this.get("_renderercache").environment_settings.rotation));(void 0===b||b)&&this.Render()},GetEnvironmentRotation:function(){return this.get("_renderercache").environment_settings.rotation.clone()},UpdateMaterialEnvironmentRotation:function(a){var b=new d.Vector4(a.x,a.y,a.z,a.w),c=this;return function(i){if(i&&
i.hasOwnProperty("uniforms")&&(i.uniforms.hasOwnProperty("envMapRotQuat")&&(i.uniforms.envMapRotQuat.value=b),i.uniforms.hasOwnProperty("lightPos")))for(var g=0;g<c.get("_renderercache").lights.holo_light.Lights.length&&4>g;++g){var h=c.get("_renderercache").lights.holo_light.Lights[g],h=new d.Vector3(h[0],h[1],h[2]);h.applyQuaternion(a);i.uniforms.lightPos.value[g]=h}}},FlipMaterialSide:function(a){return function(b){b&&(b.flipped!=a&&(b.side!=d.DoubleSide&&(b.side=b.side==d.FrontSide?d.BackSide:
d.FrontSide),b.hasOwnProperty("uniforms")&&b.uniforms.hasOwnProperty("isFloorReflection")&&(b.uniforms.isFloorReflection.value=d.FrontSide==a?0:1)),b.flipped=a)}},UpdateReflectionUniforms:function(a,b,c,d){this.get("_renderercache").materials.BackdropShaderMaterial.uniforms.reflection_opacity.value=void 0!==a?a:this.get("_renderercache").reflections.opacity;this.get("_renderercache").materials.BackdropShaderMaterial.uniforms.reflection_fade.value=void 0!==b?b:this.get("_renderercache").reflections.fade;
this.get("_renderercache").materials.BackdropShaderMaterial.uniforms.reflection_fade_position.value=void 0!==c?c:this.get("_renderercache").reflections.fade_position;this.get("_renderercache").materials.BackdropShaderMaterial.uniforms.reflection_fade_size.value=void 0!==d?d:this.get("_renderercache").reflections.fade_size;this.get("_renderercache").materials.ColorBlendShaderMaterial.uniforms.reflection_opacity.value=void 0!==a?a:this.get("_renderercache").reflections.opacity;this.get("_renderercache").materials.ColorBlendShaderMaterial.uniforms.reflection_fade.value=
void 0!==b?b:this.get("_renderercache").reflections.fade;this.get("_renderercache").materials.ColorBlendShaderMaterial.uniforms.reflection_fade_position.value=void 0!==c?c:this.get("_renderercache").reflections.fade_position;this.get("_renderercache").materials.ColorBlendShaderMaterial.uniforms.reflection_fade_size.value=void 0!==d?d:this.get("_renderercache").reflections.fade_size;this.get("_renderercache").materials.CopyShaderMaterial.uniforms.reflection_opacity.value=void 0!==a?a:this.get("_renderercache").reflections.opacity;
this.get("_renderercache").materials.CopyShaderMaterial.uniforms.reflection_fade.value=void 0!==b?b:this.get("_renderercache").reflections.fade;this.get("_renderercache").materials.CopyShaderMaterial.uniforms.reflection_fade_position.value=void 0!==c?c:this.get("_renderercache").reflections.fade_position;this.get("_renderercache").materials.CopyShaderMaterial.uniforms.reflection_fade_size.value=void 0!==d?d:this.get("_renderercache").reflections.fade_size},IsReflectionsRenderingEnabled:function(){return this.get("_SceneLoaded")&&
this.get("_3JSsceneBBox").min.y<this.get("_3JScamera").position.y&&("JSON"==this.get("_reflection_config")&&this.get("_renderercache").reflections.enabled||"ON"==this.get("_reflection_config"))},FlipScene:function(a){a.applyMatrix(this.get("_reflection_Y_scale"));a.applyMatrix(this.get("_reflection_Y_translation"))},UnflipScene:function(a){a.applyMatrix(this.get("_reflection_Y_opp_translation"));a.applyMatrix(this.get("_reflection_Y_scale"))},FlipAllScenes:function(){this.FlipScene(this.get("_3JSsceneOp"));
this.FlipScene(this.get("_3JSsceneOpDepth"));this.FlipScene(this.get("_3JSsceneOpaqueDiffuse"));for(var a=0;a<this.get("_3JSsceneOpCoincidentGroupsPasses").length;++a){var b=this.get("_3JSsceneOpCoincidentGroupsPasses")[a];this.FlipScene(this.get("_3JSsceneOpCoincidentGroups")[b]);this.FlipScene(this.get("_3JSsceneOpCoincidentGroupsDepth")[b]);this.FlipScene(this.get("_3JSsceneOpCoincidentGroupsDiffuse")[b])}this.FlipScene(this.get("_3JSsceneTransp"));this.FlipScene(this.get("_3JSsceneTranspDepth"));
this.FlipScene(this.get("_3JSsceneTranspDiffuse"));for(a=0;a<this.get("_3JSsceneTranspCoincidentGroupsPasses").length;++a)b=this.get("_3JSsceneTranspCoincidentGroupsPasses")[a],this.FlipScene(this.get("_3JSsceneTranspCoincidentGroups")[b]),this.FlipScene(this.get("_3JSsceneTranspCoincidentGroupsDiffuse")[b]),this.FlipScene(this.get("_3JSsceneTranspCoincidentGroupsDepth")[b])},UnFlipAllScenes:function(){this.UnflipScene(this.get("_3JSsceneOp"));this.UnflipScene(this.get("_3JSsceneOpDepth"));this.UnflipScene(this.get("_3JSsceneOpaqueDiffuse"));
for(var a=0;a<this.get("_3JSsceneOpCoincidentGroupsPasses").length;++a){var b=this.get("_3JSsceneOpCoincidentGroupsPasses")[a];this.UnflipScene(this.get("_3JSsceneOpCoincidentGroups")[b]);this.UnflipScene(this.get("_3JSsceneOpCoincidentGroupsDepth")[b]);this.UnflipScene(this.get("_3JSsceneOpCoincidentGroupsDiffuse")[b])}this.UnflipScene(this.get("_3JSsceneTransp"));this.UnflipScene(this.get("_3JSsceneTranspDepth"));this.UnflipScene(this.get("_3JSsceneTranspDiffuse"));for(a=0;a<this.get("_3JSsceneTranspCoincidentGroupsPasses").length;++a)b=
this.get("_3JSsceneTranspCoincidentGroupsPasses")[a],this.UnflipScene(this.get("_3JSsceneTranspCoincidentGroups")[b]),this.UnflipScene(this.get("_3JSsceneTranspCoincidentGroupsDiffuse")[b]),this.UnflipScene(this.get("_3JSsceneTranspCoincidentGroupsDepth")[b])},FlipOpaqueScene:function(){this.FlipScene(this.get("_3JSsceneOp"));for(var a=0;a<this.get("_3JSsceneOpCoincidentGroupsPasses").length;++a){var b=this.get("_3JSsceneOpCoincidentGroupsPasses")[a];this.FlipScene(this.get("_3JSsceneOpCoincidentGroups")[b])}},
UnFlipOpaqueScene:function(){this.UnflipScene(this.get("_3JSsceneOp"));for(var a=0;a<this.get("_3JSsceneOpCoincidentGroupsPasses").length;++a){var b=this.get("_3JSsceneOpCoincidentGroupsPasses")[a];this.UnflipScene(this.get("_3JSsceneOpCoincidentGroups")[b])}},FlipTransparentScene:function(){this.FlipScene(this.get("_3JSsceneTransp"));for(var a=0;a<this.get("_3JSsceneTranspCoincidentGroupsPasses").length;++a){var b=this.get("_3JSsceneTranspCoincidentGroupsPasses")[a];this.FlipScene(this.get("_3JSsceneTranspCoincidentGroups")[b])}},
UnFlipTransparentScene:function(){this.UnflipScene(this.get("_3JSsceneTransp"));for(var a=0;a<this.get("_3JSsceneTranspCoincidentGroupsPasses").length;++a){var b=this.get("_3JSsceneTranspCoincidentGroupsPasses")[a];this.UnflipScene(this.get("_3JSsceneTranspCoincidentGroups")[b])}},FlipLights:function(){for(var a=0,b=Object.keys(this.get("_renderercache").lights.dir_light),c=b.length;a<c;++a){var d=this.get("_renderercache").lights.dir_light[b[a]];d&&(d.position.set(-d.position.x,d.position.y,-d.position.z),
d.needsUpdate=!0)}},UnFlipLights:function(){this.FlipLights()},RenderScene:function(a,b){this.get("_3JSrenderer").render(a,this.get("_3JScamera"),b)},RenderOpaqueScene:function(a){this.RenderScene(this.get("_3JSsceneOp"),a);var b=function(a){return function(b){b instanceof d.Mesh&&b.material&&(b.material.depthWrite=a)}};this.get("_3JSrenderer").autoClear=!1;for(var c=0;c<this.get("_3JSsceneOpCoincidentGroupsPasses").length;++c){var i=this.get("_3JSsceneOpCoincidentGroupsPasses")[c];this.get("_3JSsceneOpCoincidentGroups")[i].traverse(b(!1));
this.RenderScene(this.get("_3JSsceneOpCoincidentGroups")[i],a);this.get("_3JSrenderer").context.colorMask(!1,!1,!1,!1);this.get("_3JSsceneOpCoincidentGroups")[i].traverse(b(!0));this.RenderScene(this.get("_3JSsceneOpCoincidentGroups")[i],a);this.get("_3JSrenderer").context.colorMask(!0,!0,!0,!0)}this.get("_3JSrenderer").autoClear=!0},RenderOpaqueSceneDepth:function(a,b){this.get("_3JSsceneOpDepth").overrideMaterial=b?b:this.get("_renderercache").materials.D0ShaderMaterial;this.RenderScene(this.get("_3JSsceneOpDepth"),
a);this.get("_3JSrenderer").autoClear=!1;for(var c=0;c<this.get("_3JSsceneOpCoincidentGroupsPasses").length;++c){var d=this.get("_3JSsceneOpCoincidentGroupsPasses")[c];this.get("_3JSsceneOpCoincidentGroupsDepth")[d].overrideMaterial=b?b:this.get("_renderercache").materials.D0ShaderMaterial;this.RenderScene(this.get("_3JSsceneOpCoincidentGroupsDepth")[d],a)}this.get("_3JSrenderer").autoClear=!0},RenderOpaqueSceneDiffuse:function(a){this.RenderScene(this.get("_3JSsceneOpaqueDiffuse"),a);var b=function(a){return function(b){b instanceof
d.Mesh&&b.material&&(b.material.depthWrite=a)}};this.get("_3JSrenderer").autoClear=!1;for(var c=0;c<this.get("_3JSsceneOpCoincidentGroupsPasses").length;++c){var i=this.get("_3JSsceneOpCoincidentGroupsPasses")[c];this.get("_3JSsceneOpCoincidentGroupsDiffuse")[i].traverse(b(!1));this.RenderScene(this.get("_3JSsceneOpCoincidentGroupsDiffuse")[i],a);this.get("_3JSrenderer").context.colorMask(!1,!1,!1,!1);this.get("_3JSsceneOpCoincidentGroupsDiffuse")[i].traverse(b(!0));this.RenderScene(this.get("_3JSsceneOpCoincidentGroupsDiffuse")[i],
a);this.get("_3JSrenderer").context.colorMask(!0,!0,!0,!0)}this.get("_3JSrenderer").autoClear=!0},RenderTransparentScene:function(a,b){"function"===typeof b&&this.get("_3JSsceneTransp").traverse(b);this.RenderScene(this.get("_3JSsceneTransp"),a);var c=function(a){return function(b){b instanceof d.Mesh&&b.material&&(b.material.depthWrite=a)}};this.get("_3JSrenderer").autoClear=!1;for(var i=0;i<this.get("_3JSsceneTranspCoincidentGroupsPasses").length;++i){var g=this.get("_3JSsceneTranspCoincidentGroupsPasses")[i];
this.get("_3JSsceneTranspCoincidentGroups")[g].traverse(b);this.get("_3JSsceneTranspCoincidentGroups")[g].traverse(c(!1));this.RenderScene(this.get("_3JSsceneTranspCoincidentGroups")[g],a);this.get("_3JSrenderer").context.colorMask(!1,!1,!1,!1);this.get("_3JSsceneTranspCoincidentGroups")[g].traverse(c(!0));this.RenderScene(this.get("_3JSsceneTranspCoincidentGroups")[g],a);this.get("_3JSrenderer").context.colorMask(!0,!0,!0,!0)}this.get("_3JSrenderer").autoClear=!0},RenderTransparentSceneDepth:function(a,
b){this.get("_3JSsceneTranspDepth").overrideMaterial=b;this.RenderScene(this.get("_3JSsceneTranspDepth"),a);this.get("_3JSsceneTranspDepth").overrideMaterial=null;this.get("_3JSrenderer").autoClear=!1;for(var c=0;c<this.get("_3JSsceneTranspCoincidentGroupsPasses").length;++c){var d=this.get("_3JSsceneTranspCoincidentGroupsPasses")[c];this.get("_3JSsceneTranspCoincidentGroupsDepth")[d].overrideMaterial=b;this.RenderScene(this.get("_3JSsceneTranspCoincidentGroupsDepth")[d],a);this.get("_3JSsceneTranspCoincidentGroupsDepth")[d].overrideMaterial=
null}this.get("_3JSrenderer").autoClear=!0},RenderTransparentSceneDiffuse:function(a,b){this.get("_3JSsceneTranspDiffuse").traverse(b);this.RenderScene(this.get("_3JSsceneTranspDiffuse"),a);var c=function(a){return function(b){b instanceof d.Mesh&&b.material&&(b.material.depthWrite=a)}};this.get("_3JSrenderer").autoClear=!1;for(var i=0;i<this.get("_3JSsceneTranspCoincidentGroupsPasses").length;++i){var g=this.get("_3JSsceneTranspCoincidentGroupsPasses")[i];this.get("_3JSsceneTranspCoincidentGroupsDiffuse")[g].traverse(b);
this.get("_3JSsceneTranspCoincidentGroupsDiffuse")[g].traverse(c(!1));this.RenderScene(this.get("_3JSsceneTranspCoincidentGroupsDiffuse")[g],a);this.get("_3JSrenderer").context.colorMask(!1,!1,!1,!1);this.get("_3JSsceneTranspCoincidentGroupsDiffuse")[g].traverse(c(!0));this.RenderScene(this.get("_3JSsceneTranspCoincidentGroupsDiffuse")[g],a);this.get("_3JSrenderer").context.colorMask(!0,!0,!0,!0)}this.get("_3JSrenderer").autoClear=!0},SetSizeOfRTSrc:function(a,b){return function(c){c instanceof d.Mesh&&
c.material.hasOwnProperty("uniforms")&&c.material.uniforms.hasOwnProperty("canvas_size")&&(c.material.uniforms.canvas_size.value=new d.Vector2(a,b))}},SetAsRTSrc:function(a,b,c,i){var g=Math.max(arguments.length-2,0),h=this;return function(f){f instanceof d.Mesh&&f.material.hasOwnProperty("uniforms")&&(f.material.uniforms.hasOwnProperty("DX1RT")&&(f.material.uniforms.hasOwnProperty("DX2RT")&&f.material.uniforms.hasOwnProperty("NBRTSRC")&&f.material.uniforms.hasOwnProperty("canvas_size"))&&(f.material.uniforms.canvas_size.value=
new d.Vector2(a,b),f.material.uniforms.DX1RT.value=c?c.texture:h.get("_DummyTexture"),f.material.uniforms.DX2RT.value=i?i.texture:h.get("_DummyTexture"),f.material.uniforms.NBRTSRC.value=g),f.material.uniforms.hasOwnProperty("transparent")&&(f.material.uniforms.transparent.value=c?1:0))}},RenderDepthPeel:function(a,b,c,i,g,h,f,e,j,l,m,k,r,n){this.get("_3JSrenderer").setClearColor(r,1);this.RenderOpaqueSceneDepth(e);this.get("_3JSrenderer").autoClearDepth=!0;this.get("_renderercache").materials.DepthOnlyShaderMaterial.uniforms.DX1RT.value=
e.texture;this.get("_renderercache").materials.DepthOnlyShaderMaterial.uniforms.NBRTSRC.value=1;this.RenderTransparentSceneDepth(h,this.get("_renderercache").materials.DepthOnlyShaderMaterial);this.get("_3JSrenderer").autoClearDepth=!1;this.get("_3JSrenderer").setClearColor(r,1);this.RenderTransparentScene(h,this.SetAsRTSrc(i,g,e));this.get("_3JSrenderer").autoClearDepth=!0;this.RenderTransparentSceneDepth(f,this.get("_renderercache").materials.DepthOnlyShaderMaterial);this.get("_3JSrenderer").autoClearDepth=
!1;this.get("_3JSrenderer").setClearColor(n,1);this.RenderTransparentSceneDiffuse(f,this.SetAsRTSrc(i,g,e));this.get("_3JSrenderer").autoClearDepth=!0;if(1<this.get("_current_nb_peels")&&this.get("_SceneLoaded")){this.get("_3JSrenderer").setClearColor(r,1);this.get("_renderercache").materials.D1ShaderMaterial.uniforms.D0RT.value=e.texture;this.RenderTransparentSceneDepth(j,this.get("_renderercache").materials.D1ShaderMaterial);this.get("_renderercache").materials.D2ShaderMaterial.uniforms.DX1RT.value=
e.texture;this.get("_3JSrenderer").setClearColor(r,1);for(var p=0;p<this.get("_current_nb_peels")-1;++p){this.get("_3JSrenderer").autoClearDepth=!0;this.get("_3JSrenderer").autoClearColor=!0;this.get("_renderercache").materials.DepthOnlyShaderMaterial.uniforms.DX2RT.value=p%2?l.texture:j.texture;this.get("_renderercache").materials.DepthOnlyShaderMaterial.uniforms.NBRTSRC.value=2;this.RenderTransparentSceneDepth(m,this.get("_renderercache").materials.DepthOnlyShaderMaterial);this.get("_3JSrenderer").autoClearDepth=
!1;this.RenderTransparentScene(m,this.SetAsRTSrc(i,g,e,p%2?l:j));this.get("_3JSrenderer").autoClearDepth=!0;this.get("_3JSrenderer").autoClearColor=!1;this.get("_renderercache").materials.ColorBlendShaderMaterial.uniforms.CX1RT.value=m.texture;this.get("_renderercache").materials.ColorBlendShaderMaterial.uniforms.TransparencyStack.value=f.texture;this.get("_renderercache").materials.ColorBlendShaderMaterial.uniforms.EnableBGBlend.value=0;var s=new d.Mesh(c,this.get("_renderercache").materials.ColorBlendShaderMaterial),
q=new d.Scene;q.add(s);this.get("_3JSrenderer").render(q,b,h);this.get("_3JSrenderer").autoClearColor=!0;this.get("_3JSrenderer").autoClearDepth=!0;this.get("_3JSrenderer").autoClearColor=!1;this.RenderTransparentSceneDepth(f,this.get("_renderercache").materials.DepthOnlyShaderMaterial);this.get("_3JSrenderer").autoClearDepth=!1;this.get("_3JSrenderer").autoClearColor=!1;this.RenderTransparentSceneDiffuse(f,this.SetAsRTSrc(i,g,e,p%2?l:j));this.get("_3JSrenderer").autoClearColor=!0;this.get("_3JSrenderer").autoClearDepth=
!0;this.get("_renderercache").materials.D2ShaderMaterial.uniforms.DX2RT.value=p%2?l.texture:j.texture;this.RenderTransparentSceneDepth(p%2?j:l,this.get("_renderercache").materials.D2ShaderMaterial)}}this.get("_3JSrenderer").setClearColor(r,1);this.RenderOpaqueScene(m);a&&(this.get("_3JSrenderer").autoClear=!1,this.get("_3JSrenderer").render(this.get("_3JSsceneHightlights"),this.get("_3JScamera"),m),this.get("_3JSrenderer").autoClear=!0);this.get("_3JSrenderer").setClearColor(n,1);this.RenderOpaqueSceneDiffuse(k);
a&&(this.get("_3JSrenderer").autoClear=!1,this.get("_3JSsceneHightlights").overrideMaterial=this.get("_renderercache").materials.blackhighlight,this.get("_3JSrenderer").render(this.get("_3JSsceneHightlights"),this.get("_3JScamera"),k),this.get("_3JSsceneHightlights").overrideMaterial=null,this.get("_3JSrenderer").autoClear=!0)},Render:function(a,b,c){if(!this.get("_emptyOpaqueScene")||!this.get("_emptyTransparentScene")){b=b?b:this.get("_context").clientWidth;c=c?c:this.get("_context").clientHeight;
if(a||this.get("_resetRenderTarget"))this.InitializeRenderTargets(b,c),this.CameraUpdate(!1,b,c),this.set("_3JSHUDcamera",new d.OrthographicCamera(-b/2,b/2,c/2,-c/2,0,10)),this.set("_resetRenderTarget",!1);this.get("_renderercache");var i=this.get("_renderercache").materials.enablehighlights,g=this.get("_renderercache").materials.enablehardedgehighlights,h=this.get("_renderercache").materials.enablehorizonhighlights,f=this.get("_renderercache").labels.visible,e=this.get("_ColorStackRT"),j=new d.OrthographicCamera(-b/
2,b/2,c/2,-c/2,-1E5,1E5);j.position.z=1E4;var l=new d.PlaneGeometry(b,c),m,k,r,n,p;if(this.get("_renderercache").textures[this.get("_RenderingQuality")].backdrop.loaded&&this.get("_renderercache").textures[this.get("_RenderingQuality")].backdrop.enabled){m=this.get("_renderercache").textures[this.get("_RenderingQuality")].backdrop.data;n=this.get("_renderercache").textures[this.get("_RenderingQuality")].backdrop.original_width;p=this.get("_renderercache").textures[this.get("_RenderingQuality")].backdrop.original_height;
var s=m.image.naturalWidth,q=m.image.naturalHeight;n||(n=s);p||(p=q);var u=b/c,v=s/p;r=k=1;u<v?k=u/v:r=v/u;k*=n/s;r*=p/q;n=-0.5*k+0.5*n/s;p=-0.5*r+0.5*p/q}aa.Update();q=aa.GetCountPerMinute();q!=this.get("_current_fps")&&(w.Log("Average framerate: "+q),this.set("_current_fps",q));if(!this.get("_emptyTransparentScene")&&"Visualizer"==this.get("_RenderingQuality")){this.get("_interactiveFrameRate")&&this.get("_enableInteractionOptimization")?(q>this.get("_target_fps_max")?this.set("_current_nb_peels",
this.get("_current_nb_peels")+1):q<this.get("_target_fps_min")&&this.set("_current_nb_peels",this.get("_current_nb_peels")-1),this.set("_current_nb_peels",Math.max(Math.min(this.get("_current_nb_peels"),this.get("_nb_max_peels")),this.get("_nb_min_peels")))):this.set("_current_nb_peels",this.get("_nb_max_peels"));var q=this.get("_OpaqueDepthRT"),t=this.get("_D1RT"),y=this.get("_D2RT"),s=this.get("_PeelColorRT"),u=this.get("_TransparencyStackRT"),v=this.get("_OpaqueBackgroundMaskRT"),x=this.get("_MirrorColorStackRT"),
z=this.get("_MirrorColorStackRT2"),A=this.get("_MirrorOpaqueDepthRT"),C=this.get("_MirrorPeelColorRT"),D=this.get("_MirrorTransparencyStackRT");this.get("_FadedMirrorTransparencyStackRT");var E=this.get("_MirrorOpaqueBackgroundMaskRT");this.get("_3JSsceneOp").traverse(this.SetSizeOfRTSrc(b,c));this.get("_3JSsceneTransp").traverse(this.SetSizeOfRTSrc(b,c));this.get("_3JSsceneTranspDepth").traverse(this.SetSizeOfRTSrc(b,c));this.get("_3JSsceneTranspDiffuse").traverse(this.SetSizeOfRTSrc(b,c));this.get("_3JSsceneOpaqueDiffuse").traverse(this.SetSizeOfRTSrc(b,
c));this.get("_3JSrenderer").autoClear=!0;var F=new d.Color(1,1,1),G=new d.Color(0,0,0),H=this.get("_backgroundColor"),I=this.get("_backgroundAlpha");this.get("_renderercache").materials.CopyShaderMaterial.uniforms.canvas_size.value=new d.Vector2(b,c);this.get("_renderercache").materials.ColorBlendShaderMaterial.uniforms.canvas_size.value=new d.Vector2(b,c);this.get("_renderercache").materials.ColorBlendShaderMaterial.uniforms.EnableBGBlend.value=0;this.get("_renderercache").materials.ColorBlendShaderMaterial.uniforms.EnableBackdrop.value=
0;this.get("_renderercache").materials.ColorBlendShaderMaterial.uniforms.Backdrop.value=this.get("_DummyTexture");this.get("_renderercache").materials.ColorBlendShaderMaterial.uniforms.CX1RT.value=this.get("_DummyTexture");this.get("_renderercache").materials.ColorBlendShaderMaterial.uniforms.TransparencyStack.value=this.get("_DummyTexture");this.get("_renderercache").materials.ColorBlendShaderMaterial.uniforms.OpaqueRT.value=this.get("_DummyTexture");this.get("_renderercache").materials.ColorBlendShaderMaterial.uniforms.ColorStackRT.value=
this.get("_DummyTexture");this.get("_renderercache").materials.DepthOnlyShaderMaterial.uniforms.canvas_size.value=new d.Vector2(b,c);this.get("_renderercache").materials.D1ShaderMaterial.uniforms.canvas_size.value=new d.Vector2(b,c);this.get("_renderercache").materials.D2ShaderMaterial.uniforms.canvas_size.value=new d.Vector2(b,c);this.IsReflectionsRenderingEnabled()&&(this.FlipAllScenes(),this.ApplyFctToAllMaterials(this.FlipMaterialSide(d.BackSide)),this.FlipLights(),this.RenderDepthPeel(!1,j,l,
b,c,x,D,A,t,y,C,E,G,F),this.UnFlipAllScenes(),this.ApplyFctToAllMaterials(this.FlipMaterialSide(d.FrontSide)),this.UnFlipLights());this.RenderDepthPeel(i&&g,j,l,b,c,e,u,q,t,y,s,v,G,F);this.get("_3JSrenderer").getContext().colorMask(!1,!1,!1,!0);this.get("_3JSrenderer").setClearColor(G,0);this.get("_3JSrenderer").clearTarget(e,!0,!1,!1);this.get("_3JSrenderer").getContext().colorMask(!0,!0,!0,!0);this.get("_3JSrenderer").setClearColor(G,1);this.get("_3JSrenderer").autoClearColor=!1;t=new d.Mesh(l,
this.get("_renderercache").materials.ColorBlendShaderMaterial);g=new d.Scene;g.add(t);this.get("_renderercache").materials.ColorBlendShaderMaterial.uniforms.EnableBGBlend.value=1;this.get("_renderercache").materials.ColorBlendShaderMaterial.uniforms.BGColor.value=H;this.get("_renderercache").materials.ColorBlendShaderMaterial.uniforms.BGAlpha.value=I;this.get("_renderercache").materials.ColorBlendShaderMaterial.uniforms.Backdrop.value=m;this.get("_renderercache").materials.ColorBlendShaderMaterial.uniforms.EnableBackdrop.value=
m?1:0;this.get("_renderercache").materials.ColorBlendShaderMaterial.uniforms.EnableBackdropAlpha.value=m?0:1;this.get("_renderercache").materials.ColorBlendShaderMaterial.uniforms.Backdrop_scale.value=new d.Vector2(k,r);this.get("_renderercache").materials.ColorBlendShaderMaterial.uniforms.Backdrop_offset.value=new d.Vector2(n,p);this.IsReflectionsRenderingEnabled()?(this.get("_3JSrenderer").autoClearColor=!0,this.get("_3JSrenderer").setClearColor(G,0),m=new d.Mesh(l,this.get("_renderercache").materials.CopyShaderMaterial),
k=new d.Scene,k.add(m),this.get("_renderercache").materials.ColorBlendShaderMaterial.uniforms.EnableMirror.value=1,this.get("_renderercache").materials.ColorBlendShaderMaterial.uniforms.CX1RT.value=C.texture,this.get("_renderercache").materials.ColorBlendShaderMaterial.uniforms.TransparencyStack.value=D.texture,this.get("_renderercache").materials.ColorBlendShaderMaterial.uniforms.OpaqueRT.value=E.texture,this.get("_renderercache").materials.ColorBlendShaderMaterial.uniforms.ColorStackRT.value=x.texture,
this.get("_3JSrenderer").render(g,j,z),this.get("_renderercache").materials.ColorBlendShaderMaterial.uniforms.EnableMirror.value=0,this.get("_renderercache").materials.ColorBlendShaderMaterial.uniforms.EnableBackdrop.value=1,this.get("_renderercache").materials.ColorBlendShaderMaterial.uniforms.EnableBackdropAlpha.value=1,this.get("_renderercache").materials.ColorBlendShaderMaterial.uniforms.Backdrop_scale.value=new d.Vector2(1,1),this.get("_renderercache").materials.ColorBlendShaderMaterial.uniforms.Backdrop_offset.value=
new d.Vector2(0,0),this.get("_renderercache").materials.ColorBlendShaderMaterial.uniforms.Backdrop.value=z.texture,this.get("_renderercache").materials.ColorBlendShaderMaterial.uniforms.CX1RT.value=s.texture,this.get("_renderercache").materials.ColorBlendShaderMaterial.uniforms.TransparencyStack.value=u.texture,this.get("_renderercache").materials.ColorBlendShaderMaterial.uniforms.OpaqueRT.value=v.texture,this.get("_renderercache").materials.ColorBlendShaderMaterial.uniforms.ColorStackRT.value=e.texture,
this.get("_3JSrenderer").render(g,j,x),this.get("_renderercache").materials.ColorBlendShaderMaterial.uniforms.EnableMirror.value=0):(this.get("_3JSrenderer").autoClearColor=!0,this.get("_3JSrenderer").setClearColor(G,0),this.get("_renderercache").materials.ColorBlendShaderMaterial.uniforms.EnableMirror.value=0,this.get("_renderercache").materials.ColorBlendShaderMaterial.uniforms.CX1RT.value=s.texture,this.get("_renderercache").materials.ColorBlendShaderMaterial.uniforms.TransparencyStack.value=u.texture,
this.get("_renderercache").materials.ColorBlendShaderMaterial.uniforms.OpaqueRT.value=v.texture,this.get("_renderercache").materials.ColorBlendShaderMaterial.uniforms.ColorStackRT.value=e.texture,this.get("_3JSrenderer").render(g,j,x));this.get("_3JSrenderer").autoClearColor=!0;if(i&&h||f)this.get("_3JSrenderer").clear(!1,!0,!1),i&&h&&(this.get("_3JSrenderer").autoClear=!0,this.get("_3JSrenderer").setClearColor(K,0),this.RenderOpaqueSceneDepth(q,this.get("_renderercache").materials.colordepth),this.get("_3JSrenderer").autoClear=
!1,this.RenderTransparentSceneDepth(q,this.get("_renderercache").materials.colordepth),this.get("_3JSrenderer").autoClear=!1,this.get("_renderercache").materials.edge.uniforms.canvas_size.value=new d.Vector2(b,c),this.get("_renderercache").materials.edge.uniforms.depth_texture.value=q.texture,this.RenderOpaqueSceneDepth(x,this.get("_renderercache").materials.edge),this.get("_3JSrenderer").autoClear=!1,this.RenderTransparentSceneDepth(x,this.get("_renderercache").materials.edge),this.get("_3JSrenderer").autoClear=
!1),f&&(this.get("_3JSrenderer").autoClear=!1,this.get("_3JSrenderer").render(this.get("_3JSsceneLabels"),this.get("_3JSHUDcamera"),x)),this.get("_3JSrenderer").autoClear=!0;a||(this.get("_3JSrenderer").setClearColor(G,0),this.get("_renderercache").materials.CopyShaderMaterial.transparent=!0,this.get("_renderercache").materials.CopyShaderMaterial.blending=d.AdditiveBlending,this.get("_renderercache").materials.CopyShaderMaterial.uniforms.canvas_size.value=new d.Vector2(b,c),this.get("_renderercache").materials.CopyShaderMaterial.uniforms.CXRT.value=
x.texture,this.get("_renderercache").materials.CopyShaderMaterial.uniforms.OpaqueRT.value=this.get("_DummyTexture"),this.get("_renderercache").materials.CopyShaderMaterial.uniforms.EnableMask.value=0,this.get("_renderercache").materials.CopyShaderMaterial.uniforms.EnableRefOpacity.value=0,this.get("_renderercache").materials.CopyShaderMaterial.uniforms.EnableInvRefOpacity.value=0,m=new d.Mesh(l,this.get("_renderercache").materials.CopyShaderMaterial),k=new d.Scene,k.add(m),this.get("_3JSrenderer").render(k,
j,null));this.get("_3JSrenderer").autoClear=!1}else{q=null;if(this.IsReflectionsRenderingEnabled()){var q=this.get("_PeelColorRT"),K=new d.Color(0,0,0);this.get("_3JSrenderer").setClearColor(K,1);this.FlipOpaqueScene();this.FlipTransparentScene();this.ApplyFctToAllMaterials(this.FlipMaterialSide(d.BackSide));this.FlipLights();this.RenderOpaqueScene(q,!0);this.get("_3JSrenderer").autoClear=!1;this.RenderTransparentScene(q,!0);this.UnFlipOpaqueScene();this.UnFlipTransparentScene();this.ApplyFctToAllMaterials(this.FlipMaterialSide(d.FrontSide));
this.UnFlipLights()}m?(this.get("_renderercache").materials.BackdropShaderMaterial.uniforms.canvas_size.value=new d.Vector2(b,c),this.get("_renderercache").materials.BackdropShaderMaterial.uniforms.backdrop.value=m,this.get("_renderercache").materials.BackdropShaderMaterial.uniforms.backdrop_enabled.value=1,this.get("_renderercache").materials.BackdropShaderMaterial.uniforms.backdrop_scale.value=new d.Vector2(k,r),this.get("_renderercache").materials.BackdropShaderMaterial.uniforms.backdrop_offset.value=
new d.Vector2(n,p),this.get("_renderercache").materials.BackdropShaderMaterial.uniforms.reflection.value=q,this.get("_renderercache").materials.BackdropShaderMaterial.uniforms.reflection_enabled.value=this.IsReflectionsRenderingEnabled()?1:0,K=new d.Mesh(l,this.get("_renderercache").materials.BackdropShaderMaterial),l=new d.Scene,l.add(K),this.get("_3JSrenderer").render(l,j,a?e:null),this.get("_3JSrenderer").autoClear=!1):this.IsReflectionsRenderingEnabled()?(this.get("_3JSrenderer").setClearColor(this.get("_backgroundColor"),
this.get("_backgroundAlpha")),this.get("_renderercache").materials.BackdropShaderMaterial.uniforms.canvas_size.value=new d.Vector2(b,c),this.get("_renderercache").materials.BackdropShaderMaterial.uniforms.backdrop.value=this.get("_DummyTexture"),this.get("_renderercache").materials.BackdropShaderMaterial.uniforms.backdrop_enabled.value=0,this.get("_renderercache").materials.BackdropShaderMaterial.uniforms.reflection.value=q.texture,this.get("_renderercache").materials.BackdropShaderMaterial.uniforms.reflection_enabled.value=
1,this.get("_renderercache").materials.BackdropShaderMaterial.uniforms.default_bg_color.value=new d.Vector4(this.get("_backgroundColor").r,this.get("_backgroundColor").g,this.get("_backgroundColor").b,this.get("_backgroundAlpha")),K=new d.Mesh(l,this.get("_renderercache").materials.BackdropShaderMaterial),l=new d.Scene,l.add(K),this.get("_3JSrenderer").render(l,j,a?e:null),this.get("_3JSrenderer").autoClear=!1):(this.get("_3JSrenderer").setClearColor(this.get("_backgroundColor"),this.get("_backgroundAlpha")),
this.get("_3JSrenderer").autoClear=!0);this.RenderOpaqueScene(a?e:null);this.get("_3JSrenderer").autoClear=!1;this.RenderTransparentScene(a?e:null);this.get("_3JSrenderer").autoClear=!1;i&&(h&&(this.get("_3JSrenderer").autoClear=!0,q=this.get("_OpaqueDepthRT"),this.get("_3JSrenderer").setClearColor(G,0),this.RenderOpaqueSceneDepth(q,this.get("_renderercache").materials.colordepth),this.get("_3JSrenderer").autoClear=!1,this.RenderTransparentSceneDepth(q,this.get("_renderercache").materials.colordepth),
this.get("_3JSrenderer").autoClear=!1,this.get("_renderercache").materials.edge.uniforms.canvas_size.value=new d.Vector2(b,c),this.get("_renderercache").materials.edge.uniforms.depth_texture.value=q.texture,this.RenderOpaqueSceneDepth(a?e:null,this.get("_renderercache").materials.edge),this.get("_3JSrenderer").autoClear=!1,this.RenderTransparentSceneDepth(a?e:null,this.get("_renderercache").materials.edge),this.get("_3JSrenderer").autoClear=!1),g&&this.get("_3JSrenderer").render(this.get("_3JSsceneHightlights"),
this.get("_3JScamera"),a?e:null));f&&this.get("_3JSrenderer").render(this.get("_3JSsceneLabels"),this.get("_3JSHUDcamera"),a?e:null)}this.get("_3JSrenderer").autoClear=!0;a&&this.set("_resetRenderTarget",!0)}},StartInteractiveFramerate:function(){this.set("_interactiveFrameRate",!0);this.set("_current_nb_peels",this.get("_nb_min_peels"))},EndInteractiveFramerate:function(a){this.set("_interactiveFrameRate",!1);(void 0===a||a)&&this.Render()},Resize:function(a,b,c){this.get("_build_scene_exec_queue").whenFinished(function(){var a=
b?b:this.get("_context").clientWidth,g=c?c:this.get("_context").clientHeight;this.get("_3JSrenderer").setSize(a,g);this.set("_3JSHUDcamera",new d.OrthographicCamera(-a/2,a/2,g/2,-g/2,0,10));this.InitializeRenderTargets();this.CameraUpdate(!0,b,c)},this)},UpdatePolygonOffset:function(a){return function(b){b&&b.polygonOffset&&(b.polygonOffsetFactor=a?this.get("_polygon_offset_factor"):0,b.polygonOffsetUnits=a?this.get("_polygon_offset_units"):0)}.bind(this)},SetHighlights:function(a,b){var c=(this.get("_renderercache").materials.enablehighlights=
a)&&this.get("_renderercache").materials.enablehardedgehighlights;this.ApplyFctToAllMaterials(this.UpdatePolygonOffset(c));(void 0==b||b)&&this.Render()},SetHighlightsConfiguration:function(a,b,c){var d=this.get("_renderercache").materials;d.enablehardedgehighlights=b;d.enablehorizonhighlights=a;this.ApplyFctToAllMaterials(this.UpdatePolygonOffset(d.enablehighlights&&b));(void 0==c||c)&&this.Render()},SetHighlightsColor:function(a,b,c,i){this.get("_renderercache").materials.highlight.color.setHex((a<<
16)+(b<<8)+c);this.get("_renderercache").materials.edge.uniforms.color.value=new d.Vector3(a/255,b/255,c/255);this.get("_renderercache").materials.enablehighlights&&(void 0==i||i)&&this.Render()},SetBackgroundColor:function(a,b,c,i,g){this.set("_backgroundColor",new d.Color(a,b,c));this.set("_backgroundAlpha",i);this.get("_renderercache").materials.hasOwnProperty("ColorBlendShaderMaterial")&&(this.get("_renderercache").textures[this.get("_RenderingQuality")].backdrop.enabled=!1);(void 0==g||g)&&this.Render()},
SetLabelsVisible:function(a,b){this.get("_renderercache").labels.visible=a;(void 0==b||b)&&this.CameraUpdate(!0)},ResetMainSceneVisibility:function(a){var b=function(a){a instanceof d.Scene||a instanceof d.Mesh||(a.visible=!0)};this.get("_3JSsceneOp").traverse(b);this.get("_3JSsceneTransp").traverse(b);this.get("_3JSsceneHightlights").traverse(b);(void 0==a||a)&&this.Render()},ToggleNodeVisibility:function(a,b,c,d){this.SetNodeVisibility(a,null,b,c,d)},SetNodeVisibility:function(a,b,c,i,g){var h=
this.URLToKeyString(a);if(void 0!==this.get("_renderercache").nodeviewproperties[h]){for(var f=0,e=Object.keys(this.get("_renderercache").nodeviewproperties[h].threejsnodes),j=e.length;f<j;++f)for(var l=function(a){a instanceof d.Scene||a instanceof d.Mesh||(a.visible=null===b?!a.visible:b)},a=this.get("_renderercache").nodeviewproperties[h].threejsnodes[e[f]],m=0,k=Object.keys(a),r=k.length;m<r;m++){var n=a[k[m]];l(n);if(void 0!=c&&c)for(var p=0,s=Object.keys(n.children),q=s.length;p<q;++p)n.children[s[p]].traverse(l);
void 0!=i&&i&&n.parent&&n.parent.traverseParents(l)}(void 0==g||g)&&this.Render()}},GetNodeInfo:function(a,b){switch(b){case "NODEOBJECTVIS":var c=a.threejsnodes[Object.keys(a.threejsnodes)[0]];return c[Object.keys(c)[0]].visible;default:w.Log("Unknown queried data type")}},Get:function(a,b){var c=this.URLToKeyString(a),d=this.get("_renderercache").nodeviewproperties[c];if(d)return this.GetNodeInfo(d,b);w.Log("ViewerView Warning: No existing node for "+c)},LogMemoryReport:function(){w.Log("Node View Properties Size: "+
y.get("SizeOf")(this.get("_renderercache").nodeviewproperties)/1E6+"MB");w.Log("_3JSsceneOp Size: "+y.get("SizeOf")(this.get("_3JSsceneOp"))/1E6+"MB");w.Log("_3JSsceneOpDepth Size: "+y.get("SizeOf")(this.get("_3JSsceneOpDepth"))/1E6+"MB");w.Log("_3JSsceneOpaqueDiffuse Size: "+y.get("SizeOf")(this.get("_3JSsceneOpaqueDiffuse"))/1E6+"MB");w.Log("_3JSsceneTransp Size: "+y.get("SizeOf")(this.get("_3JSsceneTransp"))/1E6+"MB");w.Log("_3JSsceneTranspDepth Size: "+y.get("SizeOf")(this.get("_3JSsceneTranspDepth"))/
1E6+"MB");w.Log("_3JSsceneTranspDiffuse Size: "+y.get("SizeOf")(this.get("_3JSsceneTranspDiffuse"))/1E6+"MB");for(var a=0;a<this.get("_3JSsceneOpCoincidentGroupsPasses").length;++a){var b=this.get("_3JSsceneOpCoincidentGroupsPasses")[a];w.Log("_3JSsceneOpCoincidentGroups["+b+"] Size: "+y.get("SizeOf")(this.get("_3JSsceneOpCoincidentGroups")[b])/1E6+"MB");w.Log("_3JSsceneOpCoincidentGroupsDepth["+b+"] Size: "+y.get("SizeOf")(this.get("_3JSsceneOpCoincidentGroupsDepth")[b])/1E6+"MB");w.Log("_3JSsceneOpCoincidentGroupsDiffuse["+
b+"] Size: "+y.get("SizeOf")(this.get("_3JSsceneOpCoincidentGroupsDiffuse")[b])/1E6+"MB")}for(a=0;a<this.get("_3JSsceneTranspCoincidentGroupsPasses").length;++a)b=this.get("_3JSsceneTranspCoincidentGroupsPasses")[a],w.Log("_3JSsceneTranspCoincidentGroups["+b+"] Size: "+y.get("SizeOf")(this.get("_3JSsceneTranspCoincidentGroups")[b])/1E6+"MB"),w.Log("_3JSsceneTranspCoincidentGroupsDepth["+b+"] Size: "+y.get("SizeOf")(this.get("_3JSsceneTranspCoincidentGroupsDepth")[b])/1E6+"MB"),w.Log("_3JSsceneTranspCoincidentGroupsDiffuse["+
b+"] Size: "+y.get("SizeOf")(this.get("_3JSsceneTranspCoincidentGroupsDiffuse")[b])/1E6+"MB");w.Log("_3JSsceneHightlights Size: "+y.get("SizeOf")(this.get("_3JSsceneHightlights"))/1E6+"MB");w.Log("_3JSsceneLabels Size: "+y.get("SizeOf")(this.get("_3JSsceneLabels"))/1E6+"MB")},PrintOpaqueSceneVertices:function(){w.Log("List of vertices (opaques scene)");var a=new d.Vector3,b=function(a){a instanceof d.Vector3&&(!isNaN(a.x)&&!isNaN(a.y)&&!isNaN(a.z))&&w.Log("("+a.x+","+a.y+","+a.z+")")},c=function(c){var f=
c.geometry;if(void 0!==f)if(f instanceof d.Geometry)for(var f=f.vertices,e=0,g=f.length;e<g;++e)a.copy(f[e]),a.applyMatrix4(c.matrixWorld),b(a);else if(f instanceof d.BufferGeometry&&void 0!==f.attributes.position){var i=f.attributes.position.array;f instanceof d.InstancedBufferGeometry&&new d.Box3;e=0;for(g=i.length;e<g;e+=3)if(a.fromArray(i,e),a.applyMatrix4(c.matrixWorld),f instanceof d.InstancedBufferGeometry&&void 0!==f.attributes.inst_translation&&void 0!==f.attributes.inst_rotation&&void 0!==
f.attributes.inst_scale)for(var m=0,k=f.maxInstancedCount;m<k;++m){var r=d.GetInstanceTransform(f.attributes.inst_translation,f.attributes.inst_rotation,f.attributes.inst_scale,m);b(d.Vector3.transformVertex(a,r))}else b(a)}};this.get("_3JSsceneOp").updateMatrixWorld(!0);this.get("_3JSsceneOp").traverse(c);for(var i=0;i<this.get("_3JSsceneOpCoincidentGroupsPasses").length;++i){var g=this.get("_3JSsceneOpCoincidentGroupsPasses")[i];this.get("_3JSsceneOpCoincidentGroups")[g].updateMatrixWorld(!0);this.get("_3JSsceneOpCoincidentGroups")[g].traverse(c)}},
SetReflections:function(a,b,c,d,g,h){this.set("_reflection_config",a);"ON"==a?this.UpdateReflectionUniforms(b,c,d,g):"JSON"==a&&this.UpdateReflectionUniforms();(void 0==h||h)&&this.Render()},SetInteractionOptimization:function(a){this.set("_enableInteractionOptimization",a)},SetQualityLevel:function(a,b){this.set("_nb_max_peels",a);(void 0==b||b)&&this.Render()},SetLightingContrast:function(a,b){this.set("_lighting_contrast",a);this.UpdateLightingContrast();(void 0==b||b)&&this.Render()},UpdateLightingContrast:function(){for(var a=
0,b=Object.keys(this.get("_renderercache").lights.dir_light),c=b.length;a<c;a++){var d=b[a];this.get("_renderercache").lights.dir_light[d].intensity=this.get("_lighting_contrast")}a=0;b=Object.keys(this.get("_renderercache").lights.amb_light);for(c=b.length;a<c;a++)d=b[a],this.get("_renderercache").lights.amb_light[d].intensity=1+(0.5-this.get("_lighting_contrast"))},AppendRendererToDocument:function(){"function"===typeof this.get("_context").appendChild&&this.get("_context").appendChild(this.get("_3JSrenderer").domElement)},
GetSnapshot:function(a,b,c){this.Render(!0,b,c);var d=this.get("_3JSrenderer").getContext(),g=new Uint8Array(4*b*c);d.readPixels(0,0,b,c,d.RGBA,d.UNSIGNED_BYTE,g);d=document.createElement("canvas");d.width=b;d.height=c;var h=d.getContext("2d"),b=h.createImageData(b,c);b.data.set(g);for(var f,e,j,g=0;g<b.height/2;g++)for(c=0;c<b.width;c++)f=b.width*g+c,e=b.width*(b.height-1-g)+c,f*=4,e*=4,j=b.data[e],b.data[e]=b.data[f],b.data[f]=j,j=b.data[e+1],b.data[e+1]=b.data[f+1],b.data[f+1]=j,j=b.data[e+2],
b.data[e+2]=b.data[f+2],b.data[f+2]=j,j=b.data[e+3],b.data[e+3]=b.data[f+3],b.data[f+3]=j;h.putImageData(b,0,0);"function"===typeof this.get("_context").appendChild&&this.CameraUpdate(!0,this.get("_context").clientWidth,this.get("_context").clientHeight);return d.toDataURL("image/"+a)}})});