/**
 * @author DOGO
 * @module WebViewer3D
 * @copyright 2017 Esko Software BVBA. All rights reserved.
 */

define("underscore backbone WV3Dlib/three WV3Dmod/LogMessage WV3Dmod/SystemChecker WV3Dmod/Math WV3Dmod/HttpRequestHandler WV3Dmod/Utils WV3Dmod/shaders/ShaderUtils WV3Dmod/shaders/AlphaFixShader WV3Dmod/shaders/DesignerShader WV3Dmod/shaders/D0Shader WV3Dmod/shaders/D1Shader WV3Dmod/shaders/D2Shader WV3Dmod/shaders/DepthOnlyShader WV3Dmod/shaders/BackdropShader WV3Dmod/shaders/ColorBlendShader WV3Dmod/shaders/CopyShader WV3Dmod/shaders/LineBasicShader WV3Dmod/shaders/UniformColorShader WV3Dmod/shaders/EdgeShader2 WV3Dmod/shaders/TransparencyBlendShader WV3Dmod/shaders/FilterShaderPM WV3Dmod/shaders/FilterShaderNPM WV3Dmod/shaders/ReflectanceShaderPM WV3Dmod/shaders/ReflectanceShaderNPM WV3Dmod/shaders/IrradianceShaderPM WV3Dmod/shaders/IrradianceShaderNPM WV3Dmod/shaders/DiffractionShaderPM".split(" "),
function($,Y,c,r,y,W,Z,E,aa,F,z,G,H,I,J,K,L,M,B,N,O,P,Q,R,C,D,S,T,U){var p=function(a,b){if(a&&(a.dispose(),a.uniforms))for(var d=0,i=Object.keys(a.uniforms),g=i.length;d<g;++d){var f=a.uniforms[i[d]];f.value&&"function"===typeof f.value.dispose&&(void 0===b||b||!(f.value instanceof c.Texture))&&f.value.dispose()}},X=function(a){if(a){var b=a.boundmeshlist;if(b){0==Object.keys(b).length&&r.Log("ViewerView Warning: No meshes to update");for(var d=0,c=Object.keys(b),g=c.length;d<g;++d){var f=c[d];0==
Object.keys(b[f]).length&&r.Log("ViewerView Warning: No render passes to update");for(var l=0,k=Object.keys(b[f]),e=k.length;l<e;++l){for(var h=k[l],m=0,j=Object.keys(b[f][h]),n=j.length;m<n;m++){var q=j[m];p(a.mat.untextured_mat[f][q]);0==Object.keys(b[f][h][q]).length&&r.Log("ViewerView Warning: No sided materials to update");for(var s=0,t=Object.keys(b[f][h][q]),v=t.length;s<v;++s){var w=t[s];p(a.mat.textured_mat[f][q][w]);delete a.mat.textured_mat[f][q][w];delete b[f][h][q][w]}delete b[f][h][q]}delete b[f][h];
delete b[f]}}delete a.boundmeshlist}else r.Log("ViewerView Warning: No meshes to update");a.diff_texture&&a.diff_texture.dispose();a.spec_texture&&a.spec_texture.dispose();a.int_spec_texture&&a.int_spec_texture.dispose();a.normal_map_texture&&a.normal_map_texture.dispose();a.diff_grating_texture&&a.diff_grating_texture.dispose();a.diff_grating_filter_texture&&a.diff_grating_filter_texture.dispose();a.annotationsTexture&&a.annotationsTexture.dispose()}},V=function(a,b){for(var d=0,c=Object.keys(a.mat.untextured_mat),
g=c.length;d<g;++d)for(var f=a.mat.untextured_mat[c[d]],l=0,k=Object.keys(f),e=k.length;l<e;++l){var h=f[k[l]];b(h);h.needsUpdate=!0}d=0;c=Object.keys(a.mat.textured_mat);for(g=c.length;d<g;++d){f=a.mat.textured_mat[c[d]];l=0;k=Object.keys(f);for(e=k.length;l<e;++l)for(var m=f[k[l]],j=0,n=Object.keys(m),q=n.length;j<q;++j)h=m[n[j]],b(h),h.needsUpdate=!0}};return Y.Model.extend({initialize:function(a,b,d,c){r.Log("Creating WV3DMaterialManager Object");this.set("_renderercache",a);this.set("_assetmanager",
b);this.set("_texturemanager",d);this.set("_exec_queue",c);this.listenTo(d,"updatematerialsgloballighting",this.UpdateMaterialsGlobalLighting);this.listenTo(d,"updatetexturedmaterial",this.UpdateTexturedMaterial);this.listenTo(d,"updatematerialtexture",this.UpdateMaterialTexture)},Reset:function(){this.get("_texturemanager").Reset()},InitializeShaders:function(){if(!this.get("_renderercache").get("materials").default_material){var a=c.UniformsUtils.clone(z.uniforms);a.diffuse.value=new c.Vector3(1,
1,1);a.specular.value=new c.Vector3(0,0,0);var b=this.get("_renderercache").get("materials").enablehighlights&&this.get("_renderercache").get("materials").enablehardedgehighlights;this.get("_renderercache").get("materials").default_material=new c.ShaderMaterial({name:"designer",uniforms:a,vertexShader:z.vertexShader,fragmentShader:z.fragmentShader,depthTest:!0,vertexColors:c.FaceColors,side:c.FrontSide,transparent:!1,defines:{ENVMAP_TYPE_CUBE:"",ENVMAP_MODE_REFLECTION:"",ENVMAP_BLENDING_ADD:"",ANNOTATION_NUMBER:"0",
ANNOTATION_TEXTURE_SIZE:"0",LINES_START_OFFSET:"0"},lights:!0,polygonOffset:!0,polygonOffsetFactor:b?this.get("_renderercache").get("_polygon_offset_factor"):0,polygonOffsetUnits:b?this.get("_renderercache").get("_polygon_offset_units"):0})}this.get("_renderercache").get("materials").D0ShaderMaterial||(a=c.UniformsUtils.clone(G.uniforms),a=new c.ShaderMaterial({name:"D0ShaderMaterial",uniforms:a,vertexShader:G.vertexShader,fragmentShader:G.fragmentShader,side:c.FrontSide,depthWrite:!0,transparent:!1}),
this.get("_renderercache").get("materials").D0ShaderMaterial=a);this.get("_renderercache").get("materials").D1ShaderMaterial||(a=c.UniformsUtils.clone(H.uniforms),a.D0RT.value=null,a=new c.ShaderMaterial({name:"D1ShaderMaterial",uniforms:a,vertexShader:H.vertexShader,fragmentShader:H.fragmentShader,side:c.FrontSide,depthWrite:!0,transparent:!1}),this.get("_renderercache").get("materials").D1ShaderMaterial=a);this.get("_renderercache").get("materials").D2ShaderMaterial||(a=c.UniformsUtils.clone(I.uniforms),
a.DX1RT.value=null,a.DX2RT.value=null,a=new c.ShaderMaterial({name:"D2ShaderMaterial",uniforms:a,vertexShader:I.vertexShader,fragmentShader:I.fragmentShader,side:c.FrontSide,depthWrite:!0,transparent:!1}),this.get("_renderercache").get("materials").D2ShaderMaterial=a);this.get("_renderercache").get("materials").DepthOnlyShaderMaterial||(a=c.UniformsUtils.clone(J.uniforms),a.DX1RT.value=null,a.DX2RT.value=null,a=new c.ShaderMaterial({name:"DepthOnlyShaderMaterial",uniforms:a,vertexShader:J.vertexShader,
fragmentShader:J.fragmentShader,side:c.FrontSide,depthWrite:!0,colorWrite:!1,transparent:!1}),this.get("_renderercache").get("materials").DepthOnlyShaderMaterial=a);this.get("_renderercache").get("materials").BackdropShaderMaterial||(a=c.UniformsUtils.clone(K.uniforms),a.backdrop.value=null,a.reflection.value=null,a=new c.ShaderMaterial({name:"BackdropShaderMaterial",uniforms:a,vertexShader:K.vertexShader,fragmentShader:K.fragmentShader,side:c.FrontSide,depthWrite:!1,transparent:!1}),this.get("_renderercache").get("materials").BackdropShaderMaterial=
a);this.get("_renderercache").get("materials").ColorBlendShaderMaterial||(a=c.UniformsUtils.clone(L.uniforms),a.CX1RT.value=null,a.TransparencyStack.value=null,a.OpaqueRT.value=null,a.ColorStackRT.value=null,a=new c.ShaderMaterial({name:"ColorBlendShaderMaterial",uniforms:a,vertexShader:L.vertexShader,fragmentShader:L.fragmentShader,side:c.FrontSide,depthWrite:!0,transparent:!0,blending:c.AdditiveBlending}),this.get("_renderercache").get("materials").ColorBlendShaderMaterial=a);this.get("_renderercache").get("materials").CopyShaderMaterial||
(a=c.UniformsUtils.clone(M.uniforms),a.CXRT.value=null,a.OpaqueRT.value=null,a=new c.ShaderMaterial({name:"CopyShaderMaterial",uniforms:a,vertexShader:M.vertexShader,fragmentShader:M.fragmentShader,side:c.FrontSide,depthWrite:!0,transparent:!1,blending:c.AdditiveBlending}),this.get("_renderercache").get("materials").CopyShaderMaterial=a);this.ResetOutlineShaders()},ResetOutlineShaders:function(){var a=this.get("_renderercache").get("materials");if(!a.highlight){var b=c.UniformsUtils.clone(B.uniforms),
d=this.get("_renderercache").get("materials").defaultcolor;b.diffuse.value=new c.Vector3(d[0]/255,d[1]/255,d[2]/255);d=new c.ShaderMaterial({name:"ColoredLineBasicMaterialInstanced",uniforms:b,vertexShader:B.vertexShader,fragmentShader:B.fragmentShader,side:c.DoubleSide,linewidth:1,depthTest:!0});a.highlight=d}a.blackhighlight||(b=c.UniformsUtils.clone(B.uniforms),d=new c.ShaderMaterial({name:"BlackLineBasicMaterialInstanced",uniforms:b,vertexShader:B.vertexShader,fragmentShader:B.fragmentShader,
side:c.DoubleSide,linewidth:1,depthTest:!0}),a.blackhighlight=d,a.blackhighlight.uniforms.diffuse.value=new c.Vector3(0,0,0));a.colordepth||(d=c.UniformsUtils.clone(N.uniforms),d=new c.ShaderMaterial({name:"ColorDepth",uniforms:d,vertexShader:N.vertexShader,fragmentShader:N.fragmentShader,side:c.DoubleSide}),a.colordepth=d);a.alphafix||(d=new c.ShaderMaterial({name:"alphafix",uniforms:c.UniformsUtils.clone(F.uniforms),vertexShader:F.vertexShader,fragmentShader:F.fragmentShader,depthFunc:c.GreaterDepth}),
a.alphafix=d);a.edge||(d=this.get("_renderercache").get("materials").defaultcolor,b=c.UniformsUtils.clone(O.uniforms),b.color.value=new c.Vector3(d[0]/255,d[1]/255,d[2]/255),b.depth_texture.value=null,d=new c.ShaderMaterial({name:"Edge",uniforms:b,vertexShader:O.vertexShader,fragmentShader:O.fragmentShader,wireframe:!0}),a.edge=d)},UpdateReflectionUniforms:function(a,b,d,c){var g=this.get("_renderercache"),f=function(f){g.get("materials")[f].uniforms.reflection_opacity.value=void 0!==a?a:g.get("reflections").opacity;
g.get("materials")[f].uniforms.reflection_fade.value=void 0!==b?b:g.get("reflections").fade;g.get("materials")[f].uniforms.reflection_fade_position.value=void 0!==d?d:g.get("reflections").fade_position;g.get("materials")[f].uniforms.reflection_fade_size.value=void 0!==c?c:g.get("reflections").fade_size};f("BackdropShaderMaterial");f("ColorBlendShaderMaterial");f("CopyShaderMaterial")},LoadMaterial:function(a,b,d,i,g){if("Material"==b.AssetType){if(b.hasOwnProperty("Properties")){var b=b.Properties,
f=1,l=1,k=1,e=1,h=1,m=1,j=1,n=1,q=1;b.front.hasOwnProperty("diffuse")&&(f=b.front.diffuse[0],l=b.front.diffuse[1],k=b.front.diffuse[2]);b.front.hasOwnProperty("specular")&&(e=b.front.specular[0],h=b.front.specular[1],m=b.front.specular[2]);b.front.hasOwnProperty("ambient")&&(j=b.front.ambient[0],n=b.front.ambient[1],q=b.front.ambient[2]);var f=new c.Color(f,l,k),e=new c.Color(e,h,m),q=new c.Color(j,n,q),h=b.front.hasOwnProperty("shininess")?W.clamp(parseFloat(b.front.shininess),0,1):0.5,m=b.hasOwnProperty("double_sided")?
E.ToBool(b.double_sided):!1,l=b.hasOwnProperty("opacity")?W.clamp(parseFloat(b.opacity),0,1):1,k=b.front.hasOwnProperty("double_grating")?E.ToBool(b.front.double_grating):!1,s=b.front.hasOwnProperty("grating_spacing_scale")?parseFloat(b.front.grating_spacing_scale):null,p=b.front.hasOwnProperty("default_diff_haze")?parseFloat(b.front.default_diff_haze):null,v=b.front.hasOwnProperty("default_diff_spacing")?parseFloat(b.front.default_diff_spacing):null,j=b.front.hasOwnProperty("diff_grating_tex")||
b.front.hasOwnProperty("diff_grating_filter_tex"),n="Designer"==this.get("_renderercache").get("_RenderingQuality")||j||b.front.hasOwnProperty("int_specular_tex")||b.front.hasOwnProperty("normal_map_tex"),w=!1;b.front.hasOwnProperty("diffuse_tex")&&d[b.front.diffuse_tex].Properties.hasOwnProperty("transparent")&&(l=(w=E.ToBool(d[b.front.diffuse_tex].Properties.transparent))?0.5:l);a={JSONMaterialName:a,mat:{untextured_mat:null,textured_mat:{}},boundmeshlist:null,reflectance_model:b.reflectance_model,
diff_texture:null,spec_texture:null,int_spec_texture:null,normal_map_texture:null,diff_grating_texture:null,diff_grating_filter_texture:null,diff_col:f,spec_col:e,amb_col:q,shininess:h,double_sided:m,opacity:l,transp_texture:w,double_grating:k,grating_spacing_scale:s,default_diff_haze:p,default_diff_spacing:v,holographic:j,printable:n,backTexture:g};g=this.CreateMaterial(a);a.mat.untextured_mat=g;i=this.get("_assetmanager").get("_assetloader").get("_httprequestmanager").IsAbsoluteURL(i)?i.substring(0,
i.lastIndexOf("/")+1):this.get("_assetmanager").get("_resourcePath")+"/";this.get("_texturemanager").StartAsyncTextureLoad(d,b,"diffuse_tex","diff_texture",a,i,n?c.RGBAFormat:c.RGBFormat,4);this.get("_texturemanager").StartAsyncTextureLoad(d,b,"specular_tex","spec_texture",a,i,c.RGBAFormat,4);"Visualizer"==this.get("_renderercache").get("_RenderingQuality")&&(this.get("_texturemanager").StartAsyncTextureLoad(d,b,"int_specular_tex","int_spec_texture",a,i,c.RGBAFormat,4),this.get("_texturemanager").StartAsyncTextureLoad(d,
b,"normal_map_tex","normal_map_texture",a,i,c.RGBFormat,4),this.get("_texturemanager").StartAsyncTextureLoad(d,b,"diff_grating_tex","diff_grating_texture",a,i,c.RGBAFormat,4)&&this.get("_texturemanager").StartAsyncTextureLoad(d,b,"diff_grating_filter_tex","diff_grating_filter_texture",a,i,c.RGBAFormat,4));"Visualizer"==this.get("_renderercache").get("_RenderingQuality")&&(j&&!this.get("_renderercache").get("textures")[this.get("_renderercache").get("_RenderingQuality")].spectrum.queried)&&(i=this.get("_assetmanager").get("_resourcePath")+
"/"+this.get("_renderercache").get("textures")[this.get("_renderercache").get("_RenderingQuality")].path,this.get("_renderercache").get("textures")[this.get("_renderercache").get("_RenderingQuality")].spectrum.queried=!0,new Z(i+"PointLightSources.json",this.AsynchronousLightLoad.bind(this),this.AsynchronousLightLoadFail.bind(this),this.get("_assetmanager").GetURLPreprocessCallback()),this.get("_assetmanager").IncrementTextureQueryCounter(1),this.get("_texturemanager").StartAsyncGlobalTextureLoad("spectrum",
i));return a}r.Log("ViewerView Warning: Material properties not defined")}else r.Log("ViewerView Warning: Queried asset is not a material")},CreateMaterial:function(a,b){var d=null,i=null,g,f;a.diff_texture?g=a.diff_texture:a.spec_texture&&(g=a.spec_texture);void 0!==g?(f=g.offset,g=g.repeat,f=new c.Vector4(f.x,f.y,g.x,g.y)):f=new c.Vector4(0,0,1,1);g=y.get("_fullSupportFloatingPointTextures")||y.get("_fullSupportHFloatingPointTextures");g=1<=a.opacity&&!a.transp_texture||!g;var l={};if(!b||"opaque_pass"==
b||"transparent_pass"==b){var k={};switch(this.get("_renderercache").get("_RenderingQuality")){case "Designer":0.5<=a.shininess?this.get("_renderercache").get("textures").Designer.envmap.glossy.loaded&&(d=this.get("_renderercache").get("textures").Designer.envmap.glossy.data,this.get("_renderercache").get("textures").Designer.irradiancemap.loaded&&(i=this.get("_renderercache").get("textures").Designer.irradiancemap.data)):this.get("_renderercache").get("textures").Designer.envmap.matte.loaded&&(d=
this.get("_renderercache").get("textures").Designer.envmap.matte.data,this.get("_renderercache").get("textures").Designer.irradiancemap.loaded&&(i=this.get("_renderercache").get("textures").Designer.irradiancemap.data));var e=c.UniformsUtils.clone(z.uniforms);e.diffuse.value=a.diff_col;e.opacity.value=g?1:a.opacity;e.specular.value=a.spec_col;e.shininess.value=Math.max(0.001,a.shininess);e.map.value=a.diff_texture;e.specularMap.value=a.spec_texture;e.irr_tex.value=i;e.envMap.value=d;e.reflectivity.value=
0.5;e.offsetRepeat.value=f;k[1]={name:"designer",uniforms:e,vertexShader:z.vertexShader,fragmentShader:z.fragmentShader,depthTest:!0,vertexColors:c.FaceColors,side:c.FrontSide,transparent:!g,blending:c.NormalBlending,defines:{ENVMAP_TYPE_CUBE:"",ENVMAP_MODE_REFLECTION:"",ENVMAP_BLENDING_ADD:"",ANNOTATION_NUMBER:"0",ANNOTATION_TEXTURE_SIZE:"0",LINES_START_OFFSET:"0"},lights:!0};break;case "Visualizer":for(var h={},m=!0,e=0;5>e;++e)if(this.get("_renderercache").get("textures").Visualizer.envmap.loaded[e])h[e]=
this.get("_renderercache").get("textures").Visualizer.envmap.data[e];else{m=!1;break}m&&this.get("_renderercache").get("textures").Visualizer.irradiancemap.loaded&&(i=this.get("_renderercache").get("textures").Visualizer.irradiancemap.data,d=h);if(a.printable){if(e=c.UniformsUtils.clone(S.uniforms),e.offsetRepeat.value=f,e.diffuseColor.value=a.diff_col,e.opacity.value=g?1:a.opacity,e.diffuseTexture.value=a.diff_texture?a.diff_texture:null,e.normalMap.value=a.normal_map_texture?a.normal_map_texture:
null,e.DX1RT.value=null,e.DX2RT.value=null,e.irradianceCubeMap.value=i?i:null,e.backTexture.value=a.backTexture?1:0,h={},a.normal_map_texture&&(h.USE_NORMALMAP_TEXTURE=""),k[1]={name:"irradiancepm",uniforms:e,vertexShader:S.vertexShader,fragmentShader:S.fragmentShader,depthTest:!0,vertexColors:c.FaceColors,side:c.FrontSide,defines:h,blending:g?c.NormalBlending:c.CustomBlending,blendSrc:c.OneFactor,blendDst:c.OneMinusSrcAlphaFactor,transparent:!0,extensions:{derivatives:!0,fragDepth:!1,drawBuffers:!1,
shaderTextureLOD:!1}},e=c.UniformsUtils.clone(Q.uniforms),e.offsetRepeat.value=f,e.diffuseColor.value=a.diff_col,e.opacity.value=g?1:a.opacity,e.diffuseTexture.value=a.diff_texture?a.diff_texture:null,e.DX1RT.value=null,e.DX2RT.value=null,e.backTexture.value=a.backTexture?1:0,k[3]={name:"filterpm",uniforms:e,vertexShader:Q.vertexShader,fragmentShader:Q.fragmentShader,depthTest:!0,vertexColors:c.FaceColors,side:c.FrontSide,defines:{},blending:c.CustomBlending,blendSrc:c.DstColorFactor,blendDst:c.ZeroFactor,
transparent:!0},11<=y.get("_glmaxtextureimageunits")?(e=c.UniformsUtils.clone(C.EXTuniforms),e.haze1CubeMap.value=d?d[0]:null,e.haze2CubeMap.value=d?d[1]:null,e.haze3CubeMap.value=d?d[2]:null,e.haze4CubeMap.value=d?d[3]:null,e.haze5CubeMap.value=d?d[4]:null):(e=c.UniformsUtils.clone(C.uniforms),e.haze1CubeMap.value=d?d[0]:null,e.haze2CubeMap.value=d?d[4]:null),e.offsetRepeat.value=f,e.specularColor.value=a.spec_col,e.shininess.value=a.shininess,e.specularTexture.value=a.spec_texture?a.spec_texture:
null,e.internalSpecTex.value=a.int_spec_texture?a.int_spec_texture:null,e.normalMap.value=a.normal_map_texture?a.normal_map_texture:null,e.DX1RT.value=null,e.DX2RT.value=null,e.backTexture.value=a.backTexture?1:0,h={},a.int_spec_texture&&(h.USE_INT_SPEC_TEXTURE=""),a.normal_map_texture&&(h.USE_NORMALMAP_TEXTURE=""),h.ANNOTATION_NUMBER="0",h.ANNOTATION_TEXTURE_SIZE="0",h.LINES_START_OFFSET="0",k[6]={name:"reflectancepm",uniforms:e,vertexShader:C.vertexShader,fragmentShader:11<=y.get("_glmaxtextureimageunits")?
C.EXTfragmentShader:C.fragmentShader,depthTest:!0,vertexColors:c.FaceColors,side:c.FrontSide,defines:h,blending:c.CustomBlending,blendSrc:c.OneFactor,blendDst:c.SrcAlphaFactor,transparent:!0,extensions:{derivatives:!0,fragDepth:!1,drawBuffers:!1,shaderTextureLOD:!1}},a.holographic){h=c.UniformsUtils.clone(U.uniforms);h.offsetRepeat.value=f;h.uvdhTexture.value=a.diff_grating_texture?a.diff_grating_texture:null;h.diffFilterTexture.value=a.diff_grating_filter_texture?a.diff_grating_filter_texture:null;
h.normalMap.value=a.normal_map_texture?a.normal_map_texture:null;h.DX1RT.value=null;h.DX2RT.value=null;h.grating_spacing_scale.value=a.grating_spacing_scale;h.spectrumTexture.value=this.get("_renderercache").get("textures")[this.get("_renderercache").get("_RenderingQuality")].spectrum.data;h.defaultDiffSpacing.value=a.default_diff_spacing;h.defaultDiffHaze.value=a.default_diff_haze;h.backTexture.value=a.backTexture?1:0;m={};a.double_grating&&(m.DOUBLE_GRATING="");a.normal_map_texture&&(m.USE_NORMALMAP_TEXTURE=
"");if(this.get("_renderercache").get("textures")[this.get("_renderercache").get("_RenderingQuality")].spectrum.loaded&&this.get("_renderercache").get("lights").hasOwnProperty("holo_light")){m.USE_HOLOGRAPHICS="";h.lightPos.value=[];h.lightIntensity.value=[];h.lightRadius.value=[];h.lightHardness.value=[];for(e=0;e<this.get("_renderercache").get("lights").holo_light.Lights.length&&4>e;++e){var j=this.get("_renderercache").get("lights").holo_light.Lights[e];h.lightPos.value.push(new c.Vector3(j[0],
j[1],j[2]));h.lightIntensity.value.push(j[3]);h.lightRadius.value.push(j[4]);h.lightHardness.value.push(j[5])}}k[5]={name:"holographicspm",uniforms:h,vertexShader:U.vertexShader,fragmentShader:U.fragmentShader,depthTest:!0,vertexColors:c.FaceColors,side:c.FrontSide,defines:m,blending:c.CustomBlending,blendSrc:c.OneMinusDstColorFactor,blendDst:c.OneFactor,transparent:!0,extensions:{derivatives:!0,fragDepth:!1,drawBuffers:!1,shaderTextureLOD:!1}}}}else e=c.UniformsUtils.clone(T.uniforms),e.offsetRepeat.value=
f,e.diffuseColor.value=a.diff_col,e.opacity.value=g?1:a.opacity,e.diffuseTexture.value=a.diff_texture?a.diff_texture:null,e.DX1RT.value=null,e.DX2RT.value=null,e.irradianceCubeMap.value=i?i:null,e.backTexture.value=a.backTexture?1:0,k[2]={name:"irradiancenpm",uniforms:e,vertexShader:T.vertexShader,fragmentShader:T.fragmentShader,depthTest:!0,vertexColors:c.FaceColors,side:c.FrontSide,defines:{},blending:g?c.NormalBlending:c.CustomBlending,blendSrc:c.OneFactor,blendDst:c.OneMinusSrcAlphaFactor,transparent:!0},
e=c.UniformsUtils.clone(R.uniforms),e.offsetRepeat.value=f,e.diffuseColor.value=a.diff_col,e.opacity.value=g?1:a.opacity,e.diffuseTexture.value=a.diff_texture?a.diff_texture:null,e.DX1RT.value=null,e.DX2RT.value=null,e.backTexture.value=a.backTexture?1:0,k[4]={name:"filternpm",uniforms:e,vertexShader:R.vertexShader,fragmentShader:R.fragmentShader,depthTest:!0,vertexColors:c.FaceColors,side:c.FrontSide,defines:{},blending:c.CustomBlending,blendSrc:c.DstColorFactor,blendDst:c.ZeroFactor,transparent:!0},
11<=y.get("_glmaxtextureimageunits")?(e=c.UniformsUtils.clone(D.EXTuniforms),e.haze1CubeMap.value=d?d[0]:null,e.haze2CubeMap.value=d?d[1]:null,e.haze3CubeMap.value=d?d[2]:null,e.haze4CubeMap.value=d?d[3]:null,e.haze5CubeMap.value=d?d[4]:null):(e=c.UniformsUtils.clone(D.uniforms),e.haze1CubeMap.value=d?d[0]:null,e.haze2CubeMap.value=d?d[4]:null),e.DX1RT.value=null,e.DX2RT.value=null,e.offsetRepeat.value=f,e.specularCol.value=a.spec_col,e.shininess.value=a.shininess,e.backTexture.value=a.backTexture?
1:0,k[7]={name:"reflectancenpm",uniforms:e,vertexShader:D.vertexShader,fragmentShader:11<=y.get("_glmaxtextureimageunits")?D.EXTfragmentShader:D.fragmentShader,depthTest:!0,vertexColors:c.FaceColors,side:c.FrontSide,defines:{},blending:c.CustomBlending,blendSrc:c.OneFactor,blendDst:c.OneFactor,transparent:!0}}e=0;h=Object.keys(k);for(m=h.length;e<m;++e)if(j=h[e],k[j])if(a.double_sided&&(k[j].defines.DOUBLE_SIDED=""),a.diff_texture&&(k[j].defines.USE_MAP=""),a.spec_texture&&(k[j].defines.USE_SPECULARMAP=
""),i&&(k[j].defines.USE_IRRMAP=""),d&&(k[j].defines.USE_ENVMAP=""),a.diff_texture&&a.diff_texture.remappedAlphaChannel&&(k[j].defines.REMAPPED_DIFFUSE_ALPHA_CHANNEL=""),a.spec_texture&&a.spec_texture.remappedAlphaChannel&&(k[j].defines.REMAPPED_SPECULAR_ALPHA_CHANNEL=""),a.int_spec_texture&&a.int_spec_texture.remappedAlphaChannel&&(k[j].defines.REMAPPED_INT_SPECULAR_ALPHA_CHANNEL=""),a.diff_grating_texture&&a.diff_grating_texture.remappedAlphaChannel&&(k[j].defines.REMAPPED_DIFF_GRATING_ALPHA_CHANNEL=
""),g&&(!b||"opaque_pass"==b)){j=new c.ShaderMaterial(k[j]);j.polygonOffset=!0;this.get("_renderercache").get("materials");var n=this.get("_renderercache").get("materials").enablehighlights&&__enableHardEdgeHighlights;j.polygonOffsetFactor=n?this.get("_renderercache").get("_polygon_offset_factor"):0;j.polygonOffsetUnits=n?this.get("_renderercache").get("_polygon_offset_units"):0;j.JSONMaterialName=a.JSONMaterialName;l.hasOwnProperty("opaque_pass")||(l.opaque_pass=[]);l.opaque_pass.push(j)}else if(!g&&
(!b||"transparent_pass"==b))j=new c.ShaderMaterial(k[j]),j.polygonOffset=!1,j.JSONMaterialName=a.JSONMaterialName,l.hasOwnProperty("transparent_pass")||(l.transparent_pass=[]),l.transparent_pass.push(j)}if(!b||"opaque_diffuse_pass"==b||"transp_diffuse_pass"==b)if(d=c.UniformsUtils.clone(P.uniforms),d.diffuseColor.value=a.diff_col,d.opacity.value=a.opacity,d.diffuseTexture.value=a.diff_texture?a.diff_texture:null,d.offsetRepeat.value=f,d.DX1RT.value=null,d.DX2RT.value=null,d.backTexture.value=a.backTexture?
1:0,d=new c.ShaderMaterial({name:"TransBlendShader",uniforms:d,vertexShader:P.vertexShader,fragmentShader:P.fragmentShader,side:c.FrontSide,depthWrite:!0,transparent:!0,blending:c.CustomBlending,blendSrc:c.DstColorFactor,blendDst:c.ZeroFactor,lights:!1,defines:{ANNOTATION_NUMBER:"0",ANNOTATION_TEXTURE_SIZE:"0",MAX_LINES_PER_CELL:"1",ACCEL_GRID_SIZE:"0",LINES_START_OFFSET:"0"}}),a.diff_texture&&(d.defines.USE_MAP=""),a.printable||(d.defines.IS_NPM=""),a.diff_texture&&a.diff_texture.remappedAlphaChannel&&
(d.defines.REMAPPED_DIFFUSE_ALPHA_CHANNEL=""),a.spec_texture&&a.spec_texture.remappedAlphaChannel&&(d.defines.REMAPPED_SPECULAR_ALPHA_CHANNEL=""),a.int_spec_texture&&a.int_spec_texture.remappedAlphaChannel&&(d.defines.REMAPPED_INT_SPECULAR_ALPHA_CHANNEL=""),a.diff_grating_texture&&a.diff_grating_texture.remappedAlphaChannel&&(d.defines.REMAPPED_DIFF_GRATING_ALPHA_CHANNEL=""),g&&(!b||"opaque_diffuse_pass"==b))l.opaque_diffuse_pass=[d];else if(!g&&(!b||"transp_diffuse_pass"==b))l.transp_diffuse_pass=
[d];return l},AsynchronousLightLoad:function(a){this.get("_exec_queue").whenFinished(function(){this.get("_renderercache").get("lights").holo_light=a;this.UpdateMaterialsGlobalLighting();this.get("_assetmanager").IncrementTextureLoadCounter();this.trigger("render");this.trigger("check_post_scene_load_actions")},this)},AsynchronousLightLoadFail:function(){this.get("_exec_queue").whenFinished(function(){this.get("_assetmanager").IncrementTextureLoadCounter();this.trigger("resource_query_error",{errorCode:3,
message:"Point Light Sources"})},this)},UpdateMaterialsGlobalLighting:function(){for(var a=this.get("_renderercache").get("materials"),b=0,d=Object.keys(a.materiallist),c=d.length;b<c;++b){var g=d[b],f=a.materiallist[g].back;this.UpdateTexturedMaterial({mat_struct:a.materiallist[g].front});this.UpdateTexturedMaterial({mat_struct:f})}},UpdateTexturedMaterial:function(a){if(a=a.mat_struct){var b=a.boundmeshlist;if(b){0==Object.keys(b).length&&r.Log("ViewerView Warning: No meshes to update");for(var c=
0,i=Object.keys(b),g=i.length;c<g;++c){var f=i[c],l=this.CreateMaterial(a,f);0==Object.keys(b[f]).length&&r.Log("ViewerView Warning: No render passes to update");for(var k=0,e=Object.keys(b[f]),h=e.length;k<h;++k){var m=e[k];0==Object.keys(b[f][m]).length&&r.Log("ViewerView Warning: No sided materials to update");for(var j=0,n=Object.keys(b[f][m]),q=n.length;j<q;++j){var s=n[j];0==Object.keys(b[f][m][s]).length&&r.Log("ViewerView Warning: No shading pass to update");for(var t=0,v=Object.keys(b[f][m][s]),
w=v.length;t<w;++t){var x=v[t];p(a.mat.textured_mat[f][s][x],!1);a.mat.textured_mat[f][s][x]=l[f][s];for(var u=0,y=Object.keys(b[f][m][s][x]),z=y.length;u<z;++u){var A=b[f][m][s][x][y[u]];A.material=l[f][s];A.geometry.buffersNeedUpdate=!0;A.geometry.uvsNeedUpdate=!0;A.geometry.hasOwnProperty("dUdP")&&A.geometry.hasOwnProperty("dVdP")&&(a.dUdP=A.geometry.dUdP,a.dVdP=A.geometry.dVdP)}}}}}}else r.Log("ViewerView Warning: No meshes to update")}},UpdateMaterialTexture:function(a){var b,d;b=a.mat_struct;
d=a.texture_URL;a=a.new_texture;if(b){for(var i=b.mat.textured_mat,g=0,f=Object.keys(b),l=f.length;g<l;++g){var k=f[g];b[k]&&(b[k]instanceof c.Texture&&""!=b[k].name&&b[k].name==d)&&(b[k].dispose(),b[k]=a)}if(i){0==Object.keys(i).length&&r.Log("ViewerView Warning: No render passes to update");b=0;g=Object.keys(i);for(k=g.length;b<k;++b){var e=g[b];0==Object.keys(i[e]).length&&r.Log("ViewerView Warning: No shading passes to update");for(var h=0,m=Object.keys(i[e]),l=m.length;h<l;++h){var j=m[h];0==
Object.keys(i[e][j]).length&&r.Log("ViewerView Warning: No surface materials to update");for(var n=0,q=Object.keys(i[e][j]),p=q.length;n<p;++n){var t=i[e][j][q[n]];if(t&&t.uniforms)for(var v=0,f=Object.keys(t.uniforms),w=f.length;v<w;++v){var x=t.uniforms[f[v]];if(x.value&&"function"===typeof x.value.dispose&&x.value instanceof c.Texture){var u=x.value;""!=u.name&&u.name==d&&(a.format=u.format,a.unpackAlignment=u.unpackAlignment,a.anisotropy=u.anisotropy,a.repeat=u.repeat,a.remappedAlphaChannel=u.remappedAlphaChannel,
x.value=a)}}}}}}else r.Log("ViewerView Warning: No textured material to update")}},ReleaseGeomMatTex:function(a){a&&a.traverse(function(a){a instanceof c.Mesh&&a.geometry&&(a.geometry.dispose(),p(a.material))})},ReleaseAllMaterialsAndTextures:function(){for(var a=this.get("_renderercache"),b=0,c=Object.keys(a.get("materials").materiallist),i=c.length;b<i;++b){var g=a.get("materials").materiallist[c[b]];X(g.front);X(g.back)}a.get("textures").Designer.irradiancemap.data&&a.get("textures").Designer.irradiancemap.data.dispose();
a.get("textures").Designer.envmap.glossy.data&&a.get("textures").Designer.envmap.glossy.data.dispose();a.get("textures").Designer.envmap.matte.data&&a.get("textures").Designer.envmap.matte.data.dispose();a.get("textures").Visualizer.irradiancemap.data&&a.get("textures").Visualizer.irradiancemap.data.dispose();if(a.get("textures").Visualizer.envmap.data)for(b=0;b<a.get("textures").Visualizer.envmap.data.length;b++)a.get("textures").Visualizer.envmap.data[b]&&a.get("textures").Visualizer.envmap.data[b].dispose();
a.get("textures").Visualizer.spectrum.data&&a.get("textures").Visualizer.spectrum.data.dispose();a.get("textures").backdrop.data&&a.get("textures").backdrop.data.dispose();p(a.get("materials").default_material);p(a.get("materials").highlight);p(a.get("materials").edge);p(a.get("materials").colordepth);p(a.get("materials").D0ShaderMaterial);p(a.get("materials").D1ShaderMaterial);p(a.get("materials").D2ShaderMaterial);p(a.get("materials").BackdropShaderMaterial);p(a.get("materials").ColorBlendShaderMaterial);
p(a.get("materials").CopyShaderMaterial);p(a.get("materials").alphafix)},ApplyFctToAllMaterials:function(a){a(this.get("_renderercache").get("materials").default_material);this.get("_renderercache").get("materials").default_material.needsUpdate=!0;for(var b=0,c=Object.keys(this.get("_renderercache").get("materials").materiallist),i=c.length;b<i;++b){var g=this.get("_renderercache").get("materials").materiallist[c[b]];V(g.front,a);V(g.back,a)}},UpdateMatStructAnnotationLines:function(a,b){var d=this.get("_texturemanager").UpdateAnnotationsTexture(a,
b,64),i=d.textureSize,g=d.maxLinesPerCell,f=d.linesStartOffset;V(a,function(d){if(d.hasOwnProperty("uniforms")&&d.hasOwnProperty("name")&&("reflectancepm"===d.name||"designer"==d.name||"TransBlendShader"===d.name)&&d.defines.hasOwnProperty("ANNOTATION_NUMBER"))d.defines.ANNOTATION_NUMBER=""+b.length,d.defines.ANNOTATION_TEXTURE_SIZE=""+i,d.defines.MAX_LINES_PER_CELL=""+g,d.defines.ACCEL_GRID_SIZE=64,d.defines.LINES_START_OFFSET=f,d.uniforms.annotationsTexture.value=b.length?a.annotationsTexture:null,
d.uniforms.annotationsAspectRatio.value=new c.Vector2(a.dUdP||1,a.dVdP||1)})},GetJSONMaterialStruct:function(a){for(var b=this.get("_renderercache").get("materials").materiallist,c=0,i=Object.keys(b),g=i.length;c<g;++c){var f=b[i[c]];if(f.front.JSONMaterialName===a)return f.front;if(!f.sharedmaterial&&f.back.JSONMaterialName===a)return f.back}return null},GetAnnotablePartsList:function(){for(var a=[],b=this.get("_renderercache").get("materials").materiallist,c=0,i=Object.keys(b),g=i.length;c<g;++c){var f=
b[i[c]];f.front.printable&&(a.push(f.front.JSONMaterialName),f.sharedmaterial||a.push(f.back.JSONMaterialName))}return a},SetAnnotations:function(a,b){var c=this.GetJSONMaterialStruct(a);return c?(this.UpdateMatStructAnnotationLines(c,b),!0):!1},SetAnnotationsThickness:function(a){this.get("_renderercache").set("_annotationsThickness",a);this.ApplyFctToAllMaterials(function(b){if(b.hasOwnProperty("uniforms")&&b.hasOwnProperty("name")&&("reflectancepm"===b.name||"designer"==b.name||"TransBlendShader"===
b.name)&&b.defines.hasOwnProperty("ANNOTATION_NUMBER"))b.uniforms.annotationsThickness.value=a})},SetAnnotationsColor:function(a,b,d){this.ApplyFctToAllMaterials(function(i){if(i.hasOwnProperty("uniforms")&&i.hasOwnProperty("name")&&("reflectancepm"===i.name||"designer"==i.name||"TransBlendShader"===i.name)&&i.defines.hasOwnProperty("ANNOTATION_NUMBER"))i.uniforms.annotationsColor.value=new c.Vector3(a,b,d)})}})});