/**
 * @author DOGO
 * @module WebViewer3D
 * @copyright   2014 Esko Stonecube Ltd. All rights reserved.
 */

define("underscore backbone WV3Dlib/three WV3Dmod/Utils WV3Dmod/Timers WV3Dmod/LogMessage".split(" "),function(qb,za,c,sa,rb,D){var J=function(g,e,k){var a=new c.Matrix3;a.set(g.x,g.y,1,e.x,e.y,1,k.x,k.y,1);return a.determinant()},Ya=function(g){if(0==g.length)return new c.Vector2(1,1);for(var e=0,k=0,a=0,s=0;s<g.length;++s)e+=g[s].value.x*g[s].TriangleArea,k+=g[s].value.y*g[s].TriangleArea,a+=g[s].TriangleArea;return new c.Vector2(e/a,k/a)},Za=function(g,e,k,a,s,r,l,f,p,q){var b=new c.Vector2(a,
s),r=new c.Vector2(r,l),f=new c.Vector2(f,p),l=new c.Vector2(a+1,s),t=new c.Vector2(a,s+1),i=J(b,f,r);if(!(1E-7>Math.abs(i))&&(a={TriangleArea:Math.abs(i)},!(20<q.length&&a.TriangleArea<q[0]))){var s=J(b,l,r)/i,p=J(r,l,f)/i,y=J(f,l,b)/i,l=J(b,t,r)/i,r=J(r,t,f)/i,b=J(f,t,b)/i,f=g.clone().multiplyScalar(p).add(e.clone().multiplyScalar(y).add(k.clone().multiplyScalar(s))),e=g.clone().multiplyScalar(r).add(e.clone().multiplyScalar(b).add(k.clone().multiplyScalar(l)));a.value=new c.Vector2(f.sub(g).length(),
e.sub(g).length());if(Infinity!==a.value.x&&1E-7<a.value.x&&Infinity!==a.value.y&&1E-7<a.value.y)if(20<=q.length){g=0;for(e=1;e<q.length;++e)if(a.TriangleArea>q[e].TriangleArea)g=e-1;else break;for(e=0;e<g;++e)q[e]=q[e+1];q[g]=a}else q.push(a),20==q.length&&q.sort(function(a,b){var g=a.TriangleArea-b.TriangleArea;return 0>g?-1:0<g?1:0})}},ta=function(g){g=parseInt(g,16);return{r:(g&16711680)>>16,g:(g&65280)>>8,b:g&255}},$a=function(g,e,k){var a=k.indices;return ta(e[k.source][a[g%a.length]])},Va=
function(g,e,k){return function(){var a=k.input.position,s=k.input.interleaved,r=k.input.color,l=k.input.normal,f=k.input.texcoord,p=l&&l.hasOwnProperty("smooth")&&sa.ToBool(l.smooth);if(s){var q=e[s.sources[0]],b=s.indices,t=e[s.sources[1]],i=null,y=[],j=[],u=[],z=[],v=[],m=[],d,n;switch(s.format){default:D.Log("ThreeDObjectHandler Warning: Unrecognized interleaved format, switching to default PNT");case "PNT":i=e[s.sources[2]];d=9;n=3;break;case "PN":d=6,n=2}switch(k.topology){default:D.Log("ThreeDObjectHandler Warning: Unrecognized topology type. Switching to default triangle soup");
case "TRIANGLE_SOUP":var w,x=b,F=t,K=q,N=n,C=3*x[1],G=3*x[1+N],A=3*x[1+2*N],H=new c.Vector3(F[C],F[C+1],F[C+2]),gb=new c.Vector3(F[G],F[G+1],F[G+2]),S=new c.Vector3(F[A],F[A+1],F[A+2]),E=H.add(gb).add(S).normalize(),I=3*x[0],J=3*x[N],Aa=3*x[2*N],fa=new c.Vector3(K[I],K[I+1],K[I+2]),ta=new c.Vector3(K[J],K[J+1],K[J+2]),ya=new c.Vector3(K[Aa],K[Aa+1],K[Aa+2]),za=ta.sub(fa).normalize(),Va=ya.sub(fa).normalize();w=za.cross(Va).dot(E);0==w&&D.Log("ThreeDObjectHandler Warning: Problem in normal computation for winding");
(0>w&&"CCW"==k.winding||0<w&&"CW"==k.winding)&&D.Log("ThreeDObjectHandler Warning: Surface winding is not coherent with input normals, please check input file.");switch(k.winding){default:case "CCW":w=1;break;case "CW":w=-1}for(var B={},h=0;h<k.count;++h){0>w&&(b[h*d+n]=[b[h*d+2*n],b[h*d+2*n]=b[h*d+n]][0],b[h*d+n+1]=[b[h*d+2*n+1],b[h*d+2*n+1]=b[h*d+n+1]][0],3<=n&&(b[h*d+n+2]=[b[h*d+2*n+2],b[h*d+2*n+2]=b[h*d+n+2]][0]));var ua,va,wa,Y,Z,$,aa,ba,ca;ua=q[3*b[d*h]];va=q[3*b[d*h]+1];wa=q[3*b[d*h]+2];Y=
q[3*b[d*h+n]];Z=q[3*b[d*h+n]+1];$=q[3*b[d*h+n]+2];aa=q[3*b[d*h+2*n]];ba=q[3*b[d*h+2*n]+1];ca=q[3*b[d*h+2*n]+2];var P=[ua,va,wa,Y,Z,$,aa,ba,ca];j.push.apply(j,P);if(p){var Ba=function(a,b,g){B.hasOwnProperty(a)?B[a].add(g):B[a]=g},ab=new c.Vector3(ua,va,wa),Ca=new c.Vector3(Y,Z,$),Da=new c.Vector3(aa,ba,ca),Wa=Ca.clone().sub(ab),Xa=Da.clone().sub(ab),Ea=Wa.cross(Xa);Ba(b[d*h],B,Ea);Ba(b[d*h+n],B,Ea);Ba(b[d*h+2*n],B,Ea)}else{var Fa=[t[3*b[d*h+1]],t[3*b[d*h+1]+1],t[3*b[d*h+1]+2],t[3*b[d*h+n+1]],t[3*
b[d*h+n+1]+1],t[3*b[d*h+n+1]+2],t[3*b[d*h+2*n+1]],t[3*b[d*h+2*n+1]+1],t[3*b[d*h+2*n+1]+2]];u.push.apply(u,Fa)}var da;if(i){var ga=i[2*b[d*h+2]],ha=i[2*b[d*h+2]+1],ia=i[2*b[d*h+n+2]],ja=i[2*b[d*h+n+2]+1],ka=i[2*b[d*h+2*n+2]],la=i[2*b[d*h+2*n+2]+1];da=[ga,ha,ia,ja,ka,la];var Ga=new c.Vector3(ua,va,wa),Ha=new c.Vector3(Y,Z,$),Ia=new c.Vector3(aa,ba,ca);Za(Ga,Ha,Ia,ga,ha,ia,ja,ka,la,y)}else da=[0,0,0,0,0,0];z.push.apply(z,da);v.push.apply(v,da);if(r){var L=$a(h,e,r);m.push.apply(m,[L.r/255,L.g/255,L.b/
255]);m.push.apply(m,[L.r/255,L.g/255,L.b/255]);m.push.apply(m,[L.r/255,L.g/255,L.b/255])}}var ma=Ya(y);g.dUdP=ma.x;g.dVdP=ma.y;if(p){for(var Ja=0,na=Object.keys(B),Ka=na.length;Ja<Ka;++Ja)B[na[Ja]].normalize();for(h=0;h<k.count;++h)Fa=[B[b[d*h]].x,B[b[d*h]].y,B[b[d*h]].z,B[b[d*h+n]].x,B[b[d*h+n]].y,B[b[d*h+n]].z,B[b[d*h+2*n]].x,B[b[d*h+2*n]].y,B[b[d*h+2*n]].z],u.push.apply(u,Fa)}}g.addAttribute("position",new c.BufferAttribute(new Float32Array(j),3));g.addAttribute("normal",new c.BufferAttribute(new Float32Array(u),
3));r&&g.addAttribute("color",new c.BufferAttribute(new Float32Array(m),3));g.addAttribute("uv",new c.BufferAttribute(new Float32Array(z),2));g.addAttribute("uv2",new c.BufferAttribute(new Float32Array(v),2));g.uvsNeedUpdate=!0}else{w=1;if(l&&a&&l.hasOwnProperty("indices")&&l.indices&&3<=l.indices.length&&e[l.source]&&a.hasOwnProperty("indices")&&a.indices&&3<=a.indices.length&&e[a.source]){var T=e[a.source],t=e[l.source],La=l.indices,Ma=a.indices,U=t,Na=3*La[0],Oa=3*La[1],Pa=3*La[2],hb=new c.Vector3(U[Na],
U[Na+1],U[Na+2]),ib=new c.Vector3(U[Oa],U[Oa+1],U[Oa+2]),jb=new c.Vector3(U[Pa],U[Pa+1],U[Pa+2]),kb=hb.add(ib).add(jb).normalize(),Qa=3*Ma[0],Ra=3*Ma[1],Sa=3*Ma[2],bb=new c.Vector3(T[Qa],T[Qa+1],T[Qa+2]),lb=new c.Vector3(T[Ra],T[Ra+1],T[Ra+2]),mb=new c.Vector3(T[Sa],T[Sa+1],T[Sa+2]),nb=lb.sub(bb).normalize(),ob=mb.sub(bb).normalize();w=nb.cross(ob).dot(kb);0==w&&D.Log("ThreeDObjectHandler Warning: Problem in normal computation for winding");(0>w&&"CCW"==k.winding||0<w&&"CW"==k.winding)&&D.Log("ThreeDObjectHandler Warning: Surface winding is not coherent with input normals, please check input file.")}switch(k.winding){default:case "CCW":w=
1;break;case "CW":w=-1}var cb=f&&f.indices&&f.indices.length&&e[f.source],xa=[];if(a){q=e[a.source];b=a.indices;j=[];m=[];switch(k.topology){default:D.Log("ThreeDObjectHandler Warning: Unrecognized topology type. Switching to default triangle soup");case "TRIANGLE_SOUP":for(h=0;h<k.count;++h){0>w&&(b[3*h+2]=[b[3*h+1],b[3*h+1]=b[3*h+2]][0]);Y=q[3*parseInt(b[3*h])];Z=q[3*parseInt(b[3*h])+1];$=q[3*parseInt(b[3*h])+2];aa=q[3*parseInt(b[3*h+1])];ba=q[3*parseInt(b[3*h+1])+1];ca=q[3*parseInt(b[3*h+1])+2];
var db=q[3*parseInt(b[3*h+2])],eb=q[3*parseInt(b[3*h+2])+1],fb=q[3*parseInt(b[3*h+2])+2],P=[Y,Z,$,aa,ba,ca,db,eb,fb];void 0===P[0]||void 0===P[1]||void 0===P[2]||void 0===P[3]||void 0===P[4]||void 0===P[5]||void 0===P[6]||void 0===P[7]||void 0===P[8]?D.Log("ThreeDObjectHandler Warning: index out of vertices array bounds"):j.push.apply(j,P);if(cb){var Ca=new c.Vector3(Y,Z,$),Da=new c.Vector3(aa,ba,ca),pb=new c.Vector3(db,eb,fb);xa.push(Ca,Da,pb)}r&&(L=$a(h,e,r),m.push.apply(m,[L.r/255,L.g/255,L.b/
255]),m.push.apply(m,[L.r/255,L.g/255,L.b/255]),m.push.apply(m,[L.r/255,L.g/255,L.b/255]))}}g.addAttribute("position",new c.BufferAttribute(new Float32Array(j),3));r&&g.addAttribute("color",new c.BufferAttribute(new Float32Array(m),3))}if(l=k.input.normal)if(l.hasOwnProperty("smooth")&&sa.ToBool(l.smooth)){for(var q=e[a.source],b=a.indices,Q=[],B={},V,W,X,oa=new c.Vector3,ea=new c.Vector3,pa=new c.Vector3,M=new c.Vector3,qa=new c.Vector3,h=0;h<k.count;++h){V=3*b[3*h];W=3*b[3*h+1];X=3*b[3*h+2];oa.fromArray(q,
V);ea.fromArray(q,W);pa.fromArray(q,X);M.subVectors(pa,ea);qa.subVectors(oa,ea);M.cross(qa);var Ta=function(a,b){B.hasOwnProperty(a)?B[a].add(b):B[a]=b.clone()};Ta(V,M);Ta(W,M);Ta(X,M)}for(var Ua=0,na=Object.keys(B),Ka=na.length;Ua<Ka;++Ua)B[na[Ua]].normalize();for(h=0;h<k.count;++h){V=3*b[3*h];W=3*b[3*h+1];X=3*b[3*h+2];var ra=[B[V].x,B[V].y,B[V].z,B[W].x,B[W].y,B[W].z,B[X].x,B[X].y,B[X].z];Q.push.apply(Q,ra)}g.addAttribute("normal",new c.BufferAttribute(new Float32Array(Q),3))}else if(l.hasOwnProperty("indices")&&
l.indices&&l.indices.length&&e[l.source]){for(var t=e[l.source],O=l.indices,Q=[],h=0;h<k.count;++h)0>w&&(O[3*h+2]=[O[3*h+1],O[3*h+1]=O[3*h+2]][0]),ra=[t[3*O[3*h]],t[3*O[3*h]+1],t[3*O[3*h]+2],t[3*O[3*h+1]],t[3*O[3*h+1]+1],t[3*O[3*h+1]+2],t[3*O[3*h+2]],t[3*O[3*h+2]+1],t[3*O[3*h+2]+2]],Q.push.apply(Q,ra);g.addAttribute("normal",new c.BufferAttribute(new Float32Array(Q),3))}else if(l.hasOwnProperty("smooth")&&!sa.ToBool(l.smooth)){q=e[a.source];b=a.indices;Q=[];oa=new c.Vector3;ea=new c.Vector3;pa=new c.Vector3;
M=new c.Vector3;qa=new c.Vector3;for(h=0;h<k.count;++h)V=3*b[3*h],W=3*b[3*h+1],X=3*b[3*h+2],oa.fromArray(q,V),ea.fromArray(q,W),pa.fromArray(q,X),M.subVectors(pa,ea),qa.subVectors(oa,ea),M.cross(qa),M.normalize(),ra=[M.x,M.y,M.z,M.x,M.y,M.z,M.x,M.y,M.z],Q.push.apply(Q,ra);g.addAttribute("normal",new c.BufferAttribute(new Float32Array(Q),3))}else D.Log("Problem parsing json: no normal computation can be infered");else g.computeVertexNormals();z=[];v=[];if(cb){for(var i=e[f.source],R=f.indices,y=[],
h=0;h<k.count;h++)0>w&&(R[3*h+2]=[R[3*h+1],R[3*h+1]=R[3*h+2]][0]),ga=i[2*R[3*h]],ha=i[2*R[3*h]+1],ia=i[2*R[3*h+1]],ja=i[2*R[3*h+1]+1],ka=i[2*R[3*h+2]],la=i[2*R[3*h+2]+1],da=[ga,ha,ia,ja,ka,la],z.push.apply(z,da),v.push.apply(v,da),Ga=xa[3*h],Ha=xa[3*h+1],Ia=xa[3*h+2],Za(Ga,Ha,Ia,ga,ha,ia,ja,ka,la,y);ma=Ya(y);g.dUdP=ma.x;g.dVdP=ma.y;g.uvsNeedUpdate=!0}else for(h=0;h<3*k.count;h++)z.push.apply(z,[0,0]),v.push.apply(v,[0,0]);g.addAttribute("uv",new c.BufferAttribute(new Float32Array(z),2));g.addAttribute("uv2",
new c.BufferAttribute(new Float32Array(v),2))}}},Wa=function(g,e){return function(){e.attributes.position&&(g.attributes.position=e.attributes.position);e.attributes.normal&&(g.attributes.normal=e.attributes.normal);e.attributes.color&&(g.attributes.color=e.attributes.color);e.attributes.uv&&(g.attributes.uv=e.attributes.uv);e.attributes.uv2&&(g.attributes.uv2=e.attributes.uv2);e.dUdP&&(g.dUdP=e.dUdP);e.dVdP&&(g.dVdP=e.dVdP);e.adjacentfacesedgeslines.attributes.position&&(g.adjacentfacesedgeslines.attributes.position=
e.adjacentfacesedgeslines.attributes.position)}},Xa=function(g,e,k,a,s){return function(){var r=k.input.position,l=k.input.interleaved,f=k.input.normal,p=!(f&&f.hasOwnProperty("smooth")&&sa.ToBool(f.smooth)),q={};if(p||s)for(var b={},t=0;t<k.count;++t){var i=t,y,j,u;if(r)u=r.indices,y=parseInt(u[3*i]),j=parseInt(u[3*i+1]),u=parseInt(u[3*i+2]);else if(l){var z,v;switch(l.format){default:D.Log("ThreeDObjectHandler Warning: Unrecognized interleaved format, switching to default PNT");case "PNT":z=9;v=
3;break;case "PN":z=6,v=2}u=l.indices;y=parseInt(u[i*z]);j=parseInt(u[i*z+v]);u=parseInt(u[i*z+2*v])}var m={"0":y,1:j,face1:i,face2:null,opedge:null,edgeIDF1:0,edgeIDF2:null},d=m["0"]+"/"+m["1"],n=m["1"]+"/"+m["0"];b.hasOwnProperty(n)?(b[d]=m,b[d].face2=b[n].face1,b[d].opedge=b[n],b[n].face2&&D.Log("ThreeDObjectHandler Warning: Edge shared with more than two faces"),b[n].face2=i,b[n].opedge=m,b[n].edgeIDF2=0):b.hasOwnProperty(d)?D.Log("ThreeDObjectHandler Warning: Edge already existing : not treated"):
(b[d]=m,q[d]=m);m={"0":j,1:u,face1:i,face2:null,opedge:null,edgeIDF1:1,edgeIDF2:null};d=m["0"]+"/"+m["1"];n=m["1"]+"/"+m["0"];b.hasOwnProperty(n)?(b[d]=m,b[d].face2=b[n].face1,b[d].opedge=b[n],b[n].face2&&D.Log("ThreeDObjectHandler Warning: Edge shared with more than two faces"),b[n].face2=i,b[n].opedge=m,b[n].edgeIDF2=1):b.hasOwnProperty(d)?D.Log("Warning: Edge already existing : not treated"):(b[d]=m,q[d]=m);m={"0":u,1:y,face1:i,face2:null,opedge:null,edgeIDF1:2,edgeIDF2:null};d=m["0"]+"/"+m["1"];
n=m["1"]+"/"+m["0"];b.hasOwnProperty(n)?(b[d]=m,b[d].face2=b[n].face1,b[d].opedge=b[n],b[n].face2&&D.Log("ThreeDObjectHandler Warning: Edge shared with more than two faces"),b[n].face2=i,b[n].opedge=m,b[n].edgeIDF2=2):b.hasOwnProperty(d)?D.Log("ThreeDObjectHandler Warning: Edge already existing : not treated"):(b[d]=m,q[d]=m)}b=[];t=0;i=Object.keys(q);for(y=i.length;t<y;++t)if(j=q[i[t]],j.face2){if(p){m=new c.Vector3;if(f||l){var w,x,F,K,N;if(r&&f)d=e[f.source],u=f.indices,n=3*j.face1+j.edgeIDF1,
F=3*j.face1+(j.edgeIDF1+1)%3,K=3*j.face2+j.edgeIDF2,N=3*j.face2+(j.edgeIDF2+1)%3;else{switch(l.format){default:D.Log("ThreeDObjectHandler Warning: Unrecognized interleaved format, switching to default PNT");case "PNT":z=9;v=3;break;case "PN":z=6,v=2}d=e[l.sources[1]];u=l.indices;n=j.face1*z+1+v*j.edgeIDF1;F=j.face1*z+1+v*((j.edgeIDF1+1)%3);K=j.face2*z+1+v*j.edgeIDF2;N=j.face2*z+1+v*((j.edgeIDF2+1)%3)}z=new c.Vector3;v=new c.Vector3;w=new c.Vector3;x=new c.Vector3;z.fromArray(d,3*u[n]);v.fromArray(d,
3*u[F]);w.fromArray(d,3*u[K]);x.fromArray(d,3*u[N]);z.normalize();v.normalize();w.normalize();x.normalize();u=Math.abs(Math.min(z.dot(x),v.dot(w)))>1-a;m.addVectors(z,v);m.add(w).add(x).divideScalar(4)}else{if(r){A=e[r.source];u=r.indices;N=3*j.face1+j.edgeIDF1;var C=3*j.face1+(j.edgeIDF1+1)%3,G=3*j.face1+(j.edgeIDF1+2)%3,d=3*j.face2+j.edgeIDF2,n=3*j.face2+(j.edgeIDF2+1)%3;F=3*j.face2+(j.edgeIDF2+2)%3;K=new c.Vector3;z=new c.Vector3;v=new c.Vector3;w=new c.Vector3;x=new c.Vector3;K.fromArray(A,3*
u[N]);z.fromArray(A,3*u[C]);v.fromArray(A,3*u[G]);w.subVectors(v,z);x.subVectors(K,z);w.cross(x);w.normalize();N=w.clone();K.fromArray(A,3*u[d]);z.fromArray(A,3*u[n]);v.fromArray(A,3*u[F]);w.subVectors(v,z);x.subVectors(K,z);w.cross(x);w.normalize();d=w.clone()}else{D.Log("Missing vertex data");break}u=Math.abs(N.dot(d))>1-a;m.addVectors(N,d);m.divideScalar(4)}u||(u=j["0"],j=j["1"],r?A=e[r.source]:l&&(A=e[l.sources[0]]),d=3*u,m=3*j,u=A[d],j=A[d+1],d=A[d+2],n=A[m],F=A[m+1],m=A[m+2],b.push(u,j,d,n,
F,m))}}else if(s){u=j["0"];j=j["1"];var A;r?A=e[r.source]:l&&(A=e[l.sources[0]]);d=3*u;m=3*j;u=A[d];j=A[d+1];d=A[d+2];n=A[m];F=A[m+1];m=A[m+2];b.push(u,j,d,n,F,m)}A=new c.BufferAttribute(new Float32Array(b),3);g.addAttribute("position",A)}},fa=function(g){return function(e,k){return parseFloat(e.geometry.coincidentgroup)!=parseFloat(k.geometry.coincidentgroup)?0>parseFloat(e.geometry.coincidentgroup)&&0>parseFloat(k.geometry.coincidentgroup)?!1:parseFloat(e.geometry.coincidentgroup)-parseFloat(k.geometry.coincidentgroup):
g?Math.abs(e.geometry.coincidentpriority)-Math.abs(k.geometry.coincidentpriority):Math.abs(k.geometry.coincidentpriority)-Math.abs(e.geometry.coincidentpriority)}},ya=function(g,e){var k,a,c,r,l,f,p,q;k=a="-1";if(e)for(l=0;l<g.length;){f=g[l];p=f.geometry.coincidentgroup;q=f.geometry.coincidentpriority;switch(f.geometry.coincidentgrouptag){case "planar":b=!0;break;default:case "tris-same":case "shape-same":b=!1}0>q?(p!=a?r=q:q<r&&(f.material.transparencylayer=!b),a=p):f.material.transparencylayer=
!b;f.material.fromARD=b;l++}else for(l=g.length-1;0<=l;){f=g[l];p=f.geometry.coincidentgroup;q=f.geometry.coincidentpriority;var b;switch(f.geometry.coincidentgrouptag){case "planar":b=!0;break;default:case "tris-same":case "shape-same":b=!1}0<q?(p!=k?c=q:q<c&&(f.material.transparencylayer=!b),k=p):f.material.transparencylayer=!b;f.material.fromARD=b;l--}};return za.Model.extend({initialize:function(g){D.Log("Creating ThreeDObjectHandler Object");this.set("_exec_queue",g);this.set("_geometrycounter",
0);this.set("_geomsources",{});this.set("_proxy_geometries",{});this.set("_geom_register_map",{})},ClearBuildMaps:function(){this.set("_geomsources",{});this.set("_proxy_geometries",{});this.set("_geom_register_map",{})},InstantiateGeometry:function(g,e,k,a,s,r,l,f,p,q,b,t){var i,y,j,u;void 0===t&&(t="");var z=!1;switch(g){case "Cuboid":u=a.hasOwnProperty("surfaceID")&&l.hasOwnProperty(a.surfaceID)?l[a.surfaceID].material_name:"default_material";s.hasOwnProperty(t+e)||(s[t+e]={});this.get("_geom_register_map").hasOwnProperty(t+
e)||(this.get("_geom_register_map")[t+e]={});this.get("_geom_register_map")[t+e].hasOwnProperty(u+"#"+k)||(this.get("_geom_register_map")[t+e][u+"#"+k]={},z=!0);if(!s[t+e].hasOwnProperty(u)&&"opaque_pass"==k){this.set("_geometrycounter",this.get("_geometrycounter")+1);i=new c.InstancedBufferGeometry;i.maxInstancedCount=1;i.adjacentfacesedgeslines=new c.InstancedBufferGeometry;i.adjacentfacesedgeslines.maxInstancedCount=1;var v=new c.Vector3,m=new c.Quaternion,d=new c.Vector3(1,1,1);b.decompose(v,
m,d);var n=(new c.InstancedBufferAttribute(new Float32Array(3*i.maxInstancedCount),3,1)).setDynamic(!0);n.setXYZ(0,v.x,v.y,v.z);var w=(new c.InstancedBufferAttribute(new Float32Array(4*i.maxInstancedCount),4,1)).setDynamic(!0);w.setXYZW(0,m.x,m.y,m.z,m.w);y=(new c.InstancedBufferAttribute(new Float32Array(3*i.maxInstancedCount),3,1)).setDynamic(!0);y.setXYZ(0,d.x,d.y,d.z);if(this.get("_proxy_geometries").hasOwnProperty(e))i.copy(this.get("_proxy_geometries")[e]),i.adjacentfacesedgeslines.copy(this.get("_proxy_geometries")[e].adjacentfacesedgeslines);
else{this.set("_geometrycounter",this.get("_geometrycounter")+1);var x=this.get("_proxy_geometries")[e]=i,F=0.5*a.length,K=0.5*a.width,N=0.5*a.height,f=[-1,1,1,1,1,1,-1,-1,1,1,-1,1,1,1,-1,-1,1,-1,1,-1,-1,-1,-1,-1,-1,1,-1,-1,1,1,-1,-1,-1,-1,-1,1,1,1,1,1,1,-1,1,-1,1,1,-1,-1,-1,1,1,1,1,1,-1,1,-1,1,1,-1,1,-1,1,-1,-1,1,1,-1,-1,-1,-1,-1].map(function(a,b){switch(b%3){case 0:return a*F;case 1:return a*K;case 2:return a*N}}),f=new c.BufferAttribute(new Float32Array(f),3);x.addAttribute("position",f);f=1/
3;p=2*f;f=new c.BufferAttribute(new Float32Array([0,f,0.5,f,0,0,0.5,0,0.5,f,1,f,0.5,0,1,0,0.5,1,1,1,0.5,p,1,p,0,1,0.5,1,0,p,0.5,p,0,f,0.5,f,0,p,0.5,p,0.5,f,1,f,0.5,p,1,p]),2);x.addAttribute("uv",f);if(a.hasOwnProperty("colors")&&null!==a.colors){f=[];for(p=0;24>p;p++){var C;switch(Math.floor(p/4)){case 0:C=2;break;case 1:C=5;break;case 2:C=3;break;case 3:C=0;break;case 4:C=1;break;case 5:C=4}b=ta(a.colors[C%a.colors.length]);f.push(b.r/255);f.push(b.g/255);f.push(b.b/255)}f=new c.BufferAttribute(new Float32Array(f),
3);x.addAttribute("color",f)}f=new Uint16Array([0,2,1,2,3,1,4,6,5,6,7,5,8,10,9,10,11,9,12,14,13,14,15,13,16,17,18,18,17,19,20,21,22,22,21,23]);x.setIndex(new c.BufferAttribute(f,1));f=new c.BufferAttribute(new Float32Array([0,0,1,0,0,1,0,0,1,0,0,1,0,0,-1,0,0,-1,0,0,-1,0,0,-1,-1,0,0,-1,0,0,-1,0,0,-1,0,0,1,0,0,1,0,0,1,0,0,1,0,0,0,1,0,0,1,0,0,1,0,0,1,0,0,-1,0,0,-1,0,0,-1,0,0,-1,0]),3);x.addAttribute("normal",f);var x=i.adjacentfacesedgeslines,G=-a.length/2,A=-a.width/2,H=-a.height/2;C=a.length/2;var J=
a.width/2,S=a.height/2,f=[G,A,H],p=[C,A,H],b=[G,A,S],A=[C,A,S],E=[G,J,H],H=[C,J,H],G=[G,J,S];C=[C,J,S];f=[].concat(f,b,b,A,A,p,b,G,G,C,C,A,G,E,E,H,H,C,E,f,f,p,p,H);f=new c.BufferAttribute(new Float32Array(f),3);x.addAttribute("position",f)}i.addAttribute("inst_translation",n);i.addAttribute("inst_rotation",w);i.addAttribute("inst_scale",y);i.adjacentfacesedgeslines.addAttribute("inst_translation",n);i.adjacentfacesedgeslines.addAttribute("inst_rotation",w);i.adjacentfacesedgeslines.addAttribute("inst_scale",
y);i.attributes.inst_translation.jarray=[v.x,v.y,v.z];i.attributes.inst_rotation.jarray=[m.x,m.y,m.z,m.w];i.attributes.inst_scale.jarray=[d.x,d.y,d.z];s[t+e][u]=i}else i=s[t+e][u],"opaque_pass"==k&&(v=new c.Vector3,m=new c.Quaternion,d=new c.Vector3(1,1,1),b.decompose(v,m,d),i.attributes.inst_translation.jarray.push(v.x,v.y,v.z),i.attributes.inst_rotation.jarray.push(m.x,m.y,m.z,m.w),i.attributes.inst_scale.jarray.push(d.x,d.y,d.z));break;case "Mesh":C=null;J=0;S=Object.keys(a.triangles);for(A=S.length;J<
A;++J)if(x=S[J],E=a.triangles[x],0<E.count){u=l.hasOwnProperty(x)?l[x].material_name:"default_material";s.hasOwnProperty(t+e)?j=s[t+e]:s[t+e]=j=[];if(this.get("_geomsources").hasOwnProperty(e))C=this.get("_geomsources")[e];else{C={};if(a.sources){m=0;d=Object.keys(a.sources);for(v=d.length;m<v;++m)if(n=d[m],"string"==typeof n){w=[];y=a.sources[n].stride;G=a.sources[n].count;H=a.sources[n].values;switch(a.sources[n].format){case "ST":case "UV":for(var I=0;I<G;++I)w.push.apply(w,[parseFloat(H[I*y]),
parseFloat(H[I*y+1])]);break;case "XYZ":case "RGB":for(I=0;I<G;++I)w.push.apply(w,[parseFloat(H[I*y]),parseFloat(H[I*y+1]),parseFloat(H[I*y+2])]);break;case "XYZW":for(I=0;I<G;++I)w.push.apply(w,[parseFloat(H[I*y]),parseFloat(H[I*y+1]),parseFloat(H[I*y+2]),parseFloat(H[I*y+3])]);break;default:D.Log("ThreeDObjectHandler Warning: Unhandled format string: default single buffer selected");case "C":w=H}C[n]=w}}this.get("_geomsources")[e]=C}j.hasOwnProperty(x)||(j[x]={});this.get("_geom_register_map").hasOwnProperty(t+
e)||(this.get("_geom_register_map")[t+e]={});if(!this.get("_geom_register_map")[t+e].hasOwnProperty(u+"#"+k)||E.hasOwnProperty("coincident-group"))this.get("_geom_register_map")[t+e][u+"#"+k]={},z=!0;if(!j[x].hasOwnProperty(u)||E.hasOwnProperty("coincident-group")){if("opaque_pass"==k){m=!1;if(E.hasOwnProperty("coincident-group")&&j[x]){n=0;d=Object.keys(j[x]);for(v=d.length;n<v;++n)if(w=d[n],"default_cg"!=w&&1==j[x][w].maxInstancedCount){m=!0;i=j[x][w];break}}m||(i=new c.InstancedBufferGeometry,
i.maxInstancedCount=1,i.adjacentfacesedgeslines=new c.InstancedBufferGeometry,i.adjacentfacesedgeslines.maxInstancedCount=1,v=e,G=E.hasOwnProperty("coincident-group")?parseFloat(E["coincident-group"]):0,d=E.hasOwnProperty("coincident-priority")?parseFloat(E["coincident-priority"]):0,n=E.hasOwnProperty("coincident-group-tag")?E["coincident-group-tag"]:"tris-same",i.useSoftwareInstancing=E.hasOwnProperty("coincident-group")?!0:m,i.adjacentfacesedgeslines.useSoftwareInstancing=E.hasOwnProperty("coincident-group")?
!0:m,i.coincidentmeshID=v,i.coincidentgroup=G,i.coincidentpriority=d,i.coincidentgrouptag=n,n=(new c.InstancedBufferAttribute(new Float32Array(3*i.maxInstancedCount),3,1)).setDynamic(!0),w=(new c.InstancedBufferAttribute(new Float32Array(4*i.maxInstancedCount),4,1)).setDynamic(!0),y=(new c.InstancedBufferAttribute(new Float32Array(3*i.maxInstancedCount),3,1)).setDynamic(!0),v=new c.Vector3,m=new c.Quaternion,d=new c.Vector3(1,1,1),E.hasOwnProperty("coincident-group")||b.decompose(v,m,d),n.setXYZ(0,
v.x,v.y,v.z),w.setXYZW(0,m.x,m.y,m.z,m.w),y.setXYZ(0,d.x,d.y,d.z),i.addAttribute("inst_translation",n),i.addAttribute("inst_rotation",w),i.addAttribute("inst_scale",y),i.adjacentfacesedgeslines.addAttribute("inst_translation",n),i.adjacentfacesedgeslines.addAttribute("inst_rotation",w),i.adjacentfacesedgeslines.addAttribute("inst_scale",y),i.attributes.inst_translation.jarray=[v.x,v.y,v.z],i.attributes.inst_rotation.jarray=[m.x,m.y,m.z,m.w],i.attributes.inst_scale.jarray=[d.x,d.y,d.z],this.get("_proxy_geometries").hasOwnProperty(e)||
(this.get("_proxy_geometries")[e]={}),this.get("_proxy_geometries")[e].hasOwnProperty(x)?v=this.get("_proxy_geometries")[e][x]:(this.set("_geometrycounter",this.get("_geometrycounter")+1),this.get("_proxy_geometries")[e][x]=v=new c.BufferGeometry,v.adjacentfacesedgeslines=new c.BufferGeometry,this.get("_exec_queue").run(Va(v,C,E),this,!1,null,null,!0),this.get("_exec_queue").run(Xa(v.adjacentfacesedgeslines,C,E,f,p),this,!1,null,null,!0)),this.get("_exec_queue").run(Wa(i,v),this,!1,null,null,!0),
j[x].hasOwnProperty(u)||(j[x][u]={}),E.hasOwnProperty("coincident-group")?j[x][u][G]=i:j[x][u].default_cg=i)}}else i=j[x][u].default_cg,i instanceof c.InstancedBufferGeometry&&("opaque_pass"==k&&void 0===q)&&(v=new c.Vector3,m=new c.Quaternion,d=new c.Vector3(1,1,1),b.decompose(v,m,d),i.attributes.inst_translation.jarray.push(v.x,v.y,v.z),i.attributes.inst_rotation.jarray.push(m.x,m.y,m.z,m.w),i.attributes.inst_scale.jarray.push(d.x,d.y,d.z))}break;default:D.Log("ThreeDObjectHandler Warning: Unrecognized type of geometry - Accepted: Cuboid, Mesh")}e=
[];if(z)switch(k){case "highlightnode":switch(g){case "Cuboid":e.push(new c.LineSegments(i.adjacentfacesedgeslines,r.highlight));break;case "Mesh":m=0;d=Object.keys(j);for(v=d.length;m<v;++m)if(x=d[m],i=j[x],u=l.hasOwnProperty(x)?l[x].material_name:"default_material",i[u]){n=0;k=Object.keys(i[u]);for(g=k.length;n<g;++n)e.push(new c.LineSegments(i[u][k[n]].adjacentfacesedgeslines,r.highlight))}break;default:D.Log("ThreeDObjectHandler Warning: Unrecognized type of geometry - Accepted: Cuboid, Mesh")}break;
default:switch(g){case "Cuboid":if(a.hasOwnProperty("surfaceID")&&l.hasOwnProperty(a.surfaceID)){if(x=a.surfaceID,j=l[x].front,u=1>j.opacity||j.transp_texture,this.trigger("non_empty_scene",{transparent:u}),j.mat.untextured_mat[k]){j.boundmeshlist||(j.boundmeshlist={});j.boundmeshlist.hasOwnProperty(k)||(j.boundmeshlist[k]={});j.boundmeshlist[k].hasOwnProperty("front_mat")||(j.boundmeshlist[k].front_mat={});u=j.mat.untextured_mat[k];g=0;a=Object.keys(u);for(q=a.length;g<q;g++)s=a[g],w=u[a[s]],j.mat.textured_mat.hasOwnProperty(k)||
(j.mat.textured_mat[k]={}),j.mat.textured_mat[k].hasOwnProperty(s)||(j.mat.textured_mat[k][s]={}),j.mat.textured_mat[k][s].hasOwnProperty(x)||(j.mat.textured_mat[k][s][x]=w),j.boundmeshlist[k].front_mat.hasOwnProperty(s)||(j.boundmeshlist[k].front_mat[s]={}),j.boundmeshlist[k].front_mat[s].hasOwnProperty(x)||(j.boundmeshlist[k].front_mat[s][x]=[]),w=new c.Mesh(i,w),e.push(w),j.boundmeshlist[k].front_mat[s][x].push(w)}}else w=new c.Mesh(i,r.default_material),e.push(w),this.trigger("non_empty_scene",
{transparent:!1});break;case "Mesh":i=this.OrderRenderList(k,j,q,l);m=0;d=Object.keys(i);for(v=d.length;m<v;++m)if(x=i[m].surfaceID,t=i[m].geometry,d=i[m].material,l.hasOwnProperty(x))if(n=d.side==c.BackSide?"back_mat":"front_mat",j=d.side==c.BackSide?l[x].back:l[x].front){if(u=1>j.opacity||j.transp_texture,(!d.transparencylayer||u)&&j.mat.untextured_mat[k]){u=j.mat.untextured_mat[k];g=0;a=Object.keys(u);for(q=a.length;g<q;g++)s=a[g],w=u[s],y=new w.constructor({name:"placeholder_material"}),y.copy(w),
d.side===c.BackSide&&!t.HasInvertedWinding&&console.error("Back geometry not inverted !!!"),y.side=c.FrontSide,j.mat.textured_mat.hasOwnProperty(k)||(j.mat.textured_mat[k]={}),j.mat.textured_mat[k].hasOwnProperty(s)||(j.mat.textured_mat[k][s]={}),j.mat.textured_mat[k][s].hasOwnProperty(x)||(j.mat.textured_mat[k][s][x]=y),j.boundmeshlist||(j.boundmeshlist={}),j.boundmeshlist.hasOwnProperty(k)||(j.boundmeshlist[k]={}),j.boundmeshlist[k].hasOwnProperty(n)||(j.boundmeshlist[k][n]={}),j.boundmeshlist[k][n].hasOwnProperty(s)||
(j.boundmeshlist[k][n][s]={}),j.boundmeshlist[k][n][s].hasOwnProperty(x)||(j.boundmeshlist[k][n][s][x]=[]),w=new c.Mesh(t,y),e.push(w),j.boundmeshlist[k][n][s][x].push(w)}}else D.Log("ThreeDObjectHandler Warning: No front material found for this surface");else w=new c.Mesh(t,r.default_material),e.push(w),this.trigger("non_empty_scene",{transparent:!1});break;default:D.Log("ThreeDObjectHandler Warning: Unrecognized type of geometry - Only accepted: Cuboid, Mesh")}}return{register:z,objects:e}},OrderRenderList:function(g,
e,k,a){var c,g=[];c=[];for(var r,l=Object.keys(e),f=l.length-1;-1!==f;f--){var p=e[l[f]];r=l[f];r=a.hasOwnProperty(r)?a[r].material_name:"default_material";if(p[r])for(var q=0,b=Object.keys(p[r]),t=b.length;q<t;++q)c.push({surfaceID:l[f],geometry:p[r][b[q]]});p=!1;a.hasOwnProperty(l[f])&&(p=a[l[f]].front,r=a[l[f]].back,r=1>r.opacity||r.transp_texture,p=1>p.opacity||p.transp_texture||r);this.trigger("non_empty_scene",{transparent:p})}c.sort(fa(!0));l=[];e=[];f=Object.keys(c);if(0!=f.length)if(1==f.length)l=
c;else for(p=0;p!==f.length;p++)r=!c[f[p]].geometry.hasOwnProperty("coincidentgroup"),r||(q=c[f[p]].geometry.coincidentgroup,0==p?(b=c[f[p+1]].geometry.coincidentgroup,q!=b&&(r=!0)):p==f.length-1?(t=c[f[p-1]].geometry.coincidentgroup,q!=t&&(r=!0)):(b=c[f[p+1]].geometry.coincidentgroup,t=c[f[p-1]].geometry.coincidentgroup,q!=t&&q!=b&&(r=!0))),r?l.push(c[f[p]]):e.push(c[f[p]]);c=l;void 0===k&&(c=this.DuplicateSurfaceForFrontAndBack(c,a),Array.prototype.push.apply(g,c.ungrouped),Array.prototype.push.apply(g,
c.front),Array.prototype.push.apply(g,c.back));c=this.FilterRenderList(e,k,a);a=this.DuplicateSurfaceForFrontAndBack(c,a);a.front.sort(fa(!0));a.back.sort(fa(!1));void 0===k&&Array.prototype.push.apply(g,a.ungrouped);ya(a.front,!1);a.back.reverse();ya(a.back,!0);a.back.reverse();Array.prototype.push.apply(g,a.back);Array.prototype.push.apply(g,a.front);return g},InvertGeometryWinding:function(g,e){g.hasOwnProperty("HasInvertedWinding")||(g.HasInvertedWinding=!0,this.get("_exec_queue").run(function(){if(g.attributes.hasOwnProperty("index")){for(var c=
g.attributes.index.clone(),a=0;a<c.count;a+=3){var s=c[a+1];c[a+1]=c[a+2];c[a+2]=s}g.attributes.index=c}else{for(var c=g.attributes.position.clone(),s=g.attributes.normal.clone(),r=g.attributes.uv.clone(),l=g.attributes.uv2.clone(),f=g.attributes.hasOwnProperty("color")?g.attributes.color.clone():null,a=0;a<c.count;a+=3){var p=c.getX(a+1),q=c.getY(a+1),b=c.getZ(a+1),t=c.getX(a+2),i=c.getY(a+2),y=c.getZ(a+2);c.setXYZ(a+1,t,i,y);c.setXYZ(a+2,p,q,b);var j=s.getX(a),u=s.getY(a),z=s.getZ(a),p=s.getX(a+
1),q=s.getY(a+1),b=s.getZ(a+1),t=s.getX(a+2),i=s.getY(a+2),y=s.getZ(a+2);s.setXYZ(a+0,-j,-u,-z);s.setXYZ(a+1,-t,-i,-y);s.setXYZ(a+2,-p,-q,-b);p=r.getX(a+1);q=r.getY(a+1);t=r.getX(a+2);i=r.getY(a+2);r.setXY(a+1,t,i);r.setXY(a+2,p,q);p=l.getX(a+1);q=l.getY(a+1);t=l.getX(a+2);i=l.getY(a+2);l.setXY(a+1,t,i);l.setXY(a+2,p,q);f&&(p=f.getX(a+1),q=f.getY(a+1),b=f.getZ(a+1),t=f.getX(a+2),i=f.getY(a+2),y=f.getZ(a+2),f.setXYZ(a+1,t,i,y),f.setXYZ(a+2,p,q,b))}c.needsUpdate=!0;s.needsUpdate=!0;r.needsUpdate=!0;
l.needsUpdate=!0;g.attributes={position:c,normal:s,uv:r,uv2:l,inst_translation:g.attributes.inst_translation,inst_rotation:g.attributes.inst_rotation,inst_scale:g.attributes.inst_scale};f&&(g.attributes.color=f);g.verticesNeedUpdate=!0;g.normalsNeedUpdate=!0;g.uvsNeedUpdate=!0}e.hasOwnProperty("dUdP")&&e.hasOwnProperty("dVdP")&&(g.dUdP=e.dUdP,g.dVdP=e.dVdP)},this,!1,null,null,!0))},GetInvertedGeometry:function(c){var e;if(c.hasOwnProperty("InvertedWindingGeometry"))e=c.InvertedWindingGeometry;else{e=
new c.constructor;for(var k=Object.keys(c),a=k.length-1;0<=a;a--)e[k[a]]=c[k[a]];this.InvertGeometryWinding(e,c);c.InvertedWindingGeometry=e}return e},DuplicateSurfaceForFrontAndBack:function(g,e){for(var k=[],a=[],s=[],r=Object.keys(g),l=r.length-1;-1!==l;l--){var f=g[r[l]].geometry;if(f.hasOwnProperty(["coincidentgroup"])&&f.hasOwnProperty(["coincidentpriority"])&&f.hasOwnProperty(["coincidentgrouptag"])&&0<=f.coincidentgroup&&0!==f.coincidentpriority){var p=f.coincidentpriority,q={surfaceID:g[r[l]].surfaceID,
material:{transparencylayer:!1,coincidentsurface:!0,fromARD:!1,side:0<p?c.FrontSide:c.BackSide}},b={surfaceID:g[r[l]].surfaceID,material:{transparencylayer:!1,coincidentsurface:!0,fromARD:!1,side:0<p?c.BackSide:c.FrontSide}};switch(f.coincidentgrouptag){case "planar":0<p?(q.geometry=f,k.unshift(q)):(b.geometry=f,a.unshift(b));break;default:case "tris-same":case "shape-same":var t=this.GetInvertedGeometry(f);0<p?(q.geometry=f,b.geometry=t):(q.geometry=t,b.geometry=f);k.unshift(q);a.unshift(b)}}else p=
!0,e.hasOwnProperty(g[r[l]].surfaceID)&&(q=e[g[r[l]].surfaceID].front,p=e[g[r[l]].surfaceID].back,q.double_sided!==p.double_sided&&console.warn("Front and back material not coherent on double_sided flag"),p=q.double_sided||p.double_sided),q={surfaceID:g[r[l]].surfaceID,geometry:f,material:{transparencylayer:!1,coincidentsurface:!1,fromARD:!1,side:c.FrontSide}},s.push(q),p&&(t=this.GetInvertedGeometry(f),s.unshift({surfaceID:g[r[l]].surfaceID,geometry:t,material:{transparencylayer:!1,coincidentsurface:!1,
fromARD:!1,side:c.BackSide}}))}return{front:k,back:a,ungrouped:s}},FilterRenderList:function(c,e,k){for(var a=[],s=Object.keys(c),r=s.length-1;-1!==r;r--){var l=c[s[r]].surfaceID;if(k.hasOwnProperty(l)){var f=k[l].front,l=k[l].back,l=1>l.opacity||l.transp_texture,f=1>f.opacity||f.transp_texture||l,l=!1,p=c[s[r]].geometry;if(p.hasOwnProperty(["coincidentgroup"])&&p.hasOwnProperty(["coincidentpriority"])&&p.hasOwnProperty(["coincidentgrouptag"])&&0<=p.coincidentgroup&&0!==p.coincidentpriority)switch(p.coincidentgrouptag){case "planar":l=
!0;break;default:case "tris-same":case "shape-same":l=!1}void 0===e?(l||f)&&p.hasOwnProperty("coincidentgroup")&&0<=p.coincidentgroup&&0!==p.coincidentpriority?this.trigger("new_coincident_group_pass",{coincidentgroup:p.coincidentgroup,transparent:f}):a.push(c[r]):(l||f)&&(p.hasOwnProperty("coincidentgroup")&&0<=p.coincidentgroup&&0!==p.coincidentpriority&&e==p.coincidentgroup)&&a.push(c[r])}else D.Log("ThreeDObjectHandler Warning: Surface '"+l+"' not found in material map :("),a.push(c[r])}return a}})});