/**
 * @author DOGO
 * @module WebViewer3D
 * @copyright   2014 Esko Stonecube Ltd. All rights reserved.
 */

define(["underscore","backbone","WV3Dlib/detect","WV3Dmod/Constants","WV3Dmod/LogMessage"],function(q,n,p,d,g){return new (n.Model.extend({initialize:function(){this.set("_ua",p.parse(navigator.userAgent));this.UpdateSystemSupportLevel();this.UpdateSystemReport()},UpdateSystemSupportLevel:function(){g.Log("SystemChecker: Update system support level");this.set("_issues",{});var a=d.wglSsupportLevel.NONE;if(window.WebGLRenderingContext){for(var e=document.createElement("canvas"),b=["webgl","experimental-webgl",
"moz-webgl","webkit-3d"],k=!1,c=0;4>c;c++)try{if((k=e.getContext(b[c]))&&"function"==typeof k.getParameter)a=d.wglSsupportLevel.FULL}catch(f){}a!=d.wglSsupportLevel.FULL&&(this.get("_issues").webgl="Rendering context supported, but WebGL probably user disabled!",a=d.wglSsupportLevel.PARTIAL)}else this.get("_issues").webgl="WebGL not supported!",a=d.wglSsupportLevel.NONE;-1!=navigator.appVersion.indexOf("Win")&&this.set("_os_name","Windows");-1!=navigator.appVersion.indexOf("Mac")&&this.set("_os_name",
"MacOS");-1!=navigator.appVersion.indexOf("X11")&&this.set("_os_name","UNIX");-1!=navigator.appVersion.indexOf("Linux")&&this.set("_os_name","Linux");e=d.supportLevel.FULL;a==d.wglSsupportLevel.PARTIAL?e=d.supportLevel.PARTIAL:a==d.wglSsupportLevel.NONE&&(e=d.supportLevel.NONE);this.set("_overallSupportLevel",e)},GetSystemSupportLevel:function(){g.Log("SystemChecker: Get system support level");return{issues:this.get("_issues"),support_level:this.get("_overallSupportLevel")}},UpdateSystemReport:function(){g.Log("SystemChecker: Update readable system report");
for(var a=document.createElement("canvas"),e=["webgl","experimental-webgl","moz-webgl","webkit-3d"],b,d,c="",f=0;4>f&&!(b=a.getContext(e[f]),d=a.getContext(e[f],{failIfMajorPerformanceCaveat:!0}),b&&"function"==typeof b.getParameter);f++);if(null===b)confirm("This viewer could not be started since your browser does not support WebGL. Do you want to enable WebGL in your browser?")&&window.open("https://wiki.esko.com/pages/viewpage.action?pageId=170058865"),console.error("No WebGL support detected");
else{this.RunRenderTargetTests(b);for(var h in{3:3,1:1})c+=h;a="31"==c?"JSC":"V8";e=navigator.plugins.length;c="";for(f=0;f<e;f++)c+=navigator.plugins[f].name+", ";this.set("_glversion",b.getParameter(b.VERSION));this.set("_glshadinglanguage",b.getParameter(b.SHADING_LANGUAGE_VERSION));this.set("_glvendor",b.getParameter(b.VENDOR));this.set("_glrenderer",b.getParameter(b.RENDERER));this.set("_glantialias",b.getContextAttributes().antialias);this.set("_glstencilbits",b.getParameter(b.STENCIL_BITS));
this.set("_glmaxrenderbuffersize",b.getParameter(b.MAX_RENDERBUFFER_SIZE));this.set("_glmaxcombinedtextureimageunits",b.getParameter(b.MAX_COMBINED_TEXTURE_IMAGE_UNITS));this.set("_glmaxcubemaptexturesize",b.getParameter(b.MAX_CUBE_MAP_TEXTURE_SIZE));this.set("_glmaxfragmentuniformvectors",b.getParameter(b.MAX_FRAGMENT_UNIFORM_VECTORS));this.set("_glmaxtextureimageunits",b.getParameter(b.MAX_TEXTURE_IMAGE_UNITS));this.set("_glmaxtexturesize",b.getParameter(b.MAX_TEXTURE_SIZE));this.set("_glmaxvaryingvectors",
b.getParameter(b.MAX_VARYING_VECTORS));this.set("_dlmaxvertexattribs",b.getParameter(b.MAX_VERTEX_ATTRIBS));this.set("_glmaxvertextextureimageunits",b.getParameter(b.MAX_VERTEX_TEXTURE_IMAGE_UNITS));this.set("_glmaxvertexuniformvectors",b.getParameter(b.MAX_VERTEX_UNIFORM_VECTORS));this.set("_glmaxviewportdims",b.MAX_VIEWPORT_DIMS);this.set("_glaliasedlinewidthrange0",b.getParameter(b.ALIASED_LINE_WIDTH_RANGE)[0]);this.set("_glaliasedlinewidthrange1",b.getParameter(b.ALIASED_LINE_WIDTH_RANGE)[1]);
this.set("_glaliasedpointsizerange0",b.getParameter(b.ALIASED_POINT_SIZE_RANGE)[0]);this.set("_glaliasedpointsizerange1",b.getParameter(b.ALIASED_POINT_SIZE_RANGE)[1]);this.set("_gltexanistpyavail",b.getExtension("EXT_texture_filter_anisotropic")||b.getExtension("WEBKIT_EXT_texture_filter_anisotropic")||b.getExtension("MOZ_EXT_texture_filter_anisotropic"));this.get("_gltexanistpyavail")?this.set("_glmaxtexanistpy",b.getParameter(this.get("_gltexanistpyavail").MAX_TEXTURE_MAX_ANISOTROPY_EXT)):this.set("_glmaxtexanistpy",
"NA");this.set("_vshighfloatprecision",b.getShaderPrecisionFormat(b.VERTEX_SHADER,b.HIGH_FLOAT).precision);this.set("_vsmediumfloatprecision",b.getShaderPrecisionFormat(b.VERTEX_SHADER,b.MEDIUM_FLOAT).precision);this.set("_vslowfloatprecision",b.getShaderPrecisionFormat(b.VERTEX_SHADER,b.LOW_FLOAT).precision);this.set("_fshighfloatprecision",b.getShaderPrecisionFormat(b.FRAGMENT_SHADER,b.HIGH_FLOAT).precision);this.set("_fsmediumfloatprecision",b.getShaderPrecisionFormat(b.FRAGMENT_SHADER,b.MEDIUM_FLOAT).precision);
this.set("_fslowfloatprecision",b.getShaderPrecisionFormat(b.FRAGMENT_SHADER,b.LOW_FLOAT).precision);this.set("_fshighintprecision",b.getShaderPrecisionFormat(b.FRAGMENT_SHADER,b.HIGH_INT).rangeMax);b=this.get("_ua").os.family+"<BR/>"+this.get("_ua").browser.family+"<BR/>"+navigator.userAgent+"<BR/>CPU Cores# "+navigator.hardwareConcurrency+"<BR/>JavaScript Engine: "+a+"<BR/>GL_VERSION: "+this.get("_glversion")+"<BR/>SHADING_LANGUAGE_VERSION: "+this.get("_glshadinglanguage")+"<BR/>VENDOR: "+this.get("_glvendor")+
"<BR/>RENDERER: "+this.get("_glrenderer")+"<BR/>Anti-Aliasing: "+this.get("_glantialias")+"<BR/>Stencil Bits: "+this.get("_glstencilbits")+"<BR/>MajorPerformance Caveat: "+!d+"<BR/>MAX_RENDERBUFFER_SIZE: "+this.get("_glmaxrenderbuffersize")+"<BR/>MAX_COMBINED_TEXTURE_IMAGE_UNITS: "+this.get("_glmaxcombinedtextureimageunits")+"<BR/>MAX_CUBE_MAP_TEXTURE_SIZE: "+this.get("_glmaxcubemaptexturesize")+"<BR/>MAX_FRAGMENT_UNIFORM_VECTORS: "+this.get("_glmaxfragmentuniformvectors")+"<BR/>MAX_TEXTURE_IMAGE_UNITS: "+
this.get("_glmaxtextureimageunits")+"<BR/>MAX_TEXTURE_SIZE: "+this.get("_glmaxtexturesize")+"<BR/>MAX_VARYING_VECTORS: "+this.get("_glmaxvaryingvectors")+"<BR/>MAX_VERTEX_ATTRIBS: "+this.get("_dlmaxvertexattribs")+"<BR/>MAX_VERTEX_TEXTURE_IMAGE_UNITS: "+this.get("_glmaxvertextextureimageunits")+"<BR/>MAX_VERTEX_UNIFORM_VECTORS: "+this.get("_glmaxvertexuniformvectors")+"<BR/>MAX_VIEWPORT_DIMS: "+this.get("_glmaxviewportdims")+"<BR/>ALIASED_LINE_WIDTH_RANGE: "+this.get("_glaliasedlinewidthrange0")+
", "+this.get("_glaliasedlinewidthrange1")+"<BR/>ALIASED_POINT_SIZE_RANGE: "+this.get("_glaliasedpointsizerange0")+", "+this.get("_glaliasedpointsizerange1")+"<BR/>MAX_TEXTURE_ANISITROPY: "+this.get("_glmaxtexanistpy")+"<BR/>VERTEX_SHADER HIGH_FLOAT Precision: "+this.get("_vshighfloatprecision")+"<BR/>VERTEX_SHADER MEDIUM_FLOAT Precision: "+this.get("_vsmediumfloatprecision")+"<BR/>VERTEX_SHADER LOW_FLOAT Precision: "+this.get("_vslowfloatprecision")+"<BR/>FRAG_SHADER HIGH_FLOAT Precision: "+this.get("_fshighfloatprecision")+
"<BR/>FRAG_SHADER MEDIUM_FLOAT Precision: "+this.get("_fsmediumfloatprecision")+"<BR/>FRAG_SHADER LOW_FLOAT Precision: "+this.get("_fslowfloatprecision")+"<BR/>FRAG_SHADER HIGH_INT Precision: "+this.get("_fshighintprecision")+"<BR/>Supported EXTS: "+b.getSupportedExtensions()+"<BR/>Installed Plugins: "+c+"<BR/>Floating point texture support: "+this.get("_fullSupportFloatingPointTextures")+"<BR/>Half Floating point texture support: "+this.get("_fullSupportHFloatingPointTextures");this.set("_systemReport",
b)}},RunRenderTargetTests:function(a){function e(a,b){for(var d in a)if(a[d]===b)return d;return"0x"+b.toString(16)}function b(a,b,d){a=a.getExtension(b);g.Log("SystemChecker "+(a?"can ":"can **NOT** ")+d);return a}function d(b){var c=a.createTexture();a.bindTexture(a.TEXTURE_2D,c);a.texImage2D(a.TEXTURE_2D,0,a.RGBA,1,1,0,a.RGBA,b,null);a.texParameteri(a.TEXTURE_2D,a.TEXTURE_MIN_FILTER,a.NEAREST);a.texParameteri(a.TEXTURE_2D,a.TEXTURE_MAG_FILTER,a.NEAREST);var f=a.createFramebuffer();a.bindFramebuffer(a.FRAMEBUFFER,
f);a.framebufferTexture2D(a.FRAMEBUFFER,a.COLOR_ATTACHMENT0,a.TEXTURE_2D,c,0);if(a.checkFramebufferStatus(a.FRAMEBUFFER)!==a.FRAMEBUFFER_COMPLETE)g.Log("SystemChecker can **NOT** render to "+e(a,b)+" texture");else{a.bindTexture(a.TEXTURE_2D,l);a.uniform4fv(m,[0,10,20,1]);a.drawArrays(a.TRIANGLES,0,6);a.bindTexture(a.TEXTURE_2D,c);a.bindFramebuffer(a.FRAMEBUFFER,null);a.clearColor(1,0,0,1);a.clear(a.COLOR_BUFFER_BIT);a.uniform4fv(m,[0,0.1,0.05,1]);a.drawArrays(a.TRIANGLES,0,6);c=new Uint8Array(4);
a.readPixels(0,0,1,1,a.RGBA,a.UNSIGNED_BYTE,c);if(0!==c[0]||248>c[1]||248>c[2]||254>c[3])return g.Log("SystemChecker was not able to actually render to "+e(a,b)+" texture"),!1;g.Log("SystemChecker succesfully rendered to "+e(a,b)+" texture");return!0}}var c=b(a,"OES_texture_float","make floating point textures");b(a,"OES_texture_float_linear","linear filter floating point textures");var f=b(a,"OES_texture_half_float","make half floating point textures");b(a,"OES_texture_half_float_linear","linear filter half floating point textures");
a.HALF_FLOAT_OES=36193;var h=a.createProgram(),i=a.createShader(a.FRAGMENT_SHADER),j=a.createShader(a.VERTEX_SHADER);a.shaderSource(j," attribute vec4 a_position;                            void main()                            {                              gl_Position = a_position;                            }");a.shaderSource(i,"  precision mediump float;                              uniform vec4 u_color;                              uniform sampler2D u_texture;                              void main()                              {                                gl_FragColor = texture2D(u_texture, vec2(0.5, 0.5)) * u_color;                              }");
a.compileShader(j);a.compileShader(i);a.attachShader(h,j);a.attachShader(h,i);a.linkProgram(h);a.useProgram(h);var i=a.getAttribLocation(h,"a_position"),m=a.getUniformLocation(h,"u_color"),h=a.createBuffer();a.bindBuffer(a.ARRAY_BUFFER,h);a.bufferData(a.ARRAY_BUFFER,new Float32Array([-1,-1,1,-1,-1,1,-1,1,1,-1,1,1]),a.STATIC_DRAW);a.enableVertexAttribArray(i);a.vertexAttribPointer(i,2,a.FLOAT,!1,0,0);var l=a.createTexture();a.bindTexture(a.TEXTURE_2D,l);a.texImage2D(a.TEXTURE_2D,0,a.RGBA,1,1,0,a.RGBA,
a.UNSIGNED_BYTE,new Uint8Array([255,255,255,255]));this.set("_fullSupportFloatingPointTextures",c&&d(a.FLOAT));this.set("_fullSupportHFloatingPointTextures",f&&d(a.HALF_FLOAT_OES))},GetSystemReport:function(){g.Log("SystemChecker: Get readable system report");return this.get("_systemReport")},IsWindows:function(){return-1!=this.get("_ua").os.family.search("Windows")},IsMac:function(){return-1!=this.get("_ua").os.family.search("Mac")},IsiOSFirstGen:function(){return-1!=this.get("_ua").os.family.search("iOS")&&
-1!=this.get("_glversion").search("SGX")},IsiOSSecondGen:function(){return-1!=this.get("_ua").os.family.search("iOS")&&-1==this.get("_glversion").search("SGX")},IsiPad:function(){return-1!=this.get("_ua").os.family.search("iPad")||-1!=this.get("_ua").source.search("iPad")},IsiPod:function(){return-1!=this.get("_ua").os.family.search("iPod")||-1!=this.get("_ua").source.search("iPod")},IsiPhone:function(){return-1!=this.get("_ua").os.family.search("iPhone")||-1!=this.get("_ua").source.search("iPhone")&&
-1==this.get("_ua").source.search("iPod")},IsAndroid:function(){return-1!=this.get("_ua").os.family.search("Android")},IsIE:function(){return-1!=this.get("_ua").browser.family.search("IE")},IsFirefox:function(){return-1!=this.get("_ua").browser.family.search("Firefox")},IsChrome:function(){return-1!=this.get("_ua").browser.family.search("Chrome")},IsSafari:function(){return-1!=this.get("_ua").browser.family.search("Safari")},ControllerTestFunction:function(){g.Log("Controller Test function");this.get("_model").ModelTestFunction()},
ControllerTestFunction2:function(){g.Log("Controller Test function 2 ")}}))});