/**
 * @author DOGO
 * @module WebViewer3D
 * @copyright 2017 Esko Software BVBA. All rights reserved.
 */

define("underscore backbone WV3Dlib/three WV3Dmod/LogMessage WV3Dmod/Constants WV3Dmod/Math WV3Dmod/Utils".split(" "),function(x,v,j,s,p,t,w){var u=function(a){var c=!0;if(a.image.naturalHeight>p.textureSupport.MAX_NATURAL_HEIGHT||a.image.naturalWidth>p.textureSupport.MAX_NATURAL_WIDTH)this.get("_TextureSizeWarningMessageDisplayed")?c=this.get("_TextureSizeByPass"):(c=window.confirm("WARNING ! Some textures have a size greater than "+p.textureSupport.MAX_NATURAL_WIDTH+"x"+p.textureSupport.MAX_NATURAL_HEIGHT+
". This might not be supported by your system and you might experience browser or graphics card crashes."),this.set("_TextureSizeWarningMessageDisplayed",!0),this.set("_TextureSizeByPass",c));return c},r=function(a,c){for(var b=[],f=0,d=Object.keys(c),i=d.length;f<i;++f)b.push(a+c[d[f]]);return b};return v.Model.extend({initialize:function(a,c,b){s.Log("Creating WV3DTextureManager Object");this.set("_renderercache",a);this.set("_assetmanager",c);this.set("_exec_queue",b)},Reset:function(){this.set("_QueriedGlobalTextures",
!1);this.set("_TextureSizeWarningMessageDisplayed",!1);this.set("_TextureSizeByPass",!0)},StartAsyncTextureLoad:function(a,c,b,f,d,i,h,k){if(c.front.hasOwnProperty(b)&&c.front[b]&&a.hasOwnProperty(c.front[b])){var e=a[c.front[b]],g=e.Properties.hasOwnProperty("remapped_alpha_channel")?w.ToBool(e.Properties.remapped_alpha_channel):!1,m=function(a){this.get("_exec_queue").whenFinished(function(){this.get("_assetmanager").IncrementTextureLoadCounter();if(u(a)&&d){var b,c;b=c=1;d.hasOwnProperty("originalTexWidth")&&
(b=(d.originalTexWidth-1)/a.image.naturalWidth);d.hasOwnProperty("originalTexHeight")&&(c=(d.originalTexHeight-1)/a.image.naturalHeight);a.repeat.set(b,c);a.remappedAlphaChannel=g;d[f]=a;this.trigger("updatetexturedmaterial",{mat_struct:d});this.trigger("render")}this.trigger("check_post_scene_load_actions")},this)}.bind(this),n=function(){this.get("_exec_queue").whenFinished(function(){this.get("_assetmanager").IncrementTextureLoadCounter();this.trigger("resource_query_error",{errorCode:2,message:"Texture: "+
b})},this)}.bind(this),l;l=this.get("_assetmanager").get("_assetloader").get("_httprequestmanager").IsAbsoluteURL(e.Properties.filepath)?e.Properties.filepath:i+e.Properties.filepath;a=function(a){var b=new j.TextureLoader;b.crossOrigin="";a=b.load(a,function(a){m(a)},void 0,n);a.name=l;a.format=h;a.unpackAlignment=k;a.anisotropy=16;b=e.Properties;b.hasOwnProperty("original_width")&&(d.originalTexWidth=parseFloat(b.original_width));b.hasOwnProperty("original_height")&&(d.originalTexHeight=parseFloat(b.original_height));
switch(b.swrap){default:case "GL_REPEAT":a.wrapS=j.RepeatWrapping;break;case "GL_CLAMP":case "GL_CLAMP_TO_BORDER":case "GL_CLAMP_TO_EDGE":a.wrapS=j.ClampToEdgeWrapping}switch(b.twrap){default:case "GL_REPEAT":a.wrapT=j.RepeatWrapping;break;case "GL_CLAMP":case "GL_CLAMP_TO_BORDER":case "GL_CLAMP_TO_EDGE":a.wrapT=j.ClampToEdgeWrapping}}.bind(this);this.get("_assetmanager").IncrementTextureQueryCounter(1);this.get("_assetmanager").GetURLPreprocessCallback()(l,a);this.get("_renderercache").get("textures").FromFile.hasOwnProperty(l)||
(this.get("_renderercache").get("textures").FromFile[l]=null);return!0}return!1},LoadGlobalLightingTextures:function(){if(!this.get("_QueriedGlobalTextures")){var a=this.get("_assetmanager").get("_resourcePath")+"/"+this.get("_renderercache").get("textures")[this.get("_renderercache").get("_RenderingQuality")].path;this.get("_renderercache").get("materials").enableirradiancemap&&this.StartAsyncGlobalTextureLoad("irradiancemap",a);this.get("_renderercache").get("materials").enableenvmap&&this.StartAsyncGlobalTextureLoad("envmap",
a);this.set("_QueriedGlobalTextures",!0)}},StartAsyncGlobalTextureLoad:function(a,c){var b=function(a){this.get("_assetmanager").IncrementTextureLoadCounter();u(a)&&this.trigger("render");this.trigger("check_post_scene_load_actions")}.bind(this),f=function(c){this.get("_exec_queue").whenFinished(function(){this.get("_renderercache").get("textures")[this.get("_renderercache").get("_RenderingQuality")][a].loaded=!0;this.trigger("updatematerialsgloballighting");b(c)},this)}.bind(this),d=function(a){this.get("_exec_queue").whenFinished(function(){this.get("_renderercache").get("textures")[this.get("_renderercache").get("_RenderingQuality")].envmap.glossy.loaded=
!0;this.trigger("updatematerialsgloballighting");b(a)},this)}.bind(this),i=function(a){this.get("_exec_queue").whenFinished(function(){this.get("_renderercache").get("textures")[this.get("_renderercache").get("_RenderingQuality")].envmap.matte.loaded=!0;this.trigger("updatematerialsgloballighting");b(a)},this)}.bind(this),h=function(){this.get("_exec_queue").whenFinished(function(){this.get("_assetmanager").IncrementTextureLoadCounter();this.trigger("resource_query_error",{errorCode:2,message:"Texture: "+
a})},this)}.bind(this),k=function(a,b,c,e){for(var d=[],g=function(g){d.push(g);if(d.length==a.length)switch(g=(new j.CubeTextureLoader).load(d,e,void 0,h),g.format=j.RGBFormat,b){case "irradiancemap":this.get("_renderercache").get("textures")[this.get("_renderercache").get("_RenderingQuality")][b].data=g;break;case "envmap":switch(this.get("_renderercache").get("_RenderingQuality")){case "Designer":this.get("_renderercache").get("textures")[this.get("_renderercache").get("_RenderingQuality")][b][c].data=
g;break;case "Visualizer":this.get("_renderercache").get("textures")[this.get("_renderercache").get("_RenderingQuality")][b].data[c]=g}}}.bind(this),f=0,i=Object.keys(a),k=a.length;f<k;++f)this.get("_assetmanager").GetURLPreprocessCallback()(a[i[f]],g)}.bind(this);switch(a){case "irradiancemap":var e=this.get("_renderercache").get("textures")[this.get("_renderercache").get("_RenderingQuality")],i=r(c,e[a].files);k(i,a,null,f);this.get("_assetmanager").IncrementTextureQueryCounter(1);break;case "envmap":switch(this.get("_renderercache").get("_RenderingQuality")){case "Designer":var e=
this.get("_renderercache").get("textures")[this.get("_renderercache").get("_RenderingQuality")],g=r(c,e[a].glossy.files);k(g,a,"glossy",d);d=r(c,e[a].matte.files);k(d,a,"matte",i);this.get("_assetmanager").IncrementTextureQueryCounter(2);break;case "Visualizer":e=this.get("_renderercache").get("textures")[this.get("_renderercache").get("_RenderingQuality")];e[a].data={};e[a].loaded={};i=function(d){var g=function(c){this.get("_exec_queue").whenFinished(function(){e[a].loaded[d]=!0;this.trigger("updatematerialsgloballighting");
b(c)},this)}.bind(this),f=r(c,e[a].files.slice(6*d,6*(d+1)));k(f,a,d,g)}.bind(this);for(d=0;5>d;++d)i(d);this.get("_assetmanager").IncrementTextureQueryCounter(5)}break;case "spectrum":var e=this.get("_renderercache").get("textures")[this.get("_renderercache").get("_RenderingQuality")],m=c+e[a].file,i=function(b){b=(new j.TextureLoader).load(b,f,void 0,h);b.format=j.RGBFormat;b.name=m;e[a].data=b}.bind(this);this.get("_assetmanager").IncrementTextureQueryCounter(1);this.get("_assetmanager").GetURLPreprocessCallback()(m,
i);break;case "backdrop":this.get("_assetmanager").IncrementTextureQueryCounter(1);this.get("_assetmanager").GetURLPreprocessCallback()(c,this.BackdropQueryCallback(c,b));break;default:s.Log("ViewerView Warning: Unhandled global texture type !")}},BackdropQueryCallback:function(a,c){var b=this.get("_renderercache").get("textures").backdrop;return function(f){var d=function(a){this.get("_exec_queue").whenFinished(function(){b.loaded=!0;b.original_width||(b.original_width=a.width);b.original_height||
(b.original_height=a.height);c(a)},this)}.bind(this),i=function(){this.get("_exec_queue").whenFinished(function(){this.get("_assetmanager").IncrementTextureLoadCounter();this.trigger("resource_query_error",{errorCode:2,message:"Texture: "+f})},this)}.bind(this),h=new j.TextureLoader;h.crossOrigin="";d=h.load(a,d,void 0,i);d.format=j.RGBFormat;d.name=a;b.enabled=!0;b.data=d}.bind(this)},LoadBackdrop:function(a,c){if(a.Properties.hasOwnProperty("backdrop")){var b=a.Assets[a.Properties.backdrop.image_tex].Properties,
f;f=this.get("_assetmanager").get("_assetloader").get("_httprequestmanager").IsAbsoluteURL(b.filepath)?b.filepath:c.substring(0,c.lastIndexOf("/")+1)+b.filepath;this.StartAsyncGlobalTextureLoad("backdrop",f);this.get("_renderercache").get("textures").backdrop.original_height=b.original_height;this.get("_renderercache").get("textures").backdrop.original_width=b.original_width}},SetBackdropTexture:function(a,c,b){var f=function(a){(void 0===b||b)&&this.trigger("render");c(arguments)}.bind(this),d=this.get("_renderercache").get("textures").backdrop;
d.original_width=null;d.original_height=null;this.get("_assetmanager").GetURLPreprocessCallback()(a,this.BackdropQueryCallback(a,f))},ReloadAllTextures:function(a,c){for(var b=0,f=0,d=Object.keys(this.get("_renderercache").get("textures").FromFile),i=d.length;f<i;++f){var h=d[f],j=function(){++b;b==i&&((void 0===c||c)&&this.trigger("render"),"function"==typeof a&&a())}.bind(this);this.ReloadTexture(h,h,j,!0,!1)}},ReloadTexture:function(a,c,b,f,d){var i=function(a,c){for(var f=this.get("_renderercache").get("materials"),
h=0,i=Object.keys(f.materiallist),j=i.length;h<j;++h){var k=f.materiallist[i[h]].front,p={mat_struct:k,texture_URL:a,new_texture:c};this.trigger("updatematerialtexture",{mat_struct:k,texture_URL:a,new_texture:c});this.trigger("updatematerialtexture",p)}(void 0===d||d)&&this.trigger("render");"function"==typeof b&&b()}.bind(this),h=function(){this.get("_exec_queue").whenFinished(function(){this.get("_assetmanager").IncrementTextureLoadCounter();this.trigger("resource_query_error",{errorCode:2,message:"Texture: "+
c})},this)}.bind(this),k=function(b){var d=new j.TextureLoader;d.crossOrigin="";d.load(b,function(b){i(a,b)},void 0,h).name=f||void 0==f?a:c}.bind(this);this.get("_assetmanager").GetURLPreprocessCallback()(c+"?t="+(new Date).getTime(),k)},UpdateAnnotationsTexture:function(a,c,b){for(var f=[],d=0,i=0,h=0;h<b;++h)for(var k=h/b,e=(h+1)/b,g=0;g<b;++g){for(var m=g/b,n=(g+1)/b,l=[],q=0;q<c.length;q++)t.IntersectCellSegment({left:k,right:e,bottom:m,top:n},c[q])&&l.push({lineIdx:q,segment:c[q]});f.push(l);
1<l.length&&(d+=l.length,l.length>i&&(i=l.length))}b=t.nextHighestPowerOfTwo(Math.ceil(Math.sqrt(b*b+d+c.length)));k=b*b;e=a.annotationTextureSize!==k?new Float32Array(4*k):a.annotationsTexture.image.data;for(h=m=0;h<f.length;h++)if(g=4*h,l=f[h],e[g]=l.length,1<l.length){var n=Math.floor(m/65535),q=Math.floor((m-65535*n)/255),p=Math.floor(m-65535*n-255*q);e[g+1]=n;e[g+2]=q;e[g+3]=p;for(g=0;g<l.length;g++)n=4*(f.length+m+g),e[n]=l[g].lineIdx,e[n+1]=-1,e[n+2]=-1,e[n+3]=-1;m+=l.length}else e[g+1]=1==
l.length?l[0].lineIdx:-1,e[g+2]=-1,e[g+3]=-1;for(h=0;h<c.length;h++)g=4*(f.length+d+h),e[g]=c[h].startU,e[g+1]=c[h].startV,e[g+2]=c[h].endU,e[g+3]=c[h].endV;a.annotationTextureSize!==k&&(a.annotationsTexture&&a.annotationsTexture.dispose(),a.annotationsTexture=new j.DataTexture(e,b,b,j.RGBAFormat,j.FloatType,j.UVMapping,j.RepeatWrapping,j.RepeatWrapping,j.NearestFilter,j.NearestFilter),a.annotationTextureSize=k);a.annotationsTexture.needsUpdate=!0;return{textureSize:b,maxLinesPerCell:i,linesStartOffset:f.length+
d}}})});