/**

 * @author DOGO

 * @module WebViewer3D

 * @copyright   2015 Esko Stonecube Ltd. All rights reserved.

 */

define(["WV3Dlib/three","WV3Dmod/shaders/ShaderUtils"],function(a,b){return{uniforms:a.UniformsUtils.merge([a.UniformsLib.common,a.UniformsLib.specularmap,a.UniformsLib.envmap,a.UniformsLib.lights,{annotationsTexture:{type:"t",value:null},annotationsAspectRatio:{type:"v2",value:new a.Vector2(1,1)},annotationsThickness:{type:"f",value:1},annotationsColor:{type:"v3",value:new a.Vector3(1,0,0)},irr_tex:{type:"t",value:null},isFloorReflection:{type:"i",value:0},envMapRotQuat:{type:"v4",value:new a.Vector4(0,
0,0,1)},offsetRepeat:{type:"v4",value:new a.Vector4(0,0,1,1)},emissive:{type:"c",value:new a.Color(0)},specular:{type:"c",value:new a.Color(1118481)},shininess:{type:"1f",value:30}}]),vertexShader:"            attribute vec3 inst_translation;\n            attribute vec4 inst_rotation;\n            attribute vec3 inst_scale;\n            varying vec3 vViewPosition;\n            varying vec3 vNormal;\n            varying vec2 texcoordVarying;\n            uniform vec4 offsetRepeat;\n            #if defined(USE_IRRMAP) || defined(USE_ENVMAP)\n                varying vec3 vWorldPosition;\n            #endif\n            varying vec3 vColor;\n            void main() {\n                texcoordVarying = uv * offsetRepeat.zw + offsetRepeat.xy;\n                vColor.xyz = color.xyz;\n                vec3 objectNormal = vec3( normal );\n                #ifdef FLIP_SIDED\n                    objectNormal = -objectNormal;\n                #endif\n                vec3 vcV = cross(inst_rotation.xyz, objectNormal.xyz / inst_scale);\n                vec3 rotated_normal = vcV * (2.0 * inst_rotation.w) + (cross(inst_rotation.xyz, vcV) * 2.0 + objectNormal.xyz); \n                vec3 transformedNormal = mat3(normalMatrix) * rotated_normal;\n                vec3 transformedNormalIrr = mat3(modelMatrix) * rotated_normal;\n                #ifndef FLAT_SHADED\n                   vNormal = normalize( transformedNormal );\n                #endif\n                vec3 transformed = vec3( position );\n                vec4 worldPosition = vec4( transformed, 1.0 );\n                worldPosition = worldPosition * vec4(inst_scale,1.0);\n                vcV = cross(inst_rotation.xyz, worldPosition.xyz);\n                vec3 vPosition = vcV * (2.0 * inst_rotation.w) + (cross(inst_rotation.xyz, vcV) * 2.0 + worldPosition.xyz);\n                worldPosition = modelMatrix * vec4(vPosition + inst_translation,1.0);\n                vec4 mvPosition = viewMatrix * worldPosition;\n                gl_Position = projectionMatrix * mvPosition;\n                vViewPosition = - mvPosition.xyz;\n                #if defined(USE_IRRMAP) || defined(USE_ENVMAP)\n                    vWorldPosition = worldPosition.xyz;\n                #endif\n            }\n",
fragmentShader:["#define PHONG\n",b.get("EnvironmentRotationChunck"),"#if ANNOTATION_NUMBER\nuniform sampler2D annotationsTexture;\nuniform vec2 annotationsAspectRatio;\nuniform float annotationsThickness;\nuniform vec3 annotationsColor;\n#endif",b.get("SegmentDistance"),"uniform vec3 diffuse;\n            uniform vec3 emissive;\n            uniform vec3 specular;\n            uniform float shininess;\n            uniform float opacity;\n            uniform bool isFloorReflection;\n            uniform vec4 envMapRotQuat;\n            varying vec3 vNormalIrr;\n            #ifdef USE_IRRMAP\n\n                uniform samplerCube irr_tex;\n            #endif\n                        #define PI 3.14159265359\n            #define RECIPROCAL_PI 0.31830988618\n            struct IncidentLight {\n                vec3 color;\n                vec3 direction;\n                bool visible;\n            };\n            struct ReflectedLight {\n                vec3 directDiffuse;\n                vec3 directSpecular;\n                vec3 indirectDiffuse;\n                vec3 indirectSpecular;\n            };\n            struct GeometricContext {\n                vec3 position;\n                vec3 normal;\n                vec3 viewDir;\n            };\n            vec3 transformDirection( in vec3 dir, in mat4 matrix ) {\n                return normalize( ( matrix * vec4( dir, 0.0 ) ).xyz );\n            }\n            vec3 inverseTransformDirection( in vec3 dir, in mat4 matrix ) {\n                return normalize( ( vec4( dir, 0.0 ) * matrix ).xyz );\n            }\n                        varying vec3 vColor;\n            varying vec2 texcoordVarying;\n            #ifdef USE_MAP\n                uniform sampler2D map;\n            #endif\n            \n            #if defined( USE_ENVMAP )\n                uniform float reflectivity;\n                uniform float envMapIntenstiy;\n            #endif\n            #if defined(USE_IRRMAP) || defined(USE_ENVMAP)\n                varying vec3 vWorldPosition;\n                uniform float flipEnvMap;\n            #endif\n            #ifdef USE_ENVMAP\n                uniform samplerCube envMap;\n            #endif\n            \n            vec3 BRDF_Diffuse_Lambert( const in vec3 diffuseColor ) {\n                return RECIPROCAL_PI * diffuseColor;\n            }\n            vec3 F_Schlick( const in vec3 specularColor, const in float dotLH ) {\n                float fresnel = exp2( ( -5.55473 * dotLH - 6.98316 ) * dotLH );\n                return ( 1.0 - specularColor ) * fresnel + specularColor;\n            }\n            float G_BlinnPhong_Implicit( ) {\n                return 0.25;\n            }\n            float D_BlinnPhong( const in float shininess, const in float dotNH ) {\n                return RECIPROCAL_PI * ( shininess * 0.5 + 1.0 ) * pow( dotNH, shininess );\n            }\n            vec3 BRDF_Specular_BlinnPhong( const in IncidentLight incidentLight, const in GeometricContext geometry, const in vec3 specularColor, const in float shininess ) {\n                vec3 halfDir = normalize( incidentLight.direction + geometry.viewDir );\n                float dotNH = saturate( dot( geometry.normal, halfDir ) );\n                float dotLH = saturate( dot( incidentLight.direction, halfDir ) );\n                vec3 F = F_Schlick( specularColor, dotLH );\n                float G = G_BlinnPhong_Implicit( );\n                float D = D_BlinnPhong( shininess, dotNH );\n                return F * ( G * D );\n            }\n            \n            uniform vec3 ambientLightColor;\n            vec3 getAmbientLightIrradiance( const in vec3 ambientLightColor ) {\n                vec3 irradiance = ambientLightColor;\n                irradiance *= PI;\n                return irradiance;\n            }\n            #if NUM_DIR_LIGHTS > 0\n             struct DirectionalLight {\n                vec3 direction;\n                vec3 color;\n                int shadow;\n                float shadowBias;\n                float shadowRadius;\n                vec2 shadowMapSize;\n             };\n             uniform DirectionalLight directionalLights[ NUM_DIR_LIGHTS ];\n             void getDirectionalDirectLightIrradiance( const in DirectionalLight directionalLight, const in GeometricContext geometry, out IncidentLight directLight ) {\n                directLight.color = directionalLight.color;\n                directLight.direction = directionalLight.direction;\n                directLight.visible = true;\n             }\n            #endif\n                        varying vec3 vViewPosition;\n            #ifndef FLAT_SHADED\n                varying vec3 vNormal;\n            #endif\n            struct BlinnPhongMaterial {\n                vec3  diffuseColor;\n                vec3  specularColor;\n                float specularShininess;\n                float specularStrength;\n            };\n            void RE_Direct_BlinnPhong( const in IncidentLight directLight, const in GeometricContext geometry, const in BlinnPhongMaterial material, inout ReflectedLight reflectedLight ) {\n                float dotNL = saturate( dot( geometry.normal, directLight.direction ) );\n                vec3 irradiance = dotNL * directLight.color;\n                irradiance *= PI;\n                reflectedLight.directDiffuse += irradiance * BRDF_Diffuse_Lambert( material.diffuseColor );\n                reflectedLight.directSpecular += irradiance * BRDF_Specular_BlinnPhong( directLight, geometry, material.specularColor, material.specularShininess ) * material.specularStrength;\n            }\n            void RE_IndirectDiffuse_BlinnPhong( const in vec3 irradiance, const in GeometricContext geometry, const in BlinnPhongMaterial material, inout ReflectedLight reflectedLight ) {\n                reflectedLight.indirectDiffuse += irradiance * BRDF_Diffuse_Lambert( material.diffuseColor );\n            }\n                        #ifdef USE_SPECULARMAP\n                uniform sampler2D specularMap;\n            #endif\n            void main() {\n\nvec4 reflResult;",
b.get("AnnotationDrawing"),"#if ANNOTATION_NUMBER\nif(!annotated){\n#endif\nvec4 diffuseColor = vec4( diffuse, opacity );\n                ReflectedLight reflectedLight = ReflectedLight( vec3( 0.0 ), vec3( 0.0 ), vec3( 0.0 ), vec3( 0.0 ) );\n                vec3 totalEmissiveRadiance = emissive;\n                \n                #ifdef USE_MAP\n                    vec4 texelColor = texture2D( map, texcoordVarying );\n                    texelColor = mapTexelToLinear( texelColor );\n                    diffuseColor *= texelColor;\n                #endif\n                \n                #ifdef USE_COLOR\n                    diffuseColor.rgb *= vColor;\n                #endif\n                \n                float specularStrength;\n                #ifdef USE_SPECULARMAP\n                    vec4 texelSpecular = texture2D( specularMap, texcoordVarying );\n                    specularStrength = texelSpecular.r;\n                #else\n                    specularStrength = 1.0;\n                #endif\n                #ifdef FLAT_SHADED\n                    vec3 fdx = vec3( dFdx( vViewPosition.x ), dFdx( vViewPosition.y ), dFdx( vViewPosition.z ) );\n                    vec3 fdy = vec3( dFdy( vViewPosition.x ), dFdy( vViewPosition.y ), dFdy( vViewPosition.z ) );\n                    vec3 normal = normalize( cross( fdx, fdy ) );\n                #else\n                    vec3 normal = normalize( vNormal );\n                    #ifdef DOUBLE_SIDED\n                        normal = normal * ( -1.0 + 2.0 * float( gl_FrontFacing ) );\n                    #endif\n                #endif\n                \n                BlinnPhongMaterial material;\n                material.diffuseColor = diffuseColor.rgb;\n                material.specularColor = specular;\n                material.specularShininess = shininess;\n                material.specularStrength = specularStrength;\n                \n                #if defined(USE_IRRMAP) || defined(USE_ENVMAP)\n                    vec3 cameraToVertex = normalize( vWorldPosition - cameraPosition );\n                    vec3 worldNormal = inverseTransformDirection( normal, viewMatrix );\n                    vec3 reflectVec = reflect( cameraToVertex, worldNormal );\n                    if(isFloorReflection)\n                    {\n                        worldNormal.x = -worldNormal.x;\n                        worldNormal.z = -worldNormal.z;\n                        reflectVec.y = -reflectVec.y;\n                    }\n                    worldNormal = rotate_vec_from_quat(envMapRotQuat, worldNormal);\n                    reflectVec = rotate_vec_from_quat(envMapRotQuat, reflectVec);\n                    #ifdef DOUBLE_SIDED\n                        float flipNormal = ( float( gl_FrontFacing ) * 2.0 - 1.0 );\n                    #else\n                        float flipNormal = 1.0;\n                    #endif\n                #else\n                    vec3 worldNormal = normal;\n                #endif\n                GeometricContext geometry;\n                geometry.position = - vViewPosition;\n                geometry.normal = normal;\n                geometry.viewDir = normalize( vViewPosition );\n                IncidentLight directLight;\n                #if ( NUM_DIR_LIGHTS > 0 ) \n                    DirectionalLight directionalLight;\n                    for ( int i = 0; i < NUM_DIR_LIGHTS; i ++ ) {\n                        directionalLight = directionalLights[ i ];\n                        getDirectionalDirectLightIrradiance( directionalLight, geometry, directLight );\n                        RE_Direct_BlinnPhong( directLight, geometry, material, reflectedLight );\n                    }\n                #endif\n                    vec3 irradiance = getAmbientLightIrradiance( ambientLightColor );\n                    #ifdef USE_IRRMAP\n                        #ifdef DOUBLE_SIDED\n                            vec3 cubeIrrColor = textureCube( irr_tex, flipNormal * vec3( flipEnvMap * worldNormal.x, worldNormal.yz ) ).rgb;\n                        #else\n                            vec3 cubeIrrColor = textureCube( irr_tex, vec3( flipEnvMap * worldNormal.x, worldNormal.yz ) ).rgb;\n                        #endif\n                    irradiance += cubeIrrColor;\n                    #endif\n                    RE_IndirectDiffuse_BlinnPhong( irradiance, geometry, material, reflectedLight );\n                \n                vec3 outgoingLight =  reflectedLight.directDiffuse + reflectedLight.indirectDiffuse + reflectedLight.directSpecular + reflectedLight.indirectSpecular + totalEmissiveRadiance;\n                #ifdef USE_ENVMAP\n                    vec4 envColor = textureCube( envMap, flipNormal * vec3( flipEnvMap * reflectVec.x, reflectVec.yz ) );\n                    envColor = envMapTexelToLinear( envColor );\n                    #ifdef ENVMAP_BLENDING_MULTIPLY\n                        outgoingLight = mix( outgoingLight, outgoingLight * envColor.xyz, specularStrength * reflectivity );\n                    #elif defined( ENVMAP_BLENDING_MIX )\n                        outgoingLight = mix( outgoingLight, envColor.xyz, specularStrength * reflectivity );\n                    #elif defined( ENVMAP_BLENDING_ADD )\n                        outgoingLight += envColor.xyz * specular * specularStrength * reflectivity;\n                    #endif\n                #endif\n                gl_FragColor.rgba = vec4( outgoingLight, diffuseColor.a );\n\n#if ANNOTATION_NUMBER\n}\nelse gl_FragColor = vec4(reflResult.rgb,1.0);\n#endif\n}\n"].join("\n")}});