/**
 * @author DOGO
 * @contributor SVN
 * @module WebViewer3D
 * @copyright   2015 Esko Stonecube Ltd. All rights reserved.
 */

define(["WV3Dlib/three","backbone","WV3Dmod/SystemChecker","WV3Dmod/LogMessage"],function(c,f,b,a){var c=["depth = floor(depth * 255.) * 0.003921568627450980392156862745098;"],d,e;a.Log("Configuration set up for:");b.get("_fullSupportFloatingPointTextures")?b.IsWindows()?(a.Log("Windows"),b.IsIE()?(a.Log("IE"),c=d=e="",b="vec4 EncodeFloatRGBA( float v ) {\nreturn vec4(v, 0., 0., 0.);\n}",a="float DecodeFloatRGBA( vec4 rgba ) {\nreturn rgba.r;\n}"):(a.Log("Not IE"),c=d=e=c,b="vec4 EncodeFloatRGBA( float v ) {\nfloat remainder = v;\nvec4 res, r;\nres[0] = floor(remainder * 255.0) / 255.0;\nremainder -= res[0];\nres[1] = floor(remainder * 65535.0) / 65535.0;\nremainder -= res[1];\nres[2] = floor(remainder * 16777215.0) / 16777215.0;\nr[0] = clamp(floor((v) * 255.0),0.,255.);\nr[1] = clamp(floor((v - res[0]) * 65535.0),0.,255.);\nr[2] = clamp(floor((v - res[0] - res[1]) * 16777215.0),0.,255.);\nr[3] = clamp(floor((v - res[0] - res[1] - res[2]) * 4294967295.0),0.,255.);\nr[0] = r[0] / 255.0;\nr[1] = r[1] / 255.0;\nr[2] = r[2] / 255.0;\nr[3] = r[3] / 255.0;\nreturn r;\n}",
a="float DecodeFloatRGBA( vec4 rgba ) {\nreturn dot( rgba, vec4(1.0, 1./255., 1./65535., 1./16777215.) );\n}")):b.IsMac()?(a.Log("Mac"),c=d=e="",b="vec4 EncodeFloatRGBA( float v ) {\nreturn vec4(v, 0., 0., 0.);\n}",a="float DecodeFloatRGBA( vec4 rgba ) {\nreturn rgba.r;\n}"):(a.Log("Unsupported OS (for now): "+b.get("_ua").os.family+" / "+b.get("_ua").browser.family),c=d=e=c,b="vec4 EncodeFloatRGBA( float v ) {\nfloat remainder = v;\nvec4 res, r;\nres[0] = floor(remainder * 255.0) / 255.0;\nremainder -= res[0];\nres[1] = floor(remainder * 65535.0) / 65535.0;\nremainder -= res[1];\nres[2] = floor(remainder * 16777215.0) / 16777215.0;\nr[0] = clamp(floor((v) * 255.0),0.,255.);\nr[1] = clamp(floor((v - res[0]) * 65535.0),0.,255.);\nr[2] = clamp(floor((v - res[0] - res[1]) * 16777215.0),0.,255.);\nr[3] = clamp(floor((v - res[0] - res[1] - res[2]) * 4294967295.0),0.,255.);\nr[0] = r[0] / 255.0;\nr[1] = r[1] / 255.0;\nr[2] = r[2] / 255.0;\nr[3] = r[3] / 255.0;\nreturn r;\n}",
a="float DecodeFloatRGBA( vec4 rgba ) {\nreturn dot( rgba, vec4(1.0, 1./255., 1./65535., 1./16777215.) );\n}"):(b.IsAndroid()?(a.Log("Android"),c=d=e=""):b.IsiOSFirstGen()?(a.Log("iOS First Generation"),c=d=e=c):(a.Log("Default Mobile Device"),c=d=e=""),b="vec4 EncodeFloatRGBA( float v ) {\nfloat remainder = v;\nvec4 res, r;\nres[0] = floor(remainder * 127.0) / 127.0;\nremainder -= res[0];\nres[1] = floor(remainder * 16383.0) / 16383.0;\nremainder -= res[1];\nres[2] = floor(remainder * 2097151.0) / 2097151.0;\nr[0] = clamp(floor((v) * 127.0),0.,127.);\nr[1] = clamp(floor((v - res[0]) * 16383.0),0.,127.);\nr[2] = clamp(floor((v - res[0] - res[1]) * 2097151.0),0.,127.);\nr.r = r[0] / 127.0;\nr.g = r[1] / 127.0;\nr.b = r[2] / 127.0;\nr.a = 1.;\nreturn r;\n}",
a="float DecodeFloatRGBA( vec4 rgba ) {\nreturn rgba.r + rgba.g/127. + rgba.b/16383.;\n}");return new (f.Model.extend({defaults:{SegmentDistance:"#if ANNOTATION_NUMBER\nfloat distToSegment(vec2 p, vec2 v, vec2 w)\n{\np=(p-v)*annotationsAspectRatio;\nif (v == w)\nreturn length(p);\nw=(w-v)*annotationsAspectRatio;\nfloat t = dot(p, w) / dot(w,w);\nt = clamp(t, 0.0, 1.0);\nreturn length(p - t * w);\n}\nvec4 texelRefFetch(int idx)\n{\nint reindexedX = idx - ANNOTATION_TEXTURE_SIZE * (idx / ANNOTATION_TEXTURE_SIZE);\nint reindexedY = idx / ANNOTATION_TEXTURE_SIZE;\nvec2 loc = vec2((float(reindexedX))/float(ANNOTATION_TEXTURE_SIZE), (float(reindexedY))/float(ANNOTATION_TEXTURE_SIZE));\nreturn texture2D(annotationsTexture, loc);\n}\nvec4 accelGridFetch(int idX, int idY)\n{\nint indexCell = idX * ACCEL_GRID_SIZE + idY;\nreturn texelRefFetch(indexCell);\n}\n#endif",
AnnotationDrawing:"#if ANNOTATION_NUMBER\nbool annotated = false;\nif(!isFloorReflection){\nfloat linearCamZ = length(vWorldPosition.xyz - cameraPosition);\nfloat thick = linearCamZ * annotationsThickness * 0.001;\nint minAccelIdX = int(floor(clamp(texcoordVarying.x - thick / annotationsAspectRatio.x, 0., 1.) * float(ACCEL_GRID_SIZE)));\nint maxAccelIdX = int(ceil(clamp(texcoordVarying.x + thick / annotationsAspectRatio.x, 0., 1.) * float(ACCEL_GRID_SIZE)));\nint minAccelIdY = int(floor(clamp(texcoordVarying.y - thick / annotationsAspectRatio.y, 0., 1.) * float(ACCEL_GRID_SIZE)));\nint maxAccelIdY = int(ceil(clamp(texcoordVarying.y + thick / annotationsAspectRatio.y, 0., 1.) * float(ACCEL_GRID_SIZE)));\nfor(int x = 0; x < ACCEL_GRID_SIZE; x++)\n{\nif(x < minAccelIdX) continue;\nif(annotated || x >= maxAccelIdX) break;\nfor(int y = 0; y < ACCEL_GRID_SIZE; y++)\n{\nif(y < minAccelIdY) continue;\nif(y >= maxAccelIdY) break;\nvec4 accelGridInfo = accelGridFetch(x,y);\nif(int(accelGridInfo.r) == 0) continue;\nif(int(accelGridInfo.r) == 1)\n{\nint lineStartIdx = int(accelGridInfo.g);\nvec4 segment = texelRefFetch(lineStartIdx + LINES_START_OFFSET ).rgba;\nfloat dist = distToSegment(texcoordVarying, segment.rg, segment.ba );\nif(dist < thick )\n{\nannotated = true;\nbreak;\n}\n}\nelse\n{\nint lineStartIdxRecomposed = int(dot( accelGridInfo.gba, vec3(65535., 255., 1.)));\nfor(int lineIdx = 0; lineIdx < MAX_LINES_PER_CELL ; lineIdx++)\n{\nif(annotated || lineIdx >= int(accelGridInfo.r)) break;\nint lineRef = int(texelRefFetch(ACCEL_GRID_SIZE * ACCEL_GRID_SIZE + lineStartIdxRecomposed + lineIdx).r);\nvec4 segment = texelRefFetch(lineRef + LINES_START_OFFSET).rgba;\nfloat dist = distToSegment(texcoordVarying, segment.rg, segment.ba );\nif(dist < thick )\n{\nannotated = true;\nbreak;\n}\n}\n}\n}\n}\nif(annotated) reflResult = vec4(annotationsColor.r,annotationsColor.g,annotationsColor.b,0.);\n}\n#endif",
EncodeDepthChunck:b,DecodeDepthChunck:a,SimulateEncodingChunckD2:e,SimulateEncodingChunckD1:d,SimulateEncodingChunckD0:c,DeclareDepthSamplerChunck:"#ifdef GL_FRAGMENT_PRECISION_HIGH\nuniform highp sampler2D D0RT;\n#else\nuniform mediump sampler2D D0RT;\n#endif\nuniform vec2 canvas_size;",DeclareDepthSamplersChunck:"uniform vec2 canvas_size;\nuniform int NBRTSRC;\n#ifdef GL_FRAGMENT_PRECISION_HIGH\nuniform highp sampler2D DX1RT;\nuniform highp sampler2D DX2RT;\n#else\nuniform mediump sampler2D DX1RT;\nuniform mediump sampler2D DX2RT;\n#endif",
SelectPeelChunck:"vec2 loc = vec2(gl_FragCoord.x/canvas_size.x, gl_FragCoord.y/canvas_size.y);\nvec4 dx1_rgba = texture2D(DX1RT, loc);\nvec4 dx2_rgba = texture2D(DX2RT, loc);\nif(canvas_size.x > 0. && NBRTSRC > 0)\n{\nfloat z = DecodeFloatRGBA(EncodeFloatRGBA(1.0 - gl_FragCoord.z));\nif (NBRTSRC == 2)\n{\nfloat zmax = DecodeFloatRGBA(dx2_rgba);\nif (z >= zmax)\n{\ndiscard;\n} \nfloat zmin = DecodeFloatRGBA(dx1_rgba);\nif (z <= zmin)\n{\ndiscard;\n} \n}else if (NBRTSRC == 1){\nfloat zmin = DecodeFloatRGBA(dx1_rgba);\nif (z <= zmin)\n{\ndiscard;\n} \n}\n}",
ReflectionFadeChunck:"if(reflection_fade)\n{\nfloat inv_position = 1. - reflection_fade_position;\nfloat offset = (reflection_fade_size - 1.) * 0.1;\nfloat fade_start = inv_position + offset;\nfloat fade_end = inv_position - offset;\nfloat factor = (fade_start - loc.y) / (fade_end - fade_start) + 1.;\nif (loc.y > fade_start) refopacity *= 1.;\nelse if (loc.y < fade_end) refopacity *= 0.;\nelse refopacity *= factor ;\n}",ReflectionCosineFadeChunck:"if(reflection_fade)\n{\nfloat inv_position = 1. - reflection_fade_position;\nfloat offset = (reflection_fade_size - 1.) * 0.1;\nfloat fade_start = inv_position + offset;\nfloat fade_end = inv_position - offset;\nfloat factor = (fade_start - loc.y) / (fade_start - fade_end) * 3.1415926535;\nif (loc.y > fade_start) refopacity *= 1.;\nelse if (loc.y < fade_end) refopacity *= 0.;\nelse refopacity *= cos(factor)*0.5 + 0.5 ;\n}",
EnvironmentRotationChunck:"vec3 rotate_vec_from_quat(vec4 envMapRotQuat, vec3 vector)\n{\nvec3 tempVec = 2.0 * cross(envMapRotQuat.xyz, vector);\nvector = vector + envMapRotQuat.w * tempVec + cross(envMapRotQuat.xyz, tempVec);\nreturn vector;\n}"}}))});