/**
 * @author SVN & DOGO (Original by RAVO)
 * @module WebViewer3D
 * @copyright   2015 Esko Stonecube Ltd. All rights reserved.
 */

define(["three","@esko/3d-web-viewer/modules/shaders/VertexShaderPM","@esko/3d-web-viewer/modules/shaders/ShaderUtils"],function(a,c,b){return{uniforms:a.UniformsUtils.merge([c.uniforms,{uvdhTexture:{type:"t",value:null},diffFilterTexture:{type:"t",value:null},isFloorReflection:{type:"i",value:0},normalMap:{type:"t",value:null},spectrumTexture:{type:"t",value:null},envMapRotQuat:{type:"v4",value:new a.Vector4(0,0,0,1)},grating_spacing_scale:{type:"f",value:1.6},defaultDiffSpacing:{type:"f",value:0.5},
defaultDiffHaze:{type:"f",value:1},lightPos:{type:"v3v",value:[new a.Vector3(0,0,0),new a.Vector3(0,0,0),new a.Vector3(0,0,0),new a.Vector3(0,0,0)]},lightIntensity:{type:"fv1",value:[0,0,0,0]},lightRadius:{type:"fv1",value:[0,0,0,0]},lightHardness:{type:"fv1",value:[0,0,0,0]},canvas_size:{type:"v2",value:new a.Vector2(1,1)},DX1RT:{type:"t",value:null},DX2RT:{type:"t",value:null},NBRTSRC:{type:"i",value:0}}]),vertexShader:c.vertexShader,fragmentShader:["varying vec2 texcoordVarying;\nvarying vec2 texcoordVaryingScaled;\nvarying vec3 vNormal;\nvarying vec4 vPosition;\nvarying vec4 vWorldPosition;\nuniform sampler2D uvdhTexture;\nuniform sampler2D diffFilterTexture;\nuniform sampler2D normalMap;\nuniform sampler2D spectrumTexture;\nuniform float grating_spacing_scale;\nuniform float defaultDiffSpacing;\nuniform float defaultDiffHaze;\nuniform float lightIntensity[4];\nuniform float lightRadius[4];\nuniform float lightHardness[4];\nuniform vec3 lightPos[4];\nuniform vec4 envMapRotQuat;\nuniform bool isFloorReflection;\nvec3 tangent;\nvec3 binormal;\nmat3 cotangent_frame(vec3 N, vec3 p, vec2 uv)\n{\nvec3 dp1 = dFdx( p );\nvec3 dp2 = dFdy( p );\nvec2 duv1 = dFdx( uv );\nvec2 duv2 = dFdy( uv );\nvec3 dp2perp = cross( dp2, N );\nvec3 dp1perp = cross( N, dp1 );\ntangent = normalize(dp2perp * duv1.x + dp1perp * duv2.x);\nbinormal = normalize(dp2perp * duv1.y + dp1perp * duv2.y);\nfloat invmax = inversesqrt( max( dot(tangent,tangent), dot(binormal,binormal) ) );\ntangent *= invmax;\nbinormal *= invmax;\nreturn mat3( tangent, binormal, N );\n}\nvec3 perturb_normal( vec3 N, vec3 V, vec2 texcoord)\n{\nvec3 map = vec3(texture2D(normalMap, texcoord).rg, 0.);\nmap = map * 255./127. - 128./127.;\nvec2 tmp;\nif(map.x >= 0.0) tmp.x = -1.0; else tmp.x = 1.0;\nif(map.y >= 0.0) tmp.y = -1.0; else tmp.y = 1.0;\nmap = abs(map) * 9.96722625883599;\nmap = exp2(map);\nmap = (map * 0.001) - 0.001;\nmap = map * vec3(tmp,0.);\nmap.z = sqrt( 1. - dot( map.xy, map.xy ) );\nmat3 TBN = cotangent_frame(N, -V, texcoord);\nreturn normalize(TBN * map);\n}\nvec4 diffraction_color( vec4 uvdh, vec3 worldP, vec3 eyeVector, vec3 pN, vec3 vNormalOriginal)\n{\nvec4 diffractColor = vec4(0., 0., 0., 0.);\nvec4 filt = texture2D(diffFilterTexture, texcoordVaryingScaled);\n#ifdef DOUBLE_GRATING\nvec4 originaluvdh = uvdh;\nfor (int doubleGratingPass = 0; doubleGratingPass < 2; doubleGratingPass ++)\n{\nuvdh = originaluvdh;\nif(doubleGratingPass == 1)\nuvdh.xy = uvdh.zw;\nuvdh.zw = vec2(defaultDiffSpacing, defaultDiffHaze);\n#endif\nuvdh.y = uvdh.y - 0.5;\nfloat sign = 1.57079632679;\nif(uvdh.y < 0.0)\nsign = -1.57079632679;\nuvdh.x = (1.0 - uvdh.x) * sign;\nfloat uvdhx_t = uvdh.x;\nuvdh.x = sin(uvdhx_t);\nuvdh.y = cos(uvdhx_t);\nvec3 Gn = tangent * uvdh.x;\nGn = (binormal * uvdh.y) + Gn;\nfor ( int lightIndex = 0; lightIndex < 4; lightIndex++)\n{\nfloat hardness = 1.0 - uvdh.w;\nvec3 illumVec = normalize(worldP - lightPos[ lightIndex ]);\nif(dot(illumVec, vNormalOriginal * -1.0) < 0.0)\ncontinue;\nvec3 H = illumVec + eyeVector;\nfloat delta = abs(dot(Gn, H));\nhardness = min(lightHardness[ lightIndex ], hardness);\nfloat radius = (uvdh.w * 0.1) + lightRadius[ lightIndex ];\nfloat intensityFact = 0.0;\nif((delta - radius) < 0.0)\nintensityFact = 1.0;\nfloat hardRadius = radius * hardness;\nfloat intensityScale = (radius - delta) / (radius - hardRadius);\nif((delta - hardRadius) < 0.0)\nintensityScale = 1.0;\nintensityFact *= intensityScale;\nintensityFact *= lightIntensity[ lightIndex ];\nvec3 dG = (Gn * uvdh.z) * grating_spacing_scale;\nfloat wavl = abs(dot(cross(H, pN), dG)) * 0.48828125;\nvec2 lightSpecTexCoord = vec2(wavl, wavl);\nvec4 lightSpectrum = texture2D(spectrumTexture, lightSpecTexCoord);\nlightSpectrum = lightSpectrum * filt;\nvec4 current_color = lightSpectrum * intensityFact;\ndiffractColor += current_color;\n}\n#ifdef DOUBLE_GRATING\n}\n#endif\nreturn diffractColor; \n}",
b.get("DeclareDepthSamplersChunck"),b.get("EncodeDepthChunck"),b.get("DecodeDepthChunck"),b.get("EnvironmentRotationChunck"),"void main()\n{\n#ifndef USE_HOLOGRAPHICS\ndiscard;\n#else",b.get("SelectPeelChunck"),"vec3 vNormalOriginal = normalize(vNormal);\nvec4 uvdh = texture2D(uvdhTexture, texcoordVaryingScaled);\n#ifdef REMAPPED_DIFF_GRATING_ALPHA_CHANNEL\nuvdh.a = clamp((uvdh.a - 127./255.) * 255. / 127., 0.,1.);\n#endif\nvec3 worldP = vWorldPosition.xyz;\nvec3 eyeVector = normalize(worldP - cameraPosition.xyz);\n#ifdef USE_NORMALMAP_TEXTURE\nvec3 pN = perturb_normal(normalize(vNormal), eyeVector, texcoordVarying);\n#else\nvec3 pN = normalize(vNormal);\n#endif\npN = reflect(eyeVector, pN);\nif(isFloorReflection);\n{\npN.y = -pN.y;\nvNormalOriginal.y = -vNormalOriginal.y;\n}\npN = rotate_vec_from_quat(envMapRotQuat, pN);\ngl_FragColor = diffraction_color( uvdh, worldP, eyeVector, pN, vNormalOriginal);\n#endif\n}"].join("\n")}});