/**
 * @author SVN & DOGO (Original by RAVO)
 * @module WebViewer3D
 * @copyright   2015 Esko Stonecube Ltd. All rights reserved.
 */

define(["three","@esko/3d-web-viewer/modules/shaders/VertexShaderPM","@esko/3d-web-viewer/modules/shaders/ShaderUtils"],function(b,c,a){return{uniforms:b.UniformsUtils.merge([c.uniforms,{diffuseColor:{type:"c",value:new b.Color(16777215)},opacity:{type:"f",value:null},diffuseTexture:{type:"t",value:null},normalMap:{type:"t",value:null},isFloorReflection:{type:"i",value:0},irradianceCubeMap:{type:"t",value:null},envMapRotQuat:{type:"v4",value:new b.Vector4(0,0,0,1)},shadowsShadingContrast:{type:"f",
value:0.3},canvas_size:{type:"v2",value:new b.Vector2(1,1)},DX1RT:{type:"t",value:null},DX2RT:{type:"t",value:null},NBRTSRC:{type:"i",value:0},stripSize:{type:"f",value:250},gapSize:{type:"f",value:35}}]),vertexShader:c.vertexShader,fragmentShader:["varying vec2 texcoordVarying;\nvarying vec2 texcoordVaryingScaled;\nvarying vec3 vNormal;\nvarying vec4 vPosition;\nvarying vec4 vWorldPosition;\nuniform vec3 diffuseColor;\nuniform float opacity;\nuniform sampler2D diffuseTexture;\nuniform sampler2D normalMap;\nuniform bool isFloorReflection;\nuniform samplerCube irradianceCubeMap;\nuniform vec4 envMapRotQuat;\nuniform float shadowsShadingContrast;\nmat3 cotangent_frame(vec3 N, vec3 p, vec2 uv)\n{\nvec3 dp1 = dFdx( p );\nvec3 dp2 = dFdy( p );\nvec2 duv1 = dFdx( uv );\nvec2 duv2 = dFdy( uv );\nvec3 dp2perp = cross( dp2, N );\nvec3 dp1perp = cross( N, dp1 );\nvec3 T = normalize(dp2perp * duv1.x + dp1perp * duv2.x);\nvec3 B = normalize(dp2perp * duv1.y + dp1perp * duv2.y);\nfloat invmax = inversesqrt( max( dot(T,T), dot(B,B) ) );\nreturn mat3( T * invmax, B * invmax, N );\n}\nvec3 perturb_normal( vec3 N, vec3 V, vec2 texcoord )\n{\nvec3 map = vec3(texture2D(normalMap, texcoord).rg, 0.);\nmap = map * 255./127. - 128./127.;\nvec2 tmp;\nif(map.x >= 0.0) tmp.x = -1.0; else tmp.x = 1.0;\nif(map.y >= 0.0) tmp.y = -1.0; else tmp.y = 1.0;\nmap = abs(map) * 9.96722625883599;\nmap = exp2(map);\nmap = (map * 0.001) - 0.001;\nmap = map * vec3(tmp,0.);\nmap.z = sqrt( 1. - dot( map.xy, map.xy ) );\nmat3 TBN = cotangent_frame(N, -V, texcoord);\nreturn normalize(TBN * map);\n}",
a.get("DeclareDepthSamplersChunck"),a.get("EncodeDepthChunck"),a.get("DecodeDepthChunck"),a.get("EnvironmentRotationChunck"),a.get("Noise"),a.get("Distort"),"void main()\n{",a.get("SelectPeelChunck"),"#ifdef USE_MAP\nvec4 diffColour = texture2D(diffuseTexture, texcoordVaryingScaled);\n#ifdef REMAPPED_DIFFUSE_ALPHA_CHANNEL\ndiffColour.a = clamp((diffColour.a - 127./255.) * 255. / 127., 0.,1.);\n#endif\n#else\nvec4 diffColour = vec4(diffuseColor,opacity);\n#endif\nvec3 eyeVector = normalize(vec3(vWorldPosition) - cameraPosition.xyz);\n#ifdef USE_NORMALMAP_TEXTURE\nvec3 pN = perturb_normal(normalize(vNormal), eyeVector, texcoordVarying);\n#else\nvec3 pN = normalize(vNormal);\n#endif",
a.get("WrapDistortNormal"),"#ifdef USE_IRRMAP\nif(isFloorReflection) pN.y = -pN.y;\npN = rotate_vec_from_quat(envMapRotQuat, pN);\nvec4 irradiance = textureCube(irradianceCubeMap, pN);\n#else\nvec4 irradiance = diffColour;\n#endif\nfloat shadowFactor;\nif(shadowsShadingContrast > 0.3)\nshadowFactor = 1.0 + ((shadowsShadingContrast - 0.3) / 0.7);\nelse \nshadowFactor = shadowsShadingContrast / 0.3;\ngl_FragColor = clamp(shadowFactor * irradiance + (1.0 - shadowFactor), 0.0, 1.0) * diffColour.a;\ngl_FragColor.a = diffColour.a;\n}"].join("\n")}});